/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 91;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 63,
  Feature_HasRCPC_IMMOBit = 83,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 62,
  Feature_HasSHA3Bit = 61,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 90,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 80,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 74,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 43,
  Feature_HasSVEAESBit = 36,
  Feature_HasSVE2SM4Bit = 40,
  Feature_HasSVE2SHA3Bit = 89,
  Feature_HasSVEBitPermBit = 38,
  Feature_HasSMEandIsNonStreamingSafeBit = 55,
  Feature_HasSMEBit = 49,
  Feature_HasSMEF64F64Bit = 51,
  Feature_HasSMEI16I64Bit = 54,
  Feature_HasSME2andIsNonStreamingSafeBit = 58,
  Feature_HasSME2Bit = 57,
  Feature_HasSME2p1Bit = 60,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 46,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 41,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 47,
  Feature_HasLUTBit = 48,
  Feature_HasSME_LUTv2Bit = 59,
  Feature_HasSMEF8F16Bit = 52,
  Feature_HasSMEF8F32Bit = 50,
  Feature_HasCMPBRBit = 81,
  Feature_HasFPRCVTBit = 14,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 39,
  Feature_HasSVE2_or_SMEBit = 32,
  Feature_HasSVE2_or_SME2Bit = 45,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 35,
  Feature_HasSVE2p1_or_SMEBit = 56,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 44,
  Feature_HasSVE2p2_or_SME2p2Bit = 31,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 53,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 37,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 71,
  Feature_HasRCPCBit = 82,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 88,
  Feature_HasMatMulFP64Bit = 42,
  Feature_HasLS64Bit = 78,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 79,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 69,
  Feature_IsBEBit = 75,
  Feature_UseExperimentalZeroingPseudosBit = 34,
  Feature_UseAlternateSExtLoadCVTF32Bit = 73,
  Feature_UseScalarIncVLBit = 33,
  Feature_NoUseScalarIncVLBit = 86,
  Feature_UseSVEFPLD1RBit = 85,
  Feature_UseLDAPURBit = 84,
  Feature_AllowMisalignedMemAccessesBit = 87,
  Feature_NotForCodeSizeBit = 72,
  Feature_UseSTRQroBit = 70,
  Feature_TailCallX16X17Bit = 65,
  Feature_TailCallX17Bit = 76,
  Feature_TailCallNotX16Bit = 77,
  Feature_TailCallAnyBit = 64,
  Feature_SLSBLRMitigationBit = 68,
  Feature_NoSLSBLRMitigationBit = 67,
  Feature_OptimizedGISelOrOtherSelectorBit = 66,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return MI.getOpcode() == TargetOpcode::G_ADD ||
                (MI.getOpcode() == TargetOpcode::G_OR &&
                 MI.getFlag(MachineInstr::MIFlag::Disjoint));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(841), /*)*//*default:*//*Label 154*/ GIMT_Encode4(402966),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3162),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(34665),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(48013),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(49842),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(49924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(50006),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(57752),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(69799), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(75738), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(83262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(93206),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(93697),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(94188),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(94456),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(94606),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(95097), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(95130),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(103940),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(104990), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(107959), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(121485),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(122836),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(123828),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(124820),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(126312), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(127804),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(128796),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(129788),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(130780),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(131772),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(132764), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 31*/ GIMT_Encode4(133756), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 32*/ GIMT_Encode4(133807),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 33*/ GIMT_Encode4(243540), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 34*/ GIMT_Encode4(253796),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 35*/ GIMT_Encode4(254086),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 36*/ GIMT_Encode4(255523),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 37*/ GIMT_Encode4(255643), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 38*/ GIMT_Encode4(255884),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 39*/ GIMT_Encode4(257782),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 40*/ GIMT_Encode4(259436),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 41*/ GIMT_Encode4(262215),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 42*/ GIMT_Encode4(262995),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 43*/ GIMT_Encode4(263388), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 44*/ GIMT_Encode4(264164),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 45*/ GIMT_Encode4(264294), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 46*/ GIMT_Encode4(264787), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 47*/ GIMT_Encode4(269363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 48*/ GIMT_Encode4(270069),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 49*/ GIMT_Encode4(270553),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 50*/ GIMT_Encode4(271037),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 51*/ GIMT_Encode4(271467),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 52*/ GIMT_Encode4(271897),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 53*/ GIMT_Encode4(272327), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 54*/ GIMT_Encode4(272757),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 55*/ GIMT_Encode4(274555),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 56*/ GIMT_Encode4(275293),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 57*/ GIMT_Encode4(279389), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 58*/ GIMT_Encode4(295662), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 59*/ GIMT_Encode4(296278),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 60*/ GIMT_Encode4(299785),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 61*/ GIMT_Encode4(300033),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 62*/ GIMT_Encode4(300221),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 63*/ GIMT_Encode4(301284),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 64*/ GIMT_Encode4(302347),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 65*/ GIMT_Encode4(306744),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 66*/ GIMT_Encode4(310519),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 67*/ GIMT_Encode4(310839),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 68*/ GIMT_Encode4(311159), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 69*/ GIMT_Encode4(312016),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 70*/ GIMT_Encode4(312298),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 71*/ GIMT_Encode4(312676),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 72*/ GIMT_Encode4(313054),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 73*/ GIMT_Encode4(313404),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(313754),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(314457), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(315160),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(315564),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(315968),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(316372),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(316776),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(317591),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(317757),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(317856), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 84*/ GIMT_Encode4(317872),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 85*/ GIMT_Encode4(322884),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 86*/ GIMT_Encode4(350281), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 87*/ GIMT_Encode4(353199), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(354905), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(355057), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(355731),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(355891),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(356205),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(356359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(356850),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(357150),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(357641),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(358132), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(358623),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(359749),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(360365),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(364087), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(364703),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(380310), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(380610),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(380624),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 106*/ GIMT_Encode4(380645), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 107*/ GIMT_Encode4(380670), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 108*/ GIMT_Encode4(380980),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 109*/ GIMT_Encode4(381151),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 110*/ GIMT_Encode4(381322),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 111*/ GIMT_Encode4(381493),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 112*/ GIMT_Encode4(381664), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 113*/ GIMT_Encode4(382793),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 114*/ GIMT_Encode4(382996),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 115*/ GIMT_Encode4(383199),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 116*/ GIMT_Encode4(383402), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3010 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 117*/ GIMT_Encode4(383605), GIMT_Encode4(0),
     /*   3018 */ /*AArch64::G_BSP*//*Label 118*/ GIMT_Encode4(383745),
     /*   3022 */ /*AArch64::G_DUP*//*Label 119*/ GIMT_Encode4(384285),
     /*   3026 */ /*AArch64::G_DUPLANE16*//*Label 120*/ GIMT_Encode4(386108),
     /*   3030 */ /*AArch64::G_DUPLANE32*//*Label 121*/ GIMT_Encode4(386363),
     /*   3034 */ /*AArch64::G_DUPLANE64*//*Label 122*/ GIMT_Encode4(386618),
     /*   3038 */ /*AArch64::G_DUPLANE8*//*Label 123*/ GIMT_Encode4(386764),
     /*   3042 */ /*AArch64::G_EXT*//*Label 124*/ GIMT_Encode4(386943),
     /*   3046 */ /*AArch64::G_FCMEQ*//*Label 125*/ GIMT_Encode4(388593),
     /*   3050 */ /*AArch64::G_FCMEQZ*//*Label 126*/ GIMT_Encode4(388932),
     /*   3054 */ /*AArch64::G_FCMGE*//*Label 127*/ GIMT_Encode4(389162),
     /*   3058 */ /*AArch64::G_FCMGEZ*//*Label 128*/ GIMT_Encode4(389826),
     /*   3062 */ /*AArch64::G_FCMGT*//*Label 129*/ GIMT_Encode4(390056),
     /*   3066 */ /*AArch64::G_FCMGTZ*//*Label 130*/ GIMT_Encode4(390720),
     /*   3070 */ /*AArch64::G_FCMLEZ*//*Label 131*/ GIMT_Encode4(390950),
     /*   3074 */ /*AArch64::G_FCMLTZ*//*Label 132*/ GIMT_Encode4(391180),
     /*   3078 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(391410),
     /*   3082 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(391564),
     /*   3086 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(391740),
     /*   3090 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(392014),
     /*   3094 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(392220),
     /*   3098 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(392619),
     /*   3102 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(392989),
     /*   3106 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(393106),
     /*   3110 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(394339),
     /*   3114 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(395119),
     /*   3118 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(395899),
     /*   3122 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(396105),
     /*   3126 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(396972),
     /*   3130 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(397342),
     /*   3134 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(397459),
     /*   3138 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(398692),
     /*   3142 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(399472),
     /*   3146 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(400252),
     /*   3150 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(400950),
     /*   3154 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(401406),
     /*   3158 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(402186),
     /*   3162 */ // Label 0: @3162
     /*   3162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(34664),
     /*   3173 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3261),
     /*   3177 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(4784), GIMT_Encode4(0),
     /*   3185 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(9876),
     /*   3189 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(13484),
     /*   3193 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(19386),
     /*   3197 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(22884),
     /*   3201 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(29062),
     /*   3205 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(29912),
     /*   3209 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(33490), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3229 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(34214), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3241 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(34586), GIMT_Encode4(0),
     /*   3249 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(34612), GIMT_Encode4(0),
     /*   3257 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(34638),
     /*   3261 */ // Label 155: @3261
     /*   3261 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4783),
     /*   3266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3272 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3305), // Rule ID 12948 //
     /*   3277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3292 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3303 */     GIR_RootConstrainSelectedInstOperands,
     /*   3304 */     // GIR_Coverage, 12948,
     /*   3304 */     GIR_EraseRootFromParent_Done,
     /*   3305 */   // Label 170: @3305
     /*   3305 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3457), // Rule ID 13375 //
     /*   3310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3337 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3340 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3345 */     // MIs[2] pattern
     /*   3345 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3348 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3359 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3456 */     // GIR_Coverage, 13375,
     /*   3456 */     GIR_EraseRootFromParent_Done,
     /*   3457 */   // Label 171: @3457
     /*   3457 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3609), // Rule ID 15232 //
     /*   3462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3489 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3492 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3497 */     // MIs[2] pattern
     /*   3497 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3500 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3511 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3537 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3608 */     // GIR_Coverage, 15232,
     /*   3608 */     GIR_EraseRootFromParent_Done,
     /*   3609 */   // Label 172: @3609
     /*   3609 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3761), // Rule ID 15244 //
     /*   3614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3641 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3644 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3649 */     // MIs[2] pattern
     /*   3649 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3652 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3663 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3689 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3692 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3696 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3743 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3760 */     // GIR_Coverage, 15244,
     /*   3760 */     GIR_EraseRootFromParent_Done,
     /*   3761 */   // Label 173: @3761
     /*   3761 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3913), // Rule ID 15256 //
     /*   3766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3793 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3796 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3801 */     // MIs[2] pattern
     /*   3801 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3804 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3815 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   3873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3912 */     // GIR_Coverage, 15256,
     /*   3912 */     GIR_EraseRootFromParent_Done,
     /*   3913 */   // Label 174: @3913
     /*   3913 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3946), // Rule ID 91 //
     /*   3918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3933 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3944 */     GIR_RootConstrainSelectedInstOperands,
     /*   3945 */     // GIR_Coverage, 91,
     /*   3945 */     GIR_EraseRootFromParent_Done,
     /*   3946 */   // Label 175: @3946
     /*   3946 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4098), // Rule ID 2642 //
     /*   3951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3982 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3985 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3990 */     // MIs[2] pattern
     /*   3990 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3993 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4000 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4080 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4097 */     // GIR_Coverage, 2642,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 176: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4250), // Rule ID 9791 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4134 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4137 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4142 */     // MIs[2] pattern
     /*   4142 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4145 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4152 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4232 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4249 */     // GIR_Coverage, 9791,
     /*   4249 */     GIR_EraseRootFromParent_Done,
     /*   4250 */   // Label 177: @4250
     /*   4250 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4402), // Rule ID 9803 //
     /*   4255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4286 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4289 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4294 */     // MIs[2] pattern
     /*   4294 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4297 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4304 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4401 */     // GIR_Coverage, 9803,
     /*   4401 */     GIR_EraseRootFromParent_Done,
     /*   4402 */   // Label 178: @4402
     /*   4402 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4554), // Rule ID 9815 //
     /*   4407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4438 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4441 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4446 */     // MIs[2] pattern
     /*   4446 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4449 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4456 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4456 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4459 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4463 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4553 */     // GIR_Coverage, 9815,
     /*   4553 */     GIR_EraseRootFromParent_Done,
     /*   4554 */   // Label 179: @4554
     /*   4554 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4587), // Rule ID 12952 //
     /*   4559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4574 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4585 */     GIR_RootConstrainSelectedInstOperands,
     /*   4586 */     // GIR_Coverage, 12952,
     /*   4586 */     GIR_EraseRootFromParent_Done,
     /*   4587 */   // Label 180: @4587
     /*   4587 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4623), // Rule ID 13515 //
     /*   4592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4607 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4621 */     GIR_RootConstrainSelectedInstOperands,
     /*   4622 */     // GIR_Coverage, 13515,
     /*   4622 */     GIR_EraseRootFromParent_Done,
     /*   4623 */   // Label 181: @4623
     /*   4623 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4656), // Rule ID 97 //
     /*   4628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4643 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4654 */     GIR_RootConstrainSelectedInstOperands,
     /*   4655 */     // GIR_Coverage, 97,
     /*   4655 */     GIR_EraseRootFromParent_Done,
     /*   4656 */   // Label 182: @4656
     /*   4656 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4692), // Rule ID 3863 //
     /*   4661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4676 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4690 */     GIR_RootConstrainSelectedInstOperands,
     /*   4691 */     // GIR_Coverage, 3863,
     /*   4691 */     GIR_EraseRootFromParent_Done,
     /*   4692 */   // Label 183: @4692
     /*   4692 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4725), // Rule ID 12950 //
     /*   4697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4712 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4723 */     GIR_RootConstrainSelectedInstOperands,
     /*   4724 */     // GIR_Coverage, 12950,
     /*   4724 */     GIR_EraseRootFromParent_Done,
     /*   4725 */   // Label 184: @4725
     /*   4725 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4758), // Rule ID 95 //
     /*   4730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4745 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4756 */     GIR_RootConstrainSelectedInstOperands,
     /*   4757 */     // GIR_Coverage, 95,
     /*   4757 */     GIR_EraseRootFromParent_Done,
     /*   4758 */   // Label 185: @4758
     /*   4758 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4782), // Rule ID 93 //
     /*   4763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4775 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   4775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   4780 */     GIR_RootConstrainSelectedInstOperands,
     /*   4781 */     // GIR_Coverage, 93,
     /*   4781 */     GIR_Done,
     /*   4782 */   // Label 186: @4782
     /*   4782 */   GIM_Reject,
     /*   4783 */ // Label 169: @4783
     /*   4783 */ GIM_Reject,
     /*   4784 */ // Label 156: @4784
     /*   4784 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(9875),
     /*   4789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   4792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   4795 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4931), // Rule ID 5313 //
     /*   4800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4833 */     // MIs[1] Operand 2
     /*   4833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4868 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4873 */     // MIs[3] Operand 2
     /*   4873 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   4886 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   4886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   4889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   4893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   4906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   4920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   4930 */     // GIR_Coverage, 5313,
     /*   4930 */     GIR_EraseRootFromParent_Done,
     /*   4931 */   // Label 188: @4931
     /*   4931 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5067), // Rule ID 5312 //
     /*   4936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4969 */     // MIs[1] Operand 2
     /*   4969 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5004 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5009 */     // MIs[3] Operand 2
     /*   5009 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5022 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5066 */     // GIR_Coverage, 5312,
     /*   5066 */     GIR_EraseRootFromParent_Done,
     /*   5067 */   // Label 189: @5067
     /*   5067 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5203), // Rule ID 5322 //
     /*   5072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5105 */     // MIs[1] Operand 2
     /*   5105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5136 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5140 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5145 */     // MIs[3] Operand 2
     /*   5145 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5158 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   5165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5202 */     // GIR_Coverage, 5322,
     /*   5202 */     GIR_EraseRootFromParent_Done,
     /*   5203 */   // Label 190: @5203
     /*   5203 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5339), // Rule ID 5311 //
     /*   5208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5241 */     // MIs[1] Operand 2
     /*   5241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   5272 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5276 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5281 */     // MIs[3] Operand 2
     /*   5281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5292 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5294 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5338 */     // GIR_Coverage, 5311,
     /*   5338 */     GIR_EraseRootFromParent_Done,
     /*   5339 */   // Label 191: @5339
     /*   5339 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5475), // Rule ID 5310 //
     /*   5344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5377 */     // MIs[1] Operand 2
     /*   5377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5412 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5417 */     // MIs[3] Operand 2
     /*   5417 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5428 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5430 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5457 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5474 */     // GIR_Coverage, 5310,
     /*   5474 */     GIR_EraseRootFromParent_Done,
     /*   5475 */   // Label 192: @5475
     /*   5475 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5543), // Rule ID 6819 //
     /*   5480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   5509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5521 */     // MIs[2] Rn
     /*   5521 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5526 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   5530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5532 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5541 */     GIR_RootConstrainSelectedInstOperands,
     /*   5542 */     // GIR_Coverage, 6819,
     /*   5542 */     GIR_EraseRootFromParent_Done,
     /*   5543 */   // Label 193: @5543
     /*   5543 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5611), // Rule ID 13676 //
     /*   5548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   5577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5589 */     // MIs[2] Rn
     /*   5589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   5598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5600 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5609 */     GIR_RootConstrainSelectedInstOperands,
     /*   5610 */     // GIR_Coverage, 13676,
     /*   5610 */     GIR_EraseRootFromParent_Done,
     /*   5611 */   // Label 194: @5611
     /*   5611 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5644), // Rule ID 12949 //
     /*   5616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5631 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5642 */     GIR_RootConstrainSelectedInstOperands,
     /*   5643 */     // GIR_Coverage, 12949,
     /*   5643 */     GIR_EraseRootFromParent_Done,
     /*   5644 */   // Label 195: @5644
     /*   5644 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5777), // Rule ID 3915 //
     /*   5649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   5681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5686 */     // MIs[2] Operand 2
     /*   5686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   5697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5709 */     // MIs[3] Operand 1
     /*   5709 */     // No operand predicates
     /*   5709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5715 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   5718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5727 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   5734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5746 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   5752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   5773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5775 */     GIR_RootConstrainSelectedInstOperands,
     /*   5776 */     // GIR_Coverage, 3915,
     /*   5776 */     GIR_EraseRootFromParent_Done,
     /*   5777 */   // Label 196: @5777
     /*   5777 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5872), // Rule ID 3913 //
     /*   5782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5831 */     // MIs[3] Operand 1
     /*   5831 */     // No operand predicates
     /*   5831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5837 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5849 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5870 */     GIR_RootConstrainSelectedInstOperands,
     /*   5871 */     // GIR_Coverage, 3913,
     /*   5871 */     GIR_EraseRootFromParent_Done,
     /*   5872 */   // Label 197: @5872
     /*   5872 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5967), // Rule ID 3914 //
     /*   5877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   5926 */     // MIs[3] Operand 1
     /*   5926 */     // No operand predicates
     /*   5926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5932 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5944 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   5954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5965 */     GIR_RootConstrainSelectedInstOperands,
     /*   5966 */     // GIR_Coverage, 3914,
     /*   5966 */     GIR_EraseRootFromParent_Done,
     /*   5967 */   // Label 198: @5967
     /*   5967 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6000), // Rule ID 92 //
     /*   5972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5987 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5998 */     GIR_RootConstrainSelectedInstOperands,
     /*   5999 */     // GIR_Coverage, 92,
     /*   5999 */     GIR_EraseRootFromParent_Done,
     /*   6000 */   // Label 199: @6000
     /*   6000 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6133), // Rule ID 13525 //
     /*   6005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   6041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6046 */     // MIs[2] Operand 2
     /*   6046 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   6057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6069 */     // MIs[3] Operand 1
     /*   6069 */     // No operand predicates
     /*   6069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6071 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   6074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6083 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   6090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   6108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6131 */     GIR_RootConstrainSelectedInstOperands,
     /*   6132 */     // GIR_Coverage, 13525,
     /*   6132 */     GIR_EraseRootFromParent_Done,
     /*   6133 */   // Label 200: @6133
     /*   6133 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6228), // Rule ID 13523 //
     /*   6138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6191 */     // MIs[3] Operand 1
     /*   6191 */     // No operand predicates
     /*   6191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6193 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6205 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6226 */     GIR_RootConstrainSelectedInstOperands,
     /*   6227 */     // GIR_Coverage, 13523,
     /*   6227 */     GIR_EraseRootFromParent_Done,
     /*   6228 */   // Label 201: @6228
     /*   6228 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6323), // Rule ID 13524 //
     /*   6233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   6286 */     // MIs[3] Operand 1
     /*   6286 */     // No operand predicates
     /*   6286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6288 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6300 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6321 */     GIR_RootConstrainSelectedInstOperands,
     /*   6322 */     // GIR_Coverage, 13524,
     /*   6322 */     GIR_EraseRootFromParent_Done,
     /*   6323 */   // Label 202: @6323
     /*   6323 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6405), // Rule ID 12960 //
     /*   6328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6388 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6403 */     GIR_RootConstrainSelectedInstOperands,
     /*   6404 */     // GIR_Coverage, 12960,
     /*   6404 */     GIR_EraseRootFromParent_Done,
     /*   6405 */   // Label 203: @6405
     /*   6405 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6487), // Rule ID 12961 //
     /*   6410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6470 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6485 */     GIR_RootConstrainSelectedInstOperands,
     /*   6486 */     // GIR_Coverage, 12961,
     /*   6486 */     GIR_EraseRootFromParent_Done,
     /*   6487 */   // Label 204: @6487
     /*   6487 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6569), // Rule ID 123 //
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6552 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6567 */     GIR_RootConstrainSelectedInstOperands,
     /*   6568 */     // GIR_Coverage, 123,
     /*   6568 */     GIR_EraseRootFromParent_Done,
     /*   6569 */   // Label 205: @6569
     /*   6569 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6651), // Rule ID 125 //
     /*   6574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6634 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6649 */     GIR_RootConstrainSelectedInstOperands,
     /*   6650 */     // GIR_Coverage, 125,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 206: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6709), // Rule ID 13370 //
     /*   6656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6679 */     // MIs[1] pattern
     /*   6679 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6682 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6693 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6707 */     GIR_RootConstrainSelectedInstOperands,
     /*   6708 */     // GIR_Coverage, 13370,
     /*   6708 */     GIR_EraseRootFromParent_Done,
     /*   6709 */   // Label 207: @6709
     /*   6709 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6767), // Rule ID 15227 //
     /*   6714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6732 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6737 */     // MIs[1] pattern
     /*   6737 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6740 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6751 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6765 */     GIR_RootConstrainSelectedInstOperands,
     /*   6766 */     // GIR_Coverage, 15227,
     /*   6766 */     GIR_EraseRootFromParent_Done,
     /*   6767 */   // Label 208: @6767
     /*   6767 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6825), // Rule ID 15239 //
     /*   6772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   6795 */     // MIs[1] pattern
     /*   6795 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6798 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6809 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   6812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6823 */     GIR_RootConstrainSelectedInstOperands,
     /*   6824 */     // GIR_Coverage, 15239,
     /*   6824 */     GIR_EraseRootFromParent_Done,
     /*   6825 */   // Label 209: @6825
     /*   6825 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6883), // Rule ID 15251 //
     /*   6830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6845 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6848 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   6853 */     // MIs[1] pattern
     /*   6853 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6856 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6867 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   6870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6881 */     GIR_RootConstrainSelectedInstOperands,
     /*   6882 */     // GIR_Coverage, 15251,
     /*   6882 */     GIR_EraseRootFromParent_Done,
     /*   6883 */   // Label 210: @6883
     /*   6883 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6941), // Rule ID 2639 //
     /*   6888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6907 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6910 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6915 */     // MIs[1] pattern
     /*   6915 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6918 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6925 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6939 */     GIR_RootConstrainSelectedInstOperands,
     /*   6940 */     // GIR_Coverage, 2639,
     /*   6940 */     GIR_EraseRootFromParent_Done,
     /*   6941 */   // Label 211: @6941
     /*   6941 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6999), // Rule ID 9788 //
     /*   6946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6965 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6968 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6973 */     // MIs[1] pattern
     /*   6973 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6976 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6983 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6997 */     GIR_RootConstrainSelectedInstOperands,
     /*   6998 */     // GIR_Coverage, 9788,
     /*   6998 */     GIR_EraseRootFromParent_Done,
     /*   6999 */   // Label 212: @6999
     /*   6999 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7057), // Rule ID 9800 //
     /*   7004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7023 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7026 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   7031 */     // MIs[1] pattern
     /*   7031 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7034 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7041 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   7044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7055 */     GIR_RootConstrainSelectedInstOperands,
     /*   7056 */     // GIR_Coverage, 9800,
     /*   7056 */     GIR_EraseRootFromParent_Done,
     /*   7057 */   // Label 213: @7057
     /*   7057 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7115), // Rule ID 9812 //
     /*   7062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7081 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7084 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   7089 */     // MIs[1] pattern
     /*   7089 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7092 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7099 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   7102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 9812,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 214: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7278), // Rule ID 13642 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7162 */     // MIs[1] Operand 2
     /*   7162 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7179 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7205 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   7237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7277 */     // GIR_Coverage, 13642,
     /*   7277 */     GIR_EraseRootFromParent_Done,
     /*   7278 */   // Label 215: @7278
     /*   7278 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7441), // Rule ID 13639 //
     /*   7283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   7307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7325 */     // MIs[1] Operand 2
     /*   7325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7342 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7342 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7345 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7349 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7368 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   7400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7440 */     // GIR_Coverage, 13639,
     /*   7440 */     GIR_EraseRootFromParent_Done,
     /*   7441 */   // Label 216: @7441
     /*   7441 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7591), // Rule ID 13648 //
     /*   7446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7479 */     // MIs[1] Operand 2
     /*   7479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7496 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7590 */     // GIR_Coverage, 13648,
     /*   7590 */     GIR_EraseRootFromParent_Done,
     /*   7591 */   // Label 217: @7591
     /*   7591 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7741), // Rule ID 13651 //
     /*   7596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7629 */     // MIs[1] Operand 2
     /*   7629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7646 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7740 */     // GIR_Coverage, 13651,
     /*   7740 */     GIR_EraseRootFromParent_Done,
     /*   7741 */   // Label 218: @7741
     /*   7741 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7891), // Rule ID 13647 //
     /*   7746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7779 */     // MIs[1] Operand 2
     /*   7779 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7796 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7825 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7829 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7890 */     // GIR_Coverage, 13647,
     /*   7890 */     GIR_EraseRootFromParent_Done,
     /*   7891 */   // Label 219: @7891
     /*   7891 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8054), // Rule ID 5295 //
     /*   7896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7942 */     // MIs[1] Operand 2
     /*   7942 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7955 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7955 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7958 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7962 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7981 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   7988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8053 */     // GIR_Coverage, 5295,
     /*   8053 */     GIR_EraseRootFromParent_Done,
     /*   8054 */   // Label 220: @8054
     /*   8054 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8217), // Rule ID 5292 //
     /*   8059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8105 */     // MIs[1] Operand 2
     /*   8105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8118 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8144 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   8151 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8216 */     // GIR_Coverage, 5292,
     /*   8216 */     GIR_EraseRootFromParent_Done,
     /*   8217 */   // Label 221: @8217
     /*   8217 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8367), // Rule ID 5319 //
     /*   8222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8259 */     // MIs[1] Operand 2
     /*   8259 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8272 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8301 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8366 */     // GIR_Coverage, 5319,
     /*   8366 */     GIR_EraseRootFromParent_Done,
     /*   8367 */   // Label 222: @8367
     /*   8367 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8517), // Rule ID 5325 //
     /*   8372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8409 */     // MIs[1] Operand 2
     /*   8409 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8422 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8422 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8425 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8429 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8436 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8439 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8443 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8448 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   8480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8516 */     // GIR_Coverage, 5325,
     /*   8516 */     GIR_EraseRootFromParent_Done,
     /*   8517 */   // Label 223: @8517
     /*   8517 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8667), // Rule ID 5318 //
     /*   8522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8559 */     // MIs[1] Operand 2
     /*   8559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8572 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8572 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8575 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8579 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8598 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8605 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8666 */     // GIR_Coverage, 5318,
     /*   8666 */     GIR_EraseRootFromParent_Done,
     /*   8667 */   // Label 224: @8667
     /*   8667 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8700), // Rule ID 12953 //
     /*   8672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8687 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8698 */     GIR_RootConstrainSelectedInstOperands,
     /*   8699 */     // GIR_Coverage, 12953,
     /*   8699 */     GIR_EraseRootFromParent_Done,
     /*   8700 */   // Label 225: @8700
     /*   8700 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8736), // Rule ID 13516 //
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8720 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8734 */     GIR_RootConstrainSelectedInstOperands,
     /*   8735 */     // GIR_Coverage, 13516,
     /*   8735 */     GIR_EraseRootFromParent_Done,
     /*   8736 */   // Label 226: @8736
     /*   8736 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8769), // Rule ID 98 //
     /*   8741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8756 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8767 */     GIR_RootConstrainSelectedInstOperands,
     /*   8768 */     // GIR_Coverage, 98,
     /*   8768 */     GIR_EraseRootFromParent_Done,
     /*   8769 */   // Label 227: @8769
     /*   8769 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8805), // Rule ID 3864 //
     /*   8774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8789 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8803 */     GIR_RootConstrainSelectedInstOperands,
     /*   8804 */     // GIR_Coverage, 3864,
     /*   8804 */     GIR_EraseRootFromParent_Done,
     /*   8805 */   // Label 228: @8805
     /*   8805 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8838), // Rule ID 12951 //
     /*   8810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8825 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8836 */     GIR_RootConstrainSelectedInstOperands,
     /*   8837 */     // GIR_Coverage, 12951,
     /*   8837 */     GIR_EraseRootFromParent_Done,
     /*   8838 */   // Label 229: @8838
     /*   8838 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8871), // Rule ID 96 //
     /*   8843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8858 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8869 */     GIR_RootConstrainSelectedInstOperands,
     /*   8870 */     // GIR_Coverage, 96,
     /*   8870 */     GIR_EraseRootFromParent_Done,
     /*   8871 */   // Label 230: @8871
     /*   8871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8927), // Rule ID 13059 //
     /*   8876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8891 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8894 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   8899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8914 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   8917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8925 */     GIR_RootConstrainSelectedInstOperands,
     /*   8926 */     // GIR_Coverage, 13059,
     /*   8926 */     GIR_EraseRootFromParent_Done,
     /*   8927 */   // Label 231: @8927
     /*   8927 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8983), // Rule ID 13071 //
     /*   8932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8947 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8950 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   8955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8970 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   8973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8981 */     GIR_RootConstrainSelectedInstOperands,
     /*   8982 */     // GIR_Coverage, 13071,
     /*   8982 */     GIR_EraseRootFromParent_Done,
     /*   8983 */   // Label 232: @8983
     /*   8983 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9050), // Rule ID 13277 //
     /*   8988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9012 */     // MIs[1] imm
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9024 */     // MIs[2] Operand 1
     /*   9024 */     // No operand predicates
     /*   9024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9034 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9048 */     GIR_RootConstrainSelectedInstOperands,
     /*   9049 */     // GIR_Coverage, 13277,
     /*   9049 */     GIR_EraseRootFromParent_Done,
     /*   9050 */   // Label 233: @9050
     /*   9050 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9117), // Rule ID 13665 //
     /*   9055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9079 */     // MIs[1] imm
     /*   9079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9091 */     // MIs[2] Operand 1
     /*   9091 */     // No operand predicates
     /*   9091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9101 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9115 */     GIR_RootConstrainSelectedInstOperands,
     /*   9116 */     // GIR_Coverage, 13665,
     /*   9116 */     GIR_EraseRootFromParent_Done,
     /*   9117 */   // Label 234: @9117
     /*   9117 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(9184), // Rule ID 13280 //
     /*   9122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9146 */     // MIs[1] imm
     /*   9146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9158 */     // MIs[2] Operand 1
     /*   9158 */     // No operand predicates
     /*   9158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9168 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9182 */     GIR_RootConstrainSelectedInstOperands,
     /*   9183 */     // GIR_Coverage, 13280,
     /*   9183 */     GIR_EraseRootFromParent_Done,
     /*   9184 */   // Label 235: @9184
     /*   9184 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9251), // Rule ID 13668 //
     /*   9189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9213 */     // MIs[1] imm
     /*   9213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9225 */     // MIs[2] Operand 1
     /*   9225 */     // No operand predicates
     /*   9225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9235 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9249 */     GIR_RootConstrainSelectedInstOperands,
     /*   9250 */     // GIR_Coverage, 13668,
     /*   9250 */     GIR_EraseRootFromParent_Done,
     /*   9251 */   // Label 236: @9251
     /*   9251 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9307), // Rule ID 990 //
     /*   9256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   9283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9294 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9305 */     GIR_RootConstrainSelectedInstOperands,
     /*   9306 */     // GIR_Coverage, 990,
     /*   9306 */     GIR_EraseRootFromParent_Done,
     /*   9307 */   // Label 237: @9307
     /*   9307 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9363), // Rule ID 1051 //
     /*   9312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   9339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9350 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9361 */     GIR_RootConstrainSelectedInstOperands,
     /*   9362 */     // GIR_Coverage, 1051,
     /*   9362 */     GIR_EraseRootFromParent_Done,
     /*   9363 */   // Label 238: @9363
     /*   9363 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9430), // Rule ID 2112 //
     /*   9368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9396 */     // MIs[1] imm
     /*   9396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9408 */     // MIs[2] Operand 1
     /*   9408 */     // No operand predicates
     /*   9408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9414 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9428 */     GIR_RootConstrainSelectedInstOperands,
     /*   9429 */     // GIR_Coverage, 2112,
     /*   9429 */     GIR_EraseRootFromParent_Done,
     /*   9430 */   // Label 239: @9430
     /*   9430 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9497), // Rule ID 6197 //
     /*   9435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9463 */     // MIs[1] imm
     /*   9463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9475 */     // MIs[2] Operand 1
     /*   9475 */     // No operand predicates
     /*   9475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9481 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9495 */     GIR_RootConstrainSelectedInstOperands,
     /*   9496 */     // GIR_Coverage, 6197,
     /*   9496 */     GIR_EraseRootFromParent_Done,
     /*   9497 */   // Label 240: @9497
     /*   9497 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9564), // Rule ID 2121 //
     /*   9502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9530 */     // MIs[1] imm
     /*   9530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9542 */     // MIs[2] Operand 1
     /*   9542 */     // No operand predicates
     /*   9542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9548 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9562 */     GIR_RootConstrainSelectedInstOperands,
     /*   9563 */     // GIR_Coverage, 2121,
     /*   9563 */     GIR_EraseRootFromParent_Done,
     /*   9564 */   // Label 241: @9564
     /*   9564 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9631), // Rule ID 6203 //
     /*   9569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9597 */     // MIs[1] imm
     /*   9597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9609 */     // MIs[2] Operand 1
     /*   9609 */     // No operand predicates
     /*   9609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9615 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9629 */     GIR_RootConstrainSelectedInstOperands,
     /*   9630 */     // GIR_Coverage, 6203,
     /*   9630 */     GIR_EraseRootFromParent_Done,
     /*   9631 */   // Label 242: @9631
     /*   9631 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9679), // Rule ID 13058 //
     /*   9636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9666 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9677 */     GIR_RootConstrainSelectedInstOperands,
     /*   9678 */     // GIR_Coverage, 13058,
     /*   9678 */     GIR_EraseRootFromParent_Done,
     /*   9679 */   // Label 243: @9679
     /*   9679 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9727), // Rule ID 13070 //
     /*   9684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9714 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9725 */     GIR_RootConstrainSelectedInstOperands,
     /*   9726 */     // GIR_Coverage, 13070,
     /*   9726 */     GIR_EraseRootFromParent_Done,
     /*   9727 */   // Label 244: @9727
     /*   9727 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9775), // Rule ID 989 //
     /*   9732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9762 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9773 */     GIR_RootConstrainSelectedInstOperands,
     /*   9774 */     // GIR_Coverage, 989,
     /*   9774 */     GIR_EraseRootFromParent_Done,
     /*   9775 */   // Label 245: @9775
     /*   9775 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9823), // Rule ID 1050 //
     /*   9780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9810 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9821 */     GIR_RootConstrainSelectedInstOperands,
     /*   9822 */     // GIR_Coverage, 1050,
     /*   9822 */     GIR_EraseRootFromParent_Done,
     /*   9823 */   // Label 246: @9823
     /*   9823 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9847), // Rule ID 94 //
     /*   9828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9840 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*   9840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*   9845 */     GIR_RootConstrainSelectedInstOperands,
     /*   9846 */     // GIR_Coverage, 94,
     /*   9846 */     GIR_Done,
     /*   9847 */   // Label 247: @9847
     /*   9847 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9874), // Rule ID 1600 //
     /*   9852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9867 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*   9867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*   9872 */     GIR_RootConstrainSelectedInstOperands,
     /*   9873 */     // GIR_Coverage, 1600,
     /*   9873 */     GIR_Done,
     /*   9874 */   // Label 248: @9874
     /*   9874 */   GIM_Reject,
     /*   9875 */ // Label 187: @9875
     /*   9875 */ GIM_Reject,
     /*   9876 */ // Label 157: @9876
     /*   9876 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(13483),
     /*   9881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9887 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10075), // Rule ID 6840 //
     /*   9892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*   9904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9929 */     // MIs[2] Operand 2
     /*   9929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*   9940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   9944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9948 */     // MIs[3] Rn
     /*   9948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9953 */     // MIs[3] Operand 2
     /*   9953 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*   9964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   9968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*   9972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9976 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9988 */     // MIs[5] Rn
     /*   9988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9993 */     // MIs[5] Operand 2
     /*   9993 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10004 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10008 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10012 */     // MIs[6] Rn
     /*  10012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10017 */     // MIs[6] Operand 2
     /*  10017 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10028 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10030 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10074 */     // GIR_Coverage, 6840,
     /*  10074 */     GIR_EraseRootFromParent_Done,
     /*  10075 */   // Label 250: @10075
     /*  10075 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10263), // Rule ID 13687 //
     /*  10080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  10092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     // MIs[2] Operand 2
     /*  10117 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  10128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  10132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10136 */     // MIs[3] Rn
     /*  10136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10141 */     // MIs[3] Operand 2
     /*  10141 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  10152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  10156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  10160 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10164 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10168 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10172 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10176 */     // MIs[5] Rn
     /*  10176 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10181 */     // MIs[5] Operand 2
     /*  10181 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10192 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10196 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10200 */     // MIs[6] Rn
     /*  10200 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10205 */     // MIs[6] Operand 2
     /*  10205 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10218 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10262 */     // GIR_Coverage, 13687,
     /*  10262 */     GIR_EraseRootFromParent_Done,
     /*  10263 */   // Label 251: @10263
     /*  10263 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(10399), // Rule ID 5309 //
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10332 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10336 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10341 */     // MIs[3] Operand 2
     /*  10341 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10354 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10398 */     // GIR_Coverage, 5309,
     /*  10398 */     GIR_EraseRootFromParent_Done,
     /*  10399 */   // Label 252: @10399
     /*  10399 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10535), // Rule ID 5308 //
     /*  10404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10437 */     // MIs[1] Operand 2
     /*  10437 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10464 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10468 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10477 */     // MIs[3] Operand 2
     /*  10477 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10490 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10534 */     // GIR_Coverage, 5308,
     /*  10534 */     GIR_EraseRootFromParent_Done,
     /*  10535 */   // Label 253: @10535
     /*  10535 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10671), // Rule ID 5321 //
     /*  10540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10573 */     // MIs[1] Operand 2
     /*  10573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10600 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10604 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10608 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10613 */     // MIs[3] Operand 2
     /*  10613 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10626 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  10633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10670 */     // GIR_Coverage, 5321,
     /*  10670 */     GIR_EraseRootFromParent_Done,
     /*  10671 */   // Label 254: @10671
     /*  10671 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10807), // Rule ID 5307 //
     /*  10676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10709 */     // MIs[1] Operand 2
     /*  10709 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10740 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10744 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10749 */     // MIs[3] Operand 2
     /*  10749 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10760 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10762 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10806 */     // GIR_Coverage, 5307,
     /*  10806 */     GIR_EraseRootFromParent_Done,
     /*  10807 */   // Label 255: @10807
     /*  10807 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10943), // Rule ID 5306 //
     /*  10812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10845 */     // MIs[1] Operand 2
     /*  10845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10885 */     // MIs[3] Operand 2
     /*  10885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10898 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10942 */     // GIR_Coverage, 5306,
     /*  10942 */     GIR_EraseRootFromParent_Done,
     /*  10943 */   // Label 256: @10943
     /*  10943 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11106), // Rule ID 13641 //
     /*  10948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  10972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  10980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10990 */     // MIs[1] Operand 2
     /*  10990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11007 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11088 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11105 */     // GIR_Coverage, 13641,
     /*  11105 */     GIR_EraseRootFromParent_Done,
     /*  11106 */   // Label 257: @11106
     /*  11106 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11269), // Rule ID 13638 //
     /*  11111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11153 */     // MIs[1] Operand 2
     /*  11153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11170 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11196 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  11228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11268 */     // GIR_Coverage, 13638,
     /*  11268 */     GIR_EraseRootFromParent_Done,
     /*  11269 */   // Label 258: @11269
     /*  11269 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11419), // Rule ID 13646 //
     /*  11274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11307 */     // MIs[1] Operand 2
     /*  11307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11324 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11324 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11327 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11331 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11350 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11357 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11418 */     // GIR_Coverage, 13646,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 259: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11569), // Rule ID 13650 //
     /*  11424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11457 */     // MIs[1] Operand 2
     /*  11457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11474 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11488 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11491 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11495 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11500 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11507 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  11532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11551 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11568 */     // GIR_Coverage, 13650,
     /*  11568 */     GIR_EraseRootFromParent_Done,
     /*  11569 */   // Label 260: @11569
     /*  11569 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11719), // Rule ID 13645 //
     /*  11574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // MIs[1] Operand 2
     /*  11607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11624 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11624 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11627 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11631 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11650 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11653 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11657 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11718 */     // GIR_Coverage, 13645,
     /*  11718 */     GIR_EraseRootFromParent_Done,
     /*  11719 */   // Label 261: @11719
     /*  11719 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11882), // Rule ID 5294 //
     /*  11724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  11752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11770 */     // MIs[1] Operand 2
     /*  11770 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11783 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11809 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11881 */     // GIR_Coverage, 5294,
     /*  11881 */     GIR_EraseRootFromParent_Done,
     /*  11882 */   // Label 262: @11882
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12045), // Rule ID 5291 //
     /*  11887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11933 */     // MIs[1] Operand 2
     /*  11933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11946 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11972 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11979 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12044 */     // GIR_Coverage, 5291,
     /*  12044 */     GIR_EraseRootFromParent_Done,
     /*  12045 */   // Label 263: @12045
     /*  12045 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12195), // Rule ID 5317 //
     /*  12050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12087 */     // MIs[1] Operand 2
     /*  12087 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12100 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12100 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12103 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12107 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12126 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12133 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12194 */     // GIR_Coverage, 5317,
     /*  12194 */     GIR_EraseRootFromParent_Done,
     /*  12195 */   // Label 264: @12195
     /*  12195 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12345), // Rule ID 5324 //
     /*  12200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12237 */     // MIs[1] Operand 2
     /*  12237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12250 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12276 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12283 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  12308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12344 */     // GIR_Coverage, 5324,
     /*  12344 */     GIR_EraseRootFromParent_Done,
     /*  12345 */   // Label 265: @12345
     /*  12345 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12495), // Rule ID 5316 //
     /*  12350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12387 */     // MIs[1] Operand 2
     /*  12387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12400 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12494 */     // GIR_Coverage, 5316,
     /*  12494 */     GIR_EraseRootFromParent_Done,
     /*  12495 */   // Label 266: @12495
     /*  12495 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12564), // Rule ID 13093 //
     /*  12500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12518 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12547 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12562 */     GIR_RootConstrainSelectedInstOperands,
     /*  12563 */     // GIR_Coverage, 13093,
     /*  12563 */     GIR_EraseRootFromParent_Done,
     /*  12564 */   // Label 267: @12564
     /*  12564 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12633), // Rule ID 13105 //
     /*  12569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12616 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  12619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12631 */     GIR_RootConstrainSelectedInstOperands,
     /*  12632 */     // GIR_Coverage, 13105,
     /*  12632 */     GIR_EraseRootFromParent_Done,
     /*  12633 */   // Label 268: @12633
     /*  12633 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12689), // Rule ID 13055 //
     /*  12638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12653 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12656 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  12661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12676 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  12679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12687 */     GIR_RootConstrainSelectedInstOperands,
     /*  12688 */     // GIR_Coverage, 13055,
     /*  12688 */     GIR_EraseRootFromParent_Done,
     /*  12689 */   // Label 269: @12689
     /*  12689 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12745), // Rule ID 13067 //
     /*  12694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12709 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12712 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  12717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12732 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  12735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12743 */     GIR_RootConstrainSelectedInstOperands,
     /*  12744 */     // GIR_Coverage, 13067,
     /*  12744 */     GIR_EraseRootFromParent_Done,
     /*  12745 */   // Label 270: @12745
     /*  12745 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12812), // Rule ID 13297 //
     /*  12750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  12765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12774 */     // MIs[1] imm
     /*  12774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12786 */     // MIs[2] Operand 1
     /*  12786 */     // No operand predicates
     /*  12786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12796 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  12799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12810 */     GIR_RootConstrainSelectedInstOperands,
     /*  12811 */     // GIR_Coverage, 13297,
     /*  12811 */     GIR_EraseRootFromParent_Done,
     /*  12812 */   // Label 271: @12812
     /*  12812 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12879), // Rule ID 13318 //
     /*  12817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  12832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12841 */     // MIs[1] imm
     /*  12841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12853 */     // MIs[2] Operand 1
     /*  12853 */     // No operand predicates
     /*  12853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12863 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  12866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12877 */     GIR_RootConstrainSelectedInstOperands,
     /*  12878 */     // GIR_Coverage, 13318,
     /*  12878 */     GIR_EraseRootFromParent_Done,
     /*  12879 */   // Label 272: @12879
     /*  12879 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12948), // Rule ID 1358 //
     /*  12884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12903 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12906 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12931 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12946 */     GIR_RootConstrainSelectedInstOperands,
     /*  12947 */     // GIR_Coverage, 1358,
     /*  12947 */     GIR_EraseRootFromParent_Done,
     /*  12948 */   // Label 273: @12948
     /*  12948 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13017), // Rule ID 1481 //
     /*  12953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12972 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12975 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13000 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  13015 */     GIR_RootConstrainSelectedInstOperands,
     /*  13016 */     // GIR_Coverage, 1481,
     /*  13016 */     GIR_EraseRootFromParent_Done,
     /*  13017 */   // Label 274: @13017
     /*  13017 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13073), // Rule ID 986 //
     /*  13022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13041 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13044 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  13049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13060 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13071 */     GIR_RootConstrainSelectedInstOperands,
     /*  13072 */     // GIR_Coverage, 986,
     /*  13072 */     GIR_EraseRootFromParent_Done,
     /*  13073 */   // Label 275: @13073
     /*  13073 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13129), // Rule ID 1047 //
     /*  13078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13097 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13100 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  13105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13127 */     GIR_RootConstrainSelectedInstOperands,
     /*  13128 */     // GIR_Coverage, 1047,
     /*  13128 */     GIR_EraseRootFromParent_Done,
     /*  13129 */   // Label 276: @13129
     /*  13129 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13196), // Rule ID 2229 //
     /*  13134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  13153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13162 */     // MIs[1] imm
     /*  13162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13174 */     // MIs[2] Operand 1
     /*  13174 */     // No operand predicates
     /*  13174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13180 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  13183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13194 */     GIR_RootConstrainSelectedInstOperands,
     /*  13195 */     // GIR_Coverage, 2229,
     /*  13195 */     GIR_EraseRootFromParent_Done,
     /*  13196 */   // Label 277: @13196
     /*  13196 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13263), // Rule ID 2288 //
     /*  13201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  13220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13229 */     // MIs[1] imm
     /*  13229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13241 */     // MIs[2] Operand 1
     /*  13241 */     // No operand predicates
     /*  13241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13247 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  13250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13261 */     GIR_RootConstrainSelectedInstOperands,
     /*  13262 */     // GIR_Coverage, 2288,
     /*  13262 */     GIR_EraseRootFromParent_Done,
     /*  13263 */   // Label 278: @13263
     /*  13263 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13311), // Rule ID 13054 //
     /*  13268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13298 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13309 */     GIR_RootConstrainSelectedInstOperands,
     /*  13310 */     // GIR_Coverage, 13054,
     /*  13310 */     GIR_EraseRootFromParent_Done,
     /*  13311 */   // Label 279: @13311
     /*  13311 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13359), // Rule ID 13066 //
     /*  13316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13346 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13357 */     GIR_RootConstrainSelectedInstOperands,
     /*  13358 */     // GIR_Coverage, 13066,
     /*  13358 */     GIR_EraseRootFromParent_Done,
     /*  13359 */   // Label 280: @13359
     /*  13359 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13407), // Rule ID 985 //
     /*  13364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13394 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13405 */     GIR_RootConstrainSelectedInstOperands,
     /*  13406 */     // GIR_Coverage, 985,
     /*  13406 */     GIR_EraseRootFromParent_Done,
     /*  13407 */   // Label 281: @13407
     /*  13407 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13455), // Rule ID 1046 //
     /*  13412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13442 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13453 */     GIR_RootConstrainSelectedInstOperands,
     /*  13454 */     // GIR_Coverage, 1046,
     /*  13454 */     GIR_EraseRootFromParent_Done,
     /*  13455 */   // Label 282: @13455
     /*  13455 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13482), // Rule ID 1097 //
     /*  13460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13475 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  13480 */     GIR_RootConstrainSelectedInstOperands,
     /*  13481 */     // GIR_Coverage, 1097,
     /*  13481 */     GIR_Done,
     /*  13482 */   // Label 283: @13482
     /*  13482 */   GIM_Reject,
     /*  13483 */ // Label 249: @13483
     /*  13483 */ GIM_Reject,
     /*  13484 */ // Label 158: @13484
     /*  13484 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(19385),
     /*  13489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  13492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  13495 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13613), // Rule ID 13232 //
     /*  13500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13551 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13560 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13564 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13568 */     // MIs[4] Operand 1
     /*  13568 */     // No operand predicates
     /*  13568 */     // MIs[2] Operand 2
     /*  13568 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13592 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13611 */     GIR_RootConstrainSelectedInstOperands,
     /*  13612 */     // GIR_Coverage, 13232,
     /*  13612 */     GIR_EraseRootFromParent_Done,
     /*  13613 */   // Label 285: @13613
     /*  13613 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13731), // Rule ID 13233 //
     /*  13618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13682 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13686 */     // MIs[4] Operand 1
     /*  13686 */     // No operand predicates
     /*  13686 */     // MIs[2] Operand 2
     /*  13686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13710 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13729 */     GIR_RootConstrainSelectedInstOperands,
     /*  13730 */     // GIR_Coverage, 13233,
     /*  13730 */     GIR_EraseRootFromParent_Done,
     /*  13731 */   // Label 286: @13731
     /*  13731 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13849), // Rule ID 13262 //
     /*  13736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13783 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13796 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13800 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13804 */     // MIs[4] Operand 1
     /*  13804 */     // No operand predicates
     /*  13804 */     // MIs[2] Operand 2
     /*  13804 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13828 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13847 */     GIR_RootConstrainSelectedInstOperands,
     /*  13848 */     // GIR_Coverage, 13262,
     /*  13848 */     GIR_EraseRootFromParent_Done,
     /*  13849 */   // Label 287: @13849
     /*  13849 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13967), // Rule ID 13263 //
     /*  13854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13918 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13922 */     // MIs[4] Operand 1
     /*  13922 */     // No operand predicates
     /*  13922 */     // MIs[2] Operand 2
     /*  13922 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13946 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13965 */     GIR_RootConstrainSelectedInstOperands,
     /*  13966 */     // GIR_Coverage, 13263,
     /*  13966 */     GIR_EraseRootFromParent_Done,
     /*  13967 */   // Label 288: @13967
     /*  13967 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14085), // Rule ID 2035 //
     /*  13972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14040 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14044 */     // MIs[4] Operand 1
     /*  14044 */     // No operand predicates
     /*  14044 */     // MIs[2] Operand 2
     /*  14044 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14064 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14083 */     GIR_RootConstrainSelectedInstOperands,
     /*  14084 */     // GIR_Coverage, 2035,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 289: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14203), // Rule ID 13231 //
     /*  14090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14162 */     // MIs[4] Operand 1
     /*  14162 */     // No operand predicates
     /*  14162 */     // MIs[2] Operand 2
     /*  14162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14182 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14201 */     GIR_RootConstrainSelectedInstOperands,
     /*  14202 */     // GIR_Coverage, 13231,
     /*  14202 */     GIR_EraseRootFromParent_Done,
     /*  14203 */   // Label 290: @14203
     /*  14203 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14321), // Rule ID 2087 //
     /*  14208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14276 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14280 */     // MIs[4] Operand 1
     /*  14280 */     // No operand predicates
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14300 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14319 */     GIR_RootConstrainSelectedInstOperands,
     /*  14320 */     // GIR_Coverage, 2087,
     /*  14320 */     GIR_EraseRootFromParent_Done,
     /*  14321 */   // Label 291: @14321
     /*  14321 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14439), // Rule ID 13261 //
     /*  14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14394 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14398 */     // MIs[4] Operand 1
     /*  14398 */     // No operand predicates
     /*  14398 */     // MIs[2] Operand 2
     /*  14398 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14409 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14418 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14437 */     GIR_RootConstrainSelectedInstOperands,
     /*  14438 */     // GIR_Coverage, 13261,
     /*  14438 */     GIR_EraseRootFromParent_Done,
     /*  14439 */   // Label 292: @14439
     /*  14439 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14526), // Rule ID 13137 //
     /*  14444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14471 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14474 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14483 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14507 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14524 */     GIR_RootConstrainSelectedInstOperands,
     /*  14525 */     // GIR_Coverage, 13137,
     /*  14525 */     GIR_EraseRootFromParent_Done,
     /*  14526 */   // Label 293: @14526
     /*  14526 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14613), // Rule ID 13161 //
     /*  14531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14558 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14561 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14570 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14594 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14611 */     GIR_RootConstrainSelectedInstOperands,
     /*  14612 */     // GIR_Coverage, 13161,
     /*  14612 */     GIR_EraseRootFromParent_Done,
     /*  14613 */   // Label 294: @14613
     /*  14613 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14700), // Rule ID 1692 //
     /*  14618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14649 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14652 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14661 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14681 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14698 */     GIR_RootConstrainSelectedInstOperands,
     /*  14699 */     // GIR_Coverage, 1692,
     /*  14699 */     GIR_EraseRootFromParent_Done,
     /*  14700 */   // Label 295: @14700
     /*  14700 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14787), // Rule ID 1770 //
     /*  14705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14736 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14739 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14748 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14768 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14785 */     GIR_RootConstrainSelectedInstOperands,
     /*  14786 */     // GIR_Coverage, 1770,
     /*  14786 */     GIR_EraseRootFromParent_Done,
     /*  14787 */   // Label 296: @14787
     /*  14787 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14902), // Rule ID 13227 //
     /*  14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14835 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14856 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14860 */     // MIs[4] Operand 1
     /*  14860 */     // No operand predicates
     /*  14860 */     // MIs[2] Operand 2
     /*  14860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14882 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  14885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14900 */     GIR_RootConstrainSelectedInstOperands,
     /*  14901 */     // GIR_Coverage, 13227,
     /*  14901 */     GIR_EraseRootFromParent_Done,
     /*  14902 */   // Label 297: @14902
     /*  14902 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15017), // Rule ID 13226 //
     /*  14907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14980 */     // MIs[4] Operand 1
     /*  14980 */     // No operand predicates
     /*  14980 */     // MIs[2] Operand 2
     /*  14980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14995 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14997 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15015 */     GIR_RootConstrainSelectedInstOperands,
     /*  15016 */     // GIR_Coverage, 13226,
     /*  15016 */     GIR_EraseRootFromParent_Done,
     /*  15017 */   // Label 298: @15017
     /*  15017 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15132), // Rule ID 13257 //
     /*  15022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15065 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15069 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15086 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15090 */     // MIs[4] Operand 1
     /*  15090 */     // No operand predicates
     /*  15090 */     // MIs[2] Operand 2
     /*  15090 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15112 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15130 */     GIR_RootConstrainSelectedInstOperands,
     /*  15131 */     // GIR_Coverage, 13257,
     /*  15131 */     GIR_EraseRootFromParent_Done,
     /*  15132 */   // Label 299: @15132
     /*  15132 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15247), // Rule ID 13256 //
     /*  15137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15189 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15206 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15210 */     // MIs[4] Operand 1
     /*  15210 */     // No operand predicates
     /*  15210 */     // MIs[2] Operand 2
     /*  15210 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15227 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15245 */     GIR_RootConstrainSelectedInstOperands,
     /*  15246 */     // GIR_Coverage, 13256,
     /*  15246 */     GIR_EraseRootFromParent_Done,
     /*  15247 */   // Label 300: @15247
     /*  15247 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15316), // Rule ID 1794 //
     /*  15252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15299 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 1794,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 301: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15385), // Rule ID 1793 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15368 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15383 */     GIR_RootConstrainSelectedInstOperands,
     /*  15384 */     // GIR_Coverage, 1793,
     /*  15384 */     GIR_EraseRootFromParent_Done,
     /*  15385 */   // Label 302: @15385
     /*  15385 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15454), // Rule ID 1710 //
     /*  15390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15437 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15452 */     GIR_RootConstrainSelectedInstOperands,
     /*  15453 */     // GIR_Coverage, 1710,
     /*  15453 */     GIR_EraseRootFromParent_Done,
     /*  15454 */   // Label 303: @15454
     /*  15454 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15523), // Rule ID 1792 //
     /*  15459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15506 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15521 */     GIR_RootConstrainSelectedInstOperands,
     /*  15522 */     // GIR_Coverage, 1792,
     /*  15522 */     GIR_EraseRootFromParent_Done,
     /*  15523 */   // Label 304: @15523
     /*  15523 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15592), // Rule ID 1791 //
     /*  15528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15575 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15590 */     GIR_RootConstrainSelectedInstOperands,
     /*  15591 */     // GIR_Coverage, 1791,
     /*  15591 */     GIR_EraseRootFromParent_Done,
     /*  15592 */   // Label 305: @15592
     /*  15592 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15707), // Rule ID 13225 //
     /*  15597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15652 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15661 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15665 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15669 */     // MIs[4] Operand 1
     /*  15669 */     // No operand predicates
     /*  15669 */     // MIs[2] Operand 2
     /*  15669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15687 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13225,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 306: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15822), // Rule ID 2033 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15785 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15789 */     // MIs[4] Operand 1
     /*  15789 */     // No operand predicates
     /*  15789 */     // MIs[2] Operand 2
     /*  15789 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15800 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15802 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15820 */     GIR_RootConstrainSelectedInstOperands,
     /*  15821 */     // GIR_Coverage, 2033,
     /*  15821 */     GIR_EraseRootFromParent_Done,
     /*  15822 */   // Label 307: @15822
     /*  15822 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15937), // Rule ID 13255 //
     /*  15827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15891 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15895 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15899 */     // MIs[4] Operand 1
     /*  15899 */     // No operand predicates
     /*  15899 */     // MIs[2] Operand 2
     /*  15899 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15917 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15935 */     GIR_RootConstrainSelectedInstOperands,
     /*  15936 */     // GIR_Coverage, 13255,
     /*  15936 */     GIR_EraseRootFromParent_Done,
     /*  15937 */   // Label 308: @15937
     /*  15937 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16052), // Rule ID 2085 //
     /*  15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16015 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16019 */     // MIs[4] Operand 1
     /*  16019 */     // No operand predicates
     /*  16019 */     // MIs[2] Operand 2
     /*  16019 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16032 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16050 */     GIR_RootConstrainSelectedInstOperands,
     /*  16051 */     // GIR_Coverage, 2085,
     /*  16051 */     GIR_EraseRootFromParent_Done,
     /*  16052 */   // Label 309: @16052
     /*  16052 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16119), // Rule ID 13149 //
     /*  16057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16100 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16117 */     GIR_RootConstrainSelectedInstOperands,
     /*  16118 */     // GIR_Coverage, 13149,
     /*  16118 */     GIR_EraseRootFromParent_Done,
     /*  16119 */   // Label 310: @16119
     /*  16119 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16186), // Rule ID 13179 //
     /*  16124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16167 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16184 */     GIR_RootConstrainSelectedInstOperands,
     /*  16185 */     // GIR_Coverage, 13179,
     /*  16185 */     GIR_EraseRootFromParent_Done,
     /*  16186 */   // Label 311: @16186
     /*  16186 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16253), // Rule ID 1722 //
     /*  16191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16234 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16251 */     GIR_RootConstrainSelectedInstOperands,
     /*  16252 */     // GIR_Coverage, 1722,
     /*  16252 */     GIR_EraseRootFromParent_Done,
     /*  16253 */   // Label 312: @16253
     /*  16253 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16320), // Rule ID 1812 //
     /*  16258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16301 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16318 */     GIR_RootConstrainSelectedInstOperands,
     /*  16319 */     // GIR_Coverage, 1812,
     /*  16319 */     GIR_EraseRootFromParent_Done,
     /*  16320 */   // Label 313: @16320
     /*  16320 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16401), // Rule ID 13135 //
     /*  16325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16352 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16355 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16364 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16384 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16399 */     GIR_RootConstrainSelectedInstOperands,
     /*  16400 */     // GIR_Coverage, 13135,
     /*  16400 */     GIR_EraseRootFromParent_Done,
     /*  16401 */   // Label 314: @16401
     /*  16401 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16482), // Rule ID 13159 //
     /*  16406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16433 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16436 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16445 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16465 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16480 */     GIR_RootConstrainSelectedInstOperands,
     /*  16481 */     // GIR_Coverage, 13159,
     /*  16481 */     GIR_EraseRootFromParent_Done,
     /*  16482 */   // Label 315: @16482
     /*  16482 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16563), // Rule ID 1690 //
     /*  16487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16518 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16521 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16530 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16546 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16561 */     GIR_RootConstrainSelectedInstOperands,
     /*  16562 */     // GIR_Coverage, 1690,
     /*  16562 */     GIR_EraseRootFromParent_Done,
     /*  16563 */   // Label 316: @16563
     /*  16563 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16644), // Rule ID 1768 //
     /*  16568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16599 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16602 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16611 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16627 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16642 */     GIR_RootConstrainSelectedInstOperands,
     /*  16643 */     // GIR_Coverage, 1768,
     /*  16643 */     GIR_EraseRootFromParent_Done,
     /*  16644 */   // Label 317: @16644
     /*  16644 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16736), // Rule ID 13230 //
     /*  16649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16701 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16705 */     // MIs[3] Operand 1
     /*  16705 */     // No operand predicates
     /*  16705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16716 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16734 */     GIR_RootConstrainSelectedInstOperands,
     /*  16735 */     // GIR_Coverage, 13230,
     /*  16735 */     GIR_EraseRootFromParent_Done,
     /*  16736 */   // Label 318: @16736
     /*  16736 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16828), // Rule ID 13229 //
     /*  16741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16802 */     // MIs[3] Operand 1
     /*  16802 */     // No operand predicates
     /*  16802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16808 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16826 */     GIR_RootConstrainSelectedInstOperands,
     /*  16827 */     // GIR_Coverage, 13229,
     /*  16827 */     GIR_EraseRootFromParent_Done,
     /*  16828 */   // Label 319: @16828
     /*  16828 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16920), // Rule ID 13260 //
     /*  16833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16889 */     // MIs[3] Operand 1
     /*  16889 */     // No operand predicates
     /*  16889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16900 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16918 */     GIR_RootConstrainSelectedInstOperands,
     /*  16919 */     // GIR_Coverage, 13260,
     /*  16919 */     GIR_EraseRootFromParent_Done,
     /*  16920 */   // Label 320: @16920
     /*  16920 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17012), // Rule ID 13259 //
     /*  16925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16982 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16986 */     // MIs[3] Operand 1
     /*  16986 */     // No operand predicates
     /*  16986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16992 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17010 */     GIR_RootConstrainSelectedInstOperands,
     /*  17011 */     // GIR_Coverage, 13259,
     /*  17011 */     GIR_EraseRootFromParent_Done,
     /*  17012 */   // Label 321: @17012
     /*  17012 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17104), // Rule ID 13228 //
     /*  17017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17077 */     // MIs[3] Operand 1
     /*  17077 */     // No operand predicates
     /*  17077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17102 */     GIR_RootConstrainSelectedInstOperands,
     /*  17103 */     // GIR_Coverage, 13228,
     /*  17103 */     GIR_EraseRootFromParent_Done,
     /*  17104 */   // Label 322: @17104
     /*  17104 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17196), // Rule ID 2034 //
     /*  17109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17174 */     // MIs[3] Operand 1
     /*  17174 */     // No operand predicates
     /*  17174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17176 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17194 */     GIR_RootConstrainSelectedInstOperands,
     /*  17195 */     // GIR_Coverage, 2034,
     /*  17195 */     GIR_EraseRootFromParent_Done,
     /*  17196 */   // Label 323: @17196
     /*  17196 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17288), // Rule ID 13258 //
     /*  17201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17261 */     // MIs[3] Operand 1
     /*  17261 */     // No operand predicates
     /*  17261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17268 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17286 */     GIR_RootConstrainSelectedInstOperands,
     /*  17287 */     // GIR_Coverage, 13258,
     /*  17287 */     GIR_EraseRootFromParent_Done,
     /*  17288 */   // Label 324: @17288
     /*  17288 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17380), // Rule ID 2086 //
     /*  17293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17358 */     // MIs[3] Operand 1
     /*  17358 */     // No operand predicates
     /*  17358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17360 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17378 */     GIR_RootConstrainSelectedInstOperands,
     /*  17379 */     // GIR_Coverage, 2086,
     /*  17379 */     GIR_EraseRootFromParent_Done,
     /*  17380 */   // Label 325: @17380
     /*  17380 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17431), // Rule ID 13173 //
     /*  17385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17417 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17429 */     GIR_RootConstrainSelectedInstOperands,
     /*  17430 */     // GIR_Coverage, 13173,
     /*  17430 */     GIR_EraseRootFromParent_Done,
     /*  17431 */   // Label 326: @17431
     /*  17431 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17482), // Rule ID 13143 //
     /*  17436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17468 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17480 */     GIR_RootConstrainSelectedInstOperands,
     /*  17481 */     // GIR_Coverage, 13143,
     /*  17481 */     GIR_EraseRootFromParent_Done,
     /*  17482 */   // Label 327: @17482
     /*  17482 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17533), // Rule ID 13172 //
     /*  17487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17519 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17531 */     GIR_RootConstrainSelectedInstOperands,
     /*  17532 */     // GIR_Coverage, 13172,
     /*  17532 */     GIR_EraseRootFromParent_Done,
     /*  17533 */   // Label 328: @17533
     /*  17533 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17584), // Rule ID 1806 //
     /*  17538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17570 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17582 */     GIR_RootConstrainSelectedInstOperands,
     /*  17583 */     // GIR_Coverage, 1806,
     /*  17583 */     GIR_EraseRootFromParent_Done,
     /*  17584 */   // Label 329: @17584
     /*  17584 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17635), // Rule ID 1716 //
     /*  17589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17621 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17633 */     GIR_RootConstrainSelectedInstOperands,
     /*  17634 */     // GIR_Coverage, 1716,
     /*  17634 */     GIR_EraseRootFromParent_Done,
     /*  17635 */   // Label 330: @17635
     /*  17635 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17686), // Rule ID 1805 //
     /*  17640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17672 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17684 */     GIR_RootConstrainSelectedInstOperands,
     /*  17685 */     // GIR_Coverage, 1805,
     /*  17685 */     GIR_EraseRootFromParent_Done,
     /*  17686 */   // Label 331: @17686
     /*  17686 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17742), // Rule ID 13061 //
     /*  17691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17706 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17709 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17729 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17740 */     GIR_RootConstrainSelectedInstOperands,
     /*  17741 */     // GIR_Coverage, 13061,
     /*  17741 */     GIR_EraseRootFromParent_Done,
     /*  17742 */   // Label 332: @17742
     /*  17742 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17798), // Rule ID 13073 //
     /*  17747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  17770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17785 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  17788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17796 */     GIR_RootConstrainSelectedInstOperands,
     /*  17797 */     // GIR_Coverage, 13073,
     /*  17797 */     GIR_EraseRootFromParent_Done,
     /*  17798 */   // Label 333: @17798
     /*  17798 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17865), // Rule ID 13301 //
     /*  17803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  17818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17827 */     // MIs[1] imm
     /*  17827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17839 */     // MIs[2] Operand 1
     /*  17839 */     // No operand predicates
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17849 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  17852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17863 */     GIR_RootConstrainSelectedInstOperands,
     /*  17864 */     // GIR_Coverage, 13301,
     /*  17864 */     GIR_EraseRootFromParent_Done,
     /*  17865 */   // Label 334: @17865
     /*  17865 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17932), // Rule ID 13322 //
     /*  17870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  17885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17894 */     // MIs[1] imm
     /*  17894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17906 */     // MIs[2] Operand 1
     /*  17906 */     // No operand predicates
     /*  17906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17916 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  17919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17930 */     GIR_RootConstrainSelectedInstOperands,
     /*  17931 */     // GIR_Coverage, 13322,
     /*  17931 */     GIR_EraseRootFromParent_Done,
     /*  17932 */   // Label 335: @17932
     /*  17932 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17988), // Rule ID 992 //
     /*  17937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17975 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17986 */     GIR_RootConstrainSelectedInstOperands,
     /*  17987 */     // GIR_Coverage, 992,
     /*  17987 */     GIR_EraseRootFromParent_Done,
     /*  17988 */   // Label 336: @17988
     /*  17988 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18044), // Rule ID 1053 //
     /*  17993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  18015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  18020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18031 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18042 */     GIR_RootConstrainSelectedInstOperands,
     /*  18043 */     // GIR_Coverage, 1053,
     /*  18043 */     GIR_EraseRootFromParent_Done,
     /*  18044 */   // Label 337: @18044
     /*  18044 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18111), // Rule ID 2233 //
     /*  18049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  18068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18077 */     // MIs[1] imm
     /*  18077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18089 */     // MIs[2] Operand 1
     /*  18089 */     // No operand predicates
     /*  18089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18095 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  18098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18109 */     GIR_RootConstrainSelectedInstOperands,
     /*  18110 */     // GIR_Coverage, 2233,
     /*  18110 */     GIR_EraseRootFromParent_Done,
     /*  18111 */   // Label 338: @18111
     /*  18111 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18178), // Rule ID 2292 //
     /*  18116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  18135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18144 */     // MIs[1] imm
     /*  18144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18156 */     // MIs[2] Operand 1
     /*  18156 */     // No operand predicates
     /*  18156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18162 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  18165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18176 */     GIR_RootConstrainSelectedInstOperands,
     /*  18177 */     // GIR_Coverage, 2292,
     /*  18177 */     GIR_EraseRootFromParent_Done,
     /*  18178 */   // Label 339: @18178
     /*  18178 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18248), // Rule ID 6836 //
     /*  18183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18221 */     // MIs[2] Rn
     /*  18221 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18226 */     // MIs[2] Rm
     /*  18226 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18233 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18246 */     GIR_RootConstrainSelectedInstOperands,
     /*  18247 */     // GIR_Coverage, 6836,
     /*  18247 */     GIR_EraseRootFromParent_Done,
     /*  18248 */   // Label 340: @18248
     /*  18248 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18318), // Rule ID 13683 //
     /*  18253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18291 */     // MIs[2] Rn
     /*  18291 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18296 */     // MIs[2] Rm
     /*  18296 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18303 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18316 */     GIR_RootConstrainSelectedInstOperands,
     /*  18317 */     // GIR_Coverage, 13683,
     /*  18317 */     GIR_EraseRootFromParent_Done,
     /*  18318 */   // Label 341: @18318
     /*  18318 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18381), // Rule ID 1790 //
     /*  18323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18366 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 1790,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 342: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18444), // Rule ID 1789 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18429 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18442 */     GIR_RootConstrainSelectedInstOperands,
     /*  18443 */     // GIR_Coverage, 1789,
     /*  18443 */     GIR_EraseRootFromParent_Done,
     /*  18444 */   // Label 343: @18444
     /*  18444 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18507), // Rule ID 1709 //
     /*  18449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18492 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  18495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18505 */     GIR_RootConstrainSelectedInstOperands,
     /*  18506 */     // GIR_Coverage, 1709,
     /*  18506 */     GIR_EraseRootFromParent_Done,
     /*  18507 */   // Label 344: @18507
     /*  18507 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18570), // Rule ID 1788 //
     /*  18512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18555 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18568 */     GIR_RootConstrainSelectedInstOperands,
     /*  18569 */     // GIR_Coverage, 1788,
     /*  18569 */     GIR_EraseRootFromParent_Done,
     /*  18570 */   // Label 345: @18570
     /*  18570 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18633), // Rule ID 1787 //
     /*  18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18618 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18631 */     GIR_RootConstrainSelectedInstOperands,
     /*  18632 */     // GIR_Coverage, 1787,
     /*  18632 */     GIR_EraseRootFromParent_Done,
     /*  18633 */   // Label 346: @18633
     /*  18633 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18694), // Rule ID 13148 //
     /*  18638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18677 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  18680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18692 */     GIR_RootConstrainSelectedInstOperands,
     /*  18693 */     // GIR_Coverage, 13148,
     /*  18693 */     GIR_EraseRootFromParent_Done,
     /*  18694 */   // Label 347: @18694
     /*  18694 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18755), // Rule ID 13178 //
     /*  18699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18738 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18753 */     GIR_RootConstrainSelectedInstOperands,
     /*  18754 */     // GIR_Coverage, 13178,
     /*  18754 */     GIR_EraseRootFromParent_Done,
     /*  18755 */   // Label 348: @18755
     /*  18755 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18803), // Rule ID 13171 //
     /*  18760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18790 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18801 */     GIR_RootConstrainSelectedInstOperands,
     /*  18802 */     // GIR_Coverage, 13171,
     /*  18802 */     GIR_EraseRootFromParent_Done,
     /*  18803 */   // Label 349: @18803
     /*  18803 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18851), // Rule ID 13060 //
     /*  18808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  18823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18838 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  18841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18849 */     GIR_RootConstrainSelectedInstOperands,
     /*  18850 */     // GIR_Coverage, 13060,
     /*  18850 */     GIR_EraseRootFromParent_Done,
     /*  18851 */   // Label 350: @18851
     /*  18851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18899), // Rule ID 13142 //
     /*  18856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18886 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  18889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18897 */     GIR_RootConstrainSelectedInstOperands,
     /*  18898 */     // GIR_Coverage, 13142,
     /*  18898 */     GIR_EraseRootFromParent_Done,
     /*  18899 */   // Label 351: @18899
     /*  18899 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18947), // Rule ID 13072 //
     /*  18904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  18919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18934 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18945 */     GIR_RootConstrainSelectedInstOperands,
     /*  18946 */     // GIR_Coverage, 13072,
     /*  18946 */     GIR_EraseRootFromParent_Done,
     /*  18947 */   // Label 352: @18947
     /*  18947 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18995), // Rule ID 13170 //
     /*  18952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18982 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18993 */     GIR_RootConstrainSelectedInstOperands,
     /*  18994 */     // GIR_Coverage, 13170,
     /*  18994 */     GIR_EraseRootFromParent_Done,
     /*  18995 */   // Label 353: @18995
     /*  18995 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19056), // Rule ID 1721 //
     /*  19000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  19042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19054 */     GIR_RootConstrainSelectedInstOperands,
     /*  19055 */     // GIR_Coverage, 1721,
     /*  19055 */     GIR_EraseRootFromParent_Done,
     /*  19056 */   // Label 354: @19056
     /*  19056 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19117), // Rule ID 1811 //
     /*  19061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19115 */     GIR_RootConstrainSelectedInstOperands,
     /*  19116 */     // GIR_Coverage, 1811,
     /*  19116 */     GIR_EraseRootFromParent_Done,
     /*  19117 */   // Label 355: @19117
     /*  19117 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19165), // Rule ID 1804 //
     /*  19122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19152 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19163 */     GIR_RootConstrainSelectedInstOperands,
     /*  19164 */     // GIR_Coverage, 1804,
     /*  19164 */     GIR_EraseRootFromParent_Done,
     /*  19165 */   // Label 356: @19165
     /*  19165 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19213), // Rule ID 991 //
     /*  19170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  19189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19200 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19211 */     GIR_RootConstrainSelectedInstOperands,
     /*  19212 */     // GIR_Coverage, 991,
     /*  19212 */     GIR_EraseRootFromParent_Done,
     /*  19213 */   // Label 357: @19213
     /*  19213 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19261), // Rule ID 1715 //
     /*  19218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19248 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  19251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19259 */     GIR_RootConstrainSelectedInstOperands,
     /*  19260 */     // GIR_Coverage, 1715,
     /*  19260 */     GIR_EraseRootFromParent_Done,
     /*  19261 */   // Label 358: @19261
     /*  19261 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19309), // Rule ID 1052 //
     /*  19266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  19285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19296 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19307 */     GIR_RootConstrainSelectedInstOperands,
     /*  19308 */     // GIR_Coverage, 1052,
     /*  19308 */     GIR_EraseRootFromParent_Done,
     /*  19309 */   // Label 359: @19309
     /*  19309 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19357), // Rule ID 1803 //
     /*  19314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19344 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19355 */     GIR_RootConstrainSelectedInstOperands,
     /*  19356 */     // GIR_Coverage, 1803,
     /*  19356 */     GIR_EraseRootFromParent_Done,
     /*  19357 */   // Label 360: @19357
     /*  19357 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19384), // Rule ID 1099 //
     /*  19362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19377 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  19377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  19382 */     GIR_RootConstrainSelectedInstOperands,
     /*  19383 */     // GIR_Coverage, 1099,
     /*  19383 */     GIR_Done,
     /*  19384 */   // Label 361: @19384
     /*  19384 */   GIM_Reject,
     /*  19385 */ // Label 284: @19385
     /*  19385 */ GIM_Reject,
     /*  19386 */ // Label 159: @19386
     /*  19386 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(22883),
     /*  19391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  19394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  19397 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19533), // Rule ID 5305 //
     /*  19402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19435 */     // MIs[1] Operand 2
     /*  19435 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19466 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19470 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19475 */     // MIs[3] Operand 2
     /*  19475 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19488 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19532 */     // GIR_Coverage, 5305,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 363: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19669), // Rule ID 5304 //
     /*  19538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19571 */     // MIs[1] Operand 2
     /*  19571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19602 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19606 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19611 */     // MIs[3] Operand 2
     /*  19611 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19624 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     // GIR_Coverage, 5304,
     /*  19668 */     GIR_EraseRootFromParent_Done,
     /*  19669 */   // Label 364: @19669
     /*  19669 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19805), // Rule ID 5320 //
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19707 */     // MIs[1] Operand 2
     /*  19707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19742 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19747 */     // MIs[3] Operand 2
     /*  19747 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19760 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  19767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19804 */     // GIR_Coverage, 5320,
     /*  19804 */     GIR_EraseRootFromParent_Done,
     /*  19805 */   // Label 365: @19805
     /*  19805 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19941), // Rule ID 5303 //
     /*  19810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19843 */     // MIs[1] Operand 2
     /*  19843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19870 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19874 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19878 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19883 */     // MIs[3] Operand 2
     /*  19883 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19896 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19923 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19940 */     // GIR_Coverage, 5303,
     /*  19940 */     GIR_EraseRootFromParent_Done,
     /*  19941 */   // Label 366: @19941
     /*  19941 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20077), // Rule ID 5302 //
     /*  19946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19979 */     // MIs[1] Operand 2
     /*  19979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20010 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20014 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20019 */     // MIs[3] Operand 2
     /*  20019 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20032 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  20039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  20052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20076 */     // GIR_Coverage, 5302,
     /*  20076 */     GIR_EraseRootFromParent_Done,
     /*  20077 */   // Label 367: @20077
     /*  20077 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20210), // Rule ID 13688 //
     /*  20082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20127 */     // MIs[1] Operand 2
     /*  20127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20146 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20154 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20158 */     // MIs[5] Rn
     /*  20158 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20163 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20165 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20192 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20209 */     // GIR_Coverage, 13688,
     /*  20209 */     GIR_EraseRootFromParent_Done,
     /*  20210 */   // Label 368: @20210
     /*  20210 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20343), // Rule ID 6841 //
     /*  20215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  20268 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20272 */     // MIs[4] Rn
     /*  20272 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20277 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20281 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20285 */     // MIs[3] Operand 2
     /*  20285 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20296 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20298 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20325 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20342 */     // GIR_Coverage, 6841,
     /*  20342 */     GIR_EraseRootFromParent_Done,
     /*  20343 */   // Label 369: @20343
     /*  20343 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20506), // Rule ID 13640 //
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  20372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20390 */     // MIs[1] Operand 2
     /*  20390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20407 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20407 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20410 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20414 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20433 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20436 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20440 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  20465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20488 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20505 */     // GIR_Coverage, 13640,
     /*  20505 */     GIR_EraseRootFromParent_Done,
     /*  20506 */   // Label 370: @20506
     /*  20506 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20669), // Rule ID 13637 //
     /*  20511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  20535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20553 */     // MIs[1] Operand 2
     /*  20553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20570 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20596 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  20628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     // GIR_Coverage, 13637,
     /*  20668 */     GIR_EraseRootFromParent_Done,
     /*  20669 */   // Label 371: @20669
     /*  20669 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20819), // Rule ID 13644 //
     /*  20674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20707 */     // MIs[1] Operand 2
     /*  20707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20724 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20750 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20753 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20757 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  20782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20818 */     // GIR_Coverage, 13644,
     /*  20818 */     GIR_EraseRootFromParent_Done,
     /*  20819 */   // Label 372: @20819
     /*  20819 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20969), // Rule ID 13649 //
     /*  20824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20857 */     // MIs[1] Operand 2
     /*  20857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20874 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20874 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20877 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20881 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20900 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20907 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  20932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20951 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20968 */     // GIR_Coverage, 13649,
     /*  20968 */     GIR_EraseRootFromParent_Done,
     /*  20969 */   // Label 373: @20969
     /*  20969 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21119), // Rule ID 13643 //
     /*  20974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21007 */     // MIs[1] Operand 2
     /*  21007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21024 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21050 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  21057 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21101 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21118 */     // GIR_Coverage, 13643,
     /*  21118 */     GIR_EraseRootFromParent_Done,
     /*  21119 */   // Label 374: @21119
     /*  21119 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21282), // Rule ID 5293 //
     /*  21124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  21152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21170 */     // MIs[1] Operand 2
     /*  21170 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21183 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21183 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21186 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21190 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21209 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  21241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21281 */     // GIR_Coverage, 5293,
     /*  21281 */     GIR_EraseRootFromParent_Done,
     /*  21282 */   // Label 375: @21282
     /*  21282 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21445), // Rule ID 5290 //
     /*  21287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  21315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21333 */     // MIs[1] Operand 2
     /*  21333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21346 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  21404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21444 */     // GIR_Coverage, 5290,
     /*  21444 */     GIR_EraseRootFromParent_Done,
     /*  21445 */   // Label 376: @21445
     /*  21445 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21595), // Rule ID 5315 //
     /*  21450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[1] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21500 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21526 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21533 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21577 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21594 */     // GIR_Coverage, 5315,
     /*  21594 */     GIR_EraseRootFromParent_Done,
     /*  21595 */   // Label 377: @21595
     /*  21595 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21745), // Rule ID 5323 //
     /*  21600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21637 */     // MIs[1] Operand 2
     /*  21637 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21650 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21676 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21683 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  21708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21744 */     // GIR_Coverage, 5323,
     /*  21744 */     GIR_EraseRootFromParent_Done,
     /*  21745 */   // Label 378: @21745
     /*  21745 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21895), // Rule ID 5314 //
     /*  21750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21800 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21826 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21829 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21894 */     // GIR_Coverage, 5314,
     /*  21894 */     GIR_EraseRootFromParent_Done,
     /*  21895 */   // Label 379: @21895
     /*  21895 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21964), // Rule ID 13089 //
     /*  21900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  21923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  21931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21947 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  21947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  21950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  21958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  21962 */     GIR_RootConstrainSelectedInstOperands,
     /*  21963 */     // GIR_Coverage, 13089,
     /*  21963 */     GIR_EraseRootFromParent_Done,
     /*  21964 */   // Label 380: @21964
     /*  21964 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22033), // Rule ID 13101 //
     /*  21969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  21992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22016 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22031 */     GIR_RootConstrainSelectedInstOperands,
     /*  22032 */     // GIR_Coverage, 13101,
     /*  22032 */     GIR_EraseRootFromParent_Done,
     /*  22033 */   // Label 381: @22033
     /*  22033 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22089), // Rule ID 13051 //
     /*  22038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22053 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22056 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22076 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22087 */     GIR_RootConstrainSelectedInstOperands,
     /*  22088 */     // GIR_Coverage, 13051,
     /*  22088 */     GIR_EraseRootFromParent_Done,
     /*  22089 */   // Label 382: @22089
     /*  22089 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22145), // Rule ID 13063 //
     /*  22094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22109 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22112 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22132 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22143 */     GIR_RootConstrainSelectedInstOperands,
     /*  22144 */     // GIR_Coverage, 13063,
     /*  22144 */     GIR_EraseRootFromParent_Done,
     /*  22145 */   // Label 383: @22145
     /*  22145 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22212), // Rule ID 13293 //
     /*  22150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22174 */     // MIs[1] imm
     /*  22174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22186 */     // MIs[2] Operand 1
     /*  22186 */     // No operand predicates
     /*  22186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22196 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22210 */     GIR_RootConstrainSelectedInstOperands,
     /*  22211 */     // GIR_Coverage, 13293,
     /*  22211 */     GIR_EraseRootFromParent_Done,
     /*  22212 */   // Label 384: @22212
     /*  22212 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22279), // Rule ID 13314 //
     /*  22217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22241 */     // MIs[1] imm
     /*  22241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22253 */     // MIs[2] Operand 1
     /*  22253 */     // No operand predicates
     /*  22253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22263 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22277 */     GIR_RootConstrainSelectedInstOperands,
     /*  22278 */     // GIR_Coverage, 13314,
     /*  22278 */     GIR_EraseRootFromParent_Done,
     /*  22279 */   // Label 385: @22279
     /*  22279 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22348), // Rule ID 1354 //
     /*  22284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  22311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22331 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  22334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22346 */     GIR_RootConstrainSelectedInstOperands,
     /*  22347 */     // GIR_Coverage, 1354,
     /*  22347 */     GIR_EraseRootFromParent_Done,
     /*  22348 */   // Label 386: @22348
     /*  22348 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22417), // Rule ID 1477 //
     /*  22353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  22380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22384 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22400 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22415 */     GIR_RootConstrainSelectedInstOperands,
     /*  22416 */     // GIR_Coverage, 1477,
     /*  22416 */     GIR_EraseRootFromParent_Done,
     /*  22417 */   // Label 387: @22417
     /*  22417 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22473), // Rule ID 982 //
     /*  22422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22441 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22444 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22460 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22471 */     GIR_RootConstrainSelectedInstOperands,
     /*  22472 */     // GIR_Coverage, 982,
     /*  22472 */     GIR_EraseRootFromParent_Done,
     /*  22473 */   // Label 388: @22473
     /*  22473 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22529), // Rule ID 1043 //
     /*  22478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22497 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22500 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22516 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22527 */     GIR_RootConstrainSelectedInstOperands,
     /*  22528 */     // GIR_Coverage, 1043,
     /*  22528 */     GIR_EraseRootFromParent_Done,
     /*  22529 */   // Label 389: @22529
     /*  22529 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22596), // Rule ID 2225 //
     /*  22534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22562 */     // MIs[1] imm
     /*  22562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22570 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22574 */     // MIs[2] Operand 1
     /*  22574 */     // No operand predicates
     /*  22574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22580 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22594 */     GIR_RootConstrainSelectedInstOperands,
     /*  22595 */     // GIR_Coverage, 2225,
     /*  22595 */     GIR_EraseRootFromParent_Done,
     /*  22596 */   // Label 390: @22596
     /*  22596 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22663), // Rule ID 2284 //
     /*  22601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22629 */     // MIs[1] imm
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22641 */     // MIs[2] Operand 1
     /*  22641 */     // No operand predicates
     /*  22641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22647 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22661 */     GIR_RootConstrainSelectedInstOperands,
     /*  22662 */     // GIR_Coverage, 2284,
     /*  22662 */     GIR_EraseRootFromParent_Done,
     /*  22663 */   // Label 391: @22663
     /*  22663 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22711), // Rule ID 13050 //
     /*  22668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22698 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22709 */     GIR_RootConstrainSelectedInstOperands,
     /*  22710 */     // GIR_Coverage, 13050,
     /*  22710 */     GIR_EraseRootFromParent_Done,
     /*  22711 */   // Label 392: @22711
     /*  22711 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22759), // Rule ID 13062 //
     /*  22716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22746 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22757 */     GIR_RootConstrainSelectedInstOperands,
     /*  22758 */     // GIR_Coverage, 13062,
     /*  22758 */     GIR_EraseRootFromParent_Done,
     /*  22759 */   // Label 393: @22759
     /*  22759 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22807), // Rule ID 981 //
     /*  22764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22794 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22805 */     GIR_RootConstrainSelectedInstOperands,
     /*  22806 */     // GIR_Coverage, 981,
     /*  22806 */     GIR_EraseRootFromParent_Done,
     /*  22807 */   // Label 394: @22807
     /*  22807 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22855), // Rule ID 1042 //
     /*  22812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22842 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22853 */     GIR_RootConstrainSelectedInstOperands,
     /*  22854 */     // GIR_Coverage, 1042,
     /*  22854 */     GIR_EraseRootFromParent_Done,
     /*  22855 */   // Label 395: @22855
     /*  22855 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22882), // Rule ID 1095 //
     /*  22860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22875 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  22880 */     GIR_RootConstrainSelectedInstOperands,
     /*  22881 */     // GIR_Coverage, 1095,
     /*  22881 */     GIR_Done,
     /*  22882 */   // Label 396: @22882
     /*  22882 */   GIM_Reject,
     /*  22883 */ // Label 362: @22883
     /*  22883 */ GIM_Reject,
     /*  22884 */ // Label 160: @22884
     /*  22884 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(29061),
     /*  22889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22895 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23013), // Rule ID 13223 //
     /*  22900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  22915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  22943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  22951 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  22956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22964 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  22968 */     // MIs[4] Operand 1
     /*  22968 */     // No operand predicates
     /*  22968 */     // MIs[2] Operand 2
     /*  22968 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  22979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22983 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  22992 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  22992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  22995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23011 */     GIR_RootConstrainSelectedInstOperands,
     /*  23012 */     // GIR_Coverage, 13223,
     /*  23012 */     GIR_EraseRootFromParent_Done,
     /*  23013 */   // Label 398: @23013
     /*  23013 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23131), // Rule ID 13224 //
     /*  23018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23086 */     // MIs[4] Operand 1
     /*  23086 */     // No operand predicates
     /*  23086 */     // MIs[2] Operand 2
     /*  23086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23101 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23110 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23129 */     GIR_RootConstrainSelectedInstOperands,
     /*  23130 */     // GIR_Coverage, 13224,
     /*  23130 */     GIR_EraseRootFromParent_Done,
     /*  23131 */   // Label 399: @23131
     /*  23131 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23249), // Rule ID 13253 //
     /*  23136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23204 */     // MIs[4] Operand 1
     /*  23204 */     // No operand predicates
     /*  23204 */     // MIs[2] Operand 2
     /*  23204 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23228 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23247 */     GIR_RootConstrainSelectedInstOperands,
     /*  23248 */     // GIR_Coverage, 13253,
     /*  23248 */     GIR_EraseRootFromParent_Done,
     /*  23249 */   // Label 400: @23249
     /*  23249 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23367), // Rule ID 13254 //
     /*  23254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23318 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23322 */     // MIs[4] Operand 1
     /*  23322 */     // No operand predicates
     /*  23322 */     // MIs[2] Operand 2
     /*  23322 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23346 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 13254,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 401: @23367
     /*  23367 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23485), // Rule ID 2032 //
     /*  23372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23444 */     // MIs[4] Operand 1
     /*  23444 */     // No operand predicates
     /*  23444 */     // MIs[2] Operand 2
     /*  23444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23464 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23483 */     GIR_RootConstrainSelectedInstOperands,
     /*  23484 */     // GIR_Coverage, 2032,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 402: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23603), // Rule ID 13222 //
     /*  23490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23562 */     // MIs[4] Operand 1
     /*  23562 */     // No operand predicates
     /*  23562 */     // MIs[2] Operand 2
     /*  23562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23582 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23601 */     GIR_RootConstrainSelectedInstOperands,
     /*  23602 */     // GIR_Coverage, 13222,
     /*  23602 */     GIR_EraseRootFromParent_Done,
     /*  23603 */   // Label 403: @23603
     /*  23603 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23721), // Rule ID 2084 //
     /*  23608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23676 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23680 */     // MIs[4] Operand 1
     /*  23680 */     // No operand predicates
     /*  23680 */     // MIs[2] Operand 2
     /*  23680 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23691 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23700 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23719 */     GIR_RootConstrainSelectedInstOperands,
     /*  23720 */     // GIR_Coverage, 2084,
     /*  23720 */     GIR_EraseRootFromParent_Done,
     /*  23721 */   // Label 404: @23721
     /*  23721 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23839), // Rule ID 13252 //
     /*  23726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23798 */     // MIs[4] Operand 1
     /*  23798 */     // No operand predicates
     /*  23798 */     // MIs[2] Operand 2
     /*  23798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23818 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23837 */     GIR_RootConstrainSelectedInstOperands,
     /*  23838 */     // GIR_Coverage, 13252,
     /*  23838 */     GIR_EraseRootFromParent_Done,
     /*  23839 */   // Label 405: @23839
     /*  23839 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23926), // Rule ID 13133 //
     /*  23844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23871 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23874 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23883 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23907 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  23910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  23924 */     GIR_RootConstrainSelectedInstOperands,
     /*  23925 */     // GIR_Coverage, 13133,
     /*  23925 */     GIR_EraseRootFromParent_Done,
     /*  23926 */   // Label 406: @23926
     /*  23926 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24013), // Rule ID 13157 //
     /*  23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23958 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23961 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23970 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23994 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  23997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24011 */     GIR_RootConstrainSelectedInstOperands,
     /*  24012 */     // GIR_Coverage, 13157,
     /*  24012 */     GIR_EraseRootFromParent_Done,
     /*  24013 */   // Label 407: @24013
     /*  24013 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24100), // Rule ID 1688 //
     /*  24018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24049 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24052 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24061 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24081 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  24084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24098 */     GIR_RootConstrainSelectedInstOperands,
     /*  24099 */     // GIR_Coverage, 1688,
     /*  24099 */     GIR_EraseRootFromParent_Done,
     /*  24100 */   // Label 408: @24100
     /*  24100 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24187), // Rule ID 1766 //
     /*  24105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24136 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24139 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24148 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24168 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  24171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24185 */     GIR_RootConstrainSelectedInstOperands,
     /*  24186 */     // GIR_Coverage, 1766,
     /*  24186 */     GIR_EraseRootFromParent_Done,
     /*  24187 */   // Label 409: @24187
     /*  24187 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24302), // Rule ID 13218 //
     /*  24192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24256 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24260 */     // MIs[4] Operand 1
     /*  24260 */     // No operand predicates
     /*  24260 */     // MIs[2] Operand 2
     /*  24260 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24280 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24282 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24300 */     GIR_RootConstrainSelectedInstOperands,
     /*  24301 */     // GIR_Coverage, 13218,
     /*  24301 */     GIR_EraseRootFromParent_Done,
     /*  24302 */   // Label 410: @24302
     /*  24302 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24417), // Rule ID 13217 //
     /*  24307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24376 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24380 */     // MIs[4] Operand 1
     /*  24380 */     // No operand predicates
     /*  24380 */     // MIs[2] Operand 2
     /*  24380 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24395 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24397 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24415 */     GIR_RootConstrainSelectedInstOperands,
     /*  24416 */     // GIR_Coverage, 13217,
     /*  24416 */     GIR_EraseRootFromParent_Done,
     /*  24417 */   // Label 411: @24417
     /*  24417 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24532), // Rule ID 13248 //
     /*  24422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24486 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24490 */     // MIs[4] Operand 1
     /*  24490 */     // No operand predicates
     /*  24490 */     // MIs[2] Operand 2
     /*  24490 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24512 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24530 */     GIR_RootConstrainSelectedInstOperands,
     /*  24531 */     // GIR_Coverage, 13248,
     /*  24531 */     GIR_EraseRootFromParent_Done,
     /*  24532 */   // Label 412: @24532
     /*  24532 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24647), // Rule ID 13247 //
     /*  24537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24589 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24606 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24610 */     // MIs[4] Operand 1
     /*  24610 */     // No operand predicates
     /*  24610 */     // MIs[2] Operand 2
     /*  24610 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24625 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24627 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24645 */     GIR_RootConstrainSelectedInstOperands,
     /*  24646 */     // GIR_Coverage, 13247,
     /*  24646 */     GIR_EraseRootFromParent_Done,
     /*  24647 */   // Label 413: @24647
     /*  24647 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24716), // Rule ID 1786 //
     /*  24652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24699 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24714 */     GIR_RootConstrainSelectedInstOperands,
     /*  24715 */     // GIR_Coverage, 1786,
     /*  24715 */     GIR_EraseRootFromParent_Done,
     /*  24716 */   // Label 414: @24716
     /*  24716 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24785), // Rule ID 1785 //
     /*  24721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24768 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24783 */     GIR_RootConstrainSelectedInstOperands,
     /*  24784 */     // GIR_Coverage, 1785,
     /*  24784 */     GIR_EraseRootFromParent_Done,
     /*  24785 */   // Label 415: @24785
     /*  24785 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24854), // Rule ID 1708 //
     /*  24790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24837 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  24840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24852 */     GIR_RootConstrainSelectedInstOperands,
     /*  24853 */     // GIR_Coverage, 1708,
     /*  24853 */     GIR_EraseRootFromParent_Done,
     /*  24854 */   // Label 416: @24854
     /*  24854 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24923), // Rule ID 1784 //
     /*  24859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24906 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24921 */     GIR_RootConstrainSelectedInstOperands,
     /*  24922 */     // GIR_Coverage, 1784,
     /*  24922 */     GIR_EraseRootFromParent_Done,
     /*  24923 */   // Label 417: @24923
     /*  24923 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24992), // Rule ID 1783 //
     /*  24928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24975 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24990 */     GIR_RootConstrainSelectedInstOperands,
     /*  24991 */     // GIR_Coverage, 1783,
     /*  24991 */     GIR_EraseRootFromParent_Done,
     /*  24992 */   // Label 418: @24992
     /*  24992 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25107), // Rule ID 13216 //
     /*  24997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25052 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25057 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25061 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25065 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25069 */     // MIs[4] Operand 1
     /*  25069 */     // No operand predicates
     /*  25069 */     // MIs[2] Operand 2
     /*  25069 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25087 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13216,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 419: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25222), // Rule ID 2030 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25189 */     // MIs[4] Operand 1
     /*  25189 */     // No operand predicates
     /*  25189 */     // MIs[2] Operand 2
     /*  25189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25202 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25220 */     GIR_RootConstrainSelectedInstOperands,
     /*  25221 */     // GIR_Coverage, 2030,
     /*  25221 */     GIR_EraseRootFromParent_Done,
     /*  25222 */   // Label 420: @25222
     /*  25222 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25337), // Rule ID 13246 //
     /*  25227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25295 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25299 */     // MIs[4] Operand 1
     /*  25299 */     // No operand predicates
     /*  25299 */     // MIs[2] Operand 2
     /*  25299 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25317 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25335 */     GIR_RootConstrainSelectedInstOperands,
     /*  25336 */     // GIR_Coverage, 13246,
     /*  25336 */     GIR_EraseRootFromParent_Done,
     /*  25337 */   // Label 421: @25337
     /*  25337 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25452), // Rule ID 2082 //
     /*  25342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25402 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25415 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25419 */     // MIs[4] Operand 1
     /*  25419 */     // No operand predicates
     /*  25419 */     // MIs[2] Operand 2
     /*  25419 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25430 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25432 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25450 */     GIR_RootConstrainSelectedInstOperands,
     /*  25451 */     // GIR_Coverage, 2082,
     /*  25451 */     GIR_EraseRootFromParent_Done,
     /*  25452 */   // Label 422: @25452
     /*  25452 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25519), // Rule ID 13147 //
     /*  25457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25500 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25517 */     GIR_RootConstrainSelectedInstOperands,
     /*  25518 */     // GIR_Coverage, 13147,
     /*  25518 */     GIR_EraseRootFromParent_Done,
     /*  25519 */   // Label 423: @25519
     /*  25519 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25586), // Rule ID 13177 //
     /*  25524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25567 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25584 */     GIR_RootConstrainSelectedInstOperands,
     /*  25585 */     // GIR_Coverage, 13177,
     /*  25585 */     GIR_EraseRootFromParent_Done,
     /*  25586 */   // Label 424: @25586
     /*  25586 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25653), // Rule ID 1720 //
     /*  25591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25634 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25651 */     GIR_RootConstrainSelectedInstOperands,
     /*  25652 */     // GIR_Coverage, 1720,
     /*  25652 */     GIR_EraseRootFromParent_Done,
     /*  25653 */   // Label 425: @25653
     /*  25653 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25720), // Rule ID 1810 //
     /*  25658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25701 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25718 */     GIR_RootConstrainSelectedInstOperands,
     /*  25719 */     // GIR_Coverage, 1810,
     /*  25719 */     GIR_EraseRootFromParent_Done,
     /*  25720 */   // Label 426: @25720
     /*  25720 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25801), // Rule ID 13131 //
     /*  25725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25752 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25755 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25764 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25784 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25799 */     GIR_RootConstrainSelectedInstOperands,
     /*  25800 */     // GIR_Coverage, 13131,
     /*  25800 */     GIR_EraseRootFromParent_Done,
     /*  25801 */   // Label 427: @25801
     /*  25801 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25882), // Rule ID 13155 //
     /*  25806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25845 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25865 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25880 */     GIR_RootConstrainSelectedInstOperands,
     /*  25881 */     // GIR_Coverage, 13155,
     /*  25881 */     GIR_EraseRootFromParent_Done,
     /*  25882 */   // Label 428: @25882
     /*  25882 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25963), // Rule ID 1686 //
     /*  25887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25918 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25921 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25930 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25946 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25961 */     GIR_RootConstrainSelectedInstOperands,
     /*  25962 */     // GIR_Coverage, 1686,
     /*  25962 */     GIR_EraseRootFromParent_Done,
     /*  25963 */   // Label 429: @25963
     /*  25963 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26044), // Rule ID 1764 //
     /*  25968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25999 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26002 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26011 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26027 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  26027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  26030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  26038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  26042 */     GIR_RootConstrainSelectedInstOperands,
     /*  26043 */     // GIR_Coverage, 1764,
     /*  26043 */     GIR_EraseRootFromParent_Done,
     /*  26044 */   // Label 430: @26044
     /*  26044 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26136), // Rule ID 13221 //
     /*  26049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26105 */     // MIs[3] Operand 1
     /*  26105 */     // No operand predicates
     /*  26105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26116 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26134 */     GIR_RootConstrainSelectedInstOperands,
     /*  26135 */     // GIR_Coverage, 13221,
     /*  26135 */     GIR_EraseRootFromParent_Done,
     /*  26136 */   // Label 431: @26136
     /*  26136 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26228), // Rule ID 13220 //
     /*  26141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26202 */     // MIs[3] Operand 1
     /*  26202 */     // No operand predicates
     /*  26202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26208 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26226 */     GIR_RootConstrainSelectedInstOperands,
     /*  26227 */     // GIR_Coverage, 13220,
     /*  26227 */     GIR_EraseRootFromParent_Done,
     /*  26228 */   // Label 432: @26228
     /*  26228 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26320), // Rule ID 13251 //
     /*  26233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26289 */     // MIs[3] Operand 1
     /*  26289 */     // No operand predicates
     /*  26289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26300 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26318 */     GIR_RootConstrainSelectedInstOperands,
     /*  26319 */     // GIR_Coverage, 13251,
     /*  26319 */     GIR_EraseRootFromParent_Done,
     /*  26320 */   // Label 433: @26320
     /*  26320 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26412), // Rule ID 13250 //
     /*  26325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26386 */     // MIs[3] Operand 1
     /*  26386 */     // No operand predicates
     /*  26386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26392 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26410 */     GIR_RootConstrainSelectedInstOperands,
     /*  26411 */     // GIR_Coverage, 13250,
     /*  26411 */     GIR_EraseRootFromParent_Done,
     /*  26412 */   // Label 434: @26412
     /*  26412 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26504), // Rule ID 13219 //
     /*  26417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26473 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26477 */     // MIs[3] Operand 1
     /*  26477 */     // No operand predicates
     /*  26477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26484 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26502 */     GIR_RootConstrainSelectedInstOperands,
     /*  26503 */     // GIR_Coverage, 13219,
     /*  26503 */     GIR_EraseRootFromParent_Done,
     /*  26504 */   // Label 435: @26504
     /*  26504 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26596), // Rule ID 2031 //
     /*  26509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26574 */     // MIs[3] Operand 1
     /*  26574 */     // No operand predicates
     /*  26574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26576 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26594 */     GIR_RootConstrainSelectedInstOperands,
     /*  26595 */     // GIR_Coverage, 2031,
     /*  26595 */     GIR_EraseRootFromParent_Done,
     /*  26596 */   // Label 436: @26596
     /*  26596 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26688), // Rule ID 13249 //
     /*  26601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26661 */     // MIs[3] Operand 1
     /*  26661 */     // No operand predicates
     /*  26661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26668 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26686 */     GIR_RootConstrainSelectedInstOperands,
     /*  26687 */     // GIR_Coverage, 13249,
     /*  26687 */     GIR_EraseRootFromParent_Done,
     /*  26688 */   // Label 437: @26688
     /*  26688 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26780), // Rule ID 2083 //
     /*  26693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26758 */     // MIs[3] Operand 1
     /*  26758 */     // No operand predicates
     /*  26758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26778 */     GIR_RootConstrainSelectedInstOperands,
     /*  26779 */     // GIR_Coverage, 2083,
     /*  26779 */     GIR_EraseRootFromParent_Done,
     /*  26780 */   // Label 438: @26780
     /*  26780 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26831), // Rule ID 13169 //
     /*  26785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26817 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26829 */     GIR_RootConstrainSelectedInstOperands,
     /*  26830 */     // GIR_Coverage, 13169,
     /*  26830 */     GIR_EraseRootFromParent_Done,
     /*  26831 */   // Label 439: @26831
     /*  26831 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26882), // Rule ID 13141 //
     /*  26836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26868 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  26871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26880 */     GIR_RootConstrainSelectedInstOperands,
     /*  26881 */     // GIR_Coverage, 13141,
     /*  26881 */     GIR_EraseRootFromParent_Done,
     /*  26882 */   // Label 440: @26882
     /*  26882 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26933), // Rule ID 13168 //
     /*  26887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26919 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26931 */     GIR_RootConstrainSelectedInstOperands,
     /*  26932 */     // GIR_Coverage, 13168,
     /*  26932 */     GIR_EraseRootFromParent_Done,
     /*  26933 */   // Label 441: @26933
     /*  26933 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26984), // Rule ID 1802 //
     /*  26938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26970 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  26977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26982 */     GIR_RootConstrainSelectedInstOperands,
     /*  26983 */     // GIR_Coverage, 1802,
     /*  26983 */     GIR_EraseRootFromParent_Done,
     /*  26984 */   // Label 442: @26984
     /*  26984 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27035), // Rule ID 1714 //
     /*  26989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27021 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  27024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27033 */     GIR_RootConstrainSelectedInstOperands,
     /*  27034 */     // GIR_Coverage, 1714,
     /*  27034 */     GIR_EraseRootFromParent_Done,
     /*  27035 */   // Label 443: @27035
     /*  27035 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27086), // Rule ID 1801 //
     /*  27040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27072 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  27075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27084 */     GIR_RootConstrainSelectedInstOperands,
     /*  27085 */     // GIR_Coverage, 1801,
     /*  27085 */     GIR_EraseRootFromParent_Done,
     /*  27086 */   // Label 444: @27086
     /*  27086 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27155), // Rule ID 13095 //
     /*  27091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27106 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27109 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27138 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27153 */     GIR_RootConstrainSelectedInstOperands,
     /*  27154 */     // GIR_Coverage, 13095,
     /*  27154 */     GIR_EraseRootFromParent_Done,
     /*  27155 */   // Label 445: @27155
     /*  27155 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27224), // Rule ID 13107 //
     /*  27160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27207 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27222 */     GIR_RootConstrainSelectedInstOperands,
     /*  27223 */     // GIR_Coverage, 13107,
     /*  27223 */     GIR_EraseRootFromParent_Done,
     /*  27224 */   // Label 446: @27224
     /*  27224 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27280), // Rule ID 13057 //
     /*  27229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27244 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27247 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27267 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27278 */     GIR_RootConstrainSelectedInstOperands,
     /*  27279 */     // GIR_Coverage, 13057,
     /*  27279 */     GIR_EraseRootFromParent_Done,
     /*  27280 */   // Label 447: @27280
     /*  27280 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27336), // Rule ID 13069 //
     /*  27285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27300 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27303 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27323 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27334 */     GIR_RootConstrainSelectedInstOperands,
     /*  27335 */     // GIR_Coverage, 13069,
     /*  27335 */     GIR_EraseRootFromParent_Done,
     /*  27336 */   // Label 448: @27336
     /*  27336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27403), // Rule ID 13299 //
     /*  27341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27365 */     // MIs[1] imm
     /*  27365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27377 */     // MIs[2] Operand 1
     /*  27377 */     // No operand predicates
     /*  27377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27387 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27401 */     GIR_RootConstrainSelectedInstOperands,
     /*  27402 */     // GIR_Coverage, 13299,
     /*  27402 */     GIR_EraseRootFromParent_Done,
     /*  27403 */   // Label 449: @27403
     /*  27403 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(27470), // Rule ID 13320 //
     /*  27408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27432 */     // MIs[1] imm
     /*  27432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27444 */     // MIs[2] Operand 1
     /*  27444 */     // No operand predicates
     /*  27444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27454 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27468 */     GIR_RootConstrainSelectedInstOperands,
     /*  27469 */     // GIR_Coverage, 13320,
     /*  27469 */     GIR_EraseRootFromParent_Done,
     /*  27470 */   // Label 450: @27470
     /*  27470 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27539), // Rule ID 1360 //
     /*  27475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27522 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27537 */     GIR_RootConstrainSelectedInstOperands,
     /*  27538 */     // GIR_Coverage, 1360,
     /*  27538 */     GIR_EraseRootFromParent_Done,
     /*  27539 */   // Label 451: @27539
     /*  27539 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27608), // Rule ID 1483 //
     /*  27544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27591 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27606 */     GIR_RootConstrainSelectedInstOperands,
     /*  27607 */     // GIR_Coverage, 1483,
     /*  27607 */     GIR_EraseRootFromParent_Done,
     /*  27608 */   // Label 452: @27608
     /*  27608 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27664), // Rule ID 988 //
     /*  27613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27632 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27635 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27651 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27662 */     GIR_RootConstrainSelectedInstOperands,
     /*  27663 */     // GIR_Coverage, 988,
     /*  27663 */     GIR_EraseRootFromParent_Done,
     /*  27664 */   // Label 453: @27664
     /*  27664 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27720), // Rule ID 1049 //
     /*  27669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27707 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27718 */     GIR_RootConstrainSelectedInstOperands,
     /*  27719 */     // GIR_Coverage, 1049,
     /*  27719 */     GIR_EraseRootFromParent_Done,
     /*  27720 */   // Label 454: @27720
     /*  27720 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27787), // Rule ID 2231 //
     /*  27725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27753 */     // MIs[1] imm
     /*  27753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27765 */     // MIs[2] Operand 1
     /*  27765 */     // No operand predicates
     /*  27765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27771 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27785 */     GIR_RootConstrainSelectedInstOperands,
     /*  27786 */     // GIR_Coverage, 2231,
     /*  27786 */     GIR_EraseRootFromParent_Done,
     /*  27787 */   // Label 455: @27787
     /*  27787 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27854), // Rule ID 2290 //
     /*  27792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27820 */     // MIs[1] imm
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27832 */     // MIs[2] Operand 1
     /*  27832 */     // No operand predicates
     /*  27832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27838 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27852 */     GIR_RootConstrainSelectedInstOperands,
     /*  27853 */     // GIR_Coverage, 2290,
     /*  27853 */     GIR_EraseRootFromParent_Done,
     /*  27854 */   // Label 456: @27854
     /*  27854 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27924), // Rule ID 6837 //
     /*  27859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  27871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  27897 */     // MIs[2] Rn
     /*  27897 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27902 */     // MIs[2] Rm
     /*  27902 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27909 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27922 */     GIR_RootConstrainSelectedInstOperands,
     /*  27923 */     // GIR_Coverage, 6837,
     /*  27923 */     GIR_EraseRootFromParent_Done,
     /*  27924 */   // Label 457: @27924
     /*  27924 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27994), // Rule ID 13684 //
     /*  27929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  27941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  27967 */     // MIs[2] Rn
     /*  27967 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27972 */     // MIs[2] Rm
     /*  27972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27979 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27992 */     GIR_RootConstrainSelectedInstOperands,
     /*  27993 */     // GIR_Coverage, 13684,
     /*  27993 */     GIR_EraseRootFromParent_Done,
     /*  27994 */   // Label 458: @27994
     /*  27994 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28057), // Rule ID 1782 //
     /*  27999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28042 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_RootConstrainSelectedInstOperands,
     /*  28056 */     // GIR_Coverage, 1782,
     /*  28056 */     GIR_EraseRootFromParent_Done,
     /*  28057 */   // Label 459: @28057
     /*  28057 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28120), // Rule ID 1781 //
     /*  28062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28105 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28118 */     GIR_RootConstrainSelectedInstOperands,
     /*  28119 */     // GIR_Coverage, 1781,
     /*  28119 */     GIR_EraseRootFromParent_Done,
     /*  28120 */   // Label 460: @28120
     /*  28120 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28183), // Rule ID 1707 //
     /*  28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28168 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  28171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28181 */     GIR_RootConstrainSelectedInstOperands,
     /*  28182 */     // GIR_Coverage, 1707,
     /*  28182 */     GIR_EraseRootFromParent_Done,
     /*  28183 */   // Label 461: @28183
     /*  28183 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28246), // Rule ID 1780 //
     /*  28188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28231 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28244 */     GIR_RootConstrainSelectedInstOperands,
     /*  28245 */     // GIR_Coverage, 1780,
     /*  28245 */     GIR_EraseRootFromParent_Done,
     /*  28246 */   // Label 462: @28246
     /*  28246 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(28309), // Rule ID 1779 //
     /*  28251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28294 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28307 */     GIR_RootConstrainSelectedInstOperands,
     /*  28308 */     // GIR_Coverage, 1779,
     /*  28308 */     GIR_EraseRootFromParent_Done,
     /*  28309 */   // Label 463: @28309
     /*  28309 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(28370), // Rule ID 13146 //
     /*  28314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28353 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28368 */     GIR_RootConstrainSelectedInstOperands,
     /*  28369 */     // GIR_Coverage, 13146,
     /*  28369 */     GIR_EraseRootFromParent_Done,
     /*  28370 */   // Label 464: @28370
     /*  28370 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(28431), // Rule ID 13176 //
     /*  28375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28414 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28429 */     GIR_RootConstrainSelectedInstOperands,
     /*  28430 */     // GIR_Coverage, 13176,
     /*  28430 */     GIR_EraseRootFromParent_Done,
     /*  28431 */   // Label 465: @28431
     /*  28431 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(28479), // Rule ID 13167 //
     /*  28436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28466 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28477 */     GIR_RootConstrainSelectedInstOperands,
     /*  28478 */     // GIR_Coverage, 13167,
     /*  28478 */     GIR_EraseRootFromParent_Done,
     /*  28479 */   // Label 466: @28479
     /*  28479 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(28527), // Rule ID 13056 //
     /*  28484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28514 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28525 */     GIR_RootConstrainSelectedInstOperands,
     /*  28526 */     // GIR_Coverage, 13056,
     /*  28526 */     GIR_EraseRootFromParent_Done,
     /*  28527 */   // Label 467: @28527
     /*  28527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(28575), // Rule ID 13140 //
     /*  28532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28562 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28573 */     GIR_RootConstrainSelectedInstOperands,
     /*  28574 */     // GIR_Coverage, 13140,
     /*  28574 */     GIR_EraseRootFromParent_Done,
     /*  28575 */   // Label 468: @28575
     /*  28575 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28623), // Rule ID 13068 //
     /*  28580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28610 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28621 */     GIR_RootConstrainSelectedInstOperands,
     /*  28622 */     // GIR_Coverage, 13068,
     /*  28622 */     GIR_EraseRootFromParent_Done,
     /*  28623 */   // Label 469: @28623
     /*  28623 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28671), // Rule ID 13166 //
     /*  28628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28658 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28669 */     GIR_RootConstrainSelectedInstOperands,
     /*  28670 */     // GIR_Coverage, 13166,
     /*  28670 */     GIR_EraseRootFromParent_Done,
     /*  28671 */   // Label 470: @28671
     /*  28671 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28732), // Rule ID 1719 //
     /*  28676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28715 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28730 */     GIR_RootConstrainSelectedInstOperands,
     /*  28731 */     // GIR_Coverage, 1719,
     /*  28731 */     GIR_EraseRootFromParent_Done,
     /*  28732 */   // Label 471: @28732
     /*  28732 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28793), // Rule ID 1809 //
     /*  28737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28776 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28791 */     GIR_RootConstrainSelectedInstOperands,
     /*  28792 */     // GIR_Coverage, 1809,
     /*  28792 */     GIR_EraseRootFromParent_Done,
     /*  28793 */   // Label 472: @28793
     /*  28793 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28841), // Rule ID 1800 //
     /*  28798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28828 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28839 */     GIR_RootConstrainSelectedInstOperands,
     /*  28840 */     // GIR_Coverage, 1800,
     /*  28840 */     GIR_EraseRootFromParent_Done,
     /*  28841 */   // Label 473: @28841
     /*  28841 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28889), // Rule ID 987 //
     /*  28846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28876 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28887 */     GIR_RootConstrainSelectedInstOperands,
     /*  28888 */     // GIR_Coverage, 987,
     /*  28888 */     GIR_EraseRootFromParent_Done,
     /*  28889 */   // Label 474: @28889
     /*  28889 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28937), // Rule ID 1713 //
     /*  28894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28924 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28935 */     GIR_RootConstrainSelectedInstOperands,
     /*  28936 */     // GIR_Coverage, 1713,
     /*  28936 */     GIR_EraseRootFromParent_Done,
     /*  28937 */   // Label 475: @28937
     /*  28937 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28985), // Rule ID 1048 //
     /*  28942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28972 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28983 */     GIR_RootConstrainSelectedInstOperands,
     /*  28984 */     // GIR_Coverage, 1048,
     /*  28984 */     GIR_EraseRootFromParent_Done,
     /*  28985 */   // Label 476: @28985
     /*  28985 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29033), // Rule ID 1799 //
     /*  28990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  29031 */     GIR_RootConstrainSelectedInstOperands,
     /*  29032 */     // GIR_Coverage, 1799,
     /*  29032 */     GIR_EraseRootFromParent_Done,
     /*  29033 */   // Label 477: @29033
     /*  29033 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(29060), // Rule ID 1098 //
     /*  29038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 1098,
     /*  29059 */     GIR_Done,
     /*  29060 */   // Label 478: @29060
     /*  29060 */   GIM_Reject,
     /*  29061 */ // Label 397: @29061
     /*  29061 */ GIM_Reject,
     /*  29062 */ // Label 161: @29062
     /*  29062 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(29911),
     /*  29067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29073 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(29206), // Rule ID 13689 //
     /*  29078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29123 */     // MIs[1] Operand 2
     /*  29123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  29134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  29138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29142 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29154 */     // MIs[5] Rn
     /*  29154 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29159 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29161 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29205 */     // GIR_Coverage, 13689,
     /*  29205 */     GIR_EraseRootFromParent_Done,
     /*  29206 */   // Label 480: @29206
     /*  29206 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(29339), // Rule ID 6842 //
     /*  29211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  29248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29260 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  29264 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29268 */     // MIs[4] Rn
     /*  29268 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29273 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  29277 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29281 */     // MIs[3] Operand 2
     /*  29281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  29292 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29294 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29338 */     // GIR_Coverage, 6842,
     /*  29338 */     GIR_EraseRootFromParent_Done,
     /*  29339 */   // Label 481: @29339
     /*  29339 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(29408), // Rule ID 13085 //
     /*  29344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29406 */     GIR_RootConstrainSelectedInstOperands,
     /*  29407 */     // GIR_Coverage, 13085,
     /*  29407 */     GIR_EraseRootFromParent_Done,
     /*  29408 */   // Label 482: @29408
     /*  29408 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(29477), // Rule ID 13097 //
     /*  29413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29460 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29475 */     GIR_RootConstrainSelectedInstOperands,
     /*  29476 */     // GIR_Coverage, 13097,
     /*  29476 */     GIR_EraseRootFromParent_Done,
     /*  29477 */   // Label 483: @29477
     /*  29477 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(29544), // Rule ID 13289 //
     /*  29482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29506 */     // MIs[1] imm
     /*  29506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29518 */     // MIs[2] Operand 1
     /*  29518 */     // No operand predicates
     /*  29518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29528 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29542 */     GIR_RootConstrainSelectedInstOperands,
     /*  29543 */     // GIR_Coverage, 13289,
     /*  29543 */     GIR_EraseRootFromParent_Done,
     /*  29544 */   // Label 484: @29544
     /*  29544 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(29611), // Rule ID 13310 //
     /*  29549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29573 */     // MIs[1] imm
     /*  29573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29585 */     // MIs[2] Operand 1
     /*  29585 */     // No operand predicates
     /*  29585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29595 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29609 */     GIR_RootConstrainSelectedInstOperands,
     /*  29610 */     // GIR_Coverage, 13310,
     /*  29610 */     GIR_EraseRootFromParent_Done,
     /*  29611 */   // Label 485: @29611
     /*  29611 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29680), // Rule ID 1350 //
     /*  29616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29663 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29678 */     GIR_RootConstrainSelectedInstOperands,
     /*  29679 */     // GIR_Coverage, 1350,
     /*  29679 */     GIR_EraseRootFromParent_Done,
     /*  29680 */   // Label 486: @29680
     /*  29680 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29749), // Rule ID 1473 //
     /*  29685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29704 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29707 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29732 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29747 */     GIR_RootConstrainSelectedInstOperands,
     /*  29748 */     // GIR_Coverage, 1473,
     /*  29748 */     GIR_EraseRootFromParent_Done,
     /*  29749 */   // Label 487: @29749
     /*  29749 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29816), // Rule ID 2221 //
     /*  29754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29782 */     // MIs[1] imm
     /*  29782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29794 */     // MIs[2] Operand 1
     /*  29794 */     // No operand predicates
     /*  29794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29800 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29814 */     GIR_RootConstrainSelectedInstOperands,
     /*  29815 */     // GIR_Coverage, 2221,
     /*  29815 */     GIR_EraseRootFromParent_Done,
     /*  29816 */   // Label 488: @29816
     /*  29816 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29883), // Rule ID 2280 //
     /*  29821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29849 */     // MIs[1] imm
     /*  29849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29861 */     // MIs[2] Operand 1
     /*  29861 */     // No operand predicates
     /*  29861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29867 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29881 */     GIR_RootConstrainSelectedInstOperands,
     /*  29882 */     // GIR_Coverage, 2280,
     /*  29882 */     GIR_EraseRootFromParent_Done,
     /*  29883 */   // Label 489: @29883
     /*  29883 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29910), // Rule ID 1093 //
     /*  29888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29903 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  29908 */     GIR_RootConstrainSelectedInstOperands,
     /*  29909 */     // GIR_Coverage, 1093,
     /*  29909 */     GIR_Done,
     /*  29910 */   // Label 490: @29910
     /*  29910 */   GIM_Reject,
     /*  29911 */ // Label 479: @29911
     /*  29911 */ GIM_Reject,
     /*  29912 */ // Label 162: @29912
     /*  29912 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(33489),
     /*  29917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30010), // Rule ID 13129 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29955 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29958 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29967 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29991 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  29991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  29994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30008 */     GIR_RootConstrainSelectedInstOperands,
     /*  30009 */     // GIR_Coverage, 13129,
     /*  30009 */     GIR_EraseRootFromParent_Done,
     /*  30010 */   // Label 492: @30010
     /*  30010 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30097), // Rule ID 13153 //
     /*  30015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30042 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30045 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30054 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30078 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30095 */     GIR_RootConstrainSelectedInstOperands,
     /*  30096 */     // GIR_Coverage, 13153,
     /*  30096 */     GIR_EraseRootFromParent_Done,
     /*  30097 */   // Label 493: @30097
     /*  30097 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30184), // Rule ID 1684 //
     /*  30102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30133 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30136 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30145 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30165 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  30168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30182 */     GIR_RootConstrainSelectedInstOperands,
     /*  30183 */     // GIR_Coverage, 1684,
     /*  30183 */     GIR_EraseRootFromParent_Done,
     /*  30184 */   // Label 494: @30184
     /*  30184 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30271), // Rule ID 1762 //
     /*  30189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30220 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30223 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30232 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30252 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30269 */     GIR_RootConstrainSelectedInstOperands,
     /*  30270 */     // GIR_Coverage, 1762,
     /*  30270 */     GIR_EraseRootFromParent_Done,
     /*  30271 */   // Label 495: @30271
     /*  30271 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30340), // Rule ID 1778 //
     /*  30276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30323 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30338 */     GIR_RootConstrainSelectedInstOperands,
     /*  30339 */     // GIR_Coverage, 1778,
     /*  30339 */     GIR_EraseRootFromParent_Done,
     /*  30340 */   // Label 496: @30340
     /*  30340 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(30409), // Rule ID 1777 //
     /*  30345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30392 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1777,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 497: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(30478), // Rule ID 1706 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30461 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  30464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30476 */     GIR_RootConstrainSelectedInstOperands,
     /*  30477 */     // GIR_Coverage, 1706,
     /*  30477 */     GIR_EraseRootFromParent_Done,
     /*  30478 */   // Label 498: @30478
     /*  30478 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(30547), // Rule ID 1776 //
     /*  30483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30530 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30545 */     GIR_RootConstrainSelectedInstOperands,
     /*  30546 */     // GIR_Coverage, 1776,
     /*  30546 */     GIR_EraseRootFromParent_Done,
     /*  30547 */   // Label 499: @30547
     /*  30547 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30616), // Rule ID 1775 //
     /*  30552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30599 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30614 */     GIR_RootConstrainSelectedInstOperands,
     /*  30615 */     // GIR_Coverage, 1775,
     /*  30615 */     GIR_EraseRootFromParent_Done,
     /*  30616 */   // Label 500: @30616
     /*  30616 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30683), // Rule ID 13145 //
     /*  30621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30664 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30681 */     GIR_RootConstrainSelectedInstOperands,
     /*  30682 */     // GIR_Coverage, 13145,
     /*  30682 */     GIR_EraseRootFromParent_Done,
     /*  30683 */   // Label 501: @30683
     /*  30683 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30750), // Rule ID 13175 //
     /*  30688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30731 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30748 */     GIR_RootConstrainSelectedInstOperands,
     /*  30749 */     // GIR_Coverage, 13175,
     /*  30749 */     GIR_EraseRootFromParent_Done,
     /*  30750 */   // Label 502: @30750
     /*  30750 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30817), // Rule ID 1718 //
     /*  30755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30798 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30815 */     GIR_RootConstrainSelectedInstOperands,
     /*  30816 */     // GIR_Coverage, 1718,
     /*  30816 */     GIR_EraseRootFromParent_Done,
     /*  30817 */   // Label 503: @30817
     /*  30817 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30884), // Rule ID 1808 //
     /*  30822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30865 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30882 */     GIR_RootConstrainSelectedInstOperands,
     /*  30883 */     // GIR_Coverage, 1808,
     /*  30883 */     GIR_EraseRootFromParent_Done,
     /*  30884 */   // Label 504: @30884
     /*  30884 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30965), // Rule ID 13127 //
     /*  30889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30916 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30919 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30928 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30948 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  30948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  30951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  30959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  30963 */     GIR_RootConstrainSelectedInstOperands,
     /*  30964 */     // GIR_Coverage, 13127,
     /*  30964 */     GIR_EraseRootFromParent_Done,
     /*  30965 */   // Label 505: @30965
     /*  30965 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31046), // Rule ID 13151 //
     /*  30970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30997 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31000 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31009 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31029 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31044 */     GIR_RootConstrainSelectedInstOperands,
     /*  31045 */     // GIR_Coverage, 13151,
     /*  31045 */     GIR_EraseRootFromParent_Done,
     /*  31046 */   // Label 506: @31046
     /*  31046 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31127), // Rule ID 1682 //
     /*  31051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31082 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31085 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31094 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31110 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  31113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31125 */     GIR_RootConstrainSelectedInstOperands,
     /*  31126 */     // GIR_Coverage, 1682,
     /*  31126 */     GIR_EraseRootFromParent_Done,
     /*  31127 */   // Label 507: @31127
     /*  31127 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31208), // Rule ID 1760 //
     /*  31132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31175 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31191 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31206 */     GIR_RootConstrainSelectedInstOperands,
     /*  31207 */     // GIR_Coverage, 1760,
     /*  31207 */     GIR_EraseRootFromParent_Done,
     /*  31208 */   // Label 508: @31208
     /*  31208 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31259), // Rule ID 13165 //
     /*  31213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31245 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31257 */     GIR_RootConstrainSelectedInstOperands,
     /*  31258 */     // GIR_Coverage, 13165,
     /*  31258 */     GIR_EraseRootFromParent_Done,
     /*  31259 */   // Label 509: @31259
     /*  31259 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31310), // Rule ID 13139 //
     /*  31264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31296 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31308 */     GIR_RootConstrainSelectedInstOperands,
     /*  31309 */     // GIR_Coverage, 13139,
     /*  31309 */     GIR_EraseRootFromParent_Done,
     /*  31310 */   // Label 510: @31310
     /*  31310 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31361), // Rule ID 13164 //
     /*  31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31347 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31359 */     GIR_RootConstrainSelectedInstOperands,
     /*  31360 */     // GIR_Coverage, 13164,
     /*  31360 */     GIR_EraseRootFromParent_Done,
     /*  31361 */   // Label 511: @31361
     /*  31361 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(31412), // Rule ID 1798 //
     /*  31366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31398 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1798,
     /*  31411 */     GIR_EraseRootFromParent_Done,
     /*  31412 */   // Label 512: @31412
     /*  31412 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(31463), // Rule ID 1712 //
     /*  31417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31449 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31461 */     GIR_RootConstrainSelectedInstOperands,
     /*  31462 */     // GIR_Coverage, 1712,
     /*  31462 */     GIR_EraseRootFromParent_Done,
     /*  31463 */   // Label 513: @31463
     /*  31463 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(31514), // Rule ID 1797 //
     /*  31468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31500 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31512 */     GIR_RootConstrainSelectedInstOperands,
     /*  31513 */     // GIR_Coverage, 1797,
     /*  31513 */     GIR_EraseRootFromParent_Done,
     /*  31514 */   // Label 514: @31514
     /*  31514 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(31583), // Rule ID 13091 //
     /*  31519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31566 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31581 */     GIR_RootConstrainSelectedInstOperands,
     /*  31582 */     // GIR_Coverage, 13091,
     /*  31582 */     GIR_EraseRootFromParent_Done,
     /*  31583 */   // Label 515: @31583
     /*  31583 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(31652), // Rule ID 13103 //
     /*  31588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31603 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31606 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31635 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  31638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31650 */     GIR_RootConstrainSelectedInstOperands,
     /*  31651 */     // GIR_Coverage, 13103,
     /*  31651 */     GIR_EraseRootFromParent_Done,
     /*  31652 */   // Label 516: @31652
     /*  31652 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31708), // Rule ID 13053 //
     /*  31657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  31680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31695 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  31698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31706 */     GIR_RootConstrainSelectedInstOperands,
     /*  31707 */     // GIR_Coverage, 13053,
     /*  31707 */     GIR_EraseRootFromParent_Done,
     /*  31708 */   // Label 517: @31708
     /*  31708 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31764), // Rule ID 13065 //
     /*  31713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31728 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31731 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  31736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31751 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  31754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31762 */     GIR_RootConstrainSelectedInstOperands,
     /*  31763 */     // GIR_Coverage, 13065,
     /*  31763 */     GIR_EraseRootFromParent_Done,
     /*  31764 */   // Label 518: @31764
     /*  31764 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31831), // Rule ID 13295 //
     /*  31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31793 */     // MIs[1] imm
     /*  31793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31805 */     // MIs[2] Operand 1
     /*  31805 */     // No operand predicates
     /*  31805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31815 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  31818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31829 */     GIR_RootConstrainSelectedInstOperands,
     /*  31830 */     // GIR_Coverage, 13295,
     /*  31830 */     GIR_EraseRootFromParent_Done,
     /*  31831 */   // Label 519: @31831
     /*  31831 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31898), // Rule ID 13316 //
     /*  31836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31860 */     // MIs[1] imm
     /*  31860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31872 */     // MIs[2] Operand 1
     /*  31872 */     // No operand predicates
     /*  31872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31882 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31896 */     GIR_RootConstrainSelectedInstOperands,
     /*  31897 */     // GIR_Coverage, 13316,
     /*  31897 */     GIR_EraseRootFromParent_Done,
     /*  31898 */   // Label 520: @31898
     /*  31898 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31967), // Rule ID 1356 //
     /*  31903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31922 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31925 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31950 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31965 */     GIR_RootConstrainSelectedInstOperands,
     /*  31966 */     // GIR_Coverage, 1356,
     /*  31966 */     GIR_EraseRootFromParent_Done,
     /*  31967 */   // Label 521: @31967
     /*  31967 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32036), // Rule ID 1479 //
     /*  31972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31991 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31994 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  32007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32019 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  32019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  32022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32034 */     GIR_RootConstrainSelectedInstOperands,
     /*  32035 */     // GIR_Coverage, 1479,
     /*  32035 */     GIR_EraseRootFromParent_Done,
     /*  32036 */   // Label 522: @32036
     /*  32036 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32092), // Rule ID 984 //
     /*  32041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32060 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32063 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32079 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32090 */     GIR_RootConstrainSelectedInstOperands,
     /*  32091 */     // GIR_Coverage, 984,
     /*  32091 */     GIR_EraseRootFromParent_Done,
     /*  32092 */   // Label 523: @32092
     /*  32092 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32148), // Rule ID 1045 //
     /*  32097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32116 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32119 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  32124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32135 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  32138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32146 */     GIR_RootConstrainSelectedInstOperands,
     /*  32147 */     // GIR_Coverage, 1045,
     /*  32147 */     GIR_EraseRootFromParent_Done,
     /*  32148 */   // Label 524: @32148
     /*  32148 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32215), // Rule ID 2227 //
     /*  32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32181 */     // MIs[1] imm
     /*  32181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32193 */     // MIs[2] Operand 1
     /*  32193 */     // No operand predicates
     /*  32193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32199 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  32202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32213 */     GIR_RootConstrainSelectedInstOperands,
     /*  32214 */     // GIR_Coverage, 2227,
     /*  32214 */     GIR_EraseRootFromParent_Done,
     /*  32215 */   // Label 525: @32215
     /*  32215 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(32282), // Rule ID 2286 //
     /*  32220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32248 */     // MIs[1] imm
     /*  32248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32260 */     // MIs[2] Operand 1
     /*  32260 */     // No operand predicates
     /*  32260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32266 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  32269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32280 */     GIR_RootConstrainSelectedInstOperands,
     /*  32281 */     // GIR_Coverage, 2286,
     /*  32281 */     GIR_EraseRootFromParent_Done,
     /*  32282 */   // Label 526: @32282
     /*  32282 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(32352), // Rule ID 6838 //
     /*  32287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  32299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  32325 */     // MIs[2] Rn
     /*  32325 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32330 */     // MIs[2] Rm
     /*  32330 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32337 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32350 */     GIR_RootConstrainSelectedInstOperands,
     /*  32351 */     // GIR_Coverage, 6838,
     /*  32351 */     GIR_EraseRootFromParent_Done,
     /*  32352 */   // Label 527: @32352
     /*  32352 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(32422), // Rule ID 13685 //
     /*  32357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  32369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  32395 */     // MIs[2] Rn
     /*  32395 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32400 */     // MIs[2] Rm
     /*  32400 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32407 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32420 */     GIR_RootConstrainSelectedInstOperands,
     /*  32421 */     // GIR_Coverage, 13685,
     /*  32421 */     GIR_EraseRootFromParent_Done,
     /*  32422 */   // Label 528: @32422
     /*  32422 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(32485), // Rule ID 1774 //
     /*  32427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32470 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32483 */     GIR_RootConstrainSelectedInstOperands,
     /*  32484 */     // GIR_Coverage, 1774,
     /*  32484 */     GIR_EraseRootFromParent_Done,
     /*  32485 */   // Label 529: @32485
     /*  32485 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(32548), // Rule ID 1773 //
     /*  32490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32533 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32546 */     GIR_RootConstrainSelectedInstOperands,
     /*  32547 */     // GIR_Coverage, 1773,
     /*  32547 */     GIR_EraseRootFromParent_Done,
     /*  32548 */   // Label 530: @32548
     /*  32548 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(32611), // Rule ID 1705 //
     /*  32553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32596 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  32599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32609 */     GIR_RootConstrainSelectedInstOperands,
     /*  32610 */     // GIR_Coverage, 1705,
     /*  32610 */     GIR_EraseRootFromParent_Done,
     /*  32611 */   // Label 531: @32611
     /*  32611 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(32674), // Rule ID 1772 //
     /*  32616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32659 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32672 */     GIR_RootConstrainSelectedInstOperands,
     /*  32673 */     // GIR_Coverage, 1772,
     /*  32673 */     GIR_EraseRootFromParent_Done,
     /*  32674 */   // Label 532: @32674
     /*  32674 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(32737), // Rule ID 1771 //
     /*  32679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32722 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32735 */     GIR_RootConstrainSelectedInstOperands,
     /*  32736 */     // GIR_Coverage, 1771,
     /*  32736 */     GIR_EraseRootFromParent_Done,
     /*  32737 */   // Label 533: @32737
     /*  32737 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(32798), // Rule ID 13144 //
     /*  32742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32781 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  32784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32796 */     GIR_RootConstrainSelectedInstOperands,
     /*  32797 */     // GIR_Coverage, 13144,
     /*  32797 */     GIR_EraseRootFromParent_Done,
     /*  32798 */   // Label 534: @32798
     /*  32798 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32859), // Rule ID 13174 //
     /*  32803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32842 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  32845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32857 */     GIR_RootConstrainSelectedInstOperands,
     /*  32858 */     // GIR_Coverage, 13174,
     /*  32858 */     GIR_EraseRootFromParent_Done,
     /*  32859 */   // Label 535: @32859
     /*  32859 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32907), // Rule ID 13163 //
     /*  32864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32894 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  32897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  32905 */     GIR_RootConstrainSelectedInstOperands,
     /*  32906 */     // GIR_Coverage, 13163,
     /*  32906 */     GIR_EraseRootFromParent_Done,
     /*  32907 */   // Label 536: @32907
     /*  32907 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32955), // Rule ID 13052 //
     /*  32912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  32927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32942 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32953 */     GIR_RootConstrainSelectedInstOperands,
     /*  32954 */     // GIR_Coverage, 13052,
     /*  32954 */     GIR_EraseRootFromParent_Done,
     /*  32955 */   // Label 537: @32955
     /*  32955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33003), // Rule ID 13138 //
     /*  32960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32990 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  32993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33001 */     GIR_RootConstrainSelectedInstOperands,
     /*  33002 */     // GIR_Coverage, 13138,
     /*  33002 */     GIR_EraseRootFromParent_Done,
     /*  33003 */   // Label 538: @33003
     /*  33003 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33051), // Rule ID 13064 //
     /*  33008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33038 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33049 */     GIR_RootConstrainSelectedInstOperands,
     /*  33050 */     // GIR_Coverage, 13064,
     /*  33050 */     GIR_EraseRootFromParent_Done,
     /*  33051 */   // Label 539: @33051
     /*  33051 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33099), // Rule ID 13162 //
     /*  33056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33086 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33097 */     GIR_RootConstrainSelectedInstOperands,
     /*  33098 */     // GIR_Coverage, 13162,
     /*  33098 */     GIR_EraseRootFromParent_Done,
     /*  33099 */   // Label 540: @33099
     /*  33099 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33160), // Rule ID 1717 //
     /*  33104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33143 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  33146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33158 */     GIR_RootConstrainSelectedInstOperands,
     /*  33159 */     // GIR_Coverage, 1717,
     /*  33159 */     GIR_EraseRootFromParent_Done,
     /*  33160 */   // Label 541: @33160
     /*  33160 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(33221), // Rule ID 1807 //
     /*  33165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33204 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  33207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33219 */     GIR_RootConstrainSelectedInstOperands,
     /*  33220 */     // GIR_Coverage, 1807,
     /*  33220 */     GIR_EraseRootFromParent_Done,
     /*  33221 */   // Label 542: @33221
     /*  33221 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(33269), // Rule ID 1796 //
     /*  33226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33256 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33267 */     GIR_RootConstrainSelectedInstOperands,
     /*  33268 */     // GIR_Coverage, 1796,
     /*  33268 */     GIR_EraseRootFromParent_Done,
     /*  33269 */   // Label 543: @33269
     /*  33269 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(33317), // Rule ID 983 //
     /*  33274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  33293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33304 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 983,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 544: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(33365), // Rule ID 1711 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33352 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  33355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33363 */     GIR_RootConstrainSelectedInstOperands,
     /*  33364 */     // GIR_Coverage, 1711,
     /*  33364 */     GIR_EraseRootFromParent_Done,
     /*  33365 */   // Label 545: @33365
     /*  33365 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(33413), // Rule ID 1044 //
     /*  33370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33400 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33411 */     GIR_RootConstrainSelectedInstOperands,
     /*  33412 */     // GIR_Coverage, 1044,
     /*  33412 */     GIR_EraseRootFromParent_Done,
     /*  33413 */   // Label 546: @33413
     /*  33413 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(33461), // Rule ID 1795 //
     /*  33418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33448 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33459 */     GIR_RootConstrainSelectedInstOperands,
     /*  33460 */     // GIR_Coverage, 1795,
     /*  33460 */     GIR_EraseRootFromParent_Done,
     /*  33461 */   // Label 547: @33461
     /*  33461 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(33488), // Rule ID 1096 //
     /*  33466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33481 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  33486 */     GIR_RootConstrainSelectedInstOperands,
     /*  33487 */     // GIR_Coverage, 1096,
     /*  33487 */     GIR_Done,
     /*  33488 */   // Label 548: @33488
     /*  33488 */   GIM_Reject,
     /*  33489 */ // Label 491: @33489
     /*  33489 */ GIM_Reject,
     /*  33490 */ // Label 163: @33490
     /*  33490 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34213),
     /*  33495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33501 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(33570), // Rule ID 13087 //
     /*  33506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33553 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33568 */     GIR_RootConstrainSelectedInstOperands,
     /*  33569 */     // GIR_Coverage, 13087,
     /*  33569 */     GIR_EraseRootFromParent_Done,
     /*  33570 */   // Label 550: @33570
     /*  33570 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(33639), // Rule ID 13099 //
     /*  33575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33622 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33637 */     GIR_RootConstrainSelectedInstOperands,
     /*  33638 */     // GIR_Coverage, 13099,
     /*  33638 */     GIR_EraseRootFromParent_Done,
     /*  33639 */   // Label 551: @33639
     /*  33639 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(33706), // Rule ID 13291 //
     /*  33644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33668 */     // MIs[1] imm
     /*  33668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33680 */     // MIs[2] Operand 1
     /*  33680 */     // No operand predicates
     /*  33680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33690 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33704 */     GIR_RootConstrainSelectedInstOperands,
     /*  33705 */     // GIR_Coverage, 13291,
     /*  33705 */     GIR_EraseRootFromParent_Done,
     /*  33706 */   // Label 552: @33706
     /*  33706 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(33773), // Rule ID 13312 //
     /*  33711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33735 */     // MIs[1] imm
     /*  33735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33747 */     // MIs[2] Operand 1
     /*  33747 */     // No operand predicates
     /*  33747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33757 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  33760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33771 */     GIR_RootConstrainSelectedInstOperands,
     /*  33772 */     // GIR_Coverage, 13312,
     /*  33772 */     GIR_EraseRootFromParent_Done,
     /*  33773 */   // Label 553: @33773
     /*  33773 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(33842), // Rule ID 1352 //
     /*  33778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33797 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33800 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33809 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33825 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33840 */     GIR_RootConstrainSelectedInstOperands,
     /*  33841 */     // GIR_Coverage, 1352,
     /*  33841 */     GIR_EraseRootFromParent_Done,
     /*  33842 */   // Label 554: @33842
     /*  33842 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(33911), // Rule ID 1475 //
     /*  33847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33894 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33909 */     GIR_RootConstrainSelectedInstOperands,
     /*  33910 */     // GIR_Coverage, 1475,
     /*  33910 */     GIR_EraseRootFromParent_Done,
     /*  33911 */   // Label 555: @33911
     /*  33911 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(33978), // Rule ID 2223 //
     /*  33916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33944 */     // MIs[1] imm
     /*  33944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33956 */     // MIs[2] Operand 1
     /*  33956 */     // No operand predicates
     /*  33956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33962 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33976 */     GIR_RootConstrainSelectedInstOperands,
     /*  33977 */     // GIR_Coverage, 2223,
     /*  33977 */     GIR_EraseRootFromParent_Done,
     /*  33978 */   // Label 556: @33978
     /*  33978 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34045), // Rule ID 2282 //
     /*  33983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34011 */     // MIs[1] imm
     /*  34011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  34023 */     // MIs[2] Operand 1
     /*  34023 */     // No operand predicates
     /*  34023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34029 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  34032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34043 */     GIR_RootConstrainSelectedInstOperands,
     /*  34044 */     // GIR_Coverage, 2282,
     /*  34044 */     GIR_EraseRootFromParent_Done,
     /*  34045 */   // Label 557: @34045
     /*  34045 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34115), // Rule ID 6839 //
     /*  34050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34088 */     // MIs[2] Rn
     /*  34088 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34093 */     // MIs[2] Rm
     /*  34093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34100 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34113 */     GIR_RootConstrainSelectedInstOperands,
     /*  34114 */     // GIR_Coverage, 6839,
     /*  34114 */     GIR_EraseRootFromParent_Done,
     /*  34115 */   // Label 558: @34115
     /*  34115 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(34185), // Rule ID 13686 //
     /*  34120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34158 */     // MIs[2] Rn
     /*  34158 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34163 */     // MIs[2] Rm
     /*  34163 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34170 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34183 */     GIR_RootConstrainSelectedInstOperands,
     /*  34184 */     // GIR_Coverage, 13686,
     /*  34184 */     GIR_EraseRootFromParent_Done,
     /*  34185 */   // Label 559: @34185
     /*  34185 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(34212), // Rule ID 1094 //
     /*  34190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34205 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  34205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  34210 */     GIR_RootConstrainSelectedInstOperands,
     /*  34211 */     // GIR_Coverage, 1094,
     /*  34211 */     GIR_Done,
     /*  34212 */   // Label 560: @34212
     /*  34212 */   GIM_Reject,
     /*  34213 */ // Label 549: @34213
     /*  34213 */ GIM_Reject,
     /*  34214 */ // Label 164: @34214
     /*  34214 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(34585),
     /*  34219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34229 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(34291), // Rule ID 14870 //
     /*  34234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34265 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34278 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34289 */     GIR_RootConstrainSelectedInstOperands,
     /*  34290 */     // GIR_Coverage, 14870,
     /*  34290 */     GIR_EraseRootFromParent_Done,
     /*  34291 */   // Label 562: @34291
     /*  34291 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(34353), // Rule ID 14869 //
     /*  34296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34327 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34340 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34351 */     GIR_RootConstrainSelectedInstOperands,
     /*  34352 */     // GIR_Coverage, 14869,
     /*  34352 */     GIR_EraseRootFromParent_Done,
     /*  34353 */   // Label 563: @34353
     /*  34353 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(34415), // Rule ID 14868 //
     /*  34358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34389 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34402 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34413 */     GIR_RootConstrainSelectedInstOperands,
     /*  34414 */     // GIR_Coverage, 14868,
     /*  34414 */     GIR_EraseRootFromParent_Done,
     /*  34415 */   // Label 564: @34415
     /*  34415 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(34477), // Rule ID 8738 //
     /*  34420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34451 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34464 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 8738,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 565: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(34523), // Rule ID 14871 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34497 */     // MIs[1] Operand 2
     /*  34497 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34510 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34521 */     GIR_RootConstrainSelectedInstOperands,
     /*  34522 */     // GIR_Coverage, 14871,
     /*  34522 */     GIR_EraseRootFromParent_Done,
     /*  34523 */   // Label 566: @34523
     /*  34523 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34569), // Rule ID 8739 //
     /*  34528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34543 */     // MIs[1] Operand 2
     /*  34543 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34556 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34567 */     GIR_RootConstrainSelectedInstOperands,
     /*  34568 */     // GIR_Coverage, 8739,
     /*  34568 */     GIR_EraseRootFromParent_Done,
     /*  34569 */   // Label 567: @34569
     /*  34569 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(34584), // Rule ID 2766 //
     /*  34574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34577 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  34582 */     GIR_RootConstrainSelectedInstOperands,
     /*  34583 */     // GIR_Coverage, 2766,
     /*  34583 */     GIR_Done,
     /*  34584 */   // Label 568: @34584
     /*  34584 */   GIM_Reject,
     /*  34585 */ // Label 561: @34585
     /*  34585 */ GIM_Reject,
     /*  34586 */ // Label 165: @34586
     /*  34586 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(34611), // Rule ID 2765 //
     /*  34591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  34597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  34600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34604 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  34604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  34609 */   GIR_RootConstrainSelectedInstOperands,
     /*  34610 */   // GIR_Coverage, 2765,
     /*  34610 */   GIR_Done,
     /*  34611 */ // Label 569: @34611
     /*  34611 */ GIM_Reject,
     /*  34612 */ // Label 166: @34612
     /*  34612 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(34637), // Rule ID 2764 //
     /*  34617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  34623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  34626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34630 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  34630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  34635 */   GIR_RootConstrainSelectedInstOperands,
     /*  34636 */   // GIR_Coverage, 2764,
     /*  34636 */   GIR_Done,
     /*  34637 */ // Label 570: @34637
     /*  34637 */ GIM_Reject,
     /*  34638 */ // Label 167: @34638
     /*  34638 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(34663), // Rule ID 2763 //
     /*  34643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  34649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  34652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34656 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  34656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  34661 */   GIR_RootConstrainSelectedInstOperands,
     /*  34662 */   // GIR_Coverage, 2763,
     /*  34662 */   GIR_Done,
     /*  34663 */ // Label 571: @34663
     /*  34663 */ GIM_Reject,
     /*  34664 */ // Label 168: @34664
     /*  34664 */ GIM_Reject,
     /*  34665 */ // Label 1: @34665
     /*  34665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 585*/ GIMT_Encode4(48012),
     /*  34676 */ /*GILLT_s32*//*Label 572*/ GIMT_Encode4(34764),
     /*  34680 */ /*GILLT_s64*//*Label 573*/ GIMT_Encode4(35618), GIMT_Encode4(0),
     /*  34688 */ /*GILLT_v2s32*//*Label 574*/ GIMT_Encode4(38648),
     /*  34692 */ /*GILLT_v2s64*//*Label 575*/ GIMT_Encode4(40139),
     /*  34696 */ /*GILLT_v4s16*//*Label 576*/ GIMT_Encode4(42599),
     /*  34700 */ /*GILLT_v4s32*//*Label 577*/ GIMT_Encode4(44090),
     /*  34704 */ /*GILLT_v8s8*//*Label 578*/ GIMT_Encode4(46550),
     /*  34708 */ /*GILLT_v8s16*//*Label 579*/ GIMT_Encode4(46625),
     /*  34712 */ /*GILLT_v16s8*//*Label 580*/ GIMT_Encode4(47833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34732 */ /*GILLT_nxv2s64*//*Label 581*/ GIMT_Encode4(47908), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34744 */ /*GILLT_nxv4s32*//*Label 582*/ GIMT_Encode4(47934), GIMT_Encode4(0),
     /*  34752 */ /*GILLT_nxv8s16*//*Label 583*/ GIMT_Encode4(47960), GIMT_Encode4(0),
     /*  34760 */ /*GILLT_nxv16s8*//*Label 584*/ GIMT_Encode4(47986),
     /*  34764 */ // Label 572: @34764
     /*  34764 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(35617),
     /*  34769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  34772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(34927), // Rule ID 9785 //
     /*  34780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34811 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34814 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  34819 */     // MIs[2] pattern
     /*  34819 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34822 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34829 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  34850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34855 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  34858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  34862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  34865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  34883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  34887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  34899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  34902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  34916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  34926 */     // GIR_Coverage, 9785,
     /*  34926 */     GIR_EraseRootFromParent_Done,
     /*  34927 */   // Label 587: @34927
     /*  34927 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(35079), // Rule ID 9797 //
     /*  34932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34963 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34966 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  34971 */     // MIs[2] pattern
     /*  34971 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34974 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34981 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34981 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34984 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34988 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35007 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35014 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  35039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35078 */     // GIR_Coverage, 9797,
     /*  35078 */     GIR_EraseRootFromParent_Done,
     /*  35079 */   // Label 588: @35079
     /*  35079 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35231), // Rule ID 9809 //
     /*  35084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35115 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35118 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  35123 */     // MIs[2] pattern
     /*  35123 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35126 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35133 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35133 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35136 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35140 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35159 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35166 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  35191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35230 */     // GIR_Coverage, 9809,
     /*  35230 */     GIR_EraseRootFromParent_Done,
     /*  35231 */   // Label 589: @35231
     /*  35231 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(35383), // Rule ID 9821 //
     /*  35236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35267 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35270 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  35275 */     // MIs[2] pattern
     /*  35275 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35278 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35285 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35311 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  35343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35382 */     // GIR_Coverage, 9821,
     /*  35382 */     GIR_EraseRootFromParent_Done,
     /*  35383 */   // Label 590: @35383
     /*  35383 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35445), // Rule ID 3895 //
     /*  35388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  35396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35424 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  35424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  35427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35443 */     GIR_RootConstrainSelectedInstOperands,
     /*  35444 */     // GIR_Coverage, 3895,
     /*  35444 */     GIR_EraseRootFromParent_Done,
     /*  35445 */   // Label 591: @35445
     /*  35445 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35481), // Rule ID 3860 //
     /*  35450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  35465 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  35465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  35468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35470 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  35472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  35476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35479 */     GIR_RootConstrainSelectedInstOperands,
     /*  35480 */     // GIR_Coverage, 3860,
     /*  35480 */     GIR_EraseRootFromParent_Done,
     /*  35481 */   // Label 592: @35481
     /*  35481 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35514), // Rule ID 3865 //
     /*  35486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  35501 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  35504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35512 */     GIR_RootConstrainSelectedInstOperands,
     /*  35513 */     // GIR_Coverage, 3865,
     /*  35513 */     GIR_EraseRootFromParent_Done,
     /*  35514 */   // Label 593: @35514
     /*  35514 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35550), // Rule ID 3854 //
     /*  35519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  35534 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  35537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35548 */     GIR_RootConstrainSelectedInstOperands,
     /*  35549 */     // GIR_Coverage, 3854,
     /*  35549 */     GIR_EraseRootFromParent_Done,
     /*  35550 */   // Label 594: @35550
     /*  35550 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35586), // Rule ID 3858 //
     /*  35555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  35570 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  35570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  35573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  35581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35584 */     GIR_RootConstrainSelectedInstOperands,
     /*  35585 */     // GIR_Coverage, 3858,
     /*  35585 */     GIR_EraseRootFromParent_Done,
     /*  35586 */   // Label 595: @35586
     /*  35586 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35616), // Rule ID 3856 //
     /*  35591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35603 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  35603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  35608 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  35614 */     GIR_RootConstrainSelectedInstOperands,
     /*  35615 */     // GIR_Coverage, 3856,
     /*  35615 */     GIR_Done,
     /*  35616 */   // Label 596: @35616
     /*  35616 */   GIM_Reject,
     /*  35617 */ // Label 586: @35617
     /*  35617 */ GIM_Reject,
     /*  35618 */ // Label 573: @35618
     /*  35618 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(38647),
     /*  35623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  35629 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(35765), // Rule ID 5337 //
     /*  35634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35667 */     // MIs[1] Operand 2
     /*  35667 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35698 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35702 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35707 */     // MIs[3] Operand 2
     /*  35707 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35718 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35720 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35764 */     // GIR_Coverage, 5337,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 598: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(35901), // Rule ID 5336 //
     /*  35770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35803 */     // MIs[1] Operand 2
     /*  35803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35838 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35843 */     // MIs[3] Operand 2
     /*  35843 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35856 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35900 */     // GIR_Coverage, 5336,
     /*  35900 */     GIR_EraseRootFromParent_Done,
     /*  35901 */   // Label 599: @35901
     /*  35901 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36037), // Rule ID 5346 //
     /*  35906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35939 */     // MIs[1] Operand 2
     /*  35939 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35970 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35974 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35979 */     // MIs[3] Operand 2
     /*  35979 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35992 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  35999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     // GIR_Coverage, 5346,
     /*  36036 */     GIR_EraseRootFromParent_Done,
     /*  36037 */   // Label 600: @36037
     /*  36037 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36173), // Rule ID 5335 //
     /*  36042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36075 */     // MIs[1] Operand 2
     /*  36075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  36106 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36110 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36115 */     // MIs[3] Operand 2
     /*  36115 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36128 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36155 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36172 */     // GIR_Coverage, 5335,
     /*  36172 */     GIR_EraseRootFromParent_Done,
     /*  36173 */   // Label 601: @36173
     /*  36173 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36309), // Rule ID 5334 //
     /*  36178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36211 */     // MIs[1] Operand 2
     /*  36211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36246 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36251 */     // MIs[3] Operand 2
     /*  36251 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36262 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36264 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36308 */     // GIR_Coverage, 5334,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 602: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36446), // Rule ID 3912 //
     /*  36314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36355 */     // MIs[2] Operand 2
     /*  36355 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36374 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36378 */     // MIs[3] Operand 1
     /*  36378 */     // No operand predicates
     /*  36378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36380 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36392 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36411 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36444 */     GIR_RootConstrainSelectedInstOperands,
     /*  36445 */     // GIR_Coverage, 3912,
     /*  36445 */     GIR_EraseRootFromParent_Done,
     /*  36446 */   // Label 603: @36446
     /*  36446 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36545), // Rule ID 3910 //
     /*  36451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36504 */     // MIs[3] Operand 1
     /*  36504 */     // No operand predicates
     /*  36504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36506 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36518 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36543 */     GIR_RootConstrainSelectedInstOperands,
     /*  36544 */     // GIR_Coverage, 3910,
     /*  36544 */     GIR_EraseRootFromParent_Done,
     /*  36545 */   // Label 604: @36545
     /*  36545 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36644), // Rule ID 3911 //
     /*  36550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  36603 */     // MIs[3] Operand 1
     /*  36603 */     // No operand predicates
     /*  36603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36605 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36617 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36642 */     GIR_RootConstrainSelectedInstOperands,
     /*  36643 */     // GIR_Coverage, 3911,
     /*  36643 */     GIR_EraseRootFromParent_Done,
     /*  36644 */   // Label 605: @36644
     /*  36644 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36730), // Rule ID 3905 //
     /*  36649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36702 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36709 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36728 */     GIR_RootConstrainSelectedInstOperands,
     /*  36729 */     // GIR_Coverage, 3905,
     /*  36729 */     GIR_EraseRootFromParent_Done,
     /*  36730 */   // Label 606: @36730
     /*  36730 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36816), // Rule ID 3906 //
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36795 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36814 */     GIR_RootConstrainSelectedInstOperands,
     /*  36815 */     // GIR_Coverage, 3906,
     /*  36815 */     GIR_EraseRootFromParent_Done,
     /*  36816 */   // Label 607: @36816
     /*  36816 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36949), // Rule ID 3918 //
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36862 */     // MIs[2] Operand 2
     /*  36862 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36885 */     // MIs[3] Operand 1
     /*  36885 */     // No operand predicates
     /*  36885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36887 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36918 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  36947 */     GIR_RootConstrainSelectedInstOperands,
     /*  36948 */     // GIR_Coverage, 3918,
     /*  36948 */     GIR_EraseRootFromParent_Done,
     /*  36949 */   // Label 608: @36949
     /*  36949 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37044), // Rule ID 3916 //
     /*  36954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  37007 */     // MIs[3] Operand 1
     /*  37007 */     // No operand predicates
     /*  37007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37009 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37021 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37042 */     GIR_RootConstrainSelectedInstOperands,
     /*  37043 */     // GIR_Coverage, 3916,
     /*  37043 */     GIR_EraseRootFromParent_Done,
     /*  37044 */   // Label 609: @37044
     /*  37044 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37139), // Rule ID 3917 //
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  37102 */     // MIs[3] Operand 1
     /*  37102 */     // No operand predicates
     /*  37102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37104 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37116 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37137 */     GIR_RootConstrainSelectedInstOperands,
     /*  37138 */     // GIR_Coverage, 3917,
     /*  37138 */     GIR_EraseRootFromParent_Done,
     /*  37139 */   // Label 610: @37139
     /*  37139 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37221), // Rule ID 124 //
     /*  37144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37204 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37219 */     GIR_RootConstrainSelectedInstOperands,
     /*  37220 */     // GIR_Coverage, 124,
     /*  37220 */     GIR_EraseRootFromParent_Done,
     /*  37221 */   // Label 611: @37221
     /*  37221 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37303), // Rule ID 126 //
     /*  37226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37286 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37301 */     GIR_RootConstrainSelectedInstOperands,
     /*  37302 */     // GIR_Coverage, 126,
     /*  37302 */     GIR_EraseRootFromParent_Done,
     /*  37303 */   // Label 612: @37303
     /*  37303 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37365), // Rule ID 3896 //
     /*  37308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37344 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  37344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37363 */     GIR_RootConstrainSelectedInstOperands,
     /*  37364 */     // GIR_Coverage, 3896,
     /*  37364 */     GIR_EraseRootFromParent_Done,
     /*  37365 */   // Label 613: @37365
     /*  37365 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37423), // Rule ID 9782 //
     /*  37370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37397 */     // MIs[1] pattern
     /*  37397 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37400 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37407 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37421 */     GIR_RootConstrainSelectedInstOperands,
     /*  37422 */     // GIR_Coverage, 9782,
     /*  37422 */     GIR_EraseRootFromParent_Done,
     /*  37423 */   // Label 614: @37423
     /*  37423 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37481), // Rule ID 9794 //
     /*  37428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37447 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37450 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37455 */     // MIs[1] pattern
     /*  37455 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37458 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37465 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37479 */     GIR_RootConstrainSelectedInstOperands,
     /*  37480 */     // GIR_Coverage, 9794,
     /*  37480 */     GIR_EraseRootFromParent_Done,
     /*  37481 */   // Label 615: @37481
     /*  37481 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37539), // Rule ID 9806 //
     /*  37486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37505 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37508 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37513 */     // MIs[1] pattern
     /*  37513 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37516 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37523 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37537 */     GIR_RootConstrainSelectedInstOperands,
     /*  37538 */     // GIR_Coverage, 9806,
     /*  37538 */     GIR_EraseRootFromParent_Done,
     /*  37539 */   // Label 616: @37539
     /*  37539 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37597), // Rule ID 9818 //
     /*  37544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37571 */     // MIs[1] pattern
     /*  37571 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37574 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37581 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37595 */     GIR_RootConstrainSelectedInstOperands,
     /*  37596 */     // GIR_Coverage, 9818,
     /*  37596 */     GIR_EraseRootFromParent_Done,
     /*  37597 */   // Label 617: @37597
     /*  37597 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37760), // Rule ID 5301 //
     /*  37602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  37630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37648 */     // MIs[1] Operand 2
     /*  37648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37661 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37687 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  37719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37759 */     // GIR_Coverage, 5301,
     /*  37759 */     GIR_EraseRootFromParent_Done,
     /*  37760 */   // Label 618: @37760
     /*  37760 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(37923), // Rule ID 5298 //
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  37793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37811 */     // MIs[1] Operand 2
     /*  37811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37824 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  37882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37922 */     // GIR_Coverage, 5298,
     /*  37922 */     GIR_EraseRootFromParent_Done,
     /*  37923 */   // Label 619: @37923
     /*  37923 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38073), // Rule ID 5343 //
     /*  37928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37965 */     // MIs[1] Operand 2
     /*  37965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37978 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38004 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38072 */     // GIR_Coverage, 5343,
     /*  38072 */     GIR_EraseRootFromParent_Done,
     /*  38073 */   // Label 620: @38073
     /*  38073 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38223), // Rule ID 5349 //
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38115 */     // MIs[1] Operand 2
     /*  38115 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38128 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38154 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38157 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  38186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38205 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38222 */     // GIR_Coverage, 5349,
     /*  38222 */     GIR_EraseRootFromParent_Done,
     /*  38223 */   // Label 621: @38223
     /*  38223 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38373), // Rule ID 5342 //
     /*  38228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38265 */     // MIs[1] Operand 2
     /*  38265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38278 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38304 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38311 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38355 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38372 */     // GIR_Coverage, 5342,
     /*  38372 */     GIR_EraseRootFromParent_Done,
     /*  38373 */   // Label 622: @38373
     /*  38373 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38409), // Rule ID 3861 //
     /*  38378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  38393 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  38393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  38396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38398 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38407 */     GIR_RootConstrainSelectedInstOperands,
     /*  38408 */     // GIR_Coverage, 3861,
     /*  38408 */     GIR_EraseRootFromParent_Done,
     /*  38409 */   // Label 623: @38409
     /*  38409 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38442), // Rule ID 3866 //
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  38429 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  38432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38440 */     GIR_RootConstrainSelectedInstOperands,
     /*  38441 */     // GIR_Coverage, 3866,
     /*  38441 */     GIR_EraseRootFromParent_Done,
     /*  38442 */   // Label 624: @38442
     /*  38442 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38478), // Rule ID 3855 //
     /*  38447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  38462 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  38465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38476 */     GIR_RootConstrainSelectedInstOperands,
     /*  38477 */     // GIR_Coverage, 3855,
     /*  38477 */     GIR_EraseRootFromParent_Done,
     /*  38478 */   // Label 625: @38478
     /*  38478 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38514), // Rule ID 3859 //
     /*  38483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  38498 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  38498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  38501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38512 */     GIR_RootConstrainSelectedInstOperands,
     /*  38513 */     // GIR_Coverage, 3859,
     /*  38513 */     GIR_EraseRootFromParent_Done,
     /*  38514 */   // Label 626: @38514
     /*  38514 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38553), // Rule ID 1648 //
     /*  38519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38544 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  38544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38551 */     GIR_RootConstrainSelectedInstOperands,
     /*  38552 */     // GIR_Coverage, 1648,
     /*  38552 */     GIR_EraseRootFromParent_Done,
     /*  38553 */   // Label 627: @38553
     /*  38553 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38589), // Rule ID 5184 //
     /*  38558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38580 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  38580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38587 */     GIR_RootConstrainSelectedInstOperands,
     /*  38588 */     // GIR_Coverage, 5184,
     /*  38588 */     GIR_EraseRootFromParent_Done,
     /*  38589 */   // Label 628: @38589
     /*  38589 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38616), // Rule ID 1637 //
     /*  38594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38609 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  38609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  38614 */     GIR_RootConstrainSelectedInstOperands,
     /*  38615 */     // GIR_Coverage, 1637,
     /*  38615 */     GIR_Done,
     /*  38616 */   // Label 629: @38616
     /*  38616 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38646), // Rule ID 3857 //
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38633 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  38633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  38638 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38644 */     GIR_RootConstrainSelectedInstOperands,
     /*  38645 */     // GIR_Coverage, 3857,
     /*  38645 */     GIR_Done,
     /*  38646 */   // Label 630: @38646
     /*  38646 */   GIM_Reject,
     /*  38647 */ // Label 597: @38647
     /*  38647 */ GIM_Reject,
     /*  38648 */ // Label 574: @38648
     /*  38648 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(40138),
     /*  38653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38663 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(38795), // Rule ID 5333 //
     /*  38668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38697 */     // MIs[1] Operand 2
     /*  38697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38728 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38732 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38737 */     // MIs[3] Operand 2
     /*  38737 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38750 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38794 */     // GIR_Coverage, 5333,
     /*  38794 */     GIR_EraseRootFromParent_Done,
     /*  38795 */   // Label 632: @38795
     /*  38795 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(38927), // Rule ID 5332 //
     /*  38800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38829 */     // MIs[1] Operand 2
     /*  38829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38869 */     // MIs[3] Operand 2
     /*  38869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38882 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38926 */     // GIR_Coverage, 5332,
     /*  38926 */     GIR_EraseRootFromParent_Done,
     /*  38927 */   // Label 633: @38927
     /*  38927 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39059), // Rule ID 5345 //
     /*  38932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38961 */     // MIs[1] Operand 2
     /*  38961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38996 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39001 */     // MIs[3] Operand 2
     /*  39001 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39014 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  39021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39058 */     // GIR_Coverage, 5345,
     /*  39058 */     GIR_EraseRootFromParent_Done,
     /*  39059 */   // Label 634: @39059
     /*  39059 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39191), // Rule ID 5331 //
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39093 */     // MIs[1] Operand 2
     /*  39093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39124 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39128 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39133 */     // MIs[3] Operand 2
     /*  39133 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39144 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39146 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39190 */     // GIR_Coverage, 5331,
     /*  39190 */     GIR_EraseRootFromParent_Done,
     /*  39191 */   // Label 635: @39191
     /*  39191 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39323), // Rule ID 5330 //
     /*  39196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39225 */     // MIs[1] Operand 2
     /*  39225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39256 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39260 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39265 */     // MIs[3] Operand 2
     /*  39265 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39278 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39322 */     // GIR_Coverage, 5330,
     /*  39322 */     GIR_EraseRootFromParent_Done,
     /*  39323 */   // Label 636: @39323
     /*  39323 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39482), // Rule ID 5300 //
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39370 */     // MIs[1] Operand 2
     /*  39370 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39383 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39409 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39416 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  39441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39481 */     // GIR_Coverage, 5300,
     /*  39481 */     GIR_EraseRootFromParent_Done,
     /*  39482 */   // Label 637: @39482
     /*  39482 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39641), // Rule ID 5297 //
     /*  39487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  39511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39529 */     // MIs[1] Operand 2
     /*  39529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39542 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  39600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39640 */     // GIR_Coverage, 5297,
     /*  39640 */     GIR_EraseRootFromParent_Done,
     /*  39641 */   // Label 638: @39641
     /*  39641 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39787), // Rule ID 5341 //
     /*  39646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39679 */     // MIs[1] Operand 2
     /*  39679 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39692 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  39750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39786 */     // GIR_Coverage, 5341,
     /*  39786 */     GIR_EraseRootFromParent_Done,
     /*  39787 */   // Label 639: @39787
     /*  39787 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39933), // Rule ID 5348 //
     /*  39792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39825 */     // MIs[1] Operand 2
     /*  39825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39838 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39871 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  39896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39915 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39932 */     // GIR_Coverage, 5348,
     /*  39932 */     GIR_EraseRootFromParent_Done,
     /*  39933 */   // Label 640: @39933
     /*  39933 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40079), // Rule ID 5340 //
     /*  39938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39971 */     // MIs[1] Operand 2
     /*  39971 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39984 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  40001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  40042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40078 */     // GIR_Coverage, 5340,
     /*  40078 */     GIR_EraseRootFromParent_Done,
     /*  40079 */   // Label 641: @40079
     /*  40079 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40114), // Rule ID 962 //
     /*  40084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  40099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40105 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 962,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 642: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40137), // Rule ID 1469 //
     /*  40119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40130 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  40130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  40135 */     GIR_RootConstrainSelectedInstOperands,
     /*  40136 */     // GIR_Coverage, 1469,
     /*  40136 */     GIR_Done,
     /*  40137 */   // Label 643: @40137
     /*  40137 */   GIM_Reject,
     /*  40138 */ // Label 631: @40138
     /*  40138 */ GIM_Reject,
     /*  40139 */ // Label 575: @40139
     /*  40139 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(42598),
     /*  40144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  40150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40154 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40268), // Rule ID 2041 //
     /*  40159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40210 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40215 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40219 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40223 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40227 */     // MIs[4] Operand 1
     /*  40227 */     // No operand predicates
     /*  40227 */     // MIs[2] Operand 2
     /*  40227 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40247 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40266 */     GIR_RootConstrainSelectedInstOperands,
     /*  40267 */     // GIR_Coverage, 2041,
     /*  40267 */     GIR_EraseRootFromParent_Done,
     /*  40268 */   // Label 645: @40268
     /*  40268 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40382), // Rule ID 13239 //
     /*  40273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40341 */     // MIs[4] Operand 1
     /*  40341 */     // No operand predicates
     /*  40341 */     // MIs[2] Operand 2
     /*  40341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40361 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40380 */     GIR_RootConstrainSelectedInstOperands,
     /*  40381 */     // GIR_Coverage, 13239,
     /*  40381 */     GIR_EraseRootFromParent_Done,
     /*  40382 */   // Label 646: @40382
     /*  40382 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40496), // Rule ID 2093 //
     /*  40387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40430 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40447 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40451 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40455 */     // MIs[4] Operand 1
     /*  40455 */     // No operand predicates
     /*  40455 */     // MIs[2] Operand 2
     /*  40455 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40466 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40475 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40494 */     GIR_RootConstrainSelectedInstOperands,
     /*  40495 */     // GIR_Coverage, 2093,
     /*  40495 */     GIR_EraseRootFromParent_Done,
     /*  40496 */   // Label 647: @40496
     /*  40496 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40610), // Rule ID 13269 //
     /*  40501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40565 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40569 */     // MIs[4] Operand 1
     /*  40569 */     // No operand predicates
     /*  40569 */     // MIs[2] Operand 2
     /*  40569 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40589 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40608 */     GIR_RootConstrainSelectedInstOperands,
     /*  40609 */     // GIR_Coverage, 13269,
     /*  40609 */     GIR_EraseRootFromParent_Done,
     /*  40610 */   // Label 648: @40610
     /*  40610 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40675), // Rule ID 1848 //
     /*  40615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40658 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40673 */     GIR_RootConstrainSelectedInstOperands,
     /*  40674 */     // GIR_Coverage, 1848,
     /*  40674 */     GIR_EraseRootFromParent_Done,
     /*  40675 */   // Label 649: @40675
     /*  40675 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40740), // Rule ID 1847 //
     /*  40680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40723 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40738 */     GIR_RootConstrainSelectedInstOperands,
     /*  40739 */     // GIR_Coverage, 1847,
     /*  40739 */     GIR_EraseRootFromParent_Done,
     /*  40740 */   // Label 650: @40740
     /*  40740 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40805), // Rule ID 1752 //
     /*  40745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40788 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  40791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40803 */     GIR_RootConstrainSelectedInstOperands,
     /*  40804 */     // GIR_Coverage, 1752,
     /*  40804 */     GIR_EraseRootFromParent_Done,
     /*  40805 */   // Label 651: @40805
     /*  40805 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40870), // Rule ID 1846 //
     /*  40810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40853 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40868 */     GIR_RootConstrainSelectedInstOperands,
     /*  40869 */     // GIR_Coverage, 1846,
     /*  40869 */     GIR_EraseRootFromParent_Done,
     /*  40870 */   // Label 652: @40870
     /*  40870 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40935), // Rule ID 1845 //
     /*  40875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40918 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40933 */     GIR_RootConstrainSelectedInstOperands,
     /*  40934 */     // GIR_Coverage, 1845,
     /*  40934 */     GIR_EraseRootFromParent_Done,
     /*  40935 */   // Label 653: @40935
     /*  40935 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41046), // Rule ID 13237 //
     /*  40940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40987 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41004 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41008 */     // MIs[4] Operand 1
     /*  41008 */     // No operand predicates
     /*  41008 */     // MIs[2] Operand 2
     /*  41008 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41024 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41026 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41044 */     GIR_RootConstrainSelectedInstOperands,
     /*  41045 */     // GIR_Coverage, 13237,
     /*  41045 */     GIR_EraseRootFromParent_Done,
     /*  41046 */   // Label 654: @41046
     /*  41046 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41157), // Rule ID 2039 //
     /*  41051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41124 */     // MIs[4] Operand 1
     /*  41124 */     // No operand predicates
     /*  41124 */     // MIs[2] Operand 2
     /*  41124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 2039,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 655: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41268), // Rule ID 13267 //
     /*  41162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41230 */     // MIs[4] Operand 1
     /*  41230 */     // No operand predicates
     /*  41230 */     // MIs[2] Operand 2
     /*  41230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41248 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41266 */     GIR_RootConstrainSelectedInstOperands,
     /*  41267 */     // GIR_Coverage, 13267,
     /*  41267 */     GIR_EraseRootFromParent_Done,
     /*  41268 */   // Label 656: @41268
     /*  41268 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41379), // Rule ID 2091 //
     /*  41273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41342 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41346 */     // MIs[4] Operand 1
     /*  41346 */     // No operand predicates
     /*  41346 */     // MIs[2] Operand 2
     /*  41346 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41357 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41359 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41377 */     GIR_RootConstrainSelectedInstOperands,
     /*  41378 */     // GIR_Coverage, 2091,
     /*  41378 */     GIR_EraseRootFromParent_Done,
     /*  41379 */   // Label 657: @41379
     /*  41379 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41442), // Rule ID 1728 //
     /*  41384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41423 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  41426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41440 */     GIR_RootConstrainSelectedInstOperands,
     /*  41441 */     // GIR_Coverage, 1728,
     /*  41441 */     GIR_EraseRootFromParent_Done,
     /*  41442 */   // Label 658: @41442
     /*  41442 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41505), // Rule ID 1818 //
     /*  41447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41486 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  41489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41503 */     GIR_RootConstrainSelectedInstOperands,
     /*  41504 */     // GIR_Coverage, 1818,
     /*  41504 */     GIR_EraseRootFromParent_Done,
     /*  41505 */   // Label 659: @41505
     /*  41505 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41593), // Rule ID 13238 //
     /*  41510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41566 */     // MIs[3] Operand 1
     /*  41566 */     // No operand predicates
     /*  41566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41573 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41591 */     GIR_RootConstrainSelectedInstOperands,
     /*  41592 */     // GIR_Coverage, 13238,
     /*  41592 */     GIR_EraseRootFromParent_Done,
     /*  41593 */   // Label 660: @41593
     /*  41593 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41681), // Rule ID 2040 //
     /*  41598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41659 */     // MIs[3] Operand 1
     /*  41659 */     // No operand predicates
     /*  41659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41661 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41679 */     GIR_RootConstrainSelectedInstOperands,
     /*  41680 */     // GIR_Coverage, 2040,
     /*  41680 */     GIR_EraseRootFromParent_Done,
     /*  41681 */   // Label 661: @41681
     /*  41681 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41769), // Rule ID 13268 //
     /*  41686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41742 */     // MIs[3] Operand 1
     /*  41742 */     // No operand predicates
     /*  41742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41749 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41767 */     GIR_RootConstrainSelectedInstOperands,
     /*  41768 */     // GIR_Coverage, 13268,
     /*  41768 */     GIR_EraseRootFromParent_Done,
     /*  41769 */   // Label 662: @41769
     /*  41769 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41857), // Rule ID 2092 //
     /*  41774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41835 */     // MIs[3] Operand 1
     /*  41835 */     // No operand predicates
     /*  41835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41837 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41855 */     GIR_RootConstrainSelectedInstOperands,
     /*  41856 */     // GIR_Coverage, 2092,
     /*  41856 */     GIR_EraseRootFromParent_Done,
     /*  41857 */   // Label 663: @41857
     /*  41857 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41904), // Rule ID 1860 //
     /*  41862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41890 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41902 */     GIR_RootConstrainSelectedInstOperands,
     /*  41903 */     // GIR_Coverage, 1860,
     /*  41903 */     GIR_EraseRootFromParent_Done,
     /*  41904 */   // Label 664: @41904
     /*  41904 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41951), // Rule ID 1758 //
     /*  41909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41937 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  41940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41949 */     GIR_RootConstrainSelectedInstOperands,
     /*  41950 */     // GIR_Coverage, 1758,
     /*  41950 */     GIR_EraseRootFromParent_Done,
     /*  41951 */   // Label 665: @41951
     /*  41951 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41998), // Rule ID 1859 //
     /*  41956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41984 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41996 */     GIR_RootConstrainSelectedInstOperands,
     /*  41997 */     // GIR_Coverage, 1859,
     /*  41997 */     GIR_EraseRootFromParent_Done,
     /*  41998 */   // Label 666: @41998
     /*  41998 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42057), // Rule ID 1844 //
     /*  42003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42042 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42055 */     GIR_RootConstrainSelectedInstOperands,
     /*  42056 */     // GIR_Coverage, 1844,
     /*  42056 */     GIR_EraseRootFromParent_Done,
     /*  42057 */   // Label 667: @42057
     /*  42057 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42116), // Rule ID 1843 //
     /*  42062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42101 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42114 */     GIR_RootConstrainSelectedInstOperands,
     /*  42115 */     // GIR_Coverage, 1843,
     /*  42115 */     GIR_EraseRootFromParent_Done,
     /*  42116 */   // Label 668: @42116
     /*  42116 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42175), // Rule ID 1751 //
     /*  42121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42160 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  42163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42173 */     GIR_RootConstrainSelectedInstOperands,
     /*  42174 */     // GIR_Coverage, 1751,
     /*  42174 */     GIR_EraseRootFromParent_Done,
     /*  42175 */   // Label 669: @42175
     /*  42175 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42234), // Rule ID 1842 //
     /*  42180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42219 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42232 */     GIR_RootConstrainSelectedInstOperands,
     /*  42233 */     // GIR_Coverage, 1842,
     /*  42233 */     GIR_EraseRootFromParent_Done,
     /*  42234 */   // Label 670: @42234
     /*  42234 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(42293), // Rule ID 1841 //
     /*  42239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42278 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42291 */     GIR_RootConstrainSelectedInstOperands,
     /*  42292 */     // GIR_Coverage, 1841,
     /*  42292 */     GIR_EraseRootFromParent_Done,
     /*  42293 */   // Label 671: @42293
     /*  42293 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42328), // Rule ID 964 //
     /*  42298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42319 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  42319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  42322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42326 */     GIR_RootConstrainSelectedInstOperands,
     /*  42327 */     // GIR_Coverage, 964,
     /*  42327 */     GIR_EraseRootFromParent_Done,
     /*  42328 */   // Label 672: @42328
     /*  42328 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42385), // Rule ID 1727 //
     /*  42333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42368 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42383 */     GIR_RootConstrainSelectedInstOperands,
     /*  42384 */     // GIR_Coverage, 1727,
     /*  42384 */     GIR_EraseRootFromParent_Done,
     /*  42385 */   // Label 673: @42385
     /*  42385 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42442), // Rule ID 1817 //
     /*  42390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42425 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  42428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42440 */     GIR_RootConstrainSelectedInstOperands,
     /*  42441 */     // GIR_Coverage, 1817,
     /*  42441 */     GIR_EraseRootFromParent_Done,
     /*  42442 */   // Label 674: @42442
     /*  42442 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42486), // Rule ID 1858 //
     /*  42447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42473 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42484 */     GIR_RootConstrainSelectedInstOperands,
     /*  42485 */     // GIR_Coverage, 1858,
     /*  42485 */     GIR_EraseRootFromParent_Done,
     /*  42486 */   // Label 675: @42486
     /*  42486 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42530), // Rule ID 1757 //
     /*  42491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  42520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_RootConstrainSelectedInstOperands,
     /*  42529 */     // GIR_Coverage, 1757,
     /*  42529 */     GIR_EraseRootFromParent_Done,
     /*  42530 */   // Label 676: @42530
     /*  42530 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42574), // Rule ID 1857 //
     /*  42535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42561 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42572 */     GIR_RootConstrainSelectedInstOperands,
     /*  42573 */     // GIR_Coverage, 1857,
     /*  42573 */     GIR_EraseRootFromParent_Done,
     /*  42574 */   // Label 677: @42574
     /*  42574 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42597), // Rule ID 1471 //
     /*  42579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42590 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  42590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  42595 */     GIR_RootConstrainSelectedInstOperands,
     /*  42596 */     // GIR_Coverage, 1471,
     /*  42596 */     GIR_Done,
     /*  42597 */   // Label 678: @42597
     /*  42597 */   GIM_Reject,
     /*  42598 */ // Label 644: @42598
     /*  42598 */ GIM_Reject,
     /*  42599 */ // Label 576: @42599
     /*  42599 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44089),
     /*  42604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42614 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(42746), // Rule ID 5329 //
     /*  42619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42648 */     // MIs[1] Operand 2
     /*  42648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42688 */     // MIs[3] Operand 2
     /*  42688 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42701 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42745 */     // GIR_Coverage, 5329,
     /*  42745 */     GIR_EraseRootFromParent_Done,
     /*  42746 */   // Label 680: @42746
     /*  42746 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(42878), // Rule ID 5328 //
     /*  42751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42780 */     // MIs[1] Operand 2
     /*  42780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42811 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42820 */     // MIs[3] Operand 2
     /*  42820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42833 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42877 */     // GIR_Coverage, 5328,
     /*  42877 */     GIR_EraseRootFromParent_Done,
     /*  42878 */   // Label 681: @42878
     /*  42878 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43010), // Rule ID 5344 //
     /*  42883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42912 */     // MIs[1] Operand 2
     /*  42912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42947 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42952 */     // MIs[3] Operand 2
     /*  42952 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42965 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  42972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43009 */     // GIR_Coverage, 5344,
     /*  43009 */     GIR_EraseRootFromParent_Done,
     /*  43010 */   // Label 682: @43010
     /*  43010 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(43142), // Rule ID 5327 //
     /*  43015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43044 */     // MIs[1] Operand 2
     /*  43044 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43067 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43071 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43075 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43079 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43084 */     // MIs[3] Operand 2
     /*  43084 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43095 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43097 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43141 */     // GIR_Coverage, 5327,
     /*  43141 */     GIR_EraseRootFromParent_Done,
     /*  43142 */   // Label 683: @43142
     /*  43142 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(43274), // Rule ID 5326 //
     /*  43147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43176 */     // MIs[1] Operand 2
     /*  43176 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43199 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43203 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43207 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43211 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43216 */     // MIs[3] Operand 2
     /*  43216 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43227 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43229 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43273 */     // GIR_Coverage, 5326,
     /*  43273 */     GIR_EraseRootFromParent_Done,
     /*  43274 */   // Label 684: @43274
     /*  43274 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43433), // Rule ID 5299 //
     /*  43279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43321 */     // MIs[1] Operand 2
     /*  43321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43334 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43334 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43337 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43341 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43360 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43367 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  43392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43432 */     // GIR_Coverage, 5299,
     /*  43432 */     GIR_EraseRootFromParent_Done,
     /*  43433 */   // Label 685: @43433
     /*  43433 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43592), // Rule ID 5296 //
     /*  43438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43480 */     // MIs[1] Operand 2
     /*  43480 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43493 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43493 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43496 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43500 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43519 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  43551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43574 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43591 */     // GIR_Coverage, 5296,
     /*  43591 */     GIR_EraseRootFromParent_Done,
     /*  43592 */   // Label 686: @43592
     /*  43592 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43738), // Rule ID 5339 //
     /*  43597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43630 */     // MIs[1] Operand 2
     /*  43630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43643 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43643 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43646 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43650 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43672 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43720 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43737 */     // GIR_Coverage, 5339,
     /*  43737 */     GIR_EraseRootFromParent_Done,
     /*  43738 */   // Label 687: @43738
     /*  43738 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43884), // Rule ID 5347 //
     /*  43743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43776 */     // MIs[1] Operand 2
     /*  43776 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43789 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43815 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43866 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43883 */     // GIR_Coverage, 5347,
     /*  43883 */     GIR_EraseRootFromParent_Done,
     /*  43884 */   // Label 688: @43884
     /*  43884 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44030), // Rule ID 5338 //
     /*  43889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43922 */     // MIs[1] Operand 2
     /*  43922 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43935 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43961 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  44019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44029 */     // GIR_Coverage, 5338,
     /*  44029 */     GIR_EraseRootFromParent_Done,
     /*  44030 */   // Label 689: @44030
     /*  44030 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44065), // Rule ID 960 //
     /*  44035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44042 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44048 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44056 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  44056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  44059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44063 */     GIR_RootConstrainSelectedInstOperands,
     /*  44064 */     // GIR_Coverage, 960,
     /*  44064 */     GIR_EraseRootFromParent_Done,
     /*  44065 */   // Label 690: @44065
     /*  44065 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44088), // Rule ID 1467 //
     /*  44070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44081 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  44081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  44086 */     GIR_RootConstrainSelectedInstOperands,
     /*  44087 */     // GIR_Coverage, 1467,
     /*  44087 */     GIR_Done,
     /*  44088 */   // Label 691: @44088
     /*  44088 */   GIM_Reject,
     /*  44089 */ // Label 679: @44089
     /*  44089 */ GIM_Reject,
     /*  44090 */ // Label 577: @44090
     /*  44090 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(46549),
     /*  44095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44105 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44219), // Rule ID 2038 //
     /*  44110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44157 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44178 */     // MIs[4] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     // MIs[2] Operand 2
     /*  44178 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44198 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44217 */     GIR_RootConstrainSelectedInstOperands,
     /*  44218 */     // GIR_Coverage, 2038,
     /*  44218 */     GIR_EraseRootFromParent_Done,
     /*  44219 */   // Label 693: @44219
     /*  44219 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44333), // Rule ID 13236 //
     /*  44224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44292 */     // MIs[4] Operand 1
     /*  44292 */     // No operand predicates
     /*  44292 */     // MIs[2] Operand 2
     /*  44292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44312 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44331 */     GIR_RootConstrainSelectedInstOperands,
     /*  44332 */     // GIR_Coverage, 13236,
     /*  44332 */     GIR_EraseRootFromParent_Done,
     /*  44333 */   // Label 694: @44333
     /*  44333 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44447), // Rule ID 2090 //
     /*  44338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44389 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44398 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44402 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44406 */     // MIs[4] Operand 1
     /*  44406 */     // No operand predicates
     /*  44406 */     // MIs[2] Operand 2
     /*  44406 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44426 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44445 */     GIR_RootConstrainSelectedInstOperands,
     /*  44446 */     // GIR_Coverage, 2090,
     /*  44446 */     GIR_EraseRootFromParent_Done,
     /*  44447 */   // Label 695: @44447
     /*  44447 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44561), // Rule ID 13266 //
     /*  44452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44516 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44520 */     // MIs[4] Operand 1
     /*  44520 */     // No operand predicates
     /*  44520 */     // MIs[2] Operand 2
     /*  44520 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44540 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44559 */     GIR_RootConstrainSelectedInstOperands,
     /*  44560 */     // GIR_Coverage, 13266,
     /*  44560 */     GIR_EraseRootFromParent_Done,
     /*  44561 */   // Label 696: @44561
     /*  44561 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44626), // Rule ID 1840 //
     /*  44566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44609 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44624 */     GIR_RootConstrainSelectedInstOperands,
     /*  44625 */     // GIR_Coverage, 1840,
     /*  44625 */     GIR_EraseRootFromParent_Done,
     /*  44626 */   // Label 697: @44626
     /*  44626 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44691), // Rule ID 1839 //
     /*  44631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44674 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44689 */     GIR_RootConstrainSelectedInstOperands,
     /*  44690 */     // GIR_Coverage, 1839,
     /*  44690 */     GIR_EraseRootFromParent_Done,
     /*  44691 */   // Label 698: @44691
     /*  44691 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44756), // Rule ID 1750 //
     /*  44696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44739 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  44742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44754 */     GIR_RootConstrainSelectedInstOperands,
     /*  44755 */     // GIR_Coverage, 1750,
     /*  44755 */     GIR_EraseRootFromParent_Done,
     /*  44756 */   // Label 699: @44756
     /*  44756 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44821), // Rule ID 1838 //
     /*  44761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44804 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44819 */     GIR_RootConstrainSelectedInstOperands,
     /*  44820 */     // GIR_Coverage, 1838,
     /*  44820 */     GIR_EraseRootFromParent_Done,
     /*  44821 */   // Label 700: @44821
     /*  44821 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44886), // Rule ID 1837 //
     /*  44826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44869 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44884 */     GIR_RootConstrainSelectedInstOperands,
     /*  44885 */     // GIR_Coverage, 1837,
     /*  44885 */     GIR_EraseRootFromParent_Done,
     /*  44886 */   // Label 701: @44886
     /*  44886 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44997), // Rule ID 13234 //
     /*  44891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44955 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44959 */     // MIs[4] Operand 1
     /*  44959 */     // No operand predicates
     /*  44959 */     // MIs[2] Operand 2
     /*  44959 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44977 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  44980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44995 */     GIR_RootConstrainSelectedInstOperands,
     /*  44996 */     // GIR_Coverage, 13234,
     /*  44996 */     GIR_EraseRootFromParent_Done,
     /*  44997 */   // Label 702: @44997
     /*  44997 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45108), // Rule ID 2036 //
     /*  45002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45075 */     // MIs[4] Operand 1
     /*  45075 */     // No operand predicates
     /*  45075 */     // MIs[2] Operand 2
     /*  45075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45106 */     GIR_RootConstrainSelectedInstOperands,
     /*  45107 */     // GIR_Coverage, 2036,
     /*  45107 */     GIR_EraseRootFromParent_Done,
     /*  45108 */   // Label 703: @45108
     /*  45108 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45219), // Rule ID 13264 //
     /*  45113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45177 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45181 */     // MIs[4] Operand 1
     /*  45181 */     // No operand predicates
     /*  45181 */     // MIs[2] Operand 2
     /*  45181 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45199 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45217 */     GIR_RootConstrainSelectedInstOperands,
     /*  45218 */     // GIR_Coverage, 13264,
     /*  45218 */     GIR_EraseRootFromParent_Done,
     /*  45219 */   // Label 704: @45219
     /*  45219 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45330), // Rule ID 2088 //
     /*  45224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45280 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45285 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45289 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45293 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45297 */     // MIs[4] Operand 1
     /*  45297 */     // No operand predicates
     /*  45297 */     // MIs[2] Operand 2
     /*  45297 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45308 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45310 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45328 */     GIR_RootConstrainSelectedInstOperands,
     /*  45329 */     // GIR_Coverage, 2088,
     /*  45329 */     GIR_EraseRootFromParent_Done,
     /*  45330 */   // Label 705: @45330
     /*  45330 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45393), // Rule ID 1726 //
     /*  45335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45374 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  45377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45391 */     GIR_RootConstrainSelectedInstOperands,
     /*  45392 */     // GIR_Coverage, 1726,
     /*  45392 */     GIR_EraseRootFromParent_Done,
     /*  45393 */   // Label 706: @45393
     /*  45393 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45456), // Rule ID 1816 //
     /*  45398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45437 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  45440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45454 */     GIR_RootConstrainSelectedInstOperands,
     /*  45455 */     // GIR_Coverage, 1816,
     /*  45455 */     GIR_EraseRootFromParent_Done,
     /*  45456 */   // Label 707: @45456
     /*  45456 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45544), // Rule ID 13235 //
     /*  45461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45517 */     // MIs[3] Operand 1
     /*  45517 */     // No operand predicates
     /*  45517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45524 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45542 */     GIR_RootConstrainSelectedInstOperands,
     /*  45543 */     // GIR_Coverage, 13235,
     /*  45543 */     GIR_EraseRootFromParent_Done,
     /*  45544 */   // Label 708: @45544
     /*  45544 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45632), // Rule ID 2037 //
     /*  45549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45610 */     // MIs[3] Operand 1
     /*  45610 */     // No operand predicates
     /*  45610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45612 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45630 */     GIR_RootConstrainSelectedInstOperands,
     /*  45631 */     // GIR_Coverage, 2037,
     /*  45631 */     GIR_EraseRootFromParent_Done,
     /*  45632 */   // Label 709: @45632
     /*  45632 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45720), // Rule ID 13265 //
     /*  45637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45689 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45693 */     // MIs[3] Operand 1
     /*  45693 */     // No operand predicates
     /*  45693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45700 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45718 */     GIR_RootConstrainSelectedInstOperands,
     /*  45719 */     // GIR_Coverage, 13265,
     /*  45719 */     GIR_EraseRootFromParent_Done,
     /*  45720 */   // Label 710: @45720
     /*  45720 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(45808), // Rule ID 2089 //
     /*  45725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45786 */     // MIs[3] Operand 1
     /*  45786 */     // No operand predicates
     /*  45786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45788 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45806 */     GIR_RootConstrainSelectedInstOperands,
     /*  45807 */     // GIR_Coverage, 2089,
     /*  45807 */     GIR_EraseRootFromParent_Done,
     /*  45808 */   // Label 711: @45808
     /*  45808 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45855), // Rule ID 1856 //
     /*  45813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45841 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45853 */     GIR_RootConstrainSelectedInstOperands,
     /*  45854 */     // GIR_Coverage, 1856,
     /*  45854 */     GIR_EraseRootFromParent_Done,
     /*  45855 */   // Label 712: @45855
     /*  45855 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45902), // Rule ID 1756 //
     /*  45860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45888 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  45891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45900 */     GIR_RootConstrainSelectedInstOperands,
     /*  45901 */     // GIR_Coverage, 1756,
     /*  45901 */     GIR_EraseRootFromParent_Done,
     /*  45902 */   // Label 713: @45902
     /*  45902 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45949), // Rule ID 1855 //
     /*  45907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45935 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45947 */     GIR_RootConstrainSelectedInstOperands,
     /*  45948 */     // GIR_Coverage, 1855,
     /*  45948 */     GIR_EraseRootFromParent_Done,
     /*  45949 */   // Label 714: @45949
     /*  45949 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46008), // Rule ID 1836 //
     /*  45954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45993 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  45993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  45996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46006 */     GIR_RootConstrainSelectedInstOperands,
     /*  46007 */     // GIR_Coverage, 1836,
     /*  46007 */     GIR_EraseRootFromParent_Done,
     /*  46008 */   // Label 715: @46008
     /*  46008 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46067), // Rule ID 1835 //
     /*  46013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46052 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46065 */     GIR_RootConstrainSelectedInstOperands,
     /*  46066 */     // GIR_Coverage, 1835,
     /*  46066 */     GIR_EraseRootFromParent_Done,
     /*  46067 */   // Label 716: @46067
     /*  46067 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46126), // Rule ID 1749 //
     /*  46072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46111 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  46114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46124 */     GIR_RootConstrainSelectedInstOperands,
     /*  46125 */     // GIR_Coverage, 1749,
     /*  46125 */     GIR_EraseRootFromParent_Done,
     /*  46126 */   // Label 717: @46126
     /*  46126 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46185), // Rule ID 1834 //
     /*  46131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46170 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46183 */     GIR_RootConstrainSelectedInstOperands,
     /*  46184 */     // GIR_Coverage, 1834,
     /*  46184 */     GIR_EraseRootFromParent_Done,
     /*  46185 */   // Label 718: @46185
     /*  46185 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(46244), // Rule ID 1833 //
     /*  46190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46229 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46242 */     GIR_RootConstrainSelectedInstOperands,
     /*  46243 */     // GIR_Coverage, 1833,
     /*  46243 */     GIR_EraseRootFromParent_Done,
     /*  46244 */   // Label 719: @46244
     /*  46244 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(46279), // Rule ID 963 //
     /*  46249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46270 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  46270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  46273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46277 */     GIR_RootConstrainSelectedInstOperands,
     /*  46278 */     // GIR_Coverage, 963,
     /*  46278 */     GIR_EraseRootFromParent_Done,
     /*  46279 */   // Label 720: @46279
     /*  46279 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(46336), // Rule ID 1725 //
     /*  46284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46319 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46334 */     GIR_RootConstrainSelectedInstOperands,
     /*  46335 */     // GIR_Coverage, 1725,
     /*  46335 */     GIR_EraseRootFromParent_Done,
     /*  46336 */   // Label 721: @46336
     /*  46336 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(46393), // Rule ID 1815 //
     /*  46341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46376 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  46379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46391 */     GIR_RootConstrainSelectedInstOperands,
     /*  46392 */     // GIR_Coverage, 1815,
     /*  46392 */     GIR_EraseRootFromParent_Done,
     /*  46393 */   // Label 722: @46393
     /*  46393 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46437), // Rule ID 1854 //
     /*  46398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46424 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46435 */     GIR_RootConstrainSelectedInstOperands,
     /*  46436 */     // GIR_Coverage, 1854,
     /*  46436 */     GIR_EraseRootFromParent_Done,
     /*  46437 */   // Label 723: @46437
     /*  46437 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(46481), // Rule ID 1755 //
     /*  46442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  46471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_RootConstrainSelectedInstOperands,
     /*  46480 */     // GIR_Coverage, 1755,
     /*  46480 */     GIR_EraseRootFromParent_Done,
     /*  46481 */   // Label 724: @46481
     /*  46481 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(46525), // Rule ID 1853 //
     /*  46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46512 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46523 */     GIR_RootConstrainSelectedInstOperands,
     /*  46524 */     // GIR_Coverage, 1853,
     /*  46524 */     GIR_EraseRootFromParent_Done,
     /*  46525 */   // Label 725: @46525
     /*  46525 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(46548), // Rule ID 1470 //
     /*  46530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46541 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  46541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  46546 */     GIR_RootConstrainSelectedInstOperands,
     /*  46547 */     // GIR_Coverage, 1470,
     /*  46547 */     GIR_Done,
     /*  46548 */   // Label 726: @46548
     /*  46548 */   GIM_Reject,
     /*  46549 */ // Label 692: @46549
     /*  46549 */ GIM_Reject,
     /*  46550 */ // Label 578: @46550
     /*  46550 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(46624),
     /*  46555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46565 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(46600), // Rule ID 958 //
     /*  46570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46591 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  46591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  46594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46598 */     GIR_RootConstrainSelectedInstOperands,
     /*  46599 */     // GIR_Coverage, 958,
     /*  46599 */     GIR_EraseRootFromParent_Done,
     /*  46600 */   // Label 728: @46600
     /*  46600 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(46623), // Rule ID 1465 //
     /*  46605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46616 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  46616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  46621 */     GIR_RootConstrainSelectedInstOperands,
     /*  46622 */     // GIR_Coverage, 1465,
     /*  46622 */     GIR_Done,
     /*  46623 */   // Label 729: @46623
     /*  46623 */   GIM_Reject,
     /*  46624 */ // Label 727: @46624
     /*  46624 */ GIM_Reject,
     /*  46625 */ // Label 579: @46625
     /*  46625 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47832),
     /*  46630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  46636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46640 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46705), // Rule ID 1832 //
     /*  46645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46688 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46703 */     GIR_RootConstrainSelectedInstOperands,
     /*  46704 */     // GIR_Coverage, 1832,
     /*  46704 */     GIR_EraseRootFromParent_Done,
     /*  46705 */   // Label 731: @46705
     /*  46705 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46770), // Rule ID 1831 //
     /*  46710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46753 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46768 */     GIR_RootConstrainSelectedInstOperands,
     /*  46769 */     // GIR_Coverage, 1831,
     /*  46769 */     GIR_EraseRootFromParent_Done,
     /*  46770 */   // Label 732: @46770
     /*  46770 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(46835), // Rule ID 1748 //
     /*  46775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46818 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46833 */     GIR_RootConstrainSelectedInstOperands,
     /*  46834 */     // GIR_Coverage, 1748,
     /*  46834 */     GIR_EraseRootFromParent_Done,
     /*  46835 */   // Label 733: @46835
     /*  46835 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46900), // Rule ID 1830 //
     /*  46840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46883 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46898 */     GIR_RootConstrainSelectedInstOperands,
     /*  46899 */     // GIR_Coverage, 1830,
     /*  46899 */     GIR_EraseRootFromParent_Done,
     /*  46900 */   // Label 734: @46900
     /*  46900 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46965), // Rule ID 1829 //
     /*  46905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46948 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46963 */     GIR_RootConstrainSelectedInstOperands,
     /*  46964 */     // GIR_Coverage, 1829,
     /*  46964 */     GIR_EraseRootFromParent_Done,
     /*  46965 */   // Label 735: @46965
     /*  46965 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(47028), // Rule ID 1724 //
     /*  46970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47009 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  47012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47026 */     GIR_RootConstrainSelectedInstOperands,
     /*  47027 */     // GIR_Coverage, 1724,
     /*  47027 */     GIR_EraseRootFromParent_Done,
     /*  47028 */   // Label 736: @47028
     /*  47028 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(47091), // Rule ID 1814 //
     /*  47033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47072 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  47075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47089 */     GIR_RootConstrainSelectedInstOperands,
     /*  47090 */     // GIR_Coverage, 1814,
     /*  47090 */     GIR_EraseRootFromParent_Done,
     /*  47091 */   // Label 737: @47091
     /*  47091 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47138), // Rule ID 1852 //
     /*  47096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47124 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47136 */     GIR_RootConstrainSelectedInstOperands,
     /*  47137 */     // GIR_Coverage, 1852,
     /*  47137 */     GIR_EraseRootFromParent_Done,
     /*  47138 */   // Label 738: @47138
     /*  47138 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(47185), // Rule ID 1754 //
     /*  47143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47171 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  47174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47183 */     GIR_RootConstrainSelectedInstOperands,
     /*  47184 */     // GIR_Coverage, 1754,
     /*  47184 */     GIR_EraseRootFromParent_Done,
     /*  47185 */   // Label 739: @47185
     /*  47185 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(47232), // Rule ID 1851 //
     /*  47190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47218 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47230 */     GIR_RootConstrainSelectedInstOperands,
     /*  47231 */     // GIR_Coverage, 1851,
     /*  47231 */     GIR_EraseRootFromParent_Done,
     /*  47232 */   // Label 740: @47232
     /*  47232 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(47291), // Rule ID 1828 //
     /*  47237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47276 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47289 */     GIR_RootConstrainSelectedInstOperands,
     /*  47290 */     // GIR_Coverage, 1828,
     /*  47290 */     GIR_EraseRootFromParent_Done,
     /*  47291 */   // Label 741: @47291
     /*  47291 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(47350), // Rule ID 1827 //
     /*  47296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47335 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47348 */     GIR_RootConstrainSelectedInstOperands,
     /*  47349 */     // GIR_Coverage, 1827,
     /*  47349 */     GIR_EraseRootFromParent_Done,
     /*  47350 */   // Label 742: @47350
     /*  47350 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(47409), // Rule ID 1747 //
     /*  47355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47394 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  47397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47407 */     GIR_RootConstrainSelectedInstOperands,
     /*  47408 */     // GIR_Coverage, 1747,
     /*  47408 */     GIR_EraseRootFromParent_Done,
     /*  47409 */   // Label 743: @47409
     /*  47409 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47468), // Rule ID 1826 //
     /*  47414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47453 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47466 */     GIR_RootConstrainSelectedInstOperands,
     /*  47467 */     // GIR_Coverage, 1826,
     /*  47467 */     GIR_EraseRootFromParent_Done,
     /*  47468 */   // Label 744: @47468
     /*  47468 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(47527), // Rule ID 1825 //
     /*  47473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47512 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47525 */     GIR_RootConstrainSelectedInstOperands,
     /*  47526 */     // GIR_Coverage, 1825,
     /*  47526 */     GIR_EraseRootFromParent_Done,
     /*  47527 */   // Label 745: @47527
     /*  47527 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(47562), // Rule ID 961 //
     /*  47532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47539 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47545 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47553 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  47553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  47556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47560 */     GIR_RootConstrainSelectedInstOperands,
     /*  47561 */     // GIR_Coverage, 961,
     /*  47561 */     GIR_EraseRootFromParent_Done,
     /*  47562 */   // Label 746: @47562
     /*  47562 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(47619), // Rule ID 1723 //
     /*  47567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47602 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47617 */     GIR_RootConstrainSelectedInstOperands,
     /*  47618 */     // GIR_Coverage, 1723,
     /*  47618 */     GIR_EraseRootFromParent_Done,
     /*  47619 */   // Label 747: @47619
     /*  47619 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(47676), // Rule ID 1813 //
     /*  47624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47659 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47674 */     GIR_RootConstrainSelectedInstOperands,
     /*  47675 */     // GIR_Coverage, 1813,
     /*  47675 */     GIR_EraseRootFromParent_Done,
     /*  47676 */   // Label 748: @47676
     /*  47676 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(47720), // Rule ID 1850 //
     /*  47681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47707 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47718 */     GIR_RootConstrainSelectedInstOperands,
     /*  47719 */     // GIR_Coverage, 1850,
     /*  47719 */     GIR_EraseRootFromParent_Done,
     /*  47720 */   // Label 749: @47720
     /*  47720 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(47764), // Rule ID 1753 //
     /*  47725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47751 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47762 */     GIR_RootConstrainSelectedInstOperands,
     /*  47763 */     // GIR_Coverage, 1753,
     /*  47763 */     GIR_EraseRootFromParent_Done,
     /*  47764 */   // Label 750: @47764
     /*  47764 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(47808), // Rule ID 1849 //
     /*  47769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47795 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47806 */     GIR_RootConstrainSelectedInstOperands,
     /*  47807 */     // GIR_Coverage, 1849,
     /*  47807 */     GIR_EraseRootFromParent_Done,
     /*  47808 */   // Label 751: @47808
     /*  47808 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(47831), // Rule ID 1468 //
     /*  47813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47824 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  47829 */     GIR_RootConstrainSelectedInstOperands,
     /*  47830 */     // GIR_Coverage, 1468,
     /*  47830 */     GIR_Done,
     /*  47831 */   // Label 752: @47831
     /*  47831 */   GIM_Reject,
     /*  47832 */ // Label 730: @47832
     /*  47832 */ GIM_Reject,
     /*  47833 */ // Label 580: @47833
     /*  47833 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(47907),
     /*  47838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  47841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  47844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47848 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(47883), // Rule ID 959 //
     /*  47853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47874 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  47874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  47877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47881 */     GIR_RootConstrainSelectedInstOperands,
     /*  47882 */     // GIR_Coverage, 959,
     /*  47882 */     GIR_EraseRootFromParent_Done,
     /*  47883 */   // Label 754: @47883
     /*  47883 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(47906), // Rule ID 1466 //
     /*  47888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47899 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  47904 */     GIR_RootConstrainSelectedInstOperands,
     /*  47905 */     // GIR_Coverage, 1466,
     /*  47905 */     GIR_Done,
     /*  47906 */   // Label 755: @47906
     /*  47906 */   GIM_Reject,
     /*  47907 */ // Label 753: @47907
     /*  47907 */ GIM_Reject,
     /*  47908 */ // Label 581: @47908
     /*  47908 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(47933), // Rule ID 7289 //
     /*  47913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  47919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  47922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47926 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  47926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  47931 */   GIR_RootConstrainSelectedInstOperands,
     /*  47932 */   // GIR_Coverage, 7289,
     /*  47932 */   GIR_Done,
     /*  47933 */ // Label 756: @47933
     /*  47933 */ GIM_Reject,
     /*  47934 */ // Label 582: @47934
     /*  47934 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(47959), // Rule ID 7288 //
     /*  47939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  47945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  47948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47952 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  47952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  47957 */   GIR_RootConstrainSelectedInstOperands,
     /*  47958 */   // GIR_Coverage, 7288,
     /*  47958 */   GIR_Done,
     /*  47959 */ // Label 757: @47959
     /*  47959 */ GIM_Reject,
     /*  47960 */ // Label 583: @47960
     /*  47960 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(47985), // Rule ID 7287 //
     /*  47965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  47971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  47974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47978 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  47978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  47983 */   GIR_RootConstrainSelectedInstOperands,
     /*  47984 */   // GIR_Coverage, 7287,
     /*  47984 */   GIR_Done,
     /*  47985 */ // Label 758: @47985
     /*  47985 */ GIM_Reject,
     /*  47986 */ // Label 584: @47986
     /*  47986 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(48011), // Rule ID 7286 //
     /*  47991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  47997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  48000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  48004 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  48004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  48009 */   GIR_RootConstrainSelectedInstOperands,
     /*  48010 */   // GIR_Coverage, 7286,
     /*  48010 */   GIR_Done,
     /*  48011 */ // Label 759: @48011
     /*  48011 */ GIM_Reject,
     /*  48012 */ // Label 585: @48012
     /*  48012 */ GIM_Reject,
     /*  48013 */ // Label 2: @48013
     /*  48013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 768*/ GIMT_Encode4(49841),
     /*  48024 */ /*GILLT_s32*//*Label 760*/ GIMT_Encode4(48064),
     /*  48028 */ /*GILLT_s64*//*Label 761*/ GIMT_Encode4(48221), GIMT_Encode4(0),
     /*  48036 */ /*GILLT_v2s32*//*Label 762*/ GIMT_Encode4(48765), GIMT_Encode4(0),
     /*  48044 */ /*GILLT_v4s16*//*Label 763*/ GIMT_Encode4(49103),
     /*  48048 */ /*GILLT_v4s32*//*Label 764*/ GIMT_Encode4(49441),
     /*  48052 */ /*GILLT_v8s8*//*Label 765*/ GIMT_Encode4(49607),
     /*  48056 */ /*GILLT_v8s16*//*Label 766*/ GIMT_Encode4(49641),
     /*  48060 */ /*GILLT_v16s8*//*Label 767*/ GIMT_Encode4(49807),
     /*  48064 */ // Label 760: @48064
     /*  48064 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(48220),
     /*  48069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48079 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(48134), // Rule ID 3897 //
     /*  48084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48115 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48132 */     GIR_RootConstrainSelectedInstOperands,
     /*  48133 */     // GIR_Coverage, 3897,
     /*  48133 */     GIR_EraseRootFromParent_Done,
     /*  48134 */   // Label 770: @48134
     /*  48134 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(48189), // Rule ID 13519 //
     /*  48139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48159 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48170 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13519,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 771: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(48219), // Rule ID 3893 //
     /*  48194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48202 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  48205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48217 */     GIR_RootConstrainSelectedInstOperands,
     /*  48218 */     // GIR_Coverage, 3893,
     /*  48218 */     GIR_EraseRootFromParent_Done,
     /*  48219 */   // Label 772: @48219
     /*  48219 */   GIM_Reject,
     /*  48220 */ // Label 769: @48220
     /*  48220 */ GIM_Reject,
     /*  48221 */ // Label 761: @48221
     /*  48221 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(48764),
     /*  48226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  48232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(48291), // Rule ID 3898 //
     /*  48241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48272 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48289 */     GIR_RootConstrainSelectedInstOperands,
     /*  48290 */     // GIR_Coverage, 3898,
     /*  48290 */     GIR_EraseRootFromParent_Done,
     /*  48291 */   // Label 774: @48291
     /*  48291 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(48346), // Rule ID 13520 //
     /*  48296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48327 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48344 */     GIR_RootConstrainSelectedInstOperands,
     /*  48345 */     // GIR_Coverage, 13520,
     /*  48345 */     GIR_EraseRootFromParent_Done,
     /*  48346 */   // Label 775: @48346
     /*  48346 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(48459), // Rule ID 3909 //
     /*  48351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  48359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48368 */     // MIs[1] Operand 2
     /*  48368 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  48379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48391 */     // MIs[2] Operand 1
     /*  48391 */     // No operand predicates
     /*  48391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48393 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48405 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  48430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  48451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48457 */     GIR_RootConstrainSelectedInstOperands,
     /*  48458 */     // GIR_Coverage, 3909,
     /*  48458 */     GIR_EraseRootFromParent_Done,
     /*  48459 */   // Label 776: @48459
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(48534), // Rule ID 3907 //
     /*  48464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48493 */     // MIs[2] Operand 1
     /*  48493 */     // No operand predicates
     /*  48493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48495 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48507 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48532 */     GIR_RootConstrainSelectedInstOperands,
     /*  48533 */     // GIR_Coverage, 3907,
     /*  48533 */     GIR_EraseRootFromParent_Done,
     /*  48534 */   // Label 777: @48534
     /*  48534 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(48609), // Rule ID 3908 //
     /*  48539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  48568 */     // MIs[2] Operand 1
     /*  48568 */     // No operand predicates
     /*  48568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48570 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48582 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48607 */     GIR_RootConstrainSelectedInstOperands,
     /*  48608 */     // GIR_Coverage, 3908,
     /*  48608 */     GIR_EraseRootFromParent_Done,
     /*  48609 */   // Label 778: @48609
     /*  48609 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(48671), // Rule ID 3901 //
     /*  48614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48650 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48669 */     GIR_RootConstrainSelectedInstOperands,
     /*  48670 */     // GIR_Coverage, 3901,
     /*  48670 */     GIR_EraseRootFromParent_Done,
     /*  48671 */   // Label 779: @48671
     /*  48671 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(48733), // Rule ID 3904 //
     /*  48676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48712 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48731 */     GIR_RootConstrainSelectedInstOperands,
     /*  48732 */     // GIR_Coverage, 3904,
     /*  48732 */     GIR_EraseRootFromParent_Done,
     /*  48733 */   // Label 780: @48733
     /*  48733 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(48763), // Rule ID 3894 //
     /*  48738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48746 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  48749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48761 */     GIR_RootConstrainSelectedInstOperands,
     /*  48762 */     // GIR_Coverage, 3894,
     /*  48762 */     GIR_EraseRootFromParent_Done,
     /*  48763 */   // Label 781: @48763
     /*  48763 */   GIM_Reject,
     /*  48764 */ // Label 773: @48764
     /*  48764 */ GIM_Reject,
     /*  48765 */ // Label 762: @48765
     /*  48765 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(49102),
     /*  48770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  48773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  48776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48780 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(48866), // Rule ID 13213 //
     /*  48785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48833 */     // MIs[3] Operand 1
     /*  48833 */     // No operand predicates
     /*  48833 */     // MIs[1] Operand 2
     /*  48833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48850 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48864 */     GIR_RootConstrainSelectedInstOperands,
     /*  48865 */     // GIR_Coverage, 13213,
     /*  48865 */     GIR_EraseRootFromParent_Done,
     /*  48866 */   // Label 783: @48866
     /*  48866 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48952), // Rule ID 2027 //
     /*  48871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48923 */     // MIs[3] Operand 1
     /*  48923 */     // No operand predicates
     /*  48923 */     // MIs[1] Operand 2
     /*  48923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48936 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48950 */     GIR_RootConstrainSelectedInstOperands,
     /*  48951 */     // GIR_Coverage, 2027,
     /*  48951 */     GIR_EraseRootFromParent_Done,
     /*  48952 */   // Label 784: @48952
     /*  48952 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(49015), // Rule ID 13214 //
     /*  48957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48993 */     // MIs[2] Operand 1
     /*  48993 */     // No operand predicates
     /*  48993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48999 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49013 */     GIR_RootConstrainSelectedInstOperands,
     /*  49014 */     // GIR_Coverage, 13214,
     /*  49014 */     GIR_EraseRootFromParent_Done,
     /*  49015 */   // Label 785: @49015
     /*  49015 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(49078), // Rule ID 2028 //
     /*  49020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49060 */     // MIs[2] Operand 1
     /*  49060 */     // No operand predicates
     /*  49060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49062 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49076 */     GIR_RootConstrainSelectedInstOperands,
     /*  49077 */     // GIR_Coverage, 2028,
     /*  49077 */     GIR_EraseRootFromParent_Done,
     /*  49078 */   // Label 786: @49078
     /*  49078 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(49101), // Rule ID 1345 //
     /*  49083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49094 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  49094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1345,
     /*  49100 */     GIR_Done,
     /*  49101 */   // Label 787: @49101
     /*  49101 */   GIM_Reject,
     /*  49102 */ // Label 782: @49102
     /*  49102 */ GIM_Reject,
     /*  49103 */ // Label 763: @49103
     /*  49103 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(49440),
     /*  49108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49118 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(49204), // Rule ID 13210 //
     /*  49123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49171 */     // MIs[3] Operand 1
     /*  49171 */     // No operand predicates
     /*  49171 */     // MIs[1] Operand 2
     /*  49171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49188 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49202 */     GIR_RootConstrainSelectedInstOperands,
     /*  49203 */     // GIR_Coverage, 13210,
     /*  49203 */     GIR_EraseRootFromParent_Done,
     /*  49204 */   // Label 789: @49204
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(49290), // Rule ID 2024 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49261 */     // MIs[3] Operand 1
     /*  49261 */     // No operand predicates
     /*  49261 */     // MIs[1] Operand 2
     /*  49261 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49274 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49288 */     GIR_RootConstrainSelectedInstOperands,
     /*  49289 */     // GIR_Coverage, 2024,
     /*  49289 */     GIR_EraseRootFromParent_Done,
     /*  49290 */   // Label 790: @49290
     /*  49290 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(49353), // Rule ID 13211 //
     /*  49295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49331 */     // MIs[2] Operand 1
     /*  49331 */     // No operand predicates
     /*  49331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49337 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49351 */     GIR_RootConstrainSelectedInstOperands,
     /*  49352 */     // GIR_Coverage, 13211,
     /*  49352 */     GIR_EraseRootFromParent_Done,
     /*  49353 */   // Label 791: @49353
     /*  49353 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(49416), // Rule ID 2025 //
     /*  49358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49398 */     // MIs[2] Operand 1
     /*  49398 */     // No operand predicates
     /*  49398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49400 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49414 */     GIR_RootConstrainSelectedInstOperands,
     /*  49415 */     // GIR_Coverage, 2025,
     /*  49415 */     GIR_EraseRootFromParent_Done,
     /*  49416 */   // Label 792: @49416
     /*  49416 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(49439), // Rule ID 1343 //
     /*  49421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49432 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  49437 */     GIR_RootConstrainSelectedInstOperands,
     /*  49438 */     // GIR_Coverage, 1343,
     /*  49438 */     GIR_Done,
     /*  49439 */   // Label 793: @49439
     /*  49439 */   GIM_Reject,
     /*  49440 */ // Label 788: @49440
     /*  49440 */ GIM_Reject,
     /*  49441 */ // Label 764: @49441
     /*  49441 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(49606),
     /*  49446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49456 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49519), // Rule ID 13215 //
     /*  49461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49497 */     // MIs[2] Operand 1
     /*  49497 */     // No operand predicates
     /*  49497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49503 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49517 */     GIR_RootConstrainSelectedInstOperands,
     /*  49518 */     // GIR_Coverage, 13215,
     /*  49518 */     GIR_EraseRootFromParent_Done,
     /*  49519 */   // Label 795: @49519
     /*  49519 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49582), // Rule ID 2029 //
     /*  49524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49564 */     // MIs[2] Operand 1
     /*  49564 */     // No operand predicates
     /*  49564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49566 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49580 */     GIR_RootConstrainSelectedInstOperands,
     /*  49581 */     // GIR_Coverage, 2029,
     /*  49581 */     GIR_EraseRootFromParent_Done,
     /*  49582 */   // Label 796: @49582
     /*  49582 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49605), // Rule ID 1346 //
     /*  49587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49598 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  49603 */     GIR_RootConstrainSelectedInstOperands,
     /*  49604 */     // GIR_Coverage, 1346,
     /*  49604 */     GIR_Done,
     /*  49605 */   // Label 797: @49605
     /*  49605 */   GIM_Reject,
     /*  49606 */ // Label 794: @49606
     /*  49606 */ GIM_Reject,
     /*  49607 */ // Label 765: @49607
     /*  49607 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49640), // Rule ID 1341 //
     /*  49612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49633 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  49638 */   GIR_RootConstrainSelectedInstOperands,
     /*  49639 */   // GIR_Coverage, 1341,
     /*  49639 */   GIR_Done,
     /*  49640 */ // Label 798: @49640
     /*  49640 */ GIM_Reject,
     /*  49641 */ // Label 766: @49641
     /*  49641 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49806),
     /*  49646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49656 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49719), // Rule ID 13212 //
     /*  49661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49697 */     // MIs[2] Operand 1
     /*  49697 */     // No operand predicates
     /*  49697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49703 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49717 */     GIR_RootConstrainSelectedInstOperands,
     /*  49718 */     // GIR_Coverage, 13212,
     /*  49718 */     GIR_EraseRootFromParent_Done,
     /*  49719 */   // Label 800: @49719
     /*  49719 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49782), // Rule ID 2026 //
     /*  49724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49760 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49764 */     // MIs[2] Operand 1
     /*  49764 */     // No operand predicates
     /*  49764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49766 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49780 */     GIR_RootConstrainSelectedInstOperands,
     /*  49781 */     // GIR_Coverage, 2026,
     /*  49781 */     GIR_EraseRootFromParent_Done,
     /*  49782 */   // Label 801: @49782
     /*  49782 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49805), // Rule ID 1344 //
     /*  49787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49798 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1344,
     /*  49804 */     GIR_Done,
     /*  49805 */   // Label 802: @49805
     /*  49805 */   GIM_Reject,
     /*  49806 */ // Label 799: @49806
     /*  49806 */ GIM_Reject,
     /*  49807 */ // Label 767: @49807
     /*  49807 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49840), // Rule ID 1342 //
     /*  49812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  49818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49833 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  49838 */   GIR_RootConstrainSelectedInstOperands,
     /*  49839 */   // GIR_Coverage, 1342,
     /*  49839 */   GIR_Done,
     /*  49840 */ // Label 803: @49840
     /*  49840 */ GIM_Reject,
     /*  49841 */ // Label 768: @49841
     /*  49841 */ GIM_Reject,
     /*  49842 */ // Label 3: @49842
     /*  49842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 806*/ GIMT_Encode4(49923),
     /*  49853 */ /*GILLT_s32*//*Label 804*/ GIMT_Encode4(49861),
     /*  49857 */ /*GILLT_s64*//*Label 805*/ GIMT_Encode4(49892),
     /*  49861 */ // Label 804: @49861
     /*  49861 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49891), // Rule ID 117 //
     /*  49866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49884 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  49889 */   GIR_RootConstrainSelectedInstOperands,
     /*  49890 */   // GIR_Coverage, 117,
     /*  49890 */   GIR_Done,
     /*  49891 */ // Label 807: @49891
     /*  49891 */ GIM_Reject,
     /*  49892 */ // Label 805: @49892
     /*  49892 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49922), // Rule ID 118 //
     /*  49897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49915 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  49920 */   GIR_RootConstrainSelectedInstOperands,
     /*  49921 */   // GIR_Coverage, 118,
     /*  49921 */   GIR_Done,
     /*  49922 */ // Label 808: @49922
     /*  49922 */ GIM_Reject,
     /*  49923 */ // Label 806: @49923
     /*  49923 */ GIM_Reject,
     /*  49924 */ // Label 4: @49924
     /*  49924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 811*/ GIMT_Encode4(50005),
     /*  49935 */ /*GILLT_s32*//*Label 809*/ GIMT_Encode4(49943),
     /*  49939 */ /*GILLT_s64*//*Label 810*/ GIMT_Encode4(49974),
     /*  49943 */ // Label 809: @49943
     /*  49943 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(49973), // Rule ID 115 //
     /*  49948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49966 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  49971 */   GIR_RootConstrainSelectedInstOperands,
     /*  49972 */   // GIR_Coverage, 115,
     /*  49972 */   GIR_Done,
     /*  49973 */ // Label 812: @49973
     /*  49973 */ GIM_Reject,
     /*  49974 */ // Label 810: @49974
     /*  49974 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50004), // Rule ID 116 //
     /*  49979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49997 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  50002 */   GIR_RootConstrainSelectedInstOperands,
     /*  50003 */   // GIR_Coverage, 116,
     /*  50003 */   GIR_Done,
     /*  50004 */ // Label 813: @50004
     /*  50004 */ GIM_Reject,
     /*  50005 */ // Label 811: @50005
     /*  50005 */ GIM_Reject,
     /*  50006 */ // Label 5: @50006
     /*  50006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 832*/ GIMT_Encode4(57751),
     /*  50017 */ /*GILLT_s32*//*Label 814*/ GIMT_Encode4(50105),
     /*  50021 */ /*GILLT_s64*//*Label 815*/ GIMT_Encode4(50603), GIMT_Encode4(0),
     /*  50029 */ /*GILLT_v2s32*//*Label 816*/ GIMT_Encode4(52038),
     /*  50033 */ /*GILLT_v2s64*//*Label 817*/ GIMT_Encode4(52198),
     /*  50037 */ /*GILLT_v4s16*//*Label 818*/ GIMT_Encode4(52358),
     /*  50041 */ /*GILLT_v4s32*//*Label 819*/ GIMT_Encode4(52518),
     /*  50045 */ /*GILLT_v8s8*//*Label 820*/ GIMT_Encode4(52678),
     /*  50049 */ /*GILLT_v8s16*//*Label 821*/ GIMT_Encode4(52838),
     /*  50053 */ /*GILLT_v16s8*//*Label 822*/ GIMT_Encode4(52998),
     /*  50057 */ /*GILLT_nxv1s1*//*Label 823*/ GIMT_Encode4(53158),
     /*  50061 */ /*GILLT_nxv2s1*//*Label 824*/ GIMT_Encode4(53699), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  50073 */ /*GILLT_nxv2s64*//*Label 825*/ GIMT_Encode4(54240),
     /*  50077 */ /*GILLT_nxv4s1*//*Label 826*/ GIMT_Encode4(54712), GIMT_Encode4(0),
     /*  50085 */ /*GILLT_nxv4s32*//*Label 827*/ GIMT_Encode4(55253),
     /*  50089 */ /*GILLT_nxv8s1*//*Label 828*/ GIMT_Encode4(55725),
     /*  50093 */ /*GILLT_nxv8s16*//*Label 829*/ GIMT_Encode4(56266),
     /*  50097 */ /*GILLT_nxv16s1*//*Label 830*/ GIMT_Encode4(56738),
     /*  50101 */ /*GILLT_nxv16s8*//*Label 831*/ GIMT_Encode4(57279),
     /*  50105 */ // Label 814: @50105
     /*  50105 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(50602),
     /*  50110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50116 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(50171), // Rule ID 12972 //
     /*  50121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50158 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50169 */     GIR_RootConstrainSelectedInstOperands,
     /*  50170 */     // GIR_Coverage, 12972,
     /*  50170 */     GIR_EraseRootFromParent_Done,
     /*  50171 */   // Label 834: @50171
     /*  50171 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(50226), // Rule ID 162 //
     /*  50176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50213 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50224 */     GIR_RootConstrainSelectedInstOperands,
     /*  50225 */     // GIR_Coverage, 162,
     /*  50225 */     GIR_EraseRootFromParent_Done,
     /*  50226 */   // Label 835: @50226
     /*  50226 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(50295), // Rule ID 5590 //
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50268 */     // MIs[2] Operand 1
     /*  50268 */     // No operand predicates
     /*  50268 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50281 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  50281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50293 */     GIR_RootConstrainSelectedInstOperands,
     /*  50294 */     // GIR_Coverage, 5590,
     /*  50294 */     GIR_EraseRootFromParent_Done,
     /*  50295 */   // Label 836: @50295
     /*  50295 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(50364), // Rule ID 5591 //
     /*  50300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50337 */     // MIs[2] Operand 1
     /*  50337 */     // No operand predicates
     /*  50337 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50350 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  50350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50362 */     GIR_RootConstrainSelectedInstOperands,
     /*  50363 */     // GIR_Coverage, 5591,
     /*  50363 */     GIR_EraseRootFromParent_Done,
     /*  50364 */   // Label 837: @50364
     /*  50364 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50417), // Rule ID 12970 //
     /*  50369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50404 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50415 */     GIR_RootConstrainSelectedInstOperands,
     /*  50416 */     // GIR_Coverage, 12970,
     /*  50416 */     GIR_EraseRootFromParent_Done,
     /*  50417 */   // Label 838: @50417
     /*  50417 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50470), // Rule ID 160 //
     /*  50422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50457 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50468 */     GIR_RootConstrainSelectedInstOperands,
     /*  50469 */     // GIR_Coverage, 160,
     /*  50469 */     GIR_EraseRootFromParent_Done,
     /*  50470 */   // Label 839: @50470
     /*  50470 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50511), // Rule ID 142 //
     /*  50475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  50479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50491 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  50495 */     // MIs[1] Operand 1
     /*  50495 */     // No operand predicates
     /*  50495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50497 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  50497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  50500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50504 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  50509 */     GIR_RootConstrainSelectedInstOperands,
     /*  50510 */     // GIR_Coverage, 142,
     /*  50510 */     GIR_EraseRootFromParent_Done,
     /*  50511 */   // Label 840: @50511
     /*  50511 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50544), // Rule ID 12968 //
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50531 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50542 */     GIR_RootConstrainSelectedInstOperands,
     /*  50543 */     // GIR_Coverage, 12968,
     /*  50543 */     GIR_EraseRootFromParent_Done,
     /*  50544 */   // Label 841: @50544
     /*  50544 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50577), // Rule ID 158 //
     /*  50549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50564 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50575 */     GIR_RootConstrainSelectedInstOperands,
     /*  50576 */     // GIR_Coverage, 158,
     /*  50576 */     GIR_EraseRootFromParent_Done,
     /*  50577 */   // Label 842: @50577
     /*  50577 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50601), // Rule ID 156 //
     /*  50582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50594 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  50599 */     GIR_RootConstrainSelectedInstOperands,
     /*  50600 */     // GIR_Coverage, 156,
     /*  50600 */     GIR_Done,
     /*  50601 */   // Label 843: @50601
     /*  50601 */   GIM_Reject,
     /*  50602 */ // Label 833: @50602
     /*  50602 */ GIM_Reject,
     /*  50603 */ // Label 815: @50603
     /*  50603 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52037),
     /*  50608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50614 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50669), // Rule ID 12973 //
     /*  50619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50656 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50667 */     GIR_RootConstrainSelectedInstOperands,
     /*  50668 */     // GIR_Coverage, 12973,
     /*  50668 */     GIR_EraseRootFromParent_Done,
     /*  50669 */   // Label 845: @50669
     /*  50669 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50724), // Rule ID 163 //
     /*  50674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50711 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50722 */     GIR_RootConstrainSelectedInstOperands,
     /*  50723 */     // GIR_Coverage, 163,
     /*  50723 */     GIR_EraseRootFromParent_Done,
     /*  50724 */   // Label 846: @50724
     /*  50724 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(50837), // Rule ID 5592 //
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50778 */     // MIs[3] Operand 1
     /*  50778 */     // No operand predicates
     /*  50778 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50791 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  50791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50836 */     // GIR_Coverage, 5592,
     /*  50836 */     GIR_EraseRootFromParent_Done,
     /*  50837 */   // Label 847: @50837
     /*  50837 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50950), // Rule ID 5593 //
     /*  50842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50891 */     // MIs[3] Operand 1
     /*  50891 */     // No operand predicates
     /*  50891 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50904 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  50904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50949 */     // GIR_Coverage, 5593,
     /*  50949 */     GIR_EraseRootFromParent_Done,
     /*  50950 */   // Label 848: @50950
     /*  50950 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(51049), // Rule ID 7008 //
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  50967 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  50970 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  50975 */     // MIs[1] addr
     /*  50975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  50979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  50984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  50988 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51001 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  51008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51048 */     // GIR_Coverage, 7008,
     /*  51048 */     GIR_EraseRootFromParent_Done,
     /*  51049 */   // Label 849: @51049
     /*  51049 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(51148), // Rule ID 7009 //
     /*  51054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51074 */     // MIs[1] addr
     /*  51074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51083 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  51087 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51100 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  51107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51147 */     // GIR_Coverage, 7009,
     /*  51147 */     GIR_EraseRootFromParent_Done,
     /*  51148 */   // Label 850: @51148
     /*  51148 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(51247), // Rule ID 7010 //
     /*  51153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51173 */     // MIs[1] addr
     /*  51173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51182 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  51186 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51199 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  51206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51246 */     // GIR_Coverage, 7010,
     /*  51246 */     GIR_EraseRootFromParent_Done,
     /*  51247 */   // Label 851: @51247
     /*  51247 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(51346), // Rule ID 7015 //
     /*  51252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51264 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51267 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51272 */     // MIs[1] addr
     /*  51272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51281 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  51285 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  51296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51298 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  51305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51345 */     // GIR_Coverage, 7015,
     /*  51345 */     GIR_EraseRootFromParent_Done,
     /*  51346 */   // Label 852: @51346
     /*  51346 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(51445), // Rule ID 7016 //
     /*  51351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51363 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51366 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51371 */     // MIs[1] addr
     /*  51371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  51384 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51397 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  51404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51444 */     // GIR_Coverage, 7016,
     /*  51444 */     GIR_EraseRootFromParent_Done,
     /*  51445 */   // Label 853: @51445
     /*  51445 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(51544), // Rule ID 7017 //
     /*  51450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51462 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51465 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51470 */     // MIs[1] addr
     /*  51470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51479 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  51483 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51496 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  51503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51543 */     // GIR_Coverage, 7017,
     /*  51543 */     GIR_EraseRootFromParent_Done,
     /*  51544 */   // Label 854: @51544
     /*  51544 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(51597), // Rule ID 12971 //
     /*  51549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51574 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51584 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51595 */     GIR_RootConstrainSelectedInstOperands,
     /*  51596 */     // GIR_Coverage, 12971,
     /*  51596 */     GIR_EraseRootFromParent_Done,
     /*  51597 */   // Label 855: @51597
     /*  51597 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(51650), // Rule ID 161 //
     /*  51602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51637 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51648 */     GIR_RootConstrainSelectedInstOperands,
     /*  51649 */     // GIR_Coverage, 161,
     /*  51649 */     GIR_EraseRootFromParent_Done,
     /*  51650 */   // Label 856: @51650
     /*  51650 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(51750), // Rule ID 3946 //
     /*  51655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51663 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51674 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  51709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51714 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51749 */     // GIR_Coverage, 3946,
     /*  51749 */     GIR_EraseRootFromParent_Done,
     /*  51750 */   // Label 857: @51750
     /*  51750 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(51791), // Rule ID 143 //
     /*  51755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51771 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  51775 */     // MIs[1] Operand 1
     /*  51775 */     // No operand predicates
     /*  51775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51777 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  51777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  51780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51784 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  51789 */     GIR_RootConstrainSelectedInstOperands,
     /*  51790 */     // GIR_Coverage, 143,
     /*  51790 */     GIR_EraseRootFromParent_Done,
     /*  51791 */   // Label 858: @51791
     /*  51791 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(51824), // Rule ID 12969 //
     /*  51796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51811 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51822 */     GIR_RootConstrainSelectedInstOperands,
     /*  51823 */     // GIR_Coverage, 12969,
     /*  51823 */     GIR_EraseRootFromParent_Done,
     /*  51824 */   // Label 859: @51824
     /*  51824 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51857), // Rule ID 159 //
     /*  51829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51844 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51855 */     GIR_RootConstrainSelectedInstOperands,
     /*  51856 */     // GIR_Coverage, 159,
     /*  51856 */     GIR_EraseRootFromParent_Done,
     /*  51857 */   // Label 860: @51857
     /*  51857 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(51921), // Rule ID 13624 //
     /*  51862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51908 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51913 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  51915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13624,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 861: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(51985), // Rule ID 4981 //
     /*  51926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51962 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51972 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51977 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  51979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51983 */     GIR_RootConstrainSelectedInstOperands,
     /*  51984 */     // GIR_Coverage, 4981,
     /*  51984 */     GIR_EraseRootFromParent_Done,
     /*  51985 */   // Label 862: @51985
     /*  51985 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(52009), // Rule ID 157 //
     /*  51990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52002 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  52007 */     GIR_RootConstrainSelectedInstOperands,
     /*  52008 */     // GIR_Coverage, 157,
     /*  52008 */     GIR_Done,
     /*  52009 */   // Label 863: @52009
     /*  52009 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(52036), // Rule ID 2475 //
     /*  52014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52029 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  52029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52034 */     GIR_RootConstrainSelectedInstOperands,
     /*  52035 */     // GIR_Coverage, 2475,
     /*  52035 */     GIR_Done,
     /*  52036 */   // Label 864: @52036
     /*  52036 */   GIM_Reject,
     /*  52037 */ // Label 844: @52037
     /*  52037 */ GIM_Reject,
     /*  52038 */ // Label 816: @52038
     /*  52038 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(52197),
     /*  52043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52053 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(52113), // Rule ID 13623 //
     /*  52058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52086 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52100 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52105 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52111 */     GIR_RootConstrainSelectedInstOperands,
     /*  52112 */     // GIR_Coverage, 13623,
     /*  52112 */     GIR_EraseRootFromParent_Done,
     /*  52113 */   // Label 866: @52113
     /*  52113 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(52173), // Rule ID 4980 //
     /*  52118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52160 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52171 */     GIR_RootConstrainSelectedInstOperands,
     /*  52172 */     // GIR_Coverage, 4980,
     /*  52172 */     GIR_EraseRootFromParent_Done,
     /*  52173 */   // Label 867: @52173
     /*  52173 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(52196), // Rule ID 2474 //
     /*  52178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52189 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52194 */     GIR_RootConstrainSelectedInstOperands,
     /*  52195 */     // GIR_Coverage, 2474,
     /*  52195 */     GIR_Done,
     /*  52196 */   // Label 868: @52196
     /*  52196 */   GIM_Reject,
     /*  52197 */ // Label 865: @52197
     /*  52197 */ GIM_Reject,
     /*  52198 */ // Label 817: @52198
     /*  52198 */ GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(52357),
     /*  52203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52213 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(52273), // Rule ID 13627 //
     /*  52218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52260 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52265 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52271 */     GIR_RootConstrainSelectedInstOperands,
     /*  52272 */     // GIR_Coverage, 13627,
     /*  52272 */     GIR_EraseRootFromParent_Done,
     /*  52273 */   // Label 870: @52273
     /*  52273 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(52333), // Rule ID 4984 //
     /*  52278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52310 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52320 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52331 */     GIR_RootConstrainSelectedInstOperands,
     /*  52332 */     // GIR_Coverage, 4984,
     /*  52332 */     GIR_EraseRootFromParent_Done,
     /*  52333 */   // Label 871: @52333
     /*  52333 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(52356), // Rule ID 2478 //
     /*  52338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52349 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52354 */     GIR_RootConstrainSelectedInstOperands,
     /*  52355 */     // GIR_Coverage, 2478,
     /*  52355 */     GIR_Done,
     /*  52356 */   // Label 872: @52356
     /*  52356 */   GIM_Reject,
     /*  52357 */ // Label 869: @52357
     /*  52357 */ GIM_Reject,
     /*  52358 */ // Label 818: @52358
     /*  52358 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(52517),
     /*  52363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52373 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(52433), // Rule ID 13622 //
     /*  52378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52420 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52425 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52431 */     GIR_RootConstrainSelectedInstOperands,
     /*  52432 */     // GIR_Coverage, 13622,
     /*  52432 */     GIR_EraseRootFromParent_Done,
     /*  52433 */   // Label 874: @52433
     /*  52433 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(52493), // Rule ID 4979 //
     /*  52438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52470 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52480 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52491 */     GIR_RootConstrainSelectedInstOperands,
     /*  52492 */     // GIR_Coverage, 4979,
     /*  52492 */     GIR_EraseRootFromParent_Done,
     /*  52493 */   // Label 875: @52493
     /*  52493 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(52516), // Rule ID 2473 //
     /*  52498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52509 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 2473,
     /*  52515 */     GIR_Done,
     /*  52516 */   // Label 876: @52516
     /*  52516 */   GIM_Reject,
     /*  52517 */ // Label 873: @52517
     /*  52517 */ GIM_Reject,
     /*  52518 */ // Label 819: @52518
     /*  52518 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(52677),
     /*  52523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52533 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(52593), // Rule ID 13626 //
     /*  52538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52580 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52591 */     GIR_RootConstrainSelectedInstOperands,
     /*  52592 */     // GIR_Coverage, 13626,
     /*  52592 */     GIR_EraseRootFromParent_Done,
     /*  52593 */   // Label 878: @52593
     /*  52593 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(52653), // Rule ID 4983 //
     /*  52598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52640 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52645 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52651 */     GIR_RootConstrainSelectedInstOperands,
     /*  52652 */     // GIR_Coverage, 4983,
     /*  52652 */     GIR_EraseRootFromParent_Done,
     /*  52653 */   // Label 879: @52653
     /*  52653 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(52676), // Rule ID 2477 //
     /*  52658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52669 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52674 */     GIR_RootConstrainSelectedInstOperands,
     /*  52675 */     // GIR_Coverage, 2477,
     /*  52675 */     GIR_Done,
     /*  52676 */   // Label 880: @52676
     /*  52676 */   GIM_Reject,
     /*  52677 */ // Label 877: @52677
     /*  52677 */ GIM_Reject,
     /*  52678 */ // Label 820: @52678
     /*  52678 */ GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(52837),
     /*  52683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52693 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(52753), // Rule ID 13108 //
     /*  52698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52726 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52740 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52751 */     GIR_RootConstrainSelectedInstOperands,
     /*  52752 */     // GIR_Coverage, 13108,
     /*  52752 */     GIR_EraseRootFromParent_Done,
     /*  52753 */   // Label 882: @52753
     /*  52753 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(52813), // Rule ID 1590 //
     /*  52758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52800 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52811 */     GIR_RootConstrainSelectedInstOperands,
     /*  52812 */     // GIR_Coverage, 1590,
     /*  52812 */     GIR_EraseRootFromParent_Done,
     /*  52813 */   // Label 883: @52813
     /*  52813 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(52836), // Rule ID 1588 //
     /*  52818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52829 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52834 */     GIR_RootConstrainSelectedInstOperands,
     /*  52835 */     // GIR_Coverage, 1588,
     /*  52835 */     GIR_Done,
     /*  52836 */   // Label 884: @52836
     /*  52836 */   GIM_Reject,
     /*  52837 */ // Label 881: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 821: @52838
     /*  52838 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(52997),
     /*  52843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52853 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(52913), // Rule ID 13625 //
     /*  52858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52900 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52905 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52911 */     GIR_RootConstrainSelectedInstOperands,
     /*  52912 */     // GIR_Coverage, 13625,
     /*  52912 */     GIR_EraseRootFromParent_Done,
     /*  52913 */   // Label 886: @52913
     /*  52913 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(52973), // Rule ID 4982 //
     /*  52918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52950 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52960 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52965 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52971 */     GIR_RootConstrainSelectedInstOperands,
     /*  52972 */     // GIR_Coverage, 4982,
     /*  52972 */     GIR_EraseRootFromParent_Done,
     /*  52973 */   // Label 887: @52973
     /*  52973 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(52996), // Rule ID 2476 //
     /*  52978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52989 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52994 */     GIR_RootConstrainSelectedInstOperands,
     /*  52995 */     // GIR_Coverage, 2476,
     /*  52995 */     GIR_Done,
     /*  52996 */   // Label 888: @52996
     /*  52996 */   GIM_Reject,
     /*  52997 */ // Label 885: @52997
     /*  52997 */ GIM_Reject,
     /*  52998 */ // Label 822: @52998
     /*  52998 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(53157),
     /*  53003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(53073), // Rule ID 13109 //
     /*  53018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53046 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53060 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53071 */     GIR_RootConstrainSelectedInstOperands,
     /*  53072 */     // GIR_Coverage, 13109,
     /*  53072 */     GIR_EraseRootFromParent_Done,
     /*  53073 */   // Label 890: @53073
     /*  53073 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(53133), // Rule ID 1591 //
     /*  53078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53110 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53120 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53131 */     GIR_RootConstrainSelectedInstOperands,
     /*  53132 */     // GIR_Coverage, 1591,
     /*  53132 */     GIR_EraseRootFromParent_Done,
     /*  53133 */   // Label 891: @53133
     /*  53133 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(53156), // Rule ID 1589 //
     /*  53138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53149 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  53154 */     GIR_RootConstrainSelectedInstOperands,
     /*  53155 */     // GIR_Coverage, 1589,
     /*  53155 */     GIR_Done,
     /*  53156 */   // Label 892: @53156
     /*  53156 */   GIM_Reject,
     /*  53157 */ // Label 889: @53157
     /*  53157 */ GIM_Reject,
     /*  53158 */ // Label 823: @53158
     /*  53158 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(53698),
     /*  53163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53173 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(53230), // Rule ID 14825 //
     /*  53178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53215 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53228 */     GIR_RootConstrainSelectedInstOperands,
     /*  53229 */     // GIR_Coverage, 14825,
     /*  53229 */     GIR_EraseRootFromParent_Done,
     /*  53230 */   // Label 894: @53230
     /*  53230 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(53287), // Rule ID 14828 //
     /*  53235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53266 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53272 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53285 */     GIR_RootConstrainSelectedInstOperands,
     /*  53286 */     // GIR_Coverage, 14828,
     /*  53286 */     GIR_EraseRootFromParent_Done,
     /*  53287 */   // Label 895: @53287
     /*  53287 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(53344), // Rule ID 14824 //
     /*  53292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53323 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53329 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53342 */     GIR_RootConstrainSelectedInstOperands,
     /*  53343 */     // GIR_Coverage, 14824,
     /*  53343 */     GIR_EraseRootFromParent_Done,
     /*  53344 */   // Label 896: @53344
     /*  53344 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(53401), // Rule ID 14827 //
     /*  53349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53386 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53399 */     GIR_RootConstrainSelectedInstOperands,
     /*  53400 */     // GIR_Coverage, 14827,
     /*  53400 */     GIR_EraseRootFromParent_Done,
     /*  53401 */   // Label 897: @53401
     /*  53401 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(53458), // Rule ID 14823 //
     /*  53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53443 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53456 */     GIR_RootConstrainSelectedInstOperands,
     /*  53457 */     // GIR_Coverage, 14823,
     /*  53457 */     GIR_EraseRootFromParent_Done,
     /*  53458 */   // Label 898: @53458
     /*  53458 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(53515), // Rule ID 14826 //
     /*  53463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53500 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53513 */     GIR_RootConstrainSelectedInstOperands,
     /*  53514 */     // GIR_Coverage, 14826,
     /*  53514 */     GIR_EraseRootFromParent_Done,
     /*  53515 */   // Label 899: @53515
     /*  53515 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(53572), // Rule ID 8277 //
     /*  53520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53557 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53570 */     GIR_RootConstrainSelectedInstOperands,
     /*  53571 */     // GIR_Coverage, 8277,
     /*  53571 */     GIR_EraseRootFromParent_Done,
     /*  53572 */   // Label 900: @53572
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(53629), // Rule ID 8278 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53614 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53627 */     GIR_RootConstrainSelectedInstOperands,
     /*  53628 */     // GIR_Coverage, 8278,
     /*  53628 */     GIR_EraseRootFromParent_Done,
     /*  53629 */   // Label 901: @53629
     /*  53629 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(53676), // Rule ID 10529 //
     /*  53634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53645 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  53645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  53648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  53652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  53660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  53672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 10529,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 902: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(53697), // Rule ID 2739 //
     /*  53681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53684 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  53695 */     GIR_RootConstrainSelectedInstOperands,
     /*  53696 */     // GIR_Coverage, 2739,
     /*  53696 */     GIR_EraseRootFromParent_Done,
     /*  53697 */   // Label 903: @53697
     /*  53697 */   GIM_Reject,
     /*  53698 */ // Label 893: @53698
     /*  53698 */ GIM_Reject,
     /*  53699 */ // Label 824: @53699
     /*  53699 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(54239),
     /*  53704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53714 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(53771), // Rule ID 14816 //
     /*  53719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53756 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53769 */     GIR_RootConstrainSelectedInstOperands,
     /*  53770 */     // GIR_Coverage, 14816,
     /*  53770 */     GIR_EraseRootFromParent_Done,
     /*  53771 */   // Label 905: @53771
     /*  53771 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(53828), // Rule ID 14819 //
     /*  53776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53813 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53826 */     GIR_RootConstrainSelectedInstOperands,
     /*  53827 */     // GIR_Coverage, 14819,
     /*  53827 */     GIR_EraseRootFromParent_Done,
     /*  53828 */   // Label 906: @53828
     /*  53828 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(53885), // Rule ID 14815 //
     /*  53833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53870 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53883 */     GIR_RootConstrainSelectedInstOperands,
     /*  53884 */     // GIR_Coverage, 14815,
     /*  53884 */     GIR_EraseRootFromParent_Done,
     /*  53885 */   // Label 907: @53885
     /*  53885 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(53942), // Rule ID 14818 //
     /*  53890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53927 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53940 */     GIR_RootConstrainSelectedInstOperands,
     /*  53941 */     // GIR_Coverage, 14818,
     /*  53941 */     GIR_EraseRootFromParent_Done,
     /*  53942 */   // Label 908: @53942
     /*  53942 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(53999), // Rule ID 14814 //
     /*  53947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53984 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53997 */     GIR_RootConstrainSelectedInstOperands,
     /*  53998 */     // GIR_Coverage, 14814,
     /*  53998 */     GIR_EraseRootFromParent_Done,
     /*  53999 */   // Label 909: @53999
     /*  53999 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(54056), // Rule ID 14817 //
     /*  54004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54041 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54054 */     GIR_RootConstrainSelectedInstOperands,
     /*  54055 */     // GIR_Coverage, 14817,
     /*  54055 */     GIR_EraseRootFromParent_Done,
     /*  54056 */   // Label 910: @54056
     /*  54056 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(54113), // Rule ID 8273 //
     /*  54061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54098 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54111 */     GIR_RootConstrainSelectedInstOperands,
     /*  54112 */     // GIR_Coverage, 8273,
     /*  54112 */     GIR_EraseRootFromParent_Done,
     /*  54113 */   // Label 911: @54113
     /*  54113 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(54170), // Rule ID 8274 //
     /*  54118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54155 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54168 */     GIR_RootConstrainSelectedInstOperands,
     /*  54169 */     // GIR_Coverage, 8274,
     /*  54169 */     GIR_EraseRootFromParent_Done,
     /*  54170 */   // Label 912: @54170
     /*  54170 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(54217), // Rule ID 10528 //
     /*  54175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54186 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  54186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  54189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  54193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  54201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  54213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  54215 */     GIR_RootConstrainSelectedInstOperands,
     /*  54216 */     // GIR_Coverage, 10528,
     /*  54216 */     GIR_EraseRootFromParent_Done,
     /*  54217 */   // Label 913: @54217
     /*  54217 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(54238), // Rule ID 2738 //
     /*  54222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54225 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  54236 */     GIR_RootConstrainSelectedInstOperands,
     /*  54237 */     // GIR_Coverage, 2738,
     /*  54237 */     GIR_EraseRootFromParent_Done,
     /*  54238 */   // Label 914: @54238
     /*  54238 */   GIM_Reject,
     /*  54239 */ // Label 904: @54239
     /*  54239 */ GIM_Reject,
     /*  54240 */ // Label 825: @54240
     /*  54240 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(54711),
     /*  54245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  54255 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(54310), // Rule ID 14756 //
     /*  54260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54291 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54297 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54308 */     GIR_RootConstrainSelectedInstOperands,
     /*  54309 */     // GIR_Coverage, 14756,
     /*  54309 */     GIR_EraseRootFromParent_Done,
     /*  54310 */   // Label 916: @54310
     /*  54310 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(54365), // Rule ID 14759 //
     /*  54315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54346 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54352 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54363 */     GIR_RootConstrainSelectedInstOperands,
     /*  54364 */     // GIR_Coverage, 14759,
     /*  54364 */     GIR_EraseRootFromParent_Done,
     /*  54365 */   // Label 917: @54365
     /*  54365 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(54420), // Rule ID 14755 //
     /*  54370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54407 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54418 */     GIR_RootConstrainSelectedInstOperands,
     /*  54419 */     // GIR_Coverage, 14755,
     /*  54419 */     GIR_EraseRootFromParent_Done,
     /*  54420 */   // Label 918: @54420
     /*  54420 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54475), // Rule ID 14758 //
     /*  54425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54462 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54473 */     GIR_RootConstrainSelectedInstOperands,
     /*  54474 */     // GIR_Coverage, 14758,
     /*  54474 */     GIR_EraseRootFromParent_Done,
     /*  54475 */   // Label 919: @54475
     /*  54475 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(54530), // Rule ID 14754 //
     /*  54480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54517 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54528 */     GIR_RootConstrainSelectedInstOperands,
     /*  54529 */     // GIR_Coverage, 14754,
     /*  54529 */     GIR_EraseRootFromParent_Done,
     /*  54530 */   // Label 920: @54530
     /*  54530 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(54585), // Rule ID 14757 //
     /*  54535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54572 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54583 */     GIR_RootConstrainSelectedInstOperands,
     /*  54584 */     // GIR_Coverage, 14757,
     /*  54584 */     GIR_EraseRootFromParent_Done,
     /*  54585 */   // Label 921: @54585
     /*  54585 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(54640), // Rule ID 7326 //
     /*  54590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54627 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54638 */     GIR_RootConstrainSelectedInstOperands,
     /*  54639 */     // GIR_Coverage, 7326,
     /*  54639 */     GIR_EraseRootFromParent_Done,
     /*  54640 */   // Label 922: @54640
     /*  54640 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(54695), // Rule ID 7327 //
     /*  54645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54682 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54693 */     GIR_RootConstrainSelectedInstOperands,
     /*  54694 */     // GIR_Coverage, 7327,
     /*  54694 */     GIR_EraseRootFromParent_Done,
     /*  54695 */   // Label 923: @54695
     /*  54695 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(54710), // Rule ID 3132 //
     /*  54700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54703 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  54708 */     GIR_RootConstrainSelectedInstOperands,
     /*  54709 */     // GIR_Coverage, 3132,
     /*  54709 */     GIR_Done,
     /*  54710 */   // Label 924: @54710
     /*  54710 */   GIM_Reject,
     /*  54711 */ // Label 915: @54711
     /*  54711 */ GIM_Reject,
     /*  54712 */ // Label 826: @54712
     /*  54712 */ GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(55252),
     /*  54717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  54727 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(54784), // Rule ID 14807 //
     /*  54732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54769 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54782 */     GIR_RootConstrainSelectedInstOperands,
     /*  54783 */     // GIR_Coverage, 14807,
     /*  54783 */     GIR_EraseRootFromParent_Done,
     /*  54784 */   // Label 926: @54784
     /*  54784 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(54841), // Rule ID 14810 //
     /*  54789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54826 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54839 */     GIR_RootConstrainSelectedInstOperands,
     /*  54840 */     // GIR_Coverage, 14810,
     /*  54840 */     GIR_EraseRootFromParent_Done,
     /*  54841 */   // Label 927: @54841
     /*  54841 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(54898), // Rule ID 14806 //
     /*  54846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54877 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54883 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54896 */     GIR_RootConstrainSelectedInstOperands,
     /*  54897 */     // GIR_Coverage, 14806,
     /*  54897 */     GIR_EraseRootFromParent_Done,
     /*  54898 */   // Label 928: @54898
     /*  54898 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(54955), // Rule ID 14809 //
     /*  54903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54940 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54953 */     GIR_RootConstrainSelectedInstOperands,
     /*  54954 */     // GIR_Coverage, 14809,
     /*  54954 */     GIR_EraseRootFromParent_Done,
     /*  54955 */   // Label 929: @54955
     /*  54955 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(55012), // Rule ID 14805 //
     /*  54960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54997 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55010 */     GIR_RootConstrainSelectedInstOperands,
     /*  55011 */     // GIR_Coverage, 14805,
     /*  55011 */     GIR_EraseRootFromParent_Done,
     /*  55012 */   // Label 930: @55012
     /*  55012 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(55069), // Rule ID 14808 //
     /*  55017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55048 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55054 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55067 */     GIR_RootConstrainSelectedInstOperands,
     /*  55068 */     // GIR_Coverage, 14808,
     /*  55068 */     GIR_EraseRootFromParent_Done,
     /*  55069 */   // Label 931: @55069
     /*  55069 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(55126), // Rule ID 8269 //
     /*  55074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55105 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55111 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55124 */     GIR_RootConstrainSelectedInstOperands,
     /*  55125 */     // GIR_Coverage, 8269,
     /*  55125 */     GIR_EraseRootFromParent_Done,
     /*  55126 */   // Label 932: @55126
     /*  55126 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(55183), // Rule ID 8270 //
     /*  55131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55162 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55168 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55181 */     GIR_RootConstrainSelectedInstOperands,
     /*  55182 */     // GIR_Coverage, 8270,
     /*  55182 */     GIR_EraseRootFromParent_Done,
     /*  55183 */   // Label 933: @55183
     /*  55183 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(55230), // Rule ID 10527 //
     /*  55188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55199 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  55199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  55202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  55206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  55214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  55226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  55228 */     GIR_RootConstrainSelectedInstOperands,
     /*  55229 */     // GIR_Coverage, 10527,
     /*  55229 */     GIR_EraseRootFromParent_Done,
     /*  55230 */   // Label 934: @55230
     /*  55230 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(55251), // Rule ID 2737 //
     /*  55235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55238 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  55249 */     GIR_RootConstrainSelectedInstOperands,
     /*  55250 */     // GIR_Coverage, 2737,
     /*  55250 */     GIR_EraseRootFromParent_Done,
     /*  55251 */   // Label 935: @55251
     /*  55251 */   GIM_Reject,
     /*  55252 */ // Label 925: @55252
     /*  55252 */ GIM_Reject,
     /*  55253 */ // Label 827: @55253
     /*  55253 */ GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(55724),
     /*  55258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  55268 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(55323), // Rule ID 14747 //
     /*  55273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55304 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55310 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55321 */     GIR_RootConstrainSelectedInstOperands,
     /*  55322 */     // GIR_Coverage, 14747,
     /*  55322 */     GIR_EraseRootFromParent_Done,
     /*  55323 */   // Label 937: @55323
     /*  55323 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(55378), // Rule ID 14750 //
     /*  55328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55365 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55376 */     GIR_RootConstrainSelectedInstOperands,
     /*  55377 */     // GIR_Coverage, 14750,
     /*  55377 */     GIR_EraseRootFromParent_Done,
     /*  55378 */   // Label 938: @55378
     /*  55378 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(55433), // Rule ID 14746 //
     /*  55383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55420 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55431 */     GIR_RootConstrainSelectedInstOperands,
     /*  55432 */     // GIR_Coverage, 14746,
     /*  55432 */     GIR_EraseRootFromParent_Done,
     /*  55433 */   // Label 939: @55433
     /*  55433 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(55488), // Rule ID 14749 //
     /*  55438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55475 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55486 */     GIR_RootConstrainSelectedInstOperands,
     /*  55487 */     // GIR_Coverage, 14749,
     /*  55487 */     GIR_EraseRootFromParent_Done,
     /*  55488 */   // Label 940: @55488
     /*  55488 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(55543), // Rule ID 14745 //
     /*  55493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55530 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55541 */     GIR_RootConstrainSelectedInstOperands,
     /*  55542 */     // GIR_Coverage, 14745,
     /*  55542 */     GIR_EraseRootFromParent_Done,
     /*  55543 */   // Label 941: @55543
     /*  55543 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(55598), // Rule ID 14748 //
     /*  55548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55579 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55585 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55596 */     GIR_RootConstrainSelectedInstOperands,
     /*  55597 */     // GIR_Coverage, 14748,
     /*  55597 */     GIR_EraseRootFromParent_Done,
     /*  55598 */   // Label 942: @55598
     /*  55598 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(55653), // Rule ID 7322 //
     /*  55603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55634 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55640 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55651 */     GIR_RootConstrainSelectedInstOperands,
     /*  55652 */     // GIR_Coverage, 7322,
     /*  55652 */     GIR_EraseRootFromParent_Done,
     /*  55653 */   // Label 943: @55653
     /*  55653 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(55708), // Rule ID 7323 //
     /*  55658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55695 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55706 */     GIR_RootConstrainSelectedInstOperands,
     /*  55707 */     // GIR_Coverage, 7323,
     /*  55707 */     GIR_EraseRootFromParent_Done,
     /*  55708 */   // Label 944: @55708
     /*  55708 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(55723), // Rule ID 3131 //
     /*  55713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55716 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  55721 */     GIR_RootConstrainSelectedInstOperands,
     /*  55722 */     // GIR_Coverage, 3131,
     /*  55722 */     GIR_Done,
     /*  55723 */   // Label 945: @55723
     /*  55723 */   GIM_Reject,
     /*  55724 */ // Label 936: @55724
     /*  55724 */ GIM_Reject,
     /*  55725 */ // Label 828: @55725
     /*  55725 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(56265),
     /*  55730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55740 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(55797), // Rule ID 14798 //
     /*  55745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55776 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55782 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55795 */     GIR_RootConstrainSelectedInstOperands,
     /*  55796 */     // GIR_Coverage, 14798,
     /*  55796 */     GIR_EraseRootFromParent_Done,
     /*  55797 */   // Label 947: @55797
     /*  55797 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(55854), // Rule ID 14801 //
     /*  55802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55833 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55839 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55852 */     GIR_RootConstrainSelectedInstOperands,
     /*  55853 */     // GIR_Coverage, 14801,
     /*  55853 */     GIR_EraseRootFromParent_Done,
     /*  55854 */   // Label 948: @55854
     /*  55854 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(55911), // Rule ID 14797 //
     /*  55859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55890 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55896 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55909 */     GIR_RootConstrainSelectedInstOperands,
     /*  55910 */     // GIR_Coverage, 14797,
     /*  55910 */     GIR_EraseRootFromParent_Done,
     /*  55911 */   // Label 949: @55911
     /*  55911 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(55968), // Rule ID 14800 //
     /*  55916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55953 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55966 */     GIR_RootConstrainSelectedInstOperands,
     /*  55967 */     // GIR_Coverage, 14800,
     /*  55967 */     GIR_EraseRootFromParent_Done,
     /*  55968 */   // Label 950: @55968
     /*  55968 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(56025), // Rule ID 14796 //
     /*  55973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56010 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56023 */     GIR_RootConstrainSelectedInstOperands,
     /*  56024 */     // GIR_Coverage, 14796,
     /*  56024 */     GIR_EraseRootFromParent_Done,
     /*  56025 */   // Label 951: @56025
     /*  56025 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(56082), // Rule ID 14799 //
     /*  56030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56067 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56080 */     GIR_RootConstrainSelectedInstOperands,
     /*  56081 */     // GIR_Coverage, 14799,
     /*  56081 */     GIR_EraseRootFromParent_Done,
     /*  56082 */   // Label 952: @56082
     /*  56082 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(56139), // Rule ID 8265 //
     /*  56087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56118 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56124 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56137 */     GIR_RootConstrainSelectedInstOperands,
     /*  56138 */     // GIR_Coverage, 8265,
     /*  56138 */     GIR_EraseRootFromParent_Done,
     /*  56139 */   // Label 953: @56139
     /*  56139 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(56196), // Rule ID 8266 //
     /*  56144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56181 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56194 */     GIR_RootConstrainSelectedInstOperands,
     /*  56195 */     // GIR_Coverage, 8266,
     /*  56195 */     GIR_EraseRootFromParent_Done,
     /*  56196 */   // Label 954: @56196
     /*  56196 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(56243), // Rule ID 10526 //
     /*  56201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56212 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  56212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  56219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56224 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56241 */     GIR_RootConstrainSelectedInstOperands,
     /*  56242 */     // GIR_Coverage, 10526,
     /*  56242 */     GIR_EraseRootFromParent_Done,
     /*  56243 */   // Label 955: @56243
     /*  56243 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(56264), // Rule ID 2736 //
     /*  56248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56251 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56262 */     GIR_RootConstrainSelectedInstOperands,
     /*  56263 */     // GIR_Coverage, 2736,
     /*  56263 */     GIR_EraseRootFromParent_Done,
     /*  56264 */   // Label 956: @56264
     /*  56264 */   GIM_Reject,
     /*  56265 */ // Label 946: @56265
     /*  56265 */ GIM_Reject,
     /*  56266 */ // Label 829: @56266
     /*  56266 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(56737),
     /*  56271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56281 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(56336), // Rule ID 14738 //
     /*  56286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56323 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56334 */     GIR_RootConstrainSelectedInstOperands,
     /*  56335 */     // GIR_Coverage, 14738,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 958: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(56391), // Rule ID 14741 //
     /*  56341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56372 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56378 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56389 */     GIR_RootConstrainSelectedInstOperands,
     /*  56390 */     // GIR_Coverage, 14741,
     /*  56390 */     GIR_EraseRootFromParent_Done,
     /*  56391 */   // Label 959: @56391
     /*  56391 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(56446), // Rule ID 14737 //
     /*  56396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56433 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56444 */     GIR_RootConstrainSelectedInstOperands,
     /*  56445 */     // GIR_Coverage, 14737,
     /*  56445 */     GIR_EraseRootFromParent_Done,
     /*  56446 */   // Label 960: @56446
     /*  56446 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(56501), // Rule ID 14740 //
     /*  56451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56488 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56499 */     GIR_RootConstrainSelectedInstOperands,
     /*  56500 */     // GIR_Coverage, 14740,
     /*  56500 */     GIR_EraseRootFromParent_Done,
     /*  56501 */   // Label 961: @56501
     /*  56501 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(56556), // Rule ID 14736 //
     /*  56506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56543 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56554 */     GIR_RootConstrainSelectedInstOperands,
     /*  56555 */     // GIR_Coverage, 14736,
     /*  56555 */     GIR_EraseRootFromParent_Done,
     /*  56556 */   // Label 962: @56556
     /*  56556 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(56611), // Rule ID 14739 //
     /*  56561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56598 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56609 */     GIR_RootConstrainSelectedInstOperands,
     /*  56610 */     // GIR_Coverage, 14739,
     /*  56610 */     GIR_EraseRootFromParent_Done,
     /*  56611 */   // Label 963: @56611
     /*  56611 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(56666), // Rule ID 7318 //
     /*  56616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56653 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56664 */     GIR_RootConstrainSelectedInstOperands,
     /*  56665 */     // GIR_Coverage, 7318,
     /*  56665 */     GIR_EraseRootFromParent_Done,
     /*  56666 */   // Label 964: @56666
     /*  56666 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(56721), // Rule ID 7319 //
     /*  56671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56708 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56719 */     GIR_RootConstrainSelectedInstOperands,
     /*  56720 */     // GIR_Coverage, 7319,
     /*  56720 */     GIR_EraseRootFromParent_Done,
     /*  56721 */   // Label 965: @56721
     /*  56721 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(56736), // Rule ID 3130 //
     /*  56726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56729 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  56734 */     GIR_RootConstrainSelectedInstOperands,
     /*  56735 */     // GIR_Coverage, 3130,
     /*  56735 */     GIR_Done,
     /*  56736 */   // Label 966: @56736
     /*  56736 */   GIM_Reject,
     /*  56737 */ // Label 957: @56737
     /*  56737 */ GIM_Reject,
     /*  56738 */ // Label 830: @56738
     /*  56738 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(57278),
     /*  56743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56753 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56810), // Rule ID 14789 //
     /*  56758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56789 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56795 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56808 */     GIR_RootConstrainSelectedInstOperands,
     /*  56809 */     // GIR_Coverage, 14789,
     /*  56809 */     GIR_EraseRootFromParent_Done,
     /*  56810 */   // Label 968: @56810
     /*  56810 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56867), // Rule ID 14792 //
     /*  56815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56852 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56865 */     GIR_RootConstrainSelectedInstOperands,
     /*  56866 */     // GIR_Coverage, 14792,
     /*  56866 */     GIR_EraseRootFromParent_Done,
     /*  56867 */   // Label 969: @56867
     /*  56867 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(56924), // Rule ID 14788 //
     /*  56872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56903 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56909 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56922 */     GIR_RootConstrainSelectedInstOperands,
     /*  56923 */     // GIR_Coverage, 14788,
     /*  56923 */     GIR_EraseRootFromParent_Done,
     /*  56924 */   // Label 970: @56924
     /*  56924 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56981), // Rule ID 14791 //
     /*  56929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56966 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56979 */     GIR_RootConstrainSelectedInstOperands,
     /*  56980 */     // GIR_Coverage, 14791,
     /*  56980 */     GIR_EraseRootFromParent_Done,
     /*  56981 */   // Label 971: @56981
     /*  56981 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(57038), // Rule ID 14787 //
     /*  56986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57023 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57036 */     GIR_RootConstrainSelectedInstOperands,
     /*  57037 */     // GIR_Coverage, 14787,
     /*  57037 */     GIR_EraseRootFromParent_Done,
     /*  57038 */   // Label 972: @57038
     /*  57038 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(57095), // Rule ID 14790 //
     /*  57043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57080 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57093 */     GIR_RootConstrainSelectedInstOperands,
     /*  57094 */     // GIR_Coverage, 14790,
     /*  57094 */     GIR_EraseRootFromParent_Done,
     /*  57095 */   // Label 973: @57095
     /*  57095 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(57152), // Rule ID 8261 //
     /*  57100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57137 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57150 */     GIR_RootConstrainSelectedInstOperands,
     /*  57151 */     // GIR_Coverage, 8261,
     /*  57151 */     GIR_EraseRootFromParent_Done,
     /*  57152 */   // Label 974: @57152
     /*  57152 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(57209), // Rule ID 8262 //
     /*  57157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57194 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57207 */     GIR_RootConstrainSelectedInstOperands,
     /*  57208 */     // GIR_Coverage, 8262,
     /*  57208 */     GIR_EraseRootFromParent_Done,
     /*  57209 */   // Label 975: @57209
     /*  57209 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(57256), // Rule ID 10525 //
     /*  57214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57225 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  57225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  57232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57254 */     GIR_RootConstrainSelectedInstOperands,
     /*  57255 */     // GIR_Coverage, 10525,
     /*  57255 */     GIR_EraseRootFromParent_Done,
     /*  57256 */   // Label 976: @57256
     /*  57256 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(57277), // Rule ID 2735 //
     /*  57261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57264 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57275 */     GIR_RootConstrainSelectedInstOperands,
     /*  57276 */     // GIR_Coverage, 2735,
     /*  57276 */     GIR_EraseRootFromParent_Done,
     /*  57277 */   // Label 977: @57277
     /*  57277 */   GIM_Reject,
     /*  57278 */ // Label 967: @57278
     /*  57278 */ GIM_Reject,
     /*  57279 */ // Label 831: @57279
     /*  57279 */ GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57750),
     /*  57284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57294 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57349), // Rule ID 14729 //
     /*  57299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57336 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57347 */     GIR_RootConstrainSelectedInstOperands,
     /*  57348 */     // GIR_Coverage, 14729,
     /*  57348 */     GIR_EraseRootFromParent_Done,
     /*  57349 */   // Label 979: @57349
     /*  57349 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57404), // Rule ID 14732 //
     /*  57354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57391 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57402 */     GIR_RootConstrainSelectedInstOperands,
     /*  57403 */     // GIR_Coverage, 14732,
     /*  57403 */     GIR_EraseRootFromParent_Done,
     /*  57404 */   // Label 980: @57404
     /*  57404 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(57459), // Rule ID 14728 //
     /*  57409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57446 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57457 */     GIR_RootConstrainSelectedInstOperands,
     /*  57458 */     // GIR_Coverage, 14728,
     /*  57458 */     GIR_EraseRootFromParent_Done,
     /*  57459 */   // Label 981: @57459
     /*  57459 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57514), // Rule ID 14731 //
     /*  57464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57501 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57512 */     GIR_RootConstrainSelectedInstOperands,
     /*  57513 */     // GIR_Coverage, 14731,
     /*  57513 */     GIR_EraseRootFromParent_Done,
     /*  57514 */   // Label 982: @57514
     /*  57514 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57569), // Rule ID 14727 //
     /*  57519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57550 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57556 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57567 */     GIR_RootConstrainSelectedInstOperands,
     /*  57568 */     // GIR_Coverage, 14727,
     /*  57568 */     GIR_EraseRootFromParent_Done,
     /*  57569 */   // Label 983: @57569
     /*  57569 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57624), // Rule ID 14730 //
     /*  57574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57611 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57622 */     GIR_RootConstrainSelectedInstOperands,
     /*  57623 */     // GIR_Coverage, 14730,
     /*  57623 */     GIR_EraseRootFromParent_Done,
     /*  57624 */   // Label 984: @57624
     /*  57624 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57679), // Rule ID 7314 //
     /*  57629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57660 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57666 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57677 */     GIR_RootConstrainSelectedInstOperands,
     /*  57678 */     // GIR_Coverage, 7314,
     /*  57678 */     GIR_EraseRootFromParent_Done,
     /*  57679 */   // Label 985: @57679
     /*  57679 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57734), // Rule ID 7315 //
     /*  57684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57715 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57721 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57732 */     GIR_RootConstrainSelectedInstOperands,
     /*  57733 */     // GIR_Coverage, 7315,
     /*  57733 */     GIR_EraseRootFromParent_Done,
     /*  57734 */   // Label 986: @57734
     /*  57734 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57749), // Rule ID 3129 //
     /*  57739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57742 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57747 */     GIR_RootConstrainSelectedInstOperands,
     /*  57748 */     // GIR_Coverage, 3129,
     /*  57748 */     GIR_Done,
     /*  57749 */   // Label 987: @57749
     /*  57749 */   GIM_Reject,
     /*  57750 */ // Label 978: @57750
     /*  57750 */ GIM_Reject,
     /*  57751 */ // Label 832: @57751
     /*  57751 */ GIM_Reject,
     /*  57752 */ // Label 6: @57752
     /*  57752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1006*/ GIMT_Encode4(69798),
     /*  57763 */ /*GILLT_s32*//*Label 988*/ GIMT_Encode4(57851),
     /*  57767 */ /*GILLT_s64*//*Label 989*/ GIMT_Encode4(58211), GIMT_Encode4(0),
     /*  57775 */ /*GILLT_v2s32*//*Label 990*/ GIMT_Encode4(60378),
     /*  57779 */ /*GILLT_v2s64*//*Label 991*/ GIMT_Encode4(61686),
     /*  57783 */ /*GILLT_v4s16*//*Label 992*/ GIMT_Encode4(62994),
     /*  57787 */ /*GILLT_v4s32*//*Label 993*/ GIMT_Encode4(64302),
     /*  57791 */ /*GILLT_v8s8*//*Label 994*/ GIMT_Encode4(65610),
     /*  57795 */ /*GILLT_v8s16*//*Label 995*/ GIMT_Encode4(66918),
     /*  57799 */ /*GILLT_v16s8*//*Label 996*/ GIMT_Encode4(68226),
     /*  57803 */ /*GILLT_nxv1s1*//*Label 997*/ GIMT_Encode4(69534),
     /*  57807 */ /*GILLT_nxv2s1*//*Label 998*/ GIMT_Encode4(69566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  57819 */ /*GILLT_nxv2s64*//*Label 999*/ GIMT_Encode4(69598),
     /*  57823 */ /*GILLT_nxv4s1*//*Label 1000*/ GIMT_Encode4(69624), GIMT_Encode4(0),
     /*  57831 */ /*GILLT_nxv4s32*//*Label 1001*/ GIMT_Encode4(69656),
     /*  57835 */ /*GILLT_nxv8s1*//*Label 1002*/ GIMT_Encode4(69682),
     /*  57839 */ /*GILLT_nxv8s16*//*Label 1003*/ GIMT_Encode4(69714),
     /*  57843 */ /*GILLT_nxv16s1*//*Label 1004*/ GIMT_Encode4(69740),
     /*  57847 */ /*GILLT_nxv16s8*//*Label 1005*/ GIMT_Encode4(69772),
     /*  57851 */ // Label 988: @57851
     /*  57851 */ GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(58210),
     /*  57856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57862 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(57917), // Rule ID 12992 //
     /*  57867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57904 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57915 */     GIR_RootConstrainSelectedInstOperands,
     /*  57916 */     // GIR_Coverage, 12992,
     /*  57916 */     GIR_EraseRootFromParent_Done,
     /*  57917 */   // Label 1008: @57917
     /*  57917 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(57972), // Rule ID 174 //
     /*  57922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57959 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57970 */     GIR_RootConstrainSelectedInstOperands,
     /*  57971 */     // GIR_Coverage, 174,
     /*  57971 */     GIR_EraseRootFromParent_Done,
     /*  57972 */   // Label 1009: @57972
     /*  57972 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(58013), // Rule ID 146 //
     /*  57977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  57981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57993 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  57997 */     // MIs[1] Operand 1
     /*  57997 */     // No operand predicates
     /*  57997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57999 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  57999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  58002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58006 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  58011 */     GIR_RootConstrainSelectedInstOperands,
     /*  58012 */     // GIR_Coverage, 146,
     /*  58012 */     GIR_EraseRootFromParent_Done,
     /*  58013 */   // Label 1010: @58013
     /*  58013 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(58046), // Rule ID 12994 //
     /*  58018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58033 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58044 */     GIR_RootConstrainSelectedInstOperands,
     /*  58045 */     // GIR_Coverage, 12994,
     /*  58045 */     GIR_EraseRootFromParent_Done,
     /*  58046 */   // Label 1011: @58046
     /*  58046 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(58079), // Rule ID 178 //
     /*  58051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58066 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 178,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 1012: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(58132), // Rule ID 12990 //
     /*  58084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58119 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58130 */     GIR_RootConstrainSelectedInstOperands,
     /*  58131 */     // GIR_Coverage, 12990,
     /*  58131 */     GIR_EraseRootFromParent_Done,
     /*  58132 */   // Label 1013: @58132
     /*  58132 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(58185), // Rule ID 172 //
     /*  58137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58172 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58183 */     GIR_RootConstrainSelectedInstOperands,
     /*  58184 */     // GIR_Coverage, 172,
     /*  58184 */     GIR_EraseRootFromParent_Done,
     /*  58185 */   // Label 1014: @58185
     /*  58185 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(58209), // Rule ID 176 //
     /*  58190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58202 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  58207 */     GIR_RootConstrainSelectedInstOperands,
     /*  58208 */     // GIR_Coverage, 176,
     /*  58208 */     GIR_Done,
     /*  58209 */   // Label 1015: @58209
     /*  58209 */   GIM_Reject,
     /*  58210 */ // Label 1007: @58210
     /*  58210 */ GIM_Reject,
     /*  58211 */ // Label 989: @58211
     /*  58211 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(60377),
     /*  58216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58222 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(58344), // Rule ID 3959 //
     /*  58227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58272 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58307 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58311 */     // MIs[4] Rn
     /*  58311 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58316 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58320 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58331 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58333 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58342 */     GIR_RootConstrainSelectedInstOperands,
     /*  58343 */     // GIR_Coverage, 3959,
     /*  58343 */     GIR_EraseRootFromParent_Done,
     /*  58344 */   // Label 1017: @58344
     /*  58344 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(58466), // Rule ID 13542 //
     /*  58349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58394 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58429 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58433 */     // MIs[4] Rn
     /*  58433 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58438 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58442 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58455 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58464 */     GIR_RootConstrainSelectedInstOperands,
     /*  58465 */     // GIR_Coverage, 13542,
     /*  58465 */     GIR_EraseRootFromParent_Done,
     /*  58466 */   // Label 1018: @58466
     /*  58466 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(58521), // Rule ID 12993 //
     /*  58471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58508 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58519 */     GIR_RootConstrainSelectedInstOperands,
     /*  58520 */     // GIR_Coverage, 12993,
     /*  58520 */     GIR_EraseRootFromParent_Done,
     /*  58521 */   // Label 1019: @58521
     /*  58521 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(58576), // Rule ID 175 //
     /*  58526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58563 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58574 */     GIR_RootConstrainSelectedInstOperands,
     /*  58575 */     // GIR_Coverage, 175,
     /*  58575 */     GIR_EraseRootFromParent_Done,
     /*  58576 */   // Label 1020: @58576
     /*  58576 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(58685), // Rule ID 13342 //
     /*  58581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58654 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58659 */     // MIs[4] LHS
     /*  58659 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58666 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58683 */     GIR_RootConstrainSelectedInstOperands,
     /*  58684 */     // GIR_Coverage, 13342,
     /*  58684 */     GIR_EraseRootFromParent_Done,
     /*  58685 */   // Label 1021: @58685
     /*  58685 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(58794), // Rule ID 13341 //
     /*  58690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58738 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58755 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58759 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58763 */     // MIs[4] LHS
     /*  58763 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58768 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58775 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  58788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58792 */     GIR_RootConstrainSelectedInstOperands,
     /*  58793 */     // GIR_Coverage, 13341,
     /*  58793 */     GIR_EraseRootFromParent_Done,
     /*  58794 */   // Label 1022: @58794
     /*  58794 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(58903), // Rule ID 13344 //
     /*  58799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58852 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58872 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58877 */     // MIs[4] LHS
     /*  58877 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58884 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  58901 */     GIR_RootConstrainSelectedInstOperands,
     /*  58902 */     // GIR_Coverage, 13344,
     /*  58902 */     GIR_EraseRootFromParent_Done,
     /*  58903 */   // Label 1023: @58903
     /*  58903 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(59012), // Rule ID 13343 //
     /*  58908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58981 */     // MIs[4] LHS
     /*  58981 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58986 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58993 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  59002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  59006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  59010 */     GIR_RootConstrainSelectedInstOperands,
     /*  59011 */     // GIR_Coverage, 13343,
     /*  59011 */     GIR_EraseRootFromParent_Done,
     /*  59012 */   // Label 1024: @59012
     /*  59012 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(59121), // Rule ID 2462 //
     /*  59017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59078 */     // MIs[3] LHS
     /*  59078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59087 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59102 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59119 */     GIR_RootConstrainSelectedInstOperands,
     /*  59120 */     // GIR_Coverage, 2462,
     /*  59120 */     GIR_EraseRootFromParent_Done,
     /*  59121 */   // Label 1025: @59121
     /*  59121 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(59230), // Rule ID 13339 //
     /*  59126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59187 */     // MIs[3] LHS
     /*  59187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59196 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59202 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59211 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59228 */     GIR_RootConstrainSelectedInstOperands,
     /*  59229 */     // GIR_Coverage, 13339,
     /*  59229 */     GIR_EraseRootFromParent_Done,
     /*  59230 */   // Label 1026: @59230
     /*  59230 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(59339), // Rule ID 13338 //
     /*  59235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59301 */     // MIs[3] LHS
     /*  59301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59320 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59337 */     GIR_RootConstrainSelectedInstOperands,
     /*  59338 */     // GIR_Coverage, 13338,
     /*  59338 */     GIR_EraseRootFromParent_Done,
     /*  59339 */   // Label 1027: @59339
     /*  59339 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(59448), // Rule ID 13340 //
     /*  59344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59410 */     // MIs[3] LHS
     /*  59410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59419 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59427 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59429 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59446 */     GIR_RootConstrainSelectedInstOperands,
     /*  59447 */     // GIR_Coverage, 13340,
     /*  59447 */     GIR_EraseRootFromParent_Done,
     /*  59448 */   // Label 1028: @59448
     /*  59448 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(59489), // Rule ID 147 //
     /*  59453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  59457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59469 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  59473 */     // MIs[1] Operand 1
     /*  59473 */     // No operand predicates
     /*  59473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59475 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  59475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  59478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59482 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  59487 */     GIR_RootConstrainSelectedInstOperands,
     /*  59488 */     // GIR_Coverage, 147,
     /*  59488 */     GIR_EraseRootFromParent_Done,
     /*  59489 */   // Label 1029: @59489
     /*  59489 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(59522), // Rule ID 12995 //
     /*  59494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59509 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59520 */     GIR_RootConstrainSelectedInstOperands,
     /*  59521 */     // GIR_Coverage, 12995,
     /*  59521 */     GIR_EraseRootFromParent_Done,
     /*  59522 */   // Label 1030: @59522
     /*  59522 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(59555), // Rule ID 179 //
     /*  59527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59542 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 179,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 1031: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(59622), // Rule ID 13278 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59584 */     // MIs[1] imm
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59596 */     // MIs[2] Operand 1
     /*  59596 */     // No operand predicates
     /*  59596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59606 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59620 */     GIR_RootConstrainSelectedInstOperands,
     /*  59621 */     // GIR_Coverage, 13278,
     /*  59621 */     GIR_EraseRootFromParent_Done,
     /*  59622 */   // Label 1032: @59622
     /*  59622 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(59689), // Rule ID 13666 //
     /*  59627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59651 */     // MIs[1] imm
     /*  59651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59663 */     // MIs[2] Operand 1
     /*  59663 */     // No operand predicates
     /*  59663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59673 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59687 */     GIR_RootConstrainSelectedInstOperands,
     /*  59688 */     // GIR_Coverage, 13666,
     /*  59688 */     GIR_EraseRootFromParent_Done,
     /*  59689 */   // Label 1033: @59689
     /*  59689 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(59756), // Rule ID 13281 //
     /*  59694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59718 */     // MIs[1] imm
     /*  59718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59730 */     // MIs[2] Operand 1
     /*  59730 */     // No operand predicates
     /*  59730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59740 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 13281,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 1034: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(59823), // Rule ID 13669 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59785 */     // MIs[1] imm
     /*  59785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59797 */     // MIs[2] Operand 1
     /*  59797 */     // No operand predicates
     /*  59797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59807 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59821 */     GIR_RootConstrainSelectedInstOperands,
     /*  59822 */     // GIR_Coverage, 13669,
     /*  59822 */     GIR_EraseRootFromParent_Done,
     /*  59823 */   // Label 1035: @59823
     /*  59823 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(59876), // Rule ID 12991 //
     /*  59828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  59857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59863 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  59863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  59866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  59874 */     GIR_RootConstrainSelectedInstOperands,
     /*  59875 */     // GIR_Coverage, 12991,
     /*  59875 */     GIR_EraseRootFromParent_Done,
     /*  59876 */   // Label 1036: @59876
     /*  59876 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(59943), // Rule ID 2113 //
     /*  59881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59909 */     // MIs[1] imm
     /*  59909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59921 */     // MIs[2] Operand 1
     /*  59921 */     // No operand predicates
     /*  59921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59927 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  59934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59941 */     GIR_RootConstrainSelectedInstOperands,
     /*  59942 */     // GIR_Coverage, 2113,
     /*  59942 */     GIR_EraseRootFromParent_Done,
     /*  59943 */   // Label 1037: @59943
     /*  59943 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60010), // Rule ID 6198 //
     /*  59948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59976 */     // MIs[1] imm
     /*  59976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59988 */     // MIs[2] Operand 1
     /*  59988 */     // No operand predicates
     /*  59988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59994 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60008 */     GIR_RootConstrainSelectedInstOperands,
     /*  60009 */     // GIR_Coverage, 6198,
     /*  60009 */     GIR_EraseRootFromParent_Done,
     /*  60010 */   // Label 1038: @60010
     /*  60010 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60077), // Rule ID 2122 //
     /*  60015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60043 */     // MIs[1] imm
     /*  60043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60055 */     // MIs[2] Operand 1
     /*  60055 */     // No operand predicates
     /*  60055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60061 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  60061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60075 */     GIR_RootConstrainSelectedInstOperands,
     /*  60076 */     // GIR_Coverage, 2122,
     /*  60076 */     GIR_EraseRootFromParent_Done,
     /*  60077 */   // Label 1039: @60077
     /*  60077 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60144), // Rule ID 6204 //
     /*  60082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60110 */     // MIs[1] imm
     /*  60110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60122 */     // MIs[2] Operand 1
     /*  60122 */     // No operand predicates
     /*  60122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60128 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  60128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60142 */     GIR_RootConstrainSelectedInstOperands,
     /*  60143 */     // GIR_Coverage, 6204,
     /*  60143 */     GIR_EraseRootFromParent_Done,
     /*  60144 */   // Label 1040: @60144
     /*  60144 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(60197), // Rule ID 173 //
     /*  60149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60184 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  60187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60195 */     GIR_RootConstrainSelectedInstOperands,
     /*  60196 */     // GIR_Coverage, 173,
     /*  60196 */     GIR_EraseRootFromParent_Done,
     /*  60197 */   // Label 1041: @60197
     /*  60197 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(60261), // Rule ID 13630 //
     /*  60202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60248 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60253 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  60255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60259 */     GIR_RootConstrainSelectedInstOperands,
     /*  60260 */     // GIR_Coverage, 13630,
     /*  60260 */     GIR_EraseRootFromParent_Done,
     /*  60261 */   // Label 1042: @60261
     /*  60261 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(60325), // Rule ID 4993 //
     /*  60266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60302 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60312 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60317 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  60319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60323 */     GIR_RootConstrainSelectedInstOperands,
     /*  60324 */     // GIR_Coverage, 4993,
     /*  60324 */     GIR_EraseRootFromParent_Done,
     /*  60325 */   // Label 1043: @60325
     /*  60325 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(60349), // Rule ID 177 //
     /*  60330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60342 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  60347 */     GIR_RootConstrainSelectedInstOperands,
     /*  60348 */     // GIR_Coverage, 177,
     /*  60348 */     GIR_Done,
     /*  60349 */   // Label 1044: @60349
     /*  60349 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(60376), // Rule ID 4999 //
     /*  60354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60369 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  60374 */     GIR_RootConstrainSelectedInstOperands,
     /*  60375 */     // GIR_Coverage, 4999,
     /*  60375 */     GIR_Done,
     /*  60376 */   // Label 1045: @60376
     /*  60376 */   GIM_Reject,
     /*  60377 */ // Label 1016: @60377
     /*  60377 */ GIM_Reject,
     /*  60378 */ // Label 990: @60378
     /*  60378 */ GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61685),
     /*  60383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60389 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(60498), // Rule ID 13335 //
     /*  60394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60467 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60472 */     // MIs[4] LHS
     /*  60472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60477 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60479 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60496 */     GIR_RootConstrainSelectedInstOperands,
     /*  60497 */     // GIR_Coverage, 13335,
     /*  60497 */     GIR_EraseRootFromParent_Done,
     /*  60498 */   // Label 1047: @60498
     /*  60498 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(60607), // Rule ID 13334 //
     /*  60503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60572 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60576 */     // MIs[4] LHS
     /*  60576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60581 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60586 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60588 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60605 */     GIR_RootConstrainSelectedInstOperands,
     /*  60606 */     // GIR_Coverage, 13334,
     /*  60606 */     GIR_EraseRootFromParent_Done,
     /*  60607 */   // Label 1048: @60607
     /*  60607 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(60716), // Rule ID 13337 //
     /*  60612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60681 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60685 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60690 */     // MIs[4] LHS
     /*  60690 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60695 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60697 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 13337,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1049: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(60825), // Rule ID 13336 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60774 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60786 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60790 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60794 */     // MIs[4] LHS
     /*  60794 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60799 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60804 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60806 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60823 */     GIR_RootConstrainSelectedInstOperands,
     /*  60824 */     // GIR_Coverage, 13336,
     /*  60824 */     GIR_EraseRootFromParent_Done,
     /*  60825 */   // Label 1050: @60825
     /*  60825 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(60934), // Rule ID 2461 //
     /*  60830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60887 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60891 */     // MIs[3] LHS
     /*  60891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  60896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  60900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  60908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60915 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  60924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  60928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  60932 */     GIR_RootConstrainSelectedInstOperands,
     /*  60933 */     // GIR_Coverage, 2461,
     /*  60933 */     GIR_EraseRootFromParent_Done,
     /*  60934 */   // Label 1051: @60934
     /*  60934 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61043), // Rule ID 13332 //
     /*  60939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61000 */     // MIs[3] LHS
     /*  61000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61005 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61009 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61022 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61024 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61041 */     GIR_RootConstrainSelectedInstOperands,
     /*  61042 */     // GIR_Coverage, 13332,
     /*  61042 */     GIR_EraseRootFromParent_Done,
     /*  61043 */   // Label 1052: @61043
     /*  61043 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(61152), // Rule ID 13331 //
     /*  61048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61114 */     // MIs[3] LHS
     /*  61114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61123 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61131 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61133 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61150 */     GIR_RootConstrainSelectedInstOperands,
     /*  61151 */     // GIR_Coverage, 13331,
     /*  61151 */     GIR_EraseRootFromParent_Done,
     /*  61152 */   // Label 1053: @61152
     /*  61152 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(61261), // Rule ID 13333 //
     /*  61157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61223 */     // MIs[3] LHS
     /*  61223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61242 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61259 */     GIR_RootConstrainSelectedInstOperands,
     /*  61260 */     // GIR_Coverage, 13333,
     /*  61260 */     GIR_EraseRootFromParent_Done,
     /*  61261 */   // Label 1054: @61261
     /*  61261 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(61328), // Rule ID 13298 //
     /*  61266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61290 */     // MIs[1] imm
     /*  61290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61302 */     // MIs[2] Operand 1
     /*  61302 */     // No operand predicates
     /*  61302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61312 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61326 */     GIR_RootConstrainSelectedInstOperands,
     /*  61327 */     // GIR_Coverage, 13298,
     /*  61327 */     GIR_EraseRootFromParent_Done,
     /*  61328 */   // Label 1055: @61328
     /*  61328 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(61395), // Rule ID 13319 //
     /*  61333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61357 */     // MIs[1] imm
     /*  61357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61369 */     // MIs[2] Operand 1
     /*  61369 */     // No operand predicates
     /*  61369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61379 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61393 */     GIR_RootConstrainSelectedInstOperands,
     /*  61394 */     // GIR_Coverage, 13319,
     /*  61394 */     GIR_EraseRootFromParent_Done,
     /*  61395 */   // Label 1056: @61395
     /*  61395 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(61462), // Rule ID 2230 //
     /*  61400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61428 */     // MIs[1] imm
     /*  61428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61440 */     // MIs[2] Operand 1
     /*  61440 */     // No operand predicates
     /*  61440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61446 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61460 */     GIR_RootConstrainSelectedInstOperands,
     /*  61461 */     // GIR_Coverage, 2230,
     /*  61461 */     GIR_EraseRootFromParent_Done,
     /*  61462 */   // Label 1057: @61462
     /*  61462 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(61529), // Rule ID 2289 //
     /*  61467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61495 */     // MIs[1] imm
     /*  61495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61507 */     // MIs[2] Operand 1
     /*  61507 */     // No operand predicates
     /*  61507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61513 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61527 */     GIR_RootConstrainSelectedInstOperands,
     /*  61528 */     // GIR_Coverage, 2289,
     /*  61528 */     GIR_EraseRootFromParent_Done,
     /*  61529 */   // Label 1058: @61529
     /*  61529 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(61593), // Rule ID 13629 //
     /*  61534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61580 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  61587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61591 */     GIR_RootConstrainSelectedInstOperands,
     /*  61592 */     // GIR_Coverage, 13629,
     /*  61592 */     GIR_EraseRootFromParent_Done,
     /*  61593 */   // Label 1059: @61593
     /*  61593 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(61657), // Rule ID 4992 //
     /*  61598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61634 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  61651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61655 */     GIR_RootConstrainSelectedInstOperands,
     /*  61656 */     // GIR_Coverage, 4992,
     /*  61656 */     GIR_EraseRootFromParent_Done,
     /*  61657 */   // Label 1060: @61657
     /*  61657 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(61684), // Rule ID 4998 //
     /*  61662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61677 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  61682 */     GIR_RootConstrainSelectedInstOperands,
     /*  61683 */     // GIR_Coverage, 4998,
     /*  61683 */     GIR_Done,
     /*  61684 */   // Label 1061: @61684
     /*  61684 */   GIM_Reject,
     /*  61685 */ // Label 1046: @61685
     /*  61685 */ GIM_Reject,
     /*  61686 */ // Label 991: @61686
     /*  61686 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62993),
     /*  61691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61697 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(61806), // Rule ID 13363 //
     /*  61702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61750 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61767 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61771 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61775 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61780 */     // MIs[4] LHS
     /*  61780 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61785 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61787 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 13363,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 1063: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(61915), // Rule ID 13362 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61876 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61880 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61884 */     // MIs[4] LHS
     /*  61884 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61889 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61896 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61913 */     GIR_RootConstrainSelectedInstOperands,
     /*  61914 */     // GIR_Coverage, 13362,
     /*  61914 */     GIR_EraseRootFromParent_Done,
     /*  61915 */   // Label 1064: @61915
     /*  61915 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62024), // Rule ID 13365 //
     /*  61920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61973 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61981 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61985 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61989 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61993 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61998 */     // MIs[4] LHS
     /*  61998 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62003 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62005 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62022 */     GIR_RootConstrainSelectedInstOperands,
     /*  62023 */     // GIR_Coverage, 13365,
     /*  62023 */     GIR_EraseRootFromParent_Done,
     /*  62024 */   // Label 1065: @62024
     /*  62024 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62133), // Rule ID 13364 //
     /*  62029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62082 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62102 */     // MIs[4] LHS
     /*  62102 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62107 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62114 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62131 */     GIR_RootConstrainSelectedInstOperands,
     /*  62132 */     // GIR_Coverage, 13364,
     /*  62132 */     GIR_EraseRootFromParent_Done,
     /*  62133 */   // Label 1066: @62133
     /*  62133 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62242), // Rule ID 2465 //
     /*  62138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62195 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62199 */     // MIs[3] LHS
     /*  62199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62208 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62214 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62221 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62223 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62240 */     GIR_RootConstrainSelectedInstOperands,
     /*  62241 */     // GIR_Coverage, 2465,
     /*  62241 */     GIR_EraseRootFromParent_Done,
     /*  62242 */   // Label 1067: @62242
     /*  62242 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(62351), // Rule ID 13360 //
     /*  62247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62308 */     // MIs[3] LHS
     /*  62308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62317 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62332 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62349 */     GIR_RootConstrainSelectedInstOperands,
     /*  62350 */     // GIR_Coverage, 13360,
     /*  62350 */     GIR_EraseRootFromParent_Done,
     /*  62351 */   // Label 1068: @62351
     /*  62351 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(62460), // Rule ID 13359 //
     /*  62356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62422 */     // MIs[3] LHS
     /*  62422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62431 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62439 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62441 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62458 */     GIR_RootConstrainSelectedInstOperands,
     /*  62459 */     // GIR_Coverage, 13359,
     /*  62459 */     GIR_EraseRootFromParent_Done,
     /*  62460 */   // Label 1069: @62460
     /*  62460 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(62569), // Rule ID 13361 //
     /*  62465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62531 */     // MIs[3] LHS
     /*  62531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62540 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62548 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62550 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62567 */     GIR_RootConstrainSelectedInstOperands,
     /*  62568 */     // GIR_Coverage, 13361,
     /*  62568 */     GIR_EraseRootFromParent_Done,
     /*  62569 */   // Label 1070: @62569
     /*  62569 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(62636), // Rule ID 13302 //
     /*  62574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62598 */     // MIs[1] imm
     /*  62598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62610 */     // MIs[2] Operand 1
     /*  62610 */     // No operand predicates
     /*  62610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62620 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62634 */     GIR_RootConstrainSelectedInstOperands,
     /*  62635 */     // GIR_Coverage, 13302,
     /*  62635 */     GIR_EraseRootFromParent_Done,
     /*  62636 */   // Label 1071: @62636
     /*  62636 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(62703), // Rule ID 13323 //
     /*  62641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62665 */     // MIs[1] imm
     /*  62665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62677 */     // MIs[2] Operand 1
     /*  62677 */     // No operand predicates
     /*  62677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62687 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62701 */     GIR_RootConstrainSelectedInstOperands,
     /*  62702 */     // GIR_Coverage, 13323,
     /*  62702 */     GIR_EraseRootFromParent_Done,
     /*  62703 */   // Label 1072: @62703
     /*  62703 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(62770), // Rule ID 2234 //
     /*  62708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62736 */     // MIs[1] imm
     /*  62736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62748 */     // MIs[2] Operand 1
     /*  62748 */     // No operand predicates
     /*  62748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62754 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62768 */     GIR_RootConstrainSelectedInstOperands,
     /*  62769 */     // GIR_Coverage, 2234,
     /*  62769 */     GIR_EraseRootFromParent_Done,
     /*  62770 */   // Label 1073: @62770
     /*  62770 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(62837), // Rule ID 2293 //
     /*  62775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62803 */     // MIs[1] imm
     /*  62803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62815 */     // MIs[2] Operand 1
     /*  62815 */     // No operand predicates
     /*  62815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62821 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62835 */     GIR_RootConstrainSelectedInstOperands,
     /*  62836 */     // GIR_Coverage, 2293,
     /*  62836 */     GIR_EraseRootFromParent_Done,
     /*  62837 */   // Label 1074: @62837
     /*  62837 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(62901), // Rule ID 13633 //
     /*  62842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62874 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62888 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62893 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62899 */     GIR_RootConstrainSelectedInstOperands,
     /*  62900 */     // GIR_Coverage, 13633,
     /*  62900 */     GIR_EraseRootFromParent_Done,
     /*  62901 */   // Label 1075: @62901
     /*  62901 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(62965), // Rule ID 4996 //
     /*  62906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62952 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62963 */     GIR_RootConstrainSelectedInstOperands,
     /*  62964 */     // GIR_Coverage, 4996,
     /*  62964 */     GIR_EraseRootFromParent_Done,
     /*  62965 */   // Label 1076: @62965
     /*  62965 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(62992), // Rule ID 5002 //
     /*  62970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62985 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  62990 */     GIR_RootConstrainSelectedInstOperands,
     /*  62991 */     // GIR_Coverage, 5002,
     /*  62991 */     GIR_Done,
     /*  62992 */   // Label 1077: @62992
     /*  62992 */   GIM_Reject,
     /*  62993 */ // Label 1062: @62993
     /*  62993 */ GIM_Reject,
     /*  62994 */ // Label 992: @62994
     /*  62994 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64301),
     /*  62999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63005 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63114), // Rule ID 13328 //
     /*  63010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63058 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63064 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63079 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63083 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63088 */     // MIs[4] LHS
     /*  63088 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63093 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63095 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63112 */     GIR_RootConstrainSelectedInstOperands,
     /*  63113 */     // GIR_Coverage, 13328,
     /*  63113 */     GIR_EraseRootFromParent_Done,
     /*  63114 */   // Label 1079: @63114
     /*  63114 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63223), // Rule ID 13327 //
     /*  63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63167 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63184 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63192 */     // MIs[4] LHS
     /*  63192 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63197 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63202 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63204 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63221 */     GIR_RootConstrainSelectedInstOperands,
     /*  63222 */     // GIR_Coverage, 13327,
     /*  63222 */     GIR_EraseRootFromParent_Done,
     /*  63223 */   // Label 1080: @63223
     /*  63223 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(63332), // Rule ID 13330 //
     /*  63228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63297 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63301 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63306 */     // MIs[4] LHS
     /*  63306 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63311 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63313 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63330 */     GIR_RootConstrainSelectedInstOperands,
     /*  63331 */     // GIR_Coverage, 13330,
     /*  63331 */     GIR_EraseRootFromParent_Done,
     /*  63332 */   // Label 1081: @63332
     /*  63332 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(63441), // Rule ID 13329 //
     /*  63337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63390 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63406 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63410 */     // MIs[4] LHS
     /*  63410 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63415 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63422 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63439 */     GIR_RootConstrainSelectedInstOperands,
     /*  63440 */     // GIR_Coverage, 13329,
     /*  63440 */     GIR_EraseRootFromParent_Done,
     /*  63441 */   // Label 1082: @63441
     /*  63441 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(63550), // Rule ID 2460 //
     /*  63446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63507 */     // MIs[3] LHS
     /*  63507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63529 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63531 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63548 */     GIR_RootConstrainSelectedInstOperands,
     /*  63549 */     // GIR_Coverage, 2460,
     /*  63549 */     GIR_EraseRootFromParent_Done,
     /*  63550 */   // Label 1083: @63550
     /*  63550 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(63659), // Rule ID 13325 //
     /*  63555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63616 */     // MIs[3] LHS
     /*  63616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63621 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63625 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63638 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63640 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63657 */     GIR_RootConstrainSelectedInstOperands,
     /*  63658 */     // GIR_Coverage, 13325,
     /*  63658 */     GIR_EraseRootFromParent_Done,
     /*  63659 */   // Label 1084: @63659
     /*  63659 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(63768), // Rule ID 13324 //
     /*  63664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63730 */     // MIs[3] LHS
     /*  63730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63735 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63739 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63749 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63766 */     GIR_RootConstrainSelectedInstOperands,
     /*  63767 */     // GIR_Coverage, 13324,
     /*  63767 */     GIR_EraseRootFromParent_Done,
     /*  63768 */   // Label 1085: @63768
     /*  63768 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(63877), // Rule ID 13326 //
     /*  63773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63839 */     // MIs[3] LHS
     /*  63839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63848 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63858 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63875 */     GIR_RootConstrainSelectedInstOperands,
     /*  63876 */     // GIR_Coverage, 13326,
     /*  63876 */     GIR_EraseRootFromParent_Done,
     /*  63877 */   // Label 1086: @63877
     /*  63877 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(63944), // Rule ID 13294 //
     /*  63882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63906 */     // MIs[1] imm
     /*  63906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63918 */     // MIs[2] Operand 1
     /*  63918 */     // No operand predicates
     /*  63918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63928 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  63931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63942 */     GIR_RootConstrainSelectedInstOperands,
     /*  63943 */     // GIR_Coverage, 13294,
     /*  63943 */     GIR_EraseRootFromParent_Done,
     /*  63944 */   // Label 1087: @63944
     /*  63944 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64011), // Rule ID 13315 //
     /*  63949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63973 */     // MIs[1] imm
     /*  63973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63985 */     // MIs[2] Operand 1
     /*  63985 */     // No operand predicates
     /*  63985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63995 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  63998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64009 */     GIR_RootConstrainSelectedInstOperands,
     /*  64010 */     // GIR_Coverage, 13315,
     /*  64010 */     GIR_EraseRootFromParent_Done,
     /*  64011 */   // Label 1088: @64011
     /*  64011 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64078), // Rule ID 2226 //
     /*  64016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64044 */     // MIs[1] imm
     /*  64044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64056 */     // MIs[2] Operand 1
     /*  64056 */     // No operand predicates
     /*  64056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64062 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  64065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64076 */     GIR_RootConstrainSelectedInstOperands,
     /*  64077 */     // GIR_Coverage, 2226,
     /*  64077 */     GIR_EraseRootFromParent_Done,
     /*  64078 */   // Label 1089: @64078
     /*  64078 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64145), // Rule ID 2285 //
     /*  64083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64111 */     // MIs[1] imm
     /*  64111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64123 */     // MIs[2] Operand 1
     /*  64123 */     // No operand predicates
     /*  64123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64129 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  64132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64143 */     GIR_RootConstrainSelectedInstOperands,
     /*  64144 */     // GIR_Coverage, 2285,
     /*  64144 */     GIR_EraseRootFromParent_Done,
     /*  64145 */   // Label 1090: @64145
     /*  64145 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64209), // Rule ID 13628 //
     /*  64150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64182 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64196 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64201 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 13628,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 1091: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64273), // Rule ID 4991 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64250 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64260 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64265 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64271 */     GIR_RootConstrainSelectedInstOperands,
     /*  64272 */     // GIR_Coverage, 4991,
     /*  64272 */     GIR_EraseRootFromParent_Done,
     /*  64273 */   // Label 1092: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64300), // Rule ID 4997 //
     /*  64278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64293 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64298 */     GIR_RootConstrainSelectedInstOperands,
     /*  64299 */     // GIR_Coverage, 4997,
     /*  64299 */     GIR_Done,
     /*  64300 */   // Label 1093: @64300
     /*  64300 */   GIM_Reject,
     /*  64301 */ // Label 1078: @64301
     /*  64301 */ GIM_Reject,
     /*  64302 */ // Label 993: @64302
     /*  64302 */ GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65609),
     /*  64307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64313 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64422), // Rule ID 13356 //
     /*  64318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64366 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64372 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64383 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64387 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64391 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64396 */     // MIs[4] LHS
     /*  64396 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64403 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64420 */     GIR_RootConstrainSelectedInstOperands,
     /*  64421 */     // GIR_Coverage, 13356,
     /*  64421 */     GIR_EraseRootFromParent_Done,
     /*  64422 */   // Label 1095: @64422
     /*  64422 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64531), // Rule ID 13355 //
     /*  64427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64492 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64496 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64500 */     // MIs[4] LHS
     /*  64500 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64505 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64512 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64529 */     GIR_RootConstrainSelectedInstOperands,
     /*  64530 */     // GIR_Coverage, 13355,
     /*  64530 */     GIR_EraseRootFromParent_Done,
     /*  64531 */   // Label 1096: @64531
     /*  64531 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(64640), // Rule ID 13358 //
     /*  64536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64609 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64614 */     // MIs[4] LHS
     /*  64614 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64619 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64621 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64638 */     GIR_RootConstrainSelectedInstOperands,
     /*  64639 */     // GIR_Coverage, 13358,
     /*  64639 */     GIR_EraseRootFromParent_Done,
     /*  64640 */   // Label 1097: @64640
     /*  64640 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64749), // Rule ID 13357 //
     /*  64645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64698 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64710 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64718 */     // MIs[4] LHS
     /*  64718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64723 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64730 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64747 */     GIR_RootConstrainSelectedInstOperands,
     /*  64748 */     // GIR_Coverage, 13357,
     /*  64748 */     GIR_EraseRootFromParent_Done,
     /*  64749 */   // Label 1098: @64749
     /*  64749 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64858), // Rule ID 2464 //
     /*  64754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64811 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64815 */     // MIs[3] LHS
     /*  64815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64824 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64830 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64837 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64839 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64856 */     GIR_RootConstrainSelectedInstOperands,
     /*  64857 */     // GIR_Coverage, 2464,
     /*  64857 */     GIR_EraseRootFromParent_Done,
     /*  64858 */   // Label 1099: @64858
     /*  64858 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64967), // Rule ID 13353 //
     /*  64863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64924 */     // MIs[3] LHS
     /*  64924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64929 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64933 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64946 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64948 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64965 */     GIR_RootConstrainSelectedInstOperands,
     /*  64966 */     // GIR_Coverage, 13353,
     /*  64966 */     GIR_EraseRootFromParent_Done,
     /*  64967 */   // Label 1100: @64967
     /*  64967 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65076), // Rule ID 13352 //
     /*  64972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65038 */     // MIs[3] LHS
     /*  65038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65047 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65057 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65074 */     GIR_RootConstrainSelectedInstOperands,
     /*  65075 */     // GIR_Coverage, 13352,
     /*  65075 */     GIR_EraseRootFromParent_Done,
     /*  65076 */   // Label 1101: @65076
     /*  65076 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65185), // Rule ID 13354 //
     /*  65081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65147 */     // MIs[3] LHS
     /*  65147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65156 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65166 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65183 */     GIR_RootConstrainSelectedInstOperands,
     /*  65184 */     // GIR_Coverage, 13354,
     /*  65184 */     GIR_EraseRootFromParent_Done,
     /*  65185 */   // Label 1102: @65185
     /*  65185 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65252), // Rule ID 13300 //
     /*  65190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65214 */     // MIs[1] imm
     /*  65214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65226 */     // MIs[2] Operand 1
     /*  65226 */     // No operand predicates
     /*  65226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65236 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65250 */     GIR_RootConstrainSelectedInstOperands,
     /*  65251 */     // GIR_Coverage, 13300,
     /*  65251 */     GIR_EraseRootFromParent_Done,
     /*  65252 */   // Label 1103: @65252
     /*  65252 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65319), // Rule ID 13321 //
     /*  65257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65281 */     // MIs[1] imm
     /*  65281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65293 */     // MIs[2] Operand 1
     /*  65293 */     // No operand predicates
     /*  65293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65303 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65317 */     GIR_RootConstrainSelectedInstOperands,
     /*  65318 */     // GIR_Coverage, 13321,
     /*  65318 */     GIR_EraseRootFromParent_Done,
     /*  65319 */   // Label 1104: @65319
     /*  65319 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(65386), // Rule ID 2232 //
     /*  65324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65352 */     // MIs[1] imm
     /*  65352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65364 */     // MIs[2] Operand 1
     /*  65364 */     // No operand predicates
     /*  65364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65370 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65384 */     GIR_RootConstrainSelectedInstOperands,
     /*  65385 */     // GIR_Coverage, 2232,
     /*  65385 */     GIR_EraseRootFromParent_Done,
     /*  65386 */   // Label 1105: @65386
     /*  65386 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65453), // Rule ID 2291 //
     /*  65391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65419 */     // MIs[1] imm
     /*  65419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65431 */     // MIs[2] Operand 1
     /*  65431 */     // No operand predicates
     /*  65431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65437 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65451 */     GIR_RootConstrainSelectedInstOperands,
     /*  65452 */     // GIR_Coverage, 2291,
     /*  65452 */     GIR_EraseRootFromParent_Done,
     /*  65453 */   // Label 1106: @65453
     /*  65453 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(65517), // Rule ID 13632 //
     /*  65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65490 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65504 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65509 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65515 */     GIR_RootConstrainSelectedInstOperands,
     /*  65516 */     // GIR_Coverage, 13632,
     /*  65516 */     GIR_EraseRootFromParent_Done,
     /*  65517 */   // Label 1107: @65517
     /*  65517 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(65581), // Rule ID 4995 //
     /*  65522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65568 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65573 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65579 */     GIR_RootConstrainSelectedInstOperands,
     /*  65580 */     // GIR_Coverage, 4995,
     /*  65580 */     GIR_EraseRootFromParent_Done,
     /*  65581 */   // Label 1108: @65581
     /*  65581 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(65608), // Rule ID 5001 //
     /*  65586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65601 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65606 */     GIR_RootConstrainSelectedInstOperands,
     /*  65607 */     // GIR_Coverage, 5001,
     /*  65607 */     GIR_Done,
     /*  65608 */   // Label 1109: @65608
     /*  65608 */   GIM_Reject,
     /*  65609 */ // Label 1094: @65609
     /*  65609 */ GIM_Reject,
     /*  65610 */ // Label 994: @65610
     /*  65610 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66917),
     /*  65615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65621 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65730), // Rule ID 13116 //
     /*  65626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65674 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65680 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65704 */     // MIs[4] Rd
     /*  65704 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65709 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65711 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65728 */     GIR_RootConstrainSelectedInstOperands,
     /*  65729 */     // GIR_Coverage, 13116,
     /*  65729 */     GIR_EraseRootFromParent_Done,
     /*  65730 */   // Label 1111: @65730
     /*  65730 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65839), // Rule ID 13115 //
     /*  65735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65800 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65804 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65808 */     // MIs[4] Rd
     /*  65808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65813 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65818 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65820 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  65833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65837 */     GIR_RootConstrainSelectedInstOperands,
     /*  65838 */     // GIR_Coverage, 13115,
     /*  65838 */     GIR_EraseRootFromParent_Done,
     /*  65839 */   // Label 1112: @65839
     /*  65839 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(65948), // Rule ID 13118 //
     /*  65844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65897 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65913 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65922 */     // MIs[4] Rd
     /*  65922 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65929 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  65946 */     GIR_RootConstrainSelectedInstOperands,
     /*  65947 */     // GIR_Coverage, 13118,
     /*  65947 */     GIR_EraseRootFromParent_Done,
     /*  65948 */   // Label 1113: @65948
     /*  65948 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66057), // Rule ID 13117 //
     /*  65953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66006 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66026 */     // MIs[4] Rd
     /*  66026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66031 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66038 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  66047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  66051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66055 */     GIR_RootConstrainSelectedInstOperands,
     /*  66056 */     // GIR_Coverage, 13117,
     /*  66056 */     GIR_EraseRootFromParent_Done,
     /*  66057 */   // Label 1114: @66057
     /*  66057 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66166), // Rule ID 1598 //
     /*  66062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66123 */     // MIs[3] Rd
     /*  66123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66132 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66138 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66145 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66147 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66164 */     GIR_RootConstrainSelectedInstOperands,
     /*  66165 */     // GIR_Coverage, 1598,
     /*  66165 */     GIR_EraseRootFromParent_Done,
     /*  66166 */   // Label 1115: @66166
     /*  66166 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66275), // Rule ID 13113 //
     /*  66171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66232 */     // MIs[3] Rd
     /*  66232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66254 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66256 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66273 */     GIR_RootConstrainSelectedInstOperands,
     /*  66274 */     // GIR_Coverage, 13113,
     /*  66274 */     GIR_EraseRootFromParent_Done,
     /*  66275 */   // Label 1116: @66275
     /*  66275 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66384), // Rule ID 13112 //
     /*  66280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66346 */     // MIs[3] Rd
     /*  66346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66351 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66355 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66365 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66382 */     GIR_RootConstrainSelectedInstOperands,
     /*  66383 */     // GIR_Coverage, 13112,
     /*  66383 */     GIR_EraseRootFromParent_Done,
     /*  66384 */   // Label 1117: @66384
     /*  66384 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(66493), // Rule ID 13114 //
     /*  66389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66451 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66455 */     // MIs[3] Rd
     /*  66455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66464 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66470 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66474 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66491 */     GIR_RootConstrainSelectedInstOperands,
     /*  66492 */     // GIR_Coverage, 13114,
     /*  66492 */     GIR_EraseRootFromParent_Done,
     /*  66493 */   // Label 1118: @66493
     /*  66493 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(66560), // Rule ID 13290 //
     /*  66498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66522 */     // MIs[1] imm
     /*  66522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66534 */     // MIs[2] Operand 1
     /*  66534 */     // No operand predicates
     /*  66534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66544 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66558 */     GIR_RootConstrainSelectedInstOperands,
     /*  66559 */     // GIR_Coverage, 13290,
     /*  66559 */     GIR_EraseRootFromParent_Done,
     /*  66560 */   // Label 1119: @66560
     /*  66560 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(66627), // Rule ID 13311 //
     /*  66565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66589 */     // MIs[1] imm
     /*  66589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66601 */     // MIs[2] Operand 1
     /*  66601 */     // No operand predicates
     /*  66601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66611 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66625 */     GIR_RootConstrainSelectedInstOperands,
     /*  66626 */     // GIR_Coverage, 13311,
     /*  66626 */     GIR_EraseRootFromParent_Done,
     /*  66627 */   // Label 1120: @66627
     /*  66627 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(66694), // Rule ID 2222 //
     /*  66632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66660 */     // MIs[1] imm
     /*  66660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66672 */     // MIs[2] Operand 1
     /*  66672 */     // No operand predicates
     /*  66672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66678 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66692 */     GIR_RootConstrainSelectedInstOperands,
     /*  66693 */     // GIR_Coverage, 2222,
     /*  66693 */     GIR_EraseRootFromParent_Done,
     /*  66694 */   // Label 1121: @66694
     /*  66694 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(66761), // Rule ID 2281 //
     /*  66699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66727 */     // MIs[1] imm
     /*  66727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66739 */     // MIs[2] Operand 1
     /*  66739 */     // No operand predicates
     /*  66739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66745 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66759 */     GIR_RootConstrainSelectedInstOperands,
     /*  66760 */     // GIR_Coverage, 2281,
     /*  66760 */     GIR_EraseRootFromParent_Done,
     /*  66761 */   // Label 1122: @66761
     /*  66761 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(66825), // Rule ID 13110 //
     /*  66766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66798 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66812 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  66819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66823 */     GIR_RootConstrainSelectedInstOperands,
     /*  66824 */     // GIR_Coverage, 13110,
     /*  66824 */     GIR_EraseRootFromParent_Done,
     /*  66825 */   // Label 1123: @66825
     /*  66825 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66889), // Rule ID 1594 //
     /*  66830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66876 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  66883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66887 */     GIR_RootConstrainSelectedInstOperands,
     /*  66888 */     // GIR_Coverage, 1594,
     /*  66888 */     GIR_EraseRootFromParent_Done,
     /*  66889 */   // Label 1124: @66889
     /*  66889 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(66916), // Rule ID 1596 //
     /*  66894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66909 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66914 */     GIR_RootConstrainSelectedInstOperands,
     /*  66915 */     // GIR_Coverage, 1596,
     /*  66915 */     GIR_Done,
     /*  66916 */   // Label 1125: @66916
     /*  66916 */   GIM_Reject,
     /*  66917 */ // Label 1110: @66917
     /*  66917 */ GIM_Reject,
     /*  66918 */ // Label 995: @66918
     /*  66918 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68225),
     /*  66923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66929 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67038), // Rule ID 13349 //
     /*  66934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66982 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66999 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67003 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67012 */     // MIs[4] LHS
     /*  67012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67019 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67036 */     GIR_RootConstrainSelectedInstOperands,
     /*  67037 */     // GIR_Coverage, 13349,
     /*  67037 */     GIR_EraseRootFromParent_Done,
     /*  67038 */   // Label 1127: @67038
     /*  67038 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67147), // Rule ID 13348 //
     /*  67043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67091 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67116 */     // MIs[4] LHS
     /*  67116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67121 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67128 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67145 */     GIR_RootConstrainSelectedInstOperands,
     /*  67146 */     // GIR_Coverage, 13348,
     /*  67146 */     GIR_EraseRootFromParent_Done,
     /*  67147 */   // Label 1128: @67147
     /*  67147 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(67256), // Rule ID 13351 //
     /*  67152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67221 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67230 */     // MIs[4] LHS
     /*  67230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67235 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67237 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67254 */     GIR_RootConstrainSelectedInstOperands,
     /*  67255 */     // GIR_Coverage, 13351,
     /*  67255 */     GIR_EraseRootFromParent_Done,
     /*  67256 */   // Label 1129: @67256
     /*  67256 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(67365), // Rule ID 13350 //
     /*  67261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67334 */     // MIs[4] LHS
     /*  67334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67346 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67363 */     GIR_RootConstrainSelectedInstOperands,
     /*  67364 */     // GIR_Coverage, 13350,
     /*  67364 */     GIR_EraseRootFromParent_Done,
     /*  67365 */   // Label 1130: @67365
     /*  67365 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(67474), // Rule ID 2463 //
     /*  67370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67431 */     // MIs[3] LHS
     /*  67431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67455 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67472 */     GIR_RootConstrainSelectedInstOperands,
     /*  67473 */     // GIR_Coverage, 2463,
     /*  67473 */     GIR_EraseRootFromParent_Done,
     /*  67474 */   // Label 1131: @67474
     /*  67474 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(67583), // Rule ID 13346 //
     /*  67479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67540 */     // MIs[3] LHS
     /*  67540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67549 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67562 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67564 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67581 */     GIR_RootConstrainSelectedInstOperands,
     /*  67582 */     // GIR_Coverage, 13346,
     /*  67582 */     GIR_EraseRootFromParent_Done,
     /*  67583 */   // Label 1132: @67583
     /*  67583 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(67692), // Rule ID 13345 //
     /*  67588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67654 */     // MIs[3] LHS
     /*  67654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67673 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67690 */     GIR_RootConstrainSelectedInstOperands,
     /*  67691 */     // GIR_Coverage, 13345,
     /*  67691 */     GIR_EraseRootFromParent_Done,
     /*  67692 */   // Label 1133: @67692
     /*  67692 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(67801), // Rule ID 13347 //
     /*  67697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67759 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67763 */     // MIs[3] LHS
     /*  67763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67782 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67799 */     GIR_RootConstrainSelectedInstOperands,
     /*  67800 */     // GIR_Coverage, 13347,
     /*  67800 */     GIR_EraseRootFromParent_Done,
     /*  67801 */   // Label 1134: @67801
     /*  67801 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(67868), // Rule ID 13296 //
     /*  67806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67830 */     // MIs[1] imm
     /*  67830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67842 */     // MIs[2] Operand 1
     /*  67842 */     // No operand predicates
     /*  67842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67852 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67866 */     GIR_RootConstrainSelectedInstOperands,
     /*  67867 */     // GIR_Coverage, 13296,
     /*  67867 */     GIR_EraseRootFromParent_Done,
     /*  67868 */   // Label 1135: @67868
     /*  67868 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(67935), // Rule ID 13317 //
     /*  67873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67897 */     // MIs[1] imm
     /*  67897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67905 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67909 */     // MIs[2] Operand 1
     /*  67909 */     // No operand predicates
     /*  67909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67919 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  67922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67933 */     GIR_RootConstrainSelectedInstOperands,
     /*  67934 */     // GIR_Coverage, 13317,
     /*  67934 */     GIR_EraseRootFromParent_Done,
     /*  67935 */   // Label 1136: @67935
     /*  67935 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(68002), // Rule ID 2228 //
     /*  67940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67968 */     // MIs[1] imm
     /*  67968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67980 */     // MIs[2] Operand 1
     /*  67980 */     // No operand predicates
     /*  67980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67986 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68000 */     GIR_RootConstrainSelectedInstOperands,
     /*  68001 */     // GIR_Coverage, 2228,
     /*  68001 */     GIR_EraseRootFromParent_Done,
     /*  68002 */   // Label 1137: @68002
     /*  68002 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68069), // Rule ID 2287 //
     /*  68007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68035 */     // MIs[1] imm
     /*  68035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68047 */     // MIs[2] Operand 1
     /*  68047 */     // No operand predicates
     /*  68047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68053 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  68056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68067 */     GIR_RootConstrainSelectedInstOperands,
     /*  68068 */     // GIR_Coverage, 2287,
     /*  68068 */     GIR_EraseRootFromParent_Done,
     /*  68069 */   // Label 1138: @68069
     /*  68069 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68133), // Rule ID 13631 //
     /*  68074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68120 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68125 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68131 */     GIR_RootConstrainSelectedInstOperands,
     /*  68132 */     // GIR_Coverage, 13631,
     /*  68132 */     GIR_EraseRootFromParent_Done,
     /*  68133 */   // Label 1139: @68133
     /*  68133 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68197), // Rule ID 4994 //
     /*  68138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68174 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68184 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68189 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68195 */     GIR_RootConstrainSelectedInstOperands,
     /*  68196 */     // GIR_Coverage, 4994,
     /*  68196 */     GIR_EraseRootFromParent_Done,
     /*  68197 */   // Label 1140: @68197
     /*  68197 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68224), // Rule ID 5000 //
     /*  68202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68217 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68222 */     GIR_RootConstrainSelectedInstOperands,
     /*  68223 */     // GIR_Coverage, 5000,
     /*  68223 */     GIR_Done,
     /*  68224 */   // Label 1141: @68224
     /*  68224 */   GIM_Reject,
     /*  68225 */ // Label 1126: @68225
     /*  68225 */ GIM_Reject,
     /*  68226 */ // Label 996: @68226
     /*  68226 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69533),
     /*  68231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68237 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(68346), // Rule ID 13123 //
     /*  68242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68290 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68307 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68311 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68315 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68320 */     // MIs[4] Rd
     /*  68320 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68325 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68327 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68344 */     GIR_RootConstrainSelectedInstOperands,
     /*  68345 */     // GIR_Coverage, 13123,
     /*  68345 */     GIR_EraseRootFromParent_Done,
     /*  68346 */   // Label 1143: @68346
     /*  68346 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(68455), // Rule ID 13122 //
     /*  68351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68420 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68424 */     // MIs[4] Rd
     /*  68424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68429 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68436 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68453 */     GIR_RootConstrainSelectedInstOperands,
     /*  68454 */     // GIR_Coverage, 13122,
     /*  68454 */     GIR_EraseRootFromParent_Done,
     /*  68455 */   // Label 1144: @68455
     /*  68455 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(68564), // Rule ID 13125 //
     /*  68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68521 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68525 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68529 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68538 */     // MIs[4] Rd
     /*  68538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68545 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68562 */     GIR_RootConstrainSelectedInstOperands,
     /*  68563 */     // GIR_Coverage, 13125,
     /*  68563 */     GIR_EraseRootFromParent_Done,
     /*  68564 */   // Label 1145: @68564
     /*  68564 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(68673), // Rule ID 13124 //
     /*  68569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68634 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68638 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68642 */     // MIs[4] Rd
     /*  68642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68654 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68671 */     GIR_RootConstrainSelectedInstOperands,
     /*  68672 */     // GIR_Coverage, 13124,
     /*  68672 */     GIR_EraseRootFromParent_Done,
     /*  68673 */   // Label 1146: @68673
     /*  68673 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(68782), // Rule ID 1599 //
     /*  68678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68739 */     // MIs[3] Rd
     /*  68739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68763 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68780 */     GIR_RootConstrainSelectedInstOperands,
     /*  68781 */     // GIR_Coverage, 1599,
     /*  68781 */     GIR_EraseRootFromParent_Done,
     /*  68782 */   // Label 1147: @68782
     /*  68782 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(68891), // Rule ID 13120 //
     /*  68787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68848 */     // MIs[3] Rd
     /*  68848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68857 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68872 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68889 */     GIR_RootConstrainSelectedInstOperands,
     /*  68890 */     // GIR_Coverage, 13120,
     /*  68890 */     GIR_EraseRootFromParent_Done,
     /*  68891 */   // Label 1148: @68891
     /*  68891 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69000), // Rule ID 13119 //
     /*  68896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68962 */     // MIs[3] Rd
     /*  68962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68967 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68971 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68979 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68981 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68998 */     GIR_RootConstrainSelectedInstOperands,
     /*  68999 */     // GIR_Coverage, 13119,
     /*  68999 */     GIR_EraseRootFromParent_Done,
     /*  69000 */   // Label 1149: @69000
     /*  69000 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69109), // Rule ID 13121 //
     /*  69005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69071 */     // MIs[3] Rd
     /*  69071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69088 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69090 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69107 */     GIR_RootConstrainSelectedInstOperands,
     /*  69108 */     // GIR_Coverage, 13121,
     /*  69108 */     GIR_EraseRootFromParent_Done,
     /*  69109 */   // Label 1150: @69109
     /*  69109 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69176), // Rule ID 13292 //
     /*  69114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[1] imm
     /*  69138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69150 */     // MIs[2] Operand 1
     /*  69150 */     // No operand predicates
     /*  69150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69160 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69174 */     GIR_RootConstrainSelectedInstOperands,
     /*  69175 */     // GIR_Coverage, 13292,
     /*  69175 */     GIR_EraseRootFromParent_Done,
     /*  69176 */   // Label 1151: @69176
     /*  69176 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69243), // Rule ID 13313 //
     /*  69181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69205 */     // MIs[1] imm
     /*  69205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69217 */     // MIs[2] Operand 1
     /*  69217 */     // No operand predicates
     /*  69217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69227 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69241 */     GIR_RootConstrainSelectedInstOperands,
     /*  69242 */     // GIR_Coverage, 13313,
     /*  69242 */     GIR_EraseRootFromParent_Done,
     /*  69243 */   // Label 1152: @69243
     /*  69243 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(69310), // Rule ID 2224 //
     /*  69248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69276 */     // MIs[1] imm
     /*  69276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69288 */     // MIs[2] Operand 1
     /*  69288 */     // No operand predicates
     /*  69288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69294 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69308 */     GIR_RootConstrainSelectedInstOperands,
     /*  69309 */     // GIR_Coverage, 2224,
     /*  69309 */     GIR_EraseRootFromParent_Done,
     /*  69310 */   // Label 1153: @69310
     /*  69310 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69377), // Rule ID 2283 //
     /*  69315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69343 */     // MIs[1] imm
     /*  69343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69355 */     // MIs[2] Operand 1
     /*  69355 */     // No operand predicates
     /*  69355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69361 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69375 */     GIR_RootConstrainSelectedInstOperands,
     /*  69376 */     // GIR_Coverage, 2283,
     /*  69376 */     GIR_EraseRootFromParent_Done,
     /*  69377 */   // Label 1154: @69377
     /*  69377 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69441), // Rule ID 13111 //
     /*  69382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69428 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69439 */     GIR_RootConstrainSelectedInstOperands,
     /*  69440 */     // GIR_Coverage, 13111,
     /*  69440 */     GIR_EraseRootFromParent_Done,
     /*  69441 */   // Label 1155: @69441
     /*  69441 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(69505), // Rule ID 1595 //
     /*  69446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69482 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69492 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69503 */     GIR_RootConstrainSelectedInstOperands,
     /*  69504 */     // GIR_Coverage, 1595,
     /*  69504 */     GIR_EraseRootFromParent_Done,
     /*  69505 */   // Label 1156: @69505
     /*  69505 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(69532), // Rule ID 1597 //
     /*  69510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69525 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  69530 */     GIR_RootConstrainSelectedInstOperands,
     /*  69531 */     // GIR_Coverage, 1597,
     /*  69531 */     GIR_Done,
     /*  69532 */   // Label 1157: @69532
     /*  69532 */   GIM_Reject,
     /*  69533 */ // Label 1142: @69533
     /*  69533 */ GIM_Reject,
     /*  69534 */ // Label 997: @69534
     /*  69534 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(69565), // Rule ID 8300 //
     /*  69539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  69545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  69548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69552 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  69552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69557 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69559 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69561 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69563 */   GIR_RootConstrainSelectedInstOperands,
     /*  69564 */   // GIR_Coverage, 8300,
     /*  69564 */   GIR_EraseRootFromParent_Done,
     /*  69565 */ // Label 1158: @69565
     /*  69565 */ GIM_Reject,
     /*  69566 */ // Label 998: @69566
     /*  69566 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(69597), // Rule ID 8299 //
     /*  69571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  69577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  69580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69584 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  69584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69589 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69591 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69593 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69595 */   GIR_RootConstrainSelectedInstOperands,
     /*  69596 */   // GIR_Coverage, 8299,
     /*  69596 */   GIR_EraseRootFromParent_Done,
     /*  69597 */ // Label 1159: @69597
     /*  69597 */ GIM_Reject,
     /*  69598 */ // Label 999: @69598
     /*  69598 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(69623), // Rule ID 7309 //
     /*  69603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  69609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  69612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69616 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  69616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69621 */   GIR_RootConstrainSelectedInstOperands,
     /*  69622 */   // GIR_Coverage, 7309,
     /*  69622 */   GIR_Done,
     /*  69623 */ // Label 1160: @69623
     /*  69623 */ GIM_Reject,
     /*  69624 */ // Label 1000: @69624
     /*  69624 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(69655), // Rule ID 8298 //
     /*  69629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  69635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  69638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69642 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  69642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69649 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69651 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69653 */   GIR_RootConstrainSelectedInstOperands,
     /*  69654 */   // GIR_Coverage, 8298,
     /*  69654 */   GIR_EraseRootFromParent_Done,
     /*  69655 */ // Label 1161: @69655
     /*  69655 */ GIM_Reject,
     /*  69656 */ // Label 1001: @69656
     /*  69656 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(69681), // Rule ID 7308 //
     /*  69661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  69667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  69670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69674 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  69674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69679 */   GIR_RootConstrainSelectedInstOperands,
     /*  69680 */   // GIR_Coverage, 7308,
     /*  69680 */   GIR_Done,
     /*  69681 */ // Label 1162: @69681
     /*  69681 */ GIM_Reject,
     /*  69682 */ // Label 1002: @69682
     /*  69682 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(69713), // Rule ID 8297 //
     /*  69687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  69693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  69696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69700 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  69700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69709 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69711 */   GIR_RootConstrainSelectedInstOperands,
     /*  69712 */   // GIR_Coverage, 8297,
     /*  69712 */   GIR_EraseRootFromParent_Done,
     /*  69713 */ // Label 1163: @69713
     /*  69713 */ GIM_Reject,
     /*  69714 */ // Label 1003: @69714
     /*  69714 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(69739), // Rule ID 7307 //
     /*  69719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  69725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  69728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69732 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  69732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69737 */   GIR_RootConstrainSelectedInstOperands,
     /*  69738 */   // GIR_Coverage, 7307,
     /*  69738 */   GIR_Done,
     /*  69739 */ // Label 1164: @69739
     /*  69739 */ GIM_Reject,
     /*  69740 */ // Label 1004: @69740
     /*  69740 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(69771), // Rule ID 8296 //
     /*  69745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  69751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  69754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69758 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  69758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69767 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69769 */   GIR_RootConstrainSelectedInstOperands,
     /*  69770 */   // GIR_Coverage, 8296,
     /*  69770 */   GIR_EraseRootFromParent_Done,
     /*  69771 */ // Label 1165: @69771
     /*  69771 */ GIM_Reject,
     /*  69772 */ // Label 1005: @69772
     /*  69772 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(69797), // Rule ID 7306 //
     /*  69777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  69783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  69786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69790 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  69790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69795 */   GIR_RootConstrainSelectedInstOperands,
     /*  69796 */   // GIR_Coverage, 7306,
     /*  69796 */   GIR_Done,
     /*  69797 */ // Label 1166: @69797
     /*  69797 */ GIM_Reject,
     /*  69798 */ // Label 1006: @69798
     /*  69798 */ GIM_Reject,
     /*  69799 */ // Label 7: @69799
     /*  69799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1185*/ GIMT_Encode4(75737),
     /*  69810 */ /*GILLT_s32*//*Label 1167*/ GIMT_Encode4(69898),
     /*  69814 */ /*GILLT_s64*//*Label 1168*/ GIMT_Encode4(70578), GIMT_Encode4(0),
     /*  69822 */ /*GILLT_v2s32*//*Label 1169*/ GIMT_Encode4(71321),
     /*  69826 */ /*GILLT_v2s64*//*Label 1170*/ GIMT_Encode4(71389),
     /*  69830 */ /*GILLT_v4s16*//*Label 1171*/ GIMT_Encode4(71915),
     /*  69834 */ /*GILLT_v4s32*//*Label 1172*/ GIMT_Encode4(71983),
     /*  69838 */ /*GILLT_v8s8*//*Label 1173*/ GIMT_Encode4(72509),
     /*  69842 */ /*GILLT_v8s16*//*Label 1174*/ GIMT_Encode4(72580),
     /*  69846 */ /*GILLT_v16s8*//*Label 1175*/ GIMT_Encode4(73106),
     /*  69850 */ /*GILLT_nxv1s1*//*Label 1176*/ GIMT_Encode4(73635),
     /*  69854 */ /*GILLT_nxv2s1*//*Label 1177*/ GIMT_Encode4(73685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  69866 */ /*GILLT_nxv2s64*//*Label 1178*/ GIMT_Encode4(73735),
     /*  69870 */ /*GILLT_nxv4s1*//*Label 1179*/ GIMT_Encode4(74198), GIMT_Encode4(0),
     /*  69878 */ /*GILLT_nxv4s32*//*Label 1180*/ GIMT_Encode4(74248),
     /*  69882 */ /*GILLT_nxv8s1*//*Label 1181*/ GIMT_Encode4(74711),
     /*  69886 */ /*GILLT_nxv8s16*//*Label 1182*/ GIMT_Encode4(74761),
     /*  69890 */ /*GILLT_nxv16s1*//*Label 1183*/ GIMT_Encode4(75224),
     /*  69894 */ /*GILLT_nxv16s8*//*Label 1184*/ GIMT_Encode4(75274),
     /*  69898 */ // Label 1167: @69898
     /*  69898 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(70577),
     /*  69903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  69906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69909 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(69967), // Rule ID 12981 //
     /*  69914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  69952 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  69952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  69955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  69965 */     GIR_RootConstrainSelectedInstOperands,
     /*  69966 */     // GIR_Coverage, 12981,
     /*  69966 */     GIR_EraseRootFromParent_Done,
     /*  69967 */   // Label 1187: @69967
     /*  69967 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(70022), // Rule ID 12980 //
     /*  69972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70009 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70020 */     GIR_RootConstrainSelectedInstOperands,
     /*  70021 */     // GIR_Coverage, 12980,
     /*  70021 */     GIR_EraseRootFromParent_Done,
     /*  70022 */   // Label 1188: @70022
     /*  70022 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(70080), // Rule ID 12978 //
     /*  70027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70065 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70078 */     GIR_RootConstrainSelectedInstOperands,
     /*  70079 */     // GIR_Coverage, 12978,
     /*  70079 */     GIR_EraseRootFromParent_Done,
     /*  70080 */   // Label 1189: @70080
     /*  70080 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(70138), // Rule ID 166 //
     /*  70085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70123 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70136 */     GIR_RootConstrainSelectedInstOperands,
     /*  70137 */     // GIR_Coverage, 166,
     /*  70137 */     GIR_EraseRootFromParent_Done,
     /*  70138 */   // Label 1190: @70138
     /*  70138 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(70196), // Rule ID 12979 //
     /*  70143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70181 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70194 */     GIR_RootConstrainSelectedInstOperands,
     /*  70195 */     // GIR_Coverage, 12979,
     /*  70195 */     GIR_EraseRootFromParent_Done,
     /*  70196 */   // Label 1191: @70196
     /*  70196 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(70251), // Rule ID 12982 //
     /*  70201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70238 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70249 */     GIR_RootConstrainSelectedInstOperands,
     /*  70250 */     // GIR_Coverage, 12982,
     /*  70250 */     GIR_EraseRootFromParent_Done,
     /*  70251 */   // Label 1192: @70251
     /*  70251 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(70292), // Rule ID 144 //
     /*  70256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  70260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70272 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  70276 */     // MIs[1] Operand 1
     /*  70276 */     // No operand predicates
     /*  70276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70278 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  70278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70285 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  70290 */     GIR_RootConstrainSelectedInstOperands,
     /*  70291 */     // GIR_Coverage, 144,
     /*  70291 */     GIR_EraseRootFromParent_Done,
     /*  70292 */   // Label 1193: @70292
     /*  70292 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(70325), // Rule ID 12988 //
     /*  70297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70312 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70323 */     GIR_RootConstrainSelectedInstOperands,
     /*  70324 */     // GIR_Coverage, 12988,
     /*  70324 */     GIR_EraseRootFromParent_Done,
     /*  70325 */   // Label 1194: @70325
     /*  70325 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70358), // Rule ID 170 //
     /*  70330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70345 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70356 */     GIR_RootConstrainSelectedInstOperands,
     /*  70357 */     // GIR_Coverage, 170,
     /*  70357 */     GIR_EraseRootFromParent_Done,
     /*  70358 */   // Label 1195: @70358
     /*  70358 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(70411), // Rule ID 12974 //
     /*  70363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70398 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  70409 */     GIR_RootConstrainSelectedInstOperands,
     /*  70410 */     // GIR_Coverage, 12974,
     /*  70410 */     GIR_EraseRootFromParent_Done,
     /*  70411 */   // Label 1196: @70411
     /*  70411 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(70467), // Rule ID 164 //
     /*  70416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70452 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70465 */     GIR_RootConstrainSelectedInstOperands,
     /*  70466 */     // GIR_Coverage, 164,
     /*  70466 */     GIR_EraseRootFromParent_Done,
     /*  70467 */   // Label 1197: @70467
     /*  70467 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(70520), // Rule ID 12975 //
     /*  70472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70507 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  70518 */     GIR_RootConstrainSelectedInstOperands,
     /*  70519 */     // GIR_Coverage, 12975,
     /*  70519 */     GIR_EraseRootFromParent_Done,
     /*  70520 */   // Label 1198: @70520
     /*  70520 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(70552), // Rule ID 3944 //
     /*  70525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70537 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  70537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  70550 */     GIR_RootConstrainSelectedInstOperands,
     /*  70551 */     // GIR_Coverage, 3944,
     /*  70551 */     GIR_EraseRootFromParent_Done,
     /*  70552 */   // Label 1199: @70552
     /*  70552 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(70576), // Rule ID 168 //
     /*  70557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70569 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  70574 */     GIR_RootConstrainSelectedInstOperands,
     /*  70575 */     // GIR_Coverage, 168,
     /*  70575 */     GIR_Done,
     /*  70576 */   // Label 1200: @70576
     /*  70576 */   GIM_Reject,
     /*  70577 */ // Label 1186: @70577
     /*  70577 */ GIM_Reject,
     /*  70578 */ // Label 1168: @70578
     /*  70578 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(71320),
     /*  70583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  70586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  70589 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(70647), // Rule ID 12986 //
     /*  70594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70632 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70645 */     GIR_RootConstrainSelectedInstOperands,
     /*  70646 */     // GIR_Coverage, 12986,
     /*  70646 */     GIR_EraseRootFromParent_Done,
     /*  70647 */   // Label 1202: @70647
     /*  70647 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(70702), // Rule ID 12985 //
     /*  70652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70689 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70700 */     GIR_RootConstrainSelectedInstOperands,
     /*  70701 */     // GIR_Coverage, 12985,
     /*  70701 */     GIR_EraseRootFromParent_Done,
     /*  70702 */   // Label 1203: @70702
     /*  70702 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(70760), // Rule ID 12983 //
     /*  70707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70745 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70758 */     GIR_RootConstrainSelectedInstOperands,
     /*  70759 */     // GIR_Coverage, 12983,
     /*  70759 */     GIR_EraseRootFromParent_Done,
     /*  70760 */   // Label 1204: @70760
     /*  70760 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(70818), // Rule ID 167 //
     /*  70765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70803 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70816 */     GIR_RootConstrainSelectedInstOperands,
     /*  70817 */     // GIR_Coverage, 167,
     /*  70817 */     GIR_EraseRootFromParent_Done,
     /*  70818 */   // Label 1205: @70818
     /*  70818 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(70876), // Rule ID 12984 //
     /*  70823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70861 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70874 */     GIR_RootConstrainSelectedInstOperands,
     /*  70875 */     // GIR_Coverage, 12984,
     /*  70875 */     GIR_EraseRootFromParent_Done,
     /*  70876 */   // Label 1206: @70876
     /*  70876 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70931), // Rule ID 12987 //
     /*  70881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70905 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70929 */     GIR_RootConstrainSelectedInstOperands,
     /*  70930 */     // GIR_Coverage, 12987,
     /*  70930 */     GIR_EraseRootFromParent_Done,
     /*  70931 */   // Label 1207: @70931
     /*  70931 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70972), // Rule ID 145 //
     /*  70936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  70940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70952 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  70956 */     // MIs[1] Operand 1
     /*  70956 */     // No operand predicates
     /*  70956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70958 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  70958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  70961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70965 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  70970 */     GIR_RootConstrainSelectedInstOperands,
     /*  70971 */     // GIR_Coverage, 145,
     /*  70971 */     GIR_EraseRootFromParent_Done,
     /*  70972 */   // Label 1208: @70972
     /*  70972 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(71005), // Rule ID 12989 //
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70992 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  70995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71003 */     GIR_RootConstrainSelectedInstOperands,
     /*  71004 */     // GIR_Coverage, 12989,
     /*  71004 */     GIR_EraseRootFromParent_Done,
     /*  71005 */   // Label 1209: @71005
     /*  71005 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(71038), // Rule ID 171 //
     /*  71010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  71025 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  71025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  71028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71036 */     GIR_RootConstrainSelectedInstOperands,
     /*  71037 */     // GIR_Coverage, 171,
     /*  71037 */     GIR_EraseRootFromParent_Done,
     /*  71038 */   // Label 1210: @71038
     /*  71038 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(71091), // Rule ID 12976 //
     /*  71043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71078 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  71089 */     GIR_RootConstrainSelectedInstOperands,
     /*  71090 */     // GIR_Coverage, 12976,
     /*  71090 */     GIR_EraseRootFromParent_Done,
     /*  71091 */   // Label 1211: @71091
     /*  71091 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(71147), // Rule ID 165 //
     /*  71096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71132 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71145 */     GIR_RootConstrainSelectedInstOperands,
     /*  71146 */     // GIR_Coverage, 165,
     /*  71146 */     GIR_EraseRootFromParent_Done,
     /*  71147 */   // Label 1212: @71147
     /*  71147 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(71200), // Rule ID 12977 //
     /*  71152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71187 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  71198 */     GIR_RootConstrainSelectedInstOperands,
     /*  71199 */     // GIR_Coverage, 12977,
     /*  71199 */     GIR_EraseRootFromParent_Done,
     /*  71200 */   // Label 1213: @71200
     /*  71200 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(71232), // Rule ID 3945 //
     /*  71205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71217 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  71217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  71220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  71230 */     GIR_RootConstrainSelectedInstOperands,
     /*  71231 */     // GIR_Coverage, 3945,
     /*  71231 */     GIR_EraseRootFromParent_Done,
     /*  71232 */   // Label 1214: @71232
     /*  71232 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(71268), // Rule ID 4891 //
     /*  71237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71259 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  71259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 4891,
     /*  71267 */     GIR_EraseRootFromParent_Done,
     /*  71268 */   // Label 1215: @71268
     /*  71268 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(71292), // Rule ID 169 //
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71285 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  71290 */     GIR_RootConstrainSelectedInstOperands,
     /*  71291 */     // GIR_Coverage, 169,
     /*  71291 */     GIR_Done,
     /*  71292 */   // Label 1216: @71292
     /*  71292 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(71319), // Rule ID 4987 //
     /*  71297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71312 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  71312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71317 */     GIR_RootConstrainSelectedInstOperands,
     /*  71318 */     // GIR_Coverage, 4987,
     /*  71318 */     GIR_Done,
     /*  71319 */   // Label 1217: @71319
     /*  71319 */   GIM_Reject,
     /*  71320 */ // Label 1201: @71320
     /*  71320 */ GIM_Reject,
     /*  71321 */ // Label 1169: @71321
     /*  71321 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(71388),
     /*  71326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  71329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71340 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(71368), // Rule ID 4889 //
     /*  71345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71359 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  71359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71366 */     GIR_RootConstrainSelectedInstOperands,
     /*  71367 */     // GIR_Coverage, 4889,
     /*  71367 */     GIR_EraseRootFromParent_Done,
     /*  71368 */   // Label 1219: @71368
     /*  71368 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71387), // Rule ID 4986 //
     /*  71373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71380 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  71380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71385 */     GIR_RootConstrainSelectedInstOperands,
     /*  71386 */     // GIR_Coverage, 4986,
     /*  71386 */     GIR_Done,
     /*  71387 */   // Label 1220: @71387
     /*  71387 */   GIM_Reject,
     /*  71388 */ // Label 1218: @71388
     /*  71388 */ GIM_Reject,
     /*  71389 */ // Label 1170: @71389
     /*  71389 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71914),
     /*  71394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71404 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71489), // Rule ID 13511 //
     /*  71409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71472 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71487 */     GIR_RootConstrainSelectedInstOperands,
     /*  71488 */     // GIR_Coverage, 13511,
     /*  71488 */     GIR_EraseRootFromParent_Done,
     /*  71489 */   // Label 1222: @71489
     /*  71489 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71574), // Rule ID 13510 //
     /*  71494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71557 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71572 */     GIR_RootConstrainSelectedInstOperands,
     /*  71573 */     // GIR_Coverage, 13510,
     /*  71573 */     GIR_EraseRootFromParent_Done,
     /*  71574 */   // Label 1223: @71574
     /*  71574 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71659), // Rule ID 13509 //
     /*  71579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71627 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71633 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71642 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71657 */     GIR_RootConstrainSelectedInstOperands,
     /*  71658 */     // GIR_Coverage, 13509,
     /*  71658 */     GIR_EraseRootFromParent_Done,
     /*  71659 */   // Label 1224: @71659
     /*  71659 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71744), // Rule ID 3772 //
     /*  71664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71717 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71723 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71727 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71742 */     GIR_RootConstrainSelectedInstOperands,
     /*  71743 */     // GIR_Coverage, 3772,
     /*  71743 */     GIR_EraseRootFromParent_Done,
     /*  71744 */   // Label 1225: @71744
     /*  71744 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71776), // Rule ID 4892 //
     /*  71749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71757 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71767 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  71767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  71770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71774 */     GIR_RootConstrainSelectedInstOperands,
     /*  71775 */     // GIR_Coverage, 4892,
     /*  71775 */     GIR_EraseRootFromParent_Done,
     /*  71776 */   // Label 1226: @71776
     /*  71776 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71833), // Rule ID 3768 //
     /*  71781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71816 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  71831 */     GIR_RootConstrainSelectedInstOperands,
     /*  71832 */     // GIR_Coverage, 3768,
     /*  71832 */     GIR_EraseRootFromParent_Done,
     /*  71833 */   // Label 1227: @71833
     /*  71833 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71890), // Rule ID 13499 //
     /*  71838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71873 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  71888 */     GIR_RootConstrainSelectedInstOperands,
     /*  71889 */     // GIR_Coverage, 13499,
     /*  71889 */     GIR_EraseRootFromParent_Done,
     /*  71890 */   // Label 1228: @71890
     /*  71890 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(71913), // Rule ID 4990 //
     /*  71895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71906 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  71906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  71911 */     GIR_RootConstrainSelectedInstOperands,
     /*  71912 */     // GIR_Coverage, 4990,
     /*  71912 */     GIR_Done,
     /*  71913 */   // Label 1229: @71913
     /*  71913 */   GIM_Reject,
     /*  71914 */ // Label 1221: @71914
     /*  71914 */ GIM_Reject,
     /*  71915 */ // Label 1171: @71915
     /*  71915 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(71982),
     /*  71920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  71923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71934 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(71962), // Rule ID 4887 //
     /*  71939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71953 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  71953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71960 */     GIR_RootConstrainSelectedInstOperands,
     /*  71961 */     // GIR_Coverage, 4887,
     /*  71961 */     GIR_EraseRootFromParent_Done,
     /*  71962 */   // Label 1231: @71962
     /*  71962 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(71981), // Rule ID 4985 //
     /*  71967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71974 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  71974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71979 */     GIR_RootConstrainSelectedInstOperands,
     /*  71980 */     // GIR_Coverage, 4985,
     /*  71980 */     GIR_Done,
     /*  71981 */   // Label 1232: @71981
     /*  71981 */   GIM_Reject,
     /*  71982 */ // Label 1230: @71982
     /*  71982 */ GIM_Reject,
     /*  71983 */ // Label 1172: @71983
     /*  71983 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(72508),
     /*  71988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  71991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(72083), // Rule ID 13508 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72047 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72066 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72081 */     GIR_RootConstrainSelectedInstOperands,
     /*  72082 */     // GIR_Coverage, 13508,
     /*  72082 */     GIR_EraseRootFromParent_Done,
     /*  72083 */   // Label 1234: @72083
     /*  72083 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(72168), // Rule ID 13507 //
     /*  72088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72137 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72151 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72166 */     GIR_RootConstrainSelectedInstOperands,
     /*  72167 */     // GIR_Coverage, 13507,
     /*  72167 */     GIR_EraseRootFromParent_Done,
     /*  72168 */   // Label 1235: @72168
     /*  72168 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72253), // Rule ID 13506 //
     /*  72173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72236 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72251 */     GIR_RootConstrainSelectedInstOperands,
     /*  72252 */     // GIR_Coverage, 13506,
     /*  72252 */     GIR_EraseRootFromParent_Done,
     /*  72253 */   // Label 1236: @72253
     /*  72253 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72338), // Rule ID 3771 //
     /*  72258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72321 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72336 */     GIR_RootConstrainSelectedInstOperands,
     /*  72337 */     // GIR_Coverage, 3771,
     /*  72337 */     GIR_EraseRootFromParent_Done,
     /*  72338 */   // Label 1237: @72338
     /*  72338 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72370), // Rule ID 4890 //
     /*  72343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72361 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72368 */     GIR_RootConstrainSelectedInstOperands,
     /*  72369 */     // GIR_Coverage, 4890,
     /*  72369 */     GIR_EraseRootFromParent_Done,
     /*  72370 */   // Label 1238: @72370
     /*  72370 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72427), // Rule ID 3767 //
     /*  72375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72410 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  72425 */     GIR_RootConstrainSelectedInstOperands,
     /*  72426 */     // GIR_Coverage, 3767,
     /*  72426 */     GIR_EraseRootFromParent_Done,
     /*  72427 */   // Label 1239: @72427
     /*  72427 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(72484), // Rule ID 13498 //
     /*  72432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72467 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  72482 */     GIR_RootConstrainSelectedInstOperands,
     /*  72483 */     // GIR_Coverage, 13498,
     /*  72483 */     GIR_EraseRootFromParent_Done,
     /*  72484 */   // Label 1240: @72484
     /*  72484 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(72507), // Rule ID 4989 //
     /*  72489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72500 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  72500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  72505 */     GIR_RootConstrainSelectedInstOperands,
     /*  72506 */     // GIR_Coverage, 4989,
     /*  72506 */     GIR_Done,
     /*  72507 */   // Label 1241: @72507
     /*  72507 */   GIM_Reject,
     /*  72508 */ // Label 1233: @72508
     /*  72508 */ GIM_Reject,
     /*  72509 */ // Label 1173: @72509
     /*  72509 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(72579),
     /*  72514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  72517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  72520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72528 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(72559), // Rule ID 965 //
     /*  72533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72550 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  72550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  72553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72557 */     GIR_RootConstrainSelectedInstOperands,
     /*  72558 */     // GIR_Coverage, 965,
     /*  72558 */     GIR_EraseRootFromParent_Done,
     /*  72559 */   // Label 1243: @72559
     /*  72559 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(72578), // Rule ID 1592 //
     /*  72564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72571 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  72571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  72576 */     GIR_RootConstrainSelectedInstOperands,
     /*  72577 */     // GIR_Coverage, 1592,
     /*  72577 */     GIR_Done,
     /*  72578 */   // Label 1244: @72578
     /*  72578 */   GIM_Reject,
     /*  72579 */ // Label 1242: @72579
     /*  72579 */ GIM_Reject,
     /*  72580 */ // Label 1174: @72580
     /*  72580 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(73105),
     /*  72585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72595 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(72680), // Rule ID 13505 //
     /*  72600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72663 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72678 */     GIR_RootConstrainSelectedInstOperands,
     /*  72679 */     // GIR_Coverage, 13505,
     /*  72679 */     GIR_EraseRootFromParent_Done,
     /*  72680 */   // Label 1246: @72680
     /*  72680 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(72765), // Rule ID 13504 //
     /*  72685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72748 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72763 */     GIR_RootConstrainSelectedInstOperands,
     /*  72764 */     // GIR_Coverage, 13504,
     /*  72764 */     GIR_EraseRootFromParent_Done,
     /*  72765 */   // Label 1247: @72765
     /*  72765 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(72850), // Rule ID 13503 //
     /*  72770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72833 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72848 */     GIR_RootConstrainSelectedInstOperands,
     /*  72849 */     // GIR_Coverage, 13503,
     /*  72849 */     GIR_EraseRootFromParent_Done,
     /*  72850 */   // Label 1248: @72850
     /*  72850 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(72935), // Rule ID 3770 //
     /*  72855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72908 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72918 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72933 */     GIR_RootConstrainSelectedInstOperands,
     /*  72934 */     // GIR_Coverage, 3770,
     /*  72934 */     GIR_EraseRootFromParent_Done,
     /*  72935 */   // Label 1249: @72935
     /*  72935 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(72967), // Rule ID 4888 //
     /*  72940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72958 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  72958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72965 */     GIR_RootConstrainSelectedInstOperands,
     /*  72966 */     // GIR_Coverage, 4888,
     /*  72966 */     GIR_EraseRootFromParent_Done,
     /*  72967 */   // Label 1250: @72967
     /*  72967 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(73024), // Rule ID 3766 //
     /*  72972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73007 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73022 */     GIR_RootConstrainSelectedInstOperands,
     /*  73023 */     // GIR_Coverage, 3766,
     /*  73023 */     GIR_EraseRootFromParent_Done,
     /*  73024 */   // Label 1251: @73024
     /*  73024 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(73081), // Rule ID 13497 //
     /*  73029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  73048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73064 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73079 */     GIR_RootConstrainSelectedInstOperands,
     /*  73080 */     // GIR_Coverage, 13497,
     /*  73080 */     GIR_EraseRootFromParent_Done,
     /*  73081 */   // Label 1252: @73081
     /*  73081 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(73104), // Rule ID 4988 //
     /*  73086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73097 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  73097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73102 */     GIR_RootConstrainSelectedInstOperands,
     /*  73103 */     // GIR_Coverage, 4988,
     /*  73103 */     GIR_Done,
     /*  73104 */   // Label 1253: @73104
     /*  73104 */   GIM_Reject,
     /*  73105 */ // Label 1245: @73105
     /*  73105 */ GIM_Reject,
     /*  73106 */ // Label 1175: @73106
     /*  73106 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(73634),
     /*  73111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(73206), // Rule ID 13502 //
     /*  73126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73170 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73189 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73204 */     GIR_RootConstrainSelectedInstOperands,
     /*  73205 */     // GIR_Coverage, 13502,
     /*  73205 */     GIR_EraseRootFromParent_Done,
     /*  73206 */   // Label 1255: @73206
     /*  73206 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(73291), // Rule ID 13501 //
     /*  73211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73260 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73266 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73274 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73289 */     GIR_RootConstrainSelectedInstOperands,
     /*  73290 */     // GIR_Coverage, 13501,
     /*  73290 */     GIR_EraseRootFromParent_Done,
     /*  73291 */   // Label 1256: @73291
     /*  73291 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(73376), // Rule ID 13500 //
     /*  73296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73344 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73359 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73374 */     GIR_RootConstrainSelectedInstOperands,
     /*  73375 */     // GIR_Coverage, 13500,
     /*  73375 */     GIR_EraseRootFromParent_Done,
     /*  73376 */   // Label 1257: @73376
     /*  73376 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(73461), // Rule ID 3769 //
     /*  73381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73444 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73459 */     GIR_RootConstrainSelectedInstOperands,
     /*  73460 */     // GIR_Coverage, 3769,
     /*  73460 */     GIR_EraseRootFromParent_Done,
     /*  73461 */   // Label 1258: @73461
     /*  73461 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(73496), // Rule ID 966 //
     /*  73466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73487 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  73487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  73490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73494 */     GIR_RootConstrainSelectedInstOperands,
     /*  73495 */     // GIR_Coverage, 966,
     /*  73495 */     GIR_EraseRootFromParent_Done,
     /*  73496 */   // Label 1259: @73496
     /*  73496 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(73553), // Rule ID 3765 //
     /*  73501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73536 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73551 */     GIR_RootConstrainSelectedInstOperands,
     /*  73552 */     // GIR_Coverage, 3765,
     /*  73552 */     GIR_EraseRootFromParent_Done,
     /*  73553 */   // Label 1260: @73553
     /*  73553 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(73610), // Rule ID 13496 //
     /*  73558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73593 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73608 */     GIR_RootConstrainSelectedInstOperands,
     /*  73609 */     // GIR_Coverage, 13496,
     /*  73609 */     GIR_EraseRootFromParent_Done,
     /*  73610 */   // Label 1261: @73610
     /*  73610 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(73633), // Rule ID 1593 //
     /*  73615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73626 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 1593,
     /*  73632 */     GIR_Done,
     /*  73633 */   // Label 1262: @73633
     /*  73633 */   GIM_Reject,
     /*  73634 */ // Label 1254: @73634
     /*  73634 */ GIM_Reject,
     /*  73635 */ // Label 1176: @73635
     /*  73635 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(73684), // Rule ID 8290 //
     /*  73640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  73646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  73649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73653 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  73653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73665 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73678 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73680 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73682 */   GIR_RootConstrainSelectedInstOperands,
     /*  73683 */   // GIR_Coverage, 8290,
     /*  73683 */   GIR_EraseRootFromParent_Done,
     /*  73684 */ // Label 1263: @73684
     /*  73684 */ GIM_Reject,
     /*  73685 */ // Label 1177: @73685
     /*  73685 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(73734), // Rule ID 8289 //
     /*  73690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  73696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  73699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73703 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  73703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73715 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73728 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73730 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73732 */   GIR_RootConstrainSelectedInstOperands,
     /*  73733 */   // GIR_Coverage, 8289,
     /*  73733 */   GIR_EraseRootFromParent_Done,
     /*  73734 */ // Label 1264: @73734
     /*  73734 */ GIM_Reject,
     /*  73735 */ // Label 1178: @73735
     /*  73735 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(74197),
     /*  73740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  73750 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(73821), // Rule ID 15354 //
     /*  73755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73804 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73819 */     GIR_RootConstrainSelectedInstOperands,
     /*  73820 */     // GIR_Coverage, 15354,
     /*  73820 */     GIR_EraseRootFromParent_Done,
     /*  73821 */   // Label 1266: @73821
     /*  73821 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(73892), // Rule ID 15353 //
     /*  73826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73865 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73875 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73890 */     GIR_RootConstrainSelectedInstOperands,
     /*  73891 */     // GIR_Coverage, 15353,
     /*  73891 */     GIR_EraseRootFromParent_Done,
     /*  73892 */   // Label 1267: @73892
     /*  73892 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(73963), // Rule ID 15352 //
     /*  73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73936 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73946 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73961 */     GIR_RootConstrainSelectedInstOperands,
     /*  73962 */     // GIR_Coverage, 15352,
     /*  73962 */     GIR_EraseRootFromParent_Done,
     /*  73963 */   // Label 1268: @73963
     /*  73963 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(74034), // Rule ID 11700 //
     /*  73968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74017 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74032 */     GIR_RootConstrainSelectedInstOperands,
     /*  74033 */     // GIR_Coverage, 11700,
     /*  74033 */     GIR_EraseRootFromParent_Done,
     /*  74034 */   // Label 1269: @74034
     /*  74034 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(74095), // Rule ID 11724 //
     /*  74039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  74062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74066 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74076 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74093 */     GIR_RootConstrainSelectedInstOperands,
     /*  74094 */     // GIR_Coverage, 11724,
     /*  74094 */     GIR_EraseRootFromParent_Done,
     /*  74095 */   // Label 1270: @74095
     /*  74095 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(74138), // Rule ID 13463 //
     /*  74100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74121 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74136 */     GIR_RootConstrainSelectedInstOperands,
     /*  74137 */     // GIR_Coverage, 13463,
     /*  74137 */     GIR_EraseRootFromParent_Done,
     /*  74138 */   // Label 1271: @74138
     /*  74138 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(74181), // Rule ID 3140 //
     /*  74143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74164 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74179 */     GIR_RootConstrainSelectedInstOperands,
     /*  74180 */     // GIR_Coverage, 3140,
     /*  74180 */     GIR_EraseRootFromParent_Done,
     /*  74181 */   // Label 1272: @74181
     /*  74181 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(74196), // Rule ID 7313 //
     /*  74186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74189 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  74189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74194 */     GIR_RootConstrainSelectedInstOperands,
     /*  74195 */     // GIR_Coverage, 7313,
     /*  74195 */     GIR_Done,
     /*  74196 */   // Label 1273: @74196
     /*  74196 */   GIM_Reject,
     /*  74197 */ // Label 1265: @74197
     /*  74197 */ GIM_Reject,
     /*  74198 */ // Label 1179: @74198
     /*  74198 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(74247), // Rule ID 8288 //
     /*  74203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  74209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  74212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74216 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  74216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  74223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74241 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74243 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74245 */   GIR_RootConstrainSelectedInstOperands,
     /*  74246 */   // GIR_Coverage, 8288,
     /*  74246 */   GIR_EraseRootFromParent_Done,
     /*  74247 */ // Label 1274: @74247
     /*  74247 */ GIM_Reject,
     /*  74248 */ // Label 1180: @74248
     /*  74248 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(74710),
     /*  74253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74263 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(74334), // Rule ID 15351 //
     /*  74268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74317 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74332 */     GIR_RootConstrainSelectedInstOperands,
     /*  74333 */     // GIR_Coverage, 15351,
     /*  74333 */     GIR_EraseRootFromParent_Done,
     /*  74334 */   // Label 1276: @74334
     /*  74334 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(74405), // Rule ID 15350 //
     /*  74339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74388 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74403 */     GIR_RootConstrainSelectedInstOperands,
     /*  74404 */     // GIR_Coverage, 15350,
     /*  74404 */     GIR_EraseRootFromParent_Done,
     /*  74405 */   // Label 1277: @74405
     /*  74405 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(74476), // Rule ID 15349 //
     /*  74410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74449 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74459 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74474 */     GIR_RootConstrainSelectedInstOperands,
     /*  74475 */     // GIR_Coverage, 15349,
     /*  74475 */     GIR_EraseRootFromParent_Done,
     /*  74476 */   // Label 1278: @74476
     /*  74476 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(74547), // Rule ID 11698 //
     /*  74481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74530 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74545 */     GIR_RootConstrainSelectedInstOperands,
     /*  74546 */     // GIR_Coverage, 11698,
     /*  74546 */     GIR_EraseRootFromParent_Done,
     /*  74547 */   // Label 1279: @74547
     /*  74547 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(74608), // Rule ID 11722 //
     /*  74552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  74575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74579 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74589 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74606 */     GIR_RootConstrainSelectedInstOperands,
     /*  74607 */     // GIR_Coverage, 11722,
     /*  74607 */     GIR_EraseRootFromParent_Done,
     /*  74608 */   // Label 1280: @74608
     /*  74608 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(74651), // Rule ID 13462 //
     /*  74613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74634 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74649 */     GIR_RootConstrainSelectedInstOperands,
     /*  74650 */     // GIR_Coverage, 13462,
     /*  74650 */     GIR_EraseRootFromParent_Done,
     /*  74651 */   // Label 1281: @74651
     /*  74651 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(74694), // Rule ID 3138 //
     /*  74656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74677 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74692 */     GIR_RootConstrainSelectedInstOperands,
     /*  74693 */     // GIR_Coverage, 3138,
     /*  74693 */     GIR_EraseRootFromParent_Done,
     /*  74694 */   // Label 1282: @74694
     /*  74694 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(74709), // Rule ID 7312 //
     /*  74699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74702 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  74702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74707 */     GIR_RootConstrainSelectedInstOperands,
     /*  74708 */     // GIR_Coverage, 7312,
     /*  74708 */     GIR_Done,
     /*  74709 */   // Label 1283: @74709
     /*  74709 */   GIM_Reject,
     /*  74710 */ // Label 1275: @74710
     /*  74710 */ GIM_Reject,
     /*  74711 */ // Label 1181: @74711
     /*  74711 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(74760), // Rule ID 8287 //
     /*  74716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  74722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  74725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74729 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  74729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  74736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74741 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74754 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74756 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74758 */   GIR_RootConstrainSelectedInstOperands,
     /*  74759 */   // GIR_Coverage, 8287,
     /*  74759 */   GIR_EraseRootFromParent_Done,
     /*  74760 */ // Label 1284: @74760
     /*  74760 */ GIM_Reject,
     /*  74761 */ // Label 1182: @74761
     /*  74761 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(75223),
     /*  74766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74776 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(74847), // Rule ID 15348 //
     /*  74781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74820 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74826 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74830 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74845 */     GIR_RootConstrainSelectedInstOperands,
     /*  74846 */     // GIR_Coverage, 15348,
     /*  74846 */     GIR_EraseRootFromParent_Done,
     /*  74847 */   // Label 1286: @74847
     /*  74847 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(74918), // Rule ID 15347 //
     /*  74852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74891 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74897 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74901 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74916 */     GIR_RootConstrainSelectedInstOperands,
     /*  74917 */     // GIR_Coverage, 15347,
     /*  74917 */     GIR_EraseRootFromParent_Done,
     /*  74918 */   // Label 1287: @74918
     /*  74918 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(74989), // Rule ID 15346 //
     /*  74923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74962 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74972 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74987 */     GIR_RootConstrainSelectedInstOperands,
     /*  74988 */     // GIR_Coverage, 15346,
     /*  74988 */     GIR_EraseRootFromParent_Done,
     /*  74989 */   // Label 1288: @74989
     /*  74989 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(75060), // Rule ID 11696 //
     /*  74994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75043 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75058 */     GIR_RootConstrainSelectedInstOperands,
     /*  75059 */     // GIR_Coverage, 11696,
     /*  75059 */     GIR_EraseRootFromParent_Done,
     /*  75060 */   // Label 1289: @75060
     /*  75060 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(75121), // Rule ID 11720 //
     /*  75065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  75088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75092 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75102 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75119 */     GIR_RootConstrainSelectedInstOperands,
     /*  75120 */     // GIR_Coverage, 11720,
     /*  75120 */     GIR_EraseRootFromParent_Done,
     /*  75121 */   // Label 1290: @75121
     /*  75121 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(75164), // Rule ID 13461 //
     /*  75126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75147 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75162 */     GIR_RootConstrainSelectedInstOperands,
     /*  75163 */     // GIR_Coverage, 13461,
     /*  75163 */     GIR_EraseRootFromParent_Done,
     /*  75164 */   // Label 1291: @75164
     /*  75164 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(75207), // Rule ID 3136 //
     /*  75169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75190 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75205 */     GIR_RootConstrainSelectedInstOperands,
     /*  75206 */     // GIR_Coverage, 3136,
     /*  75206 */     GIR_EraseRootFromParent_Done,
     /*  75207 */   // Label 1292: @75207
     /*  75207 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75222), // Rule ID 7311 //
     /*  75212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75215 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  75215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75220 */     GIR_RootConstrainSelectedInstOperands,
     /*  75221 */     // GIR_Coverage, 7311,
     /*  75221 */     GIR_Done,
     /*  75222 */   // Label 1293: @75222
     /*  75222 */   GIM_Reject,
     /*  75223 */ // Label 1285: @75223
     /*  75223 */ GIM_Reject,
     /*  75224 */ // Label 1183: @75224
     /*  75224 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75273), // Rule ID 8286 //
     /*  75229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  75235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  75238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  75242 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  75242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  75245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  75249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75254 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  75257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  75262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  75264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75267 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75269 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  75271 */   GIR_RootConstrainSelectedInstOperands,
     /*  75272 */   // GIR_Coverage, 8286,
     /*  75272 */   GIR_EraseRootFromParent_Done,
     /*  75273 */ // Label 1294: @75273
     /*  75273 */ GIM_Reject,
     /*  75274 */ // Label 1184: @75274
     /*  75274 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75736),
     /*  75279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  75289 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(75360), // Rule ID 15345 //
     /*  75294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75333 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75343 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75358 */     GIR_RootConstrainSelectedInstOperands,
     /*  75359 */     // GIR_Coverage, 15345,
     /*  75359 */     GIR_EraseRootFromParent_Done,
     /*  75360 */   // Label 1296: @75360
     /*  75360 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75431), // Rule ID 15344 //
     /*  75365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75404 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75414 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75429 */     GIR_RootConstrainSelectedInstOperands,
     /*  75430 */     // GIR_Coverage, 15344,
     /*  75430 */     GIR_EraseRootFromParent_Done,
     /*  75431 */   // Label 1297: @75431
     /*  75431 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75502), // Rule ID 15343 //
     /*  75436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75485 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75500 */     GIR_RootConstrainSelectedInstOperands,
     /*  75501 */     // GIR_Coverage, 15343,
     /*  75501 */     GIR_EraseRootFromParent_Done,
     /*  75502 */   // Label 1298: @75502
     /*  75502 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75573), // Rule ID 11694 //
     /*  75507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75546 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75556 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75571 */     GIR_RootConstrainSelectedInstOperands,
     /*  75572 */     // GIR_Coverage, 11694,
     /*  75572 */     GIR_EraseRootFromParent_Done,
     /*  75573 */   // Label 1299: @75573
     /*  75573 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75634), // Rule ID 11718 //
     /*  75578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75597 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  75601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75605 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75615 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75632 */     GIR_RootConstrainSelectedInstOperands,
     /*  75633 */     // GIR_Coverage, 11718,
     /*  75633 */     GIR_EraseRootFromParent_Done,
     /*  75634 */   // Label 1300: @75634
     /*  75634 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(75677), // Rule ID 13460 //
     /*  75639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75660 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75675 */     GIR_RootConstrainSelectedInstOperands,
     /*  75676 */     // GIR_Coverage, 13460,
     /*  75676 */     GIR_EraseRootFromParent_Done,
     /*  75677 */   // Label 1301: @75677
     /*  75677 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(75720), // Rule ID 3134 //
     /*  75682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75703 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75718 */     GIR_RootConstrainSelectedInstOperands,
     /*  75719 */     // GIR_Coverage, 3134,
     /*  75719 */     GIR_EraseRootFromParent_Done,
     /*  75720 */   // Label 1302: @75720
     /*  75720 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(75735), // Rule ID 7310 //
     /*  75725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75728 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  75728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75733 */     GIR_RootConstrainSelectedInstOperands,
     /*  75734 */     // GIR_Coverage, 7310,
     /*  75734 */     GIR_Done,
     /*  75735 */   // Label 1303: @75735
     /*  75735 */   GIM_Reject,
     /*  75736 */ // Label 1295: @75736
     /*  75736 */ GIM_Reject,
     /*  75737 */ // Label 1185: @75737
     /*  75737 */ GIM_Reject,
     /*  75738 */ // Label 8: @75738
     /*  75738 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(83261),
     /*  75743 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  75746 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1316*/ GIMT_Encode4(83260),
     /*  75757 */   /*GILLT_v2s64*//*Label 1305*/ GIMT_Encode4(75825), GIMT_Encode4(0),
     /*  75765 */   /*GILLT_v4s32*//*Label 1306*/ GIMT_Encode4(76346), GIMT_Encode4(0),
     /*  75773 */   /*GILLT_v8s16*//*Label 1307*/ GIMT_Encode4(78758),
     /*  75777 */   /*GILLT_v16s8*//*Label 1308*/ GIMT_Encode4(81167), GIMT_Encode4(0),
     /*  75785 */   /*GILLT_nxv2s1*//*Label 1309*/ GIMT_Encode4(83078), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75801 */   /*GILLT_nxv4s1*//*Label 1310*/ GIMT_Encode4(83104),
     /*  75805 */   /*GILLT_nxv4s16*//*Label 1311*/ GIMT_Encode4(83130),
     /*  75809 */   /*GILLT_nxv4s32*//*Label 1312*/ GIMT_Encode4(83156),
     /*  75813 */   /*GILLT_nxv8s1*//*Label 1313*/ GIMT_Encode4(83182),
     /*  75817 */   /*GILLT_nxv8s16*//*Label 1314*/ GIMT_Encode4(83208),
     /*  75821 */   /*GILLT_nxv16s1*//*Label 1315*/ GIMT_Encode4(83234),
     /*  75825 */   // Label 1305: @75825
     /*  75825 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(76345),
     /*  75830 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75844 */     GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(75906), // Rule ID 5698 //
     /*  75849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75853 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75859 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75861 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75863 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  75863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75875 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75886 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75892 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75895 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75900 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75905 */       // GIR_Coverage, 5698,
     /*  75905 */       GIR_EraseRootFromParent_Done,
     /*  75906 */     // Label 1318: @75906
     /*  75906 */     GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(75968), // Rule ID 5702 //
     /*  75911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75915 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75921 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75923 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75925 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  75925 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75928 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75932 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75937 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75941 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75943 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75946 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75948 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75967 */       // GIR_Coverage, 5702,
     /*  75967 */       GIR_EraseRootFromParent_Done,
     /*  75968 */     // Label 1319: @75968
     /*  75968 */     GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76026), // Rule ID 5699 //
     /*  75973 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75977 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  75981 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75983 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  75983 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  75986 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75990 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75997 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76000 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76002 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76005 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76007 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76010 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76015 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76020 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76025 */       // GIR_Coverage, 5699,
     /*  76025 */       GIR_EraseRootFromParent_Done,
     /*  76026 */     // Label 1320: @76026
     /*  76026 */     GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(76084), // Rule ID 5703 //
     /*  76031 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76035 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  76039 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76041 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  76041 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  76044 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76048 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76053 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76055 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76058 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76060 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76063 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76068 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76073 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76078 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76083 */       // GIR_Coverage, 5703,
     /*  76083 */       GIR_EraseRootFromParent_Done,
     /*  76084 */     // Label 1321: @76084
     /*  76084 */     GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(76214), // Rule ID 5697 //
     /*  76089 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76093 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76093 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76096 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76100 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76107 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76110 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76114 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76119 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76122 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76126 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76129 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76134 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76139 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76144 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76147 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76151 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76156 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76158 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76161 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76165 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76170 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76173 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76177 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76180 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76185 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76190 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76200 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76203 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76206 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76212 */       GIR_RootConstrainSelectedInstOperands,
     /*  76213 */       // GIR_Coverage, 5697,
     /*  76213 */       GIR_EraseRootFromParent_Done,
     /*  76214 */     // Label 1322: @76214
     /*  76214 */     GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76344), // Rule ID 5701 //
     /*  76219 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76223 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76223 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76226 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76230 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76237 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76240 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76244 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76249 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76252 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76256 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76259 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76264 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76269 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76274 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76277 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76281 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76286 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76288 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76291 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76295 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76300 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76307 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76336 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76339 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76342 */       GIR_RootConstrainSelectedInstOperands,
     /*  76343 */       // GIR_Coverage, 5701,
     /*  76343 */       GIR_EraseRootFromParent_Done,
     /*  76344 */     // Label 1323: @76344
     /*  76344 */     GIM_Reject,
     /*  76345 */   // Label 1317: @76345
     /*  76345 */   GIM_Reject,
     /*  76346 */   // Label 1306: @76346
     /*  76346 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78757),
     /*  76351 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  76354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  76357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76361 */     GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(76490), // Rule ID 5367 //
     /*  76366 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76370 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76374 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76378 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76382 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76386 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76390 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76394 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76398 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76402 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76406 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76410 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76415 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76419 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76425 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76427 */       // MIs[2] Operand 2
     /*  76427 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76438 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76440 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  76440 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76443 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76447 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76452 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76455 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76459 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76462 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76467 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76472 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76475 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76480 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76484 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76488 */       GIR_RootConstrainSelectedInstOperands,
     /*  76489 */       // GIR_Coverage, 5367,
     /*  76489 */       GIR_EraseRootFromParent_Done,
     /*  76490 */     // Label 1325: @76490
     /*  76490 */     GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(76612), // Rule ID 5363 //
     /*  76495 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76499 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76503 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76507 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76511 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76515 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76519 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76523 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76527 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76531 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76535 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76539 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76544 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76549 */       // MIs[2] Operand 2
     /*  76549 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76560 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76562 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76574 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76577 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76581 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76584 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76594 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  76597 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76599 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76606 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76610 */       GIR_RootConstrainSelectedInstOperands,
     /*  76611 */       // GIR_Coverage, 5363,
     /*  76611 */       GIR_EraseRootFromParent_Done,
     /*  76612 */     // Label 1326: @76612
     /*  76612 */     GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(76734), // Rule ID 5365 //
     /*  76617 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76621 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76625 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76629 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76633 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76637 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76641 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76645 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76649 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76653 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76657 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76661 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76666 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76671 */       // MIs[2] Operand 2
     /*  76671 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76682 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76684 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76684 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76687 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76691 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76696 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76703 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76728 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76732 */       GIR_RootConstrainSelectedInstOperands,
     /*  76733 */       // GIR_Coverage, 5365,
     /*  76733 */       GIR_EraseRootFromParent_Done,
     /*  76734 */     // Label 1327: @76734
     /*  76734 */     GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(76836), // Rule ID 5513 //
     /*  76739 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76743 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76747 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76751 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76755 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76759 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76763 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76768 */       // MIs[2] Operand 2
     /*  76768 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76779 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76783 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76787 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76791 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  76795 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76799 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76803 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76808 */       // MIs[4] Operand 2
     /*  76808 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  76819 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76821 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  76821 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  76824 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76826 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  76830 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  76834 */       GIR_RootConstrainSelectedInstOperands,
     /*  76835 */       // GIR_Coverage, 5513,
     /*  76835 */       GIR_EraseRootFromParent_Done,
     /*  76836 */     // Label 1328: @76836
     /*  76836 */     GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(76965), // Rule ID 6251 //
     /*  76841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  76853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  76856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  76861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  76869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76874 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  76878 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76880 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  76880 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  76883 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  76887 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76892 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  76895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  76897 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76900 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76904 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76909 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76911 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76914 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76918 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76923 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76926 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  76930 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76933 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76938 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76943 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76948 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  76951 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76953 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76956 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  76960 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76963 */       GIR_RootConstrainSelectedInstOperands,
     /*  76964 */       // GIR_Coverage, 6251,
     /*  76964 */       GIR_EraseRootFromParent_Done,
     /*  76965 */     // Label 1329: @76965
     /*  76965 */     GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(77007), // Rule ID 5708 //
     /*  76970 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76977 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76984 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  76984 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76987 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76989 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  76994 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77002 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77005 */       GIR_RootConstrainSelectedInstOperands,
     /*  77006 */       // GIR_Coverage, 5708,
     /*  77006 */       GIR_EraseRootFromParent_Done,
     /*  77007 */     // Label 1330: @77007
     /*  77007 */     GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(77049), // Rule ID 5712 //
     /*  77012 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77019 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77026 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  77026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  77029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77031 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  77036 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77047 */       GIR_RootConstrainSelectedInstOperands,
     /*  77048 */       // GIR_Coverage, 5712,
     /*  77048 */       GIR_EraseRootFromParent_Done,
     /*  77049 */     // Label 1331: @77049
     /*  77049 */     GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(77172), // Rule ID 2569 //
     /*  77054 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77057 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77061 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77065 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77069 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77072 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  77077 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77081 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  77085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77090 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77094 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77098 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77102 */       // MIs[2] Operand 1
     /*  77102 */       // No operand predicates
     /*  77102 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77104 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77104 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77107 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77111 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77116 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77118 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77121 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77125 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77130 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77133 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77137 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77140 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77155 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  77158 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77160 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77163 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77167 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  77170 */       GIR_RootConstrainSelectedInstOperands,
     /*  77171 */       // GIR_Coverage, 2569,
     /*  77171 */       GIR_EraseRootFromParent_Done,
     /*  77172 */     // Label 1332: @77172
     /*  77172 */     GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77295), // Rule ID 6219 //
     /*  77177 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77196 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77200 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  77204 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77208 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77213 */       // MIs[2] imm
     /*  77213 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77217 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77221 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77225 */       // MIs[3] Operand 1
     /*  77225 */       // No operand predicates
     /*  77225 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77227 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77227 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77230 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77234 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77239 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77241 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77244 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77248 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77253 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77256 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77260 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77263 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77268 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77273 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77283 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77290 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77293 */       GIR_RootConstrainSelectedInstOperands,
     /*  77294 */       // GIR_Coverage, 6219,
     /*  77294 */       GIR_EraseRootFromParent_Done,
     /*  77295 */     // Label 1333: @77295
     /*  77295 */     GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77415), // Rule ID 6257 //
     /*  77300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77312 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77316 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77320 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  77324 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77328 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77333 */       // MIs[2] imm
     /*  77333 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77337 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77341 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77345 */       // MIs[3] Operand 1
     /*  77345 */       // No operand predicates
     /*  77345 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77347 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  77347 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77350 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77354 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77359 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77361 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77364 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77368 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77373 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77380 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77383 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77398 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77401 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77403 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77406 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77410 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77413 */       GIR_RootConstrainSelectedInstOperands,
     /*  77414 */       // GIR_Coverage, 6257,
     /*  77414 */       GIR_EraseRootFromParent_Done,
     /*  77415 */     // Label 1334: @77415
     /*  77415 */     GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77532), // Rule ID 2492 //
     /*  77420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77423 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77427 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77431 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77435 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77438 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  77443 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77447 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77451 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77456 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77461 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77463 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77463 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77466 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77470 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77475 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77477 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77480 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77484 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77489 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77492 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77496 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77499 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77504 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77509 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77514 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  77517 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77519 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77522 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77526 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77530 */       GIR_RootConstrainSelectedInstOperands,
     /*  77531 */       // GIR_Coverage, 2492,
     /*  77531 */       GIR_EraseRootFromParent_Done,
     /*  77532 */     // Label 1335: @77532
     /*  77532 */     GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77649), // Rule ID 5283 //
     /*  77537 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77540 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77544 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77548 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77552 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77555 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  77560 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77564 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77578 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77580 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77580 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77583 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77587 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77592 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77594 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77597 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77601 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77606 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77609 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77613 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77631 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  77634 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77636 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77639 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77643 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77647 */       GIR_RootConstrainSelectedInstOperands,
     /*  77648 */       // GIR_Coverage, 5283,
     /*  77648 */       GIR_EraseRootFromParent_Done,
     /*  77649 */     // Label 1336: @77649
     /*  77649 */     GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77766), // Rule ID 5286 //
     /*  77654 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77657 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77661 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77665 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77669 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77672 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  77677 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77681 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77685 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77695 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77697 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77697 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77700 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77704 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77709 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77711 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77714 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77718 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77723 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77726 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77730 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77733 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  77751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77753 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77756 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77760 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77764 */       GIR_RootConstrainSelectedInstOperands,
     /*  77765 */       // GIR_Coverage, 5286,
     /*  77765 */       GIR_EraseRootFromParent_Done,
     /*  77766 */     // Label 1337: @77766
     /*  77766 */     GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77883), // Rule ID 5289 //
     /*  77771 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77786 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77789 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  77794 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77798 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77802 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77807 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77814 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77814 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77817 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77821 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77826 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77828 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77831 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77835 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77840 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77843 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77847 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77850 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77855 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  77868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77870 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77873 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77877 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77881 */       GIR_RootConstrainSelectedInstOperands,
     /*  77882 */       // GIR_Coverage, 5289,
     /*  77882 */       GIR_EraseRootFromParent_Done,
     /*  77883 */     // Label 1338: @77883
     /*  77883 */     GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77987), // Rule ID 2488 //
     /*  77888 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77891 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77903 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  77906 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  77911 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77915 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77920 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77922 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  77922 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77925 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77929 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77934 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77936 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77939 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77943 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77948 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77951 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77955 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77958 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  77976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77978 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77981 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77985 */       GIR_RootConstrainSelectedInstOperands,
     /*  77986 */       // GIR_Coverage, 2488,
     /*  77986 */       GIR_EraseRootFromParent_Done,
     /*  77987 */     // Label 1339: @77987
     /*  77987 */     GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(78043), // Rule ID 5446 //
     /*  77992 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77996 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78000 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78004 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78009 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78013 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78017 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78021 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78026 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78028 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  78028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  78031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  78033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  78037 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  78041 */       GIR_RootConstrainSelectedInstOperands,
     /*  78042 */       // GIR_Coverage, 5446,
     /*  78042 */       GIR_EraseRootFromParent_Done,
     /*  78043 */     // Label 1340: @78043
     /*  78043 */     GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(78109), // Rule ID 5706 //
     /*  78048 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78052 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78056 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78062 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78064 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78066 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  78066 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78069 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78073 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78078 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78082 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78089 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78092 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78095 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78098 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78103 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78108 */       // GIR_Coverage, 5706,
     /*  78108 */       GIR_EraseRootFromParent_Done,
     /*  78109 */     // Label 1341: @78109
     /*  78109 */     GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(78175), // Rule ID 5710 //
     /*  78114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78118 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78122 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78128 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78130 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78132 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  78132 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78135 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78139 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78148 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78150 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78153 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78155 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78158 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78161 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78164 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78169 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78174 */       // GIR_Coverage, 5710,
     /*  78174 */       GIR_EraseRootFromParent_Done,
     /*  78175 */     // Label 1342: @78175
     /*  78175 */     GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(78268), // Rule ID 4854 //
     /*  78180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  78192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78196 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78201 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78203 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  78203 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78206 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78210 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78229 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78232 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78236 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78249 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78254 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  78257 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78259 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78262 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78266 */       GIR_RootConstrainSelectedInstOperands,
     /*  78267 */       // GIR_Coverage, 4854,
     /*  78267 */       GIR_EraseRootFromParent_Done,
     /*  78268 */     // Label 1343: @78268
     /*  78268 */     GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(78364), // Rule ID 4901 //
     /*  78273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  78276 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78280 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78284 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78288 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78292 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78297 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78299 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  78299 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78302 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78306 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78311 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78325 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78328 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78332 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78335 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78340 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78350 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  78353 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78355 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78358 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78362 */       GIR_RootConstrainSelectedInstOperands,
     /*  78363 */       // GIR_Coverage, 4901,
     /*  78363 */       GIR_EraseRootFromParent_Done,
     /*  78364 */     // Label 1344: @78364
     /*  78364 */     GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78426), // Rule ID 5707 //
     /*  78369 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78373 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78377 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78381 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78383 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  78383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78395 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78397 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78400 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78402 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78405 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78407 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78410 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78415 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78420 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78425 */       // GIR_Coverage, 5707,
     /*  78425 */       GIR_EraseRootFromParent_Done,
     /*  78426 */     // Label 1345: @78426
     /*  78426 */     GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78488), // Rule ID 5711 //
     /*  78431 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78435 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78439 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78443 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78445 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  78445 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78448 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78452 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78457 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78464 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78467 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78469 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78472 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78487 */       // GIR_Coverage, 5711,
     /*  78487 */       GIR_EraseRootFromParent_Done,
     /*  78488 */     // Label 1346: @78488
     /*  78488 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78622), // Rule ID 5705 //
     /*  78493 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78497 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78501 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78501 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78504 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78508 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78515 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78518 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78522 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78527 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78530 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78534 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78537 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78542 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78547 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78552 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78555 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78559 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78564 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78566 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78569 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78573 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78578 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78581 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78593 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78598 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78608 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78611 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78614 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78617 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78620 */       GIR_RootConstrainSelectedInstOperands,
     /*  78621 */       // GIR_Coverage, 5705,
     /*  78621 */       GIR_EraseRootFromParent_Done,
     /*  78622 */     // Label 1347: @78622
     /*  78622 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(78756), // Rule ID 5709 //
     /*  78627 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78631 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78635 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78635 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78638 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78642 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78649 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78652 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78656 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78661 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78664 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78668 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78671 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78676 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78681 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78686 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78689 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78693 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78700 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78703 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78707 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78712 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78715 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78719 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78732 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78737 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78740 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78742 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78745 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78748 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78751 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78754 */       GIR_RootConstrainSelectedInstOperands,
     /*  78755 */       // GIR_Coverage, 5709,
     /*  78755 */       GIR_EraseRootFromParent_Done,
     /*  78756 */     // Label 1348: @78756
     /*  78756 */     GIM_Reject,
     /*  78757 */   // Label 1324: @78757
     /*  78757 */   GIM_Reject,
     /*  78758 */   // Label 1307: @78758
     /*  78758 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(81166),
     /*  78763 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  78766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  78769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78773 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(78902), // Rule ID 5361 //
     /*  78778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78790 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78794 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78798 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78802 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78806 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78810 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78814 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78818 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78822 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78827 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78831 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78837 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78839 */       // MIs[2] Operand 2
     /*  78839 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78850 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78852 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  78852 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78855 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78859 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78864 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  78887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78892 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  78896 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  78900 */       GIR_RootConstrainSelectedInstOperands,
     /*  78901 */       // GIR_Coverage, 5361,
     /*  78901 */       GIR_EraseRootFromParent_Done,
     /*  78902 */     // Label 1350: @78902
     /*  78902 */     GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79024), // Rule ID 5357 //
     /*  78907 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78915 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78919 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78923 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78927 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78931 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78935 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78939 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78943 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78947 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78951 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78956 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78961 */       // MIs[2] Operand 2
     /*  78961 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78972 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78974 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  78974 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78977 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78981 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78986 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78989 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78993 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79001 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79011 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79014 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79018 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79022 */       GIR_RootConstrainSelectedInstOperands,
     /*  79023 */       // GIR_Coverage, 5357,
     /*  79023 */       GIR_EraseRootFromParent_Done,
     /*  79024 */     // Label 1351: @79024
     /*  79024 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79146), // Rule ID 5359 //
     /*  79029 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79033 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79037 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79041 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79045 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79049 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79053 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79057 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79061 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79065 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79069 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79073 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79078 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79083 */       // MIs[2] Operand 2
     /*  79083 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79094 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79096 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79096 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79099 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79103 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79108 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79115 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79118 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79128 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  79131 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79133 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79136 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79140 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79144 */       GIR_RootConstrainSelectedInstOperands,
     /*  79145 */       // GIR_Coverage, 5359,
     /*  79145 */       GIR_EraseRootFromParent_Done,
     /*  79146 */     // Label 1352: @79146
     /*  79146 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79248), // Rule ID 5512 //
     /*  79151 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79155 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79159 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79163 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79167 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79171 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79175 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79180 */       // MIs[2] Operand 2
     /*  79180 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79191 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  79195 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79199 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79203 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  79207 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79211 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79215 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79220 */       // MIs[4] Operand 2
     /*  79220 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  79231 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79233 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  79233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  79236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  79238 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  79242 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  79246 */       GIR_RootConstrainSelectedInstOperands,
     /*  79247 */       // GIR_Coverage, 5512,
     /*  79247 */       GIR_EraseRootFromParent_Done,
     /*  79248 */     // Label 1353: @79248
     /*  79248 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79377), // Rule ID 6250 //
     /*  79253 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79257 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79261 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79265 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79268 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79273 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79277 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79281 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79286 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  79290 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79292 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  79292 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  79295 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  79299 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79304 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  79307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  79309 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79312 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79316 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79321 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79323 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79326 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79330 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79335 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79338 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  79342 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79350 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79355 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79360 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  79363 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79368 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  79372 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79375 */       GIR_RootConstrainSelectedInstOperands,
     /*  79376 */       // GIR_Coverage, 6250,
     /*  79376 */       GIR_EraseRootFromParent_Done,
     /*  79377 */     // Label 1354: @79377
     /*  79377 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79419), // Rule ID 5716 //
     /*  79382 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79389 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79396 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  79396 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79399 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79401 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79406 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79409 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79414 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79417 */       GIR_RootConstrainSelectedInstOperands,
     /*  79418 */       // GIR_Coverage, 5716,
     /*  79418 */       GIR_EraseRootFromParent_Done,
     /*  79419 */     // Label 1355: @79419
     /*  79419 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79461), // Rule ID 5720 //
     /*  79424 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79431 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79438 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  79438 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79441 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79443 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79448 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79451 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79456 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79459 */       GIR_RootConstrainSelectedInstOperands,
     /*  79460 */       // GIR_Coverage, 5720,
     /*  79460 */       GIR_EraseRootFromParent_Done,
     /*  79461 */     // Label 1356: @79461
     /*  79461 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79584), // Rule ID 2567 //
     /*  79466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79473 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79477 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79481 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79484 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79489 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79493 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79497 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79502 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  79506 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79510 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79514 */       // MIs[2] Operand 1
     /*  79514 */       // No operand predicates
     /*  79514 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79516 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79516 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79519 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79523 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79528 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79530 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79533 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79537 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79542 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79545 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79549 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79562 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  79570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79572 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79575 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79579 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  79582 */       GIR_RootConstrainSelectedInstOperands,
     /*  79583 */       // GIR_Coverage, 2567,
     /*  79583 */       GIR_EraseRootFromParent_Done,
     /*  79584 */     // Label 1357: @79584
     /*  79584 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79707), // Rule ID 6218 //
     /*  79589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79596 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79600 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79604 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79608 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79612 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  79616 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79620 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79625 */       // MIs[2] imm
     /*  79625 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79629 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79633 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79637 */       // MIs[3] Operand 1
     /*  79637 */       // No operand predicates
     /*  79637 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79639 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79639 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79642 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79646 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79651 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79653 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79656 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79660 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79665 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79668 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79672 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79675 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79695 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79702 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79705 */       GIR_RootConstrainSelectedInstOperands,
     /*  79706 */       // GIR_Coverage, 6218,
     /*  79706 */       GIR_EraseRootFromParent_Done,
     /*  79707 */     // Label 1358: @79707
     /*  79707 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(79827), // Rule ID 6256 //
     /*  79712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79716 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79720 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79724 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79728 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79732 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79736 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79740 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79745 */       // MIs[2] imm
     /*  79745 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79749 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79753 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79757 */       // MIs[3] Operand 1
     /*  79757 */       // No operand predicates
     /*  79757 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79759 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79759 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79762 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79766 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79771 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79773 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79776 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79780 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79785 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79788 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79792 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79795 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79815 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79818 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79822 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79825 */       GIR_RootConstrainSelectedInstOperands,
     /*  79826 */       // GIR_Coverage, 6256,
     /*  79826 */       GIR_EraseRootFromParent_Done,
     /*  79827 */     // Label 1359: @79827
     /*  79827 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79944), // Rule ID 2491 //
     /*  79832 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79835 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79839 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79843 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79847 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79850 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  79855 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79859 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79863 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79868 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79873 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79875 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79875 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79878 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79882 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79887 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79889 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79892 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79896 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79901 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79904 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79908 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79911 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79916 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79926 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79929 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79931 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79934 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79938 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  79942 */       GIR_RootConstrainSelectedInstOperands,
     /*  79943 */       // GIR_Coverage, 2491,
     /*  79943 */       GIR_EraseRootFromParent_Done,
     /*  79944 */     // Label 1360: @79944
     /*  79944 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80061), // Rule ID 5282 //
     /*  79949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79952 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79956 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79960 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79964 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79967 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  79972 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79976 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79980 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79985 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79990 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79992 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79992 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79995 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79999 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80004 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80006 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80009 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80013 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80018 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80021 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80025 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  80046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80048 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80051 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80055 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80059 */       GIR_RootConstrainSelectedInstOperands,
     /*  80060 */       // GIR_Coverage, 5282,
     /*  80060 */       GIR_EraseRootFromParent_Done,
     /*  80061 */     // Label 1361: @80061
     /*  80061 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80178), // Rule ID 5285 //
     /*  80066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80081 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80084 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  80089 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80093 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80097 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80102 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80107 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80109 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80109 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80112 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80116 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80121 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80123 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80126 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80130 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80135 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80138 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80142 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80155 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80160 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  80163 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80165 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80168 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80172 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80176 */       GIR_RootConstrainSelectedInstOperands,
     /*  80177 */       // GIR_Coverage, 5285,
     /*  80177 */       GIR_EraseRootFromParent_Done,
     /*  80178 */     // Label 1362: @80178
     /*  80178 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80295), // Rule ID 5288 //
     /*  80183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80186 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80190 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80194 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80198 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80201 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  80206 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80210 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80214 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80219 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80224 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80226 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80226 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80229 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80233 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80240 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80243 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80247 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80252 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80255 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80259 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80262 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80267 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  80280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80293 */       GIR_RootConstrainSelectedInstOperands,
     /*  80294 */       // GIR_Coverage, 5288,
     /*  80294 */       GIR_EraseRootFromParent_Done,
     /*  80295 */     // Label 1363: @80295
     /*  80295 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80396), // Rule ID 4848 //
     /*  80300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  80315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  80320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80331 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80394 */       GIR_RootConstrainSelectedInstOperands,
     /*  80395 */       // GIR_Coverage, 4848,
     /*  80395 */       GIR_EraseRootFromParent_Done,
     /*  80396 */     // Label 1364: @80396
     /*  80396 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80452), // Rule ID 5437 //
     /*  80401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80437 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  80437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  80440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  80446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  80450 */       GIR_RootConstrainSelectedInstOperands,
     /*  80451 */       // GIR_Coverage, 5437,
     /*  80451 */       GIR_EraseRootFromParent_Done,
     /*  80452 */     // Label 1365: @80452
     /*  80452 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80518), // Rule ID 5714 //
     /*  80457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80475 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  80475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80517 */       // GIR_Coverage, 5714,
     /*  80517 */       GIR_EraseRootFromParent_Done,
     /*  80518 */     // Label 1366: @80518
     /*  80518 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80584), // Rule ID 5718 //
     /*  80523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80541 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  80541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80583 */       // GIR_Coverage, 5718,
     /*  80583 */       GIR_EraseRootFromParent_Done,
     /*  80584 */     // Label 1367: @80584
     /*  80584 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80677), // Rule ID 4856 //
     /*  80589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  80601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80612 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80675 */       GIR_RootConstrainSelectedInstOperands,
     /*  80676 */       // GIR_Coverage, 4856,
     /*  80676 */       GIR_EraseRootFromParent_Done,
     /*  80677 */     // Label 1368: @80677
     /*  80677 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80773), // Rule ID 4900 //
     /*  80682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80708 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  80708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  80762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80771 */       GIR_RootConstrainSelectedInstOperands,
     /*  80772 */       // GIR_Coverage, 4900,
     /*  80772 */       GIR_EraseRootFromParent_Done,
     /*  80773 */     // Label 1369: @80773
     /*  80773 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80835), // Rule ID 5715 //
     /*  80778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80792 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  80792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80834 */       // GIR_Coverage, 5715,
     /*  80834 */       GIR_EraseRootFromParent_Done,
     /*  80835 */     // Label 1370: @80835
     /*  80835 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(80897), // Rule ID 5719 //
     /*  80840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80854 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  80854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80896 */       // GIR_Coverage, 5719,
     /*  80896 */       GIR_EraseRootFromParent_Done,
     /*  80897 */     // Label 1371: @80897
     /*  80897 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81031), // Rule ID 5713 //
     /*  80902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80910 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81029 */       GIR_RootConstrainSelectedInstOperands,
     /*  81030 */       // GIR_Coverage, 5713,
     /*  81030 */       GIR_EraseRootFromParent_Done,
     /*  81031 */     // Label 1372: @81031
     /*  81031 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81165), // Rule ID 5717 //
     /*  81036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81044 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81163 */       GIR_RootConstrainSelectedInstOperands,
     /*  81164 */       // GIR_Coverage, 5717,
     /*  81164 */       GIR_EraseRootFromParent_Done,
     /*  81165 */     // Label 1373: @81165
     /*  81165 */     GIM_Reject,
     /*  81166 */   // Label 1349: @81166
     /*  81166 */   GIM_Reject,
     /*  81167 */   // Label 1308: @81167
     /*  81167 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(83077),
     /*  81172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  81175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81182 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81311), // Rule ID 5355 //
     /*  81187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81248 */       // MIs[2] Operand 2
     /*  81248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81261 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  81261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81309 */       GIR_RootConstrainSelectedInstOperands,
     /*  81310 */       // GIR_Coverage, 5355,
     /*  81310 */       GIR_EraseRootFromParent_Done,
     /*  81311 */     // Label 1375: @81311
     /*  81311 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81433), // Rule ID 5351 //
     /*  81316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  81352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81370 */       // MIs[2] Operand 2
     /*  81370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81383 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  81418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81431 */       GIR_RootConstrainSelectedInstOperands,
     /*  81432 */       // GIR_Coverage, 5351,
     /*  81432 */       GIR_EraseRootFromParent_Done,
     /*  81433 */     // Label 1376: @81433
     /*  81433 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81555), // Rule ID 5353 //
     /*  81438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  81474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81492 */       // MIs[2] Operand 2
     /*  81492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81505 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81553 */       GIR_RootConstrainSelectedInstOperands,
     /*  81554 */       // GIR_Coverage, 5353,
     /*  81554 */       GIR_EraseRootFromParent_Done,
     /*  81555 */     // Label 1377: @81555
     /*  81555 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81657), // Rule ID 5511 //
     /*  81560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81589 */       // MIs[2] Operand 2
     /*  81589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81629 */       // MIs[4] Operand 2
     /*  81629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  81640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81642 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  81642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  81645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81655 */       GIR_RootConstrainSelectedInstOperands,
     /*  81656 */       // GIR_Coverage, 5511,
     /*  81656 */       GIR_EraseRootFromParent_Done,
     /*  81657 */     // Label 1378: @81657
     /*  81657 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81786), // Rule ID 6249 //
     /*  81662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  81699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81701 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  81701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  81704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  81772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81784 */       GIR_RootConstrainSelectedInstOperands,
     /*  81785 */       // GIR_Coverage, 6249,
     /*  81785 */       GIR_EraseRootFromParent_Done,
     /*  81786 */     // Label 1379: @81786
     /*  81786 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81828), // Rule ID 5724 //
     /*  81791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81805 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  81805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81826 */       GIR_RootConstrainSelectedInstOperands,
     /*  81827 */       // GIR_Coverage, 5724,
     /*  81827 */       GIR_EraseRootFromParent_Done,
     /*  81828 */     // Label 1380: @81828
     /*  81828 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(81951), // Rule ID 2565 //
     /*  81833 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81840 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81844 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81848 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81851 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81856 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81860 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81864 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81869 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81873 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81877 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  81881 */       // MIs[2] Operand 1
     /*  81881 */       // No operand predicates
     /*  81881 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81883 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  81883 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81886 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81890 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81897 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81900 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81904 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81909 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81912 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81916 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81919 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81924 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81934 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  81937 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81939 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81942 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81946 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81949 */       GIR_RootConstrainSelectedInstOperands,
     /*  81950 */       // GIR_Coverage, 2565,
     /*  81950 */       GIR_EraseRootFromParent_Done,
     /*  81951 */     // Label 1381: @81951
     /*  81951 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82074), // Rule ID 6217 //
     /*  81956 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81959 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81963 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81967 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81971 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81975 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81979 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81983 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81987 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81992 */       // MIs[2] imm
     /*  81992 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81996 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82000 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82004 */       // MIs[3] Operand 1
     /*  82004 */       // No operand predicates
     /*  82004 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82006 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82069 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82072 */       GIR_RootConstrainSelectedInstOperands,
     /*  82073 */       // GIR_Coverage, 6217,
     /*  82073 */       GIR_EraseRootFromParent_Done,
     /*  82074 */     // Label 1382: @82074
     /*  82074 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82194), // Rule ID 6255 //
     /*  82079 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82083 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82087 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82091 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82095 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82099 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82103 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82107 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82112 */       // MIs[2] imm
     /*  82112 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82116 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82120 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82124 */       // MIs[3] Operand 1
     /*  82124 */       // No operand predicates
     /*  82124 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82126 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82126 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82129 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82133 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82138 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82140 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82143 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82147 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82152 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82155 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82159 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82177 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82180 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82182 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82185 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82189 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82192 */       GIR_RootConstrainSelectedInstOperands,
     /*  82193 */       // GIR_Coverage, 6255,
     /*  82193 */       GIR_EraseRootFromParent_Done,
     /*  82194 */     // Label 1383: @82194
     /*  82194 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82311), // Rule ID 2490 //
     /*  82199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82202 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82206 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82210 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82214 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82217 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  82222 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82226 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82230 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82235 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82240 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82242 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82242 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82245 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82249 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82254 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82268 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82271 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82275 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  82296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82309 */       GIR_RootConstrainSelectedInstOperands,
     /*  82310 */       // GIR_Coverage, 2490,
     /*  82310 */       GIR_EraseRootFromParent_Done,
     /*  82311 */     // Label 1384: @82311
     /*  82311 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82428), // Rule ID 5281 //
     /*  82316 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82319 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82323 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82327 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82331 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82334 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  82339 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82343 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82347 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82352 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82357 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82359 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82359 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82362 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82366 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82371 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82385 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82388 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82392 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  82413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82415 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82418 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82422 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82426 */       GIR_RootConstrainSelectedInstOperands,
     /*  82427 */       // GIR_Coverage, 5281,
     /*  82427 */       GIR_EraseRootFromParent_Done,
     /*  82428 */     // Label 1385: @82428
     /*  82428 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82545), // Rule ID 5284 //
     /*  82433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82436 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82448 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82451 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  82456 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82460 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82464 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82469 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82474 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82476 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82476 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82479 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82483 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82502 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82505 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82509 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  82530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82532 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82535 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82539 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82543 */       GIR_RootConstrainSelectedInstOperands,
     /*  82544 */       // GIR_Coverage, 5284,
     /*  82544 */       GIR_EraseRootFromParent_Done,
     /*  82545 */     // Label 1386: @82545
     /*  82545 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82662), // Rule ID 5287 //
     /*  82550 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82553 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82557 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82561 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82565 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82568 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82573 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82577 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82586 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82591 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82593 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82593 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82596 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82600 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82619 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82622 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82626 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  82647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82652 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82660 */       GIR_RootConstrainSelectedInstOperands,
     /*  82661 */       // GIR_Coverage, 5287,
     /*  82661 */       GIR_EraseRootFromParent_Done,
     /*  82662 */     // Label 1387: @82662
     /*  82662 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82718), // Rule ID 5428 //
     /*  82667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82675 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82679 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82684 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82688 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82692 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82696 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82701 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82703 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  82703 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  82706 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82716 */       GIR_RootConstrainSelectedInstOperands,
     /*  82717 */       // GIR_Coverage, 5428,
     /*  82717 */       GIR_EraseRootFromParent_Done,
     /*  82718 */     // Label 1388: @82718
     /*  82718 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82784), // Rule ID 5722 //
     /*  82723 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82727 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82731 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82737 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82739 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82741 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  82741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82753 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82757 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82764 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82767 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82773 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82778 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82783 */       // GIR_Coverage, 5722,
     /*  82783 */       GIR_EraseRootFromParent_Done,
     /*  82784 */     // Label 1389: @82784
     /*  82784 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82880), // Rule ID 4899 //
     /*  82789 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82792 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82796 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82800 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82804 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82808 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82813 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82815 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  82815 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82818 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82822 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82829 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82832 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82836 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82841 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82844 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82848 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  82869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82871 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82874 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82878 */       GIR_RootConstrainSelectedInstOperands,
     /*  82879 */       // GIR_Coverage, 4899,
     /*  82879 */       GIR_EraseRootFromParent_Done,
     /*  82880 */     // Label 1390: @82880
     /*  82880 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(82942), // Rule ID 5723 //
     /*  82885 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82889 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82893 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82897 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82899 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  82899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  82902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82911 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82918 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82921 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82923 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82931 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82936 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82941 */       // GIR_Coverage, 5723,
     /*  82941 */       GIR_EraseRootFromParent_Done,
     /*  82942 */     // Label 1391: @82942
     /*  82942 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83076), // Rule ID 5721 //
     /*  82947 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82951 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82955 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82955 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82958 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82962 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82969 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82972 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82976 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82981 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82984 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82988 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82991 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82996 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83001 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83071 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83074 */       GIR_RootConstrainSelectedInstOperands,
     /*  83075 */       // GIR_Coverage, 5721,
     /*  83075 */       GIR_EraseRootFromParent_Done,
     /*  83076 */     // Label 1392: @83076
     /*  83076 */     GIM_Reject,
     /*  83077 */   // Label 1374: @83077
     /*  83077 */   GIM_Reject,
     /*  83078 */   // Label 1309: @83078
     /*  83078 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83103), // Rule ID 8917 //
     /*  83083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83086 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  83089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  83092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83096 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  83096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  83101 */     GIR_RootConstrainSelectedInstOperands,
     /*  83102 */     // GIR_Coverage, 8917,
     /*  83102 */     GIR_Done,
     /*  83103 */   // Label 1393: @83103
     /*  83103 */   GIM_Reject,
     /*  83104 */   // Label 1310: @83104
     /*  83104 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83129), // Rule ID 8918 //
     /*  83109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83112 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  83115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  83118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83122 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  83122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  83127 */     GIR_RootConstrainSelectedInstOperands,
     /*  83128 */     // GIR_Coverage, 8918,
     /*  83128 */     GIR_Done,
     /*  83129 */   // Label 1394: @83129
     /*  83129 */   GIM_Reject,
     /*  83130 */   // Label 1311: @83130
     /*  83130 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83155), // Rule ID 8921 //
     /*  83135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83138 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  83141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  83144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83148 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  83148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83153 */     GIR_RootConstrainSelectedInstOperands,
     /*  83154 */     // GIR_Coverage, 8921,
     /*  83154 */     GIR_Done,
     /*  83155 */   // Label 1395: @83155
     /*  83155 */   GIM_Reject,
     /*  83156 */   // Label 1312: @83156
     /*  83156 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83181), // Rule ID 8923 //
     /*  83161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83164 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  83167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  83170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83174 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  83174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83179 */     GIR_RootConstrainSelectedInstOperands,
     /*  83180 */     // GIR_Coverage, 8923,
     /*  83180 */     GIR_Done,
     /*  83181 */   // Label 1396: @83181
     /*  83181 */   GIM_Reject,
     /*  83182 */   // Label 1313: @83182
     /*  83182 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83207), // Rule ID 8919 //
     /*  83187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83190 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  83193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  83196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83200 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  83200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  83205 */     GIR_RootConstrainSelectedInstOperands,
     /*  83206 */     // GIR_Coverage, 8919,
     /*  83206 */     GIR_Done,
     /*  83207 */   // Label 1397: @83207
     /*  83207 */   GIM_Reject,
     /*  83208 */   // Label 1314: @83208
     /*  83208 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83233), // Rule ID 8922 //
     /*  83213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83216 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  83219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  83222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83226 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  83226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  83231 */     GIR_RootConstrainSelectedInstOperands,
     /*  83232 */     // GIR_Coverage, 8922,
     /*  83232 */     GIR_Done,
     /*  83233 */   // Label 1398: @83233
     /*  83233 */   GIM_Reject,
     /*  83234 */   // Label 1315: @83234
     /*  83234 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83259), // Rule ID 8920 //
     /*  83239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83242 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  83245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  83248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83252 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  83252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 8920,
     /*  83258 */     GIR_Done,
     /*  83259 */   // Label 1399: @83259
     /*  83259 */   GIM_Reject,
     /*  83260 */   // Label 1316: @83260
     /*  83260 */   GIM_Reject,
     /*  83261 */ // Label 1304: @83261
     /*  83261 */ GIM_Reject,
     /*  83262 */ // Label 9: @83262
     /*  83262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1414*/ GIMT_Encode4(93205),
     /*  83273 */ /*GILLT_s32*//*Label 1400*/ GIMT_Encode4(83361),
     /*  83277 */ /*GILLT_s64*//*Label 1401*/ GIMT_Encode4(83742),
     /*  83281 */ /*GILLT_s128*//*Label 1402*/ GIMT_Encode4(85717),
     /*  83285 */ /*GILLT_v2s32*//*Label 1403*/ GIMT_Encode4(86363),
     /*  83289 */ /*GILLT_v2s64*//*Label 1404*/ GIMT_Encode4(87278),
     /*  83293 */ /*GILLT_v4s16*//*Label 1405*/ GIMT_Encode4(88047),
     /*  83297 */ /*GILLT_v4s32*//*Label 1406*/ GIMT_Encode4(88962),
     /*  83301 */ /*GILLT_v8s8*//*Label 1407*/ GIMT_Encode4(89807),
     /*  83305 */ /*GILLT_v8s16*//*Label 1408*/ GIMT_Encode4(90368),
     /*  83309 */ /*GILLT_v16s8*//*Label 1409*/ GIMT_Encode4(91213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83329 */ /*GILLT_nxv2s64*//*Label 1410*/ GIMT_Encode4(91665), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83341 */ /*GILLT_nxv4s32*//*Label 1411*/ GIMT_Encode4(92114), GIMT_Encode4(0),
     /*  83349 */ /*GILLT_nxv8s16*//*Label 1412*/ GIMT_Encode4(92563), GIMT_Encode4(0),
     /*  83357 */ /*GILLT_nxv16s8*//*Label 1413*/ GIMT_Encode4(93012),
     /*  83361 */ // Label 1400: @83361
     /*  83361 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(83741),
     /*  83366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  83369 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(83439), // Rule ID 6968 //
     /*  83374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83386 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83389 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83396 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  83412 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  83412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  83415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 6968,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1416: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(83509), // Rule ID 6969 //
     /*  83444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83456 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83459 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83466 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  83482 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  83482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  83485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83507 */     GIR_RootConstrainSelectedInstOperands,
     /*  83508 */     // GIR_Coverage, 6969,
     /*  83508 */     GIR_EraseRootFromParent_Done,
     /*  83509 */   // Label 1417: @83509
     /*  83509 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(83574), // Rule ID 6970 //
     /*  83514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83526 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83529 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83536 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  83552 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  83555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83572 */     GIR_RootConstrainSelectedInstOperands,
     /*  83573 */     // GIR_Coverage, 6970,
     /*  83573 */     GIR_EraseRootFromParent_Done,
     /*  83574 */   // Label 1418: @83574
     /*  83574 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(83639), // Rule ID 6971 //
     /*  83579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83591 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83594 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83601 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  83617 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  83617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  83620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83637 */     GIR_RootConstrainSelectedInstOperands,
     /*  83638 */     // GIR_Coverage, 6971,
     /*  83638 */     GIR_EraseRootFromParent_Done,
     /*  83639 */   // Label 1419: @83639
     /*  83639 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(83692), // Rule ID 5688 //
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  83656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  83664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  83668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83670 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  83670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83675 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  83681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83691 */     // GIR_Coverage, 5688,
     /*  83691 */     GIR_EraseRootFromParent_Done,
     /*  83692 */   // Label 1420: @83692
     /*  83692 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(83716), // Rule ID 6581 //
     /*  83697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83705 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  83705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83715 */     // GIR_Coverage, 6581,
     /*  83715 */     GIR_Done,
     /*  83716 */   // Label 1421: @83716
     /*  83716 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(83740), // Rule ID 6582 //
     /*  83721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83729 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  83729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83739 */     // GIR_Coverage, 6582,
     /*  83739 */     GIR_Done,
     /*  83740 */   // Label 1422: @83740
     /*  83740 */   GIM_Reject,
     /*  83741 */ // Label 1415: @83741
     /*  83741 */ GIM_Reject,
     /*  83742 */ // Label 1401: @83742
     /*  83742 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(83815), // Rule ID 6972 //
     /*  83747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83762 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83765 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83772 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83775 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83781 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  83788 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  83788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  83791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83813 */   GIR_RootConstrainSelectedInstOperands,
     /*  83814 */   // GIR_Coverage, 6972,
     /*  83814 */   GIR_EraseRootFromParent_Done,
     /*  83815 */ // Label 1423: @83815
     /*  83815 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(83888), // Rule ID 6973 //
     /*  83820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83838 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83848 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83854 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  83861 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  83861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  83864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83886 */   GIR_RootConstrainSelectedInstOperands,
     /*  83887 */   // GIR_Coverage, 6973,
     /*  83887 */   GIR_EraseRootFromParent_Done,
     /*  83888 */ // Label 1424: @83888
     /*  83888 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(83956), // Rule ID 6974 //
     /*  83893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83911 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  83934 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  83937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83954 */   GIR_RootConstrainSelectedInstOperands,
     /*  83955 */   // GIR_Coverage, 6974,
     /*  83955 */   GIR_EraseRootFromParent_Done,
     /*  83956 */ // Label 1425: @83956
     /*  83956 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(84024), // Rule ID 6975 //
     /*  83961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83979 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83986 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83995 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  84002 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  84002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  84005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  84007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  84012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  84022 */   GIR_RootConstrainSelectedInstOperands,
     /*  84023 */   // GIR_Coverage, 6975,
     /*  84023 */   GIR_EraseRootFromParent_Done,
     /*  84024 */ // Label 1426: @84024
     /*  84024 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(84080), // Rule ID 5690 //
     /*  84029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  84044 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  84048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  84052 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  84056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84058 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  84058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84063 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  84069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84079 */   // GIR_Coverage, 5690,
     /*  84079 */   GIR_EraseRootFromParent_Done,
     /*  84080 */ // Label 1427: @84080
     /*  84080 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(84110), // Rule ID 6556 //
     /*  84085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84099 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  84099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84109 */   // GIR_Coverage, 6556,
     /*  84109 */   GIR_Done,
     /*  84110 */ // Label 1428: @84110
     /*  84110 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(84140), // Rule ID 6557 //
     /*  84115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84129 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  84129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84139 */   // GIR_Coverage, 6557,
     /*  84139 */   GIR_Done,
     /*  84140 */ // Label 1429: @84140
     /*  84140 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(84170), // Rule ID 6558 //
     /*  84145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84159 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  84159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84169 */   // GIR_Coverage, 6558,
     /*  84169 */   GIR_Done,
     /*  84170 */ // Label 1430: @84170
     /*  84170 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(84200), // Rule ID 6559 //
     /*  84175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84189 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  84189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84199 */   // GIR_Coverage, 6559,
     /*  84199 */   GIR_Done,
     /*  84200 */ // Label 1431: @84200
     /*  84200 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(84230), // Rule ID 6560 //
     /*  84205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84219 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  84219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84229 */   // GIR_Coverage, 6560,
     /*  84229 */   GIR_Done,
     /*  84230 */ // Label 1432: @84230
     /*  84230 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(84260), // Rule ID 6561 //
     /*  84235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84249 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84259 */   // GIR_Coverage, 6561,
     /*  84259 */   GIR_Done,
     /*  84260 */ // Label 1433: @84260
     /*  84260 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(84310), // Rule ID 6567 //
     /*  84265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84279 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  84279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84308 */   GIR_RootConstrainSelectedInstOperands,
     /*  84309 */   // GIR_Coverage, 6567,
     /*  84309 */   GIR_EraseRootFromParent_Done,
     /*  84310 */ // Label 1434: @84310
     /*  84310 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(84360), // Rule ID 6568 //
     /*  84315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84329 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84358 */   GIR_RootConstrainSelectedInstOperands,
     /*  84359 */   // GIR_Coverage, 6568,
     /*  84359 */   GIR_EraseRootFromParent_Done,
     /*  84360 */ // Label 1435: @84360
     /*  84360 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(84410), // Rule ID 6569 //
     /*  84365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84379 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84408 */   GIR_RootConstrainSelectedInstOperands,
     /*  84409 */   // GIR_Coverage, 6569,
     /*  84409 */   GIR_EraseRootFromParent_Done,
     /*  84410 */ // Label 1436: @84410
     /*  84410 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(84460), // Rule ID 6570 //
     /*  84415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84429 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84458 */   GIR_RootConstrainSelectedInstOperands,
     /*  84459 */   // GIR_Coverage, 6570,
     /*  84459 */   GIR_EraseRootFromParent_Done,
     /*  84460 */ // Label 1437: @84460
     /*  84460 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(84510), // Rule ID 6571 //
     /*  84465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84479 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84508 */   GIR_RootConstrainSelectedInstOperands,
     /*  84509 */   // GIR_Coverage, 6571,
     /*  84509 */   GIR_EraseRootFromParent_Done,
     /*  84510 */ // Label 1438: @84510
     /*  84510 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(84537), // Rule ID 6572 //
     /*  84515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84526 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84536 */   // GIR_Coverage, 6572,
     /*  84536 */   GIR_Done,
     /*  84537 */ // Label 1439: @84537
     /*  84537 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(84564), // Rule ID 6573 //
     /*  84542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84553 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84563 */   // GIR_Coverage, 6573,
     /*  84563 */   GIR_Done,
     /*  84564 */ // Label 1440: @84564
     /*  84564 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(84591), // Rule ID 6574 //
     /*  84569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84580 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  84580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84590 */   // GIR_Coverage, 6574,
     /*  84590 */   GIR_Done,
     /*  84591 */ // Label 1441: @84591
     /*  84591 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(84618), // Rule ID 6583 //
     /*  84596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84607 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84617 */   // GIR_Coverage, 6583,
     /*  84617 */   GIR_Done,
     /*  84618 */ // Label 1442: @84618
     /*  84618 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(84645), // Rule ID 6584 //
     /*  84623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84634 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  84634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84644 */   // GIR_Coverage, 6584,
     /*  84644 */   GIR_Done,
     /*  84645 */ // Label 1443: @84645
     /*  84645 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(84672), // Rule ID 6585 //
     /*  84650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84661 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84671 */   // GIR_Coverage, 6585,
     /*  84671 */   GIR_Done,
     /*  84672 */ // Label 1444: @84672
     /*  84672 */ GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(84704), // Rule ID 6586 //
     /*  84677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84691 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84694 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84696 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84703 */   // GIR_Coverage, 6586,
     /*  84703 */   GIR_EraseRootFromParent_Done,
     /*  84704 */ // Label 1445: @84704
     /*  84704 */ GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(84736), // Rule ID 6587 //
     /*  84709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84723 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84726 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84728 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84735 */   // GIR_Coverage, 6587,
     /*  84735 */   GIR_EraseRootFromParent_Done,
     /*  84736 */ // Label 1446: @84736
     /*  84736 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(84768), // Rule ID 6588 //
     /*  84741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84755 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84758 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84767 */   // GIR_Coverage, 6588,
     /*  84767 */   GIR_EraseRootFromParent_Done,
     /*  84768 */ // Label 1447: @84768
     /*  84768 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(84800), // Rule ID 6589 //
     /*  84773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84787 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84790 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84799 */   // GIR_Coverage, 6589,
     /*  84799 */   GIR_EraseRootFromParent_Done,
     /*  84800 */ // Label 1448: @84800
     /*  84800 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(84832), // Rule ID 6590 //
     /*  84805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84819 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84822 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84831 */   // GIR_Coverage, 6590,
     /*  84831 */   GIR_EraseRootFromParent_Done,
     /*  84832 */ // Label 1449: @84832
     /*  84832 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(84858), // Rule ID 6591 //
     /*  84837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84851 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  84851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84856 */   GIR_RootConstrainSelectedInstOperands,
     /*  84857 */   // GIR_Coverage, 6591,
     /*  84857 */   GIR_Done,
     /*  84858 */ // Label 1450: @84858
     /*  84858 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(84884), // Rule ID 6592 //
     /*  84863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84877 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  84877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84882 */   GIR_RootConstrainSelectedInstOperands,
     /*  84883 */   // GIR_Coverage, 6592,
     /*  84883 */   GIR_Done,
     /*  84884 */ // Label 1451: @84884
     /*  84884 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(84910), // Rule ID 6593 //
     /*  84889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84903 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  84903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84908 */   GIR_RootConstrainSelectedInstOperands,
     /*  84909 */   // GIR_Coverage, 6593,
     /*  84909 */   GIR_Done,
     /*  84910 */ // Label 1452: @84910
     /*  84910 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(84936), // Rule ID 6594 //
     /*  84915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84929 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  84929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84934 */   GIR_RootConstrainSelectedInstOperands,
     /*  84935 */   // GIR_Coverage, 6594,
     /*  84935 */   GIR_Done,
     /*  84936 */ // Label 1453: @84936
     /*  84936 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(84962), // Rule ID 6595 //
     /*  84941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84955 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  84955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84960 */   GIR_RootConstrainSelectedInstOperands,
     /*  84961 */   // GIR_Coverage, 6595,
     /*  84961 */   GIR_Done,
     /*  84962 */ // Label 1454: @84962
     /*  84962 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(84991), // Rule ID 6596 //
     /*  84967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84978 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84990 */   // GIR_Coverage, 6596,
     /*  84990 */   GIR_EraseRootFromParent_Done,
     /*  84991 */ // Label 1455: @84991
     /*  84991 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(85020), // Rule ID 6597 //
     /*  84996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85007 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  85007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85019 */   // GIR_Coverage, 6597,
     /*  85019 */   GIR_EraseRootFromParent_Done,
     /*  85020 */ // Label 1456: @85020
     /*  85020 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(85052), // Rule ID 6651 //
     /*  85025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85039 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85051 */   // GIR_Coverage, 6651,
     /*  85051 */   GIR_EraseRootFromParent_Done,
     /*  85052 */ // Label 1457: @85052
     /*  85052 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(85084), // Rule ID 6652 //
     /*  85057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85071 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85083 */   // GIR_Coverage, 6652,
     /*  85083 */   GIR_EraseRootFromParent_Done,
     /*  85084 */ // Label 1458: @85084
     /*  85084 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(85116), // Rule ID 6653 //
     /*  85089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85103 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85115 */   // GIR_Coverage, 6653,
     /*  85115 */   GIR_EraseRootFromParent_Done,
     /*  85116 */ // Label 1459: @85116
     /*  85116 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(85148), // Rule ID 6654 //
     /*  85121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85135 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85147 */   // GIR_Coverage, 6654,
     /*  85147 */   GIR_EraseRootFromParent_Done,
     /*  85148 */ // Label 1460: @85148
     /*  85148 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(85180), // Rule ID 6655 //
     /*  85153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85167 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85179 */   // GIR_Coverage, 6655,
     /*  85179 */   GIR_EraseRootFromParent_Done,
     /*  85180 */ // Label 1461: @85180
     /*  85180 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(85206), // Rule ID 6656 //
     /*  85185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85199 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85204 */   GIR_RootConstrainSelectedInstOperands,
     /*  85205 */   // GIR_Coverage, 6656,
     /*  85205 */   GIR_Done,
     /*  85206 */ // Label 1462: @85206
     /*  85206 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(85232), // Rule ID 6657 //
     /*  85211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85225 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85230 */   GIR_RootConstrainSelectedInstOperands,
     /*  85231 */   // GIR_Coverage, 6657,
     /*  85231 */   GIR_Done,
     /*  85232 */ // Label 1463: @85232
     /*  85232 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(85258), // Rule ID 6658 //
     /*  85237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85251 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85256 */   GIR_RootConstrainSelectedInstOperands,
     /*  85257 */   // GIR_Coverage, 6658,
     /*  85257 */   GIR_Done,
     /*  85258 */ // Label 1464: @85258
     /*  85258 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(85284), // Rule ID 6659 //
     /*  85263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85277 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85282 */   GIR_RootConstrainSelectedInstOperands,
     /*  85283 */   // GIR_Coverage, 6659,
     /*  85283 */   GIR_Done,
     /*  85284 */ // Label 1465: @85284
     /*  85284 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(85310), // Rule ID 6660 //
     /*  85289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85303 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85308 */   GIR_RootConstrainSelectedInstOperands,
     /*  85309 */   // GIR_Coverage, 6660,
     /*  85309 */   GIR_Done,
     /*  85310 */ // Label 1466: @85310
     /*  85310 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(85339), // Rule ID 6661 //
     /*  85315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85326 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85338 */   // GIR_Coverage, 6661,
     /*  85338 */   GIR_EraseRootFromParent_Done,
     /*  85339 */ // Label 1467: @85339
     /*  85339 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(85368), // Rule ID 6662 //
     /*  85344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85355 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85367 */   // GIR_Coverage, 6662,
     /*  85367 */   GIR_EraseRootFromParent_Done,
     /*  85368 */ // Label 1468: @85368
     /*  85368 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(85400), // Rule ID 6663 //
     /*  85373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85387 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85399 */   // GIR_Coverage, 6663,
     /*  85399 */   GIR_EraseRootFromParent_Done,
     /*  85400 */ // Label 1469: @85400
     /*  85400 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(85432), // Rule ID 6664 //
     /*  85405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85419 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85431 */   // GIR_Coverage, 6664,
     /*  85431 */   GIR_EraseRootFromParent_Done,
     /*  85432 */ // Label 1470: @85432
     /*  85432 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(85464), // Rule ID 6665 //
     /*  85437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85451 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85463 */   // GIR_Coverage, 6665,
     /*  85463 */   GIR_EraseRootFromParent_Done,
     /*  85464 */ // Label 1471: @85464
     /*  85464 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(85496), // Rule ID 6666 //
     /*  85469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85483 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85495 */   // GIR_Coverage, 6666,
     /*  85495 */   GIR_EraseRootFromParent_Done,
     /*  85496 */ // Label 1472: @85496
     /*  85496 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(85528), // Rule ID 6667 //
     /*  85501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85515 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85527 */   // GIR_Coverage, 6667,
     /*  85527 */   GIR_EraseRootFromParent_Done,
     /*  85528 */ // Label 1473: @85528
     /*  85528 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(85554), // Rule ID 6668 //
     /*  85533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85547 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85552 */   GIR_RootConstrainSelectedInstOperands,
     /*  85553 */   // GIR_Coverage, 6668,
     /*  85553 */   GIR_Done,
     /*  85554 */ // Label 1474: @85554
     /*  85554 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(85580), // Rule ID 6669 //
     /*  85559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85573 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85578 */   GIR_RootConstrainSelectedInstOperands,
     /*  85579 */   // GIR_Coverage, 6669,
     /*  85579 */   GIR_Done,
     /*  85580 */ // Label 1475: @85580
     /*  85580 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(85606), // Rule ID 6670 //
     /*  85585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85599 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85604 */   GIR_RootConstrainSelectedInstOperands,
     /*  85605 */   // GIR_Coverage, 6670,
     /*  85605 */   GIR_Done,
     /*  85606 */ // Label 1476: @85606
     /*  85606 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(85632), // Rule ID 6671 //
     /*  85611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85625 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85630 */   GIR_RootConstrainSelectedInstOperands,
     /*  85631 */   // GIR_Coverage, 6671,
     /*  85631 */   GIR_Done,
     /*  85632 */ // Label 1477: @85632
     /*  85632 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(85658), // Rule ID 6672 //
     /*  85637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85651 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85656 */   GIR_RootConstrainSelectedInstOperands,
     /*  85657 */   // GIR_Coverage, 6672,
     /*  85657 */   GIR_Done,
     /*  85658 */ // Label 1478: @85658
     /*  85658 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(85687), // Rule ID 6673 //
     /*  85663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85674 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85686 */   // GIR_Coverage, 6673,
     /*  85686 */   GIR_EraseRootFromParent_Done,
     /*  85687 */ // Label 1479: @85687
     /*  85687 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(85716), // Rule ID 6674 //
     /*  85692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85703 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85706 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85708 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85715 */   // GIR_Coverage, 6674,
     /*  85715 */   GIR_EraseRootFromParent_Done,
     /*  85716 */ // Label 1480: @85716
     /*  85716 */ GIM_Reject,
     /*  85717 */ // Label 1402: @85717
     /*  85717 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(85749), // Rule ID 6688 //
     /*  85722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85736 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85748 */   // GIR_Coverage, 6688,
     /*  85748 */   GIR_EraseRootFromParent_Done,
     /*  85749 */ // Label 1481: @85749
     /*  85749 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(85781), // Rule ID 6689 //
     /*  85754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85768 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85780 */   // GIR_Coverage, 6689,
     /*  85780 */   GIR_EraseRootFromParent_Done,
     /*  85781 */ // Label 1482: @85781
     /*  85781 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(85813), // Rule ID 6690 //
     /*  85786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85800 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85812 */   // GIR_Coverage, 6690,
     /*  85812 */   GIR_EraseRootFromParent_Done,
     /*  85813 */ // Label 1483: @85813
     /*  85813 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(85845), // Rule ID 6691 //
     /*  85818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85832 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85844 */   // GIR_Coverage, 6691,
     /*  85844 */   GIR_EraseRootFromParent_Done,
     /*  85845 */ // Label 1484: @85845
     /*  85845 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(85877), // Rule ID 6692 //
     /*  85850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85864 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85876 */   // GIR_Coverage, 6692,
     /*  85876 */   GIR_EraseRootFromParent_Done,
     /*  85877 */ // Label 1485: @85877
     /*  85877 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(85909), // Rule ID 6693 //
     /*  85882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85896 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85908 */   // GIR_Coverage, 6693,
     /*  85908 */   GIR_EraseRootFromParent_Done,
     /*  85909 */ // Label 1486: @85909
     /*  85909 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(85941), // Rule ID 6694 //
     /*  85914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  85920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85928 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85931 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85933 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85940 */   // GIR_Coverage, 6694,
     /*  85940 */   GIR_EraseRootFromParent_Done,
     /*  85941 */ // Label 1487: @85941
     /*  85941 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(85974), // Rule ID 6695 //
     /*  85946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85960 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  85960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  85963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  85972 */   GIR_RootConstrainSelectedInstOperands,
     /*  85973 */   // GIR_Coverage, 6695,
     /*  85973 */   GIR_EraseRootFromParent_Done,
     /*  85974 */ // Label 1488: @85974
     /*  85974 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(86045), // Rule ID 6696 //
     /*  85979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85993 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  85993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86005 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86043 */   GIR_RootConstrainSelectedInstOperands,
     /*  86044 */   // GIR_Coverage, 6696,
     /*  86044 */   GIR_EraseRootFromParent_Done,
     /*  86045 */ // Label 1489: @86045
     /*  86045 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(86116), // Rule ID 6697 //
     /*  86050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86064 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  86064 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86067 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86071 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86076 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86094 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86114 */   GIR_RootConstrainSelectedInstOperands,
     /*  86115 */   // GIR_Coverage, 6697,
     /*  86115 */   GIR_EraseRootFromParent_Done,
     /*  86116 */ // Label 1490: @86116
     /*  86116 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(86187), // Rule ID 6698 //
     /*  86121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86135 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  86135 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86138 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86142 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86147 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86185 */   GIR_RootConstrainSelectedInstOperands,
     /*  86186 */   // GIR_Coverage, 6698,
     /*  86186 */   GIR_EraseRootFromParent_Done,
     /*  86187 */ // Label 1491: @86187
     /*  86187 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(86220), // Rule ID 6699 //
     /*  86192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  86198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86206 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  86206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86211 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86218 */   GIR_RootConstrainSelectedInstOperands,
     /*  86219 */   // GIR_Coverage, 6699,
     /*  86219 */   GIR_EraseRootFromParent_Done,
     /*  86220 */ // Label 1492: @86220
     /*  86220 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(86291), // Rule ID 6700 //
     /*  86225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  86231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86239 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  86239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86251 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86289 */   GIR_RootConstrainSelectedInstOperands,
     /*  86290 */   // GIR_Coverage, 6700,
     /*  86290 */   GIR_EraseRootFromParent_Done,
     /*  86291 */ // Label 1493: @86291
     /*  86291 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(86362), // Rule ID 6701 //
     /*  86296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  86302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86310 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  86310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86360 */   GIR_RootConstrainSelectedInstOperands,
     /*  86361 */   // GIR_Coverage, 6701,
     /*  86361 */   GIR_EraseRootFromParent_Done,
     /*  86362 */ // Label 1494: @86362
     /*  86362 */ GIM_Reject,
     /*  86363 */ // Label 1403: @86363
     /*  86363 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(86393), // Rule ID 6553 //
     /*  86368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86382 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86392 */   // GIR_Coverage, 6553,
     /*  86392 */   GIR_Done,
     /*  86393 */ // Label 1495: @86393
     /*  86393 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(86423), // Rule ID 6555 //
     /*  86398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86412 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86422 */   // GIR_Coverage, 6555,
     /*  86422 */   GIR_Done,
     /*  86423 */ // Label 1496: @86423
     /*  86423 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(86473), // Rule ID 6564 //
     /*  86428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86442 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86471 */   GIR_RootConstrainSelectedInstOperands,
     /*  86472 */   // GIR_Coverage, 6564,
     /*  86472 */   GIR_EraseRootFromParent_Done,
     /*  86473 */ // Label 1497: @86473
     /*  86473 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(86523), // Rule ID 6566 //
     /*  86478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86492 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86521 */   GIR_RootConstrainSelectedInstOperands,
     /*  86522 */   // GIR_Coverage, 6566,
     /*  86522 */   GIR_EraseRootFromParent_Done,
     /*  86523 */ // Label 1498: @86523
     /*  86523 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(86555), // Rule ID 6598 //
     /*  86528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86542 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86554 */   // GIR_Coverage, 6598,
     /*  86554 */   GIR_EraseRootFromParent_Done,
     /*  86555 */ // Label 1499: @86555
     /*  86555 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(86587), // Rule ID 6599 //
     /*  86560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86574 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86586 */   // GIR_Coverage, 6599,
     /*  86586 */   GIR_EraseRootFromParent_Done,
     /*  86587 */ // Label 1500: @86587
     /*  86587 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(86619), // Rule ID 6600 //
     /*  86592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86606 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86618 */   // GIR_Coverage, 6600,
     /*  86618 */   GIR_EraseRootFromParent_Done,
     /*  86619 */ // Label 1501: @86619
     /*  86619 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(86651), // Rule ID 6601 //
     /*  86624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86638 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86650 */   // GIR_Coverage, 6601,
     /*  86650 */   GIR_EraseRootFromParent_Done,
     /*  86651 */ // Label 1502: @86651
     /*  86651 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(86683), // Rule ID 6602 //
     /*  86656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86670 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86682 */   // GIR_Coverage, 6602,
     /*  86682 */   GIR_EraseRootFromParent_Done,
     /*  86683 */ // Label 1503: @86683
     /*  86683 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(86715), // Rule ID 6603 //
     /*  86688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86702 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86714 */   // GIR_Coverage, 6603,
     /*  86714 */   GIR_EraseRootFromParent_Done,
     /*  86715 */ // Label 1504: @86715
     /*  86715 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(86741), // Rule ID 6604 //
     /*  86720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86734 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  86734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86739 */   GIR_RootConstrainSelectedInstOperands,
     /*  86740 */   // GIR_Coverage, 6604,
     /*  86740 */   GIR_Done,
     /*  86741 */ // Label 1505: @86741
     /*  86741 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(86767), // Rule ID 6605 //
     /*  86746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86760 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  86760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86765 */   GIR_RootConstrainSelectedInstOperands,
     /*  86766 */   // GIR_Coverage, 6605,
     /*  86766 */   GIR_Done,
     /*  86767 */ // Label 1506: @86767
     /*  86767 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(86793), // Rule ID 6606 //
     /*  86772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86786 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  86786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  86791 */   GIR_RootConstrainSelectedInstOperands,
     /*  86792 */   // GIR_Coverage, 6606,
     /*  86792 */   GIR_Done,
     /*  86793 */ // Label 1507: @86793
     /*  86793 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(86819), // Rule ID 6607 //
     /*  86798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86812 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  86812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86817 */   GIR_RootConstrainSelectedInstOperands,
     /*  86818 */   // GIR_Coverage, 6607,
     /*  86818 */   GIR_Done,
     /*  86819 */ // Label 1508: @86819
     /*  86819 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(86845), // Rule ID 6608 //
     /*  86824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86838 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  86838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86843 */   GIR_RootConstrainSelectedInstOperands,
     /*  86844 */   // GIR_Coverage, 6608,
     /*  86844 */   GIR_Done,
     /*  86845 */ // Label 1509: @86845
     /*  86845 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(86871), // Rule ID 6609 //
     /*  86850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86864 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  86864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86869 */   GIR_RootConstrainSelectedInstOperands,
     /*  86870 */   // GIR_Coverage, 6609,
     /*  86870 */   GIR_Done,
     /*  86871 */ // Label 1510: @86871
     /*  86871 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(86900), // Rule ID 6610 //
     /*  86876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  86879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86887 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86899 */   // GIR_Coverage, 6610,
     /*  86899 */   GIR_EraseRootFromParent_Done,
     /*  86900 */ // Label 1511: @86900
     /*  86900 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(86932), // Rule ID 6675 //
     /*  86905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86919 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86931 */   // GIR_Coverage, 6675,
     /*  86931 */   GIR_EraseRootFromParent_Done,
     /*  86932 */ // Label 1512: @86932
     /*  86932 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(86964), // Rule ID 6676 //
     /*  86937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86951 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86954 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86956 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86963 */   // GIR_Coverage, 6676,
     /*  86963 */   GIR_EraseRootFromParent_Done,
     /*  86964 */ // Label 1513: @86964
     /*  86964 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(86996), // Rule ID 6677 //
     /*  86969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86983 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86986 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86995 */   // GIR_Coverage, 6677,
     /*  86995 */   GIR_EraseRootFromParent_Done,
     /*  86996 */ // Label 1514: @86996
     /*  86996 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(87028), // Rule ID 6678 //
     /*  87001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87015 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87027 */   // GIR_Coverage, 6678,
     /*  87027 */   GIR_EraseRootFromParent_Done,
     /*  87028 */ // Label 1515: @87028
     /*  87028 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(87060), // Rule ID 6679 //
     /*  87033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87047 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87059 */   // GIR_Coverage, 6679,
     /*  87059 */   GIR_EraseRootFromParent_Done,
     /*  87060 */ // Label 1516: @87060
     /*  87060 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(87092), // Rule ID 6680 //
     /*  87065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87079 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87091 */   // GIR_Coverage, 6680,
     /*  87091 */   GIR_EraseRootFromParent_Done,
     /*  87092 */ // Label 1517: @87092
     /*  87092 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(87118), // Rule ID 6681 //
     /*  87097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87111 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  87111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87116 */   GIR_RootConstrainSelectedInstOperands,
     /*  87117 */   // GIR_Coverage, 6681,
     /*  87117 */   GIR_Done,
     /*  87118 */ // Label 1518: @87118
     /*  87118 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(87144), // Rule ID 6682 //
     /*  87123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87137 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  87137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87142 */   GIR_RootConstrainSelectedInstOperands,
     /*  87143 */   // GIR_Coverage, 6682,
     /*  87143 */   GIR_Done,
     /*  87144 */ // Label 1519: @87144
     /*  87144 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(87170), // Rule ID 6683 //
     /*  87149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87163 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  87163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  87168 */   GIR_RootConstrainSelectedInstOperands,
     /*  87169 */   // GIR_Coverage, 6683,
     /*  87169 */   GIR_Done,
     /*  87170 */ // Label 1520: @87170
     /*  87170 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(87196), // Rule ID 6684 //
     /*  87175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87189 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  87189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87194 */   GIR_RootConstrainSelectedInstOperands,
     /*  87195 */   // GIR_Coverage, 6684,
     /*  87195 */   GIR_Done,
     /*  87196 */ // Label 1521: @87196
     /*  87196 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(87222), // Rule ID 6685 //
     /*  87201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87215 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  87215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87220 */   GIR_RootConstrainSelectedInstOperands,
     /*  87221 */   // GIR_Coverage, 6685,
     /*  87221 */   GIR_Done,
     /*  87222 */ // Label 1522: @87222
     /*  87222 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(87248), // Rule ID 6686 //
     /*  87227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87241 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  87241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87246 */   GIR_RootConstrainSelectedInstOperands,
     /*  87247 */   // GIR_Coverage, 6686,
     /*  87247 */   GIR_Done,
     /*  87248 */ // Label 1523: @87248
     /*  87248 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(87277), // Rule ID 6687 //
     /*  87253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87264 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87276 */   // GIR_Coverage, 6687,
     /*  87276 */   GIR_EraseRootFromParent_Done,
     /*  87277 */ // Label 1524: @87277
     /*  87277 */ GIM_Reject,
     /*  87278 */ // Label 1404: @87278
     /*  87278 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(87310), // Rule ID 6702 //
     /*  87283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87297 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87300 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87302 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87309 */   // GIR_Coverage, 6702,
     /*  87309 */   GIR_EraseRootFromParent_Done,
     /*  87310 */ // Label 1525: @87310
     /*  87310 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(87342), // Rule ID 6703 //
     /*  87315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87329 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87332 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87334 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87341 */   // GIR_Coverage, 6703,
     /*  87341 */   GIR_EraseRootFromParent_Done,
     /*  87342 */ // Label 1526: @87342
     /*  87342 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(87374), // Rule ID 6704 //
     /*  87347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87361 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87364 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87373 */   // GIR_Coverage, 6704,
     /*  87373 */   GIR_EraseRootFromParent_Done,
     /*  87374 */ // Label 1527: @87374
     /*  87374 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(87406), // Rule ID 6705 //
     /*  87379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87393 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87396 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87405 */   // GIR_Coverage, 6705,
     /*  87405 */   GIR_EraseRootFromParent_Done,
     /*  87406 */ // Label 1528: @87406
     /*  87406 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(87438), // Rule ID 6706 //
     /*  87411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87425 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87437 */   // GIR_Coverage, 6706,
     /*  87437 */   GIR_EraseRootFromParent_Done,
     /*  87438 */ // Label 1529: @87438
     /*  87438 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(87470), // Rule ID 6707 //
     /*  87443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87457 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87460 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87462 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87469 */   // GIR_Coverage, 6707,
     /*  87469 */   GIR_EraseRootFromParent_Done,
     /*  87470 */ // Label 1530: @87470
     /*  87470 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(87503), // Rule ID 6708 //
     /*  87475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87489 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87501 */   GIR_RootConstrainSelectedInstOperands,
     /*  87502 */   // GIR_Coverage, 6708,
     /*  87502 */   GIR_EraseRootFromParent_Done,
     /*  87503 */ // Label 1531: @87503
     /*  87503 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(87529), // Rule ID 6709 //
     /*  87508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87522 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  87522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87527 */   GIR_RootConstrainSelectedInstOperands,
     /*  87528 */   // GIR_Coverage, 6709,
     /*  87528 */   GIR_Done,
     /*  87529 */ // Label 1532: @87529
     /*  87529 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(87555), // Rule ID 6710 //
     /*  87534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87548 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  87548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87553 */   GIR_RootConstrainSelectedInstOperands,
     /*  87554 */   // GIR_Coverage, 6710,
     /*  87554 */   GIR_Done,
     /*  87555 */ // Label 1533: @87555
     /*  87555 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(87581), // Rule ID 6711 //
     /*  87560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87574 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  87574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87579 */   GIR_RootConstrainSelectedInstOperands,
     /*  87580 */   // GIR_Coverage, 6711,
     /*  87580 */   GIR_Done,
     /*  87581 */ // Label 1534: @87581
     /*  87581 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(87607), // Rule ID 6712 //
     /*  87586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87600 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  87600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87605 */   GIR_RootConstrainSelectedInstOperands,
     /*  87606 */   // GIR_Coverage, 6712,
     /*  87606 */   GIR_Done,
     /*  87607 */ // Label 1535: @87607
     /*  87607 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(87633), // Rule ID 6713 //
     /*  87612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87626 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  87626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87631 */   GIR_RootConstrainSelectedInstOperands,
     /*  87632 */   // GIR_Coverage, 6713,
     /*  87632 */   GIR_Done,
     /*  87633 */ // Label 1536: @87633
     /*  87633 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(87662), // Rule ID 6714 //
     /*  87638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87649 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87661 */   // GIR_Coverage, 6714,
     /*  87661 */   GIR_EraseRootFromParent_Done,
     /*  87662 */ // Label 1537: @87662
     /*  87662 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(87694), // Rule ID 6728 //
     /*  87667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87681 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87693 */   // GIR_Coverage, 6728,
     /*  87693 */   GIR_EraseRootFromParent_Done,
     /*  87694 */ // Label 1538: @87694
     /*  87694 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(87726), // Rule ID 6729 //
     /*  87699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87713 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87725 */   // GIR_Coverage, 6729,
     /*  87725 */   GIR_EraseRootFromParent_Done,
     /*  87726 */ // Label 1539: @87726
     /*  87726 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(87758), // Rule ID 6730 //
     /*  87731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87745 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87757 */   // GIR_Coverage, 6730,
     /*  87757 */   GIR_EraseRootFromParent_Done,
     /*  87758 */ // Label 1540: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(87790), // Rule ID 6731 //
     /*  87763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87777 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87789 */   // GIR_Coverage, 6731,
     /*  87789 */   GIR_EraseRootFromParent_Done,
     /*  87790 */ // Label 1541: @87790
     /*  87790 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(87822), // Rule ID 6732 //
     /*  87795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87809 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87821 */   // GIR_Coverage, 6732,
     /*  87821 */   GIR_EraseRootFromParent_Done,
     /*  87822 */ // Label 1542: @87822
     /*  87822 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(87854), // Rule ID 6733 //
     /*  87827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87841 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87853 */   // GIR_Coverage, 6733,
     /*  87853 */   GIR_EraseRootFromParent_Done,
     /*  87854 */ // Label 1543: @87854
     /*  87854 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(87887), // Rule ID 6734 //
     /*  87859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87873 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87885 */   GIR_RootConstrainSelectedInstOperands,
     /*  87886 */   // GIR_Coverage, 6734,
     /*  87886 */   GIR_EraseRootFromParent_Done,
     /*  87887 */ // Label 1544: @87887
     /*  87887 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(87913), // Rule ID 6735 //
     /*  87892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87906 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  87906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87911 */   GIR_RootConstrainSelectedInstOperands,
     /*  87912 */   // GIR_Coverage, 6735,
     /*  87912 */   GIR_Done,
     /*  87913 */ // Label 1545: @87913
     /*  87913 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(87939), // Rule ID 6736 //
     /*  87918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87932 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  87932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87937 */   GIR_RootConstrainSelectedInstOperands,
     /*  87938 */   // GIR_Coverage, 6736,
     /*  87938 */   GIR_Done,
     /*  87939 */ // Label 1546: @87939
     /*  87939 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(87965), // Rule ID 6737 //
     /*  87944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87958 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  87958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87963 */   GIR_RootConstrainSelectedInstOperands,
     /*  87964 */   // GIR_Coverage, 6737,
     /*  87964 */   GIR_Done,
     /*  87965 */ // Label 1547: @87965
     /*  87965 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(87991), // Rule ID 6738 //
     /*  87970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87984 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  87984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87989 */   GIR_RootConstrainSelectedInstOperands,
     /*  87990 */   // GIR_Coverage, 6738,
     /*  87990 */   GIR_Done,
     /*  87991 */ // Label 1548: @87991
     /*  87991 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(88017), // Rule ID 6739 //
     /*  87996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88010 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  88010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88015 */   GIR_RootConstrainSelectedInstOperands,
     /*  88016 */   // GIR_Coverage, 6739,
     /*  88016 */   GIR_Done,
     /*  88017 */ // Label 1549: @88017
     /*  88017 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(88046), // Rule ID 6740 //
     /*  88022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88033 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  88033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88045 */   // GIR_Coverage, 6740,
     /*  88045 */   GIR_EraseRootFromParent_Done,
     /*  88046 */ // Label 1550: @88046
     /*  88046 */ GIM_Reject,
     /*  88047 */ // Label 1405: @88047
     /*  88047 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(88077), // Rule ID 6552 //
     /*  88052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88066 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88076 */   // GIR_Coverage, 6552,
     /*  88076 */   GIR_Done,
     /*  88077 */ // Label 1551: @88077
     /*  88077 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(88107), // Rule ID 6554 //
     /*  88082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88096 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88106 */   // GIR_Coverage, 6554,
     /*  88106 */   GIR_Done,
     /*  88107 */ // Label 1552: @88107
     /*  88107 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(88157), // Rule ID 6563 //
     /*  88112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88126 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88138 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88155 */   GIR_RootConstrainSelectedInstOperands,
     /*  88156 */   // GIR_Coverage, 6563,
     /*  88156 */   GIR_EraseRootFromParent_Done,
     /*  88157 */ // Label 1553: @88157
     /*  88157 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(88207), // Rule ID 6565 //
     /*  88162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88176 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88205 */   GIR_RootConstrainSelectedInstOperands,
     /*  88206 */   // GIR_Coverage, 6565,
     /*  88206 */   GIR_EraseRootFromParent_Done,
     /*  88207 */ // Label 1554: @88207
     /*  88207 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(88239), // Rule ID 6611 //
     /*  88212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88226 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88238 */   // GIR_Coverage, 6611,
     /*  88238 */   GIR_EraseRootFromParent_Done,
     /*  88239 */ // Label 1555: @88239
     /*  88239 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(88271), // Rule ID 6612 //
     /*  88244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88258 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88261 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88263 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88270 */   // GIR_Coverage, 6612,
     /*  88270 */   GIR_EraseRootFromParent_Done,
     /*  88271 */ // Label 1556: @88271
     /*  88271 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(88303), // Rule ID 6613 //
     /*  88276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88290 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88293 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88302 */   // GIR_Coverage, 6613,
     /*  88302 */   GIR_EraseRootFromParent_Done,
     /*  88303 */ // Label 1557: @88303
     /*  88303 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(88335), // Rule ID 6614 //
     /*  88308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88322 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88334 */   // GIR_Coverage, 6614,
     /*  88334 */   GIR_EraseRootFromParent_Done,
     /*  88335 */ // Label 1558: @88335
     /*  88335 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(88367), // Rule ID 6615 //
     /*  88340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88354 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88366 */   // GIR_Coverage, 6615,
     /*  88366 */   GIR_EraseRootFromParent_Done,
     /*  88367 */ // Label 1559: @88367
     /*  88367 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(88399), // Rule ID 6616 //
     /*  88372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88386 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88398 */   // GIR_Coverage, 6616,
     /*  88398 */   GIR_EraseRootFromParent_Done,
     /*  88399 */ // Label 1560: @88399
     /*  88399 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(88425), // Rule ID 6617 //
     /*  88404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88418 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  88418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88423 */   GIR_RootConstrainSelectedInstOperands,
     /*  88424 */   // GIR_Coverage, 6617,
     /*  88424 */   GIR_Done,
     /*  88425 */ // Label 1561: @88425
     /*  88425 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(88451), // Rule ID 6618 //
     /*  88430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88444 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  88444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88449 */   GIR_RootConstrainSelectedInstOperands,
     /*  88450 */   // GIR_Coverage, 6618,
     /*  88450 */   GIR_Done,
     /*  88451 */ // Label 1562: @88451
     /*  88451 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(88477), // Rule ID 6619 //
     /*  88456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88470 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  88470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88475 */   GIR_RootConstrainSelectedInstOperands,
     /*  88476 */   // GIR_Coverage, 6619,
     /*  88476 */   GIR_Done,
     /*  88477 */ // Label 1563: @88477
     /*  88477 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(88503), // Rule ID 6620 //
     /*  88482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88496 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  88496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88501 */   GIR_RootConstrainSelectedInstOperands,
     /*  88502 */   // GIR_Coverage, 6620,
     /*  88502 */   GIR_Done,
     /*  88503 */ // Label 1564: @88503
     /*  88503 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(88529), // Rule ID 6621 //
     /*  88508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88522 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  88522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88527 */   GIR_RootConstrainSelectedInstOperands,
     /*  88528 */   // GIR_Coverage, 6621,
     /*  88528 */   GIR_Done,
     /*  88529 */ // Label 1565: @88529
     /*  88529 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(88555), // Rule ID 6622 //
     /*  88534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88548 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  88548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88553 */   GIR_RootConstrainSelectedInstOperands,
     /*  88554 */   // GIR_Coverage, 6622,
     /*  88554 */   GIR_Done,
     /*  88555 */ // Label 1566: @88555
     /*  88555 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(88584), // Rule ID 6623 //
     /*  88560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88571 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88583 */   // GIR_Coverage, 6623,
     /*  88583 */   GIR_EraseRootFromParent_Done,
     /*  88584 */ // Label 1567: @88584
     /*  88584 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(88616), // Rule ID 6624 //
     /*  88589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88603 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88606 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88608 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88615 */   // GIR_Coverage, 6624,
     /*  88615 */   GIR_EraseRootFromParent_Done,
     /*  88616 */ // Label 1568: @88616
     /*  88616 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(88648), // Rule ID 6625 //
     /*  88621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88635 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88638 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88647 */   // GIR_Coverage, 6625,
     /*  88647 */   GIR_EraseRootFromParent_Done,
     /*  88648 */ // Label 1569: @88648
     /*  88648 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(88680), // Rule ID 6626 //
     /*  88653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88667 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88679 */   // GIR_Coverage, 6626,
     /*  88679 */   GIR_EraseRootFromParent_Done,
     /*  88680 */ // Label 1570: @88680
     /*  88680 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(88712), // Rule ID 6627 //
     /*  88685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88699 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88711 */   // GIR_Coverage, 6627,
     /*  88711 */   GIR_EraseRootFromParent_Done,
     /*  88712 */ // Label 1571: @88712
     /*  88712 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(88744), // Rule ID 6628 //
     /*  88717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88731 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88743 */   // GIR_Coverage, 6628,
     /*  88743 */   GIR_EraseRootFromParent_Done,
     /*  88744 */ // Label 1572: @88744
     /*  88744 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(88776), // Rule ID 6629 //
     /*  88749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88763 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88775 */   // GIR_Coverage, 6629,
     /*  88775 */   GIR_EraseRootFromParent_Done,
     /*  88776 */ // Label 1573: @88776
     /*  88776 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(88802), // Rule ID 6630 //
     /*  88781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  88795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88800 */   GIR_RootConstrainSelectedInstOperands,
     /*  88801 */   // GIR_Coverage, 6630,
     /*  88801 */   GIR_Done,
     /*  88802 */ // Label 1574: @88802
     /*  88802 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(88828), // Rule ID 6631 //
     /*  88807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88821 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  88821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88826 */   GIR_RootConstrainSelectedInstOperands,
     /*  88827 */   // GIR_Coverage, 6631,
     /*  88827 */   GIR_Done,
     /*  88828 */ // Label 1575: @88828
     /*  88828 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(88854), // Rule ID 6632 //
     /*  88833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88847 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  88847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88852 */   GIR_RootConstrainSelectedInstOperands,
     /*  88853 */   // GIR_Coverage, 6632,
     /*  88853 */   GIR_Done,
     /*  88854 */ // Label 1576: @88854
     /*  88854 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(88880), // Rule ID 6633 //
     /*  88859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88873 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  88873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88878 */   GIR_RootConstrainSelectedInstOperands,
     /*  88879 */   // GIR_Coverage, 6633,
     /*  88879 */   GIR_Done,
     /*  88880 */ // Label 1577: @88880
     /*  88880 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(88906), // Rule ID 6634 //
     /*  88885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88899 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  88899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88904 */   GIR_RootConstrainSelectedInstOperands,
     /*  88905 */   // GIR_Coverage, 6634,
     /*  88905 */   GIR_Done,
     /*  88906 */ // Label 1578: @88906
     /*  88906 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(88932), // Rule ID 6635 //
     /*  88911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88925 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  88925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88930 */   GIR_RootConstrainSelectedInstOperands,
     /*  88931 */   // GIR_Coverage, 6635,
     /*  88931 */   GIR_Done,
     /*  88932 */ // Label 1579: @88932
     /*  88932 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(88961), // Rule ID 6636 //
     /*  88937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88948 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88960 */   // GIR_Coverage, 6636,
     /*  88960 */   GIR_EraseRootFromParent_Done,
     /*  88961 */ // Label 1580: @88961
     /*  88961 */ GIM_Reject,
     /*  88962 */ // Label 1406: @88962
     /*  88962 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(88994), // Rule ID 6715 //
     /*  88967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  88973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88981 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  88981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88984 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88993 */   // GIR_Coverage, 6715,
     /*  88993 */   GIR_EraseRootFromParent_Done,
     /*  88994 */ // Label 1581: @88994
     /*  88994 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(89026), // Rule ID 6716 //
     /*  88999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89013 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */   // GIR_Coverage, 6716,
     /*  89025 */   GIR_EraseRootFromParent_Done,
     /*  89026 */ // Label 1582: @89026
     /*  89026 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(89058), // Rule ID 6717 //
     /*  89031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89045 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89057 */   // GIR_Coverage, 6717,
     /*  89057 */   GIR_EraseRootFromParent_Done,
     /*  89058 */ // Label 1583: @89058
     /*  89058 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(89090), // Rule ID 6718 //
     /*  89063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89077 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89080 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89089 */   // GIR_Coverage, 6718,
     /*  89089 */   GIR_EraseRootFromParent_Done,
     /*  89090 */ // Label 1584: @89090
     /*  89090 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(89122), // Rule ID 6719 //
     /*  89095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89109 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89112 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89114 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89121 */   // GIR_Coverage, 6719,
     /*  89121 */   GIR_EraseRootFromParent_Done,
     /*  89122 */ // Label 1585: @89122
     /*  89122 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(89154), // Rule ID 6720 //
     /*  89127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89141 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89144 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89146 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89153 */   // GIR_Coverage, 6720,
     /*  89153 */   GIR_EraseRootFromParent_Done,
     /*  89154 */ // Label 1586: @89154
     /*  89154 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(89225), // Rule ID 6721 //
     /*  89159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89173 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89173 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89176 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89180 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89185 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89223 */   GIR_RootConstrainSelectedInstOperands,
     /*  89224 */   // GIR_Coverage, 6721,
     /*  89224 */   GIR_EraseRootFromParent_Done,
     /*  89225 */ // Label 1587: @89225
     /*  89225 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(89251), // Rule ID 6722 //
     /*  89230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89244 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  89244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89249 */   GIR_RootConstrainSelectedInstOperands,
     /*  89250 */   // GIR_Coverage, 6722,
     /*  89250 */   GIR_Done,
     /*  89251 */ // Label 1588: @89251
     /*  89251 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(89277), // Rule ID 6723 //
     /*  89256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89270 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  89270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89275 */   GIR_RootConstrainSelectedInstOperands,
     /*  89276 */   // GIR_Coverage, 6723,
     /*  89276 */   GIR_Done,
     /*  89277 */ // Label 1589: @89277
     /*  89277 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(89303), // Rule ID 6724 //
     /*  89282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89296 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  89296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89301 */   GIR_RootConstrainSelectedInstOperands,
     /*  89302 */   // GIR_Coverage, 6724,
     /*  89302 */   GIR_Done,
     /*  89303 */ // Label 1590: @89303
     /*  89303 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(89329), // Rule ID 6725 //
     /*  89308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89322 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  89322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89327 */   GIR_RootConstrainSelectedInstOperands,
     /*  89328 */   // GIR_Coverage, 6725,
     /*  89328 */   GIR_Done,
     /*  89329 */ // Label 1591: @89329
     /*  89329 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(89355), // Rule ID 6726 //
     /*  89334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89348 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  89348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89353 */   GIR_RootConstrainSelectedInstOperands,
     /*  89354 */   // GIR_Coverage, 6726,
     /*  89354 */   GIR_Done,
     /*  89355 */ // Label 1592: @89355
     /*  89355 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(89384), // Rule ID 6727 //
     /*  89360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89371 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89383 */   // GIR_Coverage, 6727,
     /*  89383 */   GIR_EraseRootFromParent_Done,
     /*  89384 */ // Label 1593: @89384
     /*  89384 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(89416), // Rule ID 6741 //
     /*  89389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89403 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89415 */   // GIR_Coverage, 6741,
     /*  89415 */   GIR_EraseRootFromParent_Done,
     /*  89416 */ // Label 1594: @89416
     /*  89416 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(89448), // Rule ID 6742 //
     /*  89421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89435 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */   // GIR_Coverage, 6742,
     /*  89447 */   GIR_EraseRootFromParent_Done,
     /*  89448 */ // Label 1595: @89448
     /*  89448 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(89480), // Rule ID 6743 //
     /*  89453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89467 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89479 */   // GIR_Coverage, 6743,
     /*  89479 */   GIR_EraseRootFromParent_Done,
     /*  89480 */ // Label 1596: @89480
     /*  89480 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(89512), // Rule ID 6744 //
     /*  89485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89499 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89511 */   // GIR_Coverage, 6744,
     /*  89511 */   GIR_EraseRootFromParent_Done,
     /*  89512 */ // Label 1597: @89512
     /*  89512 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(89544), // Rule ID 6745 //
     /*  89517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89543 */   // GIR_Coverage, 6745,
     /*  89543 */   GIR_EraseRootFromParent_Done,
     /*  89544 */ // Label 1598: @89544
     /*  89544 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(89576), // Rule ID 6746 //
     /*  89549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89563 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89566 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89575 */   // GIR_Coverage, 6746,
     /*  89575 */   GIR_EraseRootFromParent_Done,
     /*  89576 */ // Label 1599: @89576
     /*  89576 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(89647), // Rule ID 6747 //
     /*  89581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89595 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89645 */   GIR_RootConstrainSelectedInstOperands,
     /*  89646 */   // GIR_Coverage, 6747,
     /*  89646 */   GIR_EraseRootFromParent_Done,
     /*  89647 */ // Label 1600: @89647
     /*  89647 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(89673), // Rule ID 6748 //
     /*  89652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89666 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  89666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89671 */   GIR_RootConstrainSelectedInstOperands,
     /*  89672 */   // GIR_Coverage, 6748,
     /*  89672 */   GIR_Done,
     /*  89673 */ // Label 1601: @89673
     /*  89673 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(89699), // Rule ID 6749 //
     /*  89678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89692 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  89692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89697 */   GIR_RootConstrainSelectedInstOperands,
     /*  89698 */   // GIR_Coverage, 6749,
     /*  89698 */   GIR_Done,
     /*  89699 */ // Label 1602: @89699
     /*  89699 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(89725), // Rule ID 6750 //
     /*  89704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89718 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  89718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89723 */   GIR_RootConstrainSelectedInstOperands,
     /*  89724 */   // GIR_Coverage, 6750,
     /*  89724 */   GIR_Done,
     /*  89725 */ // Label 1603: @89725
     /*  89725 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(89751), // Rule ID 6751 //
     /*  89730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89744 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  89744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89749 */   GIR_RootConstrainSelectedInstOperands,
     /*  89750 */   // GIR_Coverage, 6751,
     /*  89750 */   GIR_Done,
     /*  89751 */ // Label 1604: @89751
     /*  89751 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(89777), // Rule ID 6752 //
     /*  89756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89770 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  89770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89775 */   GIR_RootConstrainSelectedInstOperands,
     /*  89776 */   // GIR_Coverage, 6752,
     /*  89776 */   GIR_Done,
     /*  89777 */ // Label 1605: @89777
     /*  89777 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(89806), // Rule ID 6753 //
     /*  89782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89793 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89805 */   // GIR_Coverage, 6753,
     /*  89805 */   GIR_EraseRootFromParent_Done,
     /*  89806 */ // Label 1606: @89806
     /*  89806 */ GIM_Reject,
     /*  89807 */ // Label 1407: @89807
     /*  89807 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(89881), // Rule ID 5598 //
     /*  89812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  89827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  89831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  89836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89838 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  89838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  89841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  89845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89850 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  89859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  89870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  89880 */   // GIR_Coverage, 5598,
     /*  89880 */   GIR_EraseRootFromParent_Done,
     /*  89881 */ // Label 1607: @89881
     /*  89881 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(89911), // Rule ID 6551 //
     /*  89886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89900 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89910 */   // GIR_Coverage, 6551,
     /*  89910 */   GIR_Done,
     /*  89911 */ // Label 1608: @89911
     /*  89911 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(89961), // Rule ID 6562 //
     /*  89916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89930 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89959 */   GIR_RootConstrainSelectedInstOperands,
     /*  89960 */   // GIR_Coverage, 6562,
     /*  89960 */   GIR_EraseRootFromParent_Done,
     /*  89961 */ // Label 1609: @89961
     /*  89961 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(89993), // Rule ID 6637 //
     /*  89966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89980 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  89980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89992 */   // GIR_Coverage, 6637,
     /*  89992 */   GIR_EraseRootFromParent_Done,
     /*  89993 */ // Label 1610: @89993
     /*  89993 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(90025), // Rule ID 6638 //
     /*  89998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90012 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90024 */   // GIR_Coverage, 6638,
     /*  90024 */   GIR_EraseRootFromParent_Done,
     /*  90025 */ // Label 1611: @90025
     /*  90025 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(90057), // Rule ID 6639 //
     /*  90030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90044 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90056 */   // GIR_Coverage, 6639,
     /*  90056 */   GIR_EraseRootFromParent_Done,
     /*  90057 */ // Label 1612: @90057
     /*  90057 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(90089), // Rule ID 6640 //
     /*  90062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90076 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90088 */   // GIR_Coverage, 6640,
     /*  90088 */   GIR_EraseRootFromParent_Done,
     /*  90089 */ // Label 1613: @90089
     /*  90089 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(90121), // Rule ID 6641 //
     /*  90094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90108 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90120 */   // GIR_Coverage, 6641,
     /*  90120 */   GIR_EraseRootFromParent_Done,
     /*  90121 */ // Label 1614: @90121
     /*  90121 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(90153), // Rule ID 6642 //
     /*  90126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90140 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90152 */   // GIR_Coverage, 6642,
     /*  90152 */   GIR_EraseRootFromParent_Done,
     /*  90153 */ // Label 1615: @90153
     /*  90153 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(90185), // Rule ID 6643 //
     /*  90158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90172 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90175 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90184 */   // GIR_Coverage, 6643,
     /*  90184 */   GIR_EraseRootFromParent_Done,
     /*  90185 */ // Label 1616: @90185
     /*  90185 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(90211), // Rule ID 6644 //
     /*  90190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90204 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  90204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90209 */   GIR_RootConstrainSelectedInstOperands,
     /*  90210 */   // GIR_Coverage, 6644,
     /*  90210 */   GIR_Done,
     /*  90211 */ // Label 1617: @90211
     /*  90211 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(90237), // Rule ID 6645 //
     /*  90216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90230 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  90230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90235 */   GIR_RootConstrainSelectedInstOperands,
     /*  90236 */   // GIR_Coverage, 6645,
     /*  90236 */   GIR_Done,
     /*  90237 */ // Label 1618: @90237
     /*  90237 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(90263), // Rule ID 6646 //
     /*  90242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90256 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  90256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90261 */   GIR_RootConstrainSelectedInstOperands,
     /*  90262 */   // GIR_Coverage, 6646,
     /*  90262 */   GIR_Done,
     /*  90263 */ // Label 1619: @90263
     /*  90263 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(90289), // Rule ID 6647 //
     /*  90268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90282 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  90282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90287 */   GIR_RootConstrainSelectedInstOperands,
     /*  90288 */   // GIR_Coverage, 6647,
     /*  90288 */   GIR_Done,
     /*  90289 */ // Label 1620: @90289
     /*  90289 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(90315), // Rule ID 6648 //
     /*  90294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90308 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  90308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90313 */   GIR_RootConstrainSelectedInstOperands,
     /*  90314 */   // GIR_Coverage, 6648,
     /*  90314 */   GIR_Done,
     /*  90315 */ // Label 1621: @90315
     /*  90315 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(90341), // Rule ID 6649 //
     /*  90320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90334 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  90334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90339 */   GIR_RootConstrainSelectedInstOperands,
     /*  90340 */   // GIR_Coverage, 6649,
     /*  90340 */   GIR_Done,
     /*  90341 */ // Label 1622: @90341
     /*  90341 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(90367), // Rule ID 6650 //
     /*  90346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90360 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  90360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90365 */   GIR_RootConstrainSelectedInstOperands,
     /*  90366 */   // GIR_Coverage, 6650,
     /*  90366 */   GIR_Done,
     /*  90367 */ // Label 1623: @90367
     /*  90367 */ GIM_Reject,
     /*  90368 */ // Label 1408: @90368
     /*  90368 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(90400), // Rule ID 6754 //
     /*  90373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90387 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90399 */   // GIR_Coverage, 6754,
     /*  90399 */   GIR_EraseRootFromParent_Done,
     /*  90400 */ // Label 1624: @90400
     /*  90400 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(90432), // Rule ID 6755 //
     /*  90405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90419 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90431 */   // GIR_Coverage, 6755,
     /*  90431 */   GIR_EraseRootFromParent_Done,
     /*  90432 */ // Label 1625: @90432
     /*  90432 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(90464), // Rule ID 6756 //
     /*  90437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90451 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90463 */   // GIR_Coverage, 6756,
     /*  90463 */   GIR_EraseRootFromParent_Done,
     /*  90464 */ // Label 1626: @90464
     /*  90464 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(90496), // Rule ID 6757 //
     /*  90469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90483 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90495 */   // GIR_Coverage, 6757,
     /*  90495 */   GIR_EraseRootFromParent_Done,
     /*  90496 */ // Label 1627: @90496
     /*  90496 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(90528), // Rule ID 6758 //
     /*  90501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90515 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */   // GIR_Coverage, 6758,
     /*  90527 */   GIR_EraseRootFromParent_Done,
     /*  90528 */ // Label 1628: @90528
     /*  90528 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(90560), // Rule ID 6759 //
     /*  90533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90547 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90559 */   // GIR_Coverage, 6759,
     /*  90559 */   GIR_EraseRootFromParent_Done,
     /*  90560 */ // Label 1629: @90560
     /*  90560 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(90631), // Rule ID 6760 //
     /*  90565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90579 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  90579 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90582 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90586 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90591 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90629 */   GIR_RootConstrainSelectedInstOperands,
     /*  90630 */   // GIR_Coverage, 6760,
     /*  90630 */   GIR_EraseRootFromParent_Done,
     /*  90631 */ // Label 1630: @90631
     /*  90631 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(90657), // Rule ID 6761 //
     /*  90636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90650 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  90650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90655 */   GIR_RootConstrainSelectedInstOperands,
     /*  90656 */   // GIR_Coverage, 6761,
     /*  90656 */   GIR_Done,
     /*  90657 */ // Label 1631: @90657
     /*  90657 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(90683), // Rule ID 6762 //
     /*  90662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90676 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  90676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90681 */   GIR_RootConstrainSelectedInstOperands,
     /*  90682 */   // GIR_Coverage, 6762,
     /*  90682 */   GIR_Done,
     /*  90683 */ // Label 1632: @90683
     /*  90683 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(90709), // Rule ID 6763 //
     /*  90688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90702 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  90702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  90707 */   GIR_RootConstrainSelectedInstOperands,
     /*  90708 */   // GIR_Coverage, 6763,
     /*  90708 */   GIR_Done,
     /*  90709 */ // Label 1633: @90709
     /*  90709 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(90735), // Rule ID 6764 //
     /*  90714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90728 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  90728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90733 */   GIR_RootConstrainSelectedInstOperands,
     /*  90734 */   // GIR_Coverage, 6764,
     /*  90734 */   GIR_Done,
     /*  90735 */ // Label 1634: @90735
     /*  90735 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(90761), // Rule ID 6765 //
     /*  90740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90754 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  90754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90759 */   GIR_RootConstrainSelectedInstOperands,
     /*  90760 */   // GIR_Coverage, 6765,
     /*  90760 */   GIR_Done,
     /*  90761 */ // Label 1635: @90761
     /*  90761 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(90790), // Rule ID 6766 //
     /*  90766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90777 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90789 */   // GIR_Coverage, 6766,
     /*  90789 */   GIR_EraseRootFromParent_Done,
     /*  90790 */ // Label 1636: @90790
     /*  90790 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(90822), // Rule ID 6767 //
     /*  90795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90809 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90821 */   // GIR_Coverage, 6767,
     /*  90821 */   GIR_EraseRootFromParent_Done,
     /*  90822 */ // Label 1637: @90822
     /*  90822 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(90854), // Rule ID 6768 //
     /*  90827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90841 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90853 */   // GIR_Coverage, 6768,
     /*  90853 */   GIR_EraseRootFromParent_Done,
     /*  90854 */ // Label 1638: @90854
     /*  90854 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90886), // Rule ID 6769 //
     /*  90859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90873 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */   // GIR_Coverage, 6769,
     /*  90885 */   GIR_EraseRootFromParent_Done,
     /*  90886 */ // Label 1639: @90886
     /*  90886 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90918), // Rule ID 6770 //
     /*  90891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90917 */   // GIR_Coverage, 6770,
     /*  90917 */   GIR_EraseRootFromParent_Done,
     /*  90918 */ // Label 1640: @90918
     /*  90918 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90950), // Rule ID 6771 //
     /*  90923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90937 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90940 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90949 */   // GIR_Coverage, 6771,
     /*  90949 */   GIR_EraseRootFromParent_Done,
     /*  90950 */ // Label 1641: @90950
     /*  90950 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90982), // Rule ID 6772 //
     /*  90955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90969 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90972 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90981 */   // GIR_Coverage, 6772,
     /*  90981 */   GIR_EraseRootFromParent_Done,
     /*  90982 */ // Label 1642: @90982
     /*  90982 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(91053), // Rule ID 6773 //
     /*  90987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91001 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91013 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91051 */   GIR_RootConstrainSelectedInstOperands,
     /*  91052 */   // GIR_Coverage, 6773,
     /*  91052 */   GIR_EraseRootFromParent_Done,
     /*  91053 */ // Label 1643: @91053
     /*  91053 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(91079), // Rule ID 6774 //
     /*  91058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91072 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  91072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91077 */   GIR_RootConstrainSelectedInstOperands,
     /*  91078 */   // GIR_Coverage, 6774,
     /*  91078 */   GIR_Done,
     /*  91079 */ // Label 1644: @91079
     /*  91079 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(91105), // Rule ID 6775 //
     /*  91084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91098 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  91098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91103 */   GIR_RootConstrainSelectedInstOperands,
     /*  91104 */   // GIR_Coverage, 6775,
     /*  91104 */   GIR_Done,
     /*  91105 */ // Label 1645: @91105
     /*  91105 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(91131), // Rule ID 6776 //
     /*  91110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91124 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  91124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91129 */   GIR_RootConstrainSelectedInstOperands,
     /*  91130 */   // GIR_Coverage, 6776,
     /*  91130 */   GIR_Done,
     /*  91131 */ // Label 1646: @91131
     /*  91131 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(91157), // Rule ID 6777 //
     /*  91136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91150 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  91150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91155 */   GIR_RootConstrainSelectedInstOperands,
     /*  91156 */   // GIR_Coverage, 6777,
     /*  91156 */   GIR_Done,
     /*  91157 */ // Label 1647: @91157
     /*  91157 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91183), // Rule ID 6778 //
     /*  91162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91176 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  91176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91181 */   GIR_RootConstrainSelectedInstOperands,
     /*  91182 */   // GIR_Coverage, 6778,
     /*  91182 */   GIR_Done,
     /*  91183 */ // Label 1648: @91183
     /*  91183 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91212), // Rule ID 6779 //
     /*  91188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91199 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  91199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91211 */   // GIR_Coverage, 6779,
     /*  91211 */   GIR_EraseRootFromParent_Done,
     /*  91212 */ // Label 1649: @91212
     /*  91212 */ GIM_Reject,
     /*  91213 */ // Label 1409: @91213
     /*  91213 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91245), // Rule ID 6780 //
     /*  91218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91232 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91235 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91244 */   // GIR_Coverage, 6780,
     /*  91244 */   GIR_EraseRootFromParent_Done,
     /*  91245 */ // Label 1650: @91245
     /*  91245 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91277), // Rule ID 6781 //
     /*  91250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91264 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91276 */   // GIR_Coverage, 6781,
     /*  91276 */   GIR_EraseRootFromParent_Done,
     /*  91277 */ // Label 1651: @91277
     /*  91277 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91309), // Rule ID 6782 //
     /*  91282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91296 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91308 */   // GIR_Coverage, 6782,
     /*  91308 */   GIR_EraseRootFromParent_Done,
     /*  91309 */ // Label 1652: @91309
     /*  91309 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91341), // Rule ID 6783 //
     /*  91314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91328 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91340 */   // GIR_Coverage, 6783,
     /*  91340 */   GIR_EraseRootFromParent_Done,
     /*  91341 */ // Label 1653: @91341
     /*  91341 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91373), // Rule ID 6784 //
     /*  91346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91360 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91372 */   // GIR_Coverage, 6784,
     /*  91372 */   GIR_EraseRootFromParent_Done,
     /*  91373 */ // Label 1654: @91373
     /*  91373 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91405), // Rule ID 6785 //
     /*  91378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91392 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91404 */   // GIR_Coverage, 6785,
     /*  91404 */   GIR_EraseRootFromParent_Done,
     /*  91405 */ // Label 1655: @91405
     /*  91405 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91437), // Rule ID 6786 //
     /*  91410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91424 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91436 */   // GIR_Coverage, 6786,
     /*  91436 */   GIR_EraseRootFromParent_Done,
     /*  91437 */ // Label 1656: @91437
     /*  91437 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91508), // Rule ID 6787 //
     /*  91442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91456 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91468 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91506 */   GIR_RootConstrainSelectedInstOperands,
     /*  91507 */   // GIR_Coverage, 6787,
     /*  91507 */   GIR_EraseRootFromParent_Done,
     /*  91508 */ // Label 1657: @91508
     /*  91508 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91534), // Rule ID 6788 //
     /*  91513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91527 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  91527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91532 */   GIR_RootConstrainSelectedInstOperands,
     /*  91533 */   // GIR_Coverage, 6788,
     /*  91533 */   GIR_Done,
     /*  91534 */ // Label 1658: @91534
     /*  91534 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91560), // Rule ID 6789 //
     /*  91539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91553 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  91553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91558 */   GIR_RootConstrainSelectedInstOperands,
     /*  91559 */   // GIR_Coverage, 6789,
     /*  91559 */   GIR_Done,
     /*  91560 */ // Label 1659: @91560
     /*  91560 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91586), // Rule ID 6790 //
     /*  91565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91579 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  91579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91584 */   GIR_RootConstrainSelectedInstOperands,
     /*  91585 */   // GIR_Coverage, 6790,
     /*  91585 */   GIR_Done,
     /*  91586 */ // Label 1660: @91586
     /*  91586 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91612), // Rule ID 6791 //
     /*  91591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91605 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  91605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91610 */   GIR_RootConstrainSelectedInstOperands,
     /*  91611 */   // GIR_Coverage, 6791,
     /*  91611 */   GIR_Done,
     /*  91612 */ // Label 1661: @91612
     /*  91612 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91638), // Rule ID 6792 //
     /*  91617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91631 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  91631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91636 */   GIR_RootConstrainSelectedInstOperands,
     /*  91637 */   // GIR_Coverage, 6792,
     /*  91637 */   GIR_Done,
     /*  91638 */ // Label 1662: @91638
     /*  91638 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91664), // Rule ID 6793 //
     /*  91643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91657 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  91657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91662 */   GIR_RootConstrainSelectedInstOperands,
     /*  91663 */   // GIR_Coverage, 6793,
     /*  91663 */   GIR_Done,
     /*  91664 */ // Label 1663: @91664
     /*  91664 */ GIM_Reject,
     /*  91665 */ // Label 1410: @91665
     /*  91665 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91697), // Rule ID 10406 //
     /*  91670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91684 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91696 */   // GIR_Coverage, 10406,
     /*  91696 */   GIR_EraseRootFromParent_Done,
     /*  91697 */ // Label 1664: @91697
     /*  91697 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91729), // Rule ID 10407 //
     /*  91702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91716 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91728 */   // GIR_Coverage, 10407,
     /*  91728 */   GIR_EraseRootFromParent_Done,
     /*  91729 */ // Label 1665: @91729
     /*  91729 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91761), // Rule ID 10408 //
     /*  91734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91748 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91760 */   // GIR_Coverage, 10408,
     /*  91760 */   GIR_EraseRootFromParent_Done,
     /*  91761 */ // Label 1666: @91761
     /*  91761 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91793), // Rule ID 10409 //
     /*  91766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91780 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91792 */   // GIR_Coverage, 10409,
     /*  91792 */   GIR_EraseRootFromParent_Done,
     /*  91793 */ // Label 1667: @91793
     /*  91793 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91825), // Rule ID 10410 //
     /*  91798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91812 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91824 */   // GIR_Coverage, 10410,
     /*  91824 */   GIR_EraseRootFromParent_Done,
     /*  91825 */ // Label 1668: @91825
     /*  91825 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91857), // Rule ID 10411 //
     /*  91830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91844 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91856 */   // GIR_Coverage, 10411,
     /*  91856 */   GIR_EraseRootFromParent_Done,
     /*  91857 */ // Label 1669: @91857
     /*  91857 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91889), // Rule ID 10424 //
     /*  91862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91876 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91888 */   // GIR_Coverage, 10424,
     /*  91888 */   GIR_EraseRootFromParent_Done,
     /*  91889 */ // Label 1670: @91889
     /*  91889 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91921), // Rule ID 10425 //
     /*  91894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91908 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91920 */   // GIR_Coverage, 10425,
     /*  91920 */   GIR_EraseRootFromParent_Done,
     /*  91921 */ // Label 1671: @91921
     /*  91921 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91953), // Rule ID 10426 //
     /*  91926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91940 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91952 */   // GIR_Coverage, 10426,
     /*  91952 */   GIR_EraseRootFromParent_Done,
     /*  91953 */ // Label 1672: @91953
     /*  91953 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91985), // Rule ID 10427 //
     /*  91958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91972 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91984 */   // GIR_Coverage, 10427,
     /*  91984 */   GIR_EraseRootFromParent_Done,
     /*  91985 */ // Label 1673: @91985
     /*  91985 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92017), // Rule ID 10428 //
     /*  91990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92004 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92016 */   // GIR_Coverage, 10428,
     /*  92016 */   GIR_EraseRootFromParent_Done,
     /*  92017 */ // Label 1674: @92017
     /*  92017 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92049), // Rule ID 10429 //
     /*  92022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92036 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92048 */   // GIR_Coverage, 10429,
     /*  92048 */   GIR_EraseRootFromParent_Done,
     /*  92049 */ // Label 1675: @92049
     /*  92049 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92081), // Rule ID 10434 //
     /*  92054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92068 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  92068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92080 */   // GIR_Coverage, 10434,
     /*  92080 */   GIR_EraseRootFromParent_Done,
     /*  92081 */ // Label 1676: @92081
     /*  92081 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92113), // Rule ID 10435 //
     /*  92086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92100 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92112 */   // GIR_Coverage, 10435,
     /*  92112 */   GIR_EraseRootFromParent_Done,
     /*  92113 */ // Label 1677: @92113
     /*  92113 */ GIM_Reject,
     /*  92114 */ // Label 1411: @92114
     /*  92114 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92146), // Rule ID 10400 //
     /*  92119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92133 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92145 */   // GIR_Coverage, 10400,
     /*  92145 */   GIR_EraseRootFromParent_Done,
     /*  92146 */ // Label 1678: @92146
     /*  92146 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92178), // Rule ID 10401 //
     /*  92151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92165 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92168 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92177 */   // GIR_Coverage, 10401,
     /*  92177 */   GIR_EraseRootFromParent_Done,
     /*  92178 */ // Label 1679: @92178
     /*  92178 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92210), // Rule ID 10402 //
     /*  92183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92197 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92200 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92209 */   // GIR_Coverage, 10402,
     /*  92209 */   GIR_EraseRootFromParent_Done,
     /*  92210 */ // Label 1680: @92210
     /*  92210 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92242), // Rule ID 10403 //
     /*  92215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92229 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92241 */   // GIR_Coverage, 10403,
     /*  92241 */   GIR_EraseRootFromParent_Done,
     /*  92242 */ // Label 1681: @92242
     /*  92242 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92274), // Rule ID 10404 //
     /*  92247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92261 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92273 */   // GIR_Coverage, 10404,
     /*  92273 */   GIR_EraseRootFromParent_Done,
     /*  92274 */ // Label 1682: @92274
     /*  92274 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92306), // Rule ID 10405 //
     /*  92279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92293 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92305 */   // GIR_Coverage, 10405,
     /*  92305 */   GIR_EraseRootFromParent_Done,
     /*  92306 */ // Label 1683: @92306
     /*  92306 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92338), // Rule ID 10418 //
     /*  92311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92325 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92337 */   // GIR_Coverage, 10418,
     /*  92337 */   GIR_EraseRootFromParent_Done,
     /*  92338 */ // Label 1684: @92338
     /*  92338 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92370), // Rule ID 10419 //
     /*  92343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92357 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92369 */   // GIR_Coverage, 10419,
     /*  92369 */   GIR_EraseRootFromParent_Done,
     /*  92370 */ // Label 1685: @92370
     /*  92370 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92402), // Rule ID 10420 //
     /*  92375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92389 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92401 */   // GIR_Coverage, 10420,
     /*  92401 */   GIR_EraseRootFromParent_Done,
     /*  92402 */ // Label 1686: @92402
     /*  92402 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92434), // Rule ID 10421 //
     /*  92407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92421 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92433 */   // GIR_Coverage, 10421,
     /*  92433 */   GIR_EraseRootFromParent_Done,
     /*  92434 */ // Label 1687: @92434
     /*  92434 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92466), // Rule ID 10422 //
     /*  92439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92453 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92465 */   // GIR_Coverage, 10422,
     /*  92465 */   GIR_EraseRootFromParent_Done,
     /*  92466 */ // Label 1688: @92466
     /*  92466 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92498), // Rule ID 10423 //
     /*  92471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92485 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92497 */   // GIR_Coverage, 10423,
     /*  92497 */   GIR_EraseRootFromParent_Done,
     /*  92498 */ // Label 1689: @92498
     /*  92498 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92530), // Rule ID 10432 //
     /*  92503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92517 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92529 */   // GIR_Coverage, 10432,
     /*  92529 */   GIR_EraseRootFromParent_Done,
     /*  92530 */ // Label 1690: @92530
     /*  92530 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92562), // Rule ID 10433 //
     /*  92535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92549 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92552 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92561 */   // GIR_Coverage, 10433,
     /*  92561 */   GIR_EraseRootFromParent_Done,
     /*  92562 */ // Label 1691: @92562
     /*  92562 */ GIM_Reject,
     /*  92563 */ // Label 1412: @92563
     /*  92563 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92595), // Rule ID 10394 //
     /*  92568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92582 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92594 */   // GIR_Coverage, 10394,
     /*  92594 */   GIR_EraseRootFromParent_Done,
     /*  92595 */ // Label 1692: @92595
     /*  92595 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92627), // Rule ID 10395 //
     /*  92600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92614 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92617 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92626 */   // GIR_Coverage, 10395,
     /*  92626 */   GIR_EraseRootFromParent_Done,
     /*  92627 */ // Label 1693: @92627
     /*  92627 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92659), // Rule ID 10396 //
     /*  92632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92646 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92649 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92651 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92658 */   // GIR_Coverage, 10396,
     /*  92658 */   GIR_EraseRootFromParent_Done,
     /*  92659 */ // Label 1694: @92659
     /*  92659 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92691), // Rule ID 10397 //
     /*  92664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92678 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92690 */   // GIR_Coverage, 10397,
     /*  92690 */   GIR_EraseRootFromParent_Done,
     /*  92691 */ // Label 1695: @92691
     /*  92691 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92723), // Rule ID 10398 //
     /*  92696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92710 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92722 */   // GIR_Coverage, 10398,
     /*  92722 */   GIR_EraseRootFromParent_Done,
     /*  92723 */ // Label 1696: @92723
     /*  92723 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92755), // Rule ID 10399 //
     /*  92728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92742 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92754 */   // GIR_Coverage, 10399,
     /*  92754 */   GIR_EraseRootFromParent_Done,
     /*  92755 */ // Label 1697: @92755
     /*  92755 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92787), // Rule ID 10412 //
     /*  92760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92774 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92786 */   // GIR_Coverage, 10412,
     /*  92786 */   GIR_EraseRootFromParent_Done,
     /*  92787 */ // Label 1698: @92787
     /*  92787 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92819), // Rule ID 10413 //
     /*  92792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92806 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92818 */   // GIR_Coverage, 10413,
     /*  92818 */   GIR_EraseRootFromParent_Done,
     /*  92819 */ // Label 1699: @92819
     /*  92819 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92851), // Rule ID 10414 //
     /*  92824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92838 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92850 */   // GIR_Coverage, 10414,
     /*  92850 */   GIR_EraseRootFromParent_Done,
     /*  92851 */ // Label 1700: @92851
     /*  92851 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92883), // Rule ID 10415 //
     /*  92856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92870 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92882 */   // GIR_Coverage, 10415,
     /*  92882 */   GIR_EraseRootFromParent_Done,
     /*  92883 */ // Label 1701: @92883
     /*  92883 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(92915), // Rule ID 10416 //
     /*  92888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92902 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92914 */   // GIR_Coverage, 10416,
     /*  92914 */   GIR_EraseRootFromParent_Done,
     /*  92915 */ // Label 1702: @92915
     /*  92915 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(92947), // Rule ID 10417 //
     /*  92920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92934 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92946 */   // GIR_Coverage, 10417,
     /*  92946 */   GIR_EraseRootFromParent_Done,
     /*  92947 */ // Label 1703: @92947
     /*  92947 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(92979), // Rule ID 10430 //
     /*  92952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92966 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92978 */   // GIR_Coverage, 10430,
     /*  92978 */   GIR_EraseRootFromParent_Done,
     /*  92979 */ // Label 1704: @92979
     /*  92979 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93011), // Rule ID 10431 //
     /*  92984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92998 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93010 */   // GIR_Coverage, 10431,
     /*  93010 */   GIR_EraseRootFromParent_Done,
     /*  93011 */ // Label 1705: @93011
     /*  93011 */ GIM_Reject,
     /*  93012 */ // Label 1413: @93012
     /*  93012 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93044), // Rule ID 10388 //
     /*  93017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93031 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93043 */   // GIR_Coverage, 10388,
     /*  93043 */   GIR_EraseRootFromParent_Done,
     /*  93044 */ // Label 1706: @93044
     /*  93044 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93076), // Rule ID 10389 //
     /*  93049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93063 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93075 */   // GIR_Coverage, 10389,
     /*  93075 */   GIR_EraseRootFromParent_Done,
     /*  93076 */ // Label 1707: @93076
     /*  93076 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93108), // Rule ID 10390 //
     /*  93081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93095 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93107 */   // GIR_Coverage, 10390,
     /*  93107 */   GIR_EraseRootFromParent_Done,
     /*  93108 */ // Label 1708: @93108
     /*  93108 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93140), // Rule ID 10391 //
     /*  93113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93127 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93139 */   // GIR_Coverage, 10391,
     /*  93139 */   GIR_EraseRootFromParent_Done,
     /*  93140 */ // Label 1709: @93140
     /*  93140 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93172), // Rule ID 10392 //
     /*  93145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93159 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93171 */   // GIR_Coverage, 10392,
     /*  93171 */   GIR_EraseRootFromParent_Done,
     /*  93172 */ // Label 1710: @93172
     /*  93172 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93204), // Rule ID 10393 //
     /*  93177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93191 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93203 */   // GIR_Coverage, 10393,
     /*  93203 */   GIR_EraseRootFromParent_Done,
     /*  93204 */ // Label 1711: @93204
     /*  93204 */ GIM_Reject,
     /*  93205 */ // Label 1414: @93205
     /*  93205 */ GIM_Reject,
     /*  93206 */ // Label 10: @93206
     /*  93206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1720*/ GIMT_Encode4(93696),
     /*  93217 */ /*GILLT_s16*//*Label 1712*/ GIMT_Encode4(93257),
     /*  93221 */ /*GILLT_s32*//*Label 1713*/ GIMT_Encode4(93288),
     /*  93225 */ /*GILLT_s64*//*Label 1714*/ GIMT_Encode4(93319), GIMT_Encode4(0),
     /*  93233 */ /*GILLT_v2s32*//*Label 1715*/ GIMT_Encode4(93350),
     /*  93237 */ /*GILLT_v2s64*//*Label 1716*/ GIMT_Encode4(93381),
     /*  93241 */ /*GILLT_v4s16*//*Label 1717*/ GIMT_Encode4(93412),
     /*  93245 */ /*GILLT_v4s32*//*Label 1718*/ GIMT_Encode4(93443), GIMT_Encode4(0),
     /*  93253 */ /*GILLT_v8s16*//*Label 1719*/ GIMT_Encode4(93474),
     /*  93257 */ // Label 1712: @93257
     /*  93257 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(93287), // Rule ID 564 //
     /*  93262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93276 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  93281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93285 */   GIR_RootConstrainSelectedInstOperands,
     /*  93286 */   // GIR_Coverage, 564,
     /*  93286 */   GIR_Done,
     /*  93287 */ // Label 1721: @93287
     /*  93287 */ GIM_Reject,
     /*  93288 */ // Label 1713: @93288
     /*  93288 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(93318), // Rule ID 566 //
     /*  93293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93307 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  93312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93316 */   GIR_RootConstrainSelectedInstOperands,
     /*  93317 */   // GIR_Coverage, 566,
     /*  93317 */   GIR_Done,
     /*  93318 */ // Label 1722: @93318
     /*  93318 */ GIM_Reject,
     /*  93319 */ // Label 1714: @93319
     /*  93319 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(93349), // Rule ID 568 //
     /*  93324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93338 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  93343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93347 */   GIR_RootConstrainSelectedInstOperands,
     /*  93348 */   // GIR_Coverage, 568,
     /*  93348 */   GIR_Done,
     /*  93349 */ // Label 1723: @93349
     /*  93349 */ GIM_Reject,
     /*  93350 */ // Label 1715: @93350
     /*  93350 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(93380), // Rule ID 926 //
     /*  93355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93369 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  93374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93378 */   GIR_RootConstrainSelectedInstOperands,
     /*  93379 */   // GIR_Coverage, 926,
     /*  93379 */   GIR_Done,
     /*  93380 */ // Label 1724: @93380
     /*  93380 */ GIM_Reject,
     /*  93381 */ // Label 1716: @93381
     /*  93381 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(93411), // Rule ID 930 //
     /*  93386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93400 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  93405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93409 */   GIR_RootConstrainSelectedInstOperands,
     /*  93410 */   // GIR_Coverage, 930,
     /*  93410 */   GIR_Done,
     /*  93411 */ // Label 1725: @93411
     /*  93411 */ GIM_Reject,
     /*  93412 */ // Label 1717: @93412
     /*  93412 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(93442), // Rule ID 922 //
     /*  93417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93431 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  93436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93440 */   GIR_RootConstrainSelectedInstOperands,
     /*  93441 */   // GIR_Coverage, 922,
     /*  93441 */   GIR_Done,
     /*  93442 */ // Label 1726: @93442
     /*  93442 */ GIM_Reject,
     /*  93443 */ // Label 1718: @93443
     /*  93443 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(93473), // Rule ID 928 //
     /*  93448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93462 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93471 */   GIR_RootConstrainSelectedInstOperands,
     /*  93472 */   // GIR_Coverage, 928,
     /*  93472 */   GIR_Done,
     /*  93473 */ // Label 1727: @93473
     /*  93473 */ GIM_Reject,
     /*  93474 */ // Label 1719: @93474
     /*  93474 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(93695),
     /*  93479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93490 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(93509), // Rule ID 924 //
     /*  93495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93498 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  93503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93507 */     GIR_RootConstrainSelectedInstOperands,
     /*  93508 */     // GIR_Coverage, 924,
     /*  93508 */     GIR_Done,
     /*  93509 */   // Label 1729: @93509
     /*  93509 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(93694), // Rule ID 6912 //
     /*  93514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  93517 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  93517 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  93520 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  93524 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93529 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  93533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  93535 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  93538 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93542 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93547 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  93550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  93552 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  93555 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93559 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93564 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  93570 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93575 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93580 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  93583 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  93587 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93592 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  93595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  93597 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  93600 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93604 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93609 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  93612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  93614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  93617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  93621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93626 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  93629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  93638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  93652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  93663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  93666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  93684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  93692 */     GIR_RootConstrainSelectedInstOperands,
     /*  93693 */     // GIR_Coverage, 6912,
     /*  93693 */     GIR_EraseRootFromParent_Done,
     /*  93694 */   // Label 1730: @93694
     /*  93694 */   GIM_Reject,
     /*  93695 */ // Label 1728: @93695
     /*  93695 */ GIM_Reject,
     /*  93696 */ // Label 1720: @93696
     /*  93696 */ GIM_Reject,
     /*  93697 */ // Label 11: @93697
     /*  93697 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1739*/ GIMT_Encode4(94187),
     /*  93708 */ /*GILLT_s16*//*Label 1731*/ GIMT_Encode4(93748),
     /*  93712 */ /*GILLT_s32*//*Label 1732*/ GIMT_Encode4(93779),
     /*  93716 */ /*GILLT_s64*//*Label 1733*/ GIMT_Encode4(93810), GIMT_Encode4(0),
     /*  93724 */ /*GILLT_v2s32*//*Label 1734*/ GIMT_Encode4(93841),
     /*  93728 */ /*GILLT_v2s64*//*Label 1735*/ GIMT_Encode4(93872),
     /*  93732 */ /*GILLT_v4s16*//*Label 1736*/ GIMT_Encode4(93903),
     /*  93736 */ /*GILLT_v4s32*//*Label 1737*/ GIMT_Encode4(93934), GIMT_Encode4(0),
     /*  93744 */ /*GILLT_v8s16*//*Label 1738*/ GIMT_Encode4(93965),
     /*  93748 */ // Label 1731: @93748
     /*  93748 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(93778), // Rule ID 528 //
     /*  93753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93767 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  93772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93776 */   GIR_RootConstrainSelectedInstOperands,
     /*  93777 */   // GIR_Coverage, 528,
     /*  93777 */   GIR_Done,
     /*  93778 */ // Label 1740: @93778
     /*  93778 */ GIM_Reject,
     /*  93779 */ // Label 1732: @93779
     /*  93779 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(93809), // Rule ID 530 //
     /*  93784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93798 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  93803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93807 */   GIR_RootConstrainSelectedInstOperands,
     /*  93808 */   // GIR_Coverage, 530,
     /*  93808 */   GIR_Done,
     /*  93809 */ // Label 1741: @93809
     /*  93809 */ GIM_Reject,
     /*  93810 */ // Label 1733: @93810
     /*  93810 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(93840), // Rule ID 532 //
     /*  93815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93829 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  93834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93838 */   GIR_RootConstrainSelectedInstOperands,
     /*  93839 */   // GIR_Coverage, 532,
     /*  93839 */   GIR_Done,
     /*  93840 */ // Label 1742: @93840
     /*  93840 */ GIM_Reject,
     /*  93841 */ // Label 1734: @93841
     /*  93841 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(93871), // Rule ID 866 //
     /*  93846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93860 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  93865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93869 */   GIR_RootConstrainSelectedInstOperands,
     /*  93870 */   // GIR_Coverage, 866,
     /*  93870 */   GIR_Done,
     /*  93871 */ // Label 1743: @93871
     /*  93871 */ GIM_Reject,
     /*  93872 */ // Label 1735: @93872
     /*  93872 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(93902), // Rule ID 870 //
     /*  93877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93891 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  93896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93900 */   GIR_RootConstrainSelectedInstOperands,
     /*  93901 */   // GIR_Coverage, 870,
     /*  93901 */   GIR_Done,
     /*  93902 */ // Label 1744: @93902
     /*  93902 */ GIM_Reject,
     /*  93903 */ // Label 1736: @93903
     /*  93903 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(93933), // Rule ID 862 //
     /*  93908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93922 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  93927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93931 */   GIR_RootConstrainSelectedInstOperands,
     /*  93932 */   // GIR_Coverage, 862,
     /*  93932 */   GIR_Done,
     /*  93933 */ // Label 1745: @93933
     /*  93933 */ GIM_Reject,
     /*  93934 */ // Label 1737: @93934
     /*  93934 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(93964), // Rule ID 868 //
     /*  93939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93953 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  93958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93962 */   GIR_RootConstrainSelectedInstOperands,
     /*  93963 */   // GIR_Coverage, 868,
     /*  93963 */   GIR_Done,
     /*  93964 */ // Label 1746: @93964
     /*  93964 */ GIM_Reject,
     /*  93965 */ // Label 1738: @93965
     /*  93965 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(94186),
     /*  93970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93981 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(94000), // Rule ID 864 //
     /*  93986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93989 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  93994 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93998 */     GIR_RootConstrainSelectedInstOperands,
     /*  93999 */     // GIR_Coverage, 864,
     /*  93999 */     GIR_Done,
     /*  94000 */   // Label 1748: @94000
     /*  94000 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(94185), // Rule ID 6906 //
     /*  94005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94008 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94008 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94011 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94015 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94020 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94026 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94029 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94033 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94038 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94043 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94046 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94050 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94055 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94061 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94066 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94071 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94074 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94078 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94083 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  94091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94100 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  94103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  94105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  94108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  94112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94117 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  94120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  94129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  94143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  94157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  94175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  94183 */     GIR_RootConstrainSelectedInstOperands,
     /*  94184 */     // GIR_Coverage, 6906,
     /*  94184 */     GIR_EraseRootFromParent_Done,
     /*  94185 */   // Label 1749: @94185
     /*  94185 */   GIM_Reject,
     /*  94186 */ // Label 1747: @94186
     /*  94186 */ GIM_Reject,
     /*  94187 */ // Label 1739: @94187
     /*  94187 */ GIM_Reject,
     /*  94188 */ // Label 12: @94188
     /*  94188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1752*/ GIMT_Encode4(94455),
     /*  94199 */ /*GILLT_s32*//*Label 1750*/ GIMT_Encode4(94207),
     /*  94203 */ /*GILLT_s64*//*Label 1751*/ GIMT_Encode4(94331),
     /*  94207 */ // Label 1750: @94207
     /*  94207 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(94250), // Rule ID 4725 //
     /*  94212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94222 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  94243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94248 */   GIR_RootConstrainSelectedInstOperands,
     /*  94249 */   // GIR_Coverage, 4725,
     /*  94249 */   GIR_EraseRootFromParent_Done,
     /*  94250 */ // Label 1753: @94250
     /*  94250 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(94290), // Rule ID 4731 //
     /*  94255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94262 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  94283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94288 */   GIR_RootConstrainSelectedInstOperands,
     /*  94289 */   // GIR_Coverage, 4731,
     /*  94289 */   GIR_EraseRootFromParent_Done,
     /*  94290 */ // Label 1754: @94290
     /*  94290 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(94330), // Rule ID 4733 //
     /*  94295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94302 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94314 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  94323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94328 */   GIR_RootConstrainSelectedInstOperands,
     /*  94329 */   // GIR_Coverage, 4733,
     /*  94329 */   GIR_EraseRootFromParent_Done,
     /*  94330 */ // Label 1755: @94330
     /*  94330 */ GIM_Reject,
     /*  94331 */ // Label 1751: @94331
     /*  94331 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(94374), // Rule ID 4727 //
     /*  94336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94346 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94372 */   GIR_RootConstrainSelectedInstOperands,
     /*  94373 */   // GIR_Coverage, 4727,
     /*  94373 */   GIR_EraseRootFromParent_Done,
     /*  94374 */ // Label 1756: @94374
     /*  94374 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(94414), // Rule ID 4735 //
     /*  94379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94386 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94412 */   GIR_RootConstrainSelectedInstOperands,
     /*  94413 */   // GIR_Coverage, 4735,
     /*  94413 */   GIR_EraseRootFromParent_Done,
     /*  94414 */ // Label 1757: @94414
     /*  94414 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(94454), // Rule ID 4737 //
     /*  94419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94426 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94452 */   GIR_RootConstrainSelectedInstOperands,
     /*  94453 */   // GIR_Coverage, 4737,
     /*  94453 */   GIR_EraseRootFromParent_Done,
     /*  94454 */ // Label 1758: @94454
     /*  94454 */ GIM_Reject,
     /*  94455 */ // Label 1752: @94455
     /*  94455 */ GIM_Reject,
     /*  94456 */ // Label 13: @94456
     /*  94456 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(94605),
     /*  94461 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94464 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1763*/ GIMT_Encode4(94604),
     /*  94475 */   /*GILLT_s16*//*Label 1760*/ GIMT_Encode4(94487),
     /*  94479 */   /*GILLT_s32*//*Label 1761*/ GIMT_Encode4(94528),
     /*  94483 */   /*GILLT_s64*//*Label 1762*/ GIMT_Encode4(94566),
     /*  94487 */   // Label 1760: @94487
     /*  94487 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(94527), // Rule ID 4729 //
     /*  94492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94499 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94525 */     GIR_RootConstrainSelectedInstOperands,
     /*  94526 */     // GIR_Coverage, 4729,
     /*  94526 */     GIR_EraseRootFromParent_Done,
     /*  94527 */   // Label 1764: @94527
     /*  94527 */   GIM_Reject,
     /*  94528 */   // Label 1761: @94528
     /*  94528 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(94565), // Rule ID 4739 //
     /*  94533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94537 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94563 */     GIR_RootConstrainSelectedInstOperands,
     /*  94564 */     // GIR_Coverage, 4739,
     /*  94564 */     GIR_EraseRootFromParent_Done,
     /*  94565 */   // Label 1765: @94565
     /*  94565 */   GIM_Reject,
     /*  94566 */   // Label 1762: @94566
     /*  94566 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(94603), // Rule ID 4741 //
     /*  94571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94575 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94601 */     GIR_RootConstrainSelectedInstOperands,
     /*  94602 */     // GIR_Coverage, 4741,
     /*  94602 */     GIR_EraseRootFromParent_Done,
     /*  94603 */   // Label 1766: @94603
     /*  94603 */   GIM_Reject,
     /*  94604 */   // Label 1763: @94604
     /*  94604 */   GIM_Reject,
     /*  94605 */ // Label 1759: @94605
     /*  94605 */ GIM_Reject,
     /*  94606 */ // Label 14: @94606
     /*  94606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1775*/ GIMT_Encode4(95096),
     /*  94617 */ /*GILLT_s16*//*Label 1767*/ GIMT_Encode4(94657),
     /*  94621 */ /*GILLT_s32*//*Label 1768*/ GIMT_Encode4(94688),
     /*  94625 */ /*GILLT_s64*//*Label 1769*/ GIMT_Encode4(94719), GIMT_Encode4(0),
     /*  94633 */ /*GILLT_v2s32*//*Label 1770*/ GIMT_Encode4(94750),
     /*  94637 */ /*GILLT_v2s64*//*Label 1771*/ GIMT_Encode4(94781),
     /*  94641 */ /*GILLT_v4s16*//*Label 1772*/ GIMT_Encode4(94812),
     /*  94645 */ /*GILLT_v4s32*//*Label 1773*/ GIMT_Encode4(94843), GIMT_Encode4(0),
     /*  94653 */ /*GILLT_v8s16*//*Label 1774*/ GIMT_Encode4(94874),
     /*  94657 */ // Label 1767: @94657
     /*  94657 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(94687), // Rule ID 546 //
     /*  94662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94676 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  94676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  94681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94685 */   GIR_RootConstrainSelectedInstOperands,
     /*  94686 */   // GIR_Coverage, 546,
     /*  94686 */   GIR_Done,
     /*  94687 */ // Label 1776: @94687
     /*  94687 */ GIM_Reject,
     /*  94688 */ // Label 1768: @94688
     /*  94688 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(94718), // Rule ID 548 //
     /*  94693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94707 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  94707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  94712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94716 */   GIR_RootConstrainSelectedInstOperands,
     /*  94717 */   // GIR_Coverage, 548,
     /*  94717 */   GIR_Done,
     /*  94718 */ // Label 1777: @94718
     /*  94718 */ GIM_Reject,
     /*  94719 */ // Label 1769: @94719
     /*  94719 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(94749), // Rule ID 550 //
     /*  94724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94738 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  94738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  94743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94747 */   GIR_RootConstrainSelectedInstOperands,
     /*  94748 */   // GIR_Coverage, 550,
     /*  94748 */   GIR_Done,
     /*  94749 */ // Label 1778: @94749
     /*  94749 */ GIM_Reject,
     /*  94750 */ // Label 1770: @94750
     /*  94750 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(94780), // Rule ID 896 //
     /*  94755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94769 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  94769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  94774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94778 */   GIR_RootConstrainSelectedInstOperands,
     /*  94779 */   // GIR_Coverage, 896,
     /*  94779 */   GIR_Done,
     /*  94780 */ // Label 1779: @94780
     /*  94780 */ GIM_Reject,
     /*  94781 */ // Label 1771: @94781
     /*  94781 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(94811), // Rule ID 900 //
     /*  94786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94800 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  94800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  94805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94809 */   GIR_RootConstrainSelectedInstOperands,
     /*  94810 */   // GIR_Coverage, 900,
     /*  94810 */   GIR_Done,
     /*  94811 */ // Label 1780: @94811
     /*  94811 */ GIM_Reject,
     /*  94812 */ // Label 1772: @94812
     /*  94812 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(94842), // Rule ID 892 //
     /*  94817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94831 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  94831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  94836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94840 */   GIR_RootConstrainSelectedInstOperands,
     /*  94841 */   // GIR_Coverage, 892,
     /*  94841 */   GIR_Done,
     /*  94842 */ // Label 1781: @94842
     /*  94842 */ GIM_Reject,
     /*  94843 */ // Label 1773: @94843
     /*  94843 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(94873), // Rule ID 898 //
     /*  94848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94862 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  94862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94871 */   GIR_RootConstrainSelectedInstOperands,
     /*  94872 */   // GIR_Coverage, 898,
     /*  94872 */   GIR_Done,
     /*  94873 */ // Label 1782: @94873
     /*  94873 */ GIM_Reject,
     /*  94874 */ // Label 1774: @94874
     /*  94874 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(95095),
     /*  94879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94890 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(94909), // Rule ID 894 //
     /*  94895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94898 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  94898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  94903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94907 */     GIR_RootConstrainSelectedInstOperands,
     /*  94908 */     // GIR_Coverage, 894,
     /*  94908 */     GIR_Done,
     /*  94909 */   // Label 1784: @94909
     /*  94909 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(95094), // Rule ID 6908 //
     /*  94914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94917 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94917 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94920 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94924 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94929 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94935 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94938 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94942 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94947 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94952 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94955 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94959 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94964 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94970 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94975 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94980 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94983 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94987 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94992 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94997 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  95000 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  95004 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95009 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  95012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95014 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  95017 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  95021 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95026 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  95029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  95038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  95052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  95066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  95081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  95084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  95092 */     GIR_RootConstrainSelectedInstOperands,
     /*  95093 */     // GIR_Coverage, 6908,
     /*  95093 */     GIR_EraseRootFromParent_Done,
     /*  95094 */   // Label 1785: @95094
     /*  95094 */   GIM_Reject,
     /*  95095 */ // Label 1783: @95095
     /*  95095 */ GIM_Reject,
     /*  95096 */ // Label 1775: @95096
     /*  95096 */ GIM_Reject,
     /*  95097 */ // Label 15: @95097
     /*  95097 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(95129), // Rule ID 3846 //
     /*  95102 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  95105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  95109 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  95109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  95112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95114 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  95124 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  95127 */   GIR_RootConstrainSelectedInstOperands,
     /*  95128 */   // GIR_Coverage, 3846,
     /*  95128 */   GIR_EraseRootFromParent_Done,
     /*  95129 */ // Label 1786: @95129
     /*  95129 */ GIM_Reject,
     /*  95130 */ // Label 16: @95130
     /*  95130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(103939),
     /*  95141 */ /*GILLT_s8*//*Label 1787*/ GIMT_Encode4(95237),
     /*  95145 */ /*GILLT_s16*//*Label 1788*/ GIMT_Encode4(95413),
     /*  95149 */ /*GILLT_s32*//*Label 1789*/ GIMT_Encode4(95589),
     /*  95153 */ /*GILLT_s64*//*Label 1790*/ GIMT_Encode4(97887),
     /*  95157 */ /*GILLT_s128*//*Label 1791*/ GIMT_Encode4(100568),
     /*  95161 */ /*GILLT_v2s32*//*Label 1792*/ GIMT_Encode4(100777),
     /*  95165 */ /*GILLT_v2s64*//*Label 1793*/ GIMT_Encode4(101155),
     /*  95169 */ /*GILLT_v4s16*//*Label 1794*/ GIMT_Encode4(101533),
     /*  95173 */ /*GILLT_v4s32*//*Label 1795*/ GIMT_Encode4(101911),
     /*  95177 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(102289),
     /*  95181 */ /*GILLT_v8s16*//*Label 1797*/ GIMT_Encode4(102497),
     /*  95185 */ /*GILLT_v16s8*//*Label 1798*/ GIMT_Encode4(102875), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  95197 */ /*GILLT_nxv2s16*//*Label 1799*/ GIMT_Encode4(103083),
     /*  95201 */ /*GILLT_nxv2s32*//*Label 1800*/ GIMT_Encode4(103147),
     /*  95205 */ /*GILLT_nxv2s64*//*Label 1801*/ GIMT_Encode4(103211), GIMT_Encode4(0),
     /*  95213 */ /*GILLT_nxv4s16*//*Label 1802*/ GIMT_Encode4(103385),
     /*  95217 */ /*GILLT_nxv4s32*//*Label 1803*/ GIMT_Encode4(103449), GIMT_Encode4(0),
     /*  95225 */ /*GILLT_nxv8s16*//*Label 1804*/ GIMT_Encode4(103623),
     /*  95229 */ /*GILLT_nxv16s1*//*Label 1805*/ GIMT_Encode4(103797),
     /*  95233 */ /*GILLT_nxv16s8*//*Label 1806*/ GIMT_Encode4(103841),
     /*  95237 */ // Label 1787: @95237
     /*  95237 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(95412),
     /*  95242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  95253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95257 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(95298), // Rule ID 237 //
     /*  95262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95272 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  95275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95296 */     GIR_RootConstrainSelectedInstOperands,
     /*  95297 */     // GIR_Coverage, 237,
     /*  95297 */     GIR_EraseRootFromParent_Done,
     /*  95298 */   // Label 1809: @95298
     /*  95298 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(95339), // Rule ID 238 //
     /*  95303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95313 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  95316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95337 */     GIR_RootConstrainSelectedInstOperands,
     /*  95338 */     // GIR_Coverage, 238,
     /*  95338 */     GIR_EraseRootFromParent_Done,
     /*  95339 */   // Label 1810: @95339
     /*  95339 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(95375), // Rule ID 261 //
     /*  95344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  95354 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  95354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  95357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95373 */     GIR_RootConstrainSelectedInstOperands,
     /*  95374 */     // GIR_Coverage, 261,
     /*  95374 */     GIR_EraseRootFromParent_Done,
     /*  95375 */   // Label 1811: @95375
     /*  95375 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(95411), // Rule ID 282 //
     /*  95380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  95390 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  95393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95409 */     GIR_RootConstrainSelectedInstOperands,
     /*  95410 */     // GIR_Coverage, 282,
     /*  95410 */     GIR_EraseRootFromParent_Done,
     /*  95411 */   // Label 1812: @95411
     /*  95411 */   GIM_Reject,
     /*  95412 */ // Label 1808: @95412
     /*  95412 */ GIM_Reject,
     /*  95413 */ // Label 1788: @95413
     /*  95413 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(95588),
     /*  95418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  95429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95433 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(95474), // Rule ID 239 //
     /*  95438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95448 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  95451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95472 */     GIR_RootConstrainSelectedInstOperands,
     /*  95473 */     // GIR_Coverage, 239,
     /*  95473 */     GIR_EraseRootFromParent_Done,
     /*  95474 */   // Label 1814: @95474
     /*  95474 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(95515), // Rule ID 240 //
     /*  95479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  95489 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  95489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  95492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95513 */     GIR_RootConstrainSelectedInstOperands,
     /*  95514 */     // GIR_Coverage, 240,
     /*  95514 */     GIR_EraseRootFromParent_Done,
     /*  95515 */   // Label 1815: @95515
     /*  95515 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(95551), // Rule ID 262 //
     /*  95520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  95530 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  95530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  95533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95549 */     GIR_RootConstrainSelectedInstOperands,
     /*  95550 */     // GIR_Coverage, 262,
     /*  95550 */     GIR_EraseRootFromParent_Done,
     /*  95551 */   // Label 1816: @95551
     /*  95551 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(95587), // Rule ID 283 //
     /*  95556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  95566 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  95569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95585 */     GIR_RootConstrainSelectedInstOperands,
     /*  95586 */     // GIR_Coverage, 283,
     /*  95586 */     GIR_EraseRootFromParent_Done,
     /*  95587 */   // Label 1817: @95587
     /*  95587 */   GIM_Reject,
     /*  95588 */ // Label 1813: @95588
     /*  95588 */ GIM_Reject,
     /*  95589 */ // Label 1789: @95589
     /*  95589 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(95642), // Rule ID 233 //
     /*  95594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95616 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  95619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95640 */   GIR_RootConstrainSelectedInstOperands,
     /*  95641 */   // GIR_Coverage, 233,
     /*  95641 */   GIR_EraseRootFromParent_Done,
     /*  95642 */ // Label 1818: @95642
     /*  95642 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95695), // Rule ID 234 //
     /*  95647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95669 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  95672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95693 */   GIR_RootConstrainSelectedInstOperands,
     /*  95694 */   // GIR_Coverage, 234,
     /*  95694 */   GIR_EraseRootFromParent_Done,
     /*  95695 */ // Label 1819: @95695
     /*  95695 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(95751), // Rule ID 241 //
     /*  95700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95725 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  95728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95749 */   GIR_RootConstrainSelectedInstOperands,
     /*  95750 */   // GIR_Coverage, 241,
     /*  95750 */   GIR_EraseRootFromParent_Done,
     /*  95751 */ // Label 1820: @95751
     /*  95751 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(95807), // Rule ID 242 //
     /*  95756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95781 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  95784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95805 */   GIR_RootConstrainSelectedInstOperands,
     /*  95806 */   // GIR_Coverage, 242,
     /*  95806 */   GIR_EraseRootFromParent_Done,
     /*  95807 */ // Label 1821: @95807
     /*  95807 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(95867), // Rule ID 4062 //
     /*  95812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95841 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  95844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95865 */   GIR_RootConstrainSelectedInstOperands,
     /*  95866 */   // GIR_Coverage, 4062,
     /*  95866 */   GIR_EraseRootFromParent_Done,
     /*  95867 */ // Label 1822: @95867
     /*  95867 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(95927), // Rule ID 4063 //
     /*  95872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95901 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  95904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95925 */   GIR_RootConstrainSelectedInstOperands,
     /*  95926 */   // GIR_Coverage, 4063,
     /*  95926 */   GIR_EraseRootFromParent_Done,
     /*  95927 */ // Label 1823: @95927
     /*  95927 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(95987), // Rule ID 4064 //
     /*  95932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95961 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  95964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95985 */   GIR_RootConstrainSelectedInstOperands,
     /*  95986 */   // GIR_Coverage, 4064,
     /*  95986 */   GIR_EraseRootFromParent_Done,
     /*  95987 */ // Label 1824: @95987
     /*  95987 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(96047), // Rule ID 4065 //
     /*  95992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95995 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96021 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96045 */   GIR_RootConstrainSelectedInstOperands,
     /*  96046 */   // GIR_Coverage, 4065,
     /*  96046 */   GIR_EraseRootFromParent_Done,
     /*  96047 */ // Label 1825: @96047
     /*  96047 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(96107), // Rule ID 4066 //
     /*  96052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96055 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96081 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96105 */   GIR_RootConstrainSelectedInstOperands,
     /*  96106 */   // GIR_Coverage, 4066,
     /*  96106 */   GIR_EraseRootFromParent_Done,
     /*  96107 */ // Label 1826: @96107
     /*  96107 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(96167), // Rule ID 4067 //
     /*  96112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96115 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96141 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96165 */   GIR_RootConstrainSelectedInstOperands,
     /*  96166 */   // GIR_Coverage, 4067,
     /*  96166 */   GIR_EraseRootFromParent_Done,
     /*  96167 */ // Label 1827: @96167
     /*  96167 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(96215), // Rule ID 260 //
     /*  96172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96194 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96213 */   GIR_RootConstrainSelectedInstOperands,
     /*  96214 */   // GIR_Coverage, 260,
     /*  96214 */   GIR_EraseRootFromParent_Done,
     /*  96215 */ // Label 1828: @96215
     /*  96215 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(96266), // Rule ID 263 //
     /*  96220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96245 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  96248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96264 */   GIR_RootConstrainSelectedInstOperands,
     /*  96265 */   // GIR_Coverage, 263,
     /*  96265 */   GIR_EraseRootFromParent_Done,
     /*  96266 */ // Label 1829: @96266
     /*  96266 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(96325), // Rule ID 6936 //
     /*  96271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96281 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  96299 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  96299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  96302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96323 */   GIR_RootConstrainSelectedInstOperands,
     /*  96324 */   // GIR_Coverage, 6936,
     /*  96324 */   GIR_EraseRootFromParent_Done,
     /*  96325 */ // Label 1830: @96325
     /*  96325 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(96384), // Rule ID 6938 //
     /*  96330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96340 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  96358 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  96358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  96361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96382 */   GIR_RootConstrainSelectedInstOperands,
     /*  96383 */   // GIR_Coverage, 6938,
     /*  96383 */   GIR_EraseRootFromParent_Done,
     /*  96384 */ // Label 1831: @96384
     /*  96384 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(96443), // Rule ID 6948 //
     /*  96389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96399 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  96417 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  96417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  96420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96441 */   GIR_RootConstrainSelectedInstOperands,
     /*  96442 */   // GIR_Coverage, 6948,
     /*  96442 */   GIR_EraseRootFromParent_Done,
     /*  96443 */ // Label 1832: @96443
     /*  96443 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(96502), // Rule ID 6950 //
     /*  96448 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96458 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96476 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96500 */   GIR_RootConstrainSelectedInstOperands,
     /*  96501 */   // GIR_Coverage, 6950,
     /*  96501 */   GIR_EraseRootFromParent_Done,
     /*  96502 */ // Label 1833: @96502
     /*  96502 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(96561), // Rule ID 6958 //
     /*  96507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96535 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96559 */   GIR_RootConstrainSelectedInstOperands,
     /*  96560 */   // GIR_Coverage, 6958,
     /*  96560 */   GIR_EraseRootFromParent_Done,
     /*  96561 */ // Label 1834: @96561
     /*  96561 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(96620), // Rule ID 6959 //
     /*  96566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96576 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96594 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96618 */   GIR_RootConstrainSelectedInstOperands,
     /*  96619 */   // GIR_Coverage, 6959,
     /*  96619 */   GIR_EraseRootFromParent_Done,
     /*  96620 */ // Label 1835: @96620
     /*  96620 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(96668), // Rule ID 281 //
     /*  96625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96647 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  96650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96666 */   GIR_RootConstrainSelectedInstOperands,
     /*  96667 */   // GIR_Coverage, 281,
     /*  96667 */   GIR_EraseRootFromParent_Done,
     /*  96668 */ // Label 1836: @96668
     /*  96668 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(96719), // Rule ID 284 //
     /*  96673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96698 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  96701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96717 */   GIR_RootConstrainSelectedInstOperands,
     /*  96718 */   // GIR_Coverage, 284,
     /*  96718 */   GIR_EraseRootFromParent_Done,
     /*  96719 */ // Label 1837: @96719
     /*  96719 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(96773), // Rule ID 6940 //
     /*  96724 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96734 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  96752 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  96752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  96755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96771 */   GIR_RootConstrainSelectedInstOperands,
     /*  96772 */   // GIR_Coverage, 6940,
     /*  96772 */   GIR_EraseRootFromParent_Done,
     /*  96773 */ // Label 1838: @96773
     /*  96773 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(96827), // Rule ID 6942 //
     /*  96778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  96806 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15696>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  96809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96825 */   GIR_RootConstrainSelectedInstOperands,
     /*  96826 */   // GIR_Coverage, 6942,
     /*  96826 */   GIR_EraseRootFromParent_Done,
     /*  96827 */ // Label 1839: @96827
     /*  96827 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(96881), // Rule ID 6952 //
     /*  96832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96842 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  96860 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  96860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  96863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96879 */   GIR_RootConstrainSelectedInstOperands,
     /*  96880 */   // GIR_Coverage, 6952,
     /*  96880 */   GIR_EraseRootFromParent_Done,
     /*  96881 */ // Label 1840: @96881
     /*  96881 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(96935), // Rule ID 6954 //
     /*  96886 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96896 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  96914 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15705>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  96917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96933 */   GIR_RootConstrainSelectedInstOperands,
     /*  96934 */   // GIR_Coverage, 6954,
     /*  96934 */   GIR_EraseRootFromParent_Done,
     /*  96935 */ // Label 1841: @96935
     /*  96935 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(96989), // Rule ID 6960 //
     /*  96940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96950 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96968 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96987 */   GIR_RootConstrainSelectedInstOperands,
     /*  96988 */   // GIR_Coverage, 6960,
     /*  96988 */   GIR_EraseRootFromParent_Done,
     /*  96989 */ // Label 1842: @96989
     /*  96989 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(97043), // Rule ID 6961 //
     /*  96994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97022 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15713>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  97025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97041 */   GIR_RootConstrainSelectedInstOperands,
     /*  97042 */   // GIR_Coverage, 6961,
     /*  97042 */   GIR_EraseRootFromParent_Done,
     /*  97043 */ // Label 1843: @97043
     /*  97043 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(97100), // Rule ID 7276 //
     /*  97048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97051 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97079 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15694>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /*  97082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97098 */   GIR_RootConstrainSelectedInstOperands,
     /*  97099 */   // GIR_Coverage, 7276,
     /*  97099 */   GIR_EraseRootFromParent_Done,
     /*  97100 */ // Label 1844: @97100
     /*  97100 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(97157), // Rule ID 7278 //
     /*  97105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97136 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15703>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /*  97139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97155 */   GIR_RootConstrainSelectedInstOperands,
     /*  97156 */   // GIR_Coverage, 7278,
     /*  97156 */   GIR_EraseRootFromParent_Done,
     /*  97157 */ // Label 1845: @97157
     /*  97157 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(97214), // Rule ID 7280 //
     /*  97162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97193 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15688>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /*  97196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97212 */   GIR_RootConstrainSelectedInstOperands,
     /*  97213 */   // GIR_Coverage, 7280,
     /*  97213 */   GIR_EraseRootFromParent_Done,
     /*  97214 */ // Label 1846: @97214
     /*  97214 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(97269), // Rule ID 4089 //
     /*  97219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  97248 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  97248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  97251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97267 */   GIR_RootConstrainSelectedInstOperands,
     /*  97268 */   // GIR_Coverage, 4089,
     /*  97268 */   GIR_EraseRootFromParent_Done,
     /*  97269 */ // Label 1847: @97269
     /*  97269 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(97324), // Rule ID 4090 //
     /*  97274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97277 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97303 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97322 */   GIR_RootConstrainSelectedInstOperands,
     /*  97323 */   // GIR_Coverage, 4090,
     /*  97323 */   GIR_EraseRootFromParent_Done,
     /*  97324 */ // Label 1848: @97324
     /*  97324 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(97379), // Rule ID 4091 //
     /*  97329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97358 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97377 */   GIR_RootConstrainSelectedInstOperands,
     /*  97378 */   // GIR_Coverage, 4091,
     /*  97378 */   GIR_EraseRootFromParent_Done,
     /*  97379 */ // Label 1849: @97379
     /*  97379 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(97434), // Rule ID 4112 //
     /*  97384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97387 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97406 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97413 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  97416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97432 */   GIR_RootConstrainSelectedInstOperands,
     /*  97433 */   // GIR_Coverage, 4112,
     /*  97433 */   GIR_EraseRootFromParent_Done,
     /*  97434 */ // Label 1850: @97434
     /*  97434 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(97489), // Rule ID 4113 //
     /*  97439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97468 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97487 */   GIR_RootConstrainSelectedInstOperands,
     /*  97488 */   // GIR_Coverage, 4113,
     /*  97488 */   GIR_EraseRootFromParent_Done,
     /*  97489 */ // Label 1851: @97489
     /*  97489 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(97544), // Rule ID 4114 //
     /*  97494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97497 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97523 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97542 */   GIR_RootConstrainSelectedInstOperands,
     /*  97543 */   // GIR_Coverage, 4114,
     /*  97543 */   GIR_EraseRootFromParent_Done,
     /*  97544 */ // Label 1852: @97544
     /*  97544 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(97584), // Rule ID 6928 //
     /*  97549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97569 */   // MIs[0] ptr
     /*  97569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97577 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15684>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /*  97582 */   GIR_RootConstrainSelectedInstOperands,
     /*  97583 */   // GIR_Coverage, 6928,
     /*  97583 */   GIR_Done,
     /*  97584 */ // Label 1853: @97584
     /*  97584 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(97624), // Rule ID 6929 //
     /*  97589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97609 */   // MIs[0] ptr
     /*  97609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97617 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15686>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /*  97622 */   GIR_RootConstrainSelectedInstOperands,
     /*  97623 */   // GIR_Coverage, 6929,
     /*  97623 */   GIR_Done,
     /*  97624 */ // Label 1854: @97624
     /*  97624 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(97664), // Rule ID 6930 //
     /*  97629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97649 */   // MIs[0] ptr
     /*  97649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97657 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15688>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /*  97662 */   GIR_RootConstrainSelectedInstOperands,
     /*  97663 */   // GIR_Coverage, 6930,
     /*  97663 */   GIR_Done,
     /*  97664 */ // Label 1855: @97664
     /*  97664 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(97701), // Rule ID 6932 //
     /*  97669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97686 */   // MIs[0] ptr
     /*  97686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97694 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15692>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97699 */   GIR_RootConstrainSelectedInstOperands,
     /*  97700 */   // GIR_Coverage, 6932,
     /*  97700 */   GIR_Done,
     /*  97701 */ // Label 1856: @97701
     /*  97701 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(97738), // Rule ID 6934 //
     /*  97706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97723 */   // MIs[0] ptr
     /*  97723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97731 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15694>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97736 */   GIR_RootConstrainSelectedInstOperands,
     /*  97737 */   // GIR_Coverage, 6934,
     /*  97737 */   GIR_Done,
     /*  97738 */ // Label 1857: @97738
     /*  97738 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(97775), // Rule ID 6944 //
     /*  97743 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97760 */   // MIs[0] ptr
     /*  97760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97768 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15701>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97773 */   GIR_RootConstrainSelectedInstOperands,
     /*  97774 */   // GIR_Coverage, 6944,
     /*  97774 */   GIR_Done,
     /*  97775 */ // Label 1858: @97775
     /*  97775 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(97812), // Rule ID 6946 //
     /*  97780 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97797 */   // MIs[0] ptr
     /*  97797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97805 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15703>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97810 */   GIR_RootConstrainSelectedInstOperands,
     /*  97811 */   // GIR_Coverage, 6946,
     /*  97811 */   GIR_Done,
     /*  97812 */ // Label 1859: @97812
     /*  97812 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(97849), // Rule ID 6956 //
     /*  97817 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97834 */   // MIs[0] ptr
     /*  97834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97842 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15710>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97847 */   GIR_RootConstrainSelectedInstOperands,
     /*  97848 */   // GIR_Coverage, 6956,
     /*  97848 */   GIR_Done,
     /*  97849 */ // Label 1860: @97849
     /*  97849 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(97886), // Rule ID 6957 //
     /*  97854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97871 */   // MIs[0] ptr
     /*  97871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15688>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97884 */   GIR_RootConstrainSelectedInstOperands,
     /*  97885 */   // GIR_Coverage, 6957,
     /*  97885 */   GIR_Done,
     /*  97886 */ // Label 1861: @97886
     /*  97886 */ GIM_Reject,
     /*  97887 */ // Label 1790: @97887
     /*  97887 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(97940), // Rule ID 235 //
     /*  97892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  97914 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  97914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  97917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97938 */   GIR_RootConstrainSelectedInstOperands,
     /*  97939 */   // GIR_Coverage, 235,
     /*  97939 */   GIR_EraseRootFromParent_Done,
     /*  97940 */ // Label 1862: @97940
     /*  97940 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(97993), // Rule ID 236 //
     /*  97945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  97967 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  97967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  97970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97991 */   GIR_RootConstrainSelectedInstOperands,
     /*  97992 */   // GIR_Coverage, 236,
     /*  97992 */   GIR_EraseRootFromParent_Done,
     /*  97993 */ // Label 1863: @97993
     /*  97993 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(98049), // Rule ID 243 //
     /*  97998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98023 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98047 */   GIR_RootConstrainSelectedInstOperands,
     /*  98048 */   // GIR_Coverage, 243,
     /*  98048 */   GIR_EraseRootFromParent_Done,
     /*  98049 */ // Label 1864: @98049
     /*  98049 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(98105), // Rule ID 244 //
     /*  98054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98079 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98103 */   GIR_RootConstrainSelectedInstOperands,
     /*  98104 */   // GIR_Coverage, 244,
     /*  98104 */   GIR_EraseRootFromParent_Done,
     /*  98105 */ // Label 1865: @98105
     /*  98105 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(98158), // Rule ID 4028 //
     /*  98110 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98132 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98156 */   GIR_RootConstrainSelectedInstOperands,
     /*  98157 */   // GIR_Coverage, 4028,
     /*  98157 */   GIR_EraseRootFromParent_Done,
     /*  98158 */ // Label 1866: @98158
     /*  98158 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(98211), // Rule ID 4029 //
     /*  98163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98185 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98209 */   GIR_RootConstrainSelectedInstOperands,
     /*  98210 */   // GIR_Coverage, 4029,
     /*  98210 */   GIR_EraseRootFromParent_Done,
     /*  98211 */ // Label 1867: @98211
     /*  98211 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(98264), // Rule ID 4030 //
     /*  98216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98238 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98262 */   GIR_RootConstrainSelectedInstOperands,
     /*  98263 */   // GIR_Coverage, 4030,
     /*  98263 */   GIR_EraseRootFromParent_Done,
     /*  98264 */ // Label 1868: @98264
     /*  98264 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(98317), // Rule ID 4031 //
     /*  98269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98291 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98315 */   GIR_RootConstrainSelectedInstOperands,
     /*  98316 */   // GIR_Coverage, 4031,
     /*  98316 */   GIR_EraseRootFromParent_Done,
     /*  98317 */ // Label 1869: @98317
     /*  98317 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98409), // Rule ID 4054 //
     /*  98322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98325 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98329 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98344 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98351 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98378 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98408 */   // GIR_Coverage, 4054,
     /*  98408 */   GIR_EraseRootFromParent_Done,
     /*  98409 */ // Label 1870: @98409
     /*  98409 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98501), // Rule ID 4055 //
     /*  98414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98417 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98443 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98470 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98500 */   // GIR_Coverage, 4055,
     /*  98500 */   GIR_EraseRootFromParent_Done,
     /*  98501 */ // Label 1871: @98501
     /*  98501 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(98593), // Rule ID 4056 //
     /*  98506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98535 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  98542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98562 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98592 */   // GIR_Coverage, 4056,
     /*  98592 */   GIR_EraseRootFromParent_Done,
     /*  98593 */ // Label 1872: @98593
     /*  98593 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(98685), // Rule ID 4057 //
     /*  98598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98601 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98627 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  98634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98654 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98684 */   // GIR_Coverage, 4057,
     /*  98684 */   GIR_EraseRootFromParent_Done,
     /*  98685 */ // Label 1873: @98685
     /*  98685 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(98777), // Rule ID 4058 //
     /*  98690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98719 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98746 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98776 */   // GIR_Coverage, 4058,
     /*  98776 */   GIR_EraseRootFromParent_Done,
     /*  98777 */ // Label 1874: @98777
     /*  98777 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(98869), // Rule ID 4059 //
     /*  98782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98811 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98838 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98868 */   // GIR_Coverage, 4059,
     /*  98868 */   GIR_EraseRootFromParent_Done,
     /*  98869 */ // Label 1875: @98869
     /*  98869 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(98961), // Rule ID 4060 //
     /*  98874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98877 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98903 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98930 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98960 */   // GIR_Coverage, 4060,
     /*  98960 */   GIR_EraseRootFromParent_Done,
     /*  98961 */ // Label 1876: @98961
     /*  98961 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(99053), // Rule ID 4061 //
     /*  98966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98969 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98995 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99022 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99052 */   // GIR_Coverage, 4061,
     /*  99052 */   GIR_EraseRootFromParent_Done,
     /*  99053 */ // Label 1877: @99053
     /*  99053 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(99101), // Rule ID 259 //
     /*  99058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99080 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99099 */   GIR_RootConstrainSelectedInstOperands,
     /*  99100 */   // GIR_Coverage, 259,
     /*  99100 */   GIR_EraseRootFromParent_Done,
     /*  99101 */ // Label 1878: @99101
     /*  99101 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(99152), // Rule ID 264 //
     /*  99106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99131 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99150 */   GIR_RootConstrainSelectedInstOperands,
     /*  99151 */   // GIR_Coverage, 264,
     /*  99151 */   GIR_EraseRootFromParent_Done,
     /*  99152 */ // Label 1879: @99152
     /*  99152 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(99211), // Rule ID 6964 //
     /*  99157 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99167 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  99185 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  99185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  99188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99209 */   GIR_RootConstrainSelectedInstOperands,
     /*  99210 */   // GIR_Coverage, 6964,
     /*  99210 */   GIR_EraseRootFromParent_Done,
     /*  99211 */ // Label 1880: @99211
     /*  99211 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(99270), // Rule ID 6965 //
     /*  99216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99226 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  99244 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  99244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  99247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99268 */   GIR_RootConstrainSelectedInstOperands,
     /*  99269 */   // GIR_Coverage, 6965,
     /*  99269 */   GIR_EraseRootFromParent_Done,
     /*  99270 */ // Label 1881: @99270
     /*  99270 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(99318), // Rule ID 280 //
     /*  99275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99297 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99316 */   GIR_RootConstrainSelectedInstOperands,
     /*  99317 */   // GIR_Coverage, 280,
     /*  99317 */   GIR_EraseRootFromParent_Done,
     /*  99318 */ // Label 1882: @99318
     /*  99318 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(99369), // Rule ID 285 //
     /*  99323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99348 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  99351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99367 */   GIR_RootConstrainSelectedInstOperands,
     /*  99368 */   // GIR_Coverage, 285,
     /*  99368 */   GIR_EraseRootFromParent_Done,
     /*  99369 */ // Label 1883: @99369
     /*  99369 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(99423), // Rule ID 6966 //
     /*  99374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99402 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99421 */   GIR_RootConstrainSelectedInstOperands,
     /*  99422 */   // GIR_Coverage, 6966,
     /*  99422 */   GIR_EraseRootFromParent_Done,
     /*  99423 */ // Label 1884: @99423
     /*  99423 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(99477), // Rule ID 6967 //
     /*  99428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99456 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15721>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99475 */   GIR_RootConstrainSelectedInstOperands,
     /*  99476 */   // GIR_Coverage, 6967,
     /*  99476 */   GIR_EraseRootFromParent_Done,
     /*  99477 */ // Label 1885: @99477
     /*  99477 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(99534), // Rule ID 7281 //
     /*  99482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99513 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15690>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /*  99516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99532 */   GIR_RootConstrainSelectedInstOperands,
     /*  99533 */   // GIR_Coverage, 7281,
     /*  99533 */   GIR_EraseRootFromParent_Done,
     /*  99534 */ // Label 1886: @99534
     /*  99534 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(99582), // Rule ID 4075 //
     /*  99539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99561 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99580 */   GIR_RootConstrainSelectedInstOperands,
     /*  99581 */   // GIR_Coverage, 4075,
     /*  99581 */   GIR_EraseRootFromParent_Done,
     /*  99582 */ // Label 1887: @99582
     /*  99582 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(99630), // Rule ID 4076 //
     /*  99587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99609 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99628 */   GIR_RootConstrainSelectedInstOperands,
     /*  99629 */   // GIR_Coverage, 4076,
     /*  99629 */   GIR_EraseRootFromParent_Done,
     /*  99630 */ // Label 1888: @99630
     /*  99630 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(99717), // Rule ID 4092 //
     /*  99635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99664 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99686 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99716 */   // GIR_Coverage, 4092,
     /*  99716 */   GIR_EraseRootFromParent_Done,
     /*  99717 */ // Label 1889: @99717
     /*  99717 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(99804), // Rule ID 4093 //
     /*  99722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99751 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  99758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99773 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99803 */   // GIR_Coverage, 4093,
     /*  99803 */   GIR_EraseRootFromParent_Done,
     /*  99804 */ // Label 1890: @99804
     /*  99804 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(99891), // Rule ID 4094 //
     /*  99809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99838 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99860 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99890 */   // GIR_Coverage, 4094,
     /*  99890 */   GIR_EraseRootFromParent_Done,
     /*  99891 */ // Label 1891: @99891
     /*  99891 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(99978), // Rule ID 4095 //
     /*  99896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99899 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99903 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99925 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99947 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99977 */   // GIR_Coverage, 4095,
     /*  99977 */   GIR_EraseRootFromParent_Done,
     /*  99978 */ // Label 1892: @99978
     /*  99978 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(100026), // Rule ID 4103 //
     /*  99983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100005 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100024 */   GIR_RootConstrainSelectedInstOperands,
     /* 100025 */   // GIR_Coverage, 4103,
     /* 100025 */   GIR_EraseRootFromParent_Done,
     /* 100026 */ // Label 1893: @100026
     /* 100026 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(100074), // Rule ID 4104 //
     /* 100031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100053 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100072 */   GIR_RootConstrainSelectedInstOperands,
     /* 100073 */   // GIR_Coverage, 4104,
     /* 100073 */   GIR_EraseRootFromParent_Done,
     /* 100074 */ // Label 1894: @100074
     /* 100074 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(100161), // Rule ID 4115 //
     /* 100079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100108 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100130 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100160 */   // GIR_Coverage, 4115,
     /* 100160 */   GIR_EraseRootFromParent_Done,
     /* 100161 */ // Label 1895: @100161
     /* 100161 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(100248), // Rule ID 4116 //
     /* 100166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100169 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100195 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100217 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100247 */   // GIR_Coverage, 4116,
     /* 100247 */   GIR_EraseRootFromParent_Done,
     /* 100248 */ // Label 1896: @100248
     /* 100248 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(100335), // Rule ID 4117 //
     /* 100253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100282 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100304 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100334 */   // GIR_Coverage, 4117,
     /* 100334 */   GIR_EraseRootFromParent_Done,
     /* 100335 */ // Label 1897: @100335
     /* 100335 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(100422), // Rule ID 4118 //
     /* 100340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100343 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100347 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100369 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100391 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100421 */   // GIR_Coverage, 4118,
     /* 100421 */   GIR_EraseRootFromParent_Done,
     /* 100422 */ // Label 1898: @100422
     /* 100422 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(100462), // Rule ID 6931 //
     /* 100427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100447 */   // MIs[0] ptr
     /* 100447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100455 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15690>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 100460 */   GIR_RootConstrainSelectedInstOperands,
     /* 100461 */   // GIR_Coverage, 6931,
     /* 100461 */   GIR_Done,
     /* 100462 */ // Label 1899: @100462
     /* 100462 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(100499), // Rule ID 6962 //
     /* 100467 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100484 */   // MIs[0] ptr
     /* 100484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100492 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15718>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100497 */   GIR_RootConstrainSelectedInstOperands,
     /* 100498 */   // GIR_Coverage, 6962,
     /* 100498 */   GIR_Done,
     /* 100499 */ // Label 1900: @100499
     /* 100499 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(100536), // Rule ID 6963 //
     /* 100504 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100521 */   // MIs[0] ptr
     /* 100521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100529 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15690>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100534 */   GIR_RootConstrainSelectedInstOperands,
     /* 100535 */   // GIR_Coverage, 6963,
     /* 100535 */   GIR_Done,
     /* 100536 */ // Label 1901: @100536
     /* 100536 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(100567), // Rule ID 6311 //
     /* 100541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100552 */   // MIs[0] Rn
     /* 100552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100560 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 100560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 100565 */   GIR_RootConstrainSelectedInstOperands,
     /* 100566 */   // GIR_Coverage, 6311,
     /* 100566 */   GIR_Done,
     /* 100567 */ // Label 1902: @100567
     /* 100567 */ GIM_Reject,
     /* 100568 */ // Label 1791: @100568
     /* 100568 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(100776),
     /* 100573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100588 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(100629), // Rule ID 245 //
     /* 100593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 100603 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 100603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 100606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100627 */     GIR_RootConstrainSelectedInstOperands,
     /* 100628 */     // GIR_Coverage, 245,
     /* 100628 */     GIR_EraseRootFromParent_Done,
     /* 100629 */   // Label 1904: @100629
     /* 100629 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(100670), // Rule ID 246 //
     /* 100634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 100644 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 100644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 100647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100668 */     GIR_RootConstrainSelectedInstOperands,
     /* 100669 */     // GIR_Coverage, 246,
     /* 100669 */     GIR_EraseRootFromParent_Done,
     /* 100670 */   // Label 1905: @100670
     /* 100670 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(100706), // Rule ID 265 //
     /* 100675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100685 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100704 */     GIR_RootConstrainSelectedInstOperands,
     /* 100705 */     // GIR_Coverage, 265,
     /* 100705 */     GIR_EraseRootFromParent_Done,
     /* 100706 */   // Label 1906: @100706
     /* 100706 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(100742), // Rule ID 286 //
     /* 100711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 100721 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 100724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100740 */     GIR_RootConstrainSelectedInstOperands,
     /* 100741 */     // GIR_Coverage, 286,
     /* 100741 */     GIR_EraseRootFromParent_Done,
     /* 100742 */   // Label 1907: @100742
     /* 100742 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(100775), // Rule ID 4084 //
     /* 100747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100754 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100773 */     GIR_RootConstrainSelectedInstOperands,
     /* 100774 */     // GIR_Coverage, 4084,
     /* 100774 */     GIR_EraseRootFromParent_Done,
     /* 100775 */   // Label 1908: @100775
     /* 100775 */   GIM_Reject,
     /* 100776 */ // Label 1903: @100776
     /* 100776 */ GIM_Reject,
     /* 100777 */ // Label 1792: @100777
     /* 100777 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(101154),
     /* 100782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100793 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(100838), // Rule ID 4018 //
     /* 100798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100812 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100836 */     GIR_RootConstrainSelectedInstOperands,
     /* 100837 */     // GIR_Coverage, 4018,
     /* 100837 */     GIR_EraseRootFromParent_Done,
     /* 100838 */   // Label 1910: @100838
     /* 100838 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100883), // Rule ID 4019 //
     /* 100843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100857 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100881 */     GIR_RootConstrainSelectedInstOperands,
     /* 100882 */     // GIR_Coverage, 4019,
     /* 100882 */     GIR_EraseRootFromParent_Done,
     /* 100883 */   // Label 1911: @100883
     /* 100883 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(100928), // Rule ID 4020 //
     /* 100888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100902 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100926 */     GIR_RootConstrainSelectedInstOperands,
     /* 100927 */     // GIR_Coverage, 4020,
     /* 100927 */     GIR_EraseRootFromParent_Done,
     /* 100928 */   // Label 1912: @100928
     /* 100928 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(100973), // Rule ID 4021 //
     /* 100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100947 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100971 */     GIR_RootConstrainSelectedInstOperands,
     /* 100972 */     // GIR_Coverage, 4021,
     /* 100972 */     GIR_EraseRootFromParent_Done,
     /* 100973 */   // Label 1913: @100973
     /* 100973 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(101013), // Rule ID 4070 //
     /* 100978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 100992 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 100992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 100995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101011 */     GIR_RootConstrainSelectedInstOperands,
     /* 101012 */     // GIR_Coverage, 4070,
     /* 101012 */     GIR_EraseRootFromParent_Done,
     /* 101013 */   // Label 1914: @101013
     /* 101013 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(101053), // Rule ID 4073 //
     /* 101018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101032 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101051 */     GIR_RootConstrainSelectedInstOperands,
     /* 101052 */     // GIR_Coverage, 4073,
     /* 101052 */     GIR_EraseRootFromParent_Done,
     /* 101053 */   // Label 1915: @101053
     /* 101053 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(101093), // Rule ID 4098 //
     /* 101058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101072 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101091 */     GIR_RootConstrainSelectedInstOperands,
     /* 101092 */     // GIR_Coverage, 4098,
     /* 101092 */     GIR_EraseRootFromParent_Done,
     /* 101093 */   // Label 1916: @101093
     /* 101093 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(101133), // Rule ID 4099 //
     /* 101098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101112 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101131 */     GIR_RootConstrainSelectedInstOperands,
     /* 101132 */     // GIR_Coverage, 4099,
     /* 101132 */     GIR_EraseRootFromParent_Done,
     /* 101133 */   // Label 1917: @101133
     /* 101133 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(101153), // Rule ID 6310 //
     /* 101138 */     // MIs[0] Rn
     /* 101138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101146 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 101151 */     GIR_RootConstrainSelectedInstOperands,
     /* 101152 */     // GIR_Coverage, 6310,
     /* 101152 */     GIR_Done,
     /* 101153 */   // Label 1918: @101153
     /* 101153 */   GIM_Reject,
     /* 101154 */ // Label 1909: @101154
     /* 101154 */ GIM_Reject,
     /* 101155 */ // Label 1793: @101155
     /* 101155 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(101532),
     /* 101160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101171 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(101216), // Rule ID 4032 //
     /* 101176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101190 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101214 */     GIR_RootConstrainSelectedInstOperands,
     /* 101215 */     // GIR_Coverage, 4032,
     /* 101215 */     GIR_EraseRootFromParent_Done,
     /* 101216 */   // Label 1920: @101216
     /* 101216 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(101261), // Rule ID 4033 //
     /* 101221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101235 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101259 */     GIR_RootConstrainSelectedInstOperands,
     /* 101260 */     // GIR_Coverage, 4033,
     /* 101260 */     GIR_EraseRootFromParent_Done,
     /* 101261 */   // Label 1921: @101261
     /* 101261 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(101306), // Rule ID 4034 //
     /* 101266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101280 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101304 */     GIR_RootConstrainSelectedInstOperands,
     /* 101305 */     // GIR_Coverage, 4034,
     /* 101305 */     GIR_EraseRootFromParent_Done,
     /* 101306 */   // Label 1922: @101306
     /* 101306 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(101351), // Rule ID 4035 //
     /* 101311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101325 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101349 */     GIR_RootConstrainSelectedInstOperands,
     /* 101350 */     // GIR_Coverage, 4035,
     /* 101350 */     GIR_EraseRootFromParent_Done,
     /* 101351 */   // Label 1923: @101351
     /* 101351 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(101391), // Rule ID 4078 //
     /* 101356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101370 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101389 */     GIR_RootConstrainSelectedInstOperands,
     /* 101390 */     // GIR_Coverage, 4078,
     /* 101390 */     GIR_EraseRootFromParent_Done,
     /* 101391 */   // Label 1924: @101391
     /* 101391 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(101431), // Rule ID 4082 //
     /* 101396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101410 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 101430 */     // GIR_Coverage, 4082,
     /* 101430 */     GIR_EraseRootFromParent_Done,
     /* 101431 */   // Label 1925: @101431
     /* 101431 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(101471), // Rule ID 4105 //
     /* 101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101450 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101469 */     GIR_RootConstrainSelectedInstOperands,
     /* 101470 */     // GIR_Coverage, 4105,
     /* 101470 */     GIR_EraseRootFromParent_Done,
     /* 101471 */   // Label 1926: @101471
     /* 101471 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(101511), // Rule ID 4106 //
     /* 101476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101490 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101509 */     GIR_RootConstrainSelectedInstOperands,
     /* 101510 */     // GIR_Coverage, 4106,
     /* 101510 */     GIR_EraseRootFromParent_Done,
     /* 101511 */   // Label 1927: @101511
     /* 101511 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(101531), // Rule ID 6307 //
     /* 101516 */     // MIs[0] Rn
     /* 101516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101524 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 101529 */     GIR_RootConstrainSelectedInstOperands,
     /* 101530 */     // GIR_Coverage, 6307,
     /* 101530 */     GIR_Done,
     /* 101531 */   // Label 1928: @101531
     /* 101531 */   GIM_Reject,
     /* 101532 */ // Label 1919: @101532
     /* 101532 */ GIM_Reject,
     /* 101533 */ // Label 1794: @101533
     /* 101533 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(101910),
     /* 101538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101549 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(101594), // Rule ID 4024 //
     /* 101554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101568 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101592 */     GIR_RootConstrainSelectedInstOperands,
     /* 101593 */     // GIR_Coverage, 4024,
     /* 101593 */     GIR_EraseRootFromParent_Done,
     /* 101594 */   // Label 1930: @101594
     /* 101594 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(101639), // Rule ID 4025 //
     /* 101599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101613 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101637 */     GIR_RootConstrainSelectedInstOperands,
     /* 101638 */     // GIR_Coverage, 4025,
     /* 101638 */     GIR_EraseRootFromParent_Done,
     /* 101639 */   // Label 1931: @101639
     /* 101639 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(101684), // Rule ID 4026 //
     /* 101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101658 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101682 */     GIR_RootConstrainSelectedInstOperands,
     /* 101683 */     // GIR_Coverage, 4026,
     /* 101683 */     GIR_EraseRootFromParent_Done,
     /* 101684 */   // Label 1932: @101684
     /* 101684 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(101729), // Rule ID 4027 //
     /* 101689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101703 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101727 */     GIR_RootConstrainSelectedInstOperands,
     /* 101728 */     // GIR_Coverage, 4027,
     /* 101728 */     GIR_EraseRootFromParent_Done,
     /* 101729 */   // Label 1933: @101729
     /* 101729 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(101769), // Rule ID 4072 //
     /* 101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101748 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101767 */     GIR_RootConstrainSelectedInstOperands,
     /* 101768 */     // GIR_Coverage, 4072,
     /* 101768 */     GIR_EraseRootFromParent_Done,
     /* 101769 */   // Label 1934: @101769
     /* 101769 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(101809), // Rule ID 4074 //
     /* 101774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101788 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101807 */     GIR_RootConstrainSelectedInstOperands,
     /* 101808 */     // GIR_Coverage, 4074,
     /* 101808 */     GIR_EraseRootFromParent_Done,
     /* 101809 */   // Label 1935: @101809
     /* 101809 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(101849), // Rule ID 4100 //
     /* 101814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101828 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101847 */     GIR_RootConstrainSelectedInstOperands,
     /* 101848 */     // GIR_Coverage, 4100,
     /* 101848 */     GIR_EraseRootFromParent_Done,
     /* 101849 */   // Label 1936: @101849
     /* 101849 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(101889), // Rule ID 4102 //
     /* 101854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101868 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101887 */     GIR_RootConstrainSelectedInstOperands,
     /* 101888 */     // GIR_Coverage, 4102,
     /* 101888 */     GIR_EraseRootFromParent_Done,
     /* 101889 */   // Label 1937: @101889
     /* 101889 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(101909), // Rule ID 6309 //
     /* 101894 */     // MIs[0] Rn
     /* 101894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101902 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 101907 */     GIR_RootConstrainSelectedInstOperands,
     /* 101908 */     // GIR_Coverage, 6309,
     /* 101908 */     GIR_Done,
     /* 101909 */   // Label 1938: @101909
     /* 101909 */   GIM_Reject,
     /* 101910 */ // Label 1929: @101910
     /* 101910 */ GIM_Reject,
     /* 101911 */ // Label 1795: @101911
     /* 101911 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(102288),
     /* 101916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101927 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(101972), // Rule ID 4036 //
     /* 101932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101946 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101970 */     GIR_RootConstrainSelectedInstOperands,
     /* 101971 */     // GIR_Coverage, 4036,
     /* 101971 */     GIR_EraseRootFromParent_Done,
     /* 101972 */   // Label 1940: @101972
     /* 101972 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(102017), // Rule ID 4037 //
     /* 101977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101991 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102015 */     GIR_RootConstrainSelectedInstOperands,
     /* 102016 */     // GIR_Coverage, 4037,
     /* 102016 */     GIR_EraseRootFromParent_Done,
     /* 102017 */   // Label 1941: @102017
     /* 102017 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(102062), // Rule ID 4038 //
     /* 102022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102036 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102060 */     GIR_RootConstrainSelectedInstOperands,
     /* 102061 */     // GIR_Coverage, 4038,
     /* 102061 */     GIR_EraseRootFromParent_Done,
     /* 102062 */   // Label 1942: @102062
     /* 102062 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(102107), // Rule ID 4039 //
     /* 102067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102081 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102105 */     GIR_RootConstrainSelectedInstOperands,
     /* 102106 */     // GIR_Coverage, 4039,
     /* 102106 */     GIR_EraseRootFromParent_Done,
     /* 102107 */   // Label 1943: @102107
     /* 102107 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(102147), // Rule ID 4077 //
     /* 102112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102126 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102145 */     GIR_RootConstrainSelectedInstOperands,
     /* 102146 */     // GIR_Coverage, 4077,
     /* 102146 */     GIR_EraseRootFromParent_Done,
     /* 102147 */   // Label 1944: @102147
     /* 102147 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(102187), // Rule ID 4081 //
     /* 102152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102166 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102185 */     GIR_RootConstrainSelectedInstOperands,
     /* 102186 */     // GIR_Coverage, 4081,
     /* 102186 */     GIR_EraseRootFromParent_Done,
     /* 102187 */   // Label 1945: @102187
     /* 102187 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(102227), // Rule ID 4107 //
     /* 102192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102206 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102225 */     GIR_RootConstrainSelectedInstOperands,
     /* 102226 */     // GIR_Coverage, 4107,
     /* 102226 */     GIR_EraseRootFromParent_Done,
     /* 102227 */   // Label 1946: @102227
     /* 102227 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(102267), // Rule ID 4108 //
     /* 102232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102246 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102265 */     GIR_RootConstrainSelectedInstOperands,
     /* 102266 */     // GIR_Coverage, 4108,
     /* 102266 */     GIR_EraseRootFromParent_Done,
     /* 102267 */   // Label 1947: @102267
     /* 102267 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(102287), // Rule ID 6306 //
     /* 102272 */     // MIs[0] Rn
     /* 102272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102280 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 102285 */     GIR_RootConstrainSelectedInstOperands,
     /* 102286 */     // GIR_Coverage, 6306,
     /* 102286 */     GIR_Done,
     /* 102287 */   // Label 1948: @102287
     /* 102287 */   GIM_Reject,
     /* 102288 */ // Label 1939: @102288
     /* 102288 */ GIM_Reject,
     /* 102289 */ // Label 1796: @102289
     /* 102289 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(102496),
     /* 102294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(102350), // Rule ID 4022 //
     /* 102310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102324 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102348 */     GIR_RootConstrainSelectedInstOperands,
     /* 102349 */     // GIR_Coverage, 4022,
     /* 102349 */     GIR_EraseRootFromParent_Done,
     /* 102350 */   // Label 1950: @102350
     /* 102350 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(102395), // Rule ID 4023 //
     /* 102355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102369 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102393 */     GIR_RootConstrainSelectedInstOperands,
     /* 102394 */     // GIR_Coverage, 4023,
     /* 102394 */     GIR_EraseRootFromParent_Done,
     /* 102395 */   // Label 1951: @102395
     /* 102395 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(102435), // Rule ID 4071 //
     /* 102400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102414 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102433 */     GIR_RootConstrainSelectedInstOperands,
     /* 102434 */     // GIR_Coverage, 4071,
     /* 102434 */     GIR_EraseRootFromParent_Done,
     /* 102435 */   // Label 1952: @102435
     /* 102435 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(102475), // Rule ID 4101 //
     /* 102440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102454 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102473 */     GIR_RootConstrainSelectedInstOperands,
     /* 102474 */     // GIR_Coverage, 4101,
     /* 102474 */     GIR_EraseRootFromParent_Done,
     /* 102475 */   // Label 1953: @102475
     /* 102475 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(102495), // Rule ID 6308 //
     /* 102480 */     // MIs[0] Rn
     /* 102480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102488 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 102493 */     GIR_RootConstrainSelectedInstOperands,
     /* 102494 */     // GIR_Coverage, 6308,
     /* 102494 */     GIR_Done,
     /* 102495 */   // Label 1954: @102495
     /* 102495 */   GIM_Reject,
     /* 102496 */ // Label 1949: @102496
     /* 102496 */ GIM_Reject,
     /* 102497 */ // Label 1797: @102497
     /* 102497 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(102874),
     /* 102502 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102513 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(102558), // Rule ID 4040 //
     /* 102518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102532 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102556 */     GIR_RootConstrainSelectedInstOperands,
     /* 102557 */     // GIR_Coverage, 4040,
     /* 102557 */     GIR_EraseRootFromParent_Done,
     /* 102558 */   // Label 1956: @102558
     /* 102558 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(102603), // Rule ID 4041 //
     /* 102563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102577 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102601 */     GIR_RootConstrainSelectedInstOperands,
     /* 102602 */     // GIR_Coverage, 4041,
     /* 102602 */     GIR_EraseRootFromParent_Done,
     /* 102603 */   // Label 1957: @102603
     /* 102603 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(102648), // Rule ID 4042 //
     /* 102608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102622 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102646 */     GIR_RootConstrainSelectedInstOperands,
     /* 102647 */     // GIR_Coverage, 4042,
     /* 102647 */     GIR_EraseRootFromParent_Done,
     /* 102648 */   // Label 1958: @102648
     /* 102648 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(102693), // Rule ID 4043 //
     /* 102653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102667 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102691 */     GIR_RootConstrainSelectedInstOperands,
     /* 102692 */     // GIR_Coverage, 4043,
     /* 102692 */     GIR_EraseRootFromParent_Done,
     /* 102693 */   // Label 1959: @102693
     /* 102693 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(102733), // Rule ID 4080 //
     /* 102698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102712 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102731 */     GIR_RootConstrainSelectedInstOperands,
     /* 102732 */     // GIR_Coverage, 4080,
     /* 102732 */     GIR_EraseRootFromParent_Done,
     /* 102733 */   // Label 1960: @102733
     /* 102733 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(102773), // Rule ID 4083 //
     /* 102738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102752 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102771 */     GIR_RootConstrainSelectedInstOperands,
     /* 102772 */     // GIR_Coverage, 4083,
     /* 102772 */     GIR_EraseRootFromParent_Done,
     /* 102773 */   // Label 1961: @102773
     /* 102773 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(102813), // Rule ID 4109 //
     /* 102778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102792 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102811 */     GIR_RootConstrainSelectedInstOperands,
     /* 102812 */     // GIR_Coverage, 4109,
     /* 102812 */     GIR_EraseRootFromParent_Done,
     /* 102813 */   // Label 1962: @102813
     /* 102813 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(102853), // Rule ID 4111 //
     /* 102818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102832 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102851 */     GIR_RootConstrainSelectedInstOperands,
     /* 102852 */     // GIR_Coverage, 4111,
     /* 102852 */     GIR_EraseRootFromParent_Done,
     /* 102853 */   // Label 1963: @102853
     /* 102853 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(102873), // Rule ID 6305 //
     /* 102858 */     // MIs[0] Rn
     /* 102858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102866 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 102871 */     GIR_RootConstrainSelectedInstOperands,
     /* 102872 */     // GIR_Coverage, 6305,
     /* 102872 */     GIR_Done,
     /* 102873 */   // Label 1964: @102873
     /* 102873 */   GIM_Reject,
     /* 102874 */ // Label 1955: @102874
     /* 102874 */ GIM_Reject,
     /* 102875 */ // Label 1798: @102875
     /* 102875 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(103082),
     /* 102880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102891 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(102936), // Rule ID 4044 //
     /* 102896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102910 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102934 */     GIR_RootConstrainSelectedInstOperands,
     /* 102935 */     // GIR_Coverage, 4044,
     /* 102935 */     GIR_EraseRootFromParent_Done,
     /* 102936 */   // Label 1966: @102936
     /* 102936 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(102981), // Rule ID 4045 //
     /* 102941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102955 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102979 */     GIR_RootConstrainSelectedInstOperands,
     /* 102980 */     // GIR_Coverage, 4045,
     /* 102980 */     GIR_EraseRootFromParent_Done,
     /* 102981 */   // Label 1967: @102981
     /* 102981 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(103021), // Rule ID 4079 //
     /* 102986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 103000 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 103000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 103003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103019 */     GIR_RootConstrainSelectedInstOperands,
     /* 103020 */     // GIR_Coverage, 4079,
     /* 103020 */     GIR_EraseRootFromParent_Done,
     /* 103021 */   // Label 1968: @103021
     /* 103021 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(103061), // Rule ID 4110 //
     /* 103026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 103040 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 103043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103059 */     GIR_RootConstrainSelectedInstOperands,
     /* 103060 */     // GIR_Coverage, 4110,
     /* 103060 */     GIR_EraseRootFromParent_Done,
     /* 103061 */   // Label 1969: @103061
     /* 103061 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(103081), // Rule ID 6304 //
     /* 103066 */     // MIs[0] Rn
     /* 103066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103074 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 103079 */     GIR_RootConstrainSelectedInstOperands,
     /* 103080 */     // GIR_Coverage, 6304,
     /* 103080 */     GIR_Done,
     /* 103081 */   // Label 1970: @103081
     /* 103081 */   GIM_Reject,
     /* 103082 */ // Label 1965: @103082
     /* 103082 */ GIM_Reject,
     /* 103083 */ // Label 1799: @103083
     /* 103083 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(103146), // Rule ID 10790 //
     /* 103088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103102 */   // MIs[0] base
     /* 103102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103110 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 103130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103135 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103144 */   GIR_RootConstrainSelectedInstOperands,
     /* 103145 */   // GIR_Coverage, 10790,
     /* 103145 */   GIR_EraseRootFromParent_Done,
     /* 103146 */ // Label 1971: @103146
     /* 103146 */ GIM_Reject,
     /* 103147 */ // Label 1800: @103147
     /* 103147 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(103210), // Rule ID 10796 //
     /* 103152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103166 */   // MIs[0] base
     /* 103166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103174 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103186 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 103194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103199 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103208 */   GIR_RootConstrainSelectedInstOperands,
     /* 103209 */   // GIR_Coverage, 10796,
     /* 103209 */   GIR_EraseRootFromParent_Done,
     /* 103210 */ // Label 1972: @103210
     /* 103210 */ GIM_Reject,
     /* 103211 */ // Label 1801: @103211
     /* 103211 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(103384),
     /* 103216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103231 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(103279), // Rule ID 10781 //
     /* 103236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103243 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103268 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103277 */     GIR_RootConstrainSelectedInstOperands,
     /* 103278 */     // GIR_Coverage, 10781,
     /* 103278 */     GIR_EraseRootFromParent_Done,
     /* 103279 */   // Label 1974: @103279
     /* 103279 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(103327), // Rule ID 10799 //
     /* 103284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103291 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103316 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103325 */     GIR_RootConstrainSelectedInstOperands,
     /* 103326 */     // GIR_Coverage, 10799,
     /* 103326 */     GIR_EraseRootFromParent_Done,
     /* 103327 */   // Label 1975: @103327
     /* 103327 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(103355), // Rule ID 10826 //
     /* 103332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103339 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103344 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103353 */     GIR_RootConstrainSelectedInstOperands,
     /* 103354 */     // GIR_Coverage, 10826,
     /* 103354 */     GIR_EraseRootFromParent_Done,
     /* 103355 */   // Label 1976: @103355
     /* 103355 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(103383), // Rule ID 10838 //
     /* 103360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103367 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103372 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103381 */     GIR_RootConstrainSelectedInstOperands,
     /* 103382 */     // GIR_Coverage, 10838,
     /* 103382 */     GIR_EraseRootFromParent_Done,
     /* 103383 */   // Label 1977: @103383
     /* 103383 */   GIM_Reject,
     /* 103384 */ // Label 1973: @103384
     /* 103384 */ GIM_Reject,
     /* 103385 */ // Label 1802: @103385
     /* 103385 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(103448), // Rule ID 10787 //
     /* 103390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103404 */   // MIs[0] base
     /* 103404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103412 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103424 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 103432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103437 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103446 */   GIR_RootConstrainSelectedInstOperands,
     /* 103447 */   // GIR_Coverage, 10787,
     /* 103447 */   GIR_EraseRootFromParent_Done,
     /* 103448 */ // Label 1978: @103448
     /* 103448 */ GIM_Reject,
     /* 103449 */ // Label 1803: @103449
     /* 103449 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(103622),
     /* 103454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103469 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(103517), // Rule ID 10769 //
     /* 103474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103481 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103493 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103506 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103515 */     GIR_RootConstrainSelectedInstOperands,
     /* 103516 */     // GIR_Coverage, 10769,
     /* 103516 */     GIR_EraseRootFromParent_Done,
     /* 103517 */   // Label 1980: @103517
     /* 103517 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(103565), // Rule ID 10793 //
     /* 103522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103529 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103554 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103563 */     GIR_RootConstrainSelectedInstOperands,
     /* 103564 */     // GIR_Coverage, 10793,
     /* 103564 */     GIR_EraseRootFromParent_Done,
     /* 103565 */   // Label 1981: @103565
     /* 103565 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(103593), // Rule ID 10822 //
     /* 103570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103577 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103582 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103591 */     GIR_RootConstrainSelectedInstOperands,
     /* 103592 */     // GIR_Coverage, 10822,
     /* 103592 */     GIR_EraseRootFromParent_Done,
     /* 103593 */   // Label 1982: @103593
     /* 103593 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(103621), // Rule ID 10834 //
     /* 103598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103605 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103610 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103619 */     GIR_RootConstrainSelectedInstOperands,
     /* 103620 */     // GIR_Coverage, 10834,
     /* 103620 */     GIR_EraseRootFromParent_Done,
     /* 103621 */   // Label 1983: @103621
     /* 103621 */   GIM_Reject,
     /* 103622 */ // Label 1979: @103622
     /* 103622 */ GIM_Reject,
     /* 103623 */ // Label 1804: @103623
     /* 103623 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(103796),
     /* 103628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103631 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103643 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(103691), // Rule ID 10748 //
     /* 103648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103655 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103680 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103689 */     GIR_RootConstrainSelectedInstOperands,
     /* 103690 */     // GIR_Coverage, 10748,
     /* 103690 */     GIR_EraseRootFromParent_Done,
     /* 103691 */   // Label 1985: @103691
     /* 103691 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(103739), // Rule ID 10784 //
     /* 103696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103703 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103728 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103737 */     GIR_RootConstrainSelectedInstOperands,
     /* 103738 */     // GIR_Coverage, 10784,
     /* 103738 */     GIR_EraseRootFromParent_Done,
     /* 103739 */   // Label 1986: @103739
     /* 103739 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(103767), // Rule ID 10818 //
     /* 103744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103751 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103756 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103765 */     GIR_RootConstrainSelectedInstOperands,
     /* 103766 */     // GIR_Coverage, 10818,
     /* 103766 */     GIR_EraseRootFromParent_Done,
     /* 103767 */   // Label 1987: @103767
     /* 103767 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(103795), // Rule ID 10830 //
     /* 103772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103779 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103784 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103793 */     GIR_RootConstrainSelectedInstOperands,
     /* 103794 */     // GIR_Coverage, 10830,
     /* 103794 */     GIR_EraseRootFromParent_Done,
     /* 103795 */   // Label 1988: @103795
     /* 103795 */   GIM_Reject,
     /* 103796 */ // Label 1984: @103796
     /* 103796 */ GIM_Reject,
     /* 103797 */ // Label 1805: @103797
     /* 103797 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(103840), // Rule ID 2419 //
     /* 103802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 103816 */   // MIs[0] base
     /* 103816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103824 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 103827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 103829 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103838 */   GIR_RootConstrainSelectedInstOperands,
     /* 103839 */   // GIR_Coverage, 2419,
     /* 103839 */   GIR_EraseRootFromParent_Done,
     /* 103840 */ // Label 1989: @103840
     /* 103840 */ GIM_Reject,
     /* 103841 */ // Label 1806: @103841
     /* 103841 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(103938),
     /* 103846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103861 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(103909), // Rule ID 10716 //
     /* 103866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103873 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 103880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 103893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103898 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103907 */     GIR_RootConstrainSelectedInstOperands,
     /* 103908 */     // GIR_Coverage, 10716,
     /* 103908 */     GIR_EraseRootFromParent_Done,
     /* 103909 */   // Label 1991: @103909
     /* 103909 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(103937), // Rule ID 10814 //
     /* 103914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 103917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103921 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 103924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103926 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103935 */     GIR_RootConstrainSelectedInstOperands,
     /* 103936 */     // GIR_Coverage, 10814,
     /* 103936 */     GIR_EraseRootFromParent_Done,
     /* 103937 */   // Label 1992: @103937
     /* 103937 */   GIM_Reject,
     /* 103938 */ // Label 1990: @103938
     /* 103938 */ GIM_Reject,
     /* 103939 */ // Label 1807: @103939
     /* 103939 */ GIM_Reject,
     /* 103940 */ // Label 17: @103940
     /* 103940 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1995*/ GIMT_Encode4(104989),
     /* 103951 */ /*GILLT_s32*//*Label 1993*/ GIMT_Encode4(103959),
     /* 103955 */ /*GILLT_s64*//*Label 1994*/ GIMT_Encode4(104373),
     /* 103959 */ // Label 1993: @103959
     /* 103959 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(104372),
     /* 103964 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103967 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(104020), // Rule ID 247 //
     /* 103972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 103994 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 103994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 103997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104018 */     GIR_RootConstrainSelectedInstOperands,
     /* 104019 */     // GIR_Coverage, 247,
     /* 104019 */     GIR_EraseRootFromParent_Done,
     /* 104020 */   // Label 1997: @104020
     /* 104020 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(104073), // Rule ID 248 //
     /* 104025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104047 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 104050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104071 */     GIR_RootConstrainSelectedInstOperands,
     /* 104072 */     // GIR_Coverage, 248,
     /* 104072 */     GIR_EraseRootFromParent_Done,
     /* 104073 */   // Label 1998: @104073
     /* 104073 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(104126), // Rule ID 251 //
     /* 104078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104100 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 104103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104124 */     GIR_RootConstrainSelectedInstOperands,
     /* 104125 */     // GIR_Coverage, 251,
     /* 104125 */     GIR_EraseRootFromParent_Done,
     /* 104126 */   // Label 1999: @104126
     /* 104126 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(104179), // Rule ID 252 //
     /* 104131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104153 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 104156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104177 */     GIR_RootConstrainSelectedInstOperands,
     /* 104178 */     // GIR_Coverage, 252,
     /* 104178 */     GIR_EraseRootFromParent_Done,
     /* 104179 */   // Label 2000: @104179
     /* 104179 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(104227), // Rule ID 268 //
     /* 104184 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104206 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 104209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104225 */     GIR_RootConstrainSelectedInstOperands,
     /* 104226 */     // GIR_Coverage, 268,
     /* 104226 */     GIR_EraseRootFromParent_Done,
     /* 104227 */   // Label 2001: @104227
     /* 104227 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(104275), // Rule ID 270 //
     /* 104232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104254 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 104257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104273 */     GIR_RootConstrainSelectedInstOperands,
     /* 104274 */     // GIR_Coverage, 270,
     /* 104274 */     GIR_EraseRootFromParent_Done,
     /* 104275 */   // Label 2002: @104275
     /* 104275 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(104323), // Rule ID 289 //
     /* 104280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104302 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 104305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104321 */     GIR_RootConstrainSelectedInstOperands,
     /* 104322 */     // GIR_Coverage, 289,
     /* 104322 */     GIR_EraseRootFromParent_Done,
     /* 104323 */   // Label 2003: @104323
     /* 104323 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(104371), // Rule ID 291 //
     /* 104328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104350 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 104353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104369 */     GIR_RootConstrainSelectedInstOperands,
     /* 104370 */     // GIR_Coverage, 291,
     /* 104370 */     GIR_EraseRootFromParent_Done,
     /* 104371 */   // Label 2004: @104371
     /* 104371 */   GIM_Reject,
     /* 104372 */ // Label 1996: @104372
     /* 104372 */ GIM_Reject,
     /* 104373 */ // Label 1994: @104373
     /* 104373 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(104988),
     /* 104378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104381 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(104434), // Rule ID 249 //
     /* 104386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104408 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 104411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104432 */     GIR_RootConstrainSelectedInstOperands,
     /* 104433 */     // GIR_Coverage, 249,
     /* 104433 */     GIR_EraseRootFromParent_Done,
     /* 104434 */   // Label 2006: @104434
     /* 104434 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(104487), // Rule ID 250 //
     /* 104439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104461 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 104464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104485 */     GIR_RootConstrainSelectedInstOperands,
     /* 104486 */     // GIR_Coverage, 250,
     /* 104486 */     GIR_EraseRootFromParent_Done,
     /* 104487 */   // Label 2007: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(104540), // Rule ID 253 //
     /* 104492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104514 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 104517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104538 */     GIR_RootConstrainSelectedInstOperands,
     /* 104539 */     // GIR_Coverage, 253,
     /* 104539 */     GIR_EraseRootFromParent_Done,
     /* 104540 */   // Label 2008: @104540
     /* 104540 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(104593), // Rule ID 254 //
     /* 104545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104567 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 104570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104591 */     GIR_RootConstrainSelectedInstOperands,
     /* 104592 */     // GIR_Coverage, 254,
     /* 104592 */     GIR_EraseRootFromParent_Done,
     /* 104593 */   // Label 2009: @104593
     /* 104593 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(104646), // Rule ID 255 //
     /* 104598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104620 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 104623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104644 */     GIR_RootConstrainSelectedInstOperands,
     /* 104645 */     // GIR_Coverage, 255,
     /* 104645 */     GIR_EraseRootFromParent_Done,
     /* 104646 */   // Label 2010: @104646
     /* 104646 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(104699), // Rule ID 256 //
     /* 104651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104673 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 104676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104697 */     GIR_RootConstrainSelectedInstOperands,
     /* 104698 */     // GIR_Coverage, 256,
     /* 104698 */     GIR_EraseRootFromParent_Done,
     /* 104699 */   // Label 2011: @104699
     /* 104699 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(104747), // Rule ID 269 //
     /* 104704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104726 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 104729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104745 */     GIR_RootConstrainSelectedInstOperands,
     /* 104746 */     // GIR_Coverage, 269,
     /* 104746 */     GIR_EraseRootFromParent_Done,
     /* 104747 */   // Label 2012: @104747
     /* 104747 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(104795), // Rule ID 271 //
     /* 104752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104774 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 104777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104793 */     GIR_RootConstrainSelectedInstOperands,
     /* 104794 */     // GIR_Coverage, 271,
     /* 104794 */     GIR_EraseRootFromParent_Done,
     /* 104795 */   // Label 2013: @104795
     /* 104795 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(104843), // Rule ID 272 //
     /* 104800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104822 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 104822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 104825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104841 */     GIR_RootConstrainSelectedInstOperands,
     /* 104842 */     // GIR_Coverage, 272,
     /* 104842 */     GIR_EraseRootFromParent_Done,
     /* 104843 */   // Label 2014: @104843
     /* 104843 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(104891), // Rule ID 290 //
     /* 104848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104870 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 104873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104889 */     GIR_RootConstrainSelectedInstOperands,
     /* 104890 */     // GIR_Coverage, 290,
     /* 104890 */     GIR_EraseRootFromParent_Done,
     /* 104891 */   // Label 2015: @104891
     /* 104891 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(104939), // Rule ID 292 //
     /* 104896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104918 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 104921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104937 */     GIR_RootConstrainSelectedInstOperands,
     /* 104938 */     // GIR_Coverage, 292,
     /* 104938 */     GIR_EraseRootFromParent_Done,
     /* 104939 */   // Label 2016: @104939
     /* 104939 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(104987), // Rule ID 293 //
     /* 104944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104966 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 104969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104985 */     GIR_RootConstrainSelectedInstOperands,
     /* 104986 */     // GIR_Coverage, 293,
     /* 104986 */     GIR_EraseRootFromParent_Done,
     /* 104987 */   // Label 2017: @104987
     /* 104987 */   GIM_Reject,
     /* 104988 */ // Label 2005: @104988
     /* 104988 */ GIM_Reject,
     /* 104989 */ // Label 1995: @104989
     /* 104989 */ GIM_Reject,
     /* 104990 */ // Label 18: @104990
     /* 104990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2020*/ GIMT_Encode4(107958),
     /* 105001 */ /*GILLT_s32*//*Label 2018*/ GIMT_Encode4(105009),
     /* 105005 */ /*GILLT_s64*//*Label 2019*/ GIMT_Encode4(106468),
     /* 105009 */ // Label 2018: @105009
     /* 105009 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(105065), // Rule ID 229 //
     /* 105014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105039 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105063 */   GIR_RootConstrainSelectedInstOperands,
     /* 105064 */   // GIR_Coverage, 229,
     /* 105064 */   GIR_EraseRootFromParent_Done,
     /* 105065 */ // Label 2021: @105065
     /* 105065 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(105121), // Rule ID 230 //
     /* 105070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105095 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105119 */   GIR_RootConstrainSelectedInstOperands,
     /* 105120 */   // GIR_Coverage, 230,
     /* 105120 */   GIR_EraseRootFromParent_Done,
     /* 105121 */ // Label 2022: @105121
     /* 105121 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(105177), // Rule ID 231 //
     /* 105126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105151 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105175 */   GIR_RootConstrainSelectedInstOperands,
     /* 105176 */   // GIR_Coverage, 231,
     /* 105176 */   GIR_EraseRootFromParent_Done,
     /* 105177 */ // Label 2023: @105177
     /* 105177 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(105233), // Rule ID 232 //
     /* 105182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105207 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105231 */   GIR_RootConstrainSelectedInstOperands,
     /* 105232 */   // GIR_Coverage, 232,
     /* 105232 */   GIR_EraseRootFromParent_Done,
     /* 105233 */ // Label 2024: @105233
     /* 105233 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(105289), // Rule ID 4068 //
     /* 105238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105263 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105287 */   GIR_RootConstrainSelectedInstOperands,
     /* 105288 */   // GIR_Coverage, 4068,
     /* 105288 */   GIR_EraseRootFromParent_Done,
     /* 105289 */ // Label 2025: @105289
     /* 105289 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(105345), // Rule ID 4069 //
     /* 105294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105319 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105343 */   GIR_RootConstrainSelectedInstOperands,
     /* 105344 */   // GIR_Coverage, 4069,
     /* 105344 */   GIR_EraseRootFromParent_Done,
     /* 105345 */ // Label 2026: @105345
     /* 105345 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(105396), // Rule ID 266 //
     /* 105350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105375 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105394 */   GIR_RootConstrainSelectedInstOperands,
     /* 105395 */   // GIR_Coverage, 266,
     /* 105395 */   GIR_EraseRootFromParent_Done,
     /* 105396 */ // Label 2027: @105396
     /* 105396 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(105447), // Rule ID 267 //
     /* 105401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105426 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105445 */   GIR_RootConstrainSelectedInstOperands,
     /* 105446 */   // GIR_Coverage, 267,
     /* 105446 */   GIR_EraseRootFromParent_Done,
     /* 105447 */ // Label 2028: @105447
     /* 105447 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(105506), // Rule ID 6937 //
     /* 105452 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105462 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105480 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 105480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105504 */   GIR_RootConstrainSelectedInstOperands,
     /* 105505 */   // GIR_Coverage, 6937,
     /* 105505 */   GIR_EraseRootFromParent_Done,
     /* 105506 */ // Label 2029: @105506
     /* 105506 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(105565), // Rule ID 6939 //
     /* 105511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105521 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105539 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 105539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105563 */   GIR_RootConstrainSelectedInstOperands,
     /* 105564 */   // GIR_Coverage, 6939,
     /* 105564 */   GIR_EraseRootFromParent_Done,
     /* 105565 */ // Label 2030: @105565
     /* 105565 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(105624), // Rule ID 6949 //
     /* 105570 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105573 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105580 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105598 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105622 */   GIR_RootConstrainSelectedInstOperands,
     /* 105623 */   // GIR_Coverage, 6949,
     /* 105623 */   GIR_EraseRootFromParent_Done,
     /* 105624 */ // Label 2031: @105624
     /* 105624 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(105683), // Rule ID 6951 //
     /* 105629 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105632 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105639 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105657 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105681 */   GIR_RootConstrainSelectedInstOperands,
     /* 105682 */   // GIR_Coverage, 6951,
     /* 105682 */   GIR_EraseRootFromParent_Done,
     /* 105683 */ // Label 2032: @105683
     /* 105683 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(105734), // Rule ID 287 //
     /* 105688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105691 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105713 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105732 */   GIR_RootConstrainSelectedInstOperands,
     /* 105733 */   // GIR_Coverage, 287,
     /* 105733 */   GIR_EraseRootFromParent_Done,
     /* 105734 */ // Label 2033: @105734
     /* 105734 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(105785), // Rule ID 288 //
     /* 105739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105757 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105764 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105783 */   GIR_RootConstrainSelectedInstOperands,
     /* 105784 */   // GIR_Coverage, 288,
     /* 105784 */   GIR_EraseRootFromParent_Done,
     /* 105785 */ // Label 2034: @105785
     /* 105785 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(105836), // Rule ID 4087 //
     /* 105790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105815 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105834 */   GIR_RootConstrainSelectedInstOperands,
     /* 105835 */   // GIR_Coverage, 4087,
     /* 105835 */   GIR_EraseRootFromParent_Done,
     /* 105836 */ // Label 2035: @105836
     /* 105836 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(105887), // Rule ID 4119 //
     /* 105841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105866 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105885 */   GIR_RootConstrainSelectedInstOperands,
     /* 105886 */   // GIR_Coverage, 4119,
     /* 105886 */   GIR_EraseRootFromParent_Done,
     /* 105887 */ // Label 2036: @105887
     /* 105887 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(105938), // Rule ID 4120 //
     /* 105892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105917 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105936 */   GIR_RootConstrainSelectedInstOperands,
     /* 105937 */   // GIR_Coverage, 4120,
     /* 105937 */   GIR_EraseRootFromParent_Done,
     /* 105938 */ // Label 2037: @105938
     /* 105938 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(105989), // Rule ID 4121 //
     /* 105943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105968 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105987 */   GIR_RootConstrainSelectedInstOperands,
     /* 105988 */   // GIR_Coverage, 4121,
     /* 105988 */   GIR_EraseRootFromParent_Done,
     /* 105989 */ // Label 2038: @105989
     /* 105989 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(106043), // Rule ID 6941 //
     /* 105994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 106022 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15696>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 106022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 106025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106041 */   GIR_RootConstrainSelectedInstOperands,
     /* 106042 */   // GIR_Coverage, 6941,
     /* 106042 */   GIR_EraseRootFromParent_Done,
     /* 106043 */ // Label 2039: @106043
     /* 106043 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(106097), // Rule ID 6943 //
     /* 106048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106058 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106076 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15696>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 106079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106095 */   GIR_RootConstrainSelectedInstOperands,
     /* 106096 */   // GIR_Coverage, 6943,
     /* 106096 */   GIR_EraseRootFromParent_Done,
     /* 106097 */ // Label 2040: @106097
     /* 106097 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(106151), // Rule ID 6953 //
     /* 106102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106112 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 106130 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15705>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 106130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 106133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106149 */   GIR_RootConstrainSelectedInstOperands,
     /* 106150 */   // GIR_Coverage, 6953,
     /* 106150 */   GIR_EraseRootFromParent_Done,
     /* 106151 */ // Label 2041: @106151
     /* 106151 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(106205), // Rule ID 6955 //
     /* 106156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106166 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106184 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15705>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 106187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106203 */   GIR_RootConstrainSelectedInstOperands,
     /* 106204 */   // GIR_Coverage, 6955,
     /* 106204 */   GIR_EraseRootFromParent_Done,
     /* 106205 */ // Label 2042: @106205
     /* 106205 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(106262), // Rule ID 7277 //
     /* 106210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106213 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106216 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106241 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15694>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 106244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106260 */   GIR_RootConstrainSelectedInstOperands,
     /* 106261 */   // GIR_Coverage, 7277,
     /* 106261 */   GIR_EraseRootFromParent_Done,
     /* 106262 */ // Label 2043: @106262
     /* 106262 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(106319), // Rule ID 7279 //
     /* 106267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106270 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106273 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106298 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15703>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 106301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106317 */   GIR_RootConstrainSelectedInstOperands,
     /* 106318 */   // GIR_Coverage, 7279,
     /* 106318 */   GIR_EraseRootFromParent_Done,
     /* 106319 */ // Label 2044: @106319
     /* 106319 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(106356), // Rule ID 6933 //
     /* 106324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106341 */   // MIs[0] ptr
     /* 106341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106349 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15692>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106354 */   GIR_RootConstrainSelectedInstOperands,
     /* 106355 */   // GIR_Coverage, 6933,
     /* 106355 */   GIR_Done,
     /* 106356 */ // Label 2045: @106356
     /* 106356 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(106393), // Rule ID 6935 //
     /* 106361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106378 */   // MIs[0] ptr
     /* 106378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106386 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15694>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106391 */   GIR_RootConstrainSelectedInstOperands,
     /* 106392 */   // GIR_Coverage, 6935,
     /* 106392 */   GIR_Done,
     /* 106393 */ // Label 2046: @106393
     /* 106393 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(106430), // Rule ID 6945 //
     /* 106398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106415 */   // MIs[0] ptr
     /* 106415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106423 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15701>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106428 */   GIR_RootConstrainSelectedInstOperands,
     /* 106429 */   // GIR_Coverage, 6945,
     /* 106429 */   GIR_Done,
     /* 106430 */ // Label 2047: @106430
     /* 106430 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(106467), // Rule ID 6947 //
     /* 106435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106452 */   // MIs[0] ptr
     /* 106452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106460 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15703>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106465 */   GIR_RootConstrainSelectedInstOperands,
     /* 106466 */   // GIR_Coverage, 6947,
     /* 106466 */   GIR_Done,
     /* 106467 */ // Label 2048: @106467
     /* 106467 */ GIM_Reject,
     /* 106468 */ // Label 2019: @106468
     /* 106468 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(107957),
     /* 106473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106476 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(106561), // Rule ID 4046 //
     /* 106481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106503 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106560 */     // GIR_Coverage, 4046,
     /* 106560 */     GIR_EraseRootFromParent_Done,
     /* 106561 */   // Label 2050: @106561
     /* 106561 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(106646), // Rule ID 4047 //
     /* 106566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106588 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106615 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106645 */     // GIR_Coverage, 4047,
     /* 106645 */     GIR_EraseRootFromParent_Done,
     /* 106646 */   // Label 2051: @106646
     /* 106646 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(106731), // Rule ID 4048 //
     /* 106651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 106673 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 106680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106730 */     // GIR_Coverage, 4048,
     /* 106730 */     GIR_EraseRootFromParent_Done,
     /* 106731 */   // Label 2052: @106731
     /* 106731 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(106816), // Rule ID 4049 //
     /* 106736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 106758 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 106765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106815 */     // GIR_Coverage, 4049,
     /* 106815 */     GIR_EraseRootFromParent_Done,
     /* 106816 */   // Label 2053: @106816
     /* 106816 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(106901), // Rule ID 4050 //
     /* 106821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106843 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 106850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106900 */     // GIR_Coverage, 4050,
     /* 106900 */     GIR_EraseRootFromParent_Done,
     /* 106901 */   // Label 2054: @106901
     /* 106901 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(106986), // Rule ID 4051 //
     /* 106906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106928 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 106935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106985 */     // GIR_Coverage, 4051,
     /* 106985 */     GIR_EraseRootFromParent_Done,
     /* 106986 */   // Label 2055: @106986
     /* 106986 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(107071), // Rule ID 4052 //
     /* 106991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107013 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 107013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 107020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107070 */     // GIR_Coverage, 4052,
     /* 107070 */     GIR_EraseRootFromParent_Done,
     /* 107071 */   // Label 2056: @107071
     /* 107071 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(107156), // Rule ID 4053 //
     /* 107076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107098 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 107098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 107105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107155 */     // GIR_Coverage, 4053,
     /* 107155 */     GIR_EraseRootFromParent_Done,
     /* 107156 */   // Label 2057: @107156
     /* 107156 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(107236), // Rule ID 4085 //
     /* 107161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107183 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107235 */     // GIR_Coverage, 4085,
     /* 107235 */     GIR_EraseRootFromParent_Done,
     /* 107236 */   // Label 2058: @107236
     /* 107236 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(107316), // Rule ID 4086 //
     /* 107241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107263 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 107270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107315 */     // GIR_Coverage, 4086,
     /* 107315 */     GIR_EraseRootFromParent_Done,
     /* 107316 */   // Label 2059: @107316
     /* 107316 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(107396), // Rule ID 4088 //
     /* 107321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107343 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107365 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107395 */     // GIR_Coverage, 4088,
     /* 107395 */     GIR_EraseRootFromParent_Done,
     /* 107396 */   // Label 2060: @107396
     /* 107396 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(107476), // Rule ID 4096 //
     /* 107401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 107423 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 107430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107475 */     // GIR_Coverage, 4096,
     /* 107475 */     GIR_EraseRootFromParent_Done,
     /* 107476 */   // Label 2061: @107476
     /* 107476 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(107556), // Rule ID 4122 //
     /* 107481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 107503 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 107510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107555 */     // GIR_Coverage, 4122,
     /* 107555 */     GIR_EraseRootFromParent_Done,
     /* 107556 */   // Label 2062: @107556
     /* 107556 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(107636), // Rule ID 4123 //
     /* 107561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107583 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107605 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107635 */     // GIR_Coverage, 4123,
     /* 107635 */     GIR_EraseRootFromParent_Done,
     /* 107636 */   // Label 2063: @107636
     /* 107636 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(107716), // Rule ID 4124 //
     /* 107641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107663 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107715 */     // GIR_Coverage, 4124,
     /* 107715 */     GIR_EraseRootFromParent_Done,
     /* 107716 */   // Label 2064: @107716
     /* 107716 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(107796), // Rule ID 4125 //
     /* 107721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107743 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107795 */     // GIR_Coverage, 4125,
     /* 107795 */     GIR_EraseRootFromParent_Done,
     /* 107796 */   // Label 2065: @107796
     /* 107796 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(107876), // Rule ID 4126 //
     /* 107801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107823 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107875 */     // GIR_Coverage, 4126,
     /* 107875 */     GIR_EraseRootFromParent_Done,
     /* 107876 */   // Label 2066: @107876
     /* 107876 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(107956), // Rule ID 4127 //
     /* 107881 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107903 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107925 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107955 */     // GIR_Coverage, 4127,
     /* 107955 */     GIR_EraseRootFromParent_Done,
     /* 107956 */   // Label 2067: @107956
     /* 107956 */   GIM_Reject,
     /* 107957 */ // Label 2049: @107957
     /* 107957 */ GIM_Reject,
     /* 107958 */ // Label 2020: @107958
     /* 107958 */ GIM_Reject,
     /* 107959 */ // Label 19: @107959
     /* 107959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2088*/ GIMT_Encode4(121484),
     /* 107970 */ /*GILLT_s8*//*Label 2068*/ GIMT_Encode4(108066),
     /* 107974 */ /*GILLT_s16*//*Label 2069*/ GIMT_Encode4(108433),
     /* 107978 */ /*GILLT_s32*//*Label 2070*/ GIMT_Encode4(109572),
     /* 107982 */ /*GILLT_s64*//*Label 2071*/ GIMT_Encode4(114167),
     /* 107986 */ /*GILLT_s128*//*Label 2072*/ GIMT_Encode4(117936),
     /* 107990 */ /*GILLT_v2s32*//*Label 2073*/ GIMT_Encode4(118142),
     /* 107994 */ /*GILLT_v2s64*//*Label 2074*/ GIMT_Encode4(118548),
     /* 107998 */ /*GILLT_v4s16*//*Label 2075*/ GIMT_Encode4(118998),
     /* 108002 */ /*GILLT_v4s32*//*Label 2076*/ GIMT_Encode4(119404),
     /* 108006 */ /*GILLT_v8s8*//*Label 2077*/ GIMT_Encode4(119810),
     /* 108010 */ /*GILLT_v8s16*//*Label 2078*/ GIMT_Encode4(120030),
     /* 108014 */ /*GILLT_v16s8*//*Label 2079*/ GIMT_Encode4(120436), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108026 */ /*GILLT_nxv2s16*//*Label 2080*/ GIMT_Encode4(120656),
     /* 108030 */ /*GILLT_nxv2s32*//*Label 2081*/ GIMT_Encode4(120716),
     /* 108034 */ /*GILLT_nxv2s64*//*Label 2082*/ GIMT_Encode4(120776), GIMT_Encode4(0),
     /* 108042 */ /*GILLT_nxv4s16*//*Label 2083*/ GIMT_Encode4(120946),
     /* 108046 */ /*GILLT_nxv4s32*//*Label 2084*/ GIMT_Encode4(121006), GIMT_Encode4(0),
     /* 108054 */ /*GILLT_nxv8s16*//*Label 2085*/ GIMT_Encode4(121176),
     /* 108058 */ /*GILLT_nxv16s1*//*Label 2086*/ GIMT_Encode4(121346),
     /* 108062 */ /*GILLT_nxv16s8*//*Label 2087*/ GIMT_Encode4(121390),
     /* 108066 */ // Label 2068: @108066
     /* 108066 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(108432),
     /* 108071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108078 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(108146), // Rule ID 12933 //
     /* 108083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 108108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 108116 */     // MIs[2] Operand 1
     /* 108116 */     // No operand predicates
     /* 108116 */     // MIs[0] Rn
     /* 108116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108126 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 108126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 108129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 108133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108144 */     GIR_RootConstrainSelectedInstOperands,
     /* 108145 */     // GIR_Coverage, 12933,
     /* 108145 */     GIR_EraseRootFromParent_Done,
     /* 108146 */   // Label 2090: @108146
     /* 108146 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(108245), // Rule ID 12934 //
     /* 108151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 108176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 108184 */     // MIs[2] Operand 1
     /* 108184 */     // No operand predicates
     /* 108184 */     // MIs[0] Rn
     /* 108184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108194 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 108194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 108197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 108201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 108209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 108213 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 108216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 108229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108243 */     GIR_RootConstrainSelectedInstOperands,
     /* 108244 */     // GIR_Coverage, 12934,
     /* 108244 */     GIR_EraseRootFromParent_Done,
     /* 108245 */   // Label 2091: @108245
     /* 108245 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(108294), // Rule ID 303 //
     /* 108250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108268 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 108271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108292 */     GIR_RootConstrainSelectedInstOperands,
     /* 108293 */     // GIR_Coverage, 303,
     /* 108293 */     GIR_EraseRootFromParent_Done,
     /* 108294 */   // Label 2092: @108294
     /* 108294 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(108343), // Rule ID 304 //
     /* 108299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108317 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 108320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108341 */     GIR_RootConstrainSelectedInstOperands,
     /* 108342 */     // GIR_Coverage, 304,
     /* 108342 */     GIR_EraseRootFromParent_Done,
     /* 108343 */   // Label 2093: @108343
     /* 108343 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(108387), // Rule ID 313 //
     /* 108348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108366 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 108369 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108385 */     GIR_RootConstrainSelectedInstOperands,
     /* 108386 */     // GIR_Coverage, 313,
     /* 108386 */     GIR_EraseRootFromParent_Done,
     /* 108387 */   // Label 2094: @108387
     /* 108387 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(108431), // Rule ID 321 //
     /* 108392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108410 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 108413 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108429 */     GIR_RootConstrainSelectedInstOperands,
     /* 108430 */     // GIR_Coverage, 321,
     /* 108430 */     GIR_EraseRootFromParent_Done,
     /* 108431 */   // Label 2095: @108431
     /* 108431 */   GIM_Reject,
     /* 108432 */ // Label 2089: @108432
     /* 108432 */ GIM_Reject,
     /* 108433 */ // Label 2069: @108433
     /* 108433 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(109571),
     /* 108438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108445 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(108544), // Rule ID 4424 //
     /* 108450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108471 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108488 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108542 */     GIR_RootConstrainSelectedInstOperands,
     /* 108543 */     // GIR_Coverage, 4424,
     /* 108543 */     GIR_EraseRootFromParent_Done,
     /* 108544 */   // Label 2097: @108544
     /* 108544 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(108643), // Rule ID 4425 //
     /* 108549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108587 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108641 */     GIR_RootConstrainSelectedInstOperands,
     /* 108642 */     // GIR_Coverage, 4425,
     /* 108642 */     GIR_EraseRootFromParent_Done,
     /* 108643 */   // Label 2098: @108643
     /* 108643 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(108742), // Rule ID 12931 //
     /* 108648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108686 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108698 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108740 */     GIR_RootConstrainSelectedInstOperands,
     /* 108741 */     // GIR_Coverage, 12931,
     /* 108741 */     GIR_EraseRootFromParent_Done,
     /* 108742 */   // Label 2099: @108742
     /* 108742 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(108841), // Rule ID 12932 //
     /* 108747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108785 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108839 */     GIR_RootConstrainSelectedInstOperands,
     /* 108840 */     // GIR_Coverage, 12932,
     /* 108840 */     GIR_EraseRootFromParent_Done,
     /* 108841 */   // Label 2100: @108841
     /* 108841 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(108935), // Rule ID 4453 //
     /* 108846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108867 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108884 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108896 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108933 */     GIR_RootConstrainSelectedInstOperands,
     /* 108934 */     // GIR_Coverage, 4453,
     /* 108934 */     GIR_EraseRootFromParent_Done,
     /* 108935 */   // Label 2101: @108935
     /* 108935 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(109029), // Rule ID 4478 //
     /* 108940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108961 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 108978 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109027 */     GIR_RootConstrainSelectedInstOperands,
     /* 109028 */     // GIR_Coverage, 4478,
     /* 109028 */     GIR_EraseRootFromParent_Done,
     /* 109029 */   // Label 2102: @109029
     /* 109029 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(109123), // Rule ID 12930 //
     /* 109034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109055 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109072 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109121 */     GIR_RootConstrainSelectedInstOperands,
     /* 109122 */     // GIR_Coverage, 12930,
     /* 109122 */     GIR_EraseRootFromParent_Done,
     /* 109123 */   // Label 2103: @109123
     /* 109123 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(109217), // Rule ID 12936 //
     /* 109128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 109166 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109215 */     GIR_RootConstrainSelectedInstOperands,
     /* 109216 */     // GIR_Coverage, 12936,
     /* 109216 */     GIR_EraseRootFromParent_Done,
     /* 109217 */   // Label 2104: @109217
     /* 109217 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109285), // Rule ID 6371 //
     /* 109222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109251 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109255 */     // MIs[2] Operand 1
     /* 109255 */     // No operand predicates
     /* 109255 */     // MIs[0] Rn
     /* 109255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109265 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109283 */     GIR_RootConstrainSelectedInstOperands,
     /* 109284 */     // GIR_Coverage, 6371,
     /* 109284 */     GIR_EraseRootFromParent_Done,
     /* 109285 */   // Label 2105: @109285
     /* 109285 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(109384), // Rule ID 6376 //
     /* 109290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109319 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109323 */     // MIs[2] Operand 1
     /* 109323 */     // No operand predicates
     /* 109323 */     // MIs[0] Rn
     /* 109323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109333 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 109348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 109355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109382 */     GIR_RootConstrainSelectedInstOperands,
     /* 109383 */     // GIR_Coverage, 6376,
     /* 109383 */     GIR_EraseRootFromParent_Done,
     /* 109384 */   // Label 2106: @109384
     /* 109384 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(109433), // Rule ID 305 //
     /* 109389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109407 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109410 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109431 */     GIR_RootConstrainSelectedInstOperands,
     /* 109432 */     // GIR_Coverage, 305,
     /* 109432 */     GIR_EraseRootFromParent_Done,
     /* 109433 */   // Label 2107: @109433
     /* 109433 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(109482), // Rule ID 306 //
     /* 109438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109456 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109459 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109480 */     GIR_RootConstrainSelectedInstOperands,
     /* 109481 */     // GIR_Coverage, 306,
     /* 109481 */     GIR_EraseRootFromParent_Done,
     /* 109482 */   // Label 2108: @109482
     /* 109482 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(109526), // Rule ID 314 //
     /* 109487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109505 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109508 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109524 */     GIR_RootConstrainSelectedInstOperands,
     /* 109525 */     // GIR_Coverage, 314,
     /* 109525 */     GIR_EraseRootFromParent_Done,
     /* 109526 */   // Label 2109: @109526
     /* 109526 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(109570), // Rule ID 322 //
     /* 109531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109549 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109552 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109568 */     GIR_RootConstrainSelectedInstOperands,
     /* 109569 */     // GIR_Coverage, 322,
     /* 109569 */     GIR_EraseRootFromParent_Done,
     /* 109570 */   // Label 2110: @109570
     /* 109570 */   GIM_Reject,
     /* 109571 */ // Label 2096: @109571
     /* 109571 */ GIM_Reject,
     /* 109572 */ // Label 2070: @109572
     /* 109572 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(109685), // Rule ID 4422 //
     /* 109577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109580 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109584 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109599 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109603 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109612 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109629 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109641 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109683 */   GIR_RootConstrainSelectedInstOperands,
     /* 109684 */   // GIR_Coverage, 4422,
     /* 109684 */   GIR_EraseRootFromParent_Done,
     /* 109685 */ // Label 2111: @109685
     /* 109685 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(109798), // Rule ID 4423 //
     /* 109690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109742 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109754 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109796 */   GIR_RootConstrainSelectedInstOperands,
     /* 109797 */   // GIR_Coverage, 4423,
     /* 109797 */   GIR_EraseRootFromParent_Done,
     /* 109798 */ // Label 2112: @109798
     /* 109798 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(109904), // Rule ID 4426 //
     /* 109803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109831 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109848 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109860 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109902 */   GIR_RootConstrainSelectedInstOperands,
     /* 109903 */   // GIR_Coverage, 4426,
     /* 109903 */   GIR_EraseRootFromParent_Done,
     /* 109904 */ // Label 2113: @109904
     /* 109904 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(110010), // Rule ID 4427 //
     /* 109909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109916 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109920 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109924 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109928 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109932 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109937 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109954 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109966 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110003 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110008 */   GIR_RootConstrainSelectedInstOperands,
     /* 110009 */   // GIR_Coverage, 4427,
     /* 110009 */   GIR_EraseRootFromParent_Done,
     /* 110010 */ // Label 2114: @110010
     /* 110010 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(110116), // Rule ID 4428 //
     /* 110015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110022 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110030 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110043 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110053 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110060 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110072 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110114 */   GIR_RootConstrainSelectedInstOperands,
     /* 110115 */   // GIR_Coverage, 4428,
     /* 110115 */   GIR_EraseRootFromParent_Done,
     /* 110116 */ // Label 2115: @110116
     /* 110116 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(110222), // Rule ID 4429 //
     /* 110121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110140 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110144 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110149 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110166 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110178 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110220 */   GIR_RootConstrainSelectedInstOperands,
     /* 110221 */   // GIR_Coverage, 4429,
     /* 110221 */   GIR_EraseRootFromParent_Done,
     /* 110222 */ // Label 2116: @110222
     /* 110222 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110328), // Rule ID 12938 //
     /* 110227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110255 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110272 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110284 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110326 */   GIR_RootConstrainSelectedInstOperands,
     /* 110327 */   // GIR_Coverage, 12938,
     /* 110327 */   GIR_EraseRootFromParent_Done,
     /* 110328 */ // Label 2117: @110328
     /* 110328 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(110434), // Rule ID 12939 //
     /* 110333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110348 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110352 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110361 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110378 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110390 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110432 */   GIR_RootConstrainSelectedInstOperands,
     /* 110433 */   // GIR_Coverage, 12939,
     /* 110433 */   GIR_EraseRootFromParent_Done,
     /* 110434 */ // Label 2118: @110434
     /* 110434 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(110542), // Rule ID 4452 //
     /* 110439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110461 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110474 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110491 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110503 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 110522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110540 */   GIR_RootConstrainSelectedInstOperands,
     /* 110541 */   // GIR_Coverage, 4452,
     /* 110541 */   GIR_EraseRootFromParent_Done,
     /* 110542 */ // Label 2119: @110542
     /* 110542 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(110643), // Rule ID 4454 //
     /* 110547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110550 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110566 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110575 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110592 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110604 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110641 */   GIR_RootConstrainSelectedInstOperands,
     /* 110642 */   // GIR_Coverage, 4454,
     /* 110642 */   GIR_EraseRootFromParent_Done,
     /* 110643 */ // Label 2120: @110643
     /* 110643 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(110744), // Rule ID 4455 //
     /* 110648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110667 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110693 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110705 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110742 */   GIR_RootConstrainSelectedInstOperands,
     /* 110743 */   // GIR_Coverage, 4455,
     /* 110743 */   GIR_EraseRootFromParent_Done,
     /* 110744 */ // Label 2121: @110744
     /* 110744 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(110852), // Rule ID 4477 //
     /* 110749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110752 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110775 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110801 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110813 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 110832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110850 */   GIR_RootConstrainSelectedInstOperands,
     /* 110851 */   // GIR_Coverage, 4477,
     /* 110851 */   GIR_EraseRootFromParent_Done,
     /* 110852 */ // Label 2122: @110852
     /* 110852 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(110953), // Rule ID 4479 //
     /* 110857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110885 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110902 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110914 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110951 */   GIR_RootConstrainSelectedInstOperands,
     /* 110952 */   // GIR_Coverage, 4479,
     /* 110952 */   GIR_EraseRootFromParent_Done,
     /* 110953 */ // Label 2123: @110953
     /* 110953 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111054), // Rule ID 4480 //
     /* 110958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110977 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 111003 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111015 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111052 */   GIR_RootConstrainSelectedInstOperands,
     /* 111053 */   // GIR_Coverage, 4480,
     /* 111053 */   GIR_EraseRootFromParent_Done,
     /* 111054 */ // Label 2124: @111054
     /* 111054 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111155), // Rule ID 12935 //
     /* 111059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111074 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111087 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111104 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 111104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111116 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 111135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111153 */   GIR_RootConstrainSelectedInstOperands,
     /* 111154 */   // GIR_Coverage, 12935,
     /* 111154 */   GIR_EraseRootFromParent_Done,
     /* 111155 */ // Label 2125: @111155
     /* 111155 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111256), // Rule ID 12937 //
     /* 111160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111188 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 111205 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111217 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111254 */   GIR_RootConstrainSelectedInstOperands,
     /* 111255 */   // GIR_Coverage, 12937,
     /* 111255 */   GIR_EraseRootFromParent_Done,
     /* 111256 */ // Label 2126: @111256
     /* 111256 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111338), // Rule ID 6365 //
     /* 111261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111264 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111291 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111296 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111300 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111304 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111308 */   // MIs[2] Operand 1
     /* 111308 */   // No operand predicates
     /* 111308 */   // MIs[0] Rn
     /* 111308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111316 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111318 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111325 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111328 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111336 */   GIR_RootConstrainSelectedInstOperands,
     /* 111337 */   // GIR_Coverage, 6365,
     /* 111337 */   GIR_EraseRootFromParent_Done,
     /* 111338 */ // Label 2127: @111338
     /* 111338 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111420), // Rule ID 6366 //
     /* 111343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111346 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111378 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111382 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111386 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111390 */   // MIs[2] Operand 1
     /* 111390 */   // No operand predicates
     /* 111390 */   // MIs[0] Rn
     /* 111390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111398 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111400 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111407 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111410 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111418 */   GIR_RootConstrainSelectedInstOperands,
     /* 111419 */   // GIR_Coverage, 6366,
     /* 111419 */   GIR_EraseRootFromParent_Done,
     /* 111420 */ // Label 2128: @111420
     /* 111420 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111495), // Rule ID 6367 //
     /* 111425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111428 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111440 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111453 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111457 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111461 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111465 */   // MIs[2] Operand 1
     /* 111465 */   // No operand predicates
     /* 111465 */   // MIs[0] Rn
     /* 111465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111475 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111482 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111485 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111493 */   GIR_RootConstrainSelectedInstOperands,
     /* 111494 */   // GIR_Coverage, 6367,
     /* 111494 */   GIR_EraseRootFromParent_Done,
     /* 111495 */ // Label 2129: @111495
     /* 111495 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(111570), // Rule ID 6368 //
     /* 111500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111536 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111540 */   // MIs[2] Operand 1
     /* 111540 */   // No operand predicates
     /* 111540 */   // MIs[0] Rn
     /* 111540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111548 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111550 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111557 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111568 */   GIR_RootConstrainSelectedInstOperands,
     /* 111569 */   // GIR_Coverage, 6368,
     /* 111569 */   GIR_EraseRootFromParent_Done,
     /* 111570 */ // Label 2130: @111570
     /* 111570 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(111683), // Rule ID 6372 //
     /* 111575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111578 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111605 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111610 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111618 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111622 */   // MIs[2] Operand 1
     /* 111622 */   // No operand predicates
     /* 111622 */   // MIs[0] Rn
     /* 111622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111630 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111632 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111644 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111651 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111673 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111681 */   GIR_RootConstrainSelectedInstOperands,
     /* 111682 */   // GIR_Coverage, 6372,
     /* 111682 */   GIR_EraseRootFromParent_Done,
     /* 111683 */ // Label 2131: @111683
     /* 111683 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(111796), // Rule ID 6373 //
     /* 111688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111714 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111723 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111727 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111731 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111735 */   // MIs[2] Operand 1
     /* 111735 */   // No operand predicates
     /* 111735 */   // MIs[0] Rn
     /* 111735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111745 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111757 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111760 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111783 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111786 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111794 */   GIR_RootConstrainSelectedInstOperands,
     /* 111795 */   // GIR_Coverage, 6373,
     /* 111795 */   GIR_EraseRootFromParent_Done,
     /* 111796 */ // Label 2132: @111796
     /* 111796 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(111902), // Rule ID 6374 //
     /* 111801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111829 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111833 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111837 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111841 */   // MIs[2] Operand 1
     /* 111841 */   // No operand predicates
     /* 111841 */   // MIs[0] Rn
     /* 111841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111849 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111851 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111863 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111870 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111889 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111900 */   GIR_RootConstrainSelectedInstOperands,
     /* 111901 */   // GIR_Coverage, 6374,
     /* 111901 */   GIR_EraseRootFromParent_Done,
     /* 111902 */ // Label 2133: @111902
     /* 111902 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112008), // Rule ID 6375 //
     /* 111907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111935 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111939 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111943 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111947 */   // MIs[2] Operand 1
     /* 111947 */   // No operand predicates
     /* 111947 */   // MIs[0] Rn
     /* 111947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111955 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111957 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111969 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111976 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111998 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112006 */   GIR_RootConstrainSelectedInstOperands,
     /* 112007 */   // GIR_Coverage, 6375,
     /* 112007 */   GIR_EraseRootFromParent_Done,
     /* 112008 */ // Label 2134: @112008
     /* 112008 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112068), // Rule ID 295 //
     /* 112013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112016 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112042 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112045 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112066 */   GIR_RootConstrainSelectedInstOperands,
     /* 112067 */   // GIR_Coverage, 295,
     /* 112067 */   GIR_EraseRootFromParent_Done,
     /* 112068 */ // Label 2135: @112068
     /* 112068 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112128), // Rule ID 296 //
     /* 112073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112076 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112102 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112105 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112126 */   GIR_RootConstrainSelectedInstOperands,
     /* 112127 */   // GIR_Coverage, 296,
     /* 112127 */   GIR_EraseRootFromParent_Done,
     /* 112128 */ // Label 2136: @112128
     /* 112128 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112188), // Rule ID 297 //
     /* 112133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112136 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112162 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112165 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112186 */   GIR_RootConstrainSelectedInstOperands,
     /* 112187 */   // GIR_Coverage, 297,
     /* 112187 */   GIR_EraseRootFromParent_Done,
     /* 112188 */ // Label 2137: @112188
     /* 112188 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112248), // Rule ID 298 //
     /* 112193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112222 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 112225 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112246 */   GIR_RootConstrainSelectedInstOperands,
     /* 112247 */   // GIR_Coverage, 298,
     /* 112247 */   GIR_EraseRootFromParent_Done,
     /* 112248 */ // Label 2138: @112248
     /* 112248 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112301), // Rule ID 299 //
     /* 112253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112275 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112278 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112299 */   GIR_RootConstrainSelectedInstOperands,
     /* 112300 */   // GIR_Coverage, 299,
     /* 112300 */   GIR_EraseRootFromParent_Done,
     /* 112301 */ // Label 2139: @112301
     /* 112301 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112354), // Rule ID 300 //
     /* 112306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112328 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112331 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112352 */   GIR_RootConstrainSelectedInstOperands,
     /* 112353 */   // GIR_Coverage, 300,
     /* 112353 */   GIR_EraseRootFromParent_Done,
     /* 112354 */ // Label 2140: @112354
     /* 112354 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112410), // Rule ID 307 //
     /* 112359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112384 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112387 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112408 */   GIR_RootConstrainSelectedInstOperands,
     /* 112409 */   // GIR_Coverage, 307,
     /* 112409 */   GIR_EraseRootFromParent_Done,
     /* 112410 */ // Label 2141: @112410
     /* 112410 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112466), // Rule ID 308 //
     /* 112415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112440 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112443 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112464 */   GIR_RootConstrainSelectedInstOperands,
     /* 112465 */   // GIR_Coverage, 308,
     /* 112465 */   GIR_EraseRootFromParent_Done,
     /* 112466 */ // Label 2142: @112466
     /* 112466 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112518), // Rule ID 312 //
     /* 112471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112493 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 112496 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112516 */   GIR_RootConstrainSelectedInstOperands,
     /* 112517 */   // GIR_Coverage, 312,
     /* 112517 */   GIR_EraseRootFromParent_Done,
     /* 112518 */ // Label 2143: @112518
     /* 112518 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112569), // Rule ID 315 //
     /* 112523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112541 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112548 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 112551 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112567 */   GIR_RootConstrainSelectedInstOperands,
     /* 112568 */   // GIR_Coverage, 315,
     /* 112568 */   GIR_EraseRootFromParent_Done,
     /* 112569 */ // Label 2144: @112569
     /* 112569 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112628), // Rule ID 317 //
     /* 112574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112577 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112603 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 112606 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112626 */   GIR_RootConstrainSelectedInstOperands,
     /* 112627 */   // GIR_Coverage, 317,
     /* 112627 */   GIR_EraseRootFromParent_Done,
     /* 112628 */ // Label 2145: @112628
     /* 112628 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112687), // Rule ID 318 //
     /* 112633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112636 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112662 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 112665 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112685 */   GIR_RootConstrainSelectedInstOperands,
     /* 112686 */   // GIR_Coverage, 318,
     /* 112686 */   GIR_EraseRootFromParent_Done,
     /* 112687 */ // Label 2146: @112687
     /* 112687 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(112764), // Rule ID 6996 //
     /* 112692 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112702 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112705 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112709 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112713 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112717 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112735 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112738 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112762 */   GIR_RootConstrainSelectedInstOperands,
     /* 112763 */   // GIR_Coverage, 6996,
     /* 112763 */   GIR_EraseRootFromParent_Done,
     /* 112764 */ // Label 2147: @112764
     /* 112764 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(112841), // Rule ID 6997 //
     /* 112769 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112772 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112779 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112790 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112812 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112815 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112839 */   GIR_RootConstrainSelectedInstOperands,
     /* 112840 */   // GIR_Coverage, 6997,
     /* 112840 */   GIR_EraseRootFromParent_Done,
     /* 112841 */ // Label 2148: @112841
     /* 112841 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(112900), // Rule ID 6977 //
     /* 112846 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112856 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112874 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15736>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112877 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112898 */   GIR_RootConstrainSelectedInstOperands,
     /* 112899 */   // GIR_Coverage, 6977,
     /* 112899 */   GIR_EraseRootFromParent_Done,
     /* 112900 */ // Label 2149: @112900
     /* 112900 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(112959), // Rule ID 6978 //
     /* 112905 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112915 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112933 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15736>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112936 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112957 */   GIR_RootConstrainSelectedInstOperands,
     /* 112958 */   // GIR_Coverage, 6978,
     /* 112958 */   GIR_EraseRootFromParent_Done,
     /* 112959 */ // Label 2150: @112959
     /* 112959 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113018), // Rule ID 6982 //
     /* 112964 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112967 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112974 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112992 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15743>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112995 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113016 */   GIR_RootConstrainSelectedInstOperands,
     /* 113017 */   // GIR_Coverage, 6982,
     /* 113017 */   GIR_EraseRootFromParent_Done,
     /* 113018 */ // Label 2151: @113018
     /* 113018 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113077), // Rule ID 6983 //
     /* 113023 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113033 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113044 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113051 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15743>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 113054 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113071 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113075 */   GIR_RootConstrainSelectedInstOperands,
     /* 113076 */   // GIR_Coverage, 6983,
     /* 113076 */   GIR_EraseRootFromParent_Done,
     /* 113077 */ // Label 2152: @113077
     /* 113077 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113136), // Rule ID 6987 //
     /* 113082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113092 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113110 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 113113 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113134 */   GIR_RootConstrainSelectedInstOperands,
     /* 113135 */   // GIR_Coverage, 6987,
     /* 113135 */   GIR_EraseRootFromParent_Done,
     /* 113136 */ // Label 2153: @113136
     /* 113136 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113195), // Rule ID 6988 //
     /* 113141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113151 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113169 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113193 */   GIR_RootConstrainSelectedInstOperands,
     /* 113194 */   // GIR_Coverage, 6988,
     /* 113194 */   GIR_EraseRootFromParent_Done,
     /* 113195 */ // Label 2154: @113195
     /* 113195 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113267), // Rule ID 6998 //
     /* 113200 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113210 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113225 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113243 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113246 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113265 */   GIR_RootConstrainSelectedInstOperands,
     /* 113266 */   // GIR_Coverage, 6998,
     /* 113266 */   GIR_EraseRootFromParent_Done,
     /* 113267 */ // Label 2155: @113267
     /* 113267 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113339), // Rule ID 6999 //
     /* 113272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113275 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113282 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113315 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113337 */   GIR_RootConstrainSelectedInstOperands,
     /* 113338 */   // GIR_Coverage, 6999,
     /* 113338 */   GIR_EraseRootFromParent_Done,
     /* 113339 */ // Label 2156: @113339
     /* 113339 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113391), // Rule ID 320 //
     /* 113344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113366 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113369 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113389 */   GIR_RootConstrainSelectedInstOperands,
     /* 113390 */   // GIR_Coverage, 320,
     /* 113390 */   GIR_EraseRootFromParent_Done,
     /* 113391 */ // Label 2157: @113391
     /* 113391 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113442), // Rule ID 323 //
     /* 113396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113399 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113402 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113421 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113424 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113440 */   GIR_RootConstrainSelectedInstOperands,
     /* 113441 */   // GIR_Coverage, 323,
     /* 113441 */   GIR_EraseRootFromParent_Done,
     /* 113442 */ // Label 2158: @113442
     /* 113442 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113501), // Rule ID 326 //
     /* 113447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113450 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113476 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113479 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113499 */   GIR_RootConstrainSelectedInstOperands,
     /* 113500 */   // GIR_Coverage, 326,
     /* 113500 */   GIR_EraseRootFromParent_Done,
     /* 113501 */ // Label 2159: @113501
     /* 113501 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113560), // Rule ID 327 //
     /* 113506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113535 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113538 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113558 */   GIR_RootConstrainSelectedInstOperands,
     /* 113559 */   // GIR_Coverage, 327,
     /* 113559 */   GIR_EraseRootFromParent_Done,
     /* 113560 */ // Label 2160: @113560
     /* 113560 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113614), // Rule ID 6979 //
     /* 113565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113575 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113586 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 113593 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15736>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 113593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 113596 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113612 */   GIR_RootConstrainSelectedInstOperands,
     /* 113613 */   // GIR_Coverage, 6979,
     /* 113613 */   GIR_EraseRootFromParent_Done,
     /* 113614 */ // Label 2161: @113614
     /* 113614 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113668), // Rule ID 6980 //
     /* 113619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113629 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113647 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15736>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113650 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113666 */   GIR_RootConstrainSelectedInstOperands,
     /* 113667 */   // GIR_Coverage, 6980,
     /* 113667 */   GIR_EraseRootFromParent_Done,
     /* 113668 */ // Label 2162: @113668
     /* 113668 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113722), // Rule ID 6984 //
     /* 113673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113683 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113701 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15743>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 113704 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113720 */   GIR_RootConstrainSelectedInstOperands,
     /* 113721 */   // GIR_Coverage, 6984,
     /* 113721 */   GIR_EraseRootFromParent_Done,
     /* 113722 */ // Label 2163: @113722
     /* 113722 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113776), // Rule ID 6985 //
     /* 113727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113737 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113755 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15743>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113758 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113774 */   GIR_RootConstrainSelectedInstOperands,
     /* 113775 */   // GIR_Coverage, 6985,
     /* 113775 */   GIR_EraseRootFromParent_Done,
     /* 113776 */ // Label 2164: @113776
     /* 113776 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113830), // Rule ID 6989 //
     /* 113781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113791 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113809 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 113812 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113828 */   GIR_RootConstrainSelectedInstOperands,
     /* 113829 */   // GIR_Coverage, 6989,
     /* 113829 */   GIR_EraseRootFromParent_Done,
     /* 113830 */ // Label 2165: @113830
     /* 113830 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113884), // Rule ID 6990 //
     /* 113835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113863 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15750>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113866 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113882 */   GIR_RootConstrainSelectedInstOperands,
     /* 113883 */   // GIR_Coverage, 6990,
     /* 113883 */   GIR_EraseRootFromParent_Done,
     /* 113884 */ // Label 2166: @113884
     /* 113884 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113941), // Rule ID 7282 //
     /* 113889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113920 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15734>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 113923 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113939 */   GIR_RootConstrainSelectedInstOperands,
     /* 113940 */   // GIR_Coverage, 7282,
     /* 113940 */   GIR_EraseRootFromParent_Done,
     /* 113941 */ // Label 2167: @113941
     /* 113941 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(113998), // Rule ID 7283 //
     /* 113946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113949 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113977 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15741>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 113980 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113996 */   GIR_RootConstrainSelectedInstOperands,
     /* 113997 */   // GIR_Coverage, 7283,
     /* 113997 */   GIR_EraseRootFromParent_Done,
     /* 113998 */ // Label 2168: @113998
     /* 113998 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114055), // Rule ID 7284 //
     /* 114003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 114006 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 114016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 114034 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15748>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 114037 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 114039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114053 */   GIR_RootConstrainSelectedInstOperands,
     /* 114054 */   // GIR_Coverage, 7284,
     /* 114054 */   GIR_EraseRootFromParent_Done,
     /* 114055 */ // Label 2169: @114055
     /* 114055 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114092), // Rule ID 6976 //
     /* 114060 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114077 */   // MIs[0] ptr
     /* 114077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114085 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15734>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 114090 */   GIR_RootConstrainSelectedInstOperands,
     /* 114091 */   // GIR_Coverage, 6976,
     /* 114091 */   GIR_Done,
     /* 114092 */ // Label 2170: @114092
     /* 114092 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114129), // Rule ID 6981 //
     /* 114097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114107 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114114 */   // MIs[0] ptr
     /* 114114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114122 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15741>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 114127 */   GIR_RootConstrainSelectedInstOperands,
     /* 114128 */   // GIR_Coverage, 6981,
     /* 114128 */   GIR_Done,
     /* 114129 */ // Label 2171: @114129
     /* 114129 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114166), // Rule ID 6986 //
     /* 114134 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 114137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 114144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114151 */   // MIs[0] ptr
     /* 114151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114159 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15748>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 114159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 114164 */   GIR_RootConstrainSelectedInstOperands,
     /* 114165 */   // GIR_Coverage, 6986,
     /* 114165 */   GIR_Done,
     /* 114166 */ // Label 2172: @114166
     /* 114166 */ GIM_Reject,
     /* 114167 */ // Label 2071: @114167
     /* 114167 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114273), // Rule ID 4430 //
     /* 114172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114187 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114191 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114200 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114217 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114229 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114271 */   GIR_RootConstrainSelectedInstOperands,
     /* 114272 */   // GIR_Coverage, 4430,
     /* 114272 */   GIR_EraseRootFromParent_Done,
     /* 114273 */ // Label 2173: @114273
     /* 114273 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114379), // Rule ID 4431 //
     /* 114278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114281 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114306 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114323 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114335 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114377 */   GIR_RootConstrainSelectedInstOperands,
     /* 114378 */   // GIR_Coverage, 4431,
     /* 114378 */   GIR_EraseRootFromParent_Done,
     /* 114379 */ // Label 2174: @114379
     /* 114379 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114485), // Rule ID 4432 //
     /* 114384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114387 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114399 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114403 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114412 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114429 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114441 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114483 */   GIR_RootConstrainSelectedInstOperands,
     /* 114484 */   // GIR_Coverage, 4432,
     /* 114484 */   GIR_EraseRootFromParent_Done,
     /* 114485 */ // Label 2175: @114485
     /* 114485 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114591), // Rule ID 4433 //
     /* 114490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114493 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114505 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114509 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114513 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114518 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114535 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114547 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114589 */   GIR_RootConstrainSelectedInstOperands,
     /* 114590 */   // GIR_Coverage, 4433,
     /* 114590 */   GIR_EraseRootFromParent_Done,
     /* 114591 */ // Label 2176: @114591
     /* 114591 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114692), // Rule ID 4456 //
     /* 114596 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114611 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114615 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114624 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114641 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114653 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114690 */   GIR_RootConstrainSelectedInstOperands,
     /* 114691 */   // GIR_Coverage, 4456,
     /* 114691 */   GIR_EraseRootFromParent_Done,
     /* 114692 */ // Label 2177: @114692
     /* 114692 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114793), // Rule ID 4457 //
     /* 114697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114742 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114754 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114791 */   GIR_RootConstrainSelectedInstOperands,
     /* 114792 */   // GIR_Coverage, 4457,
     /* 114792 */   GIR_EraseRootFromParent_Done,
     /* 114793 */ // Label 2178: @114793
     /* 114793 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114894), // Rule ID 4481 //
     /* 114798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114826 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114843 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114855 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114892 */   GIR_RootConstrainSelectedInstOperands,
     /* 114893 */   // GIR_Coverage, 4481,
     /* 114893 */   GIR_EraseRootFromParent_Done,
     /* 114894 */ // Label 2179: @114894
     /* 114894 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114995), // Rule ID 4482 //
     /* 114899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114922 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114927 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114937 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114944 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114956 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114993 */   GIR_RootConstrainSelectedInstOperands,
     /* 114994 */   // GIR_Coverage, 4482,
     /* 114994 */   GIR_EraseRootFromParent_Done,
     /* 114995 */ // Label 2180: @114995
     /* 114995 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(115070), // Rule ID 6369 //
     /* 115000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115003 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115028 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115032 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115036 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 115040 */   // MIs[2] Operand 1
     /* 115040 */   // No operand predicates
     /* 115040 */   // MIs[0] Rn
     /* 115040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115048 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115050 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 115053 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115057 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115060 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115068 */   GIR_RootConstrainSelectedInstOperands,
     /* 115069 */   // GIR_Coverage, 6369,
     /* 115069 */   GIR_EraseRootFromParent_Done,
     /* 115070 */ // Label 2181: @115070
     /* 115070 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(115145), // Rule ID 6370 //
     /* 115075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115090 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115094 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115098 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115103 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115107 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115111 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 115115 */   // MIs[2] Operand 1
     /* 115115 */   // No operand predicates
     /* 115115 */   // MIs[0] Rn
     /* 115115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115123 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115125 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 115128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115132 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115135 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115143 */   GIR_RootConstrainSelectedInstOperands,
     /* 115144 */   // GIR_Coverage, 6370,
     /* 115144 */   GIR_EraseRootFromParent_Done,
     /* 115145 */ // Label 2182: @115145
     /* 115145 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(115198), // Rule ID 301 //
     /* 115150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115172 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 115175 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115196 */   GIR_RootConstrainSelectedInstOperands,
     /* 115197 */   // GIR_Coverage, 301,
     /* 115197 */   GIR_EraseRootFromParent_Done,
     /* 115198 */ // Label 2183: @115198
     /* 115198 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(115251), // Rule ID 302 //
     /* 115203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115225 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 115228 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115249 */   GIR_RootConstrainSelectedInstOperands,
     /* 115250 */   // GIR_Coverage, 302,
     /* 115250 */   GIR_EraseRootFromParent_Done,
     /* 115251 */ // Label 2184: @115251
     /* 115251 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115307), // Rule ID 309 //
     /* 115256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115281 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115284 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115305 */   GIR_RootConstrainSelectedInstOperands,
     /* 115306 */   // GIR_Coverage, 309,
     /* 115306 */   GIR_EraseRootFromParent_Done,
     /* 115307 */ // Label 2185: @115307
     /* 115307 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115363), // Rule ID 310 //
     /* 115312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115337 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115340 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115361 */   GIR_RootConstrainSelectedInstOperands,
     /* 115362 */   // GIR_Coverage, 310,
     /* 115362 */   GIR_EraseRootFromParent_Done,
     /* 115363 */ // Label 2186: @115363
     /* 115363 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115452), // Rule ID 4388 //
     /* 115368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115397 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115409 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115450 */   GIR_RootConstrainSelectedInstOperands,
     /* 115451 */   // GIR_Coverage, 4388,
     /* 115451 */   GIR_EraseRootFromParent_Done,
     /* 115452 */ // Label 2187: @115452
     /* 115452 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115541), // Rule ID 4389 //
     /* 115457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115460 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115486 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115498 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115539 */   GIR_RootConstrainSelectedInstOperands,
     /* 115540 */   // GIR_Coverage, 4389,
     /* 115540 */   GIR_EraseRootFromParent_Done,
     /* 115541 */ // Label 2188: @115541
     /* 115541 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115630), // Rule ID 4390 //
     /* 115546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115549 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115575 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115587 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115628 */   GIR_RootConstrainSelectedInstOperands,
     /* 115629 */   // GIR_Coverage, 4390,
     /* 115629 */   GIR_EraseRootFromParent_Done,
     /* 115630 */ // Label 2189: @115630
     /* 115630 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115719), // Rule ID 4391 //
     /* 115635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115664 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115717 */   GIR_RootConstrainSelectedInstOperands,
     /* 115718 */   // GIR_Coverage, 4391,
     /* 115718 */   GIR_EraseRootFromParent_Done,
     /* 115719 */ // Label 2190: @115719
     /* 115719 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(115808), // Rule ID 4392 //
     /* 115724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115727 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115731 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115753 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115765 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115806 */   GIR_RootConstrainSelectedInstOperands,
     /* 115807 */   // GIR_Coverage, 4392,
     /* 115807 */   GIR_EraseRootFromParent_Done,
     /* 115808 */ // Label 2191: @115808
     /* 115808 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(115897), // Rule ID 4393 //
     /* 115813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115816 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115842 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115854 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115865 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115895 */   GIR_RootConstrainSelectedInstOperands,
     /* 115896 */   // GIR_Coverage, 4393,
     /* 115896 */   GIR_EraseRootFromParent_Done,
     /* 115897 */ // Label 2192: @115897
     /* 115897 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115950), // Rule ID 4404 //
     /* 115902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115924 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115927 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115948 */   GIR_RootConstrainSelectedInstOperands,
     /* 115949 */   // GIR_Coverage, 4404,
     /* 115949 */   GIR_EraseRootFromParent_Done,
     /* 115950 */ // Label 2193: @115950
     /* 115950 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(116003), // Rule ID 4405 //
     /* 115955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115977 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116001 */   GIR_RootConstrainSelectedInstOperands,
     /* 116002 */   // GIR_Coverage, 4405,
     /* 116002 */   GIR_EraseRootFromParent_Done,
     /* 116003 */ // Label 2194: @116003
     /* 116003 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(116056), // Rule ID 4406 //
     /* 116008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116030 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116033 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116054 */   GIR_RootConstrainSelectedInstOperands,
     /* 116055 */   // GIR_Coverage, 4406,
     /* 116055 */   GIR_EraseRootFromParent_Done,
     /* 116056 */ // Label 2195: @116056
     /* 116056 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(116109), // Rule ID 4407 //
     /* 116061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116083 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116086 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116107 */   GIR_RootConstrainSelectedInstOperands,
     /* 116108 */   // GIR_Coverage, 4407,
     /* 116108 */   GIR_EraseRootFromParent_Done,
     /* 116109 */ // Label 2196: @116109
     /* 116109 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116161), // Rule ID 311 //
     /* 116114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116136 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 116139 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 116145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116159 */   GIR_RootConstrainSelectedInstOperands,
     /* 116160 */   // GIR_Coverage, 311,
     /* 116160 */   GIR_EraseRootFromParent_Done,
     /* 116161 */ // Label 2197: @116161
     /* 116161 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116212), // Rule ID 316 //
     /* 116166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116172 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116191 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116194 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116210 */   GIR_RootConstrainSelectedInstOperands,
     /* 116211 */   // GIR_Coverage, 316,
     /* 116211 */   GIR_EraseRootFromParent_Done,
     /* 116212 */ // Label 2198: @116212
     /* 116212 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116260), // Rule ID 4434 //
     /* 116217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116239 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116242 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116258 */   GIR_RootConstrainSelectedInstOperands,
     /* 116259 */   // GIR_Coverage, 4434,
     /* 116259 */   GIR_EraseRootFromParent_Done,
     /* 116260 */ // Label 2199: @116260
     /* 116260 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(116308), // Rule ID 4435 //
     /* 116265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116268 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116287 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116290 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116306 */   GIR_RootConstrainSelectedInstOperands,
     /* 116307 */   // GIR_Coverage, 4435,
     /* 116307 */   GIR_EraseRootFromParent_Done,
     /* 116308 */ // Label 2200: @116308
     /* 116308 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(116392), // Rule ID 4449 //
     /* 116313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116342 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116354 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116390 */   GIR_RootConstrainSelectedInstOperands,
     /* 116391 */   // GIR_Coverage, 4449,
     /* 116391 */   GIR_EraseRootFromParent_Done,
     /* 116392 */ // Label 2201: @116392
     /* 116392 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(116476), // Rule ID 4450 //
     /* 116397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116400 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116426 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116438 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116444 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116474 */   GIR_RootConstrainSelectedInstOperands,
     /* 116475 */   // GIR_Coverage, 4450,
     /* 116475 */   GIR_EraseRootFromParent_Done,
     /* 116476 */ // Label 2202: @116476
     /* 116476 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(116560), // Rule ID 4451 //
     /* 116481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116484 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116510 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116522 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116558 */   GIR_RootConstrainSelectedInstOperands,
     /* 116559 */   // GIR_Coverage, 4451,
     /* 116559 */   GIR_EraseRootFromParent_Done,
     /* 116560 */ // Label 2203: @116560
     /* 116560 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(116637), // Rule ID 7000 //
     /* 116565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116575 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116590 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116608 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116611 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116635 */   GIR_RootConstrainSelectedInstOperands,
     /* 116636 */   // GIR_Coverage, 7000,
     /* 116636 */   GIR_EraseRootFromParent_Done,
     /* 116637 */ // Label 2204: @116637
     /* 116637 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(116714), // Rule ID 7001 //
     /* 116642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116652 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116667 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116685 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116712 */   GIR_RootConstrainSelectedInstOperands,
     /* 116713 */   // GIR_Coverage, 7001,
     /* 116713 */   GIR_EraseRootFromParent_Done,
     /* 116714 */ // Label 2205: @116714
     /* 116714 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(116773), // Rule ID 6992 //
     /* 116719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116747 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 116750 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116771 */   GIR_RootConstrainSelectedInstOperands,
     /* 116772 */   // GIR_Coverage, 6992,
     /* 116772 */   GIR_EraseRootFromParent_Done,
     /* 116773 */ // Label 2206: @116773
     /* 116773 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116832), // Rule ID 6993 //
     /* 116778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116806 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 116809 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116830 */   GIR_RootConstrainSelectedInstOperands,
     /* 116831 */   // GIR_Coverage, 6993,
     /* 116831 */   GIR_EraseRootFromParent_Done,
     /* 116832 */ // Label 2207: @116832
     /* 116832 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116904), // Rule ID 7002 //
     /* 116837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116847 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116858 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116862 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116867 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116880 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116883 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116902 */   GIR_RootConstrainSelectedInstOperands,
     /* 116903 */   // GIR_Coverage, 7002,
     /* 116903 */   GIR_EraseRootFromParent_Done,
     /* 116904 */ // Label 2208: @116904
     /* 116904 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116976), // Rule ID 7003 //
     /* 116909 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116919 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116934 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116952 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116974 */   GIR_RootConstrainSelectedInstOperands,
     /* 116975 */   // GIR_Coverage, 7003,
     /* 116975 */   GIR_EraseRootFromParent_Done,
     /* 116976 */ // Label 2209: @116976
     /* 116976 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(117073), // Rule ID 7274 //
     /* 116981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 116984 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117005 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117009 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 117013 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117017 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117021 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 117025 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117030 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 117034 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117038 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117042 */   // MIs[3] Operand 1
     /* 117042 */   // No operand predicates
     /* 117042 */   // MIs[0] Rn
     /* 117042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117050 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 117052 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15755>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 117059 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 117062 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 117071 */   GIR_RootConstrainSelectedInstOperands,
     /* 117072 */   // GIR_Coverage, 7274,
     /* 117072 */   GIR_EraseRootFromParent_Done,
     /* 117073 */ // Label 2210: @117073
     /* 117073 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(117125), // Rule ID 319 //
     /* 117078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117081 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117089 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117093 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117100 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117103 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 117109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117123 */   GIR_RootConstrainSelectedInstOperands,
     /* 117124 */   // GIR_Coverage, 319,
     /* 117124 */   GIR_EraseRootFromParent_Done,
     /* 117125 */ // Label 2211: @117125
     /* 117125 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(117176), // Rule ID 324 //
     /* 117130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117155 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117158 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117174 */   GIR_RootConstrainSelectedInstOperands,
     /* 117175 */   // GIR_Coverage, 324,
     /* 117175 */   GIR_EraseRootFromParent_Done,
     /* 117176 */ // Label 2212: @117176
     /* 117176 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(117230), // Rule ID 6994 //
     /* 117181 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117184 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117191 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117202 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 117209 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 117209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 117212 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117228 */   GIR_RootConstrainSelectedInstOperands,
     /* 117229 */   // GIR_Coverage, 6994,
     /* 117229 */   GIR_EraseRootFromParent_Done,
     /* 117230 */ // Label 2213: @117230
     /* 117230 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(117284), // Rule ID 6995 //
     /* 117235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117245 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117263 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15757>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117266 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117282 */   GIR_RootConstrainSelectedInstOperands,
     /* 117283 */   // GIR_Coverage, 6995,
     /* 117283 */   GIR_EraseRootFromParent_Done,
     /* 117284 */ // Label 2214: @117284
     /* 117284 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(117341), // Rule ID 7285 //
     /* 117289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117292 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117302 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117320 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15755>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 117323 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117339 */   GIR_RootConstrainSelectedInstOperands,
     /* 117340 */   // GIR_Coverage, 7285,
     /* 117340 */   GIR_EraseRootFromParent_Done,
     /* 117341 */ // Label 2215: @117341
     /* 117341 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(117389), // Rule ID 4458 //
     /* 117346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117368 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117371 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117387 */   GIR_RootConstrainSelectedInstOperands,
     /* 117388 */   // GIR_Coverage, 4458,
     /* 117388 */   GIR_EraseRootFromParent_Done,
     /* 117389 */ // Label 2216: @117389
     /* 117389 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(117437), // Rule ID 4459 //
     /* 117394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117405 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117409 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117416 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117419 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117435 */   GIR_RootConstrainSelectedInstOperands,
     /* 117436 */   // GIR_Coverage, 4459,
     /* 117436 */   GIR_EraseRootFromParent_Done,
     /* 117437 */ // Label 2217: @117437
     /* 117437 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(117521), // Rule ID 4474 //
     /* 117442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117445 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117471 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117483 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117494 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117519 */   GIR_RootConstrainSelectedInstOperands,
     /* 117520 */   // GIR_Coverage, 4474,
     /* 117520 */   GIR_EraseRootFromParent_Done,
     /* 117521 */ // Label 2218: @117521
     /* 117521 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(117605), // Rule ID 4475 //
     /* 117526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117529 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117555 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117567 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117578 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117603 */   GIR_RootConstrainSelectedInstOperands,
     /* 117604 */   // GIR_Coverage, 4475,
     /* 117604 */   GIR_EraseRootFromParent_Done,
     /* 117605 */ // Label 2219: @117605
     /* 117605 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(117689), // Rule ID 4476 //
     /* 117610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117613 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117639 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117651 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117687 */   GIR_RootConstrainSelectedInstOperands,
     /* 117688 */   // GIR_Coverage, 4476,
     /* 117688 */   GIR_EraseRootFromParent_Done,
     /* 117689 */ // Label 2220: @117689
     /* 117689 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(117773), // Rule ID 7273 //
     /* 117694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117718 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117739 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117743 */   // MIs[2] Operand 1
     /* 117743 */   // No operand predicates
     /* 117743 */   // MIs[0] Rn
     /* 117743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117753 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15755>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117756 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117760 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117771 */   GIR_RootConstrainSelectedInstOperands,
     /* 117772 */   // GIR_Coverage, 7273,
     /* 117772 */   GIR_EraseRootFromParent_Done,
     /* 117773 */ // Label 2221: @117773
     /* 117773 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(117871), // Rule ID 7275 //
     /* 117778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117802 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117811 */   // MIs[0] Rn
     /* 117811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117821 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15755>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 117821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 117828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117833 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 117836 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117840 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117869 */   GIR_RootConstrainSelectedInstOperands,
     /* 117870 */   // GIR_Coverage, 7275,
     /* 117870 */   GIR_EraseRootFromParent_Done,
     /* 117871 */ // Label 2222: @117871
     /* 117871 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(117908), // Rule ID 6991 //
     /* 117876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117886 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117893 */   // MIs[0] ptr
     /* 117893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117901 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15755>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 117906 */   GIR_RootConstrainSelectedInstOperands,
     /* 117907 */   // GIR_Coverage, 6991,
     /* 117907 */   GIR_Done,
     /* 117908 */ // Label 2223: @117908
     /* 117908 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(117935), // Rule ID 6319 //
     /* 117913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117920 */   // MIs[0] Rn
     /* 117920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117928 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 117928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 117933 */   GIR_RootConstrainSelectedInstOperands,
     /* 117934 */   // GIR_Coverage, 6319,
     /* 117934 */   GIR_Done,
     /* 117935 */ // Label 2224: @117935
     /* 117935 */ GIM_Reject,
     /* 117936 */ // Label 2072: @117936
     /* 117936 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(118141),
     /* 117941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117956 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(117997), // Rule ID 4386 //
     /* 117961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 117971 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 117974 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117995 */     GIR_RootConstrainSelectedInstOperands,
     /* 117996 */     // GIR_Coverage, 4386,
     /* 117996 */     GIR_EraseRootFromParent_Done,
     /* 117997 */   // Label 2226: @117997
     /* 117997 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(118038), // Rule ID 4387 //
     /* 118002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 118005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118012 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118015 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118036 */     GIR_RootConstrainSelectedInstOperands,
     /* 118037 */     // GIR_Coverage, 4387,
     /* 118037 */     GIR_EraseRootFromParent_Done,
     /* 118038 */   // Label 2227: @118038
     /* 118038 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(118071), // Rule ID 4441 //
     /* 118043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118050 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118053 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118069 */     GIR_RootConstrainSelectedInstOperands,
     /* 118070 */     // GIR_Coverage, 4441,
     /* 118070 */     GIR_EraseRootFromParent_Done,
     /* 118071 */   // Label 2228: @118071
     /* 118071 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(118104), // Rule ID 4465 //
     /* 118076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118083 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118086 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118102 */     GIR_RootConstrainSelectedInstOperands,
     /* 118103 */     // GIR_Coverage, 4465,
     /* 118103 */     GIR_EraseRootFromParent_Done,
     /* 118104 */   // Label 2229: @118104
     /* 118104 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(118140), // Rule ID 325 //
     /* 118109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118119 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118122 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118138 */     GIR_RootConstrainSelectedInstOperands,
     /* 118139 */     // GIR_Coverage, 325,
     /* 118139 */     GIR_EraseRootFromParent_Done,
     /* 118140 */   // Label 2230: @118140
     /* 118140 */   GIM_Reject,
     /* 118141 */ // Label 2225: @118141
     /* 118141 */ GIM_Reject,
     /* 118142 */ // Label 2073: @118142
     /* 118142 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(118547),
     /* 118147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118154 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(118203), // Rule ID 4394 //
     /* 118159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118177 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118180 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118201 */     GIR_RootConstrainSelectedInstOperands,
     /* 118202 */     // GIR_Coverage, 4394,
     /* 118202 */     GIR_EraseRootFromParent_Done,
     /* 118203 */   // Label 2232: @118203
     /* 118203 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(118252), // Rule ID 4395 //
     /* 118208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118226 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118229 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118250 */     GIR_RootConstrainSelectedInstOperands,
     /* 118251 */     // GIR_Coverage, 4395,
     /* 118251 */     GIR_EraseRootFromParent_Done,
     /* 118252 */   // Label 2233: @118252
     /* 118252 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(118301), // Rule ID 4396 //
     /* 118257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118275 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118278 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118299 */     GIR_RootConstrainSelectedInstOperands,
     /* 118300 */     // GIR_Coverage, 4396,
     /* 118300 */     GIR_EraseRootFromParent_Done,
     /* 118301 */   // Label 2234: @118301
     /* 118301 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(118350), // Rule ID 4397 //
     /* 118306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118324 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118327 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118348 */     GIR_RootConstrainSelectedInstOperands,
     /* 118349 */     // GIR_Coverage, 4397,
     /* 118349 */     GIR_EraseRootFromParent_Done,
     /* 118350 */   // Label 2235: @118350
     /* 118350 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(118394), // Rule ID 4436 //
     /* 118355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118373 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118376 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118392 */     GIR_RootConstrainSelectedInstOperands,
     /* 118393 */     // GIR_Coverage, 4436,
     /* 118393 */     GIR_EraseRootFromParent_Done,
     /* 118394 */   // Label 2236: @118394
     /* 118394 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(118438), // Rule ID 4439 //
     /* 118399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118417 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118436 */     GIR_RootConstrainSelectedInstOperands,
     /* 118437 */     // GIR_Coverage, 4439,
     /* 118437 */     GIR_EraseRootFromParent_Done,
     /* 118438 */   // Label 2237: @118438
     /* 118438 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(118482), // Rule ID 4460 //
     /* 118443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118461 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118464 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118480 */     GIR_RootConstrainSelectedInstOperands,
     /* 118481 */     // GIR_Coverage, 4460,
     /* 118481 */     GIR_EraseRootFromParent_Done,
     /* 118482 */   // Label 2238: @118482
     /* 118482 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(118526), // Rule ID 4463 //
     /* 118487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118505 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118508 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118524 */     GIR_RootConstrainSelectedInstOperands,
     /* 118525 */     // GIR_Coverage, 4463,
     /* 118525 */     GIR_EraseRootFromParent_Done,
     /* 118526 */   // Label 2239: @118526
     /* 118526 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(118546), // Rule ID 6318 //
     /* 118531 */     // MIs[0] Rn
     /* 118531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118539 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 118544 */     GIR_RootConstrainSelectedInstOperands,
     /* 118545 */     // GIR_Coverage, 6318,
     /* 118545 */     GIR_Done,
     /* 118546 */   // Label 2240: @118546
     /* 118546 */   GIM_Reject,
     /* 118547 */ // Label 2231: @118547
     /* 118547 */ GIM_Reject,
     /* 118548 */ // Label 2074: @118548
     /* 118548 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(118997),
     /* 118553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118560 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(118609), // Rule ID 4408 //
     /* 118565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118583 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118586 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118607 */     GIR_RootConstrainSelectedInstOperands,
     /* 118608 */     // GIR_Coverage, 4408,
     /* 118608 */     GIR_EraseRootFromParent_Done,
     /* 118609 */   // Label 2242: @118609
     /* 118609 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(118658), // Rule ID 4409 //
     /* 118614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118632 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118635 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118656 */     GIR_RootConstrainSelectedInstOperands,
     /* 118657 */     // GIR_Coverage, 4409,
     /* 118657 */     GIR_EraseRootFromParent_Done,
     /* 118658 */   // Label 2243: @118658
     /* 118658 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(118707), // Rule ID 4410 //
     /* 118663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118681 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118684 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118705 */     GIR_RootConstrainSelectedInstOperands,
     /* 118706 */     // GIR_Coverage, 4410,
     /* 118706 */     GIR_EraseRootFromParent_Done,
     /* 118707 */   // Label 2244: @118707
     /* 118707 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118756), // Rule ID 4411 //
     /* 118712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118730 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118733 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118754 */     GIR_RootConstrainSelectedInstOperands,
     /* 118755 */     // GIR_Coverage, 4411,
     /* 118755 */     GIR_EraseRootFromParent_Done,
     /* 118756 */   // Label 2245: @118756
     /* 118756 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118800), // Rule ID 4443 //
     /* 118761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118779 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118782 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118798 */     GIR_RootConstrainSelectedInstOperands,
     /* 118799 */     // GIR_Coverage, 4443,
     /* 118799 */     GIR_EraseRootFromParent_Done,
     /* 118800 */   // Label 2246: @118800
     /* 118800 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118844), // Rule ID 4447 //
     /* 118805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118823 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118826 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118842 */     GIR_RootConstrainSelectedInstOperands,
     /* 118843 */     // GIR_Coverage, 4447,
     /* 118843 */     GIR_EraseRootFromParent_Done,
     /* 118844 */   // Label 2247: @118844
     /* 118844 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118888), // Rule ID 4467 //
     /* 118849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118867 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118870 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118886 */     GIR_RootConstrainSelectedInstOperands,
     /* 118887 */     // GIR_Coverage, 4467,
     /* 118887 */     GIR_EraseRootFromParent_Done,
     /* 118888 */   // Label 2248: @118888
     /* 118888 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(118932), // Rule ID 4471 //
     /* 118893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118911 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118914 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118930 */     GIR_RootConstrainSelectedInstOperands,
     /* 118931 */     // GIR_Coverage, 4471,
     /* 118931 */     GIR_EraseRootFromParent_Done,
     /* 118932 */   // Label 2249: @118932
     /* 118932 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(118976), // Rule ID 4472 //
     /* 118937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118955 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118958 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118974 */     GIR_RootConstrainSelectedInstOperands,
     /* 118975 */     // GIR_Coverage, 4472,
     /* 118975 */     GIR_EraseRootFromParent_Done,
     /* 118976 */   // Label 2250: @118976
     /* 118976 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(118996), // Rule ID 6315 //
     /* 118981 */     // MIs[0] Rn
     /* 118981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118989 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 118994 */     GIR_RootConstrainSelectedInstOperands,
     /* 118995 */     // GIR_Coverage, 6315,
     /* 118995 */     GIR_Done,
     /* 118996 */   // Label 2251: @118996
     /* 118996 */   GIM_Reject,
     /* 118997 */ // Label 2241: @118997
     /* 118997 */ GIM_Reject,
     /* 118998 */ // Label 2075: @118998
     /* 118998 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(119403),
     /* 119003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119010 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(119059), // Rule ID 4398 //
     /* 119015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119033 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119036 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119057 */     GIR_RootConstrainSelectedInstOperands,
     /* 119058 */     // GIR_Coverage, 4398,
     /* 119058 */     GIR_EraseRootFromParent_Done,
     /* 119059 */   // Label 2253: @119059
     /* 119059 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(119108), // Rule ID 4399 //
     /* 119064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119082 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119085 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119106 */     GIR_RootConstrainSelectedInstOperands,
     /* 119107 */     // GIR_Coverage, 4399,
     /* 119107 */     GIR_EraseRootFromParent_Done,
     /* 119108 */   // Label 2254: @119108
     /* 119108 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(119157), // Rule ID 4402 //
     /* 119113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119131 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119134 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119155 */     GIR_RootConstrainSelectedInstOperands,
     /* 119156 */     // GIR_Coverage, 4402,
     /* 119156 */     GIR_EraseRootFromParent_Done,
     /* 119157 */   // Label 2255: @119157
     /* 119157 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(119206), // Rule ID 4403 //
     /* 119162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119180 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119183 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119204 */     GIR_RootConstrainSelectedInstOperands,
     /* 119205 */     // GIR_Coverage, 4403,
     /* 119205 */     GIR_EraseRootFromParent_Done,
     /* 119206 */   // Label 2256: @119206
     /* 119206 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(119250), // Rule ID 4438 //
     /* 119211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119229 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119232 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119248 */     GIR_RootConstrainSelectedInstOperands,
     /* 119249 */     // GIR_Coverage, 4438,
     /* 119249 */     GIR_EraseRootFromParent_Done,
     /* 119250 */   // Label 2257: @119250
     /* 119250 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(119294), // Rule ID 4440 //
     /* 119255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119273 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119276 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119292 */     GIR_RootConstrainSelectedInstOperands,
     /* 119293 */     // GIR_Coverage, 4440,
     /* 119293 */     GIR_EraseRootFromParent_Done,
     /* 119294 */   // Label 2258: @119294
     /* 119294 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(119338), // Rule ID 4462 //
     /* 119299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119317 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119336 */     GIR_RootConstrainSelectedInstOperands,
     /* 119337 */     // GIR_Coverage, 4462,
     /* 119337 */     GIR_EraseRootFromParent_Done,
     /* 119338 */   // Label 2259: @119338
     /* 119338 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(119382), // Rule ID 4464 //
     /* 119343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119361 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119364 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119380 */     GIR_RootConstrainSelectedInstOperands,
     /* 119381 */     // GIR_Coverage, 4464,
     /* 119381 */     GIR_EraseRootFromParent_Done,
     /* 119382 */   // Label 2260: @119382
     /* 119382 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(119402), // Rule ID 6317 //
     /* 119387 */     // MIs[0] Rn
     /* 119387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119395 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 119400 */     GIR_RootConstrainSelectedInstOperands,
     /* 119401 */     // GIR_Coverage, 6317,
     /* 119401 */     GIR_Done,
     /* 119402 */   // Label 2261: @119402
     /* 119402 */   GIM_Reject,
     /* 119403 */ // Label 2252: @119403
     /* 119403 */ GIM_Reject,
     /* 119404 */ // Label 2076: @119404
     /* 119404 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(119809),
     /* 119409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119412 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119416 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(119465), // Rule ID 4412 //
     /* 119421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119439 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119442 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119463 */     GIR_RootConstrainSelectedInstOperands,
     /* 119464 */     // GIR_Coverage, 4412,
     /* 119464 */     GIR_EraseRootFromParent_Done,
     /* 119465 */   // Label 2263: @119465
     /* 119465 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(119514), // Rule ID 4413 //
     /* 119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119488 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119491 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119512 */     GIR_RootConstrainSelectedInstOperands,
     /* 119513 */     // GIR_Coverage, 4413,
     /* 119513 */     GIR_EraseRootFromParent_Done,
     /* 119514 */   // Label 2264: @119514
     /* 119514 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(119563), // Rule ID 4414 //
     /* 119519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119537 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119540 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119561 */     GIR_RootConstrainSelectedInstOperands,
     /* 119562 */     // GIR_Coverage, 4414,
     /* 119562 */     GIR_EraseRootFromParent_Done,
     /* 119563 */   // Label 2265: @119563
     /* 119563 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(119612), // Rule ID 4415 //
     /* 119568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119586 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119589 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119610 */     GIR_RootConstrainSelectedInstOperands,
     /* 119611 */     // GIR_Coverage, 4415,
     /* 119611 */     GIR_EraseRootFromParent_Done,
     /* 119612 */   // Label 2266: @119612
     /* 119612 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(119656), // Rule ID 4442 //
     /* 119617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119635 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119638 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119654 */     GIR_RootConstrainSelectedInstOperands,
     /* 119655 */     // GIR_Coverage, 4442,
     /* 119655 */     GIR_EraseRootFromParent_Done,
     /* 119656 */   // Label 2267: @119656
     /* 119656 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(119700), // Rule ID 4446 //
     /* 119661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119679 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119682 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119698 */     GIR_RootConstrainSelectedInstOperands,
     /* 119699 */     // GIR_Coverage, 4446,
     /* 119699 */     GIR_EraseRootFromParent_Done,
     /* 119700 */   // Label 2268: @119700
     /* 119700 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119744), // Rule ID 4466 //
     /* 119705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119723 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119726 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119742 */     GIR_RootConstrainSelectedInstOperands,
     /* 119743 */     // GIR_Coverage, 4466,
     /* 119743 */     GIR_EraseRootFromParent_Done,
     /* 119744 */   // Label 2269: @119744
     /* 119744 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(119788), // Rule ID 4470 //
     /* 119749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119767 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119770 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119786 */     GIR_RootConstrainSelectedInstOperands,
     /* 119787 */     // GIR_Coverage, 4470,
     /* 119787 */     GIR_EraseRootFromParent_Done,
     /* 119788 */   // Label 2270: @119788
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119808), // Rule ID 6314 //
     /* 119793 */     // MIs[0] Rn
     /* 119793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119801 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 119806 */     GIR_RootConstrainSelectedInstOperands,
     /* 119807 */     // GIR_Coverage, 6314,
     /* 119807 */     GIR_Done,
     /* 119808 */   // Label 2271: @119808
     /* 119808 */   GIM_Reject,
     /* 119809 */ // Label 2262: @119809
     /* 119809 */ GIM_Reject,
     /* 119810 */ // Label 2077: @119810
     /* 119810 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(120029),
     /* 119815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119822 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119871), // Rule ID 4400 //
     /* 119827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119845 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119848 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119869 */     GIR_RootConstrainSelectedInstOperands,
     /* 119870 */     // GIR_Coverage, 4400,
     /* 119870 */     GIR_EraseRootFromParent_Done,
     /* 119871 */   // Label 2273: @119871
     /* 119871 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(119920), // Rule ID 4401 //
     /* 119876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119894 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119918 */     GIR_RootConstrainSelectedInstOperands,
     /* 119919 */     // GIR_Coverage, 4401,
     /* 119919 */     GIR_EraseRootFromParent_Done,
     /* 119920 */   // Label 2274: @119920
     /* 119920 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(119964), // Rule ID 4437 //
     /* 119925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119943 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119946 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119962 */     GIR_RootConstrainSelectedInstOperands,
     /* 119963 */     // GIR_Coverage, 4437,
     /* 119963 */     GIR_EraseRootFromParent_Done,
     /* 119964 */   // Label 2275: @119964
     /* 119964 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(120008), // Rule ID 4461 //
     /* 119969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119987 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120006 */     GIR_RootConstrainSelectedInstOperands,
     /* 120007 */     // GIR_Coverage, 4461,
     /* 120007 */     GIR_EraseRootFromParent_Done,
     /* 120008 */   // Label 2276: @120008
     /* 120008 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(120028), // Rule ID 6316 //
     /* 120013 */     // MIs[0] Rn
     /* 120013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120021 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 120026 */     GIR_RootConstrainSelectedInstOperands,
     /* 120027 */     // GIR_Coverage, 6316,
     /* 120027 */     GIR_Done,
     /* 120028 */   // Label 2277: @120028
     /* 120028 */   GIM_Reject,
     /* 120029 */ // Label 2272: @120029
     /* 120029 */ GIM_Reject,
     /* 120030 */ // Label 2078: @120030
     /* 120030 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(120435),
     /* 120035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120042 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(120091), // Rule ID 4416 //
     /* 120047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120065 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120068 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120089 */     GIR_RootConstrainSelectedInstOperands,
     /* 120090 */     // GIR_Coverage, 4416,
     /* 120090 */     GIR_EraseRootFromParent_Done,
     /* 120091 */   // Label 2279: @120091
     /* 120091 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(120140), // Rule ID 4417 //
     /* 120096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120114 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120117 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120138 */     GIR_RootConstrainSelectedInstOperands,
     /* 120139 */     // GIR_Coverage, 4417,
     /* 120139 */     GIR_EraseRootFromParent_Done,
     /* 120140 */   // Label 2280: @120140
     /* 120140 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(120189), // Rule ID 4420 //
     /* 120145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120163 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120166 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120187 */     GIR_RootConstrainSelectedInstOperands,
     /* 120188 */     // GIR_Coverage, 4420,
     /* 120188 */     GIR_EraseRootFromParent_Done,
     /* 120189 */   // Label 2281: @120189
     /* 120189 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(120238), // Rule ID 4421 //
     /* 120194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120212 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120215 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120236 */     GIR_RootConstrainSelectedInstOperands,
     /* 120237 */     // GIR_Coverage, 4421,
     /* 120237 */     GIR_EraseRootFromParent_Done,
     /* 120238 */   // Label 2282: @120238
     /* 120238 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(120282), // Rule ID 4445 //
     /* 120243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120261 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120264 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120280 */     GIR_RootConstrainSelectedInstOperands,
     /* 120281 */     // GIR_Coverage, 4445,
     /* 120281 */     GIR_EraseRootFromParent_Done,
     /* 120282 */   // Label 2283: @120282
     /* 120282 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(120326), // Rule ID 4448 //
     /* 120287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120305 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120308 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120324 */     GIR_RootConstrainSelectedInstOperands,
     /* 120325 */     // GIR_Coverage, 4448,
     /* 120325 */     GIR_EraseRootFromParent_Done,
     /* 120326 */   // Label 2284: @120326
     /* 120326 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(120370), // Rule ID 4469 //
     /* 120331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120349 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120368 */     GIR_RootConstrainSelectedInstOperands,
     /* 120369 */     // GIR_Coverage, 4469,
     /* 120369 */     GIR_EraseRootFromParent_Done,
     /* 120370 */   // Label 2285: @120370
     /* 120370 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(120414), // Rule ID 4473 //
     /* 120375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120393 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120396 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120412 */     GIR_RootConstrainSelectedInstOperands,
     /* 120413 */     // GIR_Coverage, 4473,
     /* 120413 */     GIR_EraseRootFromParent_Done,
     /* 120414 */   // Label 2286: @120414
     /* 120414 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(120434), // Rule ID 6313 //
     /* 120419 */     // MIs[0] Rn
     /* 120419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120427 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 120432 */     GIR_RootConstrainSelectedInstOperands,
     /* 120433 */     // GIR_Coverage, 6313,
     /* 120433 */     GIR_Done,
     /* 120434 */   // Label 2287: @120434
     /* 120434 */   GIM_Reject,
     /* 120435 */ // Label 2278: @120435
     /* 120435 */ GIM_Reject,
     /* 120436 */ // Label 2079: @120436
     /* 120436 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(120655),
     /* 120441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120448 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(120497), // Rule ID 4418 //
     /* 120453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120471 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120474 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120495 */     GIR_RootConstrainSelectedInstOperands,
     /* 120496 */     // GIR_Coverage, 4418,
     /* 120496 */     GIR_EraseRootFromParent_Done,
     /* 120497 */   // Label 2289: @120497
     /* 120497 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(120546), // Rule ID 4419 //
     /* 120502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120520 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120523 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120544 */     GIR_RootConstrainSelectedInstOperands,
     /* 120545 */     // GIR_Coverage, 4419,
     /* 120545 */     GIR_EraseRootFromParent_Done,
     /* 120546 */   // Label 2290: @120546
     /* 120546 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(120590), // Rule ID 4444 //
     /* 120551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120569 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120572 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120588 */     GIR_RootConstrainSelectedInstOperands,
     /* 120589 */     // GIR_Coverage, 4444,
     /* 120589 */     GIR_EraseRootFromParent_Done,
     /* 120590 */   // Label 2291: @120590
     /* 120590 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(120634), // Rule ID 4468 //
     /* 120595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120613 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120616 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120632 */     GIR_RootConstrainSelectedInstOperands,
     /* 120633 */     // GIR_Coverage, 4468,
     /* 120633 */     GIR_EraseRootFromParent_Done,
     /* 120634 */   // Label 2292: @120634
     /* 120634 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(120654), // Rule ID 6312 //
     /* 120639 */     // MIs[0] Rn
     /* 120639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120647 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 120652 */     GIR_RootConstrainSelectedInstOperands,
     /* 120653 */     // GIR_Coverage, 6312,
     /* 120653 */     GIR_Done,
     /* 120654 */   // Label 2293: @120654
     /* 120654 */   GIM_Reject,
     /* 120655 */ // Label 2288: @120655
     /* 120655 */ GIM_Reject,
     /* 120656 */ // Label 2080: @120656
     /* 120656 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(120715), // Rule ID 10706 //
     /* 120661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120671 */   // MIs[0] base
     /* 120671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120679 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120691 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 120699 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120704 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120713 */   GIR_RootConstrainSelectedInstOperands,
     /* 120714 */   // GIR_Coverage, 10706,
     /* 120714 */   GIR_EraseRootFromParent_Done,
     /* 120715 */ // Label 2294: @120715
     /* 120715 */ GIM_Reject,
     /* 120716 */ // Label 2081: @120716
     /* 120716 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(120775), // Rule ID 10712 //
     /* 120721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120731 */   // MIs[0] base
     /* 120731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120739 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120751 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 120759 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120764 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120773 */   GIR_RootConstrainSelectedInstOperands,
     /* 120774 */   // GIR_Coverage, 10712,
     /* 120774 */   GIR_EraseRootFromParent_Done,
     /* 120775 */ // Label 2295: @120775
     /* 120775 */ GIM_Reject,
     /* 120776 */ // Label 2082: @120776
     /* 120776 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(120945),
     /* 120781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120792 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(120840), // Rule ID 10697 //
     /* 120797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120804 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120824 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120829 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120838 */     GIR_RootConstrainSelectedInstOperands,
     /* 120839 */     // GIR_Coverage, 10697,
     /* 120839 */     GIR_EraseRootFromParent_Done,
     /* 120840 */   // Label 2297: @120840
     /* 120840 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(120888), // Rule ID 10715 //
     /* 120845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120852 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120872 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120877 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120886 */     GIR_RootConstrainSelectedInstOperands,
     /* 120887 */     // GIR_Coverage, 10715,
     /* 120887 */     GIR_EraseRootFromParent_Done,
     /* 120888 */   // Label 2298: @120888
     /* 120888 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(120916), // Rule ID 10827 //
     /* 120893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 120896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120900 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 120903 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120905 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120914 */     GIR_RootConstrainSelectedInstOperands,
     /* 120915 */     // GIR_Coverage, 10827,
     /* 120915 */     GIR_EraseRootFromParent_Done,
     /* 120916 */   // Label 2299: @120916
     /* 120916 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(120944), // Rule ID 10839 //
     /* 120921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 120924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120928 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 120931 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120933 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120942 */     GIR_RootConstrainSelectedInstOperands,
     /* 120943 */     // GIR_Coverage, 10839,
     /* 120943 */     GIR_EraseRootFromParent_Done,
     /* 120944 */   // Label 2300: @120944
     /* 120944 */   GIM_Reject,
     /* 120945 */ // Label 2296: @120945
     /* 120945 */ GIM_Reject,
     /* 120946 */ // Label 2083: @120946
     /* 120946 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(121005), // Rule ID 10703 //
     /* 120951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120957 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120961 */   // MIs[0] base
     /* 120961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120969 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120981 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 120989 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120994 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121003 */   GIR_RootConstrainSelectedInstOperands,
     /* 121004 */   // GIR_Coverage, 10703,
     /* 121004 */   GIR_EraseRootFromParent_Done,
     /* 121005 */ // Label 2301: @121005
     /* 121005 */ GIM_Reject,
     /* 121006 */ // Label 2084: @121006
     /* 121006 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(121175),
     /* 121011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121022 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(121070), // Rule ID 10691 //
     /* 121027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121034 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 121041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 121054 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121059 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121068 */     GIR_RootConstrainSelectedInstOperands,
     /* 121069 */     // GIR_Coverage, 10691,
     /* 121069 */     GIR_EraseRootFromParent_Done,
     /* 121070 */   // Label 2303: @121070
     /* 121070 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(121118), // Rule ID 10709 //
     /* 121075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121082 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 121089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 121102 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121107 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121116 */     GIR_RootConstrainSelectedInstOperands,
     /* 121117 */     // GIR_Coverage, 10709,
     /* 121117 */     GIR_EraseRootFromParent_Done,
     /* 121118 */   // Label 2304: @121118
     /* 121118 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(121146), // Rule ID 10823 //
     /* 121123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121130 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121133 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121135 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121144 */     GIR_RootConstrainSelectedInstOperands,
     /* 121145 */     // GIR_Coverage, 10823,
     /* 121145 */     GIR_EraseRootFromParent_Done,
     /* 121146 */   // Label 2305: @121146
     /* 121146 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(121174), // Rule ID 10835 //
     /* 121151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121158 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121161 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121163 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121172 */     GIR_RootConstrainSelectedInstOperands,
     /* 121173 */     // GIR_Coverage, 10835,
     /* 121173 */     GIR_EraseRootFromParent_Done,
     /* 121174 */   // Label 2306: @121174
     /* 121174 */   GIM_Reject,
     /* 121175 */ // Label 2302: @121175
     /* 121175 */ GIM_Reject,
     /* 121176 */ // Label 2085: @121176
     /* 121176 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(121345),
     /* 121181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121192 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(121240), // Rule ID 10682 //
     /* 121197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121204 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 121211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 121224 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121238 */     GIR_RootConstrainSelectedInstOperands,
     /* 121239 */     // GIR_Coverage, 10682,
     /* 121239 */     GIR_EraseRootFromParent_Done,
     /* 121240 */   // Label 2308: @121240
     /* 121240 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(121288), // Rule ID 10700 //
     /* 121245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121252 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 121259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121264 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 121272 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121277 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121286 */     GIR_RootConstrainSelectedInstOperands,
     /* 121287 */     // GIR_Coverage, 10700,
     /* 121287 */     GIR_EraseRootFromParent_Done,
     /* 121288 */   // Label 2309: @121288
     /* 121288 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(121316), // Rule ID 10819 //
     /* 121293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121300 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121303 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121305 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121314 */     GIR_RootConstrainSelectedInstOperands,
     /* 121315 */     // GIR_Coverage, 10819,
     /* 121315 */     GIR_EraseRootFromParent_Done,
     /* 121316 */   // Label 2310: @121316
     /* 121316 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(121344), // Rule ID 10831 //
     /* 121321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121328 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121331 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121333 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121342 */     GIR_RootConstrainSelectedInstOperands,
     /* 121343 */     // GIR_Coverage, 10831,
     /* 121343 */     GIR_EraseRootFromParent_Done,
     /* 121344 */   // Label 2311: @121344
     /* 121344 */   GIM_Reject,
     /* 121345 */ // Label 2307: @121345
     /* 121345 */ GIM_Reject,
     /* 121346 */ // Label 2086: @121346
     /* 121346 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(121389), // Rule ID 2421 //
     /* 121351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 121365 */   // MIs[0] base
     /* 121365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121373 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 121376 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 121378 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121387 */   GIR_RootConstrainSelectedInstOperands,
     /* 121388 */   // GIR_Coverage, 2421,
     /* 121388 */   GIR_EraseRootFromParent_Done,
     /* 121389 */ // Label 2312: @121389
     /* 121389 */ GIM_Reject,
     /* 121390 */ // Label 2087: @121390
     /* 121390 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(121483),
     /* 121395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121406 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(121454), // Rule ID 10668 //
     /* 121411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121418 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 121425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 121438 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121443 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121452 */     GIR_RootConstrainSelectedInstOperands,
     /* 121453 */     // GIR_Coverage, 10668,
     /* 121453 */     GIR_EraseRootFromParent_Done,
     /* 121454 */   // Label 2314: @121454
     /* 121454 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(121482), // Rule ID 10815 //
     /* 121459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 121462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121466 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 121469 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121471 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121480 */     GIR_RootConstrainSelectedInstOperands,
     /* 121481 */     // GIR_Coverage, 10815,
     /* 121481 */     GIR_EraseRootFromParent_Done,
     /* 121482 */   // Label 2315: @121482
     /* 121482 */   GIM_Reject,
     /* 121483 */ // Label 2313: @121483
     /* 121483 */ GIM_Reject,
     /* 121484 */ // Label 2088: @121484
     /* 121484 */ GIM_Reject,
     /* 121485 */ // Label 20: @121485
     /* 121485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2318*/ GIMT_Encode4(122835),
     /* 121496 */ /*GILLT_s32*//*Label 2316*/ GIMT_Encode4(121504),
     /* 121500 */ /*GILLT_s64*//*Label 2317*/ GIMT_Encode4(122522),
     /* 121504 */ // Label 2316: @121504
     /* 121504 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(122521),
     /* 121509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 121515 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(121570), // Rule ID 7214 //
     /* 121520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121537 */     // MIs[0] Rn
     /* 121537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121553 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 121556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121568 */     GIR_RootConstrainSelectedInstOperands,
     /* 121569 */     // GIR_Coverage, 7214,
     /* 121569 */     GIR_EraseRootFromParent_Done,
     /* 121570 */   // Label 2320: @121570
     /* 121570 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(121625), // Rule ID 7215 //
     /* 121575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121592 */     // MIs[0] Rn
     /* 121592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121608 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 121611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121623 */     GIR_RootConstrainSelectedInstOperands,
     /* 121624 */     // GIR_Coverage, 7215,
     /* 121624 */     GIR_EraseRootFromParent_Done,
     /* 121625 */   // Label 2321: @121625
     /* 121625 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(121680), // Rule ID 7216 //
     /* 121630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121647 */     // MIs[0] Rn
     /* 121647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121663 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 121666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121678 */     GIR_RootConstrainSelectedInstOperands,
     /* 121679 */     // GIR_Coverage, 7216,
     /* 121679 */     GIR_EraseRootFromParent_Done,
     /* 121680 */   // Label 2322: @121680
     /* 121680 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(121735), // Rule ID 7217 //
     /* 121685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121702 */     // MIs[0] Rn
     /* 121702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121718 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121733 */     GIR_RootConstrainSelectedInstOperands,
     /* 121734 */     // GIR_Coverage, 7217,
     /* 121734 */     GIR_EraseRootFromParent_Done,
     /* 121735 */   // Label 2323: @121735
     /* 121735 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(121790), // Rule ID 7218 //
     /* 121740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121757 */     // MIs[0] Rn
     /* 121757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121773 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121788 */     GIR_RootConstrainSelectedInstOperands,
     /* 121789 */     // GIR_Coverage, 7218,
     /* 121789 */     GIR_EraseRootFromParent_Done,
     /* 121790 */   // Label 2324: @121790
     /* 121790 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(121845), // Rule ID 7219 //
     /* 121795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121812 */     // MIs[0] Rn
     /* 121812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121828 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 121831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121843 */     GIR_RootConstrainSelectedInstOperands,
     /* 121844 */     // GIR_Coverage, 7219,
     /* 121844 */     GIR_EraseRootFromParent_Done,
     /* 121845 */   // Label 2325: @121845
     /* 121845 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(121900), // Rule ID 7220 //
     /* 121850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121867 */     // MIs[0] Rn
     /* 121867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121883 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 121886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121898 */     GIR_RootConstrainSelectedInstOperands,
     /* 121899 */     // GIR_Coverage, 7220,
     /* 121899 */     GIR_EraseRootFromParent_Done,
     /* 121900 */   // Label 2326: @121900
     /* 121900 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(121955), // Rule ID 7221 //
     /* 121905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121922 */     // MIs[0] Rn
     /* 121922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121938 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 121941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121953 */     GIR_RootConstrainSelectedInstOperands,
     /* 121954 */     // GIR_Coverage, 7221,
     /* 121954 */     GIR_EraseRootFromParent_Done,
     /* 121955 */   // Label 2327: @121955
     /* 121955 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(122010), // Rule ID 7222 //
     /* 121960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121977 */     // MIs[0] Rn
     /* 121977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121993 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122008 */     GIR_RootConstrainSelectedInstOperands,
     /* 122009 */     // GIR_Coverage, 7222,
     /* 122009 */     GIR_EraseRootFromParent_Done,
     /* 122010 */   // Label 2328: @122010
     /* 122010 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(122065), // Rule ID 7223 //
     /* 122015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122032 */     // MIs[0] Rn
     /* 122032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122048 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 122051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122063 */     GIR_RootConstrainSelectedInstOperands,
     /* 122064 */     // GIR_Coverage, 7223,
     /* 122064 */     GIR_EraseRootFromParent_Done,
     /* 122065 */   // Label 2329: @122065
     /* 122065 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(122120), // Rule ID 7224 //
     /* 122070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122087 */     // MIs[0] Rn
     /* 122087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122103 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 122106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122118 */     GIR_RootConstrainSelectedInstOperands,
     /* 122119 */     // GIR_Coverage, 7224,
     /* 122119 */     GIR_EraseRootFromParent_Done,
     /* 122120 */   // Label 2330: @122120
     /* 122120 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(122175), // Rule ID 7225 //
     /* 122125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122142 */     // MIs[0] Rn
     /* 122142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122158 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 122161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122173 */     GIR_RootConstrainSelectedInstOperands,
     /* 122174 */     // GIR_Coverage, 7225,
     /* 122174 */     GIR_EraseRootFromParent_Done,
     /* 122175 */   // Label 2331: @122175
     /* 122175 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(122230), // Rule ID 7226 //
     /* 122180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122197 */     // MIs[0] Rn
     /* 122197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122213 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 122216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122228 */     GIR_RootConstrainSelectedInstOperands,
     /* 122229 */     // GIR_Coverage, 7226,
     /* 122229 */     GIR_EraseRootFromParent_Done,
     /* 122230 */   // Label 2332: @122230
     /* 122230 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(122285), // Rule ID 7227 //
     /* 122235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122252 */     // MIs[0] Rn
     /* 122252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122268 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 122271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122283 */     GIR_RootConstrainSelectedInstOperands,
     /* 122284 */     // GIR_Coverage, 7227,
     /* 122284 */     GIR_EraseRootFromParent_Done,
     /* 122285 */   // Label 2333: @122285
     /* 122285 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(122340), // Rule ID 7228 //
     /* 122290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122307 */     // MIs[0] Rn
     /* 122307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122323 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 122326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122338 */     GIR_RootConstrainSelectedInstOperands,
     /* 122339 */     // GIR_Coverage, 7228,
     /* 122339 */     GIR_EraseRootFromParent_Done,
     /* 122340 */   // Label 2334: @122340
     /* 122340 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(122400), // Rule ID 12862 //
     /* 122345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122359 */     // MIs[0] addr
     /* 122359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122375 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 122381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122383 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122388 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122390 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122392 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122398 */     GIR_RootConstrainSelectedInstOperands,
     /* 122399 */     // GIR_Coverage, 12862,
     /* 122399 */     GIR_EraseRootFromParent_Done,
     /* 122400 */   // Label 2335: @122400
     /* 122400 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(122460), // Rule ID 12863 //
     /* 122405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122419 */     // MIs[0] addr
     /* 122419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122435 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 122441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122443 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122448 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122450 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122452 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122458 */     GIR_RootConstrainSelectedInstOperands,
     /* 122459 */     // GIR_Coverage, 12863,
     /* 122459 */     GIR_EraseRootFromParent_Done,
     /* 122460 */   // Label 2336: @122460
     /* 122460 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(122520), // Rule ID 12864 //
     /* 122465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122479 */     // MIs[0] addr
     /* 122479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122495 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 122501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122503 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122508 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122510 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122512 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122518 */     GIR_RootConstrainSelectedInstOperands,
     /* 122519 */     // GIR_Coverage, 12864,
     /* 122519 */     GIR_EraseRootFromParent_Done,
     /* 122520 */   // Label 2337: @122520
     /* 122520 */   GIM_Reject,
     /* 122521 */ // Label 2319: @122521
     /* 122521 */ GIM_Reject,
     /* 122522 */ // Label 2317: @122522
     /* 122522 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(122834),
     /* 122527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 122533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122540 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(122588), // Rule ID 2575 //
     /* 122545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122555 */     // MIs[0] Rn
     /* 122555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122571 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 122574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122586 */     GIR_RootConstrainSelectedInstOperands,
     /* 122587 */     // GIR_Coverage, 2575,
     /* 122587 */     GIR_EraseRootFromParent_Done,
     /* 122588 */   // Label 2339: @122588
     /* 122588 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(122636), // Rule ID 2576 //
     /* 122593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122603 */     // MIs[0] Rn
     /* 122603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122619 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 122622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122634 */     GIR_RootConstrainSelectedInstOperands,
     /* 122635 */     // GIR_Coverage, 2576,
     /* 122635 */     GIR_EraseRootFromParent_Done,
     /* 122636 */   // Label 2340: @122636
     /* 122636 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(122684), // Rule ID 2577 //
     /* 122641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122651 */     // MIs[0] Rn
     /* 122651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122667 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122682 */     GIR_RootConstrainSelectedInstOperands,
     /* 122683 */     // GIR_Coverage, 2577,
     /* 122683 */     GIR_EraseRootFromParent_Done,
     /* 122684 */   // Label 2341: @122684
     /* 122684 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(122732), // Rule ID 2578 //
     /* 122689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122699 */     // MIs[0] Rn
     /* 122699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122715 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122730 */     GIR_RootConstrainSelectedInstOperands,
     /* 122731 */     // GIR_Coverage, 2578,
     /* 122731 */     GIR_EraseRootFromParent_Done,
     /* 122732 */   // Label 2342: @122732
     /* 122732 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(122780), // Rule ID 2579 //
     /* 122737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122747 */     // MIs[0] Rn
     /* 122747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122763 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122778 */     GIR_RootConstrainSelectedInstOperands,
     /* 122779 */     // GIR_Coverage, 2579,
     /* 122779 */     GIR_EraseRootFromParent_Done,
     /* 122780 */   // Label 2343: @122780
     /* 122780 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(122833), // Rule ID 12865 //
     /* 122785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122792 */     // MIs[0] addr
     /* 122792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122808 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 122808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 122814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122816 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122821 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122823 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122825 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122831 */     GIR_RootConstrainSelectedInstOperands,
     /* 122832 */     // GIR_Coverage, 12865,
     /* 122832 */     GIR_EraseRootFromParent_Done,
     /* 122833 */   // Label 2344: @122833
     /* 122833 */   GIM_Reject,
     /* 122834 */ // Label 2338: @122834
     /* 122834 */ GIM_Reject,
     /* 122835 */ // Label 2318: @122835
     /* 122835 */ GIM_Reject,
     /* 122836 */ // Label 21: @122836
     /* 122836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2347*/ GIMT_Encode4(123827),
     /* 122847 */ /*GILLT_s32*//*Label 2345*/ GIMT_Encode4(122855),
     /* 122851 */ /*GILLT_s64*//*Label 2346*/ GIMT_Encode4(123600),
     /* 122855 */ // Label 2345: @122855
     /* 122855 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(123599),
     /* 122860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122863 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(122912), // Rule ID 7199 //
     /* 122868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122885 */     // MIs[0] Rn
     /* 122885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122897 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 122900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122910 */     GIR_RootConstrainSelectedInstOperands,
     /* 122911 */     // GIR_Coverage, 7199,
     /* 122911 */     GIR_EraseRootFromParent_Done,
     /* 122912 */   // Label 2349: @122912
     /* 122912 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(122961), // Rule ID 7200 //
     /* 122917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122934 */     // MIs[0] Rn
     /* 122934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122946 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 122949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122959 */     GIR_RootConstrainSelectedInstOperands,
     /* 122960 */     // GIR_Coverage, 7200,
     /* 122960 */     GIR_EraseRootFromParent_Done,
     /* 122961 */   // Label 2350: @122961
     /* 122961 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(123010), // Rule ID 7201 //
     /* 122966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122983 */     // MIs[0] Rn
     /* 122983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122995 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 122998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123008 */     GIR_RootConstrainSelectedInstOperands,
     /* 123009 */     // GIR_Coverage, 7201,
     /* 123009 */     GIR_EraseRootFromParent_Done,
     /* 123010 */   // Label 2351: @123010
     /* 123010 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(123059), // Rule ID 7202 //
     /* 123015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123032 */     // MIs[0] Rn
     /* 123032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123044 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 123047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123057 */     GIR_RootConstrainSelectedInstOperands,
     /* 123058 */     // GIR_Coverage, 7202,
     /* 123058 */     GIR_EraseRootFromParent_Done,
     /* 123059 */   // Label 2352: @123059
     /* 123059 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(123108), // Rule ID 7203 //
     /* 123064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123081 */     // MIs[0] Rn
     /* 123081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123093 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 123096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123106 */     GIR_RootConstrainSelectedInstOperands,
     /* 123107 */     // GIR_Coverage, 7203,
     /* 123107 */     GIR_EraseRootFromParent_Done,
     /* 123108 */   // Label 2353: @123108
     /* 123108 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(123157), // Rule ID 7204 //
     /* 123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123130 */     // MIs[0] Rn
     /* 123130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123142 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123155 */     GIR_RootConstrainSelectedInstOperands,
     /* 123156 */     // GIR_Coverage, 7204,
     /* 123156 */     GIR_EraseRootFromParent_Done,
     /* 123157 */   // Label 2354: @123157
     /* 123157 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(123206), // Rule ID 7205 //
     /* 123162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123179 */     // MIs[0] Rn
     /* 123179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123191 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 123194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123204 */     GIR_RootConstrainSelectedInstOperands,
     /* 123205 */     // GIR_Coverage, 7205,
     /* 123205 */     GIR_EraseRootFromParent_Done,
     /* 123206 */   // Label 2355: @123206
     /* 123206 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(123255), // Rule ID 7206 //
     /* 123211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123228 */     // MIs[0] Rn
     /* 123228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123240 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 123243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123253 */     GIR_RootConstrainSelectedInstOperands,
     /* 123254 */     // GIR_Coverage, 7206,
     /* 123254 */     GIR_EraseRootFromParent_Done,
     /* 123255 */   // Label 2356: @123255
     /* 123255 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(123304), // Rule ID 7207 //
     /* 123260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123277 */     // MIs[0] Rn
     /* 123277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123289 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 123292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123302 */     GIR_RootConstrainSelectedInstOperands,
     /* 123303 */     // GIR_Coverage, 7207,
     /* 123303 */     GIR_EraseRootFromParent_Done,
     /* 123304 */   // Label 2357: @123304
     /* 123304 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(123353), // Rule ID 7208 //
     /* 123309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123326 */     // MIs[0] Rn
     /* 123326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123338 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 123341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123351 */     GIR_RootConstrainSelectedInstOperands,
     /* 123352 */     // GIR_Coverage, 7208,
     /* 123352 */     GIR_EraseRootFromParent_Done,
     /* 123353 */   // Label 2358: @123353
     /* 123353 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(123402), // Rule ID 7209 //
     /* 123358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123375 */     // MIs[0] Rn
     /* 123375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123387 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 123390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123400 */     GIR_RootConstrainSelectedInstOperands,
     /* 123401 */     // GIR_Coverage, 7209,
     /* 123401 */     GIR_EraseRootFromParent_Done,
     /* 123402 */   // Label 2359: @123402
     /* 123402 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(123451), // Rule ID 7210 //
     /* 123407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123424 */     // MIs[0] Rn
     /* 123424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123436 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 123439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123449 */     GIR_RootConstrainSelectedInstOperands,
     /* 123450 */     // GIR_Coverage, 7210,
     /* 123450 */     GIR_EraseRootFromParent_Done,
     /* 123451 */   // Label 2360: @123451
     /* 123451 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(123500), // Rule ID 7211 //
     /* 123456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123473 */     // MIs[0] Rn
     /* 123473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123485 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 123488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123498 */     GIR_RootConstrainSelectedInstOperands,
     /* 123499 */     // GIR_Coverage, 7211,
     /* 123499 */     GIR_EraseRootFromParent_Done,
     /* 123500 */   // Label 2361: @123500
     /* 123500 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(123549), // Rule ID 7212 //
     /* 123505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123522 */     // MIs[0] Rn
     /* 123522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123534 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123547 */     GIR_RootConstrainSelectedInstOperands,
     /* 123548 */     // GIR_Coverage, 7212,
     /* 123548 */     GIR_EraseRootFromParent_Done,
     /* 123549 */   // Label 2362: @123549
     /* 123549 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(123598), // Rule ID 7213 //
     /* 123554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123571 */     // MIs[0] Rn
     /* 123571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123583 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123596 */     GIR_RootConstrainSelectedInstOperands,
     /* 123597 */     // GIR_Coverage, 7213,
     /* 123597 */     GIR_EraseRootFromParent_Done,
     /* 123598 */   // Label 2363: @123598
     /* 123598 */   GIM_Reject,
     /* 123599 */ // Label 2348: @123599
     /* 123599 */ GIM_Reject,
     /* 123600 */ // Label 2346: @123600
     /* 123600 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(123826),
     /* 123605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123615 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(123657), // Rule ID 7194 //
     /* 123620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123630 */     // MIs[0] Rn
     /* 123630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123642 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 123645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123655 */     GIR_RootConstrainSelectedInstOperands,
     /* 123656 */     // GIR_Coverage, 7194,
     /* 123656 */     GIR_EraseRootFromParent_Done,
     /* 123657 */   // Label 2365: @123657
     /* 123657 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(123699), // Rule ID 7195 //
     /* 123662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123672 */     // MIs[0] Rn
     /* 123672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123684 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 123687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123697 */     GIR_RootConstrainSelectedInstOperands,
     /* 123698 */     // GIR_Coverage, 7195,
     /* 123698 */     GIR_EraseRootFromParent_Done,
     /* 123699 */   // Label 2366: @123699
     /* 123699 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(123741), // Rule ID 7196 //
     /* 123704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123714 */     // MIs[0] Rn
     /* 123714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123726 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 123729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123739 */     GIR_RootConstrainSelectedInstOperands,
     /* 123740 */     // GIR_Coverage, 7196,
     /* 123740 */     GIR_EraseRootFromParent_Done,
     /* 123741 */   // Label 2367: @123741
     /* 123741 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(123783), // Rule ID 7197 //
     /* 123746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123756 */     // MIs[0] Rn
     /* 123756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123768 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123781 */     GIR_RootConstrainSelectedInstOperands,
     /* 123782 */     // GIR_Coverage, 7197,
     /* 123782 */     GIR_EraseRootFromParent_Done,
     /* 123783 */   // Label 2368: @123783
     /* 123783 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(123825), // Rule ID 7198 //
     /* 123788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123798 */     // MIs[0] Rn
     /* 123798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123810 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123823 */     GIR_RootConstrainSelectedInstOperands,
     /* 123824 */     // GIR_Coverage, 7198,
     /* 123824 */     GIR_EraseRootFromParent_Done,
     /* 123825 */   // Label 2369: @123825
     /* 123825 */   GIM_Reject,
     /* 123826 */ // Label 2364: @123826
     /* 123826 */ GIM_Reject,
     /* 123827 */ // Label 2347: @123827
     /* 123827 */ GIM_Reject,
     /* 123828 */ // Label 22: @123828
     /* 123828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2372*/ GIMT_Encode4(124819),
     /* 123839 */ /*GILLT_s32*//*Label 2370*/ GIMT_Encode4(123847),
     /* 123843 */ /*GILLT_s64*//*Label 2371*/ GIMT_Encode4(124592),
     /* 123847 */ // Label 2370: @123847
     /* 123847 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(124591),
     /* 123852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123855 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(123904), // Rule ID 7039 //
     /* 123860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123877 */     // MIs[0] Rn
     /* 123877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123889 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 123892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123902 */     GIR_RootConstrainSelectedInstOperands,
     /* 123903 */     // GIR_Coverage, 7039,
     /* 123903 */     GIR_EraseRootFromParent_Done,
     /* 123904 */   // Label 2374: @123904
     /* 123904 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(123953), // Rule ID 7040 //
     /* 123909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123926 */     // MIs[0] Rn
     /* 123926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123938 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 123941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123951 */     GIR_RootConstrainSelectedInstOperands,
     /* 123952 */     // GIR_Coverage, 7040,
     /* 123952 */     GIR_EraseRootFromParent_Done,
     /* 123953 */   // Label 2375: @123953
     /* 123953 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(124002), // Rule ID 7041 //
     /* 123958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123975 */     // MIs[0] Rn
     /* 123975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123987 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 123990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124000 */     GIR_RootConstrainSelectedInstOperands,
     /* 124001 */     // GIR_Coverage, 7041,
     /* 124001 */     GIR_EraseRootFromParent_Done,
     /* 124002 */   // Label 2376: @124002
     /* 124002 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(124051), // Rule ID 7042 //
     /* 124007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124024 */     // MIs[0] Rn
     /* 124024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124036 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124049 */     GIR_RootConstrainSelectedInstOperands,
     /* 124050 */     // GIR_Coverage, 7042,
     /* 124050 */     GIR_EraseRootFromParent_Done,
     /* 124051 */   // Label 2377: @124051
     /* 124051 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(124100), // Rule ID 7043 //
     /* 124056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124073 */     // MIs[0] Rn
     /* 124073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124085 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124098 */     GIR_RootConstrainSelectedInstOperands,
     /* 124099 */     // GIR_Coverage, 7043,
     /* 124099 */     GIR_EraseRootFromParent_Done,
     /* 124100 */   // Label 2378: @124100
     /* 124100 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(124149), // Rule ID 7044 //
     /* 124105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124122 */     // MIs[0] Rn
     /* 124122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124134 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 124137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124147 */     GIR_RootConstrainSelectedInstOperands,
     /* 124148 */     // GIR_Coverage, 7044,
     /* 124148 */     GIR_EraseRootFromParent_Done,
     /* 124149 */   // Label 2379: @124149
     /* 124149 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(124198), // Rule ID 7045 //
     /* 124154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124171 */     // MIs[0] Rn
     /* 124171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124183 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 124186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124196 */     GIR_RootConstrainSelectedInstOperands,
     /* 124197 */     // GIR_Coverage, 7045,
     /* 124197 */     GIR_EraseRootFromParent_Done,
     /* 124198 */   // Label 2380: @124198
     /* 124198 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(124247), // Rule ID 7046 //
     /* 124203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124220 */     // MIs[0] Rn
     /* 124220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124232 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 124235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124245 */     GIR_RootConstrainSelectedInstOperands,
     /* 124246 */     // GIR_Coverage, 7046,
     /* 124246 */     GIR_EraseRootFromParent_Done,
     /* 124247 */   // Label 2381: @124247
     /* 124247 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(124296), // Rule ID 7047 //
     /* 124252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124269 */     // MIs[0] Rn
     /* 124269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124281 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 124284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124294 */     GIR_RootConstrainSelectedInstOperands,
     /* 124295 */     // GIR_Coverage, 7047,
     /* 124295 */     GIR_EraseRootFromParent_Done,
     /* 124296 */   // Label 2382: @124296
     /* 124296 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(124345), // Rule ID 7048 //
     /* 124301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124318 */     // MIs[0] Rn
     /* 124318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124330 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 124333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124343 */     GIR_RootConstrainSelectedInstOperands,
     /* 124344 */     // GIR_Coverage, 7048,
     /* 124344 */     GIR_EraseRootFromParent_Done,
     /* 124345 */   // Label 2383: @124345
     /* 124345 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(124394), // Rule ID 7049 //
     /* 124350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124367 */     // MIs[0] Rn
     /* 124367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124379 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 124382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124392 */     GIR_RootConstrainSelectedInstOperands,
     /* 124393 */     // GIR_Coverage, 7049,
     /* 124393 */     GIR_EraseRootFromParent_Done,
     /* 124394 */   // Label 2384: @124394
     /* 124394 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(124443), // Rule ID 7050 //
     /* 124399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124416 */     // MIs[0] Rn
     /* 124416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124428 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 124431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124441 */     GIR_RootConstrainSelectedInstOperands,
     /* 124442 */     // GIR_Coverage, 7050,
     /* 124442 */     GIR_EraseRootFromParent_Done,
     /* 124443 */   // Label 2385: @124443
     /* 124443 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(124492), // Rule ID 7051 //
     /* 124448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124465 */     // MIs[0] Rn
     /* 124465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124477 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 124480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124490 */     GIR_RootConstrainSelectedInstOperands,
     /* 124491 */     // GIR_Coverage, 7051,
     /* 124491 */     GIR_EraseRootFromParent_Done,
     /* 124492 */   // Label 2386: @124492
     /* 124492 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(124541), // Rule ID 7052 //
     /* 124497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124514 */     // MIs[0] Rn
     /* 124514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124526 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124539 */     GIR_RootConstrainSelectedInstOperands,
     /* 124540 */     // GIR_Coverage, 7052,
     /* 124540 */     GIR_EraseRootFromParent_Done,
     /* 124541 */   // Label 2387: @124541
     /* 124541 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(124590), // Rule ID 7053 //
     /* 124546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124563 */     // MIs[0] Rn
     /* 124563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124575 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124588 */     GIR_RootConstrainSelectedInstOperands,
     /* 124589 */     // GIR_Coverage, 7053,
     /* 124589 */     GIR_EraseRootFromParent_Done,
     /* 124590 */   // Label 2388: @124590
     /* 124590 */   GIM_Reject,
     /* 124591 */ // Label 2373: @124591
     /* 124591 */ GIM_Reject,
     /* 124592 */ // Label 2371: @124592
     /* 124592 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(124818),
     /* 124597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 124600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124607 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(124649), // Rule ID 2570 //
     /* 124612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124622 */     // MIs[0] Rn
     /* 124622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124634 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 124637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124647 */     GIR_RootConstrainSelectedInstOperands,
     /* 124648 */     // GIR_Coverage, 2570,
     /* 124648 */     GIR_EraseRootFromParent_Done,
     /* 124649 */   // Label 2390: @124649
     /* 124649 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(124691), // Rule ID 2571 //
     /* 124654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124664 */     // MIs[0] Rn
     /* 124664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124676 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 124679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124689 */     GIR_RootConstrainSelectedInstOperands,
     /* 124690 */     // GIR_Coverage, 2571,
     /* 124690 */     GIR_EraseRootFromParent_Done,
     /* 124691 */   // Label 2391: @124691
     /* 124691 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(124733), // Rule ID 2572 //
     /* 124696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124706 */     // MIs[0] Rn
     /* 124706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124718 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 124721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124731 */     GIR_RootConstrainSelectedInstOperands,
     /* 124732 */     // GIR_Coverage, 2572,
     /* 124732 */     GIR_EraseRootFromParent_Done,
     /* 124733 */   // Label 2392: @124733
     /* 124733 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(124775), // Rule ID 2573 //
     /* 124738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124748 */     // MIs[0] Rn
     /* 124748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124760 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124773 */     GIR_RootConstrainSelectedInstOperands,
     /* 124774 */     // GIR_Coverage, 2573,
     /* 124774 */     GIR_EraseRootFromParent_Done,
     /* 124775 */   // Label 2393: @124775
     /* 124775 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(124817), // Rule ID 2574 //
     /* 124780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124790 */     // MIs[0] Rn
     /* 124790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124802 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124815 */     GIR_RootConstrainSelectedInstOperands,
     /* 124816 */     // GIR_Coverage, 2574,
     /* 124816 */     GIR_EraseRootFromParent_Done,
     /* 124817 */   // Label 2394: @124817
     /* 124817 */   GIM_Reject,
     /* 124818 */ // Label 2389: @124818
     /* 124818 */ GIM_Reject,
     /* 124819 */ // Label 2372: @124819
     /* 124819 */ GIM_Reject,
     /* 124820 */ // Label 23: @124820
     /* 124820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2397*/ GIMT_Encode4(126311),
     /* 124831 */ /*GILLT_s32*//*Label 2395*/ GIMT_Encode4(124839),
     /* 124835 */ /*GILLT_s64*//*Label 2396*/ GIMT_Encode4(125959),
     /* 124839 */ // Label 2395: @124839
     /* 124839 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(125958),
     /* 124844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 124847 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(124921), // Rule ID 7234 //
     /* 124852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124869 */     // MIs[0] Rn
     /* 124869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124881 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124893 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 124908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124919 */     GIR_RootConstrainSelectedInstOperands,
     /* 124920 */     // GIR_Coverage, 7234,
     /* 124920 */     GIR_EraseRootFromParent_Done,
     /* 124921 */   // Label 2399: @124921
     /* 124921 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(124995), // Rule ID 7235 //
     /* 124926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124943 */     // MIs[0] Rn
     /* 124943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124955 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124967 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 124982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124993 */     GIR_RootConstrainSelectedInstOperands,
     /* 124994 */     // GIR_Coverage, 7235,
     /* 124994 */     GIR_EraseRootFromParent_Done,
     /* 124995 */   // Label 2400: @124995
     /* 124995 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(125069), // Rule ID 7236 //
     /* 125000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125017 */     // MIs[0] Rn
     /* 125017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125029 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125041 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 125056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125067 */     GIR_RootConstrainSelectedInstOperands,
     /* 125068 */     // GIR_Coverage, 7236,
     /* 125068 */     GIR_EraseRootFromParent_Done,
     /* 125069 */   // Label 2401: @125069
     /* 125069 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(125143), // Rule ID 7237 //
     /* 125074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125091 */     // MIs[0] Rn
     /* 125091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125103 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125115 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 125130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125141 */     GIR_RootConstrainSelectedInstOperands,
     /* 125142 */     // GIR_Coverage, 7237,
     /* 125142 */     GIR_EraseRootFromParent_Done,
     /* 125143 */   // Label 2402: @125143
     /* 125143 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(125217), // Rule ID 7238 //
     /* 125148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125165 */     // MIs[0] Rn
     /* 125165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125177 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 125204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 7238,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2403: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(125291), // Rule ID 7239 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125239 */     // MIs[0] Rn
     /* 125239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125251 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125263 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 125278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125289 */     GIR_RootConstrainSelectedInstOperands,
     /* 125290 */     // GIR_Coverage, 7239,
     /* 125290 */     GIR_EraseRootFromParent_Done,
     /* 125291 */   // Label 2404: @125291
     /* 125291 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(125365), // Rule ID 7240 //
     /* 125296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125313 */     // MIs[0] Rn
     /* 125313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125325 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 125352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125363 */     GIR_RootConstrainSelectedInstOperands,
     /* 125364 */     // GIR_Coverage, 7240,
     /* 125364 */     GIR_EraseRootFromParent_Done,
     /* 125365 */   // Label 2405: @125365
     /* 125365 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(125439), // Rule ID 7241 //
     /* 125370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125387 */     // MIs[0] Rn
     /* 125387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125399 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125411 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 125426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125437 */     GIR_RootConstrainSelectedInstOperands,
     /* 125438 */     // GIR_Coverage, 7241,
     /* 125438 */     GIR_EraseRootFromParent_Done,
     /* 125439 */   // Label 2406: @125439
     /* 125439 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(125513), // Rule ID 7242 //
     /* 125444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125461 */     // MIs[0] Rn
     /* 125461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125473 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125485 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125511 */     GIR_RootConstrainSelectedInstOperands,
     /* 125512 */     // GIR_Coverage, 7242,
     /* 125512 */     GIR_EraseRootFromParent_Done,
     /* 125513 */   // Label 2407: @125513
     /* 125513 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(125587), // Rule ID 7243 //
     /* 125518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125535 */     // MIs[0] Rn
     /* 125535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125547 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125559 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125585 */     GIR_RootConstrainSelectedInstOperands,
     /* 125586 */     // GIR_Coverage, 7243,
     /* 125586 */     GIR_EraseRootFromParent_Done,
     /* 125587 */   // Label 2408: @125587
     /* 125587 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(125661), // Rule ID 7244 //
     /* 125592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125609 */     // MIs[0] Rn
     /* 125609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125621 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125633 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 125648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125659 */     GIR_RootConstrainSelectedInstOperands,
     /* 125660 */     // GIR_Coverage, 7244,
     /* 125660 */     GIR_EraseRootFromParent_Done,
     /* 125661 */   // Label 2409: @125661
     /* 125661 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(125735), // Rule ID 7245 //
     /* 125666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125683 */     // MIs[0] Rn
     /* 125683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125695 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125707 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 125722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125733 */     GIR_RootConstrainSelectedInstOperands,
     /* 125734 */     // GIR_Coverage, 7245,
     /* 125734 */     GIR_EraseRootFromParent_Done,
     /* 125735 */   // Label 2410: @125735
     /* 125735 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(125809), // Rule ID 7246 //
     /* 125740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125757 */     // MIs[0] Rn
     /* 125757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125769 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125781 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 125796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125807 */     GIR_RootConstrainSelectedInstOperands,
     /* 125808 */     // GIR_Coverage, 7246,
     /* 125808 */     GIR_EraseRootFromParent_Done,
     /* 125809 */   // Label 2411: @125809
     /* 125809 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(125883), // Rule ID 7247 //
     /* 125814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125831 */     // MIs[0] Rn
     /* 125831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125843 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125855 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125881 */     GIR_RootConstrainSelectedInstOperands,
     /* 125882 */     // GIR_Coverage, 7247,
     /* 125882 */     GIR_EraseRootFromParent_Done,
     /* 125883 */   // Label 2412: @125883
     /* 125883 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(125957), // Rule ID 7248 //
     /* 125888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125905 */     // MIs[0] Rn
     /* 125905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125917 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125929 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125955 */     GIR_RootConstrainSelectedInstOperands,
     /* 125956 */     // GIR_Coverage, 7248,
     /* 125956 */     GIR_EraseRootFromParent_Done,
     /* 125957 */   // Label 2413: @125957
     /* 125957 */   GIM_Reject,
     /* 125958 */ // Label 2398: @125958
     /* 125958 */ GIM_Reject,
     /* 125959 */ // Label 2396: @125959
     /* 125959 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(126310),
     /* 125964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 125967 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 125974 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(126041), // Rule ID 7229 //
     /* 125979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125989 */     // MIs[0] Rn
     /* 125989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126001 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126013 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126039 */     GIR_RootConstrainSelectedInstOperands,
     /* 126040 */     // GIR_Coverage, 7229,
     /* 126040 */     GIR_EraseRootFromParent_Done,
     /* 126041 */   // Label 2415: @126041
     /* 126041 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(126108), // Rule ID 7230 //
     /* 126046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126056 */     // MIs[0] Rn
     /* 126056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126068 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126080 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 126095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126106 */     GIR_RootConstrainSelectedInstOperands,
     /* 126107 */     // GIR_Coverage, 7230,
     /* 126107 */     GIR_EraseRootFromParent_Done,
     /* 126108 */   // Label 2416: @126108
     /* 126108 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(126175), // Rule ID 7231 //
     /* 126113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126123 */     // MIs[0] Rn
     /* 126123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126135 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 126162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126173 */     GIR_RootConstrainSelectedInstOperands,
     /* 126174 */     // GIR_Coverage, 7231,
     /* 126174 */     GIR_EraseRootFromParent_Done,
     /* 126175 */   // Label 2417: @126175
     /* 126175 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(126242), // Rule ID 7232 //
     /* 126180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126183 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126190 */     // MIs[0] Rn
     /* 126190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126202 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 126229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126240 */     GIR_RootConstrainSelectedInstOperands,
     /* 126241 */     // GIR_Coverage, 7232,
     /* 126241 */     GIR_EraseRootFromParent_Done,
     /* 126242 */   // Label 2418: @126242
     /* 126242 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(126309), // Rule ID 7233 //
     /* 126247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126257 */     // MIs[0] Rn
     /* 126257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126269 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 126272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 126276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126281 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 126296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126307 */     GIR_RootConstrainSelectedInstOperands,
     /* 126308 */     // GIR_Coverage, 7233,
     /* 126308 */     GIR_EraseRootFromParent_Done,
     /* 126309 */   // Label 2419: @126309
     /* 126309 */   GIM_Reject,
     /* 126310 */ // Label 2414: @126310
     /* 126310 */ GIM_Reject,
     /* 126311 */ // Label 2397: @126311
     /* 126311 */ GIM_Reject,
     /* 126312 */ // Label 24: @126312
     /* 126312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2422*/ GIMT_Encode4(127803),
     /* 126323 */ /*GILLT_s32*//*Label 2420*/ GIMT_Encode4(126331),
     /* 126327 */ /*GILLT_s64*//*Label 2421*/ GIMT_Encode4(127451),
     /* 126331 */ // Label 2420: @126331
     /* 126331 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(127450),
     /* 126336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126339 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(126413), // Rule ID 7254 //
     /* 126344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126361 */     // MIs[0] Rn
     /* 126361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126373 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126385 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 126400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126411 */     GIR_RootConstrainSelectedInstOperands,
     /* 126412 */     // GIR_Coverage, 7254,
     /* 126412 */     GIR_EraseRootFromParent_Done,
     /* 126413 */   // Label 2424: @126413
     /* 126413 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(126487), // Rule ID 7255 //
     /* 126418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126435 */     // MIs[0] Rn
     /* 126435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126447 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126459 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 126474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126485 */     GIR_RootConstrainSelectedInstOperands,
     /* 126486 */     // GIR_Coverage, 7255,
     /* 126486 */     GIR_EraseRootFromParent_Done,
     /* 126487 */   // Label 2425: @126487
     /* 126487 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(126561), // Rule ID 7256 //
     /* 126492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126509 */     // MIs[0] Rn
     /* 126509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126521 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126533 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 126548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126559 */     GIR_RootConstrainSelectedInstOperands,
     /* 126560 */     // GIR_Coverage, 7256,
     /* 126560 */     GIR_EraseRootFromParent_Done,
     /* 126561 */   // Label 2426: @126561
     /* 126561 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(126635), // Rule ID 7257 //
     /* 126566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126583 */     // MIs[0] Rn
     /* 126583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126595 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126607 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126633 */     GIR_RootConstrainSelectedInstOperands,
     /* 126634 */     // GIR_Coverage, 7257,
     /* 126634 */     GIR_EraseRootFromParent_Done,
     /* 126635 */   // Label 2427: @126635
     /* 126635 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(126709), // Rule ID 7258 //
     /* 126640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126657 */     // MIs[0] Rn
     /* 126657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126669 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126681 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126707 */     GIR_RootConstrainSelectedInstOperands,
     /* 126708 */     // GIR_Coverage, 7258,
     /* 126708 */     GIR_EraseRootFromParent_Done,
     /* 126709 */   // Label 2428: @126709
     /* 126709 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(126783), // Rule ID 7259 //
     /* 126714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126731 */     // MIs[0] Rn
     /* 126731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126743 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126755 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 126770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126781 */     GIR_RootConstrainSelectedInstOperands,
     /* 126782 */     // GIR_Coverage, 7259,
     /* 126782 */     GIR_EraseRootFromParent_Done,
     /* 126783 */   // Label 2429: @126783
     /* 126783 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(126857), // Rule ID 7260 //
     /* 126788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126805 */     // MIs[0] Rn
     /* 126805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126817 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126829 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 126844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126855 */     GIR_RootConstrainSelectedInstOperands,
     /* 126856 */     // GIR_Coverage, 7260,
     /* 126856 */     GIR_EraseRootFromParent_Done,
     /* 126857 */   // Label 2430: @126857
     /* 126857 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(126931), // Rule ID 7261 //
     /* 126862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126879 */     // MIs[0] Rn
     /* 126879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126891 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 126918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126929 */     GIR_RootConstrainSelectedInstOperands,
     /* 126930 */     // GIR_Coverage, 7261,
     /* 126930 */     GIR_EraseRootFromParent_Done,
     /* 126931 */   // Label 2431: @126931
     /* 126931 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(127005), // Rule ID 7262 //
     /* 126936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126953 */     // MIs[0] Rn
     /* 126953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126965 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126977 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127003 */     GIR_RootConstrainSelectedInstOperands,
     /* 127004 */     // GIR_Coverage, 7262,
     /* 127004 */     GIR_EraseRootFromParent_Done,
     /* 127005 */   // Label 2432: @127005
     /* 127005 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(127079), // Rule ID 7263 //
     /* 127010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127027 */     // MIs[0] Rn
     /* 127027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127039 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127051 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 127066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127077 */     GIR_RootConstrainSelectedInstOperands,
     /* 127078 */     // GIR_Coverage, 7263,
     /* 127078 */     GIR_EraseRootFromParent_Done,
     /* 127079 */   // Label 2433: @127079
     /* 127079 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(127153), // Rule ID 7264 //
     /* 127084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127101 */     // MIs[0] Rn
     /* 127101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127113 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127125 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 127140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127151 */     GIR_RootConstrainSelectedInstOperands,
     /* 127152 */     // GIR_Coverage, 7264,
     /* 127152 */     GIR_EraseRootFromParent_Done,
     /* 127153 */   // Label 2434: @127153
     /* 127153 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(127227), // Rule ID 7265 //
     /* 127158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127175 */     // MIs[0] Rn
     /* 127175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127187 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127199 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127225 */     GIR_RootConstrainSelectedInstOperands,
     /* 127226 */     // GIR_Coverage, 7265,
     /* 127226 */     GIR_EraseRootFromParent_Done,
     /* 127227 */   // Label 2435: @127227
     /* 127227 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(127301), // Rule ID 7266 //
     /* 127232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127249 */     // MIs[0] Rn
     /* 127249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127261 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127273 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 127288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127299 */     GIR_RootConstrainSelectedInstOperands,
     /* 127300 */     // GIR_Coverage, 7266,
     /* 127300 */     GIR_EraseRootFromParent_Done,
     /* 127301 */   // Label 2436: @127301
     /* 127301 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(127375), // Rule ID 7267 //
     /* 127306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127323 */     // MIs[0] Rn
     /* 127323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127335 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127347 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 127362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127373 */     GIR_RootConstrainSelectedInstOperands,
     /* 127374 */     // GIR_Coverage, 7267,
     /* 127374 */     GIR_EraseRootFromParent_Done,
     /* 127375 */   // Label 2437: @127375
     /* 127375 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(127449), // Rule ID 7268 //
     /* 127380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127397 */     // MIs[0] Rn
     /* 127397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127409 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 127416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127421 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 127436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127447 */     GIR_RootConstrainSelectedInstOperands,
     /* 127448 */     // GIR_Coverage, 7268,
     /* 127448 */     GIR_EraseRootFromParent_Done,
     /* 127449 */   // Label 2438: @127449
     /* 127449 */   GIM_Reject,
     /* 127450 */ // Label 2423: @127450
     /* 127450 */ GIM_Reject,
     /* 127451 */ // Label 2421: @127451
     /* 127451 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(127802),
     /* 127456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127466 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(127533), // Rule ID 7249 //
     /* 127471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127481 */     // MIs[0] Rn
     /* 127481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127493 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127505 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 127520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127531 */     GIR_RootConstrainSelectedInstOperands,
     /* 127532 */     // GIR_Coverage, 7249,
     /* 127532 */     GIR_EraseRootFromParent_Done,
     /* 127533 */   // Label 2440: @127533
     /* 127533 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(127600), // Rule ID 7250 //
     /* 127538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127548 */     // MIs[0] Rn
     /* 127548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127560 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 127587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127598 */     GIR_RootConstrainSelectedInstOperands,
     /* 127599 */     // GIR_Coverage, 7250,
     /* 127599 */     GIR_EraseRootFromParent_Done,
     /* 127600 */   // Label 2441: @127600
     /* 127600 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(127667), // Rule ID 7251 //
     /* 127605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127615 */     // MIs[0] Rn
     /* 127615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127627 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 127654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127665 */     GIR_RootConstrainSelectedInstOperands,
     /* 127666 */     // GIR_Coverage, 7251,
     /* 127666 */     GIR_EraseRootFromParent_Done,
     /* 127667 */   // Label 2442: @127667
     /* 127667 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(127734), // Rule ID 7252 //
     /* 127672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127682 */     // MIs[0] Rn
     /* 127682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127694 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127706 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127732 */     GIR_RootConstrainSelectedInstOperands,
     /* 127733 */     // GIR_Coverage, 7252,
     /* 127733 */     GIR_EraseRootFromParent_Done,
     /* 127734 */   // Label 2443: @127734
     /* 127734 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(127801), // Rule ID 7253 //
     /* 127739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127749 */     // MIs[0] Rn
     /* 127749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127761 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127773 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127799 */     GIR_RootConstrainSelectedInstOperands,
     /* 127800 */     // GIR_Coverage, 7253,
     /* 127800 */     GIR_EraseRootFromParent_Done,
     /* 127801 */   // Label 2444: @127801
     /* 127801 */   GIM_Reject,
     /* 127802 */ // Label 2439: @127802
     /* 127802 */ GIM_Reject,
     /* 127803 */ // Label 2422: @127803
     /* 127803 */ GIM_Reject,
     /* 127804 */ // Label 25: @127804
     /* 127804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2447*/ GIMT_Encode4(128795),
     /* 127815 */ /*GILLT_s32*//*Label 2445*/ GIMT_Encode4(127823),
     /* 127819 */ /*GILLT_s64*//*Label 2446*/ GIMT_Encode4(128568),
     /* 127823 */ // Label 2445: @127823
     /* 127823 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(128567),
     /* 127828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127831 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(127880), // Rule ID 7059 //
     /* 127836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127839 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127853 */     // MIs[0] Rn
     /* 127853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127865 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 127868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127878 */     GIR_RootConstrainSelectedInstOperands,
     /* 127879 */     // GIR_Coverage, 7059,
     /* 127879 */     GIR_EraseRootFromParent_Done,
     /* 127880 */   // Label 2449: @127880
     /* 127880 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(127929), // Rule ID 7060 //
     /* 127885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127902 */     // MIs[0] Rn
     /* 127902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127914 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 127917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127927 */     GIR_RootConstrainSelectedInstOperands,
     /* 127928 */     // GIR_Coverage, 7060,
     /* 127928 */     GIR_EraseRootFromParent_Done,
     /* 127929 */   // Label 2450: @127929
     /* 127929 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(127978), // Rule ID 7061 //
     /* 127934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127951 */     // MIs[0] Rn
     /* 127951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127963 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 127966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127976 */     GIR_RootConstrainSelectedInstOperands,
     /* 127977 */     // GIR_Coverage, 7061,
     /* 127977 */     GIR_EraseRootFromParent_Done,
     /* 127978 */   // Label 2451: @127978
     /* 127978 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(128027), // Rule ID 7062 //
     /* 127983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128000 */     // MIs[0] Rn
     /* 128000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128012 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 128015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128025 */     GIR_RootConstrainSelectedInstOperands,
     /* 128026 */     // GIR_Coverage, 7062,
     /* 128026 */     GIR_EraseRootFromParent_Done,
     /* 128027 */   // Label 2452: @128027
     /* 128027 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(128076), // Rule ID 7063 //
     /* 128032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128049 */     // MIs[0] Rn
     /* 128049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128061 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 128064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128074 */     GIR_RootConstrainSelectedInstOperands,
     /* 128075 */     // GIR_Coverage, 7063,
     /* 128075 */     GIR_EraseRootFromParent_Done,
     /* 128076 */   // Label 2453: @128076
     /* 128076 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(128125), // Rule ID 7064 //
     /* 128081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128098 */     // MIs[0] Rn
     /* 128098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128110 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 128113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128123 */     GIR_RootConstrainSelectedInstOperands,
     /* 128124 */     // GIR_Coverage, 7064,
     /* 128124 */     GIR_EraseRootFromParent_Done,
     /* 128125 */   // Label 2454: @128125
     /* 128125 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(128174), // Rule ID 7065 //
     /* 128130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128147 */     // MIs[0] Rn
     /* 128147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128159 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 128162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128172 */     GIR_RootConstrainSelectedInstOperands,
     /* 128173 */     // GIR_Coverage, 7065,
     /* 128173 */     GIR_EraseRootFromParent_Done,
     /* 128174 */   // Label 2455: @128174
     /* 128174 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(128223), // Rule ID 7066 //
     /* 128179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128196 */     // MIs[0] Rn
     /* 128196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128208 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 128211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128221 */     GIR_RootConstrainSelectedInstOperands,
     /* 128222 */     // GIR_Coverage, 7066,
     /* 128222 */     GIR_EraseRootFromParent_Done,
     /* 128223 */   // Label 2456: @128223
     /* 128223 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(128272), // Rule ID 7067 //
     /* 128228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128245 */     // MIs[0] Rn
     /* 128245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128257 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 128260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128270 */     GIR_RootConstrainSelectedInstOperands,
     /* 128271 */     // GIR_Coverage, 7067,
     /* 128271 */     GIR_EraseRootFromParent_Done,
     /* 128272 */   // Label 2457: @128272
     /* 128272 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(128321), // Rule ID 7068 //
     /* 128277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128294 */     // MIs[0] Rn
     /* 128294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128306 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 128309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128319 */     GIR_RootConstrainSelectedInstOperands,
     /* 128320 */     // GIR_Coverage, 7068,
     /* 128320 */     GIR_EraseRootFromParent_Done,
     /* 128321 */   // Label 2458: @128321
     /* 128321 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(128370), // Rule ID 7069 //
     /* 128326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128343 */     // MIs[0] Rn
     /* 128343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128355 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 128358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128368 */     GIR_RootConstrainSelectedInstOperands,
     /* 128369 */     // GIR_Coverage, 7069,
     /* 128369 */     GIR_EraseRootFromParent_Done,
     /* 128370 */   // Label 2459: @128370
     /* 128370 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(128419), // Rule ID 7070 //
     /* 128375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128392 */     // MIs[0] Rn
     /* 128392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128404 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 128407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128417 */     GIR_RootConstrainSelectedInstOperands,
     /* 128418 */     // GIR_Coverage, 7070,
     /* 128418 */     GIR_EraseRootFromParent_Done,
     /* 128419 */   // Label 2460: @128419
     /* 128419 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(128468), // Rule ID 7071 //
     /* 128424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128441 */     // MIs[0] Rn
     /* 128441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128453 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 128456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128466 */     GIR_RootConstrainSelectedInstOperands,
     /* 128467 */     // GIR_Coverage, 7071,
     /* 128467 */     GIR_EraseRootFromParent_Done,
     /* 128468 */   // Label 2461: @128468
     /* 128468 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(128517), // Rule ID 7072 //
     /* 128473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128490 */     // MIs[0] Rn
     /* 128490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128502 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128515 */     GIR_RootConstrainSelectedInstOperands,
     /* 128516 */     // GIR_Coverage, 7072,
     /* 128516 */     GIR_EraseRootFromParent_Done,
     /* 128517 */   // Label 2462: @128517
     /* 128517 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(128566), // Rule ID 7073 //
     /* 128522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128539 */     // MIs[0] Rn
     /* 128539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128551 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128564 */     GIR_RootConstrainSelectedInstOperands,
     /* 128565 */     // GIR_Coverage, 7073,
     /* 128565 */     GIR_EraseRootFromParent_Done,
     /* 128566 */   // Label 2463: @128566
     /* 128566 */   GIM_Reject,
     /* 128567 */ // Label 2448: @128567
     /* 128567 */ GIM_Reject,
     /* 128568 */ // Label 2446: @128568
     /* 128568 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(128794),
     /* 128573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128583 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(128625), // Rule ID 7054 //
     /* 128588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128598 */     // MIs[0] Rn
     /* 128598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128610 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 128613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128623 */     GIR_RootConstrainSelectedInstOperands,
     /* 128624 */     // GIR_Coverage, 7054,
     /* 128624 */     GIR_EraseRootFromParent_Done,
     /* 128625 */   // Label 2465: @128625
     /* 128625 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(128667), // Rule ID 7055 //
     /* 128630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128640 */     // MIs[0] Rn
     /* 128640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128652 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 128655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128665 */     GIR_RootConstrainSelectedInstOperands,
     /* 128666 */     // GIR_Coverage, 7055,
     /* 128666 */     GIR_EraseRootFromParent_Done,
     /* 128667 */   // Label 2466: @128667
     /* 128667 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(128709), // Rule ID 7056 //
     /* 128672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128682 */     // MIs[0] Rn
     /* 128682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128694 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 128697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128707 */     GIR_RootConstrainSelectedInstOperands,
     /* 128708 */     // GIR_Coverage, 7056,
     /* 128708 */     GIR_EraseRootFromParent_Done,
     /* 128709 */   // Label 2467: @128709
     /* 128709 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(128751), // Rule ID 7057 //
     /* 128714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128724 */     // MIs[0] Rn
     /* 128724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128736 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128749 */     GIR_RootConstrainSelectedInstOperands,
     /* 128750 */     // GIR_Coverage, 7057,
     /* 128750 */     GIR_EraseRootFromParent_Done,
     /* 128751 */   // Label 2468: @128751
     /* 128751 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(128793), // Rule ID 7058 //
     /* 128756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128766 */     // MIs[0] Rn
     /* 128766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128778 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128791 */     GIR_RootConstrainSelectedInstOperands,
     /* 128792 */     // GIR_Coverage, 7058,
     /* 128792 */     GIR_EraseRootFromParent_Done,
     /* 128793 */   // Label 2469: @128793
     /* 128793 */   GIM_Reject,
     /* 128794 */ // Label 2464: @128794
     /* 128794 */ GIM_Reject,
     /* 128795 */ // Label 2447: @128795
     /* 128795 */ GIM_Reject,
     /* 128796 */ // Label 26: @128796
     /* 128796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2472*/ GIMT_Encode4(129787),
     /* 128807 */ /*GILLT_s32*//*Label 2470*/ GIMT_Encode4(128815),
     /* 128811 */ /*GILLT_s64*//*Label 2471*/ GIMT_Encode4(129560),
     /* 128815 */ // Label 2470: @128815
     /* 128815 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(129559),
     /* 128820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128823 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(128872), // Rule ID 7079 //
     /* 128828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128845 */     // MIs[0] Rn
     /* 128845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128857 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128870 */     GIR_RootConstrainSelectedInstOperands,
     /* 128871 */     // GIR_Coverage, 7079,
     /* 128871 */     GIR_EraseRootFromParent_Done,
     /* 128872 */   // Label 2474: @128872
     /* 128872 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(128921), // Rule ID 7080 //
     /* 128877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128894 */     // MIs[0] Rn
     /* 128894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128906 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 128909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128919 */     GIR_RootConstrainSelectedInstOperands,
     /* 128920 */     // GIR_Coverage, 7080,
     /* 128920 */     GIR_EraseRootFromParent_Done,
     /* 128921 */   // Label 2475: @128921
     /* 128921 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(128970), // Rule ID 7081 //
     /* 128926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128943 */     // MIs[0] Rn
     /* 128943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128955 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 128958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128968 */     GIR_RootConstrainSelectedInstOperands,
     /* 128969 */     // GIR_Coverage, 7081,
     /* 128969 */     GIR_EraseRootFromParent_Done,
     /* 128970 */   // Label 2476: @128970
     /* 128970 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(129019), // Rule ID 7082 //
     /* 128975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128992 */     // MIs[0] Rn
     /* 128992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129004 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 129007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129017 */     GIR_RootConstrainSelectedInstOperands,
     /* 129018 */     // GIR_Coverage, 7082,
     /* 129018 */     GIR_EraseRootFromParent_Done,
     /* 129019 */   // Label 2477: @129019
     /* 129019 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(129068), // Rule ID 7083 //
     /* 129024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129041 */     // MIs[0] Rn
     /* 129041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129053 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 129056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129066 */     GIR_RootConstrainSelectedInstOperands,
     /* 129067 */     // GIR_Coverage, 7083,
     /* 129067 */     GIR_EraseRootFromParent_Done,
     /* 129068 */   // Label 2478: @129068
     /* 129068 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(129117), // Rule ID 7084 //
     /* 129073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129090 */     // MIs[0] Rn
     /* 129090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129102 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 129105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129115 */     GIR_RootConstrainSelectedInstOperands,
     /* 129116 */     // GIR_Coverage, 7084,
     /* 129116 */     GIR_EraseRootFromParent_Done,
     /* 129117 */   // Label 2479: @129117
     /* 129117 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(129166), // Rule ID 7085 //
     /* 129122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129139 */     // MIs[0] Rn
     /* 129139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129151 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 129154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129164 */     GIR_RootConstrainSelectedInstOperands,
     /* 129165 */     // GIR_Coverage, 7085,
     /* 129165 */     GIR_EraseRootFromParent_Done,
     /* 129166 */   // Label 2480: @129166
     /* 129166 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(129215), // Rule ID 7086 //
     /* 129171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129188 */     // MIs[0] Rn
     /* 129188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129200 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 129203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129213 */     GIR_RootConstrainSelectedInstOperands,
     /* 129214 */     // GIR_Coverage, 7086,
     /* 129214 */     GIR_EraseRootFromParent_Done,
     /* 129215 */   // Label 2481: @129215
     /* 129215 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(129264), // Rule ID 7087 //
     /* 129220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129237 */     // MIs[0] Rn
     /* 129237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129249 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 129252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129262 */     GIR_RootConstrainSelectedInstOperands,
     /* 129263 */     // GIR_Coverage, 7087,
     /* 129263 */     GIR_EraseRootFromParent_Done,
     /* 129264 */   // Label 2482: @129264
     /* 129264 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(129313), // Rule ID 7088 //
     /* 129269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129286 */     // MIs[0] Rn
     /* 129286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129298 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 129301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129311 */     GIR_RootConstrainSelectedInstOperands,
     /* 129312 */     // GIR_Coverage, 7088,
     /* 129312 */     GIR_EraseRootFromParent_Done,
     /* 129313 */   // Label 2483: @129313
     /* 129313 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(129362), // Rule ID 7089 //
     /* 129318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129335 */     // MIs[0] Rn
     /* 129335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129347 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 129350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129360 */     GIR_RootConstrainSelectedInstOperands,
     /* 129361 */     // GIR_Coverage, 7089,
     /* 129361 */     GIR_EraseRootFromParent_Done,
     /* 129362 */   // Label 2484: @129362
     /* 129362 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(129411), // Rule ID 7090 //
     /* 129367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129384 */     // MIs[0] Rn
     /* 129384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129396 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 129399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129409 */     GIR_RootConstrainSelectedInstOperands,
     /* 129410 */     // GIR_Coverage, 7090,
     /* 129410 */     GIR_EraseRootFromParent_Done,
     /* 129411 */   // Label 2485: @129411
     /* 129411 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(129460), // Rule ID 7091 //
     /* 129416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129433 */     // MIs[0] Rn
     /* 129433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129445 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 129448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129458 */     GIR_RootConstrainSelectedInstOperands,
     /* 129459 */     // GIR_Coverage, 7091,
     /* 129459 */     GIR_EraseRootFromParent_Done,
     /* 129460 */   // Label 2486: @129460
     /* 129460 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(129509), // Rule ID 7092 //
     /* 129465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129482 */     // MIs[0] Rn
     /* 129482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129494 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129507 */     GIR_RootConstrainSelectedInstOperands,
     /* 129508 */     // GIR_Coverage, 7092,
     /* 129508 */     GIR_EraseRootFromParent_Done,
     /* 129509 */   // Label 2487: @129509
     /* 129509 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(129558), // Rule ID 7093 //
     /* 129514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129531 */     // MIs[0] Rn
     /* 129531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129543 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129556 */     GIR_RootConstrainSelectedInstOperands,
     /* 129557 */     // GIR_Coverage, 7093,
     /* 129557 */     GIR_EraseRootFromParent_Done,
     /* 129558 */   // Label 2488: @129558
     /* 129558 */   GIM_Reject,
     /* 129559 */ // Label 2473: @129559
     /* 129559 */ GIM_Reject,
     /* 129560 */ // Label 2471: @129560
     /* 129560 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(129786),
     /* 129565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129575 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(129617), // Rule ID 7074 //
     /* 129580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129590 */     // MIs[0] Rn
     /* 129590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129602 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 129605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129615 */     GIR_RootConstrainSelectedInstOperands,
     /* 129616 */     // GIR_Coverage, 7074,
     /* 129616 */     GIR_EraseRootFromParent_Done,
     /* 129617 */   // Label 2490: @129617
     /* 129617 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(129659), // Rule ID 7075 //
     /* 129622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129632 */     // MIs[0] Rn
     /* 129632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129644 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 129647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129657 */     GIR_RootConstrainSelectedInstOperands,
     /* 129658 */     // GIR_Coverage, 7075,
     /* 129658 */     GIR_EraseRootFromParent_Done,
     /* 129659 */   // Label 2491: @129659
     /* 129659 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(129701), // Rule ID 7076 //
     /* 129664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129674 */     // MIs[0] Rn
     /* 129674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129686 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129699 */     GIR_RootConstrainSelectedInstOperands,
     /* 129700 */     // GIR_Coverage, 7076,
     /* 129700 */     GIR_EraseRootFromParent_Done,
     /* 129701 */   // Label 2492: @129701
     /* 129701 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(129743), // Rule ID 7077 //
     /* 129706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129716 */     // MIs[0] Rn
     /* 129716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129728 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129741 */     GIR_RootConstrainSelectedInstOperands,
     /* 129742 */     // GIR_Coverage, 7077,
     /* 129742 */     GIR_EraseRootFromParent_Done,
     /* 129743 */   // Label 2493: @129743
     /* 129743 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(129785), // Rule ID 7078 //
     /* 129748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129758 */     // MIs[0] Rn
     /* 129758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129770 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129783 */     GIR_RootConstrainSelectedInstOperands,
     /* 129784 */     // GIR_Coverage, 7078,
     /* 129784 */     GIR_EraseRootFromParent_Done,
     /* 129785 */   // Label 2494: @129785
     /* 129785 */   GIM_Reject,
     /* 129786 */ // Label 2489: @129786
     /* 129786 */ GIM_Reject,
     /* 129787 */ // Label 2472: @129787
     /* 129787 */ GIM_Reject,
     /* 129788 */ // Label 27: @129788
     /* 129788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2497*/ GIMT_Encode4(130779),
     /* 129799 */ /*GILLT_s32*//*Label 2495*/ GIMT_Encode4(129807),
     /* 129803 */ /*GILLT_s64*//*Label 2496*/ GIMT_Encode4(130552),
     /* 129807 */ // Label 2495: @129807
     /* 129807 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(130551),
     /* 129812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129815 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(129864), // Rule ID 7119 //
     /* 129820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129837 */     // MIs[0] Rn
     /* 129837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129849 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 129852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129862 */     GIR_RootConstrainSelectedInstOperands,
     /* 129863 */     // GIR_Coverage, 7119,
     /* 129863 */     GIR_EraseRootFromParent_Done,
     /* 129864 */   // Label 2499: @129864
     /* 129864 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(129913), // Rule ID 7120 //
     /* 129869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129886 */     // MIs[0] Rn
     /* 129886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129898 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 129901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129911 */     GIR_RootConstrainSelectedInstOperands,
     /* 129912 */     // GIR_Coverage, 7120,
     /* 129912 */     GIR_EraseRootFromParent_Done,
     /* 129913 */   // Label 2500: @129913
     /* 129913 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(129962), // Rule ID 7121 //
     /* 129918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129935 */     // MIs[0] Rn
     /* 129935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129947 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 129950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129960 */     GIR_RootConstrainSelectedInstOperands,
     /* 129961 */     // GIR_Coverage, 7121,
     /* 129961 */     GIR_EraseRootFromParent_Done,
     /* 129962 */   // Label 2501: @129962
     /* 129962 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(130011), // Rule ID 7122 //
     /* 129967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129984 */     // MIs[0] Rn
     /* 129984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129996 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130009 */     GIR_RootConstrainSelectedInstOperands,
     /* 130010 */     // GIR_Coverage, 7122,
     /* 130010 */     GIR_EraseRootFromParent_Done,
     /* 130011 */   // Label 2502: @130011
     /* 130011 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(130060), // Rule ID 7123 //
     /* 130016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130033 */     // MIs[0] Rn
     /* 130033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130045 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 130048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130058 */     GIR_RootConstrainSelectedInstOperands,
     /* 130059 */     // GIR_Coverage, 7123,
     /* 130059 */     GIR_EraseRootFromParent_Done,
     /* 130060 */   // Label 2503: @130060
     /* 130060 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(130109), // Rule ID 7124 //
     /* 130065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130082 */     // MIs[0] Rn
     /* 130082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130094 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 130097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130107 */     GIR_RootConstrainSelectedInstOperands,
     /* 130108 */     // GIR_Coverage, 7124,
     /* 130108 */     GIR_EraseRootFromParent_Done,
     /* 130109 */   // Label 2504: @130109
     /* 130109 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(130158), // Rule ID 7125 //
     /* 130114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130131 */     // MIs[0] Rn
     /* 130131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130143 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 130146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130156 */     GIR_RootConstrainSelectedInstOperands,
     /* 130157 */     // GIR_Coverage, 7125,
     /* 130157 */     GIR_EraseRootFromParent_Done,
     /* 130158 */   // Label 2505: @130158
     /* 130158 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(130207), // Rule ID 7126 //
     /* 130163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130180 */     // MIs[0] Rn
     /* 130180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130192 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 130195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130205 */     GIR_RootConstrainSelectedInstOperands,
     /* 130206 */     // GIR_Coverage, 7126,
     /* 130206 */     GIR_EraseRootFromParent_Done,
     /* 130207 */   // Label 2506: @130207
     /* 130207 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(130256), // Rule ID 7127 //
     /* 130212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130229 */     // MIs[0] Rn
     /* 130229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130241 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 130244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130254 */     GIR_RootConstrainSelectedInstOperands,
     /* 130255 */     // GIR_Coverage, 7127,
     /* 130255 */     GIR_EraseRootFromParent_Done,
     /* 130256 */   // Label 2507: @130256
     /* 130256 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(130305), // Rule ID 7128 //
     /* 130261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130278 */     // MIs[0] Rn
     /* 130278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130290 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 130293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130303 */     GIR_RootConstrainSelectedInstOperands,
     /* 130304 */     // GIR_Coverage, 7128,
     /* 130304 */     GIR_EraseRootFromParent_Done,
     /* 130305 */   // Label 2508: @130305
     /* 130305 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(130354), // Rule ID 7129 //
     /* 130310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130327 */     // MIs[0] Rn
     /* 130327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130339 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 130342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130352 */     GIR_RootConstrainSelectedInstOperands,
     /* 130353 */     // GIR_Coverage, 7129,
     /* 130353 */     GIR_EraseRootFromParent_Done,
     /* 130354 */   // Label 2509: @130354
     /* 130354 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(130403), // Rule ID 7130 //
     /* 130359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130376 */     // MIs[0] Rn
     /* 130376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130388 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 130391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130401 */     GIR_RootConstrainSelectedInstOperands,
     /* 130402 */     // GIR_Coverage, 7130,
     /* 130402 */     GIR_EraseRootFromParent_Done,
     /* 130403 */   // Label 2510: @130403
     /* 130403 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(130452), // Rule ID 7131 //
     /* 130408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130425 */     // MIs[0] Rn
     /* 130425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130437 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 130440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130450 */     GIR_RootConstrainSelectedInstOperands,
     /* 130451 */     // GIR_Coverage, 7131,
     /* 130451 */     GIR_EraseRootFromParent_Done,
     /* 130452 */   // Label 2511: @130452
     /* 130452 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(130501), // Rule ID 7132 //
     /* 130457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130474 */     // MIs[0] Rn
     /* 130474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130486 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130499 */     GIR_RootConstrainSelectedInstOperands,
     /* 130500 */     // GIR_Coverage, 7132,
     /* 130500 */     GIR_EraseRootFromParent_Done,
     /* 130501 */   // Label 2512: @130501
     /* 130501 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(130550), // Rule ID 7133 //
     /* 130506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130523 */     // MIs[0] Rn
     /* 130523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130535 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130548 */     GIR_RootConstrainSelectedInstOperands,
     /* 130549 */     // GIR_Coverage, 7133,
     /* 130549 */     GIR_EraseRootFromParent_Done,
     /* 130550 */   // Label 2513: @130550
     /* 130550 */   GIM_Reject,
     /* 130551 */ // Label 2498: @130551
     /* 130551 */ GIM_Reject,
     /* 130552 */ // Label 2496: @130552
     /* 130552 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(130778),
     /* 130557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130560 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130567 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(130609), // Rule ID 7114 //
     /* 130572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130582 */     // MIs[0] Rn
     /* 130582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130594 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 130597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130607 */     GIR_RootConstrainSelectedInstOperands,
     /* 130608 */     // GIR_Coverage, 7114,
     /* 130608 */     GIR_EraseRootFromParent_Done,
     /* 130609 */   // Label 2515: @130609
     /* 130609 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(130651), // Rule ID 7115 //
     /* 130614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130624 */     // MIs[0] Rn
     /* 130624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130636 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 130639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130649 */     GIR_RootConstrainSelectedInstOperands,
     /* 130650 */     // GIR_Coverage, 7115,
     /* 130650 */     GIR_EraseRootFromParent_Done,
     /* 130651 */   // Label 2516: @130651
     /* 130651 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(130693), // Rule ID 7116 //
     /* 130656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130666 */     // MIs[0] Rn
     /* 130666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130678 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 130681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130691 */     GIR_RootConstrainSelectedInstOperands,
     /* 130692 */     // GIR_Coverage, 7116,
     /* 130692 */     GIR_EraseRootFromParent_Done,
     /* 130693 */   // Label 2517: @130693
     /* 130693 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(130735), // Rule ID 7117 //
     /* 130698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130708 */     // MIs[0] Rn
     /* 130708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130720 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130733 */     GIR_RootConstrainSelectedInstOperands,
     /* 130734 */     // GIR_Coverage, 7117,
     /* 130734 */     GIR_EraseRootFromParent_Done,
     /* 130735 */   // Label 2518: @130735
     /* 130735 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(130777), // Rule ID 7118 //
     /* 130740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130750 */     // MIs[0] Rn
     /* 130750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130762 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130775 */     GIR_RootConstrainSelectedInstOperands,
     /* 130776 */     // GIR_Coverage, 7118,
     /* 130776 */     GIR_EraseRootFromParent_Done,
     /* 130777 */   // Label 2519: @130777
     /* 130777 */   GIM_Reject,
     /* 130778 */ // Label 2514: @130778
     /* 130778 */ GIM_Reject,
     /* 130779 */ // Label 2497: @130779
     /* 130779 */ GIM_Reject,
     /* 130780 */ // Label 28: @130780
     /* 130780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2522*/ GIMT_Encode4(131771),
     /* 130791 */ /*GILLT_s32*//*Label 2520*/ GIMT_Encode4(130799),
     /* 130795 */ /*GILLT_s64*//*Label 2521*/ GIMT_Encode4(131544),
     /* 130799 */ // Label 2520: @130799
     /* 130799 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(131543),
     /* 130804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130807 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(130856), // Rule ID 7139 //
     /* 130812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130829 */     // MIs[0] Rn
     /* 130829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130841 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 130844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130854 */     GIR_RootConstrainSelectedInstOperands,
     /* 130855 */     // GIR_Coverage, 7139,
     /* 130855 */     GIR_EraseRootFromParent_Done,
     /* 130856 */   // Label 2524: @130856
     /* 130856 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(130905), // Rule ID 7140 //
     /* 130861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130878 */     // MIs[0] Rn
     /* 130878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130890 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 130893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130903 */     GIR_RootConstrainSelectedInstOperands,
     /* 130904 */     // GIR_Coverage, 7140,
     /* 130904 */     GIR_EraseRootFromParent_Done,
     /* 130905 */   // Label 2525: @130905
     /* 130905 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(130954), // Rule ID 7141 //
     /* 130910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130927 */     // MIs[0] Rn
     /* 130927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130939 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 130942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130952 */     GIR_RootConstrainSelectedInstOperands,
     /* 130953 */     // GIR_Coverage, 7141,
     /* 130953 */     GIR_EraseRootFromParent_Done,
     /* 130954 */   // Label 2526: @130954
     /* 130954 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(131003), // Rule ID 7142 //
     /* 130959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130976 */     // MIs[0] Rn
     /* 130976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130988 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131001 */     GIR_RootConstrainSelectedInstOperands,
     /* 131002 */     // GIR_Coverage, 7142,
     /* 131002 */     GIR_EraseRootFromParent_Done,
     /* 131003 */   // Label 2527: @131003
     /* 131003 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(131052), // Rule ID 7143 //
     /* 131008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131025 */     // MIs[0] Rn
     /* 131025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131037 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 131040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131050 */     GIR_RootConstrainSelectedInstOperands,
     /* 131051 */     // GIR_Coverage, 7143,
     /* 131051 */     GIR_EraseRootFromParent_Done,
     /* 131052 */   // Label 2528: @131052
     /* 131052 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(131101), // Rule ID 7144 //
     /* 131057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131074 */     // MIs[0] Rn
     /* 131074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131086 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 131089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131099 */     GIR_RootConstrainSelectedInstOperands,
     /* 131100 */     // GIR_Coverage, 7144,
     /* 131100 */     GIR_EraseRootFromParent_Done,
     /* 131101 */   // Label 2529: @131101
     /* 131101 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(131150), // Rule ID 7145 //
     /* 131106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131123 */     // MIs[0] Rn
     /* 131123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131135 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 131138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131148 */     GIR_RootConstrainSelectedInstOperands,
     /* 131149 */     // GIR_Coverage, 7145,
     /* 131149 */     GIR_EraseRootFromParent_Done,
     /* 131150 */   // Label 2530: @131150
     /* 131150 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(131199), // Rule ID 7146 //
     /* 131155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131172 */     // MIs[0] Rn
     /* 131172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131184 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 131187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131197 */     GIR_RootConstrainSelectedInstOperands,
     /* 131198 */     // GIR_Coverage, 7146,
     /* 131198 */     GIR_EraseRootFromParent_Done,
     /* 131199 */   // Label 2531: @131199
     /* 131199 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(131248), // Rule ID 7147 //
     /* 131204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131221 */     // MIs[0] Rn
     /* 131221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131233 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 131236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131246 */     GIR_RootConstrainSelectedInstOperands,
     /* 131247 */     // GIR_Coverage, 7147,
     /* 131247 */     GIR_EraseRootFromParent_Done,
     /* 131248 */   // Label 2532: @131248
     /* 131248 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(131297), // Rule ID 7148 //
     /* 131253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131270 */     // MIs[0] Rn
     /* 131270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131282 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 131285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131295 */     GIR_RootConstrainSelectedInstOperands,
     /* 131296 */     // GIR_Coverage, 7148,
     /* 131296 */     GIR_EraseRootFromParent_Done,
     /* 131297 */   // Label 2533: @131297
     /* 131297 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(131346), // Rule ID 7149 //
     /* 131302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131319 */     // MIs[0] Rn
     /* 131319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131331 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 131334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131344 */     GIR_RootConstrainSelectedInstOperands,
     /* 131345 */     // GIR_Coverage, 7149,
     /* 131345 */     GIR_EraseRootFromParent_Done,
     /* 131346 */   // Label 2534: @131346
     /* 131346 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(131395), // Rule ID 7150 //
     /* 131351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131368 */     // MIs[0] Rn
     /* 131368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131380 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 131383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131393 */     GIR_RootConstrainSelectedInstOperands,
     /* 131394 */     // GIR_Coverage, 7150,
     /* 131394 */     GIR_EraseRootFromParent_Done,
     /* 131395 */   // Label 2535: @131395
     /* 131395 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(131444), // Rule ID 7151 //
     /* 131400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131417 */     // MIs[0] Rn
     /* 131417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131429 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 131432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131442 */     GIR_RootConstrainSelectedInstOperands,
     /* 131443 */     // GIR_Coverage, 7151,
     /* 131443 */     GIR_EraseRootFromParent_Done,
     /* 131444 */   // Label 2536: @131444
     /* 131444 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(131493), // Rule ID 7152 //
     /* 131449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131466 */     // MIs[0] Rn
     /* 131466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131478 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131491 */     GIR_RootConstrainSelectedInstOperands,
     /* 131492 */     // GIR_Coverage, 7152,
     /* 131492 */     GIR_EraseRootFromParent_Done,
     /* 131493 */   // Label 2537: @131493
     /* 131493 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(131542), // Rule ID 7153 //
     /* 131498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131515 */     // MIs[0] Rn
     /* 131515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131527 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131540 */     GIR_RootConstrainSelectedInstOperands,
     /* 131541 */     // GIR_Coverage, 7153,
     /* 131541 */     GIR_EraseRootFromParent_Done,
     /* 131542 */   // Label 2538: @131542
     /* 131542 */   GIM_Reject,
     /* 131543 */ // Label 2523: @131543
     /* 131543 */ GIM_Reject,
     /* 131544 */ // Label 2521: @131544
     /* 131544 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(131770),
     /* 131549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131552 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131559 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(131601), // Rule ID 7134 //
     /* 131564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131574 */     // MIs[0] Rn
     /* 131574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131586 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 131589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131599 */     GIR_RootConstrainSelectedInstOperands,
     /* 131600 */     // GIR_Coverage, 7134,
     /* 131600 */     GIR_EraseRootFromParent_Done,
     /* 131601 */   // Label 2540: @131601
     /* 131601 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(131643), // Rule ID 7135 //
     /* 131606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131616 */     // MIs[0] Rn
     /* 131616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131628 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 131631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131641 */     GIR_RootConstrainSelectedInstOperands,
     /* 131642 */     // GIR_Coverage, 7135,
     /* 131642 */     GIR_EraseRootFromParent_Done,
     /* 131643 */   // Label 2541: @131643
     /* 131643 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(131685), // Rule ID 7136 //
     /* 131648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131658 */     // MIs[0] Rn
     /* 131658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131670 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 131673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131683 */     GIR_RootConstrainSelectedInstOperands,
     /* 131684 */     // GIR_Coverage, 7136,
     /* 131684 */     GIR_EraseRootFromParent_Done,
     /* 131685 */   // Label 2542: @131685
     /* 131685 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(131727), // Rule ID 7137 //
     /* 131690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131700 */     // MIs[0] Rn
     /* 131700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131712 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131725 */     GIR_RootConstrainSelectedInstOperands,
     /* 131726 */     // GIR_Coverage, 7137,
     /* 131726 */     GIR_EraseRootFromParent_Done,
     /* 131727 */   // Label 2543: @131727
     /* 131727 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(131769), // Rule ID 7138 //
     /* 131732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131742 */     // MIs[0] Rn
     /* 131742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131754 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131767 */     GIR_RootConstrainSelectedInstOperands,
     /* 131768 */     // GIR_Coverage, 7138,
     /* 131768 */     GIR_EraseRootFromParent_Done,
     /* 131769 */   // Label 2544: @131769
     /* 131769 */   GIM_Reject,
     /* 131770 */ // Label 2539: @131770
     /* 131770 */ GIM_Reject,
     /* 131771 */ // Label 2522: @131771
     /* 131771 */ GIM_Reject,
     /* 131772 */ // Label 29: @131772
     /* 131772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2547*/ GIMT_Encode4(132763),
     /* 131783 */ /*GILLT_s32*//*Label 2545*/ GIMT_Encode4(131791),
     /* 131787 */ /*GILLT_s64*//*Label 2546*/ GIMT_Encode4(132536),
     /* 131791 */ // Label 2545: @131791
     /* 131791 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(132535),
     /* 131796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131799 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(131848), // Rule ID 7159 //
     /* 131804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131821 */     // MIs[0] Rn
     /* 131821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131833 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 131836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131846 */     GIR_RootConstrainSelectedInstOperands,
     /* 131847 */     // GIR_Coverage, 7159,
     /* 131847 */     GIR_EraseRootFromParent_Done,
     /* 131848 */   // Label 2549: @131848
     /* 131848 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(131897), // Rule ID 7160 //
     /* 131853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131870 */     // MIs[0] Rn
     /* 131870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131882 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 131885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131895 */     GIR_RootConstrainSelectedInstOperands,
     /* 131896 */     // GIR_Coverage, 7160,
     /* 131896 */     GIR_EraseRootFromParent_Done,
     /* 131897 */   // Label 2550: @131897
     /* 131897 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(131946), // Rule ID 7161 //
     /* 131902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131919 */     // MIs[0] Rn
     /* 131919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131931 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 131934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131944 */     GIR_RootConstrainSelectedInstOperands,
     /* 131945 */     // GIR_Coverage, 7161,
     /* 131945 */     GIR_EraseRootFromParent_Done,
     /* 131946 */   // Label 2551: @131946
     /* 131946 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(131995), // Rule ID 7162 //
     /* 131951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131968 */     // MIs[0] Rn
     /* 131968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131980 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131993 */     GIR_RootConstrainSelectedInstOperands,
     /* 131994 */     // GIR_Coverage, 7162,
     /* 131994 */     GIR_EraseRootFromParent_Done,
     /* 131995 */   // Label 2552: @131995
     /* 131995 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(132044), // Rule ID 7163 //
     /* 132000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132017 */     // MIs[0] Rn
     /* 132017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132029 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 132032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132042 */     GIR_RootConstrainSelectedInstOperands,
     /* 132043 */     // GIR_Coverage, 7163,
     /* 132043 */     GIR_EraseRootFromParent_Done,
     /* 132044 */   // Label 2553: @132044
     /* 132044 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(132093), // Rule ID 7164 //
     /* 132049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132066 */     // MIs[0] Rn
     /* 132066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132078 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 132081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132091 */     GIR_RootConstrainSelectedInstOperands,
     /* 132092 */     // GIR_Coverage, 7164,
     /* 132092 */     GIR_EraseRootFromParent_Done,
     /* 132093 */   // Label 2554: @132093
     /* 132093 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(132142), // Rule ID 7165 //
     /* 132098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132115 */     // MIs[0] Rn
     /* 132115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132127 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 132130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132140 */     GIR_RootConstrainSelectedInstOperands,
     /* 132141 */     // GIR_Coverage, 7165,
     /* 132141 */     GIR_EraseRootFromParent_Done,
     /* 132142 */   // Label 2555: @132142
     /* 132142 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(132191), // Rule ID 7166 //
     /* 132147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132164 */     // MIs[0] Rn
     /* 132164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132176 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 132179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132189 */     GIR_RootConstrainSelectedInstOperands,
     /* 132190 */     // GIR_Coverage, 7166,
     /* 132190 */     GIR_EraseRootFromParent_Done,
     /* 132191 */   // Label 2556: @132191
     /* 132191 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(132240), // Rule ID 7167 //
     /* 132196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132213 */     // MIs[0] Rn
     /* 132213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132225 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 132228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132238 */     GIR_RootConstrainSelectedInstOperands,
     /* 132239 */     // GIR_Coverage, 7167,
     /* 132239 */     GIR_EraseRootFromParent_Done,
     /* 132240 */   // Label 2557: @132240
     /* 132240 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(132289), // Rule ID 7168 //
     /* 132245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132262 */     // MIs[0] Rn
     /* 132262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132274 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 132277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132287 */     GIR_RootConstrainSelectedInstOperands,
     /* 132288 */     // GIR_Coverage, 7168,
     /* 132288 */     GIR_EraseRootFromParent_Done,
     /* 132289 */   // Label 2558: @132289
     /* 132289 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(132338), // Rule ID 7169 //
     /* 132294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132311 */     // MIs[0] Rn
     /* 132311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132323 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 132326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132336 */     GIR_RootConstrainSelectedInstOperands,
     /* 132337 */     // GIR_Coverage, 7169,
     /* 132337 */     GIR_EraseRootFromParent_Done,
     /* 132338 */   // Label 2559: @132338
     /* 132338 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(132387), // Rule ID 7170 //
     /* 132343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132360 */     // MIs[0] Rn
     /* 132360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132372 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 132375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132385 */     GIR_RootConstrainSelectedInstOperands,
     /* 132386 */     // GIR_Coverage, 7170,
     /* 132386 */     GIR_EraseRootFromParent_Done,
     /* 132387 */   // Label 2560: @132387
     /* 132387 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(132436), // Rule ID 7171 //
     /* 132392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132409 */     // MIs[0] Rn
     /* 132409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132421 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 132424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132434 */     GIR_RootConstrainSelectedInstOperands,
     /* 132435 */     // GIR_Coverage, 7171,
     /* 132435 */     GIR_EraseRootFromParent_Done,
     /* 132436 */   // Label 2561: @132436
     /* 132436 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(132485), // Rule ID 7172 //
     /* 132441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132458 */     // MIs[0] Rn
     /* 132458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132470 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132483 */     GIR_RootConstrainSelectedInstOperands,
     /* 132484 */     // GIR_Coverage, 7172,
     /* 132484 */     GIR_EraseRootFromParent_Done,
     /* 132485 */   // Label 2562: @132485
     /* 132485 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(132534), // Rule ID 7173 //
     /* 132490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132507 */     // MIs[0] Rn
     /* 132507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132519 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132532 */     GIR_RootConstrainSelectedInstOperands,
     /* 132533 */     // GIR_Coverage, 7173,
     /* 132533 */     GIR_EraseRootFromParent_Done,
     /* 132534 */   // Label 2563: @132534
     /* 132534 */   GIM_Reject,
     /* 132535 */ // Label 2548: @132535
     /* 132535 */ GIM_Reject,
     /* 132536 */ // Label 2546: @132536
     /* 132536 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(132762),
     /* 132541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132551 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(132593), // Rule ID 7154 //
     /* 132556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132566 */     // MIs[0] Rn
     /* 132566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132578 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 132581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132591 */     GIR_RootConstrainSelectedInstOperands,
     /* 132592 */     // GIR_Coverage, 7154,
     /* 132592 */     GIR_EraseRootFromParent_Done,
     /* 132593 */   // Label 2565: @132593
     /* 132593 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(132635), // Rule ID 7155 //
     /* 132598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132608 */     // MIs[0] Rn
     /* 132608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132620 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 132623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132633 */     GIR_RootConstrainSelectedInstOperands,
     /* 132634 */     // GIR_Coverage, 7155,
     /* 132634 */     GIR_EraseRootFromParent_Done,
     /* 132635 */   // Label 2566: @132635
     /* 132635 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(132677), // Rule ID 7156 //
     /* 132640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132650 */     // MIs[0] Rn
     /* 132650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132662 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 132665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132675 */     GIR_RootConstrainSelectedInstOperands,
     /* 132676 */     // GIR_Coverage, 7156,
     /* 132676 */     GIR_EraseRootFromParent_Done,
     /* 132677 */   // Label 2567: @132677
     /* 132677 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(132719), // Rule ID 7157 //
     /* 132682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132692 */     // MIs[0] Rn
     /* 132692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132704 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132717 */     GIR_RootConstrainSelectedInstOperands,
     /* 132718 */     // GIR_Coverage, 7157,
     /* 132718 */     GIR_EraseRootFromParent_Done,
     /* 132719 */   // Label 2568: @132719
     /* 132719 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(132761), // Rule ID 7158 //
     /* 132724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132734 */     // MIs[0] Rn
     /* 132734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132746 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132759 */     GIR_RootConstrainSelectedInstOperands,
     /* 132760 */     // GIR_Coverage, 7158,
     /* 132760 */     GIR_EraseRootFromParent_Done,
     /* 132761 */   // Label 2569: @132761
     /* 132761 */   GIM_Reject,
     /* 132762 */ // Label 2564: @132762
     /* 132762 */ GIM_Reject,
     /* 132763 */ // Label 2547: @132763
     /* 132763 */ GIM_Reject,
     /* 132764 */ // Label 30: @132764
     /* 132764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2572*/ GIMT_Encode4(133755),
     /* 132775 */ /*GILLT_s32*//*Label 2570*/ GIMT_Encode4(132783),
     /* 132779 */ /*GILLT_s64*//*Label 2571*/ GIMT_Encode4(133528),
     /* 132783 */ // Label 2570: @132783
     /* 132783 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(133527),
     /* 132788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132791 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(132840), // Rule ID 7179 //
     /* 132796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132813 */     // MIs[0] Rn
     /* 132813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132825 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 132828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132838 */     GIR_RootConstrainSelectedInstOperands,
     /* 132839 */     // GIR_Coverage, 7179,
     /* 132839 */     GIR_EraseRootFromParent_Done,
     /* 132840 */   // Label 2574: @132840
     /* 132840 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(132889), // Rule ID 7180 //
     /* 132845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132862 */     // MIs[0] Rn
     /* 132862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132874 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 132877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132887 */     GIR_RootConstrainSelectedInstOperands,
     /* 132888 */     // GIR_Coverage, 7180,
     /* 132888 */     GIR_EraseRootFromParent_Done,
     /* 132889 */   // Label 2575: @132889
     /* 132889 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(132938), // Rule ID 7181 //
     /* 132894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132911 */     // MIs[0] Rn
     /* 132911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132923 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 132926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132936 */     GIR_RootConstrainSelectedInstOperands,
     /* 132937 */     // GIR_Coverage, 7181,
     /* 132937 */     GIR_EraseRootFromParent_Done,
     /* 132938 */   // Label 2576: @132938
     /* 132938 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(132987), // Rule ID 7182 //
     /* 132943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132960 */     // MIs[0] Rn
     /* 132960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132972 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132985 */     GIR_RootConstrainSelectedInstOperands,
     /* 132986 */     // GIR_Coverage, 7182,
     /* 132986 */     GIR_EraseRootFromParent_Done,
     /* 132987 */   // Label 2577: @132987
     /* 132987 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(133036), // Rule ID 7183 //
     /* 132992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133009 */     // MIs[0] Rn
     /* 133009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133021 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 133024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133034 */     GIR_RootConstrainSelectedInstOperands,
     /* 133035 */     // GIR_Coverage, 7183,
     /* 133035 */     GIR_EraseRootFromParent_Done,
     /* 133036 */   // Label 2578: @133036
     /* 133036 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(133085), // Rule ID 7184 //
     /* 133041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133058 */     // MIs[0] Rn
     /* 133058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133070 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 133073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133083 */     GIR_RootConstrainSelectedInstOperands,
     /* 133084 */     // GIR_Coverage, 7184,
     /* 133084 */     GIR_EraseRootFromParent_Done,
     /* 133085 */   // Label 2579: @133085
     /* 133085 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(133134), // Rule ID 7185 //
     /* 133090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133107 */     // MIs[0] Rn
     /* 133107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133119 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 133122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133132 */     GIR_RootConstrainSelectedInstOperands,
     /* 133133 */     // GIR_Coverage, 7185,
     /* 133133 */     GIR_EraseRootFromParent_Done,
     /* 133134 */   // Label 2580: @133134
     /* 133134 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(133183), // Rule ID 7186 //
     /* 133139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133156 */     // MIs[0] Rn
     /* 133156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133168 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 133171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133181 */     GIR_RootConstrainSelectedInstOperands,
     /* 133182 */     // GIR_Coverage, 7186,
     /* 133182 */     GIR_EraseRootFromParent_Done,
     /* 133183 */   // Label 2581: @133183
     /* 133183 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(133232), // Rule ID 7187 //
     /* 133188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133205 */     // MIs[0] Rn
     /* 133205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133217 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 133220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133230 */     GIR_RootConstrainSelectedInstOperands,
     /* 133231 */     // GIR_Coverage, 7187,
     /* 133231 */     GIR_EraseRootFromParent_Done,
     /* 133232 */   // Label 2582: @133232
     /* 133232 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(133281), // Rule ID 7188 //
     /* 133237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133254 */     // MIs[0] Rn
     /* 133254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133266 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 133269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133279 */     GIR_RootConstrainSelectedInstOperands,
     /* 133280 */     // GIR_Coverage, 7188,
     /* 133280 */     GIR_EraseRootFromParent_Done,
     /* 133281 */   // Label 2583: @133281
     /* 133281 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(133330), // Rule ID 7189 //
     /* 133286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133303 */     // MIs[0] Rn
     /* 133303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133315 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133328 */     GIR_RootConstrainSelectedInstOperands,
     /* 133329 */     // GIR_Coverage, 7189,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 2584: @133330
     /* 133330 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(133379), // Rule ID 7190 //
     /* 133335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133352 */     // MIs[0] Rn
     /* 133352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133364 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 133367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133377 */     GIR_RootConstrainSelectedInstOperands,
     /* 133378 */     // GIR_Coverage, 7190,
     /* 133378 */     GIR_EraseRootFromParent_Done,
     /* 133379 */   // Label 2585: @133379
     /* 133379 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(133428), // Rule ID 7191 //
     /* 133384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133401 */     // MIs[0] Rn
     /* 133401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133413 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 133416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133426 */     GIR_RootConstrainSelectedInstOperands,
     /* 133427 */     // GIR_Coverage, 7191,
     /* 133427 */     GIR_EraseRootFromParent_Done,
     /* 133428 */   // Label 2586: @133428
     /* 133428 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(133477), // Rule ID 7192 //
     /* 133433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133450 */     // MIs[0] Rn
     /* 133450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133462 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133475 */     GIR_RootConstrainSelectedInstOperands,
     /* 133476 */     // GIR_Coverage, 7192,
     /* 133476 */     GIR_EraseRootFromParent_Done,
     /* 133477 */   // Label 2587: @133477
     /* 133477 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(133526), // Rule ID 7193 //
     /* 133482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133499 */     // MIs[0] Rn
     /* 133499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133511 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133524 */     GIR_RootConstrainSelectedInstOperands,
     /* 133525 */     // GIR_Coverage, 7193,
     /* 133525 */     GIR_EraseRootFromParent_Done,
     /* 133526 */   // Label 2588: @133526
     /* 133526 */   GIM_Reject,
     /* 133527 */ // Label 2573: @133527
     /* 133527 */ GIM_Reject,
     /* 133528 */ // Label 2571: @133528
     /* 133528 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(133754),
     /* 133533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133543 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(133585), // Rule ID 7174 //
     /* 133548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133558 */     // MIs[0] Rn
     /* 133558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133570 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 133573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133583 */     GIR_RootConstrainSelectedInstOperands,
     /* 133584 */     // GIR_Coverage, 7174,
     /* 133584 */     GIR_EraseRootFromParent_Done,
     /* 133585 */   // Label 2590: @133585
     /* 133585 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(133627), // Rule ID 7175 //
     /* 133590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133600 */     // MIs[0] Rn
     /* 133600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133612 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 133615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133625 */     GIR_RootConstrainSelectedInstOperands,
     /* 133626 */     // GIR_Coverage, 7175,
     /* 133626 */     GIR_EraseRootFromParent_Done,
     /* 133627 */   // Label 2591: @133627
     /* 133627 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(133669), // Rule ID 7176 //
     /* 133632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133642 */     // MIs[0] Rn
     /* 133642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133654 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 133657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133667 */     GIR_RootConstrainSelectedInstOperands,
     /* 133668 */     // GIR_Coverage, 7176,
     /* 133668 */     GIR_EraseRootFromParent_Done,
     /* 133669 */   // Label 2592: @133669
     /* 133669 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(133711), // Rule ID 7177 //
     /* 133674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133684 */     // MIs[0] Rn
     /* 133684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133696 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133709 */     GIR_RootConstrainSelectedInstOperands,
     /* 133710 */     // GIR_Coverage, 7177,
     /* 133710 */     GIR_EraseRootFromParent_Done,
     /* 133711 */   // Label 2593: @133711
     /* 133711 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(133753), // Rule ID 7178 //
     /* 133716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133726 */     // MIs[0] Rn
     /* 133726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133738 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133751 */     GIR_RootConstrainSelectedInstOperands,
     /* 133752 */     // GIR_Coverage, 7178,
     /* 133752 */     GIR_EraseRootFromParent_Done,
     /* 133753 */   // Label 2594: @133753
     /* 133753 */   GIM_Reject,
     /* 133754 */ // Label 2589: @133754
     /* 133754 */ GIM_Reject,
     /* 133755 */ // Label 2572: @133755
     /* 133755 */ GIM_Reject,
     /* 133756 */ // Label 31: @133756
     /* 133756 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(133783), // Rule ID 6926 //
     /* 133761 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133764 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 133768 */   // MIs[0] Operand 1
     /* 133768 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133771 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 133771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 133777 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133781 */   GIR_RootConstrainSelectedInstOperands,
     /* 133782 */   // GIR_Coverage, 6926,
     /* 133782 */   GIR_EraseRootFromParent_Done,
     /* 133783 */ // Label 2595: @133783
     /* 133783 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(133806), // Rule ID 6927 //
     /* 133788 */   // MIs[0] Operand 0
     /* 133788 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 133791 */   // MIs[0] Operand 1
     /* 133791 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133794 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 133794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 133800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133804 */   GIR_RootConstrainSelectedInstOperands,
     /* 133805 */   // GIR_Coverage, 6927,
     /* 133805 */   GIR_EraseRootFromParent_Done,
     /* 133806 */ // Label 2596: @133806
     /* 133806 */ GIM_Reject,
     /* 133807 */ // Label 32: @133807
     /* 133807 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(146334),
     /* 133812 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 133815 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(133906), // Rule ID 6405 //
     /* 133820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 133828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 133854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133874 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 133881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 133899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133904 */     GIR_RootConstrainSelectedInstOperands,
     /* 133905 */     // GIR_Coverage, 6405,
     /* 133905 */     GIR_EraseRootFromParent_Done,
     /* 133906 */   // Label 2598: @133906
     /* 133906 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(133997), // Rule ID 6406 //
     /* 133911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 133919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133937 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133940 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 133945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133949 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133965 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 133972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 133990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133995 */     GIR_RootConstrainSelectedInstOperands,
     /* 133996 */     // GIR_Coverage, 6406,
     /* 133996 */     GIR_EraseRootFromParent_Done,
     /* 133997 */   // Label 2599: @133997
     /* 133997 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(134058), // Rule ID 4838 //
     /* 134002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 134007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 134010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 134013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 134021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 134025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134034 */     // MIs[1] Operand 2
     /* 134034 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 134045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134047 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 134047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 134050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 134056 */     GIR_RootConstrainSelectedInstOperands,
     /* 134057 */     // GIR_Coverage, 4838,
     /* 134057 */     GIR_EraseRootFromParent_Done,
     /* 134058 */   // Label 2600: @134058
     /* 134058 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(134098), // Rule ID 2637 //
     /* 134063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 134066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 134071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134078 */     // MIs[0] pattern
     /* 134078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 134081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 134086 */     // (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 134086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 134089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134091 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 134093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 134096 */     GIR_RootConstrainSelectedInstOperands,
     /* 134097 */     // GIR_Coverage, 2637,
     /* 134097 */     GIR_EraseRootFromParent_Done,
     /* 134098 */   // Label 2601: @134098
     /* 134098 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(134138), // Rule ID 9771 //
     /* 134103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 134106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 134111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134118 */     // MIs[0] pattern
     /* 134118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 134121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 134126 */     // (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 134126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 134129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134131 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 134133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 134136 */     GIR_RootConstrainSelectedInstOperands,
     /* 134137 */     // GIR_Coverage, 9771,
     /* 134137 */     GIR_EraseRootFromParent_Done,
     /* 134138 */   // Label 2602: @134138
     /* 134138 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(134178), // Rule ID 9774 //
     /* 134143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 134146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 134151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134158 */     // MIs[0] pattern
     /* 134158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 134161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 134166 */     // (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 134166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 134169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134171 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 134173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 134176 */     GIR_RootConstrainSelectedInstOperands,
     /* 134177 */     // GIR_Coverage, 9774,
     /* 134177 */     GIR_EraseRootFromParent_Done,
     /* 134178 */   // Label 2603: @134178
     /* 134178 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(134218), // Rule ID 9777 //
     /* 134183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 134186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 134191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134198 */     // MIs[0] pattern
     /* 134198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 134201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 134206 */     // (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 134206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 134209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134211 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 134213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 134216 */     GIR_RootConstrainSelectedInstOperands,
     /* 134217 */     // GIR_Coverage, 9777,
     /* 134217 */     GIR_EraseRootFromParent_Done,
     /* 134218 */   // Label 2604: @134218
     /* 134218 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(134257), // Rule ID 66 //
     /* 134223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 134226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 134231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134245 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 134248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 134255 */     GIR_RootConstrainSelectedInstOperands,
     /* 134256 */     // GIR_Coverage, 66,
     /* 134256 */     GIR_EraseRootFromParent_Done,
     /* 134257 */   // Label 2605: @134257
     /* 134257 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(134293), // Rule ID 346 //
     /* 134262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134284 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 134287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134291 */     GIR_RootConstrainSelectedInstOperands,
     /* 134292 */     // GIR_Coverage, 346,
     /* 134292 */     GIR_EraseRootFromParent_Done,
     /* 134293 */   // Label 2606: @134293
     /* 134293 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(134329), // Rule ID 347 //
     /* 134298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134320 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 134323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134327 */     GIR_RootConstrainSelectedInstOperands,
     /* 134328 */     // GIR_Coverage, 347,
     /* 134328 */     GIR_EraseRootFromParent_Done,
     /* 134329 */   // Label 2607: @134329
     /* 134329 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(134365), // Rule ID 348 //
     /* 134334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134356 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 134359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134363 */     GIR_RootConstrainSelectedInstOperands,
     /* 134364 */     // GIR_Coverage, 348,
     /* 134364 */     GIR_EraseRootFromParent_Done,
     /* 134365 */   // Label 2608: @134365
     /* 134365 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(134401), // Rule ID 349 //
     /* 134370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134392 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 134395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134399 */     GIR_RootConstrainSelectedInstOperands,
     /* 134400 */     // GIR_Coverage, 349,
     /* 134400 */     GIR_EraseRootFromParent_Done,
     /* 134401 */   // Label 2609: @134401
     /* 134401 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(134437), // Rule ID 350 //
     /* 134406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134428 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 134431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134435 */     GIR_RootConstrainSelectedInstOperands,
     /* 134436 */     // GIR_Coverage, 350,
     /* 134436 */     GIR_EraseRootFromParent_Done,
     /* 134437 */   // Label 2610: @134437
     /* 134437 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(134473), // Rule ID 351 //
     /* 134442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134464 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 134467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134471 */     GIR_RootConstrainSelectedInstOperands,
     /* 134472 */     // GIR_Coverage, 351,
     /* 134472 */     GIR_EraseRootFromParent_Done,
     /* 134473 */   // Label 2611: @134473
     /* 134473 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(134509), // Rule ID 352 //
     /* 134478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134500 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 134503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134507 */     GIR_RootConstrainSelectedInstOperands,
     /* 134508 */     // GIR_Coverage, 352,
     /* 134508 */     GIR_EraseRootFromParent_Done,
     /* 134509 */   // Label 2612: @134509
     /* 134509 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(134545), // Rule ID 353 //
     /* 134514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134536 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 134539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134543 */     GIR_RootConstrainSelectedInstOperands,
     /* 134544 */     // GIR_Coverage, 353,
     /* 134544 */     GIR_EraseRootFromParent_Done,
     /* 134545 */   // Label 2613: @134545
     /* 134545 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(134581), // Rule ID 354 //
     /* 134550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134572 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 134575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134579 */     GIR_RootConstrainSelectedInstOperands,
     /* 134580 */     // GIR_Coverage, 354,
     /* 134580 */     GIR_EraseRootFromParent_Done,
     /* 134581 */   // Label 2614: @134581
     /* 134581 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(134617), // Rule ID 355 //
     /* 134586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134608 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 134611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134615 */     GIR_RootConstrainSelectedInstOperands,
     /* 134616 */     // GIR_Coverage, 355,
     /* 134616 */     GIR_EraseRootFromParent_Done,
     /* 134617 */   // Label 2615: @134617
     /* 134617 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(134653), // Rule ID 356 //
     /* 134622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134644 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 134647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134651 */     GIR_RootConstrainSelectedInstOperands,
     /* 134652 */     // GIR_Coverage, 356,
     /* 134652 */     GIR_EraseRootFromParent_Done,
     /* 134653 */   // Label 2616: @134653
     /* 134653 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(134689), // Rule ID 357 //
     /* 134658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134680 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 134683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134687 */     GIR_RootConstrainSelectedInstOperands,
     /* 134688 */     // GIR_Coverage, 357,
     /* 134688 */     GIR_EraseRootFromParent_Done,
     /* 134689 */   // Label 2617: @134689
     /* 134689 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(134725), // Rule ID 358 //
     /* 134694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134716 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 134719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134723 */     GIR_RootConstrainSelectedInstOperands,
     /* 134724 */     // GIR_Coverage, 358,
     /* 134724 */     GIR_EraseRootFromParent_Done,
     /* 134725 */   // Label 2618: @134725
     /* 134725 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(134761), // Rule ID 359 //
     /* 134730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134752 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 134755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134759 */     GIR_RootConstrainSelectedInstOperands,
     /* 134760 */     // GIR_Coverage, 359,
     /* 134760 */     GIR_EraseRootFromParent_Done,
     /* 134761 */   // Label 2619: @134761
     /* 134761 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(134797), // Rule ID 360 //
     /* 134766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134788 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 134791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134795 */     GIR_RootConstrainSelectedInstOperands,
     /* 134796 */     // GIR_Coverage, 360,
     /* 134796 */     GIR_EraseRootFromParent_Done,
     /* 134797 */   // Label 2620: @134797
     /* 134797 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(134833), // Rule ID 361 //
     /* 134802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134824 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 134827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134831 */     GIR_RootConstrainSelectedInstOperands,
     /* 134832 */     // GIR_Coverage, 361,
     /* 134832 */     GIR_EraseRootFromParent_Done,
     /* 134833 */   // Label 2621: @134833
     /* 134833 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(134869), // Rule ID 362 //
     /* 134838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134860 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 134863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134867 */     GIR_RootConstrainSelectedInstOperands,
     /* 134868 */     // GIR_Coverage, 362,
     /* 134868 */     GIR_EraseRootFromParent_Done,
     /* 134869 */   // Label 2622: @134869
     /* 134869 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(134905), // Rule ID 363 //
     /* 134874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134896 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 134899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134903 */     GIR_RootConstrainSelectedInstOperands,
     /* 134904 */     // GIR_Coverage, 363,
     /* 134904 */     GIR_EraseRootFromParent_Done,
     /* 134905 */   // Label 2623: @134905
     /* 134905 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(134941), // Rule ID 364 //
     /* 134910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134932 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 134935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134939 */     GIR_RootConstrainSelectedInstOperands,
     /* 134940 */     // GIR_Coverage, 364,
     /* 134940 */     GIR_EraseRootFromParent_Done,
     /* 134941 */   // Label 2624: @134941
     /* 134941 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(134977), // Rule ID 365 //
     /* 134946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134968 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 134971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134975 */     GIR_RootConstrainSelectedInstOperands,
     /* 134976 */     // GIR_Coverage, 365,
     /* 134976 */     GIR_EraseRootFromParent_Done,
     /* 134977 */   // Label 2625: @134977
     /* 134977 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(135013), // Rule ID 366 //
     /* 134982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135004 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 135007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135011 */     GIR_RootConstrainSelectedInstOperands,
     /* 135012 */     // GIR_Coverage, 366,
     /* 135012 */     GIR_EraseRootFromParent_Done,
     /* 135013 */   // Label 2626: @135013
     /* 135013 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(135049), // Rule ID 367 //
     /* 135018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 135026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135040 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 135043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135047 */     GIR_RootConstrainSelectedInstOperands,
     /* 135048 */     // GIR_Coverage, 367,
     /* 135048 */     GIR_EraseRootFromParent_Done,
     /* 135049 */   // Label 2627: @135049
     /* 135049 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(135085), // Rule ID 368 //
     /* 135054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 135062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135076 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 135079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135083 */     GIR_RootConstrainSelectedInstOperands,
     /* 135084 */     // GIR_Coverage, 368,
     /* 135084 */     GIR_EraseRootFromParent_Done,
     /* 135085 */   // Label 2628: @135085
     /* 135085 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(135121), // Rule ID 369 //
     /* 135090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 135098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135112 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 135115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135119 */     GIR_RootConstrainSelectedInstOperands,
     /* 135120 */     // GIR_Coverage, 369,
     /* 135120 */     GIR_EraseRootFromParent_Done,
     /* 135121 */   // Label 2629: @135121
     /* 135121 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(135157), // Rule ID 370 //
     /* 135126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135148 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 135151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135155 */     GIR_RootConstrainSelectedInstOperands,
     /* 135156 */     // GIR_Coverage, 370,
     /* 135156 */     GIR_EraseRootFromParent_Done,
     /* 135157 */   // Label 2630: @135157
     /* 135157 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(135193), // Rule ID 371 //
     /* 135162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135184 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 135187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135191 */     GIR_RootConstrainSelectedInstOperands,
     /* 135192 */     // GIR_Coverage, 371,
     /* 135192 */     GIR_EraseRootFromParent_Done,
     /* 135193 */   // Label 2631: @135193
     /* 135193 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(135229), // Rule ID 372 //
     /* 135198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135220 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 135223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135227 */     GIR_RootConstrainSelectedInstOperands,
     /* 135228 */     // GIR_Coverage, 372,
     /* 135228 */     GIR_EraseRootFromParent_Done,
     /* 135229 */   // Label 2632: @135229
     /* 135229 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(135265), // Rule ID 373 //
     /* 135234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135256 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 135259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135263 */     GIR_RootConstrainSelectedInstOperands,
     /* 135264 */     // GIR_Coverage, 373,
     /* 135264 */     GIR_EraseRootFromParent_Done,
     /* 135265 */   // Label 2633: @135265
     /* 135265 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(135301), // Rule ID 374 //
     /* 135270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135292 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 135295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135299 */     GIR_RootConstrainSelectedInstOperands,
     /* 135300 */     // GIR_Coverage, 374,
     /* 135300 */     GIR_EraseRootFromParent_Done,
     /* 135301 */   // Label 2634: @135301
     /* 135301 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(135337), // Rule ID 375 //
     /* 135306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 135314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135328 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 135331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135335 */     GIR_RootConstrainSelectedInstOperands,
     /* 135336 */     // GIR_Coverage, 375,
     /* 135336 */     GIR_EraseRootFromParent_Done,
     /* 135337 */   // Label 2635: @135337
     /* 135337 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(135373), // Rule ID 376 //
     /* 135342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135364 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 135367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135371 */     GIR_RootConstrainSelectedInstOperands,
     /* 135372 */     // GIR_Coverage, 376,
     /* 135372 */     GIR_EraseRootFromParent_Done,
     /* 135373 */   // Label 2636: @135373
     /* 135373 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(135409), // Rule ID 377 //
     /* 135378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135400 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 135403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135407 */     GIR_RootConstrainSelectedInstOperands,
     /* 135408 */     // GIR_Coverage, 377,
     /* 135408 */     GIR_EraseRootFromParent_Done,
     /* 135409 */   // Label 2637: @135409
     /* 135409 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(135445), // Rule ID 378 //
     /* 135414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135436 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 135439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135443 */     GIR_RootConstrainSelectedInstOperands,
     /* 135444 */     // GIR_Coverage, 378,
     /* 135444 */     GIR_EraseRootFromParent_Done,
     /* 135445 */   // Label 2638: @135445
     /* 135445 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(135481), // Rule ID 379 //
     /* 135450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135472 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 135475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135479 */     GIR_RootConstrainSelectedInstOperands,
     /* 135480 */     // GIR_Coverage, 379,
     /* 135480 */     GIR_EraseRootFromParent_Done,
     /* 135481 */   // Label 2639: @135481
     /* 135481 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(135517), // Rule ID 380 //
     /* 135486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135508 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 135511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135515 */     GIR_RootConstrainSelectedInstOperands,
     /* 135516 */     // GIR_Coverage, 380,
     /* 135516 */     GIR_EraseRootFromParent_Done,
     /* 135517 */   // Label 2640: @135517
     /* 135517 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(135553), // Rule ID 381 //
     /* 135522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135544 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 135547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135551 */     GIR_RootConstrainSelectedInstOperands,
     /* 135552 */     // GIR_Coverage, 381,
     /* 135552 */     GIR_EraseRootFromParent_Done,
     /* 135553 */   // Label 2641: @135553
     /* 135553 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(135589), // Rule ID 382 //
     /* 135558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135580 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 135583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135587 */     GIR_RootConstrainSelectedInstOperands,
     /* 135588 */     // GIR_Coverage, 382,
     /* 135588 */     GIR_EraseRootFromParent_Done,
     /* 135589 */   // Label 2642: @135589
     /* 135589 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(135625), // Rule ID 383 //
     /* 135594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135616 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 135619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135623 */     GIR_RootConstrainSelectedInstOperands,
     /* 135624 */     // GIR_Coverage, 383,
     /* 135624 */     GIR_EraseRootFromParent_Done,
     /* 135625 */   // Label 2643: @135625
     /* 135625 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(135661), // Rule ID 384 //
     /* 135630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135652 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 135655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135659 */     GIR_RootConstrainSelectedInstOperands,
     /* 135660 */     // GIR_Coverage, 384,
     /* 135660 */     GIR_EraseRootFromParent_Done,
     /* 135661 */   // Label 2644: @135661
     /* 135661 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(135697), // Rule ID 385 //
     /* 135666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135688 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 135691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135695 */     GIR_RootConstrainSelectedInstOperands,
     /* 135696 */     // GIR_Coverage, 385,
     /* 135696 */     GIR_EraseRootFromParent_Done,
     /* 135697 */   // Label 2645: @135697
     /* 135697 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(135733), // Rule ID 386 //
     /* 135702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135724 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 135727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135731 */     GIR_RootConstrainSelectedInstOperands,
     /* 135732 */     // GIR_Coverage, 386,
     /* 135732 */     GIR_EraseRootFromParent_Done,
     /* 135733 */   // Label 2646: @135733
     /* 135733 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(135769), // Rule ID 387 //
     /* 135738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135760 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 135763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135767 */     GIR_RootConstrainSelectedInstOperands,
     /* 135768 */     // GIR_Coverage, 387,
     /* 135768 */     GIR_EraseRootFromParent_Done,
     /* 135769 */   // Label 2647: @135769
     /* 135769 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(135805), // Rule ID 388 //
     /* 135774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135796 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 135799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135803 */     GIR_RootConstrainSelectedInstOperands,
     /* 135804 */     // GIR_Coverage, 388,
     /* 135804 */     GIR_EraseRootFromParent_Done,
     /* 135805 */   // Label 2648: @135805
     /* 135805 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(135841), // Rule ID 389 //
     /* 135810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135832 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 135835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135839 */     GIR_RootConstrainSelectedInstOperands,
     /* 135840 */     // GIR_Coverage, 389,
     /* 135840 */     GIR_EraseRootFromParent_Done,
     /* 135841 */   // Label 2649: @135841
     /* 135841 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(135877), // Rule ID 390 //
     /* 135846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135868 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 135871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135875 */     GIR_RootConstrainSelectedInstOperands,
     /* 135876 */     // GIR_Coverage, 390,
     /* 135876 */     GIR_EraseRootFromParent_Done,
     /* 135877 */   // Label 2650: @135877
     /* 135877 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(135913), // Rule ID 391 //
     /* 135882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135904 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 135907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135911 */     GIR_RootConstrainSelectedInstOperands,
     /* 135912 */     // GIR_Coverage, 391,
     /* 135912 */     GIR_EraseRootFromParent_Done,
     /* 135913 */   // Label 2651: @135913
     /* 135913 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(135949), // Rule ID 392 //
     /* 135918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135940 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 135943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135947 */     GIR_RootConstrainSelectedInstOperands,
     /* 135948 */     // GIR_Coverage, 392,
     /* 135948 */     GIR_EraseRootFromParent_Done,
     /* 135949 */   // Label 2652: @135949
     /* 135949 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(135985), // Rule ID 393 //
     /* 135954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135976 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 135979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135983 */     GIR_RootConstrainSelectedInstOperands,
     /* 135984 */     // GIR_Coverage, 393,
     /* 135984 */     GIR_EraseRootFromParent_Done,
     /* 135985 */   // Label 2653: @135985
     /* 135985 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(136021), // Rule ID 575 //
     /* 135990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 135998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136012 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 136012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 136015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136019 */     GIR_RootConstrainSelectedInstOperands,
     /* 136020 */     // GIR_Coverage, 575,
     /* 136020 */     GIR_EraseRootFromParent_Done,
     /* 136021 */   // Label 2654: @136021
     /* 136021 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(136057), // Rule ID 576 //
     /* 136026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 136034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136048 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 136048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 136051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136055 */     GIR_RootConstrainSelectedInstOperands,
     /* 136056 */     // GIR_Coverage, 576,
     /* 136056 */     GIR_EraseRootFromParent_Done,
     /* 136057 */   // Label 2655: @136057
     /* 136057 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(136093), // Rule ID 577 //
     /* 136062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 136070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136084 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 136084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 136087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136091 */     GIR_RootConstrainSelectedInstOperands,
     /* 136092 */     // GIR_Coverage, 577,
     /* 136092 */     GIR_EraseRootFromParent_Done,
     /* 136093 */   // Label 2656: @136093
     /* 136093 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(136129), // Rule ID 578 //
     /* 136098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 136106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136120 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 136120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 136123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136127 */     GIR_RootConstrainSelectedInstOperands,
     /* 136128 */     // GIR_Coverage, 578,
     /* 136128 */     GIR_EraseRootFromParent_Done,
     /* 136129 */   // Label 2657: @136129
     /* 136129 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(136165), // Rule ID 579 //
     /* 136134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 136142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136156 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 136156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 136159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136163 */     GIR_RootConstrainSelectedInstOperands,
     /* 136164 */     // GIR_Coverage, 579,
     /* 136164 */     GIR_EraseRootFromParent_Done,
     /* 136165 */   // Label 2658: @136165
     /* 136165 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(136201), // Rule ID 580 //
     /* 136170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 136178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136192 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 136192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 136195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136199 */     GIR_RootConstrainSelectedInstOperands,
     /* 136200 */     // GIR_Coverage, 580,
     /* 136200 */     GIR_EraseRootFromParent_Done,
     /* 136201 */   // Label 2659: @136201
     /* 136201 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(136237), // Rule ID 581 //
     /* 136206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 136214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 136217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136228 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 136228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 136231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136235 */     GIR_RootConstrainSelectedInstOperands,
     /* 136236 */     // GIR_Coverage, 581,
     /* 136236 */     GIR_EraseRootFromParent_Done,
     /* 136237 */   // Label 2660: @136237
     /* 136237 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(136273), // Rule ID 582 //
     /* 136242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 136245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 136250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 136253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136264 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 136264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 136267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136271 */     GIR_RootConstrainSelectedInstOperands,
     /* 136272 */     // GIR_Coverage, 582,
     /* 136272 */     GIR_EraseRootFromParent_Done,
     /* 136273 */   // Label 2661: @136273
     /* 136273 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(136309), // Rule ID 710 //
     /* 136278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 136289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 136292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136300 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 136300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 136303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136307 */     GIR_RootConstrainSelectedInstOperands,
     /* 136308 */     // GIR_Coverage, 710,
     /* 136308 */     GIR_EraseRootFromParent_Done,
     /* 136309 */   // Label 2662: @136309
     /* 136309 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(136345), // Rule ID 711 //
     /* 136314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 136325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 136328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136336 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 136336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 136339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136343 */     GIR_RootConstrainSelectedInstOperands,
     /* 136344 */     // GIR_Coverage, 711,
     /* 136344 */     GIR_EraseRootFromParent_Done,
     /* 136345 */   // Label 2663: @136345
     /* 136345 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(136381), // Rule ID 712 //
     /* 136350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136372 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 136372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 136375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136379 */     GIR_RootConstrainSelectedInstOperands,
     /* 136380 */     // GIR_Coverage, 712,
     /* 136380 */     GIR_EraseRootFromParent_Done,
     /* 136381 */   // Label 2664: @136381
     /* 136381 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(136417), // Rule ID 713 //
     /* 136386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136408 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 136408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 136411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136415 */     GIR_RootConstrainSelectedInstOperands,
     /* 136416 */     // GIR_Coverage, 713,
     /* 136416 */     GIR_EraseRootFromParent_Done,
     /* 136417 */   // Label 2665: @136417
     /* 136417 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(136453), // Rule ID 714 //
     /* 136422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136444 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 136444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 136447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136451 */     GIR_RootConstrainSelectedInstOperands,
     /* 136452 */     // GIR_Coverage, 714,
     /* 136452 */     GIR_EraseRootFromParent_Done,
     /* 136453 */   // Label 2666: @136453
     /* 136453 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(136489), // Rule ID 715 //
     /* 136458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136480 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 136480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 136483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136487 */     GIR_RootConstrainSelectedInstOperands,
     /* 136488 */     // GIR_Coverage, 715,
     /* 136488 */     GIR_EraseRootFromParent_Done,
     /* 136489 */   // Label 2667: @136489
     /* 136489 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(136525), // Rule ID 789 //
     /* 136494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 136519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136523 */     GIR_RootConstrainSelectedInstOperands,
     /* 136524 */     // GIR_Coverage, 789,
     /* 136524 */     GIR_EraseRootFromParent_Done,
     /* 136525 */   // Label 2668: @136525
     /* 136525 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(136561), // Rule ID 790 //
     /* 136530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 136555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136559 */     GIR_RootConstrainSelectedInstOperands,
     /* 136560 */     // GIR_Coverage, 790,
     /* 136560 */     GIR_EraseRootFromParent_Done,
     /* 136561 */   // Label 2669: @136561
     /* 136561 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(136597), // Rule ID 791 //
     /* 136566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 136591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136595 */     GIR_RootConstrainSelectedInstOperands,
     /* 136596 */     // GIR_Coverage, 791,
     /* 136596 */     GIR_EraseRootFromParent_Done,
     /* 136597 */   // Label 2670: @136597
     /* 136597 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(136633), // Rule ID 792 //
     /* 136602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 136627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136631 */     GIR_RootConstrainSelectedInstOperands,
     /* 136632 */     // GIR_Coverage, 792,
     /* 136632 */     GIR_EraseRootFromParent_Done,
     /* 136633 */   // Label 2671: @136633
     /* 136633 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(136669), // Rule ID 793 //
     /* 136638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136660 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 136663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136667 */     GIR_RootConstrainSelectedInstOperands,
     /* 136668 */     // GIR_Coverage, 793,
     /* 136668 */     GIR_EraseRootFromParent_Done,
     /* 136669 */   // Label 2672: @136669
     /* 136669 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(136705), // Rule ID 794 //
     /* 136674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136696 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 136699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136703 */     GIR_RootConstrainSelectedInstOperands,
     /* 136704 */     // GIR_Coverage, 794,
     /* 136704 */     GIR_EraseRootFromParent_Done,
     /* 136705 */   // Label 2673: @136705
     /* 136705 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(136741), // Rule ID 795 //
     /* 136710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136732 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 136735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136739 */     GIR_RootConstrainSelectedInstOperands,
     /* 136740 */     // GIR_Coverage, 795,
     /* 136740 */     GIR_EraseRootFromParent_Done,
     /* 136741 */   // Label 2674: @136741
     /* 136741 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(136777), // Rule ID 796 //
     /* 136746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136768 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 136771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136775 */     GIR_RootConstrainSelectedInstOperands,
     /* 136776 */     // GIR_Coverage, 796,
     /* 136776 */     GIR_EraseRootFromParent_Done,
     /* 136777 */   // Label 2675: @136777
     /* 136777 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(136813), // Rule ID 797 //
     /* 136782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 136807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136811 */     GIR_RootConstrainSelectedInstOperands,
     /* 136812 */     // GIR_Coverage, 797,
     /* 136812 */     GIR_EraseRootFromParent_Done,
     /* 136813 */   // Label 2676: @136813
     /* 136813 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(136849), // Rule ID 798 //
     /* 136818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136840 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 136843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136847 */     GIR_RootConstrainSelectedInstOperands,
     /* 136848 */     // GIR_Coverage, 798,
     /* 136848 */     GIR_EraseRootFromParent_Done,
     /* 136849 */   // Label 2677: @136849
     /* 136849 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(136885), // Rule ID 799 //
     /* 136854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 136879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136883 */     GIR_RootConstrainSelectedInstOperands,
     /* 136884 */     // GIR_Coverage, 799,
     /* 136884 */     GIR_EraseRootFromParent_Done,
     /* 136885 */   // Label 2678: @136885
     /* 136885 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(136921), // Rule ID 800 //
     /* 136890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136912 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 136915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136919 */     GIR_RootConstrainSelectedInstOperands,
     /* 136920 */     // GIR_Coverage, 800,
     /* 136920 */     GIR_EraseRootFromParent_Done,
     /* 136921 */   // Label 2679: @136921
     /* 136921 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(136957), // Rule ID 801 //
     /* 136926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 136951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136955 */     GIR_RootConstrainSelectedInstOperands,
     /* 136956 */     // GIR_Coverage, 801,
     /* 136956 */     GIR_EraseRootFromParent_Done,
     /* 136957 */   // Label 2680: @136957
     /* 136957 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(136993), // Rule ID 802 //
     /* 136962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 136987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136991 */     GIR_RootConstrainSelectedInstOperands,
     /* 136992 */     // GIR_Coverage, 802,
     /* 136992 */     GIR_EraseRootFromParent_Done,
     /* 136993 */   // Label 2681: @136993
     /* 136993 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(137029), // Rule ID 803 //
     /* 136998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 137006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137020 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 137023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137027 */     GIR_RootConstrainSelectedInstOperands,
     /* 137028 */     // GIR_Coverage, 803,
     /* 137028 */     GIR_EraseRootFromParent_Done,
     /* 137029 */   // Label 2682: @137029
     /* 137029 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(137065), // Rule ID 804 //
     /* 137034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137056 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 137059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137063 */     GIR_RootConstrainSelectedInstOperands,
     /* 137064 */     // GIR_Coverage, 804,
     /* 137064 */     GIR_EraseRootFromParent_Done,
     /* 137065 */   // Label 2683: @137065
     /* 137065 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(137101), // Rule ID 805 //
     /* 137070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 137095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137099 */     GIR_RootConstrainSelectedInstOperands,
     /* 137100 */     // GIR_Coverage, 805,
     /* 137100 */     GIR_EraseRootFromParent_Done,
     /* 137101 */   // Label 2684: @137101
     /* 137101 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(137137), // Rule ID 806 //
     /* 137106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 137131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137135 */     GIR_RootConstrainSelectedInstOperands,
     /* 137136 */     // GIR_Coverage, 806,
     /* 137136 */     GIR_EraseRootFromParent_Done,
     /* 137137 */   // Label 2685: @137137
     /* 137137 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(137173), // Rule ID 807 //
     /* 137142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 137167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137171 */     GIR_RootConstrainSelectedInstOperands,
     /* 137172 */     // GIR_Coverage, 807,
     /* 137172 */     GIR_EraseRootFromParent_Done,
     /* 137173 */   // Label 2686: @137173
     /* 137173 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(137209), // Rule ID 808 //
     /* 137178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 137186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 137203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137207 */     GIR_RootConstrainSelectedInstOperands,
     /* 137208 */     // GIR_Coverage, 808,
     /* 137208 */     GIR_EraseRootFromParent_Done,
     /* 137209 */   // Label 2687: @137209
     /* 137209 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(137245), // Rule ID 809 //
     /* 137214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137236 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 137239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137243 */     GIR_RootConstrainSelectedInstOperands,
     /* 137244 */     // GIR_Coverage, 809,
     /* 137244 */     GIR_EraseRootFromParent_Done,
     /* 137245 */   // Label 2688: @137245
     /* 137245 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(137281), // Rule ID 810 //
     /* 137250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 137275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137279 */     GIR_RootConstrainSelectedInstOperands,
     /* 137280 */     // GIR_Coverage, 810,
     /* 137280 */     GIR_EraseRootFromParent_Done,
     /* 137281 */   // Label 2689: @137281
     /* 137281 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(137317), // Rule ID 811 //
     /* 137286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137308 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 137311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137315 */     GIR_RootConstrainSelectedInstOperands,
     /* 137316 */     // GIR_Coverage, 811,
     /* 137316 */     GIR_EraseRootFromParent_Done,
     /* 137317 */   // Label 2690: @137317
     /* 137317 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(137353), // Rule ID 812 //
     /* 137322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 137347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137351 */     GIR_RootConstrainSelectedInstOperands,
     /* 137352 */     // GIR_Coverage, 812,
     /* 137352 */     GIR_EraseRootFromParent_Done,
     /* 137353 */   // Label 2691: @137353
     /* 137353 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(137389), // Rule ID 813 //
     /* 137358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 137366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137380 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 137383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137387 */     GIR_RootConstrainSelectedInstOperands,
     /* 137388 */     // GIR_Coverage, 813,
     /* 137388 */     GIR_EraseRootFromParent_Done,
     /* 137389 */   // Label 2692: @137389
     /* 137389 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(137425), // Rule ID 814 //
     /* 137394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 137419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137423 */     GIR_RootConstrainSelectedInstOperands,
     /* 137424 */     // GIR_Coverage, 814,
     /* 137424 */     GIR_EraseRootFromParent_Done,
     /* 137425 */   // Label 2693: @137425
     /* 137425 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(137461), // Rule ID 815 //
     /* 137430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137459 */     GIR_RootConstrainSelectedInstOperands,
     /* 137460 */     // GIR_Coverage, 815,
     /* 137460 */     GIR_EraseRootFromParent_Done,
     /* 137461 */   // Label 2694: @137461
     /* 137461 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(137497), // Rule ID 816 //
     /* 137466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137488 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 137491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137495 */     GIR_RootConstrainSelectedInstOperands,
     /* 137496 */     // GIR_Coverage, 816,
     /* 137496 */     GIR_EraseRootFromParent_Done,
     /* 137497 */   // Label 2695: @137497
     /* 137497 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(137533), // Rule ID 817 //
     /* 137502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137524 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 137527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137531 */     GIR_RootConstrainSelectedInstOperands,
     /* 137532 */     // GIR_Coverage, 817,
     /* 137532 */     GIR_EraseRootFromParent_Done,
     /* 137533 */   // Label 2696: @137533
     /* 137533 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(137569), // Rule ID 818 //
     /* 137538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137560 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 137563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137567 */     GIR_RootConstrainSelectedInstOperands,
     /* 137568 */     // GIR_Coverage, 818,
     /* 137568 */     GIR_EraseRootFromParent_Done,
     /* 137569 */   // Label 2697: @137569
     /* 137569 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(137605), // Rule ID 819 //
     /* 137574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137596 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 137599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137603 */     GIR_RootConstrainSelectedInstOperands,
     /* 137604 */     // GIR_Coverage, 819,
     /* 137604 */     GIR_EraseRootFromParent_Done,
     /* 137605 */   // Label 2698: @137605
     /* 137605 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(137641), // Rule ID 820 //
     /* 137610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 137635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137639 */     GIR_RootConstrainSelectedInstOperands,
     /* 137640 */     // GIR_Coverage, 820,
     /* 137640 */     GIR_EraseRootFromParent_Done,
     /* 137641 */   // Label 2699: @137641
     /* 137641 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(137677), // Rule ID 821 //
     /* 137646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137668 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 137671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137675 */     GIR_RootConstrainSelectedInstOperands,
     /* 137676 */     // GIR_Coverage, 821,
     /* 137676 */     GIR_EraseRootFromParent_Done,
     /* 137677 */   // Label 2700: @137677
     /* 137677 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(137713), // Rule ID 822 //
     /* 137682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137704 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 137707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137711 */     GIR_RootConstrainSelectedInstOperands,
     /* 137712 */     // GIR_Coverage, 822,
     /* 137712 */     GIR_EraseRootFromParent_Done,
     /* 137713 */   // Label 2701: @137713
     /* 137713 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(137749), // Rule ID 823 //
     /* 137718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137740 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 137743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137747 */     GIR_RootConstrainSelectedInstOperands,
     /* 137748 */     // GIR_Coverage, 823,
     /* 137748 */     GIR_EraseRootFromParent_Done,
     /* 137749 */   // Label 2702: @137749
     /* 137749 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(137785), // Rule ID 824 //
     /* 137754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137776 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 137779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137783 */     GIR_RootConstrainSelectedInstOperands,
     /* 137784 */     // GIR_Coverage, 824,
     /* 137784 */     GIR_EraseRootFromParent_Done,
     /* 137785 */   // Label 2703: @137785
     /* 137785 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(137821), // Rule ID 825 //
     /* 137790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137812 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 137815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137819 */     GIR_RootConstrainSelectedInstOperands,
     /* 137820 */     // GIR_Coverage, 825,
     /* 137820 */     GIR_EraseRootFromParent_Done,
     /* 137821 */   // Label 2704: @137821
     /* 137821 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(137857), // Rule ID 826 //
     /* 137826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137848 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 137851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137855 */     GIR_RootConstrainSelectedInstOperands,
     /* 137856 */     // GIR_Coverage, 826,
     /* 137856 */     GIR_EraseRootFromParent_Done,
     /* 137857 */   // Label 2705: @137857
     /* 137857 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(137893), // Rule ID 827 //
     /* 137862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137884 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 137887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137891 */     GIR_RootConstrainSelectedInstOperands,
     /* 137892 */     // GIR_Coverage, 827,
     /* 137892 */     GIR_EraseRootFromParent_Done,
     /* 137893 */   // Label 2706: @137893
     /* 137893 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(137929), // Rule ID 828 //
     /* 137898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137920 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 137923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137927 */     GIR_RootConstrainSelectedInstOperands,
     /* 137928 */     // GIR_Coverage, 828,
     /* 137928 */     GIR_EraseRootFromParent_Done,
     /* 137929 */   // Label 2707: @137929
     /* 137929 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(137965), // Rule ID 829 //
     /* 137934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 137942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137956 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 137956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 137959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137963 */     GIR_RootConstrainSelectedInstOperands,
     /* 137964 */     // GIR_Coverage, 829,
     /* 137964 */     GIR_EraseRootFromParent_Done,
     /* 137965 */   // Label 2708: @137965
     /* 137965 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(138001), // Rule ID 856 //
     /* 137970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137992 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 137992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 137995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137999 */     GIR_RootConstrainSelectedInstOperands,
     /* 138000 */     // GIR_Coverage, 856,
     /* 138000 */     GIR_EraseRootFromParent_Done,
     /* 138001 */   // Label 2709: @138001
     /* 138001 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(138037), // Rule ID 857 //
     /* 138006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 138014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138028 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 138028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 138031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138035 */     GIR_RootConstrainSelectedInstOperands,
     /* 138036 */     // GIR_Coverage, 857,
     /* 138036 */     GIR_EraseRootFromParent_Done,
     /* 138037 */   // Label 2710: @138037
     /* 138037 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(138073), // Rule ID 858 //
     /* 138042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 138050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138064 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 138067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138071 */     GIR_RootConstrainSelectedInstOperands,
     /* 138072 */     // GIR_Coverage, 858,
     /* 138072 */     GIR_EraseRootFromParent_Done,
     /* 138073 */   // Label 2711: @138073
     /* 138073 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(138109), // Rule ID 859 //
     /* 138078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 138086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138100 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 138103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138107 */     GIR_RootConstrainSelectedInstOperands,
     /* 138108 */     // GIR_Coverage, 859,
     /* 138108 */     GIR_EraseRootFromParent_Done,
     /* 138109 */   // Label 2712: @138109
     /* 138109 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(138145), // Rule ID 860 //
     /* 138114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 138122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138136 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 138139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138143 */     GIR_RootConstrainSelectedInstOperands,
     /* 138144 */     // GIR_Coverage, 860,
     /* 138144 */     GIR_EraseRootFromParent_Done,
     /* 138145 */   // Label 2713: @138145
     /* 138145 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(138181), // Rule ID 931 //
     /* 138150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 138158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138172 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 138175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138179 */     GIR_RootConstrainSelectedInstOperands,
     /* 138180 */     // GIR_Coverage, 931,
     /* 138180 */     GIR_EraseRootFromParent_Done,
     /* 138181 */   // Label 2714: @138181
     /* 138181 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(138217), // Rule ID 932 //
     /* 138186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 138194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138208 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 138211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138215 */     GIR_RootConstrainSelectedInstOperands,
     /* 138216 */     // GIR_Coverage, 932,
     /* 138216 */     GIR_EraseRootFromParent_Done,
     /* 138217 */   // Label 2715: @138217
     /* 138217 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(138253), // Rule ID 933 //
     /* 138222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 138230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138244 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 138247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138251 */     GIR_RootConstrainSelectedInstOperands,
     /* 138252 */     // GIR_Coverage, 933,
     /* 138252 */     GIR_EraseRootFromParent_Done,
     /* 138253 */   // Label 2716: @138253
     /* 138253 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(138289), // Rule ID 934 //
     /* 138258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 138266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138280 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 138283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138287 */     GIR_RootConstrainSelectedInstOperands,
     /* 138288 */     // GIR_Coverage, 934,
     /* 138288 */     GIR_EraseRootFromParent_Done,
     /* 138289 */   // Label 2717: @138289
     /* 138289 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(138325), // Rule ID 935 //
     /* 138294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 138302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 138319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138323 */     GIR_RootConstrainSelectedInstOperands,
     /* 138324 */     // GIR_Coverage, 935,
     /* 138324 */     GIR_EraseRootFromParent_Done,
     /* 138325 */   // Label 2718: @138325
     /* 138325 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(138361), // Rule ID 936 //
     /* 138330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 138338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138352 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 138355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138359 */     GIR_RootConstrainSelectedInstOperands,
     /* 138360 */     // GIR_Coverage, 936,
     /* 138360 */     GIR_EraseRootFromParent_Done,
     /* 138361 */   // Label 2719: @138361
     /* 138361 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(138397), // Rule ID 937 //
     /* 138366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 138374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138388 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 138391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138395 */     GIR_RootConstrainSelectedInstOperands,
     /* 138396 */     // GIR_Coverage, 937,
     /* 138396 */     GIR_EraseRootFromParent_Done,
     /* 138397 */   // Label 2720: @138397
     /* 138397 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(138433), // Rule ID 938 //
     /* 138402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 138410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138424 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 138427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138431 */     GIR_RootConstrainSelectedInstOperands,
     /* 138432 */     // GIR_Coverage, 938,
     /* 138432 */     GIR_EraseRootFromParent_Done,
     /* 138433 */   // Label 2721: @138433
     /* 138433 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(138469), // Rule ID 939 //
     /* 138438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 138446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138460 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 138463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138467 */     GIR_RootConstrainSelectedInstOperands,
     /* 138468 */     // GIR_Coverage, 939,
     /* 138468 */     GIR_EraseRootFromParent_Done,
     /* 138469 */   // Label 2722: @138469
     /* 138469 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(138505), // Rule ID 940 //
     /* 138474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138496 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 138499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138503 */     GIR_RootConstrainSelectedInstOperands,
     /* 138504 */     // GIR_Coverage, 940,
     /* 138504 */     GIR_EraseRootFromParent_Done,
     /* 138505 */   // Label 2723: @138505
     /* 138505 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(138541), // Rule ID 941 //
     /* 138510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138532 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 138535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138539 */     GIR_RootConstrainSelectedInstOperands,
     /* 138540 */     // GIR_Coverage, 941,
     /* 138540 */     GIR_EraseRootFromParent_Done,
     /* 138541 */   // Label 2724: @138541
     /* 138541 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(138577), // Rule ID 942 //
     /* 138546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 138571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138575 */     GIR_RootConstrainSelectedInstOperands,
     /* 138576 */     // GIR_Coverage, 942,
     /* 138576 */     GIR_EraseRootFromParent_Done,
     /* 138577 */   // Label 2725: @138577
     /* 138577 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(138613), // Rule ID 943 //
     /* 138582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138604 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 138604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 138607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138611 */     GIR_RootConstrainSelectedInstOperands,
     /* 138612 */     // GIR_Coverage, 943,
     /* 138612 */     GIR_EraseRootFromParent_Done,
     /* 138613 */   // Label 2726: @138613
     /* 138613 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(138649), // Rule ID 944 //
     /* 138618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 138640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 138643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138647 */     GIR_RootConstrainSelectedInstOperands,
     /* 138648 */     // GIR_Coverage, 944,
     /* 138648 */     GIR_EraseRootFromParent_Done,
     /* 138649 */   // Label 2727: @138649
     /* 138649 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(138685), // Rule ID 945 //
     /* 138654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138676 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 138679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138683 */     GIR_RootConstrainSelectedInstOperands,
     /* 138684 */     // GIR_Coverage, 945,
     /* 138684 */     GIR_EraseRootFromParent_Done,
     /* 138685 */   // Label 2728: @138685
     /* 138685 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(138721), // Rule ID 946 //
     /* 138690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138712 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 138715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138719 */     GIR_RootConstrainSelectedInstOperands,
     /* 138720 */     // GIR_Coverage, 946,
     /* 138720 */     GIR_EraseRootFromParent_Done,
     /* 138721 */   // Label 2729: @138721
     /* 138721 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(138757), // Rule ID 947 //
     /* 138726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138748 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 138751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138755 */     GIR_RootConstrainSelectedInstOperands,
     /* 138756 */     // GIR_Coverage, 947,
     /* 138756 */     GIR_EraseRootFromParent_Done,
     /* 138757 */   // Label 2730: @138757
     /* 138757 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(138793), // Rule ID 994 //
     /* 138762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138784 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 138784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 138787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138791 */     GIR_RootConstrainSelectedInstOperands,
     /* 138792 */     // GIR_Coverage, 994,
     /* 138792 */     GIR_EraseRootFromParent_Done,
     /* 138793 */   // Label 2731: @138793
     /* 138793 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(138829), // Rule ID 996 //
     /* 138798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 138820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 138823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138827 */     GIR_RootConstrainSelectedInstOperands,
     /* 138828 */     // GIR_Coverage, 996,
     /* 138828 */     GIR_EraseRootFromParent_Done,
     /* 138829 */   // Label 2732: @138829
     /* 138829 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(138865), // Rule ID 998 //
     /* 138834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138856 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 138856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 138859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138863 */     GIR_RootConstrainSelectedInstOperands,
     /* 138864 */     // GIR_Coverage, 998,
     /* 138864 */     GIR_EraseRootFromParent_Done,
     /* 138865 */   // Label 2733: @138865
     /* 138865 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(138901), // Rule ID 1000 //
     /* 138870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 138892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 138895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138899 */     GIR_RootConstrainSelectedInstOperands,
     /* 138900 */     // GIR_Coverage, 1000,
     /* 138900 */     GIR_EraseRootFromParent_Done,
     /* 138901 */   // Label 2734: @138901
     /* 138901 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(138937), // Rule ID 1002 //
     /* 138906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138928 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 138928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 138931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138935 */     GIR_RootConstrainSelectedInstOperands,
     /* 138936 */     // GIR_Coverage, 1002,
     /* 138936 */     GIR_EraseRootFromParent_Done,
     /* 138937 */   // Label 2735: @138937
     /* 138937 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(138973), // Rule ID 1004 //
     /* 138942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138964 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 138964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 138967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138971 */     GIR_RootConstrainSelectedInstOperands,
     /* 138972 */     // GIR_Coverage, 1004,
     /* 138972 */     GIR_EraseRootFromParent_Done,
     /* 138973 */   // Label 2736: @138973
     /* 138973 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(139009), // Rule ID 1015 //
     /* 138978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139000 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 139000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 139003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139007 */     GIR_RootConstrainSelectedInstOperands,
     /* 139008 */     // GIR_Coverage, 1015,
     /* 139008 */     GIR_EraseRootFromParent_Done,
     /* 139009 */   // Label 2737: @139009
     /* 139009 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(139045), // Rule ID 1016 //
     /* 139014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139036 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 139036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 139039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139043 */     GIR_RootConstrainSelectedInstOperands,
     /* 139044 */     // GIR_Coverage, 1016,
     /* 139044 */     GIR_EraseRootFromParent_Done,
     /* 139045 */   // Label 2738: @139045
     /* 139045 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(139081), // Rule ID 1017 //
     /* 139050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139072 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 139072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 139075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139079 */     GIR_RootConstrainSelectedInstOperands,
     /* 139080 */     // GIR_Coverage, 1017,
     /* 139080 */     GIR_EraseRootFromParent_Done,
     /* 139081 */   // Label 2739: @139081
     /* 139081 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(139117), // Rule ID 1018 //
     /* 139086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139108 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 139108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 139111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139115 */     GIR_RootConstrainSelectedInstOperands,
     /* 139116 */     // GIR_Coverage, 1018,
     /* 139116 */     GIR_EraseRootFromParent_Done,
     /* 139117 */   // Label 2740: @139117
     /* 139117 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(139153), // Rule ID 1019 //
     /* 139122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139144 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 139147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139151 */     GIR_RootConstrainSelectedInstOperands,
     /* 139152 */     // GIR_Coverage, 1019,
     /* 139152 */     GIR_EraseRootFromParent_Done,
     /* 139153 */   // Label 2741: @139153
     /* 139153 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(139189), // Rule ID 1020 //
     /* 139158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 139183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139187 */     GIR_RootConstrainSelectedInstOperands,
     /* 139188 */     // GIR_Coverage, 1020,
     /* 139188 */     GIR_EraseRootFromParent_Done,
     /* 139189 */   // Label 2742: @139189
     /* 139189 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(139225), // Rule ID 1021 //
     /* 139194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 139216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 139219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139223 */     GIR_RootConstrainSelectedInstOperands,
     /* 139224 */     // GIR_Coverage, 1021,
     /* 139224 */     GIR_EraseRootFromParent_Done,
     /* 139225 */   // Label 2743: @139225
     /* 139225 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(139261), // Rule ID 1022 //
     /* 139230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 139241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 139244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139252 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 139252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 139255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139259 */     GIR_RootConstrainSelectedInstOperands,
     /* 139260 */     // GIR_Coverage, 1022,
     /* 139260 */     GIR_EraseRootFromParent_Done,
     /* 139261 */   // Label 2744: @139261
     /* 139261 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(139297), // Rule ID 1023 //
     /* 139266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139288 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 139288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 139291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139295 */     GIR_RootConstrainSelectedInstOperands,
     /* 139296 */     // GIR_Coverage, 1023,
     /* 139296 */     GIR_EraseRootFromParent_Done,
     /* 139297 */   // Label 2745: @139297
     /* 139297 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(139333), // Rule ID 1024 //
     /* 139302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139324 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 139324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 139327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139331 */     GIR_RootConstrainSelectedInstOperands,
     /* 139332 */     // GIR_Coverage, 1024,
     /* 139332 */     GIR_EraseRootFromParent_Done,
     /* 139333 */   // Label 2746: @139333
     /* 139333 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(139369), // Rule ID 1025 //
     /* 139338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139360 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 139360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 139363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139367 */     GIR_RootConstrainSelectedInstOperands,
     /* 139368 */     // GIR_Coverage, 1025,
     /* 139368 */     GIR_EraseRootFromParent_Done,
     /* 139369 */   // Label 2747: @139369
     /* 139369 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(139405), // Rule ID 1026 //
     /* 139374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139396 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 139399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139403 */     GIR_RootConstrainSelectedInstOperands,
     /* 139404 */     // GIR_Coverage, 1026,
     /* 139404 */     GIR_EraseRootFromParent_Done,
     /* 139405 */   // Label 2748: @139405
     /* 139405 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(139441), // Rule ID 1027 //
     /* 139410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 139435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139439 */     GIR_RootConstrainSelectedInstOperands,
     /* 139440 */     // GIR_Coverage, 1027,
     /* 139440 */     GIR_EraseRootFromParent_Done,
     /* 139441 */   // Label 2749: @139441
     /* 139441 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(139477), // Rule ID 1028 //
     /* 139446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139468 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 139468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 139471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139475 */     GIR_RootConstrainSelectedInstOperands,
     /* 139476 */     // GIR_Coverage, 1028,
     /* 139476 */     GIR_EraseRootFromParent_Done,
     /* 139477 */   // Label 2750: @139477
     /* 139477 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(139513), // Rule ID 1055 //
     /* 139482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 139496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139504 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 139504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 139507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139511 */     GIR_RootConstrainSelectedInstOperands,
     /* 139512 */     // GIR_Coverage, 1055,
     /* 139512 */     GIR_EraseRootFromParent_Done,
     /* 139513 */   // Label 2751: @139513
     /* 139513 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(139549), // Rule ID 1057 //
     /* 139518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139540 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 139540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 139543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139547 */     GIR_RootConstrainSelectedInstOperands,
     /* 139548 */     // GIR_Coverage, 1057,
     /* 139548 */     GIR_EraseRootFromParent_Done,
     /* 139549 */   // Label 2752: @139549
     /* 139549 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(139585), // Rule ID 1059 //
     /* 139554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139576 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 139576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 139579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139583 */     GIR_RootConstrainSelectedInstOperands,
     /* 139584 */     // GIR_Coverage, 1059,
     /* 139584 */     GIR_EraseRootFromParent_Done,
     /* 139585 */   // Label 2753: @139585
     /* 139585 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(139621), // Rule ID 1061 //
     /* 139590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139612 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 139612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 139615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139619 */     GIR_RootConstrainSelectedInstOperands,
     /* 139620 */     // GIR_Coverage, 1061,
     /* 139620 */     GIR_EraseRootFromParent_Done,
     /* 139621 */   // Label 2754: @139621
     /* 139621 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(139657), // Rule ID 1063 //
     /* 139626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139648 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 139648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 139651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139655 */     GIR_RootConstrainSelectedInstOperands,
     /* 139656 */     // GIR_Coverage, 1063,
     /* 139656 */     GIR_EraseRootFromParent_Done,
     /* 139657 */   // Label 2755: @139657
     /* 139657 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(139693), // Rule ID 1065 //
     /* 139662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139684 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 139684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 139687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139691 */     GIR_RootConstrainSelectedInstOperands,
     /* 139692 */     // GIR_Coverage, 1065,
     /* 139692 */     GIR_EraseRootFromParent_Done,
     /* 139693 */   // Label 2756: @139693
     /* 139693 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(139729), // Rule ID 1079 //
     /* 139698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139720 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 139723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139727 */     GIR_RootConstrainSelectedInstOperands,
     /* 139728 */     // GIR_Coverage, 1079,
     /* 139728 */     GIR_EraseRootFromParent_Done,
     /* 139729 */   // Label 2757: @139729
     /* 139729 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(139765), // Rule ID 1080 //
     /* 139734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139756 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 139759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139763 */     GIR_RootConstrainSelectedInstOperands,
     /* 139764 */     // GIR_Coverage, 1080,
     /* 139764 */     GIR_EraseRootFromParent_Done,
     /* 139765 */   // Label 2758: @139765
     /* 139765 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(139801), // Rule ID 1081 //
     /* 139770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139792 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 139795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139799 */     GIR_RootConstrainSelectedInstOperands,
     /* 139800 */     // GIR_Coverage, 1081,
     /* 139800 */     GIR_EraseRootFromParent_Done,
     /* 139801 */   // Label 2759: @139801
     /* 139801 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(139837), // Rule ID 1082 //
     /* 139806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 139831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139835 */     GIR_RootConstrainSelectedInstOperands,
     /* 139836 */     // GIR_Coverage, 1082,
     /* 139836 */     GIR_EraseRootFromParent_Done,
     /* 139837 */   // Label 2760: @139837
     /* 139837 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(139873), // Rule ID 1646 //
     /* 139842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 139850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139864 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 139867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139871 */     GIR_RootConstrainSelectedInstOperands,
     /* 139872 */     // GIR_Coverage, 1646,
     /* 139872 */     GIR_EraseRootFromParent_Done,
     /* 139873 */   // Label 2761: @139873
     /* 139873 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(139909), // Rule ID 1652 //
     /* 139878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139900 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 139903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139907 */     GIR_RootConstrainSelectedInstOperands,
     /* 139908 */     // GIR_Coverage, 1652,
     /* 139908 */     GIR_EraseRootFromParent_Done,
     /* 139909 */   // Label 2762: @139909
     /* 139909 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(139945), // Rule ID 1653 //
     /* 139914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139936 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 139936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 139939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139943 */     GIR_RootConstrainSelectedInstOperands,
     /* 139944 */     // GIR_Coverage, 1653,
     /* 139944 */     GIR_EraseRootFromParent_Done,
     /* 139945 */   // Label 2763: @139945
     /* 139945 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(139981), // Rule ID 1654 //
     /* 139950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139972 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 139975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139979 */     GIR_RootConstrainSelectedInstOperands,
     /* 139980 */     // GIR_Coverage, 1654,
     /* 139980 */     GIR_EraseRootFromParent_Done,
     /* 139981 */   // Label 2764: @139981
     /* 139981 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(140017), // Rule ID 1655 //
     /* 139986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140008 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 140008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 140011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140015 */     GIR_RootConstrainSelectedInstOperands,
     /* 140016 */     // GIR_Coverage, 1655,
     /* 140016 */     GIR_EraseRootFromParent_Done,
     /* 140017 */   // Label 2765: @140017
     /* 140017 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(140053), // Rule ID 1656 //
     /* 140022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 140030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140044 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 140044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 140047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140051 */     GIR_RootConstrainSelectedInstOperands,
     /* 140052 */     // GIR_Coverage, 1656,
     /* 140052 */     GIR_EraseRootFromParent_Done,
     /* 140053 */   // Label 2766: @140053
     /* 140053 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(140089), // Rule ID 1657 //
     /* 140058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 140066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140080 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 140080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 140083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140087 */     GIR_RootConstrainSelectedInstOperands,
     /* 140088 */     // GIR_Coverage, 1657,
     /* 140088 */     GIR_EraseRootFromParent_Done,
     /* 140089 */   // Label 2767: @140089
     /* 140089 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(140125), // Rule ID 1663 //
     /* 140094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 140102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140116 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 140116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 140119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140123 */     GIR_RootConstrainSelectedInstOperands,
     /* 140124 */     // GIR_Coverage, 1663,
     /* 140124 */     GIR_EraseRootFromParent_Done,
     /* 140125 */   // Label 2768: @140125
     /* 140125 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(140161), // Rule ID 1936 //
     /* 140130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 140138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140152 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 140155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140159 */     GIR_RootConstrainSelectedInstOperands,
     /* 140160 */     // GIR_Coverage, 1936,
     /* 140160 */     GIR_EraseRootFromParent_Done,
     /* 140161 */   // Label 2769: @140161
     /* 140161 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(140197), // Rule ID 1938 //
     /* 140166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 140174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140188 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 140191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140195 */     GIR_RootConstrainSelectedInstOperands,
     /* 140196 */     // GIR_Coverage, 1938,
     /* 140196 */     GIR_EraseRootFromParent_Done,
     /* 140197 */   // Label 2770: @140197
     /* 140197 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(140233), // Rule ID 1940 //
     /* 140202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 140210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140224 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 140227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140231 */     GIR_RootConstrainSelectedInstOperands,
     /* 140232 */     // GIR_Coverage, 1940,
     /* 140232 */     GIR_EraseRootFromParent_Done,
     /* 140233 */   // Label 2771: @140233
     /* 140233 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(140269), // Rule ID 1942 //
     /* 140238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 140246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140260 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 140263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140267 */     GIR_RootConstrainSelectedInstOperands,
     /* 140268 */     // GIR_Coverage, 1942,
     /* 140268 */     GIR_EraseRootFromParent_Done,
     /* 140269 */   // Label 2772: @140269
     /* 140269 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(140305), // Rule ID 1944 //
     /* 140274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 140282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140296 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 140299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140303 */     GIR_RootConstrainSelectedInstOperands,
     /* 140304 */     // GIR_Coverage, 1944,
     /* 140304 */     GIR_EraseRootFromParent_Done,
     /* 140305 */   // Label 2773: @140305
     /* 140305 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(140341), // Rule ID 1946 //
     /* 140310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 140318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140332 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 140335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140339 */     GIR_RootConstrainSelectedInstOperands,
     /* 140340 */     // GIR_Coverage, 1946,
     /* 140340 */     GIR_EraseRootFromParent_Done,
     /* 140341 */   // Label 2774: @140341
     /* 140341 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(140377), // Rule ID 1948 //
     /* 140346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 140354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140368 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 140371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140375 */     GIR_RootConstrainSelectedInstOperands,
     /* 140376 */     // GIR_Coverage, 1948,
     /* 140376 */     GIR_EraseRootFromParent_Done,
     /* 140377 */   // Label 2775: @140377
     /* 140377 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(140413), // Rule ID 1950 //
     /* 140382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 140390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140404 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 140407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140411 */     GIR_RootConstrainSelectedInstOperands,
     /* 140412 */     // GIR_Coverage, 1950,
     /* 140412 */     GIR_EraseRootFromParent_Done,
     /* 140413 */   // Label 2776: @140413
     /* 140413 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(140449), // Rule ID 1952 //
     /* 140418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 140426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140440 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 140443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140447 */     GIR_RootConstrainSelectedInstOperands,
     /* 140448 */     // GIR_Coverage, 1952,
     /* 140448 */     GIR_EraseRootFromParent_Done,
     /* 140449 */   // Label 2777: @140449
     /* 140449 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(140485), // Rule ID 1954 //
     /* 140454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140476 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 140479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140483 */     GIR_RootConstrainSelectedInstOperands,
     /* 140484 */     // GIR_Coverage, 1954,
     /* 140484 */     GIR_EraseRootFromParent_Done,
     /* 140485 */   // Label 2778: @140485
     /* 140485 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(140521), // Rule ID 1956 //
     /* 140490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140512 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 140515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140519 */     GIR_RootConstrainSelectedInstOperands,
     /* 140520 */     // GIR_Coverage, 1956,
     /* 140520 */     GIR_EraseRootFromParent_Done,
     /* 140521 */   // Label 2779: @140521
     /* 140521 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(140557), // Rule ID 1958 //
     /* 140526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140548 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 140551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140555 */     GIR_RootConstrainSelectedInstOperands,
     /* 140556 */     // GIR_Coverage, 1958,
     /* 140556 */     GIR_EraseRootFromParent_Done,
     /* 140557 */   // Label 2780: @140557
     /* 140557 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(140593), // Rule ID 2296 //
     /* 140562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 140570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140584 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 140587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140591 */     GIR_RootConstrainSelectedInstOperands,
     /* 140592 */     // GIR_Coverage, 2296,
     /* 140592 */     GIR_EraseRootFromParent_Done,
     /* 140593 */   // Label 2781: @140593
     /* 140593 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(140629), // Rule ID 2297 //
     /* 140598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 140606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140620 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 140623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140627 */     GIR_RootConstrainSelectedInstOperands,
     /* 140628 */     // GIR_Coverage, 2297,
     /* 140628 */     GIR_EraseRootFromParent_Done,
     /* 140629 */   // Label 2782: @140629
     /* 140629 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(140665), // Rule ID 2305 //
     /* 140634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 140637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 140642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140656 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 140656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 140659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140663 */     GIR_RootConstrainSelectedInstOperands,
     /* 140664 */     // GIR_Coverage, 2305,
     /* 140664 */     GIR_EraseRootFromParent_Done,
     /* 140665 */   // Label 2783: @140665
     /* 140665 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(140701), // Rule ID 2506 //
     /* 140670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 140678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140692 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 140692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 140695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140699 */     GIR_RootConstrainSelectedInstOperands,
     /* 140700 */     // GIR_Coverage, 2506,
     /* 140700 */     GIR_EraseRootFromParent_Done,
     /* 140701 */   // Label 2784: @140701
     /* 140701 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(140740), // Rule ID 3528 //
     /* 140706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 140717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 140720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140728 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 140728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 140731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140738 */     GIR_RootConstrainSelectedInstOperands,
     /* 140739 */     // GIR_Coverage, 3528,
     /* 140739 */     GIR_EraseRootFromParent_Done,
     /* 140740 */   // Label 2785: @140740
     /* 140740 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(140779), // Rule ID 3529 //
     /* 140745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 140756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 140759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140767 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 140767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 140770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140777 */     GIR_RootConstrainSelectedInstOperands,
     /* 140778 */     // GIR_Coverage, 3529,
     /* 140778 */     GIR_EraseRootFromParent_Done,
     /* 140779 */   // Label 2786: @140779
     /* 140779 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(140818), // Rule ID 3530 //
     /* 140784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 140795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 140798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 140806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 140809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140816 */     GIR_RootConstrainSelectedInstOperands,
     /* 140817 */     // GIR_Coverage, 3530,
     /* 140817 */     GIR_EraseRootFromParent_Done,
     /* 140818 */   // Label 2787: @140818
     /* 140818 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(140857), // Rule ID 3531 //
     /* 140823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 140834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 140837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140845 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 140845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 140848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140855 */     GIR_RootConstrainSelectedInstOperands,
     /* 140856 */     // GIR_Coverage, 3531,
     /* 140856 */     GIR_EraseRootFromParent_Done,
     /* 140857 */   // Label 2788: @140857
     /* 140857 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(140913), // Rule ID 3535 //
     /* 140862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 140873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 140876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1535:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 140884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 140901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140911 */     GIR_RootConstrainSelectedInstOperands,
     /* 140912 */     // GIR_Coverage, 3535,
     /* 140912 */     GIR_EraseRootFromParent_Done,
     /* 140913 */   // Label 2789: @140913
     /* 140913 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(140969), // Rule ID 3536 //
     /* 140918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 140929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 140932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1535:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 140940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 140957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140967 */     GIR_RootConstrainSelectedInstOperands,
     /* 140968 */     // GIR_Coverage, 3536,
     /* 140968 */     GIR_EraseRootFromParent_Done,
     /* 140969 */   // Label 2790: @140969
     /* 140969 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(141025), // Rule ID 3537 //
     /* 140974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 140985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 140988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1535:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 140996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 141013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 141015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 141023 */     GIR_RootConstrainSelectedInstOperands,
     /* 141024 */     // GIR_Coverage, 3537,
     /* 141024 */     GIR_EraseRootFromParent_Done,
     /* 141025 */   // Label 2791: @141025
     /* 141025 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(141081), // Rule ID 3538 //
     /* 141030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 141033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 141038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 141041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 141044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 141048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 141052 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1535:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 141052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 141055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 141069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 141071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 141079 */     GIR_RootConstrainSelectedInstOperands,
     /* 141080 */     // GIR_Coverage, 3538,
     /* 141080 */     GIR_EraseRootFromParent_Done,
     /* 141081 */   // Label 2792: @141081
     /* 141081 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(141114), // Rule ID 3951 //
     /* 141086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 141091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141105 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 141105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 141108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141112 */     GIR_RootConstrainSelectedInstOperands,
     /* 141113 */     // GIR_Coverage, 3951,
     /* 141113 */     GIR_EraseRootFromParent_Done,
     /* 141114 */   // Label 2793: @141114
     /* 141114 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(141179), // Rule ID 3952 //
     /* 141119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 141124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141138 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 141138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 141145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 141154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 141168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141178 */     // GIR_Coverage, 3952,
     /* 141178 */     GIR_EraseRootFromParent_Done,
     /* 141179 */   // Label 2794: @141179
     /* 141179 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(141212), // Rule ID 4720 //
     /* 141184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 141189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141203 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 141206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141210 */     GIR_RootConstrainSelectedInstOperands,
     /* 141211 */     // GIR_Coverage, 4720,
     /* 141211 */     GIR_EraseRootFromParent_Done,
     /* 141212 */   // Label 2795: @141212
     /* 141212 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(141245), // Rule ID 4721 //
     /* 141217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 141222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141236 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 141239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141243 */     GIR_RootConstrainSelectedInstOperands,
     /* 141244 */     // GIR_Coverage, 4721,
     /* 141244 */     GIR_EraseRootFromParent_Done,
     /* 141245 */   // Label 2796: @141245
     /* 141245 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(141278), // Rule ID 4722 //
     /* 141250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 141255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141269 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 141272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141276 */     GIR_RootConstrainSelectedInstOperands,
     /* 141277 */     // GIR_Coverage, 4722,
     /* 141277 */     GIR_EraseRootFromParent_Done,
     /* 141278 */   // Label 2797: @141278
     /* 141278 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(141311), // Rule ID 4723 //
     /* 141283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 141288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141302 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 141305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141309 */     GIR_RootConstrainSelectedInstOperands,
     /* 141310 */     // GIR_Coverage, 4723,
     /* 141310 */     GIR_EraseRootFromParent_Done,
     /* 141311 */   // Label 2798: @141311
     /* 141311 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(141344), // Rule ID 4837 //
     /* 141316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 141321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141335 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 141335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 141338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141342 */     GIR_RootConstrainSelectedInstOperands,
     /* 141343 */     // GIR_Coverage, 4837,
     /* 141343 */     GIR_EraseRootFromParent_Done,
     /* 141344 */   // Label 2799: @141344
     /* 141344 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(141377), // Rule ID 4847 //
     /* 141349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 141354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141368 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 141368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 141371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141375 */     GIR_RootConstrainSelectedInstOperands,
     /* 141376 */     // GIR_Coverage, 4847,
     /* 141376 */     GIR_EraseRootFromParent_Done,
     /* 141377 */   // Label 2800: @141377
     /* 141377 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(141413), // Rule ID 5185 //
     /* 141382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 141390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141404 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 141404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 141407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141411 */     GIR_RootConstrainSelectedInstOperands,
     /* 141412 */     // GIR_Coverage, 5185,
     /* 141412 */     GIR_EraseRootFromParent_Done,
     /* 141413 */   // Label 2801: @141413
     /* 141413 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(141446), // Rule ID 5188 //
     /* 141418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141437 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 141440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141444 */     GIR_RootConstrainSelectedInstOperands,
     /* 141445 */     // GIR_Coverage, 5188,
     /* 141445 */     GIR_EraseRootFromParent_Done,
     /* 141446 */   // Label 2802: @141446
     /* 141446 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(141479), // Rule ID 5189 //
     /* 141451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141470 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 141473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141477 */     GIR_RootConstrainSelectedInstOperands,
     /* 141478 */     // GIR_Coverage, 5189,
     /* 141478 */     GIR_EraseRootFromParent_Done,
     /* 141479 */   // Label 2803: @141479
     /* 141479 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(141512), // Rule ID 5190 //
     /* 141484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141503 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 141506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141510 */     GIR_RootConstrainSelectedInstOperands,
     /* 141511 */     // GIR_Coverage, 5190,
     /* 141511 */     GIR_EraseRootFromParent_Done,
     /* 141512 */   // Label 2804: @141512
     /* 141512 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(141545), // Rule ID 5191 //
     /* 141517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141536 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 141539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141543 */     GIR_RootConstrainSelectedInstOperands,
     /* 141544 */     // GIR_Coverage, 5191,
     /* 141544 */     GIR_EraseRootFromParent_Done,
     /* 141545 */   // Label 2805: @141545
     /* 141545 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(141578), // Rule ID 5192 //
     /* 141550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141569 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 141572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141576 */     GIR_RootConstrainSelectedInstOperands,
     /* 141577 */     // GIR_Coverage, 5192,
     /* 141577 */     GIR_EraseRootFromParent_Done,
     /* 141578 */   // Label 2806: @141578
     /* 141578 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(141611), // Rule ID 5193 //
     /* 141583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141602 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 141605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141609 */     GIR_RootConstrainSelectedInstOperands,
     /* 141610 */     // GIR_Coverage, 5193,
     /* 141610 */     GIR_EraseRootFromParent_Done,
     /* 141611 */   // Label 2807: @141611
     /* 141611 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(141644), // Rule ID 5194 //
     /* 141616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141635 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 141638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141642 */     GIR_RootConstrainSelectedInstOperands,
     /* 141643 */     // GIR_Coverage, 5194,
     /* 141643 */     GIR_EraseRootFromParent_Done,
     /* 141644 */   // Label 2808: @141644
     /* 141644 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(141677), // Rule ID 5195 //
     /* 141649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141668 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 141671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141675 */     GIR_RootConstrainSelectedInstOperands,
     /* 141676 */     // GIR_Coverage, 5195,
     /* 141676 */     GIR_EraseRootFromParent_Done,
     /* 141677 */   // Label 2809: @141677
     /* 141677 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(141710), // Rule ID 5196 //
     /* 141682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 141687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141701 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 141704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141708 */     GIR_RootConstrainSelectedInstOperands,
     /* 141709 */     // GIR_Coverage, 5196,
     /* 141709 */     GIR_EraseRootFromParent_Done,
     /* 141710 */   // Label 2810: @141710
     /* 141710 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(141743), // Rule ID 5197 //
     /* 141715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 141720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141734 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 141737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141741 */     GIR_RootConstrainSelectedInstOperands,
     /* 141742 */     // GIR_Coverage, 5197,
     /* 141742 */     GIR_EraseRootFromParent_Done,
     /* 141743 */   // Label 2811: @141743
     /* 141743 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(141776), // Rule ID 5198 //
     /* 141748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141767 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 141770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141774 */     GIR_RootConstrainSelectedInstOperands,
     /* 141775 */     // GIR_Coverage, 5198,
     /* 141775 */     GIR_EraseRootFromParent_Done,
     /* 141776 */   // Label 2812: @141776
     /* 141776 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(141809), // Rule ID 5199 //
     /* 141781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141800 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 141803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141807 */     GIR_RootConstrainSelectedInstOperands,
     /* 141808 */     // GIR_Coverage, 5199,
     /* 141808 */     GIR_EraseRootFromParent_Done,
     /* 141809 */   // Label 2813: @141809
     /* 141809 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(141842), // Rule ID 5200 //
     /* 141814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141833 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141840 */     GIR_RootConstrainSelectedInstOperands,
     /* 141841 */     // GIR_Coverage, 5200,
     /* 141841 */     GIR_EraseRootFromParent_Done,
     /* 141842 */   // Label 2814: @141842
     /* 141842 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(141875), // Rule ID 5201 //
     /* 141847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141866 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141873 */     GIR_RootConstrainSelectedInstOperands,
     /* 141874 */     // GIR_Coverage, 5201,
     /* 141874 */     GIR_EraseRootFromParent_Done,
     /* 141875 */   // Label 2815: @141875
     /* 141875 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(141908), // Rule ID 5213 //
     /* 141880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141899 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 141902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141906 */     GIR_RootConstrainSelectedInstOperands,
     /* 141907 */     // GIR_Coverage, 5213,
     /* 141907 */     GIR_EraseRootFromParent_Done,
     /* 141908 */   // Label 2816: @141908
     /* 141908 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(141941), // Rule ID 5214 //
     /* 141913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141932 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 141935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141939 */     GIR_RootConstrainSelectedInstOperands,
     /* 141940 */     // GIR_Coverage, 5214,
     /* 141940 */     GIR_EraseRootFromParent_Done,
     /* 141941 */   // Label 2817: @141941
     /* 141941 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(141974), // Rule ID 5215 //
     /* 141946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141965 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 141968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141972 */     GIR_RootConstrainSelectedInstOperands,
     /* 141973 */     // GIR_Coverage, 5215,
     /* 141973 */     GIR_EraseRootFromParent_Done,
     /* 141974 */   // Label 2818: @141974
     /* 141974 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(142007), // Rule ID 5216 //
     /* 141979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141998 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 142001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142005 */     GIR_RootConstrainSelectedInstOperands,
     /* 142006 */     // GIR_Coverage, 5216,
     /* 142006 */     GIR_EraseRootFromParent_Done,
     /* 142007 */   // Label 2819: @142007
     /* 142007 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(142040), // Rule ID 5217 //
     /* 142012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 142017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142031 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 142034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142038 */     GIR_RootConstrainSelectedInstOperands,
     /* 142039 */     // GIR_Coverage, 5217,
     /* 142039 */     GIR_EraseRootFromParent_Done,
     /* 142040 */   // Label 2820: @142040
     /* 142040 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(142073), // Rule ID 5218 //
     /* 142045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 142050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142064 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 142067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142071 */     GIR_RootConstrainSelectedInstOperands,
     /* 142072 */     // GIR_Coverage, 5218,
     /* 142072 */     GIR_EraseRootFromParent_Done,
     /* 142073 */   // Label 2821: @142073
     /* 142073 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(142106), // Rule ID 5219 //
     /* 142078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 142083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142097 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 142097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 142100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142104 */     GIR_RootConstrainSelectedInstOperands,
     /* 142105 */     // GIR_Coverage, 5219,
     /* 142105 */     GIR_EraseRootFromParent_Done,
     /* 142106 */   // Label 2822: @142106
     /* 142106 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(142139), // Rule ID 5543 //
     /* 142111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 142116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142130 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 142133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142137 */     GIR_RootConstrainSelectedInstOperands,
     /* 142138 */     // GIR_Coverage, 5543,
     /* 142138 */     GIR_EraseRootFromParent_Done,
     /* 142139 */   // Label 2823: @142139
     /* 142139 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(142224), // Rule ID 5544 //
     /* 142144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 142149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142163 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 142163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 142166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 142170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142197 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 142204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 142217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142222 */     GIR_RootConstrainSelectedInstOperands,
     /* 142223 */     // GIR_Coverage, 5544,
     /* 142223 */     GIR_EraseRootFromParent_Done,
     /* 142224 */   // Label 2824: @142224
     /* 142224 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(142257), // Rule ID 5545 //
     /* 142229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 142234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142248 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 142251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142255 */     GIR_RootConstrainSelectedInstOperands,
     /* 142256 */     // GIR_Coverage, 5545,
     /* 142256 */     GIR_EraseRootFromParent_Done,
     /* 142257 */   // Label 2825: @142257
     /* 142257 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(142290), // Rule ID 5547 //
     /* 142262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 142267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142281 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 142284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142288 */     GIR_RootConstrainSelectedInstOperands,
     /* 142289 */     // GIR_Coverage, 5547,
     /* 142289 */     GIR_EraseRootFromParent_Done,
     /* 142290 */   // Label 2826: @142290
     /* 142290 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(142323), // Rule ID 5549 //
     /* 142295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 142300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142314 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 142317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142321 */     GIR_RootConstrainSelectedInstOperands,
     /* 142322 */     // GIR_Coverage, 5549,
     /* 142322 */     GIR_EraseRootFromParent_Done,
     /* 142323 */   // Label 2827: @142323
     /* 142323 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(142356), // Rule ID 5551 //
     /* 142328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 142333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142347 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 142350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142354 */     GIR_RootConstrainSelectedInstOperands,
     /* 142355 */     // GIR_Coverage, 5551,
     /* 142355 */     GIR_EraseRootFromParent_Done,
     /* 142356 */   // Label 2828: @142356
     /* 142356 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(142389), // Rule ID 5553 //
     /* 142361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 142366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142380 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 142383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142387 */     GIR_RootConstrainSelectedInstOperands,
     /* 142388 */     // GIR_Coverage, 5553,
     /* 142388 */     GIR_EraseRootFromParent_Done,
     /* 142389 */   // Label 2829: @142389
     /* 142389 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(142422), // Rule ID 5555 //
     /* 142394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142413 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 142416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142420 */     GIR_RootConstrainSelectedInstOperands,
     /* 142421 */     // GIR_Coverage, 5555,
     /* 142421 */     GIR_EraseRootFromParent_Done,
     /* 142422 */   // Label 2830: @142422
     /* 142422 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(142455), // Rule ID 5557 //
     /* 142427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142446 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 142449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142453 */     GIR_RootConstrainSelectedInstOperands,
     /* 142454 */     // GIR_Coverage, 5557,
     /* 142454 */     GIR_EraseRootFromParent_Done,
     /* 142455 */   // Label 2831: @142455
     /* 142455 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(142488), // Rule ID 5559 //
     /* 142460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142479 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 142482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142486 */     GIR_RootConstrainSelectedInstOperands,
     /* 142487 */     // GIR_Coverage, 5559,
     /* 142487 */     GIR_EraseRootFromParent_Done,
     /* 142488 */   // Label 2832: @142488
     /* 142488 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(142521), // Rule ID 5561 //
     /* 142493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142512 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 142515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142519 */     GIR_RootConstrainSelectedInstOperands,
     /* 142520 */     // GIR_Coverage, 5561,
     /* 142520 */     GIR_EraseRootFromParent_Done,
     /* 142521 */   // Label 2833: @142521
     /* 142521 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(142554), // Rule ID 12869 //
     /* 142526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142545 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142552 */     GIR_RootConstrainSelectedInstOperands,
     /* 142553 */     // GIR_Coverage, 12869,
     /* 142553 */     GIR_EraseRootFromParent_Done,
     /* 142554 */   // Label 2834: @142554
     /* 142554 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(142587), // Rule ID 12871 //
     /* 142559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142578 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142585 */     GIR_RootConstrainSelectedInstOperands,
     /* 142586 */     // GIR_Coverage, 12871,
     /* 142586 */     GIR_EraseRootFromParent_Done,
     /* 142587 */   // Label 2835: @142587
     /* 142587 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(142620), // Rule ID 12873 //
     /* 142592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142611 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142618 */     GIR_RootConstrainSelectedInstOperands,
     /* 142619 */     // GIR_Coverage, 12873,
     /* 142619 */     GIR_EraseRootFromParent_Done,
     /* 142620 */   // Label 2836: @142620
     /* 142620 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(142653), // Rule ID 12875 //
     /* 142625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142644 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142651 */     GIR_RootConstrainSelectedInstOperands,
     /* 142652 */     // GIR_Coverage, 12875,
     /* 142652 */     GIR_EraseRootFromParent_Done,
     /* 142653 */   // Label 2837: @142653
     /* 142653 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(142768), // Rule ID 12876 //
     /* 142658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142677 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142689 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142750 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142767 */     // GIR_Coverage, 12876,
     /* 142767 */     GIR_EraseRootFromParent_Done,
     /* 142768 */   // Label 2838: @142768
     /* 142768 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(142801), // Rule ID 12878 //
     /* 142773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142792 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142799 */     GIR_RootConstrainSelectedInstOperands,
     /* 142800 */     // GIR_Coverage, 12878,
     /* 142800 */     GIR_EraseRootFromParent_Done,
     /* 142801 */   // Label 2839: @142801
     /* 142801 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(142834), // Rule ID 12880 //
     /* 142806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142825 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142832 */     GIR_RootConstrainSelectedInstOperands,
     /* 142833 */     // GIR_Coverage, 12880,
     /* 142833 */     GIR_EraseRootFromParent_Done,
     /* 142834 */   // Label 2840: @142834
     /* 142834 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(142867), // Rule ID 12882 //
     /* 142839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142858 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142865 */     GIR_RootConstrainSelectedInstOperands,
     /* 142866 */     // GIR_Coverage, 12882,
     /* 142866 */     GIR_EraseRootFromParent_Done,
     /* 142867 */   // Label 2841: @142867
     /* 142867 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(142900), // Rule ID 12884 //
     /* 142872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142891 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142898 */     GIR_RootConstrainSelectedInstOperands,
     /* 142899 */     // GIR_Coverage, 12884,
     /* 142899 */     GIR_EraseRootFromParent_Done,
     /* 142900 */   // Label 2842: @142900
     /* 142900 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(143015), // Rule ID 12885 //
     /* 142905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142924 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142924 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142927 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142931 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142936 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142997 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143014 */     // GIR_Coverage, 12885,
     /* 143014 */     GIR_EraseRootFromParent_Done,
     /* 143015 */   // Label 2843: @143015
     /* 143015 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(143134), // Rule ID 12886 //
     /* 143020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 143025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143039 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143039 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143042 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 143046 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143051 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143055 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143133 */     // GIR_Coverage, 12886,
     /* 143133 */     GIR_EraseRootFromParent_Done,
     /* 143134 */   // Label 2844: @143134
     /* 143134 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(143249), // Rule ID 12887 //
     /* 143139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 143144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143158 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 143158 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143161 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 143165 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143170 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 143179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 143193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143231 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 143238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143248 */     // GIR_Coverage, 12887,
     /* 143248 */     GIR_EraseRootFromParent_Done,
     /* 143249 */   // Label 2845: @143249
     /* 143249 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(143368), // Rule ID 12888 //
     /* 143254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 143259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143273 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 143280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143285 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143289 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143350 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143367 */     // GIR_Coverage, 12888,
     /* 143367 */     GIR_EraseRootFromParent_Done,
     /* 143368 */   // Label 2846: @143368
     /* 143368 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(143483), // Rule ID 12889 //
     /* 143373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 143378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143392 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 143392 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143395 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 143399 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143404 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 143413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 143427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 143472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143482 */     // GIR_Coverage, 12889,
     /* 143482 */     GIR_EraseRootFromParent_Done,
     /* 143483 */   // Label 2847: @143483
     /* 143483 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(143516), // Rule ID 12891 //
     /* 143488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143507 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 143510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143514 */     GIR_RootConstrainSelectedInstOperands,
     /* 143515 */     // GIR_Coverage, 12891,
     /* 143515 */     GIR_EraseRootFromParent_Done,
     /* 143516 */   // Label 2848: @143516
     /* 143516 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(143549), // Rule ID 12893 //
     /* 143521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143540 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143547 */     GIR_RootConstrainSelectedInstOperands,
     /* 143548 */     // GIR_Coverage, 12893,
     /* 143548 */     GIR_EraseRootFromParent_Done,
     /* 143549 */   // Label 2849: @143549
     /* 143549 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(143582), // Rule ID 12895 //
     /* 143554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143573 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 143576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143580 */     GIR_RootConstrainSelectedInstOperands,
     /* 143581 */     // GIR_Coverage, 12895,
     /* 143581 */     GIR_EraseRootFromParent_Done,
     /* 143582 */   // Label 2850: @143582
     /* 143582 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(143615), // Rule ID 12897 //
     /* 143587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143606 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 143609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143613 */     GIR_RootConstrainSelectedInstOperands,
     /* 143614 */     // GIR_Coverage, 12897,
     /* 143614 */     GIR_EraseRootFromParent_Done,
     /* 143615 */   // Label 2851: @143615
     /* 143615 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(143730), // Rule ID 12898 //
     /* 143620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143639 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143639 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143642 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 143646 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143651 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143689 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143712 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143729 */     // GIR_Coverage, 12898,
     /* 143729 */     GIR_EraseRootFromParent_Done,
     /* 143730 */   // Label 2852: @143730
     /* 143730 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(143849), // Rule ID 12899 //
     /* 143735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143754 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143754 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143757 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 143761 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143766 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143770 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143831 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143848 */     // GIR_Coverage, 12899,
     /* 143848 */     GIR_EraseRootFromParent_Done,
     /* 143849 */   // Label 2853: @143849
     /* 143849 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(143882), // Rule ID 12901 //
     /* 143854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143873 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 143876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143880 */     GIR_RootConstrainSelectedInstOperands,
     /* 143881 */     // GIR_Coverage, 12901,
     /* 143881 */     GIR_EraseRootFromParent_Done,
     /* 143882 */   // Label 2854: @143882
     /* 143882 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(143915), // Rule ID 12903 //
     /* 143887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143906 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 143909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143913 */     GIR_RootConstrainSelectedInstOperands,
     /* 143914 */     // GIR_Coverage, 12903,
     /* 143914 */     GIR_EraseRootFromParent_Done,
     /* 143915 */   // Label 2855: @143915
     /* 143915 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(143948), // Rule ID 12905 //
     /* 143920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143939 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 143942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143946 */     GIR_RootConstrainSelectedInstOperands,
     /* 143947 */     // GIR_Coverage, 12905,
     /* 143947 */     GIR_EraseRootFromParent_Done,
     /* 143948 */   // Label 2856: @143948
     /* 143948 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(143981), // Rule ID 12907 //
     /* 143953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143972 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143979 */     GIR_RootConstrainSelectedInstOperands,
     /* 143980 */     // GIR_Coverage, 12907,
     /* 143980 */     GIR_EraseRootFromParent_Done,
     /* 143981 */   // Label 2857: @143981
     /* 143981 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(144096), // Rule ID 12908 //
     /* 143986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144005 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 144012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144017 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144095 */     // GIR_Coverage, 12908,
     /* 144095 */     GIR_EraseRootFromParent_Done,
     /* 144096 */   // Label 2858: @144096
     /* 144096 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(144215), // Rule ID 12909 //
     /* 144101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 144106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144120 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144120 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144123 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 144127 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144132 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144136 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144214 */     // GIR_Coverage, 12909,
     /* 144214 */     GIR_EraseRootFromParent_Done,
     /* 144215 */   // Label 2859: @144215
     /* 144215 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(144248), // Rule ID 12911 //
     /* 144220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144239 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 144242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144246 */     GIR_RootConstrainSelectedInstOperands,
     /* 144247 */     // GIR_Coverage, 12911,
     /* 144247 */     GIR_EraseRootFromParent_Done,
     /* 144248 */   // Label 2860: @144248
     /* 144248 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(144281), // Rule ID 12913 //
     /* 144253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144272 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 144275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144279 */     GIR_RootConstrainSelectedInstOperands,
     /* 144280 */     // GIR_Coverage, 12913,
     /* 144280 */     GIR_EraseRootFromParent_Done,
     /* 144281 */   // Label 2861: @144281
     /* 144281 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(144314), // Rule ID 12915 //
     /* 144286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144305 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 144308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144312 */     GIR_RootConstrainSelectedInstOperands,
     /* 144313 */     // GIR_Coverage, 12915,
     /* 144313 */     GIR_EraseRootFromParent_Done,
     /* 144314 */   // Label 2862: @144314
     /* 144314 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(144347), // Rule ID 12917 //
     /* 144319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144338 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 144341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144345 */     GIR_RootConstrainSelectedInstOperands,
     /* 144346 */     // GIR_Coverage, 12917,
     /* 144346 */     GIR_EraseRootFromParent_Done,
     /* 144347 */   // Label 2863: @144347
     /* 144347 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(144462), // Rule ID 12918 //
     /* 144352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144371 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 144378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144383 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144444 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144461 */     // GIR_Coverage, 12918,
     /* 144461 */     GIR_EraseRootFromParent_Done,
     /* 144462 */   // Label 2864: @144462
     /* 144462 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(144581), // Rule ID 12919 //
     /* 144467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144486 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144486 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144489 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 144493 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144498 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144502 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144508 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144511 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144515 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144563 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144580 */     // GIR_Coverage, 12919,
     /* 144580 */     GIR_EraseRootFromParent_Done,
     /* 144581 */   // Label 2865: @144581
     /* 144581 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(144614), // Rule ID 12921 //
     /* 144586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144605 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 144608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144612 */     GIR_RootConstrainSelectedInstOperands,
     /* 144613 */     // GIR_Coverage, 12921,
     /* 144613 */     GIR_EraseRootFromParent_Done,
     /* 144614 */   // Label 2866: @144614
     /* 144614 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(144647), // Rule ID 12923 //
     /* 144619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144638 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 144641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144645 */     GIR_RootConstrainSelectedInstOperands,
     /* 144646 */     // GIR_Coverage, 12923,
     /* 144646 */     GIR_EraseRootFromParent_Done,
     /* 144647 */   // Label 2867: @144647
     /* 144647 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(144680), // Rule ID 12925 //
     /* 144652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144671 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 144674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144678 */     GIR_RootConstrainSelectedInstOperands,
     /* 144679 */     // GIR_Coverage, 12925,
     /* 144679 */     GIR_EraseRootFromParent_Done,
     /* 144680 */   // Label 2868: @144680
     /* 144680 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(144713), // Rule ID 12927 //
     /* 144685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144704 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 144707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144711 */     GIR_RootConstrainSelectedInstOperands,
     /* 144712 */     // GIR_Coverage, 12927,
     /* 144712 */     GIR_EraseRootFromParent_Done,
     /* 144713 */   // Label 2869: @144713
     /* 144713 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(144828), // Rule ID 12928 //
     /* 144718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144737 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 144744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144749 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144810 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144827 */     // GIR_Coverage, 12928,
     /* 144827 */     GIR_EraseRootFromParent_Done,
     /* 144828 */   // Label 2870: @144828
     /* 144828 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(144947), // Rule ID 12929 //
     /* 144833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144852 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 144859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144864 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144868 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144946 */     // GIR_Coverage, 12929,
     /* 144946 */     GIR_EraseRootFromParent_Done,
     /* 144947 */   // Label 2871: @144947
     /* 144947 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(144979), // Rule ID 2384 //
     /* 144952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 144960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1575:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 144973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144977 */     GIR_RootConstrainSelectedInstOperands,
     /* 144978 */     // GIR_Coverage, 2384,
     /* 144978 */     GIR_EraseRootFromParent_Done,
     /* 144979 */   // Label 2872: @144979
     /* 144979 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145011), // Rule ID 2385 //
     /* 144984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 144992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 145002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 145005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 145009 */     GIR_RootConstrainSelectedInstOperands,
     /* 145010 */     // GIR_Coverage, 2385,
     /* 145010 */     GIR_EraseRootFromParent_Done,
     /* 145011 */   // Label 2873: @145011
     /* 145011 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(145043), // Rule ID 2386 //
     /* 145016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 145024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 145027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 145030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1577:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 145034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 145037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 145041 */     GIR_RootConstrainSelectedInstOperands,
     /* 145042 */     // GIR_Coverage, 2386,
     /* 145042 */     GIR_EraseRootFromParent_Done,
     /* 145043 */   // Label 2874: @145043
     /* 145043 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(145075), // Rule ID 3079 //
     /* 145048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 145056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 145069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145073 */     GIR_RootConstrainSelectedInstOperands,
     /* 145074 */     // GIR_Coverage, 3079,
     /* 145074 */     GIR_EraseRootFromParent_Done,
     /* 145075 */   // Label 2875: @145075
     /* 145075 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(145107), // Rule ID 3080 //
     /* 145080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 145088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 145101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145105 */     GIR_RootConstrainSelectedInstOperands,
     /* 145106 */     // GIR_Coverage, 3080,
     /* 145106 */     GIR_EraseRootFromParent_Done,
     /* 145107 */   // Label 2876: @145107
     /* 145107 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(145139), // Rule ID 3081 //
     /* 145112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 145120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 145133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145137 */     GIR_RootConstrainSelectedInstOperands,
     /* 145138 */     // GIR_Coverage, 3081,
     /* 145138 */     GIR_EraseRootFromParent_Done,
     /* 145139 */   // Label 2877: @145139
     /* 145139 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(145171), // Rule ID 3329 //
     /* 145144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 145152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 145155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 145158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145162 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1567:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 145162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 145165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145169 */     GIR_RootConstrainSelectedInstOperands,
     /* 145170 */     // GIR_Coverage, 3329,
     /* 145170 */     GIR_EraseRootFromParent_Done,
     /* 145171 */   // Label 2878: @145171
     /* 145171 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(145203), // Rule ID 3330 //
     /* 145176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 145184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 145187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 145190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1567:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 145194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 145197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145201 */     GIR_RootConstrainSelectedInstOperands,
     /* 145202 */     // GIR_Coverage, 3330,
     /* 145202 */     GIR_EraseRootFromParent_Done,
     /* 145203 */   // Label 2879: @145203
     /* 145203 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(145235), // Rule ID 3331 //
     /* 145208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 145216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 145219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 145222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1567:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 145226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 145229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145233 */     GIR_RootConstrainSelectedInstOperands,
     /* 145234 */     // GIR_Coverage, 3331,
     /* 145234 */     GIR_EraseRootFromParent_Done,
     /* 145235 */   // Label 2880: @145235
     /* 145235 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(145267), // Rule ID 3410 //
     /* 145240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 145243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 145248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145258 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1328:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 145261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145265 */     GIR_RootConstrainSelectedInstOperands,
     /* 145266 */     // GIR_Coverage, 3410,
     /* 145266 */     GIR_EraseRootFromParent_Done,
     /* 145267 */   // Label 2881: @145267
     /* 145267 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(145299), // Rule ID 3411 //
     /* 145272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 145275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 145280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145290 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1328:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 145293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145297 */     GIR_RootConstrainSelectedInstOperands,
     /* 145298 */     // GIR_Coverage, 3411,
     /* 145298 */     GIR_EraseRootFromParent_Done,
     /* 145299 */   // Label 2882: @145299
     /* 145299 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(145331), // Rule ID 3412 //
     /* 145304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 145307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 145312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 145315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1328:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 145325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145329 */     GIR_RootConstrainSelectedInstOperands,
     /* 145330 */     // GIR_Coverage, 3412,
     /* 145330 */     GIR_EraseRootFromParent_Done,
     /* 145331 */   // Label 2883: @145331
     /* 145331 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(145363), // Rule ID 3438 //
     /* 145336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 145339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 145344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 145350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1167:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 145354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 145357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 145359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145361 */     GIR_RootConstrainSelectedInstOperands,
     /* 145362 */     // GIR_Coverage, 3438,
     /* 145362 */     GIR_EraseRootFromParent_Done,
     /* 145363 */   // Label 2884: @145363
     /* 145363 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(145395), // Rule ID 4565 //
     /* 145368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145386 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 145386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 145389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145393 */     GIR_RootConstrainSelectedInstOperands,
     /* 145394 */     // GIR_Coverage, 4565,
     /* 145394 */     GIR_EraseRootFromParent_Done,
     /* 145395 */   // Label 2885: @145395
     /* 145395 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(145427), // Rule ID 4566 //
     /* 145400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145418 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 145418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 145421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145425 */     GIR_RootConstrainSelectedInstOperands,
     /* 145426 */     // GIR_Coverage, 4566,
     /* 145426 */     GIR_EraseRootFromParent_Done,
     /* 145427 */   // Label 2886: @145427
     /* 145427 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(145456), // Rule ID 4567 //
     /* 145432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145447 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 145450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145454 */     GIR_RootConstrainSelectedInstOperands,
     /* 145455 */     // GIR_Coverage, 4567,
     /* 145455 */     GIR_EraseRootFromParent_Done,
     /* 145456 */   // Label 2887: @145456
     /* 145456 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(145485), // Rule ID 4568 //
     /* 145461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145476 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 145479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145483 */     GIR_RootConstrainSelectedInstOperands,
     /* 145484 */     // GIR_Coverage, 4568,
     /* 145484 */     GIR_EraseRootFromParent_Done,
     /* 145485 */   // Label 2888: @145485
     /* 145485 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(145514), // Rule ID 4569 //
     /* 145490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145505 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 145508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145512 */     GIR_RootConstrainSelectedInstOperands,
     /* 145513 */     // GIR_Coverage, 4569,
     /* 145513 */     GIR_EraseRootFromParent_Done,
     /* 145514 */   // Label 2889: @145514
     /* 145514 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(145543), // Rule ID 4570 //
     /* 145519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145534 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 145537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145541 */     GIR_RootConstrainSelectedInstOperands,
     /* 145542 */     // GIR_Coverage, 4570,
     /* 145542 */     GIR_EraseRootFromParent_Done,
     /* 145543 */   // Label 2890: @145543
     /* 145543 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(145575), // Rule ID 4577 //
     /* 145548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145566 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 145566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 145569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145573 */     GIR_RootConstrainSelectedInstOperands,
     /* 145574 */     // GIR_Coverage, 4577,
     /* 145574 */     GIR_EraseRootFromParent_Done,
     /* 145575 */   // Label 2891: @145575
     /* 145575 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(145607), // Rule ID 4578 //
     /* 145580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145598 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 145598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 145601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145605 */     GIR_RootConstrainSelectedInstOperands,
     /* 145606 */     // GIR_Coverage, 4578,
     /* 145606 */     GIR_EraseRootFromParent_Done,
     /* 145607 */   // Label 2892: @145607
     /* 145607 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(145636), // Rule ID 4579 //
     /* 145612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145627 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 145630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145634 */     GIR_RootConstrainSelectedInstOperands,
     /* 145635 */     // GIR_Coverage, 4579,
     /* 145635 */     GIR_EraseRootFromParent_Done,
     /* 145636 */   // Label 2893: @145636
     /* 145636 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(145665), // Rule ID 4580 //
     /* 145641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145656 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 145659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145663 */     GIR_RootConstrainSelectedInstOperands,
     /* 145664 */     // GIR_Coverage, 4580,
     /* 145664 */     GIR_EraseRootFromParent_Done,
     /* 145665 */   // Label 2894: @145665
     /* 145665 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(145694), // Rule ID 4581 //
     /* 145670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145685 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 145688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145692 */     GIR_RootConstrainSelectedInstOperands,
     /* 145693 */     // GIR_Coverage, 4581,
     /* 145693 */     GIR_EraseRootFromParent_Done,
     /* 145694 */   // Label 2895: @145694
     /* 145694 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(145723), // Rule ID 4582 //
     /* 145699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145714 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 145717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145721 */     GIR_RootConstrainSelectedInstOperands,
     /* 145722 */     // GIR_Coverage, 4582,
     /* 145722 */     GIR_EraseRootFromParent_Done,
     /* 145723 */   // Label 2896: @145723
     /* 145723 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(145752), // Rule ID 4877 //
     /* 145728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145743 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 145746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145750 */     GIR_RootConstrainSelectedInstOperands,
     /* 145751 */     // GIR_Coverage, 4877,
     /* 145751 */     GIR_EraseRootFromParent_Done,
     /* 145752 */   // Label 2897: @145752
     /* 145752 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(145781), // Rule ID 4878 //
     /* 145757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145772 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 145775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145779 */     GIR_RootConstrainSelectedInstOperands,
     /* 145780 */     // GIR_Coverage, 4878,
     /* 145780 */     GIR_EraseRootFromParent_Done,
     /* 145781 */   // Label 2898: @145781
     /* 145781 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(145810), // Rule ID 4879 //
     /* 145786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145801 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 145804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145808 */     GIR_RootConstrainSelectedInstOperands,
     /* 145809 */     // GIR_Coverage, 4879,
     /* 145809 */     GIR_EraseRootFromParent_Done,
     /* 145810 */   // Label 2899: @145810
     /* 145810 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(145839), // Rule ID 4880 //
     /* 145815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145830 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 145833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145837 */     GIR_RootConstrainSelectedInstOperands,
     /* 145838 */     // GIR_Coverage, 4880,
     /* 145838 */     GIR_EraseRootFromParent_Done,
     /* 145839 */   // Label 2900: @145839
     /* 145839 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(145868), // Rule ID 4881 //
     /* 145844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145859 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 145859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 145862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145866 */     GIR_RootConstrainSelectedInstOperands,
     /* 145867 */     // GIR_Coverage, 4881,
     /* 145867 */     GIR_EraseRootFromParent_Done,
     /* 145868 */   // Label 2901: @145868
     /* 145868 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(145897), // Rule ID 4882 //
     /* 145873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145888 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 145891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145895 */     GIR_RootConstrainSelectedInstOperands,
     /* 145896 */     // GIR_Coverage, 4882,
     /* 145896 */     GIR_EraseRootFromParent_Done,
     /* 145897 */   // Label 2902: @145897
     /* 145897 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(145926), // Rule ID 4883 //
     /* 145902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 145920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145924 */     GIR_RootConstrainSelectedInstOperands,
     /* 145925 */     // GIR_Coverage, 4883,
     /* 145925 */     GIR_EraseRootFromParent_Done,
     /* 145926 */   // Label 2903: @145926
     /* 145926 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(145955), // Rule ID 4884 //
     /* 145931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145946 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 145949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145953 */     GIR_RootConstrainSelectedInstOperands,
     /* 145954 */     // GIR_Coverage, 4884,
     /* 145954 */     GIR_EraseRootFromParent_Done,
     /* 145955 */   // Label 2904: @145955
     /* 145955 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(145984), // Rule ID 4885 //
     /* 145960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145975 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 145978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145982 */     GIR_RootConstrainSelectedInstOperands,
     /* 145983 */     // GIR_Coverage, 4885,
     /* 145983 */     GIR_EraseRootFromParent_Done,
     /* 145984 */   // Label 2905: @145984
     /* 145984 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(146013), // Rule ID 4886 //
     /* 145989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146004 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 146004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 146007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146011 */     GIR_RootConstrainSelectedInstOperands,
     /* 146012 */     // GIR_Coverage, 4886,
     /* 146012 */     GIR_EraseRootFromParent_Done,
     /* 146013 */   // Label 2906: @146013
     /* 146013 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(146045), // Rule ID 8249 //
     /* 146018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 146021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 146026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 146029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1566:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 146036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 146039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146043 */     GIR_RootConstrainSelectedInstOperands,
     /* 146044 */     // GIR_Coverage, 8249,
     /* 146044 */     GIR_EraseRootFromParent_Done,
     /* 146045 */   // Label 2907: @146045
     /* 146045 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(146077), // Rule ID 8250 //
     /* 146050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 146053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 146058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 146061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 146064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1566:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 146068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 146071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146075 */     GIR_RootConstrainSelectedInstOperands,
     /* 146076 */     // GIR_Coverage, 8250,
     /* 146076 */     GIR_EraseRootFromParent_Done,
     /* 146077 */   // Label 2908: @146077
     /* 146077 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(146109), // Rule ID 8251 //
     /* 146082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 146085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 146090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 146093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 146096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1566:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 146100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 146103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146107 */     GIR_RootConstrainSelectedInstOperands,
     /* 146108 */     // GIR_Coverage, 8251,
     /* 146108 */     GIR_EraseRootFromParent_Done,
     /* 146109 */   // Label 2909: @146109
     /* 146109 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(146141), // Rule ID 11640 //
     /* 146114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 146122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 146132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 146135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146139 */     GIR_RootConstrainSelectedInstOperands,
     /* 146140 */     // GIR_Coverage, 11640,
     /* 146140 */     GIR_EraseRootFromParent_Done,
     /* 146141 */   // Label 2910: @146141
     /* 146141 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(146173), // Rule ID 11641 //
     /* 146146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 146154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 146157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 146164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 146167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146171 */     GIR_RootConstrainSelectedInstOperands,
     /* 146172 */     // GIR_Coverage, 11641,
     /* 146172 */     GIR_EraseRootFromParent_Done,
     /* 146173 */   // Label 2911: @146173
     /* 146173 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(146205), // Rule ID 11642 //
     /* 146178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 146186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 146189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 146192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 146196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 146199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146203 */     GIR_RootConstrainSelectedInstOperands,
     /* 146204 */     // GIR_Coverage, 11642,
     /* 146204 */     GIR_EraseRootFromParent_Done,
     /* 146205 */   // Label 2912: @146205
     /* 146205 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(146237), // Rule ID 11643 //
     /* 146210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 146218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 146228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 146231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146235 */     GIR_RootConstrainSelectedInstOperands,
     /* 146236 */     // GIR_Coverage, 11643,
     /* 146236 */     GIR_EraseRootFromParent_Done,
     /* 146237 */   // Label 2913: @146237
     /* 146237 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(146269), // Rule ID 11644 //
     /* 146242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 146250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 146253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 146260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 146263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146267 */     GIR_RootConstrainSelectedInstOperands,
     /* 146268 */     // GIR_Coverage, 11644,
     /* 146268 */     GIR_EraseRootFromParent_Done,
     /* 146269 */   // Label 2914: @146269
     /* 146269 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(146301), // Rule ID 11645 //
     /* 146274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 146277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 146282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 146285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 146288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 146292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 146295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146299 */     GIR_RootConstrainSelectedInstOperands,
     /* 146300 */     // GIR_Coverage, 11645,
     /* 146300 */     GIR_EraseRootFromParent_Done,
     /* 146301 */   // Label 2915: @146301
     /* 146301 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(146333), // Rule ID 11800 //
     /* 146306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 146309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 146314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 146320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 146324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 146327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 146329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 146331 */     GIR_RootConstrainSelectedInstOperands,
     /* 146332 */     // GIR_Coverage, 11800,
     /* 146332 */     GIR_EraseRootFromParent_Done,
     /* 146333 */   // Label 2916: @146333
     /* 146333 */   GIM_Reject,
     /* 146334 */ // Label 2597: @146334
     /* 146334 */ GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(192645),
     /* 146339 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 146342 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(146526), // Rule ID 2559 //
     /* 146347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 146364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 146380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 146392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146396 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 146399 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146408 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 146421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146425 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 146433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146441 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146445 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146450 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146454 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146458 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146462 */     // MIs[5] Operand 1
     /* 146462 */     // No operand predicates
     /* 146462 */     // MIs[3] Operand 2
     /* 146462 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146477 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146479 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146491 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 146510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146524 */     GIR_RootConstrainSelectedInstOperands,
     /* 146525 */     // GIR_Coverage, 2559,
     /* 146525 */     GIR_EraseRootFromParent_Done,
     /* 146526 */   // Label 2918: @146526
     /* 146526 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(146710), // Rule ID 6167 //
     /* 146531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 146548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 146564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 146576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146580 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 146583 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146592 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 146605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146613 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 146617 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146621 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146625 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146629 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146634 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146638 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146642 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146646 */     // MIs[5] Operand 1
     /* 146646 */     // No operand predicates
     /* 146646 */     // MIs[3] Operand 2
     /* 146646 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146657 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146661 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146663 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 146694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146708 */     GIR_RootConstrainSelectedInstOperands,
     /* 146709 */     // GIR_Coverage, 6167,
     /* 146709 */     GIR_EraseRootFromParent_Done,
     /* 146710 */   // Label 2919: @146710
     /* 146710 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(146850), // Rule ID 2050 //
     /* 146715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146748 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146751 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146809 */     // MIs[4] Operand 1
     /* 146809 */     // No operand predicates
     /* 146809 */     // MIs[2] Operand 2
     /* 146809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146820 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146829 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 146832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146848 */     GIR_RootConstrainSelectedInstOperands,
     /* 146849 */     // GIR_Coverage, 2050,
     /* 146849 */     GIR_EraseRootFromParent_Done,
     /* 146850 */   // Label 2920: @146850
     /* 146850 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(146990), // Rule ID 2057 //
     /* 146855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146888 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146891 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146900 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146928 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146932 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146937 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146941 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146945 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146949 */     // MIs[4] Operand 1
     /* 146949 */     // No operand predicates
     /* 146949 */     // MIs[2] Operand 2
     /* 146949 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146969 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 146972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146988 */     GIR_RootConstrainSelectedInstOperands,
     /* 146989 */     // GIR_Coverage, 2057,
     /* 146989 */     GIR_EraseRootFromParent_Done,
     /* 146990 */   // Label 2921: @146990
     /* 146990 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(147130), // Rule ID 2053 //
     /* 146995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147028 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147031 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147072 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147085 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147089 */     // MIs[4] Operand 1
     /* 147089 */     // No operand predicates
     /* 147089 */     // MIs[2] Operand 2
     /* 147089 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 147100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 147109 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 147112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147128 */     GIR_RootConstrainSelectedInstOperands,
     /* 147129 */     // GIR_Coverage, 2053,
     /* 147129 */     GIR_EraseRootFromParent_Done,
     /* 147130 */   // Label 2922: @147130
     /* 147130 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(147270), // Rule ID 2060 //
     /* 147135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147212 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147217 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147221 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147225 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147229 */     // MIs[4] Operand 1
     /* 147229 */     // No operand predicates
     /* 147229 */     // MIs[2] Operand 2
     /* 147229 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 147240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 147249 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 147252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147268 */     GIR_RootConstrainSelectedInstOperands,
     /* 147269 */     // GIR_Coverage, 2060,
     /* 147269 */     GIR_EraseRootFromParent_Done,
     /* 147270 */   // Label 2923: @147270
     /* 147270 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(147407), // Rule ID 2048 //
     /* 147275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 147292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147349 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147353 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147357 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147362 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147366 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147370 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147374 */     // MIs[4] Operand 1
     /* 147374 */     // No operand predicates
     /* 147374 */     // MIs[2] Operand 2
     /* 147374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147385 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147387 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 147390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147405 */     GIR_RootConstrainSelectedInstOperands,
     /* 147406 */     // GIR_Coverage, 2048,
     /* 147406 */     GIR_EraseRootFromParent_Done,
     /* 147407 */   // Label 2924: @147407
     /* 147407 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(147544), // Rule ID 2055 //
     /* 147412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 147429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147445 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147448 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147457 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147494 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147507 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147511 */     // MIs[4] Operand 1
     /* 147511 */     // No operand predicates
     /* 147511 */     // MIs[2] Operand 2
     /* 147511 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147522 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147524 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 147527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147542 */     GIR_RootConstrainSelectedInstOperands,
     /* 147543 */     // GIR_Coverage, 2055,
     /* 147543 */     GIR_EraseRootFromParent_Done,
     /* 147544 */   // Label 2925: @147544
     /* 147544 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(147681), // Rule ID 2051 //
     /* 147549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147582 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147585 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147594 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147627 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147644 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147648 */     // MIs[4] Operand 1
     /* 147648 */     // No operand predicates
     /* 147648 */     // MIs[2] Operand 2
     /* 147648 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147659 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147661 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 147664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147679 */     GIR_RootConstrainSelectedInstOperands,
     /* 147680 */     // GIR_Coverage, 2051,
     /* 147680 */     GIR_EraseRootFromParent_Done,
     /* 147681 */   // Label 2926: @147681
     /* 147681 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(147818), // Rule ID 2058 //
     /* 147686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147719 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147722 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147781 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147785 */     // MIs[4] Operand 1
     /* 147785 */     // No operand predicates
     /* 147785 */     // MIs[2] Operand 2
     /* 147785 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147798 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 147801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147816 */     GIR_RootConstrainSelectedInstOperands,
     /* 147817 */     // GIR_Coverage, 2058,
     /* 147817 */     GIR_EraseRootFromParent_Done,
     /* 147818 */   // Label 2927: @147818
     /* 147818 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(147979), // Rule ID 2560 //
     /* 147823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 147840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 147856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147872 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 147875 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147884 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 147897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147909 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147918 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147922 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147926 */     // MIs[4] Operand 1
     /* 147926 */     // No operand predicates
     /* 147926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 147930 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147932 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 147932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 147935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 147950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 147963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147977 */     GIR_RootConstrainSelectedInstOperands,
     /* 147978 */     // GIR_Coverage, 2560,
     /* 147978 */     GIR_EraseRootFromParent_Done,
     /* 147979 */   // Label 2928: @147979
     /* 147979 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148140), // Rule ID 6168 //
     /* 147984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 148001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 148017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148033 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 148036 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148045 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 148058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 148062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 148070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 148075 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 148079 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148083 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 148087 */     // MIs[4] Operand 1
     /* 148087 */     // No operand predicates
     /* 148087 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 148091 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 148093 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 148093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 148096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148105 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 148111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 148124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 148135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 148138 */     GIR_RootConstrainSelectedInstOperands,
     /* 148139 */     // GIR_Coverage, 6168,
     /* 148139 */     GIR_EraseRootFromParent_Done,
     /* 148140 */   // Label 2929: @148140
     /* 148140 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148250), // Rule ID 2078 //
     /* 148145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 148186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 148194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 148199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 148203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 148211 */     // MIs[3] Operand 1
     /* 148211 */     // No operand predicates
     /* 148211 */     // MIs[1] Operand 2
     /* 148211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 148222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 148224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148231 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 148231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 148245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 148248 */     GIR_RootConstrainSelectedInstOperands,
     /* 148249 */     // GIR_Coverage, 2078,
     /* 148249 */     GIR_EraseRootFromParent_Done,
     /* 148250 */   // Label 2930: @148250
     /* 148250 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148360), // Rule ID 2081 //
     /* 148255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 148296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 148304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 148313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 148317 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 148321 */     // MIs[3] Operand 1
     /* 148321 */     // No operand predicates
     /* 148321 */     // MIs[1] Operand 2
     /* 148321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 148332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 148334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148341 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 148341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 148344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 148355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 148358 */     GIR_RootConstrainSelectedInstOperands,
     /* 148359 */     // GIR_Coverage, 2081,
     /* 148359 */     GIR_EraseRootFromParent_Done,
     /* 148360 */   // Label 2931: @148360
     /* 148360 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148449), // Rule ID 1736 //
     /* 148365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148398 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148401 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148430 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 148430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 148433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148447 */     GIR_RootConstrainSelectedInstOperands,
     /* 148448 */     // GIR_Coverage, 1736,
     /* 148448 */     GIR_EraseRootFromParent_Done,
     /* 148449 */   // Label 2932: @148449
     /* 148449 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148538), // Rule ID 1738 //
     /* 148454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148487 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148490 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148519 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 148522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 148537 */     // GIR_Coverage, 1738,
     /* 148537 */     GIR_EraseRootFromParent_Done,
     /* 148538 */   // Label 2933: @148538
     /* 148538 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148627), // Rule ID 1740 //
     /* 148543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 148608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 148611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148625 */     GIR_RootConstrainSelectedInstOperands,
     /* 148626 */     // GIR_Coverage, 1740,
     /* 148626 */     GIR_EraseRootFromParent_Done,
     /* 148627 */   // Label 2934: @148627
     /* 148627 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148716), // Rule ID 1742 //
     /* 148632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148665 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148668 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148677 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148697 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 148700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148714 */     GIR_RootConstrainSelectedInstOperands,
     /* 148715 */     // GIR_Coverage, 1742,
     /* 148715 */     GIR_EraseRootFromParent_Done,
     /* 148716 */   // Label 2935: @148716
     /* 148716 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148838), // Rule ID 6827 //
     /* 148721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148756 */     // MIs[1] Operand 2
     /* 148756 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148775 */     // MIs[2] Rn
     /* 148775 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148780 */     // MIs[2] Operand 2
     /* 148780 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 148791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148793 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 148793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 148800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148820 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148837 */     // GIR_Coverage, 6827,
     /* 148837 */     GIR_EraseRootFromParent_Done,
     /* 148838 */   // Label 2936: @148838
     /* 148838 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148960), // Rule ID 6829 //
     /* 148843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 148851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148878 */     // MIs[1] Operand 2
     /* 148878 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148897 */     // MIs[2] Rn
     /* 148897 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148902 */     // MIs[2] Operand 2
     /* 148902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148915 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 148915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 148922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148942 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148959 */     // GIR_Coverage, 6829,
     /* 148959 */     GIR_EraseRootFromParent_Done,
     /* 148960 */   // Label 2937: @148960
     /* 148960 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(149082), // Rule ID 6831 //
     /* 148965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 148973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 148979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 148995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149000 */     // MIs[1] Operand 2
     /* 149000 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149019 */     // MIs[2] Rn
     /* 149019 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 149024 */     // MIs[2] Operand 2
     /* 149024 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 149035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149037 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 149037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 149040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 149044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149064 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149081 */     // GIR_Coverage, 6831,
     /* 149081 */     GIR_EraseRootFromParent_Done,
     /* 149082 */   // Label 2938: @149082
     /* 149082 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(149204), // Rule ID 6833 //
     /* 149087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 149092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 149095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149122 */     // MIs[1] Operand 2
     /* 149122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149141 */     // MIs[2] Rn
     /* 149141 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 149146 */     // MIs[2] Operand 2
     /* 149146 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 149157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149159 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 149159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 149162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 149166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149186 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149203 */     // GIR_Coverage, 6833,
     /* 149203 */     GIR_EraseRootFromParent_Done,
     /* 149204 */   // Label 2939: @149204
     /* 149204 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(149326), // Rule ID 6835 //
     /* 149209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 149214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149244 */     // MIs[1] Operand 2
     /* 149244 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149263 */     // MIs[2] Rn
     /* 149263 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 149268 */     // MIs[2] Operand 2
     /* 149268 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 149279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149281 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 149281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 149284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 149288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 149301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149325 */     // GIR_Coverage, 6835,
     /* 149325 */     GIR_EraseRootFromParent_Done,
     /* 149326 */   // Label 2940: @149326
     /* 149326 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(149509), // Rule ID 2558 //
     /* 149331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 149339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149380 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 149383 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149392 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149412 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 149412 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 149415 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149419 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149438 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 149441 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149445 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149458 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149475 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 149494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149507 */     GIR_RootConstrainSelectedInstOperands,
     /* 149508 */     // GIR_Coverage, 2558,
     /* 149508 */     GIR_EraseRootFromParent_Done,
     /* 149509 */   // Label 2941: @149509
     /* 149509 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(149692), // Rule ID 6166 //
     /* 149514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149563 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 149566 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149575 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149589 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149595 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 149595 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 149598 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149602 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149621 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 149624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149658 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 149677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149690 */     GIR_RootConstrainSelectedInstOperands,
     /* 149691 */     // GIR_Coverage, 6166,
     /* 149691 */     GIR_EraseRootFromParent_Done,
     /* 149692 */   // Label 2942: @149692
     /* 149692 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(149796), // Rule ID 13180 //
     /* 149697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149759 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149763 */     // MIs[3] Operand 1
     /* 149763 */     // No operand predicates
     /* 149763 */     // MIs[1] Operand 2
     /* 149763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149780 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 149783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149794 */     GIR_RootConstrainSelectedInstOperands,
     /* 149795 */     // GIR_Coverage, 13180,
     /* 149795 */     GIR_EraseRootFromParent_Done,
     /* 149796 */   // Label 2943: @149796
     /* 149796 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(149900), // Rule ID 13183 //
     /* 149801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 149812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149867 */     // MIs[3] Operand 1
     /* 149867 */     // No operand predicates
     /* 149867 */     // MIs[1] Operand 2
     /* 149867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149884 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 149887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149898 */     GIR_RootConstrainSelectedInstOperands,
     /* 149899 */     // GIR_Coverage, 13183,
     /* 149899 */     GIR_EraseRootFromParent_Done,
     /* 149900 */   // Label 2944: @149900
     /* 149900 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(150031), // Rule ID 2515 //
     /* 149905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 149922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149947 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149980 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149984 */     // MIs[3] Operand 1
     /* 149984 */     // No operand predicates
     /* 149984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149986 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 149986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149998 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 150004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 150017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150029 */     GIR_RootConstrainSelectedInstOperands,
     /* 150030 */     // GIR_Coverage, 2515,
     /* 150030 */     GIR_EraseRootFromParent_Done,
     /* 150031 */   // Label 2945: @150031
     /* 150031 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(150162), // Rule ID 2516 //
     /* 150036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 150082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 150086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150111 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150115 */     // MIs[3] Operand 1
     /* 150115 */     // No operand predicates
     /* 150115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150117 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 150117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150129 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 150135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 150148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150160 */     GIR_RootConstrainSelectedInstOperands,
     /* 150161 */     // GIR_Coverage, 2516,
     /* 150161 */     GIR_EraseRootFromParent_Done,
     /* 150162 */   // Label 2946: @150162
     /* 150162 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(150293), // Rule ID 2517 //
     /* 150167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150209 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 150213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 150217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150242 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 150246 */     // MIs[3] Operand 1
     /* 150246 */     // No operand predicates
     /* 150246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150248 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 150248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150260 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 150266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 150279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150291 */     GIR_RootConstrainSelectedInstOperands,
     /* 150292 */     // GIR_Coverage, 2517,
     /* 150292 */     GIR_EraseRootFromParent_Done,
     /* 150293 */   // Label 2947: @150293
     /* 150293 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(150424), // Rule ID 13366 //
     /* 150298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 150301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 150315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150348 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150352 */     // MIs[2] Operand 1
     /* 150352 */     // No operand predicates
     /* 150352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150368 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150373 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150379 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 150379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 150382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 150397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 150410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150422 */     GIR_RootConstrainSelectedInstOperands,
     /* 150423 */     // GIR_Coverage, 13366,
     /* 150423 */     GIR_EraseRootFromParent_Done,
     /* 150424 */   // Label 2948: @150424
     /* 150424 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(150555), // Rule ID 13367 //
     /* 150429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150479 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150483 */     // MIs[2] Operand 1
     /* 150483 */     // No operand predicates
     /* 150483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150504 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150510 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 150510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150522 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 150528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 150541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150553 */     GIR_RootConstrainSelectedInstOperands,
     /* 150554 */     // GIR_Coverage, 13367,
     /* 150554 */     GIR_EraseRootFromParent_Done,
     /* 150555 */   // Label 2949: @150555
     /* 150555 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(150686), // Rule ID 13368 //
     /* 150560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 150614 */     // MIs[2] Operand 1
     /* 150614 */     // No operand predicates
     /* 150614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150622 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150626 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150630 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150635 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150641 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 150641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150653 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 150659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 150672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150684 */     GIR_RootConstrainSelectedInstOperands,
     /* 150685 */     // GIR_Coverage, 13368,
     /* 150685 */     GIR_EraseRootFromParent_Done,
     /* 150686 */   // Label 2950: @150686
     /* 150686 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(150800), // Rule ID 2049 //
     /* 150691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150778 */     // MIs[3] Operand 1
     /* 150778 */     // No operand predicates
     /* 150778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150780 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 150783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150798 */     GIR_RootConstrainSelectedInstOperands,
     /* 150799 */     // GIR_Coverage, 2049,
     /* 150799 */     GIR_EraseRootFromParent_Done,
     /* 150800 */   // Label 2951: @150800
     /* 150800 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(150914), // Rule ID 2056 //
     /* 150805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150838 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150841 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150888 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150892 */     // MIs[3] Operand 1
     /* 150892 */     // No operand predicates
     /* 150892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 150897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150912 */     GIR_RootConstrainSelectedInstOperands,
     /* 150913 */     // GIR_Coverage, 2056,
     /* 150913 */     GIR_EraseRootFromParent_Done,
     /* 150914 */   // Label 2952: @150914
     /* 150914 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(151028), // Rule ID 2052 //
     /* 150919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150952 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150955 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150964 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151002 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151006 */     // MIs[3] Operand 1
     /* 151006 */     // No operand predicates
     /* 151006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151008 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 151011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 151019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151026 */     GIR_RootConstrainSelectedInstOperands,
     /* 151027 */     // GIR_Coverage, 2052,
     /* 151027 */     GIR_EraseRootFromParent_Done,
     /* 151028 */   // Label 2953: @151028
     /* 151028 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(151142), // Rule ID 2059 //
     /* 151033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 151041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 151050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151078 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151120 */     // MIs[3] Operand 1
     /* 151120 */     // No operand predicates
     /* 151120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151122 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 151125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 151133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151140 */     GIR_RootConstrainSelectedInstOperands,
     /* 151141 */     // GIR_Coverage, 2059,
     /* 151141 */     GIR_EraseRootFromParent_Done,
     /* 151142 */   // Label 2954: @151142
     /* 151142 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(151256), // Rule ID 2054 //
     /* 151147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 151155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 151164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151180 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151183 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 151188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151234 */     // MIs[3] Operand 1
     /* 151234 */     // No operand predicates
     /* 151234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151236 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 151239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 151247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151254 */     GIR_RootConstrainSelectedInstOperands,
     /* 151255 */     // GIR_Coverage, 2054,
     /* 151255 */     GIR_EraseRootFromParent_Done,
     /* 151256 */   // Label 2955: @151256
     /* 151256 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(151370), // Rule ID 2061 //
     /* 151261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 151269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 151278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151294 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151297 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 151302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151306 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151344 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151348 */     // MIs[3] Operand 1
     /* 151348 */     // No operand predicates
     /* 151348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151350 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 151353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 151361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151368 */     GIR_RootConstrainSelectedInstOperands,
     /* 151369 */     // GIR_Coverage, 2061,
     /* 151369 */     GIR_EraseRootFromParent_Done,
     /* 151370 */   // Label 2956: @151370
     /* 151370 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(151474), // Rule ID 1980 //
     /* 151375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 151378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151445 */     // MIs[3] Operand 1
     /* 151445 */     // No operand predicates
     /* 151445 */     // MIs[1] Operand 2
     /* 151445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151458 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 151461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151472 */     GIR_RootConstrainSelectedInstOperands,
     /* 151473 */     // GIR_Coverage, 1980,
     /* 151473 */     GIR_EraseRootFromParent_Done,
     /* 151474 */   // Label 2957: @151474
     /* 151474 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(151578), // Rule ID 2010 //
     /* 151479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151549 */     // MIs[3] Operand 1
     /* 151549 */     // No operand predicates
     /* 151549 */     // MIs[1] Operand 2
     /* 151549 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151562 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 151565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151576 */     GIR_RootConstrainSelectedInstOperands,
     /* 151577 */     // GIR_Coverage, 2010,
     /* 151577 */     GIR_EraseRootFromParent_Done,
     /* 151578 */   // Label 2958: @151578
     /* 151578 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(151682), // Rule ID 2017 //
     /* 151583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 151591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151653 */     // MIs[3] Operand 1
     /* 151653 */     // No operand predicates
     /* 151653 */     // MIs[1] Operand 2
     /* 151653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151666 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 151669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151680 */     GIR_RootConstrainSelectedInstOperands,
     /* 151681 */     // GIR_Coverage, 2017,
     /* 151681 */     GIR_EraseRootFromParent_Done,
     /* 151682 */   // Label 2959: @151682
     /* 151682 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(151786), // Rule ID 2076 //
     /* 151687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151753 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151757 */     // MIs[3] Operand 1
     /* 151757 */     // No operand predicates
     /* 151757 */     // MIs[1] Operand 2
     /* 151757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151770 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 151773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151784 */     GIR_RootConstrainSelectedInstOperands,
     /* 151785 */     // GIR_Coverage, 2076,
     /* 151785 */     GIR_EraseRootFromParent_Done,
     /* 151786 */   // Label 2960: @151786
     /* 151786 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(151890), // Rule ID 1983 //
     /* 151791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151857 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151861 */     // MIs[3] Operand 1
     /* 151861 */     // No operand predicates
     /* 151861 */     // MIs[1] Operand 2
     /* 151861 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151874 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 151877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151888 */     GIR_RootConstrainSelectedInstOperands,
     /* 151889 */     // GIR_Coverage, 1983,
     /* 151889 */     GIR_EraseRootFromParent_Done,
     /* 151890 */   // Label 2961: @151890
     /* 151890 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(151994), // Rule ID 2013 //
     /* 151895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151961 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151965 */     // MIs[3] Operand 1
     /* 151965 */     // No operand predicates
     /* 151965 */     // MIs[1] Operand 2
     /* 151965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151978 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 151981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151992 */     GIR_RootConstrainSelectedInstOperands,
     /* 151993 */     // GIR_Coverage, 2013,
     /* 151993 */     GIR_EraseRootFromParent_Done,
     /* 151994 */   // Label 2962: @151994
     /* 151994 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(152098), // Rule ID 2020 //
     /* 151999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 152007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 152010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152069 */     // MIs[3] Operand 1
     /* 152069 */     // No operand predicates
     /* 152069 */     // MIs[1] Operand 2
     /* 152069 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 152080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152082 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 152085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152096 */     GIR_RootConstrainSelectedInstOperands,
     /* 152097 */     // GIR_Coverage, 2020,
     /* 152097 */     GIR_EraseRootFromParent_Done,
     /* 152098 */   // Label 2963: @152098
     /* 152098 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(152202), // Rule ID 2079 //
     /* 152103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 152156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 152165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152169 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152173 */     // MIs[3] Operand 1
     /* 152173 */     // No operand predicates
     /* 152173 */     // MIs[1] Operand 2
     /* 152173 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 152184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 152186 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 152189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 152197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 152200 */     GIR_RootConstrainSelectedInstOperands,
     /* 152201 */     // GIR_Coverage, 2079,
     /* 152201 */     GIR_EraseRootFromParent_Done,
     /* 152202 */   // Label 2964: @152202
     /* 152202 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(152259), // Rule ID 1744 //
     /* 152207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152242 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 152242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 152245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 152257 */     GIR_RootConstrainSelectedInstOperands,
     /* 152258 */     // GIR_Coverage, 1744,
     /* 152258 */     GIR_EraseRootFromParent_Done,
     /* 152259 */   // Label 2965: @152259
     /* 152259 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(152316), // Rule ID 1746 //
     /* 152264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152299 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 152299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 152302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 152314 */     GIR_RootConstrainSelectedInstOperands,
     /* 152315 */     // GIR_Coverage, 1746,
     /* 152315 */     GIR_EraseRootFromParent_Done,
     /* 152316 */   // Label 2966: @152316
     /* 152316 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(152426), // Rule ID 6185 //
     /* 152321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 152326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 152347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 152355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152360 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 152371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 152375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 152383 */     // MIs[2] Operand 1
     /* 152383 */     // No operand predicates
     /* 152383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152385 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 152385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152397 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 152416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 152424 */     GIR_RootConstrainSelectedInstOperands,
     /* 152425 */     // GIR_Coverage, 6185,
     /* 152425 */     GIR_EraseRootFromParent_Done,
     /* 152426 */   // Label 2967: @152426
     /* 152426 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(152523), // Rule ID 13634 //
     /* 152431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 152434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152483 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 152483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152495 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 152501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 152514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152521 */     GIR_RootConstrainSelectedInstOperands,
     /* 152522 */     // GIR_Coverage, 13634,
     /* 152522 */     GIR_EraseRootFromParent_Done,
     /* 152523 */   // Label 2968: @152523
     /* 152523 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(152620), // Rule ID 13635 //
     /* 152528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152580 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 152580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152592 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 152598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 152611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152618 */     GIR_RootConstrainSelectedInstOperands,
     /* 152619 */     // GIR_Coverage, 13635,
     /* 152619 */     GIR_EraseRootFromParent_Done,
     /* 152620 */   // Label 2969: @152620
     /* 152620 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(152717), // Rule ID 13636 //
     /* 152625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152667 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152677 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 152677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 152695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 152708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152715 */     GIR_RootConstrainSelectedInstOperands,
     /* 152716 */     // GIR_Coverage, 13636,
     /* 152716 */     GIR_EraseRootFromParent_Done,
     /* 152717 */   // Label 2970: @152717
     /* 152717 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(152800), // Rule ID 1735 //
     /* 152722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152755 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152758 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152767 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152783 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 152786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152798 */     GIR_RootConstrainSelectedInstOperands,
     /* 152799 */     // GIR_Coverage, 1735,
     /* 152799 */     GIR_EraseRootFromParent_Done,
     /* 152800 */   // Label 2971: @152800
     /* 152800 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(152883), // Rule ID 1737 //
     /* 152805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152838 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152841 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152866 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 152866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 152869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152881 */     GIR_RootConstrainSelectedInstOperands,
     /* 152882 */     // GIR_Coverage, 1737,
     /* 152882 */     GIR_EraseRootFromParent_Done,
     /* 152883 */   // Label 2972: @152883
     /* 152883 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(152966), // Rule ID 1739 //
     /* 152888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152921 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152924 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152933 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152949 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 152952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152964 */     GIR_RootConstrainSelectedInstOperands,
     /* 152965 */     // GIR_Coverage, 1739,
     /* 152965 */     GIR_EraseRootFromParent_Done,
     /* 152966 */   // Label 2973: @152966
     /* 152966 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(153049), // Rule ID 1741 //
     /* 152971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153004 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153007 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153032 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 153032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 153035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 153047 */     GIR_RootConstrainSelectedInstOperands,
     /* 153048 */     // GIR_Coverage, 1741,
     /* 153048 */     GIR_EraseRootFromParent_Done,
     /* 153049 */   // Label 2974: @153049
     /* 153049 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(153129), // Rule ID 5174 //
     /* 153054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153084 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153087 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 153092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 153096 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 153100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153112 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 153112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 153115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 153127 */     GIR_RootConstrainSelectedInstOperands,
     /* 153128 */     // GIR_Coverage, 5174,
     /* 153128 */     GIR_EraseRootFromParent_Done,
     /* 153129 */   // Label 2975: @153129
     /* 153129 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(153209), // Rule ID 5175 //
     /* 153134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153164 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153167 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 153172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 153176 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 153180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153192 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 153192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 153195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 153207 */     GIR_RootConstrainSelectedInstOperands,
     /* 153208 */     // GIR_Coverage, 5175,
     /* 153208 */     GIR_EraseRootFromParent_Done,
     /* 153209 */   // Label 2976: @153209
     /* 153209 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(153306), // Rule ID 5171 //
     /* 153214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 153217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 153231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153266 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 153266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 153284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 153297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153304 */     GIR_RootConstrainSelectedInstOperands,
     /* 153305 */     // GIR_Coverage, 5171,
     /* 153305 */     GIR_EraseRootFromParent_Done,
     /* 153306 */   // Label 2977: @153306
     /* 153306 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(153403), // Rule ID 5172 //
     /* 153311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 153314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153363 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 153363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 153366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153375 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 153381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 153394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153401 */     GIR_RootConstrainSelectedInstOperands,
     /* 153402 */     // GIR_Coverage, 5172,
     /* 153402 */     GIR_EraseRootFromParent_Done,
     /* 153403 */   // Label 2978: @153403
     /* 153403 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(153500), // Rule ID 5173 //
     /* 153408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 153411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153454 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153460 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 153460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 153463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153472 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 153478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 153491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153498 */     GIR_RootConstrainSelectedInstOperands,
     /* 153499 */     // GIR_Coverage, 5173,
     /* 153499 */     GIR_EraseRootFromParent_Done,
     /* 153500 */   // Label 2979: @153500
     /* 153500 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(153581), // Rule ID 13181 //
     /* 153505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153559 */     // MIs[2] Operand 1
     /* 153559 */     // No operand predicates
     /* 153559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153565 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153579 */     GIR_RootConstrainSelectedInstOperands,
     /* 153580 */     // GIR_Coverage, 13181,
     /* 153580 */     GIR_EraseRootFromParent_Done,
     /* 153581 */   // Label 2980: @153581
     /* 153581 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(153662), // Rule ID 13182 //
     /* 153586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 153603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153636 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153640 */     // MIs[2] Operand 1
     /* 153640 */     // No operand predicates
     /* 153640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153646 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 153649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153660 */     GIR_RootConstrainSelectedInstOperands,
     /* 153661 */     // GIR_Coverage, 13182,
     /* 153661 */     GIR_EraseRootFromParent_Done,
     /* 153662 */   // Label 2981: @153662
     /* 153662 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(153743), // Rule ID 13184 //
     /* 153667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153721 */     // MIs[2] Operand 1
     /* 153721 */     // No operand predicates
     /* 153721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153727 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 153730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153741 */     GIR_RootConstrainSelectedInstOperands,
     /* 153742 */     // GIR_Coverage, 13184,
     /* 153742 */     GIR_EraseRootFromParent_Done,
     /* 153743 */   // Label 2982: @153743
     /* 153743 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(153824), // Rule ID 13185 //
     /* 153748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153802 */     // MIs[2] Operand 1
     /* 153802 */     // No operand predicates
     /* 153802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153808 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 153811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153822 */     GIR_RootConstrainSelectedInstOperands,
     /* 153823 */     // GIR_Coverage, 13185,
     /* 153823 */     GIR_EraseRootFromParent_Done,
     /* 153824 */   // Label 2983: @153824
     /* 153824 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(153905), // Rule ID 13186 //
     /* 153829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 153858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153879 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 153883 */     // MIs[2] Operand 1
     /* 153883 */     // No operand predicates
     /* 153883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153889 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 153892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153903 */     GIR_RootConstrainSelectedInstOperands,
     /* 153904 */     // GIR_Coverage, 13186,
     /* 153904 */     GIR_EraseRootFromParent_Done,
     /* 153905 */   // Label 2984: @153905
     /* 153905 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(153986), // Rule ID 13187 //
     /* 153910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 153927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153964 */     // MIs[2] Operand 1
     /* 153964 */     // No operand predicates
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153970 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 153973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153984 */     GIR_RootConstrainSelectedInstOperands,
     /* 153985 */     // GIR_Coverage, 13187,
     /* 153985 */     GIR_EraseRootFromParent_Done,
     /* 153986 */   // Label 2985: @153986
     /* 153986 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(154067), // Rule ID 13188 //
     /* 153991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154045 */     // MIs[2] Operand 1
     /* 154045 */     // No operand predicates
     /* 154045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154051 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 154054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154065 */     GIR_RootConstrainSelectedInstOperands,
     /* 154066 */     // GIR_Coverage, 13188,
     /* 154066 */     GIR_EraseRootFromParent_Done,
     /* 154067 */   // Label 2986: @154067
     /* 154067 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(154148), // Rule ID 13189 //
     /* 154072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 154083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 154126 */     // MIs[2] Operand 1
     /* 154126 */     // No operand predicates
     /* 154126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154132 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 154135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154146 */     GIR_RootConstrainSelectedInstOperands,
     /* 154147 */     // GIR_Coverage, 13189,
     /* 154147 */     GIR_EraseRootFromParent_Done,
     /* 154148 */   // Label 2987: @154148
     /* 154148 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(154254), // Rule ID 6182 //
     /* 154153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 154158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 154161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 154179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 154183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154188 */     // MIs[1] Operand 2
     /* 154188 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 154199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 154211 */     // MIs[2] Operand 1
     /* 154211 */     // No operand predicates
     /* 154211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154213 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 154213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 154244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 154252 */     GIR_RootConstrainSelectedInstOperands,
     /* 154253 */     // GIR_Coverage, 6182,
     /* 154253 */     GIR_EraseRootFromParent_Done,
     /* 154254 */   // Label 2988: @154254
     /* 154254 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(154335), // Rule ID 1981 //
     /* 154259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 154262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154317 */     // MIs[2] Operand 1
     /* 154317 */     // No operand predicates
     /* 154317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154319 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 154322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154333 */     GIR_RootConstrainSelectedInstOperands,
     /* 154334 */     // GIR_Coverage, 1981,
     /* 154334 */     GIR_EraseRootFromParent_Done,
     /* 154335 */   // Label 2989: @154335
     /* 154335 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(154416), // Rule ID 1982 //
     /* 154340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 154343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154398 */     // MIs[2] Operand 1
     /* 154398 */     // No operand predicates
     /* 154398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154400 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 154403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154414 */     GIR_RootConstrainSelectedInstOperands,
     /* 154415 */     // GIR_Coverage, 1982,
     /* 154415 */     GIR_EraseRootFromParent_Done,
     /* 154416 */   // Label 2990: @154416
     /* 154416 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(154497), // Rule ID 2011 //
     /* 154421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154479 */     // MIs[2] Operand 1
     /* 154479 */     // No operand predicates
     /* 154479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154481 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 154484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154495 */     GIR_RootConstrainSelectedInstOperands,
     /* 154496 */     // GIR_Coverage, 2011,
     /* 154496 */     GIR_EraseRootFromParent_Done,
     /* 154497 */   // Label 2991: @154497
     /* 154497 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(154578), // Rule ID 2012 //
     /* 154502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154560 */     // MIs[2] Operand 1
     /* 154560 */     // No operand predicates
     /* 154560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154562 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 154565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154576 */     GIR_RootConstrainSelectedInstOperands,
     /* 154577 */     // GIR_Coverage, 2012,
     /* 154577 */     GIR_EraseRootFromParent_Done,
     /* 154578 */   // Label 2992: @154578
     /* 154578 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(154659), // Rule ID 2018 //
     /* 154583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154641 */     // MIs[2] Operand 1
     /* 154641 */     // No operand predicates
     /* 154641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154643 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 154646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154657 */     GIR_RootConstrainSelectedInstOperands,
     /* 154658 */     // GIR_Coverage, 2018,
     /* 154658 */     GIR_EraseRootFromParent_Done,
     /* 154659 */   // Label 2993: @154659
     /* 154659 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(154740), // Rule ID 2019 //
     /* 154664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154722 */     // MIs[2] Operand 1
     /* 154722 */     // No operand predicates
     /* 154722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 154727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154738 */     GIR_RootConstrainSelectedInstOperands,
     /* 154739 */     // GIR_Coverage, 2019,
     /* 154739 */     GIR_EraseRootFromParent_Done,
     /* 154740 */   // Label 2994: @154740
     /* 154740 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(154821), // Rule ID 2077 //
     /* 154745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154803 */     // MIs[2] Operand 1
     /* 154803 */     // No operand predicates
     /* 154803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154805 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 154808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154819 */     GIR_RootConstrainSelectedInstOperands,
     /* 154820 */     // GIR_Coverage, 2077,
     /* 154820 */     GIR_EraseRootFromParent_Done,
     /* 154821 */   // Label 2995: @154821
     /* 154821 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(154902), // Rule ID 1984 //
     /* 154826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154884 */     // MIs[2] Operand 1
     /* 154884 */     // No operand predicates
     /* 154884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154886 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 154889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154900 */     GIR_RootConstrainSelectedInstOperands,
     /* 154901 */     // GIR_Coverage, 1984,
     /* 154901 */     GIR_EraseRootFromParent_Done,
     /* 154902 */   // Label 2996: @154902
     /* 154902 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(154983), // Rule ID 1985 //
     /* 154907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154965 */     // MIs[2] Operand 1
     /* 154965 */     // No operand predicates
     /* 154965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154967 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 154970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154981 */     GIR_RootConstrainSelectedInstOperands,
     /* 154982 */     // GIR_Coverage, 1985,
     /* 154982 */     GIR_EraseRootFromParent_Done,
     /* 154983 */   // Label 2997: @154983
     /* 154983 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(155064), // Rule ID 2014 //
     /* 154988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155046 */     // MIs[2] Operand 1
     /* 155046 */     // No operand predicates
     /* 155046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155048 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 155051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155062 */     GIR_RootConstrainSelectedInstOperands,
     /* 155063 */     // GIR_Coverage, 2014,
     /* 155063 */     GIR_EraseRootFromParent_Done,
     /* 155064 */   // Label 2998: @155064
     /* 155064 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(155145), // Rule ID 2015 //
     /* 155069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 155077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155127 */     // MIs[2] Operand 1
     /* 155127 */     // No operand predicates
     /* 155127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 155132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155143 */     GIR_RootConstrainSelectedInstOperands,
     /* 155144 */     // GIR_Coverage, 2015,
     /* 155144 */     GIR_EraseRootFromParent_Done,
     /* 155145 */   // Label 2999: @155145
     /* 155145 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(155226), // Rule ID 2021 //
     /* 155150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 155158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155208 */     // MIs[2] Operand 1
     /* 155208 */     // No operand predicates
     /* 155208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155210 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 155213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155224 */     GIR_RootConstrainSelectedInstOperands,
     /* 155225 */     // GIR_Coverage, 2021,
     /* 155225 */     GIR_EraseRootFromParent_Done,
     /* 155226 */   // Label 3000: @155226
     /* 155226 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(155307), // Rule ID 2022 //
     /* 155231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 155239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155289 */     // MIs[2] Operand 1
     /* 155289 */     // No operand predicates
     /* 155289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 155294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155305 */     GIR_RootConstrainSelectedInstOperands,
     /* 155306 */     // GIR_Coverage, 2022,
     /* 155306 */     GIR_EraseRootFromParent_Done,
     /* 155307 */   // Label 3001: @155307
     /* 155307 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(155388), // Rule ID 2080 //
     /* 155312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155366 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155370 */     // MIs[2] Operand 1
     /* 155370 */     // No operand predicates
     /* 155370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155372 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 155375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155386 */     GIR_RootConstrainSelectedInstOperands,
     /* 155387 */     // GIR_Coverage, 2080,
     /* 155387 */     GIR_EraseRootFromParent_Done,
     /* 155388 */   // Label 3002: @155388
     /* 155388 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(155469), // Rule ID 1986 //
     /* 155393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 155426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155451 */     // MIs[2] Operand 1
     /* 155451 */     // No operand predicates
     /* 155451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155453 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 155456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155467 */     GIR_RootConstrainSelectedInstOperands,
     /* 155468 */     // GIR_Coverage, 1986,
     /* 155468 */     GIR_EraseRootFromParent_Done,
     /* 155469 */   // Label 3003: @155469
     /* 155469 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(155550), // Rule ID 1987 //
     /* 155474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155532 */     // MIs[2] Operand 1
     /* 155532 */     // No operand predicates
     /* 155532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155534 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155548 */     GIR_RootConstrainSelectedInstOperands,
     /* 155549 */     // GIR_Coverage, 1987,
     /* 155549 */     GIR_EraseRootFromParent_Done,
     /* 155550 */   // Label 3004: @155550
     /* 155550 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(155631), // Rule ID 1988 //
     /* 155555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155613 */     // MIs[2] Operand 1
     /* 155613 */     // No operand predicates
     /* 155613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155615 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155629 */     GIR_RootConstrainSelectedInstOperands,
     /* 155630 */     // GIR_Coverage, 1988,
     /* 155630 */     GIR_EraseRootFromParent_Done,
     /* 155631 */   // Label 3005: @155631
     /* 155631 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(155712), // Rule ID 1989 //
     /* 155636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155694 */     // MIs[2] Operand 1
     /* 155694 */     // No operand predicates
     /* 155694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155696 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155710 */     GIR_RootConstrainSelectedInstOperands,
     /* 155711 */     // GIR_Coverage, 1989,
     /* 155711 */     GIR_EraseRootFromParent_Done,
     /* 155712 */   // Label 3006: @155712
     /* 155712 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(155793), // Rule ID 2016 //
     /* 155717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 155725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155775 */     // MIs[2] Operand 1
     /* 155775 */     // No operand predicates
     /* 155775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155777 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 155780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155791 */     GIR_RootConstrainSelectedInstOperands,
     /* 155792 */     // GIR_Coverage, 2016,
     /* 155792 */     GIR_EraseRootFromParent_Done,
     /* 155793 */   // Label 3007: @155793
     /* 155793 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(155874), // Rule ID 2023 //
     /* 155798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 155806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155856 */     // MIs[2] Operand 1
     /* 155856 */     // No operand predicates
     /* 155856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155858 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 155861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155872 */     GIR_RootConstrainSelectedInstOperands,
     /* 155873 */     // GIR_Coverage, 2023,
     /* 155873 */     GIR_EraseRootFromParent_Done,
     /* 155874 */   // Label 3008: @155874
     /* 155874 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(155952), // Rule ID 6169 //
     /* 155879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 155884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155934 */     // MIs[2] Operand 1
     /* 155934 */     // No operand predicates
     /* 155934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155936 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 155939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 155947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155950 */     GIR_RootConstrainSelectedInstOperands,
     /* 155951 */     // GIR_Coverage, 6169,
     /* 155951 */     GIR_EraseRootFromParent_Done,
     /* 155952 */   // Label 3009: @155952
     /* 155952 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(156012), // Rule ID 6243 //
     /* 155957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 155965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 155983 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 155983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 155986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 156003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 156007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156010 */     GIR_RootConstrainSelectedInstOperands,
     /* 156011 */     // GIR_Coverage, 6243,
     /* 156011 */     GIR_EraseRootFromParent_Done,
     /* 156012 */   // Label 3010: @156012
     /* 156012 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(156072), // Rule ID 6244 //
     /* 156017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 156043 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 156043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 156046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 156050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 156058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 156063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 156067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156070 */     GIR_RootConstrainSelectedInstOperands,
     /* 156071 */     // GIR_Coverage, 6244,
     /* 156071 */     GIR_EraseRootFromParent_Done,
     /* 156072 */   // Label 3011: @156072
     /* 156072 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(156132), // Rule ID 6245 //
     /* 156077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 156103 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 156103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 156106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 156110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 156118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 156123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 156127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156130 */     GIR_RootConstrainSelectedInstOperands,
     /* 156131 */     // GIR_Coverage, 6245,
     /* 156131 */     GIR_EraseRootFromParent_Done,
     /* 156132 */   // Label 3012: @156132
     /* 156132 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(156179), // Rule ID 3839 //
     /* 156137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 156140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 156145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156159 */     // MIs[0] Operand 3
     /* 156159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 156170 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 156170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 156173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156177 */     GIR_RootConstrainSelectedInstOperands,
     /* 156178 */     // GIR_Coverage, 3839,
     /* 156178 */     GIR_EraseRootFromParent_Done,
     /* 156179 */   // Label 3013: @156179
     /* 156179 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(156226), // Rule ID 3840 //
     /* 156184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 156187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 156192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156206 */     // MIs[0] Operand 3
     /* 156206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 156217 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 156217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 156220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156224 */     GIR_RootConstrainSelectedInstOperands,
     /* 156225 */     // GIR_Coverage, 3840,
     /* 156225 */     GIR_EraseRootFromParent_Done,
     /* 156226 */   // Label 3014: @156226
     /* 156226 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(156273), // Rule ID 3841 //
     /* 156231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 156234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 156239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156253 */     // MIs[0] Operand 3
     /* 156253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 156264 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 156264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 156267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156271 */     GIR_RootConstrainSelectedInstOperands,
     /* 156272 */     // GIR_Coverage, 3841,
     /* 156272 */     GIR_EraseRootFromParent_Done,
     /* 156273 */   // Label 3015: @156273
     /* 156273 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(156320), // Rule ID 3842 //
     /* 156278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 156281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 156286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156300 */     // MIs[0] Operand 3
     /* 156300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 156311 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 156311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 156314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156318 */     GIR_RootConstrainSelectedInstOperands,
     /* 156319 */     // GIR_Coverage, 3842,
     /* 156319 */     GIR_EraseRootFromParent_Done,
     /* 156320 */   // Label 3016: @156320
     /* 156320 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(156366), // Rule ID 3524 //
     /* 156325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 156336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 156339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156347 */     // MIs[0] Idx
     /* 156347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 156355 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 156355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 156358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156364 */     GIR_RootConstrainSelectedInstOperands,
     /* 156365 */     // GIR_Coverage, 3524,
     /* 156365 */     GIR_EraseRootFromParent_Done,
     /* 156366 */   // Label 3017: @156366
     /* 156366 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(156412), // Rule ID 3525 //
     /* 156371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 156382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 156385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156393 */     // MIs[0] Idx
     /* 156393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 156401 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 156401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 156404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156410 */     GIR_RootConstrainSelectedInstOperands,
     /* 156411 */     // GIR_Coverage, 3525,
     /* 156411 */     GIR_EraseRootFromParent_Done,
     /* 156412 */   // Label 3018: @156412
     /* 156412 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(156458), // Rule ID 3526 //
     /* 156417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 156428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 156431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156439 */     // MIs[0] Idx
     /* 156439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 156447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 156447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 156450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156456 */     GIR_RootConstrainSelectedInstOperands,
     /* 156457 */     // GIR_Coverage, 3526,
     /* 156457 */     GIR_EraseRootFromParent_Done,
     /* 156458 */   // Label 3019: @156458
     /* 156458 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(156504), // Rule ID 3527 //
     /* 156463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 156474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 156477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156485 */     // MIs[0] Idx
     /* 156485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 156493 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 156493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 156496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156502 */     GIR_RootConstrainSelectedInstOperands,
     /* 156503 */     // GIR_Coverage, 3527,
     /* 156503 */     GIR_EraseRootFromParent_Done,
     /* 156504 */   // Label 3020: @156504
     /* 156504 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(156560), // Rule ID 2101 //
     /* 156509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 156517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156546 */     // MIs[1] Operand 1
     /* 156546 */     // No operand predicates
     /* 156546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156548 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 156551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156558 */     GIR_RootConstrainSelectedInstOperands,
     /* 156559 */     // GIR_Coverage, 2101,
     /* 156559 */     GIR_EraseRootFromParent_Done,
     /* 156560 */   // Label 3021: @156560
     /* 156560 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(156616), // Rule ID 2102 //
     /* 156565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 156573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156602 */     // MIs[1] Operand 1
     /* 156602 */     // No operand predicates
     /* 156602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156604 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 156607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156614 */     GIR_RootConstrainSelectedInstOperands,
     /* 156615 */     // GIR_Coverage, 2102,
     /* 156615 */     GIR_EraseRootFromParent_Done,
     /* 156616 */   // Label 3022: @156616
     /* 156616 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(156672), // Rule ID 2107 //
     /* 156621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 156629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156658 */     // MIs[1] Operand 1
     /* 156658 */     // No operand predicates
     /* 156658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156660 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 156663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156670 */     GIR_RootConstrainSelectedInstOperands,
     /* 156671 */     // GIR_Coverage, 2107,
     /* 156671 */     GIR_EraseRootFromParent_Done,
     /* 156672 */   // Label 3023: @156672
     /* 156672 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(156728), // Rule ID 2108 //
     /* 156677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 156685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156714 */     // MIs[1] Operand 1
     /* 156714 */     // No operand predicates
     /* 156714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156716 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 156719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156726 */     GIR_RootConstrainSelectedInstOperands,
     /* 156727 */     // GIR_Coverage, 2108,
     /* 156727 */     GIR_EraseRootFromParent_Done,
     /* 156728 */   // Label 3024: @156728
     /* 156728 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(156784), // Rule ID 2114 //
     /* 156733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 156741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156770 */     // MIs[1] Operand 1
     /* 156770 */     // No operand predicates
     /* 156770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156772 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 156775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156782 */     GIR_RootConstrainSelectedInstOperands,
     /* 156783 */     // GIR_Coverage, 2114,
     /* 156783 */     GIR_EraseRootFromParent_Done,
     /* 156784 */   // Label 3025: @156784
     /* 156784 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(156840), // Rule ID 2117 //
     /* 156789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 156797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156826 */     // MIs[1] Operand 1
     /* 156826 */     // No operand predicates
     /* 156826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156828 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 156831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156838 */     GIR_RootConstrainSelectedInstOperands,
     /* 156839 */     // GIR_Coverage, 2117,
     /* 156839 */     GIR_EraseRootFromParent_Done,
     /* 156840 */   // Label 3026: @156840
     /* 156840 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(156896), // Rule ID 2139 //
     /* 156845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 156856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 156882 */     // MIs[1] Operand 1
     /* 156882 */     // No operand predicates
     /* 156882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156884 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 156887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156894 */     GIR_RootConstrainSelectedInstOperands,
     /* 156895 */     // GIR_Coverage, 2139,
     /* 156895 */     GIR_EraseRootFromParent_Done,
     /* 156896 */   // Label 3027: @156896
     /* 156896 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(156952), // Rule ID 2141 //
     /* 156901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 156938 */     // MIs[1] Operand 1
     /* 156938 */     // No operand predicates
     /* 156938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 156943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156950 */     GIR_RootConstrainSelectedInstOperands,
     /* 156951 */     // GIR_Coverage, 2141,
     /* 156951 */     GIR_EraseRootFromParent_Done,
     /* 156952 */   // Label 3028: @156952
     /* 156952 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(157008), // Rule ID 2143 //
     /* 156957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 156994 */     // MIs[1] Operand 1
     /* 156994 */     // No operand predicates
     /* 156994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156996 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 156999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157006 */     GIR_RootConstrainSelectedInstOperands,
     /* 157007 */     // GIR_Coverage, 2143,
     /* 157007 */     GIR_EraseRootFromParent_Done,
     /* 157008 */   // Label 3029: @157008
     /* 157008 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(157061), // Rule ID 6170 //
     /* 157013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157047 */     // MIs[1] Operand 1
     /* 157047 */     // No operand predicates
     /* 157047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157049 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 157052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157059 */     GIR_RootConstrainSelectedInstOperands,
     /* 157060 */     // GIR_Coverage, 6170,
     /* 157060 */     GIR_EraseRootFromParent_Done,
     /* 157061 */   // Label 3030: @157061
     /* 157061 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(157114), // Rule ID 6171 //
     /* 157066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157100 */     // MIs[1] Operand 1
     /* 157100 */     // No operand predicates
     /* 157100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157102 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 157105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157112 */     GIR_RootConstrainSelectedInstOperands,
     /* 157113 */     // GIR_Coverage, 6171,
     /* 157113 */     GIR_EraseRootFromParent_Done,
     /* 157114 */   // Label 3031: @157114
     /* 157114 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(157167), // Rule ID 6172 //
     /* 157119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157153 */     // MIs[1] Operand 1
     /* 157153 */     // No operand predicates
     /* 157153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157155 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 157158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157165 */     GIR_RootConstrainSelectedInstOperands,
     /* 157166 */     // GIR_Coverage, 6172,
     /* 157166 */     GIR_EraseRootFromParent_Done,
     /* 157167 */   // Label 3032: @157167
     /* 157167 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(157220), // Rule ID 6173 //
     /* 157172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157206 */     // MIs[1] Operand 1
     /* 157206 */     // No operand predicates
     /* 157206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157208 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 157211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157218 */     GIR_RootConstrainSelectedInstOperands,
     /* 157219 */     // GIR_Coverage, 6173,
     /* 157219 */     GIR_EraseRootFromParent_Done,
     /* 157220 */   // Label 3033: @157220
     /* 157220 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(157273), // Rule ID 6174 //
     /* 157225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157259 */     // MIs[1] Operand 1
     /* 157259 */     // No operand predicates
     /* 157259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157261 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 157264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157271 */     GIR_RootConstrainSelectedInstOperands,
     /* 157272 */     // GIR_Coverage, 6174,
     /* 157272 */     GIR_EraseRootFromParent_Done,
     /* 157273 */   // Label 3034: @157273
     /* 157273 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(157326), // Rule ID 6175 //
     /* 157278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157312 */     // MIs[1] Operand 1
     /* 157312 */     // No operand predicates
     /* 157312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157314 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 157317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157324 */     GIR_RootConstrainSelectedInstOperands,
     /* 157325 */     // GIR_Coverage, 6175,
     /* 157325 */     GIR_EraseRootFromParent_Done,
     /* 157326 */   // Label 3035: @157326
     /* 157326 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(157379), // Rule ID 6176 //
     /* 157331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157365 */     // MIs[1] Operand 1
     /* 157365 */     // No operand predicates
     /* 157365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157367 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 157370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157377 */     GIR_RootConstrainSelectedInstOperands,
     /* 157378 */     // GIR_Coverage, 6176,
     /* 157378 */     GIR_EraseRootFromParent_Done,
     /* 157379 */   // Label 3036: @157379
     /* 157379 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(157432), // Rule ID 6177 //
     /* 157384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157418 */     // MIs[1] Operand 1
     /* 157418 */     // No operand predicates
     /* 157418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157420 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 157423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157430 */     GIR_RootConstrainSelectedInstOperands,
     /* 157431 */     // GIR_Coverage, 6177,
     /* 157431 */     GIR_EraseRootFromParent_Done,
     /* 157432 */   // Label 3037: @157432
     /* 157432 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(157485), // Rule ID 6178 //
     /* 157437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157471 */     // MIs[1] Operand 1
     /* 157471 */     // No operand predicates
     /* 157471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157473 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157483 */     GIR_RootConstrainSelectedInstOperands,
     /* 157484 */     // GIR_Coverage, 6178,
     /* 157484 */     GIR_EraseRootFromParent_Done,
     /* 157485 */   // Label 3038: @157485
     /* 157485 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(157538), // Rule ID 6179 //
     /* 157490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157524 */     // MIs[1] Operand 1
     /* 157524 */     // No operand predicates
     /* 157524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157526 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157536 */     GIR_RootConstrainSelectedInstOperands,
     /* 157537 */     // GIR_Coverage, 6179,
     /* 157537 */     GIR_EraseRootFromParent_Done,
     /* 157538 */   // Label 3039: @157538
     /* 157538 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(157591), // Rule ID 6180 //
     /* 157543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157577 */     // MIs[1] Operand 1
     /* 157577 */     // No operand predicates
     /* 157577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157579 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 157582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157589 */     GIR_RootConstrainSelectedInstOperands,
     /* 157590 */     // GIR_Coverage, 6180,
     /* 157590 */     GIR_EraseRootFromParent_Done,
     /* 157591 */   // Label 3040: @157591
     /* 157591 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(157644), // Rule ID 6181 //
     /* 157596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157630 */     // MIs[1] Operand 1
     /* 157630 */     // No operand predicates
     /* 157630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157632 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 157635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157642 */     GIR_RootConstrainSelectedInstOperands,
     /* 157643 */     // GIR_Coverage, 6181,
     /* 157643 */     GIR_EraseRootFromParent_Done,
     /* 157644 */   // Label 3041: @157644
     /* 157644 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(157726), // Rule ID 6183 //
     /* 157649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157683 */     // MIs[1] Operand 1
     /* 157683 */     // No operand predicates
     /* 157683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157685 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157697 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157724 */     GIR_RootConstrainSelectedInstOperands,
     /* 157725 */     // GIR_Coverage, 6183,
     /* 157725 */     GIR_EraseRootFromParent_Done,
     /* 157726 */   // Label 3042: @157726
     /* 157726 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(157808), // Rule ID 6184 //
     /* 157731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157765 */     // MIs[1] Operand 1
     /* 157765 */     // No operand predicates
     /* 157765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157767 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157806 */     GIR_RootConstrainSelectedInstOperands,
     /* 157807 */     // GIR_Coverage, 6184,
     /* 157807 */     GIR_EraseRootFromParent_Done,
     /* 157808 */   // Label 3043: @157808
     /* 157808 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(157890), // Rule ID 6186 //
     /* 157813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157847 */     // MIs[1] Operand 1
     /* 157847 */     // No operand predicates
     /* 157847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157849 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157888 */     GIR_RootConstrainSelectedInstOperands,
     /* 157889 */     // GIR_Coverage, 6186,
     /* 157889 */     GIR_EraseRootFromParent_Done,
     /* 157890 */   // Label 3044: @157890
     /* 157890 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(157972), // Rule ID 6187 //
     /* 157895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157929 */     // MIs[1] Operand 1
     /* 157929 */     // No operand predicates
     /* 157929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157931 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157943 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157970 */     GIR_RootConstrainSelectedInstOperands,
     /* 157971 */     // GIR_Coverage, 6187,
     /* 157971 */     GIR_EraseRootFromParent_Done,
     /* 157972 */   // Label 3045: @157972
     /* 157972 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(158078), // Rule ID 6188 //
     /* 157977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158011 */     // MIs[1] Operand 1
     /* 158011 */     // No operand predicates
     /* 158011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158013 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 158013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 158016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 158020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158025 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 158029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 158032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 158041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 158051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 158062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158077 */     // GIR_Coverage, 6188,
     /* 158077 */     GIR_EraseRootFromParent_Done,
     /* 158078 */   // Label 3046: @158078
     /* 158078 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(158184), // Rule ID 6189 //
     /* 158083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 158088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 158117 */     // MIs[1] Operand 1
     /* 158117 */     // No operand predicates
     /* 158117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158119 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 158119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 158122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 158126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 158135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 158138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 158147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 158157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 158168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158183 */     // GIR_Coverage, 6189,
     /* 158183 */     GIR_EraseRootFromParent_Done,
     /* 158184 */   // Label 3047: @158184
     /* 158184 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(158290), // Rule ID 6190 //
     /* 158189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 158194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 158223 */     // MIs[1] Operand 1
     /* 158223 */     // No operand predicates
     /* 158223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158225 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 158225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 158228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 158232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158237 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 158241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 158244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 158253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 158263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 158274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158289 */     // GIR_Coverage, 6190,
     /* 158289 */     GIR_EraseRootFromParent_Done,
     /* 158290 */   // Label 3048: @158290
     /* 158290 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(158396), // Rule ID 6191 //
     /* 158295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 158300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 158329 */     // MIs[1] Operand 1
     /* 158329 */     // No operand predicates
     /* 158329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158331 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 158331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 158334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 158338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 158347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 158350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 158359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 158369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 158380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158395 */     // GIR_Coverage, 6191,
     /* 158395 */     GIR_EraseRootFromParent_Done,
     /* 158396 */   // Label 3049: @158396
     /* 158396 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(158451), // Rule ID 6888 //
     /* 158401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 158406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 158423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 158435 */     // MIs[1] Operand 1
     /* 158435 */     // No operand predicates
     /* 158435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158437 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 158437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 158440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 158442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158444 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 158449 */     GIR_RootConstrainSelectedInstOperands,
     /* 158450 */     // GIR_Coverage, 6888,
     /* 158450 */     GIR_EraseRootFromParent_Done,
     /* 158451 */   // Label 3050: @158451
     /* 158451 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(158493), // Rule ID 3031 //
     /* 158456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158474 */     // MIs[0] Op2
     /* 158474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 158482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 158482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 158485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158491 */     GIR_RootConstrainSelectedInstOperands,
     /* 158492 */     // GIR_Coverage, 3031,
     /* 158492 */     GIR_EraseRootFromParent_Done,
     /* 158493 */   // Label 3051: @158493
     /* 158493 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(158535), // Rule ID 3032 //
     /* 158498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158516 */     // MIs[0] Op2
     /* 158516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 158524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 158524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 158527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158533 */     GIR_RootConstrainSelectedInstOperands,
     /* 158534 */     // GIR_Coverage, 3032,
     /* 158534 */     GIR_EraseRootFromParent_Done,
     /* 158535 */   // Label 3052: @158535
     /* 158535 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(158577), // Rule ID 3033 //
     /* 158540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158558 */     // MIs[0] Op2
     /* 158558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 158566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 158566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 158569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158575 */     GIR_RootConstrainSelectedInstOperands,
     /* 158576 */     // GIR_Coverage, 3033,
     /* 158576 */     GIR_EraseRootFromParent_Done,
     /* 158577 */   // Label 3053: @158577
     /* 158577 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(158619), // Rule ID 3067 //
     /* 158582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158600 */     // MIs[0] Op2
     /* 158600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 158611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158617 */     GIR_RootConstrainSelectedInstOperands,
     /* 158618 */     // GIR_Coverage, 3067,
     /* 158618 */     GIR_EraseRootFromParent_Done,
     /* 158619 */   // Label 3054: @158619
     /* 158619 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(158661), // Rule ID 3068 //
     /* 158624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158642 */     // MIs[0] Op2
     /* 158642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 158653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158659 */     GIR_RootConstrainSelectedInstOperands,
     /* 158660 */     // GIR_Coverage, 3068,
     /* 158660 */     GIR_EraseRootFromParent_Done,
     /* 158661 */   // Label 3055: @158661
     /* 158661 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(158703), // Rule ID 3069 //
     /* 158666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158684 */     // MIs[0] Op2
     /* 158684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 158695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158701 */     GIR_RootConstrainSelectedInstOperands,
     /* 158702 */     // GIR_Coverage, 3069,
     /* 158702 */     GIR_EraseRootFromParent_Done,
     /* 158703 */   // Label 3056: @158703
     /* 158703 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(158745), // Rule ID 3510 //
     /* 158708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158726 */     // MIs[0] Op2
     /* 158726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 158734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 158734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 158737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158743 */     GIR_RootConstrainSelectedInstOperands,
     /* 158744 */     // GIR_Coverage, 3510,
     /* 158744 */     GIR_EraseRootFromParent_Done,
     /* 158745 */   // Label 3057: @158745
     /* 158745 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(158787), // Rule ID 3511 //
     /* 158750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158768 */     // MIs[0] Op2
     /* 158768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158785 */     GIR_RootConstrainSelectedInstOperands,
     /* 158786 */     // GIR_Coverage, 3511,
     /* 158786 */     GIR_EraseRootFromParent_Done,
     /* 158787 */   // Label 3058: @158787
     /* 158787 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(158829), // Rule ID 3512 //
     /* 158792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158810 */     // MIs[0] Op2
     /* 158810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158827 */     GIR_RootConstrainSelectedInstOperands,
     /* 158828 */     // GIR_Coverage, 3512,
     /* 158828 */     GIR_EraseRootFromParent_Done,
     /* 158829 */   // Label 3059: @158829
     /* 158829 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(158871), // Rule ID 3513 //
     /* 158834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158852 */     // MIs[0] Op2
     /* 158852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158869 */     GIR_RootConstrainSelectedInstOperands,
     /* 158870 */     // GIR_Coverage, 3513,
     /* 158870 */     GIR_EraseRootFromParent_Done,
     /* 158871 */   // Label 3060: @158871
     /* 158871 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(158913), // Rule ID 3514 //
     /* 158876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158894 */     // MIs[0] Op2
     /* 158894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1251:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158911 */     GIR_RootConstrainSelectedInstOperands,
     /* 158912 */     // GIR_Coverage, 3514,
     /* 158912 */     GIR_EraseRootFromParent_Done,
     /* 158913 */   // Label 3061: @158913
     /* 158913 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(158955), // Rule ID 3515 //
     /* 158918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158936 */     // MIs[0] Op2
     /* 158936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1251:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158953 */     GIR_RootConstrainSelectedInstOperands,
     /* 158954 */     // GIR_Coverage, 3515,
     /* 158954 */     GIR_EraseRootFromParent_Done,
     /* 158955 */   // Label 3062: @158955
     /* 158955 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(158997), // Rule ID 3516 //
     /* 158960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158978 */     // MIs[0] Op2
     /* 158978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1251:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158995 */     GIR_RootConstrainSelectedInstOperands,
     /* 158996 */     // GIR_Coverage, 3516,
     /* 158996 */     GIR_EraseRootFromParent_Done,
     /* 158997 */   // Label 3063: @158997
     /* 158997 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(159039), // Rule ID 11577 //
     /* 159002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 159010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159020 */     // MIs[0] Op2
     /* 159020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 159031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159037 */     GIR_RootConstrainSelectedInstOperands,
     /* 159038 */     // GIR_Coverage, 11577,
     /* 159038 */     GIR_EraseRootFromParent_Done,
     /* 159039 */   // Label 3064: @159039
     /* 159039 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(159081), // Rule ID 11578 //
     /* 159044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 159052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159062 */     // MIs[0] Op2
     /* 159062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 159073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159079 */     GIR_RootConstrainSelectedInstOperands,
     /* 159080 */     // GIR_Coverage, 11578,
     /* 159080 */     GIR_EraseRootFromParent_Done,
     /* 159081 */   // Label 3065: @159081
     /* 159081 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(159123), // Rule ID 11579 //
     /* 159086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 159094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159104 */     // MIs[0] Op2
     /* 159104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 159115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159121 */     GIR_RootConstrainSelectedInstOperands,
     /* 159122 */     // GIR_Coverage, 11579,
     /* 159122 */     GIR_EraseRootFromParent_Done,
     /* 159123 */   // Label 3066: @159123
     /* 159123 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(159165), // Rule ID 11580 //
     /* 159128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 159136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159146 */     // MIs[0] Op2
     /* 159146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1624:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 159157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159163 */     GIR_RootConstrainSelectedInstOperands,
     /* 159164 */     // GIR_Coverage, 11580,
     /* 159164 */     GIR_EraseRootFromParent_Done,
     /* 159165 */   // Label 3067: @159165
     /* 159165 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(159207), // Rule ID 11581 //
     /* 159170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 159178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159188 */     // MIs[0] Op2
     /* 159188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 159199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159205 */     GIR_RootConstrainSelectedInstOperands,
     /* 159206 */     // GIR_Coverage, 11581,
     /* 159206 */     GIR_EraseRootFromParent_Done,
     /* 159207 */   // Label 3068: @159207
     /* 159207 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(159249), // Rule ID 11582 //
     /* 159212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 159220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159230 */     // MIs[0] Op2
     /* 159230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 159241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159247 */     GIR_RootConstrainSelectedInstOperands,
     /* 159248 */     // GIR_Coverage, 11582,
     /* 159248 */     GIR_EraseRootFromParent_Done,
     /* 159249 */   // Label 3069: @159249
     /* 159249 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(159291), // Rule ID 11584 //
     /* 159254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 159262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159272 */     // MIs[0] Op2
     /* 159272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159280 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 159283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159289 */     GIR_RootConstrainSelectedInstOperands,
     /* 159290 */     // GIR_Coverage, 11584,
     /* 159290 */     GIR_EraseRootFromParent_Done,
     /* 159291 */   // Label 3070: @159291
     /* 159291 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(159333), // Rule ID 11586 //
     /* 159296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 159304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159314 */     // MIs[0] Op2
     /* 159314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 159325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159331 */     GIR_RootConstrainSelectedInstOperands,
     /* 159332 */     // GIR_Coverage, 11586,
     /* 159332 */     GIR_EraseRootFromParent_Done,
     /* 159333 */   // Label 3071: @159333
     /* 159333 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(159375), // Rule ID 11588 //
     /* 159338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 159346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159356 */     // MIs[0] Op2
     /* 159356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1582:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 159367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159373 */     GIR_RootConstrainSelectedInstOperands,
     /* 159374 */     // GIR_Coverage, 11588,
     /* 159374 */     GIR_EraseRootFromParent_Done,
     /* 159375 */   // Label 3072: @159375
     /* 159375 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(159417), // Rule ID 11589 //
     /* 159380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159398 */     // MIs[0] Op2
     /* 159398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159415 */     GIR_RootConstrainSelectedInstOperands,
     /* 159416 */     // GIR_Coverage, 11589,
     /* 159416 */     GIR_EraseRootFromParent_Done,
     /* 159417 */   // Label 3073: @159417
     /* 159417 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(159459), // Rule ID 11590 //
     /* 159422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159440 */     // MIs[0] Op2
     /* 159440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 159451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159457 */     GIR_RootConstrainSelectedInstOperands,
     /* 159458 */     // GIR_Coverage, 11590,
     /* 159458 */     GIR_EraseRootFromParent_Done,
     /* 159459 */   // Label 3074: @159459
     /* 159459 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(159501), // Rule ID 11591 //
     /* 159464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159482 */     // MIs[0] Op2
     /* 159482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 159493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159499 */     GIR_RootConstrainSelectedInstOperands,
     /* 159500 */     // GIR_Coverage, 11591,
     /* 159500 */     GIR_EraseRootFromParent_Done,
     /* 159501 */   // Label 3075: @159501
     /* 159501 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(159543), // Rule ID 11592 //
     /* 159506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159524 */     // MIs[0] Op2
     /* 159524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 159535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159541 */     GIR_RootConstrainSelectedInstOperands,
     /* 159542 */     // GIR_Coverage, 11592,
     /* 159542 */     GIR_EraseRootFromParent_Done,
     /* 159543 */   // Label 3076: @159543
     /* 159543 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(159585), // Rule ID 11593 //
     /* 159548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159566 */     // MIs[0] Op2
     /* 159566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 159577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159583 */     GIR_RootConstrainSelectedInstOperands,
     /* 159584 */     // GIR_Coverage, 11593,
     /* 159584 */     GIR_EraseRootFromParent_Done,
     /* 159585 */   // Label 3077: @159585
     /* 159585 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159627), // Rule ID 11594 //
     /* 159590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159608 */     // MIs[0] Op2
     /* 159608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 159619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159625 */     GIR_RootConstrainSelectedInstOperands,
     /* 159626 */     // GIR_Coverage, 11594,
     /* 159626 */     GIR_EraseRootFromParent_Done,
     /* 159627 */   // Label 3078: @159627
     /* 159627 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159669), // Rule ID 11595 //
     /* 159632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159650 */     // MIs[0] Op2
     /* 159650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159658 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 159661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159667 */     GIR_RootConstrainSelectedInstOperands,
     /* 159668 */     // GIR_Coverage, 11595,
     /* 159668 */     GIR_EraseRootFromParent_Done,
     /* 159669 */   // Label 3079: @159669
     /* 159669 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159711), // Rule ID 11596 //
     /* 159674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159692 */     // MIs[0] Op2
     /* 159692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 159703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159709 */     GIR_RootConstrainSelectedInstOperands,
     /* 159710 */     // GIR_Coverage, 11596,
     /* 159710 */     GIR_EraseRootFromParent_Done,
     /* 159711 */   // Label 3080: @159711
     /* 159711 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159753), // Rule ID 11597 //
     /* 159716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159734 */     // MIs[0] Op2
     /* 159734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 159745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159751 */     GIR_RootConstrainSelectedInstOperands,
     /* 159752 */     // GIR_Coverage, 11597,
     /* 159752 */     GIR_EraseRootFromParent_Done,
     /* 159753 */   // Label 3081: @159753
     /* 159753 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159795), // Rule ID 11598 //
     /* 159758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159776 */     // MIs[0] Op2
     /* 159776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 159787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159793 */     GIR_RootConstrainSelectedInstOperands,
     /* 159794 */     // GIR_Coverage, 11598,
     /* 159794 */     GIR_EraseRootFromParent_Done,
     /* 159795 */   // Label 3082: @159795
     /* 159795 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159837), // Rule ID 11599 //
     /* 159800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159818 */     // MIs[0] Op2
     /* 159818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 159829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159835 */     GIR_RootConstrainSelectedInstOperands,
     /* 159836 */     // GIR_Coverage, 11599,
     /* 159836 */     GIR_EraseRootFromParent_Done,
     /* 159837 */   // Label 3083: @159837
     /* 159837 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159879), // Rule ID 11600 //
     /* 159842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159860 */     // MIs[0] Op2
     /* 159860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 159871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159877 */     GIR_RootConstrainSelectedInstOperands,
     /* 159878 */     // GIR_Coverage, 11600,
     /* 159878 */     GIR_EraseRootFromParent_Done,
     /* 159879 */   // Label 3084: @159879
     /* 159879 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159921), // Rule ID 11658 //
     /* 159884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159902 */     // MIs[0] Op2
     /* 159902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 159913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159919 */     GIR_RootConstrainSelectedInstOperands,
     /* 159920 */     // GIR_Coverage, 11658,
     /* 159920 */     GIR_EraseRootFromParent_Done,
     /* 159921 */   // Label 3085: @159921
     /* 159921 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159963), // Rule ID 11659 //
     /* 159926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159944 */     // MIs[0] Op2
     /* 159944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 159955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159961 */     GIR_RootConstrainSelectedInstOperands,
     /* 159962 */     // GIR_Coverage, 11659,
     /* 159962 */     GIR_EraseRootFromParent_Done,
     /* 159963 */   // Label 3086: @159963
     /* 159963 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(160005), // Rule ID 11660 //
     /* 159968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159986 */     // MIs[0] Op2
     /* 159986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 159997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160003 */     GIR_RootConstrainSelectedInstOperands,
     /* 160004 */     // GIR_Coverage, 11660,
     /* 160004 */     GIR_EraseRootFromParent_Done,
     /* 160005 */   // Label 3087: @160005
     /* 160005 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(160047), // Rule ID 11661 //
     /* 160010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 160018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 160021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 160024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160028 */     // MIs[0] Op2
     /* 160028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 160036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 160036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 160039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160045 */     GIR_RootConstrainSelectedInstOperands,
     /* 160046 */     // GIR_Coverage, 11661,
     /* 160046 */     GIR_EraseRootFromParent_Done,
     /* 160047 */   // Label 3088: @160047
     /* 160047 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160089), // Rule ID 11662 //
     /* 160052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 160060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 160063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 160066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160070 */     // MIs[0] Op2
     /* 160070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 160078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 160078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 160081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160087 */     GIR_RootConstrainSelectedInstOperands,
     /* 160088 */     // GIR_Coverage, 11662,
     /* 160088 */     GIR_EraseRootFromParent_Done,
     /* 160089 */   // Label 3089: @160089
     /* 160089 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160131), // Rule ID 11663 //
     /* 160094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 160102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 160105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 160108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160112 */     // MIs[0] Op2
     /* 160112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 160120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 160120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 160123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160129 */     GIR_RootConstrainSelectedInstOperands,
     /* 160130 */     // GIR_Coverage, 11663,
     /* 160130 */     GIR_EraseRootFromParent_Done,
     /* 160131 */   // Label 3090: @160131
     /* 160131 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160173), // Rule ID 11664 //
     /* 160136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 160144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 160147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 160150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160154 */     // MIs[0] Op2
     /* 160154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 160162 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1965:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 160162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 160165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160171 */     GIR_RootConstrainSelectedInstOperands,
     /* 160172 */     // GIR_Coverage, 11664,
     /* 160172 */     GIR_EraseRootFromParent_Done,
     /* 160173 */   // Label 3091: @160173
     /* 160173 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160215), // Rule ID 11665 //
     /* 160178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 160186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 160189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 160192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160196 */     // MIs[0] Op2
     /* 160196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 160204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 160204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 160207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160213 */     GIR_RootConstrainSelectedInstOperands,
     /* 160214 */     // GIR_Coverage, 11665,
     /* 160214 */     GIR_EraseRootFromParent_Done,
     /* 160215 */   // Label 3092: @160215
     /* 160215 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160257), // Rule ID 11666 //
     /* 160220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 160223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 160228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 160231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 160234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 160238 */     // MIs[0] Op2
     /* 160238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 160241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 160246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 160246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 160249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 160251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 160255 */     GIR_RootConstrainSelectedInstOperands,
     /* 160256 */     // GIR_Coverage, 11666,
     /* 160256 */     GIR_EraseRootFromParent_Done,
     /* 160257 */   // Label 3093: @160257
     /* 160257 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160309), // Rule ID 2123 //
     /* 160262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160295 */     // MIs[1] Operand 1
     /* 160295 */     // No operand predicates
     /* 160295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160297 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 160300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160307 */     GIR_RootConstrainSelectedInstOperands,
     /* 160308 */     // GIR_Coverage, 2123,
     /* 160308 */     GIR_EraseRootFromParent_Done,
     /* 160309 */   // Label 3094: @160309
     /* 160309 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160361), // Rule ID 2124 //
     /* 160314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160347 */     // MIs[1] Operand 1
     /* 160347 */     // No operand predicates
     /* 160347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160349 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 160352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160359 */     GIR_RootConstrainSelectedInstOperands,
     /* 160360 */     // GIR_Coverage, 2124,
     /* 160360 */     GIR_EraseRootFromParent_Done,
     /* 160361 */   // Label 3095: @160361
     /* 160361 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160413), // Rule ID 2125 //
     /* 160366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160399 */     // MIs[1] Operand 1
     /* 160399 */     // No operand predicates
     /* 160399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160401 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 160404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160411 */     GIR_RootConstrainSelectedInstOperands,
     /* 160412 */     // GIR_Coverage, 2125,
     /* 160412 */     GIR_EraseRootFromParent_Done,
     /* 160413 */   // Label 3096: @160413
     /* 160413 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160465), // Rule ID 2126 //
     /* 160418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160451 */     // MIs[1] Operand 1
     /* 160451 */     // No operand predicates
     /* 160451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 160456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160463 */     GIR_RootConstrainSelectedInstOperands,
     /* 160464 */     // GIR_Coverage, 2126,
     /* 160464 */     GIR_EraseRootFromParent_Done,
     /* 160465 */   // Label 3097: @160465
     /* 160465 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160517), // Rule ID 2127 //
     /* 160470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160503 */     // MIs[1] Operand 1
     /* 160503 */     // No operand predicates
     /* 160503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160505 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 160508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160515 */     GIR_RootConstrainSelectedInstOperands,
     /* 160516 */     // GIR_Coverage, 2127,
     /* 160516 */     GIR_EraseRootFromParent_Done,
     /* 160517 */   // Label 3098: @160517
     /* 160517 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160569), // Rule ID 2128 //
     /* 160522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160555 */     // MIs[1] Operand 1
     /* 160555 */     // No operand predicates
     /* 160555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160557 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 160560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160567 */     GIR_RootConstrainSelectedInstOperands,
     /* 160568 */     // GIR_Coverage, 2128,
     /* 160568 */     GIR_EraseRootFromParent_Done,
     /* 160569 */   // Label 3099: @160569
     /* 160569 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160621), // Rule ID 2129 //
     /* 160574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160607 */     // MIs[1] Operand 1
     /* 160607 */     // No operand predicates
     /* 160607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160609 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 160612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160619 */     GIR_RootConstrainSelectedInstOperands,
     /* 160620 */     // GIR_Coverage, 2129,
     /* 160620 */     GIR_EraseRootFromParent_Done,
     /* 160621 */   // Label 3100: @160621
     /* 160621 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160673), // Rule ID 2130 //
     /* 160626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160659 */     // MIs[1] Operand 1
     /* 160659 */     // No operand predicates
     /* 160659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160661 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 160664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160671 */     GIR_RootConstrainSelectedInstOperands,
     /* 160672 */     // GIR_Coverage, 2130,
     /* 160672 */     GIR_EraseRootFromParent_Done,
     /* 160673 */   // Label 3101: @160673
     /* 160673 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(160725), // Rule ID 2131 //
     /* 160678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160711 */     // MIs[1] Operand 1
     /* 160711 */     // No operand predicates
     /* 160711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160713 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 160716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160723 */     GIR_RootConstrainSelectedInstOperands,
     /* 160724 */     // GIR_Coverage, 2131,
     /* 160724 */     GIR_EraseRootFromParent_Done,
     /* 160725 */   // Label 3102: @160725
     /* 160725 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(160777), // Rule ID 2132 //
     /* 160730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160763 */     // MIs[1] Operand 1
     /* 160763 */     // No operand predicates
     /* 160763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160765 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 160768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160775 */     GIR_RootConstrainSelectedInstOperands,
     /* 160776 */     // GIR_Coverage, 2132,
     /* 160776 */     GIR_EraseRootFromParent_Done,
     /* 160777 */   // Label 3103: @160777
     /* 160777 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(160829), // Rule ID 2133 //
     /* 160782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160815 */     // MIs[1] Operand 1
     /* 160815 */     // No operand predicates
     /* 160815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160817 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 160820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160827 */     GIR_RootConstrainSelectedInstOperands,
     /* 160828 */     // GIR_Coverage, 2133,
     /* 160828 */     GIR_EraseRootFromParent_Done,
     /* 160829 */   // Label 3104: @160829
     /* 160829 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(160881), // Rule ID 2134 //
     /* 160834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160867 */     // MIs[1] Operand 1
     /* 160867 */     // No operand predicates
     /* 160867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160869 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 160872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160879 */     GIR_RootConstrainSelectedInstOperands,
     /* 160880 */     // GIR_Coverage, 2134,
     /* 160880 */     GIR_EraseRootFromParent_Done,
     /* 160881 */   // Label 3105: @160881
     /* 160881 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(160933), // Rule ID 2135 //
     /* 160886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160919 */     // MIs[1] Operand 1
     /* 160919 */     // No operand predicates
     /* 160919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160921 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 160924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160931 */     GIR_RootConstrainSelectedInstOperands,
     /* 160932 */     // GIR_Coverage, 2135,
     /* 160932 */     GIR_EraseRootFromParent_Done,
     /* 160933 */   // Label 3106: @160933
     /* 160933 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(160985), // Rule ID 2136 //
     /* 160938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160971 */     // MIs[1] Operand 1
     /* 160971 */     // No operand predicates
     /* 160971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160973 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 160976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160983 */     GIR_RootConstrainSelectedInstOperands,
     /* 160984 */     // GIR_Coverage, 2136,
     /* 160984 */     GIR_EraseRootFromParent_Done,
     /* 160985 */   // Label 3107: @160985
     /* 160985 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161037), // Rule ID 2137 //
     /* 160990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161023 */     // MIs[1] Operand 1
     /* 161023 */     // No operand predicates
     /* 161023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161025 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 161028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161035 */     GIR_RootConstrainSelectedInstOperands,
     /* 161036 */     // GIR_Coverage, 2137,
     /* 161036 */     GIR_EraseRootFromParent_Done,
     /* 161037 */   // Label 3108: @161037
     /* 161037 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161089), // Rule ID 2235 //
     /* 161042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 161050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161075 */     // MIs[1] Operand 1
     /* 161075 */     // No operand predicates
     /* 161075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161077 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 161080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161087 */     GIR_RootConstrainSelectedInstOperands,
     /* 161088 */     // GIR_Coverage, 2235,
     /* 161088 */     GIR_EraseRootFromParent_Done,
     /* 161089 */   // Label 3109: @161089
     /* 161089 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161141), // Rule ID 2236 //
     /* 161094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 161102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161127 */     // MIs[1] Operand 1
     /* 161127 */     // No operand predicates
     /* 161127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161129 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 161132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161139 */     GIR_RootConstrainSelectedInstOperands,
     /* 161140 */     // GIR_Coverage, 2236,
     /* 161140 */     GIR_EraseRootFromParent_Done,
     /* 161141 */   // Label 3110: @161141
     /* 161141 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161193), // Rule ID 2237 //
     /* 161146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 161154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161179 */     // MIs[1] Operand 1
     /* 161179 */     // No operand predicates
     /* 161179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161181 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 161184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161191 */     GIR_RootConstrainSelectedInstOperands,
     /* 161192 */     // GIR_Coverage, 2237,
     /* 161192 */     GIR_EraseRootFromParent_Done,
     /* 161193 */   // Label 3111: @161193
     /* 161193 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161245), // Rule ID 2238 //
     /* 161198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 161206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161231 */     // MIs[1] Operand 1
     /* 161231 */     // No operand predicates
     /* 161231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161233 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 161236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161243 */     GIR_RootConstrainSelectedInstOperands,
     /* 161244 */     // GIR_Coverage, 2238,
     /* 161244 */     GIR_EraseRootFromParent_Done,
     /* 161245 */   // Label 3112: @161245
     /* 161245 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161297), // Rule ID 2239 //
     /* 161250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 161258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161283 */     // MIs[1] Operand 1
     /* 161283 */     // No operand predicates
     /* 161283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161285 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 161288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161295 */     GIR_RootConstrainSelectedInstOperands,
     /* 161296 */     // GIR_Coverage, 2239,
     /* 161296 */     GIR_EraseRootFromParent_Done,
     /* 161297 */   // Label 3113: @161297
     /* 161297 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161342), // Rule ID 63 //
     /* 161302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 161310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 161331 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 161331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 161334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161340 */     GIR_RootConstrainSelectedInstOperands,
     /* 161341 */     // GIR_Coverage, 63,
     /* 161341 */     GIR_EraseRootFromParent_Done,
     /* 161342 */   // Label 3114: @161342
     /* 161342 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161387), // Rule ID 129 //
     /* 161347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 161355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161376 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 161379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161385 */     GIR_RootConstrainSelectedInstOperands,
     /* 161386 */     // GIR_Coverage, 129,
     /* 161386 */     GIR_EraseRootFromParent_Done,
     /* 161387 */   // Label 3115: @161387
     /* 161387 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161432), // Rule ID 130 //
     /* 161392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 161400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161421 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 161424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161430 */     GIR_RootConstrainSelectedInstOperands,
     /* 161431 */     // GIR_Coverage, 130,
     /* 161431 */     GIR_EraseRootFromParent_Done,
     /* 161432 */   // Label 3116: @161432
     /* 161432 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(161477), // Rule ID 131 //
     /* 161437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 161445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161466 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 161469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161475 */     GIR_RootConstrainSelectedInstOperands,
     /* 161476 */     // GIR_Coverage, 131,
     /* 161476 */     GIR_EraseRootFromParent_Done,
     /* 161477 */   // Label 3117: @161477
     /* 161477 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(161522), // Rule ID 132 //
     /* 161482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 161490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161511 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 161514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161520 */     GIR_RootConstrainSelectedInstOperands,
     /* 161521 */     // GIR_Coverage, 132,
     /* 161521 */     GIR_EraseRootFromParent_Done,
     /* 161522 */   // Label 3118: @161522
     /* 161522 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(161567), // Rule ID 133 //
     /* 161527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 161535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161556 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 161559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161565 */     GIR_RootConstrainSelectedInstOperands,
     /* 161566 */     // GIR_Coverage, 133,
     /* 161566 */     GIR_EraseRootFromParent_Done,
     /* 161567 */   // Label 3119: @161567
     /* 161567 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(161612), // Rule ID 134 //
     /* 161572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 161580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161601 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 161604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161610 */     GIR_RootConstrainSelectedInstOperands,
     /* 161611 */     // GIR_Coverage, 134,
     /* 161611 */     GIR_EraseRootFromParent_Done,
     /* 161612 */   // Label 3120: @161612
     /* 161612 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(161657), // Rule ID 135 //
     /* 161617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 161625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161646 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 161649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161655 */     GIR_RootConstrainSelectedInstOperands,
     /* 161656 */     // GIR_Coverage, 135,
     /* 161656 */     GIR_EraseRootFromParent_Done,
     /* 161657 */   // Label 3121: @161657
     /* 161657 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161702), // Rule ID 136 //
     /* 161662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 161670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161691 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 161694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161700 */     GIR_RootConstrainSelectedInstOperands,
     /* 161701 */     // GIR_Coverage, 136,
     /* 161701 */     GIR_EraseRootFromParent_Done,
     /* 161702 */   // Label 3122: @161702
     /* 161702 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(161747), // Rule ID 1035 //
     /* 161707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161736 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 161736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 161739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161745 */     GIR_RootConstrainSelectedInstOperands,
     /* 161746 */     // GIR_Coverage, 1035,
     /* 161746 */     GIR_EraseRootFromParent_Done,
     /* 161747 */   // Label 3123: @161747
     /* 161747 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(161792), // Rule ID 1036 //
     /* 161752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161781 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 161781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 161784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161790 */     GIR_RootConstrainSelectedInstOperands,
     /* 161791 */     // GIR_Coverage, 1036,
     /* 161791 */     GIR_EraseRootFromParent_Done,
     /* 161792 */   // Label 3124: @161792
     /* 161792 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(161837), // Rule ID 1037 //
     /* 161797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161826 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 161826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 161829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161835 */     GIR_RootConstrainSelectedInstOperands,
     /* 161836 */     // GIR_Coverage, 1037,
     /* 161836 */     GIR_EraseRootFromParent_Done,
     /* 161837 */   // Label 3125: @161837
     /* 161837 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(161882), // Rule ID 1038 //
     /* 161842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161871 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 161871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 161874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161880 */     GIR_RootConstrainSelectedInstOperands,
     /* 161881 */     // GIR_Coverage, 1038,
     /* 161881 */     GIR_EraseRootFromParent_Done,
     /* 161882 */   // Label 3126: @161882
     /* 161882 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(161927), // Rule ID 1039 //
     /* 161887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161916 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 161916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 161919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161925 */     GIR_RootConstrainSelectedInstOperands,
     /* 161926 */     // GIR_Coverage, 1039,
     /* 161926 */     GIR_EraseRootFromParent_Done,
     /* 161927 */   // Label 3127: @161927
     /* 161927 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(161972), // Rule ID 1040 //
     /* 161932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 161961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 161964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161970 */     GIR_RootConstrainSelectedInstOperands,
     /* 161971 */     // GIR_Coverage, 1040,
     /* 161971 */     GIR_EraseRootFromParent_Done,
     /* 161972 */   // Label 3128: @161972
     /* 161972 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162017), // Rule ID 1041 //
     /* 161977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162006 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 162006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 162009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162015 */     GIR_RootConstrainSelectedInstOperands,
     /* 162016 */     // GIR_Coverage, 1041,
     /* 162016 */     GIR_EraseRootFromParent_Done,
     /* 162017 */   // Label 3129: @162017
     /* 162017 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162062), // Rule ID 1083 //
     /* 162022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 162036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 162039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162051 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 162051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 162054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162060 */     GIR_RootConstrainSelectedInstOperands,
     /* 162061 */     // GIR_Coverage, 1083,
     /* 162061 */     GIR_EraseRootFromParent_Done,
     /* 162062 */   // Label 3130: @162062
     /* 162062 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162107), // Rule ID 1084 //
     /* 162067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 162078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 162084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 162096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 162099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162105 */     GIR_RootConstrainSelectedInstOperands,
     /* 162106 */     // GIR_Coverage, 1084,
     /* 162106 */     GIR_EraseRootFromParent_Done,
     /* 162107 */   // Label 3131: @162107
     /* 162107 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162152), // Rule ID 1085 //
     /* 162112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162141 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 162141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 162144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162150 */     GIR_RootConstrainSelectedInstOperands,
     /* 162151 */     // GIR_Coverage, 1085,
     /* 162151 */     GIR_EraseRootFromParent_Done,
     /* 162152 */   // Label 3132: @162152
     /* 162152 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162197), // Rule ID 1086 //
     /* 162157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162186 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 162186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 162189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162195 */     GIR_RootConstrainSelectedInstOperands,
     /* 162196 */     // GIR_Coverage, 1086,
     /* 162196 */     GIR_EraseRootFromParent_Done,
     /* 162197 */   // Label 3133: @162197
     /* 162197 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162242), // Rule ID 1087 //
     /* 162202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162231 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 162231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 162234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162240 */     GIR_RootConstrainSelectedInstOperands,
     /* 162241 */     // GIR_Coverage, 1087,
     /* 162241 */     GIR_EraseRootFromParent_Done,
     /* 162242 */   // Label 3134: @162242
     /* 162242 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162287), // Rule ID 1088 //
     /* 162247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 162276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 162279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162285 */     GIR_RootConstrainSelectedInstOperands,
     /* 162286 */     // GIR_Coverage, 1088,
     /* 162286 */     GIR_EraseRootFromParent_Done,
     /* 162287 */   // Label 3135: @162287
     /* 162287 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162332), // Rule ID 1089 //
     /* 162292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 162300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162321 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 162321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 162324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 162330 */     GIR_RootConstrainSelectedInstOperands,
     /* 162331 */     // GIR_Coverage, 1089,
     /* 162331 */     GIR_EraseRootFromParent_Done,
     /* 162332 */   // Label 3136: @162332
     /* 162332 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162377), // Rule ID 1101 //
     /* 162337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 162351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 162354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162366 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 162366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 162369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162375 */     GIR_RootConstrainSelectedInstOperands,
     /* 162376 */     // GIR_Coverage, 1101,
     /* 162376 */     GIR_EraseRootFromParent_Done,
     /* 162377 */   // Label 3137: @162377
     /* 162377 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162422), // Rule ID 1103 //
     /* 162382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 162393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 162399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162411 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 162411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 162414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162420 */     GIR_RootConstrainSelectedInstOperands,
     /* 162421 */     // GIR_Coverage, 1103,
     /* 162421 */     GIR_EraseRootFromParent_Done,
     /* 162422 */   // Label 3138: @162422
     /* 162422 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(162467), // Rule ID 1105 //
     /* 162427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162456 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 162456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 162459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162465 */     GIR_RootConstrainSelectedInstOperands,
     /* 162466 */     // GIR_Coverage, 1105,
     /* 162466 */     GIR_EraseRootFromParent_Done,
     /* 162467 */   // Label 3139: @162467
     /* 162467 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(162512), // Rule ID 1107 //
     /* 162472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162501 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 162501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 162504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162510 */     GIR_RootConstrainSelectedInstOperands,
     /* 162511 */     // GIR_Coverage, 1107,
     /* 162511 */     GIR_EraseRootFromParent_Done,
     /* 162512 */   // Label 3140: @162512
     /* 162512 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(162557), // Rule ID 1109 //
     /* 162517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162546 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 162546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 162549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162555 */     GIR_RootConstrainSelectedInstOperands,
     /* 162556 */     // GIR_Coverage, 1109,
     /* 162556 */     GIR_EraseRootFromParent_Done,
     /* 162557 */   // Label 3141: @162557
     /* 162557 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(162602), // Rule ID 1111 //
     /* 162562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 162591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 162594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162600 */     GIR_RootConstrainSelectedInstOperands,
     /* 162601 */     // GIR_Coverage, 1111,
     /* 162601 */     GIR_EraseRootFromParent_Done,
     /* 162602 */   // Label 3142: @162602
     /* 162602 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(162647), // Rule ID 1113 //
     /* 162607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162636 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 162636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 162639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162645 */     GIR_RootConstrainSelectedInstOperands,
     /* 162646 */     // GIR_Coverage, 1113,
     /* 162646 */     GIR_EraseRootFromParent_Done,
     /* 162647 */   // Label 3143: @162647
     /* 162647 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(162692), // Rule ID 1156 //
     /* 162652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162681 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 162684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162690 */     GIR_RootConstrainSelectedInstOperands,
     /* 162691 */     // GIR_Coverage, 1156,
     /* 162691 */     GIR_EraseRootFromParent_Done,
     /* 162692 */   // Label 3144: @162692
     /* 162692 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(162737), // Rule ID 1157 //
     /* 162697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162726 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 162729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162735 */     GIR_RootConstrainSelectedInstOperands,
     /* 162736 */     // GIR_Coverage, 1157,
     /* 162736 */     GIR_EraseRootFromParent_Done,
     /* 162737 */   // Label 3145: @162737
     /* 162737 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(162782), // Rule ID 1158 //
     /* 162742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162771 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 162774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162780 */     GIR_RootConstrainSelectedInstOperands,
     /* 162781 */     // GIR_Coverage, 1158,
     /* 162781 */     GIR_EraseRootFromParent_Done,
     /* 162782 */   // Label 3146: @162782
     /* 162782 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(162827), // Rule ID 1159 //
     /* 162787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162816 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 162819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162825 */     GIR_RootConstrainSelectedInstOperands,
     /* 162826 */     // GIR_Coverage, 1159,
     /* 162826 */     GIR_EraseRootFromParent_Done,
     /* 162827 */   // Label 3147: @162827
     /* 162827 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(162872), // Rule ID 1160 //
     /* 162832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162861 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 162864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162870 */     GIR_RootConstrainSelectedInstOperands,
     /* 162871 */     // GIR_Coverage, 1160,
     /* 162871 */     GIR_EraseRootFromParent_Done,
     /* 162872 */   // Label 3148: @162872
     /* 162872 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(162917), // Rule ID 1162 //
     /* 162877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162906 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 162909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162915 */     GIR_RootConstrainSelectedInstOperands,
     /* 162916 */     // GIR_Coverage, 1162,
     /* 162916 */     GIR_EraseRootFromParent_Done,
     /* 162917 */   // Label 3149: @162917
     /* 162917 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(162962), // Rule ID 1164 //
     /* 162922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162951 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 162954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162960 */     GIR_RootConstrainSelectedInstOperands,
     /* 162961 */     // GIR_Coverage, 1164,
     /* 162961 */     GIR_EraseRootFromParent_Done,
     /* 162962 */   // Label 3150: @162962
     /* 162962 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163007), // Rule ID 1166 //
     /* 162967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162996 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 162999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163005 */     GIR_RootConstrainSelectedInstOperands,
     /* 163006 */     // GIR_Coverage, 1166,
     /* 163006 */     GIR_EraseRootFromParent_Done,
     /* 163007 */   // Label 3151: @163007
     /* 163007 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163052), // Rule ID 1168 //
     /* 163012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 163020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 163044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163050 */     GIR_RootConstrainSelectedInstOperands,
     /* 163051 */     // GIR_Coverage, 1168,
     /* 163051 */     GIR_EraseRootFromParent_Done,
     /* 163052 */   // Label 3152: @163052
     /* 163052 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163097), // Rule ID 1170 //
     /* 163057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 163065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163086 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 163089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163095 */     GIR_RootConstrainSelectedInstOperands,
     /* 163096 */     // GIR_Coverage, 1170,
     /* 163096 */     GIR_EraseRootFromParent_Done,
     /* 163097 */   // Label 3153: @163097
     /* 163097 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163142), // Rule ID 1172 //
     /* 163102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 163110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163131 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 163134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163140 */     GIR_RootConstrainSelectedInstOperands,
     /* 163141 */     // GIR_Coverage, 1172,
     /* 163141 */     GIR_EraseRootFromParent_Done,
     /* 163142 */   // Label 3154: @163142
     /* 163142 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163187), // Rule ID 1174 //
     /* 163147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 163155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163176 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 163179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163185 */     GIR_RootConstrainSelectedInstOperands,
     /* 163186 */     // GIR_Coverage, 1174,
     /* 163186 */     GIR_EraseRootFromParent_Done,
     /* 163187 */   // Label 3155: @163187
     /* 163187 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163232), // Rule ID 1176 //
     /* 163192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 163200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163221 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 163224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163230 */     GIR_RootConstrainSelectedInstOperands,
     /* 163231 */     // GIR_Coverage, 1176,
     /* 163231 */     GIR_EraseRootFromParent_Done,
     /* 163232 */   // Label 3156: @163232
     /* 163232 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163277), // Rule ID 1178 //
     /* 163237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 163245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163266 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 163269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163275 */     GIR_RootConstrainSelectedInstOperands,
     /* 163276 */     // GIR_Coverage, 1178,
     /* 163276 */     GIR_EraseRootFromParent_Done,
     /* 163277 */   // Label 3157: @163277
     /* 163277 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(163322), // Rule ID 1180 //
     /* 163282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 163290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163311 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 163314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163320 */     GIR_RootConstrainSelectedInstOperands,
     /* 163321 */     // GIR_Coverage, 1180,
     /* 163321 */     GIR_EraseRootFromParent_Done,
     /* 163322 */   // Label 3158: @163322
     /* 163322 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(163367), // Rule ID 1182 //
     /* 163327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163356 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 163359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163365 */     GIR_RootConstrainSelectedInstOperands,
     /* 163366 */     // GIR_Coverage, 1182,
     /* 163366 */     GIR_EraseRootFromParent_Done,
     /* 163367 */   // Label 3159: @163367
     /* 163367 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(163412), // Rule ID 1184 //
     /* 163372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163401 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 163404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163410 */     GIR_RootConstrainSelectedInstOperands,
     /* 163411 */     // GIR_Coverage, 1184,
     /* 163411 */     GIR_EraseRootFromParent_Done,
     /* 163412 */   // Label 3160: @163412
     /* 163412 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(163457), // Rule ID 1186 //
     /* 163417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163446 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 163449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163455 */     GIR_RootConstrainSelectedInstOperands,
     /* 163456 */     // GIR_Coverage, 1186,
     /* 163456 */     GIR_EraseRootFromParent_Done,
     /* 163457 */   // Label 3161: @163457
     /* 163457 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(163502), // Rule ID 1188 //
     /* 163462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163491 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 163494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163500 */     GIR_RootConstrainSelectedInstOperands,
     /* 163501 */     // GIR_Coverage, 1188,
     /* 163501 */     GIR_EraseRootFromParent_Done,
     /* 163502 */   // Label 3162: @163502
     /* 163502 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(163547), // Rule ID 1190 //
     /* 163507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163536 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 163539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163545 */     GIR_RootConstrainSelectedInstOperands,
     /* 163546 */     // GIR_Coverage, 1190,
     /* 163546 */     GIR_EraseRootFromParent_Done,
     /* 163547 */   // Label 3163: @163547
     /* 163547 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(163592), // Rule ID 1226 //
     /* 163552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163581 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 163584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163590 */     GIR_RootConstrainSelectedInstOperands,
     /* 163591 */     // GIR_Coverage, 1226,
     /* 163591 */     GIR_EraseRootFromParent_Done,
     /* 163592 */   // Label 3164: @163592
     /* 163592 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(163637), // Rule ID 1227 //
     /* 163597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163626 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 163629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163635 */     GIR_RootConstrainSelectedInstOperands,
     /* 163636 */     // GIR_Coverage, 1227,
     /* 163636 */     GIR_EraseRootFromParent_Done,
     /* 163637 */   // Label 3165: @163637
     /* 163637 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(163682), // Rule ID 1228 //
     /* 163642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163671 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 163674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163680 */     GIR_RootConstrainSelectedInstOperands,
     /* 163681 */     // GIR_Coverage, 1228,
     /* 163681 */     GIR_EraseRootFromParent_Done,
     /* 163682 */   // Label 3166: @163682
     /* 163682 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(163727), // Rule ID 1229 //
     /* 163687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 163719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163725 */     GIR_RootConstrainSelectedInstOperands,
     /* 163726 */     // GIR_Coverage, 1229,
     /* 163726 */     GIR_EraseRootFromParent_Done,
     /* 163727 */   // Label 3167: @163727
     /* 163727 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(163772), // Rule ID 1230 //
     /* 163732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163761 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 163764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163770 */     GIR_RootConstrainSelectedInstOperands,
     /* 163771 */     // GIR_Coverage, 1230,
     /* 163771 */     GIR_EraseRootFromParent_Done,
     /* 163772 */   // Label 3168: @163772
     /* 163772 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(163817), // Rule ID 1241 //
     /* 163777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163806 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 163809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163815 */     GIR_RootConstrainSelectedInstOperands,
     /* 163816 */     // GIR_Coverage, 1241,
     /* 163816 */     GIR_EraseRootFromParent_Done,
     /* 163817 */   // Label 3169: @163817
     /* 163817 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(163862), // Rule ID 1242 //
     /* 163822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163851 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 163854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163860 */     GIR_RootConstrainSelectedInstOperands,
     /* 163861 */     // GIR_Coverage, 1242,
     /* 163861 */     GIR_EraseRootFromParent_Done,
     /* 163862 */   // Label 3170: @163862
     /* 163862 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(163907), // Rule ID 1243 //
     /* 163867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163896 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 163899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163905 */     GIR_RootConstrainSelectedInstOperands,
     /* 163906 */     // GIR_Coverage, 1243,
     /* 163906 */     GIR_EraseRootFromParent_Done,
     /* 163907 */   // Label 3171: @163907
     /* 163907 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(163952), // Rule ID 1244 //
     /* 163912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163941 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 163944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163950 */     GIR_RootConstrainSelectedInstOperands,
     /* 163951 */     // GIR_Coverage, 1244,
     /* 163951 */     GIR_EraseRootFromParent_Done,
     /* 163952 */   // Label 3172: @163952
     /* 163952 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(163997), // Rule ID 1245 //
     /* 163957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163986 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 163989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163995 */     GIR_RootConstrainSelectedInstOperands,
     /* 163996 */     // GIR_Coverage, 1245,
     /* 163996 */     GIR_EraseRootFromParent_Done,
     /* 163997 */   // Label 3173: @163997
     /* 163997 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164042), // Rule ID 1256 //
     /* 164002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 164010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164031 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 164034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164040 */     GIR_RootConstrainSelectedInstOperands,
     /* 164041 */     // GIR_Coverage, 1256,
     /* 164041 */     GIR_EraseRootFromParent_Done,
     /* 164042 */   // Label 3174: @164042
     /* 164042 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164087), // Rule ID 1257 //
     /* 164047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 164055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164076 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 164079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164085 */     GIR_RootConstrainSelectedInstOperands,
     /* 164086 */     // GIR_Coverage, 1257,
     /* 164086 */     GIR_EraseRootFromParent_Done,
     /* 164087 */   // Label 3175: @164087
     /* 164087 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164132), // Rule ID 1258 //
     /* 164092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 164100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164121 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 164124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164130 */     GIR_RootConstrainSelectedInstOperands,
     /* 164131 */     // GIR_Coverage, 1258,
     /* 164131 */     GIR_EraseRootFromParent_Done,
     /* 164132 */   // Label 3176: @164132
     /* 164132 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(164177), // Rule ID 1259 //
     /* 164137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 164145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164166 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 164169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164175 */     GIR_RootConstrainSelectedInstOperands,
     /* 164176 */     // GIR_Coverage, 1259,
     /* 164176 */     GIR_EraseRootFromParent_Done,
     /* 164177 */   // Label 3177: @164177
     /* 164177 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(164222), // Rule ID 1260 //
     /* 164182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 164190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164211 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 164214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164220 */     GIR_RootConstrainSelectedInstOperands,
     /* 164221 */     // GIR_Coverage, 1260,
     /* 164221 */     GIR_EraseRootFromParent_Done,
     /* 164222 */   // Label 3178: @164222
     /* 164222 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(164267), // Rule ID 1271 //
     /* 164227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 164235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164256 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 164259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164265 */     GIR_RootConstrainSelectedInstOperands,
     /* 164266 */     // GIR_Coverage, 1271,
     /* 164266 */     GIR_EraseRootFromParent_Done,
     /* 164267 */   // Label 3179: @164267
     /* 164267 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(164312), // Rule ID 1272 //
     /* 164272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 164280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164301 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 164304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164310 */     GIR_RootConstrainSelectedInstOperands,
     /* 164311 */     // GIR_Coverage, 1272,
     /* 164311 */     GIR_EraseRootFromParent_Done,
     /* 164312 */   // Label 3180: @164312
     /* 164312 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(164357), // Rule ID 1273 //
     /* 164317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 164325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164346 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 164349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164355 */     GIR_RootConstrainSelectedInstOperands,
     /* 164356 */     // GIR_Coverage, 1273,
     /* 164356 */     GIR_EraseRootFromParent_Done,
     /* 164357 */   // Label 3181: @164357
     /* 164357 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(164402), // Rule ID 1274 //
     /* 164362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 164370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164391 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 164394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164400 */     GIR_RootConstrainSelectedInstOperands,
     /* 164401 */     // GIR_Coverage, 1274,
     /* 164401 */     GIR_EraseRootFromParent_Done,
     /* 164402 */   // Label 3182: @164402
     /* 164402 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(164447), // Rule ID 1275 //
     /* 164407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 164415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164436 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 164439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164445 */     GIR_RootConstrainSelectedInstOperands,
     /* 164446 */     // GIR_Coverage, 1275,
     /* 164446 */     GIR_EraseRootFromParent_Done,
     /* 164447 */   // Label 3183: @164447
     /* 164447 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(164492), // Rule ID 1306 //
     /* 164452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164481 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 164484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164490 */     GIR_RootConstrainSelectedInstOperands,
     /* 164491 */     // GIR_Coverage, 1306,
     /* 164491 */     GIR_EraseRootFromParent_Done,
     /* 164492 */   // Label 3184: @164492
     /* 164492 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(164537), // Rule ID 1307 //
     /* 164497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164526 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 164529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164535 */     GIR_RootConstrainSelectedInstOperands,
     /* 164536 */     // GIR_Coverage, 1307,
     /* 164536 */     GIR_EraseRootFromParent_Done,
     /* 164537 */   // Label 3185: @164537
     /* 164537 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(164582), // Rule ID 1308 //
     /* 164542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164571 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 164574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164580 */     GIR_RootConstrainSelectedInstOperands,
     /* 164581 */     // GIR_Coverage, 1308,
     /* 164581 */     GIR_EraseRootFromParent_Done,
     /* 164582 */   // Label 3186: @164582
     /* 164582 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(164627), // Rule ID 1309 //
     /* 164587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164616 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 164619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164625 */     GIR_RootConstrainSelectedInstOperands,
     /* 164626 */     // GIR_Coverage, 1309,
     /* 164626 */     GIR_EraseRootFromParent_Done,
     /* 164627 */   // Label 3187: @164627
     /* 164627 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(164672), // Rule ID 1310 //
     /* 164632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164661 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 164664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164670 */     GIR_RootConstrainSelectedInstOperands,
     /* 164671 */     // GIR_Coverage, 1310,
     /* 164671 */     GIR_EraseRootFromParent_Done,
     /* 164672 */   // Label 3188: @164672
     /* 164672 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(164717), // Rule ID 1321 //
     /* 164677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164706 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 164709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164715 */     GIR_RootConstrainSelectedInstOperands,
     /* 164716 */     // GIR_Coverage, 1321,
     /* 164716 */     GIR_EraseRootFromParent_Done,
     /* 164717 */   // Label 3189: @164717
     /* 164717 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(164762), // Rule ID 1322 //
     /* 164722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164751 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 164754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164760 */     GIR_RootConstrainSelectedInstOperands,
     /* 164761 */     // GIR_Coverage, 1322,
     /* 164761 */     GIR_EraseRootFromParent_Done,
     /* 164762 */   // Label 3190: @164762
     /* 164762 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(164807), // Rule ID 1323 //
     /* 164767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164796 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 164799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164805 */     GIR_RootConstrainSelectedInstOperands,
     /* 164806 */     // GIR_Coverage, 1323,
     /* 164806 */     GIR_EraseRootFromParent_Done,
     /* 164807 */   // Label 3191: @164807
     /* 164807 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(164852), // Rule ID 1324 //
     /* 164812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164841 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 164844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164850 */     GIR_RootConstrainSelectedInstOperands,
     /* 164851 */     // GIR_Coverage, 1324,
     /* 164851 */     GIR_EraseRootFromParent_Done,
     /* 164852 */   // Label 3192: @164852
     /* 164852 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(164897), // Rule ID 1325 //
     /* 164857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164886 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 164889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164895 */     GIR_RootConstrainSelectedInstOperands,
     /* 164896 */     // GIR_Coverage, 1325,
     /* 164896 */     GIR_EraseRootFromParent_Done,
     /* 164897 */   // Label 3193: @164897
     /* 164897 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(164942), // Rule ID 1326 //
     /* 164902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164931 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 164934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164940 */     GIR_RootConstrainSelectedInstOperands,
     /* 164941 */     // GIR_Coverage, 1326,
     /* 164941 */     GIR_EraseRootFromParent_Done,
     /* 164942 */   // Label 3194: @164942
     /* 164942 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(164987), // Rule ID 1327 //
     /* 164947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164976 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 164979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164985 */     GIR_RootConstrainSelectedInstOperands,
     /* 164986 */     // GIR_Coverage, 1327,
     /* 164986 */     GIR_EraseRootFromParent_Done,
     /* 164987 */   // Label 3195: @164987
     /* 164987 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(165032), // Rule ID 1328 //
     /* 164992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 165000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165021 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 165021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 165024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165030 */     GIR_RootConstrainSelectedInstOperands,
     /* 165031 */     // GIR_Coverage, 1328,
     /* 165031 */     GIR_EraseRootFromParent_Done,
     /* 165032 */   // Label 3196: @165032
     /* 165032 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(165077), // Rule ID 1329 //
     /* 165037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 165045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165066 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 165066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 165069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165075 */     GIR_RootConstrainSelectedInstOperands,
     /* 165076 */     // GIR_Coverage, 1329,
     /* 165076 */     GIR_EraseRootFromParent_Done,
     /* 165077 */   // Label 3197: @165077
     /* 165077 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(165122), // Rule ID 1330 //
     /* 165082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 165090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165111 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 165111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165120 */     GIR_RootConstrainSelectedInstOperands,
     /* 165121 */     // GIR_Coverage, 1330,
     /* 165121 */     GIR_EraseRootFromParent_Done,
     /* 165122 */   // Label 3198: @165122
     /* 165122 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(165167), // Rule ID 1347 //
     /* 165127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 165135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165156 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 165159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165165 */     GIR_RootConstrainSelectedInstOperands,
     /* 165166 */     // GIR_Coverage, 1347,
     /* 165166 */     GIR_EraseRootFromParent_Done,
     /* 165167 */   // Label 3199: @165167
     /* 165167 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(165212), // Rule ID 1348 //
     /* 165172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 165180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165201 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 165204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165210 */     GIR_RootConstrainSelectedInstOperands,
     /* 165211 */     // GIR_Coverage, 1348,
     /* 165211 */     GIR_EraseRootFromParent_Done,
     /* 165212 */   // Label 3200: @165212
     /* 165212 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(165257), // Rule ID 1362 //
     /* 165217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165246 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 165249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165255 */     GIR_RootConstrainSelectedInstOperands,
     /* 165256 */     // GIR_Coverage, 1362,
     /* 165256 */     GIR_EraseRootFromParent_Done,
     /* 165257 */   // Label 3201: @165257
     /* 165257 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(165302), // Rule ID 1364 //
     /* 165262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165291 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 165294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165300 */     GIR_RootConstrainSelectedInstOperands,
     /* 165301 */     // GIR_Coverage, 1364,
     /* 165301 */     GIR_EraseRootFromParent_Done,
     /* 165302 */   // Label 3202: @165302
     /* 165302 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(165347), // Rule ID 1366 //
     /* 165307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 165339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165345 */     GIR_RootConstrainSelectedInstOperands,
     /* 165346 */     // GIR_Coverage, 1366,
     /* 165346 */     GIR_EraseRootFromParent_Done,
     /* 165347 */   // Label 3203: @165347
     /* 165347 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(165392), // Rule ID 1368 //
     /* 165352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165381 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 165384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165390 */     GIR_RootConstrainSelectedInstOperands,
     /* 165391 */     // GIR_Coverage, 1368,
     /* 165391 */     GIR_EraseRootFromParent_Done,
     /* 165392 */   // Label 3204: @165392
     /* 165392 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(165437), // Rule ID 1370 //
     /* 165397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165426 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 165429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165435 */     GIR_RootConstrainSelectedInstOperands,
     /* 165436 */     // GIR_Coverage, 1370,
     /* 165436 */     GIR_EraseRootFromParent_Done,
     /* 165437 */   // Label 3205: @165437
     /* 165437 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(165482), // Rule ID 1372 //
     /* 165442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 165474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165480 */     GIR_RootConstrainSelectedInstOperands,
     /* 165481 */     // GIR_Coverage, 1372,
     /* 165481 */     GIR_EraseRootFromParent_Done,
     /* 165482 */   // Label 3206: @165482
     /* 165482 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(165527), // Rule ID 1379 //
     /* 165487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165516 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 165519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165525 */     GIR_RootConstrainSelectedInstOperands,
     /* 165526 */     // GIR_Coverage, 1379,
     /* 165526 */     GIR_EraseRootFromParent_Done,
     /* 165527 */   // Label 3207: @165527
     /* 165527 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(165572), // Rule ID 1380 //
     /* 165532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165561 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 165564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165570 */     GIR_RootConstrainSelectedInstOperands,
     /* 165571 */     // GIR_Coverage, 1380,
     /* 165571 */     GIR_EraseRootFromParent_Done,
     /* 165572 */   // Label 3208: @165572
     /* 165572 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(165617), // Rule ID 1381 //
     /* 165577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165606 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 165609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165615 */     GIR_RootConstrainSelectedInstOperands,
     /* 165616 */     // GIR_Coverage, 1381,
     /* 165616 */     GIR_EraseRootFromParent_Done,
     /* 165617 */   // Label 3209: @165617
     /* 165617 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(165662), // Rule ID 1382 //
     /* 165622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165651 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 165654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165660 */     GIR_RootConstrainSelectedInstOperands,
     /* 165661 */     // GIR_Coverage, 1382,
     /* 165661 */     GIR_EraseRootFromParent_Done,
     /* 165662 */   // Label 3210: @165662
     /* 165662 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(165707), // Rule ID 1383 //
     /* 165667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165696 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 165699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165705 */     GIR_RootConstrainSelectedInstOperands,
     /* 165706 */     // GIR_Coverage, 1383,
     /* 165706 */     GIR_EraseRootFromParent_Done,
     /* 165707 */   // Label 3211: @165707
     /* 165707 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(165752), // Rule ID 1384 //
     /* 165712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165741 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 165744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165750 */     GIR_RootConstrainSelectedInstOperands,
     /* 165751 */     // GIR_Coverage, 1384,
     /* 165751 */     GIR_EraseRootFromParent_Done,
     /* 165752 */   // Label 3212: @165752
     /* 165752 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(165797), // Rule ID 1385 //
     /* 165757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165786 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 165789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165795 */     GIR_RootConstrainSelectedInstOperands,
     /* 165796 */     // GIR_Coverage, 1385,
     /* 165796 */     GIR_EraseRootFromParent_Done,
     /* 165797 */   // Label 3213: @165797
     /* 165797 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(165842), // Rule ID 1386 //
     /* 165802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165831 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 165834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165840 */     GIR_RootConstrainSelectedInstOperands,
     /* 165841 */     // GIR_Coverage, 1386,
     /* 165841 */     GIR_EraseRootFromParent_Done,
     /* 165842 */   // Label 3214: @165842
     /* 165842 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(165887), // Rule ID 1387 //
     /* 165847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 165879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165885 */     GIR_RootConstrainSelectedInstOperands,
     /* 165886 */     // GIR_Coverage, 1387,
     /* 165886 */     GIR_EraseRootFromParent_Done,
     /* 165887 */   // Label 3215: @165887
     /* 165887 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(165932), // Rule ID 1388 //
     /* 165892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165921 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 165924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165930 */     GIR_RootConstrainSelectedInstOperands,
     /* 165931 */     // GIR_Coverage, 1388,
     /* 165931 */     GIR_EraseRootFromParent_Done,
     /* 165932 */   // Label 3216: @165932
     /* 165932 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(165977), // Rule ID 1389 //
     /* 165937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165966 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 165969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165975 */     GIR_RootConstrainSelectedInstOperands,
     /* 165976 */     // GIR_Coverage, 1389,
     /* 165976 */     GIR_EraseRootFromParent_Done,
     /* 165977 */   // Label 3217: @165977
     /* 165977 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(166022), // Rule ID 1390 //
     /* 165982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166011 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 166014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166020 */     GIR_RootConstrainSelectedInstOperands,
     /* 166021 */     // GIR_Coverage, 1390,
     /* 166021 */     GIR_EraseRootFromParent_Done,
     /* 166022 */   // Label 3218: @166022
     /* 166022 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(166067), // Rule ID 1397 //
     /* 166027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166056 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 166059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166065 */     GIR_RootConstrainSelectedInstOperands,
     /* 166066 */     // GIR_Coverage, 1397,
     /* 166066 */     GIR_EraseRootFromParent_Done,
     /* 166067 */   // Label 3219: @166067
     /* 166067 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(166112), // Rule ID 1398 //
     /* 166072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166101 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 166104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166110 */     GIR_RootConstrainSelectedInstOperands,
     /* 166111 */     // GIR_Coverage, 1398,
     /* 166111 */     GIR_EraseRootFromParent_Done,
     /* 166112 */   // Label 3220: @166112
     /* 166112 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(166157), // Rule ID 1399 //
     /* 166117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166146 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 166149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166155 */     GIR_RootConstrainSelectedInstOperands,
     /* 166156 */     // GIR_Coverage, 1399,
     /* 166156 */     GIR_EraseRootFromParent_Done,
     /* 166157 */   // Label 3221: @166157
     /* 166157 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(166202), // Rule ID 1400 //
     /* 166162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166191 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 166194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166200 */     GIR_RootConstrainSelectedInstOperands,
     /* 166201 */     // GIR_Coverage, 1400,
     /* 166201 */     GIR_EraseRootFromParent_Done,
     /* 166202 */   // Label 3222: @166202
     /* 166202 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(166247), // Rule ID 1401 //
     /* 166207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166236 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 166239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166245 */     GIR_RootConstrainSelectedInstOperands,
     /* 166246 */     // GIR_Coverage, 1401,
     /* 166246 */     GIR_EraseRootFromParent_Done,
     /* 166247 */   // Label 3223: @166247
     /* 166247 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(166292), // Rule ID 1402 //
     /* 166252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 166260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166281 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 166284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166290 */     GIR_RootConstrainSelectedInstOperands,
     /* 166291 */     // GIR_Coverage, 1402,
     /* 166291 */     GIR_EraseRootFromParent_Done,
     /* 166292 */   // Label 3224: @166292
     /* 166292 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(166337), // Rule ID 1409 //
     /* 166297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166326 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 166329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166335 */     GIR_RootConstrainSelectedInstOperands,
     /* 166336 */     // GIR_Coverage, 1409,
     /* 166336 */     GIR_EraseRootFromParent_Done,
     /* 166337 */   // Label 3225: @166337
     /* 166337 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(166382), // Rule ID 1410 //
     /* 166342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166371 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 166374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166380 */     GIR_RootConstrainSelectedInstOperands,
     /* 166381 */     // GIR_Coverage, 1410,
     /* 166381 */     GIR_EraseRootFromParent_Done,
     /* 166382 */   // Label 3226: @166382
     /* 166382 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(166427), // Rule ID 1411 //
     /* 166387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 166419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166425 */     GIR_RootConstrainSelectedInstOperands,
     /* 166426 */     // GIR_Coverage, 1411,
     /* 166426 */     GIR_EraseRootFromParent_Done,
     /* 166427 */   // Label 3227: @166427
     /* 166427 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(166472), // Rule ID 1412 //
     /* 166432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 166464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166470 */     GIR_RootConstrainSelectedInstOperands,
     /* 166471 */     // GIR_Coverage, 1412,
     /* 166471 */     GIR_EraseRootFromParent_Done,
     /* 166472 */   // Label 3228: @166472
     /* 166472 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(166517), // Rule ID 1413 //
     /* 166477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166506 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 166509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166515 */     GIR_RootConstrainSelectedInstOperands,
     /* 166516 */     // GIR_Coverage, 1413,
     /* 166516 */     GIR_EraseRootFromParent_Done,
     /* 166517 */   // Label 3229: @166517
     /* 166517 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(166562), // Rule ID 1414 //
     /* 166522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166551 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166560 */     GIR_RootConstrainSelectedInstOperands,
     /* 166561 */     // GIR_Coverage, 1414,
     /* 166561 */     GIR_EraseRootFromParent_Done,
     /* 166562 */   // Label 3230: @166562
     /* 166562 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(166607), // Rule ID 1415 //
     /* 166567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 166596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 166599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166605 */     GIR_RootConstrainSelectedInstOperands,
     /* 166606 */     // GIR_Coverage, 1415,
     /* 166606 */     GIR_EraseRootFromParent_Done,
     /* 166607 */   // Label 3231: @166607
     /* 166607 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(166652), // Rule ID 1416 //
     /* 166612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166641 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 166644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166650 */     GIR_RootConstrainSelectedInstOperands,
     /* 166651 */     // GIR_Coverage, 1416,
     /* 166651 */     GIR_EraseRootFromParent_Done,
     /* 166652 */   // Label 3232: @166652
     /* 166652 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(166697), // Rule ID 1417 //
     /* 166657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166686 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 166689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166695 */     GIR_RootConstrainSelectedInstOperands,
     /* 166696 */     // GIR_Coverage, 1417,
     /* 166696 */     GIR_EraseRootFromParent_Done,
     /* 166697 */   // Label 3233: @166697
     /* 166697 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(166742), // Rule ID 1418 //
     /* 166702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166731 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 166734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166740 */     GIR_RootConstrainSelectedInstOperands,
     /* 166741 */     // GIR_Coverage, 1418,
     /* 166741 */     GIR_EraseRootFromParent_Done,
     /* 166742 */   // Label 3234: @166742
     /* 166742 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(166787), // Rule ID 1419 //
     /* 166747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 166779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166785 */     GIR_RootConstrainSelectedInstOperands,
     /* 166786 */     // GIR_Coverage, 1419,
     /* 166786 */     GIR_EraseRootFromParent_Done,
     /* 166787 */   // Label 3235: @166787
     /* 166787 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(166832), // Rule ID 1420 //
     /* 166792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166821 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 166824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166830 */     GIR_RootConstrainSelectedInstOperands,
     /* 166831 */     // GIR_Coverage, 1420,
     /* 166831 */     GIR_EraseRootFromParent_Done,
     /* 166832 */   // Label 3236: @166832
     /* 166832 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(166877), // Rule ID 1421 //
     /* 166837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 166869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166875 */     GIR_RootConstrainSelectedInstOperands,
     /* 166876 */     // GIR_Coverage, 1421,
     /* 166876 */     GIR_EraseRootFromParent_Done,
     /* 166877 */   // Label 3237: @166877
     /* 166877 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(166922), // Rule ID 1422 //
     /* 166882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166911 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 166914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166920 */     GIR_RootConstrainSelectedInstOperands,
     /* 166921 */     // GIR_Coverage, 1422,
     /* 166921 */     GIR_EraseRootFromParent_Done,
     /* 166922 */   // Label 3238: @166922
     /* 166922 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(166967), // Rule ID 1423 //
     /* 166927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 166959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166965 */     GIR_RootConstrainSelectedInstOperands,
     /* 166966 */     // GIR_Coverage, 1423,
     /* 166966 */     GIR_EraseRootFromParent_Done,
     /* 166967 */   // Label 3239: @166967
     /* 166967 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(167012), // Rule ID 1424 //
     /* 166972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167001 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 167004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167010 */     GIR_RootConstrainSelectedInstOperands,
     /* 167011 */     // GIR_Coverage, 1424,
     /* 167011 */     GIR_EraseRootFromParent_Done,
     /* 167012 */   // Label 3240: @167012
     /* 167012 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(167057), // Rule ID 1425 //
     /* 167017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167046 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 167049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167055 */     GIR_RootConstrainSelectedInstOperands,
     /* 167056 */     // GIR_Coverage, 1425,
     /* 167056 */     GIR_EraseRootFromParent_Done,
     /* 167057 */   // Label 3241: @167057
     /* 167057 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(167102), // Rule ID 1426 //
     /* 167062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167091 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 167094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167100 */     GIR_RootConstrainSelectedInstOperands,
     /* 167101 */     // GIR_Coverage, 1426,
     /* 167101 */     GIR_EraseRootFromParent_Done,
     /* 167102 */   // Label 3242: @167102
     /* 167102 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(167147), // Rule ID 1427 //
     /* 167107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167136 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 167139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167145 */     GIR_RootConstrainSelectedInstOperands,
     /* 167146 */     // GIR_Coverage, 1427,
     /* 167146 */     GIR_EraseRootFromParent_Done,
     /* 167147 */   // Label 3243: @167147
     /* 167147 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(167192), // Rule ID 1428 //
     /* 167152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167181 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167190 */     GIR_RootConstrainSelectedInstOperands,
     /* 167191 */     // GIR_Coverage, 1428,
     /* 167191 */     GIR_EraseRootFromParent_Done,
     /* 167192 */   // Label 3244: @167192
     /* 167192 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(167237), // Rule ID 1429 //
     /* 167197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 167229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167235 */     GIR_RootConstrainSelectedInstOperands,
     /* 167236 */     // GIR_Coverage, 1429,
     /* 167236 */     GIR_EraseRootFromParent_Done,
     /* 167237 */   // Label 3245: @167237
     /* 167237 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(167282), // Rule ID 1430 //
     /* 167242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 167250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167271 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 167274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167280 */     GIR_RootConstrainSelectedInstOperands,
     /* 167281 */     // GIR_Coverage, 1430,
     /* 167281 */     GIR_EraseRootFromParent_Done,
     /* 167282 */   // Label 3246: @167282
     /* 167282 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(167327), // Rule ID 1431 //
     /* 167287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167316 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 167319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167325 */     GIR_RootConstrainSelectedInstOperands,
     /* 167326 */     // GIR_Coverage, 1431,
     /* 167326 */     GIR_EraseRootFromParent_Done,
     /* 167327 */   // Label 3247: @167327
     /* 167327 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(167372), // Rule ID 1432 //
     /* 167332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167361 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 167364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167370 */     GIR_RootConstrainSelectedInstOperands,
     /* 167371 */     // GIR_Coverage, 1432,
     /* 167371 */     GIR_EraseRootFromParent_Done,
     /* 167372 */   // Label 3248: @167372
     /* 167372 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(167417), // Rule ID 1433 //
     /* 167377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167406 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 167409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167415 */     GIR_RootConstrainSelectedInstOperands,
     /* 167416 */     // GIR_Coverage, 1433,
     /* 167416 */     GIR_EraseRootFromParent_Done,
     /* 167417 */   // Label 3249: @167417
     /* 167417 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(167462), // Rule ID 1434 //
     /* 167422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167451 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 167454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167460 */     GIR_RootConstrainSelectedInstOperands,
     /* 167461 */     // GIR_Coverage, 1434,
     /* 167461 */     GIR_EraseRootFromParent_Done,
     /* 167462 */   // Label 3250: @167462
     /* 167462 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(167507), // Rule ID 1435 //
     /* 167467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167496 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 167499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167505 */     GIR_RootConstrainSelectedInstOperands,
     /* 167506 */     // GIR_Coverage, 1435,
     /* 167506 */     GIR_EraseRootFromParent_Done,
     /* 167507 */   // Label 3251: @167507
     /* 167507 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(167552), // Rule ID 1436 //
     /* 167512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167541 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 167544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167550 */     GIR_RootConstrainSelectedInstOperands,
     /* 167551 */     // GIR_Coverage, 1436,
     /* 167551 */     GIR_EraseRootFromParent_Done,
     /* 167552 */   // Label 3252: @167552
     /* 167552 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(167597), // Rule ID 1437 //
     /* 167557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167586 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 167589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167595 */     GIR_RootConstrainSelectedInstOperands,
     /* 167596 */     // GIR_Coverage, 1437,
     /* 167596 */     GIR_EraseRootFromParent_Done,
     /* 167597 */   // Label 3253: @167597
     /* 167597 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(167642), // Rule ID 1438 //
     /* 167602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167631 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 167634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167640 */     GIR_RootConstrainSelectedInstOperands,
     /* 167641 */     // GIR_Coverage, 1438,
     /* 167641 */     GIR_EraseRootFromParent_Done,
     /* 167642 */   // Label 3254: @167642
     /* 167642 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(167687), // Rule ID 1439 //
     /* 167647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167676 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 167679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167685 */     GIR_RootConstrainSelectedInstOperands,
     /* 167686 */     // GIR_Coverage, 1439,
     /* 167686 */     GIR_EraseRootFromParent_Done,
     /* 167687 */   // Label 3255: @167687
     /* 167687 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(167732), // Rule ID 1440 //
     /* 167692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167721 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 167724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167730 */     GIR_RootConstrainSelectedInstOperands,
     /* 167731 */     // GIR_Coverage, 1440,
     /* 167731 */     GIR_EraseRootFromParent_Done,
     /* 167732 */   // Label 3256: @167732
     /* 167732 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(167777), // Rule ID 1441 //
     /* 167737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167766 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 167769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167775 */     GIR_RootConstrainSelectedInstOperands,
     /* 167776 */     // GIR_Coverage, 1441,
     /* 167776 */     GIR_EraseRootFromParent_Done,
     /* 167777 */   // Label 3257: @167777
     /* 167777 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(167822), // Rule ID 1442 //
     /* 167782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167811 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 167814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167820 */     GIR_RootConstrainSelectedInstOperands,
     /* 167821 */     // GIR_Coverage, 1442,
     /* 167821 */     GIR_EraseRootFromParent_Done,
     /* 167822 */   // Label 3258: @167822
     /* 167822 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(167867), // Rule ID 1443 //
     /* 167827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 167859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167865 */     GIR_RootConstrainSelectedInstOperands,
     /* 167866 */     // GIR_Coverage, 1443,
     /* 167866 */     GIR_EraseRootFromParent_Done,
     /* 167867 */   // Label 3259: @167867
     /* 167867 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(167912), // Rule ID 1444 //
     /* 167872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167901 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 167904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167910 */     GIR_RootConstrainSelectedInstOperands,
     /* 167911 */     // GIR_Coverage, 1444,
     /* 167911 */     GIR_EraseRootFromParent_Done,
     /* 167912 */   // Label 3260: @167912
     /* 167912 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(167957), // Rule ID 1451 //
     /* 167917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167946 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 167949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167955 */     GIR_RootConstrainSelectedInstOperands,
     /* 167956 */     // GIR_Coverage, 1451,
     /* 167956 */     GIR_EraseRootFromParent_Done,
     /* 167957 */   // Label 3261: @167957
     /* 167957 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(168002), // Rule ID 1452 //
     /* 167962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167991 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 167994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168000 */     GIR_RootConstrainSelectedInstOperands,
     /* 168001 */     // GIR_Coverage, 1452,
     /* 168001 */     GIR_EraseRootFromParent_Done,
     /* 168002 */   // Label 3262: @168002
     /* 168002 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(168047), // Rule ID 1453 //
     /* 168007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168036 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 168039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168045 */     GIR_RootConstrainSelectedInstOperands,
     /* 168046 */     // GIR_Coverage, 1453,
     /* 168046 */     GIR_EraseRootFromParent_Done,
     /* 168047 */   // Label 3263: @168047
     /* 168047 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(168092), // Rule ID 1454 //
     /* 168052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 168060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 168084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168090 */     GIR_RootConstrainSelectedInstOperands,
     /* 168091 */     // GIR_Coverage, 1454,
     /* 168091 */     GIR_EraseRootFromParent_Done,
     /* 168092 */   // Label 3264: @168092
     /* 168092 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(168137), // Rule ID 1455 //
     /* 168097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 168105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168126 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 168129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168135 */     GIR_RootConstrainSelectedInstOperands,
     /* 168136 */     // GIR_Coverage, 1455,
     /* 168136 */     GIR_EraseRootFromParent_Done,
     /* 168137 */   // Label 3265: @168137
     /* 168137 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(168182), // Rule ID 1456 //
     /* 168142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 168150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168171 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 168174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168180 */     GIR_RootConstrainSelectedInstOperands,
     /* 168181 */     // GIR_Coverage, 1456,
     /* 168181 */     GIR_EraseRootFromParent_Done,
     /* 168182 */   // Label 3266: @168182
     /* 168182 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(168227), // Rule ID 1457 //
     /* 168187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 168195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 168219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168225 */     GIR_RootConstrainSelectedInstOperands,
     /* 168226 */     // GIR_Coverage, 1457,
     /* 168226 */     GIR_EraseRootFromParent_Done,
     /* 168227 */   // Label 3267: @168227
     /* 168227 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(168272), // Rule ID 1458 //
     /* 168232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168261 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 168264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 1458,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3268: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(168317), // Rule ID 1459 //
     /* 168277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168306 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 168309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168315 */     GIR_RootConstrainSelectedInstOperands,
     /* 168316 */     // GIR_Coverage, 1459,
     /* 168316 */     GIR_EraseRootFromParent_Done,
     /* 168317 */   // Label 3269: @168317
     /* 168317 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(168362), // Rule ID 1460 //
     /* 168322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168351 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 168354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168360 */     GIR_RootConstrainSelectedInstOperands,
     /* 168361 */     // GIR_Coverage, 1460,
     /* 168361 */     GIR_EraseRootFromParent_Done,
     /* 168362 */   // Label 3270: @168362
     /* 168362 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(168407), // Rule ID 1461 //
     /* 168367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168396 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 168399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168405 */     GIR_RootConstrainSelectedInstOperands,
     /* 168406 */     // GIR_Coverage, 1461,
     /* 168406 */     GIR_EraseRootFromParent_Done,
     /* 168407 */   // Label 3271: @168407
     /* 168407 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(168452), // Rule ID 1462 //
     /* 168412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168441 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 168444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168450 */     GIR_RootConstrainSelectedInstOperands,
     /* 168451 */     // GIR_Coverage, 1462,
     /* 168451 */     GIR_EraseRootFromParent_Done,
     /* 168452 */   // Label 3272: @168452
     /* 168452 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(168497), // Rule ID 1463 //
     /* 168457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 168489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168495 */     GIR_RootConstrainSelectedInstOperands,
     /* 168496 */     // GIR_Coverage, 1463,
     /* 168496 */     GIR_EraseRootFromParent_Done,
     /* 168497 */   // Label 3273: @168497
     /* 168497 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(168542), // Rule ID 1464 //
     /* 168502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168531 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 168534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168540 */     GIR_RootConstrainSelectedInstOperands,
     /* 168541 */     // GIR_Coverage, 1464,
     /* 168541 */     GIR_EraseRootFromParent_Done,
     /* 168542 */   // Label 3274: @168542
     /* 168542 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(168587), // Rule ID 1485 //
     /* 168547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168576 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 168579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168585 */     GIR_RootConstrainSelectedInstOperands,
     /* 168586 */     // GIR_Coverage, 1485,
     /* 168586 */     GIR_EraseRootFromParent_Done,
     /* 168587 */   // Label 3275: @168587
     /* 168587 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(168632), // Rule ID 1487 //
     /* 168592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168621 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 168624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168630 */     GIR_RootConstrainSelectedInstOperands,
     /* 168631 */     // GIR_Coverage, 1487,
     /* 168631 */     GIR_EraseRootFromParent_Done,
     /* 168632 */   // Label 3276: @168632
     /* 168632 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(168677), // Rule ID 1489 //
     /* 168637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168666 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 168669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168675 */     GIR_RootConstrainSelectedInstOperands,
     /* 168676 */     // GIR_Coverage, 1489,
     /* 168676 */     GIR_EraseRootFromParent_Done,
     /* 168677 */   // Label 3277: @168677
     /* 168677 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(168722), // Rule ID 1491 //
     /* 168682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168711 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 168714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168720 */     GIR_RootConstrainSelectedInstOperands,
     /* 168721 */     // GIR_Coverage, 1491,
     /* 168721 */     GIR_EraseRootFromParent_Done,
     /* 168722 */   // Label 3278: @168722
     /* 168722 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(168767), // Rule ID 1493 //
     /* 168727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168756 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 168759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168765 */     GIR_RootConstrainSelectedInstOperands,
     /* 168766 */     // GIR_Coverage, 1493,
     /* 168766 */     GIR_EraseRootFromParent_Done,
     /* 168767 */   // Label 3279: @168767
     /* 168767 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(168812), // Rule ID 1495 //
     /* 168772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168801 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 168804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168810 */     GIR_RootConstrainSelectedInstOperands,
     /* 168811 */     // GIR_Coverage, 1495,
     /* 168811 */     GIR_EraseRootFromParent_Done,
     /* 168812 */   // Label 3280: @168812
     /* 168812 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(168857), // Rule ID 1502 //
     /* 168817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168846 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 168849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168855 */     GIR_RootConstrainSelectedInstOperands,
     /* 168856 */     // GIR_Coverage, 1502,
     /* 168856 */     GIR_EraseRootFromParent_Done,
     /* 168857 */   // Label 3281: @168857
     /* 168857 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(168902), // Rule ID 1503 //
     /* 168862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168891 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 168894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168900 */     GIR_RootConstrainSelectedInstOperands,
     /* 168901 */     // GIR_Coverage, 1503,
     /* 168901 */     GIR_EraseRootFromParent_Done,
     /* 168902 */   // Label 3282: @168902
     /* 168902 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(168947), // Rule ID 1504 //
     /* 168907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168936 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 168939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168945 */     GIR_RootConstrainSelectedInstOperands,
     /* 168946 */     // GIR_Coverage, 1504,
     /* 168946 */     GIR_EraseRootFromParent_Done,
     /* 168947 */   // Label 3283: @168947
     /* 168947 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(168992), // Rule ID 1505 //
     /* 168952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168981 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 168984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168990 */     GIR_RootConstrainSelectedInstOperands,
     /* 168991 */     // GIR_Coverage, 1505,
     /* 168991 */     GIR_EraseRootFromParent_Done,
     /* 168992 */   // Label 3284: @168992
     /* 168992 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(169037), // Rule ID 1506 //
     /* 168997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 169005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169026 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 169029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169035 */     GIR_RootConstrainSelectedInstOperands,
     /* 169036 */     // GIR_Coverage, 1506,
     /* 169036 */     GIR_EraseRootFromParent_Done,
     /* 169037 */   // Label 3285: @169037
     /* 169037 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(169082), // Rule ID 1507 //
     /* 169042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 169050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169071 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 169074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169080 */     GIR_RootConstrainSelectedInstOperands,
     /* 169081 */     // GIR_Coverage, 1507,
     /* 169081 */     GIR_EraseRootFromParent_Done,
     /* 169082 */   // Label 3286: @169082
     /* 169082 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(169127), // Rule ID 1508 //
     /* 169087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169116 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 169119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169125 */     GIR_RootConstrainSelectedInstOperands,
     /* 169126 */     // GIR_Coverage, 1508,
     /* 169126 */     GIR_EraseRootFromParent_Done,
     /* 169127 */   // Label 3287: @169127
     /* 169127 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(169172), // Rule ID 1509 //
     /* 169132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 169164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169170 */     GIR_RootConstrainSelectedInstOperands,
     /* 169171 */     // GIR_Coverage, 1509,
     /* 169171 */     GIR_EraseRootFromParent_Done,
     /* 169172 */   // Label 3288: @169172
     /* 169172 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(169217), // Rule ID 1510 //
     /* 169177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169215 */     GIR_RootConstrainSelectedInstOperands,
     /* 169216 */     // GIR_Coverage, 1510,
     /* 169216 */     GIR_EraseRootFromParent_Done,
     /* 169217 */   // Label 3289: @169217
     /* 169217 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(169262), // Rule ID 1511 //
     /* 169222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169251 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 169254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169260 */     GIR_RootConstrainSelectedInstOperands,
     /* 169261 */     // GIR_Coverage, 1511,
     /* 169261 */     GIR_EraseRootFromParent_Done,
     /* 169262 */   // Label 3290: @169262
     /* 169262 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(169307), // Rule ID 1512 //
     /* 169267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169296 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 169299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169305 */     GIR_RootConstrainSelectedInstOperands,
     /* 169306 */     // GIR_Coverage, 1512,
     /* 169306 */     GIR_EraseRootFromParent_Done,
     /* 169307 */   // Label 3291: @169307
     /* 169307 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(169352), // Rule ID 1513 //
     /* 169312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 169320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 169344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169350 */     GIR_RootConstrainSelectedInstOperands,
     /* 169351 */     // GIR_Coverage, 1513,
     /* 169351 */     GIR_EraseRootFromParent_Done,
     /* 169352 */   // Label 3292: @169352
     /* 169352 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(169397), // Rule ID 1520 //
     /* 169357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169386 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 169389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169395 */     GIR_RootConstrainSelectedInstOperands,
     /* 169396 */     // GIR_Coverage, 1520,
     /* 169396 */     GIR_EraseRootFromParent_Done,
     /* 169397 */   // Label 3293: @169397
     /* 169397 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(169442), // Rule ID 1521 //
     /* 169402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169431 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 169434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169440 */     GIR_RootConstrainSelectedInstOperands,
     /* 169441 */     // GIR_Coverage, 1521,
     /* 169441 */     GIR_EraseRootFromParent_Done,
     /* 169442 */   // Label 3294: @169442
     /* 169442 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(169487), // Rule ID 1522 //
     /* 169447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169476 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 169479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169485 */     GIR_RootConstrainSelectedInstOperands,
     /* 169486 */     // GIR_Coverage, 1522,
     /* 169486 */     GIR_EraseRootFromParent_Done,
     /* 169487 */   // Label 3295: @169487
     /* 169487 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(169532), // Rule ID 1523 //
     /* 169492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169521 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 169524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169530 */     GIR_RootConstrainSelectedInstOperands,
     /* 169531 */     // GIR_Coverage, 1523,
     /* 169531 */     GIR_EraseRootFromParent_Done,
     /* 169532 */   // Label 3296: @169532
     /* 169532 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(169577), // Rule ID 1524 //
     /* 169537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169566 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 169569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169575 */     GIR_RootConstrainSelectedInstOperands,
     /* 169576 */     // GIR_Coverage, 1524,
     /* 169576 */     GIR_EraseRootFromParent_Done,
     /* 169577 */   // Label 3297: @169577
     /* 169577 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(169622), // Rule ID 1525 //
     /* 169582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169611 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 169614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169620 */     GIR_RootConstrainSelectedInstOperands,
     /* 169621 */     // GIR_Coverage, 1525,
     /* 169621 */     GIR_EraseRootFromParent_Done,
     /* 169622 */   // Label 3298: @169622
     /* 169622 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(169667), // Rule ID 1532 //
     /* 169627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169656 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 169659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169665 */     GIR_RootConstrainSelectedInstOperands,
     /* 169666 */     // GIR_Coverage, 1532,
     /* 169666 */     GIR_EraseRootFromParent_Done,
     /* 169667 */   // Label 3299: @169667
     /* 169667 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(169712), // Rule ID 1533 //
     /* 169672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169701 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 169704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169710 */     GIR_RootConstrainSelectedInstOperands,
     /* 169711 */     // GIR_Coverage, 1533,
     /* 169711 */     GIR_EraseRootFromParent_Done,
     /* 169712 */   // Label 3300: @169712
     /* 169712 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(169757), // Rule ID 1534 //
     /* 169717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169746 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 169749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169755 */     GIR_RootConstrainSelectedInstOperands,
     /* 169756 */     // GIR_Coverage, 1534,
     /* 169756 */     GIR_EraseRootFromParent_Done,
     /* 169757 */   // Label 3301: @169757
     /* 169757 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(169802), // Rule ID 1535 //
     /* 169762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169791 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 169794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169800 */     GIR_RootConstrainSelectedInstOperands,
     /* 169801 */     // GIR_Coverage, 1535,
     /* 169801 */     GIR_EraseRootFromParent_Done,
     /* 169802 */   // Label 3302: @169802
     /* 169802 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(169847), // Rule ID 1536 //
     /* 169807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169836 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 169839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169845 */     GIR_RootConstrainSelectedInstOperands,
     /* 169846 */     // GIR_Coverage, 1536,
     /* 169846 */     GIR_EraseRootFromParent_Done,
     /* 169847 */   // Label 3303: @169847
     /* 169847 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(169892), // Rule ID 1537 //
     /* 169852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169881 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 169884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169890 */     GIR_RootConstrainSelectedInstOperands,
     /* 169891 */     // GIR_Coverage, 1537,
     /* 169891 */     GIR_EraseRootFromParent_Done,
     /* 169892 */   // Label 3304: @169892
     /* 169892 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(169937), // Rule ID 1538 //
     /* 169897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169926 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 169929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169935 */     GIR_RootConstrainSelectedInstOperands,
     /* 169936 */     // GIR_Coverage, 1538,
     /* 169936 */     GIR_EraseRootFromParent_Done,
     /* 169937 */   // Label 3305: @169937
     /* 169937 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(169982), // Rule ID 1539 //
     /* 169942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169971 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 169974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169980 */     GIR_RootConstrainSelectedInstOperands,
     /* 169981 */     // GIR_Coverage, 1539,
     /* 169981 */     GIR_EraseRootFromParent_Done,
     /* 169982 */   // Label 3306: @169982
     /* 169982 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(170027), // Rule ID 1540 //
     /* 169987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170016 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 170019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170025 */     GIR_RootConstrainSelectedInstOperands,
     /* 170026 */     // GIR_Coverage, 1540,
     /* 170026 */     GIR_EraseRootFromParent_Done,
     /* 170027 */   // Label 3307: @170027
     /* 170027 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(170072), // Rule ID 1541 //
     /* 170032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 170040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170061 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 170064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170070 */     GIR_RootConstrainSelectedInstOperands,
     /* 170071 */     // GIR_Coverage, 1541,
     /* 170071 */     GIR_EraseRootFromParent_Done,
     /* 170072 */   // Label 3308: @170072
     /* 170072 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(170117), // Rule ID 1542 //
     /* 170077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 170085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170106 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 170109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170115 */     GIR_RootConstrainSelectedInstOperands,
     /* 170116 */     // GIR_Coverage, 1542,
     /* 170116 */     GIR_EraseRootFromParent_Done,
     /* 170117 */   // Label 3309: @170117
     /* 170117 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(170162), // Rule ID 1543 //
     /* 170122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 170130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170151 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 170154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170160 */     GIR_RootConstrainSelectedInstOperands,
     /* 170161 */     // GIR_Coverage, 1543,
     /* 170161 */     GIR_EraseRootFromParent_Done,
     /* 170162 */   // Label 3310: @170162
     /* 170162 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(170207), // Rule ID 1544 //
     /* 170167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 170175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170196 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 170199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170205 */     GIR_RootConstrainSelectedInstOperands,
     /* 170206 */     // GIR_Coverage, 1544,
     /* 170206 */     GIR_EraseRootFromParent_Done,
     /* 170207 */   // Label 3311: @170207
     /* 170207 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(170252), // Rule ID 1545 //
     /* 170212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 170220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170241 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 170244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170250 */     GIR_RootConstrainSelectedInstOperands,
     /* 170251 */     // GIR_Coverage, 1545,
     /* 170251 */     GIR_EraseRootFromParent_Done,
     /* 170252 */   // Label 3312: @170252
     /* 170252 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(170297), // Rule ID 1546 //
     /* 170257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170286 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 170289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170295 */     GIR_RootConstrainSelectedInstOperands,
     /* 170296 */     // GIR_Coverage, 1546,
     /* 170296 */     GIR_EraseRootFromParent_Done,
     /* 170297 */   // Label 3313: @170297
     /* 170297 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(170342), // Rule ID 1547 //
     /* 170302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170331 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 170334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170340 */     GIR_RootConstrainSelectedInstOperands,
     /* 170341 */     // GIR_Coverage, 1547,
     /* 170341 */     GIR_EraseRootFromParent_Done,
     /* 170342 */   // Label 3314: @170342
     /* 170342 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(170387), // Rule ID 1548 //
     /* 170347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170376 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 170379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170385 */     GIR_RootConstrainSelectedInstOperands,
     /* 170386 */     // GIR_Coverage, 1548,
     /* 170386 */     GIR_EraseRootFromParent_Done,
     /* 170387 */   // Label 3315: @170387
     /* 170387 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(170432), // Rule ID 1549 //
     /* 170392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170421 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 170424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170430 */     GIR_RootConstrainSelectedInstOperands,
     /* 170431 */     // GIR_Coverage, 1549,
     /* 170431 */     GIR_EraseRootFromParent_Done,
     /* 170432 */   // Label 3316: @170432
     /* 170432 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(170477), // Rule ID 1550 //
     /* 170437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170466 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 170469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170475 */     GIR_RootConstrainSelectedInstOperands,
     /* 170476 */     // GIR_Coverage, 1550,
     /* 170476 */     GIR_EraseRootFromParent_Done,
     /* 170477 */   // Label 3317: @170477
     /* 170477 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(170522), // Rule ID 1551 //
     /* 170482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170511 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 170514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170520 */     GIR_RootConstrainSelectedInstOperands,
     /* 170521 */     // GIR_Coverage, 1551,
     /* 170521 */     GIR_EraseRootFromParent_Done,
     /* 170522 */   // Label 3318: @170522
     /* 170522 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(170567), // Rule ID 1552 //
     /* 170527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170556 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 170559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170565 */     GIR_RootConstrainSelectedInstOperands,
     /* 170566 */     // GIR_Coverage, 1552,
     /* 170566 */     GIR_EraseRootFromParent_Done,
     /* 170567 */   // Label 3319: @170567
     /* 170567 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(170612), // Rule ID 1553 //
     /* 170572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170601 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 170604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170610 */     GIR_RootConstrainSelectedInstOperands,
     /* 170611 */     // GIR_Coverage, 1553,
     /* 170611 */     GIR_EraseRootFromParent_Done,
     /* 170612 */   // Label 3320: @170612
     /* 170612 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(170657), // Rule ID 1554 //
     /* 170617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170646 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 170649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170655 */     GIR_RootConstrainSelectedInstOperands,
     /* 170656 */     // GIR_Coverage, 1554,
     /* 170656 */     GIR_EraseRootFromParent_Done,
     /* 170657 */   // Label 3321: @170657
     /* 170657 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(170702), // Rule ID 1555 //
     /* 170662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170691 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 170694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170700 */     GIR_RootConstrainSelectedInstOperands,
     /* 170701 */     // GIR_Coverage, 1555,
     /* 170701 */     GIR_EraseRootFromParent_Done,
     /* 170702 */   // Label 3322: @170702
     /* 170702 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(170747), // Rule ID 1556 //
     /* 170707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170736 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 170739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170745 */     GIR_RootConstrainSelectedInstOperands,
     /* 170746 */     // GIR_Coverage, 1556,
     /* 170746 */     GIR_EraseRootFromParent_Done,
     /* 170747 */   // Label 3323: @170747
     /* 170747 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(170792), // Rule ID 1557 //
     /* 170752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170781 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 170784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170790 */     GIR_RootConstrainSelectedInstOperands,
     /* 170791 */     // GIR_Coverage, 1557,
     /* 170791 */     GIR_EraseRootFromParent_Done,
     /* 170792 */   // Label 3324: @170792
     /* 170792 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(170837), // Rule ID 1558 //
     /* 170797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170826 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 170829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170835 */     GIR_RootConstrainSelectedInstOperands,
     /* 170836 */     // GIR_Coverage, 1558,
     /* 170836 */     GIR_EraseRootFromParent_Done,
     /* 170837 */   // Label 3325: @170837
     /* 170837 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(170882), // Rule ID 1559 //
     /* 170842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170871 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 170874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170880 */     GIR_RootConstrainSelectedInstOperands,
     /* 170881 */     // GIR_Coverage, 1559,
     /* 170881 */     GIR_EraseRootFromParent_Done,
     /* 170882 */   // Label 3326: @170882
     /* 170882 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(170927), // Rule ID 1566 //
     /* 170887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170916 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 170919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170925 */     GIR_RootConstrainSelectedInstOperands,
     /* 170926 */     // GIR_Coverage, 1566,
     /* 170926 */     GIR_EraseRootFromParent_Done,
     /* 170927 */   // Label 3327: @170927
     /* 170927 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(170972), // Rule ID 1567 //
     /* 170932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170961 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 170964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170970 */     GIR_RootConstrainSelectedInstOperands,
     /* 170971 */     // GIR_Coverage, 1567,
     /* 170971 */     GIR_EraseRootFromParent_Done,
     /* 170972 */   // Label 3328: @170972
     /* 170972 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(171017), // Rule ID 1568 //
     /* 170977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171006 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 171009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171015 */     GIR_RootConstrainSelectedInstOperands,
     /* 171016 */     // GIR_Coverage, 1568,
     /* 171016 */     GIR_EraseRootFromParent_Done,
     /* 171017 */   // Label 3329: @171017
     /* 171017 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(171062), // Rule ID 1569 //
     /* 171022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 171030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171051 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 171054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171060 */     GIR_RootConstrainSelectedInstOperands,
     /* 171061 */     // GIR_Coverage, 1569,
     /* 171061 */     GIR_EraseRootFromParent_Done,
     /* 171062 */   // Label 3330: @171062
     /* 171062 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(171107), // Rule ID 1570 //
     /* 171067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 171075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171096 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 171099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171105 */     GIR_RootConstrainSelectedInstOperands,
     /* 171106 */     // GIR_Coverage, 1570,
     /* 171106 */     GIR_EraseRootFromParent_Done,
     /* 171107 */   // Label 3331: @171107
     /* 171107 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(171152), // Rule ID 1571 //
     /* 171112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 171120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171141 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 171144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171150 */     GIR_RootConstrainSelectedInstOperands,
     /* 171151 */     // GIR_Coverage, 1571,
     /* 171151 */     GIR_EraseRootFromParent_Done,
     /* 171152 */   // Label 3332: @171152
     /* 171152 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(171197), // Rule ID 1572 //
     /* 171157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 171165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171186 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 171186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 171189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171195 */     GIR_RootConstrainSelectedInstOperands,
     /* 171196 */     // GIR_Coverage, 1572,
     /* 171196 */     GIR_EraseRootFromParent_Done,
     /* 171197 */   // Label 3333: @171197
     /* 171197 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(171242), // Rule ID 1573 //
     /* 171202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171231 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 171234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171240 */     GIR_RootConstrainSelectedInstOperands,
     /* 171241 */     // GIR_Coverage, 1573,
     /* 171241 */     GIR_EraseRootFromParent_Done,
     /* 171242 */   // Label 3334: @171242
     /* 171242 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(171287), // Rule ID 1574 //
     /* 171247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171276 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 171279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171285 */     GIR_RootConstrainSelectedInstOperands,
     /* 171286 */     // GIR_Coverage, 1574,
     /* 171286 */     GIR_EraseRootFromParent_Done,
     /* 171287 */   // Label 3335: @171287
     /* 171287 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(171332), // Rule ID 1575 //
     /* 171292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171321 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 171324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171330 */     GIR_RootConstrainSelectedInstOperands,
     /* 171331 */     // GIR_Coverage, 1575,
     /* 171331 */     GIR_EraseRootFromParent_Done,
     /* 171332 */   // Label 3336: @171332
     /* 171332 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(171377), // Rule ID 1576 //
     /* 171337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171366 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 171369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171375 */     GIR_RootConstrainSelectedInstOperands,
     /* 171376 */     // GIR_Coverage, 1576,
     /* 171376 */     GIR_EraseRootFromParent_Done,
     /* 171377 */   // Label 3337: @171377
     /* 171377 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(171422), // Rule ID 1577 //
     /* 171382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171411 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 171414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171420 */     GIR_RootConstrainSelectedInstOperands,
     /* 171421 */     // GIR_Coverage, 1577,
     /* 171421 */     GIR_EraseRootFromParent_Done,
     /* 171422 */   // Label 3338: @171422
     /* 171422 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(171467), // Rule ID 1578 //
     /* 171427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 171459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171465 */     GIR_RootConstrainSelectedInstOperands,
     /* 171466 */     // GIR_Coverage, 1578,
     /* 171466 */     GIR_EraseRootFromParent_Done,
     /* 171467 */   // Label 3339: @171467
     /* 171467 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(171512), // Rule ID 1579 //
     /* 171472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171501 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 171501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 171504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171510 */     GIR_RootConstrainSelectedInstOperands,
     /* 171511 */     // GIR_Coverage, 1579,
     /* 171511 */     GIR_EraseRootFromParent_Done,
     /* 171512 */   // Label 3340: @171512
     /* 171512 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(171557), // Rule ID 1607 //
     /* 171517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171546 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 171549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171555 */     GIR_RootConstrainSelectedInstOperands,
     /* 171556 */     // GIR_Coverage, 1607,
     /* 171556 */     GIR_EraseRootFromParent_Done,
     /* 171557 */   // Label 3341: @171557
     /* 171557 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(171602), // Rule ID 1608 //
     /* 171562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171591 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 171594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171600 */     GIR_RootConstrainSelectedInstOperands,
     /* 171601 */     // GIR_Coverage, 1608,
     /* 171601 */     GIR_EraseRootFromParent_Done,
     /* 171602 */   // Label 3342: @171602
     /* 171602 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(171647), // Rule ID 1609 //
     /* 171607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171636 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 171639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171645 */     GIR_RootConstrainSelectedInstOperands,
     /* 171646 */     // GIR_Coverage, 1609,
     /* 171646 */     GIR_EraseRootFromParent_Done,
     /* 171647 */   // Label 3343: @171647
     /* 171647 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(171692), // Rule ID 1610 //
     /* 171652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171681 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 171684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171690 */     GIR_RootConstrainSelectedInstOperands,
     /* 171691 */     // GIR_Coverage, 1610,
     /* 171691 */     GIR_EraseRootFromParent_Done,
     /* 171692 */   // Label 3344: @171692
     /* 171692 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(171737), // Rule ID 1611 //
     /* 171697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171726 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 171729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171735 */     GIR_RootConstrainSelectedInstOperands,
     /* 171736 */     // GIR_Coverage, 1611,
     /* 171736 */     GIR_EraseRootFromParent_Done,
     /* 171737 */   // Label 3345: @171737
     /* 171737 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(171782), // Rule ID 1612 //
     /* 171742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171771 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 171774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171780 */     GIR_RootConstrainSelectedInstOperands,
     /* 171781 */     // GIR_Coverage, 1612,
     /* 171781 */     GIR_EraseRootFromParent_Done,
     /* 171782 */   // Label 3346: @171782
     /* 171782 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(171827), // Rule ID 1613 //
     /* 171787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171816 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 171819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171825 */     GIR_RootConstrainSelectedInstOperands,
     /* 171826 */     // GIR_Coverage, 1613,
     /* 171826 */     GIR_EraseRootFromParent_Done,
     /* 171827 */   // Label 3347: @171827
     /* 171827 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(171872), // Rule ID 1620 //
     /* 171832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171861 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 171864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171870 */     GIR_RootConstrainSelectedInstOperands,
     /* 171871 */     // GIR_Coverage, 1620,
     /* 171871 */     GIR_EraseRootFromParent_Done,
     /* 171872 */   // Label 3348: @171872
     /* 171872 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(171917), // Rule ID 1621 //
     /* 171877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171906 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 171909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171915 */     GIR_RootConstrainSelectedInstOperands,
     /* 171916 */     // GIR_Coverage, 1621,
     /* 171916 */     GIR_EraseRootFromParent_Done,
     /* 171917 */   // Label 3349: @171917
     /* 171917 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(171962), // Rule ID 1622 //
     /* 171922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171951 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 171954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171960 */     GIR_RootConstrainSelectedInstOperands,
     /* 171961 */     // GIR_Coverage, 1622,
     /* 171961 */     GIR_EraseRootFromParent_Done,
     /* 171962 */   // Label 3350: @171962
     /* 171962 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(172007), // Rule ID 1623 //
     /* 171967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171996 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 171999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172005 */     GIR_RootConstrainSelectedInstOperands,
     /* 172006 */     // GIR_Coverage, 1623,
     /* 172006 */     GIR_EraseRootFromParent_Done,
     /* 172007 */   // Label 3351: @172007
     /* 172007 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(172052), // Rule ID 1624 //
     /* 172012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 172015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172041 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 172041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 172044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172050 */     GIR_RootConstrainSelectedInstOperands,
     /* 172051 */     // GIR_Coverage, 1624,
     /* 172051 */     GIR_EraseRootFromParent_Done,
     /* 172052 */   // Label 3352: @172052
     /* 172052 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(172097), // Rule ID 1625 //
     /* 172057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 172060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 172065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 172068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 172074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172086 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 172086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 172089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172095 */     GIR_RootConstrainSelectedInstOperands,
     /* 172096 */     // GIR_Coverage, 1625,
     /* 172096 */     GIR_EraseRootFromParent_Done,
     /* 172097 */   // Label 3353: @172097
     /* 172097 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(172142), // Rule ID 1626 //
     /* 172102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 172105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 172110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172131 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 172131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 172134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172140 */     GIR_RootConstrainSelectedInstOperands,
     /* 172141 */     // GIR_Coverage, 1626,
     /* 172141 */     GIR_EraseRootFromParent_Done,
     /* 172142 */   // Label 3354: @172142
     /* 172142 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(172187), // Rule ID 1627 //
     /* 172147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 172150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 172155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172176 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 172176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 172179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 1627,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3355: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(172232), // Rule ID 1628 //
     /* 172192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 172195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 172200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 172203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 172209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 172221 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 172221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 172224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172230 */     GIR_RootConstrainSelectedInstOperands,
     /* 172231 */     // GIR_Coverage, 1628,
     /* 172231 */     GIR_EraseRootFromParent_Done,
     /* 172232 */   // Label 3356: @172232
     /* 172232 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(172277), // Rule ID 1629 //
     /* 172237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172266 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 172269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172275 */     GIR_RootConstrainSelectedInstOperands,
     /* 172276 */     // GIR_Coverage, 1629,
     /* 172276 */     GIR_EraseRootFromParent_Done,
     /* 172277 */   // Label 3357: @172277
     /* 172277 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(172322), // Rule ID 1630 //
     /* 172282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172311 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 172311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 172314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172320 */     GIR_RootConstrainSelectedInstOperands,
     /* 172321 */     // GIR_Coverage, 1630,
     /* 172321 */     GIR_EraseRootFromParent_Done,
     /* 172322 */   // Label 3358: @172322
     /* 172322 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(172367), // Rule ID 1631 //
     /* 172327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172356 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 172356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 172359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172365 */     GIR_RootConstrainSelectedInstOperands,
     /* 172366 */     // GIR_Coverage, 1631,
     /* 172366 */     GIR_EraseRootFromParent_Done,
     /* 172367 */   // Label 3359: @172367
     /* 172367 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(172412), // Rule ID 1632 //
     /* 172372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172401 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 172404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172410 */     GIR_RootConstrainSelectedInstOperands,
     /* 172411 */     // GIR_Coverage, 1632,
     /* 172411 */     GIR_EraseRootFromParent_Done,
     /* 172412 */   // Label 3360: @172412
     /* 172412 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(172457), // Rule ID 1633 //
     /* 172417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172446 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 172449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172455 */     GIR_RootConstrainSelectedInstOperands,
     /* 172456 */     // GIR_Coverage, 1633,
     /* 172456 */     GIR_EraseRootFromParent_Done,
     /* 172457 */   // Label 3361: @172457
     /* 172457 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(172502), // Rule ID 1634 //
     /* 172462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172491 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 172494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172500 */     GIR_RootConstrainSelectedInstOperands,
     /* 172501 */     // GIR_Coverage, 1634,
     /* 172501 */     GIR_EraseRootFromParent_Done,
     /* 172502 */   // Label 3362: @172502
     /* 172502 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(172547), // Rule ID 1635 //
     /* 172507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172536 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 172539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172545 */     GIR_RootConstrainSelectedInstOperands,
     /* 172546 */     // GIR_Coverage, 1635,
     /* 172546 */     GIR_EraseRootFromParent_Done,
     /* 172547 */   // Label 3363: @172547
     /* 172547 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(172592), // Rule ID 1636 //
     /* 172552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 172560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172581 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 172584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172590 */     GIR_RootConstrainSelectedInstOperands,
     /* 172591 */     // GIR_Coverage, 1636,
     /* 172591 */     GIR_EraseRootFromParent_Done,
     /* 172592 */   // Label 3364: @172592
     /* 172592 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(172637), // Rule ID 1638 //
     /* 172597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 172605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172626 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 172629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172635 */     GIR_RootConstrainSelectedInstOperands,
     /* 172636 */     // GIR_Coverage, 1638,
     /* 172636 */     GIR_EraseRootFromParent_Done,
     /* 172637 */   // Label 3365: @172637
     /* 172637 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(172682), // Rule ID 1639 //
     /* 172642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172671 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 172674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172680 */     GIR_RootConstrainSelectedInstOperands,
     /* 172681 */     // GIR_Coverage, 1639,
     /* 172681 */     GIR_EraseRootFromParent_Done,
     /* 172682 */   // Label 3366: @172682
     /* 172682 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(172727), // Rule ID 1640 //
     /* 172687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172716 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 172719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172725 */     GIR_RootConstrainSelectedInstOperands,
     /* 172726 */     // GIR_Coverage, 1640,
     /* 172726 */     GIR_EraseRootFromParent_Done,
     /* 172727 */   // Label 3367: @172727
     /* 172727 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(172772), // Rule ID 1641 //
     /* 172732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172761 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 172764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172770 */     GIR_RootConstrainSelectedInstOperands,
     /* 172771 */     // GIR_Coverage, 1641,
     /* 172771 */     GIR_EraseRootFromParent_Done,
     /* 172772 */   // Label 3368: @172772
     /* 172772 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(172817), // Rule ID 1642 //
     /* 172777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 172785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172806 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 172809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172815 */     GIR_RootConstrainSelectedInstOperands,
     /* 172816 */     // GIR_Coverage, 1642,
     /* 172816 */     GIR_EraseRootFromParent_Done,
     /* 172817 */   // Label 3369: @172817
     /* 172817 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(172862), // Rule ID 1643 //
     /* 172822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 172830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172851 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 172854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172860 */     GIR_RootConstrainSelectedInstOperands,
     /* 172861 */     // GIR_Coverage, 1643,
     /* 172861 */     GIR_EraseRootFromParent_Done,
     /* 172862 */   // Label 3370: @172862
     /* 172862 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(172907), // Rule ID 1644 //
     /* 172867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 172875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172896 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 172896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 172899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172905 */     GIR_RootConstrainSelectedInstOperands,
     /* 172906 */     // GIR_Coverage, 1644,
     /* 172906 */     GIR_EraseRootFromParent_Done,
     /* 172907 */   // Label 3371: @172907
     /* 172907 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(172952), // Rule ID 1658 //
     /* 172912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172941 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 172941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 172944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172950 */     GIR_RootConstrainSelectedInstOperands,
     /* 172951 */     // GIR_Coverage, 1658,
     /* 172951 */     GIR_EraseRootFromParent_Done,
     /* 172952 */   // Label 3372: @172952
     /* 172952 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(172997), // Rule ID 1659 //
     /* 172957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172986 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 172986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 172989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172995 */     GIR_RootConstrainSelectedInstOperands,
     /* 172996 */     // GIR_Coverage, 1659,
     /* 172996 */     GIR_EraseRootFromParent_Done,
     /* 172997 */   // Label 3373: @172997
     /* 172997 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(173042), // Rule ID 1664 //
     /* 173002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 173010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 173013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 173016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 173019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173031 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 173031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 173034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173040 */     GIR_RootConstrainSelectedInstOperands,
     /* 173041 */     // GIR_Coverage, 1664,
     /* 173041 */     GIR_EraseRootFromParent_Done,
     /* 173042 */   // Label 3374: @173042
     /* 173042 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(173087), // Rule ID 1665 //
     /* 173047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 173055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173076 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 173076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 173079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173085 */     GIR_RootConstrainSelectedInstOperands,
     /* 173086 */     // GIR_Coverage, 1665,
     /* 173086 */     GIR_EraseRootFromParent_Done,
     /* 173087 */   // Label 3375: @173087
     /* 173087 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(173132), // Rule ID 1666 //
     /* 173092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 173100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173121 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 173124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173130 */     GIR_RootConstrainSelectedInstOperands,
     /* 173131 */     // GIR_Coverage, 1666,
     /* 173131 */     GIR_EraseRootFromParent_Done,
     /* 173132 */   // Label 3376: @173132
     /* 173132 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(173177), // Rule ID 1667 //
     /* 173137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 173145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173166 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 173169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173175 */     GIR_RootConstrainSelectedInstOperands,
     /* 173176 */     // GIR_Coverage, 1667,
     /* 173176 */     GIR_EraseRootFromParent_Done,
     /* 173177 */   // Label 3377: @173177
     /* 173177 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(173222), // Rule ID 1668 //
     /* 173182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 173190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173211 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 173214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173220 */     GIR_RootConstrainSelectedInstOperands,
     /* 173221 */     // GIR_Coverage, 1668,
     /* 173221 */     GIR_EraseRootFromParent_Done,
     /* 173222 */   // Label 3378: @173222
     /* 173222 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(173267), // Rule ID 1669 //
     /* 173227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 173235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173256 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 173259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173265 */     GIR_RootConstrainSelectedInstOperands,
     /* 173266 */     // GIR_Coverage, 1669,
     /* 173266 */     GIR_EraseRootFromParent_Done,
     /* 173267 */   // Label 3379: @173267
     /* 173267 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(173312), // Rule ID 1670 //
     /* 173272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 173280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173301 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 173304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173310 */     GIR_RootConstrainSelectedInstOperands,
     /* 173311 */     // GIR_Coverage, 1670,
     /* 173311 */     GIR_EraseRootFromParent_Done,
     /* 173312 */   // Label 3380: @173312
     /* 173312 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(173357), // Rule ID 1671 //
     /* 173317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 173325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173346 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 173349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173355 */     GIR_RootConstrainSelectedInstOperands,
     /* 173356 */     // GIR_Coverage, 1671,
     /* 173356 */     GIR_EraseRootFromParent_Done,
     /* 173357 */   // Label 3381: @173357
     /* 173357 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(173402), // Rule ID 1672 //
     /* 173362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 173370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173391 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 173394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173400 */     GIR_RootConstrainSelectedInstOperands,
     /* 173401 */     // GIR_Coverage, 1672,
     /* 173401 */     GIR_EraseRootFromParent_Done,
     /* 173402 */   // Label 3382: @173402
     /* 173402 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(173447), // Rule ID 1673 //
     /* 173407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 173415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173436 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 173439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173445 */     GIR_RootConstrainSelectedInstOperands,
     /* 173446 */     // GIR_Coverage, 1673,
     /* 173446 */     GIR_EraseRootFromParent_Done,
     /* 173447 */   // Label 3383: @173447
     /* 173447 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(173492), // Rule ID 1674 //
     /* 173452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 173460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173481 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 173484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173490 */     GIR_RootConstrainSelectedInstOperands,
     /* 173491 */     // GIR_Coverage, 1674,
     /* 173491 */     GIR_EraseRootFromParent_Done,
     /* 173492 */   // Label 3384: @173492
     /* 173492 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(173537), // Rule ID 1675 //
     /* 173497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173526 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 173529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173535 */     GIR_RootConstrainSelectedInstOperands,
     /* 173536 */     // GIR_Coverage, 1675,
     /* 173536 */     GIR_EraseRootFromParent_Done,
     /* 173537 */   // Label 3385: @173537
     /* 173537 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(173582), // Rule ID 1676 //
     /* 173542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173571 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 173574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173580 */     GIR_RootConstrainSelectedInstOperands,
     /* 173581 */     // GIR_Coverage, 1676,
     /* 173581 */     GIR_EraseRootFromParent_Done,
     /* 173582 */   // Label 3386: @173582
     /* 173582 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(173627), // Rule ID 1677 //
     /* 173587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173616 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 173619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173625 */     GIR_RootConstrainSelectedInstOperands,
     /* 173626 */     // GIR_Coverage, 1677,
     /* 173626 */     GIR_EraseRootFromParent_Done,
     /* 173627 */   // Label 3387: @173627
     /* 173627 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(173672), // Rule ID 1743 //
     /* 173632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173661 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 173664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173670 */     GIR_RootConstrainSelectedInstOperands,
     /* 173671 */     // GIR_Coverage, 1743,
     /* 173671 */     GIR_EraseRootFromParent_Done,
     /* 173672 */   // Label 3388: @173672
     /* 173672 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(173717), // Rule ID 1745 //
     /* 173677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173706 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 173709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173715 */     GIR_RootConstrainSelectedInstOperands,
     /* 173716 */     // GIR_Coverage, 1745,
     /* 173716 */     GIR_EraseRootFromParent_Done,
     /* 173717 */   // Label 3389: @173717
     /* 173717 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(173762), // Rule ID 2294 //
     /* 173722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 173730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173751 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 173754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173760 */     GIR_RootConstrainSelectedInstOperands,
     /* 173761 */     // GIR_Coverage, 2294,
     /* 173761 */     GIR_EraseRootFromParent_Done,
     /* 173762 */   // Label 3390: @173762
     /* 173762 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(173807), // Rule ID 2295 //
     /* 173767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 173775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 173799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173805 */     GIR_RootConstrainSelectedInstOperands,
     /* 173806 */     // GIR_Coverage, 2295,
     /* 173806 */     GIR_EraseRootFromParent_Done,
     /* 173807 */   // Label 3391: @173807
     /* 173807 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(173852), // Rule ID 2306 //
     /* 173812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 173820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173841 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 173844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173850 */     GIR_RootConstrainSelectedInstOperands,
     /* 173851 */     // GIR_Coverage, 2306,
     /* 173851 */     GIR_EraseRootFromParent_Done,
     /* 173852 */   // Label 3392: @173852
     /* 173852 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(173897), // Rule ID 2307 //
     /* 173857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 173865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173886 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 173889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173895 */     GIR_RootConstrainSelectedInstOperands,
     /* 173896 */     // GIR_Coverage, 2307,
     /* 173896 */     GIR_EraseRootFromParent_Done,
     /* 173897 */   // Label 3393: @173897
     /* 173897 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(173942), // Rule ID 2330 //
     /* 173902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173931 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 173934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173940 */     GIR_RootConstrainSelectedInstOperands,
     /* 173941 */     // GIR_Coverage, 2330,
     /* 173941 */     GIR_EraseRootFromParent_Done,
     /* 173942 */   // Label 3394: @173942
     /* 173942 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(173987), // Rule ID 2331 //
     /* 173947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173976 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 173979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173985 */     GIR_RootConstrainSelectedInstOperands,
     /* 173986 */     // GIR_Coverage, 2331,
     /* 173986 */     GIR_EraseRootFromParent_Done,
     /* 173987 */   // Label 3395: @173987
     /* 173987 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(174032), // Rule ID 2332 //
     /* 173992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 174000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174021 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 174024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174030 */     GIR_RootConstrainSelectedInstOperands,
     /* 174031 */     // GIR_Coverage, 2332,
     /* 174031 */     GIR_EraseRootFromParent_Done,
     /* 174032 */   // Label 3396: @174032
     /* 174032 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(174077), // Rule ID 2333 //
     /* 174037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 174040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 174045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174066 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 174069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174075 */     GIR_RootConstrainSelectedInstOperands,
     /* 174076 */     // GIR_Coverage, 2333,
     /* 174076 */     GIR_EraseRootFromParent_Done,
     /* 174077 */   // Label 3397: @174077
     /* 174077 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(174122), // Rule ID 2334 //
     /* 174082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 174085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 174090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174111 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174120 */     GIR_RootConstrainSelectedInstOperands,
     /* 174121 */     // GIR_Coverage, 2334,
     /* 174121 */     GIR_EraseRootFromParent_Done,
     /* 174122 */   // Label 3398: @174122
     /* 174122 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(174167), // Rule ID 2335 //
     /* 174127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 174135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174156 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 174156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 174159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174165 */     GIR_RootConstrainSelectedInstOperands,
     /* 174166 */     // GIR_Coverage, 2335,
     /* 174166 */     GIR_EraseRootFromParent_Done,
     /* 174167 */   // Label 3399: @174167
     /* 174167 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(174212), // Rule ID 2338 //
     /* 174172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 174180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174201 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 174201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 174204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174210 */     GIR_RootConstrainSelectedInstOperands,
     /* 174211 */     // GIR_Coverage, 2338,
     /* 174211 */     GIR_EraseRootFromParent_Done,
     /* 174212 */   // Label 3400: @174212
     /* 174212 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(174257), // Rule ID 2341 //
     /* 174217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 174225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174246 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 174246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 174249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174255 */     GIR_RootConstrainSelectedInstOperands,
     /* 174256 */     // GIR_Coverage, 2341,
     /* 174256 */     GIR_EraseRootFromParent_Done,
     /* 174257 */   // Label 3401: @174257
     /* 174257 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(174302), // Rule ID 2344 //
     /* 174262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 174270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174291 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 174291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 174294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174300 */     GIR_RootConstrainSelectedInstOperands,
     /* 174301 */     // GIR_Coverage, 2344,
     /* 174301 */     GIR_EraseRootFromParent_Done,
     /* 174302 */   // Label 3402: @174302
     /* 174302 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(174347), // Rule ID 2347 //
     /* 174307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 174315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174336 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 174336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 174339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174345 */     GIR_RootConstrainSelectedInstOperands,
     /* 174346 */     // GIR_Coverage, 2347,
     /* 174346 */     GIR_EraseRootFromParent_Done,
     /* 174347 */   // Label 3403: @174347
     /* 174347 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(174392), // Rule ID 2350 //
     /* 174352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174381 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 174381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 174384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174390 */     GIR_RootConstrainSelectedInstOperands,
     /* 174391 */     // GIR_Coverage, 2350,
     /* 174391 */     GIR_EraseRootFromParent_Done,
     /* 174392 */   // Label 3404: @174392
     /* 174392 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(174437), // Rule ID 2353 //
     /* 174397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174426 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 174426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 174429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174435 */     GIR_RootConstrainSelectedInstOperands,
     /* 174436 */     // GIR_Coverage, 2353,
     /* 174436 */     GIR_EraseRootFromParent_Done,
     /* 174437 */   // Label 3405: @174437
     /* 174437 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(174482), // Rule ID 2356 //
     /* 174442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174471 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 174471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 174474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174480 */     GIR_RootConstrainSelectedInstOperands,
     /* 174481 */     // GIR_Coverage, 2356,
     /* 174481 */     GIR_EraseRootFromParent_Done,
     /* 174482 */   // Label 3406: @174482
     /* 174482 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(174527), // Rule ID 2359 //
     /* 174487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 174516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 174519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174525 */     GIR_RootConstrainSelectedInstOperands,
     /* 174526 */     // GIR_Coverage, 2359,
     /* 174526 */     GIR_EraseRootFromParent_Done,
     /* 174527 */   // Label 3407: @174527
     /* 174527 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(174572), // Rule ID 2362 //
     /* 174532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174561 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 174561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 174564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174570 */     GIR_RootConstrainSelectedInstOperands,
     /* 174571 */     // GIR_Coverage, 2362,
     /* 174571 */     GIR_EraseRootFromParent_Done,
     /* 174572 */   // Label 3408: @174572
     /* 174572 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(174617), // Rule ID 2499 //
     /* 174577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174606 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 174606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 174609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174615 */     GIR_RootConstrainSelectedInstOperands,
     /* 174616 */     // GIR_Coverage, 2499,
     /* 174616 */     GIR_EraseRootFromParent_Done,
     /* 174617 */   // Label 3409: @174617
     /* 174617 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(174662), // Rule ID 2500 //
     /* 174622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174651 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 174651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 174654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174660 */     GIR_RootConstrainSelectedInstOperands,
     /* 174661 */     // GIR_Coverage, 2500,
     /* 174661 */     GIR_EraseRootFromParent_Done,
     /* 174662 */   // Label 3410: @174662
     /* 174662 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(174707), // Rule ID 2501 //
     /* 174667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 174675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174696 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 174699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174705 */     GIR_RootConstrainSelectedInstOperands,
     /* 174706 */     // GIR_Coverage, 2501,
     /* 174706 */     GIR_EraseRootFromParent_Done,
     /* 174707 */   // Label 3411: @174707
     /* 174707 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(174752), // Rule ID 2502 //
     /* 174712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 174720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174741 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 174744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174750 */     GIR_RootConstrainSelectedInstOperands,
     /* 174751 */     // GIR_Coverage, 2502,
     /* 174751 */     GIR_EraseRootFromParent_Done,
     /* 174752 */   // Label 3412: @174752
     /* 174752 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(174797), // Rule ID 2507 //
     /* 174757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 174765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174786 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 174786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 174789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 174795 */     GIR_RootConstrainSelectedInstOperands,
     /* 174796 */     // GIR_Coverage, 2507,
     /* 174796 */     GIR_EraseRootFromParent_Done,
     /* 174797 */   // Label 3413: @174797
     /* 174797 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(174842), // Rule ID 2620 //
     /* 174802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174831 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 174834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174840 */     GIR_RootConstrainSelectedInstOperands,
     /* 174841 */     // GIR_Coverage, 2620,
     /* 174841 */     GIR_EraseRootFromParent_Done,
     /* 174842 */   // Label 3414: @174842
     /* 174842 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(174887), // Rule ID 2621 //
     /* 174847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 174864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174876 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 174879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174885 */     GIR_RootConstrainSelectedInstOperands,
     /* 174886 */     // GIR_Coverage, 2621,
     /* 174886 */     GIR_EraseRootFromParent_Done,
     /* 174887 */   // Label 3415: @174887
     /* 174887 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(174932), // Rule ID 2622 //
     /* 174892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 174909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174921 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 174924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174930 */     GIR_RootConstrainSelectedInstOperands,
     /* 174931 */     // GIR_Coverage, 2622,
     /* 174931 */     GIR_EraseRootFromParent_Done,
     /* 174932 */   // Label 3416: @174932
     /* 174932 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(174977), // Rule ID 2623 //
     /* 174937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 174954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174966 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 174969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174975 */     GIR_RootConstrainSelectedInstOperands,
     /* 174976 */     // GIR_Coverage, 2623,
     /* 174976 */     GIR_EraseRootFromParent_Done,
     /* 174977 */   // Label 3417: @174977
     /* 174977 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(175022), // Rule ID 2624 //
     /* 174982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 175011 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 175011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 175014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 175016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 175018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175020 */     GIR_RootConstrainSelectedInstOperands,
     /* 175021 */     // GIR_Coverage, 2624,
     /* 175021 */     GIR_EraseRootFromParent_Done,
     /* 175022 */   // Label 3418: @175022
     /* 175022 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(175067), // Rule ID 2625 //
     /* 175027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 175030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 175035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 175044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 175056 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 175056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 175059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 175061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 175063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175065 */     GIR_RootConstrainSelectedInstOperands,
     /* 175066 */     // GIR_Coverage, 2625,
     /* 175066 */     GIR_EraseRootFromParent_Done,
     /* 175067 */   // Label 3419: @175067
     /* 175067 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(175112), // Rule ID 2626 //
     /* 175072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 175075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 175080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 175089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 175101 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 175101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 175104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 175106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 175108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175110 */     GIR_RootConstrainSelectedInstOperands,
     /* 175111 */     // GIR_Coverage, 2626,
     /* 175111 */     GIR_EraseRootFromParent_Done,
     /* 175112 */   // Label 3420: @175112
     /* 175112 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(175157), // Rule ID 2627 //
     /* 175117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 175120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 175125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 175134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 175146 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 175146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 175149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 175151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 175153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175155 */     GIR_RootConstrainSelectedInstOperands,
     /* 175156 */     // GIR_Coverage, 2627,
     /* 175156 */     GIR_EraseRootFromParent_Done,
     /* 175157 */   // Label 3421: @175157
     /* 175157 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(175202), // Rule ID 3757 //
     /* 175162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 175165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 175170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175191 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 175191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 175194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 175196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 175198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 175200 */     GIR_RootConstrainSelectedInstOperands,
     /* 175201 */     // GIR_Coverage, 3757,
     /* 175201 */     GIR_EraseRootFromParent_Done,
     /* 175202 */   // Label 3422: @175202
     /* 175202 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(175247), // Rule ID 3785 //
     /* 175207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 175210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 175215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175236 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 175236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 175239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 175241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 175243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 175245 */     GIR_RootConstrainSelectedInstOperands,
     /* 175246 */     // GIR_Coverage, 3785,
     /* 175246 */     GIR_EraseRootFromParent_Done,
     /* 175247 */   // Label 3423: @175247
     /* 175247 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(175292), // Rule ID 3795 //
     /* 175252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 175255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 175260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175281 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 175281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 175284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 175286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 175288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 175290 */     GIR_RootConstrainSelectedInstOperands,
     /* 175291 */     // GIR_Coverage, 3795,
     /* 175291 */     GIR_EraseRootFromParent_Done,
     /* 175292 */   // Label 3424: @175292
     /* 175292 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(175337), // Rule ID 3796 //
     /* 175297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 175300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 175305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175326 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 175326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 175329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 175331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 175333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 175335 */     GIR_RootConstrainSelectedInstOperands,
     /* 175336 */     // GIR_Coverage, 3796,
     /* 175336 */     GIR_EraseRootFromParent_Done,
     /* 175337 */   // Label 3425: @175337
     /* 175337 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(175385), // Rule ID 3797 //
     /* 175342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175371 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 175371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 175374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175383 */     GIR_RootConstrainSelectedInstOperands,
     /* 175384 */     // GIR_Coverage, 3797,
     /* 175384 */     GIR_EraseRootFromParent_Done,
     /* 175385 */   // Label 3426: @175385
     /* 175385 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(175433), // Rule ID 3798 //
     /* 175390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175419 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 175419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 175422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175431 */     GIR_RootConstrainSelectedInstOperands,
     /* 175432 */     // GIR_Coverage, 3798,
     /* 175432 */     GIR_EraseRootFromParent_Done,
     /* 175433 */   // Label 3427: @175433
     /* 175433 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(175481), // Rule ID 3799 //
     /* 175438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175467 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 175467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175479 */     GIR_RootConstrainSelectedInstOperands,
     /* 175480 */     // GIR_Coverage, 3799,
     /* 175480 */     GIR_EraseRootFromParent_Done,
     /* 175481 */   // Label 3428: @175481
     /* 175481 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(175529), // Rule ID 3800 //
     /* 175486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175515 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 175515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175527 */     GIR_RootConstrainSelectedInstOperands,
     /* 175528 */     // GIR_Coverage, 3800,
     /* 175528 */     GIR_EraseRootFromParent_Done,
     /* 175529 */   // Label 3429: @175529
     /* 175529 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(175577), // Rule ID 3801 //
     /* 175534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175563 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 175563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175575 */     GIR_RootConstrainSelectedInstOperands,
     /* 175576 */     // GIR_Coverage, 3801,
     /* 175576 */     GIR_EraseRootFromParent_Done,
     /* 175577 */   // Label 3430: @175577
     /* 175577 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(175625), // Rule ID 3802 //
     /* 175582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175611 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 175611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175623 */     GIR_RootConstrainSelectedInstOperands,
     /* 175624 */     // GIR_Coverage, 3802,
     /* 175624 */     GIR_EraseRootFromParent_Done,
     /* 175625 */   // Label 3431: @175625
     /* 175625 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(175673), // Rule ID 3803 //
     /* 175630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175659 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 175659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175671 */     GIR_RootConstrainSelectedInstOperands,
     /* 175672 */     // GIR_Coverage, 3803,
     /* 175672 */     GIR_EraseRootFromParent_Done,
     /* 175673 */   // Label 3432: @175673
     /* 175673 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(175721), // Rule ID 3804 //
     /* 175678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175707 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 175707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175719 */     GIR_RootConstrainSelectedInstOperands,
     /* 175720 */     // GIR_Coverage, 3804,
     /* 175720 */     GIR_EraseRootFromParent_Done,
     /* 175721 */   // Label 3433: @175721
     /* 175721 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(175769), // Rule ID 3805 //
     /* 175726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175755 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 175755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175767 */     GIR_RootConstrainSelectedInstOperands,
     /* 175768 */     // GIR_Coverage, 3805,
     /* 175768 */     GIR_EraseRootFromParent_Done,
     /* 175769 */   // Label 3434: @175769
     /* 175769 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(175817), // Rule ID 3806 //
     /* 175774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175803 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 175803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175815 */     GIR_RootConstrainSelectedInstOperands,
     /* 175816 */     // GIR_Coverage, 3806,
     /* 175816 */     GIR_EraseRootFromParent_Done,
     /* 175817 */   // Label 3435: @175817
     /* 175817 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(175859), // Rule ID 3871 //
     /* 175822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175848 */     // (intrinsic_wo_chain:{ *:[i32] } 2075:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 175851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175857 */     GIR_RootConstrainSelectedInstOperands,
     /* 175858 */     // GIR_Coverage, 3871,
     /* 175858 */     GIR_EraseRootFromParent_Done,
     /* 175859 */   // Label 3436: @175859
     /* 175859 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(175901), // Rule ID 3872 //
     /* 175864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175890 */     // (intrinsic_wo_chain:{ *:[i64] } 2075:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 175893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175899 */     GIR_RootConstrainSelectedInstOperands,
     /* 175900 */     // GIR_Coverage, 3872,
     /* 175900 */     GIR_EraseRootFromParent_Done,
     /* 175901 */   // Label 3437: @175901
     /* 175901 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(175943), // Rule ID 3873 //
     /* 175906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175932 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 175935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175941 */     GIR_RootConstrainSelectedInstOperands,
     /* 175942 */     // GIR_Coverage, 3873,
     /* 175942 */     GIR_EraseRootFromParent_Done,
     /* 175943 */   // Label 3438: @175943
     /* 175943 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(175985), // Rule ID 3874 //
     /* 175948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175974 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 175977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175983 */     GIR_RootConstrainSelectedInstOperands,
     /* 175984 */     // GIR_Coverage, 3874,
     /* 175984 */     GIR_EraseRootFromParent_Done,
     /* 175985 */   // Label 3439: @175985
     /* 175985 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(176027), // Rule ID 5144 //
     /* 175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176016 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 176019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176025 */     GIR_RootConstrainSelectedInstOperands,
     /* 176026 */     // GIR_Coverage, 5144,
     /* 176026 */     GIR_EraseRootFromParent_Done,
     /* 176027 */   // Label 3440: @176027
     /* 176027 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(176072), // Rule ID 5148 //
     /* 176032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 176040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176061 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 176064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176070 */     GIR_RootConstrainSelectedInstOperands,
     /* 176071 */     // GIR_Coverage, 5148,
     /* 176071 */     GIR_EraseRootFromParent_Done,
     /* 176072 */   // Label 3441: @176072
     /* 176072 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(176117), // Rule ID 5152 //
     /* 176077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176106 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176115 */     GIR_RootConstrainSelectedInstOperands,
     /* 176116 */     // GIR_Coverage, 5152,
     /* 176116 */     GIR_EraseRootFromParent_Done,
     /* 176117 */   // Label 3442: @176117
     /* 176117 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(176162), // Rule ID 5153 //
     /* 176122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 176130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176151 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 176154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176160 */     GIR_RootConstrainSelectedInstOperands,
     /* 176161 */     // GIR_Coverage, 5153,
     /* 176161 */     GIR_EraseRootFromParent_Done,
     /* 176162 */   // Label 3443: @176162
     /* 176162 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(176207), // Rule ID 5154 //
     /* 176167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 176175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176196 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 176196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 176199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176205 */     GIR_RootConstrainSelectedInstOperands,
     /* 176206 */     // GIR_Coverage, 5154,
     /* 176206 */     GIR_EraseRootFromParent_Done,
     /* 176207 */   // Label 3444: @176207
     /* 176207 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(176252), // Rule ID 5155 //
     /* 176212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 176220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176241 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 176244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176250 */     GIR_RootConstrainSelectedInstOperands,
     /* 176251 */     // GIR_Coverage, 5155,
     /* 176251 */     GIR_EraseRootFromParent_Done,
     /* 176252 */   // Label 3445: @176252
     /* 176252 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(176297), // Rule ID 5156 //
     /* 176257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 176265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176286 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 176289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176295 */     GIR_RootConstrainSelectedInstOperands,
     /* 176296 */     // GIR_Coverage, 5156,
     /* 176296 */     GIR_EraseRootFromParent_Done,
     /* 176297 */   // Label 3446: @176297
     /* 176297 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(176342), // Rule ID 5157 //
     /* 176302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 176310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176331 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 176334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176340 */     GIR_RootConstrainSelectedInstOperands,
     /* 176341 */     // GIR_Coverage, 5157,
     /* 176341 */     GIR_EraseRootFromParent_Done,
     /* 176342 */   // Label 3447: @176342
     /* 176342 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(176387), // Rule ID 5158 //
     /* 176347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 176355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176376 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 176379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176385 */     GIR_RootConstrainSelectedInstOperands,
     /* 176386 */     // GIR_Coverage, 5158,
     /* 176386 */     GIR_EraseRootFromParent_Done,
     /* 176387 */   // Label 3448: @176387
     /* 176387 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(176432), // Rule ID 5159 //
     /* 176392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176421 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 176424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176430 */     GIR_RootConstrainSelectedInstOperands,
     /* 176431 */     // GIR_Coverage, 5159,
     /* 176431 */     GIR_EraseRootFromParent_Done,
     /* 176432 */   // Label 3449: @176432
     /* 176432 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(176477), // Rule ID 5160 //
     /* 176437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176466 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 176469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176475 */     GIR_RootConstrainSelectedInstOperands,
     /* 176476 */     // GIR_Coverage, 5160,
     /* 176476 */     GIR_EraseRootFromParent_Done,
     /* 176477 */   // Label 3450: @176477
     /* 176477 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(176522), // Rule ID 5161 //
     /* 176482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176511 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 176514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 176521 */     // GIR_Coverage, 5161,
     /* 176521 */     GIR_EraseRootFromParent_Done,
     /* 176522 */   // Label 3451: @176522
     /* 176522 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(176567), // Rule ID 5162 //
     /* 176527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176556 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 176559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176565 */     GIR_RootConstrainSelectedInstOperands,
     /* 176566 */     // GIR_Coverage, 5162,
     /* 176566 */     GIR_EraseRootFromParent_Done,
     /* 176567 */   // Label 3452: @176567
     /* 176567 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(176612), // Rule ID 5163 //
     /* 176572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176601 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 176604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176610 */     GIR_RootConstrainSelectedInstOperands,
     /* 176611 */     // GIR_Coverage, 5163,
     /* 176611 */     GIR_EraseRootFromParent_Done,
     /* 176612 */   // Label 3453: @176612
     /* 176612 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(176657), // Rule ID 5164 //
     /* 176617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176646 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 176649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176655 */     GIR_RootConstrainSelectedInstOperands,
     /* 176656 */     // GIR_Coverage, 5164,
     /* 176656 */     GIR_EraseRootFromParent_Done,
     /* 176657 */   // Label 3454: @176657
     /* 176657 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(176702), // Rule ID 5165 //
     /* 176662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176691 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 176694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176700 */     GIR_RootConstrainSelectedInstOperands,
     /* 176701 */     // GIR_Coverage, 5165,
     /* 176701 */     GIR_EraseRootFromParent_Done,
     /* 176702 */   // Label 3455: @176702
     /* 176702 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(176747), // Rule ID 5166 //
     /* 176707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176736 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 176739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176745 */     GIR_RootConstrainSelectedInstOperands,
     /* 176746 */     // GIR_Coverage, 5166,
     /* 176746 */     GIR_EraseRootFromParent_Done,
     /* 176747 */   // Label 3456: @176747
     /* 176747 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(176792), // Rule ID 5167 //
     /* 176752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176781 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 176784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176790 */     GIR_RootConstrainSelectedInstOperands,
     /* 176791 */     // GIR_Coverage, 5167,
     /* 176791 */     GIR_EraseRootFromParent_Done,
     /* 176792 */   // Label 3457: @176792
     /* 176792 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(176837), // Rule ID 5168 //
     /* 176797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176826 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 176829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176835 */     GIR_RootConstrainSelectedInstOperands,
     /* 176836 */     // GIR_Coverage, 5168,
     /* 176836 */     GIR_EraseRootFromParent_Done,
     /* 176837 */   // Label 3458: @176837
     /* 176837 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(176882), // Rule ID 5186 //
     /* 176842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 176850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176871 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 176871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 176874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176880 */     GIR_RootConstrainSelectedInstOperands,
     /* 176881 */     // GIR_Coverage, 5186,
     /* 176881 */     GIR_EraseRootFromParent_Done,
     /* 176882 */   // Label 3459: @176882
     /* 176882 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(176924), // Rule ID 5514 //
     /* 176887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176913 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 176913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 176916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 176922 */     GIR_RootConstrainSelectedInstOperands,
     /* 176923 */     // GIR_Coverage, 5514,
     /* 176923 */     GIR_EraseRootFromParent_Done,
     /* 176924 */   // Label 3460: @176924
     /* 176924 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(176966), // Rule ID 5515 //
     /* 176929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176955 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 176955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 176958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 176962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176964 */     GIR_RootConstrainSelectedInstOperands,
     /* 176965 */     // GIR_Coverage, 5515,
     /* 176965 */     GIR_EraseRootFromParent_Done,
     /* 176966 */   // Label 3461: @176966
     /* 176966 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(177063), // Rule ID 6192 //
     /* 176971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176997 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 176997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 177000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 177004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177009 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 177013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 177017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 177036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 177047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177062 */     // GIR_Coverage, 6192,
     /* 177062 */     GIR_EraseRootFromParent_Done,
     /* 177063 */   // Label 3462: @177063
     /* 177063 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(177160), // Rule ID 6193 //
     /* 177068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177094 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 177094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 177097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 177101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 177110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 177114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 177133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 177144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177159 */     // GIR_Coverage, 6193,
     /* 177159 */     GIR_EraseRootFromParent_Done,
     /* 177160 */   // Label 3463: @177160
     /* 177160 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(177202), // Rule ID 6846 //
     /* 177165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 177170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177191 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 177191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 177194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177200 */     GIR_RootConstrainSelectedInstOperands,
     /* 177201 */     // GIR_Coverage, 6846,
     /* 177201 */     GIR_EraseRootFromParent_Done,
     /* 177202 */   // Label 3464: @177202
     /* 177202 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(177244), // Rule ID 6847 //
     /* 177207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177233 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 177233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 177236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177242 */     GIR_RootConstrainSelectedInstOperands,
     /* 177243 */     // GIR_Coverage, 6847,
     /* 177243 */     GIR_EraseRootFromParent_Done,
     /* 177244 */   // Label 3465: @177244
     /* 177244 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(177286), // Rule ID 6848 //
     /* 177249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 177254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177275 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 177275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 177278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177284 */     GIR_RootConstrainSelectedInstOperands,
     /* 177285 */     // GIR_Coverage, 6848,
     /* 177285 */     GIR_EraseRootFromParent_Done,
     /* 177286 */   // Label 3466: @177286
     /* 177286 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(177328), // Rule ID 6849 //
     /* 177291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177317 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 177317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 177320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177326 */     GIR_RootConstrainSelectedInstOperands,
     /* 177327 */     // GIR_Coverage, 6849,
     /* 177327 */     GIR_EraseRootFromParent_Done,
     /* 177328 */   // Label 3467: @177328
     /* 177328 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(177376), // Rule ID 6889 //
     /* 177333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 177338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177359 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 177359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 177362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 177371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 177374 */     GIR_RootConstrainSelectedInstOperands,
     /* 177375 */     // GIR_Coverage, 6889,
     /* 177375 */     GIR_EraseRootFromParent_Done,
     /* 177376 */   // Label 3468: @177376
     /* 177376 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(177421), // Rule ID 9871 //
     /* 177381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177410 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 177413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177419 */     GIR_RootConstrainSelectedInstOperands,
     /* 177420 */     // GIR_Coverage, 9871,
     /* 177420 */     GIR_EraseRootFromParent_Done,
     /* 177421 */   // Label 3469: @177421
     /* 177421 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(177466), // Rule ID 9872 //
     /* 177426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177455 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 177458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177464 */     GIR_RootConstrainSelectedInstOperands,
     /* 177465 */     // GIR_Coverage, 9872,
     /* 177465 */     GIR_EraseRootFromParent_Done,
     /* 177466 */   // Label 3470: @177466
     /* 177466 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(177511), // Rule ID 9873 //
     /* 177471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177500 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 177503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177509 */     GIR_RootConstrainSelectedInstOperands,
     /* 177510 */     // GIR_Coverage, 9873,
     /* 177510 */     GIR_EraseRootFromParent_Done,
     /* 177511 */   // Label 3471: @177511
     /* 177511 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(177556), // Rule ID 9874 //
     /* 177516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177545 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 177548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177554 */     GIR_RootConstrainSelectedInstOperands,
     /* 177555 */     // GIR_Coverage, 9874,
     /* 177555 */     GIR_EraseRootFromParent_Done,
     /* 177556 */   // Label 3472: @177556
     /* 177556 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(177601), // Rule ID 9883 //
     /* 177561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177590 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177599 */     GIR_RootConstrainSelectedInstOperands,
     /* 177600 */     // GIR_Coverage, 9883,
     /* 177600 */     GIR_EraseRootFromParent_Done,
     /* 177601 */   // Label 3473: @177601
     /* 177601 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(177646), // Rule ID 9884 //
     /* 177606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177635 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 177638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177644 */     GIR_RootConstrainSelectedInstOperands,
     /* 177645 */     // GIR_Coverage, 9884,
     /* 177645 */     GIR_EraseRootFromParent_Done,
     /* 177646 */   // Label 3474: @177646
     /* 177646 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(177691), // Rule ID 9885 //
     /* 177651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177680 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 177683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177689 */     GIR_RootConstrainSelectedInstOperands,
     /* 177690 */     // GIR_Coverage, 9885,
     /* 177690 */     GIR_EraseRootFromParent_Done,
     /* 177691 */   // Label 3475: @177691
     /* 177691 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(177736), // Rule ID 9886 //
     /* 177696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177725 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 177728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177734 */     GIR_RootConstrainSelectedInstOperands,
     /* 177735 */     // GIR_Coverage, 9886,
     /* 177735 */     GIR_EraseRootFromParent_Done,
     /* 177736 */   // Label 3476: @177736
     /* 177736 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(177781), // Rule ID 9887 //
     /* 177741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177770 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 177773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177779 */     GIR_RootConstrainSelectedInstOperands,
     /* 177780 */     // GIR_Coverage, 9887,
     /* 177780 */     GIR_EraseRootFromParent_Done,
     /* 177781 */   // Label 3477: @177781
     /* 177781 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(177826), // Rule ID 9888 //
     /* 177786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177815 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 177818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177824 */     GIR_RootConstrainSelectedInstOperands,
     /* 177825 */     // GIR_Coverage, 9888,
     /* 177825 */     GIR_EraseRootFromParent_Done,
     /* 177826 */   // Label 3478: @177826
     /* 177826 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(177871), // Rule ID 9889 //
     /* 177831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177860 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 177863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177869 */     GIR_RootConstrainSelectedInstOperands,
     /* 177870 */     // GIR_Coverage, 9889,
     /* 177870 */     GIR_EraseRootFromParent_Done,
     /* 177871 */   // Label 3479: @177871
     /* 177871 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(177916), // Rule ID 9890 //
     /* 177876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177905 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 177908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177914 */     GIR_RootConstrainSelectedInstOperands,
     /* 177915 */     // GIR_Coverage, 9890,
     /* 177915 */     GIR_EraseRootFromParent_Done,
     /* 177916 */   // Label 3480: @177916
     /* 177916 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(177961), // Rule ID 9891 //
     /* 177921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177950 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 177953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177959 */     GIR_RootConstrainSelectedInstOperands,
     /* 177960 */     // GIR_Coverage, 9891,
     /* 177960 */     GIR_EraseRootFromParent_Done,
     /* 177961 */   // Label 3481: @177961
     /* 177961 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(178006), // Rule ID 9892 //
     /* 177966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177995 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 177998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 178000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 178002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178004 */     GIR_RootConstrainSelectedInstOperands,
     /* 178005 */     // GIR_Coverage, 9892,
     /* 178005 */     GIR_EraseRootFromParent_Done,
     /* 178006 */   // Label 3482: @178006
     /* 178006 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(178051), // Rule ID 9893 //
     /* 178011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 178019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178040 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 178040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 178043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 178045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 178047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178049 */     GIR_RootConstrainSelectedInstOperands,
     /* 178050 */     // GIR_Coverage, 9893,
     /* 178050 */     GIR_EraseRootFromParent_Done,
     /* 178051 */   // Label 3483: @178051
     /* 178051 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(178096), // Rule ID 9894 //
     /* 178056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 178064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178085 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 178085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 178088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 178090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 178092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178094 */     GIR_RootConstrainSelectedInstOperands,
     /* 178095 */     // GIR_Coverage, 9894,
     /* 178095 */     GIR_EraseRootFromParent_Done,
     /* 178096 */   // Label 3484: @178096
     /* 178096 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(178142), // Rule ID 138 //
     /* 178101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 178104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 178109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178119 */     // MIs[0] Rn
     /* 178119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 178123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 178127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178131 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 178131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 178134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178140 */     GIR_RootConstrainSelectedInstOperands,
     /* 178141 */     // GIR_Coverage, 138,
     /* 178141 */     GIR_EraseRootFromParent_Done,
     /* 178142 */   // Label 3485: @178142
     /* 178142 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(178189), // Rule ID 139 //
     /* 178147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 178150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 178155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178162 */     // MIs[0] Rn
     /* 178162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 178166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 178170 */     // MIs[0] Rm
     /* 178170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 178174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 178178 */     // (intrinsic_wo_chain:{ *:[i64] } 1148:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 178178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 178181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178187 */     GIR_RootConstrainSelectedInstOperands,
     /* 178188 */     // GIR_Coverage, 139,
     /* 178188 */     GIR_EraseRootFromParent_Done,
     /* 178189 */   // Label 3486: @178189
     /* 178189 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(178226), // Rule ID 2390 //
     /* 178194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 178202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178215 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 178218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178224 */     GIR_RootConstrainSelectedInstOperands,
     /* 178225 */     // GIR_Coverage, 2390,
     /* 178225 */     GIR_EraseRootFromParent_Done,
     /* 178226 */   // Label 3487: @178226
     /* 178226 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(178263), // Rule ID 2391 //
     /* 178231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 178239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 178255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178261 */     GIR_RootConstrainSelectedInstOperands,
     /* 178262 */     // GIR_Coverage, 2391,
     /* 178262 */     GIR_EraseRootFromParent_Done,
     /* 178263 */   // Label 3488: @178263
     /* 178263 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(178300), // Rule ID 2392 //
     /* 178268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 178276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178289 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2059:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 178292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178298 */     GIR_RootConstrainSelectedInstOperands,
     /* 178299 */     // GIR_Coverage, 2392,
     /* 178299 */     GIR_EraseRootFromParent_Done,
     /* 178300 */   // Label 3489: @178300
     /* 178300 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(178337), // Rule ID 2394 //
     /* 178305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 178313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178326 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2062:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 178329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178335 */     GIR_RootConstrainSelectedInstOperands,
     /* 178336 */     // GIR_Coverage, 2394,
     /* 178336 */     GIR_EraseRootFromParent_Done,
     /* 178337 */   // Label 3490: @178337
     /* 178337 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(178374), // Rule ID 2395 //
     /* 178342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 178350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178363 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 178366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178372 */     GIR_RootConstrainSelectedInstOperands,
     /* 178373 */     // GIR_Coverage, 2395,
     /* 178373 */     GIR_EraseRootFromParent_Done,
     /* 178374 */   // Label 3491: @178374
     /* 178374 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(178411), // Rule ID 2396 //
     /* 178379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 178387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 178403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178409 */     GIR_RootConstrainSelectedInstOperands,
     /* 178410 */     // GIR_Coverage, 2396,
     /* 178410 */     GIR_EraseRootFromParent_Done,
     /* 178411 */   // Label 3492: @178411
     /* 178411 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(178448), // Rule ID 2398 //
     /* 178416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 178424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178437 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1983:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 178440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178446 */     GIR_RootConstrainSelectedInstOperands,
     /* 178447 */     // GIR_Coverage, 2398,
     /* 178447 */     GIR_EraseRootFromParent_Done,
     /* 178448 */   // Label 3493: @178448
     /* 178448 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(178485), // Rule ID 2399 //
     /* 178453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 178461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1984:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 178477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178483 */     GIR_RootConstrainSelectedInstOperands,
     /* 178484 */     // GIR_Coverage, 2399,
     /* 178484 */     GIR_EraseRootFromParent_Done,
     /* 178485 */   // Label 3494: @178485
     /* 178485 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(178522), // Rule ID 2400 //
     /* 178490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 178498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178511 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 178514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178520 */     GIR_RootConstrainSelectedInstOperands,
     /* 178521 */     // GIR_Coverage, 2400,
     /* 178521 */     GIR_EraseRootFromParent_Done,
     /* 178522 */   // Label 3495: @178522
     /* 178522 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(178559), // Rule ID 2402 //
     /* 178527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 178535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 178551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178557 */     GIR_RootConstrainSelectedInstOperands,
     /* 178558 */     // GIR_Coverage, 2402,
     /* 178558 */     GIR_EraseRootFromParent_Done,
     /* 178559 */   // Label 3496: @178559
     /* 178559 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(178596), // Rule ID 2403 //
     /* 178564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 178572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178585 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 178588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178594 */     GIR_RootConstrainSelectedInstOperands,
     /* 178595 */     // GIR_Coverage, 2403,
     /* 178595 */     GIR_EraseRootFromParent_Done,
     /* 178596 */   // Label 3497: @178596
     /* 178596 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(178633), // Rule ID 2404 //
     /* 178601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 178609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 178625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178631 */     GIR_RootConstrainSelectedInstOperands,
     /* 178632 */     // GIR_Coverage, 2404,
     /* 178632 */     GIR_EraseRootFromParent_Done,
     /* 178633 */   // Label 3498: @178633
     /* 178633 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(178670), // Rule ID 2406 //
     /* 178638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 178646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178659 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 178662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178668 */     GIR_RootConstrainSelectedInstOperands,
     /* 178669 */     // GIR_Coverage, 2406,
     /* 178669 */     GIR_EraseRootFromParent_Done,
     /* 178670 */   // Label 3499: @178670
     /* 178670 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(178707), // Rule ID 2407 //
     /* 178675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 178683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 178699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178705 */     GIR_RootConstrainSelectedInstOperands,
     /* 178706 */     // GIR_Coverage, 2407,
     /* 178706 */     GIR_EraseRootFromParent_Done,
     /* 178707 */   // Label 3500: @178707
     /* 178707 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(178744), // Rule ID 2408 //
     /* 178712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 178720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178733 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1829:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 178736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178742 */     GIR_RootConstrainSelectedInstOperands,
     /* 178743 */     // GIR_Coverage, 2408,
     /* 178743 */     GIR_EraseRootFromParent_Done,
     /* 178744 */   // Label 3501: @178744
     /* 178744 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(178781), // Rule ID 2410 //
     /* 178749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 178757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1832:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 178773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178779 */     GIR_RootConstrainSelectedInstOperands,
     /* 178780 */     // GIR_Coverage, 2410,
     /* 178780 */     GIR_EraseRootFromParent_Done,
     /* 178781 */   // Label 3502: @178781
     /* 178781 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(178818), // Rule ID 2411 //
     /* 178786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 178794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 178810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178816 */     GIR_RootConstrainSelectedInstOperands,
     /* 178817 */     // GIR_Coverage, 2411,
     /* 178817 */     GIR_EraseRootFromParent_Done,
     /* 178818 */   // Label 3503: @178818
     /* 178818 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(178855), // Rule ID 2412 //
     /* 178823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 178831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1834:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 178847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178853 */     GIR_RootConstrainSelectedInstOperands,
     /* 178854 */     // GIR_Coverage, 2412,
     /* 178854 */     GIR_EraseRootFromParent_Done,
     /* 178855 */   // Label 3504: @178855
     /* 178855 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(178892), // Rule ID 2413 //
     /* 178860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 178863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 178868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 178871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 178874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 178877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178881 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1452:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 178881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 178884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 178888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 178890 */     GIR_RootConstrainSelectedInstOperands,
     /* 178891 */     // GIR_Coverage, 2413,
     /* 178891 */     GIR_EraseRootFromParent_Done,
     /* 178892 */   // Label 3505: @178892
     /* 178892 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(178932), // Rule ID 2607 //
     /* 178897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 178905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 178921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178930 */     GIR_RootConstrainSelectedInstOperands,
     /* 178931 */     // GIR_Coverage, 2607,
     /* 178931 */     GIR_EraseRootFromParent_Done,
     /* 178932 */   // Label 3506: @178932
     /* 178932 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(178972), // Rule ID 2608 //
     /* 178937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178958 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1539:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 178961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178970 */     GIR_RootConstrainSelectedInstOperands,
     /* 178971 */     // GIR_Coverage, 2608,
     /* 178971 */     GIR_EraseRootFromParent_Done,
     /* 178972 */   // Label 3507: @178972
     /* 178972 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(179012), // Rule ID 2609 //
     /* 178977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 178988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 178991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 179001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 179003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179010 */     GIR_RootConstrainSelectedInstOperands,
     /* 179011 */     // GIR_Coverage, 2609,
     /* 179011 */     GIR_EraseRootFromParent_Done,
     /* 179012 */   // Label 3508: @179012
     /* 179012 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(179052), // Rule ID 2610 //
     /* 179017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 179025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 179028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 179031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 179038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 179041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 179043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179050 */     GIR_RootConstrainSelectedInstOperands,
     /* 179051 */     // GIR_Coverage, 2610,
     /* 179051 */     GIR_EraseRootFromParent_Done,
     /* 179052 */   // Label 3509: @179052
     /* 179052 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(179092), // Rule ID 2611 //
     /* 179057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 179065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 179068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 179071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 179078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 179081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 179083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179090 */     GIR_RootConstrainSelectedInstOperands,
     /* 179091 */     // GIR_Coverage, 2611,
     /* 179091 */     GIR_EraseRootFromParent_Done,
     /* 179092 */   // Label 3510: @179092
     /* 179092 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(179129), // Rule ID 2628 //
     /* 179097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 179105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 179118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 179121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 179123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179127 */     GIR_RootConstrainSelectedInstOperands,
     /* 179128 */     // GIR_Coverage, 2628,
     /* 179128 */     GIR_EraseRootFromParent_Done,
     /* 179129 */   // Label 3511: @179129
     /* 179129 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(179166), // Rule ID 2629 //
     /* 179134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 179142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 179155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 179158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 179160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179164 */     GIR_RootConstrainSelectedInstOperands,
     /* 179165 */     // GIR_Coverage, 2629,
     /* 179165 */     GIR_EraseRootFromParent_Done,
     /* 179166 */   // Label 3512: @179166
     /* 179166 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(179203), // Rule ID 2630 //
     /* 179171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 179179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 179192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 179195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 179197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179201 */     GIR_RootConstrainSelectedInstOperands,
     /* 179202 */     // GIR_Coverage, 2630,
     /* 179202 */     GIR_EraseRootFromParent_Done,
     /* 179203 */   // Label 3513: @179203
     /* 179203 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(179240), // Rule ID 2631 //
     /* 179208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 179216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 179222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179229 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 179229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 179232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179238 */     GIR_RootConstrainSelectedInstOperands,
     /* 179239 */     // GIR_Coverage, 2631,
     /* 179239 */     GIR_EraseRootFromParent_Done,
     /* 179240 */   // Label 3514: @179240
     /* 179240 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(179277), // Rule ID 2632 //
     /* 179245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 179253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 179259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179266 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 179266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 179269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179275 */     GIR_RootConstrainSelectedInstOperands,
     /* 179276 */     // GIR_Coverage, 2632,
     /* 179276 */     GIR_EraseRootFromParent_Done,
     /* 179277 */   // Label 3515: @179277
     /* 179277 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(179314), // Rule ID 2633 //
     /* 179282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 179290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 179296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179303 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 179303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 179306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179312 */     GIR_RootConstrainSelectedInstOperands,
     /* 179313 */     // GIR_Coverage, 2633,
     /* 179313 */     GIR_EraseRootFromParent_Done,
     /* 179314 */   // Label 3516: @179314
     /* 179314 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(179351), // Rule ID 2634 //
     /* 179319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 179327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 179333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179340 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 179340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 179343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179349 */     GIR_RootConstrainSelectedInstOperands,
     /* 179350 */     // GIR_Coverage, 2634,
     /* 179350 */     GIR_EraseRootFromParent_Done,
     /* 179351 */   // Label 3517: @179351
     /* 179351 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(179388), // Rule ID 2812 //
     /* 179356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 179359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 179364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 179380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179386 */     GIR_RootConstrainSelectedInstOperands,
     /* 179387 */     // GIR_Coverage, 2812,
     /* 179387 */     GIR_EraseRootFromParent_Done,
     /* 179388 */   // Label 3518: @179388
     /* 179388 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(179425), // Rule ID 2813 //
     /* 179393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 179396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 179401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 179417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179423 */     GIR_RootConstrainSelectedInstOperands,
     /* 179424 */     // GIR_Coverage, 2813,
     /* 179424 */     GIR_EraseRootFromParent_Done,
     /* 179425 */   // Label 3519: @179425
     /* 179425 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(179462), // Rule ID 2814 //
     /* 179430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 179433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 179438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 179454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179460 */     GIR_RootConstrainSelectedInstOperands,
     /* 179461 */     // GIR_Coverage, 2814,
     /* 179461 */     GIR_EraseRootFromParent_Done,
     /* 179462 */   // Label 3520: @179462
     /* 179462 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(179499), // Rule ID 2985 //
     /* 179467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1701:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 179491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179497 */     GIR_RootConstrainSelectedInstOperands,
     /* 179498 */     // GIR_Coverage, 2985,
     /* 179498 */     GIR_EraseRootFromParent_Done,
     /* 179499 */   // Label 3521: @179499
     /* 179499 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(179536), // Rule ID 2986 //
     /* 179504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1701:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 179528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179534 */     GIR_RootConstrainSelectedInstOperands,
     /* 179535 */     // GIR_Coverage, 2986,
     /* 179535 */     GIR_EraseRootFromParent_Done,
     /* 179536 */   // Label 3522: @179536
     /* 179536 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(179573), // Rule ID 2987 //
     /* 179541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 179565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179571 */     GIR_RootConstrainSelectedInstOperands,
     /* 179572 */     // GIR_Coverage, 2987,
     /* 179572 */     GIR_EraseRootFromParent_Done,
     /* 179573 */   // Label 3523: @179573
     /* 179573 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(179610), // Rule ID 2988 //
     /* 179578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 179602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179608 */     GIR_RootConstrainSelectedInstOperands,
     /* 179609 */     // GIR_Coverage, 2988,
     /* 179609 */     GIR_EraseRootFromParent_Done,
     /* 179610 */   // Label 3524: @179610
     /* 179610 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(179647), // Rule ID 2989 //
     /* 179615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 179623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1536:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 179639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179645 */     GIR_RootConstrainSelectedInstOperands,
     /* 179646 */     // GIR_Coverage, 2989,
     /* 179646 */     GIR_EraseRootFromParent_Done,
     /* 179647 */   // Label 3525: @179647
     /* 179647 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(179684), // Rule ID 3011 //
     /* 179652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 179676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179682 */     GIR_RootConstrainSelectedInstOperands,
     /* 179683 */     // GIR_Coverage, 3011,
     /* 179683 */     GIR_EraseRootFromParent_Done,
     /* 179684 */   // Label 3526: @179684
     /* 179684 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(179721), // Rule ID 3012 //
     /* 179689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 179713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179719 */     GIR_RootConstrainSelectedInstOperands,
     /* 179720 */     // GIR_Coverage, 3012,
     /* 179720 */     GIR_EraseRootFromParent_Done,
     /* 179721 */   // Label 3527: @179721
     /* 179721 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(179758), // Rule ID 3013 //
     /* 179726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 179750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179756 */     GIR_RootConstrainSelectedInstOperands,
     /* 179757 */     // GIR_Coverage, 3013,
     /* 179757 */     GIR_EraseRootFromParent_Done,
     /* 179758 */   // Label 3528: @179758
     /* 179758 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(179795), // Rule ID 3017 //
     /* 179763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 179766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1537:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 179787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179793 */     GIR_RootConstrainSelectedInstOperands,
     /* 179794 */     // GIR_Coverage, 3017,
     /* 179794 */     GIR_EraseRootFromParent_Done,
     /* 179795 */   // Label 3529: @179795
     /* 179795 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(179832), // Rule ID 3018 //
     /* 179800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179821 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1537:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 179824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179830 */     GIR_RootConstrainSelectedInstOperands,
     /* 179831 */     // GIR_Coverage, 3018,
     /* 179831 */     GIR_EraseRootFromParent_Done,
     /* 179832 */   // Label 3530: @179832
     /* 179832 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(179869), // Rule ID 3019 //
     /* 179837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1537:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 179861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179867 */     GIR_RootConstrainSelectedInstOperands,
     /* 179868 */     // GIR_Coverage, 3019,
     /* 179868 */     GIR_EraseRootFromParent_Done,
     /* 179869 */   // Label 3531: @179869
     /* 179869 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(179906), // Rule ID 3020 //
     /* 179874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179895 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1179:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 179898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179904 */     GIR_RootConstrainSelectedInstOperands,
     /* 179905 */     // GIR_Coverage, 3020,
     /* 179905 */     GIR_EraseRootFromParent_Done,
     /* 179906 */   // Label 3532: @179906
     /* 179906 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(179943), // Rule ID 3021 //
     /* 179911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1179:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 179935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179941 */     GIR_RootConstrainSelectedInstOperands,
     /* 179942 */     // GIR_Coverage, 3021,
     /* 179942 */     GIR_EraseRootFromParent_Done,
     /* 179943 */   // Label 3533: @179943
     /* 179943 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(179980), // Rule ID 3022 //
     /* 179948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1179:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 179972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179978 */     GIR_RootConstrainSelectedInstOperands,
     /* 179979 */     // GIR_Coverage, 3022,
     /* 179979 */     GIR_EraseRootFromParent_Done,
     /* 179980 */   // Label 3534: @179980
     /* 179980 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(180017), // Rule ID 3023 //
     /* 179985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1179:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 180009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180015 */     GIR_RootConstrainSelectedInstOperands,
     /* 180016 */     // GIR_Coverage, 3023,
     /* 180016 */     GIR_EraseRootFromParent_Done,
     /* 180017 */   // Label 3535: @180017
     /* 180017 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(180054), // Rule ID 3024 //
     /* 180022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 180030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 180046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180052 */     GIR_RootConstrainSelectedInstOperands,
     /* 180053 */     // GIR_Coverage, 3024,
     /* 180053 */     GIR_EraseRootFromParent_Done,
     /* 180054 */   // Label 3536: @180054
     /* 180054 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(180091), // Rule ID 3025 //
     /* 180059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 180067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 180083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180089 */     GIR_RootConstrainSelectedInstOperands,
     /* 180090 */     // GIR_Coverage, 3025,
     /* 180090 */     GIR_EraseRootFromParent_Done,
     /* 180091 */   // Label 3537: @180091
     /* 180091 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(180128), // Rule ID 3026 //
     /* 180096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 180104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 180120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180126 */     GIR_RootConstrainSelectedInstOperands,
     /* 180127 */     // GIR_Coverage, 3026,
     /* 180127 */     GIR_EraseRootFromParent_Done,
     /* 180128 */   // Label 3538: @180128
     /* 180128 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(180165), // Rule ID 3073 //
     /* 180133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 180141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1156:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 180157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180163 */     GIR_RootConstrainSelectedInstOperands,
     /* 180164 */     // GIR_Coverage, 3073,
     /* 180164 */     GIR_EraseRootFromParent_Done,
     /* 180165 */   // Label 3539: @180165
     /* 180165 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(180202), // Rule ID 3074 //
     /* 180170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 180178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1156:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 180194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180200 */     GIR_RootConstrainSelectedInstOperands,
     /* 180201 */     // GIR_Coverage, 3074,
     /* 180201 */     GIR_EraseRootFromParent_Done,
     /* 180202 */   // Label 3540: @180202
     /* 180202 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(180239), // Rule ID 3075 //
     /* 180207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 180215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1156:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 180231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180237 */     GIR_RootConstrainSelectedInstOperands,
     /* 180238 */     // GIR_Coverage, 3075,
     /* 180238 */     GIR_EraseRootFromParent_Done,
     /* 180239 */   // Label 3541: @180239
     /* 180239 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(180276), // Rule ID 3082 //
     /* 180244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 180252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1758:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 180268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180274 */     GIR_RootConstrainSelectedInstOperands,
     /* 180275 */     // GIR_Coverage, 3082,
     /* 180275 */     GIR_EraseRootFromParent_Done,
     /* 180276 */   // Label 3542: @180276
     /* 180276 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(180313), // Rule ID 3083 //
     /* 180281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 180289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1758:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 180305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180311 */     GIR_RootConstrainSelectedInstOperands,
     /* 180312 */     // GIR_Coverage, 3083,
     /* 180312 */     GIR_EraseRootFromParent_Done,
     /* 180313 */   // Label 3543: @180313
     /* 180313 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(180350), // Rule ID 3084 //
     /* 180318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 180321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 180326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 180342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180348 */     GIR_RootConstrainSelectedInstOperands,
     /* 180349 */     // GIR_Coverage, 3084,
     /* 180349 */     GIR_EraseRootFromParent_Done,
     /* 180350 */   // Label 3544: @180350
     /* 180350 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(180390), // Rule ID 3182 //
     /* 180355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 180379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180388 */     GIR_RootConstrainSelectedInstOperands,
     /* 180389 */     // GIR_Coverage, 3182,
     /* 180389 */     GIR_EraseRootFromParent_Done,
     /* 180390 */   // Label 3545: @180390
     /* 180390 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(180430), // Rule ID 3183 //
     /* 180395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 180419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180428 */     GIR_RootConstrainSelectedInstOperands,
     /* 180429 */     // GIR_Coverage, 3183,
     /* 180429 */     GIR_EraseRootFromParent_Done,
     /* 180430 */   // Label 3546: @180430
     /* 180430 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(180470), // Rule ID 3184 //
     /* 180435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 180459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180468 */     GIR_RootConstrainSelectedInstOperands,
     /* 180469 */     // GIR_Coverage, 3184,
     /* 180469 */     GIR_EraseRootFromParent_Done,
     /* 180470 */   // Label 3547: @180470
     /* 180470 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(180510), // Rule ID 3185 //
     /* 180475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 180499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180508 */     GIR_RootConstrainSelectedInstOperands,
     /* 180509 */     // GIR_Coverage, 3185,
     /* 180509 */     GIR_EraseRootFromParent_Done,
     /* 180510 */   // Label 3548: @180510
     /* 180510 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(180550), // Rule ID 3190 //
     /* 180515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 180539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180548 */     GIR_RootConstrainSelectedInstOperands,
     /* 180549 */     // GIR_Coverage, 3190,
     /* 180549 */     GIR_EraseRootFromParent_Done,
     /* 180550 */   // Label 3549: @180550
     /* 180550 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(180590), // Rule ID 3191 //
     /* 180555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 180579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180588 */     GIR_RootConstrainSelectedInstOperands,
     /* 180589 */     // GIR_Coverage, 3191,
     /* 180589 */     GIR_EraseRootFromParent_Done,
     /* 180590 */   // Label 3550: @180590
     /* 180590 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(180630), // Rule ID 3192 //
     /* 180595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 180619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180628 */     GIR_RootConstrainSelectedInstOperands,
     /* 180629 */     // GIR_Coverage, 3192,
     /* 180629 */     GIR_EraseRootFromParent_Done,
     /* 180630 */   // Label 3551: @180630
     /* 180630 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(180670), // Rule ID 3193 //
     /* 180635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 180659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180668 */     GIR_RootConstrainSelectedInstOperands,
     /* 180669 */     // GIR_Coverage, 3193,
     /* 180669 */     GIR_EraseRootFromParent_Done,
     /* 180670 */   // Label 3552: @180670
     /* 180670 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(180707), // Rule ID 3382 //
     /* 180675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180705 */     GIR_RootConstrainSelectedInstOperands,
     /* 180706 */     // GIR_Coverage, 3382,
     /* 180706 */     GIR_EraseRootFromParent_Done,
     /* 180707 */   // Label 3553: @180707
     /* 180707 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(180744), // Rule ID 3383 //
     /* 180712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180742 */     GIR_RootConstrainSelectedInstOperands,
     /* 180743 */     // GIR_Coverage, 3383,
     /* 180743 */     GIR_EraseRootFromParent_Done,
     /* 180744 */   // Label 3554: @180744
     /* 180744 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(180781), // Rule ID 3384 //
     /* 180749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180779 */     GIR_RootConstrainSelectedInstOperands,
     /* 180780 */     // GIR_Coverage, 3384,
     /* 180780 */     GIR_EraseRootFromParent_Done,
     /* 180781 */   // Label 3555: @180781
     /* 180781 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(180818), // Rule ID 3385 //
     /* 180786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180816 */     GIR_RootConstrainSelectedInstOperands,
     /* 180817 */     // GIR_Coverage, 3385,
     /* 180817 */     GIR_EraseRootFromParent_Done,
     /* 180818 */   // Label 3556: @180818
     /* 180818 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(180855), // Rule ID 3407 //
     /* 180823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 180847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180853 */     GIR_RootConstrainSelectedInstOperands,
     /* 180854 */     // GIR_Coverage, 3407,
     /* 180854 */     GIR_EraseRootFromParent_Done,
     /* 180855 */   // Label 3557: @180855
     /* 180855 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(180892), // Rule ID 3408 //
     /* 180860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180881 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 180884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180890 */     GIR_RootConstrainSelectedInstOperands,
     /* 180891 */     // GIR_Coverage, 3408,
     /* 180891 */     GIR_EraseRootFromParent_Done,
     /* 180892 */   // Label 3558: @180892
     /* 180892 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(180929), // Rule ID 3409 //
     /* 180897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180918 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 180921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180927 */     GIR_RootConstrainSelectedInstOperands,
     /* 180928 */     // GIR_Coverage, 3409,
     /* 180928 */     GIR_EraseRootFromParent_Done,
     /* 180929 */   // Label 3559: @180929
     /* 180929 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(180966), // Rule ID 3431 //
     /* 180934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 180942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1200:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 180955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180964 */     GIR_RootConstrainSelectedInstOperands,
     /* 180965 */     // GIR_Coverage, 3431,
     /* 180965 */     GIR_EraseRootFromParent_Done,
     /* 180966 */   // Label 3560: @180966
     /* 180966 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(181003), // Rule ID 3436 //
     /* 180971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 180974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 180979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 180995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181001 */     GIR_RootConstrainSelectedInstOperands,
     /* 181002 */     // GIR_Coverage, 3436,
     /* 181002 */     GIR_EraseRootFromParent_Done,
     /* 181003 */   // Label 3561: @181003
     /* 181003 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(181040), // Rule ID 3437 //
     /* 181008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 181011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 181016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1165:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 181032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 181034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181038 */     GIR_RootConstrainSelectedInstOperands,
     /* 181039 */     // GIR_Coverage, 3437,
     /* 181039 */     GIR_EraseRootFromParent_Done,
     /* 181040 */   // Label 3562: @181040
     /* 181040 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(181077), // Rule ID 3446 //
     /* 181045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181075 */     GIR_RootConstrainSelectedInstOperands,
     /* 181076 */     // GIR_Coverage, 3446,
     /* 181076 */     GIR_EraseRootFromParent_Done,
     /* 181077 */   // Label 3563: @181077
     /* 181077 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(181114), // Rule ID 3447 //
     /* 181082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181112 */     GIR_RootConstrainSelectedInstOperands,
     /* 181113 */     // GIR_Coverage, 3447,
     /* 181113 */     GIR_EraseRootFromParent_Done,
     /* 181114 */   // Label 3564: @181114
     /* 181114 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(181151), // Rule ID 3448 //
     /* 181119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181140 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2060:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 181140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181149 */     GIR_RootConstrainSelectedInstOperands,
     /* 181150 */     // GIR_Coverage, 3448,
     /* 181150 */     GIR_EraseRootFromParent_Done,
     /* 181151 */   // Label 3565: @181151
     /* 181151 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(181188), // Rule ID 3449 //
     /* 181156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181186 */     GIR_RootConstrainSelectedInstOperands,
     /* 181187 */     // GIR_Coverage, 3449,
     /* 181187 */     GIR_EraseRootFromParent_Done,
     /* 181188 */   // Label 3566: @181188
     /* 181188 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(181225), // Rule ID 3450 //
     /* 181193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181214 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2060:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 181214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181223 */     GIR_RootConstrainSelectedInstOperands,
     /* 181224 */     // GIR_Coverage, 3450,
     /* 181224 */     GIR_EraseRootFromParent_Done,
     /* 181225 */   // Label 3567: @181225
     /* 181225 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(181262), // Rule ID 3451 //
     /* 181230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181260 */     GIR_RootConstrainSelectedInstOperands,
     /* 181261 */     // GIR_Coverage, 3451,
     /* 181261 */     GIR_EraseRootFromParent_Done,
     /* 181262 */   // Label 3568: @181262
     /* 181262 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(181299), // Rule ID 3452 //
     /* 181267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 181270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 181275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181288 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2060:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 181288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 181291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181297 */     GIR_RootConstrainSelectedInstOperands,
     /* 181298 */     // GIR_Coverage, 3452,
     /* 181298 */     GIR_EraseRootFromParent_Done,
     /* 181299 */   // Label 3569: @181299
     /* 181299 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(181336), // Rule ID 3507 //
     /* 181304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 181312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181325 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1273:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 181325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 181328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181334 */     GIR_RootConstrainSelectedInstOperands,
     /* 181335 */     // GIR_Coverage, 3507,
     /* 181335 */     GIR_EraseRootFromParent_Done,
     /* 181336 */   // Label 3570: @181336
     /* 181336 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(181373), // Rule ID 3508 //
     /* 181341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 181349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181362 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1273:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 181362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 181365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181371 */     GIR_RootConstrainSelectedInstOperands,
     /* 181372 */     // GIR_Coverage, 3508,
     /* 181372 */     GIR_EraseRootFromParent_Done,
     /* 181373 */   // Label 3571: @181373
     /* 181373 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(181410), // Rule ID 3509 //
     /* 181378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 181386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181399 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1273:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 181399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 181402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181408 */     GIR_RootConstrainSelectedInstOperands,
     /* 181409 */     // GIR_Coverage, 3509,
     /* 181409 */     GIR_EraseRootFromParent_Done,
     /* 181410 */   // Label 3572: @181410
     /* 181410 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(181447), // Rule ID 3539 //
     /* 181415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1524:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 181439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181445 */     GIR_RootConstrainSelectedInstOperands,
     /* 181446 */     // GIR_Coverage, 3539,
     /* 181446 */     GIR_EraseRootFromParent_Done,
     /* 181447 */   // Label 3573: @181447
     /* 181447 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(181484), // Rule ID 3540 //
     /* 181452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181473 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1524:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 181476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181482 */     GIR_RootConstrainSelectedInstOperands,
     /* 181483 */     // GIR_Coverage, 3540,
     /* 181483 */     GIR_EraseRootFromParent_Done,
     /* 181484 */   // Label 3574: @181484
     /* 181484 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(181521), // Rule ID 3541 //
     /* 181489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1524:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 181513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181519 */     GIR_RootConstrainSelectedInstOperands,
     /* 181520 */     // GIR_Coverage, 3541,
     /* 181520 */     GIR_EraseRootFromParent_Done,
     /* 181521 */   // Label 3575: @181521
     /* 181521 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(181558), // Rule ID 3542 //
     /* 181526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181547 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1524:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 181550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181556 */     GIR_RootConstrainSelectedInstOperands,
     /* 181557 */     // GIR_Coverage, 3542,
     /* 181557 */     GIR_EraseRootFromParent_Done,
     /* 181558 */   // Label 3576: @181558
     /* 181558 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(181595), // Rule ID 3543 //
     /* 181563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 181587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181593 */     GIR_RootConstrainSelectedInstOperands,
     /* 181594 */     // GIR_Coverage, 3543,
     /* 181594 */     GIR_EraseRootFromParent_Done,
     /* 181595 */   // Label 3577: @181595
     /* 181595 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(181632), // Rule ID 3544 //
     /* 181600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181630 */     GIR_RootConstrainSelectedInstOperands,
     /* 181631 */     // GIR_Coverage, 3544,
     /* 181631 */     GIR_EraseRootFromParent_Done,
     /* 181632 */   // Label 3578: @181632
     /* 181632 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(181669), // Rule ID 3545 //
     /* 181637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181667 */     GIR_RootConstrainSelectedInstOperands,
     /* 181668 */     // GIR_Coverage, 3545,
     /* 181668 */     GIR_EraseRootFromParent_Done,
     /* 181669 */   // Label 3579: @181669
     /* 181669 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(181706), // Rule ID 3546 //
     /* 181674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181704 */     GIR_RootConstrainSelectedInstOperands,
     /* 181705 */     // GIR_Coverage, 3546,
     /* 181705 */     GIR_EraseRootFromParent_Done,
     /* 181706 */   // Label 3580: @181706
     /* 181706 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(181743), // Rule ID 3547 //
     /* 181711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2068:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 181732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181741 */     GIR_RootConstrainSelectedInstOperands,
     /* 181742 */     // GIR_Coverage, 3547,
     /* 181742 */     GIR_EraseRootFromParent_Done,
     /* 181743 */   // Label 3581: @181743
     /* 181743 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(181780), // Rule ID 3548 //
     /* 181748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181769 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2068:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181778 */     GIR_RootConstrainSelectedInstOperands,
     /* 181779 */     // GIR_Coverage, 3548,
     /* 181779 */     GIR_EraseRootFromParent_Done,
     /* 181780 */   // Label 3582: @181780
     /* 181780 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(181817), // Rule ID 3549 //
     /* 181785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2068:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 181806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181815 */     GIR_RootConstrainSelectedInstOperands,
     /* 181816 */     // GIR_Coverage, 3549,
     /* 181816 */     GIR_EraseRootFromParent_Done,
     /* 181817 */   // Label 3583: @181817
     /* 181817 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(181854), // Rule ID 3550 //
     /* 181822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181843 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 181846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181852 */     GIR_RootConstrainSelectedInstOperands,
     /* 181853 */     // GIR_Coverage, 3550,
     /* 181853 */     GIR_EraseRootFromParent_Done,
     /* 181854 */   // Label 3584: @181854
     /* 181854 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(181891), // Rule ID 3551 //
     /* 181859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181889 */     GIR_RootConstrainSelectedInstOperands,
     /* 181890 */     // GIR_Coverage, 3551,
     /* 181890 */     GIR_EraseRootFromParent_Done,
     /* 181891 */   // Label 3585: @181891
     /* 181891 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(181928), // Rule ID 3552 //
     /* 181896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 181920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181926 */     GIR_RootConstrainSelectedInstOperands,
     /* 181927 */     // GIR_Coverage, 3552,
     /* 181927 */     GIR_EraseRootFromParent_Done,
     /* 181928 */   // Label 3586: @181928
     /* 181928 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(181965), // Rule ID 3553 //
     /* 181933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 181957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181963 */     GIR_RootConstrainSelectedInstOperands,
     /* 181964 */     // GIR_Coverage, 3553,
     /* 181964 */     GIR_EraseRootFromParent_Done,
     /* 181965 */   // Label 3587: @181965
     /* 181965 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(182002), // Rule ID 3554 //
     /* 181970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181991 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1823:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182000 */     GIR_RootConstrainSelectedInstOperands,
     /* 182001 */     // GIR_Coverage, 3554,
     /* 182001 */     GIR_EraseRootFromParent_Done,
     /* 182002 */   // Label 3588: @182002
     /* 182002 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(182039), // Rule ID 3555 //
     /* 182007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 182010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 182015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1823:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 182031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182037 */     GIR_RootConstrainSelectedInstOperands,
     /* 182038 */     // GIR_Coverage, 3555,
     /* 182038 */     GIR_EraseRootFromParent_Done,
     /* 182039 */   // Label 3589: @182039
     /* 182039 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(182076), // Rule ID 3556 //
     /* 182044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 182047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 182052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182065 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1823:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 182068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182074 */     GIR_RootConstrainSelectedInstOperands,
     /* 182075 */     // GIR_Coverage, 3556,
     /* 182075 */     GIR_EraseRootFromParent_Done,
     /* 182076 */   // Label 3590: @182076
     /* 182076 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(182113), // Rule ID 8254 //
     /* 182081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 182089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 182095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1202:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 182102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 182105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182111 */     GIR_RootConstrainSelectedInstOperands,
     /* 182112 */     // GIR_Coverage, 8254,
     /* 182112 */     GIR_EraseRootFromParent_Done,
     /* 182113 */   // Label 3591: @182113
     /* 182113 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(182150), // Rule ID 8730 //
     /* 182118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 182126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1160:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 182142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182148 */     GIR_RootConstrainSelectedInstOperands,
     /* 182149 */     // GIR_Coverage, 8730,
     /* 182149 */     GIR_EraseRootFromParent_Done,
     /* 182150 */   // Label 3592: @182150
     /* 182150 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(182187), // Rule ID 8731 //
     /* 182155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 182163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 182179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182185 */     GIR_RootConstrainSelectedInstOperands,
     /* 182186 */     // GIR_Coverage, 8731,
     /* 182186 */     GIR_EraseRootFromParent_Done,
     /* 182187 */   // Label 3593: @182187
     /* 182187 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(182224), // Rule ID 8732 //
     /* 182192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 182200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 182216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182222 */     GIR_RootConstrainSelectedInstOperands,
     /* 182223 */     // GIR_Coverage, 8732,
     /* 182223 */     GIR_EraseRootFromParent_Done,
     /* 182224 */   // Label 3594: @182224
     /* 182224 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(182261), // Rule ID 8733 //
     /* 182229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 182237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 182246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 182250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 182253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182259 */     GIR_RootConstrainSelectedInstOperands,
     /* 182260 */     // GIR_Coverage, 8733,
     /* 182260 */     GIR_EraseRootFromParent_Done,
     /* 182261 */   // Label 3595: @182261
     /* 182261 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(182298), // Rule ID 8734 //
     /* 182266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 182274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1160:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 182290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182296 */     GIR_RootConstrainSelectedInstOperands,
     /* 182297 */     // GIR_Coverage, 8734,
     /* 182297 */     GIR_EraseRootFromParent_Done,
     /* 182298 */   // Label 3596: @182298
     /* 182298 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(182335), // Rule ID 8735 //
     /* 182303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 182311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 182327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182333 */     GIR_RootConstrainSelectedInstOperands,
     /* 182334 */     // GIR_Coverage, 8735,
     /* 182334 */     GIR_EraseRootFromParent_Done,
     /* 182335 */   // Label 3597: @182335
     /* 182335 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(182372), // Rule ID 8736 //
     /* 182340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 182348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 182364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182370 */     GIR_RootConstrainSelectedInstOperands,
     /* 182371 */     // GIR_Coverage, 8736,
     /* 182371 */     GIR_EraseRootFromParent_Done,
     /* 182372 */   // Label 3598: @182372
     /* 182372 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(182409), // Rule ID 8737 //
     /* 182377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 182380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 182385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 182388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 182391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 182394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 182398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 182401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182407 */     GIR_RootConstrainSelectedInstOperands,
     /* 182408 */     // GIR_Coverage, 8737,
     /* 182408 */     GIR_EraseRootFromParent_Done,
     /* 182409 */   // Label 3599: @182409
     /* 182409 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(182449), // Rule ID 9737 //
     /* 182414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182447 */     GIR_RootConstrainSelectedInstOperands,
     /* 182448 */     // GIR_Coverage, 9737,
     /* 182448 */     GIR_EraseRootFromParent_Done,
     /* 182449 */   // Label 3600: @182449
     /* 182449 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(182489), // Rule ID 9738 //
     /* 182454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 182478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182487 */     GIR_RootConstrainSelectedInstOperands,
     /* 182488 */     // GIR_Coverage, 9738,
     /* 182488 */     GIR_EraseRootFromParent_Done,
     /* 182489 */   // Label 3601: @182489
     /* 182489 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(182529), // Rule ID 9739 //
     /* 182494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182515 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 182518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182527 */     GIR_RootConstrainSelectedInstOperands,
     /* 182528 */     // GIR_Coverage, 9739,
     /* 182528 */     GIR_EraseRootFromParent_Done,
     /* 182529 */   // Label 3602: @182529
     /* 182529 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(182569), // Rule ID 9740 //
     /* 182534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 182558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182567 */     GIR_RootConstrainSelectedInstOperands,
     /* 182568 */     // GIR_Coverage, 9740,
     /* 182568 */     GIR_EraseRootFromParent_Done,
     /* 182569 */   // Label 3603: @182569
     /* 182569 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(182609), // Rule ID 9741 //
     /* 182574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182595 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 182598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182607 */     GIR_RootConstrainSelectedInstOperands,
     /* 182608 */     // GIR_Coverage, 9741,
     /* 182608 */     GIR_EraseRootFromParent_Done,
     /* 182609 */   // Label 3604: @182609
     /* 182609 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(182649), // Rule ID 9742 //
     /* 182614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182635 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 182638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182647 */     GIR_RootConstrainSelectedInstOperands,
     /* 182648 */     // GIR_Coverage, 9742,
     /* 182648 */     GIR_EraseRootFromParent_Done,
     /* 182649 */   // Label 3605: @182649
     /* 182649 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(182689), // Rule ID 9743 //
     /* 182654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182675 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 182678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182687 */     GIR_RootConstrainSelectedInstOperands,
     /* 182688 */     // GIR_Coverage, 9743,
     /* 182688 */     GIR_EraseRootFromParent_Done,
     /* 182689 */   // Label 3606: @182689
     /* 182689 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(182729), // Rule ID 9744 //
     /* 182694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 182718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182727 */     GIR_RootConstrainSelectedInstOperands,
     /* 182728 */     // GIR_Coverage, 9744,
     /* 182728 */     GIR_EraseRootFromParent_Done,
     /* 182729 */   // Label 3607: @182729
     /* 182729 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(182769), // Rule ID 9749 //
     /* 182734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 182758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182767 */     GIR_RootConstrainSelectedInstOperands,
     /* 182768 */     // GIR_Coverage, 9749,
     /* 182768 */     GIR_EraseRootFromParent_Done,
     /* 182769 */   // Label 3608: @182769
     /* 182769 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(182809), // Rule ID 9750 //
     /* 182774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182795 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 182798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182807 */     GIR_RootConstrainSelectedInstOperands,
     /* 182808 */     // GIR_Coverage, 9750,
     /* 182808 */     GIR_EraseRootFromParent_Done,
     /* 182809 */   // Label 3609: @182809
     /* 182809 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(182849), // Rule ID 9751 //
     /* 182814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 182838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182847 */     GIR_RootConstrainSelectedInstOperands,
     /* 182848 */     // GIR_Coverage, 9751,
     /* 182848 */     GIR_EraseRootFromParent_Done,
     /* 182849 */   // Label 3610: @182849
     /* 182849 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(182889), // Rule ID 9752 //
     /* 182854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 182878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182887 */     GIR_RootConstrainSelectedInstOperands,
     /* 182888 */     // GIR_Coverage, 9752,
     /* 182888 */     GIR_EraseRootFromParent_Done,
     /* 182889 */   // Label 3611: @182889
     /* 182889 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(182929), // Rule ID 9753 //
     /* 182894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 182918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182927 */     GIR_RootConstrainSelectedInstOperands,
     /* 182928 */     // GIR_Coverage, 9753,
     /* 182928 */     GIR_EraseRootFromParent_Done,
     /* 182929 */   // Label 3612: @182929
     /* 182929 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(182969), // Rule ID 9754 //
     /* 182934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182955 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 182958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182967 */     GIR_RootConstrainSelectedInstOperands,
     /* 182968 */     // GIR_Coverage, 9754,
     /* 182968 */     GIR_EraseRootFromParent_Done,
     /* 182969 */   // Label 3613: @182969
     /* 182969 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(183009), // Rule ID 9755 //
     /* 182974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182995 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 182998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183007 */     GIR_RootConstrainSelectedInstOperands,
     /* 183008 */     // GIR_Coverage, 9755,
     /* 183008 */     GIR_EraseRootFromParent_Done,
     /* 183009 */   // Label 3614: @183009
     /* 183009 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(183049), // Rule ID 9756 //
     /* 183014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 183022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 183025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183047 */     GIR_RootConstrainSelectedInstOperands,
     /* 183048 */     // GIR_Coverage, 9756,
     /* 183048 */     GIR_EraseRootFromParent_Done,
     /* 183049 */   // Label 3615: @183049
     /* 183049 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(183089), // Rule ID 9757 //
     /* 183054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 183062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183075 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 183078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183087 */     GIR_RootConstrainSelectedInstOperands,
     /* 183088 */     // GIR_Coverage, 9757,
     /* 183088 */     GIR_EraseRootFromParent_Done,
     /* 183089 */   // Label 3616: @183089
     /* 183089 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(183129), // Rule ID 9758 //
     /* 183094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 183102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 183105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183115 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 183118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183127 */     GIR_RootConstrainSelectedInstOperands,
     /* 183128 */     // GIR_Coverage, 9758,
     /* 183128 */     GIR_EraseRootFromParent_Done,
     /* 183129 */   // Label 3617: @183129
     /* 183129 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(183169), // Rule ID 9759 //
     /* 183134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 183142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 183145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183155 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 183158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183167 */     GIR_RootConstrainSelectedInstOperands,
     /* 183168 */     // GIR_Coverage, 9759,
     /* 183168 */     GIR_EraseRootFromParent_Done,
     /* 183169 */   // Label 3618: @183169
     /* 183169 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(183209), // Rule ID 9760 //
     /* 183174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 183182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 183185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183195 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 183198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183207 */     GIR_RootConstrainSelectedInstOperands,
     /* 183208 */     // GIR_Coverage, 9760,
     /* 183208 */     GIR_EraseRootFromParent_Done,
     /* 183209 */   // Label 3619: @183209
     /* 183209 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(183249), // Rule ID 9765 //
     /* 183214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 183222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 183238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183247 */     GIR_RootConstrainSelectedInstOperands,
     /* 183248 */     // GIR_Coverage, 9765,
     /* 183248 */     GIR_EraseRootFromParent_Done,
     /* 183249 */   // Label 3620: @183249
     /* 183249 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(183289), // Rule ID 9766 //
     /* 183254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 183262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 183265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 183278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183287 */     GIR_RootConstrainSelectedInstOperands,
     /* 183288 */     // GIR_Coverage, 9766,
     /* 183288 */     GIR_EraseRootFromParent_Done,
     /* 183289 */   // Label 3621: @183289
     /* 183289 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(183329), // Rule ID 9767 //
     /* 183294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 183302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 183305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 183318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183327 */     GIR_RootConstrainSelectedInstOperands,
     /* 183328 */     // GIR_Coverage, 9767,
     /* 183328 */     GIR_EraseRootFromParent_Done,
     /* 183329 */   // Label 3622: @183329
     /* 183329 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(183369), // Rule ID 9768 //
     /* 183334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 183342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 183345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183355 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 183355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 183358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183367 */     GIR_RootConstrainSelectedInstOperands,
     /* 183368 */     // GIR_Coverage, 9768,
     /* 183368 */     GIR_EraseRootFromParent_Done,
     /* 183369 */   // Label 3623: @183369
     /* 183369 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(183406), // Rule ID 9927 //
     /* 183374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 183382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 183398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183404 */     GIR_RootConstrainSelectedInstOperands,
     /* 183405 */     // GIR_Coverage, 9927,
     /* 183405 */     GIR_EraseRootFromParent_Done,
     /* 183406 */   // Label 3624: @183406
     /* 183406 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(183443), // Rule ID 9928 //
     /* 183411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 183419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183441 */     GIR_RootConstrainSelectedInstOperands,
     /* 183442 */     // GIR_Coverage, 9928,
     /* 183442 */     GIR_EraseRootFromParent_Done,
     /* 183443 */   // Label 3625: @183443
     /* 183443 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(183480), // Rule ID 9929 //
     /* 183448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 183456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 183472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183478 */     GIR_RootConstrainSelectedInstOperands,
     /* 183479 */     // GIR_Coverage, 9929,
     /* 183479 */     GIR_EraseRootFromParent_Done,
     /* 183480 */   // Label 3626: @183480
     /* 183480 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(183517), // Rule ID 9930 //
     /* 183485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 183509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183515 */     GIR_RootConstrainSelectedInstOperands,
     /* 183516 */     // GIR_Coverage, 9930,
     /* 183516 */     GIR_EraseRootFromParent_Done,
     /* 183517 */   // Label 3627: @183517
     /* 183517 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(183554), // Rule ID 9931 //
     /* 183522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 183546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183552 */     GIR_RootConstrainSelectedInstOperands,
     /* 183553 */     // GIR_Coverage, 9931,
     /* 183553 */     GIR_EraseRootFromParent_Done,
     /* 183554 */   // Label 3628: @183554
     /* 183554 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(183591), // Rule ID 9932 //
     /* 183559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 183583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183589 */     GIR_RootConstrainSelectedInstOperands,
     /* 183590 */     // GIR_Coverage, 9932,
     /* 183590 */     GIR_EraseRootFromParent_Done,
     /* 183591 */   // Label 3629: @183591
     /* 183591 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(183628), // Rule ID 9933 //
     /* 183596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 183620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183626 */     GIR_RootConstrainSelectedInstOperands,
     /* 183627 */     // GIR_Coverage, 9933,
     /* 183627 */     GIR_EraseRootFromParent_Done,
     /* 183628 */   // Label 3630: @183628
     /* 183628 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(183665), // Rule ID 9934 //
     /* 183633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 183657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183663 */     GIR_RootConstrainSelectedInstOperands,
     /* 183664 */     // GIR_Coverage, 9934,
     /* 183664 */     GIR_EraseRootFromParent_Done,
     /* 183665 */   // Label 3631: @183665
     /* 183665 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(183702), // Rule ID 9935 //
     /* 183670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 183694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183700 */     GIR_RootConstrainSelectedInstOperands,
     /* 183701 */     // GIR_Coverage, 9935,
     /* 183701 */     GIR_EraseRootFromParent_Done,
     /* 183702 */   // Label 3632: @183702
     /* 183702 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(183739), // Rule ID 11103 //
     /* 183707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183737 */     GIR_RootConstrainSelectedInstOperands,
     /* 183738 */     // GIR_Coverage, 11103,
     /* 183738 */     GIR_EraseRootFromParent_Done,
     /* 183739 */   // Label 3633: @183739
     /* 183739 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(183776), // Rule ID 11104 //
     /* 183744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183774 */     GIR_RootConstrainSelectedInstOperands,
     /* 183775 */     // GIR_Coverage, 11104,
     /* 183775 */     GIR_EraseRootFromParent_Done,
     /* 183776 */   // Label 3634: @183776
     /* 183776 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(183813), // Rule ID 11105 //
     /* 183781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2065:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183811 */     GIR_RootConstrainSelectedInstOperands,
     /* 183812 */     // GIR_Coverage, 11105,
     /* 183812 */     GIR_EraseRootFromParent_Done,
     /* 183813 */   // Label 3635: @183813
     /* 183813 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(183850), // Rule ID 11106 //
     /* 183818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183848 */     GIR_RootConstrainSelectedInstOperands,
     /* 183849 */     // GIR_Coverage, 11106,
     /* 183849 */     GIR_EraseRootFromParent_Done,
     /* 183850 */   // Label 3636: @183850
     /* 183850 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(183887), // Rule ID 11107 //
     /* 183855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2065:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183885 */     GIR_RootConstrainSelectedInstOperands,
     /* 183886 */     // GIR_Coverage, 11107,
     /* 183886 */     GIR_EraseRootFromParent_Done,
     /* 183887 */   // Label 3637: @183887
     /* 183887 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(183924), // Rule ID 11108 //
     /* 183892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183922 */     GIR_RootConstrainSelectedInstOperands,
     /* 183923 */     // GIR_Coverage, 11108,
     /* 183923 */     GIR_EraseRootFromParent_Done,
     /* 183924 */   // Label 3638: @183924
     /* 183924 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(183961), // Rule ID 11109 //
     /* 183929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183950 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2065:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183959 */     GIR_RootConstrainSelectedInstOperands,
     /* 183960 */     // GIR_Coverage, 11109,
     /* 183960 */     GIR_EraseRootFromParent_Done,
     /* 183961 */   // Label 3639: @183961
     /* 183961 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(183998), // Rule ID 11110 //
     /* 183966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1986:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183996 */     GIR_RootConstrainSelectedInstOperands,
     /* 183997 */     // GIR_Coverage, 11110,
     /* 183997 */     GIR_EraseRootFromParent_Done,
     /* 183998 */   // Label 3640: @183998
     /* 183998 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(184035), // Rule ID 11111 //
     /* 184003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184033 */     GIR_RootConstrainSelectedInstOperands,
     /* 184034 */     // GIR_Coverage, 11111,
     /* 184034 */     GIR_EraseRootFromParent_Done,
     /* 184035 */   // Label 3641: @184035
     /* 184035 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(184072), // Rule ID 11112 //
     /* 184040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184061 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1986:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184070 */     GIR_RootConstrainSelectedInstOperands,
     /* 184071 */     // GIR_Coverage, 11112,
     /* 184071 */     GIR_EraseRootFromParent_Done,
     /* 184072 */   // Label 3642: @184072
     /* 184072 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(184109), // Rule ID 11113 //
     /* 184077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184107 */     GIR_RootConstrainSelectedInstOperands,
     /* 184108 */     // GIR_Coverage, 11113,
     /* 184108 */     GIR_EraseRootFromParent_Done,
     /* 184109 */   // Label 3643: @184109
     /* 184109 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(184146), // Rule ID 11114 //
     /* 184114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184135 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1986:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184144 */     GIR_RootConstrainSelectedInstOperands,
     /* 184145 */     // GIR_Coverage, 11114,
     /* 184145 */     GIR_EraseRootFromParent_Done,
     /* 184146 */   // Label 3644: @184146
     /* 184146 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(184183), // Rule ID 11115 //
     /* 184151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184181 */     GIR_RootConstrainSelectedInstOperands,
     /* 184182 */     // GIR_Coverage, 11115,
     /* 184182 */     GIR_EraseRootFromParent_Done,
     /* 184183 */   // Label 3645: @184183
     /* 184183 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(184220), // Rule ID 11116 //
     /* 184188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 184196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184209 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1986:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 184212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184218 */     GIR_RootConstrainSelectedInstOperands,
     /* 184219 */     // GIR_Coverage, 11116,
     /* 184219 */     GIR_EraseRootFromParent_Done,
     /* 184220 */   // Label 3646: @184220
     /* 184220 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(184257), // Rule ID 11117 //
     /* 184225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1991:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184255 */     GIR_RootConstrainSelectedInstOperands,
     /* 184256 */     // GIR_Coverage, 11117,
     /* 184256 */     GIR_EraseRootFromParent_Done,
     /* 184257 */   // Label 3647: @184257
     /* 184257 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(184294), // Rule ID 11118 //
     /* 184262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184292 */     GIR_RootConstrainSelectedInstOperands,
     /* 184293 */     // GIR_Coverage, 11118,
     /* 184293 */     GIR_EraseRootFromParent_Done,
     /* 184294 */   // Label 3648: @184294
     /* 184294 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(184331), // Rule ID 11119 //
     /* 184299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1991:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184329 */     GIR_RootConstrainSelectedInstOperands,
     /* 184330 */     // GIR_Coverage, 11119,
     /* 184330 */     GIR_EraseRootFromParent_Done,
     /* 184331 */   // Label 3649: @184331
     /* 184331 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(184368), // Rule ID 11120 //
     /* 184336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184366 */     GIR_RootConstrainSelectedInstOperands,
     /* 184367 */     // GIR_Coverage, 11120,
     /* 184367 */     GIR_EraseRootFromParent_Done,
     /* 184368 */   // Label 3650: @184368
     /* 184368 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(184405), // Rule ID 11121 //
     /* 184373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1991:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184403 */     GIR_RootConstrainSelectedInstOperands,
     /* 184404 */     // GIR_Coverage, 11121,
     /* 184404 */     GIR_EraseRootFromParent_Done,
     /* 184405 */   // Label 3651: @184405
     /* 184405 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(184442), // Rule ID 11122 //
     /* 184410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184440 */     GIR_RootConstrainSelectedInstOperands,
     /* 184441 */     // GIR_Coverage, 11122,
     /* 184441 */     GIR_EraseRootFromParent_Done,
     /* 184442 */   // Label 3652: @184442
     /* 184442 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(184479), // Rule ID 11123 //
     /* 184447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184468 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1991:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184477 */     GIR_RootConstrainSelectedInstOperands,
     /* 184478 */     // GIR_Coverage, 11123,
     /* 184478 */     GIR_EraseRootFromParent_Done,
     /* 184479 */   // Label 3653: @184479
     /* 184479 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(184516), // Rule ID 11124 //
     /* 184484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184505 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 11124,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 3654: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(184553), // Rule ID 11125 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184551 */     GIR_RootConstrainSelectedInstOperands,
     /* 184552 */     // GIR_Coverage, 11125,
     /* 184552 */     GIR_EraseRootFromParent_Done,
     /* 184553 */   // Label 3655: @184553
     /* 184553 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(184590), // Rule ID 11126 //
     /* 184558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1830:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184588 */     GIR_RootConstrainSelectedInstOperands,
     /* 184589 */     // GIR_Coverage, 11126,
     /* 184589 */     GIR_EraseRootFromParent_Done,
     /* 184590 */   // Label 3656: @184590
     /* 184590 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(184627), // Rule ID 11127 //
     /* 184595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184625 */     GIR_RootConstrainSelectedInstOperands,
     /* 184626 */     // GIR_Coverage, 11127,
     /* 184626 */     GIR_EraseRootFromParent_Done,
     /* 184627 */   // Label 3657: @184627
     /* 184627 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(184664), // Rule ID 11128 //
     /* 184632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184653 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1830:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184662 */     GIR_RootConstrainSelectedInstOperands,
     /* 184663 */     // GIR_Coverage, 11128,
     /* 184663 */     GIR_EraseRootFromParent_Done,
     /* 184664 */   // Label 3658: @184664
     /* 184664 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(184701), // Rule ID 11129 //
     /* 184669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184699 */     GIR_RootConstrainSelectedInstOperands,
     /* 184700 */     // GIR_Coverage, 11129,
     /* 184700 */     GIR_EraseRootFromParent_Done,
     /* 184701 */   // Label 3659: @184701
     /* 184701 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(184738), // Rule ID 11130 //
     /* 184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184727 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1830:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184736 */     GIR_RootConstrainSelectedInstOperands,
     /* 184737 */     // GIR_Coverage, 11130,
     /* 184737 */     GIR_EraseRootFromParent_Done,
     /* 184738 */   // Label 3660: @184738
     /* 184738 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(184775), // Rule ID 11131 //
     /* 184743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184773 */     GIR_RootConstrainSelectedInstOperands,
     /* 184774 */     // GIR_Coverage, 11131,
     /* 184774 */     GIR_EraseRootFromParent_Done,
     /* 184775 */   // Label 3661: @184775
     /* 184775 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(184812), // Rule ID 11132 //
     /* 184780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184810 */     GIR_RootConstrainSelectedInstOperands,
     /* 184811 */     // GIR_Coverage, 11132,
     /* 184811 */     GIR_EraseRootFromParent_Done,
     /* 184812 */   // Label 3662: @184812
     /* 184812 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(184849), // Rule ID 11133 //
     /* 184817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184838 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1835:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184847 */     GIR_RootConstrainSelectedInstOperands,
     /* 184848 */     // GIR_Coverage, 11133,
     /* 184848 */     GIR_EraseRootFromParent_Done,
     /* 184849 */   // Label 3663: @184849
     /* 184849 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(184886), // Rule ID 11134 //
     /* 184854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184884 */     GIR_RootConstrainSelectedInstOperands,
     /* 184885 */     // GIR_Coverage, 11134,
     /* 184885 */     GIR_EraseRootFromParent_Done,
     /* 184886 */   // Label 3664: @184886
     /* 184886 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(184923), // Rule ID 11135 //
     /* 184891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1835:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184921 */     GIR_RootConstrainSelectedInstOperands,
     /* 184922 */     // GIR_Coverage, 11135,
     /* 184922 */     GIR_EraseRootFromParent_Done,
     /* 184923 */   // Label 3665: @184923
     /* 184923 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(184960), // Rule ID 11136 //
     /* 184928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184958 */     GIR_RootConstrainSelectedInstOperands,
     /* 184959 */     // GIR_Coverage, 11136,
     /* 184959 */     GIR_EraseRootFromParent_Done,
     /* 184960 */   // Label 3666: @184960
     /* 184960 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(184997), // Rule ID 11137 //
     /* 184965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1835:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184995 */     GIR_RootConstrainSelectedInstOperands,
     /* 184996 */     // GIR_Coverage, 11137,
     /* 184996 */     GIR_EraseRootFromParent_Done,
     /* 184997 */   // Label 3667: @184997
     /* 184997 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(185034), // Rule ID 11157 //
     /* 185002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 185010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185023 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 185026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185032 */     GIR_RootConstrainSelectedInstOperands,
     /* 185033 */     // GIR_Coverage, 11157,
     /* 185033 */     GIR_EraseRootFromParent_Done,
     /* 185034 */   // Label 3668: @185034
     /* 185034 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(185071), // Rule ID 11158 //
     /* 185039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 185047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 185063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185069 */     GIR_RootConstrainSelectedInstOperands,
     /* 185070 */     // GIR_Coverage, 11158,
     /* 185070 */     GIR_EraseRootFromParent_Done,
     /* 185071 */   // Label 3669: @185071
     /* 185071 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(185108), // Rule ID 11159 //
     /* 185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 185084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185097 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 185100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185106 */     GIR_RootConstrainSelectedInstOperands,
     /* 185107 */     // GIR_Coverage, 11159,
     /* 185107 */     GIR_EraseRootFromParent_Done,
     /* 185108 */   // Label 3670: @185108
     /* 185108 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(185145), // Rule ID 11160 //
     /* 185113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 185121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 185137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185143 */     GIR_RootConstrainSelectedInstOperands,
     /* 185144 */     // GIR_Coverage, 11160,
     /* 185144 */     GIR_EraseRootFromParent_Done,
     /* 185145 */   // Label 3671: @185145
     /* 185145 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(185182), // Rule ID 11448 //
     /* 185150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 185158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 185174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185180 */     GIR_RootConstrainSelectedInstOperands,
     /* 185181 */     // GIR_Coverage, 11448,
     /* 185181 */     GIR_EraseRootFromParent_Done,
     /* 185182 */   // Label 3672: @185182
     /* 185182 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(185219), // Rule ID 11449 //
     /* 185187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 185195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 185211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185217 */     GIR_RootConstrainSelectedInstOperands,
     /* 185218 */     // GIR_Coverage, 11449,
     /* 185218 */     GIR_EraseRootFromParent_Done,
     /* 185219 */   // Label 3673: @185219
     /* 185219 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(185256), // Rule ID 11450 //
     /* 185224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 185232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185245 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1596:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 185248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185254 */     GIR_RootConstrainSelectedInstOperands,
     /* 185255 */     // GIR_Coverage, 11450,
     /* 185255 */     GIR_EraseRootFromParent_Done,
     /* 185256 */   // Label 3674: @185256
     /* 185256 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(185293), // Rule ID 11451 //
     /* 185261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 185269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 185285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185291 */     GIR_RootConstrainSelectedInstOperands,
     /* 185292 */     // GIR_Coverage, 11451,
     /* 185292 */     GIR_EraseRootFromParent_Done,
     /* 185293 */   // Label 3675: @185293
     /* 185293 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(185330), // Rule ID 11452 //
     /* 185298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 185306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 185322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185328 */     GIR_RootConstrainSelectedInstOperands,
     /* 185329 */     // GIR_Coverage, 11452,
     /* 185329 */     GIR_EraseRootFromParent_Done,
     /* 185330 */   // Label 3676: @185330
     /* 185330 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(185367), // Rule ID 11453 //
     /* 185335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 185343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 185359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185365 */     GIR_RootConstrainSelectedInstOperands,
     /* 185366 */     // GIR_Coverage, 11453,
     /* 185366 */     GIR_EraseRootFromParent_Done,
     /* 185367 */   // Label 3677: @185367
     /* 185367 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(185404), // Rule ID 11454 //
     /* 185372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 185380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 185396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185402 */     GIR_RootConstrainSelectedInstOperands,
     /* 185403 */     // GIR_Coverage, 11454,
     /* 185403 */     GIR_EraseRootFromParent_Done,
     /* 185404 */   // Label 3678: @185404
     /* 185404 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(185441), // Rule ID 11455 //
     /* 185409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 185417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 185433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185439 */     GIR_RootConstrainSelectedInstOperands,
     /* 185440 */     // GIR_Coverage, 11455,
     /* 185440 */     GIR_EraseRootFromParent_Done,
     /* 185441 */   // Label 3679: @185441
     /* 185441 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(185478), // Rule ID 11456 //
     /* 185446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 185454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 185470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 185477 */     // GIR_Coverage, 11456,
     /* 185477 */     GIR_EraseRootFromParent_Done,
     /* 185478 */   // Label 3680: @185478
     /* 185478 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(185515), // Rule ID 11457 //
     /* 185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 185507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185513 */     GIR_RootConstrainSelectedInstOperands,
     /* 185514 */     // GIR_Coverage, 11457,
     /* 185514 */     GIR_EraseRootFromParent_Done,
     /* 185515 */   // Label 3681: @185515
     /* 185515 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(185552), // Rule ID 11458 //
     /* 185520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 185544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185550 */     GIR_RootConstrainSelectedInstOperands,
     /* 185551 */     // GIR_Coverage, 11458,
     /* 185551 */     GIR_EraseRootFromParent_Done,
     /* 185552 */   // Label 3682: @185552
     /* 185552 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(185589), // Rule ID 11459 //
     /* 185557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 185581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185587 */     GIR_RootConstrainSelectedInstOperands,
     /* 185588 */     // GIR_Coverage, 11459,
     /* 185588 */     GIR_EraseRootFromParent_Done,
     /* 185589 */   // Label 3683: @185589
     /* 185589 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(185626), // Rule ID 11460 //
     /* 185594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1775:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 185618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185624 */     GIR_RootConstrainSelectedInstOperands,
     /* 185625 */     // GIR_Coverage, 11460,
     /* 185625 */     GIR_EraseRootFromParent_Done,
     /* 185626 */   // Label 3684: @185626
     /* 185626 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(185663), // Rule ID 11461 //
     /* 185631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 185655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185661 */     GIR_RootConstrainSelectedInstOperands,
     /* 185662 */     // GIR_Coverage, 11461,
     /* 185662 */     GIR_EraseRootFromParent_Done,
     /* 185663 */   // Label 3685: @185663
     /* 185663 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(185700), // Rule ID 11462 //
     /* 185668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 185692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185698 */     GIR_RootConstrainSelectedInstOperands,
     /* 185699 */     // GIR_Coverage, 11462,
     /* 185699 */     GIR_EraseRootFromParent_Done,
     /* 185700 */   // Label 3686: @185700
     /* 185700 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(185737), // Rule ID 11463 //
     /* 185705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 185729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185735 */     GIR_RootConstrainSelectedInstOperands,
     /* 185736 */     // GIR_Coverage, 11463,
     /* 185736 */     GIR_EraseRootFromParent_Done,
     /* 185737 */   // Label 3687: @185737
     /* 185737 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(185774), // Rule ID 11464 //
     /* 185742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185763 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 185766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185772 */     GIR_RootConstrainSelectedInstOperands,
     /* 185773 */     // GIR_Coverage, 11464,
     /* 185773 */     GIR_EraseRootFromParent_Done,
     /* 185774 */   // Label 3688: @185774
     /* 185774 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(185811), // Rule ID 11465 //
     /* 185779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 185803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185809 */     GIR_RootConstrainSelectedInstOperands,
     /* 185810 */     // GIR_Coverage, 11465,
     /* 185810 */     GIR_EraseRootFromParent_Done,
     /* 185811 */   // Label 3689: @185811
     /* 185811 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(185848), // Rule ID 11466 //
     /* 185816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 185840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185846 */     GIR_RootConstrainSelectedInstOperands,
     /* 185847 */     // GIR_Coverage, 11466,
     /* 185847 */     GIR_EraseRootFromParent_Done,
     /* 185848 */   // Label 3690: @185848
     /* 185848 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(185885), // Rule ID 11467 //
     /* 185853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 185877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185883 */     GIR_RootConstrainSelectedInstOperands,
     /* 185884 */     // GIR_Coverage, 11467,
     /* 185884 */     GIR_EraseRootFromParent_Done,
     /* 185885 */   // Label 3691: @185885
     /* 185885 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(185922), // Rule ID 11468 //
     /* 185890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 185914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185920 */     GIR_RootConstrainSelectedInstOperands,
     /* 185921 */     // GIR_Coverage, 11468,
     /* 185921 */     GIR_EraseRootFromParent_Done,
     /* 185922 */   // Label 3692: @185922
     /* 185922 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(185959), // Rule ID 11469 //
     /* 185927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 185951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185957 */     GIR_RootConstrainSelectedInstOperands,
     /* 185958 */     // GIR_Coverage, 11469,
     /* 185958 */     GIR_EraseRootFromParent_Done,
     /* 185959 */   // Label 3693: @185959
     /* 185959 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(185996), // Rule ID 11470 //
     /* 185964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 185988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185994 */     GIR_RootConstrainSelectedInstOperands,
     /* 185995 */     // GIR_Coverage, 11470,
     /* 185995 */     GIR_EraseRootFromParent_Done,
     /* 185996 */   // Label 3694: @185996
     /* 185996 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(186033), // Rule ID 11471 //
     /* 186001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 186009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 186025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186031 */     GIR_RootConstrainSelectedInstOperands,
     /* 186032 */     // GIR_Coverage, 11471,
     /* 186032 */     GIR_EraseRootFromParent_Done,
     /* 186033 */   // Label 3695: @186033
     /* 186033 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(186070), // Rule ID 11472 //
     /* 186038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 186046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 186062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186068 */     GIR_RootConstrainSelectedInstOperands,
     /* 186069 */     // GIR_Coverage, 11472,
     /* 186069 */     GIR_EraseRootFromParent_Done,
     /* 186070 */   // Label 3696: @186070
     /* 186070 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(186107), // Rule ID 11473 //
     /* 186075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 186083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 186099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186105 */     GIR_RootConstrainSelectedInstOperands,
     /* 186106 */     // GIR_Coverage, 11473,
     /* 186106 */     GIR_EraseRootFromParent_Done,
     /* 186107 */   // Label 3697: @186107
     /* 186107 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(186144), // Rule ID 11474 //
     /* 186112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 186120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 186136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186142 */     GIR_RootConstrainSelectedInstOperands,
     /* 186143 */     // GIR_Coverage, 11474,
     /* 186143 */     GIR_EraseRootFromParent_Done,
     /* 186144 */   // Label 3698: @186144
     /* 186144 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(186181), // Rule ID 11475 //
     /* 186149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 186157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 186173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186179 */     GIR_RootConstrainSelectedInstOperands,
     /* 186180 */     // GIR_Coverage, 11475,
     /* 186180 */     GIR_EraseRootFromParent_Done,
     /* 186181 */   // Label 3699: @186181
     /* 186181 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(186218), // Rule ID 11476 //
     /* 186186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 186194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 186210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186216 */     GIR_RootConstrainSelectedInstOperands,
     /* 186217 */     // GIR_Coverage, 11476,
     /* 186217 */     GIR_EraseRootFromParent_Done,
     /* 186218 */   // Label 3700: @186218
     /* 186218 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(186255), // Rule ID 11477 //
     /* 186223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 186231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 186247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186253 */     GIR_RootConstrainSelectedInstOperands,
     /* 186254 */     // GIR_Coverage, 11477,
     /* 186254 */     GIR_EraseRootFromParent_Done,
     /* 186255 */   // Label 3701: @186255
     /* 186255 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(186292), // Rule ID 11478 //
     /* 186260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 186268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 186284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186290 */     GIR_RootConstrainSelectedInstOperands,
     /* 186291 */     // GIR_Coverage, 11478,
     /* 186291 */     GIR_EraseRootFromParent_Done,
     /* 186292 */   // Label 3702: @186292
     /* 186292 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(186329), // Rule ID 11479 //
     /* 186297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 186305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 186321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186327 */     GIR_RootConstrainSelectedInstOperands,
     /* 186328 */     // GIR_Coverage, 11479,
     /* 186328 */     GIR_EraseRootFromParent_Done,
     /* 186329 */   // Label 3703: @186329
     /* 186329 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(186366), // Rule ID 11480 //
     /* 186334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 186342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 186358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186364 */     GIR_RootConstrainSelectedInstOperands,
     /* 186365 */     // GIR_Coverage, 11480,
     /* 186365 */     GIR_EraseRootFromParent_Done,
     /* 186366 */   // Label 3704: @186366
     /* 186366 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(186403), // Rule ID 11490 //
     /* 186371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 186379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 186395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186401 */     GIR_RootConstrainSelectedInstOperands,
     /* 186402 */     // GIR_Coverage, 11490,
     /* 186402 */     GIR_EraseRootFromParent_Done,
     /* 186403 */   // Label 3705: @186403
     /* 186403 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(186440), // Rule ID 11491 //
     /* 186408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 186416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 186432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186438 */     GIR_RootConstrainSelectedInstOperands,
     /* 186439 */     // GIR_Coverage, 11491,
     /* 186439 */     GIR_EraseRootFromParent_Done,
     /* 186440 */   // Label 3706: @186440
     /* 186440 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(186477), // Rule ID 11492 //
     /* 186445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 186453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 186469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186475 */     GIR_RootConstrainSelectedInstOperands,
     /* 186476 */     // GIR_Coverage, 11492,
     /* 186476 */     GIR_EraseRootFromParent_Done,
     /* 186477 */   // Label 3707: @186477
     /* 186477 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(186514), // Rule ID 11493 //
     /* 186482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 186506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186512 */     GIR_RootConstrainSelectedInstOperands,
     /* 186513 */     // GIR_Coverage, 11493,
     /* 186513 */     GIR_EraseRootFromParent_Done,
     /* 186514 */   // Label 3708: @186514
     /* 186514 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(186551), // Rule ID 11494 //
     /* 186519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 186543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186549 */     GIR_RootConstrainSelectedInstOperands,
     /* 186550 */     // GIR_Coverage, 11494,
     /* 186550 */     GIR_EraseRootFromParent_Done,
     /* 186551 */   // Label 3709: @186551
     /* 186551 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(186588), // Rule ID 11495 //
     /* 186556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 186580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186586 */     GIR_RootConstrainSelectedInstOperands,
     /* 186587 */     // GIR_Coverage, 11495,
     /* 186587 */     GIR_EraseRootFromParent_Done,
     /* 186588 */   // Label 3710: @186588
     /* 186588 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(186625), // Rule ID 11496 //
     /* 186593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 186617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186623 */     GIR_RootConstrainSelectedInstOperands,
     /* 186624 */     // GIR_Coverage, 11496,
     /* 186624 */     GIR_EraseRootFromParent_Done,
     /* 186625 */   // Label 3711: @186625
     /* 186625 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(186662), // Rule ID 11497 //
     /* 186630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 186654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186660 */     GIR_RootConstrainSelectedInstOperands,
     /* 186661 */     // GIR_Coverage, 11497,
     /* 186661 */     GIR_EraseRootFromParent_Done,
     /* 186662 */   // Label 3712: @186662
     /* 186662 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(186699), // Rule ID 11498 //
     /* 186667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 186691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186697 */     GIR_RootConstrainSelectedInstOperands,
     /* 186698 */     // GIR_Coverage, 11498,
     /* 186698 */     GIR_EraseRootFromParent_Done,
     /* 186699 */   // Label 3713: @186699
     /* 186699 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(186736), // Rule ID 11499 //
     /* 186704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 186728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186734 */     GIR_RootConstrainSelectedInstOperands,
     /* 186735 */     // GIR_Coverage, 11499,
     /* 186735 */     GIR_EraseRootFromParent_Done,
     /* 186736 */   // Label 3714: @186736
     /* 186736 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(186773), // Rule ID 11500 //
     /* 186741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 186765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186771 */     GIR_RootConstrainSelectedInstOperands,
     /* 186772 */     // GIR_Coverage, 11500,
     /* 186772 */     GIR_EraseRootFromParent_Done,
     /* 186773 */   // Label 3715: @186773
     /* 186773 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(186810), // Rule ID 11501 //
     /* 186778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 186802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186808 */     GIR_RootConstrainSelectedInstOperands,
     /* 186809 */     // GIR_Coverage, 11501,
     /* 186809 */     GIR_EraseRootFromParent_Done,
     /* 186810 */   // Label 3716: @186810
     /* 186810 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(186847), // Rule ID 11502 //
     /* 186815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 186839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186845 */     GIR_RootConstrainSelectedInstOperands,
     /* 186846 */     // GIR_Coverage, 11502,
     /* 186846 */     GIR_EraseRootFromParent_Done,
     /* 186847 */   // Label 3717: @186847
     /* 186847 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(186884), // Rule ID 11503 //
     /* 186852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 186876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186882 */     GIR_RootConstrainSelectedInstOperands,
     /* 186883 */     // GIR_Coverage, 11503,
     /* 186883 */     GIR_EraseRootFromParent_Done,
     /* 186884 */   // Label 3718: @186884
     /* 186884 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(186921), // Rule ID 11504 //
     /* 186889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 186913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186919 */     GIR_RootConstrainSelectedInstOperands,
     /* 186920 */     // GIR_Coverage, 11504,
     /* 186920 */     GIR_EraseRootFromParent_Done,
     /* 186921 */   // Label 3719: @186921
     /* 186921 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(186958), // Rule ID 11505 //
     /* 186926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1709:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 186950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186956 */     GIR_RootConstrainSelectedInstOperands,
     /* 186957 */     // GIR_Coverage, 11505,
     /* 186957 */     GIR_EraseRootFromParent_Done,
     /* 186958 */   // Label 3720: @186958
     /* 186958 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(186995), // Rule ID 11506 //
     /* 186963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 186987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186993 */     GIR_RootConstrainSelectedInstOperands,
     /* 186994 */     // GIR_Coverage, 11506,
     /* 186994 */     GIR_EraseRootFromParent_Done,
     /* 186995 */   // Label 3721: @186995
     /* 186995 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(187032), // Rule ID 11507 //
     /* 187000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 187008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 187024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187030 */     GIR_RootConstrainSelectedInstOperands,
     /* 187031 */     // GIR_Coverage, 11507,
     /* 187031 */     GIR_EraseRootFromParent_Done,
     /* 187032 */   // Label 3722: @187032
     /* 187032 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(187069), // Rule ID 11508 //
     /* 187037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 187045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187058 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1660:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 187061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187067 */     GIR_RootConstrainSelectedInstOperands,
     /* 187068 */     // GIR_Coverage, 11508,
     /* 187068 */     GIR_EraseRootFromParent_Done,
     /* 187069 */   // Label 3723: @187069
     /* 187069 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(187106), // Rule ID 11509 //
     /* 187074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 187082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1660:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 187098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187104 */     GIR_RootConstrainSelectedInstOperands,
     /* 187105 */     // GIR_Coverage, 11509,
     /* 187105 */     GIR_EraseRootFromParent_Done,
     /* 187106 */   // Label 3724: @187106
     /* 187106 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(187143), // Rule ID 11510 //
     /* 187111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 187119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1660:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 187135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187141 */     GIR_RootConstrainSelectedInstOperands,
     /* 187142 */     // GIR_Coverage, 11510,
     /* 187142 */     GIR_EraseRootFromParent_Done,
     /* 187143 */   // Label 3725: @187143
     /* 187143 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(187180), // Rule ID 11511 //
     /* 187148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 187156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 187172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187178 */     GIR_RootConstrainSelectedInstOperands,
     /* 187179 */     // GIR_Coverage, 11511,
     /* 187179 */     GIR_EraseRootFromParent_Done,
     /* 187180 */   // Label 3726: @187180
     /* 187180 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(187217), // Rule ID 11512 //
     /* 187185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 187193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 187209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187215 */     GIR_RootConstrainSelectedInstOperands,
     /* 187216 */     // GIR_Coverage, 11512,
     /* 187216 */     GIR_EraseRootFromParent_Done,
     /* 187217 */   // Label 3727: @187217
     /* 187217 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(187254), // Rule ID 11513 //
     /* 187222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 187230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 187246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187252 */     GIR_RootConstrainSelectedInstOperands,
     /* 187253 */     // GIR_Coverage, 11513,
     /* 187253 */     GIR_EraseRootFromParent_Done,
     /* 187254 */   // Label 3728: @187254
     /* 187254 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(187291), // Rule ID 11514 //
     /* 187259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 187267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1898:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 187283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187289 */     GIR_RootConstrainSelectedInstOperands,
     /* 187290 */     // GIR_Coverage, 11514,
     /* 187290 */     GIR_EraseRootFromParent_Done,
     /* 187291 */   // Label 3729: @187291
     /* 187291 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(187328), // Rule ID 11515 //
     /* 187296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 187304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1898:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 187320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187326 */     GIR_RootConstrainSelectedInstOperands,
     /* 187327 */     // GIR_Coverage, 11515,
     /* 187327 */     GIR_EraseRootFromParent_Done,
     /* 187328 */   // Label 3730: @187328
     /* 187328 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(187365), // Rule ID 11516 //
     /* 187333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 187341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1898:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 187357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187363 */     GIR_RootConstrainSelectedInstOperands,
     /* 187364 */     // GIR_Coverage, 11516,
     /* 187364 */     GIR_EraseRootFromParent_Done,
     /* 187365 */   // Label 3731: @187365
     /* 187365 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(187402), // Rule ID 11517 //
     /* 187370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 187378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1900:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 187394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187400 */     GIR_RootConstrainSelectedInstOperands,
     /* 187401 */     // GIR_Coverage, 11517,
     /* 187401 */     GIR_EraseRootFromParent_Done,
     /* 187402 */   // Label 3732: @187402
     /* 187402 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(187439), // Rule ID 11518 //
     /* 187407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 187415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1900:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 187431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187437 */     GIR_RootConstrainSelectedInstOperands,
     /* 187438 */     // GIR_Coverage, 11518,
     /* 187438 */     GIR_EraseRootFromParent_Done,
     /* 187439 */   // Label 3733: @187439
     /* 187439 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(187476), // Rule ID 11519 //
     /* 187444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 187452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1900:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 187468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187474 */     GIR_RootConstrainSelectedInstOperands,
     /* 187475 */     // GIR_Coverage, 11519,
     /* 187475 */     GIR_EraseRootFromParent_Done,
     /* 187476 */   // Label 3734: @187476
     /* 187476 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(187513), // Rule ID 11520 //
     /* 187481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187511 */     GIR_RootConstrainSelectedInstOperands,
     /* 187512 */     // GIR_Coverage, 11520,
     /* 187512 */     GIR_EraseRootFromParent_Done,
     /* 187513 */   // Label 3735: @187513
     /* 187513 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(187550), // Rule ID 11521 //
     /* 187518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1538:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 187542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187548 */     GIR_RootConstrainSelectedInstOperands,
     /* 187549 */     // GIR_Coverage, 11521,
     /* 187549 */     GIR_EraseRootFromParent_Done,
     /* 187550 */   // Label 3736: @187550
     /* 187550 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(187587), // Rule ID 11622 //
     /* 187555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 187579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187585 */     GIR_RootConstrainSelectedInstOperands,
     /* 187586 */     // GIR_Coverage, 11622,
     /* 187586 */     GIR_EraseRootFromParent_Done,
     /* 187587 */   // Label 3737: @187587
     /* 187587 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(187624), // Rule ID 11623 //
     /* 187592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 187616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187622 */     GIR_RootConstrainSelectedInstOperands,
     /* 187623 */     // GIR_Coverage, 11623,
     /* 187623 */     GIR_EraseRootFromParent_Done,
     /* 187624 */   // Label 3738: @187624
     /* 187624 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(187661), // Rule ID 11624 //
     /* 187629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 187653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187659 */     GIR_RootConstrainSelectedInstOperands,
     /* 187660 */     // GIR_Coverage, 11624,
     /* 187660 */     GIR_EraseRootFromParent_Done,
     /* 187661 */   // Label 3739: @187661
     /* 187661 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(187698), // Rule ID 11625 //
     /* 187666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187687 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 11625,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 3740: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(187735), // Rule ID 11626 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 187727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187733 */     GIR_RootConstrainSelectedInstOperands,
     /* 187734 */     // GIR_Coverage, 11626,
     /* 187734 */     GIR_EraseRootFromParent_Done,
     /* 187735 */   // Label 3741: @187735
     /* 187735 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(187772), // Rule ID 11627 //
     /* 187740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 187764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187770 */     GIR_RootConstrainSelectedInstOperands,
     /* 187771 */     // GIR_Coverage, 11627,
     /* 187771 */     GIR_EraseRootFromParent_Done,
     /* 187772 */   // Label 3742: @187772
     /* 187772 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(187809), // Rule ID 11628 //
     /* 187777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187798 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1584:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 187801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187807 */     GIR_RootConstrainSelectedInstOperands,
     /* 187808 */     // GIR_Coverage, 11628,
     /* 187808 */     GIR_EraseRootFromParent_Done,
     /* 187809 */   // Label 3743: @187809
     /* 187809 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(187846), // Rule ID 11629 //
     /* 187814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1584:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 187838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187844 */     GIR_RootConstrainSelectedInstOperands,
     /* 187845 */     // GIR_Coverage, 11629,
     /* 187845 */     GIR_EraseRootFromParent_Done,
     /* 187846 */   // Label 3744: @187846
     /* 187846 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(187883), // Rule ID 11630 //
     /* 187851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1584:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 187875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187881 */     GIR_RootConstrainSelectedInstOperands,
     /* 187882 */     // GIR_Coverage, 11630,
     /* 187882 */     GIR_EraseRootFromParent_Done,
     /* 187883 */   // Label 3745: @187883
     /* 187883 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(187920), // Rule ID 11646 //
     /* 187888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187909 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1951:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 187912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187918 */     GIR_RootConstrainSelectedInstOperands,
     /* 187919 */     // GIR_Coverage, 11646,
     /* 187919 */     GIR_EraseRootFromParent_Done,
     /* 187920 */   // Label 3746: @187920
     /* 187920 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(187957), // Rule ID 11647 //
     /* 187925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1951:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 187949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187955 */     GIR_RootConstrainSelectedInstOperands,
     /* 187956 */     // GIR_Coverage, 11647,
     /* 187956 */     GIR_EraseRootFromParent_Done,
     /* 187957 */   // Label 3747: @187957
     /* 187957 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(187994), // Rule ID 11648 //
     /* 187962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1951:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 187986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187992 */     GIR_RootConstrainSelectedInstOperands,
     /* 187993 */     // GIR_Coverage, 11648,
     /* 187993 */     GIR_EraseRootFromParent_Done,
     /* 187994 */   // Label 3748: @187994
     /* 187994 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(188031), // Rule ID 11649 //
     /* 187999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 188007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188020 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 188023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188029 */     GIR_RootConstrainSelectedInstOperands,
     /* 188030 */     // GIR_Coverage, 11649,
     /* 188030 */     GIR_EraseRootFromParent_Done,
     /* 188031 */   // Label 3749: @188031
     /* 188031 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(188068), // Rule ID 11650 //
     /* 188036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 188044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 188060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188066 */     GIR_RootConstrainSelectedInstOperands,
     /* 188067 */     // GIR_Coverage, 11650,
     /* 188067 */     GIR_EraseRootFromParent_Done,
     /* 188068 */   // Label 3750: @188068
     /* 188068 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(188105), // Rule ID 11651 //
     /* 188073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 188081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188103 */     GIR_RootConstrainSelectedInstOperands,
     /* 188104 */     // GIR_Coverage, 11651,
     /* 188104 */     GIR_EraseRootFromParent_Done,
     /* 188105 */   // Label 3751: @188105
     /* 188105 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(188142), // Rule ID 11667 //
     /* 188110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 188118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 188134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188140 */     GIR_RootConstrainSelectedInstOperands,
     /* 188141 */     // GIR_Coverage, 11667,
     /* 188141 */     GIR_EraseRootFromParent_Done,
     /* 188142 */   // Label 3752: @188142
     /* 188142 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(188179), // Rule ID 11668 //
     /* 188147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 188155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 188171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188177 */     GIR_RootConstrainSelectedInstOperands,
     /* 188178 */     // GIR_Coverage, 11668,
     /* 188178 */     GIR_EraseRootFromParent_Done,
     /* 188179 */   // Label 3753: @188179
     /* 188179 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(188216), // Rule ID 11669 //
     /* 188184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 188192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 188208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188214 */     GIR_RootConstrainSelectedInstOperands,
     /* 188215 */     // GIR_Coverage, 11669,
     /* 188215 */     GIR_EraseRootFromParent_Done,
     /* 188216 */   // Label 3754: @188216
     /* 188216 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(188253), // Rule ID 11670 //
     /* 188221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 188229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 188245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188251 */     GIR_RootConstrainSelectedInstOperands,
     /* 188252 */     // GIR_Coverage, 11670,
     /* 188252 */     GIR_EraseRootFromParent_Done,
     /* 188253 */   // Label 3755: @188253
     /* 188253 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(188290), // Rule ID 11671 //
     /* 188258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 188266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 188282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188288 */     GIR_RootConstrainSelectedInstOperands,
     /* 188289 */     // GIR_Coverage, 11671,
     /* 188289 */     GIR_EraseRootFromParent_Done,
     /* 188290 */   // Label 3756: @188290
     /* 188290 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(188327), // Rule ID 11672 //
     /* 188295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 188303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 188319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188325 */     GIR_RootConstrainSelectedInstOperands,
     /* 188326 */     // GIR_Coverage, 11672,
     /* 188326 */     GIR_EraseRootFromParent_Done,
     /* 188327 */   // Label 3757: @188327
     /* 188327 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(188367), // Rule ID 11747 //
     /* 188332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 188356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188365 */     GIR_RootConstrainSelectedInstOperands,
     /* 188366 */     // GIR_Coverage, 11747,
     /* 188366 */     GIR_EraseRootFromParent_Done,
     /* 188367 */   // Label 3758: @188367
     /* 188367 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(188407), // Rule ID 11748 //
     /* 188372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 188396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188405 */     GIR_RootConstrainSelectedInstOperands,
     /* 188406 */     // GIR_Coverage, 11748,
     /* 188406 */     GIR_EraseRootFromParent_Done,
     /* 188407 */   // Label 3759: @188407
     /* 188407 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(188447), // Rule ID 11749 //
     /* 188412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 188436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188445 */     GIR_RootConstrainSelectedInstOperands,
     /* 188446 */     // GIR_Coverage, 11749,
     /* 188446 */     GIR_EraseRootFromParent_Done,
     /* 188447 */   // Label 3760: @188447
     /* 188447 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(188487), // Rule ID 11750 //
     /* 188452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188473 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 188476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188485 */     GIR_RootConstrainSelectedInstOperands,
     /* 188486 */     // GIR_Coverage, 11750,
     /* 188486 */     GIR_EraseRootFromParent_Done,
     /* 188487 */   // Label 3761: @188487
     /* 188487 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(188527), // Rule ID 11751 //
     /* 188492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 188516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188525 */     GIR_RootConstrainSelectedInstOperands,
     /* 188526 */     // GIR_Coverage, 11751,
     /* 188526 */     GIR_EraseRootFromParent_Done,
     /* 188527 */   // Label 3762: @188527
     /* 188527 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(188567), // Rule ID 11752 //
     /* 188532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 188556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188565 */     GIR_RootConstrainSelectedInstOperands,
     /* 188566 */     // GIR_Coverage, 11752,
     /* 188566 */     GIR_EraseRootFromParent_Done,
     /* 188567 */   // Label 3763: @188567
     /* 188567 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(188607), // Rule ID 11753 //
     /* 188572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188593 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 188596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188605 */     GIR_RootConstrainSelectedInstOperands,
     /* 188606 */     // GIR_Coverage, 11753,
     /* 188606 */     GIR_EraseRootFromParent_Done,
     /* 188607 */   // Label 3764: @188607
     /* 188607 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(188647), // Rule ID 11754 //
     /* 188612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 188636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188645 */     GIR_RootConstrainSelectedInstOperands,
     /* 188646 */     // GIR_Coverage, 11754,
     /* 188646 */     GIR_EraseRootFromParent_Done,
     /* 188647 */   // Label 3765: @188647
     /* 188647 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(188687), // Rule ID 11759 //
     /* 188652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188673 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 188676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188685 */     GIR_RootConstrainSelectedInstOperands,
     /* 188686 */     // GIR_Coverage, 11759,
     /* 188686 */     GIR_EraseRootFromParent_Done,
     /* 188687 */   // Label 3766: @188687
     /* 188687 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(188727), // Rule ID 11760 //
     /* 188692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188713 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 188716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188725 */     GIR_RootConstrainSelectedInstOperands,
     /* 188726 */     // GIR_Coverage, 11760,
     /* 188726 */     GIR_EraseRootFromParent_Done,
     /* 188727 */   // Label 3767: @188727
     /* 188727 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(188767), // Rule ID 11761 //
     /* 188732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 188756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188765 */     GIR_RootConstrainSelectedInstOperands,
     /* 188766 */     // GIR_Coverage, 11761,
     /* 188766 */     GIR_EraseRootFromParent_Done,
     /* 188767 */   // Label 3768: @188767
     /* 188767 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(188807), // Rule ID 11762 //
     /* 188772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188793 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 188796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188805 */     GIR_RootConstrainSelectedInstOperands,
     /* 188806 */     // GIR_Coverage, 11762,
     /* 188806 */     GIR_EraseRootFromParent_Done,
     /* 188807 */   // Label 3769: @188807
     /* 188807 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(188847), // Rule ID 11763 //
     /* 188812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188833 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 188836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188845 */     GIR_RootConstrainSelectedInstOperands,
     /* 188846 */     // GIR_Coverage, 11763,
     /* 188846 */     GIR_EraseRootFromParent_Done,
     /* 188847 */   // Label 3770: @188847
     /* 188847 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(188887), // Rule ID 11764 //
     /* 188852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188873 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 188876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188885 */     GIR_RootConstrainSelectedInstOperands,
     /* 188886 */     // GIR_Coverage, 11764,
     /* 188886 */     GIR_EraseRootFromParent_Done,
     /* 188887 */   // Label 3771: @188887
     /* 188887 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(188927), // Rule ID 11765 //
     /* 188892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188913 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 188916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188925 */     GIR_RootConstrainSelectedInstOperands,
     /* 188926 */     // GIR_Coverage, 11765,
     /* 188926 */     GIR_EraseRootFromParent_Done,
     /* 188927 */   // Label 3772: @188927
     /* 188927 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(188967), // Rule ID 11766 //
     /* 188932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188953 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 188956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188965 */     GIR_RootConstrainSelectedInstOperands,
     /* 188966 */     // GIR_Coverage, 11766,
     /* 188966 */     GIR_EraseRootFromParent_Done,
     /* 188967 */   // Label 3773: @188967
     /* 188967 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(189007), // Rule ID 11771 //
     /* 188972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188993 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 188996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189005 */     GIR_RootConstrainSelectedInstOperands,
     /* 189006 */     // GIR_Coverage, 11771,
     /* 189006 */     GIR_EraseRootFromParent_Done,
     /* 189007 */   // Label 3774: @189007
     /* 189007 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(189047), // Rule ID 11772 //
     /* 189012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 189020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189033 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 189036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189045 */     GIR_RootConstrainSelectedInstOperands,
     /* 189046 */     // GIR_Coverage, 11772,
     /* 189046 */     GIR_EraseRootFromParent_Done,
     /* 189047 */   // Label 3775: @189047
     /* 189047 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(189087), // Rule ID 11773 //
     /* 189052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 189060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189073 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 189076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189085 */     GIR_RootConstrainSelectedInstOperands,
     /* 189086 */     // GIR_Coverage, 11773,
     /* 189086 */     GIR_EraseRootFromParent_Done,
     /* 189087 */   // Label 3776: @189087
     /* 189087 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(189127), // Rule ID 11774 //
     /* 189092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 189100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189113 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 189116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189125 */     GIR_RootConstrainSelectedInstOperands,
     /* 189126 */     // GIR_Coverage, 11774,
     /* 189126 */     GIR_EraseRootFromParent_Done,
     /* 189127 */   // Label 3777: @189127
     /* 189127 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(189167), // Rule ID 11775 //
     /* 189132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 189140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189153 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 189156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189165 */     GIR_RootConstrainSelectedInstOperands,
     /* 189166 */     // GIR_Coverage, 11775,
     /* 189166 */     GIR_EraseRootFromParent_Done,
     /* 189167 */   // Label 3778: @189167
     /* 189167 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(189207), // Rule ID 11776 //
     /* 189172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 189180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189193 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 189196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189205 */     GIR_RootConstrainSelectedInstOperands,
     /* 189206 */     // GIR_Coverage, 11776,
     /* 189206 */     GIR_EraseRootFromParent_Done,
     /* 189207 */   // Label 3779: @189207
     /* 189207 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(189247), // Rule ID 11777 //
     /* 189212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 189220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189233 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 189236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189245 */     GIR_RootConstrainSelectedInstOperands,
     /* 189246 */     // GIR_Coverage, 11777,
     /* 189246 */     GIR_EraseRootFromParent_Done,
     /* 189247 */   // Label 3780: @189247
     /* 189247 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(189287), // Rule ID 11778 //
     /* 189252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 189260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189273 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 189276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189285 */     GIR_RootConstrainSelectedInstOperands,
     /* 189286 */     // GIR_Coverage, 11778,
     /* 189286 */     GIR_EraseRootFromParent_Done,
     /* 189287 */   // Label 3781: @189287
     /* 189287 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(189327), // Rule ID 11783 //
     /* 189292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 189300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 189316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189325 */     GIR_RootConstrainSelectedInstOperands,
     /* 189326 */     // GIR_Coverage, 11783,
     /* 189326 */     GIR_EraseRootFromParent_Done,
     /* 189327 */   // Label 3782: @189327
     /* 189327 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(189367), // Rule ID 11784 //
     /* 189332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 189340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189353 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 189356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189365 */     GIR_RootConstrainSelectedInstOperands,
     /* 189366 */     // GIR_Coverage, 11784,
     /* 189366 */     GIR_EraseRootFromParent_Done,
     /* 189367 */   // Label 3783: @189367
     /* 189367 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(189407), // Rule ID 11785 //
     /* 189372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 189380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189393 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 189396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189405 */     GIR_RootConstrainSelectedInstOperands,
     /* 189406 */     // GIR_Coverage, 11785,
     /* 189406 */     GIR_EraseRootFromParent_Done,
     /* 189407 */   // Label 3784: @189407
     /* 189407 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(189447), // Rule ID 11786 //
     /* 189412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 189420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189433 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 189436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189445 */     GIR_RootConstrainSelectedInstOperands,
     /* 189446 */     // GIR_Coverage, 11786,
     /* 189446 */     GIR_EraseRootFromParent_Done,
     /* 189447 */   // Label 3785: @189447
     /* 189447 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(189487), // Rule ID 11787 //
     /* 189452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 189476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189485 */     GIR_RootConstrainSelectedInstOperands,
     /* 189486 */     // GIR_Coverage, 11787,
     /* 189486 */     GIR_EraseRootFromParent_Done,
     /* 189487 */   // Label 3786: @189487
     /* 189487 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(189527), // Rule ID 11788 //
     /* 189492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189513 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 189516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189525 */     GIR_RootConstrainSelectedInstOperands,
     /* 189526 */     // GIR_Coverage, 11788,
     /* 189526 */     GIR_EraseRootFromParent_Done,
     /* 189527 */   // Label 3787: @189527
     /* 189527 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(189567), // Rule ID 11789 //
     /* 189532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189553 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 189556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189565 */     GIR_RootConstrainSelectedInstOperands,
     /* 189566 */     // GIR_Coverage, 11789,
     /* 189566 */     GIR_EraseRootFromParent_Done,
     /* 189567 */   // Label 3788: @189567
     /* 189567 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(189607), // Rule ID 11790 //
     /* 189572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 189596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189605 */     GIR_RootConstrainSelectedInstOperands,
     /* 189606 */     // GIR_Coverage, 11790,
     /* 189606 */     GIR_EraseRootFromParent_Done,
     /* 189607 */   // Label 3789: @189607
     /* 189607 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(189644), // Rule ID 11799 //
     /* 189612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 189620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 189636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189642 */     GIR_RootConstrainSelectedInstOperands,
     /* 189643 */     // GIR_Coverage, 11799,
     /* 189643 */     GIR_EraseRootFromParent_Done,
     /* 189644 */   // Label 3790: @189644
     /* 189644 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(189681), // Rule ID 11801 //
     /* 189649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 189657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1538:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 189673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189679 */     GIR_RootConstrainSelectedInstOperands,
     /* 189680 */     // GIR_Coverage, 11801,
     /* 189680 */     GIR_EraseRootFromParent_Done,
     /* 189681 */   // Label 3791: @189681
     /* 189681 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(189718), // Rule ID 11802 //
     /* 189686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 189689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 189694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 189710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189716 */     GIR_RootConstrainSelectedInstOperands,
     /* 189717 */     // GIR_Coverage, 11802,
     /* 189717 */     GIR_EraseRootFromParent_Done,
     /* 189718 */   // Label 3792: @189718
     /* 189718 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(189755), // Rule ID 11803 //
     /* 189723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 189726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 189731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 189747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189753 */     GIR_RootConstrainSelectedInstOperands,
     /* 189754 */     // GIR_Coverage, 11803,
     /* 189754 */     GIR_EraseRootFromParent_Done,
     /* 189755 */   // Label 3793: @189755
     /* 189755 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(189792), // Rule ID 11804 //
     /* 189760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1178:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 189784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189790 */     GIR_RootConstrainSelectedInstOperands,
     /* 189791 */     // GIR_Coverage, 11804,
     /* 189791 */     GIR_EraseRootFromParent_Done,
     /* 189792 */   // Label 3794: @189792
     /* 189792 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(189829), // Rule ID 11805 //
     /* 189797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1178:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 189821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189827 */     GIR_RootConstrainSelectedInstOperands,
     /* 189828 */     // GIR_Coverage, 11805,
     /* 189828 */     GIR_EraseRootFromParent_Done,
     /* 189829 */   // Label 3795: @189829
     /* 189829 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(189866), // Rule ID 11806 //
     /* 189834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189855 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1178:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 189858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189864 */     GIR_RootConstrainSelectedInstOperands,
     /* 189865 */     // GIR_Coverage, 11806,
     /* 189865 */     GIR_EraseRootFromParent_Done,
     /* 189866 */   // Label 3796: @189866
     /* 189866 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(189903), // Rule ID 11807 //
     /* 189871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1178:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 189895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189901 */     GIR_RootConstrainSelectedInstOperands,
     /* 189902 */     // GIR_Coverage, 11807,
     /* 189902 */     GIR_EraseRootFromParent_Done,
     /* 189903 */   // Label 3797: @189903
     /* 189903 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(189940), // Rule ID 11808 //
     /* 189908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1195:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 189932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189938 */     GIR_RootConstrainSelectedInstOperands,
     /* 189939 */     // GIR_Coverage, 11808,
     /* 189939 */     GIR_EraseRootFromParent_Done,
     /* 189940 */   // Label 3798: @189940
     /* 189940 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(189977), // Rule ID 11809 //
     /* 189945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1195:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 189969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189975 */     GIR_RootConstrainSelectedInstOperands,
     /* 189976 */     // GIR_Coverage, 11809,
     /* 189976 */     GIR_EraseRootFromParent_Done,
     /* 189977 */   // Label 3799: @189977
     /* 189977 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(190014), // Rule ID 11810 //
     /* 189982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1195:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 190006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190012 */     GIR_RootConstrainSelectedInstOperands,
     /* 190013 */     // GIR_Coverage, 11810,
     /* 190013 */     GIR_EraseRootFromParent_Done,
     /* 190014 */   // Label 3800: @190014
     /* 190014 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(190051), // Rule ID 11811 //
     /* 190019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 190022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 190027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1195:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 190043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190049 */     GIR_RootConstrainSelectedInstOperands,
     /* 190050 */     // GIR_Coverage, 11811,
     /* 190050 */     GIR_EraseRootFromParent_Done,
     /* 190051 */   // Label 3801: @190051
     /* 190051 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(190088), // Rule ID 11924 //
     /* 190056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 190064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190077 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 190080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190086 */     GIR_RootConstrainSelectedInstOperands,
     /* 190087 */     // GIR_Coverage, 11924,
     /* 190087 */     GIR_EraseRootFromParent_Done,
     /* 190088 */   // Label 3802: @190088
     /* 190088 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(190125), // Rule ID 11925 //
     /* 190093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 190101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190114 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 190117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190123 */     GIR_RootConstrainSelectedInstOperands,
     /* 190124 */     // GIR_Coverage, 11925,
     /* 190124 */     GIR_EraseRootFromParent_Done,
     /* 190125 */   // Label 3803: @190125
     /* 190125 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(190162), // Rule ID 11926 //
     /* 190130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 190138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190151 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 190154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190160 */     GIR_RootConstrainSelectedInstOperands,
     /* 190161 */     // GIR_Coverage, 11926,
     /* 190161 */     GIR_EraseRootFromParent_Done,
     /* 190162 */   // Label 3804: @190162
     /* 190162 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(190199), // Rule ID 11927 //
     /* 190167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 190175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190188 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 190191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190197 */     GIR_RootConstrainSelectedInstOperands,
     /* 190198 */     // GIR_Coverage, 11927,
     /* 190198 */     GIR_EraseRootFromParent_Done,
     /* 190199 */   // Label 3805: @190199
     /* 190199 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(190236), // Rule ID 11928 //
     /* 190204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 190212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190225 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 190228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190234 */     GIR_RootConstrainSelectedInstOperands,
     /* 190235 */     // GIR_Coverage, 11928,
     /* 190235 */     GIR_EraseRootFromParent_Done,
     /* 190236 */   // Label 3806: @190236
     /* 190236 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(190273), // Rule ID 11929 //
     /* 190241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 190249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190262 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 190265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190271 */     GIR_RootConstrainSelectedInstOperands,
     /* 190272 */     // GIR_Coverage, 11929,
     /* 190272 */     GIR_EraseRootFromParent_Done,
     /* 190273 */   // Label 3807: @190273
     /* 190273 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(190310), // Rule ID 11930 //
     /* 190278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 190286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190299 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190308 */     GIR_RootConstrainSelectedInstOperands,
     /* 190309 */     // GIR_Coverage, 11930,
     /* 190309 */     GIR_EraseRootFromParent_Done,
     /* 190310 */   // Label 3808: @190310
     /* 190310 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(190347), // Rule ID 11931 //
     /* 190315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 190323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190336 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 190339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190345 */     GIR_RootConstrainSelectedInstOperands,
     /* 190346 */     // GIR_Coverage, 11931,
     /* 190346 */     GIR_EraseRootFromParent_Done,
     /* 190347 */   // Label 3809: @190347
     /* 190347 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(190384), // Rule ID 11932 //
     /* 190352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 190360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190373 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 190376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190382 */     GIR_RootConstrainSelectedInstOperands,
     /* 190383 */     // GIR_Coverage, 11932,
     /* 190383 */     GIR_EraseRootFromParent_Done,
     /* 190384 */   // Label 3810: @190384
     /* 190384 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(190421), // Rule ID 11933 //
     /* 190389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190410 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 190413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190419 */     GIR_RootConstrainSelectedInstOperands,
     /* 190420 */     // GIR_Coverage, 11933,
     /* 190420 */     GIR_EraseRootFromParent_Done,
     /* 190421 */   // Label 3811: @190421
     /* 190421 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(190458), // Rule ID 11934 //
     /* 190426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190447 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 190450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190456 */     GIR_RootConstrainSelectedInstOperands,
     /* 190457 */     // GIR_Coverage, 11934,
     /* 190457 */     GIR_EraseRootFromParent_Done,
     /* 190458 */   // Label 3812: @190458
     /* 190458 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(190495), // Rule ID 11935 //
     /* 190463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190484 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 190487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190493 */     GIR_RootConstrainSelectedInstOperands,
     /* 190494 */     // GIR_Coverage, 11935,
     /* 190494 */     GIR_EraseRootFromParent_Done,
     /* 190495 */   // Label 3813: @190495
     /* 190495 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(190532), // Rule ID 11936 //
     /* 190500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190521 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 190524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190530 */     GIR_RootConstrainSelectedInstOperands,
     /* 190531 */     // GIR_Coverage, 11936,
     /* 190531 */     GIR_EraseRootFromParent_Done,
     /* 190532 */   // Label 3814: @190532
     /* 190532 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(190569), // Rule ID 11937 //
     /* 190537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 190561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190567 */     GIR_RootConstrainSelectedInstOperands,
     /* 190568 */     // GIR_Coverage, 11937,
     /* 190568 */     GIR_EraseRootFromParent_Done,
     /* 190569 */   // Label 3815: @190569
     /* 190569 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(190606), // Rule ID 11938 //
     /* 190574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190595 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 190598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190604 */     GIR_RootConstrainSelectedInstOperands,
     /* 190605 */     // GIR_Coverage, 11938,
     /* 190605 */     GIR_EraseRootFromParent_Done,
     /* 190606 */   // Label 3816: @190606
     /* 190606 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(190643), // Rule ID 11939 //
     /* 190611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190632 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 190635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190641 */     GIR_RootConstrainSelectedInstOperands,
     /* 190642 */     // GIR_Coverage, 11939,
     /* 190642 */     GIR_EraseRootFromParent_Done,
     /* 190643 */   // Label 3817: @190643
     /* 190643 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(190680), // Rule ID 11940 //
     /* 190648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190669 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1171:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 190672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190678 */     GIR_RootConstrainSelectedInstOperands,
     /* 190679 */     // GIR_Coverage, 11940,
     /* 190679 */     GIR_EraseRootFromParent_Done,
     /* 190680 */   // Label 3818: @190680
     /* 190680 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(190717), // Rule ID 11941 //
     /* 190685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190706 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1171:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 190709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190715 */     GIR_RootConstrainSelectedInstOperands,
     /* 190716 */     // GIR_Coverage, 11941,
     /* 190716 */     GIR_EraseRootFromParent_Done,
     /* 190717 */   // Label 3819: @190717
     /* 190717 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(190754), // Rule ID 11942 //
     /* 190722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190743 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1171:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 190746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190752 */     GIR_RootConstrainSelectedInstOperands,
     /* 190753 */     // GIR_Coverage, 11942,
     /* 190753 */     GIR_EraseRootFromParent_Done,
     /* 190754 */   // Label 3820: @190754
     /* 190754 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(190791), // Rule ID 11943 //
     /* 190759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1171:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 190783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190789 */     GIR_RootConstrainSelectedInstOperands,
     /* 190790 */     // GIR_Coverage, 11943,
     /* 190790 */     GIR_EraseRootFromParent_Done,
     /* 190791 */   // Label 3821: @190791
     /* 190791 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(190828), // Rule ID 11944 //
     /* 190796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190817 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 190820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190826 */     GIR_RootConstrainSelectedInstOperands,
     /* 190827 */     // GIR_Coverage, 11944,
     /* 190827 */     GIR_EraseRootFromParent_Done,
     /* 190828 */   // Label 3822: @190828
     /* 190828 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(190865), // Rule ID 11945 //
     /* 190833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190854 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1159:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 190857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190863 */     GIR_RootConstrainSelectedInstOperands,
     /* 190864 */     // GIR_Coverage, 11945,
     /* 190864 */     GIR_EraseRootFromParent_Done,
     /* 190865 */   // Label 3823: @190865
     /* 190865 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(190902), // Rule ID 11946 //
     /* 190870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1159:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 190894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190900 */     GIR_RootConstrainSelectedInstOperands,
     /* 190901 */     // GIR_Coverage, 11946,
     /* 190901 */     GIR_EraseRootFromParent_Done,
     /* 190902 */   // Label 3824: @190902
     /* 190902 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(190939), // Rule ID 11947 //
     /* 190907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190928 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1159:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 190931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190937 */     GIR_RootConstrainSelectedInstOperands,
     /* 190938 */     // GIR_Coverage, 11947,
     /* 190938 */     GIR_EraseRootFromParent_Done,
     /* 190939 */   // Label 3825: @190939
     /* 190939 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(190976), // Rule ID 11948 //
     /* 190944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190965 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1638:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 190968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190974 */     GIR_RootConstrainSelectedInstOperands,
     /* 190975 */     // GIR_Coverage, 11948,
     /* 190975 */     GIR_EraseRootFromParent_Done,
     /* 190976 */   // Label 3826: @190976
     /* 190976 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(191013), // Rule ID 11949 //
     /* 190981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191002 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1638:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 191005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191011 */     GIR_RootConstrainSelectedInstOperands,
     /* 191012 */     // GIR_Coverage, 11949,
     /* 191012 */     GIR_EraseRootFromParent_Done,
     /* 191013 */   // Label 3827: @191013
     /* 191013 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(191050), // Rule ID 11950 //
     /* 191018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 191026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1638:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 191042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191048 */     GIR_RootConstrainSelectedInstOperands,
     /* 191049 */     // GIR_Coverage, 11950,
     /* 191049 */     GIR_EraseRootFromParent_Done,
     /* 191050 */   // Label 3828: @191050
     /* 191050 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(191087), // Rule ID 11951 //
     /* 191055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 191063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191076 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1638:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 191079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191085 */     GIR_RootConstrainSelectedInstOperands,
     /* 191086 */     // GIR_Coverage, 11951,
     /* 191086 */     GIR_EraseRootFromParent_Done,
     /* 191087 */   // Label 3829: @191087
     /* 191087 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(191124), // Rule ID 11952 //
     /* 191092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 191100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 191106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191113 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1876:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 191116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191122 */     GIR_RootConstrainSelectedInstOperands,
     /* 191123 */     // GIR_Coverage, 11952,
     /* 191123 */     GIR_EraseRootFromParent_Done,
     /* 191124 */   // Label 3830: @191124
     /* 191124 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(191161), // Rule ID 11953 //
     /* 191129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 191137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 191143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191150 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1876:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 191153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191159 */     GIR_RootConstrainSelectedInstOperands,
     /* 191160 */     // GIR_Coverage, 11953,
     /* 191160 */     GIR_EraseRootFromParent_Done,
     /* 191161 */   // Label 3831: @191161
     /* 191161 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(191198), // Rule ID 11954 //
     /* 191166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 191174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191187 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1876:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 191190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191196 */     GIR_RootConstrainSelectedInstOperands,
     /* 191197 */     // GIR_Coverage, 11954,
     /* 191197 */     GIR_EraseRootFromParent_Done,
     /* 191198 */   // Label 3832: @191198
     /* 191198 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(191235), // Rule ID 11955 //
     /* 191203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 191211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1876:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 191227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191233 */     GIR_RootConstrainSelectedInstOperands,
     /* 191234 */     // GIR_Coverage, 11955,
     /* 191234 */     GIR_EraseRootFromParent_Done,
     /* 191235 */   // Label 3833: @191235
     /* 191235 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(191272), // Rule ID 11956 //
     /* 191240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 191248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 191254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191261 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 191264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191270 */     GIR_RootConstrainSelectedInstOperands,
     /* 191271 */     // GIR_Coverage, 11956,
     /* 191271 */     GIR_EraseRootFromParent_Done,
     /* 191272 */   // Label 3834: @191272
     /* 191272 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(191309), // Rule ID 11957 //
     /* 191277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 191285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 191291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191298 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 191301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191307 */     GIR_RootConstrainSelectedInstOperands,
     /* 191308 */     // GIR_Coverage, 11957,
     /* 191308 */     GIR_EraseRootFromParent_Done,
     /* 191309 */   // Label 3835: @191309
     /* 191309 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(191346), // Rule ID 11958 //
     /* 191314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 191322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191335 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 191338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191344 */     GIR_RootConstrainSelectedInstOperands,
     /* 191345 */     // GIR_Coverage, 11958,
     /* 191345 */     GIR_EraseRootFromParent_Done,
     /* 191346 */   // Label 3836: @191346
     /* 191346 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(191383), // Rule ID 11959 //
     /* 191351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 191359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191372 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1647:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 191375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191381 */     GIR_RootConstrainSelectedInstOperands,
     /* 191382 */     // GIR_Coverage, 11959,
     /* 191382 */     GIR_EraseRootFromParent_Done,
     /* 191383 */   // Label 3837: @191383
     /* 191383 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(191420), // Rule ID 11960 //
     /* 191388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 191402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191409 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1885:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 191412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191418 */     GIR_RootConstrainSelectedInstOperands,
     /* 191419 */     // GIR_Coverage, 11960,
     /* 191419 */     GIR_EraseRootFromParent_Done,
     /* 191420 */   // Label 3838: @191420
     /* 191420 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(191457), // Rule ID 11961 //
     /* 191425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 191439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191446 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1885:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 191449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191455 */     GIR_RootConstrainSelectedInstOperands,
     /* 191456 */     // GIR_Coverage, 11961,
     /* 191456 */     GIR_EraseRootFromParent_Done,
     /* 191457 */   // Label 3839: @191457
     /* 191457 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(191494), // Rule ID 11962 //
     /* 191462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191483 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1885:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 191486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191492 */     GIR_RootConstrainSelectedInstOperands,
     /* 191493 */     // GIR_Coverage, 11962,
     /* 191493 */     GIR_EraseRootFromParent_Done,
     /* 191494 */   // Label 3840: @191494
     /* 191494 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(191531), // Rule ID 11963 //
     /* 191499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191520 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1885:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 191523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191529 */     GIR_RootConstrainSelectedInstOperands,
     /* 191530 */     // GIR_Coverage, 11963,
     /* 191530 */     GIR_EraseRootFromParent_Done,
     /* 191531 */   // Label 3841: @191531
     /* 191531 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(191568), // Rule ID 11964 //
     /* 191536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191557 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 191560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 191567 */     // GIR_Coverage, 11964,
     /* 191567 */     GIR_EraseRootFromParent_Done,
     /* 191568 */   // Label 3842: @191568
     /* 191568 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(191605), // Rule ID 11965 //
     /* 191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191603 */     GIR_RootConstrainSelectedInstOperands,
     /* 191604 */     // GIR_Coverage, 11965,
     /* 191604 */     GIR_EraseRootFromParent_Done,
     /* 191605 */   // Label 3843: @191605
     /* 191605 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(191642), // Rule ID 11966 //
     /* 191610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191640 */     GIR_RootConstrainSelectedInstOperands,
     /* 191641 */     // GIR_Coverage, 11966,
     /* 191641 */     GIR_EraseRootFromParent_Done,
     /* 191642 */   // Label 3844: @191642
     /* 191642 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(191679), // Rule ID 11967 //
     /* 191647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191677 */     GIR_RootConstrainSelectedInstOperands,
     /* 191678 */     // GIR_Coverage, 11967,
     /* 191678 */     GIR_EraseRootFromParent_Done,
     /* 191679 */   // Label 3845: @191679
     /* 191679 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(191716), // Rule ID 11968 //
     /* 191684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2069:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191714 */     GIR_RootConstrainSelectedInstOperands,
     /* 191715 */     // GIR_Coverage, 11968,
     /* 191715 */     GIR_EraseRootFromParent_Done,
     /* 191716 */   // Label 3846: @191716
     /* 191716 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(191753), // Rule ID 11969 //
     /* 191721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191742 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2069:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191751 */     GIR_RootConstrainSelectedInstOperands,
     /* 191752 */     // GIR_Coverage, 11969,
     /* 191752 */     GIR_EraseRootFromParent_Done,
     /* 191753 */   // Label 3847: @191753
     /* 191753 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(191790), // Rule ID 11970 //
     /* 191758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191779 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2069:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191788 */     GIR_RootConstrainSelectedInstOperands,
     /* 191789 */     // GIR_Coverage, 11970,
     /* 191789 */     GIR_EraseRootFromParent_Done,
     /* 191790 */   // Label 3848: @191790
     /* 191790 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(191827), // Rule ID 11971 //
     /* 191795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191816 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 191819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191825 */     GIR_RootConstrainSelectedInstOperands,
     /* 191826 */     // GIR_Coverage, 11971,
     /* 191826 */     GIR_EraseRootFromParent_Done,
     /* 191827 */   // Label 3849: @191827
     /* 191827 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(191864), // Rule ID 11972 //
     /* 191832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191862 */     GIR_RootConstrainSelectedInstOperands,
     /* 191863 */     // GIR_Coverage, 11972,
     /* 191863 */     GIR_EraseRootFromParent_Done,
     /* 191864 */   // Label 3850: @191864
     /* 191864 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(191901), // Rule ID 11973 //
     /* 191869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 191893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191899 */     GIR_RootConstrainSelectedInstOperands,
     /* 191900 */     // GIR_Coverage, 11973,
     /* 191900 */     GIR_EraseRootFromParent_Done,
     /* 191901 */   // Label 3851: @191901
     /* 191901 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(191938), // Rule ID 11974 //
     /* 191906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 191930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191936 */     GIR_RootConstrainSelectedInstOperands,
     /* 191937 */     // GIR_Coverage, 11974,
     /* 191937 */     GIR_EraseRootFromParent_Done,
     /* 191938 */   // Label 3852: @191938
     /* 191938 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(191975), // Rule ID 11975 //
     /* 191943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191964 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1994:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191973 */     GIR_RootConstrainSelectedInstOperands,
     /* 191974 */     // GIR_Coverage, 11975,
     /* 191974 */     GIR_EraseRootFromParent_Done,
     /* 191975 */   // Label 3853: @191975
     /* 191975 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(192012), // Rule ID 11976 //
     /* 191980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192001 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1994:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 192004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192010 */     GIR_RootConstrainSelectedInstOperands,
     /* 192011 */     // GIR_Coverage, 11976,
     /* 192011 */     GIR_EraseRootFromParent_Done,
     /* 192012 */   // Label 3854: @192012
     /* 192012 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(192049), // Rule ID 11977 //
     /* 192017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 192025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192038 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1994:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 192041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192047 */     GIR_RootConstrainSelectedInstOperands,
     /* 192048 */     // GIR_Coverage, 11977,
     /* 192048 */     GIR_EraseRootFromParent_Done,
     /* 192049 */   // Label 3855: @192049
     /* 192049 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(192086), // Rule ID 11978 //
     /* 192054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1995:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 192078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192084 */     GIR_RootConstrainSelectedInstOperands,
     /* 192085 */     // GIR_Coverage, 11978,
     /* 192085 */     GIR_EraseRootFromParent_Done,
     /* 192086 */   // Label 3856: @192086
     /* 192086 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(192123), // Rule ID 11979 //
     /* 192091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 192115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192121 */     GIR_RootConstrainSelectedInstOperands,
     /* 192122 */     // GIR_Coverage, 11979,
     /* 192122 */     GIR_EraseRootFromParent_Done,
     /* 192123 */   // Label 3857: @192123
     /* 192123 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(192160), // Rule ID 11980 //
     /* 192128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 192152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192158 */     GIR_RootConstrainSelectedInstOperands,
     /* 192159 */     // GIR_Coverage, 11980,
     /* 192159 */     GIR_EraseRootFromParent_Done,
     /* 192160 */   // Label 3858: @192160
     /* 192160 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(192197), // Rule ID 11981 //
     /* 192165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 192189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192195 */     GIR_RootConstrainSelectedInstOperands,
     /* 192196 */     // GIR_Coverage, 11981,
     /* 192196 */     GIR_EraseRootFromParent_Done,
     /* 192197 */   // Label 3859: @192197
     /* 192197 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(192234), // Rule ID 11982 //
     /* 192202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192223 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1995:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 192223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 192226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192232 */     GIR_RootConstrainSelectedInstOperands,
     /* 192233 */     // GIR_Coverage, 11982,
     /* 192233 */     GIR_EraseRootFromParent_Done,
     /* 192234 */   // Label 3860: @192234
     /* 192234 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(192271), // Rule ID 11983 //
     /* 192239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1995:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 192260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 192263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192269 */     GIR_RootConstrainSelectedInstOperands,
     /* 192270 */     // GIR_Coverage, 11983,
     /* 192270 */     GIR_EraseRootFromParent_Done,
     /* 192271 */   // Label 3861: @192271
     /* 192271 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(192308), // Rule ID 11984 //
     /* 192276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 192279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 192284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192297 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1995:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 192297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 192300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192306 */     GIR_RootConstrainSelectedInstOperands,
     /* 192307 */     // GIR_Coverage, 11984,
     /* 192307 */     GIR_EraseRootFromParent_Done,
     /* 192308 */   // Label 3862: @192308
     /* 192308 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(192350), // Rule ID 3198 //
     /* 192313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 192321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 192324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192328 */     // MIs[0] Op1
     /* 192328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192332 */     // MIs[0] Op2
     /* 192332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2048:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 192339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192348 */     GIR_RootConstrainSelectedInstOperands,
     /* 192349 */     // GIR_Coverage, 3198,
     /* 192349 */     GIR_EraseRootFromParent_Done,
     /* 192350 */   // Label 3863: @192350
     /* 192350 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(192392), // Rule ID 3199 //
     /* 192355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 192363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 192366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192370 */     // MIs[0] Op1
     /* 192370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192374 */     // MIs[0] Op2
     /* 192374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192378 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2050:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 192381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192390 */     GIR_RootConstrainSelectedInstOperands,
     /* 192391 */     // GIR_Coverage, 3199,
     /* 192391 */     GIR_EraseRootFromParent_Done,
     /* 192392 */   // Label 3864: @192392
     /* 192392 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(192434), // Rule ID 3200 //
     /* 192397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 192405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 192408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192412 */     // MIs[0] Op1
     /* 192412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192416 */     // MIs[0] Op2
     /* 192416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192420 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2051:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 192423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192432 */     GIR_RootConstrainSelectedInstOperands,
     /* 192433 */     // GIR_Coverage, 3200,
     /* 192433 */     GIR_EraseRootFromParent_Done,
     /* 192434 */   // Label 3865: @192434
     /* 192434 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(192476), // Rule ID 3201 //
     /* 192439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 192447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192454 */     // MIs[0] Op1
     /* 192454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192458 */     // MIs[0] Op2
     /* 192458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2049:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 192465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192474 */     GIR_RootConstrainSelectedInstOperands,
     /* 192475 */     // GIR_Coverage, 3201,
     /* 192475 */     GIR_EraseRootFromParent_Done,
     /* 192476 */   // Label 3866: @192476
     /* 192476 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(192518), // Rule ID 11795 //
     /* 192481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 192489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 192492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192496 */     // MIs[0] Op1
     /* 192496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192500 */     // MIs[0] Op2
     /* 192500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2044:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 192507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192516 */     GIR_RootConstrainSelectedInstOperands,
     /* 192517 */     // GIR_Coverage, 11795,
     /* 192517 */     GIR_EraseRootFromParent_Done,
     /* 192518 */   // Label 3867: @192518
     /* 192518 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(192560), // Rule ID 11796 //
     /* 192523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 192531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 192534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192538 */     // MIs[0] Op1
     /* 192538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192542 */     // MIs[0] Op2
     /* 192542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2046:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 192549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192558 */     GIR_RootConstrainSelectedInstOperands,
     /* 192559 */     // GIR_Coverage, 11796,
     /* 192559 */     GIR_EraseRootFromParent_Done,
     /* 192560 */   // Label 3868: @192560
     /* 192560 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(192602), // Rule ID 11797 //
     /* 192565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 192573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 192576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192580 */     // MIs[0] Op1
     /* 192580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192584 */     // MIs[0] Op2
     /* 192584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2047:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 192591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192600 */     GIR_RootConstrainSelectedInstOperands,
     /* 192601 */     // GIR_Coverage, 11797,
     /* 192601 */     GIR_EraseRootFromParent_Done,
     /* 192602 */   // Label 3869: @192602
     /* 192602 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(192644), // Rule ID 11798 //
     /* 192607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 192615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192622 */     // MIs[0] Op1
     /* 192622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192626 */     // MIs[0] Op2
     /* 192626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192630 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2045:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 192633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192642 */     GIR_RootConstrainSelectedInstOperands,
     /* 192643 */     // GIR_Coverage, 11798,
     /* 192643 */     GIR_EraseRootFromParent_Done,
     /* 192644 */   // Label 3870: @192644
     /* 192644 */   GIM_Reject,
     /* 192645 */ // Label 2917: @192645
     /* 192645 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(236428),
     /* 192650 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 192653 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(192766), // Rule ID 2062 //
     /* 192658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192731 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192735 */     // MIs[3] Operand 1
     /* 192735 */     // No operand predicates
     /* 192735 */     // MIs[1] Operand 2
     /* 192735 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192748 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 192751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192764 */     GIR_RootConstrainSelectedInstOperands,
     /* 192765 */     // GIR_Coverage, 2062,
     /* 192765 */     GIR_EraseRootFromParent_Done,
     /* 192766 */   // Label 3872: @192766
     /* 192766 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(192879), // Rule ID 2069 //
     /* 192771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 192779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192844 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192848 */     // MIs[3] Operand 1
     /* 192848 */     // No operand predicates
     /* 192848 */     // MIs[1] Operand 2
     /* 192848 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192861 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 192864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192877 */     GIR_RootConstrainSelectedInstOperands,
     /* 192878 */     // GIR_Coverage, 2069,
     /* 192878 */     GIR_EraseRootFromParent_Done,
     /* 192879 */   // Label 3873: @192879
     /* 192879 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(192992), // Rule ID 2065 //
     /* 192884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 192904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192957 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 192961 */     // MIs[3] Operand 1
     /* 192961 */     // No operand predicates
     /* 192961 */     // MIs[1] Operand 2
     /* 192961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192974 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 192977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192990 */     GIR_RootConstrainSelectedInstOperands,
     /* 192991 */     // GIR_Coverage, 2065,
     /* 192991 */     GIR_EraseRootFromParent_Done,
     /* 192992 */   // Label 3874: @192992
     /* 192992 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(193105), // Rule ID 2072 //
     /* 192997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 193000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 193005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 193017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 193037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193074 */     // MIs[3] Operand 1
     /* 193074 */     // No operand predicates
     /* 193074 */     // MIs[1] Operand 2
     /* 193074 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 193085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193087 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 193087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 193090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193103 */     GIR_RootConstrainSelectedInstOperands,
     /* 193104 */     // GIR_Coverage, 2072,
     /* 193104 */     GIR_EraseRootFromParent_Done,
     /* 193105 */   // Label 3875: @193105
     /* 193105 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(193210), // Rule ID 3811 //
     /* 193110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193183 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193187 */     // MIs[3] Operand 1
     /* 193187 */     // No operand predicates
     /* 193187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193189 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193208 */     GIR_RootConstrainSelectedInstOperands,
     /* 193209 */     // GIR_Coverage, 3811,
     /* 193209 */     GIR_EraseRootFromParent_Done,
     /* 193210 */   // Label 3876: @193210
     /* 193210 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(193315), // Rule ID 3812 //
     /* 193215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193288 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193292 */     // MIs[3] Operand 1
     /* 193292 */     // No operand predicates
     /* 193292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193294 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193313 */     GIR_RootConstrainSelectedInstOperands,
     /* 193314 */     // GIR_Coverage, 3812,
     /* 193314 */     GIR_EraseRootFromParent_Done,
     /* 193315 */   // Label 3877: @193315
     /* 193315 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(193420), // Rule ID 3813 //
     /* 193320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193397 */     // MIs[3] Operand 1
     /* 193397 */     // No operand predicates
     /* 193397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193399 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193418 */     GIR_RootConstrainSelectedInstOperands,
     /* 193419 */     // GIR_Coverage, 3813,
     /* 193419 */     GIR_EraseRootFromParent_Done,
     /* 193420 */   // Label 3878: @193420
     /* 193420 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(193525), // Rule ID 3814 //
     /* 193425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193498 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193502 */     // MIs[3] Operand 1
     /* 193502 */     // No operand predicates
     /* 193502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193504 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193523 */     GIR_RootConstrainSelectedInstOperands,
     /* 193524 */     // GIR_Coverage, 3814,
     /* 193524 */     GIR_EraseRootFromParent_Done,
     /* 193525 */   // Label 3879: @193525
     /* 193525 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(193630), // Rule ID 3819 //
     /* 193530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193603 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193607 */     // MIs[3] Operand 1
     /* 193607 */     // No operand predicates
     /* 193607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193609 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193628 */     GIR_RootConstrainSelectedInstOperands,
     /* 193629 */     // GIR_Coverage, 3819,
     /* 193629 */     GIR_EraseRootFromParent_Done,
     /* 193630 */   // Label 3880: @193630
     /* 193630 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(193735), // Rule ID 3820 //
     /* 193635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193708 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193712 */     // MIs[3] Operand 1
     /* 193712 */     // No operand predicates
     /* 193712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193714 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193733 */     GIR_RootConstrainSelectedInstOperands,
     /* 193734 */     // GIR_Coverage, 3820,
     /* 193734 */     GIR_EraseRootFromParent_Done,
     /* 193735 */   // Label 3881: @193735
     /* 193735 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(193840), // Rule ID 3821 //
     /* 193740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193817 */     // MIs[3] Operand 1
     /* 193817 */     // No operand predicates
     /* 193817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193819 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193838 */     GIR_RootConstrainSelectedInstOperands,
     /* 193839 */     // GIR_Coverage, 3821,
     /* 193839 */     GIR_EraseRootFromParent_Done,
     /* 193840 */   // Label 3882: @193840
     /* 193840 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(193945), // Rule ID 3822 //
     /* 193845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193918 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193922 */     // MIs[3] Operand 1
     /* 193922 */     // No operand predicates
     /* 193922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193924 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193943 */     GIR_RootConstrainSelectedInstOperands,
     /* 193944 */     // GIR_Coverage, 3822,
     /* 193944 */     GIR_EraseRootFromParent_Done,
     /* 193945 */   // Label 3883: @193945
     /* 193945 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(194050), // Rule ID 3835 //
     /* 193950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 194002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194023 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 194027 */     // MIs[3] Operand 1
     /* 194027 */     // No operand predicates
     /* 194027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194029 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 194029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 194032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194048 */     GIR_RootConstrainSelectedInstOperands,
     /* 194049 */     // GIR_Coverage, 3835,
     /* 194049 */     GIR_EraseRootFromParent_Done,
     /* 194050 */   // Label 3884: @194050
     /* 194050 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(194155), // Rule ID 3836 //
     /* 194055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 194058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 194063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 194075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 194091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 194095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 194103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 194107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194128 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 194132 */     // MIs[3] Operand 1
     /* 194132 */     // No operand predicates
     /* 194132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194134 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 194134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 194137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194153 */     GIR_RootConstrainSelectedInstOperands,
     /* 194154 */     // GIR_Coverage, 3836,
     /* 194154 */     GIR_EraseRootFromParent_Done,
     /* 194155 */   // Label 3885: @194155
     /* 194155 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(194260), // Rule ID 3837 //
     /* 194160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 194163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 194168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 194180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 194196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 194200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 194208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 194212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194233 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 194237 */     // MIs[3] Operand 1
     /* 194237 */     // No operand predicates
     /* 194237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194239 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 194239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 194242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 194258 */     GIR_RootConstrainSelectedInstOperands,
     /* 194259 */     // GIR_Coverage, 3837,
     /* 194259 */     GIR_EraseRootFromParent_Done,
     /* 194260 */   // Label 3886: @194260
     /* 194260 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(194365), // Rule ID 3838 //
     /* 194265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 194268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 194273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 194285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 194301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 194305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 194313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 194317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 194321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 194325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 194334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 194338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 194342 */     // MIs[3] Operand 1
     /* 194342 */     // No operand predicates
     /* 194342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 194344 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 194344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 194347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 194353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 194357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 194360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 194363 */     GIR_RootConstrainSelectedInstOperands,
     /* 194364 */     // GIR_Coverage, 3838,
     /* 194364 */     GIR_EraseRootFromParent_Done,
     /* 194365 */   // Label 3887: @194365
     /* 194365 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(194419), // Rule ID 59 //
     /* 194370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194395 */     // MIs[0] Operand 3
     /* 194395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 194406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194410 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 194413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194417 */     GIR_RootConstrainSelectedInstOperands,
     /* 194418 */     // GIR_Coverage, 59,
     /* 194418 */     GIR_EraseRootFromParent_Done,
     /* 194419 */   // Label 3888: @194419
     /* 194419 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(194473), // Rule ID 60 //
     /* 194424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194449 */     // MIs[0] Operand 3
     /* 194449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 194460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194464 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 194467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194471 */     GIR_RootConstrainSelectedInstOperands,
     /* 194472 */     // GIR_Coverage, 60,
     /* 194472 */     GIR_EraseRootFromParent_Done,
     /* 194473 */   // Label 3889: @194473
     /* 194473 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(194527), // Rule ID 61 //
     /* 194478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194503 */     // MIs[0] Operand 3
     /* 194503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 194514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194518 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 194521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194525 */     GIR_RootConstrainSelectedInstOperands,
     /* 194526 */     // GIR_Coverage, 61,
     /* 194526 */     GIR_EraseRootFromParent_Done,
     /* 194527 */   // Label 3890: @194527
     /* 194527 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(194581), // Rule ID 62 //
     /* 194532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194557 */     // MIs[0] Operand 3
     /* 194557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 194568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194572 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194579 */     GIR_RootConstrainSelectedInstOperands,
     /* 194580 */     // GIR_Coverage, 62,
     /* 194580 */     GIR_EraseRootFromParent_Done,
     /* 194581 */   // Label 3891: @194581
     /* 194581 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(194637), // Rule ID 2638 //
     /* 194586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 194594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194608 */     // MIs[0] pattern
     /* 194608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194616 */     // MIs[0] imm4
     /* 194616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1716:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 194627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 194629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 194631 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194633 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194635 */     GIR_RootConstrainSelectedInstOperands,
     /* 194636 */     // GIR_Coverage, 2638,
     /* 194636 */     GIR_EraseRootFromParent_Done,
     /* 194637 */   // Label 3892: @194637
     /* 194637 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(194693), // Rule ID 2647 //
     /* 194642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 194650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194664 */     // MIs[0] pattern
     /* 194664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194672 */     // MIs[0] imm4
     /* 194672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194680 */     // (intrinsic_wo_chain:{ *:[i32] } 1922:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 194683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194687 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194689 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194691 */     GIR_RootConstrainSelectedInstOperands,
     /* 194692 */     // GIR_Coverage, 2647,
     /* 194692 */     GIR_EraseRootFromParent_Done,
     /* 194693 */   // Label 3893: @194693
     /* 194693 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(194749), // Rule ID 2648 //
     /* 194698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 194706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194720 */     // MIs[0] pattern
     /* 194720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194728 */     // MIs[0] imm4
     /* 194728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194736 */     // (intrinsic_wo_chain:{ *:[i64] } 1712:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 194739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194743 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194745 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194747 */     GIR_RootConstrainSelectedInstOperands,
     /* 194748 */     // GIR_Coverage, 2648,
     /* 194748 */     GIR_EraseRootFromParent_Done,
     /* 194749 */   // Label 3894: @194749
     /* 194749 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(194805), // Rule ID 9826 //
     /* 194754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 194762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194776 */     // MIs[0] pattern
     /* 194776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194784 */     // MIs[0] imm4
     /* 194784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194792 */     // (intrinsic_wo_chain:{ *:[i32] } 1908:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 194795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194799 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194801 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194803 */     GIR_RootConstrainSelectedInstOperands,
     /* 194804 */     // GIR_Coverage, 9826,
     /* 194804 */     GIR_EraseRootFromParent_Done,
     /* 194805 */   // Label 3895: @194805
     /* 194805 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(194861), // Rule ID 9827 //
     /* 194810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 194818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194832 */     // MIs[0] pattern
     /* 194832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194840 */     // MIs[0] imm4
     /* 194840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194848 */     // (intrinsic_wo_chain:{ *:[i64] } 1923:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 194851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194855 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194857 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194859 */     GIR_RootConstrainSelectedInstOperands,
     /* 194860 */     // GIR_Coverage, 9827,
     /* 194860 */     GIR_EraseRootFromParent_Done,
     /* 194861 */   // Label 3896: @194861
     /* 194861 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(194917), // Rule ID 9828 //
     /* 194866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 194874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194888 */     // MIs[0] pattern
     /* 194888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194896 */     // MIs[0] imm4
     /* 194896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194904 */     // (intrinsic_wo_chain:{ *:[i64] } 1678:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 194907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194911 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194913 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194915 */     GIR_RootConstrainSelectedInstOperands,
     /* 194916 */     // GIR_Coverage, 9828,
     /* 194916 */     GIR_EraseRootFromParent_Done,
     /* 194917 */   // Label 3897: @194917
     /* 194917 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(194973), // Rule ID 9829 //
     /* 194922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 194930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194944 */     // MIs[0] pattern
     /* 194944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194952 */     // MIs[0] imm4
     /* 194952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194960 */     // (intrinsic_wo_chain:{ *:[i64] } 1909:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 194963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194967 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194969 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194971 */     GIR_RootConstrainSelectedInstOperands,
     /* 194972 */     // GIR_Coverage, 9829,
     /* 194972 */     GIR_EraseRootFromParent_Done,
     /* 194973 */   // Label 3898: @194973
     /* 194973 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195029), // Rule ID 9832 //
     /* 194978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 194986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195000 */     // MIs[0] pattern
     /* 195000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195008 */     // MIs[0] imm4
     /* 195008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195016 */     // (intrinsic_wo_chain:{ *:[i32] } 1928:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 195019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195023 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195027 */     GIR_RootConstrainSelectedInstOperands,
     /* 195028 */     // GIR_Coverage, 9832,
     /* 195028 */     GIR_EraseRootFromParent_Done,
     /* 195029 */   // Label 3899: @195029
     /* 195029 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195085), // Rule ID 9835 //
     /* 195034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 195042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195056 */     // MIs[0] pattern
     /* 195056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195064 */     // MIs[0] imm4
     /* 195064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195072 */     // (intrinsic_wo_chain:{ *:[i32] } 1914:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 195075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195079 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195081 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195083 */     GIR_RootConstrainSelectedInstOperands,
     /* 195084 */     // GIR_Coverage, 9835,
     /* 195084 */     GIR_EraseRootFromParent_Done,
     /* 195085 */   // Label 3900: @195085
     /* 195085 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195141), // Rule ID 9836 //
     /* 195090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 195098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195112 */     // MIs[0] pattern
     /* 195112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195120 */     // MIs[0] imm4
     /* 195120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195128 */     // (intrinsic_wo_chain:{ *:[i64] } 1718:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 195131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195135 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195137 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195139 */     GIR_RootConstrainSelectedInstOperands,
     /* 195140 */     // GIR_Coverage, 9836,
     /* 195140 */     GIR_EraseRootFromParent_Done,
     /* 195141 */   // Label 3901: @195141
     /* 195141 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195197), // Rule ID 9837 //
     /* 195146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 195154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195168 */     // MIs[0] pattern
     /* 195168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195176 */     // MIs[0] imm4
     /* 195176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195184 */     // (intrinsic_wo_chain:{ *:[i64] } 1929:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 195187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195191 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195193 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195195 */     GIR_RootConstrainSelectedInstOperands,
     /* 195196 */     // GIR_Coverage, 9837,
     /* 195196 */     GIR_EraseRootFromParent_Done,
     /* 195197 */   // Label 3902: @195197
     /* 195197 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195253), // Rule ID 9838 //
     /* 195202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 195210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195224 */     // MIs[0] pattern
     /* 195224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195232 */     // MIs[0] imm4
     /* 195232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195240 */     // (intrinsic_wo_chain:{ *:[i64] } 1684:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 195243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195247 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195249 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195251 */     GIR_RootConstrainSelectedInstOperands,
     /* 195252 */     // GIR_Coverage, 9838,
     /* 195252 */     GIR_EraseRootFromParent_Done,
     /* 195253 */   // Label 3903: @195253
     /* 195253 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195309), // Rule ID 9839 //
     /* 195258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 195266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195280 */     // MIs[0] pattern
     /* 195280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195288 */     // MIs[0] imm4
     /* 195288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195296 */     // (intrinsic_wo_chain:{ *:[i64] } 1915:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195303 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195305 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195307 */     GIR_RootConstrainSelectedInstOperands,
     /* 195308 */     // GIR_Coverage, 9839,
     /* 195308 */     GIR_EraseRootFromParent_Done,
     /* 195309 */   // Label 3904: @195309
     /* 195309 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195365), // Rule ID 9842 //
     /* 195314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 195322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195336 */     // MIs[0] pattern
     /* 195336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195344 */     // MIs[0] imm4
     /* 195344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195352 */     // (intrinsic_wo_chain:{ *:[i32] } 1934:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 195355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195359 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195361 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195363 */     GIR_RootConstrainSelectedInstOperands,
     /* 195364 */     // GIR_Coverage, 9842,
     /* 195364 */     GIR_EraseRootFromParent_Done,
     /* 195365 */   // Label 3905: @195365
     /* 195365 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195421), // Rule ID 9845 //
     /* 195370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 195378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195392 */     // MIs[0] pattern
     /* 195392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195400 */     // MIs[0] imm4
     /* 195400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195408 */     // (intrinsic_wo_chain:{ *:[i32] } 1920:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 195411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195415 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195417 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195419 */     GIR_RootConstrainSelectedInstOperands,
     /* 195420 */     // GIR_Coverage, 9845,
     /* 195420 */     GIR_EraseRootFromParent_Done,
     /* 195421 */   // Label 3906: @195421
     /* 195421 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195477), // Rule ID 9846 //
     /* 195426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 195434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195448 */     // MIs[0] pattern
     /* 195448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195456 */     // MIs[0] imm4
     /* 195456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195464 */     // (intrinsic_wo_chain:{ *:[i64] } 1724:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 195467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195471 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195473 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195475 */     GIR_RootConstrainSelectedInstOperands,
     /* 195476 */     // GIR_Coverage, 9846,
     /* 195476 */     GIR_EraseRootFromParent_Done,
     /* 195477 */   // Label 3907: @195477
     /* 195477 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(195533), // Rule ID 9847 //
     /* 195482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 195490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195504 */     // MIs[0] pattern
     /* 195504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195512 */     // MIs[0] imm4
     /* 195512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195520 */     // (intrinsic_wo_chain:{ *:[i64] } 1935:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 195523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195527 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195531 */     GIR_RootConstrainSelectedInstOperands,
     /* 195532 */     // GIR_Coverage, 9847,
     /* 195532 */     GIR_EraseRootFromParent_Done,
     /* 195533 */   // Label 3908: @195533
     /* 195533 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(195589), // Rule ID 9848 //
     /* 195538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 195546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195560 */     // MIs[0] pattern
     /* 195560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195568 */     // MIs[0] imm4
     /* 195568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195576 */     // (intrinsic_wo_chain:{ *:[i64] } 1690:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 195579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195583 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195585 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195587 */     GIR_RootConstrainSelectedInstOperands,
     /* 195588 */     // GIR_Coverage, 9848,
     /* 195588 */     GIR_EraseRootFromParent_Done,
     /* 195589 */   // Label 3909: @195589
     /* 195589 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(195645), // Rule ID 9849 //
     /* 195594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 195602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195616 */     // MIs[0] pattern
     /* 195616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195624 */     // MIs[0] imm4
     /* 195624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195632 */     // (intrinsic_wo_chain:{ *:[i64] } 1921:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 195635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195639 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195641 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195643 */     GIR_RootConstrainSelectedInstOperands,
     /* 195644 */     // GIR_Coverage, 9849,
     /* 195644 */     GIR_EraseRootFromParent_Done,
     /* 195645 */   // Label 3910: @195645
     /* 195645 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(195701), // Rule ID 9852 //
     /* 195650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 195658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195672 */     // MIs[0] pattern
     /* 195672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195680 */     // MIs[0] imm4
     /* 195680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195688 */     // (intrinsic_wo_chain:{ *:[i32] } 1925:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 195691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195695 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195697 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195699 */     GIR_RootConstrainSelectedInstOperands,
     /* 195700 */     // GIR_Coverage, 9852,
     /* 195700 */     GIR_EraseRootFromParent_Done,
     /* 195701 */   // Label 3911: @195701
     /* 195701 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(195757), // Rule ID 9855 //
     /* 195706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 195714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195728 */     // MIs[0] pattern
     /* 195728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195736 */     // MIs[0] imm4
     /* 195736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195744 */     // (intrinsic_wo_chain:{ *:[i32] } 1911:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 195747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195751 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195753 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195755 */     GIR_RootConstrainSelectedInstOperands,
     /* 195756 */     // GIR_Coverage, 9855,
     /* 195756 */     GIR_EraseRootFromParent_Done,
     /* 195757 */   // Label 3912: @195757
     /* 195757 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(195813), // Rule ID 9856 //
     /* 195762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 195770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195784 */     // MIs[0] pattern
     /* 195784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195792 */     // MIs[0] imm4
     /* 195792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195800 */     // (intrinsic_wo_chain:{ *:[i64] } 1715:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 195803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195807 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195809 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195811 */     GIR_RootConstrainSelectedInstOperands,
     /* 195812 */     // GIR_Coverage, 9856,
     /* 195812 */     GIR_EraseRootFromParent_Done,
     /* 195813 */   // Label 3913: @195813
     /* 195813 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(195869), // Rule ID 9857 //
     /* 195818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 195826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195840 */     // MIs[0] pattern
     /* 195840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195848 */     // MIs[0] imm4
     /* 195848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195856 */     // (intrinsic_wo_chain:{ *:[i64] } 1926:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 195859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195865 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195867 */     GIR_RootConstrainSelectedInstOperands,
     /* 195868 */     // GIR_Coverage, 9857,
     /* 195868 */     GIR_EraseRootFromParent_Done,
     /* 195869 */   // Label 3914: @195869
     /* 195869 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(195925), // Rule ID 9858 //
     /* 195874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 195882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195896 */     // MIs[0] pattern
     /* 195896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195904 */     // MIs[0] imm4
     /* 195904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195912 */     // (intrinsic_wo_chain:{ *:[i64] } 1681:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 195915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195919 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195921 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195923 */     GIR_RootConstrainSelectedInstOperands,
     /* 195924 */     // GIR_Coverage, 9858,
     /* 195924 */     GIR_EraseRootFromParent_Done,
     /* 195925 */   // Label 3915: @195925
     /* 195925 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(195981), // Rule ID 9859 //
     /* 195930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 195938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195952 */     // MIs[0] pattern
     /* 195952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195960 */     // MIs[0] imm4
     /* 195960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195968 */     // (intrinsic_wo_chain:{ *:[i64] } 1912:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 195971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195975 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195977 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195979 */     GIR_RootConstrainSelectedInstOperands,
     /* 195980 */     // GIR_Coverage, 9859,
     /* 195980 */     GIR_EraseRootFromParent_Done,
     /* 195981 */   // Label 3916: @195981
     /* 195981 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196037), // Rule ID 9860 //
     /* 195986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 195994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196008 */     // MIs[0] pattern
     /* 196008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196016 */     // MIs[0] imm4
     /* 196016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 196027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196031 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196033 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196035 */     GIR_RootConstrainSelectedInstOperands,
     /* 196036 */     // GIR_Coverage, 9860,
     /* 196036 */     GIR_EraseRootFromParent_Done,
     /* 196037 */   // Label 3917: @196037
     /* 196037 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196093), // Rule ID 9861 //
     /* 196042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 196050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196064 */     // MIs[0] pattern
     /* 196064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196072 */     // MIs[0] imm4
     /* 196072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 196083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196087 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196089 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196091 */     GIR_RootConstrainSelectedInstOperands,
     /* 196092 */     // GIR_Coverage, 9861,
     /* 196092 */     GIR_EraseRootFromParent_Done,
     /* 196093 */   // Label 3918: @196093
     /* 196093 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196149), // Rule ID 9862 //
     /* 196098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 196106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196120 */     // MIs[0] pattern
     /* 196120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196128 */     // MIs[0] imm4
     /* 196128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 196139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196143 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196145 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196147 */     GIR_RootConstrainSelectedInstOperands,
     /* 196148 */     // GIR_Coverage, 9862,
     /* 196148 */     GIR_EraseRootFromParent_Done,
     /* 196149 */   // Label 3919: @196149
     /* 196149 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196205), // Rule ID 9863 //
     /* 196154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 196162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196176 */     // MIs[0] pattern
     /* 196176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196184 */     // MIs[0] imm4
     /* 196184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 196195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196201 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196203 */     GIR_RootConstrainSelectedInstOperands,
     /* 196204 */     // GIR_Coverage, 9863,
     /* 196204 */     GIR_EraseRootFromParent_Done,
     /* 196205 */   // Label 3920: @196205
     /* 196205 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196261), // Rule ID 9864 //
     /* 196210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 196218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196232 */     // MIs[0] pattern
     /* 196232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196240 */     // MIs[0] imm4
     /* 196240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 196251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196255 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196257 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196259 */     GIR_RootConstrainSelectedInstOperands,
     /* 196260 */     // GIR_Coverage, 9864,
     /* 196260 */     GIR_EraseRootFromParent_Done,
     /* 196261 */   // Label 3921: @196261
     /* 196261 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196317), // Rule ID 9865 //
     /* 196266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 196274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196288 */     // MIs[0] pattern
     /* 196288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196296 */     // MIs[0] imm4
     /* 196296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 196307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196311 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196313 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196315 */     GIR_RootConstrainSelectedInstOperands,
     /* 196316 */     // GIR_Coverage, 9865,
     /* 196316 */     GIR_EraseRootFromParent_Done,
     /* 196317 */   // Label 3922: @196317
     /* 196317 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196373), // Rule ID 9866 //
     /* 196322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 196330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196344 */     // MIs[0] pattern
     /* 196344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196352 */     // MIs[0] imm4
     /* 196352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 196363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196367 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196369 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196371 */     GIR_RootConstrainSelectedInstOperands,
     /* 196372 */     // GIR_Coverage, 9866,
     /* 196372 */     GIR_EraseRootFromParent_Done,
     /* 196373 */   // Label 3923: @196373
     /* 196373 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196429), // Rule ID 9867 //
     /* 196378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 196386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196400 */     // MIs[0] pattern
     /* 196400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196408 */     // MIs[0] imm4
     /* 196408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 196419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196423 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196425 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196427 */     GIR_RootConstrainSelectedInstOperands,
     /* 196428 */     // GIR_Coverage, 9867,
     /* 196428 */     GIR_EraseRootFromParent_Done,
     /* 196429 */   // Label 3924: @196429
     /* 196429 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196485), // Rule ID 9868 //
     /* 196434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 196442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196456 */     // MIs[0] pattern
     /* 196456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196464 */     // MIs[0] imm4
     /* 196464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 196475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196479 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196481 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196483 */     GIR_RootConstrainSelectedInstOperands,
     /* 196484 */     // GIR_Coverage, 9868,
     /* 196484 */     GIR_EraseRootFromParent_Done,
     /* 196485 */   // Label 3925: @196485
     /* 196485 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196541), // Rule ID 9869 //
     /* 196490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 196498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196512 */     // MIs[0] pattern
     /* 196512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196520 */     // MIs[0] imm4
     /* 196520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1679:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 196531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196535 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196537 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196539 */     GIR_RootConstrainSelectedInstOperands,
     /* 196540 */     // GIR_Coverage, 9869,
     /* 196540 */     GIR_EraseRootFromParent_Done,
     /* 196541 */   // Label 3926: @196541
     /* 196541 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196597), // Rule ID 9870 //
     /* 196546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 196554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196568 */     // MIs[0] pattern
     /* 196568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196576 */     // MIs[0] imm4
     /* 196576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 196587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196591 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196593 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196595 */     GIR_RootConstrainSelectedInstOperands,
     /* 196596 */     // GIR_Coverage, 9870,
     /* 196596 */     GIR_EraseRootFromParent_Done,
     /* 196597 */   // Label 3927: @196597
     /* 196597 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196687), // Rule ID 47 //
     /* 196602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196667 */     // MIs[2] Operand 1
     /* 196667 */     // No operand predicates
     /* 196667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196669 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 196672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196685 */     GIR_RootConstrainSelectedInstOperands,
     /* 196686 */     // GIR_Coverage, 47,
     /* 196686 */     GIR_EraseRootFromParent_Done,
     /* 196687 */   // Label 3928: @196687
     /* 196687 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196777), // Rule ID 48 //
     /* 196692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196757 */     // MIs[2] Operand 1
     /* 196757 */     // No operand predicates
     /* 196757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196759 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 196762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196775 */     GIR_RootConstrainSelectedInstOperands,
     /* 196776 */     // GIR_Coverage, 48,
     /* 196776 */     GIR_EraseRootFromParent_Done,
     /* 196777 */   // Label 3929: @196777
     /* 196777 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196867), // Rule ID 49 //
     /* 196782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196843 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196847 */     // MIs[2] Operand 1
     /* 196847 */     // No operand predicates
     /* 196847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196849 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 196852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196865 */     GIR_RootConstrainSelectedInstOperands,
     /* 196866 */     // GIR_Coverage, 49,
     /* 196866 */     GIR_EraseRootFromParent_Done,
     /* 196867 */   // Label 3930: @196867
     /* 196867 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(196957), // Rule ID 50 //
     /* 196872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196937 */     // MIs[2] Operand 1
     /* 196937 */     // No operand predicates
     /* 196937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196939 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 196942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196955 */     GIR_RootConstrainSelectedInstOperands,
     /* 196956 */     // GIR_Coverage, 50,
     /* 196956 */     GIR_EraseRootFromParent_Done,
     /* 196957 */   // Label 3931: @196957
     /* 196957 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197047), // Rule ID 51 //
     /* 196962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 196970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197027 */     // MIs[2] Operand 1
     /* 197027 */     // No operand predicates
     /* 197027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197029 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 197032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197045 */     GIR_RootConstrainSelectedInstOperands,
     /* 197046 */     // GIR_Coverage, 51,
     /* 197046 */     GIR_EraseRootFromParent_Done,
     /* 197047 */   // Label 3932: @197047
     /* 197047 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197137), // Rule ID 52 //
     /* 197052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 197055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 197060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197117 */     // MIs[2] Operand 1
     /* 197117 */     // No operand predicates
     /* 197117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197119 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 197122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197135 */     GIR_RootConstrainSelectedInstOperands,
     /* 197136 */     // GIR_Coverage, 52,
     /* 197136 */     GIR_EraseRootFromParent_Done,
     /* 197137 */   // Label 3933: @197137
     /* 197137 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197227), // Rule ID 53 //
     /* 197142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 197145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 197150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197207 */     // MIs[2] Operand 1
     /* 197207 */     // No operand predicates
     /* 197207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197209 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 197212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197225 */     GIR_RootConstrainSelectedInstOperands,
     /* 197226 */     // GIR_Coverage, 53,
     /* 197226 */     GIR_EraseRootFromParent_Done,
     /* 197227 */   // Label 3934: @197227
     /* 197227 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197317), // Rule ID 54 //
     /* 197232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 197235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 197240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197297 */     // MIs[2] Operand 1
     /* 197297 */     // No operand predicates
     /* 197297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197299 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 197302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197315 */     GIR_RootConstrainSelectedInstOperands,
     /* 197316 */     // GIR_Coverage, 54,
     /* 197316 */     GIR_EraseRootFromParent_Done,
     /* 197317 */   // Label 3935: @197317
     /* 197317 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197407), // Rule ID 2063 //
     /* 197322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197387 */     // MIs[2] Operand 1
     /* 197387 */     // No operand predicates
     /* 197387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197389 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 197392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197405 */     GIR_RootConstrainSelectedInstOperands,
     /* 197406 */     // GIR_Coverage, 2063,
     /* 197406 */     GIR_EraseRootFromParent_Done,
     /* 197407 */   // Label 3936: @197407
     /* 197407 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197497), // Rule ID 2064 //
     /* 197412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197473 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197477 */     // MIs[2] Operand 1
     /* 197477 */     // No operand predicates
     /* 197477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197479 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 197482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197495 */     GIR_RootConstrainSelectedInstOperands,
     /* 197496 */     // GIR_Coverage, 2064,
     /* 197496 */     GIR_EraseRootFromParent_Done,
     /* 197497 */   // Label 3937: @197497
     /* 197497 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197587), // Rule ID 2070 //
     /* 197502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197567 */     // MIs[2] Operand 1
     /* 197567 */     // No operand predicates
     /* 197567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197569 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 197572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197585 */     GIR_RootConstrainSelectedInstOperands,
     /* 197586 */     // GIR_Coverage, 2070,
     /* 197586 */     GIR_EraseRootFromParent_Done,
     /* 197587 */   // Label 3938: @197587
     /* 197587 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197677), // Rule ID 2071 //
     /* 197592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197657 */     // MIs[2] Operand 1
     /* 197657 */     // No operand predicates
     /* 197657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197659 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 197662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197675 */     GIR_RootConstrainSelectedInstOperands,
     /* 197676 */     // GIR_Coverage, 2071,
     /* 197676 */     GIR_EraseRootFromParent_Done,
     /* 197677 */   // Label 3939: @197677
     /* 197677 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197767), // Rule ID 2066 //
     /* 197682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197747 */     // MIs[2] Operand 1
     /* 197747 */     // No operand predicates
     /* 197747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197749 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 197752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197765 */     GIR_RootConstrainSelectedInstOperands,
     /* 197766 */     // GIR_Coverage, 2066,
     /* 197766 */     GIR_EraseRootFromParent_Done,
     /* 197767 */   // Label 3940: @197767
     /* 197767 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197857), // Rule ID 2067 //
     /* 197772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197837 */     // MIs[2] Operand 1
     /* 197837 */     // No operand predicates
     /* 197837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 197842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197855 */     GIR_RootConstrainSelectedInstOperands,
     /* 197856 */     // GIR_Coverage, 2067,
     /* 197856 */     GIR_EraseRootFromParent_Done,
     /* 197857 */   // Label 3941: @197857
     /* 197857 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197947), // Rule ID 2073 //
     /* 197862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197927 */     // MIs[2] Operand 1
     /* 197927 */     // No operand predicates
     /* 197927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197929 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 197932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197945 */     GIR_RootConstrainSelectedInstOperands,
     /* 197946 */     // GIR_Coverage, 2073,
     /* 197946 */     GIR_EraseRootFromParent_Done,
     /* 197947 */   // Label 3942: @197947
     /* 197947 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198037), // Rule ID 2074 //
     /* 197952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198013 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198017 */     // MIs[2] Operand 1
     /* 198017 */     // No operand predicates
     /* 198017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 198022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198035 */     GIR_RootConstrainSelectedInstOperands,
     /* 198036 */     // GIR_Coverage, 2074,
     /* 198036 */     GIR_EraseRootFromParent_Done,
     /* 198037 */   // Label 3943: @198037
     /* 198037 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(198127), // Rule ID 2068 //
     /* 198042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 198062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 198082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198107 */     // MIs[2] Operand 1
     /* 198107 */     // No operand predicates
     /* 198107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198109 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 198112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198125 */     GIR_RootConstrainSelectedInstOperands,
     /* 198126 */     // GIR_Coverage, 2068,
     /* 198126 */     GIR_EraseRootFromParent_Done,
     /* 198127 */   // Label 3944: @198127
     /* 198127 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(198217), // Rule ID 2075 //
     /* 198132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 198152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 198172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 198180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 198189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198197 */     // MIs[2] Operand 1
     /* 198197 */     // No operand predicates
     /* 198197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198199 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 198202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 198212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 198215 */     GIR_RootConstrainSelectedInstOperands,
     /* 198216 */     // GIR_Coverage, 2075,
     /* 198216 */     GIR_EraseRootFromParent_Done,
     /* 198217 */   // Label 3945: @198217
     /* 198217 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(198294), // Rule ID 2767 //
     /* 198222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198274 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198278 */     // MIs[2] Operand 1
     /* 198278 */     // No operand predicates
     /* 198278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 198283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198292 */     GIR_RootConstrainSelectedInstOperands,
     /* 198293 */     // GIR_Coverage, 2767,
     /* 198293 */     GIR_EraseRootFromParent_Done,
     /* 198294 */   // Label 3946: @198294
     /* 198294 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(198371), // Rule ID 2768 //
     /* 198299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198351 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198355 */     // MIs[2] Operand 1
     /* 198355 */     // No operand predicates
     /* 198355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198357 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 198360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198369 */     GIR_RootConstrainSelectedInstOperands,
     /* 198370 */     // GIR_Coverage, 2768,
     /* 198370 */     GIR_EraseRootFromParent_Done,
     /* 198371 */   // Label 3947: @198371
     /* 198371 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198448), // Rule ID 2769 //
     /* 198376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198428 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198432 */     // MIs[2] Operand 1
     /* 198432 */     // No operand predicates
     /* 198432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 198437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198446 */     GIR_RootConstrainSelectedInstOperands,
     /* 198447 */     // GIR_Coverage, 2769,
     /* 198447 */     GIR_EraseRootFromParent_Done,
     /* 198448 */   // Label 3948: @198448
     /* 198448 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198525), // Rule ID 2770 //
     /* 198453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198505 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198509 */     // MIs[2] Operand 1
     /* 198509 */     // No operand predicates
     /* 198509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198511 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 198514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198523 */     GIR_RootConstrainSelectedInstOperands,
     /* 198524 */     // GIR_Coverage, 2770,
     /* 198524 */     GIR_EraseRootFromParent_Done,
     /* 198525 */   // Label 3949: @198525
     /* 198525 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198602), // Rule ID 2771 //
     /* 198530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198582 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198586 */     // MIs[2] Operand 1
     /* 198586 */     // No operand predicates
     /* 198586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 198588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198600 */     GIR_RootConstrainSelectedInstOperands,
     /* 198601 */     // GIR_Coverage, 2771,
     /* 198601 */     GIR_EraseRootFromParent_Done,
     /* 198602 */   // Label 3950: @198602
     /* 198602 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198679), // Rule ID 2772 //
     /* 198607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198659 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198663 */     // MIs[2] Operand 1
     /* 198663 */     // No operand predicates
     /* 198663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198665 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 198665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198677 */     GIR_RootConstrainSelectedInstOperands,
     /* 198678 */     // GIR_Coverage, 2772,
     /* 198678 */     GIR_EraseRootFromParent_Done,
     /* 198679 */   // Label 3951: @198679
     /* 198679 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198756), // Rule ID 7713 //
     /* 198684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198736 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198740 */     // MIs[2] Operand 1
     /* 198740 */     // No operand predicates
     /* 198740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198742 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198754 */     GIR_RootConstrainSelectedInstOperands,
     /* 198755 */     // GIR_Coverage, 7713,
     /* 198755 */     GIR_EraseRootFromParent_Done,
     /* 198756 */   // Label 3952: @198756
     /* 198756 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(198833), // Rule ID 7714 //
     /* 198761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198813 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198817 */     // MIs[2] Operand 1
     /* 198817 */     // No operand predicates
     /* 198817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198819 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198831 */     GIR_RootConstrainSelectedInstOperands,
     /* 198832 */     // GIR_Coverage, 7714,
     /* 198832 */     GIR_EraseRootFromParent_Done,
     /* 198833 */   // Label 3953: @198833
     /* 198833 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(198910), // Rule ID 7715 //
     /* 198838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198890 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198894 */     // MIs[2] Operand 1
     /* 198894 */     // No operand predicates
     /* 198894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198896 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198908 */     GIR_RootConstrainSelectedInstOperands,
     /* 198909 */     // GIR_Coverage, 7715,
     /* 198909 */     GIR_EraseRootFromParent_Done,
     /* 198910 */   // Label 3954: @198910
     /* 198910 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(198987), // Rule ID 7716 //
     /* 198915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198967 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198971 */     // MIs[2] Operand 1
     /* 198971 */     // No operand predicates
     /* 198971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198973 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198985 */     GIR_RootConstrainSelectedInstOperands,
     /* 198986 */     // GIR_Coverage, 7716,
     /* 198986 */     GIR_EraseRootFromParent_Done,
     /* 198987 */   // Label 3955: @198987
     /* 198987 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199064), // Rule ID 7717 //
     /* 198992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 199000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199044 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199048 */     // MIs[2] Operand 1
     /* 199048 */     // No operand predicates
     /* 199048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 199053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199062 */     GIR_RootConstrainSelectedInstOperands,
     /* 199063 */     // GIR_Coverage, 7717,
     /* 199063 */     GIR_EraseRootFromParent_Done,
     /* 199064 */   // Label 3956: @199064
     /* 199064 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199141), // Rule ID 7718 //
     /* 199069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 199077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199121 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199125 */     // MIs[2] Operand 1
     /* 199125 */     // No operand predicates
     /* 199125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 199130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199139 */     GIR_RootConstrainSelectedInstOperands,
     /* 199140 */     // GIR_Coverage, 7718,
     /* 199140 */     GIR_EraseRootFromParent_Done,
     /* 199141 */   // Label 3957: @199141
     /* 199141 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(199218), // Rule ID 7719 //
     /* 199146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199198 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199202 */     // MIs[2] Operand 1
     /* 199202 */     // No operand predicates
     /* 199202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 199207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199216 */     GIR_RootConstrainSelectedInstOperands,
     /* 199217 */     // GIR_Coverage, 7719,
     /* 199217 */     GIR_EraseRootFromParent_Done,
     /* 199218 */   // Label 3958: @199218
     /* 199218 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(199295), // Rule ID 7720 //
     /* 199223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199275 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199279 */     // MIs[2] Operand 1
     /* 199279 */     // No operand predicates
     /* 199279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199281 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 199284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199293 */     GIR_RootConstrainSelectedInstOperands,
     /* 199294 */     // GIR_Coverage, 7720,
     /* 199294 */     GIR_EraseRootFromParent_Done,
     /* 199295 */   // Label 3959: @199295
     /* 199295 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(199372), // Rule ID 7721 //
     /* 199300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199352 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199356 */     // MIs[2] Operand 1
     /* 199356 */     // No operand predicates
     /* 199356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 199361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199370 */     GIR_RootConstrainSelectedInstOperands,
     /* 199371 */     // GIR_Coverage, 7721,
     /* 199371 */     GIR_EraseRootFromParent_Done,
     /* 199372 */   // Label 3960: @199372
     /* 199372 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(199449), // Rule ID 7722 //
     /* 199377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199429 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199433 */     // MIs[2] Operand 1
     /* 199433 */     // No operand predicates
     /* 199433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199435 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 199438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 199448 */     // GIR_Coverage, 7722,
     /* 199448 */     GIR_EraseRootFromParent_Done,
     /* 199449 */   // Label 3961: @199449
     /* 199449 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(199526), // Rule ID 7723 //
     /* 199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199506 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199510 */     // MIs[2] Operand 1
     /* 199510 */     // No operand predicates
     /* 199510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199512 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199524 */     GIR_RootConstrainSelectedInstOperands,
     /* 199525 */     // GIR_Coverage, 7723,
     /* 199525 */     GIR_EraseRootFromParent_Done,
     /* 199526 */   // Label 3962: @199526
     /* 199526 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(199603), // Rule ID 7724 //
     /* 199531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199583 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199587 */     // MIs[2] Operand 1
     /* 199587 */     // No operand predicates
     /* 199587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199589 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199601 */     GIR_RootConstrainSelectedInstOperands,
     /* 199602 */     // GIR_Coverage, 7724,
     /* 199602 */     GIR_EraseRootFromParent_Done,
     /* 199603 */   // Label 3963: @199603
     /* 199603 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(199680), // Rule ID 7725 //
     /* 199608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199660 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199664 */     // MIs[2] Operand 1
     /* 199664 */     // No operand predicates
     /* 199664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199666 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199678 */     GIR_RootConstrainSelectedInstOperands,
     /* 199679 */     // GIR_Coverage, 7725,
     /* 199679 */     GIR_EraseRootFromParent_Done,
     /* 199680 */   // Label 3964: @199680
     /* 199680 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(199757), // Rule ID 7726 //
     /* 199685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199737 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199741 */     // MIs[2] Operand 1
     /* 199741 */     // No operand predicates
     /* 199741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199743 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199755 */     GIR_RootConstrainSelectedInstOperands,
     /* 199756 */     // GIR_Coverage, 7726,
     /* 199756 */     GIR_EraseRootFromParent_Done,
     /* 199757 */   // Label 3965: @199757
     /* 199757 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(199834), // Rule ID 7727 //
     /* 199762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199814 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199818 */     // MIs[2] Operand 1
     /* 199818 */     // No operand predicates
     /* 199818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199820 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199832 */     GIR_RootConstrainSelectedInstOperands,
     /* 199833 */     // GIR_Coverage, 7727,
     /* 199833 */     GIR_EraseRootFromParent_Done,
     /* 199834 */   // Label 3966: @199834
     /* 199834 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199911), // Rule ID 7728 //
     /* 199839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199891 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199895 */     // MIs[2] Operand 1
     /* 199895 */     // No operand predicates
     /* 199895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199897 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199909 */     GIR_RootConstrainSelectedInstOperands,
     /* 199910 */     // GIR_Coverage, 7728,
     /* 199910 */     GIR_EraseRootFromParent_Done,
     /* 199911 */   // Label 3967: @199911
     /* 199911 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199988), // Rule ID 7729 //
     /* 199916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199968 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199972 */     // MIs[2] Operand 1
     /* 199972 */     // No operand predicates
     /* 199972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199974 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 199977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199986 */     GIR_RootConstrainSelectedInstOperands,
     /* 199987 */     // GIR_Coverage, 7729,
     /* 199987 */     GIR_EraseRootFromParent_Done,
     /* 199988 */   // Label 3968: @199988
     /* 199988 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(200065), // Rule ID 7730 //
     /* 199993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 200001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200045 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200049 */     // MIs[2] Operand 1
     /* 200049 */     // No operand predicates
     /* 200049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200051 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 200054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200063 */     GIR_RootConstrainSelectedInstOperands,
     /* 200064 */     // GIR_Coverage, 7730,
     /* 200064 */     GIR_EraseRootFromParent_Done,
     /* 200065 */   // Label 3969: @200065
     /* 200065 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(200142), // Rule ID 7731 //
     /* 200070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200122 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200126 */     // MIs[2] Operand 1
     /* 200126 */     // No operand predicates
     /* 200126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200128 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 200131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200140 */     GIR_RootConstrainSelectedInstOperands,
     /* 200141 */     // GIR_Coverage, 7731,
     /* 200141 */     GIR_EraseRootFromParent_Done,
     /* 200142 */   // Label 3970: @200142
     /* 200142 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(200219), // Rule ID 7732 //
     /* 200147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200199 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200203 */     // MIs[2] Operand 1
     /* 200203 */     // No operand predicates
     /* 200203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 200208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200217 */     GIR_RootConstrainSelectedInstOperands,
     /* 200218 */     // GIR_Coverage, 7732,
     /* 200218 */     GIR_EraseRootFromParent_Done,
     /* 200219 */   // Label 3971: @200219
     /* 200219 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(200296), // Rule ID 7733 //
     /* 200224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200276 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200280 */     // MIs[2] Operand 1
     /* 200280 */     // No operand predicates
     /* 200280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 200285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200294 */     GIR_RootConstrainSelectedInstOperands,
     /* 200295 */     // GIR_Coverage, 7733,
     /* 200295 */     GIR_EraseRootFromParent_Done,
     /* 200296 */   // Label 3972: @200296
     /* 200296 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(200373), // Rule ID 7734 //
     /* 200301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200353 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200357 */     // MIs[2] Operand 1
     /* 200357 */     // No operand predicates
     /* 200357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200359 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 200362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200371 */     GIR_RootConstrainSelectedInstOperands,
     /* 200372 */     // GIR_Coverage, 7734,
     /* 200372 */     GIR_EraseRootFromParent_Done,
     /* 200373 */   // Label 3973: @200373
     /* 200373 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(200450), // Rule ID 7735 //
     /* 200378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200430 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200434 */     // MIs[2] Operand 1
     /* 200434 */     // No operand predicates
     /* 200434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 200439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200448 */     GIR_RootConstrainSelectedInstOperands,
     /* 200449 */     // GIR_Coverage, 7735,
     /* 200449 */     GIR_EraseRootFromParent_Done,
     /* 200450 */   // Label 3974: @200450
     /* 200450 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(200527), // Rule ID 7736 //
     /* 200455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200507 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200511 */     // MIs[2] Operand 1
     /* 200511 */     // No operand predicates
     /* 200511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200513 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 200516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200525 */     GIR_RootConstrainSelectedInstOperands,
     /* 200526 */     // GIR_Coverage, 7736,
     /* 200526 */     GIR_EraseRootFromParent_Done,
     /* 200527 */   // Label 3975: @200527
     /* 200527 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(200604), // Rule ID 7737 //
     /* 200532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200584 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200588 */     // MIs[2] Operand 1
     /* 200588 */     // No operand predicates
     /* 200588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200602 */     GIR_RootConstrainSelectedInstOperands,
     /* 200603 */     // GIR_Coverage, 7737,
     /* 200603 */     GIR_EraseRootFromParent_Done,
     /* 200604 */   // Label 3976: @200604
     /* 200604 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200681), // Rule ID 7738 //
     /* 200609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200661 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200665 */     // MIs[2] Operand 1
     /* 200665 */     // No operand predicates
     /* 200665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200667 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200679 */     GIR_RootConstrainSelectedInstOperands,
     /* 200680 */     // GIR_Coverage, 7738,
     /* 200680 */     GIR_EraseRootFromParent_Done,
     /* 200681 */   // Label 3977: @200681
     /* 200681 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(200758), // Rule ID 7739 //
     /* 200686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200738 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200742 */     // MIs[2] Operand 1
     /* 200742 */     // No operand predicates
     /* 200742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200756 */     GIR_RootConstrainSelectedInstOperands,
     /* 200757 */     // GIR_Coverage, 7739,
     /* 200757 */     GIR_EraseRootFromParent_Done,
     /* 200758 */   // Label 3978: @200758
     /* 200758 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200835), // Rule ID 7740 //
     /* 200763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200815 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200819 */     // MIs[2] Operand 1
     /* 200819 */     // No operand predicates
     /* 200819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200821 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200833 */     GIR_RootConstrainSelectedInstOperands,
     /* 200834 */     // GIR_Coverage, 7740,
     /* 200834 */     GIR_EraseRootFromParent_Done,
     /* 200835 */   // Label 3979: @200835
     /* 200835 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200912), // Rule ID 7741 //
     /* 200840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200892 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200896 */     // MIs[2] Operand 1
     /* 200896 */     // No operand predicates
     /* 200896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200898 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200910 */     GIR_RootConstrainSelectedInstOperands,
     /* 200911 */     // GIR_Coverage, 7741,
     /* 200911 */     GIR_EraseRootFromParent_Done,
     /* 200912 */   // Label 3980: @200912
     /* 200912 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200989), // Rule ID 7742 //
     /* 200917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200969 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200973 */     // MIs[2] Operand 1
     /* 200973 */     // No operand predicates
     /* 200973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200975 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200987 */     GIR_RootConstrainSelectedInstOperands,
     /* 200988 */     // GIR_Coverage, 7742,
     /* 200988 */     GIR_EraseRootFromParent_Done,
     /* 200989 */   // Label 3981: @200989
     /* 200989 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(201066), // Rule ID 7743 //
     /* 200994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201046 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201050 */     // MIs[2] Operand 1
     /* 201050 */     // No operand predicates
     /* 201050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 201055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201064 */     GIR_RootConstrainSelectedInstOperands,
     /* 201065 */     // GIR_Coverage, 7743,
     /* 201065 */     GIR_EraseRootFromParent_Done,
     /* 201066 */   // Label 3982: @201066
     /* 201066 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(201143), // Rule ID 7744 //
     /* 201071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201123 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201127 */     // MIs[2] Operand 1
     /* 201127 */     // No operand predicates
     /* 201127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201129 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 201132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201141 */     GIR_RootConstrainSelectedInstOperands,
     /* 201142 */     // GIR_Coverage, 7744,
     /* 201142 */     GIR_EraseRootFromParent_Done,
     /* 201143 */   // Label 3983: @201143
     /* 201143 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(201220), // Rule ID 7745 //
     /* 201148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201200 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201204 */     // MIs[2] Operand 1
     /* 201204 */     // No operand predicates
     /* 201204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201206 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 201209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201218 */     GIR_RootConstrainSelectedInstOperands,
     /* 201219 */     // GIR_Coverage, 7745,
     /* 201219 */     GIR_EraseRootFromParent_Done,
     /* 201220 */   // Label 3984: @201220
     /* 201220 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(201297), // Rule ID 7746 //
     /* 201225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201277 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201281 */     // MIs[2] Operand 1
     /* 201281 */     // No operand predicates
     /* 201281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201283 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 201286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201295 */     GIR_RootConstrainSelectedInstOperands,
     /* 201296 */     // GIR_Coverage, 7746,
     /* 201296 */     GIR_EraseRootFromParent_Done,
     /* 201297 */   // Label 3985: @201297
     /* 201297 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(201374), // Rule ID 7747 //
     /* 201302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201354 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201358 */     // MIs[2] Operand 1
     /* 201358 */     // No operand predicates
     /* 201358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201360 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 201363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201372 */     GIR_RootConstrainSelectedInstOperands,
     /* 201373 */     // GIR_Coverage, 7747,
     /* 201373 */     GIR_EraseRootFromParent_Done,
     /* 201374 */   // Label 3986: @201374
     /* 201374 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(201451), // Rule ID 7748 //
     /* 201379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 201387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201431 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201435 */     // MIs[2] Operand 1
     /* 201435 */     // No operand predicates
     /* 201435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 201440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201449 */     GIR_RootConstrainSelectedInstOperands,
     /* 201450 */     // GIR_Coverage, 7748,
     /* 201450 */     GIR_EraseRootFromParent_Done,
     /* 201451 */   // Label 3987: @201451
     /* 201451 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(201528), // Rule ID 7749 //
     /* 201456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201508 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201512 */     // MIs[2] Operand 1
     /* 201512 */     // No operand predicates
     /* 201512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201514 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201526 */     GIR_RootConstrainSelectedInstOperands,
     /* 201527 */     // GIR_Coverage, 7749,
     /* 201527 */     GIR_EraseRootFromParent_Done,
     /* 201528 */   // Label 3988: @201528
     /* 201528 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(201605), // Rule ID 7750 //
     /* 201533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201585 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201589 */     // MIs[2] Operand 1
     /* 201589 */     // No operand predicates
     /* 201589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201591 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201603 */     GIR_RootConstrainSelectedInstOperands,
     /* 201604 */     // GIR_Coverage, 7750,
     /* 201604 */     GIR_EraseRootFromParent_Done,
     /* 201605 */   // Label 3989: @201605
     /* 201605 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(201682), // Rule ID 7751 //
     /* 201610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201662 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201666 */     // MIs[2] Operand 1
     /* 201666 */     // No operand predicates
     /* 201666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201668 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201680 */     GIR_RootConstrainSelectedInstOperands,
     /* 201681 */     // GIR_Coverage, 7751,
     /* 201681 */     GIR_EraseRootFromParent_Done,
     /* 201682 */   // Label 3990: @201682
     /* 201682 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(201759), // Rule ID 7752 //
     /* 201687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201739 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201743 */     // MIs[2] Operand 1
     /* 201743 */     // No operand predicates
     /* 201743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201745 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201757 */     GIR_RootConstrainSelectedInstOperands,
     /* 201758 */     // GIR_Coverage, 7752,
     /* 201758 */     GIR_EraseRootFromParent_Done,
     /* 201759 */   // Label 3991: @201759
     /* 201759 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(201836), // Rule ID 7753 //
     /* 201764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201816 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201820 */     // MIs[2] Operand 1
     /* 201820 */     // No operand predicates
     /* 201820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201834 */     GIR_RootConstrainSelectedInstOperands,
     /* 201835 */     // GIR_Coverage, 7753,
     /* 201835 */     GIR_EraseRootFromParent_Done,
     /* 201836 */   // Label 3992: @201836
     /* 201836 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(201913), // Rule ID 7754 //
     /* 201841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201893 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201897 */     // MIs[2] Operand 1
     /* 201897 */     // No operand predicates
     /* 201897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201911 */     GIR_RootConstrainSelectedInstOperands,
     /* 201912 */     // GIR_Coverage, 7754,
     /* 201912 */     GIR_EraseRootFromParent_Done,
     /* 201913 */   // Label 3993: @201913
     /* 201913 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(201969), // Rule ID 55 //
     /* 201918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201943 */     // MIs[0] Operand 3
     /* 201943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 201954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201958 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 201961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201967 */     GIR_RootConstrainSelectedInstOperands,
     /* 201968 */     // GIR_Coverage, 55,
     /* 201968 */     GIR_EraseRootFromParent_Done,
     /* 201969 */   // Label 3994: @201969
     /* 201969 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(202025), // Rule ID 56 //
     /* 201974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201999 */     // MIs[0] Operand 3
     /* 201999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 202010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 202014 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 202014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 202017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 202023 */     GIR_RootConstrainSelectedInstOperands,
     /* 202024 */     // GIR_Coverage, 56,
     /* 202024 */     GIR_EraseRootFromParent_Done,
     /* 202025 */   // Label 3995: @202025
     /* 202025 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(202081), // Rule ID 57 //
     /* 202030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202055 */     // MIs[0] Operand 3
     /* 202055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 202066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 202070 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 202070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 202073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 202079 */     GIR_RootConstrainSelectedInstOperands,
     /* 202080 */     // GIR_Coverage, 57,
     /* 202080 */     GIR_EraseRootFromParent_Done,
     /* 202081 */   // Label 3996: @202081
     /* 202081 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(202137), // Rule ID 58 //
     /* 202086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 202089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 202094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 202103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202111 */     // MIs[0] Operand 3
     /* 202111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 202122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 202126 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 202126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 202129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 202135 */     GIR_RootConstrainSelectedInstOperands,
     /* 202136 */     // GIR_Coverage, 58,
     /* 202136 */     GIR_EraseRootFromParent_Done,
     /* 202137 */   // Label 3997: @202137
     /* 202137 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(202192), // Rule ID 2785 //
     /* 202142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 202150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202171 */     // MIs[0] imm
     /* 202171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 202179 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 202179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 202182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202188 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202190 */     GIR_RootConstrainSelectedInstOperands,
     /* 202191 */     // GIR_Coverage, 2785,
     /* 202191 */     GIR_EraseRootFromParent_Done,
     /* 202192 */   // Label 3998: @202192
     /* 202192 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(202247), // Rule ID 2786 //
     /* 202197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 202205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202226 */     // MIs[0] imm
     /* 202226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 202234 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 202234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 202237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202243 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202245 */     GIR_RootConstrainSelectedInstOperands,
     /* 202246 */     // GIR_Coverage, 2786,
     /* 202246 */     GIR_EraseRootFromParent_Done,
     /* 202247 */   // Label 3999: @202247
     /* 202247 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(202302), // Rule ID 2787 //
     /* 202252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 202260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202281 */     // MIs[0] imm
     /* 202281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 202289 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 202289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 202292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202298 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202300 */     GIR_RootConstrainSelectedInstOperands,
     /* 202301 */     // GIR_Coverage, 2787,
     /* 202301 */     GIR_EraseRootFromParent_Done,
     /* 202302 */   // Label 4000: @202302
     /* 202302 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(202357), // Rule ID 3532 //
     /* 202307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 202315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202336 */     // MIs[0] Idx
     /* 202336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 202344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 202344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 202347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 202351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 202353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 202355 */     GIR_RootConstrainSelectedInstOperands,
     /* 202356 */     // GIR_Coverage, 3532,
     /* 202356 */     GIR_EraseRootFromParent_Done,
     /* 202357 */   // Label 4001: @202357
     /* 202357 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(202412), // Rule ID 3533 //
     /* 202362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 202370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202391 */     // MIs[0] Idx
     /* 202391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 202399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 202399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 202402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 202406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 202408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 202410 */     GIR_RootConstrainSelectedInstOperands,
     /* 202411 */     // GIR_Coverage, 3533,
     /* 202411 */     GIR_EraseRootFromParent_Done,
     /* 202412 */   // Label 4002: @202412
     /* 202412 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(202467), // Rule ID 3534 //
     /* 202417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 202425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202446 */     // MIs[0] Idx
     /* 202446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 202454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 202454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 202457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 202461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 202463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 202465 */     GIR_RootConstrainSelectedInstOperands,
     /* 202466 */     // GIR_Coverage, 3534,
     /* 202466 */     GIR_EraseRootFromParent_Done,
     /* 202467 */   // Label 4003: @202467
     /* 202467 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(202522), // Rule ID 3786 //
     /* 202472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 202475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 202480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 202483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 202486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 202489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202501 */     // MIs[0] imm
     /* 202501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 202509 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 202509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 202512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 202518 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202520 */     GIR_RootConstrainSelectedInstOperands,
     /* 202521 */     // GIR_Coverage, 3786,
     /* 202521 */     GIR_EraseRootFromParent_Done,
     /* 202522 */   // Label 4004: @202522
     /* 202522 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(202569), // Rule ID 2839 //
     /* 202527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202548 */     // MIs[0] idx
     /* 202548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202556 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 202556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 202559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202565 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202567 */     GIR_RootConstrainSelectedInstOperands,
     /* 202568 */     // GIR_Coverage, 2839,
     /* 202568 */     GIR_EraseRootFromParent_Done,
     /* 202569 */   // Label 4005: @202569
     /* 202569 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(202616), // Rule ID 2840 //
     /* 202574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202595 */     // MIs[0] idx
     /* 202595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202603 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 202603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 202606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202612 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202614 */     GIR_RootConstrainSelectedInstOperands,
     /* 202615 */     // GIR_Coverage, 2840,
     /* 202615 */     GIR_EraseRootFromParent_Done,
     /* 202616 */   // Label 4006: @202616
     /* 202616 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(202663), // Rule ID 2841 //
     /* 202621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202642 */     // MIs[0] idx
     /* 202642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 202650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 202653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202659 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202661 */     GIR_RootConstrainSelectedInstOperands,
     /* 202662 */     // GIR_Coverage, 2841,
     /* 202662 */     GIR_EraseRootFromParent_Done,
     /* 202663 */   // Label 4007: @202663
     /* 202663 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(202710), // Rule ID 2990 //
     /* 202668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202689 */     // MIs[0] Op3
     /* 202689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202697 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1515:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 202700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202708 */     GIR_RootConstrainSelectedInstOperands,
     /* 202709 */     // GIR_Coverage, 2990,
     /* 202709 */     GIR_EraseRootFromParent_Done,
     /* 202710 */   // Label 4008: @202710
     /* 202710 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(202757), // Rule ID 2991 //
     /* 202715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202736 */     // MIs[0] Op3
     /* 202736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1515:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 202747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202755 */     GIR_RootConstrainSelectedInstOperands,
     /* 202756 */     // GIR_Coverage, 2991,
     /* 202756 */     GIR_EraseRootFromParent_Done,
     /* 202757 */   // Label 4009: @202757
     /* 202757 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(202804), // Rule ID 2992 //
     /* 202762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202783 */     // MIs[0] Op3
     /* 202783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1515:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 202791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 202794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202802 */     GIR_RootConstrainSelectedInstOperands,
     /* 202803 */     // GIR_Coverage, 2992,
     /* 202803 */     GIR_EraseRootFromParent_Done,
     /* 202804 */   // Label 4010: @202804
     /* 202804 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(202851), // Rule ID 2993 //
     /* 202809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202830 */     // MIs[0] Op3
     /* 202830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1661:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 202841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202849 */     GIR_RootConstrainSelectedInstOperands,
     /* 202850 */     // GIR_Coverage, 2993,
     /* 202850 */     GIR_EraseRootFromParent_Done,
     /* 202851 */   // Label 4011: @202851
     /* 202851 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(202898), // Rule ID 2994 //
     /* 202856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202877 */     // MIs[0] Op3
     /* 202877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1661:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 202888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202896 */     GIR_RootConstrainSelectedInstOperands,
     /* 202897 */     // GIR_Coverage, 2994,
     /* 202897 */     GIR_EraseRootFromParent_Done,
     /* 202898 */   // Label 4012: @202898
     /* 202898 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(202945), // Rule ID 3042 //
     /* 202903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202924 */     // MIs[0] Op3
     /* 202924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1772:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 202935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202943 */     GIR_RootConstrainSelectedInstOperands,
     /* 202944 */     // GIR_Coverage, 3042,
     /* 202944 */     GIR_EraseRootFromParent_Done,
     /* 202945 */   // Label 4013: @202945
     /* 202945 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(202992), // Rule ID 3044 //
     /* 202950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202971 */     // MIs[0] Op3
     /* 202971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202979 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1772:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 202982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202990 */     GIR_RootConstrainSelectedInstOperands,
     /* 202991 */     // GIR_Coverage, 3044,
     /* 202991 */     GIR_EraseRootFromParent_Done,
     /* 202992 */   // Label 4014: @202992
     /* 202992 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(203039), // Rule ID 3046 //
     /* 202997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 203005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203018 */     // MIs[0] Op3
     /* 203018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 203026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 203026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 203029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 203031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203037 */     GIR_RootConstrainSelectedInstOperands,
     /* 203038 */     // GIR_Coverage, 3046,
     /* 203038 */     GIR_EraseRootFromParent_Done,
     /* 203039 */   // Label 4015: @203039
     /* 203039 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(203086), // Rule ID 3048 //
     /* 203044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 203052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203065 */     // MIs[0] Op3
     /* 203065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 203073 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 203073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 203076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 203078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203084 */     GIR_RootConstrainSelectedInstOperands,
     /* 203085 */     // GIR_Coverage, 3048,
     /* 203085 */     GIR_EraseRootFromParent_Done,
     /* 203086 */   // Label 4016: @203086
     /* 203086 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(203133), // Rule ID 3070 //
     /* 203091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 203099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203112 */     // MIs[0] Op3
     /* 203112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 203120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 203120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 203123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203131 */     GIR_RootConstrainSelectedInstOperands,
     /* 203132 */     // GIR_Coverage, 3070,
     /* 203132 */     GIR_EraseRootFromParent_Done,
     /* 203133 */   // Label 4017: @203133
     /* 203133 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(203180), // Rule ID 3071 //
     /* 203138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 203146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203159 */     // MIs[0] Op3
     /* 203159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 203167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 203167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 203170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203178 */     GIR_RootConstrainSelectedInstOperands,
     /* 203179 */     // GIR_Coverage, 3071,
     /* 203179 */     GIR_EraseRootFromParent_Done,
     /* 203180 */   // Label 4018: @203180
     /* 203180 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(203227), // Rule ID 3072 //
     /* 203185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 203193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203206 */     // MIs[0] Op3
     /* 203206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 203214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 203214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203225 */     GIR_RootConstrainSelectedInstOperands,
     /* 203226 */     // GIR_Coverage, 3072,
     /* 203226 */     GIR_EraseRootFromParent_Done,
     /* 203227 */   // Label 4019: @203227
     /* 203227 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(203274), // Rule ID 3141 //
     /* 203232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 203240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203253 */     // MIs[0] Op3
     /* 203253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 203261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 203261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 203264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203272 */     GIR_RootConstrainSelectedInstOperands,
     /* 203273 */     // GIR_Coverage, 3141,
     /* 203273 */     GIR_EraseRootFromParent_Done,
     /* 203274 */   // Label 4020: @203274
     /* 203274 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(203321), // Rule ID 3142 //
     /* 203279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 203287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203300 */     // MIs[0] Op3
     /* 203300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 203308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 203308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 203311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203319 */     GIR_RootConstrainSelectedInstOperands,
     /* 203320 */     // GIR_Coverage, 3142,
     /* 203320 */     GIR_EraseRootFromParent_Done,
     /* 203321 */   // Label 4021: @203321
     /* 203321 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(203368), // Rule ID 3143 //
     /* 203326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 203334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203347 */     // MIs[0] Op3
     /* 203347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 203355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 203355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 203358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203366 */     GIR_RootConstrainSelectedInstOperands,
     /* 203367 */     // GIR_Coverage, 3143,
     /* 203367 */     GIR_EraseRootFromParent_Done,
     /* 203368 */   // Label 4022: @203368
     /* 203368 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(203415), // Rule ID 3144 //
     /* 203373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 203381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203394 */     // MIs[0] Op3
     /* 203394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 203402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 203402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 203405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203413 */     GIR_RootConstrainSelectedInstOperands,
     /* 203414 */     // GIR_Coverage, 3144,
     /* 203414 */     GIR_EraseRootFromParent_Done,
     /* 203415 */   // Label 4023: @203415
     /* 203415 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(203462), // Rule ID 3517 //
     /* 203420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 203423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 203428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203441 */     // MIs[0] Op3
     /* 203441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 203449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1263:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 203449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 203452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203460 */     GIR_RootConstrainSelectedInstOperands,
     /* 203461 */     // GIR_Coverage, 3517,
     /* 203461 */     GIR_EraseRootFromParent_Done,
     /* 203462 */   // Label 4024: @203462
     /* 203462 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(203509), // Rule ID 3565 //
     /* 203467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203488 */     // MIs[0] Op3
     /* 203488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1502:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 203499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203507 */     GIR_RootConstrainSelectedInstOperands,
     /* 203508 */     // GIR_Coverage, 3565,
     /* 203508 */     GIR_EraseRootFromParent_Done,
     /* 203509 */   // Label 4025: @203509
     /* 203509 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(203556), // Rule ID 3566 //
     /* 203514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203535 */     // MIs[0] Op3
     /* 203535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1502:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 203555 */     // GIR_Coverage, 3566,
     /* 203555 */     GIR_EraseRootFromParent_Done,
     /* 203556 */   // Label 4026: @203556
     /* 203556 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(203603), // Rule ID 3567 //
     /* 203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203582 */     // MIs[0] Op3
     /* 203582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203601 */     GIR_RootConstrainSelectedInstOperands,
     /* 203602 */     // GIR_Coverage, 3567,
     /* 203602 */     GIR_EraseRootFromParent_Done,
     /* 203603 */   // Label 4027: @203603
     /* 203603 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203650), // Rule ID 3568 //
     /* 203608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203629 */     // MIs[0] Op3
     /* 203629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 203637 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 203637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 203640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203648 */     GIR_RootConstrainSelectedInstOperands,
     /* 203649 */     // GIR_Coverage, 3568,
     /* 203649 */     GIR_EraseRootFromParent_Done,
     /* 203650 */   // Label 4028: @203650
     /* 203650 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(203697), // Rule ID 3569 //
     /* 203655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203676 */     // MIs[0] Op3
     /* 203676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1503:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203695 */     GIR_RootConstrainSelectedInstOperands,
     /* 203696 */     // GIR_Coverage, 3569,
     /* 203696 */     GIR_EraseRootFromParent_Done,
     /* 203697 */   // Label 4029: @203697
     /* 203697 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(203744), // Rule ID 3570 //
     /* 203702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203723 */     // MIs[0] Op3
     /* 203723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203742 */     GIR_RootConstrainSelectedInstOperands,
     /* 203743 */     // GIR_Coverage, 3570,
     /* 203743 */     GIR_EraseRootFromParent_Done,
     /* 203744 */   // Label 4030: @203744
     /* 203744 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(203791), // Rule ID 11151 //
     /* 203749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203770 */     // MIs[0] Op3
     /* 203770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1702:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 203781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203789 */     GIR_RootConstrainSelectedInstOperands,
     /* 203790 */     // GIR_Coverage, 11151,
     /* 203790 */     GIR_EraseRootFromParent_Done,
     /* 203791 */   // Label 4031: @203791
     /* 203791 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(203838), // Rule ID 11152 //
     /* 203796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203817 */     // MIs[0] Op3
     /* 203817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 203828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203836 */     GIR_RootConstrainSelectedInstOperands,
     /* 203837 */     // GIR_Coverage, 11152,
     /* 203837 */     GIR_EraseRootFromParent_Done,
     /* 203838 */   // Label 4032: @203838
     /* 203838 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(203885), // Rule ID 11153 //
     /* 203843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203864 */     // MIs[0] Op3
     /* 203864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 203872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 203872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 203875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203883 */     GIR_RootConstrainSelectedInstOperands,
     /* 203884 */     // GIR_Coverage, 11153,
     /* 203884 */     GIR_EraseRootFromParent_Done,
     /* 203885 */   // Label 4033: @203885
     /* 203885 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(203932), // Rule ID 11154 //
     /* 203890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203911 */     // MIs[0] Op3
     /* 203911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203919 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 203922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203930 */     GIR_RootConstrainSelectedInstOperands,
     /* 203931 */     // GIR_Coverage, 11154,
     /* 203931 */     GIR_EraseRootFromParent_Done,
     /* 203932 */   // Label 4034: @203932
     /* 203932 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(203979), // Rule ID 11155 //
     /* 203937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203958 */     // MIs[0] Op3
     /* 203958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 203969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203977 */     GIR_RootConstrainSelectedInstOperands,
     /* 203978 */     // GIR_Coverage, 11155,
     /* 203978 */     GIR_EraseRootFromParent_Done,
     /* 203979 */   // Label 4035: @203979
     /* 203979 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(204026), // Rule ID 11156 //
     /* 203984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204005 */     // MIs[0] Op3
     /* 204005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 204013 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 204013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 204016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204024 */     GIR_RootConstrainSelectedInstOperands,
     /* 204025 */     // GIR_Coverage, 11156,
     /* 204025 */     GIR_EraseRootFromParent_Done,
     /* 204026 */   // Label 4036: @204026
     /* 204026 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(204073), // Rule ID 11179 //
     /* 204031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 204039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204052 */     // MIs[0] Op3
     /* 204052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 204063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204071 */     GIR_RootConstrainSelectedInstOperands,
     /* 204072 */     // GIR_Coverage, 11179,
     /* 204072 */     GIR_EraseRootFromParent_Done,
     /* 204073 */   // Label 4037: @204073
     /* 204073 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(204120), // Rule ID 11180 //
     /* 204078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 204086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204099 */     // MIs[0] Op3
     /* 204099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 204110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204118 */     GIR_RootConstrainSelectedInstOperands,
     /* 204119 */     // GIR_Coverage, 11180,
     /* 204119 */     GIR_EraseRootFromParent_Done,
     /* 204120 */   // Label 4038: @204120
     /* 204120 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(204167), // Rule ID 11181 //
     /* 204125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 204133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204146 */     // MIs[0] Op3
     /* 204146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1899:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 204157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204165 */     GIR_RootConstrainSelectedInstOperands,
     /* 204166 */     // GIR_Coverage, 11181,
     /* 204166 */     GIR_EraseRootFromParent_Done,
     /* 204167 */   // Label 4039: @204167
     /* 204167 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(204214), // Rule ID 11182 //
     /* 204172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 204180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204193 */     // MIs[0] Op3
     /* 204193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1899:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 204204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204212 */     GIR_RootConstrainSelectedInstOperands,
     /* 204213 */     // GIR_Coverage, 11182,
     /* 204213 */     GIR_EraseRootFromParent_Done,
     /* 204214 */   // Label 4040: @204214
     /* 204214 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(204261), // Rule ID 11183 //
     /* 204219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 204227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204240 */     // MIs[0] Op3
     /* 204240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1901:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 204251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204259 */     GIR_RootConstrainSelectedInstOperands,
     /* 204260 */     // GIR_Coverage, 11183,
     /* 204260 */     GIR_EraseRootFromParent_Done,
     /* 204261 */   // Label 4041: @204261
     /* 204261 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(204308), // Rule ID 11184 //
     /* 204266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 204274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204287 */     // MIs[0] Op3
     /* 204287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1901:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 204298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204306 */     GIR_RootConstrainSelectedInstOperands,
     /* 204307 */     // GIR_Coverage, 11184,
     /* 204307 */     GIR_EraseRootFromParent_Done,
     /* 204308 */   // Label 4042: @204308
     /* 204308 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(204355), // Rule ID 11185 //
     /* 204313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 204321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204334 */     // MIs[0] Op3
     /* 204334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 204345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204353 */     GIR_RootConstrainSelectedInstOperands,
     /* 204354 */     // GIR_Coverage, 11185,
     /* 204354 */     GIR_EraseRootFromParent_Done,
     /* 204355 */   // Label 4043: @204355
     /* 204355 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(204402), // Rule ID 11186 //
     /* 204360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 204368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204381 */     // MIs[0] Op3
     /* 204381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 204392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204400 */     GIR_RootConstrainSelectedInstOperands,
     /* 204401 */     // GIR_Coverage, 11186,
     /* 204401 */     GIR_EraseRootFromParent_Done,
     /* 204402 */   // Label 4044: @204402
     /* 204402 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(204449), // Rule ID 11187 //
     /* 204407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 204415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204428 */     // MIs[0] Op3
     /* 204428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 204439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204447 */     GIR_RootConstrainSelectedInstOperands,
     /* 204448 */     // GIR_Coverage, 11187,
     /* 204448 */     GIR_EraseRootFromParent_Done,
     /* 204449 */   // Label 4045: @204449
     /* 204449 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(204496), // Rule ID 11188 //
     /* 204454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 204462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204475 */     // MIs[0] Op3
     /* 204475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 204486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204494 */     GIR_RootConstrainSelectedInstOperands,
     /* 204495 */     // GIR_Coverage, 11188,
     /* 204495 */     GIR_EraseRootFromParent_Done,
     /* 204496 */   // Label 4046: @204496
     /* 204496 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204543), // Rule ID 11432 //
     /* 204501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204522 */     // MIs[0] Op3
     /* 204522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1768:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 204533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204541 */     GIR_RootConstrainSelectedInstOperands,
     /* 204542 */     // GIR_Coverage, 11432,
     /* 204542 */     GIR_EraseRootFromParent_Done,
     /* 204543 */   // Label 4047: @204543
     /* 204543 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204590), // Rule ID 11433 //
     /* 204548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204569 */     // MIs[0] Op3
     /* 204569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1768:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 204580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204588 */     GIR_RootConstrainSelectedInstOperands,
     /* 204589 */     // GIR_Coverage, 11433,
     /* 204589 */     GIR_EraseRootFromParent_Done,
     /* 204590 */   // Label 4048: @204590
     /* 204590 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204637), // Rule ID 11434 //
     /* 204595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204616 */     // MIs[0] Op3
     /* 204616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 204627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204635 */     GIR_RootConstrainSelectedInstOperands,
     /* 204636 */     // GIR_Coverage, 11434,
     /* 204636 */     GIR_EraseRootFromParent_Done,
     /* 204637 */   // Label 4049: @204637
     /* 204637 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204684), // Rule ID 11435 //
     /* 204642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204663 */     // MIs[0] Op3
     /* 204663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1768:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 204674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204682 */     GIR_RootConstrainSelectedInstOperands,
     /* 204683 */     // GIR_Coverage, 11435,
     /* 204683 */     GIR_EraseRootFromParent_Done,
     /* 204684 */   // Label 4050: @204684
     /* 204684 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204731), // Rule ID 11436 //
     /* 204689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204710 */     // MIs[0] Op3
     /* 204710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1959:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204729 */     GIR_RootConstrainSelectedInstOperands,
     /* 204730 */     // GIR_Coverage, 11436,
     /* 204730 */     GIR_EraseRootFromParent_Done,
     /* 204731 */   // Label 4051: @204731
     /* 204731 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204778), // Rule ID 11438 //
     /* 204736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204757 */     // MIs[0] Op3
     /* 204757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1959:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 204768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204776 */     GIR_RootConstrainSelectedInstOperands,
     /* 204777 */     // GIR_Coverage, 11438,
     /* 204777 */     GIR_EraseRootFromParent_Done,
     /* 204778 */   // Label 4052: @204778
     /* 204778 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204825), // Rule ID 11440 //
     /* 204783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204804 */     // MIs[0] Op3
     /* 204804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 204815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204823 */     GIR_RootConstrainSelectedInstOperands,
     /* 204824 */     // GIR_Coverage, 11440,
     /* 204824 */     GIR_EraseRootFromParent_Done,
     /* 204825 */   // Label 4053: @204825
     /* 204825 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(204872), // Rule ID 11442 //
     /* 204830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204851 */     // MIs[0] Op3
     /* 204851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1959:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 204862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204870 */     GIR_RootConstrainSelectedInstOperands,
     /* 204871 */     // GIR_Coverage, 11442,
     /* 204871 */     GIR_EraseRootFromParent_Done,
     /* 204872 */   // Label 4054: @204872
     /* 204872 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(204919), // Rule ID 11444 //
     /* 204877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204898 */     // MIs[0] Op3
     /* 204898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 204906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 204906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 204909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204917 */     GIR_RootConstrainSelectedInstOperands,
     /* 204918 */     // GIR_Coverage, 11444,
     /* 204918 */     GIR_EraseRootFromParent_Done,
     /* 204919 */   // Label 4055: @204919
     /* 204919 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(204966), // Rule ID 11445 //
     /* 204924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204945 */     // MIs[0] Op3
     /* 204945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 204953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 204953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 204956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204964 */     GIR_RootConstrainSelectedInstOperands,
     /* 204965 */     // GIR_Coverage, 11445,
     /* 204965 */     GIR_EraseRootFromParent_Done,
     /* 204966 */   // Label 4056: @204966
     /* 204966 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205013), // Rule ID 11446 //
     /* 204971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204992 */     // MIs[0] Op3
     /* 204992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 205000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 205000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 205003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205011 */     GIR_RootConstrainSelectedInstOperands,
     /* 205012 */     // GIR_Coverage, 11446,
     /* 205012 */     GIR_EraseRootFromParent_Done,
     /* 205013 */   // Label 4057: @205013
     /* 205013 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205060), // Rule ID 11447 //
     /* 205018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 205026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205039 */     // MIs[0] Op3
     /* 205039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 205047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 205047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 205050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205058 */     GIR_RootConstrainSelectedInstOperands,
     /* 205059 */     // GIR_Coverage, 11447,
     /* 205059 */     GIR_EraseRootFromParent_Done,
     /* 205060 */   // Label 4058: @205060
     /* 205060 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205107), // Rule ID 11522 //
     /* 205065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 205073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205086 */     // MIs[0] Op3
     /* 205086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 205097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205105 */     GIR_RootConstrainSelectedInstOperands,
     /* 205106 */     // GIR_Coverage, 11522,
     /* 205106 */     GIR_EraseRootFromParent_Done,
     /* 205107 */   // Label 4059: @205107
     /* 205107 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205154), // Rule ID 11524 //
     /* 205112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 205120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205133 */     // MIs[0] Op3
     /* 205133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205141 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 205144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205152 */     GIR_RootConstrainSelectedInstOperands,
     /* 205153 */     // GIR_Coverage, 11524,
     /* 205153 */     GIR_EraseRootFromParent_Done,
     /* 205154 */   // Label 4060: @205154
     /* 205154 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205201), // Rule ID 11526 //
     /* 205159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 205167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205180 */     // MIs[0] Op3
     /* 205180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 205191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205199 */     GIR_RootConstrainSelectedInstOperands,
     /* 205200 */     // GIR_Coverage, 11526,
     /* 205200 */     GIR_EraseRootFromParent_Done,
     /* 205201 */   // Label 4061: @205201
     /* 205201 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205248), // Rule ID 11528 //
     /* 205206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 205214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205227 */     // MIs[0] Op3
     /* 205227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 205238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205246 */     GIR_RootConstrainSelectedInstOperands,
     /* 205247 */     // GIR_Coverage, 11528,
     /* 205247 */     GIR_EraseRootFromParent_Done,
     /* 205248 */   // Label 4062: @205248
     /* 205248 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205295), // Rule ID 11530 //
     /* 205253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 205261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205274 */     // MIs[0] Op3
     /* 205274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 205285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205293 */     GIR_RootConstrainSelectedInstOperands,
     /* 205294 */     // GIR_Coverage, 11530,
     /* 205294 */     GIR_EraseRootFromParent_Done,
     /* 205295 */   // Label 4063: @205295
     /* 205295 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205342), // Rule ID 11531 //
     /* 205300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 205308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205321 */     // MIs[0] Op3
     /* 205321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 205332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205340 */     GIR_RootConstrainSelectedInstOperands,
     /* 205341 */     // GIR_Coverage, 11531,
     /* 205341 */     GIR_EraseRootFromParent_Done,
     /* 205342 */   // Label 4064: @205342
     /* 205342 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205389), // Rule ID 11532 //
     /* 205347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 205355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205368 */     // MIs[0] Op3
     /* 205368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 205379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205387 */     GIR_RootConstrainSelectedInstOperands,
     /* 205388 */     // GIR_Coverage, 11532,
     /* 205388 */     GIR_EraseRootFromParent_Done,
     /* 205389 */   // Label 4065: @205389
     /* 205389 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205436), // Rule ID 11533 //
     /* 205394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 205402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205415 */     // MIs[0] Op3
     /* 205415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 205426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205434 */     GIR_RootConstrainSelectedInstOperands,
     /* 205435 */     // GIR_Coverage, 11533,
     /* 205435 */     GIR_EraseRootFromParent_Done,
     /* 205436 */   // Label 4066: @205436
     /* 205436 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205483), // Rule ID 11538 //
     /* 205441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205462 */     // MIs[0] Op3
     /* 205462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 205473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205481 */     GIR_RootConstrainSelectedInstOperands,
     /* 205482 */     // GIR_Coverage, 11538,
     /* 205482 */     GIR_EraseRootFromParent_Done,
     /* 205483 */   // Label 4067: @205483
     /* 205483 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205530), // Rule ID 11539 //
     /* 205488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205509 */     // MIs[0] Op3
     /* 205509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 205520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205528 */     GIR_RootConstrainSelectedInstOperands,
     /* 205529 */     // GIR_Coverage, 11539,
     /* 205529 */     GIR_EraseRootFromParent_Done,
     /* 205530 */   // Label 4068: @205530
     /* 205530 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205577), // Rule ID 11540 //
     /* 205535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205556 */     // MIs[0] Op3
     /* 205556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 205567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205575 */     GIR_RootConstrainSelectedInstOperands,
     /* 205576 */     // GIR_Coverage, 11540,
     /* 205576 */     GIR_EraseRootFromParent_Done,
     /* 205577 */   // Label 4069: @205577
     /* 205577 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205624), // Rule ID 11541 //
     /* 205582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205603 */     // MIs[0] Op3
     /* 205603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205611 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 205614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205622 */     GIR_RootConstrainSelectedInstOperands,
     /* 205623 */     // GIR_Coverage, 11541,
     /* 205623 */     GIR_EraseRootFromParent_Done,
     /* 205624 */   // Label 4070: @205624
     /* 205624 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205671), // Rule ID 11601 //
     /* 205629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205650 */     // MIs[0] Op3
     /* 205650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205658 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 205661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205669 */     GIR_RootConstrainSelectedInstOperands,
     /* 205670 */     // GIR_Coverage, 11601,
     /* 205670 */     GIR_EraseRootFromParent_Done,
     /* 205671 */   // Label 4071: @205671
     /* 205671 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205718), // Rule ID 11602 //
     /* 205676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205697 */     // MIs[0] Op3
     /* 205697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205705 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 205708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205716 */     GIR_RootConstrainSelectedInstOperands,
     /* 205717 */     // GIR_Coverage, 11602,
     /* 205717 */     GIR_EraseRootFromParent_Done,
     /* 205718 */   // Label 4072: @205718
     /* 205718 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(205765), // Rule ID 11603 //
     /* 205723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205744 */     // MIs[0] Op3
     /* 205744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 205755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205763 */     GIR_RootConstrainSelectedInstOperands,
     /* 205764 */     // GIR_Coverage, 11603,
     /* 205764 */     GIR_EraseRootFromParent_Done,
     /* 205765 */   // Label 4073: @205765
     /* 205765 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(205812), // Rule ID 11604 //
     /* 205770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205791 */     // MIs[0] Op3
     /* 205791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1625:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 205802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205810 */     GIR_RootConstrainSelectedInstOperands,
     /* 205811 */     // GIR_Coverage, 11604,
     /* 205811 */     GIR_EraseRootFromParent_Done,
     /* 205812 */   // Label 4074: @205812
     /* 205812 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(205859), // Rule ID 11605 //
     /* 205817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205838 */     // MIs[0] Op3
     /* 205838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 205849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205857 */     GIR_RootConstrainSelectedInstOperands,
     /* 205858 */     // GIR_Coverage, 11605,
     /* 205858 */     GIR_EraseRootFromParent_Done,
     /* 205859 */   // Label 4075: @205859
     /* 205859 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(205906), // Rule ID 11606 //
     /* 205864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205885 */     // MIs[0] Op3
     /* 205885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 205896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205904 */     GIR_RootConstrainSelectedInstOperands,
     /* 205905 */     // GIR_Coverage, 11606,
     /* 205905 */     GIR_EraseRootFromParent_Done,
     /* 205906 */   // Label 4076: @205906
     /* 205906 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(205953), // Rule ID 11607 //
     /* 205911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205932 */     // MIs[0] Op3
     /* 205932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 205943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205951 */     GIR_RootConstrainSelectedInstOperands,
     /* 205952 */     // GIR_Coverage, 11607,
     /* 205952 */     GIR_EraseRootFromParent_Done,
     /* 205953 */   // Label 4077: @205953
     /* 205953 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206000), // Rule ID 11608 //
     /* 205958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205979 */     // MIs[0] Op3
     /* 205979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 205990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205998 */     GIR_RootConstrainSelectedInstOperands,
     /* 205999 */     // GIR_Coverage, 11608,
     /* 205999 */     GIR_EraseRootFromParent_Done,
     /* 206000 */   // Label 4078: @206000
     /* 206000 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206047), // Rule ID 11609 //
     /* 206005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 206013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206026 */     // MIs[0] Op3
     /* 206026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1583:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 206037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206045 */     GIR_RootConstrainSelectedInstOperands,
     /* 206046 */     // GIR_Coverage, 11609,
     /* 206046 */     GIR_EraseRootFromParent_Done,
     /* 206047 */   // Label 4079: @206047
     /* 206047 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206094), // Rule ID 11610 //
     /* 206052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 206060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206073 */     // MIs[0] Op3
     /* 206073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206081 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 206084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206092 */     GIR_RootConstrainSelectedInstOperands,
     /* 206093 */     // GIR_Coverage, 11610,
     /* 206093 */     GIR_EraseRootFromParent_Done,
     /* 206094 */   // Label 4080: @206094
     /* 206094 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206141), // Rule ID 11611 //
     /* 206099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 206107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206120 */     // MIs[0] Op3
     /* 206120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 206131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206139 */     GIR_RootConstrainSelectedInstOperands,
     /* 206140 */     // GIR_Coverage, 11611,
     /* 206140 */     GIR_EraseRootFromParent_Done,
     /* 206141 */   // Label 4081: @206141
     /* 206141 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206188), // Rule ID 11612 //
     /* 206146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 206154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206167 */     // MIs[0] Op3
     /* 206167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 206178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206186 */     GIR_RootConstrainSelectedInstOperands,
     /* 206187 */     // GIR_Coverage, 11612,
     /* 206187 */     GIR_EraseRootFromParent_Done,
     /* 206188 */   // Label 4082: @206188
     /* 206188 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206235), // Rule ID 11613 //
     /* 206193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 206201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206214 */     // MIs[0] Op3
     /* 206214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 206225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206233 */     GIR_RootConstrainSelectedInstOperands,
     /* 206234 */     // GIR_Coverage, 11613,
     /* 206234 */     GIR_EraseRootFromParent_Done,
     /* 206235 */   // Label 4083: @206235
     /* 206235 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206282), // Rule ID 11614 //
     /* 206240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 206248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206261 */     // MIs[0] Op3
     /* 206261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 206272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 206281 */     // GIR_Coverage, 11614,
     /* 206281 */     GIR_EraseRootFromParent_Done,
     /* 206282 */   // Label 4084: @206282
     /* 206282 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206329), // Rule ID 11615 //
     /* 206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 206295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206308 */     // MIs[0] Op3
     /* 206308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 206319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206327 */     GIR_RootConstrainSelectedInstOperands,
     /* 206328 */     // GIR_Coverage, 11615,
     /* 206328 */     GIR_EraseRootFromParent_Done,
     /* 206329 */   // Label 4085: @206329
     /* 206329 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206376), // Rule ID 11616 //
     /* 206334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 206342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206355 */     // MIs[0] Op3
     /* 206355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 206366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206374 */     GIR_RootConstrainSelectedInstOperands,
     /* 206375 */     // GIR_Coverage, 11616,
     /* 206375 */     GIR_EraseRootFromParent_Done,
     /* 206376 */   // Label 4086: @206376
     /* 206376 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(206423), // Rule ID 11617 //
     /* 206381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 206389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206402 */     // MIs[0] Op3
     /* 206402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 206413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206421 */     GIR_RootConstrainSelectedInstOperands,
     /* 206422 */     // GIR_Coverage, 11617,
     /* 206422 */     GIR_EraseRootFromParent_Done,
     /* 206423 */   // Label 4087: @206423
     /* 206423 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(206470), // Rule ID 11618 //
     /* 206428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 206436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206449 */     // MIs[0] Op3
     /* 206449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 206460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206468 */     GIR_RootConstrainSelectedInstOperands,
     /* 206469 */     // GIR_Coverage, 11618,
     /* 206469 */     GIR_EraseRootFromParent_Done,
     /* 206470 */   // Label 4088: @206470
     /* 206470 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(206517), // Rule ID 11619 //
     /* 206475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206496 */     // MIs[0] Op3
     /* 206496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 206507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206515 */     GIR_RootConstrainSelectedInstOperands,
     /* 206516 */     // GIR_Coverage, 11619,
     /* 206516 */     GIR_EraseRootFromParent_Done,
     /* 206517 */   // Label 4089: @206517
     /* 206517 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(206564), // Rule ID 11620 //
     /* 206522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206543 */     // MIs[0] Op3
     /* 206543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 206554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206562 */     GIR_RootConstrainSelectedInstOperands,
     /* 206563 */     // GIR_Coverage, 11620,
     /* 206563 */     GIR_EraseRootFromParent_Done,
     /* 206564 */   // Label 4090: @206564
     /* 206564 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(206611), // Rule ID 11621 //
     /* 206569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206590 */     // MIs[0] Op3
     /* 206590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 206601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206609 */     GIR_RootConstrainSelectedInstOperands,
     /* 206610 */     // GIR_Coverage, 11621,
     /* 206610 */     GIR_EraseRootFromParent_Done,
     /* 206611 */   // Label 4091: @206611
     /* 206611 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(206678), // Rule ID 2590 //
     /* 206616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 206624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 206667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206676 */     GIR_RootConstrainSelectedInstOperands,
     /* 206677 */     // GIR_Coverage, 2590,
     /* 206677 */     GIR_EraseRootFromParent_Done,
     /* 206678 */   // Label 4092: @206678
     /* 206678 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(206745), // Rule ID 7552 //
     /* 206683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206717 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 206734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206743 */     GIR_RootConstrainSelectedInstOperands,
     /* 206744 */     // GIR_Coverage, 7552,
     /* 206744 */     GIR_EraseRootFromParent_Done,
     /* 206745 */   // Label 4093: @206745
     /* 206745 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(206812), // Rule ID 7554 //
     /* 206750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 206801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206810 */     GIR_RootConstrainSelectedInstOperands,
     /* 206811 */     // GIR_Coverage, 7554,
     /* 206811 */     GIR_EraseRootFromParent_Done,
     /* 206812 */   // Label 4094: @206812
     /* 206812 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(206879), // Rule ID 7556 //
     /* 206817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 206868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206877 */     GIR_RootConstrainSelectedInstOperands,
     /* 206878 */     // GIR_Coverage, 7556,
     /* 206878 */     GIR_EraseRootFromParent_Done,
     /* 206879 */   // Label 4095: @206879
     /* 206879 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(206946), // Rule ID 7558 //
     /* 206884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 206935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206944 */     GIR_RootConstrainSelectedInstOperands,
     /* 206945 */     // GIR_Coverage, 7558,
     /* 206945 */     GIR_EraseRootFromParent_Done,
     /* 206946 */   // Label 4096: @206946
     /* 206946 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207013), // Rule ID 7588 //
     /* 206951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206985 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 207002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207011 */     GIR_RootConstrainSelectedInstOperands,
     /* 207012 */     // GIR_Coverage, 7588,
     /* 207012 */     GIR_EraseRootFromParent_Done,
     /* 207013 */   // Label 4097: @207013
     /* 207013 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207080), // Rule ID 7590 //
     /* 207018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 207026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 207069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207078 */     GIR_RootConstrainSelectedInstOperands,
     /* 207079 */     // GIR_Coverage, 7590,
     /* 207079 */     GIR_EraseRootFromParent_Done,
     /* 207080 */   // Label 4098: @207080
     /* 207080 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207147), // Rule ID 7592 //
     /* 207085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 207093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 207136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207145 */     GIR_RootConstrainSelectedInstOperands,
     /* 207146 */     // GIR_Coverage, 7592,
     /* 207146 */     GIR_EraseRootFromParent_Done,
     /* 207147 */   // Label 4099: @207147
     /* 207147 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207214), // Rule ID 7594 //
     /* 207152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 207160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 207203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207212 */     GIR_RootConstrainSelectedInstOperands,
     /* 207213 */     // GIR_Coverage, 7594,
     /* 207213 */     GIR_EraseRootFromParent_Done,
     /* 207214 */   // Label 4100: @207214
     /* 207214 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207281), // Rule ID 7600 //
     /* 207219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 207227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 207270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207279 */     GIR_RootConstrainSelectedInstOperands,
     /* 207280 */     // GIR_Coverage, 7600,
     /* 207280 */     GIR_EraseRootFromParent_Done,
     /* 207281 */   // Label 4101: @207281
     /* 207281 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207348), // Rule ID 7602 //
     /* 207286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 207294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 207337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207346 */     GIR_RootConstrainSelectedInstOperands,
     /* 207347 */     // GIR_Coverage, 7602,
     /* 207347 */     GIR_EraseRootFromParent_Done,
     /* 207348 */   // Label 4102: @207348
     /* 207348 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207415), // Rule ID 7604 //
     /* 207353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 207361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 207404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207413 */     GIR_RootConstrainSelectedInstOperands,
     /* 207414 */     // GIR_Coverage, 7604,
     /* 207414 */     GIR_EraseRootFromParent_Done,
     /* 207415 */   // Label 4103: @207415
     /* 207415 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207482), // Rule ID 7606 //
     /* 207420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 207428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 207471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207480 */     GIR_RootConstrainSelectedInstOperands,
     /* 207481 */     // GIR_Coverage, 7606,
     /* 207481 */     GIR_EraseRootFromParent_Done,
     /* 207482 */   // Label 4104: @207482
     /* 207482 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207549), // Rule ID 11314 //
     /* 207487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 207495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 207538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207547 */     GIR_RootConstrainSelectedInstOperands,
     /* 207548 */     // GIR_Coverage, 11314,
     /* 207548 */     GIR_EraseRootFromParent_Done,
     /* 207549 */   // Label 4105: @207549
     /* 207549 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207616), // Rule ID 11316 //
     /* 207554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 207605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207614 */     GIR_RootConstrainSelectedInstOperands,
     /* 207615 */     // GIR_Coverage, 11316,
     /* 207615 */     GIR_EraseRootFromParent_Done,
     /* 207616 */   // Label 4106: @207616
     /* 207616 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207683), // Rule ID 11318 //
     /* 207621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 207672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207681 */     GIR_RootConstrainSelectedInstOperands,
     /* 207682 */     // GIR_Coverage, 11318,
     /* 207682 */     GIR_EraseRootFromParent_Done,
     /* 207683 */   // Label 4107: @207683
     /* 207683 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207750), // Rule ID 11320 //
     /* 207688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207748 */     GIR_RootConstrainSelectedInstOperands,
     /* 207749 */     // GIR_Coverage, 11320,
     /* 207749 */     GIR_EraseRootFromParent_Done,
     /* 207750 */   // Label 4108: @207750
     /* 207750 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(207817), // Rule ID 11322 //
     /* 207755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 207806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207815 */     GIR_RootConstrainSelectedInstOperands,
     /* 207816 */     // GIR_Coverage, 11322,
     /* 207816 */     GIR_EraseRootFromParent_Done,
     /* 207817 */   // Label 4109: @207817
     /* 207817 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(207884), // Rule ID 11328 //
     /* 207822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 207873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207882 */     GIR_RootConstrainSelectedInstOperands,
     /* 207883 */     // GIR_Coverage, 11328,
     /* 207883 */     GIR_EraseRootFromParent_Done,
     /* 207884 */   // Label 4110: @207884
     /* 207884 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(207951), // Rule ID 11330 //
     /* 207889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 207940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207949 */     GIR_RootConstrainSelectedInstOperands,
     /* 207950 */     // GIR_Coverage, 11330,
     /* 207950 */     GIR_EraseRootFromParent_Done,
     /* 207951 */   // Label 4111: @207951
     /* 207951 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208018), // Rule ID 11332 //
     /* 207956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 208007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208016 */     GIR_RootConstrainSelectedInstOperands,
     /* 208017 */     // GIR_Coverage, 11332,
     /* 208017 */     GIR_EraseRootFromParent_Done,
     /* 208018 */   // Label 4112: @208018
     /* 208018 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208085), // Rule ID 11334 //
     /* 208023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 208031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 208055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208057 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 208060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 208074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 208081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 208083 */     GIR_RootConstrainSelectedInstOperands,
     /* 208084 */     // GIR_Coverage, 11334,
     /* 208084 */     GIR_EraseRootFromParent_Done,
     /* 208085 */   // Label 4113: @208085
     /* 208085 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208139), // Rule ID 30 //
     /* 208090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 208093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 208098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 208107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 208110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208126 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 208126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 208129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208137 */     GIR_RootConstrainSelectedInstOperands,
     /* 208138 */     // GIR_Coverage, 30,
     /* 208138 */     GIR_EraseRootFromParent_Done,
     /* 208139 */   // Label 4114: @208139
     /* 208139 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208193), // Rule ID 31 //
     /* 208144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 208147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 208152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 208161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 208164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 208180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 208183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208191 */     GIR_RootConstrainSelectedInstOperands,
     /* 208192 */     // GIR_Coverage, 31,
     /* 208192 */     GIR_EraseRootFromParent_Done,
     /* 208193 */   // Label 4115: @208193
     /* 208193 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208247), // Rule ID 32 //
     /* 208198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 208201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 208206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 208215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 208218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 208234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 208237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208245 */     GIR_RootConstrainSelectedInstOperands,
     /* 208246 */     // GIR_Coverage, 32,
     /* 208246 */     GIR_EraseRootFromParent_Done,
     /* 208247 */   // Label 4116: @208247
     /* 208247 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208301), // Rule ID 39 //
     /* 208252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 208260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208288 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 208291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208299 */     GIR_RootConstrainSelectedInstOperands,
     /* 208300 */     // GIR_Coverage, 39,
     /* 208300 */     GIR_EraseRootFromParent_Done,
     /* 208301 */   // Label 4117: @208301
     /* 208301 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208355), // Rule ID 40 //
     /* 208306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 208314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208342 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 208345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208353 */     GIR_RootConstrainSelectedInstOperands,
     /* 208354 */     // GIR_Coverage, 40,
     /* 208354 */     GIR_EraseRootFromParent_Done,
     /* 208355 */   // Label 4118: @208355
     /* 208355 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208409), // Rule ID 41 //
     /* 208360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 208368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208396 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 208399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208407 */     GIR_RootConstrainSelectedInstOperands,
     /* 208408 */     // GIR_Coverage, 41,
     /* 208408 */     GIR_EraseRootFromParent_Done,
     /* 208409 */   // Label 4119: @208409
     /* 208409 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208463), // Rule ID 42 //
     /* 208414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 208422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208450 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 208453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208461 */     GIR_RootConstrainSelectedInstOperands,
     /* 208462 */     // GIR_Coverage, 42,
     /* 208462 */     GIR_EraseRootFromParent_Done,
     /* 208463 */   // Label 4120: @208463
     /* 208463 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208517), // Rule ID 43 //
     /* 208468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208504 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 208507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208515 */     GIR_RootConstrainSelectedInstOperands,
     /* 208516 */     // GIR_Coverage, 43,
     /* 208516 */     GIR_EraseRootFromParent_Done,
     /* 208517 */   // Label 4121: @208517
     /* 208517 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(208571), // Rule ID 44 //
     /* 208522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208558 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 208561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208569 */     GIR_RootConstrainSelectedInstOperands,
     /* 208570 */     // GIR_Coverage, 44,
     /* 208570 */     GIR_EraseRootFromParent_Done,
     /* 208571 */   // Label 4122: @208571
     /* 208571 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(208625), // Rule ID 45 //
     /* 208576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208612 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 208615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208623 */     GIR_RootConstrainSelectedInstOperands,
     /* 208624 */     // GIR_Coverage, 45,
     /* 208624 */     GIR_EraseRootFromParent_Done,
     /* 208625 */   // Label 4123: @208625
     /* 208625 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(208679), // Rule ID 46 //
     /* 208630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208666 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 208669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208677 */     GIR_RootConstrainSelectedInstOperands,
     /* 208678 */     // GIR_Coverage, 46,
     /* 208678 */     GIR_EraseRootFromParent_Done,
     /* 208679 */   // Label 4124: @208679
     /* 208679 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(208733), // Rule ID 1580 //
     /* 208684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208720 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 208723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208731 */     GIR_RootConstrainSelectedInstOperands,
     /* 208732 */     // GIR_Coverage, 1580,
     /* 208732 */     GIR_EraseRootFromParent_Done,
     /* 208733 */   // Label 4125: @208733
     /* 208733 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208787), // Rule ID 1581 //
     /* 208738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208774 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 208777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208785 */     GIR_RootConstrainSelectedInstOperands,
     /* 208786 */     // GIR_Coverage, 1581,
     /* 208786 */     GIR_EraseRootFromParent_Done,
     /* 208787 */   // Label 4126: @208787
     /* 208787 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208841), // Rule ID 1582 //
     /* 208792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 208809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 208812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208828 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 208828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 208831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208839 */     GIR_RootConstrainSelectedInstOperands,
     /* 208840 */     // GIR_Coverage, 1582,
     /* 208840 */     GIR_EraseRootFromParent_Done,
     /* 208841 */   // Label 4127: @208841
     /* 208841 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208895), // Rule ID 1583 //
     /* 208846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 208885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208893 */     GIR_RootConstrainSelectedInstOperands,
     /* 208894 */     // GIR_Coverage, 1583,
     /* 208894 */     GIR_EraseRootFromParent_Done,
     /* 208895 */   // Label 4128: @208895
     /* 208895 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208949), // Rule ID 1584 //
     /* 208900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208936 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 208939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208947 */     GIR_RootConstrainSelectedInstOperands,
     /* 208948 */     // GIR_Coverage, 1584,
     /* 208948 */     GIR_EraseRootFromParent_Done,
     /* 208949 */   // Label 4129: @208949
     /* 208949 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209003), // Rule ID 1585 //
     /* 208954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208990 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 208993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209001 */     GIR_RootConstrainSelectedInstOperands,
     /* 209002 */     // GIR_Coverage, 1585,
     /* 209002 */     GIR_EraseRootFromParent_Done,
     /* 209003 */   // Label 4130: @209003
     /* 209003 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209057), // Rule ID 1586 //
     /* 209008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 209011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 209016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 209019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 209022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 209025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 209028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 209032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 209036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 209040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 209044 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 209044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 209047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209055 */     GIR_RootConstrainSelectedInstOperands,
     /* 209056 */     // GIR_Coverage, 1586,
     /* 209056 */     GIR_EraseRootFromParent_Done,
     /* 209057 */   // Label 4131: @209057
     /* 209057 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209111), // Rule ID 1587 //
     /* 209062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 209065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 209070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 209101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209109 */     GIR_RootConstrainSelectedInstOperands,
     /* 209110 */     // GIR_Coverage, 1587,
     /* 209110 */     GIR_EraseRootFromParent_Done,
     /* 209111 */   // Label 4132: @209111
     /* 209111 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209165), // Rule ID 2298 //
     /* 209116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 209124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 209148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 209155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209163 */     GIR_RootConstrainSelectedInstOperands,
     /* 209164 */     // GIR_Coverage, 2298,
     /* 209164 */     GIR_EraseRootFromParent_Done,
     /* 209165 */   // Label 4133: @209165
     /* 209165 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209219), // Rule ID 2299 //
     /* 209170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 209178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 209202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 209209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209217 */     GIR_RootConstrainSelectedInstOperands,
     /* 209218 */     // GIR_Coverage, 2299,
     /* 209218 */     GIR_EraseRootFromParent_Done,
     /* 209219 */   // Label 4134: @209219
     /* 209219 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209273), // Rule ID 2300 //
     /* 209224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 209232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 209241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 209256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209260 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 209263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209271 */     GIR_RootConstrainSelectedInstOperands,
     /* 209272 */     // GIR_Coverage, 2300,
     /* 209272 */     GIR_EraseRootFromParent_Done,
     /* 209273 */   // Label 4135: @209273
     /* 209273 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209327), // Rule ID 2301 //
     /* 209278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 209286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209314 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 209317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209325 */     GIR_RootConstrainSelectedInstOperands,
     /* 209326 */     // GIR_Coverage, 2301,
     /* 209326 */     GIR_EraseRootFromParent_Done,
     /* 209327 */   // Label 4136: @209327
     /* 209327 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209381), // Rule ID 2302 //
     /* 209332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 209340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 209371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209379 */     GIR_RootConstrainSelectedInstOperands,
     /* 209380 */     // GIR_Coverage, 2302,
     /* 209380 */     GIR_EraseRootFromParent_Done,
     /* 209381 */   // Label 4137: @209381
     /* 209381 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209435), // Rule ID 2303 //
     /* 209386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 209394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 209425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209433 */     GIR_RootConstrainSelectedInstOperands,
     /* 209434 */     // GIR_Coverage, 2303,
     /* 209434 */     GIR_EraseRootFromParent_Done,
     /* 209435 */   // Label 4138: @209435
     /* 209435 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209489), // Rule ID 2304 //
     /* 209440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 209448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 209479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209487 */     GIR_RootConstrainSelectedInstOperands,
     /* 209488 */     // GIR_Coverage, 2304,
     /* 209488 */     GIR_EraseRootFromParent_Done,
     /* 209489 */   // Label 4139: @209489
     /* 209489 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209546), // Rule ID 3608 //
     /* 209494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 209533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209539 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209544 */     GIR_RootConstrainSelectedInstOperands,
     /* 209545 */     // GIR_Coverage, 3608,
     /* 209545 */     GIR_EraseRootFromParent_Done,
     /* 209546 */   // Label 4140: @209546
     /* 209546 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209603), // Rule ID 3609 //
     /* 209551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 209590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209596 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209601 */     GIR_RootConstrainSelectedInstOperands,
     /* 209602 */     // GIR_Coverage, 3609,
     /* 209602 */     GIR_EraseRootFromParent_Done,
     /* 209603 */   // Label 4141: @209603
     /* 209603 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209660), // Rule ID 3610 //
     /* 209608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 209647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209658 */     GIR_RootConstrainSelectedInstOperands,
     /* 209659 */     // GIR_Coverage, 3610,
     /* 209659 */     GIR_EraseRootFromParent_Done,
     /* 209660 */   // Label 4142: @209660
     /* 209660 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(209717), // Rule ID 3611 //
     /* 209665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209701 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 209704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209710 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209715 */     GIR_RootConstrainSelectedInstOperands,
     /* 209716 */     // GIR_Coverage, 3611,
     /* 209716 */     GIR_EraseRootFromParent_Done,
     /* 209717 */   // Label 4143: @209717
     /* 209717 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(209771), // Rule ID 3758 //
     /* 209722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 209730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209758 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 209761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209769 */     GIR_RootConstrainSelectedInstOperands,
     /* 209770 */     // GIR_Coverage, 3758,
     /* 209770 */     GIR_EraseRootFromParent_Done,
     /* 209771 */   // Label 4144: @209771
     /* 209771 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(209825), // Rule ID 3759 //
     /* 209776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 209784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209812 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 209815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209823 */     GIR_RootConstrainSelectedInstOperands,
     /* 209824 */     // GIR_Coverage, 3759,
     /* 209824 */     GIR_EraseRootFromParent_Done,
     /* 209825 */   // Label 4145: @209825
     /* 209825 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(209879), // Rule ID 3760 //
     /* 209830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 209838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209866 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 209869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209877 */     GIR_RootConstrainSelectedInstOperands,
     /* 209878 */     // GIR_Coverage, 3760,
     /* 209878 */     GIR_EraseRootFromParent_Done,
     /* 209879 */   // Label 4146: @209879
     /* 209879 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(209933), // Rule ID 3761 //
     /* 209884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209920 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209931 */     GIR_RootConstrainSelectedInstOperands,
     /* 209932 */     // GIR_Coverage, 3761,
     /* 209932 */     GIR_EraseRootFromParent_Done,
     /* 209933 */   // Label 4147: @209933
     /* 209933 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(209987), // Rule ID 3762 //
     /* 209938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209974 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209985 */     GIR_RootConstrainSelectedInstOperands,
     /* 209986 */     // GIR_Coverage, 3762,
     /* 209986 */     GIR_EraseRootFromParent_Done,
     /* 209987 */   // Label 4148: @209987
     /* 209987 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210041), // Rule ID 3763 //
     /* 209992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 210000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210039 */     GIR_RootConstrainSelectedInstOperands,
     /* 210040 */     // GIR_Coverage, 3763,
     /* 210040 */     GIR_EraseRootFromParent_Done,
     /* 210041 */   // Label 4149: @210041
     /* 210041 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210095), // Rule ID 3764 //
     /* 210046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 210054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210082 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210093 */     GIR_RootConstrainSelectedInstOperands,
     /* 210094 */     // GIR_Coverage, 3764,
     /* 210094 */     GIR_EraseRootFromParent_Done,
     /* 210095 */   // Label 4150: @210095
     /* 210095 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210149), // Rule ID 3773 //
     /* 210100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 210108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 210111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 210114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210136 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 210136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210147 */     GIR_RootConstrainSelectedInstOperands,
     /* 210148 */     // GIR_Coverage, 3773,
     /* 210148 */     GIR_EraseRootFromParent_Done,
     /* 210149 */   // Label 4151: @210149
     /* 210149 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210203), // Rule ID 3774 //
     /* 210154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 210162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210190 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 210190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210201 */     GIR_RootConstrainSelectedInstOperands,
     /* 210202 */     // GIR_Coverage, 3774,
     /* 210202 */     GIR_EraseRootFromParent_Done,
     /* 210203 */   // Label 4152: @210203
     /* 210203 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210257), // Rule ID 3775 //
     /* 210208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 210216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210255 */     GIR_RootConstrainSelectedInstOperands,
     /* 210256 */     // GIR_Coverage, 3775,
     /* 210256 */     GIR_EraseRootFromParent_Done,
     /* 210257 */   // Label 4153: @210257
     /* 210257 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210311), // Rule ID 3776 //
     /* 210262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 210270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210298 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210309 */     GIR_RootConstrainSelectedInstOperands,
     /* 210310 */     // GIR_Coverage, 3776,
     /* 210310 */     GIR_EraseRootFromParent_Done,
     /* 210311 */   // Label 4154: @210311
     /* 210311 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210365), // Rule ID 3777 //
     /* 210316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 210327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 210330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210352 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 210352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210363 */     GIR_RootConstrainSelectedInstOperands,
     /* 210364 */     // GIR_Coverage, 3777,
     /* 210364 */     GIR_EraseRootFromParent_Done,
     /* 210365 */   // Label 4155: @210365
     /* 210365 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210419), // Rule ID 3778 //
     /* 210370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 210406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210417 */     GIR_RootConstrainSelectedInstOperands,
     /* 210418 */     // GIR_Coverage, 3778,
     /* 210418 */     GIR_EraseRootFromParent_Done,
     /* 210419 */   // Label 4156: @210419
     /* 210419 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210473), // Rule ID 3779 //
     /* 210424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210471 */     GIR_RootConstrainSelectedInstOperands,
     /* 210472 */     // GIR_Coverage, 3779,
     /* 210472 */     GIR_EraseRootFromParent_Done,
     /* 210473 */   // Label 4157: @210473
     /* 210473 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210527), // Rule ID 3780 //
     /* 210478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210514 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210525 */     GIR_RootConstrainSelectedInstOperands,
     /* 210526 */     // GIR_Coverage, 3780,
     /* 210526 */     GIR_EraseRootFromParent_Done,
     /* 210527 */   // Label 4158: @210527
     /* 210527 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210581), // Rule ID 3781 //
     /* 210532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 210543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 210546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 210568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210579 */     GIR_RootConstrainSelectedInstOperands,
     /* 210580 */     // GIR_Coverage, 3781,
     /* 210580 */     GIR_EraseRootFromParent_Done,
     /* 210581 */   // Label 4159: @210581
     /* 210581 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210635), // Rule ID 3782 //
     /* 210586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210622 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 210622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210633 */     GIR_RootConstrainSelectedInstOperands,
     /* 210634 */     // GIR_Coverage, 3782,
     /* 210634 */     GIR_EraseRootFromParent_Done,
     /* 210635 */   // Label 4160: @210635
     /* 210635 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210689), // Rule ID 3783 //
     /* 210640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210687 */     GIR_RootConstrainSelectedInstOperands,
     /* 210688 */     // GIR_Coverage, 3783,
     /* 210688 */     GIR_EraseRootFromParent_Done,
     /* 210689 */   // Label 4161: @210689
     /* 210689 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(210743), // Rule ID 3784 //
     /* 210694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210730 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210741 */     GIR_RootConstrainSelectedInstOperands,
     /* 210742 */     // GIR_Coverage, 3784,
     /* 210742 */     GIR_EraseRootFromParent_Done,
     /* 210743 */   // Label 4162: @210743
     /* 210743 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(210797), // Rule ID 3788 //
     /* 210748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 210756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210784 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 210784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 210787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 210791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 210793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 210795 */     GIR_RootConstrainSelectedInstOperands,
     /* 210796 */     // GIR_Coverage, 3788,
     /* 210796 */     GIR_EraseRootFromParent_Done,
     /* 210797 */   // Label 4163: @210797
     /* 210797 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(210851), // Rule ID 3789 //
     /* 210802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 210810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210838 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 210841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210849 */     GIR_RootConstrainSelectedInstOperands,
     /* 210850 */     // GIR_Coverage, 3789,
     /* 210850 */     GIR_EraseRootFromParent_Done,
     /* 210851 */   // Label 4164: @210851
     /* 210851 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(210905), // Rule ID 3790 //
     /* 210856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 210864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 210895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210903 */     GIR_RootConstrainSelectedInstOperands,
     /* 210904 */     // GIR_Coverage, 3790,
     /* 210904 */     GIR_EraseRootFromParent_Done,
     /* 210905 */   // Label 4165: @210905
     /* 210905 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(210962), // Rule ID 3807 //
     /* 210910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210946 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 210946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210960 */     GIR_RootConstrainSelectedInstOperands,
     /* 210961 */     // GIR_Coverage, 3807,
     /* 210961 */     GIR_EraseRootFromParent_Done,
     /* 210962 */   // Label 4166: @210962
     /* 210962 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211019), // Rule ID 3808 //
     /* 210967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211003 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 211003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 211006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211017 */     GIR_RootConstrainSelectedInstOperands,
     /* 211018 */     // GIR_Coverage, 3808,
     /* 211018 */     GIR_EraseRootFromParent_Done,
     /* 211019 */   // Label 4167: @211019
     /* 211019 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211076), // Rule ID 3809 //
     /* 211024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 211035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 211038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 211041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 211044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211060 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 211060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 211063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211074 */     GIR_RootConstrainSelectedInstOperands,
     /* 211075 */     // GIR_Coverage, 3809,
     /* 211075 */     GIR_EraseRootFromParent_Done,
     /* 211076 */   // Label 4168: @211076
     /* 211076 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211133), // Rule ID 3810 //
     /* 211081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 211092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 211095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 211098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 211101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211117 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 211117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 211120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211131 */     GIR_RootConstrainSelectedInstOperands,
     /* 211132 */     // GIR_Coverage, 3810,
     /* 211132 */     GIR_EraseRootFromParent_Done,
     /* 211133 */   // Label 4169: @211133
     /* 211133 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211190), // Rule ID 3815 //
     /* 211138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 211152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 211155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 211158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211174 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 211174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 211177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211188 */     GIR_RootConstrainSelectedInstOperands,
     /* 211189 */     // GIR_Coverage, 3815,
     /* 211189 */     GIR_EraseRootFromParent_Done,
     /* 211190 */   // Label 4170: @211190
     /* 211190 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211247), // Rule ID 3816 //
     /* 211195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 211209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 211212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 211215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211231 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 211231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 211234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211245 */     GIR_RootConstrainSelectedInstOperands,
     /* 211246 */     // GIR_Coverage, 3816,
     /* 211246 */     GIR_EraseRootFromParent_Done,
     /* 211247 */   // Label 4171: @211247
     /* 211247 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211304), // Rule ID 3817 //
     /* 211252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 211266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 211269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 211272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211288 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 211288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 211291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211302 */     GIR_RootConstrainSelectedInstOperands,
     /* 211303 */     // GIR_Coverage, 3817,
     /* 211303 */     GIR_EraseRootFromParent_Done,
     /* 211304 */   // Label 4172: @211304
     /* 211304 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211361), // Rule ID 3818 //
     /* 211309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 211312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 211320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 211323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 211326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 211329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211345 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 211345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 211348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211359 */     GIR_RootConstrainSelectedInstOperands,
     /* 211360 */     // GIR_Coverage, 3818,
     /* 211360 */     GIR_EraseRootFromParent_Done,
     /* 211361 */   // Label 4173: @211361
     /* 211361 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211418), // Rule ID 3823 //
     /* 211366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211402 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 211402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211416 */     GIR_RootConstrainSelectedInstOperands,
     /* 211417 */     // GIR_Coverage, 3823,
     /* 211417 */     GIR_EraseRootFromParent_Done,
     /* 211418 */   // Label 4174: @211418
     /* 211418 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211475), // Rule ID 3824 //
     /* 211423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211459 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 211459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211473 */     GIR_RootConstrainSelectedInstOperands,
     /* 211474 */     // GIR_Coverage, 3824,
     /* 211474 */     GIR_EraseRootFromParent_Done,
     /* 211475 */   // Label 4175: @211475
     /* 211475 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211532), // Rule ID 3825 //
     /* 211480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211516 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 211516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211530 */     GIR_RootConstrainSelectedInstOperands,
     /* 211531 */     // GIR_Coverage, 3825,
     /* 211531 */     GIR_EraseRootFromParent_Done,
     /* 211532 */   // Label 4176: @211532
     /* 211532 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211589), // Rule ID 3826 //
     /* 211537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211573 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 211573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211587 */     GIR_RootConstrainSelectedInstOperands,
     /* 211588 */     // GIR_Coverage, 3826,
     /* 211588 */     GIR_EraseRootFromParent_Done,
     /* 211589 */   // Label 4177: @211589
     /* 211589 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211646), // Rule ID 3827 //
     /* 211594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211630 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 211630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211644 */     GIR_RootConstrainSelectedInstOperands,
     /* 211645 */     // GIR_Coverage, 3827,
     /* 211645 */     GIR_EraseRootFromParent_Done,
     /* 211646 */   // Label 4178: @211646
     /* 211646 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211703), // Rule ID 3828 //
     /* 211651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 211687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211701 */     GIR_RootConstrainSelectedInstOperands,
     /* 211702 */     // GIR_Coverage, 3828,
     /* 211702 */     GIR_EraseRootFromParent_Done,
     /* 211703 */   // Label 4179: @211703
     /* 211703 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211760), // Rule ID 3829 //
     /* 211708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211744 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 211744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211758 */     GIR_RootConstrainSelectedInstOperands,
     /* 211759 */     // GIR_Coverage, 3829,
     /* 211759 */     GIR_EraseRootFromParent_Done,
     /* 211760 */   // Label 4180: @211760
     /* 211760 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211817), // Rule ID 3830 //
     /* 211765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211801 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 211801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211815 */     GIR_RootConstrainSelectedInstOperands,
     /* 211816 */     // GIR_Coverage, 3830,
     /* 211816 */     GIR_EraseRootFromParent_Done,
     /* 211817 */   // Label 4181: @211817
     /* 211817 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211874), // Rule ID 3831 //
     /* 211822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211858 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 211858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211872 */     GIR_RootConstrainSelectedInstOperands,
     /* 211873 */     // GIR_Coverage, 3831,
     /* 211873 */     GIR_EraseRootFromParent_Done,
     /* 211874 */   // Label 4182: @211874
     /* 211874 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211931), // Rule ID 3832 //
     /* 211879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211915 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 211915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211929 */     GIR_RootConstrainSelectedInstOperands,
     /* 211930 */     // GIR_Coverage, 3832,
     /* 211930 */     GIR_EraseRootFromParent_Done,
     /* 211931 */   // Label 4183: @211931
     /* 211931 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(211988), // Rule ID 3833 //
     /* 211936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211972 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 211972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211986 */     GIR_RootConstrainSelectedInstOperands,
     /* 211987 */     // GIR_Coverage, 3833,
     /* 211987 */     GIR_EraseRootFromParent_Done,
     /* 211988 */   // Label 4184: @211988
     /* 211988 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212045), // Rule ID 3834 //
     /* 211993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 212001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 212010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 212013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212029 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 212029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 212032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 212038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 212040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 212043 */     GIR_RootConstrainSelectedInstOperands,
     /* 212044 */     // GIR_Coverage, 3834,
     /* 212044 */     GIR_EraseRootFromParent_Done,
     /* 212045 */   // Label 4185: @212045
     /* 212045 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212099), // Rule ID 5169 //
     /* 212050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 212053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 212058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 212061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 212070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212086 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 212086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 212089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 212093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 212095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 212097 */     GIR_RootConstrainSelectedInstOperands,
     /* 212098 */     // GIR_Coverage, 5169,
     /* 212098 */     GIR_EraseRootFromParent_Done,
     /* 212099 */   // Label 4186: @212099
     /* 212099 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212153), // Rule ID 5170 //
     /* 212104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 212107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 212112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 212115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 212121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 212124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 212140 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 212140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 212143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 212147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 212149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 212151 */     GIR_RootConstrainSelectedInstOperands,
     /* 212152 */     // GIR_Coverage, 5170,
     /* 212152 */     GIR_EraseRootFromParent_Done,
     /* 212153 */   // Label 4187: @212153
     /* 212153 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212204), // Rule ID 5516 //
     /* 212158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 212163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 212166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 212169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 212175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 212179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 212183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 212191 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 212191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 212194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 212198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 212200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 212202 */     GIR_RootConstrainSelectedInstOperands,
     /* 212203 */     // GIR_Coverage, 5516,
     /* 212203 */     GIR_EraseRootFromParent_Done,
     /* 212204 */   // Label 4188: @212204
     /* 212204 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212255), // Rule ID 5517 //
     /* 212209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 212214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 212217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 212220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 212223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 212226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 212242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 212245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 212249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 212251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 212253 */     GIR_RootConstrainSelectedInstOperands,
     /* 212254 */     // GIR_Coverage, 5517,
     /* 212254 */     GIR_EraseRootFromParent_Done,
     /* 212255 */   // Label 4189: @212255
     /* 212255 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212297), // Rule ID 2685 //
     /* 212260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 212284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 212287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212295 */     GIR_RootConstrainSelectedInstOperands,
     /* 212296 */     // GIR_Coverage, 2685,
     /* 212296 */     GIR_EraseRootFromParent_Done,
     /* 212297 */   // Label 4190: @212297
     /* 212297 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212339), // Rule ID 2686 //
     /* 212302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 212329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212337 */     GIR_RootConstrainSelectedInstOperands,
     /* 212338 */     // GIR_Coverage, 2686,
     /* 212338 */     GIR_EraseRootFromParent_Done,
     /* 212339 */   // Label 4191: @212339
     /* 212339 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212381), // Rule ID 2687 //
     /* 212344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 212371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212379 */     GIR_RootConstrainSelectedInstOperands,
     /* 212380 */     // GIR_Coverage, 2687,
     /* 212380 */     GIR_EraseRootFromParent_Done,
     /* 212381 */   // Label 4192: @212381
     /* 212381 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212423), // Rule ID 2688 //
     /* 212386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 212413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212421 */     GIR_RootConstrainSelectedInstOperands,
     /* 212422 */     // GIR_Coverage, 2688,
     /* 212422 */     GIR_EraseRootFromParent_Done,
     /* 212423 */   // Label 4193: @212423
     /* 212423 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212465), // Rule ID 2689 //
     /* 212428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1824:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 212455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212463 */     GIR_RootConstrainSelectedInstOperands,
     /* 212464 */     // GIR_Coverage, 2689,
     /* 212464 */     GIR_EraseRootFromParent_Done,
     /* 212465 */   // Label 4194: @212465
     /* 212465 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212507), // Rule ID 2690 //
     /* 212470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1824:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 212497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212505 */     GIR_RootConstrainSelectedInstOperands,
     /* 212506 */     // GIR_Coverage, 2690,
     /* 212506 */     GIR_EraseRootFromParent_Done,
     /* 212507 */   // Label 4195: @212507
     /* 212507 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212549), // Rule ID 2691 //
     /* 212512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1824:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 212539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212547 */     GIR_RootConstrainSelectedInstOperands,
     /* 212548 */     // GIR_Coverage, 2691,
     /* 212548 */     GIR_EraseRootFromParent_Done,
     /* 212549 */   // Label 4196: @212549
     /* 212549 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212591), // Rule ID 2730 //
     /* 212554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 212574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 212578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212589 */     GIR_RootConstrainSelectedInstOperands,
     /* 212590 */     // GIR_Coverage, 2730,
     /* 212590 */     GIR_EraseRootFromParent_Done,
     /* 212591 */   // Label 4197: @212591
     /* 212591 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212633), // Rule ID 2731 //
     /* 212596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 212616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 212620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212631 */     GIR_RootConstrainSelectedInstOperands,
     /* 212632 */     // GIR_Coverage, 2731,
     /* 212632 */     GIR_EraseRootFromParent_Done,
     /* 212633 */   // Label 4198: @212633
     /* 212633 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212675), // Rule ID 2732 //
     /* 212638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 212658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 212662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212673 */     GIR_RootConstrainSelectedInstOperands,
     /* 212674 */     // GIR_Coverage, 2732,
     /* 212674 */     GIR_EraseRootFromParent_Done,
     /* 212675 */   // Label 4199: @212675
     /* 212675 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212717), // Rule ID 2733 //
     /* 212680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 212700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1170:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212715 */     GIR_RootConstrainSelectedInstOperands,
     /* 212716 */     // GIR_Coverage, 2733,
     /* 212716 */     GIR_EraseRootFromParent_Done,
     /* 212717 */   // Label 4200: @212717
     /* 212717 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212759), // Rule ID 2734 //
     /* 212722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 212733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 212736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 212739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 212742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1170:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 212746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212757 */     GIR_RootConstrainSelectedInstOperands,
     /* 212758 */     // GIR_Coverage, 2734,
     /* 212758 */     GIR_EraseRootFromParent_Done,
     /* 212759 */   // Label 4201: @212759
     /* 212759 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(212801), // Rule ID 2773 //
     /* 212764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212788 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 212791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212799 */     GIR_RootConstrainSelectedInstOperands,
     /* 212800 */     // GIR_Coverage, 2773,
     /* 212800 */     GIR_EraseRootFromParent_Done,
     /* 212801 */   // Label 4202: @212801
     /* 212801 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(212843), // Rule ID 2775 //
     /* 212806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 212833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212841 */     GIR_RootConstrainSelectedInstOperands,
     /* 212842 */     // GIR_Coverage, 2775,
     /* 212842 */     GIR_EraseRootFromParent_Done,
     /* 212843 */   // Label 4203: @212843
     /* 212843 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(212885), // Rule ID 2777 //
     /* 212848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 212875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212883 */     GIR_RootConstrainSelectedInstOperands,
     /* 212884 */     // GIR_Coverage, 2777,
     /* 212884 */     GIR_EraseRootFromParent_Done,
     /* 212885 */   // Label 4204: @212885
     /* 212885 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(212927), // Rule ID 2779 //
     /* 212890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 212917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212925 */     GIR_RootConstrainSelectedInstOperands,
     /* 212926 */     // GIR_Coverage, 2779,
     /* 212926 */     GIR_EraseRootFromParent_Done,
     /* 212927 */   // Label 4205: @212927
     /* 212927 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(212969), // Rule ID 2780 //
     /* 212932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 212959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212967 */     GIR_RootConstrainSelectedInstOperands,
     /* 212968 */     // GIR_Coverage, 2780,
     /* 212968 */     GIR_EraseRootFromParent_Done,
     /* 212969 */   // Label 4206: @212969
     /* 212969 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213011), // Rule ID 2781 //
     /* 212974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 213001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213009 */     GIR_RootConstrainSelectedInstOperands,
     /* 213010 */     // GIR_Coverage, 2781,
     /* 213010 */     GIR_EraseRootFromParent_Done,
     /* 213011 */   // Label 4207: @213011
     /* 213011 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213053), // Rule ID 2850 //
     /* 213016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 213024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 213043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213051 */     GIR_RootConstrainSelectedInstOperands,
     /* 213052 */     // GIR_Coverage, 2850,
     /* 213052 */     GIR_EraseRootFromParent_Done,
     /* 213053 */   // Label 4208: @213053
     /* 213053 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213095), // Rule ID 2851 //
     /* 213058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 213066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 213085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213093 */     GIR_RootConstrainSelectedInstOperands,
     /* 213094 */     // GIR_Coverage, 2851,
     /* 213094 */     GIR_EraseRootFromParent_Done,
     /* 213095 */   // Label 4209: @213095
     /* 213095 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213137), // Rule ID 2852 //
     /* 213100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 213108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1301:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 213127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213135 */     GIR_RootConstrainSelectedInstOperands,
     /* 213136 */     // GIR_Coverage, 2852,
     /* 213136 */     GIR_EraseRootFromParent_Done,
     /* 213137 */   // Label 4210: @213137
     /* 213137 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213179), // Rule ID 2853 //
     /* 213142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 213150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 213169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213177 */     GIR_RootConstrainSelectedInstOperands,
     /* 213178 */     // GIR_Coverage, 2853,
     /* 213178 */     GIR_EraseRootFromParent_Done,
     /* 213179 */   // Label 4211: @213179
     /* 213179 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213221), // Rule ID 2854 //
     /* 213184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 213192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 213211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213219 */     GIR_RootConstrainSelectedInstOperands,
     /* 213220 */     // GIR_Coverage, 2854,
     /* 213220 */     GIR_EraseRootFromParent_Done,
     /* 213221 */   // Label 4212: @213221
     /* 213221 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213263), // Rule ID 2855 //
     /* 213226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 213234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213250 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 213253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213261 */     GIR_RootConstrainSelectedInstOperands,
     /* 213262 */     // GIR_Coverage, 2855,
     /* 213262 */     GIR_EraseRootFromParent_Done,
     /* 213263 */   // Label 4213: @213263
     /* 213263 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213305), // Rule ID 2856 //
     /* 213268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 213276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213292 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 213295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213303 */     GIR_RootConstrainSelectedInstOperands,
     /* 213304 */     // GIR_Coverage, 2856,
     /* 213304 */     GIR_EraseRootFromParent_Done,
     /* 213305 */   // Label 4214: @213305
     /* 213305 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213347), // Rule ID 2857 //
     /* 213310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 213318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213334 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 213337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213345 */     GIR_RootConstrainSelectedInstOperands,
     /* 213346 */     // GIR_Coverage, 2857,
     /* 213346 */     GIR_EraseRootFromParent_Done,
     /* 213347 */   // Label 4215: @213347
     /* 213347 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213389), // Rule ID 2868 //
     /* 213352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 213360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 213379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213387 */     GIR_RootConstrainSelectedInstOperands,
     /* 213388 */     // GIR_Coverage, 2868,
     /* 213388 */     GIR_EraseRootFromParent_Done,
     /* 213389 */   // Label 4216: @213389
     /* 213389 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213431), // Rule ID 2870 //
     /* 213394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 213402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 213421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213429 */     GIR_RootConstrainSelectedInstOperands,
     /* 213430 */     // GIR_Coverage, 2870,
     /* 213430 */     GIR_EraseRootFromParent_Done,
     /* 213431 */   // Label 4217: @213431
     /* 213431 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213473), // Rule ID 2878 //
     /* 213436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1329:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 213463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213471 */     GIR_RootConstrainSelectedInstOperands,
     /* 213472 */     // GIR_Coverage, 2878,
     /* 213472 */     GIR_EraseRootFromParent_Done,
     /* 213473 */   // Label 4218: @213473
     /* 213473 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213515), // Rule ID 2879 //
     /* 213478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1329:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 213505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213513 */     GIR_RootConstrainSelectedInstOperands,
     /* 213514 */     // GIR_Coverage, 2879,
     /* 213514 */     GIR_EraseRootFromParent_Done,
     /* 213515 */   // Label 4219: @213515
     /* 213515 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213557), // Rule ID 2880 //
     /* 213520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1329:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 213547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213555 */     GIR_RootConstrainSelectedInstOperands,
     /* 213556 */     // GIR_Coverage, 2880,
     /* 213556 */     GIR_EraseRootFromParent_Done,
     /* 213557 */   // Label 4220: @213557
     /* 213557 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213599), // Rule ID 2884 //
     /* 213562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 213570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213586 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1307:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 213589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213597 */     GIR_RootConstrainSelectedInstOperands,
     /* 213598 */     // GIR_Coverage, 2884,
     /* 213598 */     GIR_EraseRootFromParent_Done,
     /* 213599 */   // Label 4221: @213599
     /* 213599 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213641), // Rule ID 2929 //
     /* 213604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 213631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213639 */     GIR_RootConstrainSelectedInstOperands,
     /* 213640 */     // GIR_Coverage, 2929,
     /* 213640 */     GIR_EraseRootFromParent_Done,
     /* 213641 */   // Label 4222: @213641
     /* 213641 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213683), // Rule ID 2930 //
     /* 213646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 213673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213681 */     GIR_RootConstrainSelectedInstOperands,
     /* 213682 */     // GIR_Coverage, 2930,
     /* 213682 */     GIR_EraseRootFromParent_Done,
     /* 213683 */   // Label 4223: @213683
     /* 213683 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(213725), // Rule ID 2959 //
     /* 213688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 213715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213723 */     GIR_RootConstrainSelectedInstOperands,
     /* 213724 */     // GIR_Coverage, 2959,
     /* 213724 */     GIR_EraseRootFromParent_Done,
     /* 213725 */   // Label 4224: @213725
     /* 213725 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(213767), // Rule ID 2960 //
     /* 213730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 213757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213765 */     GIR_RootConstrainSelectedInstOperands,
     /* 213766 */     // GIR_Coverage, 2960,
     /* 213766 */     GIR_EraseRootFromParent_Done,
     /* 213767 */   // Label 4225: @213767
     /* 213767 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(213809), // Rule ID 2961 //
     /* 213772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 213799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213807 */     GIR_RootConstrainSelectedInstOperands,
     /* 213808 */     // GIR_Coverage, 2961,
     /* 213808 */     GIR_EraseRootFromParent_Done,
     /* 213809 */   // Label 4226: @213809
     /* 213809 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(213851), // Rule ID 2962 //
     /* 213814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 213841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213849 */     GIR_RootConstrainSelectedInstOperands,
     /* 213850 */     // GIR_Coverage, 2962,
     /* 213850 */     GIR_EraseRootFromParent_Done,
     /* 213851 */   // Label 4227: @213851
     /* 213851 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(213893), // Rule ID 2963 //
     /* 213856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 213883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213891 */     GIR_RootConstrainSelectedInstOperands,
     /* 213892 */     // GIR_Coverage, 2963,
     /* 213892 */     GIR_EraseRootFromParent_Done,
     /* 213893 */   // Label 4228: @213893
     /* 213893 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(213935), // Rule ID 2964 //
     /* 213898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 213925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213933 */     GIR_RootConstrainSelectedInstOperands,
     /* 213934 */     // GIR_Coverage, 2964,
     /* 213934 */     GIR_EraseRootFromParent_Done,
     /* 213935 */   // Label 4229: @213935
     /* 213935 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(213977), // Rule ID 2965 //
     /* 213940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1649:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 213967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213975 */     GIR_RootConstrainSelectedInstOperands,
     /* 213976 */     // GIR_Coverage, 2965,
     /* 213976 */     GIR_EraseRootFromParent_Done,
     /* 213977 */   // Label 4230: @213977
     /* 213977 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214019), // Rule ID 2995 //
     /* 213982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 214009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214017 */     GIR_RootConstrainSelectedInstOperands,
     /* 214018 */     // GIR_Coverage, 2995,
     /* 214018 */     GIR_EraseRootFromParent_Done,
     /* 214019 */   // Label 4231: @214019
     /* 214019 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214061), // Rule ID 2997 //
     /* 214024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 214032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 214051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214059 */     GIR_RootConstrainSelectedInstOperands,
     /* 214060 */     // GIR_Coverage, 2997,
     /* 214060 */     GIR_EraseRootFromParent_Done,
     /* 214061 */   // Label 4232: @214061
     /* 214061 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214103), // Rule ID 2999 //
     /* 214066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 214074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 214093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214101 */     GIR_RootConstrainSelectedInstOperands,
     /* 214102 */     // GIR_Coverage, 2999,
     /* 214102 */     GIR_EraseRootFromParent_Done,
     /* 214103 */   // Label 4233: @214103
     /* 214103 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214145), // Rule ID 3001 //
     /* 214108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 214116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 214135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214143 */     GIR_RootConstrainSelectedInstOperands,
     /* 214144 */     // GIR_Coverage, 3001,
     /* 214144 */     GIR_EraseRootFromParent_Done,
     /* 214145 */   // Label 4234: @214145
     /* 214145 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214187), // Rule ID 3003 //
     /* 214150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 214158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 214177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214185 */     GIR_RootConstrainSelectedInstOperands,
     /* 214186 */     // GIR_Coverage, 3003,
     /* 214186 */     GIR_EraseRootFromParent_Done,
     /* 214187 */   // Label 4235: @214187
     /* 214187 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214229), // Rule ID 3004 //
     /* 214192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 214200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 214219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214227 */     GIR_RootConstrainSelectedInstOperands,
     /* 214228 */     // GIR_Coverage, 3004,
     /* 214228 */     GIR_EraseRootFromParent_Done,
     /* 214229 */   // Label 4236: @214229
     /* 214229 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214271), // Rule ID 3005 //
     /* 214234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 214242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 214261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214269 */     GIR_RootConstrainSelectedInstOperands,
     /* 214270 */     // GIR_Coverage, 3005,
     /* 214270 */     GIR_EraseRootFromParent_Done,
     /* 214271 */   // Label 4237: @214271
     /* 214271 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214313), // Rule ID 3006 //
     /* 214276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 214284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 214303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214311 */     GIR_RootConstrainSelectedInstOperands,
     /* 214312 */     // GIR_Coverage, 3006,
     /* 214312 */     GIR_EraseRootFromParent_Done,
     /* 214313 */   // Label 4238: @214313
     /* 214313 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214355), // Rule ID 3007 //
     /* 214318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 214345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214353 */     GIR_RootConstrainSelectedInstOperands,
     /* 214354 */     // GIR_Coverage, 3007,
     /* 214354 */     GIR_EraseRootFromParent_Done,
     /* 214355 */   // Label 4239: @214355
     /* 214355 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214397), // Rule ID 3008 //
     /* 214360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 214387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214395 */     GIR_RootConstrainSelectedInstOperands,
     /* 214396 */     // GIR_Coverage, 3008,
     /* 214396 */     GIR_EraseRootFromParent_Done,
     /* 214397 */   // Label 4240: @214397
     /* 214397 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214439), // Rule ID 3009 //
     /* 214402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 214429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214437 */     GIR_RootConstrainSelectedInstOperands,
     /* 214438 */     // GIR_Coverage, 3009,
     /* 214438 */     GIR_EraseRootFromParent_Done,
     /* 214439 */   // Label 4241: @214439
     /* 214439 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214481), // Rule ID 3010 //
     /* 214444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 214471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214479 */     GIR_RootConstrainSelectedInstOperands,
     /* 214480 */     // GIR_Coverage, 3010,
     /* 214480 */     GIR_EraseRootFromParent_Done,
     /* 214481 */   // Label 4242: @214481
     /* 214481 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(214523), // Rule ID 3027 //
     /* 214486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214510 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 214513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214521 */     GIR_RootConstrainSelectedInstOperands,
     /* 214522 */     // GIR_Coverage, 3027,
     /* 214522 */     GIR_EraseRootFromParent_Done,
     /* 214523 */   // Label 4243: @214523
     /* 214523 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(214565), // Rule ID 3028 //
     /* 214528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 214555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214563 */     GIR_RootConstrainSelectedInstOperands,
     /* 214564 */     // GIR_Coverage, 3028,
     /* 214564 */     GIR_EraseRootFromParent_Done,
     /* 214565 */   // Label 4244: @214565
     /* 214565 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(214607), // Rule ID 3029 //
     /* 214570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 214597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214605 */     GIR_RootConstrainSelectedInstOperands,
     /* 214606 */     // GIR_Coverage, 3029,
     /* 214606 */     GIR_EraseRootFromParent_Done,
     /* 214607 */   // Label 4245: @214607
     /* 214607 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(214649), // Rule ID 3030 //
     /* 214612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 214639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214647 */     GIR_RootConstrainSelectedInstOperands,
     /* 214648 */     // GIR_Coverage, 3030,
     /* 214648 */     GIR_EraseRootFromParent_Done,
     /* 214649 */   // Label 4246: @214649
     /* 214649 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(214691), // Rule ID 3054 //
     /* 214654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1586:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 214681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214689 */     GIR_RootConstrainSelectedInstOperands,
     /* 214690 */     // GIR_Coverage, 3054,
     /* 214690 */     GIR_EraseRootFromParent_Done,
     /* 214691 */   // Label 4247: @214691
     /* 214691 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(214733), // Rule ID 3056 //
     /* 214696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1586:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 214723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214731 */     GIR_RootConstrainSelectedInstOperands,
     /* 214732 */     // GIR_Coverage, 3056,
     /* 214732 */     GIR_EraseRootFromParent_Done,
     /* 214733 */   // Label 4248: @214733
     /* 214733 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(214775), // Rule ID 3058 //
     /* 214738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1586:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 214765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214773 */     GIR_RootConstrainSelectedInstOperands,
     /* 214774 */     // GIR_Coverage, 3058,
     /* 214774 */     GIR_EraseRootFromParent_Done,
     /* 214775 */   // Label 4249: @214775
     /* 214775 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(214817), // Rule ID 3060 //
     /* 214780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1586:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 214807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214815 */     GIR_RootConstrainSelectedInstOperands,
     /* 214816 */     // GIR_Coverage, 3060,
     /* 214816 */     GIR_EraseRootFromParent_Done,
     /* 214817 */   // Label 4250: @214817
     /* 214817 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(214859), // Rule ID 3062 //
     /* 214822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 214849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214857 */     GIR_RootConstrainSelectedInstOperands,
     /* 214858 */     // GIR_Coverage, 3062,
     /* 214858 */     GIR_EraseRootFromParent_Done,
     /* 214859 */   // Label 4251: @214859
     /* 214859 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(214901), // Rule ID 3063 //
     /* 214864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 214891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214899 */     GIR_RootConstrainSelectedInstOperands,
     /* 214900 */     // GIR_Coverage, 3063,
     /* 214900 */     GIR_EraseRootFromParent_Done,
     /* 214901 */   // Label 4252: @214901
     /* 214901 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(214943), // Rule ID 3064 //
     /* 214906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 214933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214941 */     GIR_RootConstrainSelectedInstOperands,
     /* 214942 */     // GIR_Coverage, 3064,
     /* 214942 */     GIR_EraseRootFromParent_Done,
     /* 214943 */   // Label 4253: @214943
     /* 214943 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(214985), // Rule ID 3065 //
     /* 214948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1150:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 214975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214983 */     GIR_RootConstrainSelectedInstOperands,
     /* 214984 */     // GIR_Coverage, 3065,
     /* 214984 */     GIR_EraseRootFromParent_Done,
     /* 214985 */   // Label 4254: @214985
     /* 214985 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215027), // Rule ID 3066 //
     /* 214990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1150:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 215017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 215019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215025 */     GIR_RootConstrainSelectedInstOperands,
     /* 215026 */     // GIR_Coverage, 3066,
     /* 215026 */     GIR_EraseRootFromParent_Done,
     /* 215027 */   // Label 4255: @215027
     /* 215027 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215069), // Rule ID 3076 //
     /* 215032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 215040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 215059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215067 */     GIR_RootConstrainSelectedInstOperands,
     /* 215068 */     // GIR_Coverage, 3076,
     /* 215068 */     GIR_EraseRootFromParent_Done,
     /* 215069 */   // Label 4256: @215069
     /* 215069 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215111), // Rule ID 3077 //
     /* 215074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 215082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 215101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215109 */     GIR_RootConstrainSelectedInstOperands,
     /* 215110 */     // GIR_Coverage, 3077,
     /* 215110 */     GIR_EraseRootFromParent_Done,
     /* 215111 */   // Label 4257: @215111
     /* 215111 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215153), // Rule ID 3078 //
     /* 215116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 215124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 215143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215151 */     GIR_RootConstrainSelectedInstOperands,
     /* 215152 */     // GIR_Coverage, 3078,
     /* 215152 */     GIR_EraseRootFromParent_Done,
     /* 215153 */   // Label 4258: @215153
     /* 215153 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215195), // Rule ID 3095 //
     /* 215158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 215166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 215185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 215189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215193 */     GIR_RootConstrainSelectedInstOperands,
     /* 215194 */     // GIR_Coverage, 3095,
     /* 215194 */     GIR_EraseRootFromParent_Done,
     /* 215195 */   // Label 4259: @215195
     /* 215195 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(215237), // Rule ID 3096 //
     /* 215200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 215208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 215227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 215231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215235 */     GIR_RootConstrainSelectedInstOperands,
     /* 215236 */     // GIR_Coverage, 3096,
     /* 215236 */     GIR_EraseRootFromParent_Done,
     /* 215237 */   // Label 4260: @215237
     /* 215237 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(215279), // Rule ID 3097 //
     /* 215242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 215250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 215269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 215273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215277 */     GIR_RootConstrainSelectedInstOperands,
     /* 215278 */     // GIR_Coverage, 3097,
     /* 215278 */     GIR_EraseRootFromParent_Done,
     /* 215279 */   // Label 4261: @215279
     /* 215279 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(215321), // Rule ID 3098 //
     /* 215284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 215292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 215311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 215315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 215317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 215319 */     GIR_RootConstrainSelectedInstOperands,
     /* 215320 */     // GIR_Coverage, 3098,
     /* 215320 */     GIR_EraseRootFromParent_Done,
     /* 215321 */   // Label 4262: @215321
     /* 215321 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(215363), // Rule ID 3133 //
     /* 215326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215350 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215361 */     GIR_RootConstrainSelectedInstOperands,
     /* 215362 */     // GIR_Coverage, 3133,
     /* 215362 */     GIR_EraseRootFromParent_Done,
     /* 215363 */   // Label 4263: @215363
     /* 215363 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(215405), // Rule ID 3135 //
     /* 215368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215403 */     GIR_RootConstrainSelectedInstOperands,
     /* 215404 */     // GIR_Coverage, 3135,
     /* 215404 */     GIR_EraseRootFromParent_Done,
     /* 215405 */   // Label 4264: @215405
     /* 215405 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(215447), // Rule ID 3137 //
     /* 215410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215445 */     GIR_RootConstrainSelectedInstOperands,
     /* 215446 */     // GIR_Coverage, 3137,
     /* 215446 */     GIR_EraseRootFromParent_Done,
     /* 215447 */   // Label 4265: @215447
     /* 215447 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(215489), // Rule ID 3139 //
     /* 215452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215487 */     GIR_RootConstrainSelectedInstOperands,
     /* 215488 */     // GIR_Coverage, 3139,
     /* 215488 */     GIR_EraseRootFromParent_Done,
     /* 215489 */   // Label 4266: @215489
     /* 215489 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(215534), // Rule ID 3172 //
     /* 215494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215518 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1221:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 215521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215532 */     GIR_RootConstrainSelectedInstOperands,
     /* 215533 */     // GIR_Coverage, 3172,
     /* 215533 */     GIR_EraseRootFromParent_Done,
     /* 215534 */   // Label 4267: @215534
     /* 215534 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(215579), // Rule ID 3173 //
     /* 215539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215563 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1221:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 215566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215577 */     GIR_RootConstrainSelectedInstOperands,
     /* 215578 */     // GIR_Coverage, 3173,
     /* 215578 */     GIR_EraseRootFromParent_Done,
     /* 215579 */   // Label 4268: @215579
     /* 215579 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(215624), // Rule ID 3174 //
     /* 215584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 215611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215622 */     GIR_RootConstrainSelectedInstOperands,
     /* 215623 */     // GIR_Coverage, 3174,
     /* 215623 */     GIR_EraseRootFromParent_Done,
     /* 215624 */   // Label 4269: @215624
     /* 215624 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(215669), // Rule ID 3175 //
     /* 215629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215653 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1223:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 215656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215667 */     GIR_RootConstrainSelectedInstOperands,
     /* 215668 */     // GIR_Coverage, 3175,
     /* 215668 */     GIR_EraseRootFromParent_Done,
     /* 215669 */   // Label 4270: @215669
     /* 215669 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(215714), // Rule ID 3176 //
     /* 215674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1223:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 215701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215712 */     GIR_RootConstrainSelectedInstOperands,
     /* 215713 */     // GIR_Coverage, 3176,
     /* 215713 */     GIR_EraseRootFromParent_Done,
     /* 215714 */   // Label 4271: @215714
     /* 215714 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(215759), // Rule ID 3177 //
     /* 215719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215743 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1223:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 215746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215757 */     GIR_RootConstrainSelectedInstOperands,
     /* 215758 */     // GIR_Coverage, 3177,
     /* 215758 */     GIR_EraseRootFromParent_Done,
     /* 215759 */   // Label 4272: @215759
     /* 215759 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(215801), // Rule ID 3232 //
     /* 215764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 215791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215799 */     GIR_RootConstrainSelectedInstOperands,
     /* 215800 */     // GIR_Coverage, 3232,
     /* 215800 */     GIR_EraseRootFromParent_Done,
     /* 215801 */   // Label 4273: @215801
     /* 215801 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(215843), // Rule ID 3233 //
     /* 215806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 215833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215841 */     GIR_RootConstrainSelectedInstOperands,
     /* 215842 */     // GIR_Coverage, 3233,
     /* 215842 */     GIR_EraseRootFromParent_Done,
     /* 215843 */   // Label 4274: @215843
     /* 215843 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(215885), // Rule ID 3234 //
     /* 215848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 215875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215883 */     GIR_RootConstrainSelectedInstOperands,
     /* 215884 */     // GIR_Coverage, 3234,
     /* 215884 */     GIR_EraseRootFromParent_Done,
     /* 215885 */   // Label 4275: @215885
     /* 215885 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(215927), // Rule ID 3286 //
     /* 215890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 215917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215925 */     GIR_RootConstrainSelectedInstOperands,
     /* 215926 */     // GIR_Coverage, 3286,
     /* 215926 */     GIR_EraseRootFromParent_Done,
     /* 215927 */   // Label 4276: @215927
     /* 215927 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(215969), // Rule ID 3287 //
     /* 215932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1173:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 215959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215967 */     GIR_RootConstrainSelectedInstOperands,
     /* 215968 */     // GIR_Coverage, 3287,
     /* 215968 */     GIR_EraseRootFromParent_Done,
     /* 215969 */   // Label 4277: @215969
     /* 215969 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(216011), // Rule ID 3288 //
     /* 215974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1173:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 216001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216009 */     GIR_RootConstrainSelectedInstOperands,
     /* 216010 */     // GIR_Coverage, 3288,
     /* 216010 */     GIR_EraseRootFromParent_Done,
     /* 216011 */   // Label 4278: @216011
     /* 216011 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(216053), // Rule ID 3289 //
     /* 216016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 216024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1173:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 216043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216051 */     GIR_RootConstrainSelectedInstOperands,
     /* 216052 */     // GIR_Coverage, 3289,
     /* 216052 */     GIR_EraseRootFromParent_Done,
     /* 216053 */   // Label 4279: @216053
     /* 216053 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(216095), // Rule ID 3298 //
     /* 216058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 216066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216082 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1175:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 216085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216093 */     GIR_RootConstrainSelectedInstOperands,
     /* 216094 */     // GIR_Coverage, 3298,
     /* 216094 */     GIR_EraseRootFromParent_Done,
     /* 216095 */   // Label 4280: @216095
     /* 216095 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(216137), // Rule ID 3299 //
     /* 216100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 216108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1175:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 216127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216135 */     GIR_RootConstrainSelectedInstOperands,
     /* 216136 */     // GIR_Coverage, 3299,
     /* 216136 */     GIR_EraseRootFromParent_Done,
     /* 216137 */   // Label 4281: @216137
     /* 216137 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(216179), // Rule ID 3300 //
     /* 216142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 216150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1175:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 216169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216177 */     GIR_RootConstrainSelectedInstOperands,
     /* 216178 */     // GIR_Coverage, 3300,
     /* 216178 */     GIR_EraseRootFromParent_Done,
     /* 216179 */   // Label 4282: @216179
     /* 216179 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(216221), // Rule ID 3339 //
     /* 216184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1212:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 216211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216219 */     GIR_RootConstrainSelectedInstOperands,
     /* 216220 */     // GIR_Coverage, 3339,
     /* 216220 */     GIR_EraseRootFromParent_Done,
     /* 216221 */   // Label 4283: @216221
     /* 216221 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(216263), // Rule ID 3340 //
     /* 216226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 216253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216261 */     GIR_RootConstrainSelectedInstOperands,
     /* 216262 */     // GIR_Coverage, 3340,
     /* 216262 */     GIR_EraseRootFromParent_Done,
     /* 216263 */   // Label 4284: @216263
     /* 216263 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(216305), // Rule ID 3341 //
     /* 216268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 216295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216303 */     GIR_RootConstrainSelectedInstOperands,
     /* 216304 */     // GIR_Coverage, 3341,
     /* 216304 */     GIR_EraseRootFromParent_Done,
     /* 216305 */   // Label 4285: @216305
     /* 216305 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(216347), // Rule ID 3342 //
     /* 216310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 216337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216345 */     GIR_RootConstrainSelectedInstOperands,
     /* 216346 */     // GIR_Coverage, 3342,
     /* 216346 */     GIR_EraseRootFromParent_Done,
     /* 216347 */   // Label 4286: @216347
     /* 216347 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(216389), // Rule ID 3343 //
     /* 216352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216376 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 216376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 216379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216387 */     GIR_RootConstrainSelectedInstOperands,
     /* 216388 */     // GIR_Coverage, 3343,
     /* 216388 */     GIR_EraseRootFromParent_Done,
     /* 216389 */   // Label 4287: @216389
     /* 216389 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(216431), // Rule ID 3344 //
     /* 216394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216418 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 216418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 216421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216429 */     GIR_RootConstrainSelectedInstOperands,
     /* 216430 */     // GIR_Coverage, 3344,
     /* 216430 */     GIR_EraseRootFromParent_Done,
     /* 216431 */   // Label 4288: @216431
     /* 216431 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(216473), // Rule ID 3345 //
     /* 216436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216460 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 216463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216471 */     GIR_RootConstrainSelectedInstOperands,
     /* 216472 */     // GIR_Coverage, 3345,
     /* 216472 */     GIR_EraseRootFromParent_Done,
     /* 216473 */   // Label 4289: @216473
     /* 216473 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(216515), // Rule ID 3428 //
     /* 216478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 216486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1204:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216513 */     GIR_RootConstrainSelectedInstOperands,
     /* 216514 */     // GIR_Coverage, 3428,
     /* 216514 */     GIR_EraseRootFromParent_Done,
     /* 216515 */   // Label 4290: @216515
     /* 216515 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(216557), // Rule ID 3429 //
     /* 216520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 216528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216544 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1203:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 216547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 216549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216555 */     GIR_RootConstrainSelectedInstOperands,
     /* 216556 */     // GIR_Coverage, 3429,
     /* 216556 */     GIR_EraseRootFromParent_Done,
     /* 216557 */   // Label 4291: @216557
     /* 216557 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(216599), // Rule ID 3430 //
     /* 216562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 216570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216586 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1199:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 216589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216597 */     GIR_RootConstrainSelectedInstOperands,
     /* 216598 */     // GIR_Coverage, 3430,
     /* 216598 */     GIR_EraseRootFromParent_Done,
     /* 216599 */   // Label 4292: @216599
     /* 216599 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(216644), // Rule ID 3432 //
     /* 216604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1506:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 216631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216642 */     GIR_RootConstrainSelectedInstOperands,
     /* 216643 */     // GIR_Coverage, 3432,
     /* 216643 */     GIR_EraseRootFromParent_Done,
     /* 216644 */   // Label 4293: @216644
     /* 216644 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(216689), // Rule ID 3433 //
     /* 216649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 216660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1506:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 216676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216687 */     GIR_RootConstrainSelectedInstOperands,
     /* 216688 */     // GIR_Coverage, 3433,
     /* 216688 */     GIR_EraseRootFromParent_Done,
     /* 216689 */   // Label 4294: @216689
     /* 216689 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(216731), // Rule ID 3434 //
     /* 216694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 216721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216729 */     GIR_RootConstrainSelectedInstOperands,
     /* 216730 */     // GIR_Coverage, 3434,
     /* 216730 */     GIR_EraseRootFromParent_Done,
     /* 216731 */   // Label 4295: @216731
     /* 216731 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(216773), // Rule ID 3435 //
     /* 216736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 216763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216771 */     GIR_RootConstrainSelectedInstOperands,
     /* 216772 */     // GIR_Coverage, 3435,
     /* 216772 */     GIR_EraseRootFromParent_Done,
     /* 216773 */   // Label 4296: @216773
     /* 216773 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(216815), // Rule ID 3440 //
     /* 216778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 216781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 216786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1657:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 216805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216813 */     GIR_RootConstrainSelectedInstOperands,
     /* 216814 */     // GIR_Coverage, 3440,
     /* 216814 */     GIR_EraseRootFromParent_Done,
     /* 216815 */   // Label 4297: @216815
     /* 216815 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(216857), // Rule ID 3479 //
     /* 216820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1280:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 216844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 216847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216855 */     GIR_RootConstrainSelectedInstOperands,
     /* 216856 */     // GIR_Coverage, 3479,
     /* 216856 */     GIR_EraseRootFromParent_Done,
     /* 216857 */   // Label 4298: @216857
     /* 216857 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(216899), // Rule ID 3481 //
     /* 216862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216886 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1280:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 216886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 216889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216897 */     GIR_RootConstrainSelectedInstOperands,
     /* 216898 */     // GIR_Coverage, 3481,
     /* 216898 */     GIR_EraseRootFromParent_Done,
     /* 216899 */   // Label 4299: @216899
     /* 216899 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(216941), // Rule ID 3483 //
     /* 216904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216928 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1280:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 216931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216939 */     GIR_RootConstrainSelectedInstOperands,
     /* 216940 */     // GIR_Coverage, 3483,
     /* 216940 */     GIR_EraseRootFromParent_Done,
     /* 216941 */   // Label 4300: @216941
     /* 216941 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(216983), // Rule ID 3485 //
     /* 216946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 216954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 216973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216981 */     GIR_RootConstrainSelectedInstOperands,
     /* 216982 */     // GIR_Coverage, 3485,
     /* 216982 */     GIR_EraseRootFromParent_Done,
     /* 216983 */   // Label 4301: @216983
     /* 216983 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(217025), // Rule ID 3600 //
     /* 216988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 217015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217023 */     GIR_RootConstrainSelectedInstOperands,
     /* 217024 */     // GIR_Coverage, 3600,
     /* 217024 */     GIR_EraseRootFromParent_Done,
     /* 217025 */   // Label 4302: @217025
     /* 217025 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(217067), // Rule ID 3602 //
     /* 217030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 217038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 217057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217065 */     GIR_RootConstrainSelectedInstOperands,
     /* 217066 */     // GIR_Coverage, 3602,
     /* 217066 */     GIR_EraseRootFromParent_Done,
     /* 217067 */   // Label 4303: @217067
     /* 217067 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(217109), // Rule ID 3604 //
     /* 217072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 217080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 217099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217107 */     GIR_RootConstrainSelectedInstOperands,
     /* 217108 */     // GIR_Coverage, 3604,
     /* 217108 */     GIR_EraseRootFromParent_Done,
     /* 217109 */   // Label 4304: @217109
     /* 217109 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(217151), // Rule ID 3606 //
     /* 217114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 217117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 217122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 217141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217149 */     GIR_RootConstrainSelectedInstOperands,
     /* 217150 */     // GIR_Coverage, 3606,
     /* 217150 */     GIR_EraseRootFromParent_Done,
     /* 217151 */   // Label 4305: @217151
     /* 217151 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(217193), // Rule ID 7338 //
     /* 217156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 217164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 217183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217191 */     GIR_RootConstrainSelectedInstOperands,
     /* 217192 */     // GIR_Coverage, 7338,
     /* 217192 */     GIR_EraseRootFromParent_Done,
     /* 217193 */   // Label 4306: @217193
     /* 217193 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(217235), // Rule ID 7340 //
     /* 217198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 217206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 217225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217233 */     GIR_RootConstrainSelectedInstOperands,
     /* 217234 */     // GIR_Coverage, 7340,
     /* 217234 */     GIR_EraseRootFromParent_Done,
     /* 217235 */   // Label 4307: @217235
     /* 217235 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(217277), // Rule ID 7342 //
     /* 217240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 217248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 217267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217275 */     GIR_RootConstrainSelectedInstOperands,
     /* 217276 */     // GIR_Coverage, 7342,
     /* 217276 */     GIR_EraseRootFromParent_Done,
     /* 217277 */   // Label 4308: @217277
     /* 217277 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(217319), // Rule ID 7344 //
     /* 217282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 217290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 217309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217317 */     GIR_RootConstrainSelectedInstOperands,
     /* 217318 */     // GIR_Coverage, 7344,
     /* 217318 */     GIR_EraseRootFromParent_Done,
     /* 217319 */   // Label 4309: @217319
     /* 217319 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(217361), // Rule ID 7362 //
     /* 217324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1196:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 217351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217359 */     GIR_RootConstrainSelectedInstOperands,
     /* 217360 */     // GIR_Coverage, 7362,
     /* 217360 */     GIR_EraseRootFromParent_Done,
     /* 217361 */   // Label 4310: @217361
     /* 217361 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(217403), // Rule ID 7363 //
     /* 217366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1196:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 217393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217401 */     GIR_RootConstrainSelectedInstOperands,
     /* 217402 */     // GIR_Coverage, 7363,
     /* 217402 */     GIR_EraseRootFromParent_Done,
     /* 217403 */   // Label 4311: @217403
     /* 217403 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(217445), // Rule ID 7364 //
     /* 217408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1196:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 217435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217443 */     GIR_RootConstrainSelectedInstOperands,
     /* 217444 */     // GIR_Coverage, 7364,
     /* 217444 */     GIR_EraseRootFromParent_Done,
     /* 217445 */   // Label 4312: @217445
     /* 217445 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(217487), // Rule ID 7365 //
     /* 217450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1196:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 217477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217485 */     GIR_RootConstrainSelectedInstOperands,
     /* 217486 */     // GIR_Coverage, 7365,
     /* 217486 */     GIR_EraseRootFromParent_Done,
     /* 217487 */   // Label 4313: @217487
     /* 217487 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(217529), // Rule ID 7478 //
     /* 217492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1658:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 217519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217527 */     GIR_RootConstrainSelectedInstOperands,
     /* 217528 */     // GIR_Coverage, 7478,
     /* 217528 */     GIR_EraseRootFromParent_Done,
     /* 217529 */   // Label 4314: @217529
     /* 217529 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(217571), // Rule ID 7479 //
     /* 217534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1658:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 217561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217569 */     GIR_RootConstrainSelectedInstOperands,
     /* 217570 */     // GIR_Coverage, 7479,
     /* 217570 */     GIR_EraseRootFromParent_Done,
     /* 217571 */   // Label 4315: @217571
     /* 217571 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(217613), // Rule ID 7480 //
     /* 217576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1658:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 217603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217611 */     GIR_RootConstrainSelectedInstOperands,
     /* 217612 */     // GIR_Coverage, 7480,
     /* 217612 */     GIR_EraseRootFromParent_Done,
     /* 217613 */   // Label 4316: @217613
     /* 217613 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(217655), // Rule ID 7481 //
     /* 217618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1658:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 217645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217653 */     GIR_RootConstrainSelectedInstOperands,
     /* 217654 */     // GIR_Coverage, 7481,
     /* 217654 */     GIR_EraseRootFromParent_Done,
     /* 217655 */   // Label 4317: @217655
     /* 217655 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(217697), // Rule ID 7482 //
     /* 217660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1896:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 217687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217695 */     GIR_RootConstrainSelectedInstOperands,
     /* 217696 */     // GIR_Coverage, 7482,
     /* 217696 */     GIR_EraseRootFromParent_Done,
     /* 217697 */   // Label 4318: @217697
     /* 217697 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(217739), // Rule ID 7483 //
     /* 217702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1896:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 217729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217737 */     GIR_RootConstrainSelectedInstOperands,
     /* 217738 */     // GIR_Coverage, 7483,
     /* 217738 */     GIR_EraseRootFromParent_Done,
     /* 217739 */   // Label 4319: @217739
     /* 217739 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(217781), // Rule ID 7484 //
     /* 217744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1896:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 217771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217779 */     GIR_RootConstrainSelectedInstOperands,
     /* 217780 */     // GIR_Coverage, 7484,
     /* 217780 */     GIR_EraseRootFromParent_Done,
     /* 217781 */   // Label 4320: @217781
     /* 217781 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(217823), // Rule ID 7485 //
     /* 217786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1896:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 217813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217821 */     GIR_RootConstrainSelectedInstOperands,
     /* 217822 */     // GIR_Coverage, 7485,
     /* 217822 */     GIR_EraseRootFromParent_Done,
     /* 217823 */   // Label 4321: @217823
     /* 217823 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(217865), // Rule ID 7494 //
     /* 217828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 217855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217863 */     GIR_RootConstrainSelectedInstOperands,
     /* 217864 */     // GIR_Coverage, 7494,
     /* 217864 */     GIR_EraseRootFromParent_Done,
     /* 217865 */   // Label 4322: @217865
     /* 217865 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(217907), // Rule ID 7495 //
     /* 217870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1859:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 217897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217905 */     GIR_RootConstrainSelectedInstOperands,
     /* 217906 */     // GIR_Coverage, 7495,
     /* 217906 */     GIR_EraseRootFromParent_Done,
     /* 217907 */   // Label 4323: @217907
     /* 217907 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(217949), // Rule ID 7496 //
     /* 217912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 217939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217947 */     GIR_RootConstrainSelectedInstOperands,
     /* 217948 */     // GIR_Coverage, 7496,
     /* 217948 */     GIR_EraseRootFromParent_Done,
     /* 217949 */   // Label 4324: @217949
     /* 217949 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(217991), // Rule ID 7497 //
     /* 217954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 217981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217989 */     GIR_RootConstrainSelectedInstOperands,
     /* 217990 */     // GIR_Coverage, 7497,
     /* 217990 */     GIR_EraseRootFromParent_Done,
     /* 217991 */   // Label 4325: @217991
     /* 217991 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(218033), // Rule ID 7498 //
     /* 217996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 218004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 218023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218031 */     GIR_RootConstrainSelectedInstOperands,
     /* 218032 */     // GIR_Coverage, 7498,
     /* 218032 */     GIR_EraseRootFromParent_Done,
     /* 218033 */   // Label 4326: @218033
     /* 218033 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(218075), // Rule ID 7499 //
     /* 218038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 218046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 218065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218073 */     GIR_RootConstrainSelectedInstOperands,
     /* 218074 */     // GIR_Coverage, 7499,
     /* 218074 */     GIR_EraseRootFromParent_Done,
     /* 218075 */   // Label 4327: @218075
     /* 218075 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(218117), // Rule ID 7584 //
     /* 218080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 218088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 218094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 218104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 218107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218115 */     GIR_RootConstrainSelectedInstOperands,
     /* 218116 */     // GIR_Coverage, 7584,
     /* 218116 */     GIR_EraseRootFromParent_Done,
     /* 218117 */   // Label 4328: @218117
     /* 218117 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(218159), // Rule ID 7585 //
     /* 218122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 218130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 218146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 218149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218157 */     GIR_RootConstrainSelectedInstOperands,
     /* 218158 */     // GIR_Coverage, 7585,
     /* 218158 */     GIR_EraseRootFromParent_Done,
     /* 218159 */   // Label 4329: @218159
     /* 218159 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(218201), // Rule ID 7586 //
     /* 218164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 218172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 218188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 218191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218199 */     GIR_RootConstrainSelectedInstOperands,
     /* 218200 */     // GIR_Coverage, 7586,
     /* 218200 */     GIR_EraseRootFromParent_Done,
     /* 218201 */   // Label 4330: @218201
     /* 218201 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(218243), // Rule ID 7587 //
     /* 218206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 218214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 218230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 218233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218241 */     GIR_RootConstrainSelectedInstOperands,
     /* 218242 */     // GIR_Coverage, 7587,
     /* 218242 */     GIR_EraseRootFromParent_Done,
     /* 218243 */   // Label 4331: @218243
     /* 218243 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(218285), // Rule ID 7596 //
     /* 218248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 218256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 218262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218272 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 218272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 218275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218283 */     GIR_RootConstrainSelectedInstOperands,
     /* 218284 */     // GIR_Coverage, 7596,
     /* 218284 */     GIR_EraseRootFromParent_Done,
     /* 218285 */   // Label 4332: @218285
     /* 218285 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(218327), // Rule ID 7597 //
     /* 218290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 218298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 218314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 218317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218325 */     GIR_RootConstrainSelectedInstOperands,
     /* 218326 */     // GIR_Coverage, 7597,
     /* 218326 */     GIR_EraseRootFromParent_Done,
     /* 218327 */   // Label 4333: @218327
     /* 218327 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(218369), // Rule ID 7598 //
     /* 218332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 218340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 218356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 218359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218367 */     GIR_RootConstrainSelectedInstOperands,
     /* 218368 */     // GIR_Coverage, 7598,
     /* 218368 */     GIR_EraseRootFromParent_Done,
     /* 218369 */   // Label 4334: @218369
     /* 218369 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(218411), // Rule ID 7599 //
     /* 218374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 218382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 218398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 218401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 218405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 218407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 218409 */     GIR_RootConstrainSelectedInstOperands,
     /* 218410 */     // GIR_Coverage, 7599,
     /* 218410 */     GIR_EraseRootFromParent_Done,
     /* 218411 */   // Label 4335: @218411
     /* 218411 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(218453), // Rule ID 7678 //
     /* 218416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 218443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218451 */     GIR_RootConstrainSelectedInstOperands,
     /* 218452 */     // GIR_Coverage, 7678,
     /* 218452 */     GIR_EraseRootFromParent_Done,
     /* 218453 */   // Label 4336: @218453
     /* 218453 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(218495), // Rule ID 7679 //
     /* 218458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 218485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218493 */     GIR_RootConstrainSelectedInstOperands,
     /* 218494 */     // GIR_Coverage, 7679,
     /* 218494 */     GIR_EraseRootFromParent_Done,
     /* 218495 */   // Label 4337: @218495
     /* 218495 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(218537), // Rule ID 7680 //
     /* 218500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 218527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218535 */     GIR_RootConstrainSelectedInstOperands,
     /* 218536 */     // GIR_Coverage, 7680,
     /* 218536 */     GIR_EraseRootFromParent_Done,
     /* 218537 */   // Label 4338: @218537
     /* 218537 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(218579), // Rule ID 7681 //
     /* 218542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 218569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218577 */     GIR_RootConstrainSelectedInstOperands,
     /* 218578 */     // GIR_Coverage, 7681,
     /* 218578 */     GIR_EraseRootFromParent_Done,
     /* 218579 */   // Label 4339: @218579
     /* 218579 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(218621), // Rule ID 7682 //
     /* 218584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 218611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218619 */     GIR_RootConstrainSelectedInstOperands,
     /* 218620 */     // GIR_Coverage, 7682,
     /* 218620 */     GIR_EraseRootFromParent_Done,
     /* 218621 */   // Label 4340: @218621
     /* 218621 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(218663), // Rule ID 7683 //
     /* 218626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 218653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218661 */     GIR_RootConstrainSelectedInstOperands,
     /* 218662 */     // GIR_Coverage, 7683,
     /* 218662 */     GIR_EraseRootFromParent_Done,
     /* 218663 */   // Label 4341: @218663
     /* 218663 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(218705), // Rule ID 7684 //
     /* 218668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 218695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218703 */     GIR_RootConstrainSelectedInstOperands,
     /* 218704 */     // GIR_Coverage, 7684,
     /* 218704 */     GIR_EraseRootFromParent_Done,
     /* 218705 */   // Label 4342: @218705
     /* 218705 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(218747), // Rule ID 7685 //
     /* 218710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218745 */     GIR_RootConstrainSelectedInstOperands,
     /* 218746 */     // GIR_Coverage, 7685,
     /* 218746 */     GIR_EraseRootFromParent_Done,
     /* 218747 */   // Label 4343: @218747
     /* 218747 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(218789), // Rule ID 7881 //
     /* 218752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218776 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 218779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218787 */     GIR_RootConstrainSelectedInstOperands,
     /* 218788 */     // GIR_Coverage, 7881,
     /* 218788 */     GIR_EraseRootFromParent_Done,
     /* 218789 */   // Label 4344: @218789
     /* 218789 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(218831), // Rule ID 7883 //
     /* 218794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218818 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 218821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218829 */     GIR_RootConstrainSelectedInstOperands,
     /* 218830 */     // GIR_Coverage, 7883,
     /* 218830 */     GIR_EraseRootFromParent_Done,
     /* 218831 */   // Label 4345: @218831
     /* 218831 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(218873), // Rule ID 7885 //
     /* 218836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 218863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218871 */     GIR_RootConstrainSelectedInstOperands,
     /* 218872 */     // GIR_Coverage, 7885,
     /* 218872 */     GIR_EraseRootFromParent_Done,
     /* 218873 */   // Label 4346: @218873
     /* 218873 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(218915), // Rule ID 7893 //
     /* 218878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 218905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218913 */     GIR_RootConstrainSelectedInstOperands,
     /* 218914 */     // GIR_Coverage, 7893,
     /* 218914 */     GIR_EraseRootFromParent_Done,
     /* 218915 */   // Label 4347: @218915
     /* 218915 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(218957), // Rule ID 7895 //
     /* 218920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 218947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218955 */     GIR_RootConstrainSelectedInstOperands,
     /* 218956 */     // GIR_Coverage, 7895,
     /* 218956 */     GIR_EraseRootFromParent_Done,
     /* 218957 */   // Label 4348: @218957
     /* 218957 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(218999), // Rule ID 7897 //
     /* 218962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 218989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218997 */     GIR_RootConstrainSelectedInstOperands,
     /* 218998 */     // GIR_Coverage, 7897,
     /* 218998 */     GIR_EraseRootFromParent_Done,
     /* 218999 */   // Label 4349: @218999
     /* 218999 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(219041), // Rule ID 7935 //
     /* 219004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 219012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 219031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219039 */     GIR_RootConstrainSelectedInstOperands,
     /* 219040 */     // GIR_Coverage, 7935,
     /* 219040 */     GIR_EraseRootFromParent_Done,
     /* 219041 */   // Label 4350: @219041
     /* 219041 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(219083), // Rule ID 7936 //
     /* 219046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 219054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 219073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219081 */     GIR_RootConstrainSelectedInstOperands,
     /* 219082 */     // GIR_Coverage, 7936,
     /* 219082 */     GIR_EraseRootFromParent_Done,
     /* 219083 */   // Label 4351: @219083
     /* 219083 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(219125), // Rule ID 7937 //
     /* 219088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 219096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219112 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 219115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219123 */     GIR_RootConstrainSelectedInstOperands,
     /* 219124 */     // GIR_Coverage, 7937,
     /* 219124 */     GIR_EraseRootFromParent_Done,
     /* 219125 */   // Label 4352: @219125
     /* 219125 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(219167), // Rule ID 7938 //
     /* 219130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 219138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219154 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 219157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219165 */     GIR_RootConstrainSelectedInstOperands,
     /* 219166 */     // GIR_Coverage, 7938,
     /* 219166 */     GIR_EraseRootFromParent_Done,
     /* 219167 */   // Label 4353: @219167
     /* 219167 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(219209), // Rule ID 7939 //
     /* 219172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 219180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219196 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 219199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219207 */     GIR_RootConstrainSelectedInstOperands,
     /* 219208 */     // GIR_Coverage, 7939,
     /* 219208 */     GIR_EraseRootFromParent_Done,
     /* 219209 */   // Label 4354: @219209
     /* 219209 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(219251), // Rule ID 7940 //
     /* 219214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 219222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1386:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 219241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219249 */     GIR_RootConstrainSelectedInstOperands,
     /* 219250 */     // GIR_Coverage, 7940,
     /* 219250 */     GIR_EraseRootFromParent_Done,
     /* 219251 */   // Label 4355: @219251
     /* 219251 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(219293), // Rule ID 7941 //
     /* 219256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 219264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 219283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219291 */     GIR_RootConstrainSelectedInstOperands,
     /* 219292 */     // GIR_Coverage, 7941,
     /* 219292 */     GIR_EraseRootFromParent_Done,
     /* 219293 */   // Label 4356: @219293
     /* 219293 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(219335), // Rule ID 7942 //
     /* 219298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 219306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 219325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219333 */     GIR_RootConstrainSelectedInstOperands,
     /* 219334 */     // GIR_Coverage, 7942,
     /* 219334 */     GIR_EraseRootFromParent_Done,
     /* 219335 */   // Label 4357: @219335
     /* 219335 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(219377), // Rule ID 7943 //
     /* 219340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 219348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1325:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 219367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219375 */     GIR_RootConstrainSelectedInstOperands,
     /* 219376 */     // GIR_Coverage, 7943,
     /* 219376 */     GIR_EraseRootFromParent_Done,
     /* 219377 */   // Label 4358: @219377
     /* 219377 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(219419), // Rule ID 7944 //
     /* 219382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 219409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219417 */     GIR_RootConstrainSelectedInstOperands,
     /* 219418 */     // GIR_Coverage, 7944,
     /* 219418 */     GIR_EraseRootFromParent_Done,
     /* 219419 */   // Label 4359: @219419
     /* 219419 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219461), // Rule ID 7945 //
     /* 219424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219448 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 219451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219459 */     GIR_RootConstrainSelectedInstOperands,
     /* 219460 */     // GIR_Coverage, 7945,
     /* 219460 */     GIR_EraseRootFromParent_Done,
     /* 219461 */   // Label 4360: @219461
     /* 219461 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219503), // Rule ID 7946 //
     /* 219466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219490 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 219493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219501 */     GIR_RootConstrainSelectedInstOperands,
     /* 219502 */     // GIR_Coverage, 7946,
     /* 219502 */     GIR_EraseRootFromParent_Done,
     /* 219503 */   // Label 4361: @219503
     /* 219503 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219545), // Rule ID 7983 //
     /* 219508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219532 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219543 */     GIR_RootConstrainSelectedInstOperands,
     /* 219544 */     // GIR_Coverage, 7983,
     /* 219544 */     GIR_EraseRootFromParent_Done,
     /* 219545 */   // Label 4362: @219545
     /* 219545 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219587), // Rule ID 7985 //
     /* 219550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219585 */     GIR_RootConstrainSelectedInstOperands,
     /* 219586 */     // GIR_Coverage, 7985,
     /* 219586 */     GIR_EraseRootFromParent_Done,
     /* 219587 */   // Label 4363: @219587
     /* 219587 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219629), // Rule ID 7987 //
     /* 219592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219616 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219627 */     GIR_RootConstrainSelectedInstOperands,
     /* 219628 */     // GIR_Coverage, 7987,
     /* 219628 */     GIR_EraseRootFromParent_Done,
     /* 219629 */   // Label 4364: @219629
     /* 219629 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219671), // Rule ID 7989 //
     /* 219634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219669 */     GIR_RootConstrainSelectedInstOperands,
     /* 219670 */     // GIR_Coverage, 7989,
     /* 219670 */     GIR_EraseRootFromParent_Done,
     /* 219671 */   // Label 4365: @219671
     /* 219671 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219713), // Rule ID 7991 //
     /* 219676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219711 */     GIR_RootConstrainSelectedInstOperands,
     /* 219712 */     // GIR_Coverage, 7991,
     /* 219712 */     GIR_EraseRootFromParent_Done,
     /* 219713 */   // Label 4366: @219713
     /* 219713 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219755), // Rule ID 7993 //
     /* 219718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219742 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 219745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219753 */     GIR_RootConstrainSelectedInstOperands,
     /* 219754 */     // GIR_Coverage, 7993,
     /* 219754 */     GIR_EraseRootFromParent_Done,
     /* 219755 */   // Label 4367: @219755
     /* 219755 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(219797), // Rule ID 7995 //
     /* 219760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219784 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219795 */     GIR_RootConstrainSelectedInstOperands,
     /* 219796 */     // GIR_Coverage, 7995,
     /* 219796 */     GIR_EraseRootFromParent_Done,
     /* 219797 */   // Label 4368: @219797
     /* 219797 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(219839), // Rule ID 7996 //
     /* 219802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219826 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219837 */     GIR_RootConstrainSelectedInstOperands,
     /* 219838 */     // GIR_Coverage, 7996,
     /* 219838 */     GIR_EraseRootFromParent_Done,
     /* 219839 */   // Label 4369: @219839
     /* 219839 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(219881), // Rule ID 7997 //
     /* 219844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219868 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219879 */     GIR_RootConstrainSelectedInstOperands,
     /* 219880 */     // GIR_Coverage, 7997,
     /* 219880 */     GIR_EraseRootFromParent_Done,
     /* 219881 */   // Label 4370: @219881
     /* 219881 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(219923), // Rule ID 7998 //
     /* 219886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219921 */     GIR_RootConstrainSelectedInstOperands,
     /* 219922 */     // GIR_Coverage, 7998,
     /* 219922 */     GIR_EraseRootFromParent_Done,
     /* 219923 */   // Label 4371: @219923
     /* 219923 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(219965), // Rule ID 7999 //
     /* 219928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219963 */     GIR_RootConstrainSelectedInstOperands,
     /* 219964 */     // GIR_Coverage, 7999,
     /* 219964 */     GIR_EraseRootFromParent_Done,
     /* 219965 */   // Label 4372: @219965
     /* 219965 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(220007), // Rule ID 8000 //
     /* 219970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219994 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 219997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220005 */     GIR_RootConstrainSelectedInstOperands,
     /* 220006 */     // GIR_Coverage, 8000,
     /* 220006 */     GIR_EraseRootFromParent_Done,
     /* 220007 */   // Label 4373: @220007
     /* 220007 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220049), // Rule ID 8253 //
     /* 220012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 220020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220036 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1205:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 220039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220047 */     GIR_RootConstrainSelectedInstOperands,
     /* 220048 */     // GIR_Coverage, 8253,
     /* 220048 */     GIR_EraseRootFromParent_Done,
     /* 220049 */   // Label 4374: @220049
     /* 220049 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220091), // Rule ID 8255 //
     /* 220054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 220062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220078 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1201:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 220081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220089 */     GIR_RootConstrainSelectedInstOperands,
     /* 220090 */     // GIR_Coverage, 8255,
     /* 220090 */     GIR_EraseRootFromParent_Done,
     /* 220091 */   // Label 4375: @220091
     /* 220091 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220133), // Rule ID 8256 //
     /* 220096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 220104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220120 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1198:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 220123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220131 */     GIR_RootConstrainSelectedInstOperands,
     /* 220132 */     // GIR_Coverage, 8256,
     /* 220132 */     GIR_EraseRootFromParent_Done,
     /* 220133 */   // Label 4376: @220133
     /* 220133 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220175), // Rule ID 8257 //
     /* 220138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 220146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220162 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1198:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 220165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220173 */     GIR_RootConstrainSelectedInstOperands,
     /* 220174 */     // GIR_Coverage, 8257,
     /* 220174 */     GIR_EraseRootFromParent_Done,
     /* 220175 */   // Label 4377: @220175
     /* 220175 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220217), // Rule ID 8258 //
     /* 220180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 220188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1198:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 220207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220215 */     GIR_RootConstrainSelectedInstOperands,
     /* 220216 */     // GIR_Coverage, 8258,
     /* 220216 */     GIR_EraseRootFromParent_Done,
     /* 220217 */   // Label 4378: @220217
     /* 220217 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220259), // Rule ID 8259 //
     /* 220222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 220230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1198:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 220249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220257 */     GIR_RootConstrainSelectedInstOperands,
     /* 220258 */     // GIR_Coverage, 8259,
     /* 220258 */     GIR_EraseRootFromParent_Done,
     /* 220259 */   // Label 4379: @220259
     /* 220259 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(220301), // Rule ID 8260 //
     /* 220264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 220272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1198:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 220291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220299 */     GIR_RootConstrainSelectedInstOperands,
     /* 220300 */     // GIR_Coverage, 8260,
     /* 220300 */     GIR_EraseRootFromParent_Done,
     /* 220301 */   // Label 4380: @220301
     /* 220301 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220343), // Rule ID 8281 //
     /* 220306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220330 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1256:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220341 */     GIR_RootConstrainSelectedInstOperands,
     /* 220342 */     // GIR_Coverage, 8281,
     /* 220342 */     GIR_EraseRootFromParent_Done,
     /* 220343 */   // Label 4381: @220343
     /* 220343 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220385), // Rule ID 8282 //
     /* 220348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1256:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220383 */     GIR_RootConstrainSelectedInstOperands,
     /* 220384 */     // GIR_Coverage, 8282,
     /* 220384 */     GIR_EraseRootFromParent_Done,
     /* 220385 */   // Label 4382: @220385
     /* 220385 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220427), // Rule ID 8283 //
     /* 220390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1256:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220425 */     GIR_RootConstrainSelectedInstOperands,
     /* 220426 */     // GIR_Coverage, 8283,
     /* 220426 */     GIR_EraseRootFromParent_Done,
     /* 220427 */   // Label 4383: @220427
     /* 220427 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220469), // Rule ID 8284 //
     /* 220432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1256:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220467 */     GIR_RootConstrainSelectedInstOperands,
     /* 220468 */     // GIR_Coverage, 8284,
     /* 220468 */     GIR_EraseRootFromParent_Done,
     /* 220469 */   // Label 4384: @220469
     /* 220469 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220511), // Rule ID 8285 //
     /* 220474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1256:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220509 */     GIR_RootConstrainSelectedInstOperands,
     /* 220510 */     // GIR_Coverage, 8285,
     /* 220510 */     GIR_EraseRootFromParent_Done,
     /* 220511 */   // Label 4385: @220511
     /* 220511 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220553), // Rule ID 8301 //
     /* 220516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1527:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220551 */     GIR_RootConstrainSelectedInstOperands,
     /* 220552 */     // GIR_Coverage, 8301,
     /* 220552 */     GIR_EraseRootFromParent_Done,
     /* 220553 */   // Label 4386: @220553
     /* 220553 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(220595), // Rule ID 8302 //
     /* 220558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220593 */     GIR_RootConstrainSelectedInstOperands,
     /* 220594 */     // GIR_Coverage, 8302,
     /* 220594 */     GIR_EraseRootFromParent_Done,
     /* 220595 */   // Label 4387: @220595
     /* 220595 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(220637), // Rule ID 8303 //
     /* 220600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220624 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220635 */     GIR_RootConstrainSelectedInstOperands,
     /* 220636 */     // GIR_Coverage, 8303,
     /* 220636 */     GIR_EraseRootFromParent_Done,
     /* 220637 */   // Label 4388: @220637
     /* 220637 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(220679), // Rule ID 8304 //
     /* 220642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220666 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220677 */     GIR_RootConstrainSelectedInstOperands,
     /* 220678 */     // GIR_Coverage, 8304,
     /* 220678 */     GIR_EraseRootFromParent_Done,
     /* 220679 */   // Label 4389: @220679
     /* 220679 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(220721), // Rule ID 8305 //
     /* 220684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1527:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220719 */     GIR_RootConstrainSelectedInstOperands,
     /* 220720 */     // GIR_Coverage, 8305,
     /* 220720 */     GIR_EraseRootFromParent_Done,
     /* 220721 */   // Label 4390: @220721
     /* 220721 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(220763), // Rule ID 8306 //
     /* 220726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220750 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1523:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220761 */     GIR_RootConstrainSelectedInstOperands,
     /* 220762 */     // GIR_Coverage, 8306,
     /* 220762 */     GIR_EraseRootFromParent_Done,
     /* 220763 */   // Label 4391: @220763
     /* 220763 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(220805), // Rule ID 8307 //
     /* 220768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220803 */     GIR_RootConstrainSelectedInstOperands,
     /* 220804 */     // GIR_Coverage, 8307,
     /* 220804 */     GIR_EraseRootFromParent_Done,
     /* 220805 */   // Label 4392: @220805
     /* 220805 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(220847), // Rule ID 8308 //
     /* 220810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220845 */     GIR_RootConstrainSelectedInstOperands,
     /* 220846 */     // GIR_Coverage, 8308,
     /* 220846 */     GIR_EraseRootFromParent_Done,
     /* 220847 */   // Label 4393: @220847
     /* 220847 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(220889), // Rule ID 8309 //
     /* 220852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220887 */     GIR_RootConstrainSelectedInstOperands,
     /* 220888 */     // GIR_Coverage, 8309,
     /* 220888 */     GIR_EraseRootFromParent_Done,
     /* 220889 */   // Label 4394: @220889
     /* 220889 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(220931), // Rule ID 8310 //
     /* 220894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220918 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1523:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220929 */     GIR_RootConstrainSelectedInstOperands,
     /* 220930 */     // GIR_Coverage, 8310,
     /* 220930 */     GIR_EraseRootFromParent_Done,
     /* 220931 */   // Label 4395: @220931
     /* 220931 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(220973), // Rule ID 8311 //
     /* 220936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1521:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220971 */     GIR_RootConstrainSelectedInstOperands,
     /* 220972 */     // GIR_Coverage, 8311,
     /* 220972 */     GIR_EraseRootFromParent_Done,
     /* 220973 */   // Label 4396: @220973
     /* 220973 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221015), // Rule ID 8312 //
     /* 220978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1521:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 221002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 221005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221013 */     GIR_RootConstrainSelectedInstOperands,
     /* 221014 */     // GIR_Coverage, 8312,
     /* 221014 */     GIR_EraseRootFromParent_Done,
     /* 221015 */   // Label 4397: @221015
     /* 221015 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221057), // Rule ID 8313 //
     /* 221020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 221028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 221040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221044 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1521:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 221044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 221047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221055 */     GIR_RootConstrainSelectedInstOperands,
     /* 221056 */     // GIR_Coverage, 8313,
     /* 221056 */     GIR_EraseRootFromParent_Done,
     /* 221057 */   // Label 4398: @221057
     /* 221057 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221099), // Rule ID 8314 //
     /* 221062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 221070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 221073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 221082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1521:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 221086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 221089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221097 */     GIR_RootConstrainSelectedInstOperands,
     /* 221098 */     // GIR_Coverage, 8314,
     /* 221098 */     GIR_EraseRootFromParent_Done,
     /* 221099 */   // Label 4399: @221099
     /* 221099 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221141), // Rule ID 8315 //
     /* 221104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 221112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 221115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 221118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 221121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 221124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1521:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 221128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 221131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221139 */     GIR_RootConstrainSelectedInstOperands,
     /* 221140 */     // GIR_Coverage, 8315,
     /* 221140 */     GIR_EraseRootFromParent_Done,
     /* 221141 */   // Label 4400: @221141
     /* 221141 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(221183), // Rule ID 8316 //
     /* 221146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 221154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 221166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1517:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 221170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 221173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221181 */     GIR_RootConstrainSelectedInstOperands,
     /* 221182 */     // GIR_Coverage, 8316,
     /* 221182 */     GIR_EraseRootFromParent_Done,
     /* 221183 */   // Label 4401: @221183
     /* 221183 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(221225), // Rule ID 8317 //
     /* 221188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 221196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 221205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 221208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1517:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 221212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 221215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221223 */     GIR_RootConstrainSelectedInstOperands,
     /* 221224 */     // GIR_Coverage, 8317,
     /* 221224 */     GIR_EraseRootFromParent_Done,
     /* 221225 */   // Label 4402: @221225
     /* 221225 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(221267), // Rule ID 8318 //
     /* 221230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 221238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 221250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1517:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 221254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 221257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221265 */     GIR_RootConstrainSelectedInstOperands,
     /* 221266 */     // GIR_Coverage, 8318,
     /* 221266 */     GIR_EraseRootFromParent_Done,
     /* 221267 */   // Label 4403: @221267
     /* 221267 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(221309), // Rule ID 8319 //
     /* 221272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 221280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 221283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 221292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1517:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 221296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 221299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221307 */     GIR_RootConstrainSelectedInstOperands,
     /* 221308 */     // GIR_Coverage, 8319,
     /* 221308 */     GIR_EraseRootFromParent_Done,
     /* 221309 */   // Label 4404: @221309
     /* 221309 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(221351), // Rule ID 8320 //
     /* 221314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 221322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 221325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 221328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 221331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 221334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 221338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1517:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 221338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 221341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221349 */     GIR_RootConstrainSelectedInstOperands,
     /* 221350 */     // GIR_Coverage, 8320,
     /* 221350 */     GIR_EraseRootFromParent_Done,
     /* 221351 */   // Label 4405: @221351
     /* 221351 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(221393), // Rule ID 8328 //
     /* 221356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1214:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 221383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221391 */     GIR_RootConstrainSelectedInstOperands,
     /* 221392 */     // GIR_Coverage, 8328,
     /* 221392 */     GIR_EraseRootFromParent_Done,
     /* 221393 */   // Label 4406: @221393
     /* 221393 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(221435), // Rule ID 8329 //
     /* 221398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 221425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221433 */     GIR_RootConstrainSelectedInstOperands,
     /* 221434 */     // GIR_Coverage, 8329,
     /* 221434 */     GIR_EraseRootFromParent_Done,
     /* 221435 */   // Label 4407: @221435
     /* 221435 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(221477), // Rule ID 8330 //
     /* 221440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221475 */     GIR_RootConstrainSelectedInstOperands,
     /* 221476 */     // GIR_Coverage, 8330,
     /* 221476 */     GIR_EraseRootFromParent_Done,
     /* 221477 */   // Label 4408: @221477
     /* 221477 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(221519), // Rule ID 8331 //
     /* 221482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221517 */     GIR_RootConstrainSelectedInstOperands,
     /* 221518 */     // GIR_Coverage, 8331,
     /* 221518 */     GIR_EraseRootFromParent_Done,
     /* 221519 */   // Label 4409: @221519
     /* 221519 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(221561), // Rule ID 8332 //
     /* 221524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221548 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 221551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221559 */     GIR_RootConstrainSelectedInstOperands,
     /* 221560 */     // GIR_Coverage, 8332,
     /* 221560 */     GIR_EraseRootFromParent_Done,
     /* 221561 */   // Label 4410: @221561
     /* 221561 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(221603), // Rule ID 8333 //
     /* 221566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221601 */     GIR_RootConstrainSelectedInstOperands,
     /* 221602 */     // GIR_Coverage, 8333,
     /* 221602 */     GIR_EraseRootFromParent_Done,
     /* 221603 */   // Label 4411: @221603
     /* 221603 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(221645), // Rule ID 8334 //
     /* 221608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221643 */     GIR_RootConstrainSelectedInstOperands,
     /* 221644 */     // GIR_Coverage, 8334,
     /* 221644 */     GIR_EraseRootFromParent_Done,
     /* 221645 */   // Label 4412: @221645
     /* 221645 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221690), // Rule ID 9030 //
     /* 221650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1235:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 221677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221688 */     GIR_RootConstrainSelectedInstOperands,
     /* 221689 */     // GIR_Coverage, 9030,
     /* 221689 */     GIR_EraseRootFromParent_Done,
     /* 221690 */   // Label 4413: @221690
     /* 221690 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(221735), // Rule ID 9031 //
     /* 221695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221719 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1235:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 221722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221733 */     GIR_RootConstrainSelectedInstOperands,
     /* 221734 */     // GIR_Coverage, 9031,
     /* 221734 */     GIR_EraseRootFromParent_Done,
     /* 221735 */   // Label 4414: @221735
     /* 221735 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(221780), // Rule ID 9032 //
     /* 221740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1235:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 221767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221778 */     GIR_RootConstrainSelectedInstOperands,
     /* 221779 */     // GIR_Coverage, 9032,
     /* 221779 */     GIR_EraseRootFromParent_Done,
     /* 221780 */   // Label 4415: @221780
     /* 221780 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221825), // Rule ID 9033 //
     /* 221785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221809 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1225:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 221812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221823 */     GIR_RootConstrainSelectedInstOperands,
     /* 221824 */     // GIR_Coverage, 9033,
     /* 221824 */     GIR_EraseRootFromParent_Done,
     /* 221825 */   // Label 4416: @221825
     /* 221825 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221870), // Rule ID 9034 //
     /* 221830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1225:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 221857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221868 */     GIR_RootConstrainSelectedInstOperands,
     /* 221869 */     // GIR_Coverage, 9034,
     /* 221869 */     GIR_EraseRootFromParent_Done,
     /* 221870 */   // Label 4417: @221870
     /* 221870 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221915), // Rule ID 9035 //
     /* 221875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1225:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 221902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221913 */     GIR_RootConstrainSelectedInstOperands,
     /* 221914 */     // GIR_Coverage, 9035,
     /* 221914 */     GIR_EraseRootFromParent_Done,
     /* 221915 */   // Label 4418: @221915
     /* 221915 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221960), // Rule ID 9036 //
     /* 221920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1233:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 221947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221958 */     GIR_RootConstrainSelectedInstOperands,
     /* 221959 */     // GIR_Coverage, 9036,
     /* 221959 */     GIR_EraseRootFromParent_Done,
     /* 221960 */   // Label 4419: @221960
     /* 221960 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(222005), // Rule ID 9037 //
     /* 221965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1233:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 221992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222003 */     GIR_RootConstrainSelectedInstOperands,
     /* 222004 */     // GIR_Coverage, 9037,
     /* 222004 */     GIR_EraseRootFromParent_Done,
     /* 222005 */   // Label 4420: @222005
     /* 222005 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(222050), // Rule ID 9038 //
     /* 222010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 222018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1233:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 222037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222048 */     GIR_RootConstrainSelectedInstOperands,
     /* 222049 */     // GIR_Coverage, 9038,
     /* 222049 */     GIR_EraseRootFromParent_Done,
     /* 222050 */   // Label 4421: @222050
     /* 222050 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(222095), // Rule ID 9039 //
     /* 222055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 222063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1230:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 222082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222093 */     GIR_RootConstrainSelectedInstOperands,
     /* 222094 */     // GIR_Coverage, 9039,
     /* 222094 */     GIR_EraseRootFromParent_Done,
     /* 222095 */   // Label 4422: @222095
     /* 222095 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(222140), // Rule ID 9040 //
     /* 222100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 222108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1230:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 222127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222138 */     GIR_RootConstrainSelectedInstOperands,
     /* 222139 */     // GIR_Coverage, 9040,
     /* 222139 */     GIR_EraseRootFromParent_Done,
     /* 222140 */   // Label 4423: @222140
     /* 222140 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(222185), // Rule ID 9041 //
     /* 222145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 222153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1230:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222183 */     GIR_RootConstrainSelectedInstOperands,
     /* 222184 */     // GIR_Coverage, 9041,
     /* 222184 */     GIR_EraseRootFromParent_Done,
     /* 222185 */   // Label 4424: @222185
     /* 222185 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(222230), // Rule ID 9042 //
     /* 222190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 222198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222214 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1229:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 222217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222228 */     GIR_RootConstrainSelectedInstOperands,
     /* 222229 */     // GIR_Coverage, 9042,
     /* 222229 */     GIR_EraseRootFromParent_Done,
     /* 222230 */   // Label 4425: @222230
     /* 222230 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(222275), // Rule ID 9043 //
     /* 222235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 222243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1229:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 222262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222273 */     GIR_RootConstrainSelectedInstOperands,
     /* 222274 */     // GIR_Coverage, 9043,
     /* 222274 */     GIR_EraseRootFromParent_Done,
     /* 222275 */   // Label 4426: @222275
     /* 222275 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222320), // Rule ID 9044 //
     /* 222280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 222288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1229:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 222307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222318 */     GIR_RootConstrainSelectedInstOperands,
     /* 222319 */     // GIR_Coverage, 9044,
     /* 222319 */     GIR_EraseRootFromParent_Done,
     /* 222320 */   // Label 4427: @222320
     /* 222320 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222365), // Rule ID 9045 //
     /* 222325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 222333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222349 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1227:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 222352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222363 */     GIR_RootConstrainSelectedInstOperands,
     /* 222364 */     // GIR_Coverage, 9045,
     /* 222364 */     GIR_EraseRootFromParent_Done,
     /* 222365 */   // Label 4428: @222365
     /* 222365 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222410), // Rule ID 9046 //
     /* 222370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 222378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222394 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1227:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 222397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222408 */     GIR_RootConstrainSelectedInstOperands,
     /* 222409 */     // GIR_Coverage, 9046,
     /* 222409 */     GIR_EraseRootFromParent_Done,
     /* 222410 */   // Label 4429: @222410
     /* 222410 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222455), // Rule ID 9047 //
     /* 222415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 222423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222439 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1227:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 222442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222453 */     GIR_RootConstrainSelectedInstOperands,
     /* 222454 */     // GIR_Coverage, 9047,
     /* 222454 */     GIR_EraseRootFromParent_Done,
     /* 222455 */   // Label 4430: @222455
     /* 222455 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222500), // Rule ID 9048 //
     /* 222460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1231:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 222487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222498 */     GIR_RootConstrainSelectedInstOperands,
     /* 222499 */     // GIR_Coverage, 9048,
     /* 222499 */     GIR_EraseRootFromParent_Done,
     /* 222500 */   // Label 4431: @222500
     /* 222500 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222545), // Rule ID 9049 //
     /* 222505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1231:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 222532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222543 */     GIR_RootConstrainSelectedInstOperands,
     /* 222544 */     // GIR_Coverage, 9049,
     /* 222544 */     GIR_EraseRootFromParent_Done,
     /* 222545 */   // Label 4432: @222545
     /* 222545 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222590), // Rule ID 9050 //
     /* 222550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1231:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 222577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222588 */     GIR_RootConstrainSelectedInstOperands,
     /* 222589 */     // GIR_Coverage, 9050,
     /* 222589 */     GIR_EraseRootFromParent_Done,
     /* 222590 */   // Label 4433: @222590
     /* 222590 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222635), // Rule ID 9051 //
     /* 222595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222619 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1232:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 222622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222633 */     GIR_RootConstrainSelectedInstOperands,
     /* 222634 */     // GIR_Coverage, 9051,
     /* 222634 */     GIR_EraseRootFromParent_Done,
     /* 222635 */   // Label 4434: @222635
     /* 222635 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222680), // Rule ID 9052 //
     /* 222640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1232:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 222667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222678 */     GIR_RootConstrainSelectedInstOperands,
     /* 222679 */     // GIR_Coverage, 9052,
     /* 222679 */     GIR_EraseRootFromParent_Done,
     /* 222680 */   // Label 4435: @222680
     /* 222680 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222725), // Rule ID 9053 //
     /* 222685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222709 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1232:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 222712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222723 */     GIR_RootConstrainSelectedInstOperands,
     /* 222724 */     // GIR_Coverage, 9053,
     /* 222724 */     GIR_EraseRootFromParent_Done,
     /* 222725 */   // Label 4436: @222725
     /* 222725 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222767), // Rule ID 9450 //
     /* 222730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1268:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 222757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222765 */     GIR_RootConstrainSelectedInstOperands,
     /* 222766 */     // GIR_Coverage, 9450,
     /* 222766 */     GIR_EraseRootFromParent_Done,
     /* 222767 */   // Label 4437: @222767
     /* 222767 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(222809), // Rule ID 9451 //
     /* 222772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1268:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 222799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222807 */     GIR_RootConstrainSelectedInstOperands,
     /* 222808 */     // GIR_Coverage, 9451,
     /* 222808 */     GIR_EraseRootFromParent_Done,
     /* 222809 */   // Label 4438: @222809
     /* 222809 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(222851), // Rule ID 9452 //
     /* 222814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1268:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 222841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222849 */     GIR_RootConstrainSelectedInstOperands,
     /* 222850 */     // GIR_Coverage, 9452,
     /* 222850 */     GIR_EraseRootFromParent_Done,
     /* 222851 */   // Label 4439: @222851
     /* 222851 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(222893), // Rule ID 9990 //
     /* 222856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1499:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 222883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222891 */     GIR_RootConstrainSelectedInstOperands,
     /* 222892 */     // GIR_Coverage, 9990,
     /* 222892 */     GIR_EraseRootFromParent_Done,
     /* 222893 */   // Label 4440: @222893
     /* 222893 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(222935), // Rule ID 9991 //
     /* 222898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1499:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 222925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222933 */     GIR_RootConstrainSelectedInstOperands,
     /* 222934 */     // GIR_Coverage, 9991,
     /* 222934 */     GIR_EraseRootFromParent_Done,
     /* 222935 */   // Label 4441: @222935
     /* 222935 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(222977), // Rule ID 9992 //
     /* 222940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1499:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 222967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222975 */     GIR_RootConstrainSelectedInstOperands,
     /* 222976 */     // GIR_Coverage, 9992,
     /* 222976 */     GIR_EraseRootFromParent_Done,
     /* 222977 */   // Label 4442: @222977
     /* 222977 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223019), // Rule ID 9993 //
     /* 222982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1499:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 223009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223017 */     GIR_RootConstrainSelectedInstOperands,
     /* 223018 */     // GIR_Coverage, 9993,
     /* 223018 */     GIR_EraseRootFromParent_Done,
     /* 223019 */   // Label 4443: @223019
     /* 223019 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223061), // Rule ID 9994 //
     /* 223024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 223032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 223051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223059 */     GIR_RootConstrainSelectedInstOperands,
     /* 223060 */     // GIR_Coverage, 9994,
     /* 223060 */     GIR_EraseRootFromParent_Done,
     /* 223061 */   // Label 4444: @223061
     /* 223061 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223103), // Rule ID 9995 //
     /* 223066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 223074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223101 */     GIR_RootConstrainSelectedInstOperands,
     /* 223102 */     // GIR_Coverage, 9995,
     /* 223102 */     GIR_EraseRootFromParent_Done,
     /* 223103 */   // Label 4445: @223103
     /* 223103 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223145), // Rule ID 9996 //
     /* 223108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 223116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 223135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223143 */     GIR_RootConstrainSelectedInstOperands,
     /* 223144 */     // GIR_Coverage, 9996,
     /* 223144 */     GIR_EraseRootFromParent_Done,
     /* 223145 */   // Label 4446: @223145
     /* 223145 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223187), // Rule ID 9997 //
     /* 223150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 223158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 223177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223185 */     GIR_RootConstrainSelectedInstOperands,
     /* 223186 */     // GIR_Coverage, 9997,
     /* 223186 */     GIR_EraseRootFromParent_Done,
     /* 223187 */   // Label 4447: @223187
     /* 223187 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223229), // Rule ID 10010 //
     /* 223192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 223200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1501:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 223219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223227 */     GIR_RootConstrainSelectedInstOperands,
     /* 223228 */     // GIR_Coverage, 10010,
     /* 223228 */     GIR_EraseRootFromParent_Done,
     /* 223229 */   // Label 4448: @223229
     /* 223229 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223271), // Rule ID 10011 //
     /* 223234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 223242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1501:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 223261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223269 */     GIR_RootConstrainSelectedInstOperands,
     /* 223270 */     // GIR_Coverage, 10011,
     /* 223270 */     GIR_EraseRootFromParent_Done,
     /* 223271 */   // Label 4449: @223271
     /* 223271 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223313), // Rule ID 10012 //
     /* 223276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 223284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1501:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 223303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223311 */     GIR_RootConstrainSelectedInstOperands,
     /* 223312 */     // GIR_Coverage, 10012,
     /* 223312 */     GIR_EraseRootFromParent_Done,
     /* 223313 */   // Label 4450: @223313
     /* 223313 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223355), // Rule ID 10013 //
     /* 223318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 223326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1498:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 223345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223353 */     GIR_RootConstrainSelectedInstOperands,
     /* 223354 */     // GIR_Coverage, 10013,
     /* 223354 */     GIR_EraseRootFromParent_Done,
     /* 223355 */   // Label 4451: @223355
     /* 223355 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223397), // Rule ID 10014 //
     /* 223360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 223368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 223387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223395 */     GIR_RootConstrainSelectedInstOperands,
     /* 223396 */     // GIR_Coverage, 10014,
     /* 223396 */     GIR_EraseRootFromParent_Done,
     /* 223397 */   // Label 4452: @223397
     /* 223397 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223439), // Rule ID 10015 //
     /* 223402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 223410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 223429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223437 */     GIR_RootConstrainSelectedInstOperands,
     /* 223438 */     // GIR_Coverage, 10015,
     /* 223438 */     GIR_EraseRootFromParent_Done,
     /* 223439 */   // Label 4453: @223439
     /* 223439 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(223481), // Rule ID 10042 //
     /* 223444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 223452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223468 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1293:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 223471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223479 */     GIR_RootConstrainSelectedInstOperands,
     /* 223480 */     // GIR_Coverage, 10042,
     /* 223480 */     GIR_EraseRootFromParent_Done,
     /* 223481 */   // Label 4454: @223481
     /* 223481 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(223523), // Rule ID 10046 //
     /* 223486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 223494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 223513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223521 */     GIR_RootConstrainSelectedInstOperands,
     /* 223522 */     // GIR_Coverage, 10046,
     /* 223522 */     GIR_EraseRootFromParent_Done,
     /* 223523 */   // Label 4455: @223523
     /* 223523 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(223565), // Rule ID 10050 //
     /* 223528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 223536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1295:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 223555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223563 */     GIR_RootConstrainSelectedInstOperands,
     /* 223564 */     // GIR_Coverage, 10050,
     /* 223564 */     GIR_EraseRootFromParent_Done,
     /* 223565 */   // Label 4456: @223565
     /* 223565 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(223607), // Rule ID 10054 //
     /* 223570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 223578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1297:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 223597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223605 */     GIR_RootConstrainSelectedInstOperands,
     /* 223606 */     // GIR_Coverage, 10054,
     /* 223606 */     GIR_EraseRootFromParent_Done,
     /* 223607 */   // Label 4457: @223607
     /* 223607 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(223649), // Rule ID 10058 //
     /* 223612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 223620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1609:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 223639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223647 */     GIR_RootConstrainSelectedInstOperands,
     /* 223648 */     // GIR_Coverage, 10058,
     /* 223648 */     GIR_EraseRootFromParent_Done,
     /* 223649 */   // Label 4458: @223649
     /* 223649 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(223691), // Rule ID 10059 //
     /* 223654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 223662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223678 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1856:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 223681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223689 */     GIR_RootConstrainSelectedInstOperands,
     /* 223690 */     // GIR_Coverage, 10059,
     /* 223690 */     GIR_EraseRootFromParent_Done,
     /* 223691 */   // Label 4459: @223691
     /* 223691 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(223733), // Rule ID 10060 //
     /* 223696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 223704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223720 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1853:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 223723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223731 */     GIR_RootConstrainSelectedInstOperands,
     /* 223732 */     // GIR_Coverage, 10060,
     /* 223732 */     GIR_EraseRootFromParent_Done,
     /* 223733 */   // Label 4460: @223733
     /* 223733 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(223775), // Rule ID 10064 //
     /* 223738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 223746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223762 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1608:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 223765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223773 */     GIR_RootConstrainSelectedInstOperands,
     /* 223774 */     // GIR_Coverage, 10064,
     /* 223774 */     GIR_EraseRootFromParent_Done,
     /* 223775 */   // Label 4461: @223775
     /* 223775 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(223817), // Rule ID 10068 //
     /* 223780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 223788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 223807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223815 */     GIR_RootConstrainSelectedInstOperands,
     /* 223816 */     // GIR_Coverage, 10068,
     /* 223816 */     GIR_EraseRootFromParent_Done,
     /* 223817 */   // Label 4462: @223817
     /* 223817 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(223859), // Rule ID 10072 //
     /* 223822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 223830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223846 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 223849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223857 */     GIR_RootConstrainSelectedInstOperands,
     /* 223858 */     // GIR_Coverage, 10072,
     /* 223858 */     GIR_EraseRootFromParent_Done,
     /* 223859 */   // Label 4463: @223859
     /* 223859 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(223901), // Rule ID 10076 //
     /* 223864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 223872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223888 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1855:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 223891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223899 */     GIR_RootConstrainSelectedInstOperands,
     /* 223900 */     // GIR_Coverage, 10076,
     /* 223900 */     GIR_EraseRootFromParent_Done,
     /* 223901 */   // Label 4464: @223901
     /* 223901 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(223943), // Rule ID 10080 //
     /* 223906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 223914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1854:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 223933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223941 */     GIR_RootConstrainSelectedInstOperands,
     /* 223942 */     // GIR_Coverage, 10080,
     /* 223942 */     GIR_EraseRootFromParent_Done,
     /* 223943 */   // Label 4465: @223943
     /* 223943 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(223985), // Rule ID 10090 //
     /* 223948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 223956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 223975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223983 */     GIR_RootConstrainSelectedInstOperands,
     /* 223984 */     // GIR_Coverage, 10090,
     /* 223984 */     GIR_EraseRootFromParent_Done,
     /* 223985 */   // Label 4466: @223985
     /* 223985 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(224027), // Rule ID 10091 //
     /* 223990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 223998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 224017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224025 */     GIR_RootConstrainSelectedInstOperands,
     /* 224026 */     // GIR_Coverage, 10091,
     /* 224026 */     GIR_EraseRootFromParent_Done,
     /* 224027 */   // Label 4467: @224027
     /* 224027 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(224069), // Rule ID 10092 //
     /* 224032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 224040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 224059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224067 */     GIR_RootConstrainSelectedInstOperands,
     /* 224068 */     // GIR_Coverage, 10092,
     /* 224068 */     GIR_EraseRootFromParent_Done,
     /* 224069 */   // Label 4468: @224069
     /* 224069 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(224111), // Rule ID 10096 //
     /* 224074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 224082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 224101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224109 */     GIR_RootConstrainSelectedInstOperands,
     /* 224110 */     // GIR_Coverage, 10096,
     /* 224110 */     GIR_EraseRootFromParent_Done,
     /* 224111 */   // Label 4469: @224111
     /* 224111 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(224153), // Rule ID 10100 //
     /* 224116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 224124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1312:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 224143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224151 */     GIR_RootConstrainSelectedInstOperands,
     /* 224152 */     // GIR_Coverage, 10100,
     /* 224152 */     GIR_EraseRootFromParent_Done,
     /* 224153 */   // Label 4470: @224153
     /* 224153 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(224195), // Rule ID 10104 //
     /* 224158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 224166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 224185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224193 */     GIR_RootConstrainSelectedInstOperands,
     /* 224194 */     // GIR_Coverage, 10104,
     /* 224194 */     GIR_EraseRootFromParent_Done,
     /* 224195 */   // Label 4471: @224195
     /* 224195 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(224237), // Rule ID 10108 //
     /* 224200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 224208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1319:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 224227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224235 */     GIR_RootConstrainSelectedInstOperands,
     /* 224236 */     // GIR_Coverage, 10108,
     /* 224236 */     GIR_EraseRootFromParent_Done,
     /* 224237 */   // Label 4472: @224237
     /* 224237 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(224279), // Rule ID 10112 //
     /* 224242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 224250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 224269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224277 */     GIR_RootConstrainSelectedInstOperands,
     /* 224278 */     // GIR_Coverage, 10112,
     /* 224278 */     GIR_EraseRootFromParent_Done,
     /* 224279 */   // Label 4473: @224279
     /* 224279 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(224321), // Rule ID 11089 //
     /* 224284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 224287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 224292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1895:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 224311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224319 */     GIR_RootConstrainSelectedInstOperands,
     /* 224320 */     // GIR_Coverage, 11089,
     /* 224320 */     GIR_EraseRootFromParent_Done,
     /* 224321 */   // Label 4474: @224321
     /* 224321 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(224363), // Rule ID 11090 //
     /* 224326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 224329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 224334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 224353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224361 */     GIR_RootConstrainSelectedInstOperands,
     /* 224362 */     // GIR_Coverage, 11090,
     /* 224362 */     GIR_EraseRootFromParent_Done,
     /* 224363 */   // Label 4475: @224363
     /* 224363 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(224405), // Rule ID 11092 //
     /* 224368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 224371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 224376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 224395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224403 */     GIR_RootConstrainSelectedInstOperands,
     /* 224404 */     // GIR_Coverage, 11092,
     /* 224404 */     GIR_EraseRootFromParent_Done,
     /* 224405 */   // Label 4476: @224405
     /* 224405 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(224447), // Rule ID 11093 //
     /* 224410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 224413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 224418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 224437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224445 */     GIR_RootConstrainSelectedInstOperands,
     /* 224446 */     // GIR_Coverage, 11093,
     /* 224446 */     GIR_EraseRootFromParent_Done,
     /* 224447 */   // Label 4477: @224447
     /* 224447 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(224489), // Rule ID 11147 //
     /* 224452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 224479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224487 */     GIR_RootConstrainSelectedInstOperands,
     /* 224488 */     // GIR_Coverage, 11147,
     /* 224488 */     GIR_EraseRootFromParent_Done,
     /* 224489 */   // Label 4478: @224489
     /* 224489 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(224531), // Rule ID 11148 //
     /* 224494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 224521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224529 */     GIR_RootConstrainSelectedInstOperands,
     /* 224530 */     // GIR_Coverage, 11148,
     /* 224530 */     GIR_EraseRootFromParent_Done,
     /* 224531 */   // Label 4479: @224531
     /* 224531 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(224573), // Rule ID 11149 //
     /* 224536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 224563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224571 */     GIR_RootConstrainSelectedInstOperands,
     /* 224572 */     // GIR_Coverage, 11149,
     /* 224572 */     GIR_EraseRootFromParent_Done,
     /* 224573 */   // Label 4480: @224573
     /* 224573 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(224615), // Rule ID 11150 //
     /* 224578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 224605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224613 */     GIR_RootConstrainSelectedInstOperands,
     /* 224614 */     // GIR_Coverage, 11150,
     /* 224614 */     GIR_EraseRootFromParent_Done,
     /* 224615 */   // Label 4481: @224615
     /* 224615 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(224657), // Rule ID 11203 //
     /* 224620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1651:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 224647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224655 */     GIR_RootConstrainSelectedInstOperands,
     /* 224656 */     // GIR_Coverage, 11203,
     /* 224656 */     GIR_EraseRootFromParent_Done,
     /* 224657 */   // Label 4482: @224657
     /* 224657 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(224699), // Rule ID 11204 //
     /* 224662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1651:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 224689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224697 */     GIR_RootConstrainSelectedInstOperands,
     /* 224698 */     // GIR_Coverage, 11204,
     /* 224698 */     GIR_EraseRootFromParent_Done,
     /* 224699 */   // Label 4483: @224699
     /* 224699 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(224741), // Rule ID 11205 //
     /* 224704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1651:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 224731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224739 */     GIR_RootConstrainSelectedInstOperands,
     /* 224740 */     // GIR_Coverage, 11205,
     /* 224740 */     GIR_EraseRootFromParent_Done,
     /* 224741 */   // Label 4484: @224741
     /* 224741 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(224783), // Rule ID 11206 //
     /* 224746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 224773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224781 */     GIR_RootConstrainSelectedInstOperands,
     /* 224782 */     // GIR_Coverage, 11206,
     /* 224782 */     GIR_EraseRootFromParent_Done,
     /* 224783 */   // Label 4485: @224783
     /* 224783 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(224825), // Rule ID 11207 //
     /* 224788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1887:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 224815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224823 */     GIR_RootConstrainSelectedInstOperands,
     /* 224824 */     // GIR_Coverage, 11207,
     /* 224824 */     GIR_EraseRootFromParent_Done,
     /* 224825 */   // Label 4486: @224825
     /* 224825 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(224867), // Rule ID 11208 //
     /* 224830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1887:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 224857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224865 */     GIR_RootConstrainSelectedInstOperands,
     /* 224866 */     // GIR_Coverage, 11208,
     /* 224866 */     GIR_EraseRootFromParent_Done,
     /* 224867 */   // Label 4487: @224867
     /* 224867 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(224909), // Rule ID 11209 //
     /* 224872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 224899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224907 */     GIR_RootConstrainSelectedInstOperands,
     /* 224908 */     // GIR_Coverage, 11209,
     /* 224908 */     GIR_EraseRootFromParent_Done,
     /* 224909 */   // Label 4488: @224909
     /* 224909 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(224951), // Rule ID 11210 //
     /* 224914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 224941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224949 */     GIR_RootConstrainSelectedInstOperands,
     /* 224950 */     // GIR_Coverage, 11210,
     /* 224950 */     GIR_EraseRootFromParent_Done,
     /* 224951 */   // Label 4489: @224951
     /* 224951 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(224993), // Rule ID 11211 //
     /* 224956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 224983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224991 */     GIR_RootConstrainSelectedInstOperands,
     /* 224992 */     // GIR_Coverage, 11211,
     /* 224992 */     GIR_EraseRootFromParent_Done,
     /* 224993 */   // Label 4490: @224993
     /* 224993 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(225035), // Rule ID 11212 //
     /* 224998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 225006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1653:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 225025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225033 */     GIR_RootConstrainSelectedInstOperands,
     /* 225034 */     // GIR_Coverage, 11212,
     /* 225034 */     GIR_EraseRootFromParent_Done,
     /* 225035 */   // Label 4491: @225035
     /* 225035 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(225077), // Rule ID 11213 //
     /* 225040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 225048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1653:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 225067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225075 */     GIR_RootConstrainSelectedInstOperands,
     /* 225076 */     // GIR_Coverage, 11213,
     /* 225076 */     GIR_EraseRootFromParent_Done,
     /* 225077 */   // Label 4492: @225077
     /* 225077 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(225119), // Rule ID 11214 //
     /* 225082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 225090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1653:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 225109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225117 */     GIR_RootConstrainSelectedInstOperands,
     /* 225118 */     // GIR_Coverage, 11214,
     /* 225118 */     GIR_EraseRootFromParent_Done,
     /* 225119 */   // Label 4493: @225119
     /* 225119 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(225161), // Rule ID 11215 //
     /* 225124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 225132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 225151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225159 */     GIR_RootConstrainSelectedInstOperands,
     /* 225160 */     // GIR_Coverage, 11215,
     /* 225160 */     GIR_EraseRootFromParent_Done,
     /* 225161 */   // Label 4494: @225161
     /* 225161 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(225203), // Rule ID 11216 //
     /* 225166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 225174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 225193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225201 */     GIR_RootConstrainSelectedInstOperands,
     /* 225202 */     // GIR_Coverage, 11216,
     /* 225202 */     GIR_EraseRootFromParent_Done,
     /* 225203 */   // Label 4495: @225203
     /* 225203 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(225245), // Rule ID 11217 //
     /* 225208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 225216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1655:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225243 */     GIR_RootConstrainSelectedInstOperands,
     /* 225244 */     // GIR_Coverage, 11217,
     /* 225244 */     GIR_EraseRootFromParent_Done,
     /* 225245 */   // Label 4496: @225245
     /* 225245 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(225287), // Rule ID 11218 //
     /* 225250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 225258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 225277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225285 */     GIR_RootConstrainSelectedInstOperands,
     /* 225286 */     // GIR_Coverage, 11218,
     /* 225286 */     GIR_EraseRootFromParent_Done,
     /* 225287 */   // Label 4497: @225287
     /* 225287 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(225329), // Rule ID 11219 //
     /* 225292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 225300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 225319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225327 */     GIR_RootConstrainSelectedInstOperands,
     /* 225328 */     // GIR_Coverage, 11219,
     /* 225328 */     GIR_EraseRootFromParent_Done,
     /* 225329 */   // Label 4498: @225329
     /* 225329 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(225371), // Rule ID 11220 //
     /* 225334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 225342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 225361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225369 */     GIR_RootConstrainSelectedInstOperands,
     /* 225370 */     // GIR_Coverage, 11220,
     /* 225370 */     GIR_EraseRootFromParent_Done,
     /* 225371 */   // Label 4499: @225371
     /* 225371 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(225413), // Rule ID 11221 //
     /* 225376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 225384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1893:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 225403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225411 */     GIR_RootConstrainSelectedInstOperands,
     /* 225412 */     // GIR_Coverage, 11221,
     /* 225412 */     GIR_EraseRootFromParent_Done,
     /* 225413 */   // Label 4500: @225413
     /* 225413 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(225455), // Rule ID 11222 //
     /* 225418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 225426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1893:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 225445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225453 */     GIR_RootConstrainSelectedInstOperands,
     /* 225454 */     // GIR_Coverage, 11222,
     /* 225454 */     GIR_EraseRootFromParent_Done,
     /* 225455 */   // Label 4501: @225455
     /* 225455 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(225497), // Rule ID 11223 //
     /* 225460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 225468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1893:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 225487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225495 */     GIR_RootConstrainSelectedInstOperands,
     /* 225496 */     // GIR_Coverage, 11223,
     /* 225496 */     GIR_EraseRootFromParent_Done,
     /* 225497 */   // Label 4502: @225497
     /* 225497 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(225539), // Rule ID 11232 //
     /* 225502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 225529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225537 */     GIR_RootConstrainSelectedInstOperands,
     /* 225538 */     // GIR_Coverage, 11232,
     /* 225538 */     GIR_EraseRootFromParent_Done,
     /* 225539 */   // Label 4503: @225539
     /* 225539 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(225581), // Rule ID 11233 //
     /* 225544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 225571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225579 */     GIR_RootConstrainSelectedInstOperands,
     /* 225580 */     // GIR_Coverage, 11233,
     /* 225580 */     GIR_EraseRootFromParent_Done,
     /* 225581 */   // Label 4504: @225581
     /* 225581 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(225623), // Rule ID 11234 //
     /* 225586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 225613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225621 */     GIR_RootConstrainSelectedInstOperands,
     /* 225622 */     // GIR_Coverage, 11234,
     /* 225622 */     GIR_EraseRootFromParent_Done,
     /* 225623 */   // Label 4505: @225623
     /* 225623 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(225665), // Rule ID 11235 //
     /* 225628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 225655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225663 */     GIR_RootConstrainSelectedInstOperands,
     /* 225664 */     // GIR_Coverage, 11235,
     /* 225664 */     GIR_EraseRootFromParent_Done,
     /* 225665 */   // Label 4506: @225665
     /* 225665 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(225707), // Rule ID 11236 //
     /* 225670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 225697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225705 */     GIR_RootConstrainSelectedInstOperands,
     /* 225706 */     // GIR_Coverage, 11236,
     /* 225706 */     GIR_EraseRootFromParent_Done,
     /* 225707 */   // Label 4507: @225707
     /* 225707 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(225749), // Rule ID 11237 //
     /* 225712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 225739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225747 */     GIR_RootConstrainSelectedInstOperands,
     /* 225748 */     // GIR_Coverage, 11237,
     /* 225748 */     GIR_EraseRootFromParent_Done,
     /* 225749 */   // Label 4508: @225749
     /* 225749 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(225791), // Rule ID 11238 //
     /* 225754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 225781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225789 */     GIR_RootConstrainSelectedInstOperands,
     /* 225790 */     // GIR_Coverage, 11238,
     /* 225790 */     GIR_EraseRootFromParent_Done,
     /* 225791 */   // Label 4509: @225791
     /* 225791 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(225833), // Rule ID 11239 //
     /* 225796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 225823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225831 */     GIR_RootConstrainSelectedInstOperands,
     /* 225832 */     // GIR_Coverage, 11239,
     /* 225832 */     GIR_EraseRootFromParent_Done,
     /* 225833 */   // Label 4510: @225833
     /* 225833 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(225875), // Rule ID 11240 //
     /* 225838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 225865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225873 */     GIR_RootConstrainSelectedInstOperands,
     /* 225874 */     // GIR_Coverage, 11240,
     /* 225874 */     GIR_EraseRootFromParent_Done,
     /* 225875 */   // Label 4511: @225875
     /* 225875 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(225917), // Rule ID 11241 //
     /* 225880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 225907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225915 */     GIR_RootConstrainSelectedInstOperands,
     /* 225916 */     // GIR_Coverage, 11241,
     /* 225916 */     GIR_EraseRootFromParent_Done,
     /* 225917 */   // Label 4512: @225917
     /* 225917 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(225959), // Rule ID 11242 //
     /* 225922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 225949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225957 */     GIR_RootConstrainSelectedInstOperands,
     /* 225958 */     // GIR_Coverage, 11242,
     /* 225958 */     GIR_EraseRootFromParent_Done,
     /* 225959 */   // Label 4513: @225959
     /* 225959 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(226001), // Rule ID 11243 //
     /* 225964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 225991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225999 */     GIR_RootConstrainSelectedInstOperands,
     /* 226000 */     // GIR_Coverage, 11243,
     /* 226000 */     GIR_EraseRootFromParent_Done,
     /* 226001 */   // Label 4514: @226001
     /* 226001 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(226043), // Rule ID 11244 //
     /* 226006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 226014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 226033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226041 */     GIR_RootConstrainSelectedInstOperands,
     /* 226042 */     // GIR_Coverage, 11244,
     /* 226042 */     GIR_EraseRootFromParent_Done,
     /* 226043 */   // Label 4515: @226043
     /* 226043 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(226085), // Rule ID 11245 //
     /* 226048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 226056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 226075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226083 */     GIR_RootConstrainSelectedInstOperands,
     /* 226084 */     // GIR_Coverage, 11245,
     /* 226084 */     GIR_EraseRootFromParent_Done,
     /* 226085 */   // Label 4516: @226085
     /* 226085 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(226127), // Rule ID 11246 //
     /* 226090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 226098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 226117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226125 */     GIR_RootConstrainSelectedInstOperands,
     /* 226126 */     // GIR_Coverage, 11246,
     /* 226126 */     GIR_EraseRootFromParent_Done,
     /* 226127 */   // Label 4517: @226127
     /* 226127 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(226169), // Rule ID 11247 //
     /* 226132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 226140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 226159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226167 */     GIR_RootConstrainSelectedInstOperands,
     /* 226168 */     // GIR_Coverage, 11247,
     /* 226168 */     GIR_EraseRootFromParent_Done,
     /* 226169 */   // Label 4518: @226169
     /* 226169 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(226211), // Rule ID 11248 //
     /* 226174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 226182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 226201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226209 */     GIR_RootConstrainSelectedInstOperands,
     /* 226210 */     // GIR_Coverage, 11248,
     /* 226210 */     GIR_EraseRootFromParent_Done,
     /* 226211 */   // Label 4519: @226211
     /* 226211 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(226253), // Rule ID 11249 //
     /* 226216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 226224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 226243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 226245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226251 */     GIR_RootConstrainSelectedInstOperands,
     /* 226252 */     // GIR_Coverage, 11249,
     /* 226252 */     GIR_EraseRootFromParent_Done,
     /* 226253 */   // Label 4520: @226253
     /* 226253 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(226295), // Rule ID 11250 //
     /* 226258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 226266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 226285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226293 */     GIR_RootConstrainSelectedInstOperands,
     /* 226294 */     // GIR_Coverage, 11250,
     /* 226294 */     GIR_EraseRootFromParent_Done,
     /* 226295 */   // Label 4521: @226295
     /* 226295 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(226337), // Rule ID 11252 //
     /* 226300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 226308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 226327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226335 */     GIR_RootConstrainSelectedInstOperands,
     /* 226336 */     // GIR_Coverage, 11252,
     /* 226336 */     GIR_EraseRootFromParent_Done,
     /* 226337 */   // Label 4522: @226337
     /* 226337 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(226379), // Rule ID 11254 //
     /* 226342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 226350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 226369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226377 */     GIR_RootConstrainSelectedInstOperands,
     /* 226378 */     // GIR_Coverage, 11254,
     /* 226378 */     GIR_EraseRootFromParent_Done,
     /* 226379 */   // Label 4523: @226379
     /* 226379 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(226421), // Rule ID 11256 //
     /* 226384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 226392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 226411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226419 */     GIR_RootConstrainSelectedInstOperands,
     /* 226420 */     // GIR_Coverage, 11256,
     /* 226420 */     GIR_EraseRootFromParent_Done,
     /* 226421 */   // Label 4524: @226421
     /* 226421 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(226463), // Rule ID 11258 //
     /* 226426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 226453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226461 */     GIR_RootConstrainSelectedInstOperands,
     /* 226462 */     // GIR_Coverage, 11258,
     /* 226462 */     GIR_EraseRootFromParent_Done,
     /* 226463 */   // Label 4525: @226463
     /* 226463 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(226505), // Rule ID 11259 //
     /* 226468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 226495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226503 */     GIR_RootConstrainSelectedInstOperands,
     /* 226504 */     // GIR_Coverage, 11259,
     /* 226504 */     GIR_EraseRootFromParent_Done,
     /* 226505 */   // Label 4526: @226505
     /* 226505 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(226547), // Rule ID 11260 //
     /* 226510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 226537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226545 */     GIR_RootConstrainSelectedInstOperands,
     /* 226546 */     // GIR_Coverage, 11260,
     /* 226546 */     GIR_EraseRootFromParent_Done,
     /* 226547 */   // Label 4527: @226547
     /* 226547 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(226589), // Rule ID 11261 //
     /* 226552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 226579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226587 */     GIR_RootConstrainSelectedInstOperands,
     /* 226588 */     // GIR_Coverage, 11261,
     /* 226588 */     GIR_EraseRootFromParent_Done,
     /* 226589 */   // Label 4528: @226589
     /* 226589 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(226631), // Rule ID 11262 //
     /* 226594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 226621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226629 */     GIR_RootConstrainSelectedInstOperands,
     /* 226630 */     // GIR_Coverage, 11262,
     /* 226630 */     GIR_EraseRootFromParent_Done,
     /* 226631 */   // Label 4529: @226631
     /* 226631 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(226673), // Rule ID 11263 //
     /* 226636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 226663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226671 */     GIR_RootConstrainSelectedInstOperands,
     /* 226672 */     // GIR_Coverage, 11263,
     /* 226672 */     GIR_EraseRootFromParent_Done,
     /* 226673 */   // Label 4530: @226673
     /* 226673 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(226715), // Rule ID 11264 //
     /* 226678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 226705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226713 */     GIR_RootConstrainSelectedInstOperands,
     /* 226714 */     // GIR_Coverage, 11264,
     /* 226714 */     GIR_EraseRootFromParent_Done,
     /* 226715 */   // Label 4531: @226715
     /* 226715 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(226757), // Rule ID 11265 //
     /* 226720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 226747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226755 */     GIR_RootConstrainSelectedInstOperands,
     /* 226756 */     // GIR_Coverage, 11265,
     /* 226756 */     GIR_EraseRootFromParent_Done,
     /* 226757 */   // Label 4532: @226757
     /* 226757 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(226799), // Rule ID 11266 //
     /* 226762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1761:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 226789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226797 */     GIR_RootConstrainSelectedInstOperands,
     /* 226798 */     // GIR_Coverage, 11266,
     /* 226798 */     GIR_EraseRootFromParent_Done,
     /* 226799 */   // Label 4533: @226799
     /* 226799 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(226841), // Rule ID 11268 //
     /* 226804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 226831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226839 */     GIR_RootConstrainSelectedInstOperands,
     /* 226840 */     // GIR_Coverage, 11268,
     /* 226840 */     GIR_EraseRootFromParent_Done,
     /* 226841 */   // Label 4534: @226841
     /* 226841 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(226883), // Rule ID 11270 //
     /* 226846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 226873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226881 */     GIR_RootConstrainSelectedInstOperands,
     /* 226882 */     // GIR_Coverage, 11270,
     /* 226882 */     GIR_EraseRootFromParent_Done,
     /* 226883 */   // Label 4535: @226883
     /* 226883 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(226925), // Rule ID 11272 //
     /* 226888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 226915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226923 */     GIR_RootConstrainSelectedInstOperands,
     /* 226924 */     // GIR_Coverage, 11272,
     /* 226924 */     GIR_EraseRootFromParent_Done,
     /* 226925 */   // Label 4536: @226925
     /* 226925 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(226967), // Rule ID 11274 //
     /* 226930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 226957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226965 */     GIR_RootConstrainSelectedInstOperands,
     /* 226966 */     // GIR_Coverage, 11274,
     /* 226966 */     GIR_EraseRootFromParent_Done,
     /* 226967 */   // Label 4537: @226967
     /* 226967 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(227009), // Rule ID 11276 //
     /* 226972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 226999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227007 */     GIR_RootConstrainSelectedInstOperands,
     /* 227008 */     // GIR_Coverage, 11276,
     /* 227008 */     GIR_EraseRootFromParent_Done,
     /* 227009 */   // Label 4538: @227009
     /* 227009 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(227051), // Rule ID 11278 //
     /* 227014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 227022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 227041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227049 */     GIR_RootConstrainSelectedInstOperands,
     /* 227050 */     // GIR_Coverage, 11278,
     /* 227050 */     GIR_EraseRootFromParent_Done,
     /* 227051 */   // Label 4539: @227051
     /* 227051 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(227093), // Rule ID 11280 //
     /* 227056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 227064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 227083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227091 */     GIR_RootConstrainSelectedInstOperands,
     /* 227092 */     // GIR_Coverage, 11280,
     /* 227092 */     GIR_EraseRootFromParent_Done,
     /* 227093 */   // Label 4540: @227093
     /* 227093 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(227135), // Rule ID 11282 //
     /* 227098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 227106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 227125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227133 */     GIR_RootConstrainSelectedInstOperands,
     /* 227134 */     // GIR_Coverage, 11282,
     /* 227134 */     GIR_EraseRootFromParent_Done,
     /* 227135 */   // Label 4541: @227135
     /* 227135 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(227177), // Rule ID 11283 //
     /* 227140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 227148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 227167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227175 */     GIR_RootConstrainSelectedInstOperands,
     /* 227176 */     // GIR_Coverage, 11283,
     /* 227176 */     GIR_EraseRootFromParent_Done,
     /* 227177 */   // Label 4542: @227177
     /* 227177 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(227219), // Rule ID 11284 //
     /* 227182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 227190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 227209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227217 */     GIR_RootConstrainSelectedInstOperands,
     /* 227218 */     // GIR_Coverage, 11284,
     /* 227218 */     GIR_EraseRootFromParent_Done,
     /* 227219 */   // Label 4543: @227219
     /* 227219 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(227261), // Rule ID 11285 //
     /* 227224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 227232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 227251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227259 */     GIR_RootConstrainSelectedInstOperands,
     /* 227260 */     // GIR_Coverage, 11285,
     /* 227260 */     GIR_EraseRootFromParent_Done,
     /* 227261 */   // Label 4544: @227261
     /* 227261 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(227303), // Rule ID 11286 //
     /* 227266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 227274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1868:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 227293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227301 */     GIR_RootConstrainSelectedInstOperands,
     /* 227302 */     // GIR_Coverage, 11286,
     /* 227302 */     GIR_EraseRootFromParent_Done,
     /* 227303 */   // Label 4545: @227303
     /* 227303 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(227345), // Rule ID 11287 //
     /* 227308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 227316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 227335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227343 */     GIR_RootConstrainSelectedInstOperands,
     /* 227344 */     // GIR_Coverage, 11287,
     /* 227344 */     GIR_EraseRootFromParent_Done,
     /* 227345 */   // Label 4546: @227345
     /* 227345 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(227387), // Rule ID 11288 //
     /* 227350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 227358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 227377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227385 */     GIR_RootConstrainSelectedInstOperands,
     /* 227386 */     // GIR_Coverage, 11288,
     /* 227386 */     GIR_EraseRootFromParent_Done,
     /* 227387 */   // Label 4547: @227387
     /* 227387 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(227429), // Rule ID 11289 //
     /* 227392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 227400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 227419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227427 */     GIR_RootConstrainSelectedInstOperands,
     /* 227428 */     // GIR_Coverage, 11289,
     /* 227428 */     GIR_EraseRootFromParent_Done,
     /* 227429 */   // Label 4548: @227429
     /* 227429 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(227471), // Rule ID 11290 //
     /* 227434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 227461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227469 */     GIR_RootConstrainSelectedInstOperands,
     /* 227470 */     // GIR_Coverage, 11290,
     /* 227470 */     GIR_EraseRootFromParent_Done,
     /* 227471 */   // Label 4549: @227471
     /* 227471 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(227513), // Rule ID 11291 //
     /* 227476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 227503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227511 */     GIR_RootConstrainSelectedInstOperands,
     /* 227512 */     // GIR_Coverage, 11291,
     /* 227512 */     GIR_EraseRootFromParent_Done,
     /* 227513 */   // Label 4550: @227513
     /* 227513 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(227555), // Rule ID 11292 //
     /* 227518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 227545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227553 */     GIR_RootConstrainSelectedInstOperands,
     /* 227554 */     // GIR_Coverage, 11292,
     /* 227554 */     GIR_EraseRootFromParent_Done,
     /* 227555 */   // Label 4551: @227555
     /* 227555 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(227597), // Rule ID 11293 //
     /* 227560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 227587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227595 */     GIR_RootConstrainSelectedInstOperands,
     /* 227596 */     // GIR_Coverage, 11293,
     /* 227596 */     GIR_EraseRootFromParent_Done,
     /* 227597 */   // Label 4552: @227597
     /* 227597 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(227639), // Rule ID 11294 //
     /* 227602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1158:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 227629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227637 */     GIR_RootConstrainSelectedInstOperands,
     /* 227638 */     // GIR_Coverage, 11294,
     /* 227638 */     GIR_EraseRootFromParent_Done,
     /* 227639 */   // Label 4553: @227639
     /* 227639 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(227681), // Rule ID 11295 //
     /* 227644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1158:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 227671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227679 */     GIR_RootConstrainSelectedInstOperands,
     /* 227680 */     // GIR_Coverage, 11295,
     /* 227680 */     GIR_EraseRootFromParent_Done,
     /* 227681 */   // Label 4554: @227681
     /* 227681 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(227723), // Rule ID 11296 //
     /* 227686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1158:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 227713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227721 */     GIR_RootConstrainSelectedInstOperands,
     /* 227722 */     // GIR_Coverage, 11296,
     /* 227722 */     GIR_EraseRootFromParent_Done,
     /* 227723 */   // Label 4555: @227723
     /* 227723 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(227765), // Rule ID 11297 //
     /* 227728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 227755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227763 */     GIR_RootConstrainSelectedInstOperands,
     /* 227764 */     // GIR_Coverage, 11297,
     /* 227764 */     GIR_EraseRootFromParent_Done,
     /* 227765 */   // Label 4556: @227765
     /* 227765 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(227807), // Rule ID 11298 //
     /* 227770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1637:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227805 */     GIR_RootConstrainSelectedInstOperands,
     /* 227806 */     // GIR_Coverage, 11298,
     /* 227806 */     GIR_EraseRootFromParent_Done,
     /* 227807 */   // Label 4557: @227807
     /* 227807 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(227849), // Rule ID 11299 //
     /* 227812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 227839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227847 */     GIR_RootConstrainSelectedInstOperands,
     /* 227848 */     // GIR_Coverage, 11299,
     /* 227848 */     GIR_EraseRootFromParent_Done,
     /* 227849 */   // Label 4558: @227849
     /* 227849 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(227891), // Rule ID 11300 //
     /* 227854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1637:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 227881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227889 */     GIR_RootConstrainSelectedInstOperands,
     /* 227890 */     // GIR_Coverage, 11300,
     /* 227890 */     GIR_EraseRootFromParent_Done,
     /* 227891 */   // Label 4559: @227891
     /* 227891 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(227933), // Rule ID 11301 //
     /* 227896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1875:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 227923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227931 */     GIR_RootConstrainSelectedInstOperands,
     /* 227932 */     // GIR_Coverage, 11301,
     /* 227932 */     GIR_EraseRootFromParent_Done,
     /* 227933 */   // Label 4560: @227933
     /* 227933 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(227975), // Rule ID 11302 //
     /* 227938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 227965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227973 */     GIR_RootConstrainSelectedInstOperands,
     /* 227974 */     // GIR_Coverage, 11302,
     /* 227974 */     GIR_EraseRootFromParent_Done,
     /* 227975 */   // Label 4561: @227975
     /* 227975 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(228017), // Rule ID 11303 //
     /* 227980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 228007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228015 */     GIR_RootConstrainSelectedInstOperands,
     /* 228016 */     // GIR_Coverage, 11303,
     /* 228016 */     GIR_EraseRootFromParent_Done,
     /* 228017 */   // Label 4562: @228017
     /* 228017 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(228059), // Rule ID 11304 //
     /* 228022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 228030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 228049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228057 */     GIR_RootConstrainSelectedInstOperands,
     /* 228058 */     // GIR_Coverage, 11304,
     /* 228058 */     GIR_EraseRootFromParent_Done,
     /* 228059 */   // Label 4563: @228059
     /* 228059 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(228101), // Rule ID 11305 //
     /* 228064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 228072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 228091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228099 */     GIR_RootConstrainSelectedInstOperands,
     /* 228100 */     // GIR_Coverage, 11305,
     /* 228100 */     GIR_EraseRootFromParent_Done,
     /* 228101 */   // Label 4564: @228101
     /* 228101 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(228143), // Rule ID 11306 //
     /* 228106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 228114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 228133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228141 */     GIR_RootConstrainSelectedInstOperands,
     /* 228142 */     // GIR_Coverage, 11306,
     /* 228142 */     GIR_EraseRootFromParent_Done,
     /* 228143 */   // Label 4565: @228143
     /* 228143 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(228185), // Rule ID 11307 //
     /* 228148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 228156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 228175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228183 */     GIR_RootConstrainSelectedInstOperands,
     /* 228184 */     // GIR_Coverage, 11307,
     /* 228184 */     GIR_EraseRootFromParent_Done,
     /* 228185 */   // Label 4566: @228185
     /* 228185 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(228227), // Rule ID 11308 //
     /* 228190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 228198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1646:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 228217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228225 */     GIR_RootConstrainSelectedInstOperands,
     /* 228226 */     // GIR_Coverage, 11308,
     /* 228226 */     GIR_EraseRootFromParent_Done,
     /* 228227 */   // Label 4567: @228227
     /* 228227 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(228269), // Rule ID 11309 //
     /* 228232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 228240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1884:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 228259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228267 */     GIR_RootConstrainSelectedInstOperands,
     /* 228268 */     // GIR_Coverage, 11309,
     /* 228268 */     GIR_EraseRootFromParent_Done,
     /* 228269 */   // Label 4568: @228269
     /* 228269 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(228311), // Rule ID 11310 //
     /* 228274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 228282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1884:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 228301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228309 */     GIR_RootConstrainSelectedInstOperands,
     /* 228310 */     // GIR_Coverage, 11310,
     /* 228310 */     GIR_EraseRootFromParent_Done,
     /* 228311 */   // Label 4569: @228311
     /* 228311 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(228353), // Rule ID 11311 //
     /* 228316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 228324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1884:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 228343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228351 */     GIR_RootConstrainSelectedInstOperands,
     /* 228352 */     // GIR_Coverage, 11311,
     /* 228352 */     GIR_EraseRootFromParent_Done,
     /* 228353 */   // Label 4570: @228353
     /* 228353 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(228395), // Rule ID 11312 //
     /* 228358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 228366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 228385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228393 */     GIR_RootConstrainSelectedInstOperands,
     /* 228394 */     // GIR_Coverage, 11312,
     /* 228394 */     GIR_EraseRootFromParent_Done,
     /* 228395 */   // Label 4571: @228395
     /* 228395 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(228437), // Rule ID 11313 //
     /* 228400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 228408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 228427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228435 */     GIR_RootConstrainSelectedInstOperands,
     /* 228436 */     // GIR_Coverage, 11313,
     /* 228436 */     GIR_EraseRootFromParent_Done,
     /* 228437 */   // Label 4572: @228437
     /* 228437 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(228479), // Rule ID 11324 //
     /* 228442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 228469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228477 */     GIR_RootConstrainSelectedInstOperands,
     /* 228478 */     // GIR_Coverage, 11324,
     /* 228478 */     GIR_EraseRootFromParent_Done,
     /* 228479 */   // Label 4573: @228479
     /* 228479 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(228521), // Rule ID 11325 //
     /* 228484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 228511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228519 */     GIR_RootConstrainSelectedInstOperands,
     /* 228520 */     // GIR_Coverage, 11325,
     /* 228520 */     GIR_EraseRootFromParent_Done,
     /* 228521 */   // Label 4574: @228521
     /* 228521 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(228563), // Rule ID 11326 //
     /* 228526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 228553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228561 */     GIR_RootConstrainSelectedInstOperands,
     /* 228562 */     // GIR_Coverage, 11326,
     /* 228562 */     GIR_EraseRootFromParent_Done,
     /* 228563 */   // Label 4575: @228563
     /* 228563 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(228605), // Rule ID 11327 //
     /* 228568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 228595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228603 */     GIR_RootConstrainSelectedInstOperands,
     /* 228604 */     // GIR_Coverage, 11327,
     /* 228604 */     GIR_EraseRootFromParent_Done,
     /* 228605 */   // Label 4576: @228605
     /* 228605 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(228647), // Rule ID 11336 //
     /* 228610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 228637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228645 */     GIR_RootConstrainSelectedInstOperands,
     /* 228646 */     // GIR_Coverage, 11336,
     /* 228646 */     GIR_EraseRootFromParent_Done,
     /* 228647 */   // Label 4577: @228647
     /* 228647 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(228689), // Rule ID 11337 //
     /* 228652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 228679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228687 */     GIR_RootConstrainSelectedInstOperands,
     /* 228688 */     // GIR_Coverage, 11337,
     /* 228688 */     GIR_EraseRootFromParent_Done,
     /* 228689 */   // Label 4578: @228689
     /* 228689 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(228731), // Rule ID 11338 //
     /* 228694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 228721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228729 */     GIR_RootConstrainSelectedInstOperands,
     /* 228730 */     // GIR_Coverage, 11338,
     /* 228730 */     GIR_EraseRootFromParent_Done,
     /* 228731 */   // Label 4579: @228731
     /* 228731 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(228773), // Rule ID 11339 //
     /* 228736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 228763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228771 */     GIR_RootConstrainSelectedInstOperands,
     /* 228772 */     // GIR_Coverage, 11339,
     /* 228772 */     GIR_EraseRootFromParent_Done,
     /* 228773 */   // Label 4580: @228773
     /* 228773 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(228815), // Rule ID 11340 //
     /* 228778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1902:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 228805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228813 */     GIR_RootConstrainSelectedInstOperands,
     /* 228814 */     // GIR_Coverage, 11340,
     /* 228814 */     GIR_EraseRootFromParent_Done,
     /* 228815 */   // Label 4581: @228815
     /* 228815 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(228857), // Rule ID 11341 //
     /* 228820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1902:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 228847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228855 */     GIR_RootConstrainSelectedInstOperands,
     /* 228856 */     // GIR_Coverage, 11341,
     /* 228856 */     GIR_EraseRootFromParent_Done,
     /* 228857 */   // Label 4582: @228857
     /* 228857 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(228899), // Rule ID 11342 //
     /* 228862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1902:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 228889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228897 */     GIR_RootConstrainSelectedInstOperands,
     /* 228898 */     // GIR_Coverage, 11342,
     /* 228898 */     GIR_EraseRootFromParent_Done,
     /* 228899 */   // Label 4583: @228899
     /* 228899 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(228941), // Rule ID 11343 //
     /* 228904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1902:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 228931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228939 */     GIR_RootConstrainSelectedInstOperands,
     /* 228940 */     // GIR_Coverage, 11343,
     /* 228940 */     GIR_EraseRootFromParent_Done,
     /* 228941 */   // Label 4584: @228941
     /* 228941 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(228983), // Rule ID 11344 //
     /* 228946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1753:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 228973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228981 */     GIR_RootConstrainSelectedInstOperands,
     /* 228982 */     // GIR_Coverage, 11344,
     /* 228982 */     GIR_EraseRootFromParent_Done,
     /* 228983 */   // Label 4585: @228983
     /* 228983 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(229025), // Rule ID 11345 //
     /* 228988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 229015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229023 */     GIR_RootConstrainSelectedInstOperands,
     /* 229024 */     // GIR_Coverage, 11345,
     /* 229024 */     GIR_EraseRootFromParent_Done,
     /* 229025 */   // Label 4586: @229025
     /* 229025 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(229067), // Rule ID 11346 //
     /* 229030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 229038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 229057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229065 */     GIR_RootConstrainSelectedInstOperands,
     /* 229066 */     // GIR_Coverage, 11346,
     /* 229066 */     GIR_EraseRootFromParent_Done,
     /* 229067 */   // Label 4587: @229067
     /* 229067 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(229109), // Rule ID 11347 //
     /* 229072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 229080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 229099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229107 */     GIR_RootConstrainSelectedInstOperands,
     /* 229108 */     // GIR_Coverage, 11347,
     /* 229108 */     GIR_EraseRootFromParent_Done,
     /* 229109 */   // Label 4588: @229109
     /* 229109 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(229151), // Rule ID 11348 //
     /* 229114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 229122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 229141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229149 */     GIR_RootConstrainSelectedInstOperands,
     /* 229150 */     // GIR_Coverage, 11348,
     /* 229150 */     GIR_EraseRootFromParent_Done,
     /* 229151 */   // Label 4589: @229151
     /* 229151 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(229193), // Rule ID 11349 //
     /* 229156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 229164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 229183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229191 */     GIR_RootConstrainSelectedInstOperands,
     /* 229192 */     // GIR_Coverage, 11349,
     /* 229192 */     GIR_EraseRootFromParent_Done,
     /* 229193 */   // Label 4590: @229193
     /* 229193 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(229235), // Rule ID 11350 //
     /* 229198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 229206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 229225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229233 */     GIR_RootConstrainSelectedInstOperands,
     /* 229234 */     // GIR_Coverage, 11350,
     /* 229234 */     GIR_EraseRootFromParent_Done,
     /* 229235 */   // Label 4591: @229235
     /* 229235 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(229277), // Rule ID 11351 //
     /* 229240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 229248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 229267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229275 */     GIR_RootConstrainSelectedInstOperands,
     /* 229276 */     // GIR_Coverage, 11351,
     /* 229276 */     GIR_EraseRootFromParent_Done,
     /* 229277 */   // Label 4592: @229277
     /* 229277 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(229319), // Rule ID 11352 //
     /* 229282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 229290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1817:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 229309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229317 */     GIR_RootConstrainSelectedInstOperands,
     /* 229318 */     // GIR_Coverage, 11352,
     /* 229318 */     GIR_EraseRootFromParent_Done,
     /* 229319 */   // Label 4593: @229319
     /* 229319 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(229361), // Rule ID 11353 //
     /* 229324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 229332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 229351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229359 */     GIR_RootConstrainSelectedInstOperands,
     /* 229360 */     // GIR_Coverage, 11353,
     /* 229360 */     GIR_EraseRootFromParent_Done,
     /* 229361 */   // Label 4594: @229361
     /* 229361 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(229403), // Rule ID 11354 //
     /* 229366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 229374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 229393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229401 */     GIR_RootConstrainSelectedInstOperands,
     /* 229402 */     // GIR_Coverage, 11354,
     /* 229402 */     GIR_EraseRootFromParent_Done,
     /* 229403 */   // Label 4595: @229403
     /* 229403 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(229445), // Rule ID 11355 //
     /* 229408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 229416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 229435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229443 */     GIR_RootConstrainSelectedInstOperands,
     /* 229444 */     // GIR_Coverage, 11355,
     /* 229444 */     GIR_EraseRootFromParent_Done,
     /* 229445 */   // Label 4596: @229445
     /* 229445 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(229487), // Rule ID 11356 //
     /* 229450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 229477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229485 */     GIR_RootConstrainSelectedInstOperands,
     /* 229486 */     // GIR_Coverage, 11356,
     /* 229486 */     GIR_EraseRootFromParent_Done,
     /* 229487 */   // Label 4597: @229487
     /* 229487 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(229529), // Rule ID 11357 //
     /* 229492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 229519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229527 */     GIR_RootConstrainSelectedInstOperands,
     /* 229528 */     // GIR_Coverage, 11357,
     /* 229528 */     GIR_EraseRootFromParent_Done,
     /* 229529 */   // Label 4598: @229529
     /* 229529 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(229571), // Rule ID 11358 //
     /* 229534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 229561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229569 */     GIR_RootConstrainSelectedInstOperands,
     /* 229570 */     // GIR_Coverage, 11358,
     /* 229570 */     GIR_EraseRootFromParent_Done,
     /* 229571 */   // Label 4599: @229571
     /* 229571 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(229613), // Rule ID 11359 //
     /* 229576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 229603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229611 */     GIR_RootConstrainSelectedInstOperands,
     /* 229612 */     // GIR_Coverage, 11359,
     /* 229612 */     GIR_EraseRootFromParent_Done,
     /* 229613 */   // Label 4600: @229613
     /* 229613 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(229655), // Rule ID 11360 //
     /* 229618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1756:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 229645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229653 */     GIR_RootConstrainSelectedInstOperands,
     /* 229654 */     // GIR_Coverage, 11360,
     /* 229654 */     GIR_EraseRootFromParent_Done,
     /* 229655 */   // Label 4601: @229655
     /* 229655 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(229697), // Rule ID 11361 //
     /* 229660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 229687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229695 */     GIR_RootConstrainSelectedInstOperands,
     /* 229696 */     // GIR_Coverage, 11361,
     /* 229696 */     GIR_EraseRootFromParent_Done,
     /* 229697 */   // Label 4602: @229697
     /* 229697 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(229739), // Rule ID 11362 //
     /* 229702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 229729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229737 */     GIR_RootConstrainSelectedInstOperands,
     /* 229738 */     // GIR_Coverage, 11362,
     /* 229738 */     GIR_EraseRootFromParent_Done,
     /* 229739 */   // Label 4603: @229739
     /* 229739 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(229781), // Rule ID 11363 //
     /* 229744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 229771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229779 */     GIR_RootConstrainSelectedInstOperands,
     /* 229780 */     // GIR_Coverage, 11363,
     /* 229780 */     GIR_EraseRootFromParent_Done,
     /* 229781 */   // Label 4604: @229781
     /* 229781 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(229823), // Rule ID 11364 //
     /* 229786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1949:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 229813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229821 */     GIR_RootConstrainSelectedInstOperands,
     /* 229822 */     // GIR_Coverage, 11364,
     /* 229822 */     GIR_EraseRootFromParent_Done,
     /* 229823 */   // Label 4605: @229823
     /* 229823 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(229865), // Rule ID 11365 //
     /* 229828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 229855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229863 */     GIR_RootConstrainSelectedInstOperands,
     /* 229864 */     // GIR_Coverage, 11365,
     /* 229864 */     GIR_EraseRootFromParent_Done,
     /* 229865 */   // Label 4606: @229865
     /* 229865 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(229907), // Rule ID 11366 //
     /* 229870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 229897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229905 */     GIR_RootConstrainSelectedInstOperands,
     /* 229906 */     // GIR_Coverage, 11366,
     /* 229906 */     GIR_EraseRootFromParent_Done,
     /* 229907 */   // Label 4607: @229907
     /* 229907 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(229949), // Rule ID 11367 //
     /* 229912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 229939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229947 */     GIR_RootConstrainSelectedInstOperands,
     /* 229948 */     // GIR_Coverage, 11367,
     /* 229948 */     GIR_EraseRootFromParent_Done,
     /* 229949 */   // Label 4608: @229949
     /* 229949 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(229991), // Rule ID 11368 //
     /* 229954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1763:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 229981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229989 */     GIR_RootConstrainSelectedInstOperands,
     /* 229990 */     // GIR_Coverage, 11368,
     /* 229990 */     GIR_EraseRootFromParent_Done,
     /* 229991 */   // Label 4609: @229991
     /* 229991 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(230033), // Rule ID 11369 //
     /* 229996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 230004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 230023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230031 */     GIR_RootConstrainSelectedInstOperands,
     /* 230032 */     // GIR_Coverage, 11369,
     /* 230032 */     GIR_EraseRootFromParent_Done,
     /* 230033 */   // Label 4610: @230033
     /* 230033 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(230075), // Rule ID 11370 //
     /* 230038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 230046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 230065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230073 */     GIR_RootConstrainSelectedInstOperands,
     /* 230074 */     // GIR_Coverage, 11370,
     /* 230074 */     GIR_EraseRootFromParent_Done,
     /* 230075 */   // Label 4611: @230075
     /* 230075 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(230117), // Rule ID 11371 //
     /* 230080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 230088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 230107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230115 */     GIR_RootConstrainSelectedInstOperands,
     /* 230116 */     // GIR_Coverage, 11371,
     /* 230116 */     GIR_EraseRootFromParent_Done,
     /* 230117 */   // Label 4612: @230117
     /* 230117 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(230159), // Rule ID 11372 //
     /* 230122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 230130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1954:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 230149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230157 */     GIR_RootConstrainSelectedInstOperands,
     /* 230158 */     // GIR_Coverage, 11372,
     /* 230158 */     GIR_EraseRootFromParent_Done,
     /* 230159 */   // Label 4613: @230159
     /* 230159 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(230201), // Rule ID 11373 //
     /* 230164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 230172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1954:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 230191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230199 */     GIR_RootConstrainSelectedInstOperands,
     /* 230200 */     // GIR_Coverage, 11373,
     /* 230200 */     GIR_EraseRootFromParent_Done,
     /* 230201 */   // Label 4614: @230201
     /* 230201 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(230243), // Rule ID 11374 //
     /* 230206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 230214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 230233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230241 */     GIR_RootConstrainSelectedInstOperands,
     /* 230242 */     // GIR_Coverage, 11374,
     /* 230242 */     GIR_EraseRootFromParent_Done,
     /* 230243 */   // Label 4615: @230243
     /* 230243 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(230285), // Rule ID 11375 //
     /* 230248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 230256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 230275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230283 */     GIR_RootConstrainSelectedInstOperands,
     /* 230284 */     // GIR_Coverage, 11375,
     /* 230284 */     GIR_EraseRootFromParent_Done,
     /* 230285 */   // Label 4616: @230285
     /* 230285 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(230327), // Rule ID 11376 //
     /* 230290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 230298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230314 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 230317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230325 */     GIR_RootConstrainSelectedInstOperands,
     /* 230326 */     // GIR_Coverage, 11376,
     /* 230326 */     GIR_EraseRootFromParent_Done,
     /* 230327 */   // Label 4617: @230327
     /* 230327 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(230369), // Rule ID 11377 //
     /* 230332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 230340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 230359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230367 */     GIR_RootConstrainSelectedInstOperands,
     /* 230368 */     // GIR_Coverage, 11377,
     /* 230368 */     GIR_EraseRootFromParent_Done,
     /* 230369 */   // Label 4618: @230369
     /* 230369 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(230411), // Rule ID 11378 //
     /* 230374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 230382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 230401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230409 */     GIR_RootConstrainSelectedInstOperands,
     /* 230410 */     // GIR_Coverage, 11378,
     /* 230410 */     GIR_EraseRootFromParent_Done,
     /* 230411 */   // Label 4619: @230411
     /* 230411 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(230453), // Rule ID 11379 //
     /* 230416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 230424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 230443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230451 */     GIR_RootConstrainSelectedInstOperands,
     /* 230452 */     // GIR_Coverage, 11379,
     /* 230452 */     GIR_EraseRootFromParent_Done,
     /* 230453 */   // Label 4620: @230453
     /* 230453 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(230495), // Rule ID 11380 //
     /* 230458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 230485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230493 */     GIR_RootConstrainSelectedInstOperands,
     /* 230494 */     // GIR_Coverage, 11380,
     /* 230494 */     GIR_EraseRootFromParent_Done,
     /* 230495 */   // Label 4621: @230495
     /* 230495 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(230537), // Rule ID 11381 //
     /* 230500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 230527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230535 */     GIR_RootConstrainSelectedInstOperands,
     /* 230536 */     // GIR_Coverage, 11381,
     /* 230536 */     GIR_EraseRootFromParent_Done,
     /* 230537 */   // Label 4622: @230537
     /* 230537 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(230579), // Rule ID 11382 //
     /* 230542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 230569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230577 */     GIR_RootConstrainSelectedInstOperands,
     /* 230578 */     // GIR_Coverage, 11382,
     /* 230578 */     GIR_EraseRootFromParent_Done,
     /* 230579 */   // Label 4623: @230579
     /* 230579 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(230621), // Rule ID 11383 //
     /* 230584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 230611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230619 */     GIR_RootConstrainSelectedInstOperands,
     /* 230620 */     // GIR_Coverage, 11383,
     /* 230620 */     GIR_EraseRootFromParent_Done,
     /* 230621 */   // Label 4624: @230621
     /* 230621 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(230663), // Rule ID 11384 //
     /* 230626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1734:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 230653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230661 */     GIR_RootConstrainSelectedInstOperands,
     /* 230662 */     // GIR_Coverage, 11384,
     /* 230662 */     GIR_EraseRootFromParent_Done,
     /* 230663 */   // Label 4625: @230663
     /* 230663 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(230705), // Rule ID 11385 //
     /* 230668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1734:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 230695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230703 */     GIR_RootConstrainSelectedInstOperands,
     /* 230704 */     // GIR_Coverage, 11385,
     /* 230704 */     GIR_EraseRootFromParent_Done,
     /* 230705 */   // Label 4626: @230705
     /* 230705 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(230747), // Rule ID 11386 //
     /* 230710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 230737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230745 */     GIR_RootConstrainSelectedInstOperands,
     /* 230746 */     // GIR_Coverage, 11386,
     /* 230746 */     GIR_EraseRootFromParent_Done,
     /* 230747 */   // Label 4627: @230747
     /* 230747 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(230789), // Rule ID 11387 //
     /* 230752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 230779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230787 */     GIR_RootConstrainSelectedInstOperands,
     /* 230788 */     // GIR_Coverage, 11387,
     /* 230788 */     GIR_EraseRootFromParent_Done,
     /* 230789 */   // Label 4628: @230789
     /* 230789 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(230831), // Rule ID 11388 //
     /* 230794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 230821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230829 */     GIR_RootConstrainSelectedInstOperands,
     /* 230830 */     // GIR_Coverage, 11388,
     /* 230830 */     GIR_EraseRootFromParent_Done,
     /* 230831 */   // Label 4629: @230831
     /* 230831 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(230873), // Rule ID 11389 //
     /* 230836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 230863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230871 */     GIR_RootConstrainSelectedInstOperands,
     /* 230872 */     // GIR_Coverage, 11389,
     /* 230872 */     GIR_EraseRootFromParent_Done,
     /* 230873 */   // Label 4630: @230873
     /* 230873 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(230915), // Rule ID 11390 //
     /* 230878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 230905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230913 */     GIR_RootConstrainSelectedInstOperands,
     /* 230914 */     // GIR_Coverage, 11390,
     /* 230914 */     GIR_EraseRootFromParent_Done,
     /* 230915 */   // Label 4631: @230915
     /* 230915 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(230957), // Rule ID 11391 //
     /* 230920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 230947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230955 */     GIR_RootConstrainSelectedInstOperands,
     /* 230956 */     // GIR_Coverage, 11391,
     /* 230956 */     GIR_EraseRootFromParent_Done,
     /* 230957 */   // Label 4632: @230957
     /* 230957 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(230999), // Rule ID 11554 //
     /* 230962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 230989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230997 */     GIR_RootConstrainSelectedInstOperands,
     /* 230998 */     // GIR_Coverage, 11554,
     /* 230998 */     GIR_EraseRootFromParent_Done,
     /* 230999 */   // Label 4633: @230999
     /* 230999 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(231041), // Rule ID 11556 //
     /* 231004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 231012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 231031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231039 */     GIR_RootConstrainSelectedInstOperands,
     /* 231040 */     // GIR_Coverage, 11556,
     /* 231040 */     GIR_EraseRootFromParent_Done,
     /* 231041 */   // Label 4634: @231041
     /* 231041 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(231083), // Rule ID 11558 //
     /* 231046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 231054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 231073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231081 */     GIR_RootConstrainSelectedInstOperands,
     /* 231082 */     // GIR_Coverage, 11558,
     /* 231082 */     GIR_EraseRootFromParent_Done,
     /* 231083 */   // Label 4635: @231083
     /* 231083 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(231125), // Rule ID 11560 //
     /* 231088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 231096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 231115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231123 */     GIR_RootConstrainSelectedInstOperands,
     /* 231124 */     // GIR_Coverage, 11560,
     /* 231124 */     GIR_EraseRootFromParent_Done,
     /* 231125 */   // Label 4636: @231125
     /* 231125 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(231167), // Rule ID 11562 //
     /* 231130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 231138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 231157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231165 */     GIR_RootConstrainSelectedInstOperands,
     /* 231166 */     // GIR_Coverage, 11562,
     /* 231166 */     GIR_EraseRootFromParent_Done,
     /* 231167 */   // Label 4637: @231167
     /* 231167 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(231209), // Rule ID 11563 //
     /* 231172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 231180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 231199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231207 */     GIR_RootConstrainSelectedInstOperands,
     /* 231208 */     // GIR_Coverage, 11563,
     /* 231208 */     GIR_EraseRootFromParent_Done,
     /* 231209 */   // Label 4638: @231209
     /* 231209 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(231251), // Rule ID 11564 //
     /* 231214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 231222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 231241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231249 */     GIR_RootConstrainSelectedInstOperands,
     /* 231250 */     // GIR_Coverage, 11564,
     /* 231250 */     GIR_EraseRootFromParent_Done,
     /* 231251 */   // Label 4639: @231251
     /* 231251 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(231293), // Rule ID 11565 //
     /* 231256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 231264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 231283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231291 */     GIR_RootConstrainSelectedInstOperands,
     /* 231292 */     // GIR_Coverage, 11565,
     /* 231292 */     GIR_EraseRootFromParent_Done,
     /* 231293 */   // Label 4640: @231293
     /* 231293 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(231335), // Rule ID 11566 //
     /* 231298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 231306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 231325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231333 */     GIR_RootConstrainSelectedInstOperands,
     /* 231334 */     // GIR_Coverage, 11566,
     /* 231334 */     GIR_EraseRootFromParent_Done,
     /* 231335 */   // Label 4641: @231335
     /* 231335 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(231377), // Rule ID 11567 //
     /* 231340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 231348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 231367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231375 */     GIR_RootConstrainSelectedInstOperands,
     /* 231376 */     // GIR_Coverage, 11567,
     /* 231376 */     GIR_EraseRootFromParent_Done,
     /* 231377 */   // Label 4642: @231377
     /* 231377 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(231419), // Rule ID 11568 //
     /* 231382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 231409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231417 */     GIR_RootConstrainSelectedInstOperands,
     /* 231418 */     // GIR_Coverage, 11568,
     /* 231418 */     GIR_EraseRootFromParent_Done,
     /* 231419 */   // Label 4643: @231419
     /* 231419 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(231461), // Rule ID 11569 //
     /* 231424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 231451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231459 */     GIR_RootConstrainSelectedInstOperands,
     /* 231460 */     // GIR_Coverage, 11569,
     /* 231460 */     GIR_EraseRootFromParent_Done,
     /* 231461 */   // Label 4644: @231461
     /* 231461 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(231503), // Rule ID 11570 //
     /* 231466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 231493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231501 */     GIR_RootConstrainSelectedInstOperands,
     /* 231502 */     // GIR_Coverage, 11570,
     /* 231502 */     GIR_EraseRootFromParent_Done,
     /* 231503 */   // Label 4645: @231503
     /* 231503 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(231545), // Rule ID 11571 //
     /* 231508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 231535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231543 */     GIR_RootConstrainSelectedInstOperands,
     /* 231544 */     // GIR_Coverage, 11571,
     /* 231544 */     GIR_EraseRootFromParent_Done,
     /* 231545 */   // Label 4646: @231545
     /* 231545 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(231587), // Rule ID 11572 //
     /* 231550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 231577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231585 */     GIR_RootConstrainSelectedInstOperands,
     /* 231586 */     // GIR_Coverage, 11572,
     /* 231586 */     GIR_EraseRootFromParent_Done,
     /* 231587 */   // Label 4647: @231587
     /* 231587 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(231629), // Rule ID 11573 //
     /* 231592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 231619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231627 */     GIR_RootConstrainSelectedInstOperands,
     /* 231628 */     // GIR_Coverage, 11573,
     /* 231628 */     GIR_EraseRootFromParent_Done,
     /* 231629 */   // Label 4648: @231629
     /* 231629 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(231671), // Rule ID 11574 //
     /* 231634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 231661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231669 */     GIR_RootConstrainSelectedInstOperands,
     /* 231670 */     // GIR_Coverage, 11574,
     /* 231670 */     GIR_EraseRootFromParent_Done,
     /* 231671 */   // Label 4649: @231671
     /* 231671 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(231713), // Rule ID 11575 //
     /* 231676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 231703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231711 */     GIR_RootConstrainSelectedInstOperands,
     /* 231712 */     // GIR_Coverage, 11575,
     /* 231712 */     GIR_EraseRootFromParent_Done,
     /* 231713 */   // Label 4650: @231713
     /* 231713 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(231755), // Rule ID 11576 //
     /* 231718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 231745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231753 */     GIR_RootConstrainSelectedInstOperands,
     /* 231754 */     // GIR_Coverage, 11576,
     /* 231754 */     GIR_EraseRootFromParent_Done,
     /* 231755 */   // Label 4651: @231755
     /* 231755 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(231797), // Rule ID 11631 //
     /* 231760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1569:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 231787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231795 */     GIR_RootConstrainSelectedInstOperands,
     /* 231796 */     // GIR_Coverage, 11631,
     /* 231796 */     GIR_EraseRootFromParent_Done,
     /* 231797 */   // Label 4652: @231797
     /* 231797 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(231839), // Rule ID 11632 //
     /* 231802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1569:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231837 */     GIR_RootConstrainSelectedInstOperands,
     /* 231838 */     // GIR_Coverage, 11632,
     /* 231838 */     GIR_EraseRootFromParent_Done,
     /* 231839 */   // Label 4653: @231839
     /* 231839 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(231881), // Rule ID 11633 //
     /* 231844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 231871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231879 */     GIR_RootConstrainSelectedInstOperands,
     /* 231880 */     // GIR_Coverage, 11633,
     /* 231880 */     GIR_EraseRootFromParent_Done,
     /* 231881 */   // Label 4654: @231881
     /* 231881 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(231923), // Rule ID 11634 //
     /* 231886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 231913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231921 */     GIR_RootConstrainSelectedInstOperands,
     /* 231922 */     // GIR_Coverage, 11634,
     /* 231922 */     GIR_EraseRootFromParent_Done,
     /* 231923 */   // Label 4655: @231923
     /* 231923 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(231965), // Rule ID 11635 //
     /* 231928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 231955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231963 */     GIR_RootConstrainSelectedInstOperands,
     /* 231964 */     // GIR_Coverage, 11635,
     /* 231964 */     GIR_EraseRootFromParent_Done,
     /* 231965 */   // Label 4656: @231965
     /* 231965 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(232007), // Rule ID 11636 //
     /* 231970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 231997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232005 */     GIR_RootConstrainSelectedInstOperands,
     /* 232006 */     // GIR_Coverage, 11636,
     /* 232006 */     GIR_EraseRootFromParent_Done,
     /* 232007 */   // Label 4657: @232007
     /* 232007 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(232049), // Rule ID 11637 //
     /* 232012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 232020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232036 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 232039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232047 */     GIR_RootConstrainSelectedInstOperands,
     /* 232048 */     // GIR_Coverage, 11637,
     /* 232048 */     GIR_EraseRootFromParent_Done,
     /* 232049 */   // Label 4658: @232049
     /* 232049 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(232091), // Rule ID 11638 //
     /* 232054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 232062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 232081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232089 */     GIR_RootConstrainSelectedInstOperands,
     /* 232090 */     // GIR_Coverage, 11638,
     /* 232090 */     GIR_EraseRootFromParent_Done,
     /* 232091 */   // Label 4659: @232091
     /* 232091 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(232133), // Rule ID 11639 //
     /* 232096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 232104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 232123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232131 */     GIR_RootConstrainSelectedInstOperands,
     /* 232132 */     // GIR_Coverage, 11639,
     /* 232132 */     GIR_EraseRootFromParent_Done,
     /* 232133 */   // Label 4660: @232133
     /* 232133 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(232178), // Rule ID 11652 //
     /* 232138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 232141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 232146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1520:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 232165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 232176 */     GIR_RootConstrainSelectedInstOperands,
     /* 232177 */     // GIR_Coverage, 11652,
     /* 232177 */     GIR_EraseRootFromParent_Done,
     /* 232178 */   // Label 4661: @232178
     /* 232178 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(232223), // Rule ID 11653 //
     /* 232183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 232186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 232191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 232194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1520:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 232210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 232221 */     GIR_RootConstrainSelectedInstOperands,
     /* 232222 */     // GIR_Coverage, 11653,
     /* 232222 */     GIR_EraseRootFromParent_Done,
     /* 232223 */   // Label 4662: @232223
     /* 232223 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(232265), // Rule ID 11654 //
     /* 232228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 232236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 232255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232263 */     GIR_RootConstrainSelectedInstOperands,
     /* 232264 */     // GIR_Coverage, 11654,
     /* 232264 */     GIR_EraseRootFromParent_Done,
     /* 232265 */   // Label 4663: @232265
     /* 232265 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(232307), // Rule ID 11655 //
     /* 232270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 232278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 232297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232305 */     GIR_RootConstrainSelectedInstOperands,
     /* 232306 */     // GIR_Coverage, 11655,
     /* 232306 */     GIR_EraseRootFromParent_Done,
     /* 232307 */   // Label 4664: @232307
     /* 232307 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(232349), // Rule ID 11656 //
     /* 232312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 232320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 232339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232347 */     GIR_RootConstrainSelectedInstOperands,
     /* 232348 */     // GIR_Coverage, 11656,
     /* 232348 */     GIR_EraseRootFromParent_Done,
     /* 232349 */   // Label 4665: @232349
     /* 232349 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(232391), // Rule ID 11657 //
     /* 232354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 232362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 232381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232389 */     GIR_RootConstrainSelectedInstOperands,
     /* 232390 */     // GIR_Coverage, 11657,
     /* 232390 */     GIR_EraseRootFromParent_Done,
     /* 232391 */   // Label 4666: @232391
     /* 232391 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(232433), // Rule ID 11673 //
     /* 232396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1343:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 232423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232431 */     GIR_RootConstrainSelectedInstOperands,
     /* 232432 */     // GIR_Coverage, 11673,
     /* 232432 */     GIR_EraseRootFromParent_Done,
     /* 232433 */   // Label 4667: @232433
     /* 232433 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(232475), // Rule ID 11674 //
     /* 232438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1343:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 232465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232473 */     GIR_RootConstrainSelectedInstOperands,
     /* 232474 */     // GIR_Coverage, 11674,
     /* 232474 */     GIR_EraseRootFromParent_Done,
     /* 232475 */   // Label 4668: @232475
     /* 232475 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(232517), // Rule ID 11675 //
     /* 232480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1343:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 232507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232515 */     GIR_RootConstrainSelectedInstOperands,
     /* 232516 */     // GIR_Coverage, 11675,
     /* 232516 */     GIR_EraseRootFromParent_Done,
     /* 232517 */   // Label 4669: @232517
     /* 232517 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(232559), // Rule ID 11676 //
     /* 232522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232546 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 232549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232557 */     GIR_RootConstrainSelectedInstOperands,
     /* 232558 */     // GIR_Coverage, 11676,
     /* 232558 */     GIR_EraseRootFromParent_Done,
     /* 232559 */   // Label 4670: @232559
     /* 232559 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(232601), // Rule ID 11677 //
     /* 232564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 232591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232599 */     GIR_RootConstrainSelectedInstOperands,
     /* 232600 */     // GIR_Coverage, 11677,
     /* 232600 */     GIR_EraseRootFromParent_Done,
     /* 232601 */   // Label 4671: @232601
     /* 232601 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(232643), // Rule ID 11678 //
     /* 232606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 232633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232641 */     GIR_RootConstrainSelectedInstOperands,
     /* 232642 */     // GIR_Coverage, 11678,
     /* 232642 */     GIR_EraseRootFromParent_Done,
     /* 232643 */   // Label 4672: @232643
     /* 232643 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(232685), // Rule ID 11679 //
     /* 232648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232672 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1346:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 232675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232683 */     GIR_RootConstrainSelectedInstOperands,
     /* 232684 */     // GIR_Coverage, 11679,
     /* 232684 */     GIR_EraseRootFromParent_Done,
     /* 232685 */   // Label 4673: @232685
     /* 232685 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(232727), // Rule ID 11680 //
     /* 232690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 232717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232725 */     GIR_RootConstrainSelectedInstOperands,
     /* 232726 */     // GIR_Coverage, 11680,
     /* 232726 */     GIR_EraseRootFromParent_Done,
     /* 232727 */   // Label 4674: @232727
     /* 232727 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(232769), // Rule ID 11681 //
     /* 232732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232756 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1346:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 232759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232767 */     GIR_RootConstrainSelectedInstOperands,
     /* 232768 */     // GIR_Coverage, 11681,
     /* 232768 */     GIR_EraseRootFromParent_Done,
     /* 232769 */   // Label 4675: @232769
     /* 232769 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(232811), // Rule ID 11682 //
     /* 232774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 232801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232809 */     GIR_RootConstrainSelectedInstOperands,
     /* 232810 */     // GIR_Coverage, 11682,
     /* 232810 */     GIR_EraseRootFromParent_Done,
     /* 232811 */   // Label 4676: @232811
     /* 232811 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(232853), // Rule ID 11683 //
     /* 232816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 232843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232851 */     GIR_RootConstrainSelectedInstOperands,
     /* 232852 */     // GIR_Coverage, 11683,
     /* 232852 */     GIR_EraseRootFromParent_Done,
     /* 232853 */   // Label 4677: @232853
     /* 232853 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(232895), // Rule ID 11684 //
     /* 232858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232882 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 232885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232893 */     GIR_RootConstrainSelectedInstOperands,
     /* 232894 */     // GIR_Coverage, 11684,
     /* 232894 */     GIR_EraseRootFromParent_Done,
     /* 232895 */   // Label 4678: @232895
     /* 232895 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(232937), // Rule ID 11689 //
     /* 232900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 232908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 232927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232935 */     GIR_RootConstrainSelectedInstOperands,
     /* 232936 */     // GIR_Coverage, 11689,
     /* 232936 */     GIR_EraseRootFromParent_Done,
     /* 232937 */   // Label 4679: @232937
     /* 232937 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(232979), // Rule ID 11690 //
     /* 232942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 232950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232966 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 232969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232977 */     GIR_RootConstrainSelectedInstOperands,
     /* 232978 */     // GIR_Coverage, 11690,
     /* 232978 */     GIR_EraseRootFromParent_Done,
     /* 232979 */   // Label 4680: @232979
     /* 232979 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(233021), // Rule ID 11691 //
     /* 232984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 232992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233008 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 233008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 233011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233019 */     GIR_RootConstrainSelectedInstOperands,
     /* 233020 */     // GIR_Coverage, 11691,
     /* 233020 */     GIR_EraseRootFromParent_Done,
     /* 233021 */   // Label 4681: @233021
     /* 233021 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(233063), // Rule ID 11692 //
     /* 233026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 233034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 233050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 233053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233061 */     GIR_RootConstrainSelectedInstOperands,
     /* 233062 */     // GIR_Coverage, 11692,
     /* 233062 */     GIR_EraseRootFromParent_Done,
     /* 233063 */   // Label 4682: @233063
     /* 233063 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(233105), // Rule ID 11693 //
     /* 233068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 233076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233092 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 233095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233103 */     GIR_RootConstrainSelectedInstOperands,
     /* 233104 */     // GIR_Coverage, 11693,
     /* 233104 */     GIR_EraseRootFromParent_Done,
     /* 233105 */   // Label 4683: @233105
     /* 233105 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(233147), // Rule ID 11695 //
     /* 233110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 233118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 233137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233145 */     GIR_RootConstrainSelectedInstOperands,
     /* 233146 */     // GIR_Coverage, 11695,
     /* 233146 */     GIR_EraseRootFromParent_Done,
     /* 233147 */   // Label 4684: @233147
     /* 233147 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(233189), // Rule ID 11697 //
     /* 233152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 233160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 233179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233187 */     GIR_RootConstrainSelectedInstOperands,
     /* 233188 */     // GIR_Coverage, 11697,
     /* 233188 */     GIR_EraseRootFromParent_Done,
     /* 233189 */   // Label 4685: @233189
     /* 233189 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(233231), // Rule ID 11699 //
     /* 233194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 233202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 233221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233229 */     GIR_RootConstrainSelectedInstOperands,
     /* 233230 */     // GIR_Coverage, 11699,
     /* 233230 */     GIR_EraseRootFromParent_Done,
     /* 233231 */   // Label 4686: @233231
     /* 233231 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(233273), // Rule ID 11701 //
     /* 233236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 233244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1206:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 233263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233271 */     GIR_RootConstrainSelectedInstOperands,
     /* 233272 */     // GIR_Coverage, 11701,
     /* 233272 */     GIR_EraseRootFromParent_Done,
     /* 233273 */   // Label 4687: @233273
     /* 233273 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(233315), // Rule ID 11703 //
     /* 233278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 233286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1206:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 233305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233313 */     GIR_RootConstrainSelectedInstOperands,
     /* 233314 */     // GIR_Coverage, 11703,
     /* 233314 */     GIR_EraseRootFromParent_Done,
     /* 233315 */   // Label 4688: @233315
     /* 233315 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(233357), // Rule ID 11705 //
     /* 233320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 233328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1206:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 233347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233355 */     GIR_RootConstrainSelectedInstOperands,
     /* 233356 */     // GIR_Coverage, 11705,
     /* 233356 */     GIR_EraseRootFromParent_Done,
     /* 233357 */   // Label 4689: @233357
     /* 233357 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(233399), // Rule ID 11707 //
     /* 233362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 233370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1206:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 233389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233397 */     GIR_RootConstrainSelectedInstOperands,
     /* 233398 */     // GIR_Coverage, 11707,
     /* 233398 */     GIR_EraseRootFromParent_Done,
     /* 233399 */   // Label 4690: @233399
     /* 233399 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(233441), // Rule ID 11709 //
     /* 233404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1207:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233439 */     GIR_RootConstrainSelectedInstOperands,
     /* 233440 */     // GIR_Coverage, 11709,
     /* 233440 */     GIR_EraseRootFromParent_Done,
     /* 233441 */   // Label 4691: @233441
     /* 233441 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(233483), // Rule ID 11710 //
     /* 233446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1207:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233481 */     GIR_RootConstrainSelectedInstOperands,
     /* 233482 */     // GIR_Coverage, 11710,
     /* 233482 */     GIR_EraseRootFromParent_Done,
     /* 233483 */   // Label 4692: @233483
     /* 233483 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(233525), // Rule ID 11711 //
     /* 233488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1207:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233523 */     GIR_RootConstrainSelectedInstOperands,
     /* 233524 */     // GIR_Coverage, 11711,
     /* 233524 */     GIR_EraseRootFromParent_Done,
     /* 233525 */   // Label 4693: @233525
     /* 233525 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(233567), // Rule ID 11712 //
     /* 233530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1207:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233565 */     GIR_RootConstrainSelectedInstOperands,
     /* 233566 */     // GIR_Coverage, 11712,
     /* 233566 */     GIR_EraseRootFromParent_Done,
     /* 233567 */   // Label 4694: @233567
     /* 233567 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(233609), // Rule ID 11713 //
     /* 233572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1208:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233607 */     GIR_RootConstrainSelectedInstOperands,
     /* 233608 */     // GIR_Coverage, 11713,
     /* 233608 */     GIR_EraseRootFromParent_Done,
     /* 233609 */   // Label 4695: @233609
     /* 233609 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(233651), // Rule ID 11714 //
     /* 233614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1208:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233649 */     GIR_RootConstrainSelectedInstOperands,
     /* 233650 */     // GIR_Coverage, 11714,
     /* 233650 */     GIR_EraseRootFromParent_Done,
     /* 233651 */   // Label 4696: @233651
     /* 233651 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(233693), // Rule ID 11715 //
     /* 233656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1208:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233691 */     GIR_RootConstrainSelectedInstOperands,
     /* 233692 */     // GIR_Coverage, 11715,
     /* 233692 */     GIR_EraseRootFromParent_Done,
     /* 233693 */   // Label 4697: @233693
     /* 233693 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(233735), // Rule ID 11716 //
     /* 233698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1208:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233733 */     GIR_RootConstrainSelectedInstOperands,
     /* 233734 */     // GIR_Coverage, 11716,
     /* 233734 */     GIR_EraseRootFromParent_Done,
     /* 233735 */   // Label 4698: @233735
     /* 233735 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(233777), // Rule ID 11717 //
     /* 233740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1518:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233775 */     GIR_RootConstrainSelectedInstOperands,
     /* 233776 */     // GIR_Coverage, 11717,
     /* 233776 */     GIR_EraseRootFromParent_Done,
     /* 233777 */   // Label 4699: @233777
     /* 233777 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(233819), // Rule ID 11719 //
     /* 233782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1518:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233817 */     GIR_RootConstrainSelectedInstOperands,
     /* 233818 */     // GIR_Coverage, 11719,
     /* 233818 */     GIR_EraseRootFromParent_Done,
     /* 233819 */   // Label 4700: @233819
     /* 233819 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(233861), // Rule ID 11721 //
     /* 233824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1518:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233859 */     GIR_RootConstrainSelectedInstOperands,
     /* 233860 */     // GIR_Coverage, 11721,
     /* 233860 */     GIR_EraseRootFromParent_Done,
     /* 233861 */   // Label 4701: @233861
     /* 233861 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(233903), // Rule ID 11723 //
     /* 233866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1518:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233901 */     GIR_RootConstrainSelectedInstOperands,
     /* 233902 */     // GIR_Coverage, 11723,
     /* 233902 */     GIR_EraseRootFromParent_Done,
     /* 233903 */   // Label 4702: @233903
     /* 233903 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(233945), // Rule ID 11812 //
     /* 233908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 233935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233943 */     GIR_RootConstrainSelectedInstOperands,
     /* 233944 */     // GIR_Coverage, 11812,
     /* 233944 */     GIR_EraseRootFromParent_Done,
     /* 233945 */   // Label 4703: @233945
     /* 233945 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(233987), // Rule ID 11814 //
     /* 233950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 233977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233985 */     GIR_RootConstrainSelectedInstOperands,
     /* 233986 */     // GIR_Coverage, 11814,
     /* 233986 */     GIR_EraseRootFromParent_Done,
     /* 233987 */   // Label 4704: @233987
     /* 233987 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(234029), // Rule ID 11816 //
     /* 233992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 234000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 234019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234027 */     GIR_RootConstrainSelectedInstOperands,
     /* 234028 */     // GIR_Coverage, 11816,
     /* 234028 */     GIR_EraseRootFromParent_Done,
     /* 234029 */   // Label 4705: @234029
     /* 234029 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(234071), // Rule ID 11818 //
     /* 234034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 234042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 234061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234069 */     GIR_RootConstrainSelectedInstOperands,
     /* 234070 */     // GIR_Coverage, 11818,
     /* 234070 */     GIR_EraseRootFromParent_Done,
     /* 234071 */   // Label 4706: @234071
     /* 234071 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(234113), // Rule ID 11820 //
     /* 234076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 234079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 234084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 234103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234111 */     GIR_RootConstrainSelectedInstOperands,
     /* 234112 */     // GIR_Coverage, 11820,
     /* 234112 */     GIR_EraseRootFromParent_Done,
     /* 234113 */   // Label 4707: @234113
     /* 234113 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(234155), // Rule ID 11822 //
     /* 234118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 234121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 234126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 234145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234153 */     GIR_RootConstrainSelectedInstOperands,
     /* 234154 */     // GIR_Coverage, 11822,
     /* 234154 */     GIR_EraseRootFromParent_Done,
     /* 234155 */   // Label 4708: @234155
     /* 234155 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(234197), // Rule ID 11985 //
     /* 234160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 234187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234195 */     GIR_RootConstrainSelectedInstOperands,
     /* 234196 */     // GIR_Coverage, 11985,
     /* 234196 */     GIR_EraseRootFromParent_Done,
     /* 234197 */   // Label 4709: @234197
     /* 234197 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(234239), // Rule ID 11986 //
     /* 234202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 234229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234237 */     GIR_RootConstrainSelectedInstOperands,
     /* 234238 */     // GIR_Coverage, 11986,
     /* 234238 */     GIR_EraseRootFromParent_Done,
     /* 234239 */   // Label 4710: @234239
     /* 234239 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(234281), // Rule ID 11987 //
     /* 234244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 234271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234279 */     GIR_RootConstrainSelectedInstOperands,
     /* 234280 */     // GIR_Coverage, 11987,
     /* 234280 */     GIR_EraseRootFromParent_Done,
     /* 234281 */   // Label 4711: @234281
     /* 234281 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(234323), // Rule ID 11988 //
     /* 234286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 234313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234321 */     GIR_RootConstrainSelectedInstOperands,
     /* 234322 */     // GIR_Coverage, 11988,
     /* 234322 */     GIR_EraseRootFromParent_Done,
     /* 234323 */   // Label 4712: @234323
     /* 234323 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(234365), // Rule ID 11989 //
     /* 234328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234352 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1825:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 234355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234363 */     GIR_RootConstrainSelectedInstOperands,
     /* 234364 */     // GIR_Coverage, 11989,
     /* 234364 */     GIR_EraseRootFromParent_Done,
     /* 234365 */   // Label 4713: @234365
     /* 234365 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(234407), // Rule ID 11990 //
     /* 234370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1825:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 234397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234405 */     GIR_RootConstrainSelectedInstOperands,
     /* 234406 */     // GIR_Coverage, 11990,
     /* 234406 */     GIR_EraseRootFromParent_Done,
     /* 234407 */   // Label 4714: @234407
     /* 234407 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(234449), // Rule ID 11991 //
     /* 234412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 234415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 234420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1825:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 234439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234447 */     GIR_RootConstrainSelectedInstOperands,
     /* 234448 */     // GIR_Coverage, 11991,
     /* 234448 */     GIR_EraseRootFromParent_Done,
     /* 234449 */   // Label 4715: @234449
     /* 234449 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(234491), // Rule ID 12336 //
     /* 234454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234478 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 234481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234489 */     GIR_RootConstrainSelectedInstOperands,
     /* 234490 */     // GIR_Coverage, 12336,
     /* 234490 */     GIR_EraseRootFromParent_Done,
     /* 234491 */   // Label 4716: @234491
     /* 234491 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(234533), // Rule ID 12337 //
     /* 234496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 234523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234531 */     GIR_RootConstrainSelectedInstOperands,
     /* 234532 */     // GIR_Coverage, 12337,
     /* 234532 */     GIR_EraseRootFromParent_Done,
     /* 234533 */   // Label 4717: @234533
     /* 234533 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(234575), // Rule ID 12338 //
     /* 234538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234562 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 234565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234573 */     GIR_RootConstrainSelectedInstOperands,
     /* 234574 */     // GIR_Coverage, 12338,
     /* 234574 */     GIR_EraseRootFromParent_Done,
     /* 234575 */   // Label 4718: @234575
     /* 234575 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(234617), // Rule ID 12339 //
     /* 234580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234604 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 234607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234615 */     GIR_RootConstrainSelectedInstOperands,
     /* 234616 */     // GIR_Coverage, 12339,
     /* 234616 */     GIR_EraseRootFromParent_Done,
     /* 234617 */   // Label 4719: @234617
     /* 234617 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(234659), // Rule ID 12340 //
     /* 234622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234646 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 234649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234657 */     GIR_RootConstrainSelectedInstOperands,
     /* 234658 */     // GIR_Coverage, 12340,
     /* 234658 */     GIR_EraseRootFromParent_Done,
     /* 234659 */   // Label 4720: @234659
     /* 234659 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(234701), // Rule ID 12341 //
     /* 234664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234688 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 234691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234699 */     GIR_RootConstrainSelectedInstOperands,
     /* 234700 */     // GIR_Coverage, 12341,
     /* 234700 */     GIR_EraseRootFromParent_Done,
     /* 234701 */   // Label 4721: @234701
     /* 234701 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(234743), // Rule ID 12342 //
     /* 234706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234741 */     GIR_RootConstrainSelectedInstOperands,
     /* 234742 */     // GIR_Coverage, 12342,
     /* 234742 */     GIR_EraseRootFromParent_Done,
     /* 234743 */   // Label 4722: @234743
     /* 234743 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(234785), // Rule ID 12345 //
     /* 234748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 234759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 234765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 234768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 234772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234783 */     GIR_RootConstrainSelectedInstOperands,
     /* 234784 */     // GIR_Coverage, 12345,
     /* 234784 */     GIR_EraseRootFromParent_Done,
     /* 234785 */   // Label 4723: @234785
     /* 234785 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(234827), // Rule ID 12348 //
     /* 234790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 234801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 234807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 234810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234814 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 234814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234825 */     GIR_RootConstrainSelectedInstOperands,
     /* 234826 */     // GIR_Coverage, 12348,
     /* 234826 */     GIR_EraseRootFromParent_Done,
     /* 234827 */   // Label 4724: @234827
     /* 234827 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(234869), // Rule ID 12351 //
     /* 234832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234867 */     GIR_RootConstrainSelectedInstOperands,
     /* 234868 */     // GIR_Coverage, 12351,
     /* 234868 */     GIR_EraseRootFromParent_Done,
     /* 234869 */   // Label 4725: @234869
     /* 234869 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(234911), // Rule ID 12354 //
     /* 234874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 234885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 234891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 234894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234898 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 234898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234909 */     GIR_RootConstrainSelectedInstOperands,
     /* 234910 */     // GIR_Coverage, 12354,
     /* 234910 */     GIR_EraseRootFromParent_Done,
     /* 234911 */   // Label 4726: @234911
     /* 234911 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(234953), // Rule ID 12357 //
     /* 234916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234940 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 234943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234951 */     GIR_RootConstrainSelectedInstOperands,
     /* 234952 */     // GIR_Coverage, 12357,
     /* 234952 */     GIR_EraseRootFromParent_Done,
     /* 234953 */   // Label 4727: @234953
     /* 234953 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(234995), // Rule ID 12360 //
     /* 234958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234993 */     GIR_RootConstrainSelectedInstOperands,
     /* 234994 */     // GIR_Coverage, 12360,
     /* 234994 */     GIR_EraseRootFromParent_Done,
     /* 234995 */   // Label 4728: @234995
     /* 234995 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(235037), // Rule ID 12363 //
     /* 235000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 235003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 235008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 235011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 235017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 235020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235024 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 235024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 235027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235035 */     GIR_RootConstrainSelectedInstOperands,
     /* 235036 */     // GIR_Coverage, 12363,
     /* 235036 */     GIR_EraseRootFromParent_Done,
     /* 235037 */   // Label 4729: @235037
     /* 235037 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(235079), // Rule ID 12366 //
     /* 235042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 235045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 235050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 235053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 235059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 235062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235066 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 235066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 235069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235077 */     GIR_RootConstrainSelectedInstOperands,
     /* 235078 */     // GIR_Coverage, 12366,
     /* 235078 */     GIR_EraseRootFromParent_Done,
     /* 235079 */   // Label 4730: @235079
     /* 235079 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(235121), // Rule ID 12369 //
     /* 235084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 235087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 235092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235108 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 235111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235119 */     GIR_RootConstrainSelectedInstOperands,
     /* 235120 */     // GIR_Coverage, 12369,
     /* 235120 */     GIR_EraseRootFromParent_Done,
     /* 235121 */   // Label 4731: @235121
     /* 235121 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(235163), // Rule ID 12372 //
     /* 235126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 235129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 235134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 235137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 235143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 235146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 235150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 235153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235161 */     GIR_RootConstrainSelectedInstOperands,
     /* 235162 */     // GIR_Coverage, 12372,
     /* 235162 */     GIR_EraseRootFromParent_Done,
     /* 235163 */   // Label 4732: @235163
     /* 235163 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(235205), // Rule ID 12375 //
     /* 235168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 235171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 235176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235192 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 235195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235203 */     GIR_RootConstrainSelectedInstOperands,
     /* 235204 */     // GIR_Coverage, 12375,
     /* 235204 */     GIR_EraseRootFromParent_Done,
     /* 235205 */   // Label 4733: @235205
     /* 235205 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(235348), // Rule ID 5518 //
     /* 235210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 235224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235231 */     // MIs[0] idx
     /* 235231 */     // No operand predicates
     /* 235231 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235231 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235234 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235238 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235245 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235248 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235252 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235257 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235260 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235264 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235267 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235272 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235277 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235344 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235346 */     GIR_RootConstrainSelectedInstOperands,
     /* 235347 */     // GIR_Coverage, 5518,
     /* 235347 */     GIR_EraseRootFromParent_Done,
     /* 235348 */   // Label 4734: @235348
     /* 235348 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(235439), // Rule ID 5519 //
     /* 235353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 235367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235374 */     // MIs[0] idx
     /* 235374 */     // No operand predicates
     /* 235374 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235400 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235403 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235407 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235435 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235437 */     GIR_RootConstrainSelectedInstOperands,
     /* 235438 */     // GIR_Coverage, 5519,
     /* 235438 */     GIR_EraseRootFromParent_Done,
     /* 235439 */   // Label 4735: @235439
     /* 235439 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(235530), // Rule ID 5520 //
     /* 235444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235465 */     // MIs[0] idx
     /* 235465 */     // No operand predicates
     /* 235465 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235526 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235528 */     GIR_RootConstrainSelectedInstOperands,
     /* 235529 */     // GIR_Coverage, 5520,
     /* 235529 */     GIR_EraseRootFromParent_Done,
     /* 235530 */   // Label 4736: @235530
     /* 235530 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(235569), // Rule ID 5521 //
     /* 235535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235556 */     // MIs[0] idx
     /* 235556 */     // No operand predicates
     /* 235556 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235565 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235567 */     GIR_RootConstrainSelectedInstOperands,
     /* 235568 */     // GIR_Coverage, 5521,
     /* 235568 */     GIR_EraseRootFromParent_Done,
     /* 235569 */   // Label 4737: @235569
     /* 235569 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(235712), // Rule ID 5522 //
     /* 235574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235595 */     // MIs[0] idx
     /* 235595 */     // No operand predicates
     /* 235595 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235595 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235598 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235602 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235621 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235624 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235628 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235631 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235636 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235641 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235708 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235710 */     GIR_RootConstrainSelectedInstOperands,
     /* 235711 */     // GIR_Coverage, 5522,
     /* 235711 */     GIR_EraseRootFromParent_Done,
     /* 235712 */   // Label 4738: @235712
     /* 235712 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(235803), // Rule ID 5523 //
     /* 235717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235738 */     // MIs[0] idx
     /* 235738 */     // No operand predicates
     /* 235738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235771 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235799 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235801 */     GIR_RootConstrainSelectedInstOperands,
     /* 235802 */     // GIR_Coverage, 5523,
     /* 235802 */     GIR_EraseRootFromParent_Done,
     /* 235803 */   // Label 4739: @235803
     /* 235803 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(235894), // Rule ID 5524 //
     /* 235808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235829 */     // MIs[0] idx
     /* 235829 */     // No operand predicates
     /* 235829 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235855 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235890 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235892 */     GIR_RootConstrainSelectedInstOperands,
     /* 235893 */     // GIR_Coverage, 5524,
     /* 235893 */     GIR_EraseRootFromParent_Done,
     /* 235894 */   // Label 4740: @235894
     /* 235894 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(235933), // Rule ID 5525 //
     /* 235899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235920 */     // MIs[0] idx
     /* 235920 */     // No operand predicates
     /* 235920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235929 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235931 */     GIR_RootConstrainSelectedInstOperands,
     /* 235932 */     // GIR_Coverage, 5525,
     /* 235932 */     GIR_EraseRootFromParent_Done,
     /* 235933 */   // Label 4741: @235933
     /* 235933 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(236076), // Rule ID 5526 //
     /* 235938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235959 */     // MIs[0] idx
     /* 235959 */     // No operand predicates
     /* 235959 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235959 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235962 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235966 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235973 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235976 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235980 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235985 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235988 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235992 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235995 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236000 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236005 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 236013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 236017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 236024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 236027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 236031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 236039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 236043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 236046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 236064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 236072 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236074 */     GIR_RootConstrainSelectedInstOperands,
     /* 236075 */     // GIR_Coverage, 5526,
     /* 236075 */     GIR_EraseRootFromParent_Done,
     /* 236076 */   // Label 4742: @236076
     /* 236076 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(236167), // Rule ID 5527 //
     /* 236081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 236084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 236089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 236098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236102 */     // MIs[0] idx
     /* 236102 */     // No operand predicates
     /* 236102 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 236102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 236105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 236109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 236116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 236119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 236123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236128 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 236131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 236135 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 236138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 236156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 236163 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236165 */     GIR_RootConstrainSelectedInstOperands,
     /* 236166 */     // GIR_Coverage, 5527,
     /* 236166 */     GIR_EraseRootFromParent_Done,
     /* 236167 */   // Label 4743: @236167
     /* 236167 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(236258), // Rule ID 5528 //
     /* 236172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 236175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 236180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 236189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236193 */     // MIs[0] idx
     /* 236193 */     // No operand predicates
     /* 236193 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 236193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 236196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 236200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 236207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 236210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 236214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 236222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 236226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 236229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 236247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 236251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236254 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236256 */     GIR_RootConstrainSelectedInstOperands,
     /* 236257 */     // GIR_Coverage, 5528,
     /* 236257 */     GIR_EraseRootFromParent_Done,
     /* 236258 */   // Label 4744: @236258
     /* 236258 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(236297), // Rule ID 5529 //
     /* 236263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 236266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 236271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 236280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236284 */     // MIs[0] idx
     /* 236284 */     // No operand predicates
     /* 236284 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 236284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 236287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 236291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 236293 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236295 */     GIR_RootConstrainSelectedInstOperands,
     /* 236296 */     // GIR_Coverage, 5529,
     /* 236296 */     GIR_EraseRootFromParent_Done,
     /* 236297 */   // Label 4745: @236297
     /* 236297 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(236336), // Rule ID 5530 //
     /* 236302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 236305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 236310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 236313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 236316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 236319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236323 */     // MIs[0] idx
     /* 236323 */     // No operand predicates
     /* 236323 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 236323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 236326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 236330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 236332 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236334 */     GIR_RootConstrainSelectedInstOperands,
     /* 236335 */     // GIR_Coverage, 5530,
     /* 236335 */     GIR_EraseRootFromParent_Done,
     /* 236336 */   // Label 4746: @236336
     /* 236336 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(236427), // Rule ID 5531 //
     /* 236341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 236344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 236349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 236352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 236355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 236358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236362 */     // MIs[0] idx
     /* 236362 */     // No operand predicates
     /* 236362 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 236362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 236365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 236369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 236376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 236379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 236383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 236391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 236395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 236398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 236416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 236418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 236420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236423 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 236425 */     GIR_RootConstrainSelectedInstOperands,
     /* 236426 */     // GIR_Coverage, 5531,
     /* 236426 */     GIR_EraseRootFromParent_Done,
     /* 236427 */   // Label 4747: @236427
     /* 236427 */   GIM_Reject,
     /* 236428 */ // Label 3871: @236428
     /* 236428 */ GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(243539),
     /* 236433 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 236436 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(236483), // Rule ID 2951 //
     /* 236441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1509:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 236471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236481 */     GIR_RootConstrainSelectedInstOperands,
     /* 236482 */     // GIR_Coverage, 2951,
     /* 236482 */     GIR_EraseRootFromParent_Done,
     /* 236483 */   // Label 4749: @236483
     /* 236483 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(236530), // Rule ID 2953 //
     /* 236488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 236518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236528 */     GIR_RootConstrainSelectedInstOperands,
     /* 236529 */     // GIR_Coverage, 2953,
     /* 236529 */     GIR_EraseRootFromParent_Done,
     /* 236530 */   // Label 4750: @236530
     /* 236530 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(236577), // Rule ID 2955 //
     /* 236535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 236565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236575 */     GIR_RootConstrainSelectedInstOperands,
     /* 236576 */     // GIR_Coverage, 2955,
     /* 236576 */     GIR_EraseRootFromParent_Done,
     /* 236577 */   // Label 4751: @236577
     /* 236577 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(236624), // Rule ID 2957 //
     /* 236582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236622 */     GIR_RootConstrainSelectedInstOperands,
     /* 236623 */     // GIR_Coverage, 2957,
     /* 236623 */     GIR_EraseRootFromParent_Done,
     /* 236624 */   // Label 4752: @236624
     /* 236624 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(236671), // Rule ID 7434 //
     /* 236629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1512:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 236659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236669 */     GIR_RootConstrainSelectedInstOperands,
     /* 236670 */     // GIR_Coverage, 7434,
     /* 236670 */     GIR_EraseRootFromParent_Done,
     /* 236671 */   // Label 4753: @236671
     /* 236671 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(236718), // Rule ID 7436 //
     /* 236676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1512:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 236706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236716 */     GIR_RootConstrainSelectedInstOperands,
     /* 236717 */     // GIR_Coverage, 7436,
     /* 236717 */     GIR_EraseRootFromParent_Done,
     /* 236718 */   // Label 4754: @236718
     /* 236718 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(236765), // Rule ID 7438 //
     /* 236723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1512:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 236753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236763 */     GIR_RootConstrainSelectedInstOperands,
     /* 236764 */     // GIR_Coverage, 7438,
     /* 236764 */     GIR_EraseRootFromParent_Done,
     /* 236765 */   // Label 4755: @236765
     /* 236765 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(236812), // Rule ID 7440 //
     /* 236770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236797 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1512:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 236800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236810 */     GIR_RootConstrainSelectedInstOperands,
     /* 236811 */     // GIR_Coverage, 7440,
     /* 236811 */     GIR_EraseRootFromParent_Done,
     /* 236812 */   // Label 4756: @236812
     /* 236812 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(236892), // Rule ID 5638 //
     /* 236817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 236825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 236828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 236834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236857 */     // MIs[1] Operand 1
     /* 236857 */     // No operand predicates
     /* 236857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236869 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236873 */     // MIs[2] Operand 1
     /* 236873 */     // No operand predicates
     /* 236873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236875 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 236875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 236878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236890 */     GIR_RootConstrainSelectedInstOperands,
     /* 236891 */     // GIR_Coverage, 5638,
     /* 236891 */     GIR_EraseRootFromParent_Done,
     /* 236892 */   // Label 4757: @236892
     /* 236892 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(236972), // Rule ID 5639 //
     /* 236897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236937 */     // MIs[1] Operand 1
     /* 236937 */     // No operand predicates
     /* 236937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236953 */     // MIs[2] Operand 1
     /* 236953 */     // No operand predicates
     /* 236953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236955 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 236955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 236958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236970 */     GIR_RootConstrainSelectedInstOperands,
     /* 236971 */     // GIR_Coverage, 5639,
     /* 236971 */     GIR_EraseRootFromParent_Done,
     /* 236972 */   // Label 4758: @236972
     /* 236972 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237052), // Rule ID 5640 //
     /* 236977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 237009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 237013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 237017 */     // MIs[1] Operand 1
     /* 237017 */     // No operand predicates
     /* 237017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 237025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 237029 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 237033 */     // MIs[2] Operand 1
     /* 237033 */     // No operand predicates
     /* 237033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 237035 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 237035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 237045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 237047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 237050 */     GIR_RootConstrainSelectedInstOperands,
     /* 237051 */     // GIR_Coverage, 5640,
     /* 237051 */     GIR_EraseRootFromParent_Done,
     /* 237052 */   // Label 4759: @237052
     /* 237052 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237132), // Rule ID 5641 //
     /* 237057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 237062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 237065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 237068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 237071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 237074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 237077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 237089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 237093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 237097 */     // MIs[1] Operand 1
     /* 237097 */     // No operand predicates
     /* 237097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 237105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 237109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 237113 */     // MIs[2] Operand 1
     /* 237113 */     // No operand predicates
     /* 237113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 237115 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 237115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 237118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 237125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 237127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 237130 */     GIR_RootConstrainSelectedInstOperands,
     /* 237131 */     // GIR_Coverage, 5641,
     /* 237131 */     GIR_EraseRootFromParent_Done,
     /* 237132 */   // Label 4760: @237132
     /* 237132 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237196), // Rule ID 3791 //
     /* 237137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 237140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 237145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 237148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 237151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 237154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 237157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237173 */     // MIs[0] imm
     /* 237173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 237181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 237181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 237184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 237186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 237190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 237192 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 237194 */     GIR_RootConstrainSelectedInstOperands,
     /* 237195 */     // GIR_Coverage, 3791,
     /* 237195 */     GIR_EraseRootFromParent_Done,
     /* 237196 */   // Label 4761: @237196
     /* 237196 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237260), // Rule ID 3792 //
     /* 237201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 237204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 237209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 237212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 237215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 237218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 237221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237237 */     // MIs[0] imm
     /* 237237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 237245 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 237245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 237254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 237256 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 237258 */     GIR_RootConstrainSelectedInstOperands,
     /* 237259 */     // GIR_Coverage, 3792,
     /* 237259 */     GIR_EraseRootFromParent_Done,
     /* 237260 */   // Label 4762: @237260
     /* 237260 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237324), // Rule ID 3793 //
     /* 237265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 237268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 237273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 237276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 237279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 237282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 237285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237301 */     // MIs[0] imm
     /* 237301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 237309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 237309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 237312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 237314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 237318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 237320 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 237322 */     GIR_RootConstrainSelectedInstOperands,
     /* 237323 */     // GIR_Coverage, 3793,
     /* 237323 */     GIR_EraseRootFromParent_Done,
     /* 237324 */   // Label 4763: @237324
     /* 237324 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(237388), // Rule ID 3794 //
     /* 237329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 237332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 237337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 237340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 237343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 237346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 237349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237365 */     // MIs[0] imm
     /* 237365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 237373 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 237373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 237376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 237378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 237380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 237382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 237384 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 237386 */     GIR_RootConstrainSelectedInstOperands,
     /* 237387 */     // GIR_Coverage, 3794,
     /* 237387 */     GIR_EraseRootFromParent_Done,
     /* 237388 */   // Label 4764: @237388
     /* 237388 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(237440), // Rule ID 2836 //
     /* 237393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237417 */     // MIs[0] idx
     /* 237417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237425 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 237425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 237428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237436 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237438 */     GIR_RootConstrainSelectedInstOperands,
     /* 237439 */     // GIR_Coverage, 2836,
     /* 237439 */     GIR_EraseRootFromParent_Done,
     /* 237440 */   // Label 4765: @237440
     /* 237440 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(237492), // Rule ID 2837 //
     /* 237445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237469 */     // MIs[0] idx
     /* 237469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237477 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 237480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237488 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237490 */     GIR_RootConstrainSelectedInstOperands,
     /* 237491 */     // GIR_Coverage, 2837,
     /* 237491 */     GIR_EraseRootFromParent_Done,
     /* 237492 */   // Label 4766: @237492
     /* 237492 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(237544), // Rule ID 2838 //
     /* 237497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237521 */     // MIs[0] idx
     /* 237521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 237529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 237532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237542 */     GIR_RootConstrainSelectedInstOperands,
     /* 237543 */     // GIR_Coverage, 2838,
     /* 237543 */     GIR_EraseRootFromParent_Done,
     /* 237544 */   // Label 4767: @237544
     /* 237544 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(237596), // Rule ID 2966 //
     /* 237549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237573 */     // MIs[0] Op4
     /* 237573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237592 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237594 */     GIR_RootConstrainSelectedInstOperands,
     /* 237595 */     // GIR_Coverage, 2966,
     /* 237595 */     GIR_EraseRootFromParent_Done,
     /* 237596 */   // Label 4768: @237596
     /* 237596 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(237648), // Rule ID 2967 //
     /* 237601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237625 */     // MIs[0] Op4
     /* 237625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 237636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237644 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237646 */     GIR_RootConstrainSelectedInstOperands,
     /* 237647 */     // GIR_Coverage, 2967,
     /* 237647 */     GIR_EraseRootFromParent_Done,
     /* 237648 */   // Label 4769: @237648
     /* 237648 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(237700), // Rule ID 2968 //
     /* 237653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237677 */     // MIs[0] Op4
     /* 237677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237685 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 237688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237696 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237698 */     GIR_RootConstrainSelectedInstOperands,
     /* 237699 */     // GIR_Coverage, 2968,
     /* 237699 */     GIR_EraseRootFromParent_Done,
     /* 237700 */   // Label 4770: @237700
     /* 237700 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(237752), // Rule ID 2969 //
     /* 237705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237729 */     // MIs[0] Op4
     /* 237729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1650:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 237740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237750 */     GIR_RootConstrainSelectedInstOperands,
     /* 237751 */     // GIR_Coverage, 2969,
     /* 237751 */     GIR_EraseRootFromParent_Done,
     /* 237752 */   // Label 4771: @237752
     /* 237752 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(237804), // Rule ID 2970 //
     /* 237757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237781 */     // MIs[0] Op4
     /* 237781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237800 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237802 */     GIR_RootConstrainSelectedInstOperands,
     /* 237803 */     // GIR_Coverage, 2970,
     /* 237803 */     GIR_EraseRootFromParent_Done,
     /* 237804 */   // Label 4772: @237804
     /* 237804 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(237856), // Rule ID 2973 //
     /* 237809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237833 */     // MIs[0] Op4
     /* 237833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 237844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237852 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237854 */     GIR_RootConstrainSelectedInstOperands,
     /* 237855 */     // GIR_Coverage, 2973,
     /* 237855 */     GIR_EraseRootFromParent_Done,
     /* 237856 */   // Label 4773: @237856
     /* 237856 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(237908), // Rule ID 2974 //
     /* 237861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237885 */     // MIs[0] Op4
     /* 237885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 237896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237904 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237906 */     GIR_RootConstrainSelectedInstOperands,
     /* 237907 */     // GIR_Coverage, 2974,
     /* 237907 */     GIR_EraseRootFromParent_Done,
     /* 237908 */   // Label 4774: @237908
     /* 237908 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(237960), // Rule ID 3442 //
     /* 237913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 237916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 237921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237937 */     // MIs[0] Op4
     /* 237937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 237948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237956 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237958 */     GIR_RootConstrainSelectedInstOperands,
     /* 237959 */     // GIR_Coverage, 3442,
     /* 237959 */     GIR_EraseRootFromParent_Done,
     /* 237960 */   // Label 4775: @237960
     /* 237960 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238012), // Rule ID 3486 //
     /* 237965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 237968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 237973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237989 */     // MIs[0] Op4
     /* 237989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238008 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238010 */     GIR_RootConstrainSelectedInstOperands,
     /* 238011 */     // GIR_Coverage, 3486,
     /* 238011 */     GIR_EraseRootFromParent_Done,
     /* 238012 */   // Label 4776: @238012
     /* 238012 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238064), // Rule ID 7504 //
     /* 238017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 238025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238041 */     // MIs[0] Op4
     /* 238041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238060 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238062 */     GIR_RootConstrainSelectedInstOperands,
     /* 238063 */     // GIR_Coverage, 7504,
     /* 238063 */     GIR_EraseRootFromParent_Done,
     /* 238064 */   // Label 4777: @238064
     /* 238064 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238116), // Rule ID 7505 //
     /* 238069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 238077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238093 */     // MIs[0] Op4
     /* 238093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238101 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 238104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238112 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238114 */     GIR_RootConstrainSelectedInstOperands,
     /* 238115 */     // GIR_Coverage, 7505,
     /* 238115 */     GIR_EraseRootFromParent_Done,
     /* 238116 */   // Label 4778: @238116
     /* 238116 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238168), // Rule ID 8145 //
     /* 238121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 238129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238145 */     // MIs[0] idx
     /* 238145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238153 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1375:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 238153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 238156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238164 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 238166 */     GIR_RootConstrainSelectedInstOperands,
     /* 238167 */     // GIR_Coverage, 8145,
     /* 238167 */     GIR_EraseRootFromParent_Done,
     /* 238168 */   // Label 4779: @238168
     /* 238168 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238220), // Rule ID 8146 //
     /* 238173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 238181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238197 */     // MIs[0] idx
     /* 238197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238205 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 238205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 238208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 238218 */     GIR_RootConstrainSelectedInstOperands,
     /* 238219 */     // GIR_Coverage, 8146,
     /* 238219 */     GIR_EraseRootFromParent_Done,
     /* 238220 */   // Label 4780: @238220
     /* 238220 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238272), // Rule ID 8147 //
     /* 238225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 238233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238249 */     // MIs[0] idx
     /* 238249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1375:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 238257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238268 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 238270 */     GIR_RootConstrainSelectedInstOperands,
     /* 238271 */     // GIR_Coverage, 8147,
     /* 238271 */     GIR_EraseRootFromParent_Done,
     /* 238272 */   // Label 4781: @238272
     /* 238272 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238324), // Rule ID 11091 //
     /* 238277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 238280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 238285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238301 */     // MIs[0] Op4
     /* 238301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 238312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238320 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238322 */     GIR_RootConstrainSelectedInstOperands,
     /* 238323 */     // GIR_Coverage, 11091,
     /* 238323 */     GIR_EraseRootFromParent_Done,
     /* 238324 */   // Label 4782: @238324
     /* 238324 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238376), // Rule ID 11138 //
     /* 238329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 238337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238353 */     // MIs[0] Op4
     /* 238353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1511:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 238364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238374 */     GIR_RootConstrainSelectedInstOperands,
     /* 238375 */     // GIR_Coverage, 11138,
     /* 238375 */     GIR_EraseRootFromParent_Done,
     /* 238376 */   // Label 4783: @238376
     /* 238376 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238428), // Rule ID 11139 //
     /* 238381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 238389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238405 */     // MIs[0] Op4
     /* 238405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238424 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238426 */     GIR_RootConstrainSelectedInstOperands,
     /* 238427 */     // GIR_Coverage, 11139,
     /* 238427 */     GIR_EraseRootFromParent_Done,
     /* 238428 */   // Label 4784: @238428
     /* 238428 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238480), // Rule ID 11140 //
     /* 238433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 238441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238457 */     // MIs[0] Op4
     /* 238457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238476 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238478 */     GIR_RootConstrainSelectedInstOperands,
     /* 238479 */     // GIR_Coverage, 11140,
     /* 238479 */     GIR_EraseRootFromParent_Done,
     /* 238480 */   // Label 4785: @238480
     /* 238480 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238532), // Rule ID 11141 //
     /* 238485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238509 */     // MIs[0] Op4
     /* 238509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 238520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238528 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238530 */     GIR_RootConstrainSelectedInstOperands,
     /* 238531 */     // GIR_Coverage, 11141,
     /* 238531 */     GIR_EraseRootFromParent_Done,
     /* 238532 */   // Label 4786: @238532
     /* 238532 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238584), // Rule ID 11142 //
     /* 238537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238561 */     // MIs[0] Op4
     /* 238561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 238572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238580 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238582 */     GIR_RootConstrainSelectedInstOperands,
     /* 238583 */     // GIR_Coverage, 11142,
     /* 238583 */     GIR_EraseRootFromParent_Done,
     /* 238584 */   // Label 4787: @238584
     /* 238584 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(238636), // Rule ID 11143 //
     /* 238589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238613 */     // MIs[0] Op4
     /* 238613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 238624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238632 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238634 */     GIR_RootConstrainSelectedInstOperands,
     /* 238635 */     // GIR_Coverage, 11143,
     /* 238635 */     GIR_EraseRootFromParent_Done,
     /* 238636 */   // Label 4788: @238636
     /* 238636 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(238688), // Rule ID 11144 //
     /* 238641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238665 */     // MIs[0] Op4
     /* 238665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 238676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238684 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238686 */     GIR_RootConstrainSelectedInstOperands,
     /* 238687 */     // GIR_Coverage, 11144,
     /* 238687 */     GIR_EraseRootFromParent_Done,
     /* 238688 */   // Label 4789: @238688
     /* 238688 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(238740), // Rule ID 11145 //
     /* 238693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238717 */     // MIs[0] Op4
     /* 238717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 238728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238736 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238738 */     GIR_RootConstrainSelectedInstOperands,
     /* 238739 */     // GIR_Coverage, 11145,
     /* 238739 */     GIR_EraseRootFromParent_Done,
     /* 238740 */   // Label 4790: @238740
     /* 238740 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(238792), // Rule ID 11146 //
     /* 238745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238769 */     // MIs[0] Op4
     /* 238769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 238780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238788 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238790 */     GIR_RootConstrainSelectedInstOperands,
     /* 238791 */     // GIR_Coverage, 11146,
     /* 238791 */     GIR_EraseRootFromParent_Done,
     /* 238792 */   // Label 4791: @238792
     /* 238792 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(238844), // Rule ID 11189 //
     /* 238797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238821 */     // MIs[0] Op4
     /* 238821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1652:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 238832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238840 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238842 */     GIR_RootConstrainSelectedInstOperands,
     /* 238843 */     // GIR_Coverage, 11189,
     /* 238843 */     GIR_EraseRootFromParent_Done,
     /* 238844 */   // Label 4792: @238844
     /* 238844 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(238896), // Rule ID 11190 //
     /* 238849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238873 */     // MIs[0] Op4
     /* 238873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1652:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 238884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238894 */     GIR_RootConstrainSelectedInstOperands,
     /* 238895 */     // GIR_Coverage, 11190,
     /* 238895 */     GIR_EraseRootFromParent_Done,
     /* 238896 */   // Label 4793: @238896
     /* 238896 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(238948), // Rule ID 11191 //
     /* 238901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238925 */     // MIs[0] Op4
     /* 238925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1888:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 238936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238944 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238946 */     GIR_RootConstrainSelectedInstOperands,
     /* 238947 */     // GIR_Coverage, 11191,
     /* 238947 */     GIR_EraseRootFromParent_Done,
     /* 238948 */   // Label 4794: @238948
     /* 238948 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239000), // Rule ID 11192 //
     /* 238953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238977 */     // MIs[0] Op4
     /* 238977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1888:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 238988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238998 */     GIR_RootConstrainSelectedInstOperands,
     /* 238999 */     // GIR_Coverage, 11192,
     /* 238999 */     GIR_EraseRootFromParent_Done,
     /* 239000 */   // Label 4795: @239000
     /* 239000 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239052), // Rule ID 11193 //
     /* 239005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 239013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239029 */     // MIs[0] Op4
     /* 239029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 239040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239048 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239050 */     GIR_RootConstrainSelectedInstOperands,
     /* 239051 */     // GIR_Coverage, 11193,
     /* 239051 */     GIR_EraseRootFromParent_Done,
     /* 239052 */   // Label 4796: @239052
     /* 239052 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239104), // Rule ID 11194 //
     /* 239057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 239065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239081 */     // MIs[0] Op4
     /* 239081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1890:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 239092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239100 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239102 */     GIR_RootConstrainSelectedInstOperands,
     /* 239103 */     // GIR_Coverage, 11194,
     /* 239103 */     GIR_EraseRootFromParent_Done,
     /* 239104 */   // Label 4797: @239104
     /* 239104 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239156), // Rule ID 11195 //
     /* 239109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 239117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239133 */     // MIs[0] Op4
     /* 239133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239152 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239154 */     GIR_RootConstrainSelectedInstOperands,
     /* 239155 */     // GIR_Coverage, 11195,
     /* 239155 */     GIR_EraseRootFromParent_Done,
     /* 239156 */   // Label 4798: @239156
     /* 239156 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239208), // Rule ID 11196 //
     /* 239161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 239169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239185 */     // MIs[0] Op4
     /* 239185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 239196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239204 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239206 */     GIR_RootConstrainSelectedInstOperands,
     /* 239207 */     // GIR_Coverage, 11196,
     /* 239207 */     GIR_EraseRootFromParent_Done,
     /* 239208 */   // Label 4799: @239208
     /* 239208 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239260), // Rule ID 11197 //
     /* 239213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 239221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239237 */     // MIs[0] Op4
     /* 239237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1656:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 239248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239256 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239258 */     GIR_RootConstrainSelectedInstOperands,
     /* 239259 */     // GIR_Coverage, 11197,
     /* 239259 */     GIR_EraseRootFromParent_Done,
     /* 239260 */   // Label 4800: @239260
     /* 239260 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239312), // Rule ID 11198 //
     /* 239265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 239273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239289 */     // MIs[0] Op4
     /* 239289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1656:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 239300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239310 */     GIR_RootConstrainSelectedInstOperands,
     /* 239311 */     // GIR_Coverage, 11198,
     /* 239311 */     GIR_EraseRootFromParent_Done,
     /* 239312 */   // Label 4801: @239312
     /* 239312 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239364), // Rule ID 11199 //
     /* 239317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 239325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239341 */     // MIs[0] Op4
     /* 239341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 239352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239362 */     GIR_RootConstrainSelectedInstOperands,
     /* 239363 */     // GIR_Coverage, 11199,
     /* 239363 */     GIR_EraseRootFromParent_Done,
     /* 239364 */   // Label 4802: @239364
     /* 239364 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239416), // Rule ID 11200 //
     /* 239369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 239377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239393 */     // MIs[0] Op4
     /* 239393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1892:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 239404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239414 */     GIR_RootConstrainSelectedInstOperands,
     /* 239415 */     // GIR_Coverage, 11200,
     /* 239415 */     GIR_EraseRootFromParent_Done,
     /* 239416 */   // Label 4803: @239416
     /* 239416 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239468), // Rule ID 11201 //
     /* 239421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 239429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239445 */     // MIs[0] Op4
     /* 239445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239453 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1894:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 239456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239464 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239466 */     GIR_RootConstrainSelectedInstOperands,
     /* 239467 */     // GIR_Coverage, 11201,
     /* 239467 */     GIR_EraseRootFromParent_Done,
     /* 239468 */   // Label 4804: @239468
     /* 239468 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239520), // Rule ID 11202 //
     /* 239473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 239481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239497 */     // MIs[0] Op4
     /* 239497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1894:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 239508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239518 */     GIR_RootConstrainSelectedInstOperands,
     /* 239519 */     // GIR_Coverage, 11202,
     /* 239519 */     GIR_EraseRootFromParent_Done,
     /* 239520 */   // Label 4805: @239520
     /* 239520 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239572), // Rule ID 11224 //
     /* 239525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239549 */     // MIs[0] Op4
     /* 239549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239570 */     GIR_RootConstrainSelectedInstOperands,
     /* 239571 */     // GIR_Coverage, 11224,
     /* 239571 */     GIR_EraseRootFromParent_Done,
     /* 239572 */   // Label 4806: @239572
     /* 239572 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239624), // Rule ID 11225 //
     /* 239577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239601 */     // MIs[0] Op4
     /* 239601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 239612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239622 */     GIR_RootConstrainSelectedInstOperands,
     /* 239623 */     // GIR_Coverage, 11225,
     /* 239623 */     GIR_EraseRootFromParent_Done,
     /* 239624 */   // Label 4807: @239624
     /* 239624 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(239676), // Rule ID 11226 //
     /* 239629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239653 */     // MIs[0] Op4
     /* 239653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 239664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239672 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239674 */     GIR_RootConstrainSelectedInstOperands,
     /* 239675 */     // GIR_Coverage, 11226,
     /* 239675 */     GIR_EraseRootFromParent_Done,
     /* 239676 */   // Label 4808: @239676
     /* 239676 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(239728), // Rule ID 11227 //
     /* 239681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239705 */     // MIs[0] Op4
     /* 239705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 239716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239726 */     GIR_RootConstrainSelectedInstOperands,
     /* 239727 */     // GIR_Coverage, 11227,
     /* 239727 */     GIR_EraseRootFromParent_Done,
     /* 239728 */   // Label 4809: @239728
     /* 239728 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(239780), // Rule ID 11228 //
     /* 239733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239757 */     // MIs[0] Op4
     /* 239757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239776 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239778 */     GIR_RootConstrainSelectedInstOperands,
     /* 239779 */     // GIR_Coverage, 11228,
     /* 239779 */     GIR_EraseRootFromParent_Done,
     /* 239780 */   // Label 4810: @239780
     /* 239780 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(239832), // Rule ID 11229 //
     /* 239785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239809 */     // MIs[0] Op4
     /* 239809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 239820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239828 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239830 */     GIR_RootConstrainSelectedInstOperands,
     /* 239831 */     // GIR_Coverage, 11229,
     /* 239831 */     GIR_EraseRootFromParent_Done,
     /* 239832 */   // Label 4811: @239832
     /* 239832 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(239884), // Rule ID 11230 //
     /* 239837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239861 */     // MIs[0] Op4
     /* 239861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 239872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239880 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239882 */     GIR_RootConstrainSelectedInstOperands,
     /* 239883 */     // GIR_Coverage, 11230,
     /* 239883 */     GIR_EraseRootFromParent_Done,
     /* 239884 */   // Label 4812: @239884
     /* 239884 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(239936), // Rule ID 11231 //
     /* 239889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239913 */     // MIs[0] Op4
     /* 239913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 239924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239932 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239934 */     GIR_RootConstrainSelectedInstOperands,
     /* 239935 */     // GIR_Coverage, 11231,
     /* 239935 */     GIR_EraseRootFromParent_Done,
     /* 239936 */   // Label 4813: @239936
     /* 239936 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(239988), // Rule ID 11685 //
     /* 239941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 239949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239965 */     // MIs[0] Op4
     /* 239965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239973 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 239976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239986 */     GIR_RootConstrainSelectedInstOperands,
     /* 239987 */     // GIR_Coverage, 11685,
     /* 239987 */     GIR_EraseRootFromParent_Done,
     /* 239988 */   // Label 4814: @239988
     /* 239988 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240040), // Rule ID 11686 //
     /* 239993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 240001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240017 */     // MIs[0] Op4
     /* 240017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 240028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240038 */     GIR_RootConstrainSelectedInstOperands,
     /* 240039 */     // GIR_Coverage, 11686,
     /* 240039 */     GIR_EraseRootFromParent_Done,
     /* 240040 */   // Label 4815: @240040
     /* 240040 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240092), // Rule ID 11687 //
     /* 240045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 240053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240069 */     // MIs[0] Op4
     /* 240069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 240080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240088 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240090 */     GIR_RootConstrainSelectedInstOperands,
     /* 240091 */     // GIR_Coverage, 11687,
     /* 240091 */     GIR_EraseRootFromParent_Done,
     /* 240092 */   // Label 4816: @240092
     /* 240092 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240144), // Rule ID 11688 //
     /* 240097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 240105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240121 */     // MIs[0] Op4
     /* 240121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 240129 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 240129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 240132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240140 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240142 */     GIR_RootConstrainSelectedInstOperands,
     /* 240143 */     // GIR_Coverage, 11688,
     /* 240143 */     GIR_EraseRootFromParent_Done,
     /* 240144 */   // Label 4817: @240144
     /* 240144 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240196), // Rule ID 11821 //
     /* 240149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 240157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240173 */     // MIs[0] Op4
     /* 240173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1326:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 240184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240194 */     GIR_RootConstrainSelectedInstOperands,
     /* 240195 */     // GIR_Coverage, 11821,
     /* 240195 */     GIR_EraseRootFromParent_Done,
     /* 240196 */   // Label 4818: @240196
     /* 240196 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240248), // Rule ID 11823 //
     /* 240201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 240209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240225 */     // MIs[0] Op4
     /* 240225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 240233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 240233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240246 */     GIR_RootConstrainSelectedInstOperands,
     /* 240247 */     // GIR_Coverage, 11823,
     /* 240247 */     GIR_EraseRootFromParent_Done,
     /* 240248 */   // Label 4819: @240248
     /* 240248 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240295), // Rule ID 2815 //
     /* 240253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 240280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 240283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240293 */     GIR_RootConstrainSelectedInstOperands,
     /* 240294 */     // GIR_Coverage, 2815,
     /* 240294 */     GIR_EraseRootFromParent_Done,
     /* 240295 */   // Label 4820: @240295
     /* 240295 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240342), // Rule ID 2818 //
     /* 240300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 240323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 240327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 240330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240340 */     GIR_RootConstrainSelectedInstOperands,
     /* 240341 */     // GIR_Coverage, 2818,
     /* 240341 */     GIR_EraseRootFromParent_Done,
     /* 240342 */   // Label 4821: @240342
     /* 240342 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240389), // Rule ID 2821 //
     /* 240347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 240370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 240374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 240377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240387 */     GIR_RootConstrainSelectedInstOperands,
     /* 240388 */     // GIR_Coverage, 2821,
     /* 240388 */     GIR_EraseRootFromParent_Done,
     /* 240389 */   // Label 4822: @240389
     /* 240389 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240436), // Rule ID 2824 //
     /* 240394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 240421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 240424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240434 */     GIR_RootConstrainSelectedInstOperands,
     /* 240435 */     // GIR_Coverage, 2824,
     /* 240435 */     GIR_EraseRootFromParent_Done,
     /* 240436 */   // Label 4823: @240436
     /* 240436 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240483), // Rule ID 2827 //
     /* 240441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 240464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 240468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 240471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240481 */     GIR_RootConstrainSelectedInstOperands,
     /* 240482 */     // GIR_Coverage, 2827,
     /* 240482 */     GIR_EraseRootFromParent_Done,
     /* 240483 */   // Label 4824: @240483
     /* 240483 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240530), // Rule ID 2830 //
     /* 240488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240515 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 240518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240528 */     GIR_RootConstrainSelectedInstOperands,
     /* 240529 */     // GIR_Coverage, 2830,
     /* 240529 */     GIR_EraseRootFromParent_Done,
     /* 240530 */   // Label 4825: @240530
     /* 240530 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240577), // Rule ID 2833 //
     /* 240535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 240562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 240565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240575 */     GIR_RootConstrainSelectedInstOperands,
     /* 240576 */     // GIR_Coverage, 2833,
     /* 240576 */     GIR_EraseRootFromParent_Done,
     /* 240577 */   // Label 4826: @240577
     /* 240577 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240624), // Rule ID 2834 //
     /* 240582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240609 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 240609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 240612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240622 */     GIR_RootConstrainSelectedInstOperands,
     /* 240623 */     // GIR_Coverage, 2834,
     /* 240623 */     GIR_EraseRootFromParent_Done,
     /* 240624 */   // Label 4827: @240624
     /* 240624 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240671), // Rule ID 2835 //
     /* 240629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240656 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1330:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 240659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240669 */     GIR_RootConstrainSelectedInstOperands,
     /* 240670 */     // GIR_Coverage, 2835,
     /* 240670 */     GIR_EraseRootFromParent_Done,
     /* 240671 */   // Label 4828: @240671
     /* 240671 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(240718), // Rule ID 2931 //
     /* 240676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240703 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1505:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 240706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240716 */     GIR_RootConstrainSelectedInstOperands,
     /* 240717 */     // GIR_Coverage, 2931,
     /* 240717 */     GIR_EraseRootFromParent_Done,
     /* 240718 */   // Label 4829: @240718
     /* 240718 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(240765), // Rule ID 2934 //
     /* 240723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1505:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 240753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240763 */     GIR_RootConstrainSelectedInstOperands,
     /* 240764 */     // GIR_Coverage, 2934,
     /* 240764 */     GIR_EraseRootFromParent_Done,
     /* 240765 */   // Label 4830: @240765
     /* 240765 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(240812), // Rule ID 2937 //
     /* 240770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240797 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1505:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 240800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240810 */     GIR_RootConstrainSelectedInstOperands,
     /* 240811 */     // GIR_Coverage, 2937,
     /* 240811 */     GIR_EraseRootFromParent_Done,
     /* 240812 */   // Label 4831: @240812
     /* 240812 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(240859), // Rule ID 2940 //
     /* 240817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1505:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 240847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240857 */     GIR_RootConstrainSelectedInstOperands,
     /* 240858 */     // GIR_Coverage, 2940,
     /* 240858 */     GIR_EraseRootFromParent_Done,
     /* 240859 */   // Label 4832: @240859
     /* 240859 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(240906), // Rule ID 2943 //
     /* 240864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1507:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 240894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240904 */     GIR_RootConstrainSelectedInstOperands,
     /* 240905 */     // GIR_Coverage, 2943,
     /* 240905 */     GIR_EraseRootFromParent_Done,
     /* 240906 */   // Label 4833: @240906
     /* 240906 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(240953), // Rule ID 2945 //
     /* 240911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1507:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 240941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240951 */     GIR_RootConstrainSelectedInstOperands,
     /* 240952 */     // GIR_Coverage, 2945,
     /* 240952 */     GIR_EraseRootFromParent_Done,
     /* 240953 */   // Label 4834: @240953
     /* 240953 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241000), // Rule ID 2947 //
     /* 240958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1507:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 240988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240998 */     GIR_RootConstrainSelectedInstOperands,
     /* 240999 */     // GIR_Coverage, 2947,
     /* 240999 */     GIR_EraseRootFromParent_Done,
     /* 241000 */   // Label 4835: @241000
     /* 241000 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241047), // Rule ID 2949 //
     /* 241005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 241013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1507:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 241032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 241035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241045 */     GIR_RootConstrainSelectedInstOperands,
     /* 241046 */     // GIR_Coverage, 2949,
     /* 241046 */     GIR_EraseRootFromParent_Done,
     /* 241047 */   // Label 4836: @241047
     /* 241047 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241094), // Rule ID 7414 //
     /* 241052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 241060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 241075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1513:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 241079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 241082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241090 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241092 */     GIR_RootConstrainSelectedInstOperands,
     /* 241093 */     // GIR_Coverage, 7414,
     /* 241093 */     GIR_EraseRootFromParent_Done,
     /* 241094 */   // Label 4837: @241094
     /* 241094 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241141), // Rule ID 7417 //
     /* 241099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 241107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241126 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1513:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 241126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 241129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241139 */     GIR_RootConstrainSelectedInstOperands,
     /* 241140 */     // GIR_Coverage, 7417,
     /* 241140 */     GIR_EraseRootFromParent_Done,
     /* 241141 */   // Label 4838: @241141
     /* 241141 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241188), // Rule ID 7420 //
     /* 241146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 241154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1513:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 241173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 241176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241184 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241186 */     GIR_RootConstrainSelectedInstOperands,
     /* 241187 */     // GIR_Coverage, 7420,
     /* 241187 */     GIR_EraseRootFromParent_Done,
     /* 241188 */   // Label 4839: @241188
     /* 241188 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241235), // Rule ID 7423 //
     /* 241193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 241201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1513:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 241220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 241223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241231 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241233 */     GIR_RootConstrainSelectedInstOperands,
     /* 241234 */     // GIR_Coverage, 7423,
     /* 241234 */     GIR_EraseRootFromParent_Done,
     /* 241235 */   // Label 4840: @241235
     /* 241235 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241282), // Rule ID 7426 //
     /* 241240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 241248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 241263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241267 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1510:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 241267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 241270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241280 */     GIR_RootConstrainSelectedInstOperands,
     /* 241281 */     // GIR_Coverage, 7426,
     /* 241281 */     GIR_EraseRootFromParent_Done,
     /* 241282 */   // Label 4841: @241282
     /* 241282 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241329), // Rule ID 7428 //
     /* 241287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 241295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1510:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 241314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 241317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241327 */     GIR_RootConstrainSelectedInstOperands,
     /* 241328 */     // GIR_Coverage, 7428,
     /* 241328 */     GIR_EraseRootFromParent_Done,
     /* 241329 */   // Label 4842: @241329
     /* 241329 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241376), // Rule ID 7430 //
     /* 241334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 241342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1510:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 241361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 241364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241374 */     GIR_RootConstrainSelectedInstOperands,
     /* 241375 */     // GIR_Coverage, 7430,
     /* 241375 */     GIR_EraseRootFromParent_Done,
     /* 241376 */   // Label 4843: @241376
     /* 241376 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241423), // Rule ID 7432 //
     /* 241381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 241389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1510:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 241408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 241411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241421 */     GIR_RootConstrainSelectedInstOperands,
     /* 241422 */     // GIR_Coverage, 7432,
     /* 241422 */     GIR_EraseRootFromParent_Done,
     /* 241423 */   // Label 4844: @241423
     /* 241423 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241470), // Rule ID 8058 //
     /* 241428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241455 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241468 */     GIR_RootConstrainSelectedInstOperands,
     /* 241469 */     // GIR_Coverage, 8058,
     /* 241469 */     GIR_EraseRootFromParent_Done,
     /* 241470 */   // Label 4845: @241470
     /* 241470 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241517), // Rule ID 8061 //
     /* 241475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241515 */     GIR_RootConstrainSelectedInstOperands,
     /* 241516 */     // GIR_Coverage, 8061,
     /* 241516 */     GIR_EraseRootFromParent_Done,
     /* 241517 */   // Label 4846: @241517
     /* 241517 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241564), // Rule ID 8064 //
     /* 241522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241549 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241560 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241562 */     GIR_RootConstrainSelectedInstOperands,
     /* 241563 */     // GIR_Coverage, 8064,
     /* 241563 */     GIR_EraseRootFromParent_Done,
     /* 241564 */   // Label 4847: @241564
     /* 241564 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241611), // Rule ID 8067 //
     /* 241569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241609 */     GIR_RootConstrainSelectedInstOperands,
     /* 241610 */     // GIR_Coverage, 8067,
     /* 241610 */     GIR_EraseRootFromParent_Done,
     /* 241611 */   // Label 4848: @241611
     /* 241611 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241658), // Rule ID 8070 //
     /* 241616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241643 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241654 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241656 */     GIR_RootConstrainSelectedInstOperands,
     /* 241657 */     // GIR_Coverage, 8070,
     /* 241657 */     GIR_EraseRootFromParent_Done,
     /* 241658 */   // Label 4849: @241658
     /* 241658 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(241705), // Rule ID 8073 //
     /* 241663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 241693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241703 */     GIR_RootConstrainSelectedInstOperands,
     /* 241704 */     // GIR_Coverage, 8073,
     /* 241704 */     GIR_EraseRootFromParent_Done,
     /* 241705 */   // Label 4850: @241705
     /* 241705 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(241752), // Rule ID 8076 //
     /* 241710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241737 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1390:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241750 */     GIR_RootConstrainSelectedInstOperands,
     /* 241751 */     // GIR_Coverage, 8076,
     /* 241751 */     GIR_EraseRootFromParent_Done,
     /* 241752 */   // Label 4851: @241752
     /* 241752 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(241799), // Rule ID 8077 //
     /* 241757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241795 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241797 */     GIR_RootConstrainSelectedInstOperands,
     /* 241798 */     // GIR_Coverage, 8077,
     /* 241798 */     GIR_EraseRootFromParent_Done,
     /* 241799 */   // Label 4852: @241799
     /* 241799 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(241846), // Rule ID 8078 //
     /* 241804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241831 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241842 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241844 */     GIR_RootConstrainSelectedInstOperands,
     /* 241845 */     // GIR_Coverage, 8078,
     /* 241845 */     GIR_EraseRootFromParent_Done,
     /* 241846 */   // Label 4853: @241846
     /* 241846 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(241893), // Rule ID 8079 //
     /* 241851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241889 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241891 */     GIR_RootConstrainSelectedInstOperands,
     /* 241892 */     // GIR_Coverage, 8079,
     /* 241892 */     GIR_EraseRootFromParent_Done,
     /* 241893 */   // Label 4854: @241893
     /* 241893 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(241940), // Rule ID 8080 //
     /* 241898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241925 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241936 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241938 */     GIR_RootConstrainSelectedInstOperands,
     /* 241939 */     // GIR_Coverage, 8080,
     /* 241939 */     GIR_EraseRootFromParent_Done,
     /* 241940 */   // Label 4855: @241940
     /* 241940 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(241987), // Rule ID 8081 //
     /* 241945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241972 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 241975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241985 */     GIR_RootConstrainSelectedInstOperands,
     /* 241986 */     // GIR_Coverage, 8081,
     /* 241986 */     GIR_EraseRootFromParent_Done,
     /* 241987 */   // Label 4856: @241987
     /* 241987 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242034), // Rule ID 8082 //
     /* 241992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242019 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1392:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 242022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242030 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242032 */     GIR_RootConstrainSelectedInstOperands,
     /* 242033 */     // GIR_Coverage, 8082,
     /* 242033 */     GIR_EraseRootFromParent_Done,
     /* 242034 */   // Label 4857: @242034
     /* 242034 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242081), // Rule ID 8083 //
     /* 242039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242066 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 242069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242079 */     GIR_RootConstrainSelectedInstOperands,
     /* 242080 */     // GIR_Coverage, 8083,
     /* 242080 */     GIR_EraseRootFromParent_Done,
     /* 242081 */   // Label 4858: @242081
     /* 242081 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242128), // Rule ID 8084 //
     /* 242086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242113 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 242116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242124 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242126 */     GIR_RootConstrainSelectedInstOperands,
     /* 242127 */     // GIR_Coverage, 8084,
     /* 242127 */     GIR_EraseRootFromParent_Done,
     /* 242128 */   // Label 4859: @242128
     /* 242128 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242175), // Rule ID 8085 //
     /* 242133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242160 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 242163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242173 */     GIR_RootConstrainSelectedInstOperands,
     /* 242174 */     // GIR_Coverage, 8085,
     /* 242174 */     GIR_EraseRootFromParent_Done,
     /* 242175 */   // Label 4860: @242175
     /* 242175 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242222), // Rule ID 8086 //
     /* 242180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 242210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242218 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242220 */     GIR_RootConstrainSelectedInstOperands,
     /* 242221 */     // GIR_Coverage, 8086,
     /* 242221 */     GIR_EraseRootFromParent_Done,
     /* 242222 */   // Label 4861: @242222
     /* 242222 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242269), // Rule ID 8087 //
     /* 242227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 242235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242254 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 242257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242265 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242267 */     GIR_RootConstrainSelectedInstOperands,
     /* 242268 */     // GIR_Coverage, 8087,
     /* 242268 */     GIR_EraseRootFromParent_Done,
     /* 242269 */   // Label 4862: @242269
     /* 242269 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242316), // Rule ID 8088 //
     /* 242274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 242282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242301 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 242304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242312 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242314 */     GIR_RootConstrainSelectedInstOperands,
     /* 242315 */     // GIR_Coverage, 8088,
     /* 242315 */     GIR_EraseRootFromParent_Done,
     /* 242316 */   // Label 4863: @242316
     /* 242316 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242363), // Rule ID 8089 //
     /* 242321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 242329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 242351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242361 */     GIR_RootConstrainSelectedInstOperands,
     /* 242362 */     // GIR_Coverage, 8089,
     /* 242362 */     GIR_EraseRootFromParent_Done,
     /* 242363 */   // Label 4864: @242363
     /* 242363 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242410), // Rule ID 8090 //
     /* 242368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 242376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242395 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 242398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242408 */     GIR_RootConstrainSelectedInstOperands,
     /* 242409 */     // GIR_Coverage, 8090,
     /* 242409 */     GIR_EraseRootFromParent_Done,
     /* 242410 */   // Label 4865: @242410
     /* 242410 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242457), // Rule ID 8091 //
     /* 242415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1389:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 242445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242455 */     GIR_RootConstrainSelectedInstOperands,
     /* 242456 */     // GIR_Coverage, 8091,
     /* 242456 */     GIR_EraseRootFromParent_Done,
     /* 242457 */   // Label 4866: @242457
     /* 242457 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242504), // Rule ID 8092 //
     /* 242462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242489 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 242492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242502 */     GIR_RootConstrainSelectedInstOperands,
     /* 242503 */     // GIR_Coverage, 8092,
     /* 242503 */     GIR_EraseRootFromParent_Done,
     /* 242504 */   // Label 4867: @242504
     /* 242504 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242551), // Rule ID 8093 //
     /* 242509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1389:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 242539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242549 */     GIR_RootConstrainSelectedInstOperands,
     /* 242550 */     // GIR_Coverage, 8093,
     /* 242550 */     GIR_EraseRootFromParent_Done,
     /* 242551 */   // Label 4868: @242551
     /* 242551 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242598), // Rule ID 8094 //
     /* 242556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 242586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242596 */     GIR_RootConstrainSelectedInstOperands,
     /* 242597 */     // GIR_Coverage, 8094,
     /* 242597 */     GIR_EraseRootFromParent_Done,
     /* 242598 */   // Label 4869: @242598
     /* 242598 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242645), // Rule ID 8095 //
     /* 242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 242633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242643 */     GIR_RootConstrainSelectedInstOperands,
     /* 242644 */     // GIR_Coverage, 8095,
     /* 242644 */     GIR_EraseRootFromParent_Done,
     /* 242645 */   // Label 4870: @242645
     /* 242645 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(242692), // Rule ID 8096 //
     /* 242650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242677 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1394:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 242680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242688 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242690 */     GIR_RootConstrainSelectedInstOperands,
     /* 242691 */     // GIR_Coverage, 8096,
     /* 242691 */     GIR_EraseRootFromParent_Done,
     /* 242692 */   // Label 4871: @242692
     /* 242692 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(242739), // Rule ID 8097 //
     /* 242697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242724 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242737 */     GIR_RootConstrainSelectedInstOperands,
     /* 242738 */     // GIR_Coverage, 8097,
     /* 242738 */     GIR_EraseRootFromParent_Done,
     /* 242739 */   // Label 4872: @242739
     /* 242739 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(242786), // Rule ID 8100 //
     /* 242744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242771 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242784 */     GIR_RootConstrainSelectedInstOperands,
     /* 242785 */     // GIR_Coverage, 8100,
     /* 242785 */     GIR_EraseRootFromParent_Done,
     /* 242786 */   // Label 4873: @242786
     /* 242786 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(242833), // Rule ID 8103 //
     /* 242791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242818 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242831 */     GIR_RootConstrainSelectedInstOperands,
     /* 242832 */     // GIR_Coverage, 8103,
     /* 242832 */     GIR_EraseRootFromParent_Done,
     /* 242833 */   // Label 4874: @242833
     /* 242833 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(242880), // Rule ID 8106 //
     /* 242838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242865 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242878 */     GIR_RootConstrainSelectedInstOperands,
     /* 242879 */     // GIR_Coverage, 8106,
     /* 242879 */     GIR_EraseRootFromParent_Done,
     /* 242880 */   // Label 4875: @242880
     /* 242880 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(242927), // Rule ID 8109 //
     /* 242885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242923 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242925 */     GIR_RootConstrainSelectedInstOperands,
     /* 242926 */     // GIR_Coverage, 8109,
     /* 242926 */     GIR_EraseRootFromParent_Done,
     /* 242927 */   // Label 4876: @242927
     /* 242927 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(242974), // Rule ID 8112 //
     /* 242932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242959 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 242962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242970 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242972 */     GIR_RootConstrainSelectedInstOperands,
     /* 242973 */     // GIR_Coverage, 8112,
     /* 242973 */     GIR_EraseRootFromParent_Done,
     /* 242974 */   // Label 4877: @242974
     /* 242974 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243021), // Rule ID 8115 //
     /* 242979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243006 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1391:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 243006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 243009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243017 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243019 */     GIR_RootConstrainSelectedInstOperands,
     /* 243020 */     // GIR_Coverage, 8115,
     /* 243020 */     GIR_EraseRootFromParent_Done,
     /* 243021 */   // Label 4878: @243021
     /* 243021 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243068), // Rule ID 8118 //
     /* 243026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 243034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 243049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243053 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 243053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 243056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243064 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243066 */     GIR_RootConstrainSelectedInstOperands,
     /* 243067 */     // GIR_Coverage, 8118,
     /* 243067 */     GIR_EraseRootFromParent_Done,
     /* 243068 */   // Label 4879: @243068
     /* 243068 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243115), // Rule ID 8121 //
     /* 243073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 243081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 243096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243100 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 243100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 243103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243113 */     GIR_RootConstrainSelectedInstOperands,
     /* 243114 */     // GIR_Coverage, 8121,
     /* 243114 */     GIR_EraseRootFromParent_Done,
     /* 243115 */   // Label 4880: @243115
     /* 243115 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243162), // Rule ID 8124 //
     /* 243120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 243128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 243147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 243150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243160 */     GIR_RootConstrainSelectedInstOperands,
     /* 243161 */     // GIR_Coverage, 8124,
     /* 243161 */     GIR_EraseRootFromParent_Done,
     /* 243162 */   // Label 4881: @243162
     /* 243162 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243209), // Rule ID 8127 //
     /* 243167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 243175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 243190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243194 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 243194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 243197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243207 */     GIR_RootConstrainSelectedInstOperands,
     /* 243208 */     // GIR_Coverage, 8127,
     /* 243208 */     GIR_EraseRootFromParent_Done,
     /* 243209 */   // Label 4882: @243209
     /* 243209 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243256), // Rule ID 8130 //
     /* 243214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 243222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243241 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 243241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 243244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243252 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243254 */     GIR_RootConstrainSelectedInstOperands,
     /* 243255 */     // GIR_Coverage, 8130,
     /* 243255 */     GIR_EraseRootFromParent_Done,
     /* 243256 */   // Label 4883: @243256
     /* 243256 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243303), // Rule ID 8133 //
     /* 243261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243288 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 243288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 243291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243301 */     GIR_RootConstrainSelectedInstOperands,
     /* 243302 */     // GIR_Coverage, 8133,
     /* 243302 */     GIR_EraseRootFromParent_Done,
     /* 243303 */   // Label 4884: @243303
     /* 243303 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243350), // Rule ID 8135 //
     /* 243308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 243319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 243325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 243328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 243331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243335 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 243335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 243338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243348 */     GIR_RootConstrainSelectedInstOperands,
     /* 243349 */     // GIR_Coverage, 8135,
     /* 243349 */     GIR_EraseRootFromParent_Done,
     /* 243350 */   // Label 4885: @243350
     /* 243350 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243397), // Rule ID 8137 //
     /* 243355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 243366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 243372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 243375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 243378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243382 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 243382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 243385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243395 */     GIR_RootConstrainSelectedInstOperands,
     /* 243396 */     // GIR_Coverage, 8137,
     /* 243396 */     GIR_EraseRootFromParent_Done,
     /* 243397 */   // Label 4886: @243397
     /* 243397 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243444), // Rule ID 8139 //
     /* 243402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243429 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 243429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 243432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243440 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243442 */     GIR_RootConstrainSelectedInstOperands,
     /* 243443 */     // GIR_Coverage, 8139,
     /* 243443 */     GIR_EraseRootFromParent_Done,
     /* 243444 */   // Label 4887: @243444
     /* 243444 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243491), // Rule ID 8141 //
     /* 243449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 243472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 243476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 243479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243489 */     GIR_RootConstrainSelectedInstOperands,
     /* 243490 */     // GIR_Coverage, 8141,
     /* 243490 */     GIR_EraseRootFromParent_Done,
     /* 243491 */   // Label 4888: @243491
     /* 243491 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243538), // Rule ID 8143 //
     /* 243496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243523 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 243523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 243526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243536 */     GIR_RootConstrainSelectedInstOperands,
     /* 243537 */     // GIR_Coverage, 8143,
     /* 243537 */     GIR_EraseRootFromParent_Done,
     /* 243538 */   // Label 4889: @243538
     /* 243538 */   GIM_Reject,
     /* 243539 */ // Label 4748: @243539
     /* 243539 */ GIM_Reject,
     /* 243540 */ // Label 33: @243540
     /* 243540 */ GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243618),
     /* 243545 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 243548 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(243570), // Rule ID 78 //
     /* 243553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 243561 */     // (intrinsic_void 2072:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 243561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 243564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243568 */     GIR_RootConstrainSelectedInstOperands,
     /* 243569 */     // GIR_Coverage, 78,
     /* 243569 */     GIR_EraseRootFromParent_Done,
     /* 243570 */   // Label 4891: @243570
     /* 243570 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(243595), // Rule ID 2377 //
     /* 243575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 243583 */     // (intrinsic_void 1622:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 243583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 243586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 243589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243593 */     GIR_RootConstrainSelectedInstOperands,
     /* 243594 */     // GIR_Coverage, 2377,
     /* 243594 */     GIR_EraseRootFromParent_Done,
     /* 243595 */   // Label 4892: @243595
     /* 243595 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(243617), // Rule ID 7038 //
     /* 243600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 243605 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 243605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 243608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 243611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243615 */     GIR_RootConstrainSelectedInstOperands,
     /* 243616 */     // GIR_Coverage, 7038,
     /* 243616 */     GIR_EraseRootFromParent_Done,
     /* 243617 */   // Label 4893: @243617
     /* 243617 */   GIM_Reject,
     /* 243618 */ // Label 4890: @243618
     /* 243618 */ GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244218),
     /* 243623 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 243626 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(243658), // Rule ID 79 //
     /* 243631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 243639 */     // MIs[0] imm
     /* 243639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 243647 */     // (intrinsic_void 2071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 243647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 243650 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243656 */     GIR_RootConstrainSelectedInstOperands,
     /* 243657 */     // GIR_Coverage, 79,
     /* 243657 */     GIR_EraseRootFromParent_Done,
     /* 243658 */   // Label 4895: @243658
     /* 243658 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(243683), // Rule ID 227 //
     /* 243663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 243668 */     // MIs[0] imm
     /* 243668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243676 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 243676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 243679 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243681 */     GIR_RootConstrainSelectedInstOperands,
     /* 243682 */     // GIR_Coverage, 227,
     /* 243682 */     GIR_EraseRootFromParent_Done,
     /* 243683 */   // Label 4896: @243683
     /* 243683 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(243708), // Rule ID 228 //
     /* 243688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 243693 */     // MIs[0] imm
     /* 243693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243701 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 243701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 243704 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243706 */     GIR_RootConstrainSelectedInstOperands,
     /* 243707 */     // GIR_Coverage, 228,
     /* 243707 */     GIR_EraseRootFromParent_Done,
     /* 243708 */   // Label 4897: @243708
     /* 243708 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(243740), // Rule ID 3592 //
     /* 243713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 243721 */     // MIs[0] imm
     /* 243721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 243729 */     // (intrinsic_void 1128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 243729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 243732 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243738 */     GIR_RootConstrainSelectedInstOperands,
     /* 243739 */     // GIR_Coverage, 3592,
     /* 243739 */     GIR_EraseRootFromParent_Done,
     /* 243740 */   // Label 4898: @243740
     /* 243740 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(243780), // Rule ID 16 //
     /* 243745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 243750 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 243765 */     // MIs[1] Operand 1
     /* 243765 */     // No operand predicates
     /* 243765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243767 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 243767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 243770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 243773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243778 */     GIR_RootConstrainSelectedInstOperands,
     /* 243779 */     // GIR_Coverage, 16,
     /* 243779 */     GIR_EraseRootFromParent_Done,
     /* 243780 */   // Label 4899: @243780
     /* 243780 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(243820), // Rule ID 17 //
     /* 243785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 243790 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243805 */     // MIs[1] Operand 1
     /* 243805 */     // No operand predicates
     /* 243805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243807 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 243807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 243810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243818 */     GIR_RootConstrainSelectedInstOperands,
     /* 243819 */     // GIR_Coverage, 17,
     /* 243819 */     GIR_EraseRootFromParent_Done,
     /* 243820 */   // Label 4900: @243820
     /* 243820 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(243860), // Rule ID 18 //
     /* 243825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 243830 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243845 */     // MIs[1] Operand 1
     /* 243845 */     // No operand predicates
     /* 243845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243847 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 243847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 243850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243858 */     GIR_RootConstrainSelectedInstOperands,
     /* 243859 */     // GIR_Coverage, 18,
     /* 243859 */     GIR_EraseRootFromParent_Done,
     /* 243860 */   // Label 4901: @243860
     /* 243860 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(243900), // Rule ID 19 //
     /* 243865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 243870 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243885 */     // MIs[1] Operand 1
     /* 243885 */     // No operand predicates
     /* 243885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243887 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 243887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 243890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243898 */     GIR_RootConstrainSelectedInstOperands,
     /* 243899 */     // GIR_Coverage, 19,
     /* 243899 */     GIR_EraseRootFromParent_Done,
     /* 243900 */   // Label 4902: @243900
     /* 243900 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(243924), // Rule ID 72 //
     /* 243905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 243910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243917 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 243917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 243920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243922 */     GIR_RootConstrainSelectedInstOperands,
     /* 243923 */     // GIR_Coverage, 72,
     /* 243923 */     GIR_EraseRootFromParent_Done,
     /* 243924 */   // Label 4903: @243924
     /* 243924 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(243948), // Rule ID 74 //
     /* 243929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 243934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243941 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 243941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 243944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243946 */     GIR_RootConstrainSelectedInstOperands,
     /* 243947 */     // GIR_Coverage, 74,
     /* 243947 */     GIR_EraseRootFromParent_Done,
     /* 243948 */   // Label 4904: @243948
     /* 243948 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(243979), // Rule ID 77 //
     /* 243953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 243961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243968 */     // (intrinsic_w_chain:{ *:[i64] } 2073:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 243968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 243971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243977 */     GIR_RootConstrainSelectedInstOperands,
     /* 243978 */     // GIR_Coverage, 77,
     /* 243978 */     GIR_EraseRootFromParent_Done,
     /* 243979 */   // Label 4905: @243979
     /* 243979 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244006), // Rule ID 80 //
     /* 243984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 243992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243999 */     // (intrinsic_w_chain:{ *:[i64] } 2074:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 243999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 244002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244004 */     GIR_RootConstrainSelectedInstOperands,
     /* 244005 */     // GIR_Coverage, 80,
     /* 244005 */     GIR_EraseRootFromParent_Done,
     /* 244006 */   // Label 4906: @244006
     /* 244006 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(244037), // Rule ID 2376 //
     /* 244011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 244014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 244019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244026 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1572:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 244026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 244029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244035 */     GIR_RootConstrainSelectedInstOperands,
     /* 244036 */     // GIR_Coverage, 2376,
     /* 244036 */     GIR_EraseRootFromParent_Done,
     /* 244037 */   // Label 4907: @244037
     /* 244037 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(244077), // Rule ID 12530 //
     /* 244042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 244045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 244050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244057 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 244057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 244060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244062 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 244072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244075 */     GIR_RootConstrainSelectedInstOperands,
     /* 244076 */     // GIR_Coverage, 12530,
     /* 244076 */     GIR_EraseRootFromParent_Done,
     /* 244077 */   // Label 4908: @244077
     /* 244077 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(244111), // Rule ID 2378 //
     /* 244082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 244085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 244090 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 244093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244097 */     // (intrinsic_void 2052:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 244097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 244100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 244102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 244105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244109 */     GIR_RootConstrainSelectedInstOperands,
     /* 244110 */     // GIR_Coverage, 2378,
     /* 244110 */     GIR_EraseRootFromParent_Done,
     /* 244111 */   // Label 4909: @244111
     /* 244111 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(244134), // Rule ID 73 //
     /* 244116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 244121 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 244124 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 244124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 244127 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 244129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 244132 */     GIR_RootConstrainSelectedInstOperands,
     /* 244133 */     // GIR_Coverage, 73,
     /* 244133 */     GIR_EraseRootFromParent_Done,
     /* 244134 */   // Label 4910: @244134
     /* 244134 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(244157), // Rule ID 75 //
     /* 244139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 244144 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 244147 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 244147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 244150 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 244152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 244155 */     GIR_RootConstrainSelectedInstOperands,
     /* 244156 */     // GIR_Coverage, 75,
     /* 244156 */     GIR_EraseRootFromParent_Done,
     /* 244157 */   // Label 4911: @244157
     /* 244157 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(244184), // Rule ID 76 //
     /* 244162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 244167 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 244170 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 244170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 244173 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 244175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 244178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244182 */     GIR_RootConstrainSelectedInstOperands,
     /* 244183 */     // GIR_Coverage, 76,
     /* 244183 */     GIR_EraseRootFromParent_Done,
     /* 244184 */   // Label 4912: @244184
     /* 244184 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(244217), // Rule ID 12529 //
     /* 244189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 244192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 244197 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 244200 */     // (intrinsic_void 940:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 244200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 244203 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 244213 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 244215 */     GIR_RootConstrainSelectedInstOperands,
     /* 244216 */     // GIR_Coverage, 12529,
     /* 244216 */     GIR_EraseRootFromParent_Done,
     /* 244217 */   // Label 4913: @244217
     /* 244217 */   GIM_Reject,
     /* 244218 */ // Label 4894: @244218
     /* 244218 */ GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245189),
     /* 244223 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 244226 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(244302), // Rule ID 7004 //
     /* 244231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244243 */     // MIs[0] addr
     /* 244243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 244255 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 244262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244301 */     // GIR_Coverage, 7004,
     /* 244301 */     GIR_EraseRootFromParent_Done,
     /* 244302 */   // Label 4915: @244302
     /* 244302 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(244378), // Rule ID 7005 //
     /* 244307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244319 */     // MIs[0] addr
     /* 244319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 244331 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 244338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244377 */     // GIR_Coverage, 7005,
     /* 244377 */     GIR_EraseRootFromParent_Done,
     /* 244378 */   // Label 4916: @244378
     /* 244378 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(244454), // Rule ID 7006 //
     /* 244383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244395 */     // MIs[0] addr
     /* 244395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 244407 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 244414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244453 */     // GIR_Coverage, 7006,
     /* 244453 */     GIR_EraseRootFromParent_Done,
     /* 244454 */   // Label 4917: @244454
     /* 244454 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(244496), // Rule ID 7007 //
     /* 244459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244471 */     // MIs[0] addr
     /* 244471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 244483 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 244486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244488 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244494 */     GIR_RootConstrainSelectedInstOperands,
     /* 244495 */     // GIR_Coverage, 7007,
     /* 244495 */     GIR_EraseRootFromParent_Done,
     /* 244496 */   // Label 4918: @244496
     /* 244496 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(244572), // Rule ID 7011 //
     /* 244501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244513 */     // MIs[0] addr
     /* 244513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 244525 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 244532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244541 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244571 */     // GIR_Coverage, 7011,
     /* 244571 */     GIR_EraseRootFromParent_Done,
     /* 244572 */   // Label 4919: @244572
     /* 244572 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(244648), // Rule ID 7012 //
     /* 244577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244589 */     // MIs[0] addr
     /* 244589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 244601 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 244608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244647 */     // GIR_Coverage, 7012,
     /* 244647 */     GIR_EraseRootFromParent_Done,
     /* 244648 */   // Label 4920: @244648
     /* 244648 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(244724), // Rule ID 7013 //
     /* 244653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244665 */     // MIs[0] addr
     /* 244665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 244677 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 244684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244693 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244723 */     // GIR_Coverage, 7013,
     /* 244723 */     GIR_EraseRootFromParent_Done,
     /* 244724 */   // Label 4921: @244724
     /* 244724 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(244766), // Rule ID 7014 //
     /* 244729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244741 */     // MIs[0] addr
     /* 244741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 244753 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244758 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244764 */     GIR_RootConstrainSelectedInstOperands,
     /* 244765 */     // GIR_Coverage, 7014,
     /* 244765 */     GIR_EraseRootFromParent_Done,
     /* 244766 */   // Label 4922: @244766
     /* 244766 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(244806), // Rule ID 20 //
     /* 244771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 244774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 244779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244793 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 244793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 244796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 244800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244804 */     GIR_RootConstrainSelectedInstOperands,
     /* 244805 */     // GIR_Coverage, 20,
     /* 244805 */     GIR_EraseRootFromParent_Done,
     /* 244806 */   // Label 4923: @244806
     /* 244806 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(244846), // Rule ID 2375 //
     /* 244811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 244814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 244819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244833 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1573:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 244833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 244836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 244840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244844 */     GIR_RootConstrainSelectedInstOperands,
     /* 244845 */     // GIR_Coverage, 2375,
     /* 244845 */     GIR_EraseRootFromParent_Done,
     /* 244846 */   // Label 4924: @244846
     /* 244846 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(244886), // Rule ID 2486 //
     /* 244851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244873 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 244876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244884 */     GIR_RootConstrainSelectedInstOperands,
     /* 244885 */     // GIR_Coverage, 2486,
     /* 244885 */     GIR_EraseRootFromParent_Done,
     /* 244886 */   // Label 4925: @244886
     /* 244886 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(244926), // Rule ID 2487 //
     /* 244891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244913 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 244916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244924 */     GIR_RootConstrainSelectedInstOperands,
     /* 244925 */     // GIR_Coverage, 2487,
     /* 244925 */     GIR_EraseRootFromParent_Done,
     /* 244926 */   // Label 4926: @244926
     /* 244926 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(244966), // Rule ID 6893 //
     /* 244931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244953 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 244956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244964 */     GIR_RootConstrainSelectedInstOperands,
     /* 244965 */     // GIR_Coverage, 6893,
     /* 244965 */     GIR_EraseRootFromParent_Done,
     /* 244966 */   // Label 4927: @244966
     /* 244966 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(245006), // Rule ID 6894 //
     /* 244971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244993 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 244996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 245000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245004 */     GIR_RootConstrainSelectedInstOperands,
     /* 245005 */     // GIR_Coverage, 6894,
     /* 245005 */     GIR_EraseRootFromParent_Done,
     /* 245006 */   // Label 4928: @245006
     /* 245006 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(245042), // Rule ID 3557 //
     /* 245011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 245014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 245019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245029 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 245029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 245032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245040 */     GIR_RootConstrainSelectedInstOperands,
     /* 245041 */     // GIR_Coverage, 3557,
     /* 245041 */     GIR_EraseRootFromParent_Done,
     /* 245042 */   // Label 4929: @245042
     /* 245042 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(245080), // Rule ID 3943 //
     /* 245047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 245050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 245055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 245058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245065 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 245065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 245068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 245070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 245076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 245078 */     GIR_RootConstrainSelectedInstOperands,
     /* 245079 */     // GIR_Coverage, 3943,
     /* 245079 */     GIR_EraseRootFromParent_Done,
     /* 245080 */   // Label 4930: @245080
     /* 245080 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(245116), // Rule ID 12332 //
     /* 245085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 245088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 245093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245103 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 245103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 245106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245114 */     GIR_RootConstrainSelectedInstOperands,
     /* 245115 */     // GIR_Coverage, 12332,
     /* 245115 */     GIR_EraseRootFromParent_Done,
     /* 245116 */   // Label 4931: @245116
     /* 245116 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(245152), // Rule ID 12333 //
     /* 245121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 245124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 245129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245139 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 245139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 245142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245150 */     GIR_RootConstrainSelectedInstOperands,
     /* 245151 */     // GIR_Coverage, 12333,
     /* 245151 */     GIR_EraseRootFromParent_Done,
     /* 245152 */   // Label 4932: @245152
     /* 245152 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(245188), // Rule ID 12334 //
     /* 245157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 245160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 245165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 245171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245175 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1404:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 245175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245186 */     GIR_RootConstrainSelectedInstOperands,
     /* 245187 */     // GIR_Coverage, 12334,
     /* 245187 */     GIR_EraseRootFromParent_Done,
     /* 245188 */   // Label 4933: @245188
     /* 245188 */   GIM_Reject,
     /* 245189 */ // Label 4914: @245189
     /* 245189 */ GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(248097),
     /* 245194 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 245197 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(245294), // Rule ID 7022 //
     /* 245202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245250 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 245261 */     // MIs[0] addr
     /* 245261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 245273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245275 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 245278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245284 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245292 */     GIR_RootConstrainSelectedInstOperands,
     /* 245293 */     // GIR_Coverage, 7022,
     /* 245293 */     GIR_EraseRootFromParent_Done,
     /* 245294 */   // Label 4935: @245294
     /* 245294 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(245391), // Rule ID 7023 //
     /* 245299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245347 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 245358 */     // MIs[0] addr
     /* 245358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 245370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245372 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245381 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245389 */     GIR_RootConstrainSelectedInstOperands,
     /* 245390 */     // GIR_Coverage, 7023,
     /* 245390 */     GIR_EraseRootFromParent_Done,
     /* 245391 */   // Label 4936: @245391
     /* 245391 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(245488), // Rule ID 7032 //
     /* 245396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245444 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 245455 */     // MIs[0] addr
     /* 245455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245469 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 245472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245478 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245486 */     GIR_RootConstrainSelectedInstOperands,
     /* 245487 */     // GIR_Coverage, 7032,
     /* 245487 */     GIR_EraseRootFromParent_Done,
     /* 245488 */   // Label 4937: @245488
     /* 245488 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(245585), // Rule ID 7033 //
     /* 245493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245541 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 245552 */     // MIs[0] addr
     /* 245552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 245564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245566 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 245569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245575 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245583 */     GIR_RootConstrainSelectedInstOperands,
     /* 245584 */     // GIR_Coverage, 7033,
     /* 245584 */     GIR_EraseRootFromParent_Done,
     /* 245585 */   // Label 4938: @245585
     /* 245585 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(245696), // Rule ID 7025 //
     /* 245590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245626 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245637 */     // MIs[0] addr
     /* 245637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 245649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245651 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 245682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245694 */     GIR_RootConstrainSelectedInstOperands,
     /* 245695 */     // GIR_Coverage, 7025,
     /* 245695 */     GIR_EraseRootFromParent_Done,
     /* 245696 */   // Label 4939: @245696
     /* 245696 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(245807), // Rule ID 7026 //
     /* 245701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245737 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 245748 */     // MIs[0] addr
     /* 245748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 245760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245762 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245774 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 245793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245798 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245805 */     GIR_RootConstrainSelectedInstOperands,
     /* 245806 */     // GIR_Coverage, 7026,
     /* 245806 */     GIR_EraseRootFromParent_Done,
     /* 245807 */   // Label 4940: @245807
     /* 245807 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(245918), // Rule ID 7027 //
     /* 245812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245848 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 245859 */     // MIs[0] addr
     /* 245859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 245871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245873 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 245904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245909 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245916 */     GIR_RootConstrainSelectedInstOperands,
     /* 245917 */     // GIR_Coverage, 7027,
     /* 245917 */     GIR_EraseRootFromParent_Done,
     /* 245918 */   // Label 4941: @245918
     /* 245918 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246029), // Rule ID 7035 //
     /* 245923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245959 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245970 */     // MIs[0] addr
     /* 245970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245984 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 246015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246020 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246027 */     GIR_RootConstrainSelectedInstOperands,
     /* 246028 */     // GIR_Coverage, 7035,
     /* 246028 */     GIR_EraseRootFromParent_Done,
     /* 246029 */   // Label 4942: @246029
     /* 246029 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(246140), // Rule ID 7036 //
     /* 246034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 246057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 246061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 246065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246070 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 246081 */     // MIs[0] addr
     /* 246081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 246093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246095 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246107 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 246126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246131 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246138 */     GIR_RootConstrainSelectedInstOperands,
     /* 246139 */     // GIR_Coverage, 7036,
     /* 246139 */     GIR_EraseRootFromParent_Done,
     /* 246140 */   // Label 4943: @246140
     /* 246140 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(246251), // Rule ID 7037 //
     /* 246145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 246168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 246172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 246176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246181 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 246192 */     // MIs[0] addr
     /* 246192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246206 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246242 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246249 */     GIR_RootConstrainSelectedInstOperands,
     /* 246250 */     // GIR_Coverage, 7037,
     /* 246250 */     GIR_EraseRootFromParent_Done,
     /* 246251 */   // Label 4944: @246251
     /* 246251 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(246302), // Rule ID 70 //
     /* 246256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 246261 */     // MIs[0] ptr
     /* 246261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246269 */     // MIs[0] accessinfo
     /* 246269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 246272 */     // MIs[0] fixed_shadow
     /* 246272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246275 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 246275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 246278 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 246280 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 246282 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 246284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246300 */     GIR_RootConstrainSelectedInstOperands,
     /* 246301 */     // GIR_Coverage, 70,
     /* 246301 */     GIR_EraseRootFromParent_Done,
     /* 246302 */   // Label 4945: @246302
     /* 246302 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(246353), // Rule ID 71 //
     /* 246307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 246312 */     // MIs[0] ptr
     /* 246312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246320 */     // MIs[0] accessinfo
     /* 246320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 246323 */     // MIs[0] fixed_shadow
     /* 246323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246326 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 246326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 246329 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 246331 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 246333 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 246335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246351 */     GIR_RootConstrainSelectedInstOperands,
     /* 246352 */     // GIR_Coverage, 71,
     /* 246352 */     GIR_EraseRootFromParent_Done,
     /* 246353 */   // Label 4946: @246353
     /* 246353 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(246422), // Rule ID 7024 //
     /* 246358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 246381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 246385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246390 */     // MIs[0] addr
     /* 246390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 246402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246404 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 246407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 246413 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246420 */     GIR_RootConstrainSelectedInstOperands,
     /* 246421 */     // GIR_Coverage, 7024,
     /* 246421 */     GIR_EraseRootFromParent_Done,
     /* 246422 */   // Label 4947: @246422
     /* 246422 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(246491), // Rule ID 7034 //
     /* 246427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 246450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 246454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246459 */     // MIs[0] addr
     /* 246459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246473 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 246482 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246489 */     GIR_RootConstrainSelectedInstOperands,
     /* 246490 */     // GIR_Coverage, 7034,
     /* 246490 */     GIR_EraseRootFromParent_Done,
     /* 246491 */   // Label 4948: @246491
     /* 246491 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(246545), // Rule ID 8697 //
     /* 246496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246504 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 246507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246511 */     // MIs[0] base
     /* 246511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246519 */     // MIs[0] prfop
     /* 246519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246527 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 246530 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246532 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246534 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246543 */     GIR_RootConstrainSelectedInstOperands,
     /* 246544 */     // GIR_Coverage, 8697,
     /* 246544 */     GIR_EraseRootFromParent_Done,
     /* 246545 */   // Label 4949: @246545
     /* 246545 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(246599), // Rule ID 8700 //
     /* 246550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246558 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 246561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246565 */     // MIs[0] base
     /* 246565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246573 */     // MIs[0] prfop
     /* 246573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246581 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 246584 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246586 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246588 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246597 */     GIR_RootConstrainSelectedInstOperands,
     /* 246598 */     // GIR_Coverage, 8700,
     /* 246598 */     GIR_EraseRootFromParent_Done,
     /* 246599 */   // Label 4950: @246599
     /* 246599 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(246653), // Rule ID 8703 //
     /* 246604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246612 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 246615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246619 */     // MIs[0] base
     /* 246619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246627 */     // MIs[0] prfop
     /* 246627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246635 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 246638 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246640 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246642 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246651 */     GIR_RootConstrainSelectedInstOperands,
     /* 246652 */     // GIR_Coverage, 8703,
     /* 246652 */     GIR_EraseRootFromParent_Done,
     /* 246653 */   // Label 4951: @246653
     /* 246653 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(246707), // Rule ID 8706 //
     /* 246658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246666 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 246669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246673 */     // MIs[0] base
     /* 246673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246681 */     // MIs[0] prfop
     /* 246681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246689 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 246692 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246694 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246696 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246705 */     GIR_RootConstrainSelectedInstOperands,
     /* 246706 */     // GIR_Coverage, 8706,
     /* 246706 */     GIR_EraseRootFromParent_Done,
     /* 246707 */   // Label 4952: @246707
     /* 246707 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(246761), // Rule ID 15 //
     /* 246712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 246717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 246738 */     // MIs[1] Operand 1
     /* 246738 */     // No operand predicates
     /* 246738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246744 */     // (intrinsic_w_chain:{ *:[i64] } 1138:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 246744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 246747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 246749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 246752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 246754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246759 */     GIR_RootConstrainSelectedInstOperands,
     /* 246760 */     // GIR_Coverage, 15,
     /* 246760 */     GIR_EraseRootFromParent_Done,
     /* 246761 */   // Label 4953: @246761
     /* 246761 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(246829), // Rule ID 68 //
     /* 246766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 246771 */     // MIs[0] Operand 1
     /* 246771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 246779 */     // MIs[0] ptr
     /* 246779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246787 */     // MIs[0] accessinfo
     /* 246787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246790 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246794 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 246804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 246807 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246809 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246827 */     GIR_RootConstrainSelectedInstOperands,
     /* 246828 */     // GIR_Coverage, 68,
     /* 246828 */     GIR_EraseRootFromParent_Done,
     /* 246829 */   // Label 4954: @246829
     /* 246829 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(246897), // Rule ID 69 //
     /* 246834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 246839 */     // MIs[0] Operand 1
     /* 246839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 246847 */     // MIs[0] ptr
     /* 246847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246855 */     // MIs[0] accessinfo
     /* 246855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246858 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246862 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 246872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 246875 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246877 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246895 */     GIR_RootConstrainSelectedInstOperands,
     /* 246896 */     // GIR_Coverage, 69,
     /* 246896 */     GIR_EraseRootFromParent_Done,
     /* 246897 */   // Label 4955: @246897
     /* 246897 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(246977), // Rule ID 7018 //
     /* 246902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246921 */     // MIs[0] addr
     /* 246921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 246933 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 246964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246969 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246975 */     GIR_RootConstrainSelectedInstOperands,
     /* 246976 */     // GIR_Coverage, 7018,
     /* 246976 */     GIR_EraseRootFromParent_Done,
     /* 246977 */   // Label 4956: @246977
     /* 246977 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247057), // Rule ID 7019 //
     /* 246982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247001 */     // MIs[0] addr
     /* 247001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 247013 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 247044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247049 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247055 */     GIR_RootConstrainSelectedInstOperands,
     /* 247056 */     // GIR_Coverage, 7019,
     /* 247056 */     GIR_EraseRootFromParent_Done,
     /* 247057 */   // Label 4957: @247057
     /* 247057 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247137), // Rule ID 7020 //
     /* 247062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247081 */     // MIs[0] addr
     /* 247081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 247093 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247105 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 247124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247129 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247135 */     GIR_RootConstrainSelectedInstOperands,
     /* 247136 */     // GIR_Coverage, 7020,
     /* 247136 */     GIR_EraseRootFromParent_Done,
     /* 247137 */   // Label 4958: @247137
     /* 247137 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247188), // Rule ID 7021 //
     /* 247142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 247147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247161 */     // MIs[0] addr
     /* 247161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 247173 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 247176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247178 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 247180 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247186 */     GIR_RootConstrainSelectedInstOperands,
     /* 247187 */     // GIR_Coverage, 7021,
     /* 247187 */     GIR_EraseRootFromParent_Done,
     /* 247188 */   // Label 4959: @247188
     /* 247188 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247268), // Rule ID 7028 //
     /* 247193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247212 */     // MIs[0] addr
     /* 247212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 247224 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247236 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 247255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247260 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247266 */     GIR_RootConstrainSelectedInstOperands,
     /* 247267 */     // GIR_Coverage, 7028,
     /* 247267 */     GIR_EraseRootFromParent_Done,
     /* 247268 */   // Label 4960: @247268
     /* 247268 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247348), // Rule ID 7029 //
     /* 247273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247292 */     // MIs[0] addr
     /* 247292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 247304 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247316 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 247335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247340 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247346 */     GIR_RootConstrainSelectedInstOperands,
     /* 247347 */     // GIR_Coverage, 7029,
     /* 247347 */     GIR_EraseRootFromParent_Done,
     /* 247348 */   // Label 4961: @247348
     /* 247348 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247428), // Rule ID 7030 //
     /* 247353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247372 */     // MIs[0] addr
     /* 247372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 247384 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 247384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 247387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247396 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 247402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 247415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247420 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247426 */     GIR_RootConstrainSelectedInstOperands,
     /* 247427 */     // GIR_Coverage, 7030,
     /* 247427 */     GIR_EraseRootFromParent_Done,
     /* 247428 */   // Label 4962: @247428
     /* 247428 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(247479), // Rule ID 7031 //
     /* 247433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247452 */     // MIs[0] addr
     /* 247452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 247464 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 247467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247469 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 247471 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247477 */     GIR_RootConstrainSelectedInstOperands,
     /* 247478 */     // GIR_Coverage, 7031,
     /* 247478 */     GIR_EraseRootFromParent_Done,
     /* 247479 */   // Label 4963: @247479
     /* 247479 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(247528), // Rule ID 2479 //
     /* 247484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 247498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 247501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247513 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 247513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 247516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247526 */     GIR_RootConstrainSelectedInstOperands,
     /* 247527 */     // GIR_Coverage, 2479,
     /* 247527 */     GIR_EraseRootFromParent_Done,
     /* 247528 */   // Label 4964: @247528
     /* 247528 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(247577), // Rule ID 2480 //
     /* 247533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 247544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 247547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 247550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247562 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 247562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 247565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247575 */     GIR_RootConstrainSelectedInstOperands,
     /* 247576 */     // GIR_Coverage, 2480,
     /* 247576 */     GIR_EraseRootFromParent_Done,
     /* 247577 */   // Label 4965: @247577
     /* 247577 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(247626), // Rule ID 2481 //
     /* 247582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 247596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 247599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247611 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 247611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 247614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247624 */     GIR_RootConstrainSelectedInstOperands,
     /* 247625 */     // GIR_Coverage, 2481,
     /* 247625 */     GIR_EraseRootFromParent_Done,
     /* 247626 */   // Label 4966: @247626
     /* 247626 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(247679), // Rule ID 8583 //
     /* 247631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247653 */     // MIs[0] base
     /* 247653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247661 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247668 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247677 */     GIR_RootConstrainSelectedInstOperands,
     /* 247678 */     // GIR_Coverage, 8583,
     /* 247678 */     GIR_EraseRootFromParent_Done,
     /* 247679 */   // Label 4967: @247679
     /* 247679 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(247732), // Rule ID 8586 //
     /* 247684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247706 */     // MIs[0] base
     /* 247706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247714 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247730 */     GIR_RootConstrainSelectedInstOperands,
     /* 247731 */     // GIR_Coverage, 8586,
     /* 247731 */     GIR_EraseRootFromParent_Done,
     /* 247732 */   // Label 4968: @247732
     /* 247732 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(247785), // Rule ID 8595 //
     /* 247737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247759 */     // MIs[0] base
     /* 247759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247767 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247774 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247783 */     GIR_RootConstrainSelectedInstOperands,
     /* 247784 */     // GIR_Coverage, 8595,
     /* 247784 */     GIR_EraseRootFromParent_Done,
     /* 247785 */   // Label 4969: @247785
     /* 247785 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(247838), // Rule ID 8598 //
     /* 247790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247812 */     // MIs[0] base
     /* 247812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247820 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247836 */     GIR_RootConstrainSelectedInstOperands,
     /* 247837 */     // GIR_Coverage, 8598,
     /* 247837 */     GIR_EraseRootFromParent_Done,
     /* 247838 */   // Label 4970: @247838
     /* 247838 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(247884), // Rule ID 137 //
     /* 247843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 247846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 247851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247861 */     // MIs[0] Rn
     /* 247861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 247865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247873 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 247873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 247876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247882 */     GIR_RootConstrainSelectedInstOperands,
     /* 247883 */     // GIR_Coverage, 137,
     /* 247883 */     GIR_EraseRootFromParent_Done,
     /* 247884 */   // Label 4971: @247884
     /* 247884 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(247937), // Rule ID 8589 //
     /* 247889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247897 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247911 */     // MIs[0] base
     /* 247911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247919 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247926 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247935 */     GIR_RootConstrainSelectedInstOperands,
     /* 247936 */     // GIR_Coverage, 8589,
     /* 247936 */     GIR_EraseRootFromParent_Done,
     /* 247937 */   // Label 4972: @247937
     /* 247937 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(247990), // Rule ID 8592 //
     /* 247942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247950 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247964 */     // MIs[0] base
     /* 247964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247972 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247979 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247988 */     GIR_RootConstrainSelectedInstOperands,
     /* 247989 */     // GIR_Coverage, 8592,
     /* 247989 */     GIR_EraseRootFromParent_Done,
     /* 247990 */   // Label 4973: @247990
     /* 247990 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248043), // Rule ID 8601 //
     /* 247995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 248003 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 248006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 248009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248017 */     // MIs[0] base
     /* 248017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248025 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 248028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 248030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 248032 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 248034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248041 */     GIR_RootConstrainSelectedInstOperands,
     /* 248042 */     // GIR_Coverage, 8601,
     /* 248042 */     GIR_EraseRootFromParent_Done,
     /* 248043 */   // Label 4974: @248043
     /* 248043 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248096), // Rule ID 8604 //
     /* 248048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 248056 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 248059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 248062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248070 */     // MIs[0] base
     /* 248070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 248074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248078 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 248078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 248081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 248083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 248087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248094 */     GIR_RootConstrainSelectedInstOperands,
     /* 248095 */     // GIR_Coverage, 8604,
     /* 248095 */     GIR_EraseRootFromParent_Done,
     /* 248096 */   // Label 4975: @248096
     /* 248096 */   GIM_Reject,
     /* 248097 */ // Label 4934: @248097
     /* 248097 */ GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(250802),
     /* 248102 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 248105 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248176), // Rule ID 3393 //
     /* 248110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 248118 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 248127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 248139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 248147 */     // MIs[1] Operand 1
     /* 248147 */     // No operand predicates
     /* 248147 */     // MIs[0] prfop
     /* 248147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248157 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 248157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 248160 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 248166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 248169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248174 */     GIR_RootConstrainSelectedInstOperands,
     /* 248175 */     // GIR_Coverage, 3393,
     /* 248175 */     GIR_EraseRootFromParent_Done,
     /* 248176 */   // Label 4977: @248176
     /* 248176 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248247), // Rule ID 3406 //
     /* 248181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 248189 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 248198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 248210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 248218 */     // MIs[1] Operand 1
     /* 248218 */     // No operand predicates
     /* 248218 */     // MIs[0] prfop
     /* 248218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248228 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 248228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 248231 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 248237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 248240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248245 */     GIR_RootConstrainSelectedInstOperands,
     /* 248246 */     // GIR_Coverage, 3406,
     /* 248246 */     GIR_EraseRootFromParent_Done,
     /* 248247 */   // Label 4978: @248247
     /* 248247 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248306), // Rule ID 3581 //
     /* 248252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 248255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 248260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248269 */     // MIs[0] tile
     /* 248269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 248277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248289 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 248289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 248292 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248294 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248296 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248298 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248304 */     GIR_RootConstrainSelectedInstOperands,
     /* 248305 */     // GIR_Coverage, 3581,
     /* 248305 */     GIR_EraseRootFromParent_Done,
     /* 248306 */   // Label 4979: @248306
     /* 248306 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248365), // Rule ID 3582 //
     /* 248311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 248314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 248319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248328 */     // MIs[0] tile
     /* 248328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 248336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248348 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 248348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 248351 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248353 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248355 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248357 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248363 */     GIR_RootConstrainSelectedInstOperands,
     /* 248364 */     // GIR_Coverage, 3582,
     /* 248364 */     GIR_EraseRootFromParent_Done,
     /* 248365 */   // Label 4980: @248365
     /* 248365 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248424), // Rule ID 12392 //
     /* 248370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 248373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 248378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248387 */     // MIs[0] tile
     /* 248387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 248395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248407 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 248407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 248410 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248412 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248414 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248416 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248422 */     GIR_RootConstrainSelectedInstOperands,
     /* 248423 */     // GIR_Coverage, 12392,
     /* 248423 */     GIR_EraseRootFromParent_Done,
     /* 248424 */   // Label 4981: @248424
     /* 248424 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248483), // Rule ID 12393 //
     /* 248429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 248432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 248437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248446 */     // MIs[0] tile
     /* 248446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 248454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248466 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 248466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 248469 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248471 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248473 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248475 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248481 */     GIR_RootConstrainSelectedInstOperands,
     /* 248482 */     // GIR_Coverage, 12393,
     /* 248482 */     GIR_EraseRootFromParent_Done,
     /* 248483 */   // Label 4982: @248483
     /* 248483 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(248543), // Rule ID 3391 //
     /* 248488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248496 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248506 */     // MIs[0] Rn
     /* 248506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248518 */     // MIs[0] prfop
     /* 248518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248526 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 248529 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248541 */     GIR_RootConstrainSelectedInstOperands,
     /* 248542 */     // GIR_Coverage, 3391,
     /* 248542 */     GIR_EraseRootFromParent_Done,
     /* 248543 */   // Label 4983: @248543
     /* 248543 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(248603), // Rule ID 3392 //
     /* 248548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248556 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248566 */     // MIs[0] Rn
     /* 248566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248578 */     // MIs[0] prfop
     /* 248578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248586 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 248589 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248601 */     GIR_RootConstrainSelectedInstOperands,
     /* 248602 */     // GIR_Coverage, 3392,
     /* 248602 */     GIR_EraseRootFromParent_Done,
     /* 248603 */   // Label 4984: @248603
     /* 248603 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(248663), // Rule ID 3403 //
     /* 248608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248616 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248626 */     // MIs[0] Rn
     /* 248626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248638 */     // MIs[0] prfop
     /* 248638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248646 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 248649 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248661 */     GIR_RootConstrainSelectedInstOperands,
     /* 248662 */     // GIR_Coverage, 3403,
     /* 248662 */     GIR_EraseRootFromParent_Done,
     /* 248663 */   // Label 4985: @248663
     /* 248663 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(248723), // Rule ID 3404 //
     /* 248668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248676 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248686 */     // MIs[0] Rn
     /* 248686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248698 */     // MIs[0] prfop
     /* 248698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248706 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 248709 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248721 */     GIR_RootConstrainSelectedInstOperands,
     /* 248722 */     // GIR_Coverage, 3404,
     /* 248722 */     GIR_EraseRootFromParent_Done,
     /* 248723 */   // Label 4986: @248723
     /* 248723 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(248783), // Rule ID 3405 //
     /* 248728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 248736 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248746 */     // MIs[0] Rn
     /* 248746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248758 */     // MIs[0] prfop
     /* 248758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248766 */     // (intrinsic_void 1541:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 248766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 248769 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248781 */     GIR_RootConstrainSelectedInstOperands,
     /* 248782 */     // GIR_Coverage, 3405,
     /* 248782 */     GIR_EraseRootFromParent_Done,
     /* 248783 */   // Label 4987: @248783
     /* 248783 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(248843), // Rule ID 8709 //
     /* 248788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 248796 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248806 */     // MIs[0] Rn
     /* 248806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248818 */     // MIs[0] prfop
     /* 248818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248826 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 248829 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248841 */     GIR_RootConstrainSelectedInstOperands,
     /* 248842 */     // GIR_Coverage, 8709,
     /* 248842 */     GIR_EraseRootFromParent_Done,
     /* 248843 */   // Label 4988: @248843
     /* 248843 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(248903), // Rule ID 8710 //
     /* 248848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 248856 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248866 */     // MIs[0] Rn
     /* 248866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248878 */     // MIs[0] prfop
     /* 248878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248886 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 248889 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248901 */     GIR_RootConstrainSelectedInstOperands,
     /* 248902 */     // GIR_Coverage, 8710,
     /* 248902 */     GIR_EraseRootFromParent_Done,
     /* 248903 */   // Label 4989: @248903
     /* 248903 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(248963), // Rule ID 8711 //
     /* 248908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 248916 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248926 */     // MIs[0] Rn
     /* 248926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248938 */     // MIs[0] prfop
     /* 248938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248946 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 248946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 248949 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248961 */     GIR_RootConstrainSelectedInstOperands,
     /* 248962 */     // GIR_Coverage, 8711,
     /* 248962 */     GIR_EraseRootFromParent_Done,
     /* 248963 */   // Label 4990: @248963
     /* 248963 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249023), // Rule ID 8712 //
     /* 248968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 248976 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248986 */     // MIs[0] Rn
     /* 248986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248998 */     // MIs[0] prfop
     /* 248998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249006 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 249006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 249009 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249021 */     GIR_RootConstrainSelectedInstOperands,
     /* 249022 */     // GIR_Coverage, 8712,
     /* 249022 */     GIR_EraseRootFromParent_Done,
     /* 249023 */   // Label 4991: @249023
     /* 249023 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249083), // Rule ID 8713 //
     /* 249028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 249036 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 249039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249046 */     // MIs[0] Rn
     /* 249046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249058 */     // MIs[0] prfop
     /* 249058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249066 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 249066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 249069 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249081 */     GIR_RootConstrainSelectedInstOperands,
     /* 249082 */     // GIR_Coverage, 8713,
     /* 249082 */     GIR_EraseRootFromParent_Done,
     /* 249083 */   // Label 4992: @249083
     /* 249083 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249143), // Rule ID 8714 //
     /* 249088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 249096 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 249099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249106 */     // MIs[0] Rn
     /* 249106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249118 */     // MIs[0] prfop
     /* 249118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249126 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249141 */     GIR_RootConstrainSelectedInstOperands,
     /* 249142 */     // GIR_Coverage, 8714,
     /* 249142 */     GIR_EraseRootFromParent_Done,
     /* 249143 */   // Label 4993: @249143
     /* 249143 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249203), // Rule ID 8715 //
     /* 249148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 249156 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249166 */     // MIs[0] Rn
     /* 249166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249178 */     // MIs[0] prfop
     /* 249178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249186 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 249186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 249189 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249201 */     GIR_RootConstrainSelectedInstOperands,
     /* 249202 */     // GIR_Coverage, 8715,
     /* 249202 */     GIR_EraseRootFromParent_Done,
     /* 249203 */   // Label 4994: @249203
     /* 249203 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249263), // Rule ID 8716 //
     /* 249208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 249216 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249226 */     // MIs[0] Rn
     /* 249226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249238 */     // MIs[0] prfop
     /* 249238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249246 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 249246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 249249 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249261 */     GIR_RootConstrainSelectedInstOperands,
     /* 249262 */     // GIR_Coverage, 8716,
     /* 249262 */     GIR_EraseRootFromParent_Done,
     /* 249263 */   // Label 4995: @249263
     /* 249263 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249323), // Rule ID 8717 //
     /* 249268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 249276 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249286 */     // MIs[0] Rn
     /* 249286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249298 */     // MIs[0] prfop
     /* 249298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249306 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 249306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 249309 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249321 */     GIR_RootConstrainSelectedInstOperands,
     /* 249322 */     // GIR_Coverage, 8717,
     /* 249322 */     GIR_EraseRootFromParent_Done,
     /* 249323 */   // Label 4996: @249323
     /* 249323 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249383), // Rule ID 8718 //
     /* 249328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 249336 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249346 */     // MIs[0] Rn
     /* 249346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249358 */     // MIs[0] prfop
     /* 249358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249366 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 249366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 249369 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249381 */     GIR_RootConstrainSelectedInstOperands,
     /* 249382 */     // GIR_Coverage, 8718,
     /* 249382 */     GIR_EraseRootFromParent_Done,
     /* 249383 */   // Label 4997: @249383
     /* 249383 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249443), // Rule ID 8719 //
     /* 249388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 249396 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249406 */     // MIs[0] Rn
     /* 249406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249418 */     // MIs[0] prfop
     /* 249418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249426 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 249426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249441 */     GIR_RootConstrainSelectedInstOperands,
     /* 249442 */     // GIR_Coverage, 8719,
     /* 249442 */     GIR_EraseRootFromParent_Done,
     /* 249443 */   // Label 4998: @249443
     /* 249443 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249503), // Rule ID 8720 //
     /* 249448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 249456 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249466 */     // MIs[0] Rn
     /* 249466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249478 */     // MIs[0] prfop
     /* 249478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249486 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 249486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 249489 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249501 */     GIR_RootConstrainSelectedInstOperands,
     /* 249502 */     // GIR_Coverage, 8720,
     /* 249502 */     GIR_EraseRootFromParent_Done,
     /* 249503 */   // Label 4999: @249503
     /* 249503 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249563), // Rule ID 8721 //
     /* 249508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 249516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249526 */     // MIs[0] Rn
     /* 249526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249538 */     // MIs[0] prfop
     /* 249538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249546 */     // (intrinsic_void 1549:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 249546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 249549 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249561 */     GIR_RootConstrainSelectedInstOperands,
     /* 249562 */     // GIR_Coverage, 8721,
     /* 249562 */     GIR_EraseRootFromParent_Done,
     /* 249563 */   // Label 5000: @249563
     /* 249563 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249623), // Rule ID 8722 //
     /* 249568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 249576 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249586 */     // MIs[0] Rn
     /* 249586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249598 */     // MIs[0] prfop
     /* 249598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249606 */     // (intrinsic_void 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 249606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 249609 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249621 */     GIR_RootConstrainSelectedInstOperands,
     /* 249622 */     // GIR_Coverage, 8722,
     /* 249622 */     GIR_EraseRootFromParent_Done,
     /* 249623 */   // Label 5001: @249623
     /* 249623 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249683), // Rule ID 8723 //
     /* 249628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 249636 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249646 */     // MIs[0] Rn
     /* 249646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249658 */     // MIs[0] prfop
     /* 249658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249666 */     // (intrinsic_void 1545:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 249666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 249669 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249681 */     GIR_RootConstrainSelectedInstOperands,
     /* 249682 */     // GIR_Coverage, 8723,
     /* 249682 */     GIR_EraseRootFromParent_Done,
     /* 249683 */   // Label 5002: @249683
     /* 249683 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249741), // Rule ID 2365 //
     /* 249688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 249696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249724 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 249727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249739 */     GIR_RootConstrainSelectedInstOperands,
     /* 249740 */     // GIR_Coverage, 2365,
     /* 249740 */     GIR_EraseRootFromParent_Done,
     /* 249741 */   // Label 5003: @249741
     /* 249741 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249799), // Rule ID 2366 //
     /* 249746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 249754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249782 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 249785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249797 */     GIR_RootConstrainSelectedInstOperands,
     /* 249798 */     // GIR_Coverage, 2366,
     /* 249798 */     GIR_EraseRootFromParent_Done,
     /* 249799 */   // Label 5004: @249799
     /* 249799 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249857), // Rule ID 2367 //
     /* 249804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 249812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249840 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 249843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249855 */     GIR_RootConstrainSelectedInstOperands,
     /* 249856 */     // GIR_Coverage, 2367,
     /* 249856 */     GIR_EraseRootFromParent_Done,
     /* 249857 */   // Label 5005: @249857
     /* 249857 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249915), // Rule ID 2368 //
     /* 249862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 249870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249898 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 249901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249913 */     GIR_RootConstrainSelectedInstOperands,
     /* 249914 */     // GIR_Coverage, 2368,
     /* 249914 */     GIR_EraseRootFromParent_Done,
     /* 249915 */   // Label 5006: @249915
     /* 249915 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(249973), // Rule ID 2369 //
     /* 249920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 249928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249956 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 249959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249971 */     GIR_RootConstrainSelectedInstOperands,
     /* 249972 */     // GIR_Coverage, 2369,
     /* 249972 */     GIR_EraseRootFromParent_Done,
     /* 249973 */   // Label 5007: @249973
     /* 249973 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250031), // Rule ID 2370 //
     /* 249978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 249986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250014 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 250014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 250017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250029 */     GIR_RootConstrainSelectedInstOperands,
     /* 250030 */     // GIR_Coverage, 2370,
     /* 250030 */     GIR_EraseRootFromParent_Done,
     /* 250031 */   // Label 5008: @250031
     /* 250031 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250089), // Rule ID 2371 //
     /* 250036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 250044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 250047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 250050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 250056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250072 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 250072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 250075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250087 */     GIR_RootConstrainSelectedInstOperands,
     /* 250088 */     // GIR_Coverage, 2371,
     /* 250088 */     GIR_EraseRootFromParent_Done,
     /* 250089 */   // Label 5009: @250089
     /* 250089 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250147), // Rule ID 2372 //
     /* 250094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 250102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250130 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 250130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 250133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250145 */     GIR_RootConstrainSelectedInstOperands,
     /* 250146 */     // GIR_Coverage, 2372,
     /* 250146 */     GIR_EraseRootFromParent_Done,
     /* 250147 */   // Label 5010: @250147
     /* 250147 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250205), // Rule ID 2373 //
     /* 250152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 250160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 250163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 250166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 250172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250188 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 250188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 250191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250203 */     GIR_RootConstrainSelectedInstOperands,
     /* 250204 */     // GIR_Coverage, 2373,
     /* 250204 */     GIR_EraseRootFromParent_Done,
     /* 250205 */   // Label 5011: @250205
     /* 250205 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250263), // Rule ID 2374 //
     /* 250210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 250218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250246 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 250246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 250249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250261 */     GIR_RootConstrainSelectedInstOperands,
     /* 250262 */     // GIR_Coverage, 2374,
     /* 250262 */     GIR_EraseRootFromParent_Done,
     /* 250263 */   // Label 5012: @250263
     /* 250263 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250321), // Rule ID 2482 //
     /* 250268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 250276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 250279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 250285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 250288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250304 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 250304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 250307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250309 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 250311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250319 */     GIR_RootConstrainSelectedInstOperands,
     /* 250320 */     // GIR_Coverage, 2482,
     /* 250320 */     GIR_EraseRootFromParent_Done,
     /* 250321 */   // Label 5013: @250321
     /* 250321 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250377), // Rule ID 12866 //
     /* 250326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 250331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 250340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250352 */     // MIs[0] addr
     /* 250352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 250356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250360 */     // (intrinsic_w_chain:{ *:[i32] } 1144:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 250360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 250363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250365 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 250367 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 250369 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 250371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250375 */     GIR_RootConstrainSelectedInstOperands,
     /* 250376 */     // GIR_Coverage, 12866,
     /* 250376 */     GIR_EraseRootFromParent_Done,
     /* 250377 */   // Label 5014: @250377
     /* 250377 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250433), // Rule ID 12867 //
     /* 250382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 250387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 250396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250408 */     // MIs[0] addr
     /* 250408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 250412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250416 */     // (intrinsic_w_chain:{ *:[i32] } 1146:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 250416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 250419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250421 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 250423 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 250425 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 250427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250431 */     GIR_RootConstrainSelectedInstOperands,
     /* 250432 */     // GIR_Coverage, 12867,
     /* 250432 */     GIR_EraseRootFromParent_Done,
     /* 250433 */   // Label 5015: @250433
     /* 250433 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250479), // Rule ID 3439 //
     /* 250438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 250441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250462 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 250465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250477 */     GIR_RootConstrainSelectedInstOperands,
     /* 250478 */     // GIR_Coverage, 3439,
     /* 250478 */     GIR_EraseRootFromParent_Done,
     /* 250479 */   // Label 5016: @250479
     /* 250479 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250525), // Rule ID 3561 //
     /* 250484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 250492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250508 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 250511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250523 */     GIR_RootConstrainSelectedInstOperands,
     /* 250524 */     // GIR_Coverage, 3561,
     /* 250524 */     GIR_EraseRootFromParent_Done,
     /* 250525 */   // Label 5017: @250525
     /* 250525 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250571), // Rule ID 12379 //
     /* 250530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 250538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250554 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 250557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250569 */     GIR_RootConstrainSelectedInstOperands,
     /* 250570 */     // GIR_Coverage, 12379,
     /* 250570 */     GIR_EraseRootFromParent_Done,
     /* 250571 */   // Label 5018: @250571
     /* 250571 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250617), // Rule ID 12383 //
     /* 250576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 250584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250600 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1413:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 250603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250615 */     GIR_RootConstrainSelectedInstOperands,
     /* 250616 */     // GIR_Coverage, 12383,
     /* 250616 */     GIR_EraseRootFromParent_Done,
     /* 250617 */   // Label 5019: @250617
     /* 250617 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250663), // Rule ID 12384 //
     /* 250622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 250630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250646 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1415:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 250649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250661 */     GIR_RootConstrainSelectedInstOperands,
     /* 250662 */     // GIR_Coverage, 12384,
     /* 250662 */     GIR_EraseRootFromParent_Done,
     /* 250663 */   // Label 5020: @250663
     /* 250663 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250709), // Rule ID 12385 //
     /* 250668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 250676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250692 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 250695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250707 */     GIR_RootConstrainSelectedInstOperands,
     /* 250708 */     // GIR_Coverage, 12385,
     /* 250708 */     GIR_EraseRootFromParent_Done,
     /* 250709 */   // Label 5021: @250709
     /* 250709 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250755), // Rule ID 12386 //
     /* 250714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 250722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250738 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 250741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250753 */     GIR_RootConstrainSelectedInstOperands,
     /* 250754 */     // GIR_Coverage, 12386,
     /* 250754 */     GIR_EraseRootFromParent_Done,
     /* 250755 */   // Label 5022: @250755
     /* 250755 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250801), // Rule ID 12387 //
     /* 250760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 250763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250784 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 250787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250799 */     GIR_RootConstrainSelectedInstOperands,
     /* 250800 */     // GIR_Coverage, 12387,
     /* 250800 */     GIR_EraseRootFromParent_Done,
     /* 250801 */   // Label 5023: @250801
     /* 250801 */   GIM_Reject,
     /* 250802 */ // Label 4976: @250802
     /* 250802 */ GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(253795),
     /* 250807 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 250810 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250878), // Rule ID 2509 //
     /* 250815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 250823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250851 */     // MIs[0] Idx
     /* 250851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250859 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 250862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250870 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250876 */     GIR_RootConstrainSelectedInstOperands,
     /* 250877 */     // GIR_Coverage, 2509,
     /* 250877 */     GIR_EraseRootFromParent_Done,
     /* 250878 */   // Label 5025: @250878
     /* 250878 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250946), // Rule ID 2510 //
     /* 250883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 250891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250919 */     // MIs[0] Idx
     /* 250919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250927 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 250930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250944 */     GIR_RootConstrainSelectedInstOperands,
     /* 250945 */     // GIR_Coverage, 2510,
     /* 250945 */     GIR_EraseRootFromParent_Done,
     /* 250946 */   // Label 5026: @250946
     /* 250946 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251014), // Rule ID 2511 //
     /* 250951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 250959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 250962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 250965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250987 */     // MIs[0] Idx
     /* 250987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 250995 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 250998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251012 */     GIR_RootConstrainSelectedInstOperands,
     /* 251013 */     // GIR_Coverage, 2511,
     /* 251013 */     GIR_EraseRootFromParent_Done,
     /* 251014 */   // Label 5027: @251014
     /* 251014 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251082), // Rule ID 2512 //
     /* 251019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 251022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 251027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251055 */     // MIs[0] Idx
     /* 251055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 251063 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 251066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251074 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251080 */     GIR_RootConstrainSelectedInstOperands,
     /* 251081 */     // GIR_Coverage, 2512,
     /* 251081 */     GIR_EraseRootFromParent_Done,
     /* 251082 */   // Label 5028: @251082
     /* 251082 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251150), // Rule ID 2513 //
     /* 251087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 251090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 251095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 251098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 251101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 251104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 251123 */     // MIs[0] Idx
     /* 251123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 251131 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 251134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251142 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251148 */     GIR_RootConstrainSelectedInstOperands,
     /* 251149 */     // GIR_Coverage, 2513,
     /* 251149 */     GIR_EraseRootFromParent_Done,
     /* 251150 */   // Label 5029: @251150
     /* 251150 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251218), // Rule ID 2514 //
     /* 251155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 251158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 251163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 251169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 251191 */     // MIs[0] Idx
     /* 251191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 251199 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 251202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251216 */     GIR_RootConstrainSelectedInstOperands,
     /* 251217 */     // GIR_Coverage, 2514,
     /* 251217 */     GIR_EraseRootFromParent_Done,
     /* 251218 */   // Label 5030: @251218
     /* 251218 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251286), // Rule ID 6895 //
     /* 251223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 251231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 251237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251259 */     // MIs[0] Idx
     /* 251259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251267 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 251270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251284 */     GIR_RootConstrainSelectedInstOperands,
     /* 251285 */     // GIR_Coverage, 6895,
     /* 251285 */     GIR_EraseRootFromParent_Done,
     /* 251286 */   // Label 5031: @251286
     /* 251286 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251354), // Rule ID 6896 //
     /* 251291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 251299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251327 */     // MIs[0] Idx
     /* 251327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251335 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 251338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251352 */     GIR_RootConstrainSelectedInstOperands,
     /* 251353 */     // GIR_Coverage, 6896,
     /* 251353 */     GIR_EraseRootFromParent_Done,
     /* 251354 */   // Label 5032: @251354
     /* 251354 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251422), // Rule ID 6897 //
     /* 251359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 251367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251395 */     // MIs[0] Idx
     /* 251395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251403 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 251406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251414 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251420 */     GIR_RootConstrainSelectedInstOperands,
     /* 251421 */     // GIR_Coverage, 6897,
     /* 251421 */     GIR_EraseRootFromParent_Done,
     /* 251422 */   // Label 5033: @251422
     /* 251422 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251490), // Rule ID 6898 //
     /* 251427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 251435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251463 */     // MIs[0] Idx
     /* 251463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251471 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 251474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251482 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251488 */     GIR_RootConstrainSelectedInstOperands,
     /* 251489 */     // GIR_Coverage, 6898,
     /* 251489 */     GIR_EraseRootFromParent_Done,
     /* 251490 */   // Label 5034: @251490
     /* 251490 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251550), // Rule ID 3573 //
     /* 251495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251515 */     // MIs[0] tile
     /* 251515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251531 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 251534 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251542 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251548 */     GIR_RootConstrainSelectedInstOperands,
     /* 251549 */     // GIR_Coverage, 3573,
     /* 251549 */     GIR_EraseRootFromParent_Done,
     /* 251550 */   // Label 5035: @251550
     /* 251550 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251610), // Rule ID 3574 //
     /* 251555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 251558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 251563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251575 */     // MIs[0] tile
     /* 251575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251591 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 251594 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251602 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251608 */     GIR_RootConstrainSelectedInstOperands,
     /* 251609 */     // GIR_Coverage, 3574,
     /* 251609 */     GIR_EraseRootFromParent_Done,
     /* 251610 */   // Label 5036: @251610
     /* 251610 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251670), // Rule ID 3575 //
     /* 251615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 251618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251635 */     // MIs[0] tile
     /* 251635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251651 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 251654 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251662 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251668 */     GIR_RootConstrainSelectedInstOperands,
     /* 251669 */     // GIR_Coverage, 3575,
     /* 251669 */     GIR_EraseRootFromParent_Done,
     /* 251670 */   // Label 5037: @251670
     /* 251670 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251730), // Rule ID 3576 //
     /* 251675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 251678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 251683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251695 */     // MIs[0] tile
     /* 251695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251711 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251722 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251728 */     GIR_RootConstrainSelectedInstOperands,
     /* 251729 */     // GIR_Coverage, 3576,
     /* 251729 */     GIR_EraseRootFromParent_Done,
     /* 251730 */   // Label 5038: @251730
     /* 251730 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251790), // Rule ID 3577 //
     /* 251735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 251738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251755 */     // MIs[0] tile
     /* 251755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251771 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 251774 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251788 */     GIR_RootConstrainSelectedInstOperands,
     /* 251789 */     // GIR_Coverage, 3577,
     /* 251789 */     GIR_EraseRootFromParent_Done,
     /* 251790 */   // Label 5039: @251790
     /* 251790 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251850), // Rule ID 3578 //
     /* 251795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251815 */     // MIs[0] tile
     /* 251815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251831 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 251834 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251842 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251848 */     GIR_RootConstrainSelectedInstOperands,
     /* 251849 */     // GIR_Coverage, 3578,
     /* 251849 */     GIR_EraseRootFromParent_Done,
     /* 251850 */   // Label 5040: @251850
     /* 251850 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251910), // Rule ID 3579 //
     /* 251855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 251858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251875 */     // MIs[0] tile
     /* 251875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251891 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 251894 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251908 */     GIR_RootConstrainSelectedInstOperands,
     /* 251909 */     // GIR_Coverage, 3579,
     /* 251909 */     GIR_EraseRootFromParent_Done,
     /* 251910 */   // Label 5041: @251910
     /* 251910 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251970), // Rule ID 3580 //
     /* 251915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 251923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251935 */     // MIs[0] tile
     /* 251935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251951 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 251954 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251968 */     GIR_RootConstrainSelectedInstOperands,
     /* 251969 */     // GIR_Coverage, 3580,
     /* 251969 */     GIR_EraseRootFromParent_Done,
     /* 251970 */   // Label 5042: @251970
     /* 251970 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252030), // Rule ID 3662 //
     /* 251975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 251978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 251983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251995 */     // MIs[0] tile
     /* 251995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252011 */     // (intrinsic_void 990:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 252014 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252028 */     GIR_RootConstrainSelectedInstOperands,
     /* 252029 */     // GIR_Coverage, 3662,
     /* 252029 */     GIR_EraseRootFromParent_Done,
     /* 252030 */   // Label 5043: @252030
     /* 252030 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252090), // Rule ID 3663 //
     /* 252035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 252043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 252049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 252055 */     // MIs[0] tile
     /* 252055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252071 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 252071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 252074 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252082 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252088 */     GIR_RootConstrainSelectedInstOperands,
     /* 252089 */     // GIR_Coverage, 3663,
     /* 252089 */     GIR_EraseRootFromParent_Done,
     /* 252090 */   // Label 5044: @252090
     /* 252090 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252150), // Rule ID 12394 //
     /* 252095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 252103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 252109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 252115 */     // MIs[0] tile
     /* 252115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252131 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252142 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252148 */     GIR_RootConstrainSelectedInstOperands,
     /* 252149 */     // GIR_Coverage, 12394,
     /* 252149 */     GIR_EraseRootFromParent_Done,
     /* 252150 */   // Label 5045: @252150
     /* 252150 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252210), // Rule ID 12395 //
     /* 252155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 252158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 252163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 252169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 252175 */     // MIs[0] tile
     /* 252175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252191 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 252194 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252202 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252208 */     GIR_RootConstrainSelectedInstOperands,
     /* 252209 */     // GIR_Coverage, 12395,
     /* 252209 */     GIR_EraseRootFromParent_Done,
     /* 252210 */   // Label 5046: @252210
     /* 252210 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252270), // Rule ID 12396 //
     /* 252215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 252223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252235 */     // MIs[0] tile
     /* 252235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252251 */     // (intrinsic_void 907:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 252254 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252262 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252268 */     GIR_RootConstrainSelectedInstOperands,
     /* 252269 */     // GIR_Coverage, 12396,
     /* 252269 */     GIR_EraseRootFromParent_Done,
     /* 252270 */   // Label 5047: @252270
     /* 252270 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252330), // Rule ID 12397 //
     /* 252275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 252283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252295 */     // MIs[0] tile
     /* 252295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252311 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 252314 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252322 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252328 */     GIR_RootConstrainSelectedInstOperands,
     /* 252329 */     // GIR_Coverage, 12397,
     /* 252329 */     GIR_EraseRootFromParent_Done,
     /* 252330 */   // Label 5048: @252330
     /* 252330 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252390), // Rule ID 12398 //
     /* 252335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 252343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252355 */     // MIs[0] tile
     /* 252355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252371 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 252374 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252382 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252388 */     GIR_RootConstrainSelectedInstOperands,
     /* 252389 */     // GIR_Coverage, 12398,
     /* 252389 */     GIR_EraseRootFromParent_Done,
     /* 252390 */   // Label 5049: @252390
     /* 252390 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252450), // Rule ID 12399 //
     /* 252395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 252403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252415 */     // MIs[0] tile
     /* 252415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252431 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 252434 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252442 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252448 */     GIR_RootConstrainSelectedInstOperands,
     /* 252449 */     // GIR_Coverage, 12399,
     /* 252449 */     GIR_EraseRootFromParent_Done,
     /* 252450 */   // Label 5050: @252450
     /* 252450 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252510), // Rule ID 12400 //
     /* 252455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252475 */     // MIs[0] tile
     /* 252475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252491 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 252494 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252502 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252508 */     GIR_RootConstrainSelectedInstOperands,
     /* 252509 */     // GIR_Coverage, 12400,
     /* 252509 */     GIR_EraseRootFromParent_Done,
     /* 252510 */   // Label 5051: @252510
     /* 252510 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252570), // Rule ID 12401 //
     /* 252515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252535 */     // MIs[0] tile
     /* 252535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252551 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 252554 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252562 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252568 */     GIR_RootConstrainSelectedInstOperands,
     /* 252569 */     // GIR_Coverage, 12401,
     /* 252569 */     GIR_EraseRootFromParent_Done,
     /* 252570 */   // Label 5052: @252570
     /* 252570 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252630), // Rule ID 12402 //
     /* 252575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 252583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252595 */     // MIs[0] tile
     /* 252595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252611 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 252614 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252622 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252628 */     GIR_RootConstrainSelectedInstOperands,
     /* 252629 */     // GIR_Coverage, 12402,
     /* 252629 */     GIR_EraseRootFromParent_Done,
     /* 252630 */   // Label 5053: @252630
     /* 252630 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252690), // Rule ID 12403 //
     /* 252635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 252643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252655 */     // MIs[0] tile
     /* 252655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252671 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252682 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252688 */     GIR_RootConstrainSelectedInstOperands,
     /* 252689 */     // GIR_Coverage, 12403,
     /* 252689 */     GIR_EraseRootFromParent_Done,
     /* 252690 */   // Label 5054: @252690
     /* 252690 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252750), // Rule ID 12404 //
     /* 252695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 252703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252715 */     // MIs[0] tile
     /* 252715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252731 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 252734 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252742 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252748 */     GIR_RootConstrainSelectedInstOperands,
     /* 252749 */     // GIR_Coverage, 12404,
     /* 252749 */     GIR_EraseRootFromParent_Done,
     /* 252750 */   // Label 5055: @252750
     /* 252750 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252810), // Rule ID 12405 //
     /* 252755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 252763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252775 */     // MIs[0] tile
     /* 252775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252791 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 252794 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252802 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252808 */     GIR_RootConstrainSelectedInstOperands,
     /* 252809 */     // GIR_Coverage, 12405,
     /* 252809 */     GIR_EraseRootFromParent_Done,
     /* 252810 */   // Label 5056: @252810
     /* 252810 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252870), // Rule ID 12406 //
     /* 252815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 252823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252835 */     // MIs[0] tile
     /* 252835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252851 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 252854 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252862 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252868 */     GIR_RootConstrainSelectedInstOperands,
     /* 252869 */     // GIR_Coverage, 12406,
     /* 252869 */     GIR_EraseRootFromParent_Done,
     /* 252870 */   // Label 5057: @252870
     /* 252870 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252930), // Rule ID 12407 //
     /* 252875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252895 */     // MIs[0] tile
     /* 252895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252911 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 252914 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252922 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252928 */     GIR_RootConstrainSelectedInstOperands,
     /* 252929 */     // GIR_Coverage, 12407,
     /* 252929 */     GIR_EraseRootFromParent_Done,
     /* 252930 */   // Label 5058: @252930
     /* 252930 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252990), // Rule ID 12408 //
     /* 252935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252955 */     // MIs[0] tile
     /* 252955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252971 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 252974 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252982 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252988 */     GIR_RootConstrainSelectedInstOperands,
     /* 252989 */     // GIR_Coverage, 12408,
     /* 252989 */     GIR_EraseRootFromParent_Done,
     /* 252990 */   // Label 5059: @252990
     /* 252990 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(253050), // Rule ID 12409 //
     /* 252995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 253003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253015 */     // MIs[0] tile
     /* 253015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253031 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 253034 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253042 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253048 */     GIR_RootConstrainSelectedInstOperands,
     /* 253049 */     // GIR_Coverage, 12409,
     /* 253049 */     GIR_EraseRootFromParent_Done,
     /* 253050 */   // Label 5060: @253050
     /* 253050 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(253110), // Rule ID 12410 //
     /* 253055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 253058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 253063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253075 */     // MIs[0] tile
     /* 253075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253091 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 253094 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253102 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253108 */     GIR_RootConstrainSelectedInstOperands,
     /* 253109 */     // GIR_Coverage, 12410,
     /* 253109 */     GIR_EraseRootFromParent_Done,
     /* 253110 */   // Label 5061: @253110
     /* 253110 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(253170), // Rule ID 12707 //
     /* 253115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 253118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 253123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 253135 */     // MIs[0] tile
     /* 253135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253151 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 253151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 253154 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253162 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253168 */     GIR_RootConstrainSelectedInstOperands,
     /* 253169 */     // GIR_Coverage, 12707,
     /* 253169 */     GIR_EraseRootFromParent_Done,
     /* 253170 */   // Label 5062: @253170
     /* 253170 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253230), // Rule ID 12708 //
     /* 253175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 253178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 253183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253195 */     // MIs[0] tile
     /* 253195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253211 */     // (intrinsic_void 992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 253214 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253222 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253228 */     GIR_RootConstrainSelectedInstOperands,
     /* 253229 */     // GIR_Coverage, 12708,
     /* 253229 */     GIR_EraseRootFromParent_Done,
     /* 253230 */   // Label 5063: @253230
     /* 253230 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(253290), // Rule ID 12709 //
     /* 253235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 253238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 253243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253255 */     // MIs[0] tile
     /* 253255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253271 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 253274 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253282 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253288 */     GIR_RootConstrainSelectedInstOperands,
     /* 253289 */     // GIR_Coverage, 12709,
     /* 253289 */     GIR_EraseRootFromParent_Done,
     /* 253290 */   // Label 5064: @253290
     /* 253290 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253350), // Rule ID 12710 //
     /* 253295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 253298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 253303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253315 */     // MIs[0] tile
     /* 253315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253331 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 253334 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253342 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253348 */     GIR_RootConstrainSelectedInstOperands,
     /* 253349 */     // GIR_Coverage, 12710,
     /* 253349 */     GIR_EraseRootFromParent_Done,
     /* 253350 */   // Label 5065: @253350
     /* 253350 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253410), // Rule ID 12821 //
     /* 253355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 253358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 253363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 253375 */     // MIs[0] tile
     /* 253375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253391 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 253394 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 253398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 253400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 253402 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 253404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253408 */     GIR_RootConstrainSelectedInstOperands,
     /* 253409 */     // GIR_Coverage, 12821,
     /* 253409 */     GIR_EraseRootFromParent_Done,
     /* 253410 */   // Label 5066: @253410
     /* 253410 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253458), // Rule ID 3560 //
     /* 253415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 253423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253439 */     // MIs[0] Op4
     /* 253439 */     // No operand predicates
     /* 253439 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1412:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 253442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253450 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253456 */     GIR_RootConstrainSelectedInstOperands,
     /* 253457 */     // GIR_Coverage, 3560,
     /* 253457 */     GIR_EraseRootFromParent_Done,
     /* 253458 */   // Label 5067: @253458
     /* 253458 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253506), // Rule ID 3562 //
     /* 253463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 253471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253487 */     // MIs[0] Op4
     /* 253487 */     // No operand predicates
     /* 253487 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1414:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 253490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253498 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253504 */     GIR_RootConstrainSelectedInstOperands,
     /* 253505 */     // GIR_Coverage, 3562,
     /* 253505 */     GIR_EraseRootFromParent_Done,
     /* 253506 */   // Label 5068: @253506
     /* 253506 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253554), // Rule ID 3563 //
     /* 253511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 253514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253535 */     // MIs[0] Op4
     /* 253535 */     // No operand predicates
     /* 253535 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 253538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253546 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253552 */     GIR_RootConstrainSelectedInstOperands,
     /* 253553 */     // GIR_Coverage, 3563,
     /* 253553 */     GIR_EraseRootFromParent_Done,
     /* 253554 */   // Label 5069: @253554
     /* 253554 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253602), // Rule ID 3564 //
     /* 253559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 253562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253583 */     // MIs[0] Op4
     /* 253583 */     // No operand predicates
     /* 253583 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 253586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253600 */     GIR_RootConstrainSelectedInstOperands,
     /* 253601 */     // GIR_Coverage, 3564,
     /* 253601 */     GIR_EraseRootFromParent_Done,
     /* 253602 */   // Label 5070: @253602
     /* 253602 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253650), // Rule ID 12378 //
     /* 253607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 253615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253631 */     // MIs[0] Op4
     /* 253631 */     // No operand predicates
     /* 253631 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 253634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253642 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253648 */     GIR_RootConstrainSelectedInstOperands,
     /* 253649 */     // GIR_Coverage, 12378,
     /* 253649 */     GIR_EraseRootFromParent_Done,
     /* 253650 */   // Label 5071: @253650
     /* 253650 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253698), // Rule ID 12380 //
     /* 253655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 253663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253679 */     // MIs[0] Op4
     /* 253679 */     // No operand predicates
     /* 253679 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1416:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 253682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253690 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253696 */     GIR_RootConstrainSelectedInstOperands,
     /* 253697 */     // GIR_Coverage, 12380,
     /* 253697 */     GIR_EraseRootFromParent_Done,
     /* 253698 */   // Label 5072: @253698
     /* 253698 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253746), // Rule ID 12381 //
     /* 253703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 253711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253727 */     // MIs[0] Op4
     /* 253727 */     // No operand predicates
     /* 253727 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1418:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 253730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253738 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253744 */     GIR_RootConstrainSelectedInstOperands,
     /* 253745 */     // GIR_Coverage, 12381,
     /* 253745 */     GIR_EraseRootFromParent_Done,
     /* 253746 */   // Label 5073: @253746
     /* 253746 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253794), // Rule ID 12382 //
     /* 253751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 253759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253775 */     // MIs[0] Op4
     /* 253775 */     // No operand predicates
     /* 253775 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 253778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253786 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253792 */     GIR_RootConstrainSelectedInstOperands,
     /* 253793 */     // GIR_Coverage, 12382,
     /* 253793 */     GIR_EraseRootFromParent_Done,
     /* 253794 */   // Label 5074: @253794
     /* 253794 */   GIM_Reject,
     /* 253795 */ // Label 5024: @253795
     /* 253795 */ GIM_Reject,
     /* 253796 */ // Label 34: @253796
     /* 253796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5079*/ GIMT_Encode4(254085),
     /* 253807 */ /*GILLT_s64*//*Label 5075*/ GIMT_Encode4(253839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 253819 */ /*GILLT_v2s64*//*Label 5076*/ GIMT_Encode4(253899), GIMT_Encode4(0),
     /* 253827 */ /*GILLT_v4s32*//*Label 5077*/ GIMT_Encode4(253961), GIMT_Encode4(0),
     /* 253835 */ /*GILLT_v8s16*//*Label 5078*/ GIMT_Encode4(254023),
     /* 253839 */ // Label 5075: @253839
     /* 253839 */ GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253898), // Rule ID 6407 //
     /* 253844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 253847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253855 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 253855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 253858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 253862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 253869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 253872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 253879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 253882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253897 */   // GIR_Coverage, 6407,
     /* 253897 */   GIR_EraseRootFromParent_Done,
     /* 253898 */ // Label 5080: @253898
     /* 253898 */ GIM_Reject,
     /* 253899 */ // Label 5076: @253899
     /* 253899 */ GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253960),
     /* 253904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 253907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253911 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253938), // Rule ID 6279 //
     /* 253916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 253923 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 253923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 253926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253936 */     GIR_RootConstrainSelectedInstOperands,
     /* 253937 */     // GIR_Coverage, 6279,
     /* 253937 */     GIR_EraseRootFromParent_Done,
     /* 253938 */   // Label 5082: @253938
     /* 253938 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253959), // Rule ID 6272 //
     /* 253943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253947 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 253947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 253950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253957 */     GIR_RootConstrainSelectedInstOperands,
     /* 253958 */     // GIR_Coverage, 6272,
     /* 253958 */     GIR_EraseRootFromParent_Done,
     /* 253959 */   // Label 5083: @253959
     /* 253959 */   GIM_Reject,
     /* 253960 */ // Label 5081: @253960
     /* 253960 */ GIM_Reject,
     /* 253961 */ // Label 5077: @253961
     /* 253961 */ GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(254022),
     /* 253966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 253969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253973 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(254000), // Rule ID 6276 //
     /* 253978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 253985 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 253985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253998 */     GIR_RootConstrainSelectedInstOperands,
     /* 253999 */     // GIR_Coverage, 6276,
     /* 253999 */     GIR_EraseRootFromParent_Done,
     /* 254000 */   // Label 5085: @254000
     /* 254000 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(254021), // Rule ID 6269 //
     /* 254005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254009 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 254009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 254012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 254016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254019 */     GIR_RootConstrainSelectedInstOperands,
     /* 254020 */     // GIR_Coverage, 6269,
     /* 254020 */     GIR_EraseRootFromParent_Done,
     /* 254021 */   // Label 5086: @254021
     /* 254021 */   GIM_Reject,
     /* 254022 */ // Label 5084: @254022
     /* 254022 */ GIM_Reject,
     /* 254023 */ // Label 5078: @254023
     /* 254023 */ GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(254084),
     /* 254028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 254031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254035 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254062), // Rule ID 6273 //
     /* 254040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 254047 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 254047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 254050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 254057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254060 */     GIR_RootConstrainSelectedInstOperands,
     /* 254061 */     // GIR_Coverage, 6273,
     /* 254061 */     GIR_EraseRootFromParent_Done,
     /* 254062 */   // Label 5088: @254062
     /* 254062 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254083), // Rule ID 6266 //
     /* 254067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254071 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 254071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 254074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 254078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254081 */     GIR_RootConstrainSelectedInstOperands,
     /* 254082 */     // GIR_Coverage, 6266,
     /* 254082 */     GIR_EraseRootFromParent_Done,
     /* 254083 */   // Label 5089: @254083
     /* 254083 */   GIM_Reject,
     /* 254084 */ // Label 5087: @254084
     /* 254084 */ GIM_Reject,
     /* 254085 */ // Label 5079: @254085
     /* 254085 */ GIM_Reject,
     /* 254086 */ // Label 35: @254086
     /* 254086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5094*/ GIMT_Encode4(255522),
     /* 254097 */ /*GILLT_s32*//*Label 5090*/ GIMT_Encode4(254129), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 254109 */ /*GILLT_v2s32*//*Label 5091*/ GIMT_Encode4(254168), GIMT_Encode4(0),
     /* 254117 */ /*GILLT_v4s16*//*Label 5092*/ GIMT_Encode4(254524), GIMT_Encode4(0),
     /* 254125 */ /*GILLT_v8s8*//*Label 5093*/ GIMT_Encode4(255023),
     /* 254129 */ // Label 5090: @254129
     /* 254129 */ GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254167), // Rule ID 6428 //
     /* 254134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 254137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 254141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254145 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 254145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 254150 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 254156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 254161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254166 */   // GIR_Coverage, 6428,
     /* 254166 */   GIR_EraseRootFromParent_Done,
     /* 254167 */ // Label 5095: @254167
     /* 254167 */ GIM_Reject,
     /* 254168 */ // Label 5091: @254168
     /* 254168 */ GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254523),
     /* 254173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254180 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254258), // Rule ID 5366 //
     /* 254185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 254213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254230 */     // MIs[1] Operand 2
     /* 254230 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 254241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254243 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 254243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 254246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254256 */     GIR_RootConstrainSelectedInstOperands,
     /* 254257 */     // GIR_Coverage, 5366,
     /* 254257 */     GIR_EraseRootFromParent_Done,
     /* 254258 */   // Label 5097: @254258
     /* 254258 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254329), // Rule ID 5362 //
     /* 254263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 254291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254301 */     // MIs[1] Operand 2
     /* 254301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 254312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254314 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 254314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 254317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254327 */     GIR_RootConstrainSelectedInstOperands,
     /* 254328 */     // GIR_Coverage, 5362,
     /* 254328 */     GIR_EraseRootFromParent_Done,
     /* 254329 */   // Label 5098: @254329
     /* 254329 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254400), // Rule ID 5364 //
     /* 254334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 254362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254372 */     // MIs[1] Operand 2
     /* 254372 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 254383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254385 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 254385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 254388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254398 */     GIR_RootConstrainSelectedInstOperands,
     /* 254399 */     // GIR_Coverage, 5364,
     /* 254399 */     GIR_EraseRootFromParent_Done,
     /* 254400 */   // Label 5099: @254400
     /* 254400 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254453), // Rule ID 2153 //
     /* 254405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254425 */     // MIs[1] imm
     /* 254425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254433 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 254437 */     // MIs[2] Operand 1
     /* 254437 */     // No operand predicates
     /* 254437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254439 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 254442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254451 */     GIR_RootConstrainSelectedInstOperands,
     /* 254452 */     // GIR_Coverage, 2153,
     /* 254452 */     GIR_EraseRootFromParent_Done,
     /* 254453 */   // Label 5100: @254453
     /* 254453 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254503), // Rule ID 6254 //
     /* 254458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254475 */     // MIs[1] imm
     /* 254475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 254487 */     // MIs[2] Operand 1
     /* 254487 */     // No operand predicates
     /* 254487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254489 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 254489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 254492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254501 */     GIR_RootConstrainSelectedInstOperands,
     /* 254502 */     // GIR_Coverage, 6254,
     /* 254502 */     GIR_EraseRootFromParent_Done,
     /* 254503 */   // Label 5101: @254503
     /* 254503 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254522), // Rule ID 1092 //
     /* 254508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254515 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 254515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 254520 */     GIR_RootConstrainSelectedInstOperands,
     /* 254521 */     // GIR_Coverage, 1092,
     /* 254521 */     GIR_Done,
     /* 254522 */   // Label 5102: @254522
     /* 254522 */   GIM_Reject,
     /* 254523 */ // Label 5096: @254523
     /* 254523 */ GIM_Reject,
     /* 254524 */ // Label 5092: @254524
     /* 254524 */ GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(255022),
     /* 254529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254536 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254614), // Rule ID 5360 //
     /* 254541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254578 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254584 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254586 */     // MIs[1] Operand 2
     /* 254586 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254599 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 254599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254612 */     GIR_RootConstrainSelectedInstOperands,
     /* 254613 */     // GIR_Coverage, 5360,
     /* 254613 */     GIR_EraseRootFromParent_Done,
     /* 254614 */   // Label 5104: @254614
     /* 254614 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254685), // Rule ID 5356 //
     /* 254619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254657 */     // MIs[1] Operand 2
     /* 254657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254670 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 254673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254683 */     GIR_RootConstrainSelectedInstOperands,
     /* 254684 */     // GIR_Coverage, 5356,
     /* 254684 */     GIR_EraseRootFromParent_Done,
     /* 254685 */   // Label 5105: @254685
     /* 254685 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254756), // Rule ID 5358 //
     /* 254690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254728 */     // MIs[1] Operand 2
     /* 254728 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254741 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254754 */     GIR_RootConstrainSelectedInstOperands,
     /* 254755 */     // GIR_Coverage, 5358,
     /* 254755 */     GIR_EraseRootFromParent_Done,
     /* 254756 */   // Label 5106: @254756
     /* 254756 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(254848), // Rule ID 5482 //
     /* 254761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254769 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 254801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254816 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 254816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 254819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 254823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 254832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 254836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 254838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 254841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254846 */     GIR_RootConstrainSelectedInstOperands,
     /* 254847 */     // GIR_Coverage, 5482,
     /* 254847 */     GIR_EraseRootFromParent_Done,
     /* 254848 */   // Label 5107: @254848
     /* 254848 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(254901), // Rule ID 2152 //
     /* 254853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254873 */     // MIs[1] imm
     /* 254873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254881 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254885 */     // MIs[2] Operand 1
     /* 254885 */     // No operand predicates
     /* 254885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254887 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254899 */     GIR_RootConstrainSelectedInstOperands,
     /* 254900 */     // GIR_Coverage, 2152,
     /* 254900 */     GIR_EraseRootFromParent_Done,
     /* 254901 */   // Label 5108: @254901
     /* 254901 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(254951), // Rule ID 6253 //
     /* 254906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254923 */     // MIs[1] imm
     /* 254923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254935 */     // MIs[2] Operand 1
     /* 254935 */     // No operand predicates
     /* 254935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254937 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 254937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254949 */     GIR_RootConstrainSelectedInstOperands,
     /* 254950 */     // GIR_Coverage, 6253,
     /* 254950 */     GIR_EraseRootFromParent_Done,
     /* 254951 */   // Label 5109: @254951
     /* 254951 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255002), // Rule ID 5510 //
     /* 254956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254964 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254987 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 254987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 254990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 254996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 255000 */     GIR_RootConstrainSelectedInstOperands,
     /* 255001 */     // GIR_Coverage, 5510,
     /* 255001 */     GIR_EraseRootFromParent_Done,
     /* 255002 */   // Label 5110: @255002
     /* 255002 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255021), // Rule ID 1091 //
     /* 255007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255014 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 255014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 255019 */     GIR_RootConstrainSelectedInstOperands,
     /* 255020 */     // GIR_Coverage, 1091,
     /* 255020 */     GIR_Done,
     /* 255021 */   // Label 5111: @255021
     /* 255021 */   GIM_Reject,
     /* 255022 */ // Label 5103: @255022
     /* 255022 */ GIM_Reject,
     /* 255023 */ // Label 5093: @255023
     /* 255023 */ GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255521),
     /* 255028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255035 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255113), // Rule ID 5354 //
     /* 255040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 255048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 255056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 255060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 255077 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 255083 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 255085 */     // MIs[1] Operand 2
     /* 255085 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 255096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 255098 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 255098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 255101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 255107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 255111 */     GIR_RootConstrainSelectedInstOperands,
     /* 255112 */     // GIR_Coverage, 5354,
     /* 255112 */     GIR_EraseRootFromParent_Done,
     /* 255113 */   // Label 5113: @255113
     /* 255113 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255184), // Rule ID 5350 //
     /* 255118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 255126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 255134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 255138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255156 */     // MIs[1] Operand 2
     /* 255156 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 255167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 255169 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 255169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 255172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 255178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 255182 */     GIR_RootConstrainSelectedInstOperands,
     /* 255183 */     // GIR_Coverage, 5350,
     /* 255183 */     GIR_EraseRootFromParent_Done,
     /* 255184 */   // Label 5114: @255184
     /* 255184 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255255), // Rule ID 5352 //
     /* 255189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 255197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 255205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 255209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255227 */     // MIs[1] Operand 2
     /* 255227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 255238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 255240 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 255240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 255243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 255249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 255253 */     GIR_RootConstrainSelectedInstOperands,
     /* 255254 */     // GIR_Coverage, 5352,
     /* 255254 */     GIR_EraseRootFromParent_Done,
     /* 255255 */   // Label 5115: @255255
     /* 255255 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255347), // Rule ID 5455 //
     /* 255260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 255268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 255275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 255283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 255287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 255291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 255300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 255304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 255308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 255315 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 255315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 255318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 255322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 255331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 255335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 255340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255345 */     GIR_RootConstrainSelectedInstOperands,
     /* 255346 */     // GIR_Coverage, 5455,
     /* 255346 */     GIR_EraseRootFromParent_Done,
     /* 255347 */   // Label 5116: @255347
     /* 255347 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255400), // Rule ID 2151 //
     /* 255352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 255363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255372 */     // MIs[1] imm
     /* 255372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 255376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 255384 */     // MIs[2] Operand 1
     /* 255384 */     // No operand predicates
     /* 255384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 255386 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 255386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 255389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 255395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 255398 */     GIR_RootConstrainSelectedInstOperands,
     /* 255399 */     // GIR_Coverage, 2151,
     /* 255399 */     GIR_EraseRootFromParent_Done,
     /* 255400 */   // Label 5117: @255400
     /* 255400 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255450), // Rule ID 6252 //
     /* 255405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 255413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 255417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255422 */     // MIs[1] imm
     /* 255422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 255426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255430 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 255434 */     // MIs[2] Operand 1
     /* 255434 */     // No operand predicates
     /* 255434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 255436 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 255436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 255439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 255445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 255448 */     GIR_RootConstrainSelectedInstOperands,
     /* 255449 */     // GIR_Coverage, 6252,
     /* 255449 */     GIR_EraseRootFromParent_Done,
     /* 255450 */   // Label 5118: @255450
     /* 255450 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255501), // Rule ID 5509 //
     /* 255455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 255463 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 255470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255486 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 255486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 255489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 255495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 255499 */     GIR_RootConstrainSelectedInstOperands,
     /* 255500 */     // GIR_Coverage, 5509,
     /* 255500 */     GIR_EraseRootFromParent_Done,
     /* 255501 */   // Label 5119: @255501
     /* 255501 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255520), // Rule ID 1090 //
     /* 255506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255513 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 255513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 255518 */     GIR_RootConstrainSelectedInstOperands,
     /* 255519 */     // GIR_Coverage, 1090,
     /* 255519 */     GIR_Done,
     /* 255520 */   // Label 5120: @255520
     /* 255520 */   GIM_Reject,
     /* 255521 */ // Label 5112: @255521
     /* 255521 */ GIM_Reject,
     /* 255522 */ // Label 5094: @255522
     /* 255522 */ GIM_Reject,
     /* 255523 */ // Label 36: @255523
     /* 255523 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5123*/ GIMT_Encode4(255642),
     /* 255534 */ /*GILLT_s32*//*Label 5121*/ GIMT_Encode4(255542),
     /* 255538 */ /*GILLT_s64*//*Label 5122*/ GIMT_Encode4(255562),
     /* 255542 */ // Label 5121: @255542
     /* 255542 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(255561), // Rule ID 81 //
     /* 255547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255551 */   // MIs[0] Operand 1
     /* 255551 */   // No operand predicates
     /* 255551 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 255551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255556 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255559 */   GIR_RootConstrainSelectedInstOperands,
     /* 255560 */   // GIR_Coverage, 81,
     /* 255560 */   GIR_EraseRootFromParent_Done,
     /* 255561 */ // Label 5124: @255561
     /* 255561 */ GIM_Reject,
     /* 255562 */ // Label 5122: @255562
     /* 255562 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(255622), // Rule ID 3847 //
     /* 255567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 255570 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 255574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255578 */   // MIs[0] Operand 1
     /* 255578 */   // No operand predicates
     /* 255578 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 255578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255590 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 255595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 255600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 255611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255621 */   // GIR_Coverage, 3847,
     /* 255621 */   GIR_EraseRootFromParent_Done,
     /* 255622 */ // Label 5125: @255622
     /* 255622 */ GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(255641), // Rule ID 82 //
     /* 255627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255631 */   // MIs[0] Operand 1
     /* 255631 */   // No operand predicates
     /* 255631 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 255631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 255634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255636 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255639 */   GIR_RootConstrainSelectedInstOperands,
     /* 255640 */   // GIR_Coverage, 82,
     /* 255640 */   GIR_EraseRootFromParent_Done,
     /* 255641 */ // Label 5126: @255641
     /* 255641 */ GIM_Reject,
     /* 255642 */ // Label 5123: @255642
     /* 255642 */ GIM_Reject,
     /* 255643 */ // Label 37: @255643
     /* 255643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5130*/ GIMT_Encode4(255883),
     /* 255654 */ /*GILLT_s16*//*Label 5127*/ GIMT_Encode4(255666),
     /* 255658 */ /*GILLT_s32*//*Label 5128*/ GIMT_Encode4(255718),
     /* 255662 */ /*GILLT_s64*//*Label 5129*/ GIMT_Encode4(255831),
     /* 255666 */ // Label 5127: @255666
     /* 255666 */ GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(255689), // Rule ID 506 //
     /* 255671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255674 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255682 */   // MIs[0] Operand 1
     /* 255682 */   // No operand predicates
     /* 255682 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 255682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 255685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255687 */   GIR_RootConstrainSelectedInstOperands,
     /* 255688 */   // GIR_Coverage, 506,
     /* 255688 */   GIR_EraseRootFromParent_Done,
     /* 255689 */ // Label 5131: @255689
     /* 255689 */ GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(255717), // Rule ID 688 //
     /* 255694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 255697 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 255701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255705 */   // MIs[0] Operand 1
     /* 255705 */   // No operand predicates
     /* 255705 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 255705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 255708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255710 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 255715 */   GIR_RootConstrainSelectedInstOperands,
     /* 255716 */   // GIR_Coverage, 688,
     /* 255716 */   GIR_EraseRootFromParent_Done,
     /* 255717 */ // Label 5132: @255717
     /* 255717 */ GIM_Reject,
     /* 255718 */ // Label 5128: @255718
     /* 255718 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(255741), // Rule ID 507 //
     /* 255723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255726 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255734 */   // MIs[0] Operand 1
     /* 255734 */   // No operand predicates
     /* 255734 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 255734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 255737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255739 */   GIR_RootConstrainSelectedInstOperands,
     /* 255740 */   // GIR_Coverage, 507,
     /* 255740 */   GIR_EraseRootFromParent_Done,
     /* 255741 */ // Label 5133: @255741
     /* 255741 */ GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(255769), // Rule ID 689 //
     /* 255746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255749 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 255753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255757 */   // MIs[0] Operand 1
     /* 255757 */   // No operand predicates
     /* 255757 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 255757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 255760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255762 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 255767 */   GIR_RootConstrainSelectedInstOperands,
     /* 255768 */   // GIR_Coverage, 689,
     /* 255768 */   GIR_EraseRootFromParent_Done,
     /* 255769 */ // Label 5134: @255769
     /* 255769 */ GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(255830), // Rule ID 5933 //
     /* 255774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255777 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 255781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255785 */   // MIs[0] Operand 1
     /* 255785 */   // No operand predicates
     /* 255785 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 255785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 255788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 255792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255797 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 255802 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 255805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255812 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 255819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255829 */   // GIR_Coverage, 5933,
     /* 255829 */   GIR_EraseRootFromParent_Done,
     /* 255830 */ // Label 5135: @255830
     /* 255830 */ GIM_Reject,
     /* 255831 */ // Label 5129: @255831
     /* 255831 */ GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(255854), // Rule ID 508 //
     /* 255836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255839 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255847 */   // MIs[0] Operand 1
     /* 255847 */   // No operand predicates
     /* 255847 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 255847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 255850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255852 */   GIR_RootConstrainSelectedInstOperands,
     /* 255853 */   // GIR_Coverage, 508,
     /* 255853 */   GIR_EraseRootFromParent_Done,
     /* 255854 */ // Label 5136: @255854
     /* 255854 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(255882), // Rule ID 690 //
     /* 255859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255862 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 255866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255870 */   // MIs[0] Operand 1
     /* 255870 */   // No operand predicates
     /* 255870 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 255870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 255873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255875 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 255880 */   GIR_RootConstrainSelectedInstOperands,
     /* 255881 */   // GIR_Coverage, 690,
     /* 255881 */   GIR_EraseRootFromParent_Done,
     /* 255882 */ // Label 5137: @255882
     /* 255882 */ GIM_Reject,
     /* 255883 */ // Label 5130: @255883
     /* 255883 */ GIM_Reject,
     /* 255884 */ // Label 38: @255884
     /* 255884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5143*/ GIMT_Encode4(257781),
     /* 255895 */ /*GILLT_s32*//*Label 5138*/ GIMT_Encode4(255931),
     /* 255899 */ /*GILLT_s64*//*Label 5139*/ GIMT_Encode4(257372), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 255911 */ /*GILLT_v2s64*//*Label 5140*/ GIMT_Encode4(257595), GIMT_Encode4(0),
     /* 255919 */ /*GILLT_v4s32*//*Label 5141*/ GIMT_Encode4(257657), GIMT_Encode4(0),
     /* 255927 */ /*GILLT_v8s16*//*Label 5142*/ GIMT_Encode4(257719),
     /* 255931 */ // Label 5138: @255931
     /* 255931 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(256051), // Rule ID 12868 //
     /* 255936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255943 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255951 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255954 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255959 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255963 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255970 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255970 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 255973 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 255977 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255982 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255988 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255991 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255995 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256014 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256017 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256020 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256028 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256033 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256049 */   GIR_RootConstrainSelectedInstOperands,
     /* 256050 */   // GIR_Coverage, 12868,
     /* 256050 */   GIR_EraseRootFromParent_Done,
     /* 256051 */ // Label 5144: @256051
     /* 256051 */ GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(256171), // Rule ID 12870 //
     /* 256056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256063 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256071 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256074 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 256079 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256083 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256090 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 256097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256102 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256134 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256140 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256169 */   GIR_RootConstrainSelectedInstOperands,
     /* 256170 */   // GIR_Coverage, 12870,
     /* 256170 */   GIR_EraseRootFromParent_Done,
     /* 256171 */ // Label 5145: @256171
     /* 256171 */ GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(256291), // Rule ID 12872 //
     /* 256176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256183 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256191 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256194 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 256199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256210 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256210 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256213 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 256217 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256222 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256228 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256231 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256235 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256254 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256257 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256260 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256263 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256289 */   GIR_RootConstrainSelectedInstOperands,
     /* 256290 */   // GIR_Coverage, 12872,
     /* 256290 */   GIR_EraseRootFromParent_Done,
     /* 256291 */ // Label 5146: @256291
     /* 256291 */ GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(256411), // Rule ID 12874 //
     /* 256296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256303 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256311 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256314 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 256319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256323 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256330 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256330 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256333 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 256337 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256342 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256348 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256351 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256355 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256374 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256380 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256393 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256409 */   GIR_RootConstrainSelectedInstOperands,
     /* 256410 */   // GIR_Coverage, 12874,
     /* 256410 */   GIR_EraseRootFromParent_Done,
     /* 256411 */ // Label 5147: @256411
     /* 256411 */ GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(256531), // Rule ID 12890 //
     /* 256416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256423 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256431 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256434 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256450 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256450 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256453 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 256457 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256462 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256468 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256471 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256475 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256497 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256500 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256529 */   GIR_RootConstrainSelectedInstOperands,
     /* 256530 */   // GIR_Coverage, 12890,
     /* 256530 */   GIR_EraseRootFromParent_Done,
     /* 256531 */ // Label 5148: @256531
     /* 256531 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(256651), // Rule ID 12892 //
     /* 256536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256551 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256554 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256570 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256570 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256573 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 256577 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256582 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256588 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256591 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256595 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256614 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256617 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256620 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256623 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256649 */   GIR_RootConstrainSelectedInstOperands,
     /* 256650 */   // GIR_Coverage, 12892,
     /* 256650 */   GIR_EraseRootFromParent_Done,
     /* 256651 */ // Label 5149: @256651
     /* 256651 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(256771), // Rule ID 12894 //
     /* 256656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256671 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256674 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256688 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256690 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256690 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256693 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 256697 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256702 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256708 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256711 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256715 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256734 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256737 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256740 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256769 */   GIR_RootConstrainSelectedInstOperands,
     /* 256770 */   // GIR_Coverage, 12894,
     /* 256770 */   GIR_EraseRootFromParent_Done,
     /* 256771 */ // Label 5150: @256771
     /* 256771 */ GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(256891), // Rule ID 12896 //
     /* 256776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256783 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256791 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256794 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256799 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256803 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256810 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256810 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256813 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 256817 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256822 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256828 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256831 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256835 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256854 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256857 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256860 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256863 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256889 */   GIR_RootConstrainSelectedInstOperands,
     /* 256890 */   // GIR_Coverage, 12896,
     /* 256890 */   GIR_EraseRootFromParent_Done,
     /* 256891 */ // Label 5151: @256891
     /* 256891 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257011), // Rule ID 12900 //
     /* 256896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256903 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256911 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256914 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256919 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256923 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256930 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256930 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256933 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 256937 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256942 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256948 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256951 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256955 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256974 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256977 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256980 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257009 */   GIR_RootConstrainSelectedInstOperands,
     /* 257010 */   // GIR_Coverage, 12900,
     /* 257010 */   GIR_EraseRootFromParent_Done,
     /* 257011 */ // Label 5152: @257011
     /* 257011 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257131), // Rule ID 12902 //
     /* 257016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 257019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257023 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 257031 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257034 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 257039 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257043 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257050 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 257050 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 257053 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 257057 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257062 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 257066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 257068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 257071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 257085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257094 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 257100 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 257103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 257118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257129 */   GIR_RootConstrainSelectedInstOperands,
     /* 257130 */   // GIR_Coverage, 12902,
     /* 257130 */   GIR_EraseRootFromParent_Done,
     /* 257131 */ // Label 5153: @257131
     /* 257131 */ GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257251), // Rule ID 12904 //
     /* 257136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 257139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257143 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 257151 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257154 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 257159 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257163 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257170 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 257170 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 257173 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 257177 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257182 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 257186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 257188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 257191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 257205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257214 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257217 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 257220 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 257223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 257238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257249 */   GIR_RootConstrainSelectedInstOperands,
     /* 257250 */   // GIR_Coverage, 12904,
     /* 257250 */   GIR_EraseRootFromParent_Done,
     /* 257251 */ // Label 5154: @257251
     /* 257251 */ GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257371), // Rule ID 12906 //
     /* 257256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 257259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257263 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 257271 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 257274 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 257279 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257283 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 257290 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 257290 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 257293 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 257297 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257302 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 257306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 257308 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 257311 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257315 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 257325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257337 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 257340 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 257343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 257358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257369 */   GIR_RootConstrainSelectedInstOperands,
     /* 257370 */   // GIR_Coverage, 12906,
     /* 257370 */   GIR_EraseRootFromParent_Done,
     /* 257371 */ // Label 5155: @257371
     /* 257371 */ GIM_Reject,
     /* 257372 */ // Label 5139: @257372
     /* 257372 */ GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257594),
     /* 257377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 257380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257384 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257438), // Rule ID 5587 //
     /* 257389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 257401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257418 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257422 */     // MIs[2] Operand 1
     /* 257422 */     // No operand predicates
     /* 257422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257424 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 257424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 257427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257436 */     GIR_RootConstrainSelectedInstOperands,
     /* 257437 */     // GIR_Coverage, 5587,
     /* 257437 */     GIR_EraseRootFromParent_Done,
     /* 257438 */   // Label 5157: @257438
     /* 257438 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257517), // Rule ID 11066 //
     /* 257443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257474 */     // MIs[2] Operand 1
     /* 257474 */     // No operand predicates
     /* 257474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257476 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 257476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 257479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257488 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 257507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257515 */     GIR_RootConstrainSelectedInstOperands,
     /* 257516 */     // GIR_Coverage, 11066,
     /* 257516 */     GIR_EraseRootFromParent_Done,
     /* 257517 */   // Label 5158: @257517
     /* 257517 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257593), // Rule ID 6409 //
     /* 257522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257526 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 257526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 257529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 257543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257552 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 257559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 257562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 257580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 257591 */     GIR_RootConstrainSelectedInstOperands,
     /* 257592 */     // GIR_Coverage, 6409,
     /* 257592 */     GIR_EraseRootFromParent_Done,
     /* 257593 */   // Label 5159: @257593
     /* 257593 */   GIM_Reject,
     /* 257594 */ // Label 5156: @257594
     /* 257594 */ GIM_Reject,
     /* 257595 */ // Label 5140: @257595
     /* 257595 */ GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257656),
     /* 257600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 257603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257607 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257634), // Rule ID 6281 //
     /* 257612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 257619 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 257619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 257622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257632 */     GIR_RootConstrainSelectedInstOperands,
     /* 257633 */     // GIR_Coverage, 6281,
     /* 257633 */     GIR_EraseRootFromParent_Done,
     /* 257634 */   // Label 5161: @257634
     /* 257634 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257655), // Rule ID 6270 //
     /* 257639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257643 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 257643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 257646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257653 */     GIR_RootConstrainSelectedInstOperands,
     /* 257654 */     // GIR_Coverage, 6270,
     /* 257654 */     GIR_EraseRootFromParent_Done,
     /* 257655 */   // Label 5162: @257655
     /* 257655 */   GIM_Reject,
     /* 257656 */ // Label 5160: @257656
     /* 257656 */ GIM_Reject,
     /* 257657 */ // Label 5141: @257657
     /* 257657 */ GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257718),
     /* 257662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 257665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257669 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(257696), // Rule ID 6278 //
     /* 257674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 257681 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 257681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 257684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257694 */     GIR_RootConstrainSelectedInstOperands,
     /* 257695 */     // GIR_Coverage, 6278,
     /* 257695 */     GIR_EraseRootFromParent_Done,
     /* 257696 */   // Label 5164: @257696
     /* 257696 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(257717), // Rule ID 6267 //
     /* 257701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257705 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 257705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 257708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257715 */     GIR_RootConstrainSelectedInstOperands,
     /* 257716 */     // GIR_Coverage, 6267,
     /* 257716 */     GIR_EraseRootFromParent_Done,
     /* 257717 */   // Label 5165: @257717
     /* 257717 */   GIM_Reject,
     /* 257718 */ // Label 5163: @257718
     /* 257718 */ GIM_Reject,
     /* 257719 */ // Label 5142: @257719
     /* 257719 */ GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(257780),
     /* 257724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 257727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257731 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(257758), // Rule ID 6275 //
     /* 257736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 257743 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 257743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 257746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257756 */     GIR_RootConstrainSelectedInstOperands,
     /* 257757 */     // GIR_Coverage, 6275,
     /* 257757 */     GIR_EraseRootFromParent_Done,
     /* 257758 */   // Label 5167: @257758
     /* 257758 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(257779), // Rule ID 6264 //
     /* 257763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257767 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 257767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 257770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257777 */     GIR_RootConstrainSelectedInstOperands,
     /* 257778 */     // GIR_Coverage, 6264,
     /* 257778 */     GIR_EraseRootFromParent_Done,
     /* 257779 */   // Label 5168: @257779
     /* 257779 */   GIM_Reject,
     /* 257780 */ // Label 5166: @257780
     /* 257780 */ GIM_Reject,
     /* 257781 */ // Label 5143: @257781
     /* 257781 */ GIM_Reject,
     /* 257782 */ // Label 39: @257782
     /* 257782 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5174*/ GIMT_Encode4(259435),
     /* 257793 */ /*GILLT_s32*//*Label 5169*/ GIMT_Encode4(257873),
     /* 257797 */ /*GILLT_s64*//*Label 5170*/ GIMT_Encode4(258367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257849 */ /*GILLT_nxv2s64*//*Label 5171*/ GIMT_Encode4(259009), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257861 */ /*GILLT_nxv4s32*//*Label 5172*/ GIMT_Encode4(259218), GIMT_Encode4(0),
     /* 257869 */ /*GILLT_nxv8s16*//*Label 5173*/ GIMT_Encode4(259362),
     /* 257873 */ // Label 5169: @257873
     /* 257873 */ GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258366),
     /* 257878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 257881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257885 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(257950), // Rule ID 5582 //
     /* 257890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 257902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257923 */     // MIs[2] Operand 1
     /* 257923 */     // No operand predicates
     /* 257923 */     // MIs[0] Operand 2
     /* 257923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257936 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 257936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257948 */     GIR_RootConstrainSelectedInstOperands,
     /* 257949 */     // GIR_Coverage, 5582,
     /* 257949 */     GIR_EraseRootFromParent_Done,
     /* 257950 */   // Label 5176: @257950
     /* 257950 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258015), // Rule ID 5584 //
     /* 257955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257988 */     // MIs[2] Operand 1
     /* 257988 */     // No operand predicates
     /* 257988 */     // MIs[0] Operand 2
     /* 257988 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258001 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258013 */     GIR_RootConstrainSelectedInstOperands,
     /* 258014 */     // GIR_Coverage, 5584,
     /* 258014 */     GIR_EraseRootFromParent_Done,
     /* 258015 */   // Label 5177: @258015
     /* 258015 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258080), // Rule ID 5586 //
     /* 258020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258049 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258053 */     // MIs[2] Operand 1
     /* 258053 */     // No operand predicates
     /* 258053 */     // MIs[0] Operand 2
     /* 258053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258066 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258078 */     GIR_RootConstrainSelectedInstOperands,
     /* 258079 */     // GIR_Coverage, 5586,
     /* 258079 */     GIR_EraseRootFromParent_Done,
     /* 258080 */   // Label 5178: @258080
     /* 258080 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258170), // Rule ID 11062 //
     /* 258085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 258100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258116 */     // MIs[2] Operand 1
     /* 258116 */     // No operand predicates
     /* 258116 */     // MIs[0] Operand 2
     /* 258116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258129 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 258129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258141 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 258160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 258168 */     GIR_RootConstrainSelectedInstOperands,
     /* 258169 */     // GIR_Coverage, 11062,
     /* 258169 */     GIR_EraseRootFromParent_Done,
     /* 258170 */   // Label 5179: @258170
     /* 258170 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(258260), // Rule ID 11064 //
     /* 258175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258202 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258206 */     // MIs[2] Operand 1
     /* 258206 */     // No operand predicates
     /* 258206 */     // MIs[0] Operand 2
     /* 258206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258219 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 258219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 258222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258231 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 258250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 258258 */     GIR_RootConstrainSelectedInstOperands,
     /* 258259 */     // GIR_Coverage, 11064,
     /* 258259 */     GIR_EraseRootFromParent_Done,
     /* 258260 */   // Label 5180: @258260
     /* 258260 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(258295), // Rule ID 6414 //
     /* 258265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258269 */     // MIs[0] Operand 2
     /* 258269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258280 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 258280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 258283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 258293 */     GIR_RootConstrainSelectedInstOperands,
     /* 258294 */     // GIR_Coverage, 6414,
     /* 258294 */     GIR_EraseRootFromParent_Done,
     /* 258295 */   // Label 5181: @258295
     /* 258295 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(258330), // Rule ID 6415 //
     /* 258300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258304 */     // MIs[0] Operand 2
     /* 258304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258315 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 258315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 258318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 258328 */     GIR_RootConstrainSelectedInstOperands,
     /* 258329 */     // GIR_Coverage, 6415,
     /* 258329 */     GIR_EraseRootFromParent_Done,
     /* 258330 */   // Label 5182: @258330
     /* 258330 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(258365), // Rule ID 6416 //
     /* 258335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258339 */     // MIs[0] Operand 2
     /* 258339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 258350 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 258350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 258353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258363 */     GIR_RootConstrainSelectedInstOperands,
     /* 258364 */     // GIR_Coverage, 6416,
     /* 258364 */     GIR_EraseRootFromParent_Done,
     /* 258365 */   // Label 5183: @258365
     /* 258365 */   GIM_Reject,
     /* 258366 */ // Label 5175: @258366
     /* 258366 */ GIM_Reject,
     /* 258367 */ // Label 5170: @258367
     /* 258367 */ GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259008),
     /* 258372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 258375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258379 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(258456), // Rule ID 5588 //
     /* 258384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 258408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258429 */     // MIs[3] Operand 1
     /* 258429 */     // No operand predicates
     /* 258429 */     // MIs[0] Operand 2
     /* 258429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258442 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 258442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258454 */     GIR_RootConstrainSelectedInstOperands,
     /* 258455 */     // GIR_Coverage, 5588,
     /* 258455 */     GIR_EraseRootFromParent_Done,
     /* 258456 */   // Label 5185: @258456
     /* 258456 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(258533), // Rule ID 5589 //
     /* 258461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258502 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258506 */     // MIs[3] Operand 1
     /* 258506 */     // No operand predicates
     /* 258506 */     // MIs[0] Operand 2
     /* 258506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258519 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258531 */     GIR_RootConstrainSelectedInstOperands,
     /* 258532 */     // GIR_Coverage, 5589,
     /* 258532 */     GIR_EraseRootFromParent_Done,
     /* 258533 */   // Label 5186: @258533
     /* 258533 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(258635), // Rule ID 11063 //
     /* 258538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 258565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258577 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258581 */     // MIs[3] Operand 1
     /* 258581 */     // No operand predicates
     /* 258581 */     // MIs[0] Operand 2
     /* 258581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258594 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 258594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258633 */     GIR_RootConstrainSelectedInstOperands,
     /* 258634 */     // GIR_Coverage, 11063,
     /* 258634 */     GIR_EraseRootFromParent_Done,
     /* 258635 */   // Label 5187: @258635
     /* 258635 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(258737), // Rule ID 11065 //
     /* 258640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258683 */     // MIs[3] Operand 1
     /* 258683 */     // No operand predicates
     /* 258683 */     // MIs[0] Operand 2
     /* 258683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258696 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 258696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 258699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258708 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258735 */     GIR_RootConstrainSelectedInstOperands,
     /* 258736 */     // GIR_Coverage, 11065,
     /* 258736 */     GIR_EraseRootFromParent_Done,
     /* 258737 */   // Label 5188: @258737
     /* 258737 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(258802), // Rule ID 5583 //
     /* 258742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 258754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258775 */     // MIs[2] Operand 1
     /* 258775 */     // No operand predicates
     /* 258775 */     // MIs[0] Operand 2
     /* 258775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258788 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 258788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258800 */     GIR_RootConstrainSelectedInstOperands,
     /* 258801 */     // GIR_Coverage, 5583,
     /* 258801 */     GIR_EraseRootFromParent_Done,
     /* 258802 */   // Label 5189: @258802
     /* 258802 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(258867), // Rule ID 5585 //
     /* 258807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258840 */     // MIs[2] Operand 1
     /* 258840 */     // No operand predicates
     /* 258840 */     // MIs[0] Operand 2
     /* 258840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258853 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258865 */     GIR_RootConstrainSelectedInstOperands,
     /* 258866 */     // GIR_Coverage, 5585,
     /* 258866 */     GIR_EraseRootFromParent_Done,
     /* 258867 */   // Label 5190: @258867
     /* 258867 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(258902), // Rule ID 6410 //
     /* 258872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258876 */     // MIs[0] Operand 2
     /* 258876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 258887 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 258887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 258900 */     GIR_RootConstrainSelectedInstOperands,
     /* 258901 */     // GIR_Coverage, 6410,
     /* 258901 */     GIR_EraseRootFromParent_Done,
     /* 258902 */   // Label 5191: @258902
     /* 258902 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(258937), // Rule ID 6411 //
     /* 258907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258911 */     // MIs[0] Operand 2
     /* 258911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258922 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 258922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 258935 */     GIR_RootConstrainSelectedInstOperands,
     /* 258936 */     // GIR_Coverage, 6411,
     /* 258936 */     GIR_EraseRootFromParent_Done,
     /* 258937 */   // Label 5192: @258937
     /* 258937 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(258972), // Rule ID 6412 //
     /* 258942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258946 */     // MIs[0] Operand 2
     /* 258946 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258957 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 258957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 258970 */     GIR_RootConstrainSelectedInstOperands,
     /* 258971 */     // GIR_Coverage, 6412,
     /* 258971 */     GIR_EraseRootFromParent_Done,
     /* 258972 */   // Label 5193: @258972
     /* 258972 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259007), // Rule ID 6413 //
     /* 258977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258981 */     // MIs[0] Operand 2
     /* 258981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 258992 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 258992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259005 */     GIR_RootConstrainSelectedInstOperands,
     /* 259006 */     // GIR_Coverage, 6413,
     /* 259006 */     GIR_EraseRootFromParent_Done,
     /* 259007 */   // Label 5194: @259007
     /* 259007 */   GIM_Reject,
     /* 259008 */ // Label 5184: @259008
     /* 259008 */ GIM_Reject,
     /* 259009 */ // Label 5171: @259009
     /* 259009 */ GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259217),
     /* 259014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 259017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259021 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(259086), // Rule ID 10346 //
     /* 259026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259029 */     // MIs[0] Operand 2
     /* 259029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 259040 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 259040 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259043 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 259047 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259052 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 259074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259084 */     GIR_RootConstrainSelectedInstOperands,
     /* 259085 */     // GIR_Coverage, 10346,
     /* 259085 */     GIR_EraseRootFromParent_Done,
     /* 259086 */   // Label 5196: @259086
     /* 259086 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(259151), // Rule ID 10347 //
     /* 259091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259094 */     // MIs[0] Operand 2
     /* 259094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 259105 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 259105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 259112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259117 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 259139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259149 */     GIR_RootConstrainSelectedInstOperands,
     /* 259150 */     // GIR_Coverage, 10347,
     /* 259150 */     GIR_EraseRootFromParent_Done,
     /* 259151 */   // Label 5197: @259151
     /* 259151 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(259216), // Rule ID 10348 //
     /* 259156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259159 */     // MIs[0] Operand 2
     /* 259159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 259170 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 259170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 259177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259182 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 259204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259214 */     GIR_RootConstrainSelectedInstOperands,
     /* 259215 */     // GIR_Coverage, 10348,
     /* 259215 */     GIR_EraseRootFromParent_Done,
     /* 259216 */   // Label 5198: @259216
     /* 259216 */   GIM_Reject,
     /* 259217 */ // Label 5195: @259217
     /* 259217 */ GIM_Reject,
     /* 259218 */ // Label 5172: @259218
     /* 259218 */ GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(259361),
     /* 259223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 259226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259230 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(259295), // Rule ID 10349 //
     /* 259235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259238 */     // MIs[0] Operand 2
     /* 259238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 259249 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 259249 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259252 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 259256 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 259283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259293 */     GIR_RootConstrainSelectedInstOperands,
     /* 259294 */     // GIR_Coverage, 10349,
     /* 259294 */     GIR_EraseRootFromParent_Done,
     /* 259295 */   // Label 5200: @259295
     /* 259295 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(259360), // Rule ID 10350 //
     /* 259300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259303 */     // MIs[0] Operand 2
     /* 259303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 259314 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 259314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 259321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259326 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 259348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259358 */     GIR_RootConstrainSelectedInstOperands,
     /* 259359 */     // GIR_Coverage, 10350,
     /* 259359 */     GIR_EraseRootFromParent_Done,
     /* 259360 */   // Label 5201: @259360
     /* 259360 */   GIM_Reject,
     /* 259361 */ // Label 5199: @259361
     /* 259361 */ GIM_Reject,
     /* 259362 */ // Label 5173: @259362
     /* 259362 */ GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(259434), // Rule ID 10351 //
     /* 259367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 259373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259377 */   // MIs[0] Operand 2
     /* 259377 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 259388 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 259388 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 259391 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 259395 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259400 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 259403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 259408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 259422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259430 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259432 */   GIR_RootConstrainSelectedInstOperands,
     /* 259433 */   // GIR_Coverage, 10351,
     /* 259433 */   GIR_EraseRootFromParent_Done,
     /* 259434 */ // Label 5202: @259434
     /* 259434 */ GIM_Reject,
     /* 259435 */ // Label 5174: @259435
     /* 259435 */ GIM_Reject,
     /* 259436 */ // Label 40: @259436
     /* 259436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5207*/ GIMT_Encode4(262214),
     /* 259447 */ /*GILLT_s32*//*Label 5203*/ GIMT_Encode4(259483), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259463 */ /*GILLT_v2s64*//*Label 5204*/ GIMT_Encode4(261284), GIMT_Encode4(0),
     /* 259471 */ /*GILLT_v4s32*//*Label 5205*/ GIMT_Encode4(261594), GIMT_Encode4(0),
     /* 259479 */ /*GILLT_v8s16*//*Label 5206*/ GIMT_Encode4(261904),
     /* 259483 */ // Label 5203: @259483
     /* 259483 */ GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(259633), // Rule ID 12877 //
     /* 259488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259495 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259503 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259506 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259515 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259522 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259522 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259525 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 259529 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259534 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259540 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259543 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259547 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259566 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259569 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259572 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259575 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259580 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259585 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259590 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259593 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259597 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259602 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259614 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259632 */   // GIR_Coverage, 12877,
     /* 259632 */   GIR_EraseRootFromParent_Done,
     /* 259633 */ // Label 5208: @259633
     /* 259633 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(259783), // Rule ID 12879 //
     /* 259638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259645 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259653 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259656 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259661 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259672 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259672 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259675 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 259679 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259684 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259690 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259693 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259697 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259716 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259719 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259722 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259725 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259730 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259735 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259752 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259782 */   // GIR_Coverage, 12879,
     /* 259782 */   GIR_EraseRootFromParent_Done,
     /* 259783 */ // Label 5209: @259783
     /* 259783 */ GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(259933), // Rule ID 12881 //
     /* 259788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259795 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259803 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259806 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259811 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259815 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259822 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259822 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259825 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 259829 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259834 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259840 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259843 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259847 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259854 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259857 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259861 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259866 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259869 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259872 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 259875 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259880 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259885 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259902 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259927 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259932 */   // GIR_Coverage, 12881,
     /* 259932 */   GIR_EraseRootFromParent_Done,
     /* 259933 */ // Label 5210: @259933
     /* 259933 */ GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260083), // Rule ID 12883 //
     /* 259938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259945 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259953 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259956 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259965 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259972 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259972 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259975 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 259979 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259984 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259990 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259993 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259997 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260004 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260007 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260011 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260016 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260019 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260022 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260025 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260030 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260035 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260052 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260082 */   // GIR_Coverage, 12883,
     /* 260082 */   GIR_EraseRootFromParent_Done,
     /* 260083 */ // Label 5211: @260083
     /* 260083 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(260233), // Rule ID 12910 //
     /* 260088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260095 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260103 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260106 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 260115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260122 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260122 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260125 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 260129 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260134 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260140 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260143 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260147 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260154 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260157 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260161 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260166 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260169 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260172 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260175 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260180 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260185 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260202 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260209 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260232 */   // GIR_Coverage, 12910,
     /* 260232 */   GIR_EraseRootFromParent_Done,
     /* 260233 */ // Label 5212: @260233
     /* 260233 */ GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(260383), // Rule ID 12912 //
     /* 260238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260245 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260253 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260256 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260261 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260265 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260272 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260272 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260275 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 260279 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260284 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260290 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260293 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260297 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260304 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260307 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260311 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260316 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260319 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260322 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260325 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260330 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260335 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260352 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260364 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260382 */   // GIR_Coverage, 12912,
     /* 260382 */   GIR_EraseRootFromParent_Done,
     /* 260383 */ // Label 5213: @260383
     /* 260383 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(260533), // Rule ID 12914 //
     /* 260388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260395 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260403 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260406 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260422 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260422 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260425 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 260429 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260434 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260454 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260457 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260461 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260466 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260469 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260472 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260475 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260480 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260485 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260502 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260532 */   // GIR_Coverage, 12914,
     /* 260532 */   GIR_EraseRootFromParent_Done,
     /* 260533 */ // Label 5214: @260533
     /* 260533 */ GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(260683), // Rule ID 12916 //
     /* 260538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260545 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260553 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260556 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260572 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260572 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260575 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 260579 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260584 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260590 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260593 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260597 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260604 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260607 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260611 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260616 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260619 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260622 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260625 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260630 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260635 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260652 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260682 */   // GIR_Coverage, 12916,
     /* 260682 */   GIR_EraseRootFromParent_Done,
     /* 260683 */ // Label 5215: @260683
     /* 260683 */ GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260833), // Rule ID 12920 //
     /* 260688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260695 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260703 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260706 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260711 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 260715 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260722 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260722 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260725 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 260729 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260734 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260740 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260743 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260747 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260766 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260769 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260772 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260775 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260780 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260785 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260802 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260809 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260832 */   // GIR_Coverage, 12920,
     /* 260832 */   GIR_EraseRootFromParent_Done,
     /* 260833 */ // Label 5216: @260833
     /* 260833 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(260983), // Rule ID 12922 //
     /* 260838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260845 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260853 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260856 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260861 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260865 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260870 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260872 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260872 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260875 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 260879 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260884 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260890 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260893 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260897 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260904 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260907 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260911 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260916 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260919 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260922 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260925 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260930 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260935 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260952 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260982 */   // GIR_Coverage, 12922,
     /* 260982 */   GIR_EraseRootFromParent_Done,
     /* 260983 */ // Label 5217: @260983
     /* 260983 */ GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261133), // Rule ID 12924 //
     /* 260988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260995 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261003 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261006 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 261011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261022 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 261022 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 261025 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 261029 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261034 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 261040 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 261043 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261047 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261054 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 261057 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261061 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261066 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 261069 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 261072 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 261075 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261080 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261085 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 261090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 261093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261102 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 261109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261132 */   // GIR_Coverage, 12924,
     /* 261132 */   GIR_EraseRootFromParent_Done,
     /* 261133 */ // Label 5218: @261133
     /* 261133 */ GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261283), // Rule ID 12926 //
     /* 261138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 261141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261145 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261153 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261156 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 261161 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261172 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 261172 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 261175 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 261179 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261184 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 261190 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 261193 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261197 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 261207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261216 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 261219 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 261222 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 261225 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261230 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261235 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 261240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 261243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261252 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 261259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261282 */   // GIR_Coverage, 12926,
     /* 261282 */   GIR_EraseRootFromParent_Done,
     /* 261283 */ // Label 5219: @261283
     /* 261283 */ GIM_Reject,
     /* 261284 */ // Label 5204: @261284
     /* 261284 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261593),
     /* 261289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261296 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261361), // Rule ID 702 //
     /* 261301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261312 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261315 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261344 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 261347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261359 */     GIR_RootConstrainSelectedInstOperands,
     /* 261360 */     // GIR_Coverage, 702,
     /* 261360 */     GIR_EraseRootFromParent_Done,
     /* 261361 */   // Label 5221: @261361
     /* 261361 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261426), // Rule ID 1704 //
     /* 261366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261377 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261380 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261389 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261409 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 261412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261424 */     GIR_RootConstrainSelectedInstOperands,
     /* 261425 */     // GIR_Coverage, 1704,
     /* 261425 */     GIR_EraseRootFromParent_Done,
     /* 261426 */   // Label 5222: @261426
     /* 261426 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261485), // Rule ID 700 //
     /* 261431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261442 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261445 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261470 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 261473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261483 */     GIR_RootConstrainSelectedInstOperands,
     /* 261484 */     // GIR_Coverage, 700,
     /* 261484 */     GIR_EraseRootFromParent_Done,
     /* 261485 */   // Label 5223: @261485
     /* 261485 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261544), // Rule ID 1702 //
     /* 261490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261501 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261504 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261513 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261529 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 261532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261542 */     GIR_RootConstrainSelectedInstOperands,
     /* 261543 */     // GIR_Coverage, 1702,
     /* 261543 */     GIR_EraseRootFromParent_Done,
     /* 261544 */   // Label 5224: @261544
     /* 261544 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261571), // Rule ID 6280 //
     /* 261549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261556 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 261556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 261559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261569 */     GIR_RootConstrainSelectedInstOperands,
     /* 261570 */     // GIR_Coverage, 6280,
     /* 261570 */     GIR_EraseRootFromParent_Done,
     /* 261571 */   // Label 5225: @261571
     /* 261571 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261592), // Rule ID 6271 //
     /* 261576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261580 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 261580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 261583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261590 */     GIR_RootConstrainSelectedInstOperands,
     /* 261591 */     // GIR_Coverage, 6271,
     /* 261591 */     GIR_EraseRootFromParent_Done,
     /* 261592 */   // Label 5226: @261592
     /* 261592 */   GIM_Reject,
     /* 261593 */ // Label 5220: @261593
     /* 261593 */ GIM_Reject,
     /* 261594 */ // Label 5205: @261594
     /* 261594 */ GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261903),
     /* 261599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261606 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261671), // Rule ID 698 //
     /* 261611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261622 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261625 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261634 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261654 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 261657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261669 */     GIR_RootConstrainSelectedInstOperands,
     /* 261670 */     // GIR_Coverage, 698,
     /* 261670 */     GIR_EraseRootFromParent_Done,
     /* 261671 */   // Label 5228: @261671
     /* 261671 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261736), // Rule ID 1700 //
     /* 261676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261687 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261690 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261719 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 261722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261734 */     GIR_RootConstrainSelectedInstOperands,
     /* 261735 */     // GIR_Coverage, 1700,
     /* 261735 */     GIR_EraseRootFromParent_Done,
     /* 261736 */   // Label 5229: @261736
     /* 261736 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261795), // Rule ID 696 //
     /* 261741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261780 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 261783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261793 */     GIR_RootConstrainSelectedInstOperands,
     /* 261794 */     // GIR_Coverage, 696,
     /* 261794 */     GIR_EraseRootFromParent_Done,
     /* 261795 */   // Label 5230: @261795
     /* 261795 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261854), // Rule ID 1698 //
     /* 261800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261811 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261814 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261839 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 261842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261852 */     GIR_RootConstrainSelectedInstOperands,
     /* 261853 */     // GIR_Coverage, 1698,
     /* 261853 */     GIR_EraseRootFromParent_Done,
     /* 261854 */   // Label 5231: @261854
     /* 261854 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261881), // Rule ID 6277 //
     /* 261859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261866 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 261866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 261869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261879 */     GIR_RootConstrainSelectedInstOperands,
     /* 261880 */     // GIR_Coverage, 6277,
     /* 261880 */     GIR_EraseRootFromParent_Done,
     /* 261881 */   // Label 5232: @261881
     /* 261881 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261902), // Rule ID 6268 //
     /* 261886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261890 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 261890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 261893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261900 */     GIR_RootConstrainSelectedInstOperands,
     /* 261901 */     // GIR_Coverage, 6268,
     /* 261901 */     GIR_EraseRootFromParent_Done,
     /* 261902 */   // Label 5233: @261902
     /* 261902 */   GIM_Reject,
     /* 261903 */ // Label 5227: @261903
     /* 261903 */ GIM_Reject,
     /* 261904 */ // Label 5206: @261904
     /* 261904 */ GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(262213),
     /* 261909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 261912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261916 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261981), // Rule ID 694 //
     /* 261921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261932 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261935 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261944 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261964 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 261964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 261967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261979 */     GIR_RootConstrainSelectedInstOperands,
     /* 261980 */     // GIR_Coverage, 694,
     /* 261980 */     GIR_EraseRootFromParent_Done,
     /* 261981 */   // Label 5235: @261981
     /* 261981 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262046), // Rule ID 1696 //
     /* 261986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261997 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 262000 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 262005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262009 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 262013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 262022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 262029 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 262029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 262032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 262039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 262044 */     GIR_RootConstrainSelectedInstOperands,
     /* 262045 */     // GIR_Coverage, 1696,
     /* 262045 */     GIR_EraseRootFromParent_Done,
     /* 262046 */   // Label 5236: @262046
     /* 262046 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262105), // Rule ID 692 //
     /* 262051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262062 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 262065 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 262070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262074 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 262078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262090 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 262090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 262093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 262103 */     GIR_RootConstrainSelectedInstOperands,
     /* 262104 */     // GIR_Coverage, 692,
     /* 262104 */     GIR_EraseRootFromParent_Done,
     /* 262105 */   // Label 5237: @262105
     /* 262105 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262164), // Rule ID 1694 //
     /* 262110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262121 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 262124 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 262129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262133 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 262137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262149 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 262149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 262152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 262162 */     GIR_RootConstrainSelectedInstOperands,
     /* 262163 */     // GIR_Coverage, 1694,
     /* 262163 */     GIR_EraseRootFromParent_Done,
     /* 262164 */   // Label 5238: @262164
     /* 262164 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262191), // Rule ID 6274 //
     /* 262169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 262176 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 262176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 262179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 262186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262189 */     GIR_RootConstrainSelectedInstOperands,
     /* 262190 */     // GIR_Coverage, 6274,
     /* 262190 */     GIR_EraseRootFromParent_Done,
     /* 262191 */   // Label 5239: @262191
     /* 262191 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262212), // Rule ID 6265 //
     /* 262196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262200 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 262200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 262203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262210 */     GIR_RootConstrainSelectedInstOperands,
     /* 262211 */     // GIR_Coverage, 6265,
     /* 262211 */     GIR_EraseRootFromParent_Done,
     /* 262212 */   // Label 5240: @262212
     /* 262212 */   GIM_Reject,
     /* 262213 */ // Label 5234: @262213
     /* 262213 */ GIM_Reject,
     /* 262214 */ // Label 5207: @262214
     /* 262214 */ GIM_Reject,
     /* 262215 */ // Label 41: @262215
     /* 262215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5246*/ GIMT_Encode4(262994),
     /* 262226 */ /*GILLT_s32*//*Label 5241*/ GIMT_Encode4(262262),
     /* 262230 */ /*GILLT_s64*//*Label 5242*/ GIMT_Encode4(262394), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 262242 */ /*GILLT_v2s64*//*Label 5243*/ GIMT_Encode4(262567), GIMT_Encode4(0),
     /* 262250 */ /*GILLT_v4s32*//*Label 5244*/ GIMT_Encode4(262712), GIMT_Encode4(0),
     /* 262258 */ /*GILLT_v8s16*//*Label 5245*/ GIMT_Encode4(262853),
     /* 262262 */ // Label 5241: @262262
     /* 262262 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262393),
     /* 262267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 262270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262281 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262318), // Rule ID 3877 //
     /* 262286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 262294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262305 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 262308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262316 */     GIR_RootConstrainSelectedInstOperands,
     /* 262317 */     // GIR_Coverage, 3877,
     /* 262317 */     GIR_EraseRootFromParent_Done,
     /* 262318 */   // Label 5248: @262318
     /* 262318 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262355), // Rule ID 3878 //
     /* 262323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262342 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 262345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262353 */     GIR_RootConstrainSelectedInstOperands,
     /* 262354 */     // GIR_Coverage, 3878,
     /* 262354 */     GIR_EraseRootFromParent_Done,
     /* 262355 */   // Label 5249: @262355
     /* 262355 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262392), // Rule ID 3876 //
     /* 262360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262379 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 262382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262390 */     GIR_RootConstrainSelectedInstOperands,
     /* 262391 */     // GIR_Coverage, 3876,
     /* 262391 */     GIR_EraseRootFromParent_Done,
     /* 262392 */   // Label 5250: @262392
     /* 262392 */   GIM_Reject,
     /* 262393 */ // Label 5247: @262393
     /* 262393 */ GIM_Reject,
     /* 262394 */ // Label 5242: @262394
     /* 262394 */ GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262566),
     /* 262399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 262402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262413 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262481), // Rule ID 3879 //
     /* 262418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262437 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262479 */     GIR_RootConstrainSelectedInstOperands,
     /* 262480 */     // GIR_Coverage, 3879,
     /* 262480 */     GIR_EraseRootFromParent_Done,
     /* 262481 */   // Label 5252: @262481
     /* 262481 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262549), // Rule ID 3880 //
     /* 262486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262505 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262517 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262524 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262547 */     GIR_RootConstrainSelectedInstOperands,
     /* 262548 */     // GIR_Coverage, 3880,
     /* 262548 */     GIR_EraseRootFromParent_Done,
     /* 262549 */   // Label 5253: @262549
     /* 262549 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262565), // Rule ID 120 //
     /* 262554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262558 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 262558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262563 */     GIR_RootConstrainSelectedInstOperands,
     /* 262564 */     // GIR_Coverage, 120,
     /* 262564 */     GIR_Done,
     /* 262565 */   // Label 5254: @262565
     /* 262565 */   GIM_Reject,
     /* 262566 */ // Label 5251: @262566
     /* 262566 */ GIM_Reject,
     /* 262567 */ // Label 5243: @262567
     /* 262567 */ GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(262711),
     /* 262572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262582 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262646), // Rule ID 6263 //
     /* 262587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262628 */     // MIs[3] Operand 1
     /* 262628 */     // No operand predicates
     /* 262628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262630 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 262633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262639 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262644 */     GIR_RootConstrainSelectedInstOperands,
     /* 262645 */     // GIR_Coverage, 6263,
     /* 262645 */     GIR_EraseRootFromParent_Done,
     /* 262646 */   // Label 5256: @262646
     /* 262646 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(262710), // Rule ID 6260 //
     /* 262651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262688 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262692 */     // MIs[3] Operand 1
     /* 262692 */     // No operand predicates
     /* 262692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262694 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 262697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262703 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262708 */     GIR_RootConstrainSelectedInstOperands,
     /* 262709 */     // GIR_Coverage, 6260,
     /* 262709 */     GIR_EraseRootFromParent_Done,
     /* 262710 */   // Label 5257: @262710
     /* 262710 */   GIM_Reject,
     /* 262711 */ // Label 5255: @262711
     /* 262711 */ GIM_Reject,
     /* 262712 */ // Label 5244: @262712
     /* 262712 */ GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(262852),
     /* 262717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262727 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262789), // Rule ID 6262 //
     /* 262732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262773 */     // MIs[3] Operand 1
     /* 262773 */     // No operand predicates
     /* 262773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262775 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 262778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262787 */     GIR_RootConstrainSelectedInstOperands,
     /* 262788 */     // GIR_Coverage, 6262,
     /* 262788 */     GIR_EraseRootFromParent_Done,
     /* 262789 */   // Label 5259: @262789
     /* 262789 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262851), // Rule ID 6259 //
     /* 262794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262835 */     // MIs[3] Operand 1
     /* 262835 */     // No operand predicates
     /* 262835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262837 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 262840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262849 */     GIR_RootConstrainSelectedInstOperands,
     /* 262850 */     // GIR_Coverage, 6259,
     /* 262850 */     GIR_EraseRootFromParent_Done,
     /* 262851 */   // Label 5260: @262851
     /* 262851 */   GIM_Reject,
     /* 262852 */ // Label 5258: @262852
     /* 262852 */ GIM_Reject,
     /* 262853 */ // Label 5245: @262853
     /* 262853 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(262993),
     /* 262858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262868 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(262930), // Rule ID 6261 //
     /* 262873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262914 */     // MIs[3] Operand 1
     /* 262914 */     // No operand predicates
     /* 262914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262916 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 262919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262928 */     GIR_RootConstrainSelectedInstOperands,
     /* 262929 */     // GIR_Coverage, 6261,
     /* 262929 */     GIR_EraseRootFromParent_Done,
     /* 262930 */   // Label 5262: @262930
     /* 262930 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(262992), // Rule ID 6258 //
     /* 262935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262972 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262976 */     // MIs[3] Operand 1
     /* 262976 */     // No operand predicates
     /* 262976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262978 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 262981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262990 */     GIR_RootConstrainSelectedInstOperands,
     /* 262991 */     // GIR_Coverage, 6258,
     /* 262991 */     GIR_EraseRootFromParent_Done,
     /* 262992 */   // Label 5263: @262992
     /* 262992 */   GIM_Reject,
     /* 262993 */ // Label 5261: @262993
     /* 262993 */ GIM_Reject,
     /* 262994 */ // Label 5246: @262994
     /* 262994 */ GIM_Reject,
     /* 262995 */ // Label 42: @262995
     /* 262995 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5266*/ GIMT_Encode4(263387),
     /* 263006 */ /*GILLT_s32*//*Label 5264*/ GIMT_Encode4(263014),
     /* 263010 */ /*GILLT_s64*//*Label 5265*/ GIMT_Encode4(263180),
     /* 263014 */ // Label 5264: @263014
     /* 263014 */ GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263179),
     /* 263019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263033 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263067), // Rule ID 3966 //
     /* 263038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263050 */     // MIs[1] Operand 1
     /* 263050 */     // No operand predicates
     /* 263050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263052 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 263055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263065 */     GIR_RootConstrainSelectedInstOperands,
     /* 263066 */     // GIR_Coverage, 3966,
     /* 263066 */     GIR_EraseRootFromParent_Done,
     /* 263067 */   // Label 5268: @263067
     /* 263067 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263104), // Rule ID 3883 //
     /* 263072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263091 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 263094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263102 */     GIR_RootConstrainSelectedInstOperands,
     /* 263103 */     // GIR_Coverage, 3883,
     /* 263103 */     GIR_EraseRootFromParent_Done,
     /* 263104 */   // Label 5269: @263104
     /* 263104 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263141), // Rule ID 3884 //
     /* 263109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263128 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 263131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263139 */     GIR_RootConstrainSelectedInstOperands,
     /* 263140 */     // GIR_Coverage, 3884,
     /* 263140 */     GIR_EraseRootFromParent_Done,
     /* 263141 */   // Label 5270: @263141
     /* 263141 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263178), // Rule ID 3882 //
     /* 263146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263165 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 263168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263176 */     GIR_RootConstrainSelectedInstOperands,
     /* 263177 */     // GIR_Coverage, 3882,
     /* 263177 */     GIR_EraseRootFromParent_Done,
     /* 263178 */   // Label 5271: @263178
     /* 263178 */   GIM_Reject,
     /* 263179 */ // Label 5267: @263179
     /* 263179 */ GIM_Reject,
     /* 263180 */ // Label 5265: @263180
     /* 263180 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263386),
     /* 263185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263199 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263233), // Rule ID 3967 //
     /* 263204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263216 */     // MIs[1] Operand 1
     /* 263216 */     // No operand predicates
     /* 263216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263218 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 263218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 263221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 263231 */     GIR_RootConstrainSelectedInstOperands,
     /* 263232 */     // GIR_Coverage, 3967,
     /* 263232 */     GIR_EraseRootFromParent_Done,
     /* 263233 */   // Label 5273: @263233
     /* 263233 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263301), // Rule ID 3885 //
     /* 263238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263257 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263269 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 263292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263299 */     GIR_RootConstrainSelectedInstOperands,
     /* 263300 */     // GIR_Coverage, 3885,
     /* 263300 */     GIR_EraseRootFromParent_Done,
     /* 263301 */   // Label 5274: @263301
     /* 263301 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263369), // Rule ID 3886 //
     /* 263306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263325 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 263360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263367 */     GIR_RootConstrainSelectedInstOperands,
     /* 263368 */     // GIR_Coverage, 3886,
     /* 263368 */     GIR_EraseRootFromParent_Done,
     /* 263369 */   // Label 5275: @263369
     /* 263369 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263385), // Rule ID 121 //
     /* 263374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263378 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 263378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 263383 */     GIR_RootConstrainSelectedInstOperands,
     /* 263384 */     // GIR_Coverage, 121,
     /* 263384 */     GIR_Done,
     /* 263385 */   // Label 5276: @263385
     /* 263385 */   GIM_Reject,
     /* 263386 */ // Label 5272: @263386
     /* 263386 */ GIM_Reject,
     /* 263387 */ // Label 5266: @263387
     /* 263387 */ GIM_Reject,
     /* 263388 */ // Label 43: @263388
     /* 263388 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5279*/ GIMT_Encode4(264163),
     /* 263399 */ /*GILLT_s32*//*Label 5277*/ GIMT_Encode4(263407),
     /* 263403 */ /*GILLT_s64*//*Label 5278*/ GIMT_Encode4(263713),
     /* 263407 */ // Label 5277: @263407
     /* 263407 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263712),
     /* 263412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263422 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263486), // Rule ID 6423 //
     /* 263427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263444 */     // MIs[1] Operand 2
     /* 263444 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263467 */     // MIs[2] Operand 1
     /* 263467 */     // No operand predicates
     /* 263467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263469 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263484 */     GIR_RootConstrainSelectedInstOperands,
     /* 263485 */     // GIR_Coverage, 6423,
     /* 263485 */     GIR_EraseRootFromParent_Done,
     /* 263486 */   // Label 5281: @263486
     /* 263486 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263550), // Rule ID 6425 //
     /* 263491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263508 */     // MIs[1] Operand 2
     /* 263508 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263531 */     // MIs[2] Operand 1
     /* 263531 */     // No operand predicates
     /* 263531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263533 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263548 */     GIR_RootConstrainSelectedInstOperands,
     /* 263549 */     // GIR_Coverage, 6425,
     /* 263549 */     GIR_EraseRootFromParent_Done,
     /* 263550 */   // Label 5282: @263550
     /* 263550 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263588), // Rule ID 3964 //
     /* 263555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263571 */     // MIs[1] Operand 1
     /* 263571 */     // No operand predicates
     /* 263571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263573 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263586 */     GIR_RootConstrainSelectedInstOperands,
     /* 263587 */     // GIR_Coverage, 3964,
     /* 263587 */     GIR_EraseRootFromParent_Done,
     /* 263588 */   // Label 5283: @263588
     /* 263588 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(263629), // Rule ID 2426 //
     /* 263593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263616 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263627 */     GIR_RootConstrainSelectedInstOperands,
     /* 263628 */     // GIR_Coverage, 2426,
     /* 263628 */     GIR_EraseRootFromParent_Done,
     /* 263629 */   // Label 5284: @263629
     /* 263629 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(263670), // Rule ID 2427 //
     /* 263634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263657 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263668 */     GIR_RootConstrainSelectedInstOperands,
     /* 263669 */     // GIR_Coverage, 2427,
     /* 263669 */     GIR_EraseRootFromParent_Done,
     /* 263670 */   // Label 5285: @263670
     /* 263670 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(263711), // Rule ID 2425 //
     /* 263675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263698 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263709 */     GIR_RootConstrainSelectedInstOperands,
     /* 263710 */     // GIR_Coverage, 2425,
     /* 263710 */     GIR_EraseRootFromParent_Done,
     /* 263711 */   // Label 5286: @263711
     /* 263711 */   GIM_Reject,
     /* 263712 */ // Label 5280: @263712
     /* 263712 */ GIM_Reject,
     /* 263713 */ // Label 5278: @263713
     /* 263713 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264162),
     /* 263718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263728 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(263792), // Rule ID 6424 //
     /* 263733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263750 */     // MIs[1] Operand 2
     /* 263750 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263773 */     // MIs[2] Operand 1
     /* 263773 */     // No operand predicates
     /* 263773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263775 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263790 */     GIR_RootConstrainSelectedInstOperands,
     /* 263791 */     // GIR_Coverage, 6424,
     /* 263791 */     GIR_EraseRootFromParent_Done,
     /* 263792 */   // Label 5288: @263792
     /* 263792 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(263856), // Rule ID 6426 //
     /* 263797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263814 */     // MIs[1] Operand 2
     /* 263814 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263837 */     // MIs[2] Operand 1
     /* 263837 */     // No operand predicates
     /* 263837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263839 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263854 */     GIR_RootConstrainSelectedInstOperands,
     /* 263855 */     // GIR_Coverage, 6426,
     /* 263855 */     GIR_EraseRootFromParent_Done,
     /* 263856 */   // Label 5289: @263856
     /* 263856 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(263959), // Rule ID 6427 //
     /* 263861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263890 */     // MIs[2] Operand 1
     /* 263890 */     // No operand predicates
     /* 263890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263892 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 263895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263957 */     GIR_RootConstrainSelectedInstOperands,
     /* 263958 */     // GIR_Coverage, 6427,
     /* 263958 */     GIR_EraseRootFromParent_Done,
     /* 263959 */   // Label 5290: @263959
     /* 263959 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(263997), // Rule ID 3965 //
     /* 263964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263980 */     // MIs[1] Operand 1
     /* 263980 */     // No operand predicates
     /* 263980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263982 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 263982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 263995 */     GIR_RootConstrainSelectedInstOperands,
     /* 263996 */     // GIR_Coverage, 3965,
     /* 263996 */     GIR_EraseRootFromParent_Done,
     /* 263997 */   // Label 5291: @263997
     /* 263997 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264069), // Rule ID 2428 //
     /* 264002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264025 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 264060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264067 */     GIR_RootConstrainSelectedInstOperands,
     /* 264068 */     // GIR_Coverage, 2428,
     /* 264068 */     GIR_EraseRootFromParent_Done,
     /* 264069 */   // Label 5292: @264069
     /* 264069 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264141), // Rule ID 2429 //
     /* 264074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264097 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 264132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264139 */     GIR_RootConstrainSelectedInstOperands,
     /* 264140 */     // GIR_Coverage, 2429,
     /* 264140 */     GIR_EraseRootFromParent_Done,
     /* 264141 */   // Label 5293: @264141
     /* 264141 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264161), // Rule ID 119 //
     /* 264146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264154 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 264154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 264159 */     GIR_RootConstrainSelectedInstOperands,
     /* 264160 */     // GIR_Coverage, 119,
     /* 264160 */     GIR_Done,
     /* 264161 */   // Label 5294: @264161
     /* 264161 */   GIM_Reject,
     /* 264162 */ // Label 5287: @264162
     /* 264162 */ GIM_Reject,
     /* 264163 */ // Label 5279: @264163
     /* 264163 */ GIM_Reject,
     /* 264164 */ // Label 44: @264164
     /* 264164 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5297*/ GIMT_Encode4(264293),
     /* 264175 */ /*GILLT_s32*//*Label 5295*/ GIMT_Encode4(264183),
     /* 264179 */ /*GILLT_s64*//*Label 5296*/ GIMT_Encode4(264238),
     /* 264183 */ // Label 5295: @264183
     /* 264183 */ GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264237), // Rule ID 188 //
     /* 264188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264217 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 264221 */   // MIs[1] Operand 1
     /* 264221 */   // No operand predicates
     /* 264221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264223 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 264223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 264226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264230 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 264232 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264235 */   GIR_RootConstrainSelectedInstOperands,
     /* 264236 */   // GIR_Coverage, 188,
     /* 264236 */   GIR_EraseRootFromParent_Done,
     /* 264237 */ // Label 5298: @264237
     /* 264237 */ GIM_Reject,
     /* 264238 */ // Label 5296: @264238
     /* 264238 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264292), // Rule ID 189 //
     /* 264243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264272 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 264276 */   // MIs[1] Operand 1
     /* 264276 */   // No operand predicates
     /* 264276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264278 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 264278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 264281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264283 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264285 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 264287 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264290 */   GIR_RootConstrainSelectedInstOperands,
     /* 264291 */   // GIR_Coverage, 189,
     /* 264291 */   GIR_EraseRootFromParent_Done,
     /* 264292 */ // Label 5299: @264292
     /* 264292 */ GIM_Reject,
     /* 264293 */ // Label 5297: @264293
     /* 264293 */ GIM_Reject,
     /* 264294 */ // Label 45: @264294
     /* 264294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5302*/ GIMT_Encode4(264786),
     /* 264305 */ /*GILLT_s32*//*Label 5300*/ GIMT_Encode4(264313),
     /* 264309 */ /*GILLT_s64*//*Label 5301*/ GIMT_Encode4(264529),
     /* 264313 */ // Label 5300: @264313
     /* 264313 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(264528),
     /* 264318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264328 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264367), // Rule ID 184 //
     /* 264333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 264341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 264354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264356 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 264356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 264359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264365 */     GIR_RootConstrainSelectedInstOperands,
     /* 264366 */     // GIR_Coverage, 184,
     /* 264366 */     GIR_EraseRootFromParent_Done,
     /* 264367 */   // Label 5304: @264367
     /* 264367 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264404), // Rule ID 3960 //
     /* 264372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 264388 */     // MIs[1] Operand 1
     /* 264388 */     // No operand predicates
     /* 264388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264390 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 264390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 264393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264402 */     GIR_RootConstrainSelectedInstOperands,
     /* 264403 */     // GIR_Coverage, 3960,
     /* 264403 */     GIR_EraseRootFromParent_Done,
     /* 264404 */   // Label 5305: @264404
     /* 264404 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(264445), // Rule ID 3889 //
     /* 264409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264432 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264443 */     GIR_RootConstrainSelectedInstOperands,
     /* 264444 */     // GIR_Coverage, 3889,
     /* 264444 */     GIR_EraseRootFromParent_Done,
     /* 264445 */   // Label 5306: @264445
     /* 264445 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(264486), // Rule ID 3890 //
     /* 264450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264473 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264484 */     GIR_RootConstrainSelectedInstOperands,
     /* 264485 */     // GIR_Coverage, 3890,
     /* 264485 */     GIR_EraseRootFromParent_Done,
     /* 264486 */   // Label 5307: @264486
     /* 264486 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264527), // Rule ID 3888 //
     /* 264491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264514 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264525 */     GIR_RootConstrainSelectedInstOperands,
     /* 264526 */     // GIR_Coverage, 3888,
     /* 264526 */     GIR_EraseRootFromParent_Done,
     /* 264527 */   // Label 5308: @264527
     /* 264527 */   GIM_Reject,
     /* 264528 */ // Label 5303: @264528
     /* 264528 */ GIM_Reject,
     /* 264529 */ // Label 5301: @264529
     /* 264529 */ GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(264785),
     /* 264534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264544 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(264583), // Rule ID 187 //
     /* 264549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 264557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 264561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 264570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264572 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 264572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 264575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264581 */     GIR_RootConstrainSelectedInstOperands,
     /* 264582 */     // GIR_Coverage, 187,
     /* 264582 */     GIR_EraseRootFromParent_Done,
     /* 264583 */   // Label 5310: @264583
     /* 264583 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(264620), // Rule ID 3961 //
     /* 264588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 264604 */     // MIs[1] Operand 1
     /* 264604 */     // No operand predicates
     /* 264604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264606 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 264606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 264609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264618 */     GIR_RootConstrainSelectedInstOperands,
     /* 264619 */     // GIR_Coverage, 3961,
     /* 264619 */     GIR_EraseRootFromParent_Done,
     /* 264620 */   // Label 5311: @264620
     /* 264620 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(264692), // Rule ID 3891 //
     /* 264625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264648 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264690 */     GIR_RootConstrainSelectedInstOperands,
     /* 264691 */     // GIR_Coverage, 3891,
     /* 264691 */     GIR_EraseRootFromParent_Done,
     /* 264692 */   // Label 5312: @264692
     /* 264692 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(264764), // Rule ID 3892 //
     /* 264697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264720 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264762 */     GIR_RootConstrainSelectedInstOperands,
     /* 264763 */     // GIR_Coverage, 3892,
     /* 264763 */     GIR_EraseRootFromParent_Done,
     /* 264764 */   // Label 5313: @264764
     /* 264764 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(264784), // Rule ID 122 //
     /* 264769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264777 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 264777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264782 */     GIR_RootConstrainSelectedInstOperands,
     /* 264783 */     // GIR_Coverage, 122,
     /* 264783 */     GIR_Done,
     /* 264784 */   // Label 5314: @264784
     /* 264784 */   GIM_Reject,
     /* 264785 */ // Label 5309: @264785
     /* 264785 */ GIM_Reject,
     /* 264786 */ // Label 5302: @264786
     /* 264786 */ GIM_Reject,
     /* 264787 */ // Label 46: @264787
     /* 264787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5322*/ GIMT_Encode4(269362),
     /* 264798 */ /*GILLT_v2s32*//*Label 5315*/ GIMT_Encode4(264826),
     /* 264802 */ /*GILLT_v2s64*//*Label 5316*/ GIMT_Encode4(265474),
     /* 264806 */ /*GILLT_v4s16*//*Label 5317*/ GIMT_Encode4(266122),
     /* 264810 */ /*GILLT_v4s32*//*Label 5318*/ GIMT_Encode4(266770),
     /* 264814 */ /*GILLT_v8s8*//*Label 5319*/ GIMT_Encode4(267418),
     /* 264818 */ /*GILLT_v8s16*//*Label 5320*/ GIMT_Encode4(268066),
     /* 264822 */ /*GILLT_v16s8*//*Label 5321*/ GIMT_Encode4(268714),
     /* 264826 */ // Label 5315: @264826
     /* 264826 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265473),
     /* 264831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264841 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264878), // Rule ID 5113 //
     /* 264846 */     // MIs[0] Operand 1
     /* 264846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264869 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 264872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264876 */     GIR_RootConstrainSelectedInstOperands,
     /* 264877 */     // GIR_Coverage, 5113,
     /* 264877 */     GIR_EraseRootFromParent_Done,
     /* 264878 */   // Label 5324: @264878
     /* 264878 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(264915), // Rule ID 5120 //
     /* 264883 */     // MIs[0] Operand 1
     /* 264883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264892 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264898 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264906 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 264909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264913 */     GIR_RootConstrainSelectedInstOperands,
     /* 264914 */     // GIR_Coverage, 5120,
     /* 264914 */     GIR_EraseRootFromParent_Done,
     /* 264915 */   // Label 5325: @264915
     /* 264915 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(264952), // Rule ID 5127 //
     /* 264920 */     // MIs[0] Operand 1
     /* 264920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264929 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264935 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264943 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 264946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264950 */     GIR_RootConstrainSelectedInstOperands,
     /* 264951 */     // GIR_Coverage, 5127,
     /* 264951 */     GIR_EraseRootFromParent_Done,
     /* 264952 */   // Label 5326: @264952
     /* 264952 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(264989), // Rule ID 5134 //
     /* 264957 */     // MIs[0] Operand 1
     /* 264957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264966 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264972 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264980 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 264983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264987 */     GIR_RootConstrainSelectedInstOperands,
     /* 264988 */     // GIR_Coverage, 5134,
     /* 264988 */     GIR_EraseRootFromParent_Done,
     /* 264989 */   // Label 5327: @264989
     /* 264989 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(265026), // Rule ID 5141 //
     /* 264994 */     // MIs[0] Operand 1
     /* 264994 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265003 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265009 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265017 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 265020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265024 */     GIR_RootConstrainSelectedInstOperands,
     /* 265025 */     // GIR_Coverage, 5141,
     /* 265025 */     GIR_EraseRootFromParent_Done,
     /* 265026 */   // Label 5328: @265026
     /* 265026 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(265063), // Rule ID 5078 //
     /* 265031 */     // MIs[0] Operand 1
     /* 265031 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265054 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 265057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265061 */     GIR_RootConstrainSelectedInstOperands,
     /* 265062 */     // GIR_Coverage, 5078,
     /* 265062 */     GIR_EraseRootFromParent_Done,
     /* 265063 */   // Label 5329: @265063
     /* 265063 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(265100), // Rule ID 5085 //
     /* 265068 */     // MIs[0] Operand 1
     /* 265068 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265087 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265091 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 265094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265098 */     GIR_RootConstrainSelectedInstOperands,
     /* 265099 */     // GIR_Coverage, 5085,
     /* 265099 */     GIR_EraseRootFromParent_Done,
     /* 265100 */   // Label 5330: @265100
     /* 265100 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(265137), // Rule ID 5092 //
     /* 265105 */     // MIs[0] Operand 1
     /* 265105 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265118 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265124 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265128 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 265131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265135 */     GIR_RootConstrainSelectedInstOperands,
     /* 265136 */     // GIR_Coverage, 5092,
     /* 265136 */     GIR_EraseRootFromParent_Done,
     /* 265137 */   // Label 5331: @265137
     /* 265137 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(265174), // Rule ID 5099 //
     /* 265142 */     // MIs[0] Operand 1
     /* 265142 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265155 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265161 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265165 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 265168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265172 */     GIR_RootConstrainSelectedInstOperands,
     /* 265173 */     // GIR_Coverage, 5099,
     /* 265173 */     GIR_EraseRootFromParent_Done,
     /* 265174 */   // Label 5332: @265174
     /* 265174 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(265211), // Rule ID 5106 //
     /* 265179 */     // MIs[0] Operand 1
     /* 265179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265192 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265198 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265202 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 265202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 265205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265209 */     GIR_RootConstrainSelectedInstOperands,
     /* 265210 */     // GIR_Coverage, 5106,
     /* 265210 */     GIR_EraseRootFromParent_Done,
     /* 265211 */   // Label 5333: @265211
     /* 265211 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(265240), // Rule ID 5015 //
     /* 265216 */     // MIs[0] Operand 1
     /* 265216 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265229 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 265229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 265232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265238 */     GIR_RootConstrainSelectedInstOperands,
     /* 265239 */     // GIR_Coverage, 5015,
     /* 265239 */     GIR_EraseRootFromParent_Done,
     /* 265240 */   // Label 5334: @265240
     /* 265240 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(265269), // Rule ID 5022 //
     /* 265245 */     // MIs[0] Operand 1
     /* 265245 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265258 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 265258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 265261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265267 */     GIR_RootConstrainSelectedInstOperands,
     /* 265268 */     // GIR_Coverage, 5022,
     /* 265268 */     GIR_EraseRootFromParent_Done,
     /* 265269 */   // Label 5335: @265269
     /* 265269 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(265298), // Rule ID 5029 //
     /* 265274 */     // MIs[0] Operand 1
     /* 265274 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265287 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 265287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 265290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265296 */     GIR_RootConstrainSelectedInstOperands,
     /* 265297 */     // GIR_Coverage, 5029,
     /* 265297 */     GIR_EraseRootFromParent_Done,
     /* 265298 */   // Label 5336: @265298
     /* 265298 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(265327), // Rule ID 5036 //
     /* 265303 */     // MIs[0] Operand 1
     /* 265303 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 265308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265316 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 265316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 265319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265325 */     GIR_RootConstrainSelectedInstOperands,
     /* 265326 */     // GIR_Coverage, 5036,
     /* 265326 */     GIR_EraseRootFromParent_Done,
     /* 265327 */   // Label 5337: @265327
     /* 265327 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(265356), // Rule ID 5043 //
     /* 265332 */     // MIs[0] Operand 1
     /* 265332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 265337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265345 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 265345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 265348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265354 */     GIR_RootConstrainSelectedInstOperands,
     /* 265355 */     // GIR_Coverage, 5043,
     /* 265355 */     GIR_EraseRootFromParent_Done,
     /* 265356 */   // Label 5338: @265356
     /* 265356 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265385), // Rule ID 5050 //
     /* 265361 */     // MIs[0] Operand 1
     /* 265361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265374 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 265377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265383 */     GIR_RootConstrainSelectedInstOperands,
     /* 265384 */     // GIR_Coverage, 5050,
     /* 265384 */     GIR_EraseRootFromParent_Done,
     /* 265385 */   // Label 5339: @265385
     /* 265385 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265414), // Rule ID 5057 //
     /* 265390 */     // MIs[0] Operand 1
     /* 265390 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265403 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 265406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265412 */     GIR_RootConstrainSelectedInstOperands,
     /* 265413 */     // GIR_Coverage, 5057,
     /* 265413 */     GIR_EraseRootFromParent_Done,
     /* 265414 */   // Label 5340: @265414
     /* 265414 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265443), // Rule ID 5064 //
     /* 265419 */     // MIs[0] Operand 1
     /* 265419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 265424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265432 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 265435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265441 */     GIR_RootConstrainSelectedInstOperands,
     /* 265442 */     // GIR_Coverage, 5064,
     /* 265442 */     GIR_EraseRootFromParent_Done,
     /* 265443 */   // Label 5341: @265443
     /* 265443 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265472), // Rule ID 5071 //
     /* 265448 */     // MIs[0] Operand 1
     /* 265448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 265453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265461 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 265464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265470 */     GIR_RootConstrainSelectedInstOperands,
     /* 265471 */     // GIR_Coverage, 5071,
     /* 265471 */     GIR_EraseRootFromParent_Done,
     /* 265472 */   // Label 5342: @265472
     /* 265472 */   GIM_Reject,
     /* 265473 */ // Label 5323: @265473
     /* 265473 */ GIM_Reject,
     /* 265474 */ // Label 5316: @265474
     /* 265474 */ GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(266121),
     /* 265479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 265482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 265485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265489 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265526), // Rule ID 5115 //
     /* 265494 */     // MIs[0] Operand 1
     /* 265494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265517 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265524 */     GIR_RootConstrainSelectedInstOperands,
     /* 265525 */     // GIR_Coverage, 5115,
     /* 265525 */     GIR_EraseRootFromParent_Done,
     /* 265526 */   // Label 5344: @265526
     /* 265526 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265563), // Rule ID 5122 //
     /* 265531 */     // MIs[0] Operand 1
     /* 265531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265554 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265561 */     GIR_RootConstrainSelectedInstOperands,
     /* 265562 */     // GIR_Coverage, 5122,
     /* 265562 */     GIR_EraseRootFromParent_Done,
     /* 265563 */   // Label 5345: @265563
     /* 265563 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(265600), // Rule ID 5129 //
     /* 265568 */     // MIs[0] Operand 1
     /* 265568 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265591 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265598 */     GIR_RootConstrainSelectedInstOperands,
     /* 265599 */     // GIR_Coverage, 5129,
     /* 265599 */     GIR_EraseRootFromParent_Done,
     /* 265600 */   // Label 5346: @265600
     /* 265600 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(265637), // Rule ID 5136 //
     /* 265605 */     // MIs[0] Operand 1
     /* 265605 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265614 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265620 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265628 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265635 */     GIR_RootConstrainSelectedInstOperands,
     /* 265636 */     // GIR_Coverage, 5136,
     /* 265636 */     GIR_EraseRootFromParent_Done,
     /* 265637 */   // Label 5347: @265637
     /* 265637 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(265674), // Rule ID 5143 //
     /* 265642 */     // MIs[0] Operand 1
     /* 265642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265665 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265672 */     GIR_RootConstrainSelectedInstOperands,
     /* 265673 */     // GIR_Coverage, 5143,
     /* 265673 */     GIR_EraseRootFromParent_Done,
     /* 265674 */   // Label 5348: @265674
     /* 265674 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265711), // Rule ID 5080 //
     /* 265679 */     // MIs[0] Operand 1
     /* 265679 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265702 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265709 */     GIR_RootConstrainSelectedInstOperands,
     /* 265710 */     // GIR_Coverage, 5080,
     /* 265710 */     GIR_EraseRootFromParent_Done,
     /* 265711 */   // Label 5349: @265711
     /* 265711 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265748), // Rule ID 5087 //
     /* 265716 */     // MIs[0] Operand 1
     /* 265716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265735 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265739 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265746 */     GIR_RootConstrainSelectedInstOperands,
     /* 265747 */     // GIR_Coverage, 5087,
     /* 265747 */     GIR_EraseRootFromParent_Done,
     /* 265748 */   // Label 5350: @265748
     /* 265748 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265785), // Rule ID 5094 //
     /* 265753 */     // MIs[0] Operand 1
     /* 265753 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265776 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265783 */     GIR_RootConstrainSelectedInstOperands,
     /* 265784 */     // GIR_Coverage, 5094,
     /* 265784 */     GIR_EraseRootFromParent_Done,
     /* 265785 */   // Label 5351: @265785
     /* 265785 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265822), // Rule ID 5101 //
     /* 265790 */     // MIs[0] Operand 1
     /* 265790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265813 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265820 */     GIR_RootConstrainSelectedInstOperands,
     /* 265821 */     // GIR_Coverage, 5101,
     /* 265821 */     GIR_EraseRootFromParent_Done,
     /* 265822 */   // Label 5352: @265822
     /* 265822 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(265859), // Rule ID 5108 //
     /* 265827 */     // MIs[0] Operand 1
     /* 265827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265850 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265857 */     GIR_RootConstrainSelectedInstOperands,
     /* 265858 */     // GIR_Coverage, 5108,
     /* 265858 */     GIR_EraseRootFromParent_Done,
     /* 265859 */   // Label 5353: @265859
     /* 265859 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(265888), // Rule ID 5017 //
     /* 265864 */     // MIs[0] Operand 1
     /* 265864 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265877 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 265880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265886 */     GIR_RootConstrainSelectedInstOperands,
     /* 265887 */     // GIR_Coverage, 5017,
     /* 265887 */     GIR_EraseRootFromParent_Done,
     /* 265888 */   // Label 5354: @265888
     /* 265888 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(265917), // Rule ID 5024 //
     /* 265893 */     // MIs[0] Operand 1
     /* 265893 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265906 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 265909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265915 */     GIR_RootConstrainSelectedInstOperands,
     /* 265916 */     // GIR_Coverage, 5024,
     /* 265916 */     GIR_EraseRootFromParent_Done,
     /* 265917 */   // Label 5355: @265917
     /* 265917 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(265946), // Rule ID 5031 //
     /* 265922 */     // MIs[0] Operand 1
     /* 265922 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265935 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 265938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265944 */     GIR_RootConstrainSelectedInstOperands,
     /* 265945 */     // GIR_Coverage, 5031,
     /* 265945 */     GIR_EraseRootFromParent_Done,
     /* 265946 */   // Label 5356: @265946
     /* 265946 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(265975), // Rule ID 5038 //
     /* 265951 */     // MIs[0] Operand 1
     /* 265951 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 265956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265964 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 265967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265973 */     GIR_RootConstrainSelectedInstOperands,
     /* 265974 */     // GIR_Coverage, 5038,
     /* 265974 */     GIR_EraseRootFromParent_Done,
     /* 265975 */   // Label 5357: @265975
     /* 265975 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(266004), // Rule ID 5045 //
     /* 265980 */     // MIs[0] Operand 1
     /* 265980 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 265985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265993 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 265996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266002 */     GIR_RootConstrainSelectedInstOperands,
     /* 266003 */     // GIR_Coverage, 5045,
     /* 266003 */     GIR_EraseRootFromParent_Done,
     /* 266004 */   // Label 5358: @266004
     /* 266004 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266033), // Rule ID 5052 //
     /* 266009 */     // MIs[0] Operand 1
     /* 266009 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266022 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 266022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 266025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266031 */     GIR_RootConstrainSelectedInstOperands,
     /* 266032 */     // GIR_Coverage, 5052,
     /* 266032 */     GIR_EraseRootFromParent_Done,
     /* 266033 */   // Label 5359: @266033
     /* 266033 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266062), // Rule ID 5059 //
     /* 266038 */     // MIs[0] Operand 1
     /* 266038 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266051 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 266051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 266054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266060 */     GIR_RootConstrainSelectedInstOperands,
     /* 266061 */     // GIR_Coverage, 5059,
     /* 266061 */     GIR_EraseRootFromParent_Done,
     /* 266062 */   // Label 5360: @266062
     /* 266062 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266091), // Rule ID 5066 //
     /* 266067 */     // MIs[0] Operand 1
     /* 266067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266080 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 266080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 266083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266089 */     GIR_RootConstrainSelectedInstOperands,
     /* 266090 */     // GIR_Coverage, 5066,
     /* 266090 */     GIR_EraseRootFromParent_Done,
     /* 266091 */   // Label 5361: @266091
     /* 266091 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266120), // Rule ID 5073 //
     /* 266096 */     // MIs[0] Operand 1
     /* 266096 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266109 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 266109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 266112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266118 */     GIR_RootConstrainSelectedInstOperands,
     /* 266119 */     // GIR_Coverage, 5073,
     /* 266119 */     GIR_EraseRootFromParent_Done,
     /* 266120 */   // Label 5362: @266120
     /* 266120 */   GIM_Reject,
     /* 266121 */ // Label 5343: @266121
     /* 266121 */ GIM_Reject,
     /* 266122 */ // Label 5317: @266122
     /* 266122 */ GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266769),
     /* 266127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 266133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266137 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(266174), // Rule ID 5111 //
     /* 266142 */     // MIs[0] Operand 1
     /* 266142 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266151 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266157 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266165 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 266168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266172 */     GIR_RootConstrainSelectedInstOperands,
     /* 266173 */     // GIR_Coverage, 5111,
     /* 266173 */     GIR_EraseRootFromParent_Done,
     /* 266174 */   // Label 5364: @266174
     /* 266174 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(266211), // Rule ID 5118 //
     /* 266179 */     // MIs[0] Operand 1
     /* 266179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266188 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266194 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266202 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 266205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266209 */     GIR_RootConstrainSelectedInstOperands,
     /* 266210 */     // GIR_Coverage, 5118,
     /* 266210 */     GIR_EraseRootFromParent_Done,
     /* 266211 */   // Label 5365: @266211
     /* 266211 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(266248), // Rule ID 5125 //
     /* 266216 */     // MIs[0] Operand 1
     /* 266216 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266239 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 266242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266246 */     GIR_RootConstrainSelectedInstOperands,
     /* 266247 */     // GIR_Coverage, 5125,
     /* 266247 */     GIR_EraseRootFromParent_Done,
     /* 266248 */   // Label 5366: @266248
     /* 266248 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266285), // Rule ID 5132 //
     /* 266253 */     // MIs[0] Operand 1
     /* 266253 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266262 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266268 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266276 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 266279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266283 */     GIR_RootConstrainSelectedInstOperands,
     /* 266284 */     // GIR_Coverage, 5132,
     /* 266284 */     GIR_EraseRootFromParent_Done,
     /* 266285 */   // Label 5367: @266285
     /* 266285 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266322), // Rule ID 5139 //
     /* 266290 */     // MIs[0] Operand 1
     /* 266290 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266299 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266305 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266313 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 266316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266320 */     GIR_RootConstrainSelectedInstOperands,
     /* 266321 */     // GIR_Coverage, 5139,
     /* 266321 */     GIR_EraseRootFromParent_Done,
     /* 266322 */   // Label 5368: @266322
     /* 266322 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(266359), // Rule ID 5076 //
     /* 266327 */     // MIs[0] Operand 1
     /* 266327 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266350 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 266353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266357 */     GIR_RootConstrainSelectedInstOperands,
     /* 266358 */     // GIR_Coverage, 5076,
     /* 266358 */     GIR_EraseRootFromParent_Done,
     /* 266359 */   // Label 5369: @266359
     /* 266359 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(266396), // Rule ID 5083 //
     /* 266364 */     // MIs[0] Operand 1
     /* 266364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266387 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 266390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266394 */     GIR_RootConstrainSelectedInstOperands,
     /* 266395 */     // GIR_Coverage, 5083,
     /* 266395 */     GIR_EraseRootFromParent_Done,
     /* 266396 */   // Label 5370: @266396
     /* 266396 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(266433), // Rule ID 5090 //
     /* 266401 */     // MIs[0] Operand 1
     /* 266401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266414 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266420 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266424 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 266427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266431 */     GIR_RootConstrainSelectedInstOperands,
     /* 266432 */     // GIR_Coverage, 5090,
     /* 266432 */     GIR_EraseRootFromParent_Done,
     /* 266433 */   // Label 5371: @266433
     /* 266433 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(266470), // Rule ID 5097 //
     /* 266438 */     // MIs[0] Operand 1
     /* 266438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266461 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 266464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266468 */     GIR_RootConstrainSelectedInstOperands,
     /* 266469 */     // GIR_Coverage, 5097,
     /* 266469 */     GIR_EraseRootFromParent_Done,
     /* 266470 */   // Label 5372: @266470
     /* 266470 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(266507), // Rule ID 5104 //
     /* 266475 */     // MIs[0] Operand 1
     /* 266475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266498 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 266501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266505 */     GIR_RootConstrainSelectedInstOperands,
     /* 266506 */     // GIR_Coverage, 5104,
     /* 266506 */     GIR_EraseRootFromParent_Done,
     /* 266507 */   // Label 5373: @266507
     /* 266507 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(266536), // Rule ID 5013 //
     /* 266512 */     // MIs[0] Operand 1
     /* 266512 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266525 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 266528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266534 */     GIR_RootConstrainSelectedInstOperands,
     /* 266535 */     // GIR_Coverage, 5013,
     /* 266535 */     GIR_EraseRootFromParent_Done,
     /* 266536 */   // Label 5374: @266536
     /* 266536 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(266565), // Rule ID 5020 //
     /* 266541 */     // MIs[0] Operand 1
     /* 266541 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266554 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266563 */     GIR_RootConstrainSelectedInstOperands,
     /* 266564 */     // GIR_Coverage, 5020,
     /* 266564 */     GIR_EraseRootFromParent_Done,
     /* 266565 */   // Label 5375: @266565
     /* 266565 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(266594), // Rule ID 5027 //
     /* 266570 */     // MIs[0] Operand 1
     /* 266570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266583 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266592 */     GIR_RootConstrainSelectedInstOperands,
     /* 266593 */     // GIR_Coverage, 5027,
     /* 266593 */     GIR_EraseRootFromParent_Done,
     /* 266594 */   // Label 5376: @266594
     /* 266594 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(266623), // Rule ID 5034 //
     /* 266599 */     // MIs[0] Operand 1
     /* 266599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 266604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266612 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266621 */     GIR_RootConstrainSelectedInstOperands,
     /* 266622 */     // GIR_Coverage, 5034,
     /* 266622 */     GIR_EraseRootFromParent_Done,
     /* 266623 */   // Label 5377: @266623
     /* 266623 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(266652), // Rule ID 5041 //
     /* 266628 */     // MIs[0] Operand 1
     /* 266628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 266633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266641 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266650 */     GIR_RootConstrainSelectedInstOperands,
     /* 266651 */     // GIR_Coverage, 5041,
     /* 266651 */     GIR_EraseRootFromParent_Done,
     /* 266652 */   // Label 5378: @266652
     /* 266652 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(266681), // Rule ID 5048 //
     /* 266657 */     // MIs[0] Operand 1
     /* 266657 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266670 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266679 */     GIR_RootConstrainSelectedInstOperands,
     /* 266680 */     // GIR_Coverage, 5048,
     /* 266680 */     GIR_EraseRootFromParent_Done,
     /* 266681 */   // Label 5379: @266681
     /* 266681 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(266710), // Rule ID 5055 //
     /* 266686 */     // MIs[0] Operand 1
     /* 266686 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266699 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266708 */     GIR_RootConstrainSelectedInstOperands,
     /* 266709 */     // GIR_Coverage, 5055,
     /* 266709 */     GIR_EraseRootFromParent_Done,
     /* 266710 */   // Label 5380: @266710
     /* 266710 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(266739), // Rule ID 5062 //
     /* 266715 */     // MIs[0] Operand 1
     /* 266715 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266728 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266737 */     GIR_RootConstrainSelectedInstOperands,
     /* 266738 */     // GIR_Coverage, 5062,
     /* 266738 */     GIR_EraseRootFromParent_Done,
     /* 266739 */   // Label 5381: @266739
     /* 266739 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(266768), // Rule ID 5069 //
     /* 266744 */     // MIs[0] Operand 1
     /* 266744 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266757 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266766 */     GIR_RootConstrainSelectedInstOperands,
     /* 266767 */     // GIR_Coverage, 5069,
     /* 266767 */     GIR_EraseRootFromParent_Done,
     /* 266768 */   // Label 5382: @266768
     /* 266768 */   GIM_Reject,
     /* 266769 */ // Label 5363: @266769
     /* 266769 */ GIM_Reject,
     /* 266770 */ // Label 5318: @266770
     /* 266770 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(267417),
     /* 266775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266785 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(266822), // Rule ID 5114 //
     /* 266790 */     // MIs[0] Operand 1
     /* 266790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266813 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 266816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266820 */     GIR_RootConstrainSelectedInstOperands,
     /* 266821 */     // GIR_Coverage, 5114,
     /* 266821 */     GIR_EraseRootFromParent_Done,
     /* 266822 */   // Label 5384: @266822
     /* 266822 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(266859), // Rule ID 5121 //
     /* 266827 */     // MIs[0] Operand 1
     /* 266827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266836 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266842 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266850 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 266853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266857 */     GIR_RootConstrainSelectedInstOperands,
     /* 266858 */     // GIR_Coverage, 5121,
     /* 266858 */     GIR_EraseRootFromParent_Done,
     /* 266859 */   // Label 5385: @266859
     /* 266859 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(266896), // Rule ID 5128 //
     /* 266864 */     // MIs[0] Operand 1
     /* 266864 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266873 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266879 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266887 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 266890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266894 */     GIR_RootConstrainSelectedInstOperands,
     /* 266895 */     // GIR_Coverage, 5128,
     /* 266895 */     GIR_EraseRootFromParent_Done,
     /* 266896 */   // Label 5386: @266896
     /* 266896 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(266933), // Rule ID 5135 //
     /* 266901 */     // MIs[0] Operand 1
     /* 266901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266910 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266916 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266924 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 266927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266931 */     GIR_RootConstrainSelectedInstOperands,
     /* 266932 */     // GIR_Coverage, 5135,
     /* 266932 */     GIR_EraseRootFromParent_Done,
     /* 266933 */   // Label 5387: @266933
     /* 266933 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(266970), // Rule ID 5142 //
     /* 266938 */     // MIs[0] Operand 1
     /* 266938 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266961 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 266964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266968 */     GIR_RootConstrainSelectedInstOperands,
     /* 266969 */     // GIR_Coverage, 5142,
     /* 266969 */     GIR_EraseRootFromParent_Done,
     /* 266970 */   // Label 5388: @266970
     /* 266970 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(267007), // Rule ID 5079 //
     /* 266975 */     // MIs[0] Operand 1
     /* 266975 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266998 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 267001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267005 */     GIR_RootConstrainSelectedInstOperands,
     /* 267006 */     // GIR_Coverage, 5079,
     /* 267006 */     GIR_EraseRootFromParent_Done,
     /* 267007 */   // Label 5389: @267007
     /* 267007 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(267044), // Rule ID 5086 //
     /* 267012 */     // MIs[0] Operand 1
     /* 267012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267035 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 267035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 267038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267042 */     GIR_RootConstrainSelectedInstOperands,
     /* 267043 */     // GIR_Coverage, 5086,
     /* 267043 */     GIR_EraseRootFromParent_Done,
     /* 267044 */   // Label 5390: @267044
     /* 267044 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(267081), // Rule ID 5093 //
     /* 267049 */     // MIs[0] Operand 1
     /* 267049 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267072 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 267072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 267075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267079 */     GIR_RootConstrainSelectedInstOperands,
     /* 267080 */     // GIR_Coverage, 5093,
     /* 267080 */     GIR_EraseRootFromParent_Done,
     /* 267081 */   // Label 5391: @267081
     /* 267081 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(267118), // Rule ID 5100 //
     /* 267086 */     // MIs[0] Operand 1
     /* 267086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267099 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267105 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267109 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 267109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 267112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267116 */     GIR_RootConstrainSelectedInstOperands,
     /* 267117 */     // GIR_Coverage, 5100,
     /* 267117 */     GIR_EraseRootFromParent_Done,
     /* 267118 */   // Label 5392: @267118
     /* 267118 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(267155), // Rule ID 5107 //
     /* 267123 */     // MIs[0] Operand 1
     /* 267123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267136 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267142 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267146 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 267146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 267149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267153 */     GIR_RootConstrainSelectedInstOperands,
     /* 267154 */     // GIR_Coverage, 5107,
     /* 267154 */     GIR_EraseRootFromParent_Done,
     /* 267155 */   // Label 5393: @267155
     /* 267155 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(267184), // Rule ID 5016 //
     /* 267160 */     // MIs[0] Operand 1
     /* 267160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267173 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 267176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267182 */     GIR_RootConstrainSelectedInstOperands,
     /* 267183 */     // GIR_Coverage, 5016,
     /* 267183 */     GIR_EraseRootFromParent_Done,
     /* 267184 */   // Label 5394: @267184
     /* 267184 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(267213), // Rule ID 5023 //
     /* 267189 */     // MIs[0] Operand 1
     /* 267189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267202 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 267205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267211 */     GIR_RootConstrainSelectedInstOperands,
     /* 267212 */     // GIR_Coverage, 5023,
     /* 267212 */     GIR_EraseRootFromParent_Done,
     /* 267213 */   // Label 5395: @267213
     /* 267213 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(267242), // Rule ID 5030 //
     /* 267218 */     // MIs[0] Operand 1
     /* 267218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267231 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 267234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267240 */     GIR_RootConstrainSelectedInstOperands,
     /* 267241 */     // GIR_Coverage, 5030,
     /* 267241 */     GIR_EraseRootFromParent_Done,
     /* 267242 */   // Label 5396: @267242
     /* 267242 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(267271), // Rule ID 5037 //
     /* 267247 */     // MIs[0] Operand 1
     /* 267247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 267252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267260 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 267263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267269 */     GIR_RootConstrainSelectedInstOperands,
     /* 267270 */     // GIR_Coverage, 5037,
     /* 267270 */     GIR_EraseRootFromParent_Done,
     /* 267271 */   // Label 5397: @267271
     /* 267271 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(267300), // Rule ID 5044 //
     /* 267276 */     // MIs[0] Operand 1
     /* 267276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 267281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267289 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 267292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267298 */     GIR_RootConstrainSelectedInstOperands,
     /* 267299 */     // GIR_Coverage, 5044,
     /* 267299 */     GIR_EraseRootFromParent_Done,
     /* 267300 */   // Label 5398: @267300
     /* 267300 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(267329), // Rule ID 5051 //
     /* 267305 */     // MIs[0] Operand 1
     /* 267305 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267318 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 267318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 267321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267327 */     GIR_RootConstrainSelectedInstOperands,
     /* 267328 */     // GIR_Coverage, 5051,
     /* 267328 */     GIR_EraseRootFromParent_Done,
     /* 267329 */   // Label 5399: @267329
     /* 267329 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(267358), // Rule ID 5058 //
     /* 267334 */     // MIs[0] Operand 1
     /* 267334 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267347 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 267347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 267350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267356 */     GIR_RootConstrainSelectedInstOperands,
     /* 267357 */     // GIR_Coverage, 5058,
     /* 267357 */     GIR_EraseRootFromParent_Done,
     /* 267358 */   // Label 5400: @267358
     /* 267358 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(267387), // Rule ID 5065 //
     /* 267363 */     // MIs[0] Operand 1
     /* 267363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 267368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267376 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 267376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 267379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267385 */     GIR_RootConstrainSelectedInstOperands,
     /* 267386 */     // GIR_Coverage, 5065,
     /* 267386 */     GIR_EraseRootFromParent_Done,
     /* 267387 */   // Label 5401: @267387
     /* 267387 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(267416), // Rule ID 5072 //
     /* 267392 */     // MIs[0] Operand 1
     /* 267392 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 267397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267405 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 267405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 267408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267414 */     GIR_RootConstrainSelectedInstOperands,
     /* 267415 */     // GIR_Coverage, 5072,
     /* 267415 */     GIR_EraseRootFromParent_Done,
     /* 267416 */   // Label 5402: @267416
     /* 267416 */   GIM_Reject,
     /* 267417 */ // Label 5383: @267417
     /* 267417 */ GIM_Reject,
     /* 267418 */ // Label 5319: @267418
     /* 267418 */ GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(268065),
     /* 267423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 267429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267433 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(267470), // Rule ID 5109 //
     /* 267438 */     // MIs[0] Operand 1
     /* 267438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267461 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267468 */     GIR_RootConstrainSelectedInstOperands,
     /* 267469 */     // GIR_Coverage, 5109,
     /* 267469 */     GIR_EraseRootFromParent_Done,
     /* 267470 */   // Label 5404: @267470
     /* 267470 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(267507), // Rule ID 5116 //
     /* 267475 */     // MIs[0] Operand 1
     /* 267475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267484 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267490 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267498 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267505 */     GIR_RootConstrainSelectedInstOperands,
     /* 267506 */     // GIR_Coverage, 5116,
     /* 267506 */     GIR_EraseRootFromParent_Done,
     /* 267507 */   // Label 5405: @267507
     /* 267507 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(267544), // Rule ID 5123 //
     /* 267512 */     // MIs[0] Operand 1
     /* 267512 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267535 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267542 */     GIR_RootConstrainSelectedInstOperands,
     /* 267543 */     // GIR_Coverage, 5123,
     /* 267543 */     GIR_EraseRootFromParent_Done,
     /* 267544 */   // Label 5406: @267544
     /* 267544 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(267581), // Rule ID 5130 //
     /* 267549 */     // MIs[0] Operand 1
     /* 267549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267558 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267564 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267572 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267579 */     GIR_RootConstrainSelectedInstOperands,
     /* 267580 */     // GIR_Coverage, 5130,
     /* 267580 */     GIR_EraseRootFromParent_Done,
     /* 267581 */   // Label 5407: @267581
     /* 267581 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(267618), // Rule ID 5137 //
     /* 267586 */     // MIs[0] Operand 1
     /* 267586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267609 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267616 */     GIR_RootConstrainSelectedInstOperands,
     /* 267617 */     // GIR_Coverage, 5137,
     /* 267617 */     GIR_EraseRootFromParent_Done,
     /* 267618 */   // Label 5408: @267618
     /* 267618 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(267655), // Rule ID 5074 //
     /* 267623 */     // MIs[0] Operand 1
     /* 267623 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267646 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267653 */     GIR_RootConstrainSelectedInstOperands,
     /* 267654 */     // GIR_Coverage, 5074,
     /* 267654 */     GIR_EraseRootFromParent_Done,
     /* 267655 */   // Label 5409: @267655
     /* 267655 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(267692), // Rule ID 5081 //
     /* 267660 */     // MIs[0] Operand 1
     /* 267660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267683 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267690 */     GIR_RootConstrainSelectedInstOperands,
     /* 267691 */     // GIR_Coverage, 5081,
     /* 267691 */     GIR_EraseRootFromParent_Done,
     /* 267692 */   // Label 5410: @267692
     /* 267692 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(267729), // Rule ID 5088 //
     /* 267697 */     // MIs[0] Operand 1
     /* 267697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267710 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267716 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267720 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267727 */     GIR_RootConstrainSelectedInstOperands,
     /* 267728 */     // GIR_Coverage, 5088,
     /* 267728 */     GIR_EraseRootFromParent_Done,
     /* 267729 */   // Label 5411: @267729
     /* 267729 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(267766), // Rule ID 5095 //
     /* 267734 */     // MIs[0] Operand 1
     /* 267734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267747 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267753 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267757 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267764 */     GIR_RootConstrainSelectedInstOperands,
     /* 267765 */     // GIR_Coverage, 5095,
     /* 267765 */     GIR_EraseRootFromParent_Done,
     /* 267766 */   // Label 5412: @267766
     /* 267766 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(267803), // Rule ID 5102 //
     /* 267771 */     // MIs[0] Operand 1
     /* 267771 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267784 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267790 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267794 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267801 */     GIR_RootConstrainSelectedInstOperands,
     /* 267802 */     // GIR_Coverage, 5102,
     /* 267802 */     GIR_EraseRootFromParent_Done,
     /* 267803 */   // Label 5413: @267803
     /* 267803 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(267832), // Rule ID 5011 //
     /* 267808 */     // MIs[0] Operand 1
     /* 267808 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267821 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 267824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267830 */     GIR_RootConstrainSelectedInstOperands,
     /* 267831 */     // GIR_Coverage, 5011,
     /* 267831 */     GIR_EraseRootFromParent_Done,
     /* 267832 */   // Label 5414: @267832
     /* 267832 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(267861), // Rule ID 5018 //
     /* 267837 */     // MIs[0] Operand 1
     /* 267837 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267850 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267859 */     GIR_RootConstrainSelectedInstOperands,
     /* 267860 */     // GIR_Coverage, 5018,
     /* 267860 */     GIR_EraseRootFromParent_Done,
     /* 267861 */   // Label 5415: @267861
     /* 267861 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(267890), // Rule ID 5025 //
     /* 267866 */     // MIs[0] Operand 1
     /* 267866 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267879 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267888 */     GIR_RootConstrainSelectedInstOperands,
     /* 267889 */     // GIR_Coverage, 5025,
     /* 267889 */     GIR_EraseRootFromParent_Done,
     /* 267890 */   // Label 5416: @267890
     /* 267890 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(267919), // Rule ID 5032 //
     /* 267895 */     // MIs[0] Operand 1
     /* 267895 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 267900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267908 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 267911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267917 */     GIR_RootConstrainSelectedInstOperands,
     /* 267918 */     // GIR_Coverage, 5032,
     /* 267918 */     GIR_EraseRootFromParent_Done,
     /* 267919 */   // Label 5417: @267919
     /* 267919 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(267948), // Rule ID 5039 //
     /* 267924 */     // MIs[0] Operand 1
     /* 267924 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 267929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267937 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 267940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267946 */     GIR_RootConstrainSelectedInstOperands,
     /* 267947 */     // GIR_Coverage, 5039,
     /* 267947 */     GIR_EraseRootFromParent_Done,
     /* 267948 */   // Label 5418: @267948
     /* 267948 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(267977), // Rule ID 5046 //
     /* 267953 */     // MIs[0] Operand 1
     /* 267953 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267966 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267975 */     GIR_RootConstrainSelectedInstOperands,
     /* 267976 */     // GIR_Coverage, 5046,
     /* 267976 */     GIR_EraseRootFromParent_Done,
     /* 267977 */   // Label 5419: @267977
     /* 267977 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(268006), // Rule ID 5053 //
     /* 267982 */     // MIs[0] Operand 1
     /* 267982 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267995 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268004 */     GIR_RootConstrainSelectedInstOperands,
     /* 268005 */     // GIR_Coverage, 5053,
     /* 268005 */     GIR_EraseRootFromParent_Done,
     /* 268006 */   // Label 5420: @268006
     /* 268006 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(268035), // Rule ID 5060 //
     /* 268011 */     // MIs[0] Operand 1
     /* 268011 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268024 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 268024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 268027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268033 */     GIR_RootConstrainSelectedInstOperands,
     /* 268034 */     // GIR_Coverage, 5060,
     /* 268034 */     GIR_EraseRootFromParent_Done,
     /* 268035 */   // Label 5421: @268035
     /* 268035 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(268064), // Rule ID 5067 //
     /* 268040 */     // MIs[0] Operand 1
     /* 268040 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268053 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 268053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 268056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268062 */     GIR_RootConstrainSelectedInstOperands,
     /* 268063 */     // GIR_Coverage, 5067,
     /* 268063 */     GIR_EraseRootFromParent_Done,
     /* 268064 */   // Label 5422: @268064
     /* 268064 */   GIM_Reject,
     /* 268065 */ // Label 5403: @268065
     /* 268065 */ GIM_Reject,
     /* 268066 */ // Label 5320: @268066
     /* 268066 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(268713),
     /* 268071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 268077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268081 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(268118), // Rule ID 5112 //
     /* 268086 */     // MIs[0] Operand 1
     /* 268086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268095 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268101 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268109 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 268112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268116 */     GIR_RootConstrainSelectedInstOperands,
     /* 268117 */     // GIR_Coverage, 5112,
     /* 268117 */     GIR_EraseRootFromParent_Done,
     /* 268118 */   // Label 5424: @268118
     /* 268118 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(268155), // Rule ID 5119 //
     /* 268123 */     // MIs[0] Operand 1
     /* 268123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268146 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 268149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268153 */     GIR_RootConstrainSelectedInstOperands,
     /* 268154 */     // GIR_Coverage, 5119,
     /* 268154 */     GIR_EraseRootFromParent_Done,
     /* 268155 */   // Label 5425: @268155
     /* 268155 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(268192), // Rule ID 5126 //
     /* 268160 */     // MIs[0] Operand 1
     /* 268160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268169 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268183 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 268186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268190 */     GIR_RootConstrainSelectedInstOperands,
     /* 268191 */     // GIR_Coverage, 5126,
     /* 268191 */     GIR_EraseRootFromParent_Done,
     /* 268192 */   // Label 5426: @268192
     /* 268192 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(268229), // Rule ID 5133 //
     /* 268197 */     // MIs[0] Operand 1
     /* 268197 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268206 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268212 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268220 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 268223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268227 */     GIR_RootConstrainSelectedInstOperands,
     /* 268228 */     // GIR_Coverage, 5133,
     /* 268228 */     GIR_EraseRootFromParent_Done,
     /* 268229 */   // Label 5427: @268229
     /* 268229 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(268266), // Rule ID 5140 //
     /* 268234 */     // MIs[0] Operand 1
     /* 268234 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268243 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268249 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268257 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 268260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268264 */     GIR_RootConstrainSelectedInstOperands,
     /* 268265 */     // GIR_Coverage, 5140,
     /* 268265 */     GIR_EraseRootFromParent_Done,
     /* 268266 */   // Label 5428: @268266
     /* 268266 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(268303), // Rule ID 5077 //
     /* 268271 */     // MIs[0] Operand 1
     /* 268271 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268294 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 268297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268301 */     GIR_RootConstrainSelectedInstOperands,
     /* 268302 */     // GIR_Coverage, 5077,
     /* 268302 */     GIR_EraseRootFromParent_Done,
     /* 268303 */   // Label 5429: @268303
     /* 268303 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(268340), // Rule ID 5084 //
     /* 268308 */     // MIs[0] Operand 1
     /* 268308 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268331 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 268334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268338 */     GIR_RootConstrainSelectedInstOperands,
     /* 268339 */     // GIR_Coverage, 5084,
     /* 268339 */     GIR_EraseRootFromParent_Done,
     /* 268340 */   // Label 5430: @268340
     /* 268340 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(268377), // Rule ID 5091 //
     /* 268345 */     // MIs[0] Operand 1
     /* 268345 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268358 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268364 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268368 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 268371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268375 */     GIR_RootConstrainSelectedInstOperands,
     /* 268376 */     // GIR_Coverage, 5091,
     /* 268376 */     GIR_EraseRootFromParent_Done,
     /* 268377 */   // Label 5431: @268377
     /* 268377 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(268414), // Rule ID 5098 //
     /* 268382 */     // MIs[0] Operand 1
     /* 268382 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268405 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 268408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268412 */     GIR_RootConstrainSelectedInstOperands,
     /* 268413 */     // GIR_Coverage, 5098,
     /* 268413 */     GIR_EraseRootFromParent_Done,
     /* 268414 */   // Label 5432: @268414
     /* 268414 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(268451), // Rule ID 5105 //
     /* 268419 */     // MIs[0] Operand 1
     /* 268419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268438 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268442 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 268445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268449 */     GIR_RootConstrainSelectedInstOperands,
     /* 268450 */     // GIR_Coverage, 5105,
     /* 268450 */     GIR_EraseRootFromParent_Done,
     /* 268451 */   // Label 5433: @268451
     /* 268451 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(268480), // Rule ID 5014 //
     /* 268456 */     // MIs[0] Operand 1
     /* 268456 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268469 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 268472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268478 */     GIR_RootConstrainSelectedInstOperands,
     /* 268479 */     // GIR_Coverage, 5014,
     /* 268479 */     GIR_EraseRootFromParent_Done,
     /* 268480 */   // Label 5434: @268480
     /* 268480 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(268509), // Rule ID 5021 //
     /* 268485 */     // MIs[0] Operand 1
     /* 268485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268498 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268507 */     GIR_RootConstrainSelectedInstOperands,
     /* 268508 */     // GIR_Coverage, 5021,
     /* 268508 */     GIR_EraseRootFromParent_Done,
     /* 268509 */   // Label 5435: @268509
     /* 268509 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(268538), // Rule ID 5028 //
     /* 268514 */     // MIs[0] Operand 1
     /* 268514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268527 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268536 */     GIR_RootConstrainSelectedInstOperands,
     /* 268537 */     // GIR_Coverage, 5028,
     /* 268537 */     GIR_EraseRootFromParent_Done,
     /* 268538 */   // Label 5436: @268538
     /* 268538 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(268567), // Rule ID 5035 //
     /* 268543 */     // MIs[0] Operand 1
     /* 268543 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268556 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268565 */     GIR_RootConstrainSelectedInstOperands,
     /* 268566 */     // GIR_Coverage, 5035,
     /* 268566 */     GIR_EraseRootFromParent_Done,
     /* 268567 */   // Label 5437: @268567
     /* 268567 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(268596), // Rule ID 5042 //
     /* 268572 */     // MIs[0] Operand 1
     /* 268572 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268585 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268594 */     GIR_RootConstrainSelectedInstOperands,
     /* 268595 */     // GIR_Coverage, 5042,
     /* 268595 */     GIR_EraseRootFromParent_Done,
     /* 268596 */   // Label 5438: @268596
     /* 268596 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(268625), // Rule ID 5049 //
     /* 268601 */     // MIs[0] Operand 1
     /* 268601 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268614 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268623 */     GIR_RootConstrainSelectedInstOperands,
     /* 268624 */     // GIR_Coverage, 5049,
     /* 268624 */     GIR_EraseRootFromParent_Done,
     /* 268625 */   // Label 5439: @268625
     /* 268625 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(268654), // Rule ID 5056 //
     /* 268630 */     // MIs[0] Operand 1
     /* 268630 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268643 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268652 */     GIR_RootConstrainSelectedInstOperands,
     /* 268653 */     // GIR_Coverage, 5056,
     /* 268653 */     GIR_EraseRootFromParent_Done,
     /* 268654 */   // Label 5440: @268654
     /* 268654 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(268683), // Rule ID 5063 //
     /* 268659 */     // MIs[0] Operand 1
     /* 268659 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268672 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268681 */     GIR_RootConstrainSelectedInstOperands,
     /* 268682 */     // GIR_Coverage, 5063,
     /* 268682 */     GIR_EraseRootFromParent_Done,
     /* 268683 */   // Label 5441: @268683
     /* 268683 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(268712), // Rule ID 5070 //
     /* 268688 */     // MIs[0] Operand 1
     /* 268688 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268701 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268710 */     GIR_RootConstrainSelectedInstOperands,
     /* 268711 */     // GIR_Coverage, 5070,
     /* 268711 */     GIR_EraseRootFromParent_Done,
     /* 268712 */   // Label 5442: @268712
     /* 268712 */   GIM_Reject,
     /* 268713 */ // Label 5423: @268713
     /* 268713 */ GIM_Reject,
     /* 268714 */ // Label 5321: @268714
     /* 268714 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(269361),
     /* 268719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 268725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268729 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(268766), // Rule ID 5110 //
     /* 268734 */     // MIs[0] Operand 1
     /* 268734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268757 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268764 */     GIR_RootConstrainSelectedInstOperands,
     /* 268765 */     // GIR_Coverage, 5110,
     /* 268765 */     GIR_EraseRootFromParent_Done,
     /* 268766 */   // Label 5444: @268766
     /* 268766 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(268803), // Rule ID 5117 //
     /* 268771 */     // MIs[0] Operand 1
     /* 268771 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268794 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 268797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268801 */     GIR_RootConstrainSelectedInstOperands,
     /* 268802 */     // GIR_Coverage, 5117,
     /* 268802 */     GIR_EraseRootFromParent_Done,
     /* 268803 */   // Label 5445: @268803
     /* 268803 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(268840), // Rule ID 5124 //
     /* 268808 */     // MIs[0] Operand 1
     /* 268808 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268817 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268823 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268831 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 268834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268838 */     GIR_RootConstrainSelectedInstOperands,
     /* 268839 */     // GIR_Coverage, 5124,
     /* 268839 */     GIR_EraseRootFromParent_Done,
     /* 268840 */   // Label 5446: @268840
     /* 268840 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(268877), // Rule ID 5131 //
     /* 268845 */     // MIs[0] Operand 1
     /* 268845 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268854 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268868 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268875 */     GIR_RootConstrainSelectedInstOperands,
     /* 268876 */     // GIR_Coverage, 5131,
     /* 268876 */     GIR_EraseRootFromParent_Done,
     /* 268877 */   // Label 5447: @268877
     /* 268877 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(268914), // Rule ID 5138 //
     /* 268882 */     // MIs[0] Operand 1
     /* 268882 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268905 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 268908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268912 */     GIR_RootConstrainSelectedInstOperands,
     /* 268913 */     // GIR_Coverage, 5138,
     /* 268913 */     GIR_EraseRootFromParent_Done,
     /* 268914 */   // Label 5448: @268914
     /* 268914 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(268951), // Rule ID 5075 //
     /* 268919 */     // MIs[0] Operand 1
     /* 268919 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268942 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268949 */     GIR_RootConstrainSelectedInstOperands,
     /* 268950 */     // GIR_Coverage, 5075,
     /* 268950 */     GIR_EraseRootFromParent_Done,
     /* 268951 */   // Label 5449: @268951
     /* 268951 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(268988), // Rule ID 5082 //
     /* 268956 */     // MIs[0] Operand 1
     /* 268956 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268969 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268975 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268979 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268986 */     GIR_RootConstrainSelectedInstOperands,
     /* 268987 */     // GIR_Coverage, 5082,
     /* 268987 */     GIR_EraseRootFromParent_Done,
     /* 268988 */   // Label 5450: @268988
     /* 268988 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(269025), // Rule ID 5089 //
     /* 268993 */     // MIs[0] Operand 1
     /* 268993 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269016 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 269016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 269019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269023 */     GIR_RootConstrainSelectedInstOperands,
     /* 269024 */     // GIR_Coverage, 5089,
     /* 269024 */     GIR_EraseRootFromParent_Done,
     /* 269025 */   // Label 5451: @269025
     /* 269025 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(269062), // Rule ID 5096 //
     /* 269030 */     // MIs[0] Operand 1
     /* 269030 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269053 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 269053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 269056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269060 */     GIR_RootConstrainSelectedInstOperands,
     /* 269061 */     // GIR_Coverage, 5096,
     /* 269061 */     GIR_EraseRootFromParent_Done,
     /* 269062 */   // Label 5452: @269062
     /* 269062 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(269099), // Rule ID 5103 //
     /* 269067 */     // MIs[0] Operand 1
     /* 269067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 269080 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 269086 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 269088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269090 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 269090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 269093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269097 */     GIR_RootConstrainSelectedInstOperands,
     /* 269098 */     // GIR_Coverage, 5103,
     /* 269098 */     GIR_EraseRootFromParent_Done,
     /* 269099 */   // Label 5453: @269099
     /* 269099 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(269128), // Rule ID 5012 //
     /* 269104 */     // MIs[0] Operand 1
     /* 269104 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 269109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269117 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 269120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269126 */     GIR_RootConstrainSelectedInstOperands,
     /* 269127 */     // GIR_Coverage, 5012,
     /* 269127 */     GIR_EraseRootFromParent_Done,
     /* 269128 */   // Label 5454: @269128
     /* 269128 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(269157), // Rule ID 5019 //
     /* 269133 */     // MIs[0] Operand 1
     /* 269133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 269138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269146 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 269149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269155 */     GIR_RootConstrainSelectedInstOperands,
     /* 269156 */     // GIR_Coverage, 5019,
     /* 269156 */     GIR_EraseRootFromParent_Done,
     /* 269157 */   // Label 5455: @269157
     /* 269157 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(269186), // Rule ID 5026 //
     /* 269162 */     // MIs[0] Operand 1
     /* 269162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 269167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269175 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 269178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269184 */     GIR_RootConstrainSelectedInstOperands,
     /* 269185 */     // GIR_Coverage, 5026,
     /* 269185 */     GIR_EraseRootFromParent_Done,
     /* 269186 */   // Label 5456: @269186
     /* 269186 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(269215), // Rule ID 5033 //
     /* 269191 */     // MIs[0] Operand 1
     /* 269191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 269196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269204 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 269207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269213 */     GIR_RootConstrainSelectedInstOperands,
     /* 269214 */     // GIR_Coverage, 5033,
     /* 269214 */     GIR_EraseRootFromParent_Done,
     /* 269215 */   // Label 5457: @269215
     /* 269215 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(269244), // Rule ID 5040 //
     /* 269220 */     // MIs[0] Operand 1
     /* 269220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 269225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269233 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 269236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269242 */     GIR_RootConstrainSelectedInstOperands,
     /* 269243 */     // GIR_Coverage, 5040,
     /* 269243 */     GIR_EraseRootFromParent_Done,
     /* 269244 */   // Label 5458: @269244
     /* 269244 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(269273), // Rule ID 5047 //
     /* 269249 */     // MIs[0] Operand 1
     /* 269249 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 269254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269262 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 269262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 269265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269271 */     GIR_RootConstrainSelectedInstOperands,
     /* 269272 */     // GIR_Coverage, 5047,
     /* 269272 */     GIR_EraseRootFromParent_Done,
     /* 269273 */   // Label 5459: @269273
     /* 269273 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(269302), // Rule ID 5054 //
     /* 269278 */     // MIs[0] Operand 1
     /* 269278 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 269283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269291 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 269291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 269294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269300 */     GIR_RootConstrainSelectedInstOperands,
     /* 269301 */     // GIR_Coverage, 5054,
     /* 269301 */     GIR_EraseRootFromParent_Done,
     /* 269302 */   // Label 5460: @269302
     /* 269302 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(269331), // Rule ID 5061 //
     /* 269307 */     // MIs[0] Operand 1
     /* 269307 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 269312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269320 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 269320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 269323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269329 */     GIR_RootConstrainSelectedInstOperands,
     /* 269330 */     // GIR_Coverage, 5061,
     /* 269330 */     GIR_EraseRootFromParent_Done,
     /* 269331 */   // Label 5461: @269331
     /* 269331 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(269360), // Rule ID 5068 //
     /* 269336 */     // MIs[0] Operand 1
     /* 269336 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 269341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269349 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 269349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 269352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 269356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269358 */     GIR_RootConstrainSelectedInstOperands,
     /* 269359 */     // GIR_Coverage, 5068,
     /* 269359 */     GIR_EraseRootFromParent_Done,
     /* 269360 */   // Label 5462: @269360
     /* 269360 */   GIM_Reject,
     /* 269361 */ // Label 5443: @269361
     /* 269361 */ GIM_Reject,
     /* 269362 */ // Label 5322: @269362
     /* 269362 */ GIM_Reject,
     /* 269363 */ // Label 47: @269363
     /* 269363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5475*/ GIMT_Encode4(270068),
     /* 269374 */ /*GILLT_nxv1s1*//*Label 5463*/ GIMT_Encode4(269422),
     /* 269378 */ /*GILLT_nxv2s1*//*Label 5464*/ GIMT_Encode4(269451),
     /* 269382 */ /*GILLT_nxv2s16*//*Label 5465*/ GIMT_Encode4(269480),
     /* 269386 */ /*GILLT_nxv2s32*//*Label 5466*/ GIMT_Encode4(269509),
     /* 269390 */ /*GILLT_nxv2s64*//*Label 5467*/ GIMT_Encode4(269538),
     /* 269394 */ /*GILLT_nxv4s1*//*Label 5468*/ GIMT_Encode4(269647),
     /* 269398 */ /*GILLT_nxv4s16*//*Label 5469*/ GIMT_Encode4(269676),
     /* 269402 */ /*GILLT_nxv4s32*//*Label 5470*/ GIMT_Encode4(269705),
     /* 269406 */ /*GILLT_nxv8s1*//*Label 5471*/ GIMT_Encode4(269814),
     /* 269410 */ /*GILLT_nxv8s16*//*Label 5472*/ GIMT_Encode4(269843),
     /* 269414 */ /*GILLT_nxv16s1*//*Label 5473*/ GIMT_Encode4(269952),
     /* 269418 */ /*GILLT_nxv16s8*//*Label 5474*/ GIMT_Encode4(269981),
     /* 269422 */ // Label 5463: @269422
     /* 269422 */ GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(269450), // Rule ID 8295 //
     /* 269427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 269433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 269439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269443 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 269443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269448 */   GIR_RootConstrainSelectedInstOperands,
     /* 269449 */   // GIR_Coverage, 8295,
     /* 269449 */   GIR_Done,
     /* 269450 */ // Label 5476: @269450
     /* 269450 */ GIM_Reject,
     /* 269451 */ // Label 5464: @269451
     /* 269451 */ GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(269479), // Rule ID 8294 //
     /* 269456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 269465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 269468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269472 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 269472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269477 */   GIR_RootConstrainSelectedInstOperands,
     /* 269478 */   // GIR_Coverage, 8294,
     /* 269478 */   GIR_Done,
     /* 269479 */ // Label 5477: @269479
     /* 269479 */ GIM_Reject,
     /* 269480 */ // Label 5465: @269480
     /* 269480 */ GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(269508), // Rule ID 2727 //
     /* 269485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 269494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 269497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269501 */   // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 269501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269506 */   GIR_RootConstrainSelectedInstOperands,
     /* 269507 */   // GIR_Coverage, 2727,
     /* 269507 */   GIR_Done,
     /* 269508 */ // Label 5478: @269508
     /* 269508 */ GIM_Reject,
     /* 269509 */ // Label 5466: @269509
     /* 269509 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(269537), // Rule ID 2728 //
     /* 269514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 269523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 269526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269530 */   // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 269530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269535 */   GIR_RootConstrainSelectedInstOperands,
     /* 269536 */   // GIR_Coverage, 2728,
     /* 269536 */   GIR_Done,
     /* 269537 */ // Label 5479: @269537
     /* 269537 */ GIM_Reject,
     /* 269538 */ // Label 5467: @269538
     /* 269538 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(269646),
     /* 269543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269549 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(269601), // Rule ID 7345 //
     /* 269554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 269573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269577 */     // MIs[0] Op2
     /* 269577 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269584 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 269587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269599 */     GIR_RootConstrainSelectedInstOperands,
     /* 269600 */     // GIR_Coverage, 7345,
     /* 269600 */     GIR_EraseRootFromParent_Done,
     /* 269601 */   // Label 5481: @269601
     /* 269601 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(269623), // Rule ID 2723 //
     /* 269606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269616 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269621 */     GIR_RootConstrainSelectedInstOperands,
     /* 269622 */     // GIR_Coverage, 2723,
     /* 269622 */     GIR_Done,
     /* 269623 */   // Label 5482: @269623
     /* 269623 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(269645), // Rule ID 2729 //
     /* 269628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269638 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 269638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269643 */     GIR_RootConstrainSelectedInstOperands,
     /* 269644 */     // GIR_Coverage, 2729,
     /* 269644 */     GIR_Done,
     /* 269645 */   // Label 5483: @269645
     /* 269645 */   GIM_Reject,
     /* 269646 */ // Label 5480: @269646
     /* 269646 */ GIM_Reject,
     /* 269647 */ // Label 5468: @269647
     /* 269647 */ GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(269675), // Rule ID 8293 //
     /* 269652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 269661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 269664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269668 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 269668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269673 */   GIR_RootConstrainSelectedInstOperands,
     /* 269674 */   // GIR_Coverage, 8293,
     /* 269674 */   GIR_Done,
     /* 269675 */ // Label 5484: @269675
     /* 269675 */ GIM_Reject,
     /* 269676 */ // Label 5469: @269676
     /* 269676 */ GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(269704), // Rule ID 2725 //
     /* 269681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 269690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 269693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269697 */   // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 269697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269702 */   GIR_RootConstrainSelectedInstOperands,
     /* 269703 */   // GIR_Coverage, 2725,
     /* 269703 */   GIR_Done,
     /* 269704 */ // Label 5485: @269704
     /* 269704 */ GIM_Reject,
     /* 269705 */ // Label 5470: @269705
     /* 269705 */ GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(269813),
     /* 269710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269716 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(269768), // Rule ID 7343 //
     /* 269721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269744 */     // MIs[0] Op2
     /* 269744 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269751 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 269754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269766 */     GIR_RootConstrainSelectedInstOperands,
     /* 269767 */     // GIR_Coverage, 7343,
     /* 269767 */     GIR_EraseRootFromParent_Done,
     /* 269768 */   // Label 5487: @269768
     /* 269768 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(269790), // Rule ID 2722 //
     /* 269773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269783 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269788 */     GIR_RootConstrainSelectedInstOperands,
     /* 269789 */     // GIR_Coverage, 2722,
     /* 269789 */     GIR_Done,
     /* 269790 */   // Label 5488: @269790
     /* 269790 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(269812), // Rule ID 2726 //
     /* 269795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269805 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 269805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269810 */     GIR_RootConstrainSelectedInstOperands,
     /* 269811 */     // GIR_Coverage, 2726,
     /* 269811 */     GIR_Done,
     /* 269812 */   // Label 5489: @269812
     /* 269812 */   GIM_Reject,
     /* 269813 */ // Label 5486: @269813
     /* 269813 */ GIM_Reject,
     /* 269814 */ // Label 5471: @269814
     /* 269814 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(269842), // Rule ID 8292 //
     /* 269819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 269828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 269831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269835 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 269835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269840 */   GIR_RootConstrainSelectedInstOperands,
     /* 269841 */   // GIR_Coverage, 8292,
     /* 269841 */   GIR_Done,
     /* 269842 */ // Label 5490: @269842
     /* 269842 */ GIM_Reject,
     /* 269843 */ // Label 5472: @269843
     /* 269843 */ GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(269951),
     /* 269848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269854 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(269906), // Rule ID 7341 //
     /* 269859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 269878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269882 */     // MIs[0] Op2
     /* 269882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269889 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 269892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269904 */     GIR_RootConstrainSelectedInstOperands,
     /* 269905 */     // GIR_Coverage, 7341,
     /* 269905 */     GIR_EraseRootFromParent_Done,
     /* 269906 */   // Label 5492: @269906
     /* 269906 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(269928), // Rule ID 2721 //
     /* 269911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269921 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269926 */     GIR_RootConstrainSelectedInstOperands,
     /* 269927 */     // GIR_Coverage, 2721,
     /* 269927 */     GIR_Done,
     /* 269928 */   // Label 5493: @269928
     /* 269928 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(269950), // Rule ID 2724 //
     /* 269933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269943 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 269943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269948 */     GIR_RootConstrainSelectedInstOperands,
     /* 269949 */     // GIR_Coverage, 2724,
     /* 269949 */     GIR_Done,
     /* 269950 */   // Label 5494: @269950
     /* 269950 */   GIM_Reject,
     /* 269951 */ // Label 5491: @269951
     /* 269951 */ GIM_Reject,
     /* 269952 */ // Label 5473: @269952
     /* 269952 */ GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(269980), // Rule ID 8291 //
     /* 269957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 269966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 269969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269973 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 269973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269978 */   GIR_RootConstrainSelectedInstOperands,
     /* 269979 */   // GIR_Coverage, 8291,
     /* 269979 */   GIR_Done,
     /* 269980 */ // Label 5495: @269980
     /* 269980 */ GIM_Reject,
     /* 269981 */ // Label 5474: @269981
     /* 269981 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(270067),
     /* 269986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269992 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(270044), // Rule ID 7339 //
     /* 269997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 270012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 270016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 270020 */     // MIs[0] Op2
     /* 270020 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 270025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270027 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 270027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 270030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 270032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 270034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 270038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 270042 */     GIR_RootConstrainSelectedInstOperands,
     /* 270043 */     // GIR_Coverage, 7339,
     /* 270043 */     GIR_EraseRootFromParent_Done,
     /* 270044 */   // Label 5497: @270044
     /* 270044 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(270066), // Rule ID 2720 //
     /* 270049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 270055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270059 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 270059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 270064 */     GIR_RootConstrainSelectedInstOperands,
     /* 270065 */     // GIR_Coverage, 2720,
     /* 270065 */     GIR_Done,
     /* 270066 */   // Label 5498: @270066
     /* 270066 */   GIM_Reject,
     /* 270067 */ // Label 5496: @270067
     /* 270067 */ GIM_Reject,
     /* 270068 */ // Label 5475: @270068
     /* 270068 */ GIM_Reject,
     /* 270069 */ // Label 48: @270069
     /* 270069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5503*/ GIMT_Encode4(270552),
     /* 270080 */ /*GILLT_s64*//*Label 5499*/ GIMT_Encode4(270116), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270100 */ /*GILLT_v4s32*//*Label 5500*/ GIMT_Encode4(270147), GIMT_Encode4(0),
     /* 270108 */ /*GILLT_v8s16*//*Label 5501*/ GIMT_Encode4(270282),
     /* 270112 */ /*GILLT_v16s8*//*Label 5502*/ GIMT_Encode4(270417),
     /* 270116 */ // Label 5499: @270116
     /* 270116 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(270146), // Rule ID 128 //
     /* 270121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270139 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 270144 */   GIR_RootConstrainSelectedInstOperands,
     /* 270145 */   // GIR_Coverage, 128,
     /* 270145 */   GIR_Done,
     /* 270146 */ // Label 5504: @270146
     /* 270146 */ GIM_Reject,
     /* 270147 */ // Label 5500: @270147
     /* 270147 */ GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(270281), // Rule ID 6437 //
     /* 270152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270170 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 270170 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270173 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 270177 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270182 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270186 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270192 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270195 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270199 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270204 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270210 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270215 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270232 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270238 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270243 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 270255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270263 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 270271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270279 */   GIR_RootConstrainSelectedInstOperands,
     /* 270280 */   // GIR_Coverage, 6437,
     /* 270280 */   GIR_EraseRootFromParent_Done,
     /* 270281 */ // Label 5505: @270281
     /* 270281 */ GIM_Reject,
     /* 270282 */ // Label 5501: @270282
     /* 270282 */ GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(270416), // Rule ID 6436 //
     /* 270287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270305 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 270305 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270308 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 270312 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270317 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270321 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270327 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270330 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270334 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270339 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270345 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270350 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270367 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270373 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270378 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 270390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270395 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270398 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 270406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270414 */   GIR_RootConstrainSelectedInstOperands,
     /* 270415 */   // GIR_Coverage, 6436,
     /* 270415 */   GIR_EraseRootFromParent_Done,
     /* 270416 */ // Label 5506: @270416
     /* 270416 */ GIM_Reject,
     /* 270417 */ // Label 5502: @270417
     /* 270417 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(270551), // Rule ID 6435 //
     /* 270422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270440 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 270440 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270443 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 270447 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270452 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270456 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270474 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270480 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270485 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270490 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270493 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270497 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270502 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270508 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270513 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 270525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270530 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270533 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 270541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270549 */   GIR_RootConstrainSelectedInstOperands,
     /* 270550 */   // GIR_Coverage, 6435,
     /* 270550 */   GIR_EraseRootFromParent_Done,
     /* 270551 */ // Label 5507: @270551
     /* 270551 */ GIM_Reject,
     /* 270552 */ // Label 5503: @270552
     /* 270552 */ GIM_Reject,
     /* 270553 */ // Label 49: @270553
     /* 270553 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5512*/ GIMT_Encode4(271036),
     /* 270564 */ /*GILLT_s64*//*Label 5508*/ GIMT_Encode4(270600), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270584 */ /*GILLT_v4s32*//*Label 5509*/ GIMT_Encode4(270631), GIMT_Encode4(0),
     /* 270592 */ /*GILLT_v8s16*//*Label 5510*/ GIMT_Encode4(270766),
     /* 270596 */ /*GILLT_v16s8*//*Label 5511*/ GIMT_Encode4(270901),
     /* 270600 */ // Label 5508: @270600
     /* 270600 */ GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(270630), // Rule ID 127 //
     /* 270605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270623 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 270628 */   GIR_RootConstrainSelectedInstOperands,
     /* 270629 */   // GIR_Coverage, 127,
     /* 270629 */   GIR_Done,
     /* 270630 */ // Label 5513: @270630
     /* 270630 */ GIM_Reject,
     /* 270631 */ // Label 5509: @270631
     /* 270631 */ GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(270765), // Rule ID 6434 //
     /* 270636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270654 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 270654 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270657 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 270661 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270666 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270670 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270676 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270679 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270683 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270688 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270694 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270699 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270716 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270722 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270727 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 270739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270744 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270747 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 270755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270763 */   GIR_RootConstrainSelectedInstOperands,
     /* 270764 */   // GIR_Coverage, 6434,
     /* 270764 */   GIR_EraseRootFromParent_Done,
     /* 270765 */ // Label 5514: @270765
     /* 270765 */ GIM_Reject,
     /* 270766 */ // Label 5510: @270766
     /* 270766 */ GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(270900), // Rule ID 6433 //
     /* 270771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270789 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 270789 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270792 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 270796 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270801 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270805 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270811 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270814 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270818 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270823 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270829 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270834 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270839 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270842 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270846 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270851 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270857 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270862 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 270874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270879 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270882 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 270890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270898 */   GIR_RootConstrainSelectedInstOperands,
     /* 270899 */   // GIR_Coverage, 6433,
     /* 270899 */   GIR_EraseRootFromParent_Done,
     /* 270900 */ // Label 5515: @270900
     /* 270900 */ GIM_Reject,
     /* 270901 */ // Label 5511: @270901
     /* 270901 */ GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(271035), // Rule ID 6432 //
     /* 270906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270924 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 270924 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270927 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 270931 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270936 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270940 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270958 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270964 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270969 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270974 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270977 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270981 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270986 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270992 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270997 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 271005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 271009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271014 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 271017 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 271020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 271022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 271025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 271033 */   GIR_RootConstrainSelectedInstOperands,
     /* 271034 */   // GIR_Coverage, 6432,
     /* 271034 */   GIR_EraseRootFromParent_Done,
     /* 271035 */ // Label 5516: @271035
     /* 271035 */ GIM_Reject,
     /* 271036 */ // Label 5512: @271036
     /* 271036 */ GIM_Reject,
     /* 271037 */ // Label 50: @271037
     /* 271037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5528*/ GIMT_Encode4(271466),
     /* 271048 */ /*GILLT_v2s32*//*Label 5517*/ GIMT_Encode4(271124),
     /* 271052 */ /*GILLT_v2s64*//*Label 5518*/ GIMT_Encode4(271158),
     /* 271056 */ /*GILLT_v4s16*//*Label 5519*/ GIMT_Encode4(271192),
     /* 271060 */ /*GILLT_v4s32*//*Label 5520*/ GIMT_Encode4(271226),
     /* 271064 */ /*GILLT_v8s8*//*Label 5521*/ GIMT_Encode4(271260),
     /* 271068 */ /*GILLT_v8s16*//*Label 5522*/ GIMT_Encode4(271294),
     /* 271072 */ /*GILLT_v16s8*//*Label 5523*/ GIMT_Encode4(271328), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271092 */ /*GILLT_nxv2s64*//*Label 5524*/ GIMT_Encode4(271362), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271104 */ /*GILLT_nxv4s32*//*Label 5525*/ GIMT_Encode4(271388), GIMT_Encode4(0),
     /* 271112 */ /*GILLT_nxv8s16*//*Label 5526*/ GIMT_Encode4(271414), GIMT_Encode4(0),
     /* 271120 */ /*GILLT_nxv16s8*//*Label 5527*/ GIMT_Encode4(271440),
     /* 271124 */ // Label 5517: @271124
     /* 271124 */ GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(271157), // Rule ID 4960 //
     /* 271129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271150 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 271155 */   GIR_RootConstrainSelectedInstOperands,
     /* 271156 */   // GIR_Coverage, 4960,
     /* 271156 */   GIR_Done,
     /* 271157 */ // Label 5529: @271157
     /* 271157 */ GIM_Reject,
     /* 271158 */ // Label 5518: @271158
     /* 271158 */ GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(271191), // Rule ID 4964 //
     /* 271163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271184 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 271189 */   GIR_RootConstrainSelectedInstOperands,
     /* 271190 */   // GIR_Coverage, 4964,
     /* 271190 */   GIR_Done,
     /* 271191 */ // Label 5530: @271191
     /* 271191 */ GIM_Reject,
     /* 271192 */ // Label 5519: @271192
     /* 271192 */ GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(271225), // Rule ID 4959 //
     /* 271197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271218 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 271223 */   GIR_RootConstrainSelectedInstOperands,
     /* 271224 */   // GIR_Coverage, 4959,
     /* 271224 */   GIR_Done,
     /* 271225 */ // Label 5531: @271225
     /* 271225 */ GIM_Reject,
     /* 271226 */ // Label 5520: @271226
     /* 271226 */ GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(271259), // Rule ID 4963 //
     /* 271231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271252 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 271257 */   GIR_RootConstrainSelectedInstOperands,
     /* 271258 */   // GIR_Coverage, 4963,
     /* 271258 */   GIR_Done,
     /* 271259 */ // Label 5532: @271259
     /* 271259 */ GIM_Reject,
     /* 271260 */ // Label 5521: @271260
     /* 271260 */ GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(271293), // Rule ID 4958 //
     /* 271265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271286 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 271291 */   GIR_RootConstrainSelectedInstOperands,
     /* 271292 */   // GIR_Coverage, 4958,
     /* 271292 */   GIR_Done,
     /* 271293 */ // Label 5533: @271293
     /* 271293 */ GIM_Reject,
     /* 271294 */ // Label 5522: @271294
     /* 271294 */ GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(271327), // Rule ID 4962 //
     /* 271299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271320 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 271325 */   GIR_RootConstrainSelectedInstOperands,
     /* 271326 */   // GIR_Coverage, 4962,
     /* 271326 */   GIR_Done,
     /* 271327 */ // Label 5534: @271327
     /* 271327 */ GIM_Reject,
     /* 271328 */ // Label 5523: @271328
     /* 271328 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(271361), // Rule ID 4961 //
     /* 271333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271354 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 271359 */   GIR_RootConstrainSelectedInstOperands,
     /* 271360 */   // GIR_Coverage, 4961,
     /* 271360 */   GIR_Done,
     /* 271361 */ // Label 5535: @271361
     /* 271361 */ GIM_Reject,
     /* 271362 */ // Label 5524: @271362
     /* 271362 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(271387), // Rule ID 7297 //
     /* 271367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271380 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 271385 */   GIR_RootConstrainSelectedInstOperands,
     /* 271386 */   // GIR_Coverage, 7297,
     /* 271386 */   GIR_Done,
     /* 271387 */ // Label 5536: @271387
     /* 271387 */ GIM_Reject,
     /* 271388 */ // Label 5525: @271388
     /* 271388 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(271413), // Rule ID 7296 //
     /* 271393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271406 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 271411 */   GIR_RootConstrainSelectedInstOperands,
     /* 271412 */   // GIR_Coverage, 7296,
     /* 271412 */   GIR_Done,
     /* 271413 */ // Label 5537: @271413
     /* 271413 */ GIM_Reject,
     /* 271414 */ // Label 5526: @271414
     /* 271414 */ GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(271439), // Rule ID 7295 //
     /* 271419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271432 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 271437 */   GIR_RootConstrainSelectedInstOperands,
     /* 271438 */   // GIR_Coverage, 7295,
     /* 271438 */   GIR_Done,
     /* 271439 */ // Label 5538: @271439
     /* 271439 */ GIM_Reject,
     /* 271440 */ // Label 5527: @271440
     /* 271440 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(271465), // Rule ID 7294 //
     /* 271445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271458 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 271463 */   GIR_RootConstrainSelectedInstOperands,
     /* 271464 */   // GIR_Coverage, 7294,
     /* 271464 */   GIR_Done,
     /* 271465 */ // Label 5539: @271465
     /* 271465 */ GIM_Reject,
     /* 271466 */ // Label 5528: @271466
     /* 271466 */ GIM_Reject,
     /* 271467 */ // Label 51: @271467
     /* 271467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5551*/ GIMT_Encode4(271896),
     /* 271478 */ /*GILLT_v2s32*//*Label 5540*/ GIMT_Encode4(271554),
     /* 271482 */ /*GILLT_v2s64*//*Label 5541*/ GIMT_Encode4(271588),
     /* 271486 */ /*GILLT_v4s16*//*Label 5542*/ GIMT_Encode4(271622),
     /* 271490 */ /*GILLT_v4s32*//*Label 5543*/ GIMT_Encode4(271656),
     /* 271494 */ /*GILLT_v8s8*//*Label 5544*/ GIMT_Encode4(271690),
     /* 271498 */ /*GILLT_v8s16*//*Label 5545*/ GIMT_Encode4(271724),
     /* 271502 */ /*GILLT_v16s8*//*Label 5546*/ GIMT_Encode4(271758), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271522 */ /*GILLT_nxv2s64*//*Label 5547*/ GIMT_Encode4(271792), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271534 */ /*GILLT_nxv4s32*//*Label 5548*/ GIMT_Encode4(271818), GIMT_Encode4(0),
     /* 271542 */ /*GILLT_nxv8s16*//*Label 5549*/ GIMT_Encode4(271844), GIMT_Encode4(0),
     /* 271550 */ /*GILLT_nxv16s8*//*Label 5550*/ GIMT_Encode4(271870),
     /* 271554 */ // Label 5540: @271554
     /* 271554 */ GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(271587), // Rule ID 2468 //
     /* 271559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271580 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 271585 */   GIR_RootConstrainSelectedInstOperands,
     /* 271586 */   // GIR_Coverage, 2468,
     /* 271586 */   GIR_Done,
     /* 271587 */ // Label 5552: @271587
     /* 271587 */ GIM_Reject,
     /* 271588 */ // Label 5541: @271588
     /* 271588 */ GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(271621), // Rule ID 2472 //
     /* 271593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271614 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 271619 */   GIR_RootConstrainSelectedInstOperands,
     /* 271620 */   // GIR_Coverage, 2472,
     /* 271620 */   GIR_Done,
     /* 271621 */ // Label 5553: @271621
     /* 271621 */ GIM_Reject,
     /* 271622 */ // Label 5542: @271622
     /* 271622 */ GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(271655), // Rule ID 2467 //
     /* 271627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271648 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 271653 */   GIR_RootConstrainSelectedInstOperands,
     /* 271654 */   // GIR_Coverage, 2467,
     /* 271654 */   GIR_Done,
     /* 271655 */ // Label 5554: @271655
     /* 271655 */ GIM_Reject,
     /* 271656 */ // Label 5543: @271656
     /* 271656 */ GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(271689), // Rule ID 2471 //
     /* 271661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271682 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 271687 */   GIR_RootConstrainSelectedInstOperands,
     /* 271688 */   // GIR_Coverage, 2471,
     /* 271688 */   GIR_Done,
     /* 271689 */ // Label 5555: @271689
     /* 271689 */ GIM_Reject,
     /* 271690 */ // Label 5544: @271690
     /* 271690 */ GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(271723), // Rule ID 2466 //
     /* 271695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271716 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 271721 */   GIR_RootConstrainSelectedInstOperands,
     /* 271722 */   // GIR_Coverage, 2466,
     /* 271722 */   GIR_Done,
     /* 271723 */ // Label 5556: @271723
     /* 271723 */ GIM_Reject,
     /* 271724 */ // Label 5545: @271724
     /* 271724 */ GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(271757), // Rule ID 2470 //
     /* 271729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271750 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 271755 */   GIR_RootConstrainSelectedInstOperands,
     /* 271756 */   // GIR_Coverage, 2470,
     /* 271756 */   GIR_Done,
     /* 271757 */ // Label 5557: @271757
     /* 271757 */ GIM_Reject,
     /* 271758 */ // Label 5546: @271758
     /* 271758 */ GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(271791), // Rule ID 2469 //
     /* 271763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271784 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 271789 */   GIR_RootConstrainSelectedInstOperands,
     /* 271790 */   // GIR_Coverage, 2469,
     /* 271790 */   GIR_Done,
     /* 271791 */ // Label 5558: @271791
     /* 271791 */ GIM_Reject,
     /* 271792 */ // Label 5547: @271792
     /* 271792 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(271817), // Rule ID 7293 //
     /* 271797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271810 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 271815 */   GIR_RootConstrainSelectedInstOperands,
     /* 271816 */   // GIR_Coverage, 7293,
     /* 271816 */   GIR_Done,
     /* 271817 */ // Label 5559: @271817
     /* 271817 */ GIM_Reject,
     /* 271818 */ // Label 5548: @271818
     /* 271818 */ GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(271843), // Rule ID 7292 //
     /* 271823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271836 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 271841 */   GIR_RootConstrainSelectedInstOperands,
     /* 271842 */   // GIR_Coverage, 7292,
     /* 271842 */   GIR_Done,
     /* 271843 */ // Label 5560: @271843
     /* 271843 */ GIM_Reject,
     /* 271844 */ // Label 5549: @271844
     /* 271844 */ GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(271869), // Rule ID 7291 //
     /* 271849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271862 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 271867 */   GIR_RootConstrainSelectedInstOperands,
     /* 271868 */   // GIR_Coverage, 7291,
     /* 271868 */   GIR_Done,
     /* 271869 */ // Label 5561: @271869
     /* 271869 */ GIM_Reject,
     /* 271870 */ // Label 5550: @271870
     /* 271870 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(271895), // Rule ID 7290 //
     /* 271875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271888 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 271893 */   GIR_RootConstrainSelectedInstOperands,
     /* 271894 */   // GIR_Coverage, 7290,
     /* 271894 */   GIR_Done,
     /* 271895 */ // Label 5562: @271895
     /* 271895 */ GIM_Reject,
     /* 271896 */ // Label 5551: @271896
     /* 271896 */ GIM_Reject,
     /* 271897 */ // Label 52: @271897
     /* 271897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5574*/ GIMT_Encode4(272326),
     /* 271908 */ /*GILLT_v2s32*//*Label 5563*/ GIMT_Encode4(271984),
     /* 271912 */ /*GILLT_v2s64*//*Label 5564*/ GIMT_Encode4(272018),
     /* 271916 */ /*GILLT_v4s16*//*Label 5565*/ GIMT_Encode4(272052),
     /* 271920 */ /*GILLT_v4s32*//*Label 5566*/ GIMT_Encode4(272086),
     /* 271924 */ /*GILLT_v8s8*//*Label 5567*/ GIMT_Encode4(272120),
     /* 271928 */ /*GILLT_v8s16*//*Label 5568*/ GIMT_Encode4(272154),
     /* 271932 */ /*GILLT_v16s8*//*Label 5569*/ GIMT_Encode4(272188), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271952 */ /*GILLT_nxv2s64*//*Label 5570*/ GIMT_Encode4(272222), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271964 */ /*GILLT_nxv4s32*//*Label 5571*/ GIMT_Encode4(272248), GIMT_Encode4(0),
     /* 271972 */ /*GILLT_nxv8s16*//*Label 5572*/ GIMT_Encode4(272274), GIMT_Encode4(0),
     /* 271980 */ /*GILLT_nxv16s8*//*Label 5573*/ GIMT_Encode4(272300),
     /* 271984 */ // Label 5563: @271984
     /* 271984 */ GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(272017), // Rule ID 4974 //
     /* 271989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272010 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 272010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 272015 */   GIR_RootConstrainSelectedInstOperands,
     /* 272016 */   // GIR_Coverage, 4974,
     /* 272016 */   GIR_Done,
     /* 272017 */ // Label 5575: @272017
     /* 272017 */ GIM_Reject,
     /* 272018 */ // Label 5564: @272018
     /* 272018 */ GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(272051), // Rule ID 4978 //
     /* 272023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 272029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 272032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272044 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 272044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 272049 */   GIR_RootConstrainSelectedInstOperands,
     /* 272050 */   // GIR_Coverage, 4978,
     /* 272050 */   GIR_Done,
     /* 272051 */ // Label 5576: @272051
     /* 272051 */ GIM_Reject,
     /* 272052 */ // Label 5565: @272052
     /* 272052 */ GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(272085), // Rule ID 4973 //
     /* 272057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272078 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 272078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 272083 */   GIR_RootConstrainSelectedInstOperands,
     /* 272084 */   // GIR_Coverage, 4973,
     /* 272084 */   GIR_Done,
     /* 272085 */ // Label 5577: @272085
     /* 272085 */ GIM_Reject,
     /* 272086 */ // Label 5566: @272086
     /* 272086 */ GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(272119), // Rule ID 4977 //
     /* 272091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272112 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 272112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 272117 */   GIR_RootConstrainSelectedInstOperands,
     /* 272118 */   // GIR_Coverage, 4977,
     /* 272118 */   GIR_Done,
     /* 272119 */ // Label 5578: @272119
     /* 272119 */ GIM_Reject,
     /* 272120 */ // Label 5567: @272120
     /* 272120 */ GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(272153), // Rule ID 4972 //
     /* 272125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 272134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272146 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 272146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 272151 */   GIR_RootConstrainSelectedInstOperands,
     /* 272152 */   // GIR_Coverage, 4972,
     /* 272152 */   GIR_Done,
     /* 272153 */ // Label 5579: @272153
     /* 272153 */ GIM_Reject,
     /* 272154 */ // Label 5568: @272154
     /* 272154 */ GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(272187), // Rule ID 4976 //
     /* 272159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272180 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 272180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 272185 */   GIR_RootConstrainSelectedInstOperands,
     /* 272186 */   // GIR_Coverage, 4976,
     /* 272186 */   GIR_Done,
     /* 272187 */ // Label 5580: @272187
     /* 272187 */ GIM_Reject,
     /* 272188 */ // Label 5569: @272188
     /* 272188 */ GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(272221), // Rule ID 4975 //
     /* 272193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 272199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272214 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 272214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 272219 */   GIR_RootConstrainSelectedInstOperands,
     /* 272220 */   // GIR_Coverage, 4975,
     /* 272220 */   GIR_Done,
     /* 272221 */ // Label 5581: @272221
     /* 272221 */ GIM_Reject,
     /* 272222 */ // Label 5570: @272222
     /* 272222 */ GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(272247), // Rule ID 7305 //
     /* 272227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 272233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272240 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 272240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 272245 */   GIR_RootConstrainSelectedInstOperands,
     /* 272246 */   // GIR_Coverage, 7305,
     /* 272246 */   GIR_Done,
     /* 272247 */ // Label 5582: @272247
     /* 272247 */ GIM_Reject,
     /* 272248 */ // Label 5571: @272248
     /* 272248 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(272273), // Rule ID 7304 //
     /* 272253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 272259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272266 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 272266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 272271 */   GIR_RootConstrainSelectedInstOperands,
     /* 272272 */   // GIR_Coverage, 7304,
     /* 272272 */   GIR_Done,
     /* 272273 */ // Label 5583: @272273
     /* 272273 */ GIM_Reject,
     /* 272274 */ // Label 5572: @272274
     /* 272274 */ GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(272299), // Rule ID 7303 //
     /* 272279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 272285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272292 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 272292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 272297 */   GIR_RootConstrainSelectedInstOperands,
     /* 272298 */   // GIR_Coverage, 7303,
     /* 272298 */   GIR_Done,
     /* 272299 */ // Label 5584: @272299
     /* 272299 */ GIM_Reject,
     /* 272300 */ // Label 5573: @272300
     /* 272300 */ GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(272325), // Rule ID 7302 //
     /* 272305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 272311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272318 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 272318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 272323 */   GIR_RootConstrainSelectedInstOperands,
     /* 272324 */   // GIR_Coverage, 7302,
     /* 272324 */   GIR_Done,
     /* 272325 */ // Label 5585: @272325
     /* 272325 */ GIM_Reject,
     /* 272326 */ // Label 5574: @272326
     /* 272326 */ GIM_Reject,
     /* 272327 */ // Label 53: @272327
     /* 272327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5597*/ GIMT_Encode4(272756),
     /* 272338 */ /*GILLT_v2s32*//*Label 5586*/ GIMT_Encode4(272414),
     /* 272342 */ /*GILLT_v2s64*//*Label 5587*/ GIMT_Encode4(272448),
     /* 272346 */ /*GILLT_v4s16*//*Label 5588*/ GIMT_Encode4(272482),
     /* 272350 */ /*GILLT_v4s32*//*Label 5589*/ GIMT_Encode4(272516),
     /* 272354 */ /*GILLT_v8s8*//*Label 5590*/ GIMT_Encode4(272550),
     /* 272358 */ /*GILLT_v8s16*//*Label 5591*/ GIMT_Encode4(272584),
     /* 272362 */ /*GILLT_v16s8*//*Label 5592*/ GIMT_Encode4(272618), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272382 */ /*GILLT_nxv2s64*//*Label 5593*/ GIMT_Encode4(272652), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272394 */ /*GILLT_nxv4s32*//*Label 5594*/ GIMT_Encode4(272678), GIMT_Encode4(0),
     /* 272402 */ /*GILLT_nxv8s16*//*Label 5595*/ GIMT_Encode4(272704), GIMT_Encode4(0),
     /* 272410 */ /*GILLT_nxv16s8*//*Label 5596*/ GIMT_Encode4(272730),
     /* 272414 */ // Label 5586: @272414
     /* 272414 */ GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(272447), // Rule ID 4967 //
     /* 272419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272440 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 272440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 272445 */   GIR_RootConstrainSelectedInstOperands,
     /* 272446 */   // GIR_Coverage, 4967,
     /* 272446 */   GIR_Done,
     /* 272447 */ // Label 5598: @272447
     /* 272447 */ GIM_Reject,
     /* 272448 */ // Label 5587: @272448
     /* 272448 */ GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(272481), // Rule ID 4971 //
     /* 272453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 272459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 272462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272474 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 272474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 272479 */   GIR_RootConstrainSelectedInstOperands,
     /* 272480 */   // GIR_Coverage, 4971,
     /* 272480 */   GIR_Done,
     /* 272481 */ // Label 5599: @272481
     /* 272481 */ GIM_Reject,
     /* 272482 */ // Label 5588: @272482
     /* 272482 */ GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(272515), // Rule ID 4966 //
     /* 272487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272508 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 272508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 272513 */   GIR_RootConstrainSelectedInstOperands,
     /* 272514 */   // GIR_Coverage, 4966,
     /* 272514 */   GIR_Done,
     /* 272515 */ // Label 5600: @272515
     /* 272515 */ GIM_Reject,
     /* 272516 */ // Label 5589: @272516
     /* 272516 */ GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(272549), // Rule ID 4970 //
     /* 272521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272542 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 272542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 272547 */   GIR_RootConstrainSelectedInstOperands,
     /* 272548 */   // GIR_Coverage, 4970,
     /* 272548 */   GIR_Done,
     /* 272549 */ // Label 5601: @272549
     /* 272549 */ GIM_Reject,
     /* 272550 */ // Label 5590: @272550
     /* 272550 */ GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(272583), // Rule ID 4965 //
     /* 272555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 272564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272576 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 272576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 272581 */   GIR_RootConstrainSelectedInstOperands,
     /* 272582 */   // GIR_Coverage, 4965,
     /* 272582 */   GIR_Done,
     /* 272583 */ // Label 5602: @272583
     /* 272583 */ GIM_Reject,
     /* 272584 */ // Label 5591: @272584
     /* 272584 */ GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(272617), // Rule ID 4969 //
     /* 272589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272610 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 272610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 272615 */   GIR_RootConstrainSelectedInstOperands,
     /* 272616 */   // GIR_Coverage, 4969,
     /* 272616 */   GIR_Done,
     /* 272617 */ // Label 5603: @272617
     /* 272617 */ GIM_Reject,
     /* 272618 */ // Label 5592: @272618
     /* 272618 */ GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(272651), // Rule ID 4968 //
     /* 272623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 272629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272644 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 272644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 272649 */   GIR_RootConstrainSelectedInstOperands,
     /* 272650 */   // GIR_Coverage, 4968,
     /* 272650 */   GIR_Done,
     /* 272651 */ // Label 5604: @272651
     /* 272651 */ GIM_Reject,
     /* 272652 */ // Label 5593: @272652
     /* 272652 */ GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(272677), // Rule ID 7301 //
     /* 272657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 272663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272670 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 272670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 272675 */   GIR_RootConstrainSelectedInstOperands,
     /* 272676 */   // GIR_Coverage, 7301,
     /* 272676 */   GIR_Done,
     /* 272677 */ // Label 5605: @272677
     /* 272677 */ GIM_Reject,
     /* 272678 */ // Label 5594: @272678
     /* 272678 */ GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(272703), // Rule ID 7300 //
     /* 272683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 272689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272696 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 272696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 272701 */   GIR_RootConstrainSelectedInstOperands,
     /* 272702 */   // GIR_Coverage, 7300,
     /* 272702 */   GIR_Done,
     /* 272703 */ // Label 5606: @272703
     /* 272703 */ GIM_Reject,
     /* 272704 */ // Label 5595: @272704
     /* 272704 */ GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(272729), // Rule ID 7299 //
     /* 272709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 272715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272722 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 272722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 272727 */   GIR_RootConstrainSelectedInstOperands,
     /* 272728 */   // GIR_Coverage, 7299,
     /* 272728 */   GIR_Done,
     /* 272729 */ // Label 5607: @272729
     /* 272729 */ GIM_Reject,
     /* 272730 */ // Label 5596: @272730
     /* 272730 */ GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(272755), // Rule ID 7298 //
     /* 272735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 272741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272748 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 272748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 272753 */   GIR_RootConstrainSelectedInstOperands,
     /* 272754 */   // GIR_Coverage, 7298,
     /* 272754 */   GIR_Done,
     /* 272755 */ // Label 5608: @272755
     /* 272755 */ GIM_Reject,
     /* 272756 */ // Label 5597: @272756
     /* 272756 */ GIM_Reject,
     /* 272757 */ // Label 54: @272757
     /* 272757 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5620*/ GIMT_Encode4(274554),
     /* 272768 */ /*GILLT_s16*//*Label 5609*/ GIMT_Encode4(272852),
     /* 272772 */ /*GILLT_s32*//*Label 5610*/ GIMT_Encode4(273078),
     /* 272776 */ /*GILLT_s64*//*Label 5611*/ GIMT_Encode4(273432), GIMT_Encode4(0),
     /* 272784 */ /*GILLT_v2s32*//*Label 5612*/ GIMT_Encode4(273604),
     /* 272788 */ /*GILLT_v2s64*//*Label 5613*/ GIMT_Encode4(273642),
     /* 272792 */ /*GILLT_v4s16*//*Label 5614*/ GIMT_Encode4(273818),
     /* 272796 */ /*GILLT_v4s32*//*Label 5615*/ GIMT_Encode4(273856), GIMT_Encode4(0),
     /* 272804 */ /*GILLT_v8s16*//*Label 5616*/ GIMT_Encode4(274032), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272828 */ /*GILLT_nxv2s64*//*Label 5617*/ GIMT_Encode4(274476), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272840 */ /*GILLT_nxv4s32*//*Label 5618*/ GIMT_Encode4(274502), GIMT_Encode4(0),
     /* 272848 */ /*GILLT_nxv8s16*//*Label 5619*/ GIMT_Encode4(274528),
     /* 272852 */ // Label 5609: @272852
     /* 272852 */ GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(273077),
     /* 272857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 272860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 272863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272867 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(272958), // Rule ID 6825 //
     /* 272872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272893 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272909 */     // MIs[2] Rn
     /* 272909 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272914 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272920 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 272920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272932 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 272951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272956 */     GIR_RootConstrainSelectedInstOperands,
     /* 272957 */     // GIR_Coverage, 6825,
     /* 272957 */     GIR_EraseRootFromParent_Done,
     /* 272958 */   // Label 5622: @272958
     /* 272958 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(273049), // Rule ID 13682 //
     /* 272963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272984 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273000 */     // MIs[2] Rn
     /* 273000 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273005 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273011 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 273011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 273042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273047 */     GIR_RootConstrainSelectedInstOperands,
     /* 273048 */     // GIR_Coverage, 13682,
     /* 273048 */     GIR_EraseRootFromParent_Done,
     /* 273049 */   // Label 5623: @273049
     /* 273049 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(273076), // Rule ID 584 //
     /* 273054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 273057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 273061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 273065 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 273065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 273070 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273074 */     GIR_RootConstrainSelectedInstOperands,
     /* 273075 */     // GIR_Coverage, 584,
     /* 273075 */     GIR_Done,
     /* 273076 */   // Label 5624: @273076
     /* 273076 */   GIM_Reject,
     /* 273077 */ // Label 5621: @273077
     /* 273077 */ GIM_Reject,
     /* 273078 */ // Label 5610: @273078
     /* 273078 */ GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(273431),
     /* 273083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 273086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 273089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 273093 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(273184), // Rule ID 6823 //
     /* 273098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 273123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273135 */     // MIs[2] Rn
     /* 273135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273140 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 273144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273146 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 273146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 273177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273182 */     GIR_RootConstrainSelectedInstOperands,
     /* 273183 */     // GIR_Coverage, 6823,
     /* 273183 */     GIR_EraseRootFromParent_Done,
     /* 273184 */   // Label 5626: @273184
     /* 273184 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(273248), // Rule ID 12853 //
     /* 273189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 273214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273226 */     // MIs[2] Rn
     /* 273226 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273231 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 273235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273237 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 273237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 273240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273246 */     GIR_RootConstrainSelectedInstOperands,
     /* 273247 */     // GIR_Coverage, 12853,
     /* 273247 */     GIR_EraseRootFromParent_Done,
     /* 273248 */   // Label 5627: @273248
     /* 273248 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(273339), // Rule ID 13680 //
     /* 273253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 273278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273290 */     // MIs[2] Rn
     /* 273290 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273301 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 273301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 273304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273313 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 273332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273337 */     GIR_RootConstrainSelectedInstOperands,
     /* 273338 */     // GIR_Coverage, 13680,
     /* 273338 */     GIR_EraseRootFromParent_Done,
     /* 273339 */   // Label 5628: @273339
     /* 273339 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(273403), // Rule ID 15355 //
     /* 273344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 273369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273381 */     // MIs[2] Rn
     /* 273381 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273392 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 273392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 273395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273401 */     GIR_RootConstrainSelectedInstOperands,
     /* 273402 */     // GIR_Coverage, 15355,
     /* 273402 */     GIR_EraseRootFromParent_Done,
     /* 273403 */   // Label 5629: @273403
     /* 273403 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(273430), // Rule ID 586 //
     /* 273408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 273411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 273415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 273419 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 273419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 273424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273428 */     GIR_RootConstrainSelectedInstOperands,
     /* 273429 */     // GIR_Coverage, 586,
     /* 273429 */     GIR_Done,
     /* 273430 */   // Label 5630: @273430
     /* 273430 */   GIM_Reject,
     /* 273431 */ // Label 5625: @273431
     /* 273431 */ GIM_Reject,
     /* 273432 */ // Label 5611: @273432
     /* 273432 */ GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(273603),
     /* 273437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273447 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(273511), // Rule ID 6821 //
     /* 273452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 273477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273489 */     // MIs[2] Rn
     /* 273489 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 273498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273500 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273509 */     GIR_RootConstrainSelectedInstOperands,
     /* 273510 */     // GIR_Coverage, 6821,
     /* 273510 */     GIR_EraseRootFromParent_Done,
     /* 273511 */   // Label 5632: @273511
     /* 273511 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(273575), // Rule ID 13678 //
     /* 273516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273537 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 273541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273553 */     // MIs[2] Rn
     /* 273553 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273558 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273564 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273573 */     GIR_RootConstrainSelectedInstOperands,
     /* 273574 */     // GIR_Coverage, 13678,
     /* 273574 */     GIR_EraseRootFromParent_Done,
     /* 273575 */   // Label 5633: @273575
     /* 273575 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(273602), // Rule ID 588 //
     /* 273580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 273583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273591 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 273591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 273596 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273600 */     GIR_RootConstrainSelectedInstOperands,
     /* 273601 */     // GIR_Coverage, 588,
     /* 273601 */     GIR_Done,
     /* 273602 */   // Label 5634: @273602
     /* 273602 */   GIM_Reject,
     /* 273603 */ // Label 5631: @273603
     /* 273603 */ GIM_Reject,
     /* 273604 */ // Label 5612: @273604
     /* 273604 */ GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(273641), // Rule ID 1196 //
     /* 273609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273630 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 273630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 273635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273639 */   GIR_RootConstrainSelectedInstOperands,
     /* 273640 */   // GIR_Coverage, 1196,
     /* 273640 */   GIR_Done,
     /* 273641 */ // Label 5635: @273641
     /* 273641 */ GIM_Reject,
     /* 273642 */ // Label 5613: @273642
     /* 273642 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(273817),
     /* 273647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273657 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(273723), // Rule ID 6843 //
     /* 273662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273696 */     // MIs[2] Rn
     /* 273696 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273701 */     // MIs[2] Rm
     /* 273701 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273708 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273721 */     GIR_RootConstrainSelectedInstOperands,
     /* 273722 */     // GIR_Coverage, 6843,
     /* 273722 */     GIR_EraseRootFromParent_Done,
     /* 273723 */   // Label 5637: @273723
     /* 273723 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(273789), // Rule ID 13690 //
     /* 273728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273762 */     // MIs[2] Rn
     /* 273762 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273767 */     // MIs[2] Rm
     /* 273767 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273774 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273787 */     GIR_RootConstrainSelectedInstOperands,
     /* 273788 */     // GIR_Coverage, 13690,
     /* 273788 */     GIR_EraseRootFromParent_Done,
     /* 273789 */   // Label 5638: @273789
     /* 273789 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(273816), // Rule ID 1200 //
     /* 273794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273805 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 273805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 273810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273814 */     GIR_RootConstrainSelectedInstOperands,
     /* 273815 */     // GIR_Coverage, 1200,
     /* 273815 */     GIR_Done,
     /* 273816 */   // Label 5639: @273816
     /* 273816 */   GIM_Reject,
     /* 273817 */ // Label 5636: @273817
     /* 273817 */ GIM_Reject,
     /* 273818 */ // Label 5614: @273818
     /* 273818 */ GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(273855), // Rule ID 1192 //
     /* 273823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 273826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 273829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273844 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 273844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 273849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273853 */   GIR_RootConstrainSelectedInstOperands,
     /* 273854 */   // GIR_Coverage, 1192,
     /* 273854 */   GIR_Done,
     /* 273855 */ // Label 5640: @273855
     /* 273855 */ GIM_Reject,
     /* 273856 */ // Label 5615: @273856
     /* 273856 */ GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(274031),
     /* 273861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273871 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(273937), // Rule ID 6844 //
     /* 273876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 273884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 273910 */     // MIs[2] Rn
     /* 273910 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273915 */     // MIs[2] Rm
     /* 273915 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273922 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273935 */     GIR_RootConstrainSelectedInstOperands,
     /* 273936 */     // GIR_Coverage, 6844,
     /* 273936 */     GIR_EraseRootFromParent_Done,
     /* 273937 */   // Label 5642: @273937
     /* 273937 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(274003), // Rule ID 13691 //
     /* 273942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 273950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 273976 */     // MIs[2] Rn
     /* 273976 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273981 */     // MIs[2] Rm
     /* 273981 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273988 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 274001 */     GIR_RootConstrainSelectedInstOperands,
     /* 274002 */     // GIR_Coverage, 13691,
     /* 274002 */     GIR_EraseRootFromParent_Done,
     /* 274003 */   // Label 5643: @274003
     /* 274003 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(274030), // Rule ID 1198 //
     /* 274008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274019 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 274019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 274024 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274028 */     GIR_RootConstrainSelectedInstOperands,
     /* 274029 */     // GIR_Coverage, 1198,
     /* 274029 */     GIR_Done,
     /* 274030 */   // Label 5644: @274030
     /* 274030 */   GIM_Reject,
     /* 274031 */ // Label 5641: @274031
     /* 274031 */ GIM_Reject,
     /* 274032 */ // Label 5616: @274032
     /* 274032 */ GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(274475),
     /* 274037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274047 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(274116), // Rule ID 6845 //
     /* 274052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 274055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 274063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 274085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 274089 */     // MIs[2] Rn
     /* 274089 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 274094 */     // MIs[2] Rm
     /* 274094 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 274099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 274101 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 274101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 274104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 274110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 274114 */     GIR_RootConstrainSelectedInstOperands,
     /* 274115 */     // GIR_Coverage, 6845,
     /* 274115 */     GIR_EraseRootFromParent_Done,
     /* 274116 */   // Label 5646: @274116
     /* 274116 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(274185), // Rule ID 13692 //
     /* 274121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 274124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 274132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 274154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 274158 */     // MIs[2] Rn
     /* 274158 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 274163 */     // MIs[2] Rm
     /* 274163 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 274168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 274170 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 274170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 274179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 274183 */     GIR_RootConstrainSelectedInstOperands,
     /* 274184 */     // GIR_Coverage, 13692,
     /* 274184 */     GIR_EraseRootFromParent_Done,
     /* 274185 */   // Label 5647: @274185
     /* 274185 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(274212), // Rule ID 1194 //
     /* 274190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274201 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 274201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 274206 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274210 */     GIR_RootConstrainSelectedInstOperands,
     /* 274211 */     // GIR_Coverage, 1194,
     /* 274211 */     GIR_Done,
     /* 274212 */   // Label 5648: @274212
     /* 274212 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(274474), // Rule ID 6914 //
     /* 274217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 274220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274228 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 274228 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 274231 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274235 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274240 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 274244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 274246 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 274249 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274253 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274258 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 274262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 274264 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 274267 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 274271 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274276 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 274279 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 274282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 274284 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 274287 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274291 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274296 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 274302 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274307 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274312 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 274315 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274319 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274324 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 274327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 274329 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 274332 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274336 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274341 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 274347 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274352 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274357 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 274360 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274364 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274369 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 274372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 274374 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 274377 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 274381 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274386 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 274389 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 274392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 274394 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 274397 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 274401 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274406 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 274409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 274411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 274414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 274418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 274425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 274428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 274432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 274440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 274443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 274446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 274464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 274472 */     GIR_RootConstrainSelectedInstOperands,
     /* 274473 */     // GIR_Coverage, 6914,
     /* 274473 */     GIR_EraseRootFromParent_Done,
     /* 274474 */   // Label 5649: @274474
     /* 274474 */   GIM_Reject,
     /* 274475 */ // Label 5645: @274475
     /* 274475 */ GIM_Reject,
     /* 274476 */ // Label 5617: @274476
     /* 274476 */ GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(274501), // Rule ID 2810 //
     /* 274481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274494 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 274494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 274499 */   GIR_RootConstrainSelectedInstOperands,
     /* 274500 */   // GIR_Coverage, 2810,
     /* 274500 */   GIR_Done,
     /* 274501 */ // Label 5650: @274501
     /* 274501 */ GIM_Reject,
     /* 274502 */ // Label 5618: @274502
     /* 274502 */ GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(274527), // Rule ID 2808 //
     /* 274507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274520 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 274520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 274525 */   GIR_RootConstrainSelectedInstOperands,
     /* 274526 */   // GIR_Coverage, 2808,
     /* 274526 */   GIR_Done,
     /* 274527 */ // Label 5651: @274527
     /* 274527 */ GIM_Reject,
     /* 274528 */ // Label 5619: @274528
     /* 274528 */ GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(274553), // Rule ID 2806 //
     /* 274533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274546 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 274546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 274551 */   GIR_RootConstrainSelectedInstOperands,
     /* 274552 */   // GIR_Coverage, 2806,
     /* 274552 */   GIR_Done,
     /* 274553 */ // Label 5652: @274553
     /* 274553 */ GIM_Reject,
     /* 274554 */ // Label 5620: @274554
     /* 274554 */ GIM_Reject,
     /* 274555 */ // Label 55: @274555
     /* 274555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5664*/ GIMT_Encode4(275292),
     /* 274566 */ /*GILLT_s16*//*Label 5653*/ GIMT_Encode4(274650),
     /* 274570 */ /*GILLT_s32*//*Label 5654*/ GIMT_Encode4(274688),
     /* 274574 */ /*GILLT_s64*//*Label 5655*/ GIMT_Encode4(274726), GIMT_Encode4(0),
     /* 274582 */ /*GILLT_v2s32*//*Label 5656*/ GIMT_Encode4(274764),
     /* 274586 */ /*GILLT_v2s64*//*Label 5657*/ GIMT_Encode4(274802),
     /* 274590 */ /*GILLT_v4s16*//*Label 5658*/ GIMT_Encode4(274840),
     /* 274594 */ /*GILLT_v4s32*//*Label 5659*/ GIMT_Encode4(274878), GIMT_Encode4(0),
     /* 274602 */ /*GILLT_v8s16*//*Label 5660*/ GIMT_Encode4(274916), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274626 */ /*GILLT_nxv2s64*//*Label 5661*/ GIMT_Encode4(275214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274638 */ /*GILLT_nxv4s32*//*Label 5662*/ GIMT_Encode4(275240), GIMT_Encode4(0),
     /* 274646 */ /*GILLT_nxv8s16*//*Label 5663*/ GIMT_Encode4(275266),
     /* 274650 */ // Label 5653: @274650
     /* 274650 */ GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(274687), // Rule ID 632 //
     /* 274655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 274658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 274664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274676 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 274676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 274681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274685 */   GIR_RootConstrainSelectedInstOperands,
     /* 274686 */   // GIR_Coverage, 632,
     /* 274686 */   GIR_Done,
     /* 274687 */ // Label 5665: @274687
     /* 274687 */ GIM_Reject,
     /* 274688 */ // Label 5654: @274688
     /* 274688 */ GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(274725), // Rule ID 634 //
     /* 274693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 274699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 274702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274714 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 274714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 274719 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274723 */   GIR_RootConstrainSelectedInstOperands,
     /* 274724 */   // GIR_Coverage, 634,
     /* 274724 */   GIR_Done,
     /* 274725 */ // Label 5666: @274725
     /* 274725 */ GIM_Reject,
     /* 274726 */ // Label 5655: @274726
     /* 274726 */ GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(274763), // Rule ID 636 //
     /* 274731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 274737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274752 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 274752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 274757 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274761 */   GIR_RootConstrainSelectedInstOperands,
     /* 274762 */   // GIR_Coverage, 636,
     /* 274762 */   GIR_Done,
     /* 274763 */ // Label 5667: @274763
     /* 274763 */ GIM_Reject,
     /* 274764 */ // Label 5656: @274764
     /* 274764 */ GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(274801), // Rule ID 1336 //
     /* 274769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274790 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 274790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 274795 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274799 */   GIR_RootConstrainSelectedInstOperands,
     /* 274800 */   // GIR_Coverage, 1336,
     /* 274800 */   GIR_Done,
     /* 274801 */ // Label 5668: @274801
     /* 274801 */ GIM_Reject,
     /* 274802 */ // Label 5657: @274802
     /* 274802 */ GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(274839), // Rule ID 1340 //
     /* 274807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274828 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 274828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 274833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274837 */   GIR_RootConstrainSelectedInstOperands,
     /* 274838 */   // GIR_Coverage, 1340,
     /* 274838 */   GIR_Done,
     /* 274839 */ // Label 5669: @274839
     /* 274839 */ GIM_Reject,
     /* 274840 */ // Label 5658: @274840
     /* 274840 */ GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(274877), // Rule ID 1332 //
     /* 274845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274866 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 274866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 274871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274875 */   GIR_RootConstrainSelectedInstOperands,
     /* 274876 */   // GIR_Coverage, 1332,
     /* 274876 */   GIR_Done,
     /* 274877 */ // Label 5670: @274877
     /* 274877 */ GIM_Reject,
     /* 274878 */ // Label 5659: @274878
     /* 274878 */ GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(274915), // Rule ID 1338 //
     /* 274883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274904 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 274904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274909 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274913 */   GIR_RootConstrainSelectedInstOperands,
     /* 274914 */   // GIR_Coverage, 1338,
     /* 274914 */   GIR_Done,
     /* 274915 */ // Label 5671: @274915
     /* 274915 */ GIM_Reject,
     /* 274916 */ // Label 5660: @274916
     /* 274916 */ GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(275213),
     /* 274921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274939 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(274958), // Rule ID 1334 //
     /* 274944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274947 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 274947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 274952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274956 */     GIR_RootConstrainSelectedInstOperands,
     /* 274957 */     // GIR_Coverage, 1334,
     /* 274957 */     GIR_Done,
     /* 274958 */   // Label 5673: @274958
     /* 274958 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(275212), // Rule ID 6920 //
     /* 274963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 274966 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 274966 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 274969 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274973 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274978 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 274982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 274984 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 274987 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274991 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274996 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 275000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 275002 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 275005 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 275009 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275014 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 275017 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 275020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 275022 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 275025 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275029 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275034 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 275040 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275045 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275050 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 275053 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 275057 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275062 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 275065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 275067 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 275070 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275074 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275079 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 275085 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275090 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275095 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 275098 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 275102 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275107 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 275110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 275112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 275115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 275119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275124 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 275127 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 275130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 275132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 275135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 275139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275144 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 275147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 275149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 275152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 275166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 275170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 275178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 275181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 275184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 275202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 275210 */     GIR_RootConstrainSelectedInstOperands,
     /* 275211 */     // GIR_Coverage, 6920,
     /* 275211 */     GIR_EraseRootFromParent_Done,
     /* 275212 */   // Label 5674: @275212
     /* 275212 */   GIM_Reject,
     /* 275213 */ // Label 5672: @275213
     /* 275213 */ GIM_Reject,
     /* 275214 */ // Label 5661: @275214
     /* 275214 */ GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(275239), // Rule ID 8044 //
     /* 275219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 275225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 275228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275232 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 275232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 275237 */   GIR_RootConstrainSelectedInstOperands,
     /* 275238 */   // GIR_Coverage, 8044,
     /* 275238 */   GIR_Done,
     /* 275239 */ // Label 5675: @275239
     /* 275239 */ GIM_Reject,
     /* 275240 */ // Label 5662: @275240
     /* 275240 */ GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(275265), // Rule ID 8042 //
     /* 275245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 275251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275258 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 275258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 275263 */   GIR_RootConstrainSelectedInstOperands,
     /* 275264 */   // GIR_Coverage, 8042,
     /* 275264 */   GIR_Done,
     /* 275265 */ // Label 5676: @275265
     /* 275265 */ GIM_Reject,
     /* 275266 */ // Label 5663: @275266
     /* 275266 */ GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(275291), // Rule ID 8040 //
     /* 275271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 275277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 275280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275284 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 275284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 275289 */   GIR_RootConstrainSelectedInstOperands,
     /* 275290 */   // GIR_Coverage, 8040,
     /* 275290 */   GIR_Done,
     /* 275291 */ // Label 5677: @275291
     /* 275291 */ GIM_Reject,
     /* 275292 */ // Label 5664: @275292
     /* 275292 */ GIM_Reject,
     /* 275293 */ // Label 56: @275293
     /* 275293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5689*/ GIMT_Encode4(279388),
     /* 275304 */ /*GILLT_s16*//*Label 5678*/ GIMT_Encode4(275388),
     /* 275308 */ /*GILLT_s32*//*Label 5679*/ GIMT_Encode4(276030),
     /* 275312 */ /*GILLT_s64*//*Label 5680*/ GIMT_Encode4(276660), GIMT_Encode4(0),
     /* 275320 */ /*GILLT_v2s32*//*Label 5681*/ GIMT_Encode4(277290),
     /* 275324 */ /*GILLT_v2s64*//*Label 5682*/ GIMT_Encode4(277820),
     /* 275328 */ /*GILLT_v4s16*//*Label 5683*/ GIMT_Encode4(278178),
     /* 275332 */ /*GILLT_v4s32*//*Label 5684*/ GIMT_Encode4(278520), GIMT_Encode4(0),
     /* 275340 */ /*GILLT_v8s16*//*Label 5685*/ GIMT_Encode4(278878), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275364 */ /*GILLT_nxv2s64*//*Label 5686*/ GIMT_Encode4(279310), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 275376 */ /*GILLT_nxv4s32*//*Label 5687*/ GIMT_Encode4(279336), GIMT_Encode4(0),
     /* 275384 */ /*GILLT_nxv8s16*//*Label 5688*/ GIMT_Encode4(279362),
     /* 275388 */ // Label 5678: @275388
     /* 275388 */ GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(276029),
     /* 275393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 275399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275403 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(275516), // Rule ID 6147 //
     /* 275408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 275461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275465 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275469 */     // MIs[3] Operand 1
     /* 275469 */     // No operand predicates
     /* 275469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275471 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 275511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 275514 */     GIR_RootConstrainSelectedInstOperands,
     /* 275515 */     // GIR_Coverage, 6147,
     /* 275515 */     GIR_EraseRootFromParent_Done,
     /* 275516 */   // Label 5691: @275516
     /* 275516 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(275629), // Rule ID 13653 //
     /* 275521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275553 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275557 */     // MIs[2] Operand 1
     /* 275557 */     // No operand predicates
     /* 275557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 275561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275569 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 275573 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275578 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 275582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275584 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275627 */     GIR_RootConstrainSelectedInstOperands,
     /* 275628 */     // GIR_Coverage, 13653,
     /* 275628 */     GIR_EraseRootFromParent_Done,
     /* 275629 */   // Label 5692: @275629
     /* 275629 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(275708), // Rule ID 13590 //
     /* 275634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275658 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275668 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275706 */     GIR_RootConstrainSelectedInstOperands,
     /* 275707 */     // GIR_Coverage, 13590,
     /* 275707 */     GIR_EraseRootFromParent_Done,
     /* 275708 */   // Label 5693: @275708
     /* 275708 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(275787), // Rule ID 4743 //
     /* 275713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275747 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275759 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275785 */     GIR_RootConstrainSelectedInstOperands,
     /* 275786 */     // GIR_Coverage, 4743,
     /* 275786 */     GIR_EraseRootFromParent_Done,
     /* 275787 */   // Label 5694: @275787
     /* 275787 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(275850), // Rule ID 13205 //
     /* 275792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275824 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275828 */     // MIs[2] Operand 1
     /* 275828 */     // No operand predicates
     /* 275828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275834 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275848 */     GIR_RootConstrainSelectedInstOperands,
     /* 275849 */     // GIR_Coverage, 13205,
     /* 275849 */     GIR_EraseRootFromParent_Done,
     /* 275850 */   // Label 5695: @275850
     /* 275850 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(275913), // Rule ID 2005 //
     /* 275855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275891 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275895 */     // MIs[2] Operand 1
     /* 275895 */     // No operand predicates
     /* 275895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275897 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275911 */     GIR_RootConstrainSelectedInstOperands,
     /* 275912 */     // GIR_Coverage, 2005,
     /* 275912 */     GIR_EraseRootFromParent_Done,
     /* 275913 */   // Label 5696: @275913
     /* 275913 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(275957), // Rule ID 4748 //
     /* 275918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275944 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275953 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 275955 */     GIR_RootConstrainSelectedInstOperands,
     /* 275956 */     // GIR_Coverage, 4748,
     /* 275956 */     GIR_EraseRootFromParent_Done,
     /* 275957 */   // Label 5697: @275957
     /* 275957 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(276001), // Rule ID 13595 //
     /* 275962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275988 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275997 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 275999 */     GIR_RootConstrainSelectedInstOperands,
     /* 276000 */     // GIR_Coverage, 13595,
     /* 276000 */     GIR_EraseRootFromParent_Done,
     /* 276001 */   // Label 5698: @276001
     /* 276001 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(276028), // Rule ID 620 //
     /* 276006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 276009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 276013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 276017 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 276017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 276022 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276026 */     GIR_RootConstrainSelectedInstOperands,
     /* 276027 */     // GIR_Coverage, 620,
     /* 276027 */     GIR_Done,
     /* 276028 */   // Label 5699: @276028
     /* 276028 */   GIM_Reject,
     /* 276029 */ // Label 5690: @276029
     /* 276029 */ GIM_Reject,
     /* 276030 */ // Label 5679: @276030
     /* 276030 */ GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(276659),
     /* 276035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 276038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 276041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276045 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(276158), // Rule ID 6149 //
     /* 276050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276074 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276111 */     // MIs[3] Operand 1
     /* 276111 */     // No operand predicates
     /* 276111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276113 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 276113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 276116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276125 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 276131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276156 */     GIR_RootConstrainSelectedInstOperands,
     /* 276157 */     // GIR_Coverage, 6149,
     /* 276157 */     GIR_EraseRootFromParent_Done,
     /* 276158 */   // Label 5701: @276158
     /* 276158 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(276271), // Rule ID 13655 //
     /* 276163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276199 */     // MIs[2] Operand 1
     /* 276199 */     // No operand predicates
     /* 276199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 276203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276211 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 276215 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276220 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 276224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276226 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 276226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 276229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276238 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 276244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276269 */     GIR_RootConstrainSelectedInstOperands,
     /* 276270 */     // GIR_Coverage, 13655,
     /* 276270 */     GIR_EraseRootFromParent_Done,
     /* 276271 */   // Label 5702: @276271
     /* 276271 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(276347), // Rule ID 13592 //
     /* 276276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276307 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 276307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 276310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 276325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 276338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276345 */     GIR_RootConstrainSelectedInstOperands,
     /* 276346 */     // GIR_Coverage, 13592,
     /* 276346 */     GIR_EraseRootFromParent_Done,
     /* 276347 */   // Label 5703: @276347
     /* 276347 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(276423), // Rule ID 4745 //
     /* 276352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276377 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276383 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 276383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 276386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276395 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 276401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 276414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276421 */     GIR_RootConstrainSelectedInstOperands,
     /* 276422 */     // GIR_Coverage, 4745,
     /* 276422 */     GIR_EraseRootFromParent_Done,
     /* 276423 */   // Label 5704: @276423
     /* 276423 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(276486), // Rule ID 13207 //
     /* 276428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276460 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276464 */     // MIs[2] Operand 1
     /* 276464 */     // No operand predicates
     /* 276464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276470 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276484 */     GIR_RootConstrainSelectedInstOperands,
     /* 276485 */     // GIR_Coverage, 13207,
     /* 276485 */     GIR_EraseRootFromParent_Done,
     /* 276486 */   // Label 5705: @276486
     /* 276486 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(276549), // Rule ID 2007 //
     /* 276491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276531 */     // MIs[2] Operand 1
     /* 276531 */     // No operand predicates
     /* 276531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276533 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276547 */     GIR_RootConstrainSelectedInstOperands,
     /* 276548 */     // GIR_Coverage, 2007,
     /* 276548 */     GIR_EraseRootFromParent_Done,
     /* 276549 */   // Label 5706: @276549
     /* 276549 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(276590), // Rule ID 4749 //
     /* 276554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276577 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276586 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 276588 */     GIR_RootConstrainSelectedInstOperands,
     /* 276589 */     // GIR_Coverage, 4749,
     /* 276589 */     GIR_EraseRootFromParent_Done,
     /* 276590 */   // Label 5707: @276590
     /* 276590 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(276631), // Rule ID 13596 //
     /* 276595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276618 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276627 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 276629 */     GIR_RootConstrainSelectedInstOperands,
     /* 276630 */     // GIR_Coverage, 13596,
     /* 276630 */     GIR_EraseRootFromParent_Done,
     /* 276631 */   // Label 5708: @276631
     /* 276631 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(276658), // Rule ID 622 //
     /* 276636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276647 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 276647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 276652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276656 */     GIR_RootConstrainSelectedInstOperands,
     /* 276657 */     // GIR_Coverage, 622,
     /* 276657 */     GIR_Done,
     /* 276658 */   // Label 5709: @276658
     /* 276658 */   GIM_Reject,
     /* 276659 */ // Label 5700: @276659
     /* 276659 */ GIM_Reject,
     /* 276660 */ // Label 5680: @276660
     /* 276660 */ GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(277289),
     /* 276665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276675 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(276788), // Rule ID 6151 //
     /* 276680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276737 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276741 */     // MIs[3] Operand 1
     /* 276741 */     // No operand predicates
     /* 276741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276743 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276755 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276786 */     GIR_RootConstrainSelectedInstOperands,
     /* 276787 */     // GIR_Coverage, 6151,
     /* 276787 */     GIR_EraseRootFromParent_Done,
     /* 276788 */   // Label 5711: @276788
     /* 276788 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(276901), // Rule ID 13657 //
     /* 276793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276829 */     // MIs[2] Operand 1
     /* 276829 */     // No operand predicates
     /* 276829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 276833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 276845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276850 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 276854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276856 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276868 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276899 */     GIR_RootConstrainSelectedInstOperands,
     /* 276900 */     // GIR_Coverage, 13657,
     /* 276900 */     GIR_EraseRootFromParent_Done,
     /* 276901 */   // Label 5712: @276901
     /* 276901 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(276977), // Rule ID 13594 //
     /* 276906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276937 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 276937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276949 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276975 */     GIR_RootConstrainSelectedInstOperands,
     /* 276976 */     // GIR_Coverage, 13594,
     /* 276976 */     GIR_EraseRootFromParent_Done,
     /* 276977 */   // Label 5713: @276977
     /* 276977 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(277053), // Rule ID 4747 //
     /* 276982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277007 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 277011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277013 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 277013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 277031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 277044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277051 */     GIR_RootConstrainSelectedInstOperands,
     /* 277052 */     // GIR_Coverage, 4747,
     /* 277052 */     GIR_EraseRootFromParent_Done,
     /* 277053 */   // Label 5714: @277053
     /* 277053 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(277116), // Rule ID 13209 //
     /* 277058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 277069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277090 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277094 */     // MIs[2] Operand 1
     /* 277094 */     // No operand predicates
     /* 277094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277100 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 277103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277114 */     GIR_RootConstrainSelectedInstOperands,
     /* 277115 */     // GIR_Coverage, 13209,
     /* 277115 */     GIR_EraseRootFromParent_Done,
     /* 277116 */   // Label 5715: @277116
     /* 277116 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(277179), // Rule ID 2009 //
     /* 277121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 277136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277157 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277161 */     // MIs[2] Operand 1
     /* 277161 */     // No operand predicates
     /* 277161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277163 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 277166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277177 */     GIR_RootConstrainSelectedInstOperands,
     /* 277178 */     // GIR_Coverage, 2009,
     /* 277178 */     GIR_EraseRootFromParent_Done,
     /* 277179 */   // Label 5716: @277179
     /* 277179 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(277220), // Rule ID 4750 //
     /* 277184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 277192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277207 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 277207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 277210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 277216 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 277218 */     GIR_RootConstrainSelectedInstOperands,
     /* 277219 */     // GIR_Coverage, 4750,
     /* 277219 */     GIR_EraseRootFromParent_Done,
     /* 277220 */   // Label 5717: @277220
     /* 277220 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(277261), // Rule ID 13597 //
     /* 277225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 277237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277248 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 277248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 277251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 277257 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 277259 */     GIR_RootConstrainSelectedInstOperands,
     /* 277260 */     // GIR_Coverage, 13597,
     /* 277260 */     GIR_EraseRootFromParent_Done,
     /* 277261 */   // Label 5718: @277261
     /* 277261 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(277288), // Rule ID 624 //
     /* 277266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 277269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277277 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 277277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 277282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277286 */     GIR_RootConstrainSelectedInstOperands,
     /* 277287 */     // GIR_Coverage, 624,
     /* 277287 */     GIR_Done,
     /* 277288 */   // Label 5719: @277288
     /* 277288 */   GIM_Reject,
     /* 277289 */ // Label 5710: @277289
     /* 277289 */ GIM_Reject,
     /* 277290 */ // Label 5681: @277290
     /* 277290 */ GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(277819),
     /* 277295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 277301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277305 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(277391), // Rule ID 13198 //
     /* 277310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277358 */     // MIs[3] Operand 1
     /* 277358 */     // No operand predicates
     /* 277358 */     // MIs[1] Operand 2
     /* 277358 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277375 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277389 */     GIR_RootConstrainSelectedInstOperands,
     /* 277390 */     // GIR_Coverage, 13198,
     /* 277390 */     GIR_EraseRootFromParent_Done,
     /* 277391 */   // Label 5721: @277391
     /* 277391 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(277477), // Rule ID 1998 //
     /* 277396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277444 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277448 */     // MIs[3] Operand 1
     /* 277448 */     // No operand predicates
     /* 277448 */     // MIs[1] Operand 2
     /* 277448 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277461 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277475 */     GIR_RootConstrainSelectedInstOperands,
     /* 277476 */     // GIR_Coverage, 1998,
     /* 277476 */     GIR_EraseRootFromParent_Done,
     /* 277477 */   // Label 5722: @277477
     /* 277477 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(277540), // Rule ID 13199 //
     /* 277482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277518 */     // MIs[2] Operand 1
     /* 277518 */     // No operand predicates
     /* 277518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277524 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277538 */     GIR_RootConstrainSelectedInstOperands,
     /* 277539 */     // GIR_Coverage, 13199,
     /* 277539 */     GIR_EraseRootFromParent_Done,
     /* 277540 */   // Label 5723: @277540
     /* 277540 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(277603), // Rule ID 1999 //
     /* 277545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277585 */     // MIs[2] Operand 1
     /* 277585 */     // No operand predicates
     /* 277585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277587 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277601 */     GIR_RootConstrainSelectedInstOperands,
     /* 277602 */     // GIR_Coverage, 1999,
     /* 277602 */     GIR_EraseRootFromParent_Done,
     /* 277603 */   // Label 5724: @277603
     /* 277603 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(277697), // Rule ID 13659 //
     /* 277608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277631 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277695 */     GIR_RootConstrainSelectedInstOperands,
     /* 277696 */     // GIR_Coverage, 13659,
     /* 277696 */     GIR_EraseRootFromParent_Done,
     /* 277697 */   // Label 5725: @277697
     /* 277697 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(277791), // Rule ID 6153 //
     /* 277702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277725 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277789 */     GIR_RootConstrainSelectedInstOperands,
     /* 277790 */     // GIR_Coverage, 6153,
     /* 277790 */     GIR_EraseRootFromParent_Done,
     /* 277791 */   // Label 5726: @277791
     /* 277791 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(277818), // Rule ID 1316 //
     /* 277796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277807 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 277807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 277812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277816 */     GIR_RootConstrainSelectedInstOperands,
     /* 277817 */     // GIR_Coverage, 1316,
     /* 277817 */     GIR_Done,
     /* 277818 */   // Label 5727: @277818
     /* 277818 */   GIM_Reject,
     /* 277819 */ // Label 5720: @277819
     /* 277819 */ GIM_Reject,
     /* 277820 */ // Label 5682: @277820
     /* 277820 */ GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(278177),
     /* 277825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277835 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(277898), // Rule ID 13203 //
     /* 277840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277876 */     // MIs[2] Operand 1
     /* 277876 */     // No operand predicates
     /* 277876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277882 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277896 */     GIR_RootConstrainSelectedInstOperands,
     /* 277897 */     // GIR_Coverage, 13203,
     /* 277897 */     GIR_EraseRootFromParent_Done,
     /* 277898 */   // Label 5729: @277898
     /* 277898 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(277961), // Rule ID 2003 //
     /* 277903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277943 */     // MIs[2] Operand 1
     /* 277943 */     // No operand predicates
     /* 277943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277945 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277959 */     GIR_RootConstrainSelectedInstOperands,
     /* 277960 */     // GIR_Coverage, 2003,
     /* 277960 */     GIR_EraseRootFromParent_Done,
     /* 277961 */   // Label 5730: @277961
     /* 277961 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(278055), // Rule ID 13663 //
     /* 277966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277989 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 278025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 278043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278053 */     GIR_RootConstrainSelectedInstOperands,
     /* 278054 */     // GIR_Coverage, 13663,
     /* 278054 */     GIR_EraseRootFromParent_Done,
     /* 278055 */   // Label 5731: @278055
     /* 278055 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(278149), // Rule ID 6157 //
     /* 278060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 278076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278083 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278109 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 278119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 278137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278147 */     GIR_RootConstrainSelectedInstOperands,
     /* 278148 */     // GIR_Coverage, 6157,
     /* 278148 */     GIR_EraseRootFromParent_Done,
     /* 278149 */   // Label 5732: @278149
     /* 278149 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(278176), // Rule ID 1320 //
     /* 278154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278165 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 278165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 278170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278174 */     GIR_RootConstrainSelectedInstOperands,
     /* 278175 */     // GIR_Coverage, 1320,
     /* 278175 */     GIR_Done,
     /* 278176 */   // Label 5733: @278176
     /* 278176 */   GIM_Reject,
     /* 278177 */ // Label 5728: @278177
     /* 278177 */ GIM_Reject,
     /* 278178 */ // Label 5683: @278178
     /* 278178 */ GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(278519),
     /* 278183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278193 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(278279), // Rule ID 13192 //
     /* 278198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 278209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 278229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278242 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278246 */     // MIs[3] Operand 1
     /* 278246 */     // No operand predicates
     /* 278246 */     // MIs[1] Operand 2
     /* 278246 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 278257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278263 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 278274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 278277 */     GIR_RootConstrainSelectedInstOperands,
     /* 278278 */     // GIR_Coverage, 13192,
     /* 278278 */     GIR_EraseRootFromParent_Done,
     /* 278279 */   // Label 5735: @278279
     /* 278279 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(278365), // Rule ID 1992 //
     /* 278284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 278299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 278319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278332 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278336 */     // MIs[3] Operand 1
     /* 278336 */     // No operand predicates
     /* 278336 */     // MIs[1] Operand 2
     /* 278336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 278347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278349 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 278360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 278363 */     GIR_RootConstrainSelectedInstOperands,
     /* 278364 */     // GIR_Coverage, 1992,
     /* 278364 */     GIR_EraseRootFromParent_Done,
     /* 278365 */   // Label 5736: @278365
     /* 278365 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(278428), // Rule ID 13193 //
     /* 278370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278402 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278406 */     // MIs[2] Operand 1
     /* 278406 */     // No operand predicates
     /* 278406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278412 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278426 */     GIR_RootConstrainSelectedInstOperands,
     /* 278427 */     // GIR_Coverage, 13193,
     /* 278427 */     GIR_EraseRootFromParent_Done,
     /* 278428 */   // Label 5737: @278428
     /* 278428 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(278491), // Rule ID 1993 //
     /* 278433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278473 */     // MIs[2] Operand 1
     /* 278473 */     // No operand predicates
     /* 278473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278475 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278489 */     GIR_RootConstrainSelectedInstOperands,
     /* 278490 */     // GIR_Coverage, 1993,
     /* 278490 */     GIR_EraseRootFromParent_Done,
     /* 278491 */   // Label 5738: @278491
     /* 278491 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(278518), // Rule ID 1312 //
     /* 278496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278507 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 278507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 278512 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278516 */     GIR_RootConstrainSelectedInstOperands,
     /* 278517 */     // GIR_Coverage, 1312,
     /* 278517 */     GIR_Done,
     /* 278518 */   // Label 5739: @278518
     /* 278518 */   GIM_Reject,
     /* 278519 */ // Label 5734: @278519
     /* 278519 */ GIM_Reject,
     /* 278520 */ // Label 5684: @278520
     /* 278520 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(278877),
     /* 278525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278535 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(278598), // Rule ID 13201 //
     /* 278540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278576 */     // MIs[2] Operand 1
     /* 278576 */     // No operand predicates
     /* 278576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278582 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278596 */     GIR_RootConstrainSelectedInstOperands,
     /* 278597 */     // GIR_Coverage, 13201,
     /* 278597 */     GIR_EraseRootFromParent_Done,
     /* 278598 */   // Label 5741: @278598
     /* 278598 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(278661), // Rule ID 2001 //
     /* 278603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278643 */     // MIs[2] Operand 1
     /* 278643 */     // No operand predicates
     /* 278643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278645 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278659 */     GIR_RootConstrainSelectedInstOperands,
     /* 278660 */     // GIR_Coverage, 2001,
     /* 278660 */     GIR_EraseRootFromParent_Done,
     /* 278661 */   // Label 5742: @278661
     /* 278661 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(278755), // Rule ID 13661 //
     /* 278666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278689 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278753 */     GIR_RootConstrainSelectedInstOperands,
     /* 278754 */     // GIR_Coverage, 13661,
     /* 278754 */     GIR_EraseRootFromParent_Done,
     /* 278755 */   // Label 5743: @278755
     /* 278755 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(278849), // Rule ID 6155 //
     /* 278760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278783 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278847 */     GIR_RootConstrainSelectedInstOperands,
     /* 278848 */     // GIR_Coverage, 6155,
     /* 278848 */     GIR_EraseRootFromParent_Done,
     /* 278849 */   // Label 5744: @278849
     /* 278849 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(278876), // Rule ID 1318 //
     /* 278854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278865 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 278865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278870 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278874 */     GIR_RootConstrainSelectedInstOperands,
     /* 278875 */     // GIR_Coverage, 1318,
     /* 278875 */     GIR_Done,
     /* 278876 */   // Label 5745: @278876
     /* 278876 */   GIM_Reject,
     /* 278877 */ // Label 5740: @278877
     /* 278877 */ GIM_Reject,
     /* 278878 */ // Label 5685: @278878
     /* 278878 */ GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(279309),
     /* 278883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278893 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(278956), // Rule ID 13195 //
     /* 278898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278934 */     // MIs[2] Operand 1
     /* 278934 */     // No operand predicates
     /* 278934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278940 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 278943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278954 */     GIR_RootConstrainSelectedInstOperands,
     /* 278955 */     // GIR_Coverage, 13195,
     /* 278955 */     GIR_EraseRootFromParent_Done,
     /* 278956 */   // Label 5747: @278956
     /* 278956 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(279019), // Rule ID 1995 //
     /* 278961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279001 */     // MIs[2] Operand 1
     /* 279001 */     // No operand predicates
     /* 279001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279003 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 279003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 279006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279017 */     GIR_RootConstrainSelectedInstOperands,
     /* 279018 */     // GIR_Coverage, 1995,
     /* 279018 */     GIR_EraseRootFromParent_Done,
     /* 279019 */   // Label 5748: @279019
     /* 279019 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(279046), // Rule ID 1314 //
     /* 279024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279035 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 279035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 279040 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279044 */     GIR_RootConstrainSelectedInstOperands,
     /* 279045 */     // GIR_Coverage, 1314,
     /* 279045 */     GIR_Done,
     /* 279046 */   // Label 5749: @279046
     /* 279046 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(279308), // Rule ID 6918 //
     /* 279051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 279054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279062 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 279062 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 279065 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 279069 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279074 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 279078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 279080 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 279083 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 279087 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279092 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 279096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 279098 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 279101 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 279105 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279110 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 279113 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 279116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 279118 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 279121 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279125 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279130 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 279136 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279141 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279146 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 279149 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 279153 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279158 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 279161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 279163 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 279166 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279170 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279175 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279181 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279186 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279191 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 279194 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 279198 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279203 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 279206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 279208 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 279211 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 279215 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279220 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 279223 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 279226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 279228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 279231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 279235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279240 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 279243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 279248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 279262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279271 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279274 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 279280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 279298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 279306 */     GIR_RootConstrainSelectedInstOperands,
     /* 279307 */     // GIR_Coverage, 6918,
     /* 279307 */     GIR_EraseRootFromParent_Done,
     /* 279308 */   // Label 5750: @279308
     /* 279308 */   GIM_Reject,
     /* 279309 */ // Label 5746: @279309
     /* 279309 */ GIM_Reject,
     /* 279310 */ // Label 5686: @279310
     /* 279310 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(279335), // Rule ID 8050 //
     /* 279315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 279321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279328 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 279328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 279333 */   GIR_RootConstrainSelectedInstOperands,
     /* 279334 */   // GIR_Coverage, 8050,
     /* 279334 */   GIR_Done,
     /* 279335 */ // Label 5751: @279335
     /* 279335 */ GIM_Reject,
     /* 279336 */ // Label 5687: @279336
     /* 279336 */ GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(279361), // Rule ID 8048 //
     /* 279341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279354 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 279354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 279359 */   GIR_RootConstrainSelectedInstOperands,
     /* 279360 */   // GIR_Coverage, 8048,
     /* 279360 */   GIR_Done,
     /* 279361 */ // Label 5752: @279361
     /* 279361 */ GIM_Reject,
     /* 279362 */ // Label 5688: @279362
     /* 279362 */ GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(279387), // Rule ID 8046 //
     /* 279367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 279373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279380 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 279380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 279385 */   GIR_RootConstrainSelectedInstOperands,
     /* 279386 */   // GIR_Coverage, 8046,
     /* 279386 */   GIR_Done,
     /* 279387 */ // Label 5753: @279387
     /* 279387 */ GIM_Reject,
     /* 279388 */ // Label 5689: @279388
     /* 279388 */ GIM_Reject,
     /* 279389 */ // Label 57: @279389
     /* 279389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5762*/ GIMT_Encode4(295661),
     /* 279400 */ /*GILLT_s16*//*Label 5754*/ GIMT_Encode4(279440),
     /* 279404 */ /*GILLT_s32*//*Label 5755*/ GIMT_Encode4(282444),
     /* 279408 */ /*GILLT_s64*//*Label 5756*/ GIMT_Encode4(285592), GIMT_Encode4(0),
     /* 279416 */ /*GILLT_v2s32*//*Label 5757*/ GIMT_Encode4(288740),
     /* 279420 */ /*GILLT_v2s64*//*Label 5758*/ GIMT_Encode4(290261),
     /* 279424 */ /*GILLT_v4s16*//*Label 5759*/ GIMT_Encode4(291782),
     /* 279428 */ /*GILLT_v4s32*//*Label 5760*/ GIMT_Encode4(292961), GIMT_Encode4(0),
     /* 279436 */ /*GILLT_v8s16*//*Label 5761*/ GIMT_Encode4(294482),
     /* 279440 */ // Label 5754: @279440
     /* 279440 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(282443),
     /* 279445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 279451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 279454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279458 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(279608), // Rule ID 4805 //
     /* 279463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279512 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 279520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279524 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 279528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279535 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279547 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 279594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 279606 */     GIR_RootConstrainSelectedInstOperands,
     /* 279607 */     // GIR_Coverage, 4805,
     /* 279607 */     GIR_EraseRootFromParent_Done,
     /* 279608 */   // Label 5764: @279608
     /* 279608 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(279755), // Rule ID 4769 //
     /* 279613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279637 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279674 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279684 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279696 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279724 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279753 */     GIR_RootConstrainSelectedInstOperands,
     /* 279754 */     // GIR_Coverage, 4769,
     /* 279754 */     GIR_EraseRootFromParent_Done,
     /* 279755 */   // Label 5765: @279755
     /* 279755 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(279902), // Rule ID 13603 //
     /* 279760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279796 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279812 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279821 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279831 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279843 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279871 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279900 */     GIR_RootConstrainSelectedInstOperands,
     /* 279901 */     // GIR_Coverage, 13603,
     /* 279901 */     GIR_EraseRootFromParent_Done,
     /* 279902 */   // Label 5766: @279902
     /* 279902 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(280033), // Rule ID 5985 //
     /* 279907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279931 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 279972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279980 */     // MIs[4] Operand 1
     /* 279980 */     // No operand predicates
     /* 279980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279984 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279986 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279998 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 280017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 280028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 280031 */     GIR_RootConstrainSelectedInstOperands,
     /* 280032 */     // GIR_Coverage, 5985,
     /* 280032 */     GIR_EraseRootFromParent_Done,
     /* 280033 */   // Label 5767: @280033
     /* 280033 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(280164), // Rule ID 6017 //
     /* 280038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280074 */     // MIs[2] Operand 1
     /* 280074 */     // No operand predicates
     /* 280074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 280086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 280090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280094 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 280102 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280107 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 280111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280115 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 280117 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280129 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 280148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280162 */     GIR_RootConstrainSelectedInstOperands,
     /* 280163 */     // GIR_Coverage, 6017,
     /* 280163 */     GIR_EraseRootFromParent_Done,
     /* 280164 */   // Label 5768: @280164
     /* 280164 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(280295), // Rule ID 6081 //
     /* 280169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280205 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280221 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 280225 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 280234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280238 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280242 */     // MIs[4] Operand 1
     /* 280242 */     // No operand predicates
     /* 280242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 280248 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280260 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 280279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 280290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 280293 */     GIR_RootConstrainSelectedInstOperands,
     /* 280294 */     // GIR_Coverage, 6081,
     /* 280294 */     GIR_EraseRootFromParent_Done,
     /* 280295 */   // Label 5769: @280295
     /* 280295 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(280426), // Rule ID 6049 //
     /* 280300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280344 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280348 */     // MIs[3] Operand 1
     /* 280348 */     // No operand predicates
     /* 280348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 280352 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280356 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280360 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 280364 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280369 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 280373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280377 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 280379 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 280410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280424 */     GIR_RootConstrainSelectedInstOperands,
     /* 280425 */     // GIR_Coverage, 6049,
     /* 280425 */     GIR_EraseRootFromParent_Done,
     /* 280426 */   // Label 5770: @280426
     /* 280426 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(280561), // Rule ID 2447 //
     /* 280431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280480 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280490 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280502 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 280549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280559 */     GIR_RootConstrainSelectedInstOperands,
     /* 280560 */     // GIR_Coverage, 2447,
     /* 280560 */     GIR_EraseRootFromParent_Done,
     /* 280561 */   // Label 5771: @280561
     /* 280561 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(280680), // Rule ID 5953 //
     /* 280566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280623 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280627 */     // MIs[3] Operand 1
     /* 280627 */     // No operand predicates
     /* 280627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280633 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280645 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280678 */     GIR_RootConstrainSelectedInstOperands,
     /* 280679 */     // GIR_Coverage, 5953,
     /* 280679 */     GIR_EraseRootFromParent_Done,
     /* 280680 */   // Label 5772: @280680
     /* 280680 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(280799), // Rule ID 2529 //
     /* 280685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280721 */     // MIs[2] Operand 1
     /* 280721 */     // No operand predicates
     /* 280721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280729 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280733 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 280737 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280742 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 280746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280752 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280764 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280797 */     GIR_RootConstrainSelectedInstOperands,
     /* 280798 */     // GIR_Coverage, 2529,
     /* 280798 */     GIR_EraseRootFromParent_Done,
     /* 280799 */   // Label 5773: @280799
     /* 280799 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(280899), // Rule ID 4767 //
     /* 280804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280855 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280867 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280897 */     GIR_RootConstrainSelectedInstOperands,
     /* 280898 */     // GIR_Coverage, 4767,
     /* 280898 */     GIR_EraseRootFromParent_Done,
     /* 280899 */   // Label 5774: @280899
     /* 280899 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(280999), // Rule ID 4803 //
     /* 280904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 280940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280955 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 280986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 280993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 280997 */     GIR_RootConstrainSelectedInstOperands,
     /* 280998 */     // GIR_Coverage, 4803,
     /* 280998 */     GIR_EraseRootFromParent_Done,
     /* 280999 */   // Label 5775: @280999
     /* 280999 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(281096), // Rule ID 13599 //
     /* 281004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281040 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 281044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281054 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281066 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281094 */     GIR_RootConstrainSelectedInstOperands,
     /* 281095 */     // GIR_Coverage, 13599,
     /* 281095 */     GIR_EraseRootFromParent_Done,
     /* 281096 */   // Label 5776: @281096
     /* 281096 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(281196), // Rule ID 13601 //
     /* 281101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281142 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 281146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281152 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281194 */     GIR_RootConstrainSelectedInstOperands,
     /* 281195 */     // GIR_Coverage, 13601,
     /* 281195 */     GIR_EraseRootFromParent_Done,
     /* 281196 */   // Label 5777: @281196
     /* 281196 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(281296), // Rule ID 4801 //
     /* 281201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 281237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281252 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 281283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 281294 */     GIR_RootConstrainSelectedInstOperands,
     /* 281295 */     // GIR_Coverage, 4801,
     /* 281295 */     GIR_EraseRootFromParent_Done,
     /* 281296 */   // Label 5778: @281296
     /* 281296 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(281393), // Rule ID 4765 //
     /* 281301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281341 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 281345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281351 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281363 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281391 */     GIR_RootConstrainSelectedInstOperands,
     /* 281392 */     // GIR_Coverage, 4765,
     /* 281392 */     GIR_EraseRootFromParent_Done,
     /* 281393 */   // Label 5779: @281393
     /* 281393 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(281477), // Rule ID 6015 //
     /* 281398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281430 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281434 */     // MIs[2] Operand 1
     /* 281434 */     // No operand predicates
     /* 281434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 281438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281442 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 281446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281457 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 281468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281475 */     GIR_RootConstrainSelectedInstOperands,
     /* 281476 */     // GIR_Coverage, 6015,
     /* 281476 */     GIR_EraseRootFromParent_Done,
     /* 281477 */   // Label 5780: @281477
     /* 281477 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(281558), // Rule ID 6047 //
     /* 281482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281526 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281530 */     // MIs[3] Operand 1
     /* 281530 */     // No operand predicates
     /* 281530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281540 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281556 */     GIR_RootConstrainSelectedInstOperands,
     /* 281557 */     // GIR_Coverage, 6047,
     /* 281557 */     GIR_EraseRootFromParent_Done,
     /* 281558 */   // Label 5781: @281558
     /* 281558 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(281642), // Rule ID 6079 //
     /* 281563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281612 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281616 */     // MIs[3] Operand 1
     /* 281616 */     // No operand predicates
     /* 281616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281622 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281640 */     GIR_RootConstrainSelectedInstOperands,
     /* 281641 */     // GIR_Coverage, 6079,
     /* 281641 */     GIR_EraseRootFromParent_Done,
     /* 281642 */   // Label 5782: @281642
     /* 281642 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(281723), // Rule ID 5983 //
     /* 281647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281695 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281699 */     // MIs[3] Operand 1
     /* 281699 */     // No operand predicates
     /* 281699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281705 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281721 */     GIR_RootConstrainSelectedInstOperands,
     /* 281722 */     // GIR_Coverage, 5983,
     /* 281722 */     GIR_EraseRootFromParent_Done,
     /* 281723 */   // Label 5783: @281723
     /* 281723 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(281808), // Rule ID 2445 //
     /* 281728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281752 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281766 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281778 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281806 */     GIR_RootConstrainSelectedInstOperands,
     /* 281807 */     // GIR_Coverage, 2445,
     /* 281807 */     GIR_EraseRootFromParent_Done,
     /* 281808 */   // Label 5784: @281808
     /* 281808 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(281893), // Rule ID 2443 //
     /* 281813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281851 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281863 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281891 */     GIR_RootConstrainSelectedInstOperands,
     /* 281892 */     // GIR_Coverage, 2443,
     /* 281892 */     GIR_EraseRootFromParent_Done,
     /* 281893 */   // Label 5785: @281893
     /* 281893 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(281962), // Rule ID 2527 //
     /* 281898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281934 */     // MIs[2] Operand 1
     /* 281934 */     // No operand predicates
     /* 281934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281944 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 281947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281960 */     GIR_RootConstrainSelectedInstOperands,
     /* 281961 */     // GIR_Coverage, 2527,
     /* 281961 */     GIR_EraseRootFromParent_Done,
     /* 281962 */   // Label 5786: @281962
     /* 281962 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(282031), // Rule ID 5951 //
     /* 281967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282007 */     // MIs[2] Operand 1
     /* 282007 */     // No operand predicates
     /* 282007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282013 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 282016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282029 */     GIR_RootConstrainSelectedInstOperands,
     /* 282030 */     // GIR_Coverage, 5951,
     /* 282030 */     GIR_EraseRootFromParent_Done,
     /* 282031 */   // Label 5787: @282031
     /* 282031 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(282096), // Rule ID 4821 //
     /* 282036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 282064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282079 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 282082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 282090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 282094 */     GIR_RootConstrainSelectedInstOperands,
     /* 282095 */     // GIR_Coverage, 4821,
     /* 282095 */     GIR_EraseRootFromParent_Done,
     /* 282096 */   // Label 5788: @282096
     /* 282096 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(282161), // Rule ID 13619 //
     /* 282101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 282129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282144 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 282147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 282155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 282159 */     GIR_RootConstrainSelectedInstOperands,
     /* 282160 */     // GIR_Coverage, 13619,
     /* 282160 */     GIR_EraseRootFromParent_Done,
     /* 282161 */   // Label 5789: @282161
     /* 282161 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(282211), // Rule ID 4818 //
     /* 282166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282196 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 282207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282209 */     GIR_RootConstrainSelectedInstOperands,
     /* 282210 */     // GIR_Coverage, 4818,
     /* 282210 */     GIR_EraseRootFromParent_Done,
     /* 282211 */   // Label 5790: @282211
     /* 282211 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(282261), // Rule ID 13045 //
     /* 282216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282246 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282259 */     GIR_RootConstrainSelectedInstOperands,
     /* 282260 */     // GIR_Coverage, 13045,
     /* 282260 */     GIR_EraseRootFromParent_Done,
     /* 282261 */   // Label 5791: @282261
     /* 282261 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(282311), // Rule ID 644 //
     /* 282266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282296 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282309 */     GIR_RootConstrainSelectedInstOperands,
     /* 282310 */     // GIR_Coverage, 644,
     /* 282310 */     GIR_EraseRootFromParent_Done,
     /* 282311 */   // Label 5792: @282311
     /* 282311 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(282361), // Rule ID 13616 //
     /* 282316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282346 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 282349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 282357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282359 */     GIR_RootConstrainSelectedInstOperands,
     /* 282360 */     // GIR_Coverage, 13616,
     /* 282360 */     GIR_EraseRootFromParent_Done,
     /* 282361 */   // Label 5793: @282361
     /* 282361 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(282411), // Rule ID 656 //
     /* 282366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 282381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282396 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 282399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 282405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 282409 */     GIR_RootConstrainSelectedInstOperands,
     /* 282410 */     // GIR_Coverage, 656,
     /* 282410 */     GIR_EraseRootFromParent_Done,
     /* 282411 */   // Label 5794: @282411
     /* 282411 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(282442), // Rule ID 638 //
     /* 282416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282431 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 282436 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 282440 */     GIR_RootConstrainSelectedInstOperands,
     /* 282441 */     // GIR_Coverage, 638,
     /* 282441 */     GIR_Done,
     /* 282442 */   // Label 5795: @282442
     /* 282442 */   GIM_Reject,
     /* 282443 */ // Label 5763: @282443
     /* 282443 */ GIM_Reject,
     /* 282444 */ // Label 5755: @282444
     /* 282444 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(285591),
     /* 282449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 282458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282462 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(282612), // Rule ID 4811 //
     /* 282467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 282524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 282532 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282539 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282551 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282562 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 282598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 282610 */     GIR_RootConstrainSelectedInstOperands,
     /* 282611 */     // GIR_Coverage, 4811,
     /* 282611 */     GIR_EraseRootFromParent_Done,
     /* 282612 */   // Label 5797: @282612
     /* 282612 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(282759), // Rule ID 4775 //
     /* 282617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282641 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282678 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282688 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282700 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282757 */     GIR_RootConstrainSelectedInstOperands,
     /* 282758 */     // GIR_Coverage, 4775,
     /* 282758 */     GIR_EraseRootFromParent_Done,
     /* 282759 */   // Label 5798: @282759
     /* 282759 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(282906), // Rule ID 13609 //
     /* 282764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282800 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282820 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282825 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282835 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282847 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282904 */     GIR_RootConstrainSelectedInstOperands,
     /* 282905 */     // GIR_Coverage, 13609,
     /* 282905 */     GIR_EraseRootFromParent_Done,
     /* 282906 */   // Label 5799: @282906
     /* 282906 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(283037), // Rule ID 6001 //
     /* 282911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282963 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282980 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282984 */     // MIs[4] Operand 1
     /* 282984 */     // No operand predicates
     /* 282984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282988 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282990 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 283021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 283032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 283035 */     GIR_RootConstrainSelectedInstOperands,
     /* 283036 */     // GIR_Coverage, 6001,
     /* 283036 */     GIR_EraseRootFromParent_Done,
     /* 283037 */   // Label 5800: @283037
     /* 283037 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(283168), // Rule ID 6033 //
     /* 283042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283078 */     // MIs[2] Operand 1
     /* 283078 */     // No operand predicates
     /* 283078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283086 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 283090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 283094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283098 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283102 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 283106 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283111 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 283115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283119 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 283121 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283133 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 283152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283166 */     GIR_RootConstrainSelectedInstOperands,
     /* 283167 */     // GIR_Coverage, 6033,
     /* 283167 */     GIR_EraseRootFromParent_Done,
     /* 283168 */   // Label 5801: @283168
     /* 283168 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(283299), // Rule ID 6097 //
     /* 283173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283221 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283225 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283229 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 283238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283242 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283246 */     // MIs[4] Operand 1
     /* 283246 */     // No operand predicates
     /* 283246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 283252 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 283283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 283294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 283297 */     GIR_RootConstrainSelectedInstOperands,
     /* 283298 */     // GIR_Coverage, 6097,
     /* 283298 */     GIR_EraseRootFromParent_Done,
     /* 283299 */   // Label 5802: @283299
     /* 283299 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(283430), // Rule ID 6065 //
     /* 283304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283348 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283352 */     // MIs[3] Operand 1
     /* 283352 */     // No operand predicates
     /* 283352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 283356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283360 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283364 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 283368 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283373 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 283377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283381 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 283383 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283395 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 283414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283428 */     GIR_RootConstrainSelectedInstOperands,
     /* 283429 */     // GIR_Coverage, 6065,
     /* 283429 */     GIR_EraseRootFromParent_Done,
     /* 283430 */   // Label 5803: @283430
     /* 283430 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(283565), // Rule ID 2453 //
     /* 283435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283494 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 283497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283506 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283512 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283534 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 283553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283563 */     GIR_RootConstrainSelectedInstOperands,
     /* 283564 */     // GIR_Coverage, 2453,
     /* 283564 */     GIR_EraseRootFromParent_Done,
     /* 283565 */   // Label 5804: @283565
     /* 283565 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(283684), // Rule ID 5969 //
     /* 283570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283594 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283631 */     // MIs[3] Operand 1
     /* 283631 */     // No operand predicates
     /* 283631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283637 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283682 */     GIR_RootConstrainSelectedInstOperands,
     /* 283683 */     // GIR_Coverage, 5969,
     /* 283683 */     GIR_EraseRootFromParent_Done,
     /* 283684 */   // Label 5805: @283684
     /* 283684 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(283803), // Rule ID 2545 //
     /* 283689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283721 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283725 */     // MIs[2] Operand 1
     /* 283725 */     // No operand predicates
     /* 283725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283733 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283737 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283741 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283746 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 283750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283756 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283768 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283801 */     GIR_RootConstrainSelectedInstOperands,
     /* 283802 */     // GIR_Coverage, 2545,
     /* 283802 */     GIR_EraseRootFromParent_Done,
     /* 283803 */   // Label 5806: @283803
     /* 283803 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(283903), // Rule ID 4773 //
     /* 283808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283832 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283859 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283871 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283901 */     GIR_RootConstrainSelectedInstOperands,
     /* 283902 */     // GIR_Coverage, 4773,
     /* 283902 */     GIR_EraseRootFromParent_Done,
     /* 283903 */   // Label 5807: @283903
     /* 283903 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(284003), // Rule ID 4809 //
     /* 283908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283932 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283959 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283971 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 283990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 283997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284001 */     GIR_RootConstrainSelectedInstOperands,
     /* 284002 */     // GIR_Coverage, 4809,
     /* 284002 */     GIR_EraseRootFromParent_Done,
     /* 284003 */   // Label 5808: @284003
     /* 284003 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(284100), // Rule ID 13605 //
     /* 284008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284044 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284058 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 284076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284098 */     GIR_RootConstrainSelectedInstOperands,
     /* 284099 */     // GIR_Coverage, 13605,
     /* 284099 */     GIR_EraseRootFromParent_Done,
     /* 284100 */   // Label 5809: @284100
     /* 284100 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(284200), // Rule ID 13607 //
     /* 284105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284146 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284156 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 284174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284198 */     GIR_RootConstrainSelectedInstOperands,
     /* 284199 */     // GIR_Coverage, 13607,
     /* 284199 */     GIR_EraseRootFromParent_Done,
     /* 284200 */   // Label 5810: @284200
     /* 284200 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(284300), // Rule ID 4807 //
     /* 284205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284256 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284268 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 284274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 284287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284298 */     GIR_RootConstrainSelectedInstOperands,
     /* 284299 */     // GIR_Coverage, 4807,
     /* 284299 */     GIR_EraseRootFromParent_Done,
     /* 284300 */   // Label 5811: @284300
     /* 284300 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(284397), // Rule ID 4771 //
     /* 284305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284345 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284355 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284367 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 284373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284395 */     GIR_RootConstrainSelectedInstOperands,
     /* 284396 */     // GIR_Coverage, 4771,
     /* 284396 */     GIR_EraseRootFromParent_Done,
     /* 284397 */   // Label 5812: @284397
     /* 284397 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(284475), // Rule ID 6119 //
     /* 284402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 284439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284443 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284447 */     // MIs[3] Operand 1
     /* 284447 */     // No operand predicates
     /* 284447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284457 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284473 */     GIR_RootConstrainSelectedInstOperands,
     /* 284474 */     // GIR_Coverage, 6119,
     /* 284474 */     GIR_EraseRootFromParent_Done,
     /* 284475 */   // Label 5813: @284475
     /* 284475 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(284559), // Rule ID 6031 //
     /* 284480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284516 */     // MIs[2] Operand 1
     /* 284516 */     // No operand predicates
     /* 284516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 284520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284524 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 284528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284539 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 284550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284557 */     GIR_RootConstrainSelectedInstOperands,
     /* 284558 */     // GIR_Coverage, 6031,
     /* 284558 */     GIR_EraseRootFromParent_Done,
     /* 284559 */   // Label 5814: @284559
     /* 284559 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(284640), // Rule ID 6063 //
     /* 284564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284608 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284612 */     // MIs[3] Operand 1
     /* 284612 */     // No operand predicates
     /* 284612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284622 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284638 */     GIR_RootConstrainSelectedInstOperands,
     /* 284639 */     // GIR_Coverage, 6063,
     /* 284639 */     GIR_EraseRootFromParent_Done,
     /* 284640 */   // Label 5815: @284640
     /* 284640 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(284724), // Rule ID 6095 //
     /* 284645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284698 */     // MIs[3] Operand 1
     /* 284698 */     // No operand predicates
     /* 284698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284704 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284722 */     GIR_RootConstrainSelectedInstOperands,
     /* 284723 */     // GIR_Coverage, 6095,
     /* 284723 */     GIR_EraseRootFromParent_Done,
     /* 284724 */   // Label 5816: @284724
     /* 284724 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(284802), // Rule ID 6141 //
     /* 284729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 284770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284778 */     // MIs[3] Operand 1
     /* 284778 */     // No operand predicates
     /* 284778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284784 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284800 */     GIR_RootConstrainSelectedInstOperands,
     /* 284801 */     // GIR_Coverage, 6141,
     /* 284801 */     GIR_EraseRootFromParent_Done,
     /* 284802 */   // Label 5817: @284802
     /* 284802 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(284883), // Rule ID 5999 //
     /* 284807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284859 */     // MIs[3] Operand 1
     /* 284859 */     // No operand predicates
     /* 284859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284865 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284881 */     GIR_RootConstrainSelectedInstOperands,
     /* 284882 */     // GIR_Coverage, 5999,
     /* 284882 */     GIR_EraseRootFromParent_Done,
     /* 284883 */   // Label 5818: @284883
     /* 284883 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(284968), // Rule ID 2451 //
     /* 284888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284912 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284926 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284938 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 284944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 284957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284966 */     GIR_RootConstrainSelectedInstOperands,
     /* 284967 */     // GIR_Coverage, 2451,
     /* 284967 */     GIR_EraseRootFromParent_Done,
     /* 284968 */   // Label 5819: @284968
     /* 284968 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(285053), // Rule ID 2449 //
     /* 284973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285001 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285011 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 285011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 285029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 285042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285051 */     GIR_RootConstrainSelectedInstOperands,
     /* 285052 */     // GIR_Coverage, 2449,
     /* 285052 */     GIR_EraseRootFromParent_Done,
     /* 285053 */   // Label 5820: @285053
     /* 285053 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(285122), // Rule ID 2543 //
     /* 285058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285090 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285094 */     // MIs[2] Operand 1
     /* 285094 */     // No operand predicates
     /* 285094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285104 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 285107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 285113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285120 */     GIR_RootConstrainSelectedInstOperands,
     /* 285121 */     // GIR_Coverage, 2543,
     /* 285121 */     GIR_EraseRootFromParent_Done,
     /* 285122 */   // Label 5821: @285122
     /* 285122 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(285191), // Rule ID 5967 //
     /* 285127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 285167 */     // MIs[2] Operand 1
     /* 285167 */     // No operand predicates
     /* 285167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285173 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 285173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 285176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285189 */     GIR_RootConstrainSelectedInstOperands,
     /* 285190 */     // GIR_Coverage, 5967,
     /* 285190 */     GIR_EraseRootFromParent_Done,
     /* 285191 */   // Label 5822: @285191
     /* 285191 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(285253), // Rule ID 4822 //
     /* 285196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 285221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285236 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 285239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 285247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 285251 */     GIR_RootConstrainSelectedInstOperands,
     /* 285252 */     // GIR_Coverage, 4822,
     /* 285252 */     GIR_EraseRootFromParent_Done,
     /* 285253 */   // Label 5823: @285253
     /* 285253 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(285315), // Rule ID 13620 //
     /* 285258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 285283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285298 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 285301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 285309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 285313 */     GIR_RootConstrainSelectedInstOperands,
     /* 285314 */     // GIR_Coverage, 13620,
     /* 285314 */     GIR_EraseRootFromParent_Done,
     /* 285315 */   // Label 5824: @285315
     /* 285315 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(285362), // Rule ID 4819 //
     /* 285320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285347 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 285358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285360 */     GIR_RootConstrainSelectedInstOperands,
     /* 285361 */     // GIR_Coverage, 4819,
     /* 285361 */     GIR_EraseRootFromParent_Done,
     /* 285362 */   // Label 5825: @285362
     /* 285362 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(285412), // Rule ID 13047 //
     /* 285367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285397 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 285404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285410 */     GIR_RootConstrainSelectedInstOperands,
     /* 285411 */     // GIR_Coverage, 13047,
     /* 285411 */     GIR_EraseRootFromParent_Done,
     /* 285412 */   // Label 5826: @285412
     /* 285412 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(285462), // Rule ID 646 //
     /* 285417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285447 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285460 */     GIR_RootConstrainSelectedInstOperands,
     /* 285461 */     // GIR_Coverage, 646,
     /* 285461 */     GIR_EraseRootFromParent_Done,
     /* 285462 */   // Label 5827: @285462
     /* 285462 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(285509), // Rule ID 13617 //
     /* 285467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285494 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 285505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285507 */     GIR_RootConstrainSelectedInstOperands,
     /* 285508 */     // GIR_Coverage, 13617,
     /* 285508 */     GIR_EraseRootFromParent_Done,
     /* 285509 */   // Label 5828: @285509
     /* 285509 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(285559), // Rule ID 658 //
     /* 285514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 285529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285544 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 285547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 285553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 285557 */     GIR_RootConstrainSelectedInstOperands,
     /* 285558 */     // GIR_Coverage, 658,
     /* 285558 */     GIR_EraseRootFromParent_Done,
     /* 285559 */   // Label 5829: @285559
     /* 285559 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(285590), // Rule ID 640 //
     /* 285564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285579 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 285584 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285588 */     GIR_RootConstrainSelectedInstOperands,
     /* 285589 */     // GIR_Coverage, 640,
     /* 285589 */     GIR_Done,
     /* 285590 */   // Label 5830: @285590
     /* 285590 */   GIM_Reject,
     /* 285591 */ // Label 5796: @285591
     /* 285591 */ GIM_Reject,
     /* 285592 */ // Label 5756: @285592
     /* 285592 */ GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(288739),
     /* 285597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 285606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285610 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(285760), // Rule ID 4817 //
     /* 285615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285664 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 285672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 285680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285687 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285699 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 285746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 285758 */     GIR_RootConstrainSelectedInstOperands,
     /* 285759 */     // GIR_Coverage, 4817,
     /* 285759 */     GIR_EraseRootFromParent_Done,
     /* 285760 */   // Label 5832: @285760
     /* 285760 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(285907), // Rule ID 4781 //
     /* 285765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 285805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285813 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285817 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285826 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285836 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285848 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285876 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 285895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285905 */     GIR_RootConstrainSelectedInstOperands,
     /* 285906 */     // GIR_Coverage, 4781,
     /* 285906 */     GIR_EraseRootFromParent_Done,
     /* 285907 */   // Label 5833: @285907
     /* 285907 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(286054), // Rule ID 13615 //
     /* 285912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285948 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285968 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285973 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285983 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285995 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286052 */     GIR_RootConstrainSelectedInstOperands,
     /* 286053 */     // GIR_Coverage, 13615,
     /* 286053 */     GIR_EraseRootFromParent_Done,
     /* 286054 */   // Label 5834: @286054
     /* 286054 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(286185), // Rule ID 6005 //
     /* 286059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 286124 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286128 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286132 */     // MIs[4] Operand 1
     /* 286132 */     // No operand predicates
     /* 286132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286136 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286138 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286150 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 286180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286183 */     GIR_RootConstrainSelectedInstOperands,
     /* 286184 */     // GIR_Coverage, 6005,
     /* 286184 */     GIR_EraseRootFromParent_Done,
     /* 286185 */   // Label 5835: @286185
     /* 286185 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(286316), // Rule ID 6037 //
     /* 286190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286226 */     // MIs[2] Operand 1
     /* 286226 */     // No operand predicates
     /* 286226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 286238 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 286242 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286246 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286250 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286254 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286259 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286269 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286281 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286314 */     GIR_RootConstrainSelectedInstOperands,
     /* 286315 */     // GIR_Coverage, 6037,
     /* 286315 */     GIR_EraseRootFromParent_Done,
     /* 286316 */   // Label 5836: @286316
     /* 286316 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(286447), // Rule ID 6101 //
     /* 286321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286357 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286373 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 286386 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286390 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286394 */     // MIs[4] Operand 1
     /* 286394 */     // No operand predicates
     /* 286394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286400 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286412 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 286442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286445 */     GIR_RootConstrainSelectedInstOperands,
     /* 286446 */     // GIR_Coverage, 6101,
     /* 286446 */     GIR_EraseRootFromParent_Done,
     /* 286447 */   // Label 5837: @286447
     /* 286447 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(286578), // Rule ID 6069 //
     /* 286452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286500 */     // MIs[3] Operand 1
     /* 286500 */     // No operand predicates
     /* 286500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 286504 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286508 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286512 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286516 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286521 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286529 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286531 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286576 */     GIR_RootConstrainSelectedInstOperands,
     /* 286577 */     // GIR_Coverage, 6069,
     /* 286577 */     GIR_EraseRootFromParent_Done,
     /* 286578 */   // Label 5838: @286578
     /* 286578 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(286713), // Rule ID 2459 //
     /* 286583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286607 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286632 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286642 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 286645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286654 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286682 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 286701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286711 */     GIR_RootConstrainSelectedInstOperands,
     /* 286712 */     // GIR_Coverage, 2459,
     /* 286712 */     GIR_EraseRootFromParent_Done,
     /* 286713 */   // Label 5839: @286713
     /* 286713 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(286832), // Rule ID 5973 //
     /* 286718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286775 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286779 */     // MIs[3] Operand 1
     /* 286779 */     // No operand predicates
     /* 286779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286785 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286830 */     GIR_RootConstrainSelectedInstOperands,
     /* 286831 */     // GIR_Coverage, 5973,
     /* 286831 */     GIR_EraseRootFromParent_Done,
     /* 286832 */   // Label 5840: @286832
     /* 286832 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(286951), // Rule ID 2549 //
     /* 286837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286869 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286873 */     // MIs[2] Operand 1
     /* 286873 */     // No operand predicates
     /* 286873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286881 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286885 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286889 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286894 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286904 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286949 */     GIR_RootConstrainSelectedInstOperands,
     /* 286950 */     // GIR_Coverage, 2549,
     /* 286950 */     GIR_EraseRootFromParent_Done,
     /* 286951 */   // Label 5841: @286951
     /* 286951 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(287051), // Rule ID 4779 //
     /* 286956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287007 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287019 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287049 */     GIR_RootConstrainSelectedInstOperands,
     /* 287050 */     // GIR_Coverage, 4779,
     /* 287050 */     GIR_EraseRootFromParent_Done,
     /* 287051 */   // Label 5842: @287051
     /* 287051 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(287151), // Rule ID 4815 //
     /* 287056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 287100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287107 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 287138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287149 */     GIR_RootConstrainSelectedInstOperands,
     /* 287150 */     // GIR_Coverage, 4815,
     /* 287150 */     GIR_EraseRootFromParent_Done,
     /* 287151 */   // Label 5843: @287151
     /* 287151 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(287248), // Rule ID 13611 //
     /* 287156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287206 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287246 */     GIR_RootConstrainSelectedInstOperands,
     /* 287247 */     // GIR_Coverage, 13611,
     /* 287247 */     GIR_EraseRootFromParent_Done,
     /* 287248 */   // Label 5844: @287248
     /* 287248 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(287348), // Rule ID 13613 //
     /* 287253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287294 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287304 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287316 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287346 */     GIR_RootConstrainSelectedInstOperands,
     /* 287347 */     // GIR_Coverage, 13613,
     /* 287347 */     GIR_EraseRootFromParent_Done,
     /* 287348 */   // Label 5845: @287348
     /* 287348 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(287448), // Rule ID 4813 //
     /* 287353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 287397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287404 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 287435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287446 */     GIR_RootConstrainSelectedInstOperands,
     /* 287447 */     // GIR_Coverage, 4813,
     /* 287447 */     GIR_EraseRootFromParent_Done,
     /* 287448 */   // Label 5846: @287448
     /* 287448 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(287545), // Rule ID 4777 //
     /* 287453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287493 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287503 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287543 */     GIR_RootConstrainSelectedInstOperands,
     /* 287544 */     // GIR_Coverage, 4777,
     /* 287544 */     GIR_EraseRootFromParent_Done,
     /* 287545 */   // Label 5847: @287545
     /* 287545 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(287623), // Rule ID 6123 //
     /* 287550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287591 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287595 */     // MIs[3] Operand 1
     /* 287595 */     // No operand predicates
     /* 287595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287605 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287621 */     GIR_RootConstrainSelectedInstOperands,
     /* 287622 */     // GIR_Coverage, 6123,
     /* 287622 */     GIR_EraseRootFromParent_Done,
     /* 287623 */   // Label 5848: @287623
     /* 287623 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(287707), // Rule ID 6035 //
     /* 287628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287664 */     // MIs[2] Operand 1
     /* 287664 */     // No operand predicates
     /* 287664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 287676 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287687 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 287698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287705 */     GIR_RootConstrainSelectedInstOperands,
     /* 287706 */     // GIR_Coverage, 6035,
     /* 287706 */     GIR_EraseRootFromParent_Done,
     /* 287707 */   // Label 5849: @287707
     /* 287707 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(287788), // Rule ID 6067 //
     /* 287712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287756 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287760 */     // MIs[3] Operand 1
     /* 287760 */     // No operand predicates
     /* 287760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287770 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287786 */     GIR_RootConstrainSelectedInstOperands,
     /* 287787 */     // GIR_Coverage, 6067,
     /* 287787 */     GIR_EraseRootFromParent_Done,
     /* 287788 */   // Label 5850: @287788
     /* 287788 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(287872), // Rule ID 6099 //
     /* 287793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287842 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287846 */     // MIs[3] Operand 1
     /* 287846 */     // No operand predicates
     /* 287846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287852 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287870 */     GIR_RootConstrainSelectedInstOperands,
     /* 287871 */     // GIR_Coverage, 6099,
     /* 287871 */     GIR_EraseRootFromParent_Done,
     /* 287872 */   // Label 5851: @287872
     /* 287872 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(287950), // Rule ID 6145 //
     /* 287877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287926 */     // MIs[3] Operand 1
     /* 287926 */     // No operand predicates
     /* 287926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287932 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287948 */     GIR_RootConstrainSelectedInstOperands,
     /* 287949 */     // GIR_Coverage, 6145,
     /* 287949 */     GIR_EraseRootFromParent_Done,
     /* 287950 */   // Label 5852: @287950
     /* 287950 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(288031), // Rule ID 6003 //
     /* 287955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288007 */     // MIs[3] Operand 1
     /* 288007 */     // No operand predicates
     /* 288007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288013 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 288016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288029 */     GIR_RootConstrainSelectedInstOperands,
     /* 288030 */     // GIR_Coverage, 6003,
     /* 288030 */     GIR_EraseRootFromParent_Done,
     /* 288031 */   // Label 5853: @288031
     /* 288031 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(288116), // Rule ID 2457 //
     /* 288036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288060 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288074 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 288105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288114 */     GIR_RootConstrainSelectedInstOperands,
     /* 288115 */     // GIR_Coverage, 2457,
     /* 288115 */     GIR_EraseRootFromParent_Done,
     /* 288116 */   // Label 5854: @288116
     /* 288116 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(288201), // Rule ID 2455 //
     /* 288121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288159 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 288159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288171 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 288190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288199 */     GIR_RootConstrainSelectedInstOperands,
     /* 288200 */     // GIR_Coverage, 2455,
     /* 288200 */     GIR_EraseRootFromParent_Done,
     /* 288201 */   // Label 5855: @288201
     /* 288201 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(288270), // Rule ID 2547 //
     /* 288206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288242 */     // MIs[2] Operand 1
     /* 288242 */     // No operand predicates
     /* 288242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288252 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 288255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288268 */     GIR_RootConstrainSelectedInstOperands,
     /* 288269 */     // GIR_Coverage, 2547,
     /* 288269 */     GIR_EraseRootFromParent_Done,
     /* 288270 */   // Label 5856: @288270
     /* 288270 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(288339), // Rule ID 5971 //
     /* 288275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288311 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288315 */     // MIs[2] Operand 1
     /* 288315 */     // No operand predicates
     /* 288315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288321 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 288324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288337 */     GIR_RootConstrainSelectedInstOperands,
     /* 288338 */     // GIR_Coverage, 5971,
     /* 288338 */     GIR_EraseRootFromParent_Done,
     /* 288339 */   // Label 5857: @288339
     /* 288339 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(288401), // Rule ID 4823 //
     /* 288344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 288369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288384 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 288387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288399 */     GIR_RootConstrainSelectedInstOperands,
     /* 288400 */     // GIR_Coverage, 4823,
     /* 288400 */     GIR_EraseRootFromParent_Done,
     /* 288401 */   // Label 5858: @288401
     /* 288401 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(288463), // Rule ID 13621 //
     /* 288406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 288431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288446 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 288449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288461 */     GIR_RootConstrainSelectedInstOperands,
     /* 288462 */     // GIR_Coverage, 13621,
     /* 288462 */     GIR_EraseRootFromParent_Done,
     /* 288463 */   // Label 5859: @288463
     /* 288463 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(288510), // Rule ID 4820 //
     /* 288468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288495 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288508 */     GIR_RootConstrainSelectedInstOperands,
     /* 288509 */     // GIR_Coverage, 4820,
     /* 288509 */     GIR_EraseRootFromParent_Done,
     /* 288510 */   // Label 5860: @288510
     /* 288510 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(288560), // Rule ID 13049 //
     /* 288515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288545 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288558 */     GIR_RootConstrainSelectedInstOperands,
     /* 288559 */     // GIR_Coverage, 13049,
     /* 288559 */     GIR_EraseRootFromParent_Done,
     /* 288560 */   // Label 5861: @288560
     /* 288560 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(288610), // Rule ID 648 //
     /* 288565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288595 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288608 */     GIR_RootConstrainSelectedInstOperands,
     /* 288609 */     // GIR_Coverage, 648,
     /* 288609 */     GIR_EraseRootFromParent_Done,
     /* 288610 */   // Label 5862: @288610
     /* 288610 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(288657), // Rule ID 13618 //
     /* 288615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288642 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288655 */     GIR_RootConstrainSelectedInstOperands,
     /* 288656 */     // GIR_Coverage, 13618,
     /* 288656 */     GIR_EraseRootFromParent_Done,
     /* 288657 */   // Label 5863: @288657
     /* 288657 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(288707), // Rule ID 660 //
     /* 288662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288692 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 288695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 288705 */     GIR_RootConstrainSelectedInstOperands,
     /* 288706 */     // GIR_Coverage, 660,
     /* 288706 */     GIR_EraseRootFromParent_Done,
     /* 288707 */   // Label 5864: @288707
     /* 288707 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(288738), // Rule ID 642 //
     /* 288712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288727 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 288732 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288736 */     GIR_RootConstrainSelectedInstOperands,
     /* 288737 */     // GIR_Coverage, 642,
     /* 288737 */     GIR_Done,
     /* 288738 */   // Label 5865: @288738
     /* 288738 */   GIM_Reject,
     /* 288739 */ // Label 5831: @288739
     /* 288739 */ GIM_Reject,
     /* 288740 */ // Label 5757: @288740
     /* 288740 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(290260),
     /* 288745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 288754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288758 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(288836), // Rule ID 6103 //
     /* 288763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 288800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288804 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288808 */     // MIs[3] Operand 1
     /* 288808 */     // No operand predicates
     /* 288808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288818 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288834 */     GIR_RootConstrainSelectedInstOperands,
     /* 288835 */     // GIR_Coverage, 6103,
     /* 288835 */     GIR_EraseRootFromParent_Done,
     /* 288836 */   // Label 5867: @288836
     /* 288836 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(288920), // Rule ID 6019 //
     /* 288841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288877 */     // MIs[2] Operand 1
     /* 288877 */     // No operand predicates
     /* 288877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288889 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288900 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 288911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288918 */     GIR_RootConstrainSelectedInstOperands,
     /* 288919 */     // GIR_Coverage, 6019,
     /* 288919 */     GIR_EraseRootFromParent_Done,
     /* 288920 */   // Label 5868: @288920
     /* 288920 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(289001), // Rule ID 6051 //
     /* 288925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288973 */     // MIs[3] Operand 1
     /* 288973 */     // No operand predicates
     /* 288973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288983 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288999 */     GIR_RootConstrainSelectedInstOperands,
     /* 289000 */     // GIR_Coverage, 6051,
     /* 289000 */     GIR_EraseRootFromParent_Done,
     /* 289001 */   // Label 5869: @289001
     /* 289001 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(289085), // Rule ID 6083 //
     /* 289006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289055 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289059 */     // MIs[3] Operand 1
     /* 289059 */     // No operand predicates
     /* 289059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289065 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289083 */     GIR_RootConstrainSelectedInstOperands,
     /* 289084 */     // GIR_Coverage, 6083,
     /* 289084 */     GIR_EraseRootFromParent_Done,
     /* 289085 */   // Label 5870: @289085
     /* 289085 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(289163), // Rule ID 6125 //
     /* 289090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 289131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289135 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289139 */     // MIs[3] Operand 1
     /* 289139 */     // No operand predicates
     /* 289139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289145 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289161 */     GIR_RootConstrainSelectedInstOperands,
     /* 289162 */     // GIR_Coverage, 6125,
     /* 289162 */     GIR_EraseRootFromParent_Done,
     /* 289163 */   // Label 5871: @289163
     /* 289163 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(289244), // Rule ID 5987 //
     /* 289168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289216 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289220 */     // MIs[3] Operand 1
     /* 289220 */     // No operand predicates
     /* 289220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289226 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289242 */     GIR_RootConstrainSelectedInstOperands,
     /* 289243 */     // GIR_Coverage, 5987,
     /* 289243 */     GIR_EraseRootFromParent_Done,
     /* 289244 */   // Label 5872: @289244
     /* 289244 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(289313), // Rule ID 2531 //
     /* 289249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289281 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289285 */     // MIs[2] Operand 1
     /* 289285 */     // No operand predicates
     /* 289285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289295 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289311 */     GIR_RootConstrainSelectedInstOperands,
     /* 289312 */     // GIR_Coverage, 2531,
     /* 289312 */     GIR_EraseRootFromParent_Done,
     /* 289313 */   // Label 5873: @289313
     /* 289313 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(289382), // Rule ID 5955 //
     /* 289318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289358 */     // MIs[2] Operand 1
     /* 289358 */     // No operand predicates
     /* 289358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289364 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289380 */     GIR_RootConstrainSelectedInstOperands,
     /* 289381 */     // GIR_Coverage, 5955,
     /* 289381 */     GIR_EraseRootFromParent_Done,
     /* 289382 */   // Label 5874: @289382
     /* 289382 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(289475), // Rule ID 6107 //
     /* 289387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289426 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289473 */     GIR_RootConstrainSelectedInstOperands,
     /* 289474 */     // GIR_Coverage, 6107,
     /* 289474 */     GIR_EraseRootFromParent_Done,
     /* 289475 */   // Label 5875: @289475
     /* 289475 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(289574), // Rule ID 6021 //
     /* 289480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289523 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289542 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 289566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289572 */     GIR_RootConstrainSelectedInstOperands,
     /* 289573 */     // GIR_Coverage, 6021,
     /* 289573 */     GIR_EraseRootFromParent_Done,
     /* 289574 */   // Label 5876: @289574
     /* 289574 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(289670), // Rule ID 6053 //
     /* 289579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289621 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289668 */     GIR_RootConstrainSelectedInstOperands,
     /* 289669 */     // GIR_Coverage, 6053,
     /* 289669 */     GIR_EraseRootFromParent_Done,
     /* 289670 */   // Label 5877: @289670
     /* 289670 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(289769), // Rule ID 6085 //
     /* 289675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289718 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289767 */     GIR_RootConstrainSelectedInstOperands,
     /* 289768 */     // GIR_Coverage, 6085,
     /* 289768 */     GIR_EraseRootFromParent_Done,
     /* 289769 */   // Label 5878: @289769
     /* 289769 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(289862), // Rule ID 6129 //
     /* 289774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289813 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289860 */     GIR_RootConstrainSelectedInstOperands,
     /* 289861 */     // GIR_Coverage, 6129,
     /* 289861 */     GIR_EraseRootFromParent_Done,
     /* 289862 */   // Label 5879: @289862
     /* 289862 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(289958), // Rule ID 5989 //
     /* 289867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289909 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289928 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289956 */     GIR_RootConstrainSelectedInstOperands,
     /* 289957 */     // GIR_Coverage, 5989,
     /* 289957 */     GIR_EraseRootFromParent_Done,
     /* 289958 */   // Label 5880: @289958
     /* 289958 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(290042), // Rule ID 2533 //
     /* 289963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289993 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 290028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290040 */     GIR_RootConstrainSelectedInstOperands,
     /* 290041 */     // GIR_Coverage, 2533,
     /* 290041 */     GIR_EraseRootFromParent_Done,
     /* 290042 */   // Label 5881: @290042
     /* 290042 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(290092), // Rule ID 13079 //
     /* 290047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 290062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290077 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 290077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 290080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290090 */     GIR_RootConstrainSelectedInstOperands,
     /* 290091 */     // GIR_Coverage, 13079,
     /* 290091 */     GIR_EraseRootFromParent_Done,
     /* 290092 */   // Label 5882: @290092
     /* 290092 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(290176), // Rule ID 5957 //
     /* 290097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290127 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 290162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290174 */     GIR_RootConstrainSelectedInstOperands,
     /* 290175 */     // GIR_Coverage, 5957,
     /* 290175 */     GIR_EraseRootFromParent_Done,
     /* 290176 */   // Label 5883: @290176
     /* 290176 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(290226), // Rule ID 1301 //
     /* 290181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 290200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290211 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 290211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 290214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290224 */     GIR_RootConstrainSelectedInstOperands,
     /* 290225 */     // GIR_Coverage, 1301,
     /* 290225 */     GIR_EraseRootFromParent_Done,
     /* 290226 */   // Label 5884: @290226
     /* 290226 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(290259), // Rule ID 1291 //
     /* 290231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290246 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 290246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 290249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 290257 */     GIR_RootConstrainSelectedInstOperands,
     /* 290258 */     // GIR_Coverage, 1291,
     /* 290258 */     GIR_EraseRootFromParent_Done,
     /* 290259 */   // Label 5885: @290259
     /* 290259 */   GIM_Reject,
     /* 290260 */ // Label 5866: @290260
     /* 290260 */ GIM_Reject,
     /* 290261 */ // Label 5758: @290261
     /* 290261 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(291781),
     /* 290266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 290275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290279 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(290357), // Rule ID 6115 //
     /* 290284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290325 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290329 */     // MIs[3] Operand 1
     /* 290329 */     // No operand predicates
     /* 290329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290339 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290355 */     GIR_RootConstrainSelectedInstOperands,
     /* 290356 */     // GIR_Coverage, 6115,
     /* 290356 */     GIR_EraseRootFromParent_Done,
     /* 290357 */   // Label 5887: @290357
     /* 290357 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(290441), // Rule ID 6027 //
     /* 290362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290398 */     // MIs[2] Operand 1
     /* 290398 */     // No operand predicates
     /* 290398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290410 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290421 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 290432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290439 */     GIR_RootConstrainSelectedInstOperands,
     /* 290440 */     // GIR_Coverage, 6027,
     /* 290440 */     GIR_EraseRootFromParent_Done,
     /* 290441 */   // Label 5888: @290441
     /* 290441 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(290522), // Rule ID 6059 //
     /* 290446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290490 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290494 */     // MIs[3] Operand 1
     /* 290494 */     // No operand predicates
     /* 290494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290504 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290520 */     GIR_RootConstrainSelectedInstOperands,
     /* 290521 */     // GIR_Coverage, 6059,
     /* 290521 */     GIR_EraseRootFromParent_Done,
     /* 290522 */   // Label 5889: @290522
     /* 290522 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(290606), // Rule ID 6091 //
     /* 290527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290576 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290580 */     // MIs[3] Operand 1
     /* 290580 */     // No operand predicates
     /* 290580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290586 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290604 */     GIR_RootConstrainSelectedInstOperands,
     /* 290605 */     // GIR_Coverage, 6091,
     /* 290605 */     GIR_EraseRootFromParent_Done,
     /* 290606 */   // Label 5890: @290606
     /* 290606 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(290684), // Rule ID 6137 //
     /* 290611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290656 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290660 */     // MIs[3] Operand 1
     /* 290660 */     // No operand predicates
     /* 290660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290666 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290682 */     GIR_RootConstrainSelectedInstOperands,
     /* 290683 */     // GIR_Coverage, 6137,
     /* 290683 */     GIR_EraseRootFromParent_Done,
     /* 290684 */   // Label 5891: @290684
     /* 290684 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(290765), // Rule ID 5995 //
     /* 290689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290737 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290741 */     // MIs[3] Operand 1
     /* 290741 */     // No operand predicates
     /* 290741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290747 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290763 */     GIR_RootConstrainSelectedInstOperands,
     /* 290764 */     // GIR_Coverage, 5995,
     /* 290764 */     GIR_EraseRootFromParent_Done,
     /* 290765 */   // Label 5892: @290765
     /* 290765 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(290834), // Rule ID 2539 //
     /* 290770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290806 */     // MIs[2] Operand 1
     /* 290806 */     // No operand predicates
     /* 290806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290816 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290832 */     GIR_RootConstrainSelectedInstOperands,
     /* 290833 */     // GIR_Coverage, 2539,
     /* 290833 */     GIR_EraseRootFromParent_Done,
     /* 290834 */   // Label 5893: @290834
     /* 290834 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(290903), // Rule ID 5963 //
     /* 290839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290879 */     // MIs[2] Operand 1
     /* 290879 */     // No operand predicates
     /* 290879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290885 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290901 */     GIR_RootConstrainSelectedInstOperands,
     /* 290902 */     // GIR_Coverage, 5963,
     /* 290902 */     GIR_EraseRootFromParent_Done,
     /* 290903 */   // Label 5894: @290903
     /* 290903 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(290996), // Rule ID 6117 //
     /* 290908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290947 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290994 */     GIR_RootConstrainSelectedInstOperands,
     /* 290995 */     // GIR_Coverage, 6117,
     /* 290995 */     GIR_EraseRootFromParent_Done,
     /* 290996 */   // Label 5895: @290996
     /* 290996 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(291095), // Rule ID 6029 //
     /* 291001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291044 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 291087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291093 */     GIR_RootConstrainSelectedInstOperands,
     /* 291094 */     // GIR_Coverage, 6029,
     /* 291094 */     GIR_EraseRootFromParent_Done,
     /* 291095 */   // Label 5896: @291095
     /* 291095 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(291191), // Rule ID 6061 //
     /* 291100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 291123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 291127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291142 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291189 */     GIR_RootConstrainSelectedInstOperands,
     /* 291190 */     // GIR_Coverage, 6061,
     /* 291190 */     GIR_EraseRootFromParent_Done,
     /* 291191 */   // Label 5897: @291191
     /* 291191 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(291290), // Rule ID 6093 //
     /* 291196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 291224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 291228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291239 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291288 */     GIR_RootConstrainSelectedInstOperands,
     /* 291289 */     // GIR_Coverage, 6093,
     /* 291289 */     GIR_EraseRootFromParent_Done,
     /* 291290 */   // Label 5898: @291290
     /* 291290 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(291383), // Rule ID 6139 //
     /* 291295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 291323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291334 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291381 */     GIR_RootConstrainSelectedInstOperands,
     /* 291382 */     // GIR_Coverage, 6139,
     /* 291382 */     GIR_EraseRootFromParent_Done,
     /* 291383 */   // Label 5899: @291383
     /* 291383 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(291479), // Rule ID 5997 //
     /* 291388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 291415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 291419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291430 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291442 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291445 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291477 */     GIR_RootConstrainSelectedInstOperands,
     /* 291478 */     // GIR_Coverage, 5997,
     /* 291478 */     GIR_EraseRootFromParent_Done,
     /* 291479 */   // Label 5900: @291479
     /* 291479 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(291563), // Rule ID 2541 //
     /* 291484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291514 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291561 */     GIR_RootConstrainSelectedInstOperands,
     /* 291562 */     // GIR_Coverage, 2541,
     /* 291562 */     GIR_EraseRootFromParent_Done,
     /* 291563 */   // Label 5901: @291563
     /* 291563 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(291613), // Rule ID 13083 //
     /* 291568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291598 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291611 */     GIR_RootConstrainSelectedInstOperands,
     /* 291612 */     // GIR_Coverage, 13083,
     /* 291612 */     GIR_EraseRootFromParent_Done,
     /* 291613 */   // Label 5902: @291613
     /* 291613 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(291697), // Rule ID 5965 //
     /* 291618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291648 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291695 */     GIR_RootConstrainSelectedInstOperands,
     /* 291696 */     // GIR_Coverage, 5965,
     /* 291696 */     GIR_EraseRootFromParent_Done,
     /* 291697 */   // Label 5903: @291697
     /* 291697 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(291747), // Rule ID 1305 //
     /* 291702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291732 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291745 */     GIR_RootConstrainSelectedInstOperands,
     /* 291746 */     // GIR_Coverage, 1305,
     /* 291746 */     GIR_EraseRootFromParent_Done,
     /* 291747 */   // Label 5904: @291747
     /* 291747 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(291780), // Rule ID 1295 //
     /* 291752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291767 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 291770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291778 */     GIR_RootConstrainSelectedInstOperands,
     /* 291779 */     // GIR_Coverage, 1295,
     /* 291779 */     GIR_EraseRootFromParent_Done,
     /* 291780 */   // Label 5905: @291780
     /* 291780 */   GIM_Reject,
     /* 291781 */ // Label 5886: @291781
     /* 291781 */ GIM_Reject,
     /* 291782 */ // Label 5759: @291782
     /* 291782 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(292960),
     /* 291787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291800 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(291884), // Rule ID 6011 //
     /* 291805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291841 */     // MIs[2] Operand 1
     /* 291841 */     // No operand predicates
     /* 291841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291853 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291864 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291882 */     GIR_RootConstrainSelectedInstOperands,
     /* 291883 */     // GIR_Coverage, 6011,
     /* 291883 */     GIR_EraseRootFromParent_Done,
     /* 291884 */   // Label 5907: @291884
     /* 291884 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(291965), // Rule ID 6043 //
     /* 291889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291937 */     // MIs[3] Operand 1
     /* 291937 */     // No operand predicates
     /* 291937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291947 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291963 */     GIR_RootConstrainSelectedInstOperands,
     /* 291964 */     // GIR_Coverage, 6043,
     /* 291964 */     GIR_EraseRootFromParent_Done,
     /* 291965 */   // Label 5908: @291965
     /* 291965 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(292049), // Rule ID 6075 //
     /* 291970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292023 */     // MIs[3] Operand 1
     /* 292023 */     // No operand predicates
     /* 292023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292029 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292047 */     GIR_RootConstrainSelectedInstOperands,
     /* 292048 */     // GIR_Coverage, 6075,
     /* 292048 */     GIR_EraseRootFromParent_Done,
     /* 292049 */   // Label 5909: @292049
     /* 292049 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(292130), // Rule ID 5979 //
     /* 292054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 292081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292102 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292106 */     // MIs[3] Operand 1
     /* 292106 */     // No operand predicates
     /* 292106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292112 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292128 */     GIR_RootConstrainSelectedInstOperands,
     /* 292129 */     // GIR_Coverage, 5979,
     /* 292129 */     GIR_EraseRootFromParent_Done,
     /* 292130 */   // Label 5910: @292130
     /* 292130 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(292199), // Rule ID 2523 //
     /* 292135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 292146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292171 */     // MIs[2] Operand 1
     /* 292171 */     // No operand predicates
     /* 292171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292181 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292197 */     GIR_RootConstrainSelectedInstOperands,
     /* 292198 */     // GIR_Coverage, 2523,
     /* 292198 */     GIR_EraseRootFromParent_Done,
     /* 292199 */   // Label 5911: @292199
     /* 292199 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(292268), // Rule ID 5947 //
     /* 292204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 292219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292244 */     // MIs[2] Operand 1
     /* 292244 */     // No operand predicates
     /* 292244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292250 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292266 */     GIR_RootConstrainSelectedInstOperands,
     /* 292267 */     // GIR_Coverage, 5947,
     /* 292267 */     GIR_EraseRootFromParent_Done,
     /* 292268 */   // Label 5912: @292268
     /* 292268 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(292367), // Rule ID 6013 //
     /* 292273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292316 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 292359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292365 */     GIR_RootConstrainSelectedInstOperands,
     /* 292366 */     // GIR_Coverage, 6013,
     /* 292366 */     GIR_EraseRootFromParent_Done,
     /* 292367 */   // Label 5913: @292367
     /* 292367 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(292463), // Rule ID 6045 //
     /* 292372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292414 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292433 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292461 */     GIR_RootConstrainSelectedInstOperands,
     /* 292462 */     // GIR_Coverage, 6045,
     /* 292462 */     GIR_EraseRootFromParent_Done,
     /* 292463 */   // Label 5914: @292463
     /* 292463 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(292562), // Rule ID 6077 //
     /* 292468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292511 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292560 */     GIR_RootConstrainSelectedInstOperands,
     /* 292561 */     // GIR_Coverage, 6077,
     /* 292561 */     GIR_EraseRootFromParent_Done,
     /* 292562 */   // Label 5915: @292562
     /* 292562 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(292658), // Rule ID 5981 //
     /* 292567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292609 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292656 */     GIR_RootConstrainSelectedInstOperands,
     /* 292657 */     // GIR_Coverage, 5981,
     /* 292657 */     GIR_EraseRootFromParent_Done,
     /* 292658 */   // Label 5916: @292658
     /* 292658 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(292742), // Rule ID 2525 //
     /* 292663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292693 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292740 */     GIR_RootConstrainSelectedInstOperands,
     /* 292741 */     // GIR_Coverage, 2525,
     /* 292741 */     GIR_EraseRootFromParent_Done,
     /* 292742 */   // Label 5917: @292742
     /* 292742 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(292792), // Rule ID 13075 //
     /* 292747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292777 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292790 */     GIR_RootConstrainSelectedInstOperands,
     /* 292791 */     // GIR_Coverage, 13075,
     /* 292791 */     GIR_EraseRootFromParent_Done,
     /* 292792 */   // Label 5918: @292792
     /* 292792 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(292876), // Rule ID 5949 //
     /* 292797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292827 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292874 */     GIR_RootConstrainSelectedInstOperands,
     /* 292875 */     // GIR_Coverage, 5949,
     /* 292875 */     GIR_EraseRootFromParent_Done,
     /* 292876 */   // Label 5919: @292876
     /* 292876 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(292926), // Rule ID 1297 //
     /* 292881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292911 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292924 */     GIR_RootConstrainSelectedInstOperands,
     /* 292925 */     // GIR_Coverage, 1297,
     /* 292925 */     GIR_EraseRootFromParent_Done,
     /* 292926 */   // Label 5920: @292926
     /* 292926 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(292959), // Rule ID 1287 //
     /* 292931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292946 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 292949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292957 */     GIR_RootConstrainSelectedInstOperands,
     /* 292958 */     // GIR_Coverage, 1287,
     /* 292958 */     GIR_EraseRootFromParent_Done,
     /* 292959 */   // Label 5921: @292959
     /* 292959 */   GIM_Reject,
     /* 292960 */ // Label 5906: @292960
     /* 292960 */ GIM_Reject,
     /* 292961 */ // Label 5760: @292961
     /* 292961 */ GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(294481),
     /* 292966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292979 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(293057), // Rule ID 6109 //
     /* 292984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 293021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293029 */     // MIs[3] Operand 1
     /* 293029 */     // No operand predicates
     /* 293029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293039 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293055 */     GIR_RootConstrainSelectedInstOperands,
     /* 293056 */     // GIR_Coverage, 6109,
     /* 293056 */     GIR_EraseRootFromParent_Done,
     /* 293057 */   // Label 5923: @293057
     /* 293057 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(293141), // Rule ID 6023 //
     /* 293062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293098 */     // MIs[2] Operand 1
     /* 293098 */     // No operand predicates
     /* 293098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293110 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293121 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 293132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293139 */     GIR_RootConstrainSelectedInstOperands,
     /* 293140 */     // GIR_Coverage, 6023,
     /* 293140 */     GIR_EraseRootFromParent_Done,
     /* 293141 */   // Label 5924: @293141
     /* 293141 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(293222), // Rule ID 6055 //
     /* 293146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293194 */     // MIs[3] Operand 1
     /* 293194 */     // No operand predicates
     /* 293194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293204 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293220 */     GIR_RootConstrainSelectedInstOperands,
     /* 293221 */     // GIR_Coverage, 6055,
     /* 293221 */     GIR_EraseRootFromParent_Done,
     /* 293222 */   // Label 5925: @293222
     /* 293222 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(293306), // Rule ID 6087 //
     /* 293227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293280 */     // MIs[3] Operand 1
     /* 293280 */     // No operand predicates
     /* 293280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293286 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293304 */     GIR_RootConstrainSelectedInstOperands,
     /* 293305 */     // GIR_Coverage, 6087,
     /* 293305 */     GIR_EraseRootFromParent_Done,
     /* 293306 */   // Label 5926: @293306
     /* 293306 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(293384), // Rule ID 6131 //
     /* 293311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 293352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293360 */     // MIs[3] Operand 1
     /* 293360 */     // No operand predicates
     /* 293360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293366 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293382 */     GIR_RootConstrainSelectedInstOperands,
     /* 293383 */     // GIR_Coverage, 6131,
     /* 293383 */     GIR_EraseRootFromParent_Done,
     /* 293384 */   // Label 5927: @293384
     /* 293384 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(293465), // Rule ID 5991 //
     /* 293389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293437 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293441 */     // MIs[3] Operand 1
     /* 293441 */     // No operand predicates
     /* 293441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293447 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293463 */     GIR_RootConstrainSelectedInstOperands,
     /* 293464 */     // GIR_Coverage, 5991,
     /* 293464 */     GIR_EraseRootFromParent_Done,
     /* 293465 */   // Label 5928: @293465
     /* 293465 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(293534), // Rule ID 2535 //
     /* 293470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293506 */     // MIs[2] Operand 1
     /* 293506 */     // No operand predicates
     /* 293506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293516 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293532 */     GIR_RootConstrainSelectedInstOperands,
     /* 293533 */     // GIR_Coverage, 2535,
     /* 293533 */     GIR_EraseRootFromParent_Done,
     /* 293534 */   // Label 5929: @293534
     /* 293534 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(293603), // Rule ID 5959 //
     /* 293539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293579 */     // MIs[2] Operand 1
     /* 293579 */     // No operand predicates
     /* 293579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293585 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293601 */     GIR_RootConstrainSelectedInstOperands,
     /* 293602 */     // GIR_Coverage, 5959,
     /* 293602 */     GIR_EraseRootFromParent_Done,
     /* 293603 */   // Label 5930: @293603
     /* 293603 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(293696), // Rule ID 6113 //
     /* 293608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293647 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293694 */     GIR_RootConstrainSelectedInstOperands,
     /* 293695 */     // GIR_Coverage, 6113,
     /* 293695 */     GIR_EraseRootFromParent_Done,
     /* 293696 */   // Label 5931: @293696
     /* 293696 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(293795), // Rule ID 6025 //
     /* 293701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293744 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 293787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293793 */     GIR_RootConstrainSelectedInstOperands,
     /* 293794 */     // GIR_Coverage, 6025,
     /* 293794 */     GIR_EraseRootFromParent_Done,
     /* 293795 */   // Label 5932: @293795
     /* 293795 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(293891), // Rule ID 6057 //
     /* 293800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293842 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293889 */     GIR_RootConstrainSelectedInstOperands,
     /* 293890 */     // GIR_Coverage, 6057,
     /* 293890 */     GIR_EraseRootFromParent_Done,
     /* 293891 */   // Label 5933: @293891
     /* 293891 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(293990), // Rule ID 6089 //
     /* 293896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293939 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293988 */     GIR_RootConstrainSelectedInstOperands,
     /* 293989 */     // GIR_Coverage, 6089,
     /* 293989 */     GIR_EraseRootFromParent_Done,
     /* 293990 */   // Label 5934: @293990
     /* 293990 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(294083), // Rule ID 6135 //
     /* 293995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294034 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 294037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 294056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 294069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294081 */     GIR_RootConstrainSelectedInstOperands,
     /* 294082 */     // GIR_Coverage, 6135,
     /* 294082 */     GIR_EraseRootFromParent_Done,
     /* 294083 */   // Label 5935: @294083
     /* 294083 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(294179), // Rule ID 5993 //
     /* 294088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294130 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 294133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 294152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 294165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294177 */     GIR_RootConstrainSelectedInstOperands,
     /* 294178 */     // GIR_Coverage, 5993,
     /* 294178 */     GIR_EraseRootFromParent_Done,
     /* 294179 */   // Label 5936: @294179
     /* 294179 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(294263), // Rule ID 2537 //
     /* 294184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294214 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 294217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294233 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 294236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 294249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294261 */     GIR_RootConstrainSelectedInstOperands,
     /* 294262 */     // GIR_Coverage, 2537,
     /* 294262 */     GIR_EraseRootFromParent_Done,
     /* 294263 */   // Label 5937: @294263
     /* 294263 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(294313), // Rule ID 13081 //
     /* 294268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294298 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 294301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294311 */     GIR_RootConstrainSelectedInstOperands,
     /* 294312 */     // GIR_Coverage, 13081,
     /* 294312 */     GIR_EraseRootFromParent_Done,
     /* 294313 */   // Label 5938: @294313
     /* 294313 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(294397), // Rule ID 5961 //
     /* 294318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294348 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 294351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294367 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 294370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 294383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294395 */     GIR_RootConstrainSelectedInstOperands,
     /* 294396 */     // GIR_Coverage, 5961,
     /* 294396 */     GIR_EraseRootFromParent_Done,
     /* 294397 */   // Label 5939: @294397
     /* 294397 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(294447), // Rule ID 1303 //
     /* 294402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294432 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 294435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294445 */     GIR_RootConstrainSelectedInstOperands,
     /* 294446 */     // GIR_Coverage, 1303,
     /* 294446 */     GIR_EraseRootFromParent_Done,
     /* 294447 */   // Label 5940: @294447
     /* 294447 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(294480), // Rule ID 1293 //
     /* 294452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294467 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 294470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 294478 */     GIR_RootConstrainSelectedInstOperands,
     /* 294479 */     // GIR_Coverage, 1293,
     /* 294479 */     GIR_EraseRootFromParent_Done,
     /* 294480 */   // Label 5941: @294480
     /* 294480 */   GIM_Reject,
     /* 294481 */ // Label 5922: @294481
     /* 294481 */ GIM_Reject,
     /* 294482 */ // Label 5761: @294482
     /* 294482 */ GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(295660),
     /* 294487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294500 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(294584), // Rule ID 6007 //
     /* 294505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294541 */     // MIs[2] Operand 1
     /* 294541 */     // No operand predicates
     /* 294541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294553 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294564 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294582 */     GIR_RootConstrainSelectedInstOperands,
     /* 294583 */     // GIR_Coverage, 6007,
     /* 294583 */     GIR_EraseRootFromParent_Done,
     /* 294584 */   // Label 5943: @294584
     /* 294584 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(294665), // Rule ID 6039 //
     /* 294589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294633 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294637 */     // MIs[3] Operand 1
     /* 294637 */     // No operand predicates
     /* 294637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294647 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294663 */     GIR_RootConstrainSelectedInstOperands,
     /* 294664 */     // GIR_Coverage, 6039,
     /* 294664 */     GIR_EraseRootFromParent_Done,
     /* 294665 */   // Label 5944: @294665
     /* 294665 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(294749), // Rule ID 6071 //
     /* 294670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294719 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294723 */     // MIs[3] Operand 1
     /* 294723 */     // No operand predicates
     /* 294723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294729 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294747 */     GIR_RootConstrainSelectedInstOperands,
     /* 294748 */     // GIR_Coverage, 6071,
     /* 294748 */     GIR_EraseRootFromParent_Done,
     /* 294749 */   // Label 5945: @294749
     /* 294749 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(294830), // Rule ID 5975 //
     /* 294754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294802 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294806 */     // MIs[3] Operand 1
     /* 294806 */     // No operand predicates
     /* 294806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294812 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294828 */     GIR_RootConstrainSelectedInstOperands,
     /* 294829 */     // GIR_Coverage, 5975,
     /* 294829 */     GIR_EraseRootFromParent_Done,
     /* 294830 */   // Label 5946: @294830
     /* 294830 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(294899), // Rule ID 2519 //
     /* 294835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294871 */     // MIs[2] Operand 1
     /* 294871 */     // No operand predicates
     /* 294871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294881 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294897 */     GIR_RootConstrainSelectedInstOperands,
     /* 294898 */     // GIR_Coverage, 2519,
     /* 294898 */     GIR_EraseRootFromParent_Done,
     /* 294899 */   // Label 5947: @294899
     /* 294899 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(294968), // Rule ID 5943 //
     /* 294904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294944 */     // MIs[2] Operand 1
     /* 294944 */     // No operand predicates
     /* 294944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294950 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294966 */     GIR_RootConstrainSelectedInstOperands,
     /* 294967 */     // GIR_Coverage, 5943,
     /* 294967 */     GIR_EraseRootFromParent_Done,
     /* 294968 */   // Label 5948: @294968
     /* 294968 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(295067), // Rule ID 6009 //
     /* 294973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295016 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 295051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 295059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295065 */     GIR_RootConstrainSelectedInstOperands,
     /* 295066 */     // GIR_Coverage, 6009,
     /* 295066 */     GIR_EraseRootFromParent_Done,
     /* 295067 */   // Label 5949: @295067
     /* 295067 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(295163), // Rule ID 6041 //
     /* 295072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 295095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295114 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 295149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295161 */     GIR_RootConstrainSelectedInstOperands,
     /* 295162 */     // GIR_Coverage, 6041,
     /* 295162 */     GIR_EraseRootFromParent_Done,
     /* 295163 */   // Label 5950: @295163
     /* 295163 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(295262), // Rule ID 6073 //
     /* 295168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 295196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295211 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 295246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295260 */     GIR_RootConstrainSelectedInstOperands,
     /* 295261 */     // GIR_Coverage, 6073,
     /* 295261 */     GIR_EraseRootFromParent_Done,
     /* 295262 */   // Label 5951: @295262
     /* 295262 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(295358), // Rule ID 5977 //
     /* 295267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 295294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 295298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295309 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 295344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295356 */     GIR_RootConstrainSelectedInstOperands,
     /* 295357 */     // GIR_Coverage, 5977,
     /* 295357 */     GIR_EraseRootFromParent_Done,
     /* 295358 */   // Label 5952: @295358
     /* 295358 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(295442), // Rule ID 2521 //
     /* 295363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295393 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 295428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295440 */     GIR_RootConstrainSelectedInstOperands,
     /* 295441 */     // GIR_Coverage, 2521,
     /* 295441 */     GIR_EraseRootFromParent_Done,
     /* 295442 */   // Label 5953: @295442
     /* 295442 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(295492), // Rule ID 13077 //
     /* 295447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295477 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295490 */     GIR_RootConstrainSelectedInstOperands,
     /* 295491 */     // GIR_Coverage, 13077,
     /* 295491 */     GIR_EraseRootFromParent_Done,
     /* 295492 */   // Label 5954: @295492
     /* 295492 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(295576), // Rule ID 5945 //
     /* 295497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295527 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295539 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 295562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295574 */     GIR_RootConstrainSelectedInstOperands,
     /* 295575 */     // GIR_Coverage, 5945,
     /* 295575 */     GIR_EraseRootFromParent_Done,
     /* 295576 */   // Label 5955: @295576
     /* 295576 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(295626), // Rule ID 1299 //
     /* 295581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295611 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295624 */     GIR_RootConstrainSelectedInstOperands,
     /* 295625 */     // GIR_Coverage, 1299,
     /* 295625 */     GIR_EraseRootFromParent_Done,
     /* 295626 */   // Label 5956: @295626
     /* 295626 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(295659), // Rule ID 1289 //
     /* 295631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295646 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 295649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295657 */     GIR_RootConstrainSelectedInstOperands,
     /* 295658 */     // GIR_Coverage, 1289,
     /* 295658 */     GIR_EraseRootFromParent_Done,
     /* 295659 */   // Label 5957: @295659
     /* 295659 */   GIM_Reject,
     /* 295660 */ // Label 5942: @295660
     /* 295660 */ GIM_Reject,
     /* 295661 */ // Label 5762: @295661
     /* 295661 */ GIM_Reject,
     /* 295662 */ // Label 58: @295662
     /* 295662 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5966*/ GIMT_Encode4(296277),
     /* 295673 */ /*GILLT_s16*//*Label 5958*/ GIMT_Encode4(295713),
     /* 295677 */ /*GILLT_s32*//*Label 5959*/ GIMT_Encode4(295751),
     /* 295681 */ /*GILLT_s64*//*Label 5960*/ GIMT_Encode4(295789), GIMT_Encode4(0),
     /* 295689 */ /*GILLT_v2s32*//*Label 5961*/ GIMT_Encode4(295827),
     /* 295693 */ /*GILLT_v2s64*//*Label 5962*/ GIMT_Encode4(295865),
     /* 295697 */ /*GILLT_v4s16*//*Label 5963*/ GIMT_Encode4(295903),
     /* 295701 */ /*GILLT_v4s32*//*Label 5964*/ GIMT_Encode4(295941), GIMT_Encode4(0),
     /* 295709 */ /*GILLT_v8s16*//*Label 5965*/ GIMT_Encode4(295979),
     /* 295713 */ // Label 5958: @295713
     /* 295713 */ GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(295750), // Rule ID 590 //
     /* 295718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295739 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 295739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 295744 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295748 */   GIR_RootConstrainSelectedInstOperands,
     /* 295749 */   // GIR_Coverage, 590,
     /* 295749 */   GIR_Done,
     /* 295750 */ // Label 5967: @295750
     /* 295750 */ GIM_Reject,
     /* 295751 */ // Label 5959: @295751
     /* 295751 */ GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(295788), // Rule ID 592 //
     /* 295756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295777 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 295777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 295782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295786 */   GIR_RootConstrainSelectedInstOperands,
     /* 295787 */   // GIR_Coverage, 592,
     /* 295787 */   GIR_Done,
     /* 295788 */ // Label 5968: @295788
     /* 295788 */ GIM_Reject,
     /* 295789 */ // Label 5960: @295789
     /* 295789 */ GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(295826), // Rule ID 594 //
     /* 295794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295815 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 295815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 295820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295824 */   GIR_RootConstrainSelectedInstOperands,
     /* 295825 */   // GIR_Coverage, 594,
     /* 295825 */   GIR_Done,
     /* 295826 */ // Label 5969: @295826
     /* 295826 */ GIM_Reject,
     /* 295827 */ // Label 5961: @295827
     /* 295827 */ GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(295864), // Rule ID 1221 //
     /* 295832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295853 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 295853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 295858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295862 */   GIR_RootConstrainSelectedInstOperands,
     /* 295863 */   // GIR_Coverage, 1221,
     /* 295863 */   GIR_Done,
     /* 295864 */ // Label 5970: @295864
     /* 295864 */ GIM_Reject,
     /* 295865 */ // Label 5962: @295865
     /* 295865 */ GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(295902), // Rule ID 1225 //
     /* 295870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 295879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295891 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 295891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 295896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295900 */   GIR_RootConstrainSelectedInstOperands,
     /* 295901 */   // GIR_Coverage, 1225,
     /* 295901 */   GIR_Done,
     /* 295902 */ // Label 5971: @295902
     /* 295902 */ GIM_Reject,
     /* 295903 */ // Label 5963: @295903
     /* 295903 */ GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(295940), // Rule ID 1217 //
     /* 295908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 295917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295929 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 295934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295938 */   GIR_RootConstrainSelectedInstOperands,
     /* 295939 */   // GIR_Coverage, 1217,
     /* 295939 */   GIR_Done,
     /* 295940 */ // Label 5972: @295940
     /* 295940 */ GIM_Reject,
     /* 295941 */ // Label 5964: @295941
     /* 295941 */ GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(295978), // Rule ID 1223 //
     /* 295946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295967 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 295967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295976 */   GIR_RootConstrainSelectedInstOperands,
     /* 295977 */   // GIR_Coverage, 1223,
     /* 295977 */   GIR_Done,
     /* 295978 */ // Label 5973: @295978
     /* 295978 */ GIM_Reject,
     /* 295979 */ // Label 5965: @295979
     /* 295979 */ GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(296276),
     /* 295984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 295990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296002 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(296021), // Rule ID 1219 //
     /* 296007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 296010 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 296010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 296015 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 296019 */     GIR_RootConstrainSelectedInstOperands,
     /* 296020 */     // GIR_Coverage, 1219,
     /* 296020 */     GIR_Done,
     /* 296021 */   // Label 5975: @296021
     /* 296021 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(296275), // Rule ID 6916 //
     /* 296026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 296029 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 296029 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 296032 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 296036 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296041 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 296045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 296047 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 296050 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 296054 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296059 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 296065 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 296068 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 296072 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296077 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 296080 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 296083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 296085 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 296088 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296092 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296097 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296103 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296108 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296113 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 296116 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 296120 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296125 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 296128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 296130 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 296133 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296137 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296142 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296148 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296153 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296158 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 296161 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 296165 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296170 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 296173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 296175 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 296178 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 296182 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296187 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 296190 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 296193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 296195 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 296198 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 296202 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296207 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 296210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 296212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 296215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 296219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 296226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 296233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 296241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 296244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 296247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 296265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 296273 */     GIR_RootConstrainSelectedInstOperands,
     /* 296274 */     // GIR_Coverage, 6916,
     /* 296274 */     GIR_EraseRootFromParent_Done,
     /* 296275 */   // Label 5976: @296275
     /* 296275 */   GIM_Reject,
     /* 296276 */ // Label 5974: @296276
     /* 296276 */ GIM_Reject,
     /* 296277 */ // Label 5966: @296277
     /* 296277 */ GIM_Reject,
     /* 296278 */ // Label 59: @296278
     /* 296278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5985*/ GIMT_Encode4(299784),
     /* 296289 */ /*GILLT_s16*//*Label 5977*/ GIMT_Encode4(296329),
     /* 296293 */ /*GILLT_s32*//*Label 5978*/ GIMT_Encode4(297497),
     /* 296297 */ /*GILLT_s64*//*Label 5979*/ GIMT_Encode4(298520), GIMT_Encode4(0),
     /* 296305 */ /*GILLT_v2s32*//*Label 5980*/ GIMT_Encode4(299543),
     /* 296309 */ /*GILLT_v2s64*//*Label 5981*/ GIMT_Encode4(299570),
     /* 296313 */ /*GILLT_v4s16*//*Label 5982*/ GIMT_Encode4(299597),
     /* 296317 */ /*GILLT_v4s32*//*Label 5983*/ GIMT_Encode4(299677), GIMT_Encode4(0),
     /* 296325 */ /*GILLT_v8s16*//*Label 5984*/ GIMT_Encode4(299704),
     /* 296329 */ // Label 5977: @296329
     /* 296329 */ GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(297496),
     /* 296334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 296337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296341 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(296499), // Rule ID 4787 //
     /* 296346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296365 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296410 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296415 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296426 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 296429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296438 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296497 */     GIR_RootConstrainSelectedInstOperands,
     /* 296498 */     // GIR_Coverage, 4787,
     /* 296498 */     GIR_EraseRootFromParent_Done,
     /* 296499 */   // Label 5987: @296499
     /* 296499 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(296657), // Rule ID 4786 //
     /* 296504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296548 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296568 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296573 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296584 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 296587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296596 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296624 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296655 */     GIR_RootConstrainSelectedInstOperands,
     /* 296656 */     // GIR_Coverage, 4786,
     /* 296656 */     GIR_EraseRootFromParent_Done,
     /* 296657 */   // Label 5988: @296657
     /* 296657 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(296768), // Rule ID 4785 //
     /* 296662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296681 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296706 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296722 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296766 */     GIR_RootConstrainSelectedInstOperands,
     /* 296767 */     // GIR_Coverage, 4785,
     /* 296767 */     GIR_EraseRootFromParent_Done,
     /* 296768 */   // Label 5989: @296768
     /* 296768 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(296879), // Rule ID 4783 //
     /* 296773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296822 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296833 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296877 */     GIR_RootConstrainSelectedInstOperands,
     /* 296878 */     // GIR_Coverage, 4783,
     /* 296878 */     GIR_EraseRootFromParent_Done,
     /* 296879 */   // Label 5990: @296879
     /* 296879 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(296990), // Rule ID 4784 //
     /* 296884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296903 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296928 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296944 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296988 */     GIR_RootConstrainSelectedInstOperands,
     /* 296989 */     // GIR_Coverage, 4784,
     /* 296989 */     GIR_EraseRootFromParent_Done,
     /* 296990 */   // Label 5991: @296990
     /* 296990 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(297101), // Rule ID 4782 //
     /* 296995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 297014 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 297018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297044 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297055 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 297055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 297058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 297073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 297086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297099 */     GIR_RootConstrainSelectedInstOperands,
     /* 297100 */     // GIR_Coverage, 4782,
     /* 297100 */     GIR_EraseRootFromParent_Done,
     /* 297101 */   // Label 5992: @297101
     /* 297101 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(297165), // Rule ID 650 //
     /* 297106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 297109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 297125 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 297129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297146 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 297146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 297149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297163 */     GIR_RootConstrainSelectedInstOperands,
     /* 297164 */     // GIR_Coverage, 650,
     /* 297164 */     GIR_EraseRootFromParent_Done,
     /* 297165 */   // Label 5993: @297165
     /* 297165 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(297229), // Rule ID 649 //
     /* 297170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 297173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 297189 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 297193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297210 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 297210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 297213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297227 */     GIR_RootConstrainSelectedInstOperands,
     /* 297228 */     // GIR_Coverage, 649,
     /* 297228 */     GIR_EraseRootFromParent_Done,
     /* 297229 */   // Label 5994: @297229
     /* 297229 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(297280), // Rule ID 626 //
     /* 297234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 297237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 297245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 297253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297265 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 297265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 297268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297278 */     GIR_RootConstrainSelectedInstOperands,
     /* 297279 */     // GIR_Coverage, 626,
     /* 297279 */     GIR_EraseRootFromParent_Done,
     /* 297280 */   // Label 5995: @297280
     /* 297280 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(297331), // Rule ID 625 //
     /* 297285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 297288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 297296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 297304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297316 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 297316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 297319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297329 */     GIR_RootConstrainSelectedInstOperands,
     /* 297330 */     // GIR_Coverage, 625,
     /* 297330 */     GIR_EraseRootFromParent_Done,
     /* 297331 */   // Label 5996: @297331
     /* 297331 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(297350), // Rule ID 524 //
     /* 297336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 297339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297343 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 297343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 297348 */     GIR_RootConstrainSelectedInstOperands,
     /* 297349 */     // GIR_Coverage, 524,
     /* 297349 */     GIR_Done,
     /* 297350 */   // Label 5997: @297350
     /* 297350 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(297495), // Rule ID 6283 //
     /* 297355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297359 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 297359 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 297362 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 297366 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 297373 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 297376 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 297380 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297385 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 297388 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297392 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 297395 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297400 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297405 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297410 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 297413 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297417 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297422 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 297425 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 297430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 297437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297442 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 297445 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 297450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 297452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 297484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297494 */     // GIR_Coverage, 6283,
     /* 297494 */     GIR_EraseRootFromParent_Done,
     /* 297495 */   // Label 5998: @297495
     /* 297495 */   GIM_Reject,
     /* 297496 */ // Label 5986: @297496
     /* 297496 */ GIM_Reject,
     /* 297497 */ // Label 5978: @297497
     /* 297497 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(298519),
     /* 297502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 297505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297509 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(297667), // Rule ID 4793 //
     /* 297514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297558 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297574 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297583 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297594 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297606 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297665 */     GIR_RootConstrainSelectedInstOperands,
     /* 297666 */     // GIR_Coverage, 4793,
     /* 297666 */     GIR_EraseRootFromParent_Done,
     /* 297667 */   // Label 6000: @297667
     /* 297667 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(297825), // Rule ID 4792 //
     /* 297672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297691 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297741 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297752 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297752 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297755 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297759 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297764 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297775 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297792 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297823 */     GIR_RootConstrainSelectedInstOperands,
     /* 297824 */     // GIR_Coverage, 4792,
     /* 297824 */     GIR_EraseRootFromParent_Done,
     /* 297825 */   // Label 6001: @297825
     /* 297825 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(297936), // Rule ID 4791 //
     /* 297830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297849 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297874 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297890 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297934 */     GIR_RootConstrainSelectedInstOperands,
     /* 297935 */     // GIR_Coverage, 4791,
     /* 297935 */     GIR_EraseRootFromParent_Done,
     /* 297936 */   // Label 6002: @297936
     /* 297936 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(298047), // Rule ID 4789 //
     /* 297941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297990 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298001 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 298001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298013 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 298019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298045 */     GIR_RootConstrainSelectedInstOperands,
     /* 298046 */     // GIR_Coverage, 4789,
     /* 298046 */     GIR_EraseRootFromParent_Done,
     /* 298047 */   // Label 6003: @298047
     /* 298047 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(298158), // Rule ID 4790 //
     /* 298052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 298075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298112 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298124 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 298130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298156 */     GIR_RootConstrainSelectedInstOperands,
     /* 298157 */     // GIR_Coverage, 4790,
     /* 298157 */     GIR_EraseRootFromParent_Done,
     /* 298158 */   // Label 6004: @298158
     /* 298158 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(298269), // Rule ID 4788 //
     /* 298163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298182 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 298186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298223 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 298223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 298241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298267 */     GIR_RootConstrainSelectedInstOperands,
     /* 298268 */     // GIR_Coverage, 4788,
     /* 298268 */     GIR_EraseRootFromParent_Done,
     /* 298269 */   // Label 6005: @298269
     /* 298269 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(298333), // Rule ID 652 //
     /* 298274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298293 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 298297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298314 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298331 */     GIR_RootConstrainSelectedInstOperands,
     /* 298332 */     // GIR_Coverage, 652,
     /* 298332 */     GIR_EraseRootFromParent_Done,
     /* 298333 */   // Label 6006: @298333
     /* 298333 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(298397), // Rule ID 651 //
     /* 298338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298357 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 298361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298378 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 298378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 298381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298395 */     GIR_RootConstrainSelectedInstOperands,
     /* 298396 */     // GIR_Coverage, 651,
     /* 298396 */     GIR_EraseRootFromParent_Done,
     /* 298397 */   // Label 6007: @298397
     /* 298397 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(298448), // Rule ID 628 //
     /* 298402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 298413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298433 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 298436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298446 */     GIR_RootConstrainSelectedInstOperands,
     /* 298447 */     // GIR_Coverage, 628,
     /* 298447 */     GIR_EraseRootFromParent_Done,
     /* 298448 */   // Label 6008: @298448
     /* 298448 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(298499), // Rule ID 627 //
     /* 298453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 298464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298484 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 298487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298497 */     GIR_RootConstrainSelectedInstOperands,
     /* 298498 */     // GIR_Coverage, 627,
     /* 298498 */     GIR_EraseRootFromParent_Done,
     /* 298499 */   // Label 6009: @298499
     /* 298499 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(298518), // Rule ID 525 //
     /* 298504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298511 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 298511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 298516 */     GIR_RootConstrainSelectedInstOperands,
     /* 298517 */     // GIR_Coverage, 525,
     /* 298517 */     GIR_Done,
     /* 298518 */   // Label 6010: @298518
     /* 298518 */   GIM_Reject,
     /* 298519 */ // Label 5999: @298519
     /* 298519 */ GIM_Reject,
     /* 298520 */ // Label 5979: @298520
     /* 298520 */ GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(299542),
     /* 298525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298532 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(298690), // Rule ID 4799 //
     /* 298537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298597 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298601 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298606 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298617 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298629 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298657 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298688 */     GIR_RootConstrainSelectedInstOperands,
     /* 298689 */     // GIR_Coverage, 4799,
     /* 298689 */     GIR_EraseRootFromParent_Done,
     /* 298690 */   // Label 6012: @298690
     /* 298690 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(298848), // Rule ID 4798 //
     /* 298695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298755 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298759 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298764 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298775 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298787 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298815 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298846 */     GIR_RootConstrainSelectedInstOperands,
     /* 298847 */     // GIR_Coverage, 4798,
     /* 298847 */     GIR_EraseRootFromParent_Done,
     /* 298848 */   // Label 6013: @298848
     /* 298848 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(298959), // Rule ID 4797 //
     /* 298853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298913 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298957 */     GIR_RootConstrainSelectedInstOperands,
     /* 298958 */     // GIR_Coverage, 4797,
     /* 298958 */     GIR_EraseRootFromParent_Done,
     /* 298959 */   // Label 6014: @298959
     /* 298959 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(299070), // Rule ID 4795 //
     /* 298964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299013 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299024 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299068 */     GIR_RootConstrainSelectedInstOperands,
     /* 299069 */     // GIR_Coverage, 4795,
     /* 299069 */     GIR_EraseRootFromParent_Done,
     /* 299070 */   // Label 6015: @299070
     /* 299070 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(299181), // Rule ID 4796 //
     /* 299075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299094 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 299098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299135 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299179 */     GIR_RootConstrainSelectedInstOperands,
     /* 299180 */     // GIR_Coverage, 4796,
     /* 299180 */     GIR_EraseRootFromParent_Done,
     /* 299181 */   // Label 6016: @299181
     /* 299181 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(299292), // Rule ID 4794 //
     /* 299186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299205 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 299209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299235 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299246 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299290 */     GIR_RootConstrainSelectedInstOperands,
     /* 299291 */     // GIR_Coverage, 4794,
     /* 299291 */     GIR_EraseRootFromParent_Done,
     /* 299292 */   // Label 6017: @299292
     /* 299292 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(299356), // Rule ID 654 //
     /* 299297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 299308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 299320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299337 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299354 */     GIR_RootConstrainSelectedInstOperands,
     /* 299355 */     // GIR_Coverage, 654,
     /* 299355 */     GIR_EraseRootFromParent_Done,
     /* 299356 */   // Label 6018: @299356
     /* 299356 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(299420), // Rule ID 653 //
     /* 299361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 299372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299380 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 299384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299401 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 299418 */     GIR_RootConstrainSelectedInstOperands,
     /* 299419 */     // GIR_Coverage, 653,
     /* 299419 */     GIR_EraseRootFromParent_Done,
     /* 299420 */   // Label 6019: @299420
     /* 299420 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(299471), // Rule ID 630 //
     /* 299425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 299436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299456 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299469 */     GIR_RootConstrainSelectedInstOperands,
     /* 299470 */     // GIR_Coverage, 630,
     /* 299470 */     GIR_EraseRootFromParent_Done,
     /* 299471 */   // Label 6020: @299471
     /* 299471 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(299522), // Rule ID 629 //
     /* 299476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 299487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299507 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299520 */     GIR_RootConstrainSelectedInstOperands,
     /* 299521 */     // GIR_Coverage, 629,
     /* 299521 */     GIR_EraseRootFromParent_Done,
     /* 299522 */   // Label 6021: @299522
     /* 299522 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(299541), // Rule ID 526 //
     /* 299527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299534 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 299534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 299539 */     GIR_RootConstrainSelectedInstOperands,
     /* 299540 */     // GIR_Coverage, 526,
     /* 299540 */     GIR_Done,
     /* 299541 */   // Label 6022: @299541
     /* 299541 */   GIM_Reject,
     /* 299542 */ // Label 6011: @299542
     /* 299542 */ GIM_Reject,
     /* 299543 */ // Label 5980: @299543
     /* 299543 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(299569), // Rule ID 853 //
     /* 299548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299562 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 299562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 299567 */   GIR_RootConstrainSelectedInstOperands,
     /* 299568 */   // GIR_Coverage, 853,
     /* 299568 */   GIR_Done,
     /* 299569 */ // Label 6023: @299569
     /* 299569 */ GIM_Reject,
     /* 299570 */ // Label 5981: @299570
     /* 299570 */ GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(299596), // Rule ID 855 //
     /* 299575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299589 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 299589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 299594 */   GIR_RootConstrainSelectedInstOperands,
     /* 299595 */   // GIR_Coverage, 855,
     /* 299595 */   GIR_Done,
     /* 299596 */ // Label 6024: @299596
     /* 299596 */ GIM_Reject,
     /* 299597 */ // Label 5982: @299597
     /* 299597 */ GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(299676),
     /* 299602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299613 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(299628), // Rule ID 851 //
     /* 299618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299621 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 299621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 299626 */     GIR_RootConstrainSelectedInstOperands,
     /* 299627 */     // GIR_Coverage, 851,
     /* 299627 */     GIR_Done,
     /* 299628 */   // Label 6026: @299628
     /* 299628 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(299675), // Rule ID 6286 //
     /* 299633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299636 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 299643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299648 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 299666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299673 */     GIR_RootConstrainSelectedInstOperands,
     /* 299674 */     // GIR_Coverage, 6286,
     /* 299674 */     GIR_EraseRootFromParent_Done,
     /* 299675 */   // Label 6027: @299675
     /* 299675 */   GIM_Reject,
     /* 299676 */ // Label 6025: @299676
     /* 299676 */ GIM_Reject,
     /* 299677 */ // Label 5983: @299677
     /* 299677 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(299703), // Rule ID 854 //
     /* 299682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299696 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 299696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 299701 */   GIR_RootConstrainSelectedInstOperands,
     /* 299702 */   // GIR_Coverage, 854,
     /* 299702 */   GIR_Done,
     /* 299703 */ // Label 6028: @299703
     /* 299703 */ GIM_Reject,
     /* 299704 */ // Label 5984: @299704
     /* 299704 */ GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(299783),
     /* 299709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299720 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(299735), // Rule ID 852 //
     /* 299725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299728 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 299728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 299733 */     GIR_RootConstrainSelectedInstOperands,
     /* 299734 */     // GIR_Coverage, 852,
     /* 299734 */     GIR_Done,
     /* 299735 */   // Label 6030: @299735
     /* 299735 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(299782), // Rule ID 6287 //
     /* 299740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299743 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 299750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299755 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 299773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299780 */     GIR_RootConstrainSelectedInstOperands,
     /* 299781 */     // GIR_Coverage, 6287,
     /* 299781 */     GIR_EraseRootFromParent_Done,
     /* 299782 */   // Label 6031: @299782
     /* 299782 */   GIM_Reject,
     /* 299783 */ // Label 6029: @299783
     /* 299783 */ GIM_Reject,
     /* 299784 */ // Label 5985: @299784
     /* 299784 */ GIM_Reject,
     /* 299785 */ // Label 60: @299785
     /* 299785 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6036*/ GIMT_Encode4(300032),
     /* 299796 */ /*GILLT_s32*//*Label 6032*/ GIMT_Encode4(299824),
     /* 299800 */ /*GILLT_s64*//*Label 6033*/ GIMT_Encode4(299855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299812 */ /*GILLT_v2s64*//*Label 6034*/ GIMT_Encode4(299916), GIMT_Encode4(0),
     /* 299820 */ /*GILLT_v4s32*//*Label 6035*/ GIMT_Encode4(299974),
     /* 299824 */ // Label 6032: @299824
     /* 299824 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(299854), // Rule ID 516 //
     /* 299829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299843 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 299843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 299848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299852 */   GIR_RootConstrainSelectedInstOperands,
     /* 299853 */   // GIR_Coverage, 516,
     /* 299853 */   GIR_Done,
     /* 299854 */ // Label 6037: @299854
     /* 299854 */ GIM_Reject,
     /* 299855 */ // Label 6033: @299855
     /* 299855 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(299885), // Rule ID 514 //
     /* 299860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299874 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 299874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 299879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299883 */   GIR_RootConstrainSelectedInstOperands,
     /* 299884 */   // GIR_Coverage, 514,
     /* 299884 */   GIR_Done,
     /* 299885 */ // Label 6038: @299885
     /* 299885 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(299915), // Rule ID 518 //
     /* 299890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299904 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 299904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 299909 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299913 */   GIR_RootConstrainSelectedInstOperands,
     /* 299914 */   // GIR_Coverage, 518,
     /* 299914 */   GIR_Done,
     /* 299915 */ // Label 6039: @299915
     /* 299915 */ GIM_Reject,
     /* 299916 */ // Label 6034: @299916
     /* 299916 */ GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(299973),
     /* 299921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299928 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(299952), // Rule ID 4842 //
     /* 299933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 299940 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 299940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 299943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299950 */     GIR_RootConstrainSelectedInstOperands,
     /* 299951 */     // GIR_Coverage, 4842,
     /* 299951 */     GIR_EraseRootFromParent_Done,
     /* 299952 */   // Label 6041: @299952
     /* 299952 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(299972), // Rule ID 4840 //
     /* 299957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299961 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 299961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 299966 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299970 */     GIR_RootConstrainSelectedInstOperands,
     /* 299971 */     // GIR_Coverage, 4840,
     /* 299971 */     GIR_Done,
     /* 299972 */   // Label 6042: @299972
     /* 299972 */   GIM_Reject,
     /* 299973 */ // Label 6040: @299973
     /* 299973 */ GIM_Reject,
     /* 299974 */ // Label 6035: @299974
     /* 299974 */ GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(300031),
     /* 299979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299986 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(300010), // Rule ID 4846 //
     /* 299991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 299998 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 299998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 300001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300008 */     GIR_RootConstrainSelectedInstOperands,
     /* 300009 */     // GIR_Coverage, 4846,
     /* 300009 */     GIR_EraseRootFromParent_Done,
     /* 300010 */   // Label 6044: @300010
     /* 300010 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(300030), // Rule ID 4844 //
     /* 300015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300019 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 300019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 300024 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300028 */     GIR_RootConstrainSelectedInstOperands,
     /* 300029 */     // GIR_Coverage, 4844,
     /* 300029 */     GIR_Done,
     /* 300030 */   // Label 6045: @300030
     /* 300030 */   GIM_Reject,
     /* 300031 */ // Label 6043: @300031
     /* 300031 */ GIM_Reject,
     /* 300032 */ // Label 6036: @300032
     /* 300032 */ GIM_Reject,
     /* 300033 */ // Label 61: @300033
     /* 300033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6050*/ GIMT_Encode4(300220),
     /* 300044 */ /*GILLT_s16*//*Label 6046*/ GIMT_Encode4(300072),
     /* 300048 */ /*GILLT_s32*//*Label 6047*/ GIMT_Encode4(300133), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300060 */ /*GILLT_v2s32*//*Label 6048*/ GIMT_Encode4(300164), GIMT_Encode4(0),
     /* 300068 */ /*GILLT_v4s16*//*Label 6049*/ GIMT_Encode4(300192),
     /* 300072 */ // Label 6046: @300072
     /* 300072 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(300102), // Rule ID 510 //
     /* 300077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300091 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 300091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 300096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300100 */   GIR_RootConstrainSelectedInstOperands,
     /* 300101 */   // GIR_Coverage, 510,
     /* 300101 */   GIR_Done,
     /* 300102 */ // Label 6051: @300102
     /* 300102 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(300132), // Rule ID 520 //
     /* 300107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300121 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 300121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 300126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300130 */   GIR_RootConstrainSelectedInstOperands,
     /* 300131 */   // GIR_Coverage, 520,
     /* 300131 */   GIR_Done,
     /* 300132 */ // Label 6052: @300132
     /* 300132 */ GIM_Reject,
     /* 300133 */ // Label 6047: @300133
     /* 300133 */ GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(300163), // Rule ID 512 //
     /* 300138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300152 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 300152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 300157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300161 */   GIR_RootConstrainSelectedInstOperands,
     /* 300162 */   // GIR_Coverage, 512,
     /* 300162 */   GIR_Done,
     /* 300163 */ // Label 6053: @300163
     /* 300163 */ GIM_Reject,
     /* 300164 */ // Label 6048: @300164
     /* 300164 */ GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(300191), // Rule ID 4850 //
     /* 300169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300180 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 300180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 300185 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300189 */   GIR_RootConstrainSelectedInstOperands,
     /* 300190 */   // GIR_Coverage, 4850,
     /* 300190 */   GIR_Done,
     /* 300191 */ // Label 6054: @300191
     /* 300191 */ GIM_Reject,
     /* 300192 */ // Label 6049: @300192
     /* 300192 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(300219), // Rule ID 4852 //
     /* 300197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300208 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 300208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 300213 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300217 */   GIR_RootConstrainSelectedInstOperands,
     /* 300218 */   // GIR_Coverage, 4852,
     /* 300218 */   GIR_Done,
     /* 300219 */ // Label 6055: @300219
     /* 300219 */ GIM_Reject,
     /* 300220 */ // Label 6050: @300220
     /* 300220 */ GIM_Reject,
     /* 300221 */ // Label 62: @300221
     /* 300221 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6063*/ GIMT_Encode4(301283),
     /* 300232 */ /*GILLT_s32*//*Label 6056*/ GIMT_Encode4(300268),
     /* 300236 */ /*GILLT_s64*//*Label 6057*/ GIMT_Encode4(300655), GIMT_Encode4(0),
     /* 300244 */ /*GILLT_v2s32*//*Label 6058*/ GIMT_Encode4(301042),
     /* 300248 */ /*GILLT_v2s64*//*Label 6059*/ GIMT_Encode4(301116),
     /* 300252 */ /*GILLT_v4s16*//*Label 6060*/ GIMT_Encode4(301190),
     /* 300256 */ /*GILLT_v4s32*//*Label 6061*/ GIMT_Encode4(301221), GIMT_Encode4(0),
     /* 300264 */ /*GILLT_v8s16*//*Label 6062*/ GIMT_Encode4(301252),
     /* 300268 */ // Label 6056: @300268
     /* 300268 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(300305), // Rule ID 4589 //
     /* 300273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300280 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300284 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300288 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300294 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 300297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300299 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300303 */   GIR_RootConstrainSelectedInstOperands,
     /* 300304 */   // GIR_Coverage, 4589,
     /* 300304 */   GIR_EraseRootFromParent_Done,
     /* 300305 */ // Label 6064: @300305
     /* 300305 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(300342), // Rule ID 4591 //
     /* 300310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300325 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300331 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 300334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300336 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300340 */   GIR_RootConstrainSelectedInstOperands,
     /* 300341 */   // GIR_Coverage, 4591,
     /* 300341 */   GIR_EraseRootFromParent_Done,
     /* 300342 */ // Label 6065: @300342
     /* 300342 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(300379), // Rule ID 4609 //
     /* 300347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300368 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 300371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300373 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300377 */   GIR_RootConstrainSelectedInstOperands,
     /* 300378 */   // GIR_Coverage, 4609,
     /* 300378 */   GIR_EraseRootFromParent_Done,
     /* 300379 */ // Label 6066: @300379
     /* 300379 */ GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(300416), // Rule ID 4611 //
     /* 300384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300399 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300405 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 300408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300410 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300414 */   GIR_RootConstrainSelectedInstOperands,
     /* 300415 */   // GIR_Coverage, 4611,
     /* 300415 */   GIR_EraseRootFromParent_Done,
     /* 300416 */ // Label 6067: @300416
     /* 300416 */ GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(300453), // Rule ID 4649 //
     /* 300421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300436 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300440 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300442 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 300445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300447 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300451 */   GIR_RootConstrainSelectedInstOperands,
     /* 300452 */   // GIR_Coverage, 4649,
     /* 300452 */   GIR_EraseRootFromParent_Done,
     /* 300453 */ // Label 6068: @300453
     /* 300453 */ GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(300490), // Rule ID 4651 //
     /* 300458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300473 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300479 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 300482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300484 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300488 */   GIR_RootConstrainSelectedInstOperands,
     /* 300489 */   // GIR_Coverage, 4651,
     /* 300489 */   GIR_EraseRootFromParent_Done,
     /* 300490 */ // Label 6069: @300490
     /* 300490 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(300527), // Rule ID 4629 //
     /* 300495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300510 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300516 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300521 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300525 */   GIR_RootConstrainSelectedInstOperands,
     /* 300526 */   // GIR_Coverage, 4629,
     /* 300526 */   GIR_EraseRootFromParent_Done,
     /* 300527 */ // Label 6070: @300527
     /* 300527 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(300564), // Rule ID 4631 //
     /* 300532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300553 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300558 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300562 */   GIR_RootConstrainSelectedInstOperands,
     /* 300563 */   // GIR_Coverage, 4631,
     /* 300563 */   GIR_EraseRootFromParent_Done,
     /* 300564 */ // Label 6071: @300564
     /* 300564 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(300594), // Rule ID 395 //
     /* 300569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300583 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 300583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 300588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300592 */   GIR_RootConstrainSelectedInstOperands,
     /* 300593 */   // GIR_Coverage, 395,
     /* 300593 */   GIR_Done,
     /* 300594 */ // Label 6072: @300594
     /* 300594 */ GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(300624), // Rule ID 399 //
     /* 300599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300613 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 300613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300618 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300622 */   GIR_RootConstrainSelectedInstOperands,
     /* 300623 */   // GIR_Coverage, 399,
     /* 300623 */   GIR_Done,
     /* 300624 */ // Label 6073: @300624
     /* 300624 */ GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(300654), // Rule ID 403 //
     /* 300629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300643 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 300643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300652 */   GIR_RootConstrainSelectedInstOperands,
     /* 300653 */   // GIR_Coverage, 403,
     /* 300653 */   GIR_Done,
     /* 300654 */ // Label 6074: @300654
     /* 300654 */ GIM_Reject,
     /* 300655 */ // Label 6057: @300655
     /* 300655 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(300692), // Rule ID 4590 //
     /* 300660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300681 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 300684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300686 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300690 */   GIR_RootConstrainSelectedInstOperands,
     /* 300691 */   // GIR_Coverage, 4590,
     /* 300691 */   GIR_EraseRootFromParent_Done,
     /* 300692 */ // Label 6075: @300692
     /* 300692 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(300729), // Rule ID 4592 //
     /* 300697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300718 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 300721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300727 */   GIR_RootConstrainSelectedInstOperands,
     /* 300728 */   // GIR_Coverage, 4592,
     /* 300728 */   GIR_EraseRootFromParent_Done,
     /* 300729 */ // Label 6076: @300729
     /* 300729 */ GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(300766), // Rule ID 4610 //
     /* 300734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300749 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300755 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 300758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300764 */   GIR_RootConstrainSelectedInstOperands,
     /* 300765 */   // GIR_Coverage, 4610,
     /* 300765 */   GIR_EraseRootFromParent_Done,
     /* 300766 */ // Label 6077: @300766
     /* 300766 */ GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(300803), // Rule ID 4612 //
     /* 300771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300792 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 300795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300801 */   GIR_RootConstrainSelectedInstOperands,
     /* 300802 */   // GIR_Coverage, 4612,
     /* 300802 */   GIR_EraseRootFromParent_Done,
     /* 300803 */ // Label 6078: @300803
     /* 300803 */ GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(300840), // Rule ID 4650 //
     /* 300808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300829 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 300832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300834 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300838 */   GIR_RootConstrainSelectedInstOperands,
     /* 300839 */   // GIR_Coverage, 4650,
     /* 300839 */   GIR_EraseRootFromParent_Done,
     /* 300840 */ // Label 6079: @300840
     /* 300840 */ GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(300877), // Rule ID 4652 //
     /* 300845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300866 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 300869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300871 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300875 */   GIR_RootConstrainSelectedInstOperands,
     /* 300876 */   // GIR_Coverage, 4652,
     /* 300876 */   GIR_EraseRootFromParent_Done,
     /* 300877 */ // Label 6080: @300877
     /* 300877 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(300914), // Rule ID 4630 //
     /* 300882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300897 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300903 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 300906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300912 */   GIR_RootConstrainSelectedInstOperands,
     /* 300913 */   // GIR_Coverage, 4630,
     /* 300913 */   GIR_EraseRootFromParent_Done,
     /* 300914 */ // Label 6081: @300914
     /* 300914 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(300951), // Rule ID 4632 //
     /* 300919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300934 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300940 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 300943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300949 */   GIR_RootConstrainSelectedInstOperands,
     /* 300950 */   // GIR_Coverage, 4632,
     /* 300950 */   GIR_EraseRootFromParent_Done,
     /* 300951 */ // Label 6082: @300951
     /* 300951 */ GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(300981), // Rule ID 397 //
     /* 300956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300970 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 300970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 300975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300979 */   GIR_RootConstrainSelectedInstOperands,
     /* 300980 */   // GIR_Coverage, 397,
     /* 300980 */   GIR_Done,
     /* 300981 */ // Label 6083: @300981
     /* 300981 */ GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(301011), // Rule ID 401 //
     /* 300986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301000 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 301000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 301005 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301009 */   GIR_RootConstrainSelectedInstOperands,
     /* 301010 */   // GIR_Coverage, 401,
     /* 301010 */   GIR_Done,
     /* 301011 */ // Label 6084: @301011
     /* 301011 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(301041), // Rule ID 405 //
     /* 301016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301030 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 301030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 301035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301039 */   GIR_RootConstrainSelectedInstOperands,
     /* 301040 */   // GIR_Coverage, 405,
     /* 301040 */   GIR_Done,
     /* 301041 */ // Label 6085: @301041
     /* 301041 */ GIM_Reject,
     /* 301042 */ // Label 6058: @301042
     /* 301042 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(301072), // Rule ID 836 //
     /* 301047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301061 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 301061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 301066 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301070 */   GIR_RootConstrainSelectedInstOperands,
     /* 301071 */   // GIR_Coverage, 836,
     /* 301071 */   GIR_Done,
     /* 301072 */ // Label 6086: @301072
     /* 301072 */ GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(301115), // Rule ID 12860 //
     /* 301077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301087 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 301087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 301094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301099 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 301108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301113 */   GIR_RootConstrainSelectedInstOperands,
     /* 301114 */   // GIR_Coverage, 12860,
     /* 301114 */   GIR_EraseRootFromParent_Done,
     /* 301115 */ // Label 6087: @301115
     /* 301115 */ GIM_Reject,
     /* 301116 */ // Label 6059: @301116
     /* 301116 */ GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(301146), // Rule ID 840 //
     /* 301121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301135 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 301135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 301140 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301144 */   GIR_RootConstrainSelectedInstOperands,
     /* 301145 */   // GIR_Coverage, 840,
     /* 301145 */   GIR_Done,
     /* 301146 */ // Label 6088: @301146
     /* 301146 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(301189), // Rule ID 12858 //
     /* 301151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301161 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 301161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 301168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301173 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 301182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301187 */   GIR_RootConstrainSelectedInstOperands,
     /* 301188 */   // GIR_Coverage, 12858,
     /* 301188 */   GIR_EraseRootFromParent_Done,
     /* 301189 */ // Label 6089: @301189
     /* 301189 */ GIM_Reject,
     /* 301190 */ // Label 6060: @301190
     /* 301190 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(301220), // Rule ID 832 //
     /* 301195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301209 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 301209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 301214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301218 */   GIR_RootConstrainSelectedInstOperands,
     /* 301219 */   // GIR_Coverage, 832,
     /* 301219 */   GIR_Done,
     /* 301220 */ // Label 6090: @301220
     /* 301220 */ GIM_Reject,
     /* 301221 */ // Label 6061: @301221
     /* 301221 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(301251), // Rule ID 838 //
     /* 301226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301240 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 301240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 301245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301249 */   GIR_RootConstrainSelectedInstOperands,
     /* 301250 */   // GIR_Coverage, 838,
     /* 301250 */   GIR_Done,
     /* 301251 */ // Label 6091: @301251
     /* 301251 */ GIM_Reject,
     /* 301252 */ // Label 6062: @301252
     /* 301252 */ GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(301282), // Rule ID 834 //
     /* 301257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301271 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 301271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 301276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301280 */   GIR_RootConstrainSelectedInstOperands,
     /* 301281 */   // GIR_Coverage, 834,
     /* 301281 */   GIR_Done,
     /* 301282 */ // Label 6092: @301282
     /* 301282 */ GIM_Reject,
     /* 301283 */ // Label 6063: @301283
     /* 301283 */ GIM_Reject,
     /* 301284 */ // Label 63: @301284
     /* 301284 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6100*/ GIMT_Encode4(302346),
     /* 301295 */ /*GILLT_s32*//*Label 6093*/ GIMT_Encode4(301331),
     /* 301299 */ /*GILLT_s64*//*Label 6094*/ GIMT_Encode4(301718), GIMT_Encode4(0),
     /* 301307 */ /*GILLT_v2s32*//*Label 6095*/ GIMT_Encode4(302105),
     /* 301311 */ /*GILLT_v2s64*//*Label 6096*/ GIMT_Encode4(302179),
     /* 301315 */ /*GILLT_v4s16*//*Label 6097*/ GIMT_Encode4(302253),
     /* 301319 */ /*GILLT_v4s32*//*Label 6098*/ GIMT_Encode4(302284), GIMT_Encode4(0),
     /* 301327 */ /*GILLT_v8s16*//*Label 6099*/ GIMT_Encode4(302315),
     /* 301331 */ // Label 6093: @301331
     /* 301331 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(301368), // Rule ID 4599 //
     /* 301336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301351 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301357 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 301360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301362 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301366 */   GIR_RootConstrainSelectedInstOperands,
     /* 301367 */   // GIR_Coverage, 4599,
     /* 301367 */   GIR_EraseRootFromParent_Done,
     /* 301368 */ // Label 6101: @301368
     /* 301368 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(301405), // Rule ID 4601 //
     /* 301373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301380 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301384 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301388 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301394 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 301397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301403 */   GIR_RootConstrainSelectedInstOperands,
     /* 301404 */   // GIR_Coverage, 4601,
     /* 301404 */   GIR_EraseRootFromParent_Done,
     /* 301405 */ // Label 6102: @301405
     /* 301405 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(301442), // Rule ID 4619 //
     /* 301410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301425 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301431 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 301434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301436 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301440 */   GIR_RootConstrainSelectedInstOperands,
     /* 301441 */   // GIR_Coverage, 4619,
     /* 301441 */   GIR_EraseRootFromParent_Done,
     /* 301442 */ // Label 6103: @301442
     /* 301442 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(301479), // Rule ID 4621 //
     /* 301447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301466 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301468 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 301471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301473 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301477 */   GIR_RootConstrainSelectedInstOperands,
     /* 301478 */   // GIR_Coverage, 4621,
     /* 301478 */   GIR_EraseRootFromParent_Done,
     /* 301479 */ // Label 6104: @301479
     /* 301479 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(301516), // Rule ID 4659 //
     /* 301484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301505 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 301508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301510 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301514 */   GIR_RootConstrainSelectedInstOperands,
     /* 301515 */   // GIR_Coverage, 4659,
     /* 301515 */   GIR_EraseRootFromParent_Done,
     /* 301516 */ // Label 6105: @301516
     /* 301516 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(301553), // Rule ID 4661 //
     /* 301521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301536 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301542 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 301545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301547 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301551 */   GIR_RootConstrainSelectedInstOperands,
     /* 301552 */   // GIR_Coverage, 4661,
     /* 301552 */   GIR_EraseRootFromParent_Done,
     /* 301553 */ // Label 6106: @301553
     /* 301553 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(301590), // Rule ID 4639 //
     /* 301558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301579 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301584 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301588 */   GIR_RootConstrainSelectedInstOperands,
     /* 301589 */   // GIR_Coverage, 4639,
     /* 301589 */   GIR_EraseRootFromParent_Done,
     /* 301590 */ // Label 6107: @301590
     /* 301590 */ GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(301627), // Rule ID 4641 //
     /* 301595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301610 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301616 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301621 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301625 */   GIR_RootConstrainSelectedInstOperands,
     /* 301626 */   // GIR_Coverage, 4641,
     /* 301626 */   GIR_EraseRootFromParent_Done,
     /* 301627 */ // Label 6108: @301627
     /* 301627 */ GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(301657), // Rule ID 407 //
     /* 301632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301646 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 301646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 301651 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301655 */   GIR_RootConstrainSelectedInstOperands,
     /* 301656 */   // GIR_Coverage, 407,
     /* 301656 */   GIR_Done,
     /* 301657 */ // Label 6109: @301657
     /* 301657 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(301687), // Rule ID 411 //
     /* 301662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301676 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 301676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301685 */   GIR_RootConstrainSelectedInstOperands,
     /* 301686 */   // GIR_Coverage, 411,
     /* 301686 */   GIR_Done,
     /* 301687 */ // Label 6110: @301687
     /* 301687 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(301717), // Rule ID 415 //
     /* 301692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301706 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 301706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301711 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301715 */   GIR_RootConstrainSelectedInstOperands,
     /* 301716 */   // GIR_Coverage, 415,
     /* 301716 */   GIR_Done,
     /* 301717 */ // Label 6111: @301717
     /* 301717 */ GIM_Reject,
     /* 301718 */ // Label 6094: @301718
     /* 301718 */ GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(301755), // Rule ID 4600 //
     /* 301723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301744 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 301747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301753 */   GIR_RootConstrainSelectedInstOperands,
     /* 301754 */   // GIR_Coverage, 4600,
     /* 301754 */   GIR_EraseRootFromParent_Done,
     /* 301755 */ // Label 6112: @301755
     /* 301755 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301792), // Rule ID 4602 //
     /* 301760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301775 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301781 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 301784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301786 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301790 */   GIR_RootConstrainSelectedInstOperands,
     /* 301791 */   // GIR_Coverage, 4602,
     /* 301791 */   GIR_EraseRootFromParent_Done,
     /* 301792 */ // Label 6113: @301792
     /* 301792 */ GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(301829), // Rule ID 4620 //
     /* 301797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301812 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301818 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 301821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301823 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301827 */   GIR_RootConstrainSelectedInstOperands,
     /* 301828 */   // GIR_Coverage, 4620,
     /* 301828 */   GIR_EraseRootFromParent_Done,
     /* 301829 */ // Label 6114: @301829
     /* 301829 */ GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(301866), // Rule ID 4622 //
     /* 301834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301849 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301855 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 301858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301860 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301864 */   GIR_RootConstrainSelectedInstOperands,
     /* 301865 */   // GIR_Coverage, 4622,
     /* 301865 */   GIR_EraseRootFromParent_Done,
     /* 301866 */ // Label 6115: @301866
     /* 301866 */ GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(301903), // Rule ID 4660 //
     /* 301871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301892 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 301895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301901 */   GIR_RootConstrainSelectedInstOperands,
     /* 301902 */   // GIR_Coverage, 4660,
     /* 301902 */   GIR_EraseRootFromParent_Done,
     /* 301903 */ // Label 6116: @301903
     /* 301903 */ GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(301940), // Rule ID 4662 //
     /* 301908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301929 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 301932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301934 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301938 */   GIR_RootConstrainSelectedInstOperands,
     /* 301939 */   // GIR_Coverage, 4662,
     /* 301939 */   GIR_EraseRootFromParent_Done,
     /* 301940 */ // Label 6117: @301940
     /* 301940 */ GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(301977), // Rule ID 4640 //
     /* 301945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301966 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 301969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301971 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301975 */   GIR_RootConstrainSelectedInstOperands,
     /* 301976 */   // GIR_Coverage, 4640,
     /* 301976 */   GIR_EraseRootFromParent_Done,
     /* 301977 */ // Label 6118: @301977
     /* 301977 */ GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(302014), // Rule ID 4642 //
     /* 301982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302003 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 302003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 302006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302008 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302012 */   GIR_RootConstrainSelectedInstOperands,
     /* 302013 */   // GIR_Coverage, 4642,
     /* 302013 */   GIR_EraseRootFromParent_Done,
     /* 302014 */ // Label 6119: @302014
     /* 302014 */ GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(302044), // Rule ID 409 //
     /* 302019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302033 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 302033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 302038 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302042 */   GIR_RootConstrainSelectedInstOperands,
     /* 302043 */   // GIR_Coverage, 409,
     /* 302043 */   GIR_Done,
     /* 302044 */ // Label 6120: @302044
     /* 302044 */ GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(302074), // Rule ID 413 //
     /* 302049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302063 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 302063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 302068 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302072 */   GIR_RootConstrainSelectedInstOperands,
     /* 302073 */   // GIR_Coverage, 413,
     /* 302073 */   GIR_Done,
     /* 302074 */ // Label 6121: @302074
     /* 302074 */ GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(302104), // Rule ID 417 //
     /* 302079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302093 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 302093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 302098 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302102 */   GIR_RootConstrainSelectedInstOperands,
     /* 302103 */   // GIR_Coverage, 417,
     /* 302103 */   GIR_Done,
     /* 302104 */ // Label 6122: @302104
     /* 302104 */ GIM_Reject,
     /* 302105 */ // Label 6095: @302105
     /* 302105 */ GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(302135), // Rule ID 846 //
     /* 302110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302124 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 302124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 302129 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302133 */   GIR_RootConstrainSelectedInstOperands,
     /* 302134 */   // GIR_Coverage, 846,
     /* 302134 */   GIR_Done,
     /* 302135 */ // Label 6123: @302135
     /* 302135 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(302178), // Rule ID 12861 //
     /* 302140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302150 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 302150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 302157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302162 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 302166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 302171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302176 */   GIR_RootConstrainSelectedInstOperands,
     /* 302177 */   // GIR_Coverage, 12861,
     /* 302177 */   GIR_EraseRootFromParent_Done,
     /* 302178 */ // Label 6124: @302178
     /* 302178 */ GIM_Reject,
     /* 302179 */ // Label 6096: @302179
     /* 302179 */ GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(302209), // Rule ID 850 //
     /* 302184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302198 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 302198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 302203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302207 */   GIR_RootConstrainSelectedInstOperands,
     /* 302208 */   // GIR_Coverage, 850,
     /* 302208 */   GIR_Done,
     /* 302209 */ // Label 6125: @302209
     /* 302209 */ GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(302252), // Rule ID 12859 //
     /* 302214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302224 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 302224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 302231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302236 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 302240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 302245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302250 */   GIR_RootConstrainSelectedInstOperands,
     /* 302251 */   // GIR_Coverage, 12859,
     /* 302251 */   GIR_EraseRootFromParent_Done,
     /* 302252 */ // Label 6126: @302252
     /* 302252 */ GIM_Reject,
     /* 302253 */ // Label 6097: @302253
     /* 302253 */ GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(302283), // Rule ID 842 //
     /* 302258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302272 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 302272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 302277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302281 */   GIR_RootConstrainSelectedInstOperands,
     /* 302282 */   // GIR_Coverage, 842,
     /* 302282 */   GIR_Done,
     /* 302283 */ // Label 6127: @302283
     /* 302283 */ GIM_Reject,
     /* 302284 */ // Label 6098: @302284
     /* 302284 */ GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(302314), // Rule ID 848 //
     /* 302289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302303 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 302303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 302308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302312 */   GIR_RootConstrainSelectedInstOperands,
     /* 302313 */   // GIR_Coverage, 848,
     /* 302313 */   GIR_Done,
     /* 302314 */ // Label 6128: @302314
     /* 302314 */ GIM_Reject,
     /* 302315 */ // Label 6099: @302315
     /* 302315 */ GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302345), // Rule ID 844 //
     /* 302320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302334 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 302334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 302339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302343 */   GIR_RootConstrainSelectedInstOperands,
     /* 302344 */   // GIR_Coverage, 844,
     /* 302344 */   GIR_Done,
     /* 302345 */ // Label 6129: @302345
     /* 302345 */ GIM_Reject,
     /* 302346 */ // Label 6100: @302346
     /* 302346 */ GIM_Reject,
     /* 302347 */ // Label 64: @302347
     /* 302347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6138*/ GIMT_Encode4(306743),
     /* 302358 */ /*GILLT_s16*//*Label 6130*/ GIMT_Encode4(302398),
     /* 302362 */ /*GILLT_s32*//*Label 6131*/ GIMT_Encode4(302679),
     /* 302366 */ /*GILLT_s64*//*Label 6132*/ GIMT_Encode4(304595), GIMT_Encode4(0),
     /* 302374 */ /*GILLT_v2s32*//*Label 6133*/ GIMT_Encode4(306499),
     /* 302378 */ /*GILLT_v2s64*//*Label 6134*/ GIMT_Encode4(306573),
     /* 302382 */ /*GILLT_v4s16*//*Label 6135*/ GIMT_Encode4(306650),
     /* 302386 */ /*GILLT_v4s32*//*Label 6136*/ GIMT_Encode4(306681), GIMT_Encode4(0),
     /* 302394 */ /*GILLT_v8s16*//*Label 6137*/ GIMT_Encode4(306712),
     /* 302398 */ // Label 6130: @302398
     /* 302398 */ GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(302501), // Rule ID 5259 //
     /* 302403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 302406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 302421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302425 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302429 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302433 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302437 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302441 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302446 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302450 */   // MIs[1] Operand 2
     /* 302450 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 302461 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302463 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 302463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302475 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 302481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302499 */   GIR_RootConstrainSelectedInstOperands,
     /* 302500 */   // GIR_Coverage, 5259,
     /* 302500 */   GIR_EraseRootFromParent_Done,
     /* 302501 */ // Label 6139: @302501
     /* 302501 */ GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(302558), // Rule ID 5250 //
     /* 302506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 302509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 302524 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302528 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302530 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 302530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 302537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302556 */   GIR_RootConstrainSelectedInstOperands,
     /* 302557 */   // GIR_Coverage, 5250,
     /* 302557 */   GIR_EraseRootFromParent_Done,
     /* 302558 */ // Label 6140: @302558
     /* 302558 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(302588), // Rule ID 443 //
     /* 302563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302577 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 302577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 302582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302586 */   GIR_RootConstrainSelectedInstOperands,
     /* 302587 */   // GIR_Coverage, 443,
     /* 302587 */   GIR_Done,
     /* 302588 */ // Label 6141: @302588
     /* 302588 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(302618), // Rule ID 449 //
     /* 302593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302607 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 302607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 302612 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302616 */   GIR_RootConstrainSelectedInstOperands,
     /* 302617 */   // GIR_Coverage, 449,
     /* 302617 */   GIR_Done,
     /* 302618 */ // Label 6142: @302618
     /* 302618 */ GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(302648), // Rule ID 491 //
     /* 302623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302637 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 302637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 302642 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302646 */   GIR_RootConstrainSelectedInstOperands,
     /* 302647 */   // GIR_Coverage, 491,
     /* 302647 */   GIR_Done,
     /* 302648 */ // Label 6143: @302648
     /* 302648 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(302678), // Rule ID 495 //
     /* 302653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302667 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 302667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 302672 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302676 */   GIR_RootConstrainSelectedInstOperands,
     /* 302677 */   // GIR_Coverage, 495,
     /* 302677 */   GIR_Done,
     /* 302678 */ // Label 6144: @302678
     /* 302678 */ GIM_Reject,
     /* 302679 */ // Label 6131: @302679
     /* 302679 */ GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(302917), // Rule ID 6288 //
     /* 302684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302702 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302705 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302712 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302718 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 302725 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302725 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302728 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 302732 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302752 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302759 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 302762 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302766 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 302773 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 302776 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302780 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302785 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302788 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 302791 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 302794 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302799 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302804 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 302809 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 302812 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 302816 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302821 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302824 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 302827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302829 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302832 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302836 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302841 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 302848 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302853 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302858 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302861 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302865 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302870 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302873 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302890 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302902 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302915 */   GIR_RootConstrainSelectedInstOperands,
     /* 302916 */   // GIR_Coverage, 6288,
     /* 302916 */   GIR_EraseRootFromParent_Done,
     /* 302917 */ // Label 6145: @302917
     /* 302917 */ GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(303155), // Rule ID 6289 //
     /* 302922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302940 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302943 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302950 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302956 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 302963 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302963 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302966 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 302970 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302990 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302997 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303000 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303004 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303011 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303014 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303018 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303023 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303026 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303029 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303032 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303037 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303042 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303047 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303050 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303054 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303059 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303062 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303067 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303070 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303074 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303079 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303086 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303091 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303108 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303111 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303128 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303153 */   GIR_RootConstrainSelectedInstOperands,
     /* 303154 */   // GIR_Coverage, 6289,
     /* 303154 */   GIR_EraseRootFromParent_Done,
     /* 303155 */ // Label 6146: @303155
     /* 303155 */ GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303344), // Rule ID 6292 //
     /* 303160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303178 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303181 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303188 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303194 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 303201 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303201 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303204 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 303208 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 303223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 303228 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303235 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303238 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303242 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303249 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303252 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303256 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303261 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303264 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303267 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303270 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303275 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303280 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303285 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303288 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303292 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303297 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303300 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303317 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303342 */   GIR_RootConstrainSelectedInstOperands,
     /* 303343 */   // GIR_Coverage, 6292,
     /* 303343 */   GIR_EraseRootFromParent_Done,
     /* 303344 */ // Label 6147: @303344
     /* 303344 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303533), // Rule ID 6293 //
     /* 303349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303367 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303370 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303377 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303383 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 303390 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303390 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303393 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 303397 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 303412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 303417 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303424 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303427 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303431 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303450 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303453 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303456 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303459 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303464 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303469 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303486 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303489 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303506 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303531 */   GIR_RootConstrainSelectedInstOperands,
     /* 303532 */   // GIR_Coverage, 6293,
     /* 303532 */   GIR_EraseRootFromParent_Done,
     /* 303533 */ // Label 6148: @303533
     /* 303533 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(303766), // Rule ID 6290 //
     /* 303538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303556 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303559 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303566 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303572 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 303579 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303579 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303582 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 303586 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303601 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303608 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303611 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303615 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303622 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303625 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303629 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303634 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303637 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303640 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303643 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303648 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303653 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303658 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303661 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303665 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303670 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303673 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303678 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303681 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303685 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303690 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303697 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303702 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303707 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303710 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303714 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303719 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303722 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303739 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303764 */   GIR_RootConstrainSelectedInstOperands,
     /* 303765 */   // GIR_Coverage, 6290,
     /* 303765 */   GIR_EraseRootFromParent_Done,
     /* 303766 */ // Label 6149: @303766
     /* 303766 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303999), // Rule ID 6291 //
     /* 303771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303792 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303799 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303805 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 303812 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303812 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303815 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 303819 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303834 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303841 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303844 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303848 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303855 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303858 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303862 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303867 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303870 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303873 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303876 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303881 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303886 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303891 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303894 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303898 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303903 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303906 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303911 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303914 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303918 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303923 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303930 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303935 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303940 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303943 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303947 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303952 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303955 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303972 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303997 */   GIR_RootConstrainSelectedInstOperands,
     /* 303998 */   // GIR_Coverage, 6291,
     /* 303998 */   GIR_EraseRootFromParent_Done,
     /* 303999 */ // Label 6150: @303999
     /* 303999 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(304183), // Rule ID 6294 //
     /* 304004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304014 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304022 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304025 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304032 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304038 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 304045 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 304045 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 304048 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 304052 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 304067 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304074 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304077 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304081 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304088 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304091 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304095 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304100 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304103 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304106 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 304109 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304114 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304119 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304124 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304127 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304131 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304136 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304139 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304156 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 304163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304181 */   GIR_RootConstrainSelectedInstOperands,
     /* 304182 */   // GIR_Coverage, 6294,
     /* 304182 */   GIR_EraseRootFromParent_Done,
     /* 304183 */ // Label 6151: @304183
     /* 304183 */ GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(304367), // Rule ID 6295 //
     /* 304188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304206 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304209 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304216 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304222 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 304229 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 304229 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 304232 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 304236 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 304251 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304258 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304261 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304265 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304272 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304275 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304279 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304284 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304287 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304290 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 304293 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304298 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304303 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304308 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304311 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304315 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304320 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304323 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304340 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 304347 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304352 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304365 */   GIR_RootConstrainSelectedInstOperands,
     /* 304366 */   // GIR_Coverage, 6295,
     /* 304366 */   GIR_EraseRootFromParent_Done,
     /* 304367 */ // Label 6152: @304367
     /* 304367 */ GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(304447), // Rule ID 5255 //
     /* 304372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 304375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304403 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304409 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 304409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304421 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304445 */   GIR_RootConstrainSelectedInstOperands,
     /* 304446 */   // GIR_Coverage, 5255,
     /* 304446 */   GIR_EraseRootFromParent_Done,
     /* 304447 */ // Label 6153: @304447
     /* 304447 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(304504), // Rule ID 5238 //
     /* 304452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 304455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304462 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 304470 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304476 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 304476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 304483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304502 */   GIR_RootConstrainSelectedInstOperands,
     /* 304503 */   // GIR_Coverage, 5238,
     /* 304503 */   GIR_EraseRootFromParent_Done,
     /* 304504 */ // Label 6154: @304504
     /* 304504 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(304534), // Rule ID 445 //
     /* 304509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304523 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 304523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 304528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304532 */   GIR_RootConstrainSelectedInstOperands,
     /* 304533 */   // GIR_Coverage, 445,
     /* 304533 */   GIR_Done,
     /* 304534 */ // Label 6155: @304534
     /* 304534 */ GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(304564), // Rule ID 451 //
     /* 304539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304553 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 304553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 304558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304562 */   GIR_RootConstrainSelectedInstOperands,
     /* 304563 */   // GIR_Coverage, 451,
     /* 304563 */   GIR_Done,
     /* 304564 */ // Label 6156: @304564
     /* 304564 */ GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(304594), // Rule ID 497 //
     /* 304569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 304572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304583 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 304583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 304588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304592 */   GIR_RootConstrainSelectedInstOperands,
     /* 304593 */   // GIR_Coverage, 497,
     /* 304593 */   GIR_Done,
     /* 304594 */ // Label 6157: @304594
     /* 304594 */ GIM_Reject,
     /* 304595 */ // Label 6132: @304595
     /* 304595 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(304781), // Rule ID 6300 //
     /* 304600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304618 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304621 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304625 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304629 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304631 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 304638 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304638 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304641 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 304645 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304665 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304672 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304675 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304679 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304686 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304689 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304693 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304698 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304701 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304704 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304707 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304712 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304717 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304722 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304725 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304729 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304734 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304737 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304754 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304779 */   GIR_RootConstrainSelectedInstOperands,
     /* 304780 */   // GIR_Coverage, 6300,
     /* 304780 */   GIR_EraseRootFromParent_Done,
     /* 304781 */ // Label 6158: @304781
     /* 304781 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(304967), // Rule ID 6301 //
     /* 304786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304804 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304811 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304817 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 304824 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304824 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304827 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 304831 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304851 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304858 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304861 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304865 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304872 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304875 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304879 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304884 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304887 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304890 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304893 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304898 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304903 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304908 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304911 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304915 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304920 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304923 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304940 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304947 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304952 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304965 */   GIR_RootConstrainSelectedInstOperands,
     /* 304966 */   // GIR_Coverage, 6301,
     /* 304966 */   GIR_EraseRootFromParent_Done,
     /* 304967 */ // Label 6159: @304967
     /* 304967 */ GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(305205), // Rule ID 6296 //
     /* 304972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304990 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304993 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305000 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305006 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 305013 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305013 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305016 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 305020 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305040 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305047 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305050 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305054 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305061 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305064 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305068 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305073 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305076 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305079 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305082 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305087 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305092 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305097 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305100 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305104 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305109 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305112 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305117 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305120 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305124 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305129 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305136 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305141 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305146 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305149 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305153 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305158 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305161 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305178 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305203 */   GIR_RootConstrainSelectedInstOperands,
     /* 305204 */   // GIR_Coverage, 6296,
     /* 305204 */   GIR_EraseRootFromParent_Done,
     /* 305205 */ // Label 6160: @305205
     /* 305205 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(305443), // Rule ID 6297 //
     /* 305210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305228 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305231 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305238 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305244 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 305251 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305251 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305254 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 305258 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 305273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 305278 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305285 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305288 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305292 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305299 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305302 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305306 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305311 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305314 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305317 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305320 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305325 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305330 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305335 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305338 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305342 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305347 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305350 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305367 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305374 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305379 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305396 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305399 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305416 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305441 */   GIR_RootConstrainSelectedInstOperands,
     /* 305442 */   // GIR_Coverage, 6297,
     /* 305442 */   GIR_EraseRootFromParent_Done,
     /* 305443 */ // Label 6161: @305443
     /* 305443 */ GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(305624), // Rule ID 6302 //
     /* 305448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305466 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305469 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305473 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305479 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 305486 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305486 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305489 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 305493 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305508 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305515 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305518 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305522 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305541 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305544 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305547 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305550 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305555 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305560 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305580 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305597 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305622 */   GIR_RootConstrainSelectedInstOperands,
     /* 305623 */   // GIR_Coverage, 6302,
     /* 305623 */   GIR_EraseRootFromParent_Done,
     /* 305624 */ // Label 6162: @305624
     /* 305624 */ GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(305805), // Rule ID 6303 //
     /* 305629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305647 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305654 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305658 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305660 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 305667 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305667 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305670 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 305674 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305689 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305696 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305699 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305703 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305710 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305713 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305717 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305722 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305725 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305728 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305731 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305736 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305741 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305746 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305749 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305753 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305758 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305761 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305778 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305803 */   GIR_RootConstrainSelectedInstOperands,
     /* 305804 */   // GIR_Coverage, 6303,
     /* 305804 */   GIR_EraseRootFromParent_Done,
     /* 305805 */ // Label 6163: @305805
     /* 305805 */ GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(306038), // Rule ID 6298 //
     /* 305810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305828 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305831 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305838 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305844 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 305851 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305851 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305854 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 305858 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305873 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305880 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305883 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305887 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305894 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305897 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305901 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305906 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305909 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305912 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305915 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305920 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305925 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305930 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305933 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305937 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305942 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305945 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305950 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305953 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305957 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305962 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305969 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305974 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305982 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305986 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305991 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305994 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306011 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 306018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 306031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306036 */   GIR_RootConstrainSelectedInstOperands,
     /* 306037 */   // GIR_Coverage, 6298,
     /* 306037 */   GIR_EraseRootFromParent_Done,
     /* 306038 */ // Label 6164: @306038
     /* 306038 */ GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(306271), // Rule ID 6299 //
     /* 306043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 306046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 306061 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306064 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 306071 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306077 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 306084 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 306084 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 306087 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 306091 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 306106 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306113 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 306116 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306120 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 306127 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 306130 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306134 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306139 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306142 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 306145 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 306148 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306153 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306158 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306163 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 306166 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 306170 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306175 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306178 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 306181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306183 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 306186 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306190 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306195 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 306202 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 306219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306224 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306227 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 306230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306244 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 306251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 306264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306269 */   GIR_RootConstrainSelectedInstOperands,
     /* 306270 */   // GIR_Coverage, 6299,
     /* 306270 */   GIR_EraseRootFromParent_Done,
     /* 306271 */ // Label 6165: @306271
     /* 306271 */ GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(306351), // Rule ID 5257 //
     /* 306276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306294 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306298 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306302 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306307 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306313 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 306313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306325 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306331 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 306344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306349 */   GIR_RootConstrainSelectedInstOperands,
     /* 306350 */   // GIR_Coverage, 5257,
     /* 306350 */   GIR_EraseRootFromParent_Done,
     /* 306351 */ // Label 6166: @306351
     /* 306351 */ GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(306408), // Rule ID 5234 //
     /* 306356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 306374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306380 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 306380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 306387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306392 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 306401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306406 */   GIR_RootConstrainSelectedInstOperands,
     /* 306407 */   // GIR_Coverage, 5234,
     /* 306407 */   GIR_EraseRootFromParent_Done,
     /* 306408 */ // Label 6167: @306408
     /* 306408 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(306438), // Rule ID 447 //
     /* 306413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306427 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 306427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 306432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306436 */   GIR_RootConstrainSelectedInstOperands,
     /* 306437 */   // GIR_Coverage, 447,
     /* 306437 */   GIR_Done,
     /* 306438 */ // Label 6168: @306438
     /* 306438 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(306468), // Rule ID 453 //
     /* 306443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 306457 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 306457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 306462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306466 */   GIR_RootConstrainSelectedInstOperands,
     /* 306467 */   // GIR_Coverage, 453,
     /* 306467 */   GIR_Done,
     /* 306468 */ // Label 6169: @306468
     /* 306468 */ GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(306498), // Rule ID 493 //
     /* 306473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306487 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 306487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 306492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306496 */   GIR_RootConstrainSelectedInstOperands,
     /* 306497 */   // GIR_Coverage, 493,
     /* 306497 */   GIR_Done,
     /* 306498 */ // Label 6170: @306498
     /* 306498 */ GIM_Reject,
     /* 306499 */ // Label 6133: @306499
     /* 306499 */ GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(306529), // Rule ID 1010 //
     /* 306504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306518 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 306518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 306523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306527 */   GIR_RootConstrainSelectedInstOperands,
     /* 306528 */   // GIR_Coverage, 1010,
     /* 306528 */   GIR_Done,
     /* 306529 */ // Label 6171: @306529
     /* 306529 */ GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(306572), // Rule ID 12856 //
     /* 306534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306544 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 306544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306556 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 306565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306570 */   GIR_RootConstrainSelectedInstOperands,
     /* 306571 */   // GIR_Coverage, 12856,
     /* 306571 */   GIR_EraseRootFromParent_Done,
     /* 306572 */ // Label 6172: @306572
     /* 306572 */ GIM_Reject,
     /* 306573 */ // Label 6134: @306573
     /* 306573 */ GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(306603), // Rule ID 1014 //
     /* 306578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306592 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 306592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306601 */   GIR_RootConstrainSelectedInstOperands,
     /* 306602 */   // GIR_Coverage, 1014,
     /* 306602 */   GIR_Done,
     /* 306603 */ // Label 6173: @306603
     /* 306603 */ GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(306649), // Rule ID 12854 //
     /* 306608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306618 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 306618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 306625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306634 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306647 */   GIR_RootConstrainSelectedInstOperands,
     /* 306648 */   // GIR_Coverage, 12854,
     /* 306648 */   GIR_EraseRootFromParent_Done,
     /* 306649 */ // Label 6174: @306649
     /* 306649 */ GIM_Reject,
     /* 306650 */ // Label 6135: @306650
     /* 306650 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(306680), // Rule ID 1006 //
     /* 306655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306669 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 306669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 306674 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306678 */   GIR_RootConstrainSelectedInstOperands,
     /* 306679 */   // GIR_Coverage, 1006,
     /* 306679 */   GIR_Done,
     /* 306680 */ // Label 6175: @306680
     /* 306680 */ GIM_Reject,
     /* 306681 */ // Label 6136: @306681
     /* 306681 */ GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(306711), // Rule ID 1012 //
     /* 306686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306700 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 306700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 306705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306709 */   GIR_RootConstrainSelectedInstOperands,
     /* 306710 */   // GIR_Coverage, 1012,
     /* 306710 */   GIR_Done,
     /* 306711 */ // Label 6176: @306711
     /* 306711 */ GIM_Reject,
     /* 306712 */ // Label 6137: @306712
     /* 306712 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(306742), // Rule ID 1008 //
     /* 306717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306731 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 306731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 306736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306740 */   GIR_RootConstrainSelectedInstOperands,
     /* 306741 */   // GIR_Coverage, 1008,
     /* 306741 */   GIR_Done,
     /* 306742 */ // Label 6177: @306742
     /* 306742 */ GIM_Reject,
     /* 306743 */ // Label 6138: @306743
     /* 306743 */ GIM_Reject,
     /* 306744 */ // Label 65: @306744
     /* 306744 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6186*/ GIMT_Encode4(310518),
     /* 306755 */ /*GILLT_s16*//*Label 6178*/ GIMT_Encode4(306795),
     /* 306759 */ /*GILLT_s32*//*Label 6179*/ GIMT_Encode4(307080),
     /* 306763 */ /*GILLT_s64*//*Label 6180*/ GIMT_Encode4(308408), GIMT_Encode4(0),
     /* 306771 */ /*GILLT_v2s32*//*Label 6181*/ GIMT_Encode4(310274),
     /* 306775 */ /*GILLT_v2s64*//*Label 6182*/ GIMT_Encode4(310348),
     /* 306779 */ /*GILLT_v4s16*//*Label 6183*/ GIMT_Encode4(310425),
     /* 306783 */ /*GILLT_v4s32*//*Label 6184*/ GIMT_Encode4(310456), GIMT_Encode4(0),
     /* 306791 */ /*GILLT_v8s16*//*Label 6185*/ GIMT_Encode4(310487),
     /* 306795 */ // Label 6178: @306795
     /* 306795 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(306902), // Rule ID 5260 //
     /* 306800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 306818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306826 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306834 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306838 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306842 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306847 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306851 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 306862 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306864 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 306864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306876 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306900 */   GIR_RootConstrainSelectedInstOperands,
     /* 306901 */   // GIR_Coverage, 5260,
     /* 306901 */   GIR_EraseRootFromParent_Done,
     /* 306902 */ // Label 6187: @306902
     /* 306902 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(306959), // Rule ID 5254 //
     /* 306907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 306925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306931 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 306931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 306938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306957 */   GIR_RootConstrainSelectedInstOperands,
     /* 306958 */   // GIR_Coverage, 5254,
     /* 306958 */   GIR_EraseRootFromParent_Done,
     /* 306959 */ // Label 6188: @306959
     /* 306959 */ GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(306989), // Rule ID 467 //
     /* 306964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306978 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 306978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 306983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306987 */   GIR_RootConstrainSelectedInstOperands,
     /* 306988 */   // GIR_Coverage, 467,
     /* 306988 */   GIR_Done,
     /* 306989 */ // Label 6189: @306989
     /* 306989 */ GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(307019), // Rule ID 473 //
     /* 306994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307008 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 307008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 307013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307017 */   GIR_RootConstrainSelectedInstOperands,
     /* 307018 */   // GIR_Coverage, 473,
     /* 307018 */   GIR_Done,
     /* 307019 */ // Label 6190: @307019
     /* 307019 */ GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(307049), // Rule ID 499 //
     /* 307024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 307027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307038 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 307038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 307043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307047 */   GIR_RootConstrainSelectedInstOperands,
     /* 307048 */   // GIR_Coverage, 499,
     /* 307048 */   GIR_Done,
     /* 307049 */ // Label 6191: @307049
     /* 307049 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(307079), // Rule ID 503 //
     /* 307054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 307057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307068 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 307068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 307073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307077 */   GIR_RootConstrainSelectedInstOperands,
     /* 307078 */   // GIR_Coverage, 503,
     /* 307078 */   GIR_Done,
     /* 307079 */ // Label 6192: @307079
     /* 307079 */ GIM_Reject,
     /* 307080 */ // Label 6179: @307080
     /* 307080 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(307220), // Rule ID 5261 //
     /* 307085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307103 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307106 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307113 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307119 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 307126 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 307126 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307129 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 307133 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307153 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307186 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307189 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307192 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307195 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307200 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307218 */   GIR_RootConstrainSelectedInstOperands,
     /* 307219 */   // GIR_Coverage, 5261,
     /* 307219 */   GIR_EraseRootFromParent_Done,
     /* 307220 */ // Label 6193: @307220
     /* 307220 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(307360), // Rule ID 5262 //
     /* 307225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307243 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307246 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307253 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307259 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 307266 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 307266 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307269 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 307273 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307293 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307326 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307329 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307332 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307335 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307340 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307358 */   GIR_RootConstrainSelectedInstOperands,
     /* 307359 */   // GIR_Coverage, 5262,
     /* 307359 */   GIR_EraseRootFromParent_Done,
     /* 307360 */ // Label 6194: @307360
     /* 307360 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(307500), // Rule ID 5265 //
     /* 307365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307383 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307386 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307393 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307399 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 307406 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 307406 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307409 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 307413 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307433 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307440 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307443 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307447 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307466 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307469 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307472 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307498 */   GIR_RootConstrainSelectedInstOperands,
     /* 307499 */   // GIR_Coverage, 5265,
     /* 307499 */   GIR_EraseRootFromParent_Done,
     /* 307500 */ // Label 6195: @307500
     /* 307500 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(307640), // Rule ID 5266 //
     /* 307505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307523 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307526 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307533 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307539 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 307546 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 307546 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307549 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 307553 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307573 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307580 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307583 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307587 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307606 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307609 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307612 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307625 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307638 */   GIR_RootConstrainSelectedInstOperands,
     /* 307639 */   // GIR_Coverage, 5266,
     /* 307639 */   GIR_EraseRootFromParent_Done,
     /* 307640 */ // Label 6196: @307640
     /* 307640 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(307775), // Rule ID 5263 //
     /* 307645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307663 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307666 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307673 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307679 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 307686 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 307686 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307689 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 307693 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307708 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307715 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307718 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307722 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307744 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307747 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307750 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307755 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307760 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307773 */   GIR_RootConstrainSelectedInstOperands,
     /* 307774 */   // GIR_Coverage, 5263,
     /* 307774 */   GIR_EraseRootFromParent_Done,
     /* 307775 */ // Label 6197: @307775
     /* 307775 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(307910), // Rule ID 5264 //
     /* 307780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307798 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307801 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307808 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307814 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 307821 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 307821 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307824 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 307828 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307843 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307850 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307853 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307857 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307876 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307879 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307882 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307885 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307890 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307895 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307908 */   GIR_RootConstrainSelectedInstOperands,
     /* 307909 */   // GIR_Coverage, 5264,
     /* 307909 */   GIR_EraseRootFromParent_Done,
     /* 307910 */ // Label 6198: @307910
     /* 307910 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(308045), // Rule ID 5267 //
     /* 307915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307925 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307929 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307933 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307936 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307943 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307949 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 307956 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 307956 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307959 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 307963 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307978 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307985 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307988 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307992 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308011 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308014 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308017 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308020 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308030 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 308038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308043 */   GIR_RootConstrainSelectedInstOperands,
     /* 308044 */   // GIR_Coverage, 5267,
     /* 308044 */   GIR_EraseRootFromParent_Done,
     /* 308045 */ // Label 6199: @308045
     /* 308045 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(308180), // Rule ID 5268 //
     /* 308050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308068 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308071 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308078 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308084 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 308091 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 308091 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 308094 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 308098 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308113 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308120 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308123 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308127 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308146 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308149 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308152 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 308173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308178 */   GIR_RootConstrainSelectedInstOperands,
     /* 308179 */   // GIR_Coverage, 5268,
     /* 308179 */   GIR_EraseRootFromParent_Done,
     /* 308180 */ // Label 6200: @308180
     /* 308180 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(308260), // Rule ID 5256 //
     /* 308185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308203 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308207 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308211 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308216 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308222 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 308222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308234 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308245 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 308253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308258 */   GIR_RootConstrainSelectedInstOperands,
     /* 308259 */   // GIR_Coverage, 5256,
     /* 308259 */   GIR_EraseRootFromParent_Done,
     /* 308260 */ // Label 6201: @308260
     /* 308260 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(308317), // Rule ID 5246 //
     /* 308265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 308283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308289 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 308289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 308296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 308310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308315 */   GIR_RootConstrainSelectedInstOperands,
     /* 308316 */   // GIR_Coverage, 5246,
     /* 308316 */   GIR_EraseRootFromParent_Done,
     /* 308317 */ // Label 6202: @308317
     /* 308317 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(308347), // Rule ID 469 //
     /* 308322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308336 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 308336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 308341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308345 */   GIR_RootConstrainSelectedInstOperands,
     /* 308346 */   // GIR_Coverage, 469,
     /* 308346 */   GIR_Done,
     /* 308347 */ // Label 6203: @308347
     /* 308347 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(308377), // Rule ID 475 //
     /* 308352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308366 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 308366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 308371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308375 */   GIR_RootConstrainSelectedInstOperands,
     /* 308376 */   // GIR_Coverage, 475,
     /* 308376 */   GIR_Done,
     /* 308377 */ // Label 6204: @308377
     /* 308377 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(308407), // Rule ID 505 //
     /* 308382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 308385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308396 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 308396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 308401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308405 */   GIR_RootConstrainSelectedInstOperands,
     /* 308406 */   // GIR_Coverage, 505,
     /* 308406 */   GIR_Done,
     /* 308407 */ // Label 6205: @308407
     /* 308407 */ GIM_Reject,
     /* 308408 */ // Label 6180: @308408
     /* 308408 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(308545), // Rule ID 5277 //
     /* 308413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308431 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308438 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308444 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 308451 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 308458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308478 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308511 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308514 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308517 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308543 */   GIR_RootConstrainSelectedInstOperands,
     /* 308544 */   // GIR_Coverage, 5277,
     /* 308544 */   GIR_EraseRootFromParent_Done,
     /* 308545 */ // Label 6206: @308545
     /* 308545 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(308682), // Rule ID 5278 //
     /* 308550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308568 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308575 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308581 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 308588 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308588 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308591 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 308595 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308615 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308651 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308654 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308680 */   GIR_RootConstrainSelectedInstOperands,
     /* 308681 */   // GIR_Coverage, 5278,
     /* 308681 */   GIR_EraseRootFromParent_Done,
     /* 308682 */ // Label 6207: @308682
     /* 308682 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(308822), // Rule ID 5269 //
     /* 308687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308697 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308705 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308708 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308715 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308721 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 308728 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308728 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308731 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 308735 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308755 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308762 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308765 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308769 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308791 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308794 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308797 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308820 */   GIR_RootConstrainSelectedInstOperands,
     /* 308821 */   // GIR_Coverage, 5269,
     /* 308821 */   GIR_EraseRootFromParent_Done,
     /* 308822 */ // Label 6208: @308822
     /* 308822 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(308962), // Rule ID 5270 //
     /* 308827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308845 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308848 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308855 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308861 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 308868 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308868 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308871 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 308875 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308895 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308902 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308905 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308909 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308928 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308931 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308934 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308947 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308960 */   GIR_RootConstrainSelectedInstOperands,
     /* 308961 */   // GIR_Coverage, 5270,
     /* 308961 */   GIR_EraseRootFromParent_Done,
     /* 308962 */ // Label 6209: @308962
     /* 308962 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(309102), // Rule ID 5273 //
     /* 308967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308985 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308988 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308995 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309001 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 309008 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 309008 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309011 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 309015 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 309035 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309042 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309045 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309049 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309068 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309071 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309074 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309100 */   GIR_RootConstrainSelectedInstOperands,
     /* 309101 */   // GIR_Coverage, 5273,
     /* 309101 */   GIR_EraseRootFromParent_Done,
     /* 309102 */ // Label 6210: @309102
     /* 309102 */ GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(309242), // Rule ID 5274 //
     /* 309107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309125 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309128 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309135 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309141 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 309148 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 309148 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309151 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 309155 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 309175 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309208 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309211 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309214 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309240 */   GIR_RootConstrainSelectedInstOperands,
     /* 309241 */   // GIR_Coverage, 5274,
     /* 309241 */   GIR_EraseRootFromParent_Done,
     /* 309242 */ // Label 6211: @309242
     /* 309242 */ GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(309374), // Rule ID 5279 //
     /* 309247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 309265 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309268 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 309272 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309278 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 309285 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 309285 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 309288 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 309292 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309307 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309340 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309343 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309346 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309372 */   GIR_RootConstrainSelectedInstOperands,
     /* 309373 */   // GIR_Coverage, 5279,
     /* 309373 */   GIR_EraseRootFromParent_Done,
     /* 309374 */ // Label 6212: @309374
     /* 309374 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(309506), // Rule ID 5280 //
     /* 309379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 309397 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 309404 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309410 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 309417 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 309417 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 309420 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 309424 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309439 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309446 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309449 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309453 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309472 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309475 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309478 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309504 */   GIR_RootConstrainSelectedInstOperands,
     /* 309505 */   // GIR_Coverage, 5280,
     /* 309505 */   GIR_EraseRootFromParent_Done,
     /* 309506 */ // Label 6213: @309506
     /* 309506 */ GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(309641), // Rule ID 5271 //
     /* 309511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309529 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309532 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309539 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309545 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 309552 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 309552 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309555 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 309559 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309574 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309581 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309584 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309588 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309610 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309613 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309639 */   GIR_RootConstrainSelectedInstOperands,
     /* 309640 */   // GIR_Coverage, 5271,
     /* 309640 */   GIR_EraseRootFromParent_Done,
     /* 309641 */ // Label 6214: @309641
     /* 309641 */ GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(309776), // Rule ID 5272 //
     /* 309646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309664 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309667 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309674 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309680 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 309687 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 309687 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309690 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 309694 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309709 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309742 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309748 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309774 */   GIR_RootConstrainSelectedInstOperands,
     /* 309775 */   // GIR_Coverage, 5272,
     /* 309775 */   GIR_EraseRootFromParent_Done,
     /* 309776 */ // Label 6215: @309776
     /* 309776 */ GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(309911), // Rule ID 5275 //
     /* 309781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309799 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309802 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309809 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309815 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 309822 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 309822 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309825 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 309829 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309844 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309851 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309854 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309858 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309877 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309880 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309883 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309896 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309909 */   GIR_RootConstrainSelectedInstOperands,
     /* 309910 */   // GIR_Coverage, 5275,
     /* 309910 */   GIR_EraseRootFromParent_Done,
     /* 309911 */ // Label 6216: @309911
     /* 309911 */ GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(310046), // Rule ID 5276 //
     /* 309916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309934 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309937 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 309957 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 309957 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309960 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 309964 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309979 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 310018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 310021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 310039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310044 */   GIR_RootConstrainSelectedInstOperands,
     /* 310045 */   // GIR_Coverage, 5276,
     /* 310045 */   GIR_EraseRootFromParent_Done,
     /* 310046 */ // Label 6217: @310046
     /* 310046 */ GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(310126), // Rule ID 5258 //
     /* 310051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310069 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310073 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310077 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310082 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310088 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 310088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310100 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 310106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 310119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310124 */   GIR_RootConstrainSelectedInstOperands,
     /* 310125 */   // GIR_Coverage, 5258,
     /* 310125 */   GIR_EraseRootFromParent_Done,
     /* 310126 */ // Label 6218: @310126
     /* 310126 */ GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(310183), // Rule ID 5242 //
     /* 310131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 310149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310155 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 310155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 310162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310167 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 310176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310181 */   GIR_RootConstrainSelectedInstOperands,
     /* 310182 */   // GIR_Coverage, 5242,
     /* 310182 */   GIR_EraseRootFromParent_Done,
     /* 310183 */ // Label 6219: @310183
     /* 310183 */ GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(310213), // Rule ID 471 //
     /* 310188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310202 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 310202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 310207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310211 */   GIR_RootConstrainSelectedInstOperands,
     /* 310212 */   // GIR_Coverage, 471,
     /* 310212 */   GIR_Done,
     /* 310213 */ // Label 6220: @310213
     /* 310213 */ GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(310243), // Rule ID 477 //
     /* 310218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310232 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 310232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 310237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310241 */   GIR_RootConstrainSelectedInstOperands,
     /* 310242 */   // GIR_Coverage, 477,
     /* 310242 */   GIR_Done,
     /* 310243 */ // Label 6221: @310243
     /* 310243 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(310273), // Rule ID 501 //
     /* 310248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 310251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310262 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 310262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 310267 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310271 */   GIR_RootConstrainSelectedInstOperands,
     /* 310272 */   // GIR_Coverage, 501,
     /* 310272 */   GIR_Done,
     /* 310273 */ // Label 6222: @310273
     /* 310273 */ GIM_Reject,
     /* 310274 */ // Label 6181: @310274
     /* 310274 */ GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(310304), // Rule ID 1071 //
     /* 310279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310293 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 310293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 310298 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310302 */   GIR_RootConstrainSelectedInstOperands,
     /* 310303 */   // GIR_Coverage, 1071,
     /* 310303 */   GIR_Done,
     /* 310304 */ // Label 6223: @310304
     /* 310304 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(310347), // Rule ID 12857 //
     /* 310309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310319 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 310319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 310326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310331 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 310335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 310340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310345 */   GIR_RootConstrainSelectedInstOperands,
     /* 310346 */   // GIR_Coverage, 12857,
     /* 310346 */   GIR_EraseRootFromParent_Done,
     /* 310347 */ // Label 6224: @310347
     /* 310347 */ GIM_Reject,
     /* 310348 */ // Label 6182: @310348
     /* 310348 */ GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(310378), // Rule ID 1075 //
     /* 310353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310367 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 310367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 310372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310376 */   GIR_RootConstrainSelectedInstOperands,
     /* 310377 */   // GIR_Coverage, 1075,
     /* 310377 */   GIR_Done,
     /* 310378 */ // Label 6225: @310378
     /* 310378 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(310424), // Rule ID 12855 //
     /* 310383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310393 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 310393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 310400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310405 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 310409 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 310412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 310417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310422 */   GIR_RootConstrainSelectedInstOperands,
     /* 310423 */   // GIR_Coverage, 12855,
     /* 310423 */   GIR_EraseRootFromParent_Done,
     /* 310424 */ // Label 6226: @310424
     /* 310424 */ GIM_Reject,
     /* 310425 */ // Label 6183: @310425
     /* 310425 */ GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(310455), // Rule ID 1067 //
     /* 310430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310444 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 310444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 310449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310453 */   GIR_RootConstrainSelectedInstOperands,
     /* 310454 */   // GIR_Coverage, 1067,
     /* 310454 */   GIR_Done,
     /* 310455 */ // Label 6227: @310455
     /* 310455 */ GIM_Reject,
     /* 310456 */ // Label 6184: @310456
     /* 310456 */ GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(310486), // Rule ID 1073 //
     /* 310461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310475 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 310475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 310480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310484 */   GIR_RootConstrainSelectedInstOperands,
     /* 310485 */   // GIR_Coverage, 1073,
     /* 310485 */   GIR_Done,
     /* 310486 */ // Label 6228: @310486
     /* 310486 */ GIM_Reject,
     /* 310487 */ // Label 6185: @310487
     /* 310487 */ GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(310517), // Rule ID 1069 //
     /* 310492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310506 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 310506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 310511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310515 */   GIR_RootConstrainSelectedInstOperands,
     /* 310516 */   // GIR_Coverage, 1069,
     /* 310516 */   GIR_Done,
     /* 310517 */ // Label 6229: @310517
     /* 310517 */ GIM_Reject,
     /* 310518 */ // Label 6186: @310518
     /* 310518 */ GIM_Reject,
     /* 310519 */ // Label 66: @310519
     /* 310519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6237*/ GIMT_Encode4(310838),
     /* 310530 */ /*GILLT_s32*//*Label 6230*/ GIMT_Encode4(310566),
     /* 310534 */ /*GILLT_s64*//*Label 6231*/ GIMT_Encode4(310639), GIMT_Encode4(0),
     /* 310542 */ /*GILLT_v2s32*//*Label 6232*/ GIMT_Encode4(310712),
     /* 310546 */ /*GILLT_v2s64*//*Label 6233*/ GIMT_Encode4(310736),
     /* 310550 */ /*GILLT_v4s16*//*Label 6234*/ GIMT_Encode4(310760),
     /* 310554 */ /*GILLT_v4s32*//*Label 6235*/ GIMT_Encode4(310787), GIMT_Encode4(0),
     /* 310562 */ /*GILLT_v8s16*//*Label 6236*/ GIMT_Encode4(310811),
     /* 310566 */ // Label 6230: @310566
     /* 310566 */ GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(310592), // Rule ID 4523 //
     /* 310571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310581 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 310586 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310590 */   GIR_RootConstrainSelectedInstOperands,
     /* 310591 */   // GIR_Coverage, 4523,
     /* 310591 */   GIR_Done,
     /* 310592 */ // Label 6238: @310592
     /* 310592 */ GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(310615), // Rule ID 4525 //
     /* 310597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310604 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310609 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310613 */   GIR_RootConstrainSelectedInstOperands,
     /* 310614 */   // GIR_Coverage, 4525,
     /* 310614 */   GIR_Done,
     /* 310615 */ // Label 6239: @310615
     /* 310615 */ GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(310638), // Rule ID 4527 //
     /* 310620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310627 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310636 */   GIR_RootConstrainSelectedInstOperands,
     /* 310637 */   // GIR_Coverage, 4527,
     /* 310637 */   GIR_Done,
     /* 310638 */ // Label 6240: @310638
     /* 310638 */ GIM_Reject,
     /* 310639 */ // Label 6231: @310639
     /* 310639 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(310665), // Rule ID 4524 //
     /* 310644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310654 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 310659 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310663 */   GIR_RootConstrainSelectedInstOperands,
     /* 310664 */   // GIR_Coverage, 4524,
     /* 310664 */   GIR_Done,
     /* 310665 */ // Label 6241: @310665
     /* 310665 */ GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(310688), // Rule ID 4526 //
     /* 310670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310677 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 310682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310686 */   GIR_RootConstrainSelectedInstOperands,
     /* 310687 */   // GIR_Coverage, 4526,
     /* 310687 */   GIR_Done,
     /* 310688 */ // Label 6242: @310688
     /* 310688 */ GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(310711), // Rule ID 4528 //
     /* 310693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310700 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 310705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310709 */   GIR_RootConstrainSelectedInstOperands,
     /* 310710 */   // GIR_Coverage, 4528,
     /* 310710 */   GIR_Done,
     /* 310711 */ // Label 6243: @310711
     /* 310711 */ GIM_Reject,
     /* 310712 */ // Label 6232: @310712
     /* 310712 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(310735), // Rule ID 4864 //
     /* 310717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310724 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 310724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 310729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310733 */   GIR_RootConstrainSelectedInstOperands,
     /* 310734 */   // GIR_Coverage, 4864,
     /* 310734 */   GIR_Done,
     /* 310735 */ // Label 6244: @310735
     /* 310735 */ GIM_Reject,
     /* 310736 */ // Label 6233: @310736
     /* 310736 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(310759), // Rule ID 4866 //
     /* 310741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310748 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 310748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 310753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310757 */   GIR_RootConstrainSelectedInstOperands,
     /* 310758 */   // GIR_Coverage, 4866,
     /* 310758 */   GIR_Done,
     /* 310759 */ // Label 6245: @310759
     /* 310759 */ GIM_Reject,
     /* 310760 */ // Label 6234: @310760
     /* 310760 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310786), // Rule ID 4859 //
     /* 310765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310775 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 310775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 310780 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310784 */   GIR_RootConstrainSelectedInstOperands,
     /* 310785 */   // GIR_Coverage, 4859,
     /* 310785 */   GIR_Done,
     /* 310786 */ // Label 6246: @310786
     /* 310786 */ GIM_Reject,
     /* 310787 */ // Label 6235: @310787
     /* 310787 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(310810), // Rule ID 4865 //
     /* 310792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310799 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 310799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 310804 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310808 */   GIR_RootConstrainSelectedInstOperands,
     /* 310809 */   // GIR_Coverage, 4865,
     /* 310809 */   GIR_Done,
     /* 310810 */ // Label 6247: @310810
     /* 310810 */ GIM_Reject,
     /* 310811 */ // Label 6236: @310811
     /* 310811 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(310837), // Rule ID 4860 //
     /* 310816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310826 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 310826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 310831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310835 */   GIR_RootConstrainSelectedInstOperands,
     /* 310836 */   // GIR_Coverage, 4860,
     /* 310836 */   GIR_Done,
     /* 310837 */ // Label 6248: @310837
     /* 310837 */ GIM_Reject,
     /* 310838 */ // Label 6237: @310838
     /* 310838 */ GIM_Reject,
     /* 310839 */ // Label 67: @310839
     /* 310839 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6256*/ GIMT_Encode4(311158),
     /* 310850 */ /*GILLT_s32*//*Label 6249*/ GIMT_Encode4(310886),
     /* 310854 */ /*GILLT_s64*//*Label 6250*/ GIMT_Encode4(310959), GIMT_Encode4(0),
     /* 310862 */ /*GILLT_v2s32*//*Label 6251*/ GIMT_Encode4(311032),
     /* 310866 */ /*GILLT_v2s64*//*Label 6252*/ GIMT_Encode4(311056),
     /* 310870 */ /*GILLT_v4s16*//*Label 6253*/ GIMT_Encode4(311080),
     /* 310874 */ /*GILLT_v4s32*//*Label 6254*/ GIMT_Encode4(311107), GIMT_Encode4(0),
     /* 310882 */ /*GILLT_v8s16*//*Label 6255*/ GIMT_Encode4(311131),
     /* 310886 */ // Label 6249: @310886
     /* 310886 */ GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(310912), // Rule ID 4547 //
     /* 310891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310901 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 310906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310910 */   GIR_RootConstrainSelectedInstOperands,
     /* 310911 */   // GIR_Coverage, 4547,
     /* 310911 */   GIR_Done,
     /* 310912 */ // Label 6257: @310912
     /* 310912 */ GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(310935), // Rule ID 4549 //
     /* 310917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310924 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 310929 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310933 */   GIR_RootConstrainSelectedInstOperands,
     /* 310934 */   // GIR_Coverage, 4549,
     /* 310934 */   GIR_Done,
     /* 310935 */ // Label 6258: @310935
     /* 310935 */ GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(310958), // Rule ID 4551 //
     /* 310940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310947 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 310952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310956 */   GIR_RootConstrainSelectedInstOperands,
     /* 310957 */   // GIR_Coverage, 4551,
     /* 310957 */   GIR_Done,
     /* 310958 */ // Label 6259: @310958
     /* 310958 */ GIM_Reject,
     /* 310959 */ // Label 6250: @310959
     /* 310959 */ GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(310985), // Rule ID 4548 //
     /* 310964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310974 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 310979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310983 */   GIR_RootConstrainSelectedInstOperands,
     /* 310984 */   // GIR_Coverage, 4548,
     /* 310984 */   GIR_Done,
     /* 310985 */ // Label 6260: @310985
     /* 310985 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(311008), // Rule ID 4550 //
     /* 310990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310997 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 311002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311006 */   GIR_RootConstrainSelectedInstOperands,
     /* 311007 */   // GIR_Coverage, 4550,
     /* 311007 */   GIR_Done,
     /* 311008 */ // Label 6261: @311008
     /* 311008 */ GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(311031), // Rule ID 4552 //
     /* 311013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311020 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 311025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311029 */   GIR_RootConstrainSelectedInstOperands,
     /* 311030 */   // GIR_Coverage, 4552,
     /* 311030 */   GIR_Done,
     /* 311031 */ // Label 6262: @311031
     /* 311031 */ GIM_Reject,
     /* 311032 */ // Label 6251: @311032
     /* 311032 */ GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(311055), // Rule ID 4874 //
     /* 311037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311044 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 311044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 311049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311053 */   GIR_RootConstrainSelectedInstOperands,
     /* 311054 */   // GIR_Coverage, 4874,
     /* 311054 */   GIR_Done,
     /* 311055 */ // Label 6263: @311055
     /* 311055 */ GIM_Reject,
     /* 311056 */ // Label 6252: @311056
     /* 311056 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(311079), // Rule ID 4876 //
     /* 311061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311068 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 311068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 311073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311077 */   GIR_RootConstrainSelectedInstOperands,
     /* 311078 */   // GIR_Coverage, 4876,
     /* 311078 */   GIR_Done,
     /* 311079 */ // Label 6264: @311079
     /* 311079 */ GIM_Reject,
     /* 311080 */ // Label 6253: @311080
     /* 311080 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(311106), // Rule ID 4869 //
     /* 311085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311095 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 311095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 311100 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311104 */   GIR_RootConstrainSelectedInstOperands,
     /* 311105 */   // GIR_Coverage, 4869,
     /* 311105 */   GIR_Done,
     /* 311106 */ // Label 6265: @311106
     /* 311106 */ GIM_Reject,
     /* 311107 */ // Label 6254: @311107
     /* 311107 */ GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(311130), // Rule ID 4875 //
     /* 311112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311119 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 311119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 311124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311128 */   GIR_RootConstrainSelectedInstOperands,
     /* 311129 */   // GIR_Coverage, 4875,
     /* 311129 */   GIR_Done,
     /* 311130 */ // Label 6266: @311130
     /* 311130 */ GIM_Reject,
     /* 311131 */ // Label 6255: @311131
     /* 311131 */ GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(311157), // Rule ID 4870 //
     /* 311136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311146 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 311146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 311151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311155 */   GIR_RootConstrainSelectedInstOperands,
     /* 311156 */   // GIR_Coverage, 4870,
     /* 311156 */   GIR_Done,
     /* 311157 */ // Label 6267: @311157
     /* 311157 */ GIM_Reject,
     /* 311158 */ // Label 6256: @311158
     /* 311158 */ GIM_Reject,
     /* 311159 */ // Label 68: @311159
     /* 311159 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6276*/ GIMT_Encode4(312015),
     /* 311170 */ /*GILLT_s16*//*Label 6268*/ GIMT_Encode4(311210),
     /* 311174 */ /*GILLT_s32*//*Label 6269*/ GIMT_Encode4(311429),
     /* 311178 */ /*GILLT_s64*//*Label 6270*/ GIMT_Encode4(311503), GIMT_Encode4(0),
     /* 311186 */ /*GILLT_v2s32*//*Label 6271*/ GIMT_Encode4(311577),
     /* 311190 */ /*GILLT_v2s64*//*Label 6272*/ GIMT_Encode4(311651),
     /* 311194 */ /*GILLT_v4s16*//*Label 6273*/ GIMT_Encode4(311725),
     /* 311198 */ /*GILLT_v4s32*//*Label 6274*/ GIMT_Encode4(311833), GIMT_Encode4(0),
     /* 311206 */ /*GILLT_v8s16*//*Label 6275*/ GIMT_Encode4(311907),
     /* 311210 */ // Label 6268: @311210
     /* 311210 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(311428),
     /* 311215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311222 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(311263), // Rule ID 5145 //
     /* 311227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311248 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 311248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 311251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311261 */     GIR_RootConstrainSelectedInstOperands,
     /* 311262 */     // GIR_Coverage, 5145,
     /* 311262 */     GIR_EraseRootFromParent_Done,
     /* 311263 */   // Label 6278: @311263
     /* 311263 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(311282), // Rule ID 521 //
     /* 311268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311275 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 311275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 311280 */     GIR_RootConstrainSelectedInstOperands,
     /* 311281 */     // GIR_Coverage, 521,
     /* 311281 */     GIR_Done,
     /* 311282 */   // Label 6279: @311282
     /* 311282 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(311427), // Rule ID 6282 //
     /* 311287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311291 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 311291 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 311294 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311298 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 311305 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 311308 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311312 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311317 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 311320 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 311324 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 311327 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311332 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311337 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311342 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 311345 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311349 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311354 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 311357 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 311369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311374 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311377 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 311382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 311387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 311399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 311416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311426 */     // GIR_Coverage, 6282,
     /* 311426 */     GIR_EraseRootFromParent_Done,
     /* 311427 */   // Label 6280: @311427
     /* 311427 */   GIM_Reject,
     /* 311428 */ // Label 6277: @311428
     /* 311428 */ GIM_Reject,
     /* 311429 */ // Label 6269: @311429
     /* 311429 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311502),
     /* 311434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311441 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(311482), // Rule ID 5146 //
     /* 311446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311467 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 311467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 311470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311480 */     GIR_RootConstrainSelectedInstOperands,
     /* 311481 */     // GIR_Coverage, 5146,
     /* 311481 */     GIR_EraseRootFromParent_Done,
     /* 311482 */   // Label 6282: @311482
     /* 311482 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(311501), // Rule ID 522 //
     /* 311487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311494 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 311494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 311499 */     GIR_RootConstrainSelectedInstOperands,
     /* 311500 */     // GIR_Coverage, 522,
     /* 311500 */     GIR_Done,
     /* 311501 */   // Label 6283: @311501
     /* 311501 */   GIM_Reject,
     /* 311502 */ // Label 6281: @311502
     /* 311502 */ GIM_Reject,
     /* 311503 */ // Label 6270: @311503
     /* 311503 */ GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(311576),
     /* 311508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311515 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311556), // Rule ID 5147 //
     /* 311520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311541 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 311541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 311544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311554 */     GIR_RootConstrainSelectedInstOperands,
     /* 311555 */     // GIR_Coverage, 5147,
     /* 311555 */     GIR_EraseRootFromParent_Done,
     /* 311556 */   // Label 6285: @311556
     /* 311556 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311575), // Rule ID 523 //
     /* 311561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311568 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 311568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 311573 */     GIR_RootConstrainSelectedInstOperands,
     /* 311574 */     // GIR_Coverage, 523,
     /* 311574 */     GIR_Done,
     /* 311575 */   // Label 6286: @311575
     /* 311575 */   GIM_Reject,
     /* 311576 */ // Label 6284: @311576
     /* 311576 */ GIM_Reject,
     /* 311577 */ // Label 6271: @311577
     /* 311577 */ GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311650),
     /* 311582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311589 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311630), // Rule ID 4938 //
     /* 311594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 311613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311615 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 311615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 311618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311628 */     GIR_RootConstrainSelectedInstOperands,
     /* 311629 */     // GIR_Coverage, 4938,
     /* 311629 */     GIR_EraseRootFromParent_Done,
     /* 311630 */   // Label 6288: @311630
     /* 311630 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311649), // Rule ID 761 //
     /* 311635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311642 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 311642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 311647 */     GIR_RootConstrainSelectedInstOperands,
     /* 311648 */     // GIR_Coverage, 761,
     /* 311648 */     GIR_Done,
     /* 311649 */   // Label 6289: @311649
     /* 311649 */   GIM_Reject,
     /* 311650 */ // Label 6287: @311650
     /* 311650 */ GIM_Reject,
     /* 311651 */ // Label 6272: @311651
     /* 311651 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311724),
     /* 311656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311663 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311704), // Rule ID 4940 //
     /* 311668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 311687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311689 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 311689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 311692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311702 */     GIR_RootConstrainSelectedInstOperands,
     /* 311703 */     // GIR_Coverage, 4940,
     /* 311703 */     GIR_EraseRootFromParent_Done,
     /* 311704 */   // Label 6291: @311704
     /* 311704 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(311723), // Rule ID 763 //
     /* 311709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311716 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 311716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 311721 */     GIR_RootConstrainSelectedInstOperands,
     /* 311722 */     // GIR_Coverage, 763,
     /* 311722 */     GIR_Done,
     /* 311723 */   // Label 6292: @311723
     /* 311723 */   GIM_Reject,
     /* 311724 */ // Label 6290: @311724
     /* 311724 */ GIM_Reject,
     /* 311725 */ // Label 6273: @311725
     /* 311725 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(311832),
     /* 311730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311737 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(311778), // Rule ID 4941 //
     /* 311742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 311761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311763 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 311763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 311766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311776 */     GIR_RootConstrainSelectedInstOperands,
     /* 311777 */     // GIR_Coverage, 4941,
     /* 311777 */     GIR_EraseRootFromParent_Done,
     /* 311778 */   // Label 6294: @311778
     /* 311778 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(311797), // Rule ID 759 //
     /* 311783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311790 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 311790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 311795 */     GIR_RootConstrainSelectedInstOperands,
     /* 311796 */     // GIR_Coverage, 759,
     /* 311796 */     GIR_Done,
     /* 311797 */   // Label 6295: @311797
     /* 311797 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(311831), // Rule ID 6284 //
     /* 311802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311809 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 311812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311816 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 311826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 311829 */     GIR_RootConstrainSelectedInstOperands,
     /* 311830 */     // GIR_Coverage, 6284,
     /* 311830 */     GIR_EraseRootFromParent_Done,
     /* 311831 */   // Label 6296: @311831
     /* 311831 */   GIM_Reject,
     /* 311832 */ // Label 6293: @311832
     /* 311832 */ GIM_Reject,
     /* 311833 */ // Label 6274: @311833
     /* 311833 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(311906),
     /* 311838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311845 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(311886), // Rule ID 4939 //
     /* 311850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 311869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311871 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 311871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 311874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311884 */     GIR_RootConstrainSelectedInstOperands,
     /* 311885 */     // GIR_Coverage, 4939,
     /* 311885 */     GIR_EraseRootFromParent_Done,
     /* 311886 */   // Label 6298: @311886
     /* 311886 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(311905), // Rule ID 762 //
     /* 311891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311898 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 311898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 311903 */     GIR_RootConstrainSelectedInstOperands,
     /* 311904 */     // GIR_Coverage, 762,
     /* 311904 */     GIR_Done,
     /* 311905 */   // Label 6299: @311905
     /* 311905 */   GIM_Reject,
     /* 311906 */ // Label 6297: @311906
     /* 311906 */ GIM_Reject,
     /* 311907 */ // Label 6275: @311907
     /* 311907 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(312014),
     /* 311912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311919 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311960), // Rule ID 4942 //
     /* 311924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 311943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311945 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 311945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 311948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311958 */     GIR_RootConstrainSelectedInstOperands,
     /* 311959 */     // GIR_Coverage, 4942,
     /* 311959 */     GIR_EraseRootFromParent_Done,
     /* 311960 */   // Label 6301: @311960
     /* 311960 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311979), // Rule ID 760 //
     /* 311965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311972 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 311972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 311977 */     GIR_RootConstrainSelectedInstOperands,
     /* 311978 */     // GIR_Coverage, 760,
     /* 311978 */     GIR_Done,
     /* 311979 */   // Label 6302: @311979
     /* 311979 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(312013), // Rule ID 6285 //
     /* 311984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311991 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 311994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 312008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 312011 */     GIR_RootConstrainSelectedInstOperands,
     /* 312012 */     // GIR_Coverage, 6285,
     /* 312012 */     GIR_EraseRootFromParent_Done,
     /* 312013 */   // Label 6303: @312013
     /* 312013 */   GIM_Reject,
     /* 312014 */ // Label 6300: @312014
     /* 312014 */ GIM_Reject,
     /* 312015 */ // Label 6276: @312015
     /* 312015 */ GIM_Reject,
     /* 312016 */ // Label 69: @312016
     /* 312016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6312*/ GIMT_Encode4(312297),
     /* 312027 */ /*GILLT_s16*//*Label 6304*/ GIMT_Encode4(312067),
     /* 312031 */ /*GILLT_s32*//*Label 6305*/ GIMT_Encode4(312094),
     /* 312035 */ /*GILLT_s64*//*Label 6306*/ GIMT_Encode4(312118), GIMT_Encode4(0),
     /* 312043 */ /*GILLT_v2s32*//*Label 6307*/ GIMT_Encode4(312142),
     /* 312047 */ /*GILLT_v2s64*//*Label 6308*/ GIMT_Encode4(312173),
     /* 312051 */ /*GILLT_v4s16*//*Label 6309*/ GIMT_Encode4(312204),
     /* 312055 */ /*GILLT_v4s32*//*Label 6310*/ GIMT_Encode4(312235), GIMT_Encode4(0),
     /* 312063 */ /*GILLT_v8s16*//*Label 6311*/ GIMT_Encode4(312266),
     /* 312067 */ // Label 6304: @312067
     /* 312067 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(312093), // Rule ID 4763 //
     /* 312072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312082 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 312082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 312085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312087 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312089 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312091 */   GIR_RootConstrainSelectedInstOperands,
     /* 312092 */   // GIR_Coverage, 4763,
     /* 312092 */   GIR_EraseRootFromParent_Done,
     /* 312093 */ // Label 6313: @312093
     /* 312093 */ GIM_Reject,
     /* 312094 */ // Label 6305: @312094
     /* 312094 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(312117), // Rule ID 4760 //
     /* 312099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312106 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 312106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 312109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312111 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312113 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312115 */   GIR_RootConstrainSelectedInstOperands,
     /* 312116 */   // GIR_Coverage, 4760,
     /* 312116 */   GIR_EraseRootFromParent_Done,
     /* 312117 */ // Label 6314: @312117
     /* 312117 */ GIM_Reject,
     /* 312118 */ // Label 6306: @312118
     /* 312118 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(312141), // Rule ID 4757 //
     /* 312123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312130 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 312130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312135 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312137 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 312139 */   GIR_RootConstrainSelectedInstOperands,
     /* 312140 */   // GIR_Coverage, 4757,
     /* 312140 */   GIR_EraseRootFromParent_Done,
     /* 312141 */ // Label 6315: @312141
     /* 312141 */ GIM_Reject,
     /* 312142 */ // Label 6307: @312142
     /* 312142 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(312172), // Rule ID 4951 //
     /* 312147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312161 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 312161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312166 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312168 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312170 */   GIR_RootConstrainSelectedInstOperands,
     /* 312171 */   // GIR_Coverage, 4951,
     /* 312171 */   GIR_EraseRootFromParent_Done,
     /* 312172 */ // Label 6316: @312172
     /* 312172 */ GIM_Reject,
     /* 312173 */ // Label 6308: @312173
     /* 312173 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(312203), // Rule ID 4945 //
     /* 312178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312192 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 312192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312197 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312201 */   GIR_RootConstrainSelectedInstOperands,
     /* 312202 */   // GIR_Coverage, 4945,
     /* 312202 */   GIR_EraseRootFromParent_Done,
     /* 312203 */ // Label 6317: @312203
     /* 312203 */ GIM_Reject,
     /* 312204 */ // Label 6309: @312204
     /* 312204 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(312234), // Rule ID 4957 //
     /* 312209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312223 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 312223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312230 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312232 */   GIR_RootConstrainSelectedInstOperands,
     /* 312233 */   // GIR_Coverage, 4957,
     /* 312233 */   GIR_EraseRootFromParent_Done,
     /* 312234 */ // Label 6318: @312234
     /* 312234 */ GIM_Reject,
     /* 312235 */ // Label 6310: @312235
     /* 312235 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312265), // Rule ID 4948 //
     /* 312240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312254 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 312254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312259 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312261 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312263 */   GIR_RootConstrainSelectedInstOperands,
     /* 312264 */   // GIR_Coverage, 4948,
     /* 312264 */   GIR_EraseRootFromParent_Done,
     /* 312265 */ // Label 6319: @312265
     /* 312265 */ GIM_Reject,
     /* 312266 */ // Label 6311: @312266
     /* 312266 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312296), // Rule ID 4954 //
     /* 312271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312285 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 312285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312290 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312294 */   GIR_RootConstrainSelectedInstOperands,
     /* 312295 */   // GIR_Coverage, 4954,
     /* 312295 */   GIR_EraseRootFromParent_Done,
     /* 312296 */ // Label 6320: @312296
     /* 312296 */ GIM_Reject,
     /* 312297 */ // Label 6312: @312297
     /* 312297 */ GIM_Reject,
     /* 312298 */ // Label 70: @312298
     /* 312298 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6329*/ GIMT_Encode4(312675),
     /* 312309 */ /*GILLT_s16*//*Label 6321*/ GIMT_Encode4(312349),
     /* 312313 */ /*GILLT_s32*//*Label 6322*/ GIMT_Encode4(312387),
     /* 312317 */ /*GILLT_s64*//*Label 6323*/ GIMT_Encode4(312425), GIMT_Encode4(0),
     /* 312325 */ /*GILLT_v2s32*//*Label 6324*/ GIMT_Encode4(312485),
     /* 312329 */ /*GILLT_v2s64*//*Label 6325*/ GIMT_Encode4(312523),
     /* 312333 */ /*GILLT_v4s16*//*Label 6326*/ GIMT_Encode4(312561),
     /* 312337 */ /*GILLT_v4s32*//*Label 6327*/ GIMT_Encode4(312599), GIMT_Encode4(0),
     /* 312345 */ /*GILLT_v8s16*//*Label 6328*/ GIMT_Encode4(312637),
     /* 312349 */ // Label 6321: @312349
     /* 312349 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(312386), // Rule ID 608 //
     /* 312354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312375 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 312375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 312380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312384 */   GIR_RootConstrainSelectedInstOperands,
     /* 312385 */   // GIR_Coverage, 608,
     /* 312385 */   GIR_Done,
     /* 312386 */ // Label 6330: @312386
     /* 312386 */ GIM_Reject,
     /* 312387 */ // Label 6322: @312387
     /* 312387 */ GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(312424), // Rule ID 610 //
     /* 312392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312413 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 312413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 312418 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312422 */   GIR_RootConstrainSelectedInstOperands,
     /* 312423 */   // GIR_Coverage, 610,
     /* 312423 */   GIR_Done,
     /* 312424 */ // Label 6331: @312424
     /* 312424 */ GIM_Reject,
     /* 312425 */ // Label 6323: @312425
     /* 312425 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(312484),
     /* 312430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312448 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(312467), // Rule ID 612 //
     /* 312453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312456 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312465 */     GIR_RootConstrainSelectedInstOperands,
     /* 312466 */     // GIR_Coverage, 612,
     /* 312466 */     GIR_Done,
     /* 312467 */   // Label 6333: @312467
     /* 312467 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(312483), // Rule ID 4754 //
     /* 312472 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312481 */     GIR_RootConstrainSelectedInstOperands,
     /* 312482 */     // GIR_Coverage, 4754,
     /* 312482 */     GIR_Done,
     /* 312483 */   // Label 6334: @312483
     /* 312483 */   GIM_Reject,
     /* 312484 */ // Label 6332: @312484
     /* 312484 */ GIM_Reject,
     /* 312485 */ // Label 6324: @312485
     /* 312485 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(312522), // Rule ID 1266 //
     /* 312490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312511 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312520 */   GIR_RootConstrainSelectedInstOperands,
     /* 312521 */   // GIR_Coverage, 1266,
     /* 312521 */   GIR_Done,
     /* 312522 */ // Label 6335: @312522
     /* 312522 */ GIM_Reject,
     /* 312523 */ // Label 6325: @312523
     /* 312523 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312560), // Rule ID 1270 //
     /* 312528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312549 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312558 */   GIR_RootConstrainSelectedInstOperands,
     /* 312559 */   // GIR_Coverage, 1270,
     /* 312559 */   GIR_Done,
     /* 312560 */ // Label 6336: @312560
     /* 312560 */ GIM_Reject,
     /* 312561 */ // Label 6326: @312561
     /* 312561 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312598), // Rule ID 1262 //
     /* 312566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312587 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312596 */   GIR_RootConstrainSelectedInstOperands,
     /* 312597 */   // GIR_Coverage, 1262,
     /* 312597 */   GIR_Done,
     /* 312598 */ // Label 6337: @312598
     /* 312598 */ GIM_Reject,
     /* 312599 */ // Label 6327: @312599
     /* 312599 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312636), // Rule ID 1268 //
     /* 312604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312625 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312630 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312634 */   GIR_RootConstrainSelectedInstOperands,
     /* 312635 */   // GIR_Coverage, 1268,
     /* 312635 */   GIR_Done,
     /* 312636 */ // Label 6338: @312636
     /* 312636 */ GIM_Reject,
     /* 312637 */ // Label 6328: @312637
     /* 312637 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312674), // Rule ID 1264 //
     /* 312642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312663 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312672 */   GIR_RootConstrainSelectedInstOperands,
     /* 312673 */   // GIR_Coverage, 1264,
     /* 312673 */   GIR_Done,
     /* 312674 */ // Label 6339: @312674
     /* 312674 */ GIM_Reject,
     /* 312675 */ // Label 6329: @312675
     /* 312675 */ GIM_Reject,
     /* 312676 */ // Label 71: @312676
     /* 312676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6348*/ GIMT_Encode4(313053),
     /* 312687 */ /*GILLT_s16*//*Label 6340*/ GIMT_Encode4(312727),
     /* 312691 */ /*GILLT_s32*//*Label 6341*/ GIMT_Encode4(312765),
     /* 312695 */ /*GILLT_s64*//*Label 6342*/ GIMT_Encode4(312803), GIMT_Encode4(0),
     /* 312703 */ /*GILLT_v2s32*//*Label 6343*/ GIMT_Encode4(312863),
     /* 312707 */ /*GILLT_v2s64*//*Label 6344*/ GIMT_Encode4(312901),
     /* 312711 */ /*GILLT_v4s16*//*Label 6345*/ GIMT_Encode4(312939),
     /* 312715 */ /*GILLT_v4s32*//*Label 6346*/ GIMT_Encode4(312977), GIMT_Encode4(0),
     /* 312723 */ /*GILLT_v8s16*//*Label 6347*/ GIMT_Encode4(313015),
     /* 312727 */ // Label 6340: @312727
     /* 312727 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(312764), // Rule ID 596 //
     /* 312732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312753 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 312753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 312758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312762 */   GIR_RootConstrainSelectedInstOperands,
     /* 312763 */   // GIR_Coverage, 596,
     /* 312763 */   GIR_Done,
     /* 312764 */ // Label 6349: @312764
     /* 312764 */ GIM_Reject,
     /* 312765 */ // Label 6341: @312765
     /* 312765 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(312802), // Rule ID 598 //
     /* 312770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312791 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 312791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 312796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312800 */   GIR_RootConstrainSelectedInstOperands,
     /* 312801 */   // GIR_Coverage, 598,
     /* 312801 */   GIR_Done,
     /* 312802 */ // Label 6350: @312802
     /* 312802 */ GIM_Reject,
     /* 312803 */ // Label 6342: @312803
     /* 312803 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(312862),
     /* 312808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312826 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312845), // Rule ID 600 //
     /* 312831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312834 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312843 */     GIR_RootConstrainSelectedInstOperands,
     /* 312844 */     // GIR_Coverage, 600,
     /* 312844 */     GIR_Done,
     /* 312845 */   // Label 6352: @312845
     /* 312845 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(312861), // Rule ID 4753 //
     /* 312850 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312859 */     GIR_RootConstrainSelectedInstOperands,
     /* 312860 */     // GIR_Coverage, 4753,
     /* 312860 */     GIR_Done,
     /* 312861 */   // Label 6353: @312861
     /* 312861 */   GIM_Reject,
     /* 312862 */ // Label 6351: @312862
     /* 312862 */ GIM_Reject,
     /* 312863 */ // Label 6343: @312863
     /* 312863 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(312900), // Rule ID 1236 //
     /* 312868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312889 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 312894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312898 */   GIR_RootConstrainSelectedInstOperands,
     /* 312899 */   // GIR_Coverage, 1236,
     /* 312899 */   GIR_Done,
     /* 312900 */ // Label 6354: @312900
     /* 312900 */ GIM_Reject,
     /* 312901 */ // Label 6344: @312901
     /* 312901 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(312938), // Rule ID 1240 //
     /* 312906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312927 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 312932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312936 */   GIR_RootConstrainSelectedInstOperands,
     /* 312937 */   // GIR_Coverage, 1240,
     /* 312937 */   GIR_Done,
     /* 312938 */ // Label 6355: @312938
     /* 312938 */ GIM_Reject,
     /* 312939 */ // Label 6345: @312939
     /* 312939 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(312976), // Rule ID 1232 //
     /* 312944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312965 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 312970 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312974 */   GIR_RootConstrainSelectedInstOperands,
     /* 312975 */   // GIR_Coverage, 1232,
     /* 312975 */   GIR_Done,
     /* 312976 */ // Label 6356: @312976
     /* 312976 */ GIM_Reject,
     /* 312977 */ // Label 6346: @312977
     /* 312977 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(313014), // Rule ID 1238 //
     /* 312982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313003 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 313008 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313012 */   GIR_RootConstrainSelectedInstOperands,
     /* 313013 */   // GIR_Coverage, 1238,
     /* 313013 */   GIR_Done,
     /* 313014 */ // Label 6357: @313014
     /* 313014 */ GIM_Reject,
     /* 313015 */ // Label 6347: @313015
     /* 313015 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(313052), // Rule ID 1234 //
     /* 313020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313041 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 313046 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313050 */   GIR_RootConstrainSelectedInstOperands,
     /* 313051 */   // GIR_Coverage, 1234,
     /* 313051 */   GIR_Done,
     /* 313052 */ // Label 6358: @313052
     /* 313052 */ GIM_Reject,
     /* 313053 */ // Label 6348: @313053
     /* 313053 */ GIM_Reject,
     /* 313054 */ // Label 72: @313054
     /* 313054 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6367*/ GIMT_Encode4(313403),
     /* 313065 */ /*GILLT_s16*//*Label 6359*/ GIMT_Encode4(313105),
     /* 313069 */ /*GILLT_s32*//*Label 6360*/ GIMT_Encode4(313143),
     /* 313073 */ /*GILLT_s64*//*Label 6361*/ GIMT_Encode4(313178), GIMT_Encode4(0),
     /* 313081 */ /*GILLT_v2s32*//*Label 6362*/ GIMT_Encode4(313213),
     /* 313085 */ /*GILLT_v2s64*//*Label 6363*/ GIMT_Encode4(313251),
     /* 313089 */ /*GILLT_v4s16*//*Label 6364*/ GIMT_Encode4(313289),
     /* 313093 */ /*GILLT_v4s32*//*Label 6365*/ GIMT_Encode4(313327), GIMT_Encode4(0),
     /* 313101 */ /*GILLT_v8s16*//*Label 6366*/ GIMT_Encode4(313365),
     /* 313105 */ // Label 6359: @313105
     /* 313105 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(313142), // Rule ID 4761 //
     /* 313110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313131 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 313131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 313136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313140 */   GIR_RootConstrainSelectedInstOperands,
     /* 313141 */   // GIR_Coverage, 4761,
     /* 313141 */   GIR_Done,
     /* 313142 */ // Label 6368: @313142
     /* 313142 */ GIM_Reject,
     /* 313143 */ // Label 6360: @313143
     /* 313143 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(313177), // Rule ID 4758 //
     /* 313148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313166 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 313166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 313171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313175 */   GIR_RootConstrainSelectedInstOperands,
     /* 313176 */   // GIR_Coverage, 4758,
     /* 313176 */   GIR_Done,
     /* 313177 */ // Label 6369: @313177
     /* 313177 */ GIM_Reject,
     /* 313178 */ // Label 6361: @313178
     /* 313178 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(313212), // Rule ID 4755 //
     /* 313183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313201 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 313201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 313206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313210 */   GIR_RootConstrainSelectedInstOperands,
     /* 313211 */   // GIR_Coverage, 4755,
     /* 313211 */   GIR_Done,
     /* 313212 */ // Label 6370: @313212
     /* 313212 */ GIM_Reject,
     /* 313213 */ // Label 6362: @313213
     /* 313213 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(313250), // Rule ID 4949 //
     /* 313218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313239 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 313244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313248 */   GIR_RootConstrainSelectedInstOperands,
     /* 313249 */   // GIR_Coverage, 4949,
     /* 313249 */   GIR_Done,
     /* 313250 */ // Label 6371: @313250
     /* 313250 */ GIM_Reject,
     /* 313251 */ // Label 6363: @313251
     /* 313251 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313288), // Rule ID 4943 //
     /* 313256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313277 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 313282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313286 */   GIR_RootConstrainSelectedInstOperands,
     /* 313287 */   // GIR_Coverage, 4943,
     /* 313287 */   GIR_Done,
     /* 313288 */ // Label 6372: @313288
     /* 313288 */ GIM_Reject,
     /* 313289 */ // Label 6364: @313289
     /* 313289 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(313326), // Rule ID 4955 //
     /* 313294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313315 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 313320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313324 */   GIR_RootConstrainSelectedInstOperands,
     /* 313325 */   // GIR_Coverage, 4955,
     /* 313325 */   GIR_Done,
     /* 313326 */ // Label 6373: @313326
     /* 313326 */ GIM_Reject,
     /* 313327 */ // Label 6365: @313327
     /* 313327 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(313364), // Rule ID 4946 //
     /* 313332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313353 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 313358 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313362 */   GIR_RootConstrainSelectedInstOperands,
     /* 313363 */   // GIR_Coverage, 4946,
     /* 313363 */   GIR_Done,
     /* 313364 */ // Label 6374: @313364
     /* 313364 */ GIM_Reject,
     /* 313365 */ // Label 6366: @313365
     /* 313365 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(313402), // Rule ID 4952 //
     /* 313370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313391 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 313396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313400 */   GIR_RootConstrainSelectedInstOperands,
     /* 313401 */   // GIR_Coverage, 4952,
     /* 313401 */   GIR_Done,
     /* 313402 */ // Label 6375: @313402
     /* 313402 */ GIM_Reject,
     /* 313403 */ // Label 6367: @313403
     /* 313403 */ GIM_Reject,
     /* 313404 */ // Label 73: @313404
     /* 313404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6384*/ GIMT_Encode4(313753),
     /* 313415 */ /*GILLT_s16*//*Label 6376*/ GIMT_Encode4(313455),
     /* 313419 */ /*GILLT_s32*//*Label 6377*/ GIMT_Encode4(313493),
     /* 313423 */ /*GILLT_s64*//*Label 6378*/ GIMT_Encode4(313528), GIMT_Encode4(0),
     /* 313431 */ /*GILLT_v2s32*//*Label 6379*/ GIMT_Encode4(313563),
     /* 313435 */ /*GILLT_v2s64*//*Label 6380*/ GIMT_Encode4(313601),
     /* 313439 */ /*GILLT_v4s16*//*Label 6381*/ GIMT_Encode4(313639),
     /* 313443 */ /*GILLT_v4s32*//*Label 6382*/ GIMT_Encode4(313677), GIMT_Encode4(0),
     /* 313451 */ /*GILLT_v8s16*//*Label 6383*/ GIMT_Encode4(313715),
     /* 313455 */ // Label 6376: @313455
     /* 313455 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(313492), // Rule ID 4762 //
     /* 313460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313481 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 313481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 313486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313490 */   GIR_RootConstrainSelectedInstOperands,
     /* 313491 */   // GIR_Coverage, 4762,
     /* 313491 */   GIR_Done,
     /* 313492 */ // Label 6385: @313492
     /* 313492 */ GIM_Reject,
     /* 313493 */ // Label 6377: @313493
     /* 313493 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(313527), // Rule ID 4759 //
     /* 313498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313516 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 313516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 313521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313525 */   GIR_RootConstrainSelectedInstOperands,
     /* 313526 */   // GIR_Coverage, 4759,
     /* 313526 */   GIR_Done,
     /* 313527 */ // Label 6386: @313527
     /* 313527 */ GIM_Reject,
     /* 313528 */ // Label 6378: @313528
     /* 313528 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(313562), // Rule ID 4756 //
     /* 313533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313551 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 313551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 313556 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313560 */   GIR_RootConstrainSelectedInstOperands,
     /* 313561 */   // GIR_Coverage, 4756,
     /* 313561 */   GIR_Done,
     /* 313562 */ // Label 6387: @313562
     /* 313562 */ GIM_Reject,
     /* 313563 */ // Label 6379: @313563
     /* 313563 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(313600), // Rule ID 4950 //
     /* 313568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313589 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 313594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313598 */   GIR_RootConstrainSelectedInstOperands,
     /* 313599 */   // GIR_Coverage, 4950,
     /* 313599 */   GIR_Done,
     /* 313600 */ // Label 6388: @313600
     /* 313600 */ GIM_Reject,
     /* 313601 */ // Label 6380: @313601
     /* 313601 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(313638), // Rule ID 4944 //
     /* 313606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313627 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 313632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313636 */   GIR_RootConstrainSelectedInstOperands,
     /* 313637 */   // GIR_Coverage, 4944,
     /* 313637 */   GIR_Done,
     /* 313638 */ // Label 6389: @313638
     /* 313638 */ GIM_Reject,
     /* 313639 */ // Label 6381: @313639
     /* 313639 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(313676), // Rule ID 4956 //
     /* 313644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313665 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 313670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313674 */   GIR_RootConstrainSelectedInstOperands,
     /* 313675 */   // GIR_Coverage, 4956,
     /* 313675 */   GIR_Done,
     /* 313676 */ // Label 6390: @313676
     /* 313676 */ GIM_Reject,
     /* 313677 */ // Label 6382: @313677
     /* 313677 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(313714), // Rule ID 4947 //
     /* 313682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313703 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 313708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313712 */   GIR_RootConstrainSelectedInstOperands,
     /* 313713 */   // GIR_Coverage, 4947,
     /* 313713 */   GIR_Done,
     /* 313714 */ // Label 6391: @313714
     /* 313714 */ GIM_Reject,
     /* 313715 */ // Label 6383: @313715
     /* 313715 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(313752), // Rule ID 4953 //
     /* 313720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313741 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 313746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313750 */   GIR_RootConstrainSelectedInstOperands,
     /* 313751 */   // GIR_Coverage, 4953,
     /* 313751 */   GIR_Done,
     /* 313752 */ // Label 6392: @313752
     /* 313752 */ GIM_Reject,
     /* 313753 */ // Label 6384: @313753
     /* 313753 */ GIM_Reject,
     /* 313754 */ // Label 74: @313754
     /* 313754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6401*/ GIMT_Encode4(314456),
     /* 313765 */ /*GILLT_s16*//*Label 6393*/ GIMT_Encode4(313805),
     /* 313769 */ /*GILLT_s32*//*Label 6394*/ GIMT_Encode4(313843),
     /* 313773 */ /*GILLT_s64*//*Label 6395*/ GIMT_Encode4(313881), GIMT_Encode4(0),
     /* 313781 */ /*GILLT_v2s32*//*Label 6396*/ GIMT_Encode4(313941),
     /* 313785 */ /*GILLT_v2s64*//*Label 6397*/ GIMT_Encode4(314044),
     /* 313789 */ /*GILLT_v4s16*//*Label 6398*/ GIMT_Encode4(314147),
     /* 313793 */ /*GILLT_v4s32*//*Label 6399*/ GIMT_Encode4(314250), GIMT_Encode4(0),
     /* 313801 */ /*GILLT_v8s16*//*Label 6400*/ GIMT_Encode4(314353),
     /* 313805 */ // Label 6393: @313805
     /* 313805 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(313842), // Rule ID 614 //
     /* 313810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313831 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 313831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 313836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313840 */   GIR_RootConstrainSelectedInstOperands,
     /* 313841 */   // GIR_Coverage, 614,
     /* 313841 */   GIR_Done,
     /* 313842 */ // Label 6402: @313842
     /* 313842 */ GIM_Reject,
     /* 313843 */ // Label 6394: @313843
     /* 313843 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(313880), // Rule ID 616 //
     /* 313848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313869 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 313869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 313874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313878 */   GIR_RootConstrainSelectedInstOperands,
     /* 313879 */   // GIR_Coverage, 616,
     /* 313879 */   GIR_Done,
     /* 313880 */ // Label 6403: @313880
     /* 313880 */ GIM_Reject,
     /* 313881 */ // Label 6395: @313881
     /* 313881 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(313940),
     /* 313886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313904 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(313923), // Rule ID 618 //
     /* 313909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313912 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 313912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313921 */     GIR_RootConstrainSelectedInstOperands,
     /* 313922 */     // GIR_Coverage, 618,
     /* 313922 */     GIR_Done,
     /* 313923 */   // Label 6405: @313923
     /* 313923 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(313939), // Rule ID 4752 //
     /* 313928 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 313928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313933 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313937 */     GIR_RootConstrainSelectedInstOperands,
     /* 313938 */     // GIR_Coverage, 4752,
     /* 313938 */     GIR_Done,
     /* 313939 */   // Label 6406: @313939
     /* 313939 */   GIM_Reject,
     /* 313940 */ // Label 6404: @313940
     /* 313940 */ GIM_Reject,
     /* 313941 */ // Label 6396: @313941
     /* 313941 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(314043),
     /* 313946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313956 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(314015), // Rule ID 2357 //
     /* 313961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314000 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 314003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314013 */     GIR_RootConstrainSelectedInstOperands,
     /* 314014 */     // GIR_Coverage, 2357,
     /* 314014 */     GIR_EraseRootFromParent_Done,
     /* 314015 */   // Label 6408: @314015
     /* 314015 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(314042), // Rule ID 1281 //
     /* 314020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314031 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 314036 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314040 */     GIR_RootConstrainSelectedInstOperands,
     /* 314041 */     // GIR_Coverage, 1281,
     /* 314041 */     GIR_Done,
     /* 314042 */   // Label 6409: @314042
     /* 314042 */   GIM_Reject,
     /* 314043 */ // Label 6407: @314043
     /* 314043 */ GIM_Reject,
     /* 314044 */ // Label 6397: @314044
     /* 314044 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(314146),
     /* 314049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314059 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(314118), // Rule ID 2363 //
     /* 314064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314103 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 314106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314116 */     GIR_RootConstrainSelectedInstOperands,
     /* 314117 */     // GIR_Coverage, 2363,
     /* 314117 */     GIR_EraseRootFromParent_Done,
     /* 314118 */   // Label 6411: @314118
     /* 314118 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(314145), // Rule ID 1285 //
     /* 314123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314134 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 314139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314143 */     GIR_RootConstrainSelectedInstOperands,
     /* 314144 */     // GIR_Coverage, 1285,
     /* 314144 */     GIR_Done,
     /* 314145 */   // Label 6412: @314145
     /* 314145 */   GIM_Reject,
     /* 314146 */ // Label 6410: @314146
     /* 314146 */ GIM_Reject,
     /* 314147 */ // Label 6398: @314147
     /* 314147 */ GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(314249),
     /* 314152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314162 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(314221), // Rule ID 2351 //
     /* 314167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314206 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 314209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314219 */     GIR_RootConstrainSelectedInstOperands,
     /* 314220 */     // GIR_Coverage, 2351,
     /* 314220 */     GIR_EraseRootFromParent_Done,
     /* 314221 */   // Label 6414: @314221
     /* 314221 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(314248), // Rule ID 1277 //
     /* 314226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314237 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 314242 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314246 */     GIR_RootConstrainSelectedInstOperands,
     /* 314247 */     // GIR_Coverage, 1277,
     /* 314247 */     GIR_Done,
     /* 314248 */   // Label 6415: @314248
     /* 314248 */   GIM_Reject,
     /* 314249 */ // Label 6413: @314249
     /* 314249 */ GIM_Reject,
     /* 314250 */ // Label 6399: @314250
     /* 314250 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(314352),
     /* 314255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314265 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(314324), // Rule ID 2360 //
     /* 314270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314309 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 314312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314322 */     GIR_RootConstrainSelectedInstOperands,
     /* 314323 */     // GIR_Coverage, 2360,
     /* 314323 */     GIR_EraseRootFromParent_Done,
     /* 314324 */   // Label 6417: @314324
     /* 314324 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(314351), // Rule ID 1283 //
     /* 314329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314340 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 314345 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314349 */     GIR_RootConstrainSelectedInstOperands,
     /* 314350 */     // GIR_Coverage, 1283,
     /* 314350 */     GIR_Done,
     /* 314351 */   // Label 6418: @314351
     /* 314351 */   GIM_Reject,
     /* 314352 */ // Label 6416: @314352
     /* 314352 */ GIM_Reject,
     /* 314353 */ // Label 6400: @314353
     /* 314353 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(314455),
     /* 314358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 314364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314368 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(314427), // Rule ID 2354 //
     /* 314373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314412 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 314415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314425 */     GIR_RootConstrainSelectedInstOperands,
     /* 314426 */     // GIR_Coverage, 2354,
     /* 314426 */     GIR_EraseRootFromParent_Done,
     /* 314427 */   // Label 6420: @314427
     /* 314427 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(314454), // Rule ID 1279 //
     /* 314432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314443 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 314448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314452 */     GIR_RootConstrainSelectedInstOperands,
     /* 314453 */     // GIR_Coverage, 1279,
     /* 314453 */     GIR_Done,
     /* 314454 */   // Label 6421: @314454
     /* 314454 */   GIM_Reject,
     /* 314455 */ // Label 6419: @314455
     /* 314455 */ GIM_Reject,
     /* 314456 */ // Label 6401: @314456
     /* 314456 */ GIM_Reject,
     /* 314457 */ // Label 75: @314457
     /* 314457 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6430*/ GIMT_Encode4(315159),
     /* 314468 */ /*GILLT_s16*//*Label 6422*/ GIMT_Encode4(314508),
     /* 314472 */ /*GILLT_s32*//*Label 6423*/ GIMT_Encode4(314546),
     /* 314476 */ /*GILLT_s64*//*Label 6424*/ GIMT_Encode4(314584), GIMT_Encode4(0),
     /* 314484 */ /*GILLT_v2s32*//*Label 6425*/ GIMT_Encode4(314644),
     /* 314488 */ /*GILLT_v2s64*//*Label 6426*/ GIMT_Encode4(314747),
     /* 314492 */ /*GILLT_v4s16*//*Label 6427*/ GIMT_Encode4(314850),
     /* 314496 */ /*GILLT_v4s32*//*Label 6428*/ GIMT_Encode4(314953), GIMT_Encode4(0),
     /* 314504 */ /*GILLT_v8s16*//*Label 6429*/ GIMT_Encode4(315056),
     /* 314508 */ // Label 6422: @314508
     /* 314508 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(314545), // Rule ID 602 //
     /* 314513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 314522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314534 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 314534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 314539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314543 */   GIR_RootConstrainSelectedInstOperands,
     /* 314544 */   // GIR_Coverage, 602,
     /* 314544 */   GIR_Done,
     /* 314545 */ // Label 6431: @314545
     /* 314545 */ GIM_Reject,
     /* 314546 */ // Label 6423: @314546
     /* 314546 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(314583), // Rule ID 604 //
     /* 314551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314572 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 314572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 314577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314581 */   GIR_RootConstrainSelectedInstOperands,
     /* 314582 */   // GIR_Coverage, 604,
     /* 314582 */   GIR_Done,
     /* 314583 */ // Label 6432: @314583
     /* 314583 */ GIM_Reject,
     /* 314584 */ // Label 6424: @314584
     /* 314584 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(314643),
     /* 314589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314607 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(314626), // Rule ID 606 //
     /* 314612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314615 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 314615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314620 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314624 */     GIR_RootConstrainSelectedInstOperands,
     /* 314625 */     // GIR_Coverage, 606,
     /* 314625 */     GIR_Done,
     /* 314626 */   // Label 6434: @314626
     /* 314626 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(314642), // Rule ID 4751 //
     /* 314631 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 314631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314636 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314640 */     GIR_RootConstrainSelectedInstOperands,
     /* 314641 */     // GIR_Coverage, 4751,
     /* 314641 */     GIR_Done,
     /* 314642 */   // Label 6435: @314642
     /* 314642 */   GIM_Reject,
     /* 314643 */ // Label 6433: @314643
     /* 314643 */ GIM_Reject,
     /* 314644 */ // Label 6425: @314644
     /* 314644 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(314746),
     /* 314649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314659 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(314718), // Rule ID 2342 //
     /* 314664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314703 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 314706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314716 */     GIR_RootConstrainSelectedInstOperands,
     /* 314717 */     // GIR_Coverage, 2342,
     /* 314717 */     GIR_EraseRootFromParent_Done,
     /* 314718 */   // Label 6437: @314718
     /* 314718 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(314745), // Rule ID 1251 //
     /* 314723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314734 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 314739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314743 */     GIR_RootConstrainSelectedInstOperands,
     /* 314744 */     // GIR_Coverage, 1251,
     /* 314744 */     GIR_Done,
     /* 314745 */   // Label 6438: @314745
     /* 314745 */   GIM_Reject,
     /* 314746 */ // Label 6436: @314746
     /* 314746 */ GIM_Reject,
     /* 314747 */ // Label 6426: @314747
     /* 314747 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(314849),
     /* 314752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314762 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(314821), // Rule ID 2348 //
     /* 314767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314806 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 314809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314819 */     GIR_RootConstrainSelectedInstOperands,
     /* 314820 */     // GIR_Coverage, 2348,
     /* 314820 */     GIR_EraseRootFromParent_Done,
     /* 314821 */   // Label 6440: @314821
     /* 314821 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(314848), // Rule ID 1255 //
     /* 314826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314837 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 314842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314846 */     GIR_RootConstrainSelectedInstOperands,
     /* 314847 */     // GIR_Coverage, 1255,
     /* 314847 */     GIR_Done,
     /* 314848 */   // Label 6441: @314848
     /* 314848 */   GIM_Reject,
     /* 314849 */ // Label 6439: @314849
     /* 314849 */ GIM_Reject,
     /* 314850 */ // Label 6427: @314850
     /* 314850 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(314952),
     /* 314855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314865 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(314924), // Rule ID 2336 //
     /* 314870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314909 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 314912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314922 */     GIR_RootConstrainSelectedInstOperands,
     /* 314923 */     // GIR_Coverage, 2336,
     /* 314923 */     GIR_EraseRootFromParent_Done,
     /* 314924 */   // Label 6443: @314924
     /* 314924 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(314951), // Rule ID 1247 //
     /* 314929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314940 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 314945 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314949 */     GIR_RootConstrainSelectedInstOperands,
     /* 314950 */     // GIR_Coverage, 1247,
     /* 314950 */     GIR_Done,
     /* 314951 */   // Label 6444: @314951
     /* 314951 */   GIM_Reject,
     /* 314952 */ // Label 6442: @314952
     /* 314952 */ GIM_Reject,
     /* 314953 */ // Label 6428: @314953
     /* 314953 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(315055),
     /* 314958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314968 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(315027), // Rule ID 2345 //
     /* 314973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 315001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315012 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 315012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 315015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315025 */     GIR_RootConstrainSelectedInstOperands,
     /* 315026 */     // GIR_Coverage, 2345,
     /* 315026 */     GIR_EraseRootFromParent_Done,
     /* 315027 */   // Label 6446: @315027
     /* 315027 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(315054), // Rule ID 1253 //
     /* 315032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315043 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 315043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 315048 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315052 */     GIR_RootConstrainSelectedInstOperands,
     /* 315053 */     // GIR_Coverage, 1253,
     /* 315053 */     GIR_Done,
     /* 315054 */   // Label 6447: @315054
     /* 315054 */   GIM_Reject,
     /* 315055 */ // Label 6445: @315055
     /* 315055 */ GIM_Reject,
     /* 315056 */ // Label 6429: @315056
     /* 315056 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(315158),
     /* 315061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315071 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(315130), // Rule ID 2339 //
     /* 315076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 315079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 315087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 315104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315115 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 315115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 315118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315128 */     GIR_RootConstrainSelectedInstOperands,
     /* 315129 */     // GIR_Coverage, 2339,
     /* 315129 */     GIR_EraseRootFromParent_Done,
     /* 315130 */   // Label 6449: @315130
     /* 315130 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(315157), // Rule ID 1249 //
     /* 315135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 315138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315146 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 315146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 315151 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315155 */     GIR_RootConstrainSelectedInstOperands,
     /* 315156 */     // GIR_Coverage, 1249,
     /* 315156 */     GIR_Done,
     /* 315157 */   // Label 6450: @315157
     /* 315157 */   GIM_Reject,
     /* 315158 */ // Label 6448: @315158
     /* 315158 */ GIM_Reject,
     /* 315159 */ // Label 6430: @315159
     /* 315159 */ GIM_Reject,
     /* 315160 */ // Label 76: @315160
     /* 315160 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6459*/ GIMT_Encode4(315563),
     /* 315171 */ /*GILLT_s32*//*Label 6451*/ GIMT_Encode4(315211),
     /* 315175 */ /*GILLT_s64*//*Label 6452*/ GIMT_Encode4(315285), GIMT_Encode4(0),
     /* 315183 */ /*GILLT_v2s32*//*Label 6453*/ GIMT_Encode4(315359), GIMT_Encode4(0),
     /* 315191 */ /*GILLT_v4s16*//*Label 6454*/ GIMT_Encode4(315393),
     /* 315195 */ /*GILLT_v4s32*//*Label 6455*/ GIMT_Encode4(315427),
     /* 315199 */ /*GILLT_v8s8*//*Label 6456*/ GIMT_Encode4(315461),
     /* 315203 */ /*GILLT_v8s16*//*Label 6457*/ GIMT_Encode4(315495),
     /* 315207 */ /*GILLT_v16s8*//*Label 6458*/ GIMT_Encode4(315529),
     /* 315211 */ // Label 6451: @315211
     /* 315211 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(315284),
     /* 315216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315230 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(315264), // Rule ID 2319 //
     /* 315235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 315250 */     // MIs[1] Operand 1
     /* 315250 */     // No operand predicates
     /* 315250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315252 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 315255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315262 */     GIR_RootConstrainSelectedInstOperands,
     /* 315263 */     // GIR_Coverage, 2319,
     /* 315263 */     GIR_EraseRootFromParent_Done,
     /* 315264 */   // Label 6461: @315264
     /* 315264 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(315283), // Rule ID 2318 //
     /* 315269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315276 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 315281 */     GIR_RootConstrainSelectedInstOperands,
     /* 315282 */     // GIR_Coverage, 2318,
     /* 315282 */     GIR_Done,
     /* 315283 */   // Label 6462: @315283
     /* 315283 */   GIM_Reject,
     /* 315284 */ // Label 6460: @315284
     /* 315284 */ GIM_Reject,
     /* 315285 */ // Label 6452: @315285
     /* 315285 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(315358),
     /* 315290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315304 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(315338), // Rule ID 2321 //
     /* 315309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 315324 */     // MIs[1] Operand 1
     /* 315324 */     // No operand predicates
     /* 315324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315326 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 315329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315336 */     GIR_RootConstrainSelectedInstOperands,
     /* 315337 */     // GIR_Coverage, 2321,
     /* 315337 */     GIR_EraseRootFromParent_Done,
     /* 315338 */   // Label 6464: @315338
     /* 315338 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(315357), // Rule ID 2320 //
     /* 315343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315350 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 315355 */     GIR_RootConstrainSelectedInstOperands,
     /* 315356 */     // GIR_Coverage, 2320,
     /* 315356 */     GIR_Done,
     /* 315357 */   // Label 6465: @315357
     /* 315357 */   GIM_Reject,
     /* 315358 */ // Label 6463: @315358
     /* 315358 */ GIM_Reject,
     /* 315359 */ // Label 6453: @315359
     /* 315359 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(315392), // Rule ID 1407 //
     /* 315364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315385 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 315390 */   GIR_RootConstrainSelectedInstOperands,
     /* 315391 */   // GIR_Coverage, 1407,
     /* 315391 */   GIR_Done,
     /* 315392 */ // Label 6466: @315392
     /* 315392 */ GIM_Reject,
     /* 315393 */ // Label 6454: @315393
     /* 315393 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(315426), // Rule ID 1405 //
     /* 315398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315419 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 315424 */   GIR_RootConstrainSelectedInstOperands,
     /* 315425 */   // GIR_Coverage, 1405,
     /* 315425 */   GIR_Done,
     /* 315426 */ // Label 6467: @315426
     /* 315426 */ GIM_Reject,
     /* 315427 */ // Label 6455: @315427
     /* 315427 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(315460), // Rule ID 1408 //
     /* 315432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315453 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 315458 */   GIR_RootConstrainSelectedInstOperands,
     /* 315459 */   // GIR_Coverage, 1408,
     /* 315459 */   GIR_Done,
     /* 315460 */ // Label 6468: @315460
     /* 315460 */ GIM_Reject,
     /* 315461 */ // Label 6456: @315461
     /* 315461 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(315494), // Rule ID 1403 //
     /* 315466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315487 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 315492 */   GIR_RootConstrainSelectedInstOperands,
     /* 315493 */   // GIR_Coverage, 1403,
     /* 315493 */   GIR_Done,
     /* 315494 */ // Label 6469: @315494
     /* 315494 */ GIM_Reject,
     /* 315495 */ // Label 6457: @315495
     /* 315495 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(315528), // Rule ID 1406 //
     /* 315500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315521 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 315526 */   GIR_RootConstrainSelectedInstOperands,
     /* 315527 */   // GIR_Coverage, 1406,
     /* 315527 */   GIR_Done,
     /* 315528 */ // Label 6470: @315528
     /* 315528 */ GIM_Reject,
     /* 315529 */ // Label 6458: @315529
     /* 315529 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(315562), // Rule ID 1404 //
     /* 315534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315555 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 315560 */   GIR_RootConstrainSelectedInstOperands,
     /* 315561 */   // GIR_Coverage, 1404,
     /* 315561 */   GIR_Done,
     /* 315562 */ // Label 6471: @315562
     /* 315562 */ GIM_Reject,
     /* 315563 */ // Label 6459: @315563
     /* 315563 */ GIM_Reject,
     /* 315564 */ // Label 77: @315564
     /* 315564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6480*/ GIMT_Encode4(315967),
     /* 315575 */ /*GILLT_s32*//*Label 6472*/ GIMT_Encode4(315615),
     /* 315579 */ /*GILLT_s64*//*Label 6473*/ GIMT_Encode4(315689), GIMT_Encode4(0),
     /* 315587 */ /*GILLT_v2s32*//*Label 6474*/ GIMT_Encode4(315763), GIMT_Encode4(0),
     /* 315595 */ /*GILLT_v4s16*//*Label 6475*/ GIMT_Encode4(315797),
     /* 315599 */ /*GILLT_v4s32*//*Label 6476*/ GIMT_Encode4(315831),
     /* 315603 */ /*GILLT_v8s8*//*Label 6477*/ GIMT_Encode4(315865),
     /* 315607 */ /*GILLT_v8s16*//*Label 6478*/ GIMT_Encode4(315899),
     /* 315611 */ /*GILLT_v16s8*//*Label 6479*/ GIMT_Encode4(315933),
     /* 315615 */ // Label 6472: @315615
     /* 315615 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(315688),
     /* 315620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315634 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(315668), // Rule ID 2315 //
     /* 315639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 315654 */     // MIs[1] Operand 1
     /* 315654 */     // No operand predicates
     /* 315654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315656 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 315659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315666 */     GIR_RootConstrainSelectedInstOperands,
     /* 315667 */     // GIR_Coverage, 2315,
     /* 315667 */     GIR_EraseRootFromParent_Done,
     /* 315668 */   // Label 6482: @315668
     /* 315668 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(315687), // Rule ID 2314 //
     /* 315673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315680 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 315685 */     GIR_RootConstrainSelectedInstOperands,
     /* 315686 */     // GIR_Coverage, 2314,
     /* 315686 */     GIR_Done,
     /* 315687 */   // Label 6483: @315687
     /* 315687 */   GIM_Reject,
     /* 315688 */ // Label 6481: @315688
     /* 315688 */ GIM_Reject,
     /* 315689 */ // Label 6473: @315689
     /* 315689 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(315762),
     /* 315694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315708 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(315742), // Rule ID 2317 //
     /* 315713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 315728 */     // MIs[1] Operand 1
     /* 315728 */     // No operand predicates
     /* 315728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315730 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 315733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315740 */     GIR_RootConstrainSelectedInstOperands,
     /* 315741 */     // GIR_Coverage, 2317,
     /* 315741 */     GIR_EraseRootFromParent_Done,
     /* 315742 */   // Label 6485: @315742
     /* 315742 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(315761), // Rule ID 2316 //
     /* 315747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315754 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 315759 */     GIR_RootConstrainSelectedInstOperands,
     /* 315760 */     // GIR_Coverage, 2316,
     /* 315760 */     GIR_Done,
     /* 315761 */   // Label 6486: @315761
     /* 315761 */   GIM_Reject,
     /* 315762 */ // Label 6484: @315762
     /* 315762 */ GIM_Reject,
     /* 315763 */ // Label 6474: @315763
     /* 315763 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(315796), // Rule ID 1395 //
     /* 315768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315789 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 315794 */   GIR_RootConstrainSelectedInstOperands,
     /* 315795 */   // GIR_Coverage, 1395,
     /* 315795 */   GIR_Done,
     /* 315796 */ // Label 6487: @315796
     /* 315796 */ GIM_Reject,
     /* 315797 */ // Label 6475: @315797
     /* 315797 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(315830), // Rule ID 1393 //
     /* 315802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315823 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 315828 */   GIR_RootConstrainSelectedInstOperands,
     /* 315829 */   // GIR_Coverage, 1393,
     /* 315829 */   GIR_Done,
     /* 315830 */ // Label 6488: @315830
     /* 315830 */ GIM_Reject,
     /* 315831 */ // Label 6476: @315831
     /* 315831 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(315864), // Rule ID 1396 //
     /* 315836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315857 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 315862 */   GIR_RootConstrainSelectedInstOperands,
     /* 315863 */   // GIR_Coverage, 1396,
     /* 315863 */   GIR_Done,
     /* 315864 */ // Label 6489: @315864
     /* 315864 */ GIM_Reject,
     /* 315865 */ // Label 6477: @315865
     /* 315865 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(315898), // Rule ID 1391 //
     /* 315870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315891 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 315896 */   GIR_RootConstrainSelectedInstOperands,
     /* 315897 */   // GIR_Coverage, 1391,
     /* 315897 */   GIR_Done,
     /* 315898 */ // Label 6490: @315898
     /* 315898 */ GIM_Reject,
     /* 315899 */ // Label 6478: @315899
     /* 315899 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(315932), // Rule ID 1394 //
     /* 315904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315925 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 315930 */   GIR_RootConstrainSelectedInstOperands,
     /* 315931 */   // GIR_Coverage, 1394,
     /* 315931 */   GIR_Done,
     /* 315932 */ // Label 6491: @315932
     /* 315932 */ GIM_Reject,
     /* 315933 */ // Label 6479: @315933
     /* 315933 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(315966), // Rule ID 1392 //
     /* 315938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315959 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 315964 */   GIR_RootConstrainSelectedInstOperands,
     /* 315965 */   // GIR_Coverage, 1392,
     /* 315965 */   GIR_Done,
     /* 315966 */ // Label 6492: @315966
     /* 315966 */ GIM_Reject,
     /* 315967 */ // Label 6480: @315967
     /* 315967 */ GIM_Reject,
     /* 315968 */ // Label 78: @315968
     /* 315968 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6501*/ GIMT_Encode4(316371),
     /* 315979 */ /*GILLT_s32*//*Label 6493*/ GIMT_Encode4(316019),
     /* 315983 */ /*GILLT_s64*//*Label 6494*/ GIMT_Encode4(316093), GIMT_Encode4(0),
     /* 315991 */ /*GILLT_v2s32*//*Label 6495*/ GIMT_Encode4(316167), GIMT_Encode4(0),
     /* 315999 */ /*GILLT_v4s16*//*Label 6496*/ GIMT_Encode4(316201),
     /* 316003 */ /*GILLT_v4s32*//*Label 6497*/ GIMT_Encode4(316235),
     /* 316007 */ /*GILLT_v8s8*//*Label 6498*/ GIMT_Encode4(316269),
     /* 316011 */ /*GILLT_v8s16*//*Label 6499*/ GIMT_Encode4(316303),
     /* 316015 */ /*GILLT_v16s8*//*Label 6500*/ GIMT_Encode4(316337),
     /* 316019 */ // Label 6493: @316019
     /* 316019 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(316092),
     /* 316024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 316030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316038 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(316072), // Rule ID 2327 //
     /* 316043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 316058 */     // MIs[1] Operand 1
     /* 316058 */     // No operand predicates
     /* 316058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316060 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 316060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 316063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316070 */     GIR_RootConstrainSelectedInstOperands,
     /* 316071 */     // GIR_Coverage, 2327,
     /* 316071 */     GIR_EraseRootFromParent_Done,
     /* 316072 */   // Label 6503: @316072
     /* 316072 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(316091), // Rule ID 2326 //
     /* 316077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316084 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 316084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 316089 */     GIR_RootConstrainSelectedInstOperands,
     /* 316090 */     // GIR_Coverage, 2326,
     /* 316090 */     GIR_Done,
     /* 316091 */   // Label 6504: @316091
     /* 316091 */   GIM_Reject,
     /* 316092 */ // Label 6502: @316092
     /* 316092 */ GIM_Reject,
     /* 316093 */ // Label 6494: @316093
     /* 316093 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(316166),
     /* 316098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316112 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(316146), // Rule ID 2329 //
     /* 316117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 316132 */     // MIs[1] Operand 1
     /* 316132 */     // No operand predicates
     /* 316132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316134 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 316134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 316137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316144 */     GIR_RootConstrainSelectedInstOperands,
     /* 316145 */     // GIR_Coverage, 2329,
     /* 316145 */     GIR_EraseRootFromParent_Done,
     /* 316146 */   // Label 6506: @316146
     /* 316146 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(316165), // Rule ID 2328 //
     /* 316151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316158 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 316158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 316163 */     GIR_RootConstrainSelectedInstOperands,
     /* 316164 */     // GIR_Coverage, 2328,
     /* 316164 */     GIR_Done,
     /* 316165 */   // Label 6507: @316165
     /* 316165 */   GIM_Reject,
     /* 316166 */ // Label 6505: @316166
     /* 316166 */ GIM_Reject,
     /* 316167 */ // Label 6495: @316167
     /* 316167 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(316200), // Rule ID 1530 //
     /* 316172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316193 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 316193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 316198 */   GIR_RootConstrainSelectedInstOperands,
     /* 316199 */   // GIR_Coverage, 1530,
     /* 316199 */   GIR_Done,
     /* 316200 */ // Label 6508: @316200
     /* 316200 */ GIM_Reject,
     /* 316201 */ // Label 6496: @316201
     /* 316201 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(316234), // Rule ID 1528 //
     /* 316206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316227 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 316227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 316232 */   GIR_RootConstrainSelectedInstOperands,
     /* 316233 */   // GIR_Coverage, 1528,
     /* 316233 */   GIR_Done,
     /* 316234 */ // Label 6509: @316234
     /* 316234 */ GIM_Reject,
     /* 316235 */ // Label 6497: @316235
     /* 316235 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(316268), // Rule ID 1531 //
     /* 316240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316261 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 316261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 316266 */   GIR_RootConstrainSelectedInstOperands,
     /* 316267 */   // GIR_Coverage, 1531,
     /* 316267 */   GIR_Done,
     /* 316268 */ // Label 6510: @316268
     /* 316268 */ GIM_Reject,
     /* 316269 */ // Label 6498: @316269
     /* 316269 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(316302), // Rule ID 1526 //
     /* 316274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 316283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316295 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 316295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 316300 */   GIR_RootConstrainSelectedInstOperands,
     /* 316301 */   // GIR_Coverage, 1526,
     /* 316301 */   GIR_Done,
     /* 316302 */ // Label 6511: @316302
     /* 316302 */ GIM_Reject,
     /* 316303 */ // Label 6499: @316303
     /* 316303 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(316336), // Rule ID 1529 //
     /* 316308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316329 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 316329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 316334 */   GIR_RootConstrainSelectedInstOperands,
     /* 316335 */   // GIR_Coverage, 1529,
     /* 316335 */   GIR_Done,
     /* 316336 */ // Label 6512: @316336
     /* 316336 */ GIM_Reject,
     /* 316337 */ // Label 6500: @316337
     /* 316337 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(316370), // Rule ID 1527 //
     /* 316342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 316348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 316351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316363 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 316363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 316368 */   GIR_RootConstrainSelectedInstOperands,
     /* 316369 */   // GIR_Coverage, 1527,
     /* 316369 */   GIR_Done,
     /* 316370 */ // Label 6513: @316370
     /* 316370 */ GIM_Reject,
     /* 316371 */ // Label 6501: @316371
     /* 316371 */ GIM_Reject,
     /* 316372 */ // Label 79: @316372
     /* 316372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6522*/ GIMT_Encode4(316775),
     /* 316383 */ /*GILLT_s32*//*Label 6514*/ GIMT_Encode4(316423),
     /* 316387 */ /*GILLT_s64*//*Label 6515*/ GIMT_Encode4(316497), GIMT_Encode4(0),
     /* 316395 */ /*GILLT_v2s32*//*Label 6516*/ GIMT_Encode4(316571), GIMT_Encode4(0),
     /* 316403 */ /*GILLT_v4s16*//*Label 6517*/ GIMT_Encode4(316605),
     /* 316407 */ /*GILLT_v4s32*//*Label 6518*/ GIMT_Encode4(316639),
     /* 316411 */ /*GILLT_v8s8*//*Label 6519*/ GIMT_Encode4(316673),
     /* 316415 */ /*GILLT_v8s16*//*Label 6520*/ GIMT_Encode4(316707),
     /* 316419 */ /*GILLT_v16s8*//*Label 6521*/ GIMT_Encode4(316741),
     /* 316423 */ // Label 6514: @316423
     /* 316423 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(316496),
     /* 316428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 316434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316442 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(316476), // Rule ID 2323 //
     /* 316447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 316462 */     // MIs[1] Operand 1
     /* 316462 */     // No operand predicates
     /* 316462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316464 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 316464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 316467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316474 */     GIR_RootConstrainSelectedInstOperands,
     /* 316475 */     // GIR_Coverage, 2323,
     /* 316475 */     GIR_EraseRootFromParent_Done,
     /* 316476 */   // Label 6524: @316476
     /* 316476 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(316495), // Rule ID 2322 //
     /* 316481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316488 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 316488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 316493 */     GIR_RootConstrainSelectedInstOperands,
     /* 316494 */     // GIR_Coverage, 2322,
     /* 316494 */     GIR_Done,
     /* 316495 */   // Label 6525: @316495
     /* 316495 */   GIM_Reject,
     /* 316496 */ // Label 6523: @316496
     /* 316496 */ GIM_Reject,
     /* 316497 */ // Label 6515: @316497
     /* 316497 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(316570),
     /* 316502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316516 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(316550), // Rule ID 2325 //
     /* 316521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 316536 */     // MIs[1] Operand 1
     /* 316536 */     // No operand predicates
     /* 316536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316538 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 316538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 316541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316548 */     GIR_RootConstrainSelectedInstOperands,
     /* 316549 */     // GIR_Coverage, 2325,
     /* 316549 */     GIR_EraseRootFromParent_Done,
     /* 316550 */   // Label 6527: @316550
     /* 316550 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(316569), // Rule ID 2324 //
     /* 316555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316562 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 316562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 316567 */     GIR_RootConstrainSelectedInstOperands,
     /* 316568 */     // GIR_Coverage, 2324,
     /* 316568 */     GIR_Done,
     /* 316569 */   // Label 6528: @316569
     /* 316569 */   GIM_Reject,
     /* 316570 */ // Label 6526: @316570
     /* 316570 */ GIM_Reject,
     /* 316571 */ // Label 6516: @316571
     /* 316571 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(316604), // Rule ID 1518 //
     /* 316576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316597 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 316597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 316602 */   GIR_RootConstrainSelectedInstOperands,
     /* 316603 */   // GIR_Coverage, 1518,
     /* 316603 */   GIR_Done,
     /* 316604 */ // Label 6529: @316604
     /* 316604 */ GIM_Reject,
     /* 316605 */ // Label 6517: @316605
     /* 316605 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(316638), // Rule ID 1516 //
     /* 316610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316631 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 316631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 316636 */   GIR_RootConstrainSelectedInstOperands,
     /* 316637 */   // GIR_Coverage, 1516,
     /* 316637 */   GIR_Done,
     /* 316638 */ // Label 6530: @316638
     /* 316638 */ GIM_Reject,
     /* 316639 */ // Label 6518: @316639
     /* 316639 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(316672), // Rule ID 1519 //
     /* 316644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316665 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 316665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 316670 */   GIR_RootConstrainSelectedInstOperands,
     /* 316671 */   // GIR_Coverage, 1519,
     /* 316671 */   GIR_Done,
     /* 316672 */ // Label 6531: @316672
     /* 316672 */ GIM_Reject,
     /* 316673 */ // Label 6519: @316673
     /* 316673 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(316706), // Rule ID 1514 //
     /* 316678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 316687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316699 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 316699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 316704 */   GIR_RootConstrainSelectedInstOperands,
     /* 316705 */   // GIR_Coverage, 1514,
     /* 316705 */   GIR_Done,
     /* 316706 */ // Label 6532: @316706
     /* 316706 */ GIM_Reject,
     /* 316707 */ // Label 6520: @316707
     /* 316707 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(316740), // Rule ID 1517 //
     /* 316712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316733 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 316733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 316738 */   GIR_RootConstrainSelectedInstOperands,
     /* 316739 */   // GIR_Coverage, 1517,
     /* 316739 */   GIR_Done,
     /* 316740 */ // Label 6533: @316740
     /* 316740 */ GIM_Reject,
     /* 316741 */ // Label 6521: @316741
     /* 316741 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(316774), // Rule ID 1515 //
     /* 316746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 316752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 316755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316767 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 316767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 316772 */   GIR_RootConstrainSelectedInstOperands,
     /* 316773 */   // GIR_Coverage, 1515,
     /* 316773 */   GIR_Done,
     /* 316774 */ // Label 6534: @316774
     /* 316774 */ GIM_Reject,
     /* 316775 */ // Label 6522: @316775
     /* 316775 */ GIM_Reject,
     /* 316776 */ // Label 80: @316776
     /* 316776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6544*/ GIMT_Encode4(317590),
     /* 316787 */ /*GILLT_s32*//*Label 6535*/ GIMT_Encode4(316827),
     /* 316791 */ /*GILLT_s64*//*Label 6536*/ GIMT_Encode4(316854), GIMT_Encode4(0),
     /* 316799 */ /*GILLT_v2s32*//*Label 6537*/ GIMT_Encode4(316933),
     /* 316803 */ /*GILLT_v2s64*//*Label 6538*/ GIMT_Encode4(316960),
     /* 316807 */ /*GILLT_v4s16*//*Label 6539*/ GIMT_Encode4(317143),
     /* 316811 */ /*GILLT_v4s32*//*Label 6540*/ GIMT_Encode4(317170),
     /* 316815 */ /*GILLT_v8s8*//*Label 6541*/ GIMT_Encode4(317353),
     /* 316819 */ /*GILLT_v8s16*//*Label 6542*/ GIMT_Encode4(317380),
     /* 316823 */ /*GILLT_v16s8*//*Label 6543*/ GIMT_Encode4(317563),
     /* 316827 */ // Label 6535: @316827
     /* 316827 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(316853), // Rule ID 2308 //
     /* 316832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316846 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 316846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 316851 */   GIR_RootConstrainSelectedInstOperands,
     /* 316852 */   // GIR_Coverage, 2308,
     /* 316852 */   GIR_Done,
     /* 316853 */ // Label 6545: @316853
     /* 316853 */ GIM_Reject,
     /* 316854 */ // Label 6536: @316854
     /* 316854 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(316932),
     /* 316859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316862 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(316885), // Rule ID 1645 //
     /* 316867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316878 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 316878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316883 */     GIR_RootConstrainSelectedInstOperands,
     /* 316884 */     // GIR_Coverage, 1645,
     /* 316884 */     GIR_Done,
     /* 316885 */   // Label 6547: @316885
     /* 316885 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(316908), // Rule ID 2309 //
     /* 316890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316901 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 316901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 316906 */     GIR_RootConstrainSelectedInstOperands,
     /* 316907 */     // GIR_Coverage, 2309,
     /* 316907 */     GIR_Done,
     /* 316908 */   // Label 6548: @316908
     /* 316908 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(316931), // Rule ID 2505 //
     /* 316913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 316916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316924 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 316924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316929 */     GIR_RootConstrainSelectedInstOperands,
     /* 316930 */     // GIR_Coverage, 2505,
     /* 316930 */     GIR_Done,
     /* 316931 */   // Label 6549: @316931
     /* 316931 */   GIM_Reject,
     /* 316932 */ // Label 6546: @316932
     /* 316932 */ GIM_Reject,
     /* 316933 */ // Label 6537: @316933
     /* 316933 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(316959), // Rule ID 707 //
     /* 316938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316952 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 316952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 316957 */   GIR_RootConstrainSelectedInstOperands,
     /* 316958 */   // GIR_Coverage, 707,
     /* 316958 */   GIR_Done,
     /* 316959 */ // Label 6550: @316959
     /* 316959 */ GIM_Reject,
     /* 316960 */ // Label 6538: @316960
     /* 316960 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(317142),
     /* 316965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316972 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(317050), // Rule ID 4829 //
     /* 316977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 317026 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 317033 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 317033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 317036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 317043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 317048 */     GIR_RootConstrainSelectedInstOperands,
     /* 317049 */     // GIR_Coverage, 4829,
     /* 317049 */     GIR_EraseRootFromParent_Done,
     /* 317050 */   // Label 6552: @317050
     /* 317050 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(317122), // Rule ID 4828 //
     /* 317055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 317071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317100 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317107 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 317107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 317110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 317116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 317120 */     GIR_RootConstrainSelectedInstOperands,
     /* 317121 */     // GIR_Coverage, 4828,
     /* 317121 */     GIR_EraseRootFromParent_Done,
     /* 317122 */   // Label 6553: @317122
     /* 317122 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(317141), // Rule ID 709 //
     /* 317127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317134 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 317134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 317139 */     GIR_RootConstrainSelectedInstOperands,
     /* 317140 */     // GIR_Coverage, 709,
     /* 317140 */     GIR_Done,
     /* 317141 */   // Label 6554: @317141
     /* 317141 */   GIM_Reject,
     /* 317142 */ // Label 6551: @317142
     /* 317142 */ GIM_Reject,
     /* 317143 */ // Label 6539: @317143
     /* 317143 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(317169), // Rule ID 705 //
     /* 317148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317162 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 317162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 317167 */   GIR_RootConstrainSelectedInstOperands,
     /* 317168 */   // GIR_Coverage, 705,
     /* 317168 */   GIR_Done,
     /* 317169 */ // Label 6555: @317169
     /* 317169 */ GIM_Reject,
     /* 317170 */ // Label 6540: @317170
     /* 317170 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(317352),
     /* 317175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317182 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(317260), // Rule ID 4827 //
     /* 317187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 317203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317223 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 317236 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 317243 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 317243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 317246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 317253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 317258 */     GIR_RootConstrainSelectedInstOperands,
     /* 317259 */     // GIR_Coverage, 4827,
     /* 317259 */     GIR_EraseRootFromParent_Done,
     /* 317260 */   // Label 6557: @317260
     /* 317260 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(317332), // Rule ID 4826 //
     /* 317265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 317281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317317 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 317317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 317320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 317326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 317330 */     GIR_RootConstrainSelectedInstOperands,
     /* 317331 */     // GIR_Coverage, 4826,
     /* 317331 */     GIR_EraseRootFromParent_Done,
     /* 317332 */   // Label 6558: @317332
     /* 317332 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(317351), // Rule ID 708 //
     /* 317337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317344 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 317344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 317349 */     GIR_RootConstrainSelectedInstOperands,
     /* 317350 */     // GIR_Coverage, 708,
     /* 317350 */     GIR_Done,
     /* 317351 */   // Label 6559: @317351
     /* 317351 */   GIM_Reject,
     /* 317352 */ // Label 6556: @317352
     /* 317352 */ GIM_Reject,
     /* 317353 */ // Label 6541: @317353
     /* 317353 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(317379), // Rule ID 703 //
     /* 317358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317372 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 317372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 317377 */   GIR_RootConstrainSelectedInstOperands,
     /* 317378 */   // GIR_Coverage, 703,
     /* 317378 */   GIR_Done,
     /* 317379 */ // Label 6560: @317379
     /* 317379 */ GIM_Reject,
     /* 317380 */ // Label 6542: @317380
     /* 317380 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(317562),
     /* 317385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317392 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(317470), // Rule ID 4825 //
     /* 317397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317446 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317453 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 317453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 317456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 317463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 317468 */     GIR_RootConstrainSelectedInstOperands,
     /* 317469 */     // GIR_Coverage, 4825,
     /* 317469 */     GIR_EraseRootFromParent_Done,
     /* 317470 */   // Label 6562: @317470
     /* 317470 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(317542), // Rule ID 4824 //
     /* 317475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317520 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317527 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 317527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 317530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 317536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 317540 */     GIR_RootConstrainSelectedInstOperands,
     /* 317541 */     // GIR_Coverage, 4824,
     /* 317541 */     GIR_EraseRootFromParent_Done,
     /* 317542 */   // Label 6563: @317542
     /* 317542 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(317561), // Rule ID 706 //
     /* 317547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317554 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 317554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 317559 */     GIR_RootConstrainSelectedInstOperands,
     /* 317560 */     // GIR_Coverage, 706,
     /* 317560 */     GIR_Done,
     /* 317561 */   // Label 6564: @317561
     /* 317561 */   GIM_Reject,
     /* 317562 */ // Label 6561: @317562
     /* 317562 */ GIM_Reject,
     /* 317563 */ // Label 6543: @317563
     /* 317563 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(317589), // Rule ID 704 //
     /* 317568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 317574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317582 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 317582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 317587 */   GIR_RootConstrainSelectedInstOperands,
     /* 317588 */   // GIR_Coverage, 704,
     /* 317588 */   GIR_Done,
     /* 317589 */ // Label 6565: @317589
     /* 317589 */ GIM_Reject,
     /* 317590 */ // Label 6544: @317590
     /* 317590 */ GIM_Reject,
     /* 317591 */ // Label 81: @317591
     /* 317591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6568*/ GIMT_Encode4(317756),
     /* 317602 */ /*GILLT_s32*//*Label 6566*/ GIMT_Encode4(317610),
     /* 317606 */ /*GILLT_s64*//*Label 6567*/ GIMT_Encode4(317683),
     /* 317610 */ // Label 6566: @317610
     /* 317610 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(317636), // Rule ID 4670 //
     /* 317615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317625 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 317625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 317630 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317634 */   GIR_RootConstrainSelectedInstOperands,
     /* 317635 */   // GIR_Coverage, 4670,
     /* 317635 */   GIR_Done,
     /* 317636 */ // Label 6569: @317636
     /* 317636 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(317659), // Rule ID 4676 //
     /* 317641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317648 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 317648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 317653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317657 */   GIR_RootConstrainSelectedInstOperands,
     /* 317658 */   // GIR_Coverage, 4676,
     /* 317658 */   GIR_Done,
     /* 317659 */ // Label 6570: @317659
     /* 317659 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(317682), // Rule ID 4678 //
     /* 317664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317671 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 317671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 317676 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317680 */   GIR_RootConstrainSelectedInstOperands,
     /* 317681 */   // GIR_Coverage, 4678,
     /* 317681 */   GIR_Done,
     /* 317682 */ // Label 6571: @317682
     /* 317682 */ GIM_Reject,
     /* 317683 */ // Label 6567: @317683
     /* 317683 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(317709), // Rule ID 4672 //
     /* 317688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317698 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317707 */   GIR_RootConstrainSelectedInstOperands,
     /* 317708 */   // GIR_Coverage, 4672,
     /* 317708 */   GIR_Done,
     /* 317709 */ // Label 6572: @317709
     /* 317709 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(317732), // Rule ID 4680 //
     /* 317714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317721 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317726 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317730 */   GIR_RootConstrainSelectedInstOperands,
     /* 317731 */   // GIR_Coverage, 4680,
     /* 317731 */   GIR_Done,
     /* 317732 */ // Label 6573: @317732
     /* 317732 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(317755), // Rule ID 4682 //
     /* 317737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317744 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317749 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317753 */   GIR_RootConstrainSelectedInstOperands,
     /* 317754 */   // GIR_Coverage, 4682,
     /* 317754 */   GIR_Done,
     /* 317755 */ // Label 6574: @317755
     /* 317755 */ GIM_Reject,
     /* 317756 */ // Label 6568: @317756
     /* 317756 */ GIM_Reject,
     /* 317757 */ // Label 82: @317757
     /* 317757 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(317855),
     /* 317762 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 317765 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6579*/ GIMT_Encode4(317854),
     /* 317776 */   /*GILLT_s16*//*Label 6576*/ GIMT_Encode4(317788),
     /* 317780 */   /*GILLT_s32*//*Label 6577*/ GIMT_Encode4(317812),
     /* 317784 */   /*GILLT_s64*//*Label 6578*/ GIMT_Encode4(317833),
     /* 317788 */   // Label 6576: @317788
     /* 317788 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(317811), // Rule ID 4674 //
     /* 317793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317800 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317805 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317809 */     GIR_RootConstrainSelectedInstOperands,
     /* 317810 */     // GIR_Coverage, 4674,
     /* 317810 */     GIR_Done,
     /* 317811 */   // Label 6580: @317811
     /* 317811 */   GIM_Reject,
     /* 317812 */   // Label 6577: @317812
     /* 317812 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(317832), // Rule ID 4684 //
     /* 317817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317821 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317830 */     GIR_RootConstrainSelectedInstOperands,
     /* 317831 */     // GIR_Coverage, 4684,
     /* 317831 */     GIR_Done,
     /* 317832 */   // Label 6581: @317832
     /* 317832 */   GIM_Reject,
     /* 317833 */   // Label 6578: @317833
     /* 317833 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(317853), // Rule ID 4686 //
     /* 317838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317842 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317851 */     GIR_RootConstrainSelectedInstOperands,
     /* 317852 */     // GIR_Coverage, 4686,
     /* 317852 */     GIR_Done,
     /* 317853 */   // Label 6582: @317853
     /* 317853 */   GIM_Reject,
     /* 317854 */   // Label 6579: @317854
     /* 317854 */   GIM_Reject,
     /* 317855 */ // Label 6575: @317855
     /* 317855 */ GIM_Reject,
     /* 317856 */ // Label 83: @317856
     /* 317856 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(317871), // Rule ID 225 //
     /* 317861 */   // MIs[0] addr
     /* 317861 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 317864 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 317864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 317869 */   GIR_RootConstrainSelectedInstOperands,
     /* 317870 */   // GIR_Coverage, 225,
     /* 317870 */   GIR_Done,
     /* 317871 */ // Label 6583: @317871
     /* 317871 */ GIM_Reject,
     /* 317872 */ // Label 84: @317872
     /* 317872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6595*/ GIMT_Encode4(322883),
     /* 317883 */ /*GILLT_s64*//*Label 6584*/ GIMT_Encode4(317955), GIMT_Encode4(0),
     /* 317891 */ /*GILLT_v2s32*//*Label 6585*/ GIMT_Encode4(318237), GIMT_Encode4(0),
     /* 317899 */ /*GILLT_v4s16*//*Label 6586*/ GIMT_Encode4(318519), GIMT_Encode4(0),
     /* 317907 */ /*GILLT_v8s8*//*Label 6587*/ GIMT_Encode4(318801), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 317919 */ /*GILLT_nxv1s1*//*Label 6588*/ GIMT_Encode4(318981),
     /* 317923 */ /*GILLT_nxv2s1*//*Label 6589*/ GIMT_Encode4(321244),
     /* 317927 */ /*GILLT_nxv2s16*//*Label 6590*/ GIMT_Encode4(322099),
     /* 317931 */ /*GILLT_nxv2s32*//*Label 6591*/ GIMT_Encode4(322386), GIMT_Encode4(0),
     /* 317939 */ /*GILLT_nxv4s1*//*Label 6592*/ GIMT_Encode4(322456),
     /* 317943 */ /*GILLT_nxv4s16*//*Label 6593*/ GIMT_Encode4(322743), GIMT_Encode4(0),
     /* 317951 */ /*GILLT_nxv8s1*//*Label 6594*/ GIMT_Encode4(322813),
     /* 317955 */ // Label 6584: @317955
     /* 317955 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(318236),
     /* 317960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317971 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(318035), // Rule ID 5395 //
     /* 317976 */     // MIs[0] Operand 2
     /* 317976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317987 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318017 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318034 */     // GIR_Coverage, 5395,
     /* 318034 */     GIR_EraseRootFromParent_Done,
     /* 318035 */   // Label 6597: @318035
     /* 318035 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(318099), // Rule ID 5400 //
     /* 318040 */     // MIs[0] Operand 2
     /* 318040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318051 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318071 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318081 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318098 */     // GIR_Coverage, 5400,
     /* 318098 */     GIR_EraseRootFromParent_Done,
     /* 318099 */   // Label 6598: @318099
     /* 318099 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(318137), // Rule ID 6799 //
     /* 318104 */     // MIs[0] Operand 2
     /* 318104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318115 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 318115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318120 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318136 */     // GIR_Coverage, 6799,
     /* 318136 */     GIR_EraseRootFromParent_Done,
     /* 318137 */   // Label 6599: @318137
     /* 318137 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(318175), // Rule ID 6800 //
     /* 318142 */     // MIs[0] Operand 2
     /* 318142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318153 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 318153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318158 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318174 */     // GIR_Coverage, 6800,
     /* 318174 */     GIR_EraseRootFromParent_Done,
     /* 318175 */   // Label 6600: @318175
     /* 318175 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(318235), // Rule ID 6804 //
     /* 318180 */     // MIs[0] Operand 2
     /* 318180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318191 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318234 */     // GIR_Coverage, 6804,
     /* 318234 */     GIR_EraseRootFromParent_Done,
     /* 318235 */   // Label 6601: @318235
     /* 318235 */   GIM_Reject,
     /* 318236 */ // Label 6596: @318236
     /* 318236 */ GIM_Reject,
     /* 318237 */ // Label 6585: @318237
     /* 318237 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(318518),
     /* 318242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318253 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(318317), // Rule ID 5385 //
     /* 318258 */     // MIs[0] Operand 2
     /* 318258 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 318269 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318299 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318316 */     // GIR_Coverage, 5385,
     /* 318316 */     GIR_EraseRootFromParent_Done,
     /* 318317 */   // Label 6603: @318317
     /* 318317 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(318381), // Rule ID 5390 //
     /* 318322 */     // MIs[0] Operand 2
     /* 318322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 318333 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318363 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318380 */     // GIR_Coverage, 5390,
     /* 318380 */     GIR_EraseRootFromParent_Done,
     /* 318381 */   // Label 6604: @318381
     /* 318381 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(318419), // Rule ID 6796 //
     /* 318386 */     // MIs[0] Operand 2
     /* 318386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318397 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 318397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318402 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318418 */     // GIR_Coverage, 6796,
     /* 318418 */     GIR_EraseRootFromParent_Done,
     /* 318419 */   // Label 6605: @318419
     /* 318419 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(318457), // Rule ID 6798 //
     /* 318424 */     // MIs[0] Operand 2
     /* 318424 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318435 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 318435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318440 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318456 */     // GIR_Coverage, 6798,
     /* 318456 */     GIR_EraseRootFromParent_Done,
     /* 318457 */   // Label 6606: @318457
     /* 318457 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(318517), // Rule ID 6803 //
     /* 318462 */     // MIs[0] Operand 2
     /* 318462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318473 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318516 */     // GIR_Coverage, 6803,
     /* 318516 */     GIR_EraseRootFromParent_Done,
     /* 318517 */   // Label 6607: @318517
     /* 318517 */   GIM_Reject,
     /* 318518 */ // Label 6602: @318518
     /* 318518 */ GIM_Reject,
     /* 318519 */ // Label 6586: @318519
     /* 318519 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(318800),
     /* 318524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318535 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(318599), // Rule ID 5375 //
     /* 318540 */     // MIs[0] Operand 2
     /* 318540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318551 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318598 */     // GIR_Coverage, 5375,
     /* 318598 */     GIR_EraseRootFromParent_Done,
     /* 318599 */   // Label 6609: @318599
     /* 318599 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(318663), // Rule ID 5380 //
     /* 318604 */     // MIs[0] Operand 2
     /* 318604 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318615 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318645 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318662 */     // GIR_Coverage, 5380,
     /* 318662 */     GIR_EraseRootFromParent_Done,
     /* 318663 */   // Label 6610: @318663
     /* 318663 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(318701), // Rule ID 6794 //
     /* 318668 */     // MIs[0] Operand 2
     /* 318668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318679 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 318679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318684 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318700 */     // GIR_Coverage, 6794,
     /* 318700 */     GIR_EraseRootFromParent_Done,
     /* 318701 */   // Label 6611: @318701
     /* 318701 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(318739), // Rule ID 6797 //
     /* 318706 */     // MIs[0] Operand 2
     /* 318706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318717 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 318717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318722 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318738 */     // GIR_Coverage, 6797,
     /* 318738 */     GIR_EraseRootFromParent_Done,
     /* 318739 */   // Label 6612: @318739
     /* 318739 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(318799), // Rule ID 6802 //
     /* 318744 */     // MIs[0] Operand 2
     /* 318744 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318755 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318771 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318798 */     // GIR_Coverage, 6802,
     /* 318798 */     GIR_EraseRootFromParent_Done,
     /* 318799 */   // Label 6613: @318799
     /* 318799 */   GIM_Reject,
     /* 318800 */ // Label 6608: @318800
     /* 318800 */ GIM_Reject,
     /* 318801 */ // Label 6587: @318801
     /* 318801 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(318980),
     /* 318806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 318809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318817 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(318881), // Rule ID 5370 //
     /* 318822 */     // MIs[0] Operand 2
     /* 318822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 318833 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318880 */     // GIR_Coverage, 5370,
     /* 318880 */     GIR_EraseRootFromParent_Done,
     /* 318881 */   // Label 6615: @318881
     /* 318881 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(318919), // Rule ID 6795 //
     /* 318886 */     // MIs[0] Operand 2
     /* 318886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318897 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 318897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318902 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318918 */     // GIR_Coverage, 6795,
     /* 318918 */     GIR_EraseRootFromParent_Done,
     /* 318919 */   // Label 6616: @318919
     /* 318919 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(318979), // Rule ID 6801 //
     /* 318924 */     // MIs[0] Operand 2
     /* 318924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318935 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318978 */     // GIR_Coverage, 6801,
     /* 318978 */     GIR_EraseRootFromParent_Done,
     /* 318979 */   // Label 6617: @318979
     /* 318979 */   GIM_Reject,
     /* 318980 */ // Label 6614: @318980
     /* 318980 */ GIM_Reject,
     /* 318981 */ // Label 6588: @318981
     /* 318981 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(319016), // Rule ID 8817 //
     /* 318986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 318992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318996 */   // MIs[0] Operand 2
     /* 318996 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319007 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 319007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319012 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 319014 */   GIR_RootConstrainSelectedInstOperands,
     /* 319015 */   // GIR_Coverage, 8817,
     /* 319015 */   GIR_EraseRootFromParent_Done,
     /* 319016 */ // Label 6618: @319016
     /* 319016 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(319051), // Rule ID 8818 //
     /* 319021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 319027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319031 */   // MIs[0] Operand 2
     /* 319031 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319042 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 319042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319047 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 319049 */   GIR_RootConstrainSelectedInstOperands,
     /* 319050 */   // GIR_Coverage, 8818,
     /* 319050 */   GIR_EraseRootFromParent_Done,
     /* 319051 */ // Label 6619: @319051
     /* 319051 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(319105), // Rule ID 8825 //
     /* 319056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 319062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319066 */   // MIs[0] Operand 2
     /* 319066 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319077 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 319077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319103 */   GIR_RootConstrainSelectedInstOperands,
     /* 319104 */   // GIR_Coverage, 8825,
     /* 319104 */   GIR_EraseRootFromParent_Done,
     /* 319105 */ // Label 6620: @319105
     /* 319105 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(319159), // Rule ID 8826 //
     /* 319110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 319116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319120 */   // MIs[0] Operand 2
     /* 319120 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319131 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 319131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319143 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319157 */   GIR_RootConstrainSelectedInstOperands,
     /* 319158 */   // GIR_Coverage, 8826,
     /* 319158 */   GIR_EraseRootFromParent_Done,
     /* 319159 */ // Label 6621: @319159
     /* 319159 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(319213), // Rule ID 8827 //
     /* 319164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 319170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319174 */   // MIs[0] Operand 2
     /* 319174 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 319185 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 319185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319197 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319211 */   GIR_RootConstrainSelectedInstOperands,
     /* 319212 */   // GIR_Coverage, 8827,
     /* 319212 */   GIR_EraseRootFromParent_Done,
     /* 319213 */ // Label 6622: @319213
     /* 319213 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(319267), // Rule ID 8828 //
     /* 319218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 319224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319228 */   // MIs[0] Operand 2
     /* 319228 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319239 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 319239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319265 */   GIR_RootConstrainSelectedInstOperands,
     /* 319266 */   // GIR_Coverage, 8828,
     /* 319266 */   GIR_EraseRootFromParent_Done,
     /* 319267 */ // Label 6623: @319267
     /* 319267 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(319338), // Rule ID 8837 //
     /* 319272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319282 */   // MIs[0] Operand 2
     /* 319282 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319293 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319293 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319296 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319300 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319305 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319323 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319336 */   GIR_RootConstrainSelectedInstOperands,
     /* 319337 */   // GIR_Coverage, 8837,
     /* 319337 */   GIR_EraseRootFromParent_Done,
     /* 319338 */ // Label 6624: @319338
     /* 319338 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(319409), // Rule ID 8838 //
     /* 319343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319353 */   // MIs[0] Operand 2
     /* 319353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319364 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319364 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319367 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319371 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319376 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319394 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319407 */   GIR_RootConstrainSelectedInstOperands,
     /* 319408 */   // GIR_Coverage, 8838,
     /* 319408 */   GIR_EraseRootFromParent_Done,
     /* 319409 */ // Label 6625: @319409
     /* 319409 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(319480), // Rule ID 8839 //
     /* 319414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319424 */   // MIs[0] Operand 2
     /* 319424 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 319435 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319447 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319478 */   GIR_RootConstrainSelectedInstOperands,
     /* 319479 */   // GIR_Coverage, 8839,
     /* 319479 */   GIR_EraseRootFromParent_Done,
     /* 319480 */ // Label 6626: @319480
     /* 319480 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(319551), // Rule ID 8840 //
     /* 319485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319495 */   // MIs[0] Operand 2
     /* 319495 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319506 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319506 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319509 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319513 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319518 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319549 */   GIR_RootConstrainSelectedInstOperands,
     /* 319550 */   // GIR_Coverage, 8840,
     /* 319550 */   GIR_EraseRootFromParent_Done,
     /* 319551 */ // Label 6627: @319551
     /* 319551 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(319622), // Rule ID 8841 //
     /* 319556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319566 */   // MIs[0] Operand 2
     /* 319566 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 319577 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319577 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319580 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319584 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319589 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319620 */   GIR_RootConstrainSelectedInstOperands,
     /* 319621 */   // GIR_Coverage, 8841,
     /* 319621 */   GIR_EraseRootFromParent_Done,
     /* 319622 */ // Label 6628: @319622
     /* 319622 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(319693), // Rule ID 8842 //
     /* 319627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319637 */   // MIs[0] Operand 2
     /* 319637 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 319648 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319648 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319651 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319655 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319660 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319678 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319691 */   GIR_RootConstrainSelectedInstOperands,
     /* 319692 */   // GIR_Coverage, 8842,
     /* 319692 */   GIR_EraseRootFromParent_Done,
     /* 319693 */ // Label 6629: @319693
     /* 319693 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(319764), // Rule ID 8843 //
     /* 319698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319708 */   // MIs[0] Operand 2
     /* 319708 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 319719 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319731 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319762 */   GIR_RootConstrainSelectedInstOperands,
     /* 319763 */   // GIR_Coverage, 8843,
     /* 319763 */   GIR_EraseRootFromParent_Done,
     /* 319764 */ // Label 6630: @319764
     /* 319764 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(319835), // Rule ID 8844 //
     /* 319769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319779 */   // MIs[0] Operand 2
     /* 319779 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 319790 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319802 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319820 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319833 */   GIR_RootConstrainSelectedInstOperands,
     /* 319834 */   // GIR_Coverage, 8844,
     /* 319834 */   GIR_EraseRootFromParent_Done,
     /* 319835 */ // Label 6631: @319835
     /* 319835 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(319923), // Rule ID 8853 //
     /* 319840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319850 */   // MIs[0] Operand 2
     /* 319850 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319861 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319861 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319864 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319868 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319873 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319891 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319908 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319921 */   GIR_RootConstrainSelectedInstOperands,
     /* 319922 */   // GIR_Coverage, 8853,
     /* 319922 */   GIR_EraseRootFromParent_Done,
     /* 319923 */ // Label 6632: @319923
     /* 319923 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(320011), // Rule ID 8854 //
     /* 319928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319938 */   // MIs[0] Operand 2
     /* 319938 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319949 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319949 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319952 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319956 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319961 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319967 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319970 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319974 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319979 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319996 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320009 */   GIR_RootConstrainSelectedInstOperands,
     /* 320010 */   // GIR_Coverage, 8854,
     /* 320010 */   GIR_EraseRootFromParent_Done,
     /* 320011 */ // Label 6633: @320011
     /* 320011 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(320099), // Rule ID 8855 //
     /* 320016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320026 */   // MIs[0] Operand 2
     /* 320026 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320037 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320037 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320040 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320044 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320049 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320055 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320058 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320062 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320067 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320084 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320097 */   GIR_RootConstrainSelectedInstOperands,
     /* 320098 */   // GIR_Coverage, 8855,
     /* 320098 */   GIR_EraseRootFromParent_Done,
     /* 320099 */ // Label 6634: @320099
     /* 320099 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(320187), // Rule ID 8856 //
     /* 320104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320114 */   // MIs[0] Operand 2
     /* 320114 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 320125 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320125 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320128 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320132 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320137 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320143 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320146 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320150 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320155 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320172 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320185 */   GIR_RootConstrainSelectedInstOperands,
     /* 320186 */   // GIR_Coverage, 8856,
     /* 320186 */   GIR_EraseRootFromParent_Done,
     /* 320187 */ // Label 6635: @320187
     /* 320187 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(320275), // Rule ID 8857 //
     /* 320192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320202 */   // MIs[0] Operand 2
     /* 320202 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 320213 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320213 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320216 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320220 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320225 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320231 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320234 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320238 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320243 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320273 */   GIR_RootConstrainSelectedInstOperands,
     /* 320274 */   // GIR_Coverage, 8857,
     /* 320274 */   GIR_EraseRootFromParent_Done,
     /* 320275 */ // Label 6636: @320275
     /* 320275 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(320363), // Rule ID 8858 //
     /* 320280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320290 */   // MIs[0] Operand 2
     /* 320290 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 320301 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320313 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320331 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320361 */   GIR_RootConstrainSelectedInstOperands,
     /* 320362 */   // GIR_Coverage, 8858,
     /* 320362 */   GIR_EraseRootFromParent_Done,
     /* 320363 */ // Label 6637: @320363
     /* 320363 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(320451), // Rule ID 8859 //
     /* 320368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320378 */   // MIs[0] Operand 2
     /* 320378 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 320389 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320389 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320392 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320396 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320401 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320419 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320436 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320449 */   GIR_RootConstrainSelectedInstOperands,
     /* 320450 */   // GIR_Coverage, 8859,
     /* 320450 */   GIR_EraseRootFromParent_Done,
     /* 320451 */ // Label 6638: @320451
     /* 320451 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(320539), // Rule ID 8860 //
     /* 320456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320466 */   // MIs[0] Operand 2
     /* 320466 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 320477 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320477 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320480 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320484 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320489 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320495 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320498 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320502 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320507 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320537 */   GIR_RootConstrainSelectedInstOperands,
     /* 320538 */   // GIR_Coverage, 8860,
     /* 320538 */   GIR_EraseRootFromParent_Done,
     /* 320539 */ // Label 6639: @320539
     /* 320539 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(320627), // Rule ID 8861 //
     /* 320544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320554 */   // MIs[0] Operand 2
     /* 320554 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 320565 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320565 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320568 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320572 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320577 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320583 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320586 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320590 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320595 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320612 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320625 */   GIR_RootConstrainSelectedInstOperands,
     /* 320626 */   // GIR_Coverage, 8861,
     /* 320626 */   GIR_EraseRootFromParent_Done,
     /* 320627 */ // Label 6640: @320627
     /* 320627 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(320715), // Rule ID 8862 //
     /* 320632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320642 */   // MIs[0] Operand 2
     /* 320642 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 320653 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320653 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320656 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320660 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320665 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320683 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320700 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320713 */   GIR_RootConstrainSelectedInstOperands,
     /* 320714 */   // GIR_Coverage, 8862,
     /* 320714 */   GIR_EraseRootFromParent_Done,
     /* 320715 */ // Label 6641: @320715
     /* 320715 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(320803), // Rule ID 8863 //
     /* 320720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320730 */   // MIs[0] Operand 2
     /* 320730 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 320741 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320741 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320744 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320748 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320753 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320759 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320762 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320766 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320771 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320801 */   GIR_RootConstrainSelectedInstOperands,
     /* 320802 */   // GIR_Coverage, 8863,
     /* 320802 */   GIR_EraseRootFromParent_Done,
     /* 320803 */ // Label 6642: @320803
     /* 320803 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(320891), // Rule ID 8864 //
     /* 320808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320818 */   // MIs[0] Operand 2
     /* 320818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 320829 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320829 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320832 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320836 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320841 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320859 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320876 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320889 */   GIR_RootConstrainSelectedInstOperands,
     /* 320890 */   // GIR_Coverage, 8864,
     /* 320890 */   GIR_EraseRootFromParent_Done,
     /* 320891 */ // Label 6643: @320891
     /* 320891 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(320979), // Rule ID 8865 //
     /* 320896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320906 */   // MIs[0] Operand 2
     /* 320906 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 320917 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320917 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320920 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320924 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320929 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320935 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320938 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320942 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320947 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320964 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320977 */   GIR_RootConstrainSelectedInstOperands,
     /* 320978 */   // GIR_Coverage, 8865,
     /* 320978 */   GIR_EraseRootFromParent_Done,
     /* 320979 */ // Label 6644: @320979
     /* 320979 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(321067), // Rule ID 8866 //
     /* 320984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320994 */   // MIs[0] Operand 2
     /* 320994 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 321005 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 321005 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 321008 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321012 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321017 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321023 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321026 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321030 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321035 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321065 */   GIR_RootConstrainSelectedInstOperands,
     /* 321066 */   // GIR_Coverage, 8866,
     /* 321066 */   GIR_EraseRootFromParent_Done,
     /* 321067 */ // Label 6645: @321067
     /* 321067 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(321155), // Rule ID 8867 //
     /* 321072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321082 */   // MIs[0] Operand 2
     /* 321082 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 321093 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 321093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 321096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321105 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321123 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321153 */   GIR_RootConstrainSelectedInstOperands,
     /* 321154 */   // GIR_Coverage, 8867,
     /* 321154 */   GIR_EraseRootFromParent_Done,
     /* 321155 */ // Label 6646: @321155
     /* 321155 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(321243), // Rule ID 8868 //
     /* 321160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321170 */   // MIs[0] Operand 2
     /* 321170 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 321181 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 321181 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 321184 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321188 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321193 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321199 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321202 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321206 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321211 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321241 */   GIR_RootConstrainSelectedInstOperands,
     /* 321242 */   // GIR_Coverage, 8868,
     /* 321242 */   GIR_EraseRootFromParent_Done,
     /* 321243 */ // Label 6647: @321243
     /* 321243 */ GIM_Reject,
     /* 321244 */ // Label 6589: @321244
     /* 321244 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(321279), // Rule ID 8819 //
     /* 321249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321259 */   // MIs[0] Operand 2
     /* 321259 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321270 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 321270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 321277 */   GIR_RootConstrainSelectedInstOperands,
     /* 321278 */   // GIR_Coverage, 8819,
     /* 321278 */   GIR_EraseRootFromParent_Done,
     /* 321279 */ // Label 6648: @321279
     /* 321279 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(321314), // Rule ID 8820 //
     /* 321284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 321290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321294 */   // MIs[0] Operand 2
     /* 321294 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321305 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 321305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321310 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 321312 */   GIR_RootConstrainSelectedInstOperands,
     /* 321313 */   // GIR_Coverage, 8820,
     /* 321313 */   GIR_EraseRootFromParent_Done,
     /* 321314 */ // Label 6649: @321314
     /* 321314 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(321368), // Rule ID 8829 //
     /* 321319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321329 */   // MIs[0] Operand 2
     /* 321329 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321340 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321366 */   GIR_RootConstrainSelectedInstOperands,
     /* 321367 */   // GIR_Coverage, 8829,
     /* 321367 */   GIR_EraseRootFromParent_Done,
     /* 321368 */ // Label 6650: @321368
     /* 321368 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(321422), // Rule ID 8830 //
     /* 321373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321383 */   // MIs[0] Operand 2
     /* 321383 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321394 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321420 */   GIR_RootConstrainSelectedInstOperands,
     /* 321421 */   // GIR_Coverage, 8830,
     /* 321421 */   GIR_EraseRootFromParent_Done,
     /* 321422 */ // Label 6651: @321422
     /* 321422 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(321476), // Rule ID 8831 //
     /* 321427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321437 */   // MIs[0] Operand 2
     /* 321437 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321448 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321460 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321474 */   GIR_RootConstrainSelectedInstOperands,
     /* 321475 */   // GIR_Coverage, 8831,
     /* 321475 */   GIR_EraseRootFromParent_Done,
     /* 321476 */ // Label 6652: @321476
     /* 321476 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(321530), // Rule ID 8832 //
     /* 321481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321491 */   // MIs[0] Operand 2
     /* 321491 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321502 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321528 */   GIR_RootConstrainSelectedInstOperands,
     /* 321529 */   // GIR_Coverage, 8832,
     /* 321529 */   GIR_EraseRootFromParent_Done,
     /* 321530 */ // Label 6653: @321530
     /* 321530 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(321601), // Rule ID 8845 //
     /* 321535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321545 */   // MIs[0] Operand 2
     /* 321545 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321556 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321556 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321559 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321563 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321568 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321599 */   GIR_RootConstrainSelectedInstOperands,
     /* 321600 */   // GIR_Coverage, 8845,
     /* 321600 */   GIR_EraseRootFromParent_Done,
     /* 321601 */ // Label 6654: @321601
     /* 321601 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(321672), // Rule ID 8846 //
     /* 321606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321616 */   // MIs[0] Operand 2
     /* 321616 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321627 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321639 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321670 */   GIR_RootConstrainSelectedInstOperands,
     /* 321671 */   // GIR_Coverage, 8846,
     /* 321671 */   GIR_EraseRootFromParent_Done,
     /* 321672 */ // Label 6655: @321672
     /* 321672 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(321743), // Rule ID 8847 //
     /* 321677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321687 */   // MIs[0] Operand 2
     /* 321687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321698 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321698 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321701 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321705 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321710 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321728 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321741 */   GIR_RootConstrainSelectedInstOperands,
     /* 321742 */   // GIR_Coverage, 8847,
     /* 321742 */   GIR_EraseRootFromParent_Done,
     /* 321743 */ // Label 6656: @321743
     /* 321743 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(321814), // Rule ID 8848 //
     /* 321748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321758 */   // MIs[0] Operand 2
     /* 321758 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321769 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321769 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321772 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321776 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321781 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321799 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321812 */   GIR_RootConstrainSelectedInstOperands,
     /* 321813 */   // GIR_Coverage, 8848,
     /* 321813 */   GIR_EraseRootFromParent_Done,
     /* 321814 */ // Label 6657: @321814
     /* 321814 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(321885), // Rule ID 8849 //
     /* 321819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321829 */   // MIs[0] Operand 2
     /* 321829 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 321840 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321840 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321843 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321847 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321852 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321870 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321883 */   GIR_RootConstrainSelectedInstOperands,
     /* 321884 */   // GIR_Coverage, 8849,
     /* 321884 */   GIR_EraseRootFromParent_Done,
     /* 321885 */ // Label 6658: @321885
     /* 321885 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(321956), // Rule ID 8850 //
     /* 321890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321900 */   // MIs[0] Operand 2
     /* 321900 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 321911 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321911 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321914 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321918 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321923 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321954 */   GIR_RootConstrainSelectedInstOperands,
     /* 321955 */   // GIR_Coverage, 8850,
     /* 321955 */   GIR_EraseRootFromParent_Done,
     /* 321956 */ // Label 6659: @321956
     /* 321956 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(322027), // Rule ID 8851 //
     /* 321961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321971 */   // MIs[0] Operand 2
     /* 321971 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 321982 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321982 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321985 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321989 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321994 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322025 */   GIR_RootConstrainSelectedInstOperands,
     /* 322026 */   // GIR_Coverage, 8851,
     /* 322026 */   GIR_EraseRootFromParent_Done,
     /* 322027 */ // Label 6660: @322027
     /* 322027 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(322098), // Rule ID 8852 //
     /* 322032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322042 */   // MIs[0] Operand 2
     /* 322042 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 322053 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 322053 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 322056 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322060 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322065 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322083 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322096 */   GIR_RootConstrainSelectedInstOperands,
     /* 322097 */   // GIR_Coverage, 8852,
     /* 322097 */   GIR_EraseRootFromParent_Done,
     /* 322098 */ // Label 6661: @322098
     /* 322098 */ GIM_Reject,
     /* 322099 */ // Label 6590: @322099
     /* 322099 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(322134), // Rule ID 8869 //
     /* 322104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 322110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322114 */   // MIs[0] Operand 2
     /* 322114 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322125 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 322125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 322128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322130 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322132 */   GIR_RootConstrainSelectedInstOperands,
     /* 322133 */   // GIR_Coverage, 8869,
     /* 322133 */   GIR_EraseRootFromParent_Done,
     /* 322134 */ // Label 6662: @322134
     /* 322134 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(322169), // Rule ID 8870 //
     /* 322139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 322145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322149 */   // MIs[0] Operand 2
     /* 322149 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322160 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 322160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322165 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322167 */   GIR_RootConstrainSelectedInstOperands,
     /* 322168 */   // GIR_Coverage, 8870,
     /* 322168 */   GIR_EraseRootFromParent_Done,
     /* 322169 */ // Label 6663: @322169
     /* 322169 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(322223), // Rule ID 8875 //
     /* 322174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322184 */   // MIs[0] Operand 2
     /* 322184 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322195 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 322195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 322198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 322202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 322211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 322216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322221 */   GIR_RootConstrainSelectedInstOperands,
     /* 322222 */   // GIR_Coverage, 8875,
     /* 322222 */   GIR_EraseRootFromParent_Done,
     /* 322223 */ // Label 6664: @322223
     /* 322223 */ GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(322277), // Rule ID 8876 //
     /* 322228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322238 */   // MIs[0] Operand 2
     /* 322238 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322249 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 322249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 322252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 322256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 322265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322275 */   GIR_RootConstrainSelectedInstOperands,
     /* 322276 */   // GIR_Coverage, 8876,
     /* 322276 */   GIR_EraseRootFromParent_Done,
     /* 322277 */ // Label 6665: @322277
     /* 322277 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(322331), // Rule ID 8877 //
     /* 322282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322292 */   // MIs[0] Operand 2
     /* 322292 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322303 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 322303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 322306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 322310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322315 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 322319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 322324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322329 */   GIR_RootConstrainSelectedInstOperands,
     /* 322330 */   // GIR_Coverage, 8877,
     /* 322330 */   GIR_EraseRootFromParent_Done,
     /* 322331 */ // Label 6666: @322331
     /* 322331 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(322385), // Rule ID 8878 //
     /* 322336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322346 */   // MIs[0] Operand 2
     /* 322346 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 322357 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 322357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 322360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 322364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322369 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 322373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322383 */   GIR_RootConstrainSelectedInstOperands,
     /* 322384 */   // GIR_Coverage, 8878,
     /* 322384 */   GIR_EraseRootFromParent_Done,
     /* 322385 */ // Label 6667: @322385
     /* 322385 */ GIM_Reject,
     /* 322386 */ // Label 6591: @322386
     /* 322386 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(322455),
     /* 322391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 322394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322398 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(322426), // Rule ID 8873 //
     /* 322403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322406 */     // MIs[0] Operand 2
     /* 322406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322417 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 322417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 322420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322424 */     GIR_RootConstrainSelectedInstOperands,
     /* 322425 */     // GIR_Coverage, 8873,
     /* 322425 */     GIR_EraseRootFromParent_Done,
     /* 322426 */   // Label 6669: @322426
     /* 322426 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(322454), // Rule ID 8874 //
     /* 322431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322434 */     // MIs[0] Operand 2
     /* 322434 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322445 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 322445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322452 */     GIR_RootConstrainSelectedInstOperands,
     /* 322453 */     // GIR_Coverage, 8874,
     /* 322453 */     GIR_EraseRootFromParent_Done,
     /* 322454 */   // Label 6670: @322454
     /* 322454 */   GIM_Reject,
     /* 322455 */ // Label 6668: @322455
     /* 322455 */ GIM_Reject,
     /* 322456 */ // Label 6592: @322456
     /* 322456 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(322491), // Rule ID 8821 //
     /* 322461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322471 */   // MIs[0] Operand 2
     /* 322471 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322482 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322487 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322489 */   GIR_RootConstrainSelectedInstOperands,
     /* 322490 */   // GIR_Coverage, 8821,
     /* 322490 */   GIR_EraseRootFromParent_Done,
     /* 322491 */ // Label 6671: @322491
     /* 322491 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(322526), // Rule ID 8822 //
     /* 322496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322506 */   // MIs[0] Operand 2
     /* 322506 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322517 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322522 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322524 */   GIR_RootConstrainSelectedInstOperands,
     /* 322525 */   // GIR_Coverage, 8822,
     /* 322525 */   GIR_EraseRootFromParent_Done,
     /* 322526 */ // Label 6672: @322526
     /* 322526 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(322580), // Rule ID 8833 //
     /* 322531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322541 */   // MIs[0] Operand 2
     /* 322541 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322552 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322578 */   GIR_RootConstrainSelectedInstOperands,
     /* 322579 */   // GIR_Coverage, 8833,
     /* 322579 */   GIR_EraseRootFromParent_Done,
     /* 322580 */ // Label 6673: @322580
     /* 322580 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(322634), // Rule ID 8834 //
     /* 322585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322595 */   // MIs[0] Operand 2
     /* 322595 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322606 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322632 */   GIR_RootConstrainSelectedInstOperands,
     /* 322633 */   // GIR_Coverage, 8834,
     /* 322633 */   GIR_EraseRootFromParent_Done,
     /* 322634 */ // Label 6674: @322634
     /* 322634 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(322688), // Rule ID 8835 //
     /* 322639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322649 */   // MIs[0] Operand 2
     /* 322649 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322660 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322672 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322686 */   GIR_RootConstrainSelectedInstOperands,
     /* 322687 */   // GIR_Coverage, 8835,
     /* 322687 */   GIR_EraseRootFromParent_Done,
     /* 322688 */ // Label 6675: @322688
     /* 322688 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(322742), // Rule ID 8836 //
     /* 322693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322703 */   // MIs[0] Operand 2
     /* 322703 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 322714 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322726 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322740 */   GIR_RootConstrainSelectedInstOperands,
     /* 322741 */   // GIR_Coverage, 8836,
     /* 322741 */   GIR_EraseRootFromParent_Done,
     /* 322742 */ // Label 6676: @322742
     /* 322742 */ GIM_Reject,
     /* 322743 */ // Label 6593: @322743
     /* 322743 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(322812),
     /* 322748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322755 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(322783), // Rule ID 8871 //
     /* 322760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322763 */     // MIs[0] Operand 2
     /* 322763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322774 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 322777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322781 */     GIR_RootConstrainSelectedInstOperands,
     /* 322782 */     // GIR_Coverage, 8871,
     /* 322782 */     GIR_EraseRootFromParent_Done,
     /* 322783 */   // Label 6678: @322783
     /* 322783 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(322811), // Rule ID 8872 //
     /* 322788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322791 */     // MIs[0] Operand 2
     /* 322791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322802 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 322805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322809 */     GIR_RootConstrainSelectedInstOperands,
     /* 322810 */     // GIR_Coverage, 8872,
     /* 322810 */     GIR_EraseRootFromParent_Done,
     /* 322811 */   // Label 6679: @322811
     /* 322811 */   GIM_Reject,
     /* 322812 */ // Label 6677: @322812
     /* 322812 */ GIM_Reject,
     /* 322813 */ // Label 6594: @322813
     /* 322813 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(322882),
     /* 322818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322825 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(322853), // Rule ID 8823 //
     /* 322830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322833 */     // MIs[0] Operand 2
     /* 322833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322844 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322851 */     GIR_RootConstrainSelectedInstOperands,
     /* 322852 */     // GIR_Coverage, 8823,
     /* 322852 */     GIR_EraseRootFromParent_Done,
     /* 322853 */   // Label 6681: @322853
     /* 322853 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(322881), // Rule ID 8824 //
     /* 322858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322861 */     // MIs[0] Operand 2
     /* 322861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322872 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322879 */     GIR_RootConstrainSelectedInstOperands,
     /* 322880 */     // GIR_Coverage, 8824,
     /* 322880 */     GIR_EraseRootFromParent_Done,
     /* 322881 */   // Label 6682: @322881
     /* 322881 */   GIM_Reject,
     /* 322882 */ // Label 6680: @322882
     /* 322882 */ GIM_Reject,
     /* 322883 */ // Label 6595: @322883
     /* 322883 */ GIM_Reject,
     /* 322884 */ // Label 85: @322884
     /* 322884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6698*/ GIMT_Encode4(350280),
     /* 322895 */ /*GILLT_s64*//*Label 6683*/ GIMT_Encode4(322979), GIMT_Encode4(0),
     /* 322903 */ /*GILLT_v2s32*//*Label 6684*/ GIMT_Encode4(323689),
     /* 322907 */ /*GILLT_v2s64*//*Label 6685*/ GIMT_Encode4(327220),
     /* 322911 */ /*GILLT_v4s16*//*Label 6686*/ GIMT_Encode4(330049),
     /* 322915 */ /*GILLT_v4s32*//*Label 6687*/ GIMT_Encode4(333689),
     /* 322919 */ /*GILLT_v8s8*//*Label 6688*/ GIMT_Encode4(336353),
     /* 322923 */ /*GILLT_v8s16*//*Label 6689*/ GIMT_Encode4(338197),
     /* 322927 */ /*GILLT_v16s8*//*Label 6690*/ GIMT_Encode4(341172), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 322939 */ /*GILLT_nxv2s16*//*Label 6691*/ GIMT_Encode4(342752),
     /* 322943 */ /*GILLT_nxv2s32*//*Label 6692*/ GIMT_Encode4(342877),
     /* 322947 */ /*GILLT_nxv2s64*//*Label 6693*/ GIMT_Encode4(343002), GIMT_Encode4(0),
     /* 322955 */ /*GILLT_nxv4s16*//*Label 6694*/ GIMT_Encode4(344916),
     /* 322959 */ /*GILLT_nxv4s32*//*Label 6695*/ GIMT_Encode4(345068), GIMT_Encode4(0),
     /* 322967 */ /*GILLT_nxv8s16*//*Label 6696*/ GIMT_Encode4(347036), GIMT_Encode4(0),
     /* 322975 */ /*GILLT_nxv16s8*//*Label 6697*/ GIMT_Encode4(349230),
     /* 322979 */ // Label 6683: @322979
     /* 322979 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(323688),
     /* 322984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 322993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322997 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(323127), // Rule ID 5658 //
     /* 323002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323035 */     // MIs[2] Operand 1
     /* 323035 */     // No operand predicates
     /* 323035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323043 */     // MIs[3] Operand 1
     /* 323043 */     // No operand predicates
     /* 323043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323045 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323045 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323048 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323052 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323057 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323060 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323064 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323126 */     // GIR_Coverage, 5658,
     /* 323126 */     GIR_EraseRootFromParent_Done,
     /* 323127 */   // Label 6700: @323127
     /* 323127 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(323288), // Rule ID 5659 //
     /* 323132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323165 */     // MIs[2] Operand 1
     /* 323165 */     // No operand predicates
     /* 323165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323173 */     // MIs[3] Operand 1
     /* 323173 */     // No operand predicates
     /* 323173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323175 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323175 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 323178 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323182 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323187 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 323190 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323194 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 323197 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323202 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323219 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323222 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323226 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323257 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323270 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323287 */     // GIR_Coverage, 5659,
     /* 323287 */     GIR_EraseRootFromParent_Done,
     /* 323288 */   // Label 6701: @323288
     /* 323288 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(323418), // Rule ID 5682 //
     /* 323293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323326 */     // MIs[2] Operand 1
     /* 323326 */     // No operand predicates
     /* 323326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323334 */     // MIs[3] Operand 1
     /* 323334 */     // No operand predicates
     /* 323334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323336 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323348 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323355 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323380 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323400 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323417 */     // GIR_Coverage, 5682,
     /* 323417 */     GIR_EraseRootFromParent_Done,
     /* 323418 */   // Label 6702: @323418
     /* 323418 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(323579), // Rule ID 5683 //
     /* 323423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323456 */     // MIs[2] Operand 1
     /* 323456 */     // No operand predicates
     /* 323456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323464 */     // MIs[3] Operand 1
     /* 323464 */     // No operand predicates
     /* 323464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323466 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323466 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 323469 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323473 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323478 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 323481 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323485 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 323488 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323493 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323510 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323542 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323578 */     // GIR_Coverage, 5683,
     /* 323578 */     GIR_EraseRootFromParent_Done,
     /* 323579 */   // Label 6703: @323579
     /* 323579 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(323615), // Rule ID 6575 //
     /* 323584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323602 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323614 */     // GIR_Coverage, 6575,
     /* 323614 */     GIR_EraseRootFromParent_Done,
     /* 323615 */   // Label 6704: @323615
     /* 323615 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(323651), // Rule ID 6577 //
     /* 323620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323638 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323650 */     // GIR_Coverage, 6577,
     /* 323650 */     GIR_EraseRootFromParent_Done,
     /* 323651 */   // Label 6705: @323651
     /* 323651 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(323687), // Rule ID 6579 //
     /* 323656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323674 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 323674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323677 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 323679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323686 */     // GIR_Coverage, 6579,
     /* 323686 */     GIR_EraseRootFromParent_Done,
     /* 323687 */   // Label 6706: @323687
     /* 323687 */   GIM_Reject,
     /* 323688 */ // Label 6699: @323688
     /* 323688 */ GIM_Reject,
     /* 323689 */ // Label 6684: @323689
     /* 323689 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(327219),
     /* 323694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 323703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323707 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(323816), // Rule ID 4214 //
     /* 323712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323732 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323739 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323756 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323815 */     // GIR_Coverage, 4214,
     /* 323815 */     GIR_EraseRootFromParent_Done,
     /* 323816 */   // Label 6708: @323816
     /* 323816 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(323925), // Rule ID 4215 //
     /* 323821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323865 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323892 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323924 */     // GIR_Coverage, 4215,
     /* 323924 */     GIR_EraseRootFromParent_Done,
     /* 323925 */   // Label 6709: @323925
     /* 323925 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(324034), // Rule ID 4322 //
     /* 323930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323934 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323940 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323950 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323957 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323974 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324033 */     // GIR_Coverage, 4322,
     /* 324033 */     GIR_EraseRootFromParent_Done,
     /* 324034 */   // Label 6710: @324034
     /* 324034 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(324143), // Rule ID 4323 //
     /* 324039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324059 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324066 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 324083 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 324090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324142 */     // GIR_Coverage, 4323,
     /* 324142 */     GIR_EraseRootFromParent_Done,
     /* 324143 */   // Label 6711: @324143
     /* 324143 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(324248), // Rule ID 4220 //
     /* 324148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 324188 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 324195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324247 */     // GIR_Coverage, 4220,
     /* 324247 */     GIR_EraseRootFromParent_Done,
     /* 324248 */   // Label 6712: @324248
     /* 324248 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(324353), // Rule ID 4222 //
     /* 324253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324269 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324276 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 324293 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 324300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324352 */     // GIR_Coverage, 4222,
     /* 324352 */     GIR_EraseRootFromParent_Done,
     /* 324353 */   // Label 6713: @324353
     /* 324353 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(324458), // Rule ID 4328 //
     /* 324358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324374 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324381 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 324398 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 324405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324457 */     // GIR_Coverage, 4328,
     /* 324457 */     GIR_EraseRootFromParent_Done,
     /* 324458 */   // Label 6714: @324458
     /* 324458 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(324563), // Rule ID 4330 //
     /* 324463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324479 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 324503 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 324510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324562 */     // GIR_Coverage, 4330,
     /* 324562 */     GIR_EraseRootFromParent_Done,
     /* 324563 */   // Label 6715: @324563
     /* 324563 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(324667), // Rule ID 4212 //
     /* 324568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324578 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324588 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324595 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324612 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324634 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324666 */     // GIR_Coverage, 4212,
     /* 324666 */     GIR_EraseRootFromParent_Done,
     /* 324667 */   // Label 6716: @324667
     /* 324667 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(324771), // Rule ID 4213 //
     /* 324672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324676 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324682 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324692 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324699 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324716 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324770 */     // GIR_Coverage, 4213,
     /* 324770 */     GIR_EraseRootFromParent_Done,
     /* 324771 */   // Label 6717: @324771
     /* 324771 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(324875), // Rule ID 4320 //
     /* 324776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324796 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324803 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324820 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324842 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324874 */     // GIR_Coverage, 4320,
     /* 324874 */     GIR_EraseRootFromParent_Done,
     /* 324875 */   // Label 6718: @324875
     /* 324875 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(324979), // Rule ID 4321 //
     /* 324880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324884 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324890 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324900 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324924 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324978 */     // GIR_Coverage, 4321,
     /* 324978 */     GIR_EraseRootFromParent_Done,
     /* 324979 */   // Label 6719: @324979
     /* 324979 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(325079), // Rule ID 4216 //
     /* 324984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325007 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 325011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 325024 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 325024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 325027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 325031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 325041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 325046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325078 */     // GIR_Coverage, 4216,
     /* 325078 */     GIR_EraseRootFromParent_Done,
     /* 325079 */   // Label 6720: @325079
     /* 325079 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(325179), // Rule ID 4218 //
     /* 325084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325100 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325107 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 325111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 325124 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 325124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 325127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 325131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 325141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 325146 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325178 */     // GIR_Coverage, 4218,
     /* 325178 */     GIR_EraseRootFromParent_Done,
     /* 325179 */   // Label 6721: @325179
     /* 325179 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(325279), // Rule ID 4324 //
     /* 325184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325200 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 325211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 325224 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 325224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 325227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 325231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 325241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 325246 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325278 */     // GIR_Coverage, 4324,
     /* 325278 */     GIR_EraseRootFromParent_Done,
     /* 325279 */   // Label 6722: @325279
     /* 325279 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(325379), // Rule ID 4326 //
     /* 325284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325300 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325307 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 325311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 325324 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 325324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 325327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 325331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 325341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 325346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325378 */     // GIR_Coverage, 4326,
     /* 325378 */     GIR_EraseRootFromParent_Done,
     /* 325379 */   // Label 6723: @325379
     /* 325379 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(325499), // Rule ID 6354 //
     /* 325384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325406 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325410 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 325417 */     // MIs[2] Rn
     /* 325417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 325421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 325426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325432 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 325432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 325435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 325453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325468 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325498 */     // GIR_Coverage, 6354,
     /* 325498 */     GIR_EraseRootFromParent_Done,
     /* 325499 */   // Label 6724: @325499
     /* 325499 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(325619), // Rule ID 6356 //
     /* 325504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325523 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325526 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325530 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 325537 */     // MIs[2] Rn
     /* 325537 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 325541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 325546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325552 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 325552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 325555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 325573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325588 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325618 */     // GIR_Coverage, 6356,
     /* 325618 */     GIR_EraseRootFromParent_Done,
     /* 325619 */   // Label 6725: @325619
     /* 325619 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(325749), // Rule ID 5652 //
     /* 325624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325657 */     // MIs[2] Operand 1
     /* 325657 */     // No operand predicates
     /* 325657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325665 */     // MIs[3] Operand 1
     /* 325665 */     // No operand predicates
     /* 325665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325667 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325686 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325731 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325748 */     // GIR_Coverage, 5652,
     /* 325748 */     GIR_EraseRootFromParent_Done,
     /* 325749 */   // Label 6726: @325749
     /* 325749 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(325910), // Rule ID 5653 //
     /* 325754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325787 */     // MIs[2] Operand 1
     /* 325787 */     // No operand predicates
     /* 325787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325795 */     // MIs[3] Operand 1
     /* 325795 */     // No operand predicates
     /* 325795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325797 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325797 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325800 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325804 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325809 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325812 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325816 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325819 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325824 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325892 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325909 */     // GIR_Coverage, 5653,
     /* 325909 */     GIR_EraseRootFromParent_Done,
     /* 325910 */   // Label 6727: @325910
     /* 325910 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(326040), // Rule ID 5676 //
     /* 325915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325948 */     // MIs[2] Operand 1
     /* 325948 */     // No operand predicates
     /* 325948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325956 */     // MIs[3] Operand 1
     /* 325956 */     // No operand predicates
     /* 325956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325958 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325970 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 326008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 326015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326022 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326039 */     // GIR_Coverage, 5676,
     /* 326039 */     GIR_EraseRootFromParent_Done,
     /* 326040 */   // Label 6728: @326040
     /* 326040 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(326201), // Rule ID 5677 //
     /* 326045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 326065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326078 */     // MIs[2] Operand 1
     /* 326078 */     // No operand predicates
     /* 326078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 326082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326086 */     // MIs[3] Operand 1
     /* 326086 */     // No operand predicates
     /* 326086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326088 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 326088 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 326091 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326095 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326100 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 326103 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326107 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 326110 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326115 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326132 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326135 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 326139 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 326170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 326173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 326176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326183 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326200 */     // GIR_Coverage, 5677,
     /* 326200 */     GIR_EraseRootFromParent_Done,
     /* 326201 */   // Label 6729: @326201
     /* 326201 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(326267), // Rule ID 5607 //
     /* 326206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326224 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 326224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 326227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326266 */     // GIR_Coverage, 5607,
     /* 326266 */     GIR_EraseRootFromParent_Done,
     /* 326267 */   // Label 6730: @326267
     /* 326267 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(326333), // Rule ID 5619 //
     /* 326272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 326280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326290 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 326290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 326293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 326317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326332 */     // GIR_Coverage, 5619,
     /* 326332 */     GIR_EraseRootFromParent_Done,
     /* 326333 */   // Label 6731: @326333
     /* 326333 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(326468), // Rule ID 5627 //
     /* 326338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 326350 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 326354 */     // MIs[1] Operand 1
     /* 326354 */     // No operand predicates
     /* 326354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326366 */     // MIs[2] Operand 1
     /* 326366 */     // No operand predicates
     /* 326366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326368 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 326368 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326371 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326375 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326394 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326401 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326414 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 326426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326431 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 326437 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 326443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326450 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326467 */     // GIR_Coverage, 5627,
     /* 326467 */     GIR_EraseRootFromParent_Done,
     /* 326468 */   // Label 6732: @326468
     /* 326468 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(326600), // Rule ID 6362 //
     /* 326473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326492 */     // MIs[1] Rn
     /* 326492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326513 */     // MIs[2] Operand 1
     /* 326513 */     // No operand predicates
     /* 326513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326515 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326527 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326530 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326534 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326582 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326599 */     // GIR_Coverage, 6362,
     /* 326599 */     GIR_EraseRootFromParent_Done,
     /* 326600 */   // Label 6733: @326600
     /* 326600 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(326732), // Rule ID 6363 //
     /* 326605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326617 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326624 */     // MIs[1] Rn
     /* 326624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326645 */     // MIs[2] Operand 1
     /* 326645 */     // No operand predicates
     /* 326645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326647 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326659 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326666 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326701 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326714 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326731 */     // GIR_Coverage, 6363,
     /* 326731 */     GIR_EraseRootFromParent_Done,
     /* 326732 */   // Label 6734: @326732
     /* 326732 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(326915), // Rule ID 5685 //
     /* 326737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 326745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326762 */     // MIs[2] Operand 1
     /* 326762 */     // No operand predicates
     /* 326762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326764 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326764 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 326767 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326771 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326778 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 326781 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326785 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326790 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326793 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 326797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326800 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326805 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326810 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 326848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 326884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 326887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326914 */     // GIR_Coverage, 5685,
     /* 326914 */     GIR_EraseRootFromParent_Done,
     /* 326915 */   // Label 6735: @326915
     /* 326915 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(327093), // Rule ID 5630 //
     /* 326920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 326932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326940 */     // MIs[1] Operand 1
     /* 326940 */     // No operand predicates
     /* 326940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326942 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326942 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326945 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326949 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326956 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326959 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326963 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326968 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326971 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326975 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326978 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326983 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326988 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326993 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326996 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327000 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 327010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327019 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 327026 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 327029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327034 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 327047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 327051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327056 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 327062 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 327065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 327068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327075 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 327082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327092 */     // GIR_Coverage, 5630,
     /* 327092 */     GIR_EraseRootFromParent_Done,
     /* 327093 */   // Label 6736: @327093
     /* 327093 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(327218), // Rule ID 5633 //
     /* 327098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 327110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 327118 */     // MIs[1] Operand 1
     /* 327118 */     // No operand predicates
     /* 327118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327120 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 327120 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 327123 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327127 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 327137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327146 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327149 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 327153 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 327156 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327161 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 327174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 327178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 327189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 327193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327200 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 327207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327217 */     // GIR_Coverage, 5633,
     /* 327217 */     GIR_EraseRootFromParent_Done,
     /* 327218 */   // Label 6737: @327218
     /* 327218 */   GIM_Reject,
     /* 327219 */ // Label 6707: @327219
     /* 327219 */ GIM_Reject,
     /* 327220 */ // Label 6685: @327220
     /* 327220 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(330048),
     /* 327225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 327234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327238 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(327347), // Rule ID 4238 //
     /* 327243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327247 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327253 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327263 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327287 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327346 */     // GIR_Coverage, 4238,
     /* 327346 */     GIR_EraseRootFromParent_Done,
     /* 327347 */   // Label 6739: @327347
     /* 327347 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(327456), // Rule ID 4239 //
     /* 327352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327372 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327379 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327396 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327455 */     // GIR_Coverage, 4239,
     /* 327455 */     GIR_EraseRootFromParent_Done,
     /* 327456 */   // Label 6740: @327456
     /* 327456 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(327565), // Rule ID 4346 //
     /* 327461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327465 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327471 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327505 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327564 */     // GIR_Coverage, 4346,
     /* 327564 */     GIR_EraseRootFromParent_Done,
     /* 327565 */   // Label 6741: @327565
     /* 327565 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(327674), // Rule ID 4347 //
     /* 327570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327574 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327580 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327590 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327597 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327614 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327673 */     // GIR_Coverage, 4347,
     /* 327673 */     GIR_EraseRootFromParent_Done,
     /* 327674 */   // Label 6742: @327674
     /* 327674 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(327779), // Rule ID 4244 //
     /* 327679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327719 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327746 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327778 */     // GIR_Coverage, 4244,
     /* 327778 */     GIR_EraseRootFromParent_Done,
     /* 327779 */   // Label 6743: @327779
     /* 327779 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(327884), // Rule ID 4246 //
     /* 327784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327800 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327807 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327824 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327851 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327883 */     // GIR_Coverage, 4246,
     /* 327883 */     GIR_EraseRootFromParent_Done,
     /* 327884 */   // Label 6744: @327884
     /* 327884 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(327989), // Rule ID 4352 //
     /* 327889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327905 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327912 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327929 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327956 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327988 */     // GIR_Coverage, 4352,
     /* 327988 */     GIR_EraseRootFromParent_Done,
     /* 327989 */   // Label 6745: @327989
     /* 327989 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(328094), // Rule ID 4354 //
     /* 327994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328010 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328017 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 328034 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 328034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 328041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 328056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 328061 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328093 */     // GIR_Coverage, 4354,
     /* 328093 */     GIR_EraseRootFromParent_Done,
     /* 328094 */   // Label 6746: @328094
     /* 328094 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(328198), // Rule ID 4236 //
     /* 328099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328103 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 328109 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 328111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328119 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328126 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328143 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328197 */     // GIR_Coverage, 4236,
     /* 328197 */     GIR_EraseRootFromParent_Done,
     /* 328198 */   // Label 6747: @328198
     /* 328198 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(328302), // Rule ID 4237 //
     /* 328203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 328213 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 328215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328247 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328301 */     // GIR_Coverage, 4237,
     /* 328301 */     GIR_EraseRootFromParent_Done,
     /* 328302 */   // Label 6748: @328302
     /* 328302 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(328406), // Rule ID 4344 //
     /* 328307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 328317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 328319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328327 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328334 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328351 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328373 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328405 */     // GIR_Coverage, 4344,
     /* 328405 */     GIR_EraseRootFromParent_Done,
     /* 328406 */   // Label 6749: @328406
     /* 328406 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(328510), // Rule ID 4345 //
     /* 328411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 328421 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 328423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328431 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328434 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328438 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328455 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328477 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328509 */     // GIR_Coverage, 4345,
     /* 328509 */     GIR_EraseRootFromParent_Done,
     /* 328510 */   // Label 6750: @328510
     /* 328510 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(328610), // Rule ID 4240 //
     /* 328515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328531 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328538 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328555 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328609 */     // GIR_Coverage, 4240,
     /* 328609 */     GIR_EraseRootFromParent_Done,
     /* 328610 */   // Label 6751: @328610
     /* 328610 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(328710), // Rule ID 4242 //
     /* 328615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328631 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328638 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328655 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328677 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328709 */     // GIR_Coverage, 4242,
     /* 328709 */     GIR_EraseRootFromParent_Done,
     /* 328710 */   // Label 6752: @328710
     /* 328710 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(328810), // Rule ID 4348 //
     /* 328715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328738 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328755 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328809 */     // GIR_Coverage, 4348,
     /* 328809 */     GIR_EraseRootFromParent_Done,
     /* 328810 */   // Label 6753: @328810
     /* 328810 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(328910), // Rule ID 4350 //
     /* 328815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328831 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328838 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328855 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328877 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328909 */     // GIR_Coverage, 4350,
     /* 328909 */     GIR_EraseRootFromParent_Done,
     /* 328910 */   // Label 6754: @328910
     /* 328910 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(328988), // Rule ID 1934 //
     /* 328915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328955 */     // MIs[2] Operand 1
     /* 328955 */     // No operand predicates
     /* 328955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328963 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328967 */     // MIs[3] Operand 1
     /* 328967 */     // No operand predicates
     /* 328967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328969 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 328969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 328976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 328979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 328986 */     GIR_RootConstrainSelectedInstOperands,
     /* 328987 */     // GIR_Coverage, 1934,
     /* 328987 */     GIR_EraseRootFromParent_Done,
     /* 328988 */   // Label 6755: @328988
     /* 328988 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(329079), // Rule ID 7270 //
     /* 328993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 328996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 329008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329020 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 329023 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 329030 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 329033 */     // MIs[2] Rn
     /* 329033 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 329037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329050 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329054 */     // MIs[3] Operand 1
     /* 329054 */     // No operand predicates
     /* 329054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329056 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15690>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 329059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 329066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 329070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 329077 */     GIR_RootConstrainSelectedInstOperands,
     /* 329078 */     // GIR_Coverage, 7270,
     /* 329078 */     GIR_EraseRootFromParent_Done,
     /* 329079 */   // Label 6756: @329079
     /* 329079 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(329146), // Rule ID 5656 //
     /* 329084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329117 */     // MIs[2] Operand 1
     /* 329117 */     // No operand predicates
     /* 329117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329125 */     // MIs[3] Operand 1
     /* 329125 */     // No operand predicates
     /* 329125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329127 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 329127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 329137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 329144 */     GIR_RootConstrainSelectedInstOperands,
     /* 329145 */     // GIR_Coverage, 5656,
     /* 329145 */     GIR_EraseRootFromParent_Done,
     /* 329146 */   // Label 6757: @329146
     /* 329146 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(329244), // Rule ID 5657 //
     /* 329151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329184 */     // MIs[2] Operand 1
     /* 329184 */     // No operand predicates
     /* 329184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329192 */     // MIs[3] Operand 1
     /* 329192 */     // No operand predicates
     /* 329192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329194 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 329194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 329209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329213 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 329236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 329242 */     GIR_RootConstrainSelectedInstOperands,
     /* 329243 */     // GIR_Coverage, 5657,
     /* 329243 */     GIR_EraseRootFromParent_Done,
     /* 329244 */   // Label 6758: @329244
     /* 329244 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(329311), // Rule ID 5680 //
     /* 329249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329282 */     // MIs[2] Operand 1
     /* 329282 */     // No operand predicates
     /* 329282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329290 */     // MIs[3] Operand 1
     /* 329290 */     // No operand predicates
     /* 329290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329292 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 329292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 329302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 329309 */     GIR_RootConstrainSelectedInstOperands,
     /* 329310 */     // GIR_Coverage, 5680,
     /* 329310 */     GIR_EraseRootFromParent_Done,
     /* 329311 */   // Label 6759: @329311
     /* 329311 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(329409), // Rule ID 5681 //
     /* 329316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329349 */     // MIs[2] Operand 1
     /* 329349 */     // No operand predicates
     /* 329349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329357 */     // MIs[3] Operand 1
     /* 329357 */     // No operand predicates
     /* 329357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329359 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 329359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 329374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 329401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 329407 */     GIR_RootConstrainSelectedInstOperands,
     /* 329408 */     // GIR_Coverage, 5681,
     /* 329408 */     GIR_EraseRootFromParent_Done,
     /* 329409 */   // Label 6760: @329409
     /* 329409 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(329475), // Rule ID 5611 //
     /* 329414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 329422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329432 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 329432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329474 */     // GIR_Coverage, 5611,
     /* 329474 */     GIR_EraseRootFromParent_Done,
     /* 329475 */   // Label 6761: @329475
     /* 329475 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(329541), // Rule ID 5621 //
     /* 329480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 329488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329498 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 329498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329540 */     // GIR_Coverage, 5621,
     /* 329540 */     GIR_EraseRootFromParent_Done,
     /* 329541 */   // Label 6762: @329541
     /* 329541 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(329619), // Rule ID 7269 //
     /* 329546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 329549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329561 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 329564 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 329571 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 329574 */     // MIs[1] Rn
     /* 329574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329591 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329595 */     // MIs[2] Operand 1
     /* 329595 */     // No operand predicates
     /* 329595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329597 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15690>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 329600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329617 */     GIR_RootConstrainSelectedInstOperands,
     /* 329618 */     // GIR_Coverage, 7269,
     /* 329618 */     GIR_EraseRootFromParent_Done,
     /* 329619 */   // Label 6763: @329619
     /* 329619 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(329688), // Rule ID 6345 //
     /* 329624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329643 */     // MIs[1] Rn
     /* 329643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329664 */     // MIs[2] Operand 1
     /* 329664 */     // No operand predicates
     /* 329664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329666 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329686 */     GIR_RootConstrainSelectedInstOperands,
     /* 329687 */     // GIR_Coverage, 6345,
     /* 329687 */     GIR_EraseRootFromParent_Done,
     /* 329688 */   // Label 6764: @329688
     /* 329688 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(329757), // Rule ID 6346 //
     /* 329693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329712 */     // MIs[1] Rn
     /* 329712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329733 */     // MIs[2] Operand 1
     /* 329733 */     // No operand predicates
     /* 329733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329735 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329755 */     GIR_RootConstrainSelectedInstOperands,
     /* 329756 */     // GIR_Coverage, 6346,
     /* 329756 */     GIR_EraseRootFromParent_Done,
     /* 329757 */   // Label 6765: @329757
     /* 329757 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(329806), // Rule ID 5628 //
     /* 329762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 329770 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 329774 */     // MIs[1] Operand 1
     /* 329774 */     // No operand predicates
     /* 329774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329786 */     // MIs[2] Operand 1
     /* 329786 */     // No operand predicates
     /* 329786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329788 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 329788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 329798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 329804 */     GIR_RootConstrainSelectedInstOperands,
     /* 329805 */     // GIR_Coverage, 5628,
     /* 329805 */     GIR_EraseRootFromParent_Done,
     /* 329806 */   // Label 6766: @329806
     /* 329806 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(329907), // Rule ID 5686 //
     /* 329811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 329819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329836 */     // MIs[2] Operand 1
     /* 329836 */     // No operand predicates
     /* 329836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329838 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 329871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 329899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329905 */     GIR_RootConstrainSelectedInstOperands,
     /* 329906 */     // GIR_Coverage, 5686,
     /* 329906 */     GIR_EraseRootFromParent_Done,
     /* 329907 */   // Label 6767: @329907
     /* 329907 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(329951), // Rule ID 1930 //
     /* 329912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329935 */     // MIs[1] Operand 1
     /* 329935 */     // No operand predicates
     /* 329935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329937 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 329937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 329947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329949 */     GIR_RootConstrainSelectedInstOperands,
     /* 329950 */     // GIR_Coverage, 1930,
     /* 329950 */     GIR_EraseRootFromParent_Done,
     /* 329951 */   // Label 6768: @329951
     /* 329951 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(330047), // Rule ID 5632 //
     /* 329956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329976 */     // MIs[1] Operand 1
     /* 329976 */     // No operand predicates
     /* 329976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329978 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 329981 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329985 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 330011 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 330014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 330032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 330039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330045 */     GIR_RootConstrainSelectedInstOperands,
     /* 330046 */     // GIR_Coverage, 5632,
     /* 330046 */     GIR_EraseRootFromParent_Done,
     /* 330047 */   // Label 6769: @330047
     /* 330047 */   GIM_Reject,
     /* 330048 */ // Label 6738: @330048
     /* 330048 */ GIM_Reject,
     /* 330049 */ // Label 6686: @330049
     /* 330049 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(333688),
     /* 330054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330057 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(330183), // Rule ID 4178 //
     /* 330062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330076 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330082 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330092 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330095 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330099 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330123 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330150 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330182 */     // GIR_Coverage, 4178,
     /* 330182 */     GIR_EraseRootFromParent_Done,
     /* 330183 */   // Label 6771: @330183
     /* 330183 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(330309), // Rule ID 4179 //
     /* 330188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330202 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330208 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330221 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330225 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330232 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330249 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330276 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330308 */     // GIR_Coverage, 4179,
     /* 330308 */     GIR_EraseRootFromParent_Done,
     /* 330309 */   // Label 6772: @330309
     /* 330309 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(330428), // Rule ID 4286 //
     /* 330314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330328 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330334 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330344 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330351 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330368 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330395 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330427 */     // GIR_Coverage, 4286,
     /* 330427 */     GIR_EraseRootFromParent_Done,
     /* 330428 */   // Label 6773: @330428
     /* 330428 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(330547), // Rule ID 4287 //
     /* 330433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330463 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330470 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330487 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330546 */     // GIR_Coverage, 4287,
     /* 330546 */     GIR_EraseRootFromParent_Done,
     /* 330547 */   // Label 6774: @330547
     /* 330547 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(330669), // Rule ID 4184 //
     /* 330552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330581 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330585 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330592 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330609 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330636 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330668 */     // GIR_Coverage, 4184,
     /* 330668 */     GIR_EraseRootFromParent_Done,
     /* 330669 */   // Label 6775: @330669
     /* 330669 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(330791), // Rule ID 4186 //
     /* 330674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330700 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330703 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330707 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330714 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330731 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330790 */     // GIR_Coverage, 4186,
     /* 330790 */     GIR_EraseRootFromParent_Done,
     /* 330791 */   // Label 6776: @330791
     /* 330791 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(330906), // Rule ID 4292 //
     /* 330796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330822 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330829 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330846 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330873 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330905 */     // GIR_Coverage, 4292,
     /* 330905 */     GIR_EraseRootFromParent_Done,
     /* 330906 */   // Label 6777: @330906
     /* 330906 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(331021), // Rule ID 4294 //
     /* 330911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330937 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330961 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330988 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331020 */     // GIR_Coverage, 4294,
     /* 331020 */     GIR_EraseRootFromParent_Done,
     /* 331021 */   // Label 6778: @331021
     /* 331021 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(331142), // Rule ID 4176 //
     /* 331026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331056 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331059 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331063 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331070 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331087 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331109 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331141 */     // GIR_Coverage, 4176,
     /* 331141 */     GIR_EraseRootFromParent_Done,
     /* 331142 */   // Label 6779: @331142
     /* 331142 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(331263), // Rule ID 4177 //
     /* 331147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331177 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331180 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331184 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331191 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331208 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331230 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331262 */     // GIR_Coverage, 4177,
     /* 331262 */     GIR_EraseRootFromParent_Done,
     /* 331263 */   // Label 6780: @331263
     /* 331263 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(331377), // Rule ID 4284 //
     /* 331268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331322 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331376 */     // GIR_Coverage, 4284,
     /* 331376 */     GIR_EraseRootFromParent_Done,
     /* 331377 */   // Label 6781: @331377
     /* 331377 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(331491), // Rule ID 4285 //
     /* 331382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331412 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331419 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331436 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331458 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331490 */     // GIR_Coverage, 4285,
     /* 331490 */     GIR_EraseRootFromParent_Done,
     /* 331491 */   // Label 6782: @331491
     /* 331491 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(331608), // Rule ID 4180 //
     /* 331496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331525 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331529 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331553 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331607 */     // GIR_Coverage, 4180,
     /* 331607 */     GIR_EraseRootFromParent_Done,
     /* 331608 */   // Label 6783: @331608
     /* 331608 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(331725), // Rule ID 4182 //
     /* 331613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331639 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331642 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331646 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331653 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331670 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331724 */     // GIR_Coverage, 4182,
     /* 331724 */     GIR_EraseRootFromParent_Done,
     /* 331725 */   // Label 6784: @331725
     /* 331725 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(331835), // Rule ID 4288 //
     /* 331730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331780 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331834 */     // GIR_Coverage, 4288,
     /* 331834 */     GIR_EraseRootFromParent_Done,
     /* 331835 */   // Label 6785: @331835
     /* 331835 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(331945), // Rule ID 4290 //
     /* 331840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331866 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331873 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331890 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331912 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331944 */     // GIR_Coverage, 4290,
     /* 331944 */     GIR_EraseRootFromParent_Done,
     /* 331945 */   // Label 6786: @331945
     /* 331945 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(332075), // Rule ID 6358 //
     /* 331950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331982 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331986 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331993 */     // MIs[2] Rn
     /* 331993 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 331997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332008 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 332011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 332029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 332040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 332044 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332074 */     // GIR_Coverage, 6358,
     /* 332074 */     GIR_EraseRootFromParent_Done,
     /* 332075 */   // Label 6787: @332075
     /* 332075 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(332215), // Rule ID 5646 //
     /* 332080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332123 */     // MIs[2] Operand 1
     /* 332123 */     // No operand predicates
     /* 332123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332131 */     // MIs[3] Operand 1
     /* 332131 */     // No operand predicates
     /* 332131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332133 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332145 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332148 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332152 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332155 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332214 */     // GIR_Coverage, 5646,
     /* 332214 */     GIR_EraseRootFromParent_Done,
     /* 332215 */   // Label 6788: @332215
     /* 332215 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(332386), // Rule ID 5647 //
     /* 332220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332263 */     // MIs[2] Operand 1
     /* 332263 */     // No operand predicates
     /* 332263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332271 */     // MIs[3] Operand 1
     /* 332271 */     // No operand predicates
     /* 332271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332273 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332285 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332288 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332292 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332295 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332300 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332320 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332324 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332368 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332385 */     // GIR_Coverage, 5647,
     /* 332385 */     GIR_EraseRootFromParent_Done,
     /* 332386 */   // Label 6789: @332386
     /* 332386 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(332526), // Rule ID 5670 //
     /* 332391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332434 */     // MIs[2] Operand 1
     /* 332434 */     // No operand predicates
     /* 332434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332442 */     // MIs[3] Operand 1
     /* 332442 */     // No operand predicates
     /* 332442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332444 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332456 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332466 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332471 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332508 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332525 */     // GIR_Coverage, 5670,
     /* 332525 */     GIR_EraseRootFromParent_Done,
     /* 332526 */   // Label 6790: @332526
     /* 332526 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(332697), // Rule ID 5671 //
     /* 332531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332574 */     // MIs[2] Operand 1
     /* 332574 */     // No operand predicates
     /* 332574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332582 */     // MIs[3] Operand 1
     /* 332582 */     // No operand predicates
     /* 332582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332584 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332584 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332587 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332591 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332596 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332599 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332603 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332606 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332611 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332696 */     // GIR_Coverage, 5671,
     /* 332696 */     GIR_EraseRootFromParent_Done,
     /* 332697 */   // Label 6791: @332697
     /* 332697 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(332776), // Rule ID 5601 //
     /* 332702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332730 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 332730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 332746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 332765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332775 */     // GIR_Coverage, 5601,
     /* 332775 */     GIR_EraseRootFromParent_Done,
     /* 332776 */   // Label 6792: @332776
     /* 332776 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(332852), // Rule ID 5603 //
     /* 332781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332809 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332851 */     // GIR_Coverage, 5603,
     /* 332851 */     GIR_EraseRootFromParent_Done,
     /* 332852 */   // Label 6793: @332852
     /* 332852 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(332928), // Rule ID 5613 //
     /* 332857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332885 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332927 */     // GIR_Coverage, 5613,
     /* 332927 */     GIR_EraseRootFromParent_Done,
     /* 332928 */   // Label 6794: @332928
     /* 332928 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(333073), // Rule ID 5625 //
     /* 332933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 332955 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 332959 */     // MIs[1] Operand 1
     /* 332959 */     // No operand predicates
     /* 332959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332971 */     // MIs[2] Operand 1
     /* 332971 */     // No operand predicates
     /* 332971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332973 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332973 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 332976 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332980 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 332990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332999 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333006 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 333031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 333042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 333048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333072 */     // GIR_Coverage, 5625,
     /* 333072 */     GIR_EraseRootFromParent_Done,
     /* 333073 */   // Label 6795: @333073
     /* 333073 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(333222), // Rule ID 6361 //
     /* 333078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333103 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333107 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333114 */     // MIs[1] Rn
     /* 333114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 333118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 333123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 333135 */     // MIs[2] Operand 1
     /* 333135 */     // No operand predicates
     /* 333135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333137 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 333137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333152 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 333156 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 333176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 333187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333191 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333221 */     // GIR_Coverage, 6361,
     /* 333221 */     GIR_EraseRootFromParent_Done,
     /* 333222 */   // Label 6796: @333222
     /* 333222 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(333364), // Rule ID 6364 //
     /* 333227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333256 */     // MIs[1] Rn
     /* 333256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 333260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 333265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 333277 */     // MIs[2] Operand 1
     /* 333277 */     // No operand predicates
     /* 333277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333279 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 333279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333291 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 333298 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 333318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333323 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 333329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333333 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333346 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333363 */     // GIR_Coverage, 6364,
     /* 333363 */     GIR_EraseRootFromParent_Done,
     /* 333364 */   // Label 6797: @333364
     /* 333364 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(333552), // Rule ID 5623 //
     /* 333369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 333372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333399 */     // MIs[1] Operand 1
     /* 333399 */     // No operand predicates
     /* 333399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333401 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 333401 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 333404 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333408 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333415 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 333418 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333422 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333427 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333430 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333434 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 333437 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333442 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333447 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 333510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 333524 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 333527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333534 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333551 */     // GIR_Coverage, 5623,
     /* 333551 */     GIR_EraseRootFromParent_Done,
     /* 333552 */   // Label 6798: @333552
     /* 333552 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(333687), // Rule ID 5634 //
     /* 333557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 333587 */     // MIs[1] Operand 1
     /* 333587 */     // No operand predicates
     /* 333587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333589 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 333589 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333592 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333596 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333615 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333622 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333630 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 333647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333686 */     // GIR_Coverage, 5634,
     /* 333686 */     GIR_EraseRootFromParent_Done,
     /* 333687 */   // Label 6799: @333687
     /* 333687 */   GIM_Reject,
     /* 333688 */ // Label 6770: @333688
     /* 333688 */ GIM_Reject,
     /* 333689 */ // Label 6687: @333689
     /* 333689 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(336352),
     /* 333694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333707 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(333816), // Rule ID 4202 //
     /* 333712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333732 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333739 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333756 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333815 */     // GIR_Coverage, 4202,
     /* 333815 */     GIR_EraseRootFromParent_Done,
     /* 333816 */   // Label 6801: @333816
     /* 333816 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(333925), // Rule ID 4203 //
     /* 333821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333865 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333892 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333924 */     // GIR_Coverage, 4203,
     /* 333924 */     GIR_EraseRootFromParent_Done,
     /* 333925 */   // Label 6802: @333925
     /* 333925 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(334034), // Rule ID 4310 //
     /* 333930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333934 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333940 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333950 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333957 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333974 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334033 */     // GIR_Coverage, 4310,
     /* 334033 */     GIR_EraseRootFromParent_Done,
     /* 334034 */   // Label 6803: @334034
     /* 334034 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(334143), // Rule ID 4311 //
     /* 334039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334059 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334066 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334083 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334142 */     // GIR_Coverage, 4311,
     /* 334142 */     GIR_EraseRootFromParent_Done,
     /* 334143 */   // Label 6804: @334143
     /* 334143 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(334248), // Rule ID 4208 //
     /* 334148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334188 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334247 */     // GIR_Coverage, 4208,
     /* 334247 */     GIR_EraseRootFromParent_Done,
     /* 334248 */   // Label 6805: @334248
     /* 334248 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(334353), // Rule ID 4210 //
     /* 334253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334269 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334276 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334293 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334352 */     // GIR_Coverage, 4210,
     /* 334352 */     GIR_EraseRootFromParent_Done,
     /* 334353 */   // Label 6806: @334353
     /* 334353 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(334458), // Rule ID 4316 //
     /* 334358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334374 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334381 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334398 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334457 */     // GIR_Coverage, 4316,
     /* 334457 */     GIR_EraseRootFromParent_Done,
     /* 334458 */   // Label 6807: @334458
     /* 334458 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(334563), // Rule ID 4318 //
     /* 334463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334479 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334503 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334562 */     // GIR_Coverage, 4318,
     /* 334562 */     GIR_EraseRootFromParent_Done,
     /* 334563 */   // Label 6808: @334563
     /* 334563 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(334667), // Rule ID 4200 //
     /* 334568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334578 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334588 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334595 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334612 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334634 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334666 */     // GIR_Coverage, 4200,
     /* 334666 */     GIR_EraseRootFromParent_Done,
     /* 334667 */   // Label 6809: @334667
     /* 334667 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(334771), // Rule ID 4201 //
     /* 334672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334676 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334682 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334692 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334699 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334716 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334770 */     // GIR_Coverage, 4201,
     /* 334770 */     GIR_EraseRootFromParent_Done,
     /* 334771 */   // Label 6810: @334771
     /* 334771 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(334875), // Rule ID 4308 //
     /* 334776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334786 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334796 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334803 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334820 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334842 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334874 */     // GIR_Coverage, 4308,
     /* 334874 */     GIR_EraseRootFromParent_Done,
     /* 334875 */   // Label 6811: @334875
     /* 334875 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(334979), // Rule ID 4309 //
     /* 334880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334884 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334890 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334900 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334924 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334978 */     // GIR_Coverage, 4309,
     /* 334978 */     GIR_EraseRootFromParent_Done,
     /* 334979 */   // Label 6812: @334979
     /* 334979 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(335079), // Rule ID 4204 //
     /* 334984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335007 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335024 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335078 */     // GIR_Coverage, 4204,
     /* 335078 */     GIR_EraseRootFromParent_Done,
     /* 335079 */   // Label 6813: @335079
     /* 335079 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(335179), // Rule ID 4206 //
     /* 335084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335100 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335107 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335124 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335146 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335178 */     // GIR_Coverage, 4206,
     /* 335178 */     GIR_EraseRootFromParent_Done,
     /* 335179 */   // Label 6814: @335179
     /* 335179 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(335279), // Rule ID 4312 //
     /* 335184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335200 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335224 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335246 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335278 */     // GIR_Coverage, 4312,
     /* 335278 */     GIR_EraseRootFromParent_Done,
     /* 335279 */   // Label 6815: @335279
     /* 335279 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(335379), // Rule ID 4314 //
     /* 335284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335300 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335307 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335324 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335378 */     // GIR_Coverage, 4314,
     /* 335378 */     GIR_EraseRootFromParent_Done,
     /* 335379 */   // Label 6816: @335379
     /* 335379 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(335457), // Rule ID 1933 //
     /* 335384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335424 */     // MIs[2] Operand 1
     /* 335424 */     // No operand predicates
     /* 335424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335432 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335436 */     // MIs[3] Operand 1
     /* 335436 */     // No operand predicates
     /* 335436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335438 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 335438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 335448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 335455 */     GIR_RootConstrainSelectedInstOperands,
     /* 335456 */     // GIR_Coverage, 1933,
     /* 335456 */     GIR_EraseRootFromParent_Done,
     /* 335457 */   // Label 6817: @335457
     /* 335457 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(335524), // Rule ID 5650 //
     /* 335462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335495 */     // MIs[2] Operand 1
     /* 335495 */     // No operand predicates
     /* 335495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335503 */     // MIs[3] Operand 1
     /* 335503 */     // No operand predicates
     /* 335503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335505 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335522 */     GIR_RootConstrainSelectedInstOperands,
     /* 335523 */     // GIR_Coverage, 5650,
     /* 335523 */     GIR_EraseRootFromParent_Done,
     /* 335524 */   // Label 6818: @335524
     /* 335524 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(335622), // Rule ID 5651 //
     /* 335529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335562 */     // MIs[2] Operand 1
     /* 335562 */     // No operand predicates
     /* 335562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335570 */     // MIs[3] Operand 1
     /* 335570 */     // No operand predicates
     /* 335570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335572 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335620 */     GIR_RootConstrainSelectedInstOperands,
     /* 335621 */     // GIR_Coverage, 5651,
     /* 335621 */     GIR_EraseRootFromParent_Done,
     /* 335622 */   // Label 6819: @335622
     /* 335622 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(335689), // Rule ID 5674 //
     /* 335627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335660 */     // MIs[2] Operand 1
     /* 335660 */     // No operand predicates
     /* 335660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335668 */     // MIs[3] Operand 1
     /* 335668 */     // No operand predicates
     /* 335668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335670 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335687 */     GIR_RootConstrainSelectedInstOperands,
     /* 335688 */     // GIR_Coverage, 5674,
     /* 335688 */     GIR_EraseRootFromParent_Done,
     /* 335689 */   // Label 6820: @335689
     /* 335689 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(335787), // Rule ID 5675 //
     /* 335694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335727 */     // MIs[2] Operand 1
     /* 335727 */     // No operand predicates
     /* 335727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335735 */     // MIs[3] Operand 1
     /* 335735 */     // No operand predicates
     /* 335735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335737 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335749 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335785 */     GIR_RootConstrainSelectedInstOperands,
     /* 335786 */     // GIR_Coverage, 5675,
     /* 335786 */     GIR_EraseRootFromParent_Done,
     /* 335787 */   // Label 6821: @335787
     /* 335787 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(335853), // Rule ID 5609 //
     /* 335792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335810 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 335810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335852 */     // GIR_Coverage, 5609,
     /* 335852 */     GIR_EraseRootFromParent_Done,
     /* 335853 */   // Label 6822: @335853
     /* 335853 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(335919), // Rule ID 5617 //
     /* 335858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335876 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 335876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335918 */     // GIR_Coverage, 5617,
     /* 335918 */     GIR_EraseRootFromParent_Done,
     /* 335919 */   // Label 6823: @335919
     /* 335919 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(335972), // Rule ID 5626 //
     /* 335924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 335936 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 335940 */     // MIs[1] Operand 1
     /* 335940 */     // No operand predicates
     /* 335940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335948 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335952 */     // MIs[2] Operand 1
     /* 335952 */     // No operand predicates
     /* 335952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335954 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 335954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 335957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 335961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 335964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 335970 */     GIR_RootConstrainSelectedInstOperands,
     /* 335971 */     // GIR_Coverage, 5626,
     /* 335971 */     GIR_EraseRootFromParent_Done,
     /* 335972 */   // Label 6824: @335972
     /* 335972 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(336041), // Rule ID 6343 //
     /* 335977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335989 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335996 */     // MIs[1] Rn
     /* 335996 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336013 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336017 */     // MIs[2] Operand 1
     /* 336017 */     // No operand predicates
     /* 336017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336019 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 336019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 336022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 336029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336039 */     GIR_RootConstrainSelectedInstOperands,
     /* 336040 */     // GIR_Coverage, 6343,
     /* 336040 */     GIR_EraseRootFromParent_Done,
     /* 336041 */   // Label 6825: @336041
     /* 336041 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(336110), // Rule ID 6344 //
     /* 336046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336065 */     // MIs[1] Rn
     /* 336065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336082 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336086 */     // MIs[2] Operand 1
     /* 336086 */     // No operand predicates
     /* 336086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336088 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 336088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 336091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 336098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336108 */     GIR_RootConstrainSelectedInstOperands,
     /* 336109 */     // GIR_Coverage, 6344,
     /* 336109 */     GIR_EraseRootFromParent_Done,
     /* 336110 */   // Label 6826: @336110
     /* 336110 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(336211), // Rule ID 5684 //
     /* 336115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 336123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 336127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336140 */     // MIs[2] Operand 1
     /* 336140 */     // No operand predicates
     /* 336140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336142 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 336142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 336175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 336178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 336200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 336203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336209 */     GIR_RootConstrainSelectedInstOperands,
     /* 336210 */     // GIR_Coverage, 5684,
     /* 336210 */     GIR_EraseRootFromParent_Done,
     /* 336211 */   // Label 6827: @336211
     /* 336211 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(336255), // Rule ID 1929 //
     /* 336216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 336231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336239 */     // MIs[1] Operand 1
     /* 336239 */     // No operand predicates
     /* 336239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336241 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 336241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 336244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 336251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336253 */     GIR_RootConstrainSelectedInstOperands,
     /* 336254 */     // GIR_Coverage, 1929,
     /* 336254 */     GIR_EraseRootFromParent_Done,
     /* 336255 */   // Label 6828: @336255
     /* 336255 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(336351), // Rule ID 5631 //
     /* 336260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 336272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336280 */     // MIs[1] Operand 1
     /* 336280 */     // No operand predicates
     /* 336280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336282 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 336282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 336285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 336299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336308 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 336315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 336318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 336340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 336343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336349 */     GIR_RootConstrainSelectedInstOperands,
     /* 336350 */     // GIR_Coverage, 5631,
     /* 336350 */     GIR_EraseRootFromParent_Done,
     /* 336351 */   // Label 6829: @336351
     /* 336351 */   GIM_Reject,
     /* 336352 */ // Label 6800: @336352
     /* 336352 */ GIM_Reject,
     /* 336353 */ // Label 6688: @336353
     /* 336353 */ GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(338196),
     /* 336358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 336361 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(336487), // Rule ID 4142 //
     /* 336366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336380 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336386 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336396 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336399 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336403 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336427 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336454 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336486 */     // GIR_Coverage, 4142,
     /* 336486 */     GIR_EraseRootFromParent_Done,
     /* 336487 */   // Label 6831: @336487
     /* 336487 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(336613), // Rule ID 4143 //
     /* 336492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336506 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336512 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336525 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336529 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336553 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336580 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336612 */     // GIR_Coverage, 4143,
     /* 336612 */     GIR_EraseRootFromParent_Done,
     /* 336613 */   // Label 6832: @336613
     /* 336613 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(336735), // Rule ID 4148 //
     /* 336618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336644 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336647 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336651 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336658 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336675 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336734 */     // GIR_Coverage, 4148,
     /* 336734 */     GIR_EraseRootFromParent_Done,
     /* 336735 */   // Label 6833: @336735
     /* 336735 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(336857), // Rule ID 4150 //
     /* 336740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336766 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336769 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336773 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336780 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336797 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336856 */     // GIR_Coverage, 4150,
     /* 336856 */     GIR_EraseRootFromParent_Done,
     /* 336857 */   // Label 6834: @336857
     /* 336857 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(336978), // Rule ID 4140 //
     /* 336862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336892 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336895 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336899 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336906 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336923 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 336923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336977 */     // GIR_Coverage, 4140,
     /* 336977 */     GIR_EraseRootFromParent_Done,
     /* 336978 */   // Label 6835: @336978
     /* 336978 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(337099), // Rule ID 4141 //
     /* 336983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337013 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337016 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337020 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337027 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337037 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 337044 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 337044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 337047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 337051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337066 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 337088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337098 */     // GIR_Coverage, 4141,
     /* 337098 */     GIR_EraseRootFromParent_Done,
     /* 337099 */   // Label 6836: @337099
     /* 337099 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(337216), // Rule ID 4144 //
     /* 337104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337130 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337133 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337137 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337144 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 337161 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 337161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 337164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 337168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 337205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337215 */     // GIR_Coverage, 4144,
     /* 337215 */     GIR_EraseRootFromParent_Done,
     /* 337216 */   // Label 6837: @337216
     /* 337216 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(337333), // Rule ID 4146 //
     /* 337221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337247 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337250 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337254 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337261 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 337278 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 337278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 337281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 337285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337300 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 337322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337332 */     // GIR_Coverage, 4146,
     /* 337332 */     GIR_EraseRootFromParent_Done,
     /* 337333 */   // Label 6838: @337333
     /* 337333 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(337473), // Rule ID 5664 //
     /* 337338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 337364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337381 */     // MIs[2] Operand 1
     /* 337381 */     // No operand predicates
     /* 337381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337389 */     // MIs[3] Operand 1
     /* 337389 */     // No operand predicates
     /* 337389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337391 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337403 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337410 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337455 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337472 */     // GIR_Coverage, 5664,
     /* 337472 */     GIR_EraseRootFromParent_Done,
     /* 337473 */   // Label 6839: @337473
     /* 337473 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(337644), // Rule ID 5665 //
     /* 337478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 337504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337521 */     // MIs[2] Operand 1
     /* 337521 */     // No operand predicates
     /* 337521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337529 */     // MIs[3] Operand 1
     /* 337529 */     // No operand predicates
     /* 337529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337531 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337531 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337534 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337538 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337543 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337546 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337553 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337558 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337626 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337643 */     // GIR_Coverage, 5665,
     /* 337643 */     GIR_EraseRootFromParent_Done,
     /* 337644 */   // Label 6840: @337644
     /* 337644 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(337723), // Rule ID 5596 //
     /* 337649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337677 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 337677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 337693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337722 */     // GIR_Coverage, 5596,
     /* 337722 */     GIR_EraseRootFromParent_Done,
     /* 337723 */   // Label 6841: @337723
     /* 337723 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(337872), // Rule ID 6360 //
     /* 337728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337753 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337757 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337764 */     // MIs[1] Rn
     /* 337764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337785 */     // MIs[2] Operand 1
     /* 337785 */     // No operand predicates
     /* 337785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337787 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337799 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337806 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 337826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337854 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337871 */     // GIR_Coverage, 6360,
     /* 337871 */     GIR_EraseRootFromParent_Done,
     /* 337872 */   // Label 6842: @337872
     /* 337872 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(338007), // Rule ID 5635 //
     /* 337877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337907 */     // MIs[1] Operand 1
     /* 337907 */     // No operand predicates
     /* 337907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337909 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 337912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337935 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337942 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337955 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 337967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337972 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338006 */     // GIR_Coverage, 5635,
     /* 338006 */     GIR_EraseRootFromParent_Done,
     /* 338007 */   // Label 6843: @338007
     /* 338007 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(338195), // Rule ID 5636 //
     /* 338012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 338015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 338034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 338042 */     // MIs[1] Operand 1
     /* 338042 */     // No operand predicates
     /* 338042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338044 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 338044 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 338047 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338051 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 338058 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 338061 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338065 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338070 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 338073 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 338077 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 338080 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338085 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338090 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338095 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 338098 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338102 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338109 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 338112 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338116 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338121 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 338124 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 338128 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 338153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 338164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 338167 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338194 */     // GIR_Coverage, 5636,
     /* 338194 */     GIR_EraseRootFromParent_Done,
     /* 338195 */   // Label 6844: @338195
     /* 338195 */   GIM_Reject,
     /* 338196 */ // Label 6830: @338196
     /* 338196 */ GIM_Reject,
     /* 338197 */ // Label 6689: @338197
     /* 338197 */ GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(341171),
     /* 338202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 338205 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(338331), // Rule ID 4166 //
     /* 338210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338224 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338230 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338240 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338243 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338247 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338254 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338271 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338330 */     // GIR_Coverage, 4166,
     /* 338330 */     GIR_EraseRootFromParent_Done,
     /* 338331 */   // Label 6846: @338331
     /* 338331 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(338457), // Rule ID 4167 //
     /* 338336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338350 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338356 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338366 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338369 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338373 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338380 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338397 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338424 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338456 */     // GIR_Coverage, 4167,
     /* 338456 */     GIR_EraseRootFromParent_Done,
     /* 338457 */   // Label 6847: @338457
     /* 338457 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(338576), // Rule ID 4274 //
     /* 338462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338476 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338482 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338492 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338499 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338516 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338543 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338575 */     // GIR_Coverage, 4274,
     /* 338575 */     GIR_EraseRootFromParent_Done,
     /* 338576 */   // Label 6848: @338576
     /* 338576 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(338695), // Rule ID 4275 //
     /* 338581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338618 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338635 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338662 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338694 */     // GIR_Coverage, 4275,
     /* 338694 */     GIR_EraseRootFromParent_Done,
     /* 338695 */   // Label 6849: @338695
     /* 338695 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(338817), // Rule ID 4172 //
     /* 338700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338726 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338729 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338733 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338740 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338757 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338784 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338816 */     // GIR_Coverage, 4172,
     /* 338816 */     GIR_EraseRootFromParent_Done,
     /* 338817 */   // Label 6850: @338817
     /* 338817 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(338939), // Rule ID 4174 //
     /* 338822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338848 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338851 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338855 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338862 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338879 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338906 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338938 */     // GIR_Coverage, 4174,
     /* 338938 */     GIR_EraseRootFromParent_Done,
     /* 338939 */   // Label 6851: @338939
     /* 338939 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(339054), // Rule ID 4280 //
     /* 338944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338970 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338977 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338994 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 339001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339021 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339053 */     // GIR_Coverage, 4280,
     /* 339053 */     GIR_EraseRootFromParent_Done,
     /* 339054 */   // Label 6852: @339054
     /* 339054 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(339169), // Rule ID 4282 //
     /* 339059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339085 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 339109 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 339109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 339116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339136 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339168 */     // GIR_Coverage, 4282,
     /* 339168 */     GIR_EraseRootFromParent_Done,
     /* 339169 */   // Label 6853: @339169
     /* 339169 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(339290), // Rule ID 4164 //
     /* 339174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339188 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339194 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339204 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339207 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339211 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339218 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339235 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339257 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339289 */     // GIR_Coverage, 4164,
     /* 339289 */     GIR_EraseRootFromParent_Done,
     /* 339290 */   // Label 6854: @339290
     /* 339290 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(339411), // Rule ID 4165 //
     /* 339295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339309 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339315 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339325 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339328 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339332 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339339 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339356 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339378 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339410 */     // GIR_Coverage, 4165,
     /* 339410 */     GIR_EraseRootFromParent_Done,
     /* 339411 */   // Label 6855: @339411
     /* 339411 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(339525), // Rule ID 4272 //
     /* 339416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339430 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339436 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339446 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339453 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339470 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339524 */     // GIR_Coverage, 4272,
     /* 339524 */     GIR_EraseRootFromParent_Done,
     /* 339525 */   // Label 6856: @339525
     /* 339525 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(339639), // Rule ID 4273 //
     /* 339530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339584 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339638 */     // GIR_Coverage, 4273,
     /* 339638 */     GIR_EraseRootFromParent_Done,
     /* 339639 */   // Label 6857: @339639
     /* 339639 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(339756), // Rule ID 4168 //
     /* 339644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339670 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339673 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339677 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339684 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339701 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339755 */     // GIR_Coverage, 4168,
     /* 339755 */     GIR_EraseRootFromParent_Done,
     /* 339756 */   // Label 6858: @339756
     /* 339756 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(339873), // Rule ID 4170 //
     /* 339761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339787 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339790 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339794 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339801 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339818 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339872 */     // GIR_Coverage, 4170,
     /* 339872 */     GIR_EraseRootFromParent_Done,
     /* 339873 */   // Label 6859: @339873
     /* 339873 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(339983), // Rule ID 4276 //
     /* 339878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339904 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339928 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339982 */     // GIR_Coverage, 4276,
     /* 339982 */     GIR_EraseRootFromParent_Done,
     /* 339983 */   // Label 6860: @339983
     /* 339983 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(340093), // Rule ID 4278 //
     /* 339988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340014 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340021 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 340038 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 340038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 340045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340060 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340092 */     // GIR_Coverage, 4278,
     /* 340092 */     GIR_EraseRootFromParent_Done,
     /* 340093 */   // Label 6861: @340093
     /* 340093 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(340181), // Rule ID 1932 //
     /* 340098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340148 */     // MIs[2] Operand 1
     /* 340148 */     // No operand predicates
     /* 340148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340156 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340160 */     // MIs[3] Operand 1
     /* 340160 */     // No operand predicates
     /* 340160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340162 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 340162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 340172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 340179 */     GIR_RootConstrainSelectedInstOperands,
     /* 340180 */     // GIR_Coverage, 1932,
     /* 340180 */     GIR_EraseRootFromParent_Done,
     /* 340181 */   // Label 6862: @340181
     /* 340181 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(340258), // Rule ID 5644 //
     /* 340186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340229 */     // MIs[2] Operand 1
     /* 340229 */     // No operand predicates
     /* 340229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340237 */     // MIs[3] Operand 1
     /* 340237 */     // No operand predicates
     /* 340237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340239 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 340239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340244 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340256 */     GIR_RootConstrainSelectedInstOperands,
     /* 340257 */     // GIR_Coverage, 5644,
     /* 340257 */     GIR_EraseRootFromParent_Done,
     /* 340258 */   // Label 6863: @340258
     /* 340258 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(340366), // Rule ID 5645 //
     /* 340263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340306 */     // MIs[2] Operand 1
     /* 340306 */     // No operand predicates
     /* 340306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340314 */     // MIs[3] Operand 1
     /* 340314 */     // No operand predicates
     /* 340314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340316 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340364 */     GIR_RootConstrainSelectedInstOperands,
     /* 340365 */     // GIR_Coverage, 5645,
     /* 340365 */     GIR_EraseRootFromParent_Done,
     /* 340366 */   // Label 6864: @340366
     /* 340366 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(340443), // Rule ID 5668 //
     /* 340371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340414 */     // MIs[2] Operand 1
     /* 340414 */     // No operand predicates
     /* 340414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340422 */     // MIs[3] Operand 1
     /* 340422 */     // No operand predicates
     /* 340422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340424 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 340424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340441 */     GIR_RootConstrainSelectedInstOperands,
     /* 340442 */     // GIR_Coverage, 5668,
     /* 340442 */     GIR_EraseRootFromParent_Done,
     /* 340443 */   // Label 6865: @340443
     /* 340443 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(340551), // Rule ID 5669 //
     /* 340448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340491 */     // MIs[2] Operand 1
     /* 340491 */     // No operand predicates
     /* 340491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340499 */     // MIs[3] Operand 1
     /* 340499 */     // No operand predicates
     /* 340499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340501 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340513 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340520 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340549 */     GIR_RootConstrainSelectedInstOperands,
     /* 340550 */     // GIR_Coverage, 5669,
     /* 340550 */     GIR_EraseRootFromParent_Done,
     /* 340551 */   // Label 6866: @340551
     /* 340551 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(340630), // Rule ID 5599 //
     /* 340556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340584 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 340584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 340600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340629 */     // GIR_Coverage, 5599,
     /* 340629 */     GIR_EraseRootFromParent_Done,
     /* 340630 */   // Label 6867: @340630
     /* 340630 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(340706), // Rule ID 5605 //
     /* 340635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340663 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340705 */     // GIR_Coverage, 5605,
     /* 340705 */     GIR_EraseRootFromParent_Done,
     /* 340706 */   // Label 6868: @340706
     /* 340706 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(340782), // Rule ID 5615 //
     /* 340711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340739 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340781 */     // GIR_Coverage, 5615,
     /* 340781 */     GIR_EraseRootFromParent_Done,
     /* 340782 */   // Label 6869: @340782
     /* 340782 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(340845), // Rule ID 5624 //
     /* 340787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340809 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340813 */     // MIs[1] Operand 1
     /* 340813 */     // No operand predicates
     /* 340813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340825 */     // MIs[2] Operand 1
     /* 340825 */     // No operand predicates
     /* 340825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340827 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 340827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340843 */     GIR_RootConstrainSelectedInstOperands,
     /* 340844 */     // GIR_Coverage, 5624,
     /* 340844 */     GIR_EraseRootFromParent_Done,
     /* 340845 */   // Label 6870: @340845
     /* 340845 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(340931), // Rule ID 6342 //
     /* 340850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340875 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340879 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340886 */     // MIs[1] Rn
     /* 340886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340903 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340907 */     // MIs[2] Operand 1
     /* 340907 */     // No operand predicates
     /* 340907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340909 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340929 */     GIR_RootConstrainSelectedInstOperands,
     /* 340930 */     // GIR_Coverage, 6342,
     /* 340930 */     GIR_EraseRootFromParent_Done,
     /* 340931 */   // Label 6871: @340931
     /* 340931 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(341010), // Rule ID 6347 //
     /* 340936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340965 */     // MIs[1] Rn
     /* 340965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340982 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340986 */     // MIs[2] Operand 1
     /* 340986 */     // No operand predicates
     /* 340986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340988 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341008 */     GIR_RootConstrainSelectedInstOperands,
     /* 341009 */     // GIR_Coverage, 6347,
     /* 341009 */     GIR_EraseRootFromParent_Done,
     /* 341010 */   // Label 6872: @341010
     /* 341010 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(341064), // Rule ID 1928 //
     /* 341015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 341040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 341048 */     // MIs[1] Operand 1
     /* 341048 */     // No operand predicates
     /* 341048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341050 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 341050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 341053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 341060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 341062 */     GIR_RootConstrainSelectedInstOperands,
     /* 341063 */     // GIR_Coverage, 1928,
     /* 341063 */     GIR_EraseRootFromParent_Done,
     /* 341064 */   // Label 6873: @341064
     /* 341064 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(341170), // Rule ID 5629 //
     /* 341069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 341091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 341099 */     // MIs[1] Operand 1
     /* 341099 */     // No operand predicates
     /* 341099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341101 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 341101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 341104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 341118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 341134 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 341137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 341155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 341162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341168 */     GIR_RootConstrainSelectedInstOperands,
     /* 341169 */     // GIR_Coverage, 5629,
     /* 341169 */     GIR_EraseRootFromParent_Done,
     /* 341170 */   // Label 6874: @341170
     /* 341170 */   GIM_Reject,
     /* 341171 */ // Label 6845: @341171
     /* 341171 */ GIM_Reject,
     /* 341172 */ // Label 6690: @341172
     /* 341172 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(342751),
     /* 341177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 341180 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(341306), // Rule ID 4130 //
     /* 341185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341199 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341205 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341215 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341218 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341222 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 341246 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 341253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341305 */     // GIR_Coverage, 4130,
     /* 341305 */     GIR_EraseRootFromParent_Done,
     /* 341306 */   // Label 6876: @341306
     /* 341306 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(341432), // Rule ID 4131 //
     /* 341311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341325 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341331 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341344 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341348 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 341372 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 341379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341431 */     // GIR_Coverage, 4131,
     /* 341431 */     GIR_EraseRootFromParent_Done,
     /* 341432 */   // Label 6877: @341432
     /* 341432 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(341554), // Rule ID 4136 //
     /* 341437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341463 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341466 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341470 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341477 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 341494 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 341501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341521 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341553 */     // GIR_Coverage, 4136,
     /* 341553 */     GIR_EraseRootFromParent_Done,
     /* 341554 */   // Label 6878: @341554
     /* 341554 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(341676), // Rule ID 4138 //
     /* 341559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341585 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341588 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341592 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341599 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 341616 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 341623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341643 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341675 */     // GIR_Coverage, 4138,
     /* 341675 */     GIR_EraseRootFromParent_Done,
     /* 341676 */   // Label 6879: @341676
     /* 341676 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(341797), // Rule ID 4128 //
     /* 341681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341711 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341714 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341718 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341725 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341742 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341764 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341796 */     // GIR_Coverage, 4128,
     /* 341796 */     GIR_EraseRootFromParent_Done,
     /* 341797 */   // Label 6880: @341797
     /* 341797 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(341918), // Rule ID 4129 //
     /* 341802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341816 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341822 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341832 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341835 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341839 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341863 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 341863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341917 */     // GIR_Coverage, 4129,
     /* 341917 */     GIR_EraseRootFromParent_Done,
     /* 341918 */   // Label 6881: @341918
     /* 341918 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(342035), // Rule ID 4132 //
     /* 341923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341949 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341952 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341956 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341980 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342002 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 342024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342034 */     // GIR_Coverage, 4132,
     /* 342034 */     GIR_EraseRootFromParent_Done,
     /* 342035 */   // Label 6882: @342035
     /* 342035 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(342152), // Rule ID 4134 //
     /* 342040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342066 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342069 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342073 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342080 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 342097 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 342097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 342100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 342104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342119 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 342141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342151 */     // GIR_Coverage, 4134,
     /* 342151 */     GIR_EraseRootFromParent_Done,
     /* 342152 */   // Label 6883: @342152
     /* 342152 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(342240), // Rule ID 1931 //
     /* 342157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 342186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342207 */     // MIs[2] Operand 1
     /* 342207 */     // No operand predicates
     /* 342207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342215 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342219 */     // MIs[3] Operand 1
     /* 342219 */     // No operand predicates
     /* 342219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342221 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 342221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 342238 */     GIR_RootConstrainSelectedInstOperands,
     /* 342239 */     // GIR_Coverage, 1931,
     /* 342239 */     GIR_EraseRootFromParent_Done,
     /* 342240 */   // Label 6884: @342240
     /* 342240 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(342317), // Rule ID 5662 //
     /* 342245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 342271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342288 */     // MIs[2] Operand 1
     /* 342288 */     // No operand predicates
     /* 342288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342296 */     // MIs[3] Operand 1
     /* 342296 */     // No operand predicates
     /* 342296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342298 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 342298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342315 */     GIR_RootConstrainSelectedInstOperands,
     /* 342316 */     // GIR_Coverage, 5662,
     /* 342316 */     GIR_EraseRootFromParent_Done,
     /* 342317 */   // Label 6885: @342317
     /* 342317 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(342425), // Rule ID 5663 //
     /* 342322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 342348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342365 */     // MIs[2] Operand 1
     /* 342365 */     // No operand predicates
     /* 342365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342373 */     // MIs[3] Operand 1
     /* 342373 */     // No operand predicates
     /* 342373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342375 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 342375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342387 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342423 */     GIR_RootConstrainSelectedInstOperands,
     /* 342424 */     // GIR_Coverage, 5663,
     /* 342424 */     GIR_EraseRootFromParent_Done,
     /* 342425 */   // Label 6886: @342425
     /* 342425 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(342504), // Rule ID 5594 //
     /* 342430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342458 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 342458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 342474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342503 */     // GIR_Coverage, 5594,
     /* 342503 */     GIR_EraseRootFromParent_Done,
     /* 342504 */   // Label 6887: @342504
     /* 342504 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(342590), // Rule ID 6341 //
     /* 342509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342534 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342538 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342545 */     // MIs[1] Rn
     /* 342545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342562 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342566 */     // MIs[2] Operand 1
     /* 342566 */     // No operand predicates
     /* 342566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342568 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342588 */     GIR_RootConstrainSelectedInstOperands,
     /* 342589 */     // GIR_Coverage, 6341,
     /* 342589 */     GIR_EraseRootFromParent_Done,
     /* 342590 */   // Label 6888: @342590
     /* 342590 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(342644), // Rule ID 1927 //
     /* 342595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342628 */     // MIs[1] Operand 1
     /* 342628 */     // No operand predicates
     /* 342628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342630 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 342630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 342633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 342640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342642 */     GIR_RootConstrainSelectedInstOperands,
     /* 342643 */     // GIR_Coverage, 1927,
     /* 342643 */     GIR_EraseRootFromParent_Done,
     /* 342644 */   // Label 6889: @342644
     /* 342644 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(342750), // Rule ID 5637 //
     /* 342649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 342652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342679 */     // MIs[1] Operand 1
     /* 342679 */     // No operand predicates
     /* 342679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342681 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 342698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 342714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 342717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 342742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342748 */     GIR_RootConstrainSelectedInstOperands,
     /* 342749 */     // GIR_Coverage, 5637,
     /* 342749 */     GIR_EraseRootFromParent_Done,
     /* 342750 */   // Label 6890: @342750
     /* 342750 */   GIM_Reject,
     /* 342751 */ // Label 6875: @342751
     /* 342751 */ GIM_Reject,
     /* 342752 */ // Label 6691: @342752
     /* 342752 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(342876), // Rule ID 11026 //
     /* 342757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 342763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342766 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342781 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 342781 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342784 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342788 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342793 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342811 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342814 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342831 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342848 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342851 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342854 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342857 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 342865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342867 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342872 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342874 */   GIR_RootConstrainSelectedInstOperands,
     /* 342875 */   // GIR_Coverage, 11026,
     /* 342875 */   GIR_EraseRootFromParent_Done,
     /* 342876 */ // Label 6891: @342876
     /* 342876 */ GIM_Reject,
     /* 342877 */ // Label 6692: @342877
     /* 342877 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(343001), // Rule ID 11029 //
     /* 342882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 342888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342902 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342906 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 342906 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342909 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342913 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342918 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342924 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342927 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342931 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342936 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342939 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342944 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342947 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342951 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342956 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342973 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342976 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342979 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342982 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 342990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342992 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342997 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342999 */   GIR_RootConstrainSelectedInstOperands,
     /* 343000 */   // GIR_Coverage, 11029,
     /* 343000 */   GIR_EraseRootFromParent_Done,
     /* 343001 */ // Label 6892: @343001
     /* 343001 */ GIM_Reject,
     /* 343002 */ // Label 6693: @343002
     /* 343002 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(344915),
     /* 343007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 343010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343020 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(343129), // Rule ID 4262 //
     /* 343025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343029 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343035 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343045 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343052 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343069 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343096 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343128 */     // GIR_Coverage, 4262,
     /* 343128 */     GIR_EraseRootFromParent_Done,
     /* 343129 */   // Label 6894: @343129
     /* 343129 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(343238), // Rule ID 4263 //
     /* 343134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343138 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343144 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343154 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343161 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343178 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343237 */     // GIR_Coverage, 4263,
     /* 343237 */     GIR_EraseRootFromParent_Done,
     /* 343238 */   // Label 6895: @343238
     /* 343238 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(343347), // Rule ID 4370 //
     /* 343243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343247 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343253 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343263 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343287 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343346 */     // GIR_Coverage, 4370,
     /* 343346 */     GIR_EraseRootFromParent_Done,
     /* 343347 */   // Label 6896: @343347
     /* 343347 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(343456), // Rule ID 4371 //
     /* 343352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343372 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343379 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343396 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343455 */     // GIR_Coverage, 4371,
     /* 343455 */     GIR_EraseRootFromParent_Done,
     /* 343456 */   // Label 6897: @343456
     /* 343456 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(343561), // Rule ID 4268 //
     /* 343461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343477 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343484 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343501 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343528 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343560 */     // GIR_Coverage, 4268,
     /* 343560 */     GIR_EraseRootFromParent_Done,
     /* 343561 */   // Label 6898: @343561
     /* 343561 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(343666), // Rule ID 4270 //
     /* 343566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343582 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343606 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343633 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343665 */     // GIR_Coverage, 4270,
     /* 343665 */     GIR_EraseRootFromParent_Done,
     /* 343666 */   // Label 6899: @343666
     /* 343666 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(343771), // Rule ID 4376 //
     /* 343671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343694 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343711 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343770 */     // GIR_Coverage, 4376,
     /* 343770 */     GIR_EraseRootFromParent_Done,
     /* 343771 */   // Label 6900: @343771
     /* 343771 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(343876), // Rule ID 4378 //
     /* 343776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343816 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343875 */     // GIR_Coverage, 4378,
     /* 343875 */     GIR_EraseRootFromParent_Done,
     /* 343876 */   // Label 6901: @343876
     /* 343876 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(343980), // Rule ID 4260 //
     /* 343881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343885 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343891 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343901 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343908 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343925 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343947 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343979 */     // GIR_Coverage, 4260,
     /* 343979 */     GIR_EraseRootFromParent_Done,
     /* 343980 */   // Label 6902: @343980
     /* 343980 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(344084), // Rule ID 4261 //
     /* 343985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343989 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343995 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344029 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344083 */     // GIR_Coverage, 4261,
     /* 344083 */     GIR_EraseRootFromParent_Done,
     /* 344084 */   // Label 6903: @344084
     /* 344084 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(344188), // Rule ID 4368 //
     /* 344089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344109 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344116 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 344133 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 344133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 344140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344155 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344187 */     // GIR_Coverage, 4368,
     /* 344187 */     GIR_EraseRootFromParent_Done,
     /* 344188 */   // Label 6904: @344188
     /* 344188 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(344292), // Rule ID 4369 //
     /* 344193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344213 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344237 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344259 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344291 */     // GIR_Coverage, 4369,
     /* 344291 */     GIR_EraseRootFromParent_Done,
     /* 344292 */   // Label 6905: @344292
     /* 344292 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(344392), // Rule ID 4264 //
     /* 344297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344313 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344320 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 344337 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 344337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 344344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344359 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344391 */     // GIR_Coverage, 4264,
     /* 344391 */     GIR_EraseRootFromParent_Done,
     /* 344392 */   // Label 6906: @344392
     /* 344392 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(344492), // Rule ID 4266 //
     /* 344397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344437 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344459 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344491 */     // GIR_Coverage, 4266,
     /* 344491 */     GIR_EraseRootFromParent_Done,
     /* 344492 */   // Label 6907: @344492
     /* 344492 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(344592), // Rule ID 4372 //
     /* 344497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344520 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 344537 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 344537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 344544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344559 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344591 */     // GIR_Coverage, 4372,
     /* 344591 */     GIR_EraseRootFromParent_Done,
     /* 344592 */   // Label 6908: @344592
     /* 344592 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(344692), // Rule ID 4374 //
     /* 344597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344613 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344620 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344637 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344659 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344691 */     // GIR_Coverage, 4374,
     /* 344691 */     GIR_EraseRootFromParent_Done,
     /* 344692 */   // Label 6909: @344692
     /* 344692 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(344803), // Rule ID 11025 //
     /* 344697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344708 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 344708 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344711 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344715 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344720 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344741 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344758 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344784 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 344792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344794 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344801 */     GIR_RootConstrainSelectedInstOperands,
     /* 344802 */     // GIR_Coverage, 11025,
     /* 344802 */     GIR_EraseRootFromParent_Done,
     /* 344803 */   // Label 6910: @344803
     /* 344803 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(344914), // Rule ID 11031 //
     /* 344808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344819 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 344819 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344822 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344826 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344831 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344837 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344840 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344844 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344849 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344852 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344869 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344895 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 344903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344905 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344912 */     GIR_RootConstrainSelectedInstOperands,
     /* 344913 */     // GIR_Coverage, 11031,
     /* 344913 */     GIR_EraseRootFromParent_Done,
     /* 344914 */   // Label 6911: @344914
     /* 344914 */   GIM_Reject,
     /* 344915 */ // Label 6893: @344915
     /* 344915 */ GIM_Reject,
     /* 344916 */ // Label 6694: @344916
     /* 344916 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(345067), // Rule ID 11027 //
     /* 344921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 344927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344945 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 344945 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 344948 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344952 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344957 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 344963 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344968 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344973 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344976 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 344980 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344985 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344990 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344993 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 344997 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345002 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 345005 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 345008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 345010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 345013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 345017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345022 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 345025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 345027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 345030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 345034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345039 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345042 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 345045 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 345048 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 345051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 345056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 345058 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 345060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345063 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 345065 */   GIR_RootConstrainSelectedInstOperands,
     /* 345066 */   // GIR_Coverage, 11027,
     /* 345066 */   GIR_EraseRootFromParent_Done,
     /* 345067 */ // Label 6912: @345067
     /* 345067 */ GIM_Reject,
     /* 345068 */ // Label 6695: @345068
     /* 345068 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(347035),
     /* 345073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 345076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345086 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(345195), // Rule ID 4226 //
     /* 345091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345095 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345101 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345111 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345118 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345135 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345162 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345194 */     // GIR_Coverage, 4226,
     /* 345194 */     GIR_EraseRootFromParent_Done,
     /* 345195 */   // Label 6914: @345195
     /* 345195 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(345304), // Rule ID 4227 //
     /* 345200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345204 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345210 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345220 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345227 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345244 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345303 */     // GIR_Coverage, 4227,
     /* 345303 */     GIR_EraseRootFromParent_Done,
     /* 345304 */   // Label 6915: @345304
     /* 345304 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(345413), // Rule ID 4334 //
     /* 345309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345329 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345336 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345353 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345380 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345412 */     // GIR_Coverage, 4334,
     /* 345412 */     GIR_EraseRootFromParent_Done,
     /* 345413 */   // Label 6916: @345413
     /* 345413 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(345522), // Rule ID 4335 //
     /* 345418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345422 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345438 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345445 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345462 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345489 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345521 */     // GIR_Coverage, 4335,
     /* 345521 */     GIR_EraseRootFromParent_Done,
     /* 345522 */   // Label 6917: @345522
     /* 345522 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(345627), // Rule ID 4232 //
     /* 345527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345543 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345550 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345567 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345594 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345626 */     // GIR_Coverage, 4232,
     /* 345626 */     GIR_EraseRootFromParent_Done,
     /* 345627 */   // Label 6918: @345627
     /* 345627 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(345732), // Rule ID 4234 //
     /* 345632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345648 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345655 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345672 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345699 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345731 */     // GIR_Coverage, 4234,
     /* 345731 */     GIR_EraseRootFromParent_Done,
     /* 345732 */   // Label 6919: @345732
     /* 345732 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(345837), // Rule ID 4340 //
     /* 345737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345753 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345760 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345777 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345804 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345836 */     // GIR_Coverage, 4340,
     /* 345836 */     GIR_EraseRootFromParent_Done,
     /* 345837 */   // Label 6920: @345837
     /* 345837 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(345942), // Rule ID 4342 //
     /* 345842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345858 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345865 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345882 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345909 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345941 */     // GIR_Coverage, 4342,
     /* 345941 */     GIR_EraseRootFromParent_Done,
     /* 345942 */   // Label 6921: @345942
     /* 345942 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(346046), // Rule ID 4224 //
     /* 345947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345967 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345974 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345991 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346013 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346045 */     // GIR_Coverage, 4224,
     /* 346045 */     GIR_EraseRootFromParent_Done,
     /* 346046 */   // Label 6922: @346046
     /* 346046 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(346150), // Rule ID 4225 //
     /* 346051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346055 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346061 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346078 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346095 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346117 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346149 */     // GIR_Coverage, 4225,
     /* 346149 */     GIR_EraseRootFromParent_Done,
     /* 346150 */   // Label 6923: @346150
     /* 346150 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(346254), // Rule ID 4332 //
     /* 346155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346175 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346182 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346199 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346221 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346253 */     // GIR_Coverage, 4332,
     /* 346253 */     GIR_EraseRootFromParent_Done,
     /* 346254 */   // Label 6924: @346254
     /* 346254 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(346358), // Rule ID 4333 //
     /* 346259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346279 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346303 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346325 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346357 */     // GIR_Coverage, 4333,
     /* 346357 */     GIR_EraseRootFromParent_Done,
     /* 346358 */   // Label 6925: @346358
     /* 346358 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(346458), // Rule ID 4228 //
     /* 346363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346379 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346386 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346403 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346457 */     // GIR_Coverage, 4228,
     /* 346457 */     GIR_EraseRootFromParent_Done,
     /* 346458 */   // Label 6926: @346458
     /* 346458 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(346558), // Rule ID 4230 //
     /* 346463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346479 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346503 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346557 */     // GIR_Coverage, 4230,
     /* 346557 */     GIR_EraseRootFromParent_Done,
     /* 346558 */   // Label 6927: @346558
     /* 346558 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(346658), // Rule ID 4336 //
     /* 346563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346579 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346586 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346603 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346657 */     // GIR_Coverage, 4336,
     /* 346657 */     GIR_EraseRootFromParent_Done,
     /* 346658 */   // Label 6928: @346658
     /* 346658 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(346758), // Rule ID 4338 //
     /* 346663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346679 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346686 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346703 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346757 */     // GIR_Coverage, 4338,
     /* 346757 */     GIR_EraseRootFromParent_Done,
     /* 346758 */   // Label 6929: @346758
     /* 346758 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(346896), // Rule ID 11024 //
     /* 346763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346774 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 346774 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346777 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346781 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346786 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346792 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346797 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346802 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346805 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346809 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346814 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346819 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346822 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346826 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346831 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346834 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346851 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 346863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346874 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346877 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 346880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 346885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 346887 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 346889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 346894 */     GIR_RootConstrainSelectedInstOperands,
     /* 346895 */     // GIR_Coverage, 11024,
     /* 346895 */     GIR_EraseRootFromParent_Done,
     /* 346896 */   // Label 6930: @346896
     /* 346896 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(347034), // Rule ID 11030 //
     /* 346901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346912 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 346912 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346915 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346919 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346924 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346930 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346935 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346952 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346969 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346972 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346989 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 347001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 347012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 347015 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 347018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 347023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 347025 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 347027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 347032 */     GIR_RootConstrainSelectedInstOperands,
     /* 347033 */     // GIR_Coverage, 11030,
     /* 347033 */     GIR_EraseRootFromParent_Done,
     /* 347034 */   // Label 6931: @347034
     /* 347034 */   GIM_Reject,
     /* 347035 */ // Label 6913: @347035
     /* 347035 */ GIM_Reject,
     /* 347036 */ // Label 6696: @347036
     /* 347036 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(349229),
     /* 347041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 347044 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(347170), // Rule ID 4190 //
     /* 347049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347063 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347069 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347079 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347082 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347086 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347093 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347110 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347137 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347169 */     // GIR_Coverage, 4190,
     /* 347169 */     GIR_EraseRootFromParent_Done,
     /* 347170 */   // Label 6933: @347170
     /* 347170 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(347296), // Rule ID 4191 //
     /* 347175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347205 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347208 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347212 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347219 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347236 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347263 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347295 */     // GIR_Coverage, 4191,
     /* 347295 */     GIR_EraseRootFromParent_Done,
     /* 347296 */   // Label 6934: @347296
     /* 347296 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(347415), // Rule ID 4298 //
     /* 347301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347338 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347355 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347382 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347414 */     // GIR_Coverage, 4298,
     /* 347414 */     GIR_EraseRootFromParent_Done,
     /* 347415 */   // Label 6935: @347415
     /* 347415 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(347534), // Rule ID 4299 //
     /* 347420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347434 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347440 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347450 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347474 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347533 */     // GIR_Coverage, 4299,
     /* 347533 */     GIR_EraseRootFromParent_Done,
     /* 347534 */   // Label 6936: @347534
     /* 347534 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(347656), // Rule ID 4196 //
     /* 347539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347565 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347568 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347572 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347579 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347596 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347655 */     // GIR_Coverage, 4196,
     /* 347655 */     GIR_EraseRootFromParent_Done,
     /* 347656 */   // Label 6937: @347656
     /* 347656 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(347778), // Rule ID 4198 //
     /* 347661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347690 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347694 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347701 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347718 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347777 */     // GIR_Coverage, 4198,
     /* 347777 */     GIR_EraseRootFromParent_Done,
     /* 347778 */   // Label 6938: @347778
     /* 347778 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(347893), // Rule ID 4304 //
     /* 347783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347833 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347892 */     // GIR_Coverage, 4304,
     /* 347892 */     GIR_EraseRootFromParent_Done,
     /* 347893 */   // Label 6939: @347893
     /* 347893 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(348008), // Rule ID 4306 //
     /* 347898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347924 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347931 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347948 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347975 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348007 */     // GIR_Coverage, 4306,
     /* 348007 */     GIR_EraseRootFromParent_Done,
     /* 348008 */   // Label 6940: @348008
     /* 348008 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(348129), // Rule ID 4188 //
     /* 348013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348043 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348046 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348050 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348057 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348074 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348096 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348128 */     // GIR_Coverage, 4188,
     /* 348128 */     GIR_EraseRootFromParent_Done,
     /* 348129 */   // Label 6941: @348129
     /* 348129 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(348250), // Rule ID 4189 //
     /* 348134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348148 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348154 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348167 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348171 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348178 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348195 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348217 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348249 */     // GIR_Coverage, 4189,
     /* 348249 */     GIR_EraseRootFromParent_Done,
     /* 348250 */   // Label 6942: @348250
     /* 348250 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(348364), // Rule ID 4296 //
     /* 348255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348269 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348275 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348292 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348309 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348331 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348363 */     // GIR_Coverage, 4296,
     /* 348363 */     GIR_EraseRootFromParent_Done,
     /* 348364 */   // Label 6943: @348364
     /* 348364 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(348478), // Rule ID 4297 //
     /* 348369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348383 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348389 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348399 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348423 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348477 */     // GIR_Coverage, 4297,
     /* 348477 */     GIR_EraseRootFromParent_Done,
     /* 348478 */   // Label 6944: @348478
     /* 348478 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(348595), // Rule ID 4192 //
     /* 348483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348512 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348516 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348523 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348540 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348562 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348594 */     // GIR_Coverage, 4192,
     /* 348594 */     GIR_EraseRootFromParent_Done,
     /* 348595 */   // Label 6945: @348595
     /* 348595 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(348712), // Rule ID 4194 //
     /* 348600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348626 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348629 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348633 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348657 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348679 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348711 */     // GIR_Coverage, 4194,
     /* 348711 */     GIR_EraseRootFromParent_Done,
     /* 348712 */   // Label 6946: @348712
     /* 348712 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(348822), // Rule ID 4300 //
     /* 348717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348750 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348767 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348789 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348821 */     // GIR_Coverage, 4300,
     /* 348821 */     GIR_EraseRootFromParent_Done,
     /* 348822 */   // Label 6947: @348822
     /* 348822 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(348932), // Rule ID 4302 //
     /* 348827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348853 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348877 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348899 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348931 */     // GIR_Coverage, 4302,
     /* 348931 */     GIR_EraseRootFromParent_Done,
     /* 348932 */   // Label 6948: @348932
     /* 348932 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(349080), // Rule ID 11023 //
     /* 348937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348958 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 348958 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 348961 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348965 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348970 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 348976 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348981 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348986 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 348989 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 348993 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348998 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 349010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349015 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349018 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 349030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 349047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349061 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 349069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349078 */     GIR_RootConstrainSelectedInstOperands,
     /* 349079 */     // GIR_Coverage, 11023,
     /* 349079 */     GIR_EraseRootFromParent_Done,
     /* 349080 */   // Label 6949: @349080
     /* 349080 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(349228), // Rule ID 11028 //
     /* 349085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349106 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 349106 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 349109 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349113 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349118 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 349124 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349129 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349134 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349137 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 349141 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349146 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 349158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349163 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349166 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 349178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 349195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349209 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 349217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349219 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349226 */     GIR_RootConstrainSelectedInstOperands,
     /* 349227 */     // GIR_Coverage, 11028,
     /* 349227 */     GIR_EraseRootFromParent_Done,
     /* 349228 */   // Label 6950: @349228
     /* 349228 */   GIM_Reject,
     /* 349229 */ // Label 6932: @349229
     /* 349229 */ GIM_Reject,
     /* 349230 */ // Label 6697: @349230
     /* 349230 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(350279),
     /* 349235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 349238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349248 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(349364), // Rule ID 4154 //
     /* 349253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349257 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349263 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349273 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349276 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349280 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349287 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349304 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349331 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349363 */     // GIR_Coverage, 4154,
     /* 349363 */     GIR_EraseRootFromParent_Done,
     /* 349364 */   // Label 6952: @349364
     /* 349364 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(349480), // Rule ID 4155 //
     /* 349369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349373 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349389 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349392 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349396 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349403 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349420 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349479 */     // GIR_Coverage, 4155,
     /* 349479 */     GIR_EraseRootFromParent_Done,
     /* 349480 */   // Label 6953: @349480
     /* 349480 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(349592), // Rule ID 4160 //
     /* 349485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349501 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349504 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349508 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349515 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349532 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349559 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349591 */     // GIR_Coverage, 4160,
     /* 349591 */     GIR_EraseRootFromParent_Done,
     /* 349592 */   // Label 6954: @349592
     /* 349592 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(349704), // Rule ID 4162 //
     /* 349597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349613 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349616 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349620 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349627 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349644 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349671 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349703 */     // GIR_Coverage, 4162,
     /* 349703 */     GIR_EraseRootFromParent_Done,
     /* 349704 */   // Label 6955: @349704
     /* 349704 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(349815), // Rule ID 4152 //
     /* 349709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349729 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349732 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349736 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349760 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349782 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349814 */     // GIR_Coverage, 4152,
     /* 349814 */     GIR_EraseRootFromParent_Done,
     /* 349815 */   // Label 6956: @349815
     /* 349815 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(349926), // Rule ID 4153 //
     /* 349820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349824 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349830 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349840 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349843 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349847 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349854 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 349871 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 349871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 349878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349893 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349925 */     // GIR_Coverage, 4153,
     /* 349925 */     GIR_EraseRootFromParent_Done,
     /* 349926 */   // Label 6957: @349926
     /* 349926 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(350033), // Rule ID 4156 //
     /* 349931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349947 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349950 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349954 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349961 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349978 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350032 */     // GIR_Coverage, 4156,
     /* 350032 */     GIR_EraseRootFromParent_Done,
     /* 350033 */   // Label 6958: @350033
     /* 350033 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(350140), // Rule ID 4158 //
     /* 350038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350054 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350057 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350061 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350068 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 350085 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 350085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 350092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350107 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350139 */     // GIR_Coverage, 4158,
     /* 350139 */     GIR_EraseRootFromParent_Done,
     /* 350140 */   // Label 6959: @350140
     /* 350140 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(350278), // Rule ID 11022 //
     /* 350145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350156 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 350156 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 350159 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350163 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350168 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 350174 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350179 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350184 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 350187 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 350191 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350196 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 350199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 350201 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 350204 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 350208 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350213 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 350216 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 350219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 350228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350233 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 350236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 350245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 350256 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 350259 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 350267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 350269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 350276 */     GIR_RootConstrainSelectedInstOperands,
     /* 350277 */     // GIR_Coverage, 11022,
     /* 350277 */     GIR_EraseRootFromParent_Done,
     /* 350278 */   // Label 6960: @350278
     /* 350278 */   GIM_Reject,
     /* 350279 */ // Label 6951: @350279
     /* 350279 */ GIM_Reject,
     /* 350280 */ // Label 6698: @350280
     /* 350280 */ GIM_Reject,
     /* 350281 */ // Label 86: @350281
     /* 350281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6964*/ GIMT_Encode4(353198),
     /* 350292 */ /*GILLT_s16*//*Label 6961*/ GIMT_Encode4(350304),
     /* 350296 */ /*GILLT_s32*//*Label 6962*/ GIMT_Encode4(350938),
     /* 350300 */ /*GILLT_s64*//*Label 6963*/ GIMT_Encode4(352531),
     /* 350304 */ // Label 6961: @350304
     /* 350304 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(350348), // Rule ID 11071 //
     /* 350309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350322 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350326 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 350326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350331 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 350337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350347 */   // GIR_Coverage, 11071,
     /* 350347 */   GIR_EraseRootFromParent_Done,
     /* 350348 */ // Label 6965: @350348
     /* 350348 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(350392), // Rule ID 11072 //
     /* 350353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350366 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350370 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 350370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350375 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 350381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350391 */   // GIR_Coverage, 11072,
     /* 350391 */   GIR_EraseRootFromParent_Done,
     /* 350392 */ // Label 6966: @350392
     /* 350392 */ GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(350436), // Rule ID 11073 //
     /* 350397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350410 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350414 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 350414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350419 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 350425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350435 */   // GIR_Coverage, 11073,
     /* 350435 */   GIR_EraseRootFromParent_Done,
     /* 350436 */ // Label 6967: @350436
     /* 350436 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(350481), // Rule ID 5693 //
     /* 350441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350455 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350459 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 350459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350464 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 350470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350480 */   // GIR_Coverage, 5693,
     /* 350480 */   GIR_EraseRootFromParent_Done,
     /* 350481 */ // Label 6968: @350481
     /* 350481 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(350526), // Rule ID 5696 //
     /* 350486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350508 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350512 */   // MIs[1] Operand 1
     /* 350512 */   // No operand predicates
     /* 350512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350514 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 350514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 350517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350519 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350521 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 350524 */   GIR_RootConstrainSelectedInstOperands,
     /* 350525 */   // GIR_Coverage, 5696,
     /* 350525 */   GIR_EraseRootFromParent_Done,
     /* 350526 */ // Label 6969: @350526
     /* 350526 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(350602), // Rule ID 11046 //
     /* 350531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350544 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350548 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350552 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 350556 */   // MIs[1] Operand 1
     /* 350556 */   // No operand predicates
     /* 350556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350558 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 350558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 350565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350574 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350584 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350601 */   // GIR_Coverage, 11046,
     /* 350601 */   GIR_EraseRootFromParent_Done,
     /* 350602 */ // Label 6970: @350602
     /* 350602 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(350678), // Rule ID 11047 //
     /* 350607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350628 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 350632 */   // MIs[1] Operand 1
     /* 350632 */   // No operand predicates
     /* 350632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350634 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 350634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 350641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350646 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350650 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350660 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350677 */   // GIR_Coverage, 11047,
     /* 350677 */   GIR_EraseRootFromParent_Done,
     /* 350678 */ // Label 6971: @350678
     /* 350678 */ GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(350754), // Rule ID 11048 //
     /* 350683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350704 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 350708 */   // MIs[1] Operand 1
     /* 350708 */   // No operand predicates
     /* 350708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350710 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 350710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 350717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350722 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350726 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350736 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350753 */   // GIR_Coverage, 11048,
     /* 350753 */   GIR_EraseRootFromParent_Done,
     /* 350754 */ // Label 6972: @350754
     /* 350754 */ GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(350815), // Rule ID 11036 //
     /* 350759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350776 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 350776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 350783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350788 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350794 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350798 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350811 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350813 */   GIR_RootConstrainSelectedInstOperands,
     /* 350814 */   // GIR_Coverage, 11036,
     /* 350814 */   GIR_EraseRootFromParent_Done,
     /* 350815 */ // Label 6973: @350815
     /* 350815 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(350876), // Rule ID 11037 //
     /* 350820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350837 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 350837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 350844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350849 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350855 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350859 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350872 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350874 */   GIR_RootConstrainSelectedInstOperands,
     /* 350875 */   // GIR_Coverage, 11037,
     /* 350875 */   GIR_EraseRootFromParent_Done,
     /* 350876 */ // Label 6974: @350876
     /* 350876 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(350937), // Rule ID 11038 //
     /* 350881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350898 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 350898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 350905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350910 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350916 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350920 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350933 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350935 */   GIR_RootConstrainSelectedInstOperands,
     /* 350936 */   // GIR_Coverage, 11038,
     /* 350936 */   GIR_EraseRootFromParent_Done,
     /* 350937 */ // Label 6975: @350937
     /* 350937 */ GIM_Reject,
     /* 350938 */ // Label 6962: @350938
     /* 350938 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(350983), // Rule ID 6868 //
     /* 350943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350957 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350961 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 350961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350966 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 350972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350982 */   // GIR_Coverage, 6868,
     /* 350982 */   GIR_EraseRootFromParent_Done,
     /* 350983 */ // Label 6976: @350983
     /* 350983 */ GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(351028), // Rule ID 6869 //
     /* 350988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351002 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351006 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 351006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351011 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 351017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351027 */   // GIR_Coverage, 6869,
     /* 351027 */   GIR_EraseRootFromParent_Done,
     /* 351028 */ // Label 6977: @351028
     /* 351028 */ GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(351072), // Rule ID 11067 //
     /* 351033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351046 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351050 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 351050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351055 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 351061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351071 */   // GIR_Coverage, 11067,
     /* 351071 */   GIR_EraseRootFromParent_Done,
     /* 351072 */ // Label 6978: @351072
     /* 351072 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(351116), // Rule ID 11068 //
     /* 351077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351090 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351094 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 351094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351099 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 351105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351115 */   // GIR_Coverage, 11068,
     /* 351115 */   GIR_EraseRootFromParent_Done,
     /* 351116 */ // Label 6979: @351116
     /* 351116 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(351160), // Rule ID 11069 //
     /* 351121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351134 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351138 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 351138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351143 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 351149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351159 */   // GIR_Coverage, 11069,
     /* 351159 */   GIR_EraseRootFromParent_Done,
     /* 351160 */ // Label 6980: @351160
     /* 351160 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(351204), // Rule ID 11074 //
     /* 351165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351178 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351182 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 351182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351187 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 351193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351203 */   // GIR_Coverage, 11074,
     /* 351203 */   GIR_EraseRootFromParent_Done,
     /* 351204 */ // Label 6981: @351204
     /* 351204 */ GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(351248), // Rule ID 11075 //
     /* 351209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 351215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351222 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351226 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 351226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351231 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 351237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351247 */   // GIR_Coverage, 11075,
     /* 351247 */   GIR_EraseRootFromParent_Done,
     /* 351248 */ // Label 6982: @351248
     /* 351248 */ GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(351293), // Rule ID 5692 //
     /* 351253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351267 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 351271 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 351271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351276 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 351282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351292 */   // GIR_Coverage, 5692,
     /* 351292 */   GIR_EraseRootFromParent_Done,
     /* 351293 */ // Label 6983: @351293
     /* 351293 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(351366), // Rule ID 11052 //
     /* 351298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351319 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 351323 */   // MIs[1] Operand 1
     /* 351323 */   // No operand predicates
     /* 351323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351325 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 351325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 351328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351337 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 351343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 351356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351361 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351364 */   GIR_RootConstrainSelectedInstOperands,
     /* 351365 */   // GIR_Coverage, 11052,
     /* 351365 */   GIR_EraseRootFromParent_Done,
     /* 351366 */ // Label 6984: @351366
     /* 351366 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(351439), // Rule ID 11053 //
     /* 351371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351392 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351396 */   // MIs[1] Operand 1
     /* 351396 */   // No operand predicates
     /* 351396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351398 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 351398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351410 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 351416 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 351429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351434 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351437 */   GIR_RootConstrainSelectedInstOperands,
     /* 351438 */   // GIR_Coverage, 11053,
     /* 351438 */   GIR_EraseRootFromParent_Done,
     /* 351439 */ // Label 6985: @351439
     /* 351439 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(351512), // Rule ID 11054 //
     /* 351444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351465 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351469 */   // MIs[1] Operand 1
     /* 351469 */   // No operand predicates
     /* 351469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351471 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 351471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 351474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351483 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 351489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351494 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351507 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351510 */   GIR_RootConstrainSelectedInstOperands,
     /* 351511 */   // GIR_Coverage, 11054,
     /* 351511 */   GIR_EraseRootFromParent_Done,
     /* 351512 */ // Label 6986: @351512
     /* 351512 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(351560), // Rule ID 1919 //
     /* 351517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351542 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351546 */   // MIs[1] Operand 1
     /* 351546 */   // No operand predicates
     /* 351546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351548 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 351551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351553 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351555 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351558 */   GIR_RootConstrainSelectedInstOperands,
     /* 351559 */   // GIR_Coverage, 1919,
     /* 351559 */   GIR_EraseRootFromParent_Done,
     /* 351560 */ // Label 6987: @351560
     /* 351560 */ GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(351608), // Rule ID 1920 //
     /* 351565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351590 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351594 */   // MIs[1] Operand 1
     /* 351594 */   // No operand predicates
     /* 351594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351596 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 351599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351603 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351606 */   GIR_RootConstrainSelectedInstOperands,
     /* 351607 */   // GIR_Coverage, 1920,
     /* 351607 */   GIR_EraseRootFromParent_Done,
     /* 351608 */ // Label 6988: @351608
     /* 351608 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(351656), // Rule ID 1921 //
     /* 351613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351638 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351642 */   // MIs[1] Operand 1
     /* 351642 */   // No operand predicates
     /* 351642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351644 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 351647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351649 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351654 */   GIR_RootConstrainSelectedInstOperands,
     /* 351655 */   // GIR_Coverage, 1921,
     /* 351655 */   GIR_EraseRootFromParent_Done,
     /* 351656 */ // Label 6989: @351656
     /* 351656 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(351704), // Rule ID 1923 //
     /* 351661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351686 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 351690 */   // MIs[1] Operand 1
     /* 351690 */   // No operand predicates
     /* 351690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351692 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 351695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351697 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351699 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351702 */   GIR_RootConstrainSelectedInstOperands,
     /* 351703 */   // GIR_Coverage, 1923,
     /* 351703 */   GIR_EraseRootFromParent_Done,
     /* 351704 */ // Label 6990: @351704
     /* 351704 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(351752), // Rule ID 1924 //
     /* 351709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351734 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351738 */   // MIs[1] Operand 1
     /* 351738 */   // No operand predicates
     /* 351738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351740 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 351743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351745 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351747 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351750 */   GIR_RootConstrainSelectedInstOperands,
     /* 351751 */   // GIR_Coverage, 1924,
     /* 351751 */   GIR_EraseRootFromParent_Done,
     /* 351752 */ // Label 6991: @351752
     /* 351752 */ GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(351800), // Rule ID 1925 //
     /* 351757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351782 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351786 */   // MIs[1] Operand 1
     /* 351786 */   // No operand predicates
     /* 351786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351788 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351795 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351798 */   GIR_RootConstrainSelectedInstOperands,
     /* 351799 */   // GIR_Coverage, 1925,
     /* 351799 */   GIR_EraseRootFromParent_Done,
     /* 351800 */ // Label 6992: @351800
     /* 351800 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(351845), // Rule ID 5695 //
     /* 351805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351827 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351831 */   // MIs[1] Operand 1
     /* 351831 */   // No operand predicates
     /* 351831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351833 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 351833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 351836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351838 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351840 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351843 */   GIR_RootConstrainSelectedInstOperands,
     /* 351844 */   // GIR_Coverage, 5695,
     /* 351844 */   GIR_EraseRootFromParent_Done,
     /* 351845 */ // Label 6993: @351845
     /* 351845 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(351921), // Rule ID 11042 //
     /* 351850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351871 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 351875 */   // MIs[1] Operand 1
     /* 351875 */   // No operand predicates
     /* 351875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351877 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 351877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 351884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351893 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351903 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351920 */   // GIR_Coverage, 11042,
     /* 351920 */   GIR_EraseRootFromParent_Done,
     /* 351921 */ // Label 6994: @351921
     /* 351921 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(351997), // Rule ID 11043 //
     /* 351926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351947 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 351951 */   // MIs[1] Operand 1
     /* 351951 */   // No operand predicates
     /* 351951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351953 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 351953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 351960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351965 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351969 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351979 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351991 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351996 */   // GIR_Coverage, 11043,
     /* 351996 */   GIR_EraseRootFromParent_Done,
     /* 351997 */ // Label 6995: @351997
     /* 351997 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(352073), // Rule ID 11044 //
     /* 352002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352015 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352019 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352023 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 352027 */   // MIs[1] Operand 1
     /* 352027 */   // No operand predicates
     /* 352027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352029 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 352029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 352036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352041 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352045 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352055 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 352062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352072 */   // GIR_Coverage, 11044,
     /* 352072 */   GIR_EraseRootFromParent_Done,
     /* 352073 */ // Label 6996: @352073
     /* 352073 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(352149), // Rule ID 11049 //
     /* 352078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352099 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 352103 */   // MIs[1] Operand 1
     /* 352103 */   // No operand predicates
     /* 352103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352105 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 352105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 352112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352121 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352131 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 352138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352148 */   // GIR_Coverage, 11049,
     /* 352148 */   GIR_EraseRootFromParent_Done,
     /* 352149 */ // Label 6997: @352149
     /* 352149 */ GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(352225), // Rule ID 11050 //
     /* 352154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 352160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352175 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352179 */   // MIs[1] Operand 1
     /* 352179 */   // No operand predicates
     /* 352179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352181 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 352181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352193 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352197 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352207 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 352214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352224 */   // GIR_Coverage, 11050,
     /* 352224 */   GIR_EraseRootFromParent_Done,
     /* 352225 */ // Label 6998: @352225
     /* 352225 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(352286), // Rule ID 11032 //
     /* 352230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 352236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352247 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 352247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 352254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352259 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352265 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352269 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 352277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352282 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352284 */   GIR_RootConstrainSelectedInstOperands,
     /* 352285 */   // GIR_Coverage, 11032,
     /* 352285 */   GIR_EraseRootFromParent_Done,
     /* 352286 */ // Label 6999: @352286
     /* 352286 */ GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(352347), // Rule ID 11033 //
     /* 352291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352308 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 352308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 352315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352320 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352330 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 352338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352343 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352345 */   GIR_RootConstrainSelectedInstOperands,
     /* 352346 */   // GIR_Coverage, 11033,
     /* 352346 */   GIR_EraseRootFromParent_Done,
     /* 352347 */ // Label 7000: @352347
     /* 352347 */ GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(352408), // Rule ID 11034 //
     /* 352352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352369 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 352369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 352376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352381 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352387 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352391 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 352399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352404 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352406 */   GIR_RootConstrainSelectedInstOperands,
     /* 352407 */   // GIR_Coverage, 11034,
     /* 352407 */   GIR_EraseRootFromParent_Done,
     /* 352408 */ // Label 7001: @352408
     /* 352408 */ GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(352469), // Rule ID 11039 //
     /* 352413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352430 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 352430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 352437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352442 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352448 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352452 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352465 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352467 */   GIR_RootConstrainSelectedInstOperands,
     /* 352468 */   // GIR_Coverage, 11039,
     /* 352468 */   GIR_EraseRootFromParent_Done,
     /* 352469 */ // Label 7002: @352469
     /* 352469 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(352530), // Rule ID 11040 //
     /* 352474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 352480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352491 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 352491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352503 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352513 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352526 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352528 */   GIR_RootConstrainSelectedInstOperands,
     /* 352529 */   // GIR_Coverage, 11040,
     /* 352529 */   GIR_EraseRootFromParent_Done,
     /* 352530 */ // Label 7003: @352530
     /* 352530 */ GIM_Reject,
     /* 352531 */ // Label 6963: @352531
     /* 352531 */ GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(352576), // Rule ID 6867 //
     /* 352536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352550 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352554 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 352554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352559 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 352565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352575 */   // GIR_Coverage, 6867,
     /* 352575 */   GIR_EraseRootFromParent_Done,
     /* 352576 */ // Label 7004: @352576
     /* 352576 */ GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(352620), // Rule ID 11070 //
     /* 352581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352594 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352598 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 352598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352603 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352614 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352619 */   // GIR_Coverage, 11070,
     /* 352619 */   GIR_EraseRootFromParent_Done,
     /* 352620 */ // Label 7005: @352620
     /* 352620 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(352664), // Rule ID 11076 //
     /* 352625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352638 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352642 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 352642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352647 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352663 */   // GIR_Coverage, 11076,
     /* 352663 */   GIR_EraseRootFromParent_Done,
     /* 352664 */ // Label 7006: @352664
     /* 352664 */ GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(352709), // Rule ID 5691 //
     /* 352669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352683 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352687 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 352687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352692 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 352698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352708 */   // GIR_Coverage, 5691,
     /* 352708 */   GIR_EraseRootFromParent_Done,
     /* 352709 */ // Label 7007: @352709
     /* 352709 */ GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(352782), // Rule ID 11055 //
     /* 352714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352735 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352739 */   // MIs[1] Operand 1
     /* 352739 */   // No operand predicates
     /* 352739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352741 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 352741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 352744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352753 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 352759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352777 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 352780 */   GIR_RootConstrainSelectedInstOperands,
     /* 352781 */   // GIR_Coverage, 11055,
     /* 352781 */   GIR_EraseRootFromParent_Done,
     /* 352782 */ // Label 7008: @352782
     /* 352782 */ GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(352830), // Rule ID 1922 //
     /* 352787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 352790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352812 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 352816 */   // MIs[1] Operand 1
     /* 352816 */   // No operand predicates
     /* 352816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352818 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 352821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352823 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352825 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352828 */   GIR_RootConstrainSelectedInstOperands,
     /* 352829 */   // GIR_Coverage, 1922,
     /* 352829 */   GIR_EraseRootFromParent_Done,
     /* 352830 */ // Label 7009: @352830
     /* 352830 */ GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(352878), // Rule ID 1926 //
     /* 352835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352860 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352864 */   // MIs[1] Operand 1
     /* 352864 */   // No operand predicates
     /* 352864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352866 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352871 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352873 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352876 */   GIR_RootConstrainSelectedInstOperands,
     /* 352877 */   // GIR_Coverage, 1926,
     /* 352877 */   GIR_EraseRootFromParent_Done,
     /* 352878 */ // Label 7010: @352878
     /* 352878 */ GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(352923), // Rule ID 5694 //
     /* 352883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352905 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352909 */   // MIs[1] Operand 1
     /* 352909 */   // No operand predicates
     /* 352909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352911 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 352911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 352914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352916 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352918 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352921 */   GIR_RootConstrainSelectedInstOperands,
     /* 352922 */   // GIR_Coverage, 5694,
     /* 352922 */   GIR_EraseRootFromParent_Done,
     /* 352923 */ // Label 7011: @352923
     /* 352923 */ GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(352999), // Rule ID 11045 //
     /* 352928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352941 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352949 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352953 */   // MIs[1] Operand 1
     /* 352953 */   // No operand predicates
     /* 352953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352955 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 352955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352967 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352981 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352998 */   // GIR_Coverage, 11045,
     /* 352998 */   GIR_EraseRootFromParent_Done,
     /* 352999 */ // Label 7012: @352999
     /* 352999 */ GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(353075), // Rule ID 11051 //
     /* 353004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353025 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353029 */   // MIs[1] Operand 1
     /* 353029 */   // No operand predicates
     /* 353029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353031 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 353031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 353047 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 353050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353057 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353074 */   // GIR_Coverage, 11051,
     /* 353074 */   GIR_EraseRootFromParent_Done,
     /* 353075 */ // Label 7013: @353075
     /* 353075 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(353136), // Rule ID 11035 //
     /* 353080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353097 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 353097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 353104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353109 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 353115 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 353119 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 353127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 353129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353132 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353134 */   GIR_RootConstrainSelectedInstOperands,
     /* 353135 */   // GIR_Coverage, 11035,
     /* 353135 */   GIR_EraseRootFromParent_Done,
     /* 353136 */ // Label 7014: @353136
     /* 353136 */ GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(353197), // Rule ID 11041 //
     /* 353141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353158 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 353158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 353165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353170 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 353176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 353180 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 353188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 353190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353193 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353195 */   GIR_RootConstrainSelectedInstOperands,
     /* 353196 */   // GIR_Coverage, 11041,
     /* 353196 */   GIR_EraseRootFromParent_Done,
     /* 353197 */ // Label 7015: @353197
     /* 353197 */ GIM_Reject,
     /* 353198 */ // Label 6964: @353198
     /* 353198 */ GIM_Reject,
     /* 353199 */ // Label 87: @353199
     /* 353199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7023*/ GIMT_Encode4(354904),
     /* 353210 */ /*GILLT_nxv2s16*//*Label 7016*/ GIMT_Encode4(353250),
     /* 353214 */ /*GILLT_nxv2s32*//*Label 7017*/ GIMT_Encode4(353545),
     /* 353218 */ /*GILLT_nxv2s64*//*Label 7018*/ GIMT_Encode4(353783), GIMT_Encode4(0),
     /* 353226 */ /*GILLT_nxv4s16*//*Label 7019*/ GIMT_Encode4(354040),
     /* 353230 */ /*GILLT_nxv4s32*//*Label 7020*/ GIMT_Encode4(354278), GIMT_Encode4(0),
     /* 353238 */ /*GILLT_nxv8s16*//*Label 7021*/ GIMT_Encode4(354535), GIMT_Encode4(0),
     /* 353246 */ /*GILLT_nxv16s8*//*Label 7022*/ GIMT_Encode4(354814),
     /* 353250 */ // Label 7016: @353250
     /* 353250 */ GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(353544),
     /* 353255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 353258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353262 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(353319), // Rule ID 2661 //
     /* 353267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353299 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353303 */     // MIs[2] Operand 1
     /* 353303 */     // No operand predicates
     /* 353303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353305 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353317 */     GIR_RootConstrainSelectedInstOperands,
     /* 353318 */     // GIR_Coverage, 2661,
     /* 353318 */     GIR_EraseRootFromParent_Done,
     /* 353319 */   // Label 7025: @353319
     /* 353319 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(353376), // Rule ID 2663 //
     /* 353324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353360 */     // MIs[2] Operand 1
     /* 353360 */     // No operand predicates
     /* 353360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353362 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353374 */     GIR_RootConstrainSelectedInstOperands,
     /* 353375 */     // GIR_Coverage, 2663,
     /* 353375 */     GIR_EraseRootFromParent_Done,
     /* 353376 */   // Label 7026: @353376
     /* 353376 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(353433), // Rule ID 8187 //
     /* 353381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353413 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 353417 */     // MIs[2] Operand 1
     /* 353417 */     // No operand predicates
     /* 353417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353419 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 353419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353431 */     GIR_RootConstrainSelectedInstOperands,
     /* 353432 */     // GIR_Coverage, 8187,
     /* 353432 */     GIR_EraseRootFromParent_Done,
     /* 353433 */   // Label 7027: @353433
     /* 353433 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(353467), // Rule ID 8230 //
     /* 353438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353449 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 353453 */     // MIs[1] Operand 1
     /* 353453 */     // No operand predicates
     /* 353453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353455 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 353455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 353458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353460 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 353465 */     GIR_RootConstrainSelectedInstOperands,
     /* 353466 */     // GIR_Coverage, 8230,
     /* 353466 */     GIR_EraseRootFromParent_Done,
     /* 353467 */   // Label 7028: @353467
     /* 353467 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(353543), // Rule ID 8208 //
     /* 353472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353479 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 353515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353541 */     GIR_RootConstrainSelectedInstOperands,
     /* 353542 */     // GIR_Coverage, 8208,
     /* 353542 */     GIR_EraseRootFromParent_Done,
     /* 353543 */   // Label 7029: @353543
     /* 353543 */   GIM_Reject,
     /* 353544 */ // Label 7024: @353544
     /* 353544 */ GIM_Reject,
     /* 353545 */ // Label 7017: @353545
     /* 353545 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(353782),
     /* 353550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 353553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353557 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(353614), // Rule ID 8196 //
     /* 353562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353598 */     // MIs[2] Operand 1
     /* 353598 */     // No operand predicates
     /* 353598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353600 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353612 */     GIR_RootConstrainSelectedInstOperands,
     /* 353613 */     // GIR_Coverage, 8196,
     /* 353613 */     GIR_EraseRootFromParent_Done,
     /* 353614 */   // Label 7031: @353614
     /* 353614 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(353671), // Rule ID 8205 //
     /* 353619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353651 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353655 */     // MIs[2] Operand 1
     /* 353655 */     // No operand predicates
     /* 353655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353657 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353669 */     GIR_RootConstrainSelectedInstOperands,
     /* 353670 */     // GIR_Coverage, 8205,
     /* 353670 */     GIR_EraseRootFromParent_Done,
     /* 353671 */   // Label 7032: @353671
     /* 353671 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(353705), // Rule ID 8232 //
     /* 353676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353687 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 353691 */     // MIs[1] Operand 1
     /* 353691 */     // No operand predicates
     /* 353691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353693 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 353693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 353696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353698 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 353703 */     GIR_RootConstrainSelectedInstOperands,
     /* 353704 */     // GIR_Coverage, 8232,
     /* 353704 */     GIR_EraseRootFromParent_Done,
     /* 353705 */   // Label 7033: @353705
     /* 353705 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(353781), // Rule ID 8210 //
     /* 353710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353717 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 353753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353779 */     GIR_RootConstrainSelectedInstOperands,
     /* 353780 */     // GIR_Coverage, 8210,
     /* 353780 */     GIR_EraseRootFromParent_Done,
     /* 353781 */   // Label 7034: @353781
     /* 353781 */   GIM_Reject,
     /* 353782 */ // Label 7030: @353782
     /* 353782 */ GIM_Reject,
     /* 353783 */ // Label 7018: @353783
     /* 353783 */ GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(354039),
     /* 353788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353795 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(353852), // Rule ID 2658 //
     /* 353800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353832 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353836 */     // MIs[2] Operand 1
     /* 353836 */     // No operand predicates
     /* 353836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353838 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353850 */     GIR_RootConstrainSelectedInstOperands,
     /* 353851 */     // GIR_Coverage, 2658,
     /* 353851 */     GIR_EraseRootFromParent_Done,
     /* 353852 */   // Label 7036: @353852
     /* 353852 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(353909), // Rule ID 8202 //
     /* 353857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353893 */     // MIs[2] Operand 1
     /* 353893 */     // No operand predicates
     /* 353893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353895 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353907 */     GIR_RootConstrainSelectedInstOperands,
     /* 353908 */     // GIR_Coverage, 8202,
     /* 353908 */     GIR_EraseRootFromParent_Done,
     /* 353909 */   // Label 7037: @353909
     /* 353909 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(353943), // Rule ID 8233 //
     /* 353914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353925 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 353929 */     // MIs[1] Operand 1
     /* 353929 */     // No operand predicates
     /* 353929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353931 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 353931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 353934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353936 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 353941 */     GIR_RootConstrainSelectedInstOperands,
     /* 353942 */     // GIR_Coverage, 8233,
     /* 353942 */     GIR_EraseRootFromParent_Done,
     /* 353943 */   // Label 7038: @353943
     /* 353943 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(353962), // Rule ID 2382 //
     /* 353948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353955 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 353955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353960 */     GIR_RootConstrainSelectedInstOperands,
     /* 353961 */     // GIR_Coverage, 2382,
     /* 353961 */     GIR_Done,
     /* 353962 */   // Label 7039: @353962
     /* 353962 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(354038), // Rule ID 8211 //
     /* 353967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353974 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 354010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 354028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354036 */     GIR_RootConstrainSelectedInstOperands,
     /* 354037 */     // GIR_Coverage, 8211,
     /* 354037 */     GIR_EraseRootFromParent_Done,
     /* 354038 */   // Label 7040: @354038
     /* 354038 */   GIM_Reject,
     /* 354039 */ // Label 7035: @354039
     /* 354039 */ GIM_Reject,
     /* 354040 */ // Label 7019: @354040
     /* 354040 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(354277),
     /* 354045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354052 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(354109), // Rule ID 2662 //
     /* 354057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 354072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 354093 */     // MIs[2] Operand 1
     /* 354093 */     // No operand predicates
     /* 354093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354095 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 354095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354107 */     GIR_RootConstrainSelectedInstOperands,
     /* 354108 */     // GIR_Coverage, 2662,
     /* 354108 */     GIR_EraseRootFromParent_Done,
     /* 354109 */   // Label 7042: @354109
     /* 354109 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(354166), // Rule ID 8190 //
     /* 354114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354150 */     // MIs[2] Operand 1
     /* 354150 */     // No operand predicates
     /* 354150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354152 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354164 */     GIR_RootConstrainSelectedInstOperands,
     /* 354165 */     // GIR_Coverage, 8190,
     /* 354165 */     GIR_EraseRootFromParent_Done,
     /* 354166 */   // Label 7043: @354166
     /* 354166 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(354200), // Rule ID 8229 //
     /* 354171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354182 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 354186 */     // MIs[1] Operand 1
     /* 354186 */     // No operand predicates
     /* 354186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354188 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 354188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 354191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354193 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 354198 */     GIR_RootConstrainSelectedInstOperands,
     /* 354199 */     // GIR_Coverage, 8229,
     /* 354199 */     GIR_EraseRootFromParent_Done,
     /* 354200 */   // Label 7044: @354200
     /* 354200 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(354276), // Rule ID 8207 //
     /* 354205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354212 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 354248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354274 */     GIR_RootConstrainSelectedInstOperands,
     /* 354275 */     // GIR_Coverage, 8207,
     /* 354275 */     GIR_EraseRootFromParent_Done,
     /* 354276 */   // Label 7045: @354276
     /* 354276 */   GIM_Reject,
     /* 354277 */ // Label 7041: @354277
     /* 354277 */ GIM_Reject,
     /* 354278 */ // Label 7020: @354278
     /* 354278 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(354534),
     /* 354283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354290 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(354347), // Rule ID 2655 //
     /* 354295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 354331 */     // MIs[2] Operand 1
     /* 354331 */     // No operand predicates
     /* 354331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354333 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 354333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354345 */     GIR_RootConstrainSelectedInstOperands,
     /* 354346 */     // GIR_Coverage, 2655,
     /* 354346 */     GIR_EraseRootFromParent_Done,
     /* 354347 */   // Label 7047: @354347
     /* 354347 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(354404), // Rule ID 8199 //
     /* 354352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 354388 */     // MIs[2] Operand 1
     /* 354388 */     // No operand predicates
     /* 354388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354390 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 354390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354402 */     GIR_RootConstrainSelectedInstOperands,
     /* 354403 */     // GIR_Coverage, 8199,
     /* 354403 */     GIR_EraseRootFromParent_Done,
     /* 354404 */   // Label 7048: @354404
     /* 354404 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(354438), // Rule ID 8231 //
     /* 354409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354420 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 354424 */     // MIs[1] Operand 1
     /* 354424 */     // No operand predicates
     /* 354424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354426 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 354426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 354429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354431 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 354436 */     GIR_RootConstrainSelectedInstOperands,
     /* 354437 */     // GIR_Coverage, 8231,
     /* 354437 */     GIR_EraseRootFromParent_Done,
     /* 354438 */   // Label 7049: @354438
     /* 354438 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(354457), // Rule ID 2381 //
     /* 354443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354450 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 354455 */     GIR_RootConstrainSelectedInstOperands,
     /* 354456 */     // GIR_Coverage, 2381,
     /* 354456 */     GIR_Done,
     /* 354457 */   // Label 7050: @354457
     /* 354457 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(354533), // Rule ID 8209 //
     /* 354462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354469 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 354505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354531 */     GIR_RootConstrainSelectedInstOperands,
     /* 354532 */     // GIR_Coverage, 8209,
     /* 354532 */     GIR_EraseRootFromParent_Done,
     /* 354533 */   // Label 7051: @354533
     /* 354533 */   GIM_Reject,
     /* 354534 */ // Label 7046: @354534
     /* 354534 */ GIM_Reject,
     /* 354535 */ // Label 7021: @354535
     /* 354535 */ GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(354599), // Rule ID 2652 //
     /* 354540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354550 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354554 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354558 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354566 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354571 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354575 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354579 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354583 */   // MIs[2] Operand 1
     /* 354583 */   // No operand predicates
     /* 354583 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354585 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354590 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354594 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354597 */   GIR_RootConstrainSelectedInstOperands,
     /* 354598 */   // GIR_Coverage, 2652,
     /* 354598 */   GIR_EraseRootFromParent_Done,
     /* 354599 */ // Label 7052: @354599
     /* 354599 */ GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(354663), // Rule ID 8193 //
     /* 354604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354622 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354635 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354639 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354643 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354647 */   // MIs[2] Operand 1
     /* 354647 */   // No operand predicates
     /* 354647 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354649 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354654 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354658 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354661 */   GIR_RootConstrainSelectedInstOperands,
     /* 354662 */   // GIR_Coverage, 8193,
     /* 354662 */   GIR_EraseRootFromParent_Done,
     /* 354663 */ // Label 7053: @354663
     /* 354663 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(354704), // Rule ID 8228 //
     /* 354668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354686 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 354690 */   // MIs[1] Operand 1
     /* 354690 */   // No operand predicates
     /* 354690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354692 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 354692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 354695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354697 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 354702 */   GIR_RootConstrainSelectedInstOperands,
     /* 354703 */   // GIR_Coverage, 8228,
     /* 354703 */   GIR_EraseRootFromParent_Done,
     /* 354704 */ // Label 7054: @354704
     /* 354704 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(354730), // Rule ID 2380 //
     /* 354709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354723 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 354728 */   GIR_RootConstrainSelectedInstOperands,
     /* 354729 */   // GIR_Coverage, 2380,
     /* 354729 */   GIR_Done,
     /* 354730 */ // Label 7055: @354730
     /* 354730 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(354813), // Rule ID 8206 //
     /* 354735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354749 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354749 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354752 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354756 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354778 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354782 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 354785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354795 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354811 */   GIR_RootConstrainSelectedInstOperands,
     /* 354812 */   // GIR_Coverage, 8206,
     /* 354812 */   GIR_EraseRootFromParent_Done,
     /* 354813 */ // Label 7056: @354813
     /* 354813 */ GIM_Reject,
     /* 354814 */ // Label 7022: @354814
     /* 354814 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(354903),
     /* 354819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354826 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(354883), // Rule ID 2649 //
     /* 354831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 354846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 354867 */     // MIs[2] Operand 1
     /* 354867 */     // No operand predicates
     /* 354867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354869 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 354869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 354872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354881 */     GIR_RootConstrainSelectedInstOperands,
     /* 354882 */     // GIR_Coverage, 2649,
     /* 354882 */     GIR_EraseRootFromParent_Done,
     /* 354883 */   // Label 7058: @354883
     /* 354883 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(354902), // Rule ID 2379 //
     /* 354888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354895 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 354900 */     GIR_RootConstrainSelectedInstOperands,
     /* 354901 */     // GIR_Coverage, 2379,
     /* 354901 */     GIR_Done,
     /* 354902 */   // Label 7059: @354902
     /* 354902 */   GIM_Reject,
     /* 354903 */ // Label 7057: @354903
     /* 354903 */ GIM_Reject,
     /* 354904 */ // Label 7023: @354904
     /* 354904 */ GIM_Reject,
     /* 354905 */ // Label 88: @354905
     /* 354905 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7062*/ GIMT_Encode4(355056),
     /* 354916 */ /*GILLT_s32*//*Label 7060*/ GIMT_Encode4(354924),
     /* 354920 */ /*GILLT_s64*//*Label 7061*/ GIMT_Encode4(354990),
     /* 354924 */ // Label 7060: @354924
     /* 354924 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(354989),
     /* 354929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354940 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(354955), // Rule ID 2312 //
     /* 354945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 354948 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 354953 */     GIR_RootConstrainSelectedInstOperands,
     /* 354954 */     // GIR_Coverage, 2312,
     /* 354954 */     GIR_Done,
     /* 354955 */   // Label 7064: @354955
     /* 354955 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(354988), // Rule ID 3947 //
     /* 354960 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 354960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 354967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 354976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 354981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354986 */     GIR_RootConstrainSelectedInstOperands,
     /* 354987 */     // GIR_Coverage, 3947,
     /* 354987 */     GIR_EraseRootFromParent_Done,
     /* 354988 */   // Label 7065: @354988
     /* 354988 */   GIM_Reject,
     /* 354989 */ // Label 7063: @354989
     /* 354989 */ GIM_Reject,
     /* 354990 */ // Label 7061: @354990
     /* 354990 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(355055),
     /* 354995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355006 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(355021), // Rule ID 2313 //
     /* 355011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355014 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 355019 */     GIR_RootConstrainSelectedInstOperands,
     /* 355020 */     // GIR_Coverage, 2313,
     /* 355020 */     GIR_Done,
     /* 355021 */   // Label 7067: @355021
     /* 355021 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(355054), // Rule ID 3948 //
     /* 355026 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 355026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 355033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 355042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 355047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355052 */     GIR_RootConstrainSelectedInstOperands,
     /* 355053 */     // GIR_Coverage, 3948,
     /* 355053 */     GIR_EraseRootFromParent_Done,
     /* 355054 */   // Label 7068: @355054
     /* 355054 */   GIM_Reject,
     /* 355055 */ // Label 7066: @355055
     /* 355055 */ GIM_Reject,
     /* 355056 */ // Label 7062: @355056
     /* 355056 */ GIM_Reject,
     /* 355057 */ // Label 89: @355057
     /* 355057 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7077*/ GIMT_Encode4(355730),
     /* 355068 */ /*GILLT_s32*//*Label 7069*/ GIMT_Encode4(355108),
     /* 355072 */ /*GILLT_s64*//*Label 7070*/ GIMT_Encode4(355338), GIMT_Encode4(0),
     /* 355080 */ /*GILLT_v2s32*//*Label 7071*/ GIMT_Encode4(355568), GIMT_Encode4(0),
     /* 355088 */ /*GILLT_v4s16*//*Label 7072*/ GIMT_Encode4(355595),
     /* 355092 */ /*GILLT_v4s32*//*Label 7073*/ GIMT_Encode4(355622),
     /* 355096 */ /*GILLT_v8s8*//*Label 7074*/ GIMT_Encode4(355649),
     /* 355100 */ /*GILLT_v8s16*//*Label 7075*/ GIMT_Encode4(355676),
     /* 355104 */ /*GILLT_v16s8*//*Label 7076*/ GIMT_Encode4(355703),
     /* 355108 */ // Label 7069: @355108
     /* 355108 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(355337),
     /* 355113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355120 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(355220), // Rule ID 3949 //
     /* 355125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 355141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 355153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 355169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 355173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355177 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 355181 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355185 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355190 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 355194 */     // MIs[3] Rn
     /* 355194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 355199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355207 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355209 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 355212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 355218 */     GIR_RootConstrainSelectedInstOperands,
     /* 355219 */     // GIR_Coverage, 3949,
     /* 355219 */     GIR_EraseRootFromParent_Done,
     /* 355220 */   // Label 7079: @355220
     /* 355220 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(355320), // Rule ID 13540 //
     /* 355225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 355241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 355253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 355269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 355273 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 355282 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355286 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355290 */     // MIs[4] Rn
     /* 355290 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 355295 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 355299 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355307 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355309 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 355312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 355318 */     GIR_RootConstrainSelectedInstOperands,
     /* 355319 */     // GIR_Coverage, 13540,
     /* 355319 */     GIR_EraseRootFromParent_Done,
     /* 355320 */   // Label 7080: @355320
     /* 355320 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(355336), // Rule ID 180 //
     /* 355325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355329 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 355334 */     GIR_RootConstrainSelectedInstOperands,
     /* 355335 */     // GIR_Coverage, 180,
     /* 355335 */     GIR_Done,
     /* 355336 */   // Label 7081: @355336
     /* 355336 */   GIM_Reject,
     /* 355337 */ // Label 7078: @355337
     /* 355337 */ GIM_Reject,
     /* 355338 */ // Label 7070: @355338
     /* 355338 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(355567),
     /* 355343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355350 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(355450), // Rule ID 3950 //
     /* 355355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 355383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 355399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 355403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 355411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355415 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355420 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 355424 */     // MIs[3] Rn
     /* 355424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 355429 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355433 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355439 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 355442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 355448 */     GIR_RootConstrainSelectedInstOperands,
     /* 355449 */     // GIR_Coverage, 3950,
     /* 355449 */     GIR_EraseRootFromParent_Done,
     /* 355450 */   // Label 7083: @355450
     /* 355450 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(355550), // Rule ID 13541 //
     /* 355455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 355483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 355499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 355503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 355512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355516 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355520 */     // MIs[4] Rn
     /* 355520 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 355525 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 355529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355533 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355537 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355539 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 355542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 355548 */     GIR_RootConstrainSelectedInstOperands,
     /* 355549 */     // GIR_Coverage, 13541,
     /* 355549 */     GIR_EraseRootFromParent_Done,
     /* 355550 */   // Label 7084: @355550
     /* 355550 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(355566), // Rule ID 181 //
     /* 355555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355559 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 355564 */     GIR_RootConstrainSelectedInstOperands,
     /* 355565 */     // GIR_Coverage, 181,
     /* 355565 */     GIR_Done,
     /* 355566 */   // Label 7085: @355566
     /* 355566 */   GIM_Reject,
     /* 355567 */ // Label 7082: @355567
     /* 355567 */ GIM_Reject,
     /* 355568 */ // Label 7071: @355568
     /* 355568 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(355594), // Rule ID 720 //
     /* 355573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355587 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 355587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 355592 */   GIR_RootConstrainSelectedInstOperands,
     /* 355593 */   // GIR_Coverage, 720,
     /* 355593 */   GIR_Done,
     /* 355594 */ // Label 7086: @355594
     /* 355594 */ GIM_Reject,
     /* 355595 */ // Label 7072: @355595
     /* 355595 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(355621), // Rule ID 718 //
     /* 355600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355614 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 355614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 355619 */   GIR_RootConstrainSelectedInstOperands,
     /* 355620 */   // GIR_Coverage, 718,
     /* 355620 */   GIR_Done,
     /* 355621 */ // Label 7087: @355621
     /* 355621 */ GIM_Reject,
     /* 355622 */ // Label 7073: @355622
     /* 355622 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(355648), // Rule ID 721 //
     /* 355627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355641 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 355641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 355646 */   GIR_RootConstrainSelectedInstOperands,
     /* 355647 */   // GIR_Coverage, 721,
     /* 355647 */   GIR_Done,
     /* 355648 */ // Label 7088: @355648
     /* 355648 */ GIM_Reject,
     /* 355649 */ // Label 7074: @355649
     /* 355649 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(355675), // Rule ID 716 //
     /* 355654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355668 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 355673 */   GIR_RootConstrainSelectedInstOperands,
     /* 355674 */   // GIR_Coverage, 716,
     /* 355674 */   GIR_Done,
     /* 355675 */ // Label 7089: @355675
     /* 355675 */ GIM_Reject,
     /* 355676 */ // Label 7075: @355676
     /* 355676 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(355702), // Rule ID 719 //
     /* 355681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355695 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 355695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 355700 */   GIR_RootConstrainSelectedInstOperands,
     /* 355701 */   // GIR_Coverage, 719,
     /* 355701 */   GIR_Done,
     /* 355702 */ // Label 7090: @355702
     /* 355702 */ GIM_Reject,
     /* 355703 */ // Label 7076: @355703
     /* 355703 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(355729), // Rule ID 717 //
     /* 355708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355722 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 355727 */   GIR_RootConstrainSelectedInstOperands,
     /* 355728 */   // GIR_Coverage, 717,
     /* 355728 */   GIR_Done,
     /* 355729 */ // Label 7091: @355729
     /* 355729 */ GIM_Reject,
     /* 355730 */ // Label 7077: @355730
     /* 355730 */ GIM_Reject,
     /* 355731 */ // Label 90: @355731
     /* 355731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7096*/ GIMT_Encode4(355890),
     /* 355742 */ /*GILLT_s32*//*Label 7092*/ GIMT_Encode4(355782),
     /* 355746 */ /*GILLT_s64*//*Label 7093*/ GIMT_Encode4(355809), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355770 */ /*GILLT_v8s8*//*Label 7094*/ GIMT_Encode4(355836), GIMT_Encode4(0),
     /* 355778 */ /*GILLT_v16s8*//*Label 7095*/ GIMT_Encode4(355863),
     /* 355782 */ // Label 7092: @355782
     /* 355782 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(355808), // Rule ID 2310 //
     /* 355787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355801 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 355806 */   GIR_RootConstrainSelectedInstOperands,
     /* 355807 */   // GIR_Coverage, 2310,
     /* 355807 */   GIR_Done,
     /* 355808 */ // Label 7097: @355808
     /* 355808 */ GIM_Reject,
     /* 355809 */ // Label 7093: @355809
     /* 355809 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(355835), // Rule ID 2311 //
     /* 355814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355828 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 355833 */   GIR_RootConstrainSelectedInstOperands,
     /* 355834 */   // GIR_Coverage, 2311,
     /* 355834 */   GIR_Done,
     /* 355835 */ // Label 7098: @355835
     /* 355835 */ GIM_Reject,
     /* 355836 */ // Label 7094: @355836
     /* 355836 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(355862), // Rule ID 757 //
     /* 355841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355855 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 355860 */   GIR_RootConstrainSelectedInstOperands,
     /* 355861 */   // GIR_Coverage, 757,
     /* 355861 */   GIR_Done,
     /* 355862 */ // Label 7099: @355862
     /* 355862 */ GIM_Reject,
     /* 355863 */ // Label 7095: @355863
     /* 355863 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(355889), // Rule ID 758 //
     /* 355868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355882 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 355887 */   GIR_RootConstrainSelectedInstOperands,
     /* 355888 */   // GIR_Coverage, 758,
     /* 355888 */   GIR_Done,
     /* 355889 */ // Label 7100: @355889
     /* 355889 */ GIM_Reject,
     /* 355890 */ // Label 7096: @355890
     /* 355890 */ GIM_Reject,
     /* 355891 */ // Label 91: @355891
     /* 355891 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7108*/ GIMT_Encode4(356204),
     /* 355902 */ /*GILLT_s32*//*Label 7101*/ GIMT_Encode4(355938),
     /* 355906 */ /*GILLT_s64*//*Label 7102*/ GIMT_Encode4(356011), GIMT_Encode4(0),
     /* 355914 */ /*GILLT_v2s32*//*Label 7103*/ GIMT_Encode4(356084),
     /* 355918 */ /*GILLT_v2s64*//*Label 7104*/ GIMT_Encode4(356108),
     /* 355922 */ /*GILLT_v4s16*//*Label 7105*/ GIMT_Encode4(356132),
     /* 355926 */ /*GILLT_v4s32*//*Label 7106*/ GIMT_Encode4(356156), GIMT_Encode4(0),
     /* 355934 */ /*GILLT_v8s16*//*Label 7107*/ GIMT_Encode4(356180),
     /* 355938 */ // Label 7101: @355938
     /* 355938 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(356010),
     /* 355943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355950 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(355993), // Rule ID 3953 //
     /* 355955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 355963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355976 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 355980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355982 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 355985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355991 */     GIR_RootConstrainSelectedInstOperands,
     /* 355992 */     // GIR_Coverage, 3953,
     /* 355992 */     GIR_EraseRootFromParent_Done,
     /* 355993 */   // Label 7110: @355993
     /* 355993 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(356009), // Rule ID 185 //
     /* 355998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356002 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 356002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 356007 */     GIR_RootConstrainSelectedInstOperands,
     /* 356008 */     // GIR_Coverage, 185,
     /* 356008 */     GIR_Done,
     /* 356009 */   // Label 7111: @356009
     /* 356009 */   GIM_Reject,
     /* 356010 */ // Label 7109: @356010
     /* 356010 */ GIM_Reject,
     /* 356011 */ // Label 7102: @356011
     /* 356011 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(356083),
     /* 356016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356023 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(356066), // Rule ID 3954 //
     /* 356028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 356036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 356040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356049 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 356053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356055 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 356055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 356058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 356060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356064 */     GIR_RootConstrainSelectedInstOperands,
     /* 356065 */     // GIR_Coverage, 3954,
     /* 356065 */     GIR_EraseRootFromParent_Done,
     /* 356066 */   // Label 7113: @356066
     /* 356066 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(356082), // Rule ID 186 //
     /* 356071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356075 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 356075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 356080 */     GIR_RootConstrainSelectedInstOperands,
     /* 356081 */     // GIR_Coverage, 186,
     /* 356081 */     GIR_Done,
     /* 356082 */   // Label 7114: @356082
     /* 356082 */   GIM_Reject,
     /* 356083 */ // Label 7112: @356083
     /* 356083 */ GIM_Reject,
     /* 356084 */ // Label 7103: @356084
     /* 356084 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(356107), // Rule ID 4928 //
     /* 356089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356100 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 356100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 356105 */   GIR_RootConstrainSelectedInstOperands,
     /* 356106 */   // GIR_Coverage, 4928,
     /* 356106 */   GIR_Done,
     /* 356107 */ // Label 7115: @356107
     /* 356107 */ GIM_Reject,
     /* 356108 */ // Label 7104: @356108
     /* 356108 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(356131), // Rule ID 4930 //
     /* 356113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356124 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 356124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 356129 */   GIR_RootConstrainSelectedInstOperands,
     /* 356130 */   // GIR_Coverage, 4930,
     /* 356130 */   GIR_Done,
     /* 356131 */ // Label 7116: @356131
     /* 356131 */ GIM_Reject,
     /* 356132 */ // Label 7105: @356132
     /* 356132 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(356155), // Rule ID 4926 //
     /* 356137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356148 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 356148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 356153 */   GIR_RootConstrainSelectedInstOperands,
     /* 356154 */   // GIR_Coverage, 4926,
     /* 356154 */   GIR_Done,
     /* 356155 */ // Label 7117: @356155
     /* 356155 */ GIM_Reject,
     /* 356156 */ // Label 7106: @356156
     /* 356156 */ GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(356179), // Rule ID 4929 //
     /* 356161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356172 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 356172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 356177 */   GIR_RootConstrainSelectedInstOperands,
     /* 356178 */   // GIR_Coverage, 4929,
     /* 356178 */   GIR_Done,
     /* 356179 */ // Label 7118: @356179
     /* 356179 */ GIM_Reject,
     /* 356180 */ // Label 7107: @356180
     /* 356180 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(356203), // Rule ID 4927 //
     /* 356185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356196 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 356196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 356201 */   GIR_RootConstrainSelectedInstOperands,
     /* 356202 */   // GIR_Coverage, 4927,
     /* 356202 */   GIR_Done,
     /* 356203 */ // Label 7119: @356203
     /* 356203 */ GIM_Reject,
     /* 356204 */ // Label 7108: @356204
     /* 356204 */ GIM_Reject,
     /* 356205 */ // Label 92: @356205
     /* 356205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7124*/ GIMT_Encode4(356358),
     /* 356216 */ /*GILLT_s32*//*Label 7120*/ GIMT_Encode4(356256),
     /* 356220 */ /*GILLT_s64*//*Label 7121*/ GIMT_Encode4(356280), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 356244 */ /*GILLT_v8s8*//*Label 7122*/ GIMT_Encode4(356304), GIMT_Encode4(0),
     /* 356252 */ /*GILLT_v16s8*//*Label 7123*/ GIMT_Encode4(356331),
     /* 356256 */ // Label 7120: @356256
     /* 356256 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(356279), // Rule ID 182 //
     /* 356261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356272 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 356272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 356277 */   GIR_RootConstrainSelectedInstOperands,
     /* 356278 */   // GIR_Coverage, 182,
     /* 356278 */   GIR_Done,
     /* 356279 */ // Label 7125: @356279
     /* 356279 */ GIM_Reject,
     /* 356280 */ // Label 7121: @356280
     /* 356280 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(356303), // Rule ID 183 //
     /* 356285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356296 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 356296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 356301 */   GIR_RootConstrainSelectedInstOperands,
     /* 356302 */   // GIR_Coverage, 183,
     /* 356302 */   GIR_Done,
     /* 356303 */ // Label 7126: @356303
     /* 356303 */ GIM_Reject,
     /* 356304 */ // Label 7122: @356304
     /* 356304 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(356330), // Rule ID 967 //
     /* 356309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 356315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356323 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 356323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 356328 */   GIR_RootConstrainSelectedInstOperands,
     /* 356329 */   // GIR_Coverage, 967,
     /* 356329 */   GIR_Done,
     /* 356330 */ // Label 7127: @356330
     /* 356330 */ GIM_Reject,
     /* 356331 */ // Label 7123: @356331
     /* 356331 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(356357), // Rule ID 968 //
     /* 356336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 356342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356350 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 356350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 356355 */   GIR_RootConstrainSelectedInstOperands,
     /* 356356 */   // GIR_Coverage, 968,
     /* 356356 */   GIR_Done,
     /* 356357 */ // Label 7128: @356357
     /* 356357 */ GIM_Reject,
     /* 356358 */ // Label 7124: @356358
     /* 356358 */ GIM_Reject,
     /* 356359 */ // Label 93: @356359
     /* 356359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7137*/ GIMT_Encode4(356849),
     /* 356370 */ /*GILLT_s16*//*Label 7129*/ GIMT_Encode4(356410),
     /* 356374 */ /*GILLT_s32*//*Label 7130*/ GIMT_Encode4(356441),
     /* 356378 */ /*GILLT_s64*//*Label 7131*/ GIMT_Encode4(356472), GIMT_Encode4(0),
     /* 356386 */ /*GILLT_v2s32*//*Label 7132*/ GIMT_Encode4(356503),
     /* 356390 */ /*GILLT_v2s64*//*Label 7133*/ GIMT_Encode4(356534),
     /* 356394 */ /*GILLT_v4s16*//*Label 7134*/ GIMT_Encode4(356565),
     /* 356398 */ /*GILLT_v4s32*//*Label 7135*/ GIMT_Encode4(356596), GIMT_Encode4(0),
     /* 356406 */ /*GILLT_v8s16*//*Label 7136*/ GIMT_Encode4(356627),
     /* 356410 */ // Label 7129: @356410
     /* 356410 */ GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(356440), // Rule ID 552 //
     /* 356415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356429 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 356434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356438 */   GIR_RootConstrainSelectedInstOperands,
     /* 356439 */   // GIR_Coverage, 552,
     /* 356439 */   GIR_Done,
     /* 356440 */ // Label 7138: @356440
     /* 356440 */ GIM_Reject,
     /* 356441 */ // Label 7130: @356441
     /* 356441 */ GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(356471), // Rule ID 554 //
     /* 356446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356460 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 356465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356469 */   GIR_RootConstrainSelectedInstOperands,
     /* 356470 */   // GIR_Coverage, 554,
     /* 356470 */   GIR_Done,
     /* 356471 */ // Label 7139: @356471
     /* 356471 */ GIM_Reject,
     /* 356472 */ // Label 7131: @356472
     /* 356472 */ GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(356502), // Rule ID 556 //
     /* 356477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356491 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 356496 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356500 */   GIR_RootConstrainSelectedInstOperands,
     /* 356501 */   // GIR_Coverage, 556,
     /* 356501 */   GIR_Done,
     /* 356502 */ // Label 7140: @356502
     /* 356502 */ GIM_Reject,
     /* 356503 */ // Label 7132: @356503
     /* 356503 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356533), // Rule ID 906 //
     /* 356508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356522 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 356527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356531 */   GIR_RootConstrainSelectedInstOperands,
     /* 356532 */   // GIR_Coverage, 906,
     /* 356532 */   GIR_Done,
     /* 356533 */ // Label 7141: @356533
     /* 356533 */ GIM_Reject,
     /* 356534 */ // Label 7133: @356534
     /* 356534 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(356564), // Rule ID 910 //
     /* 356539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356553 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 356558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356562 */   GIR_RootConstrainSelectedInstOperands,
     /* 356563 */   // GIR_Coverage, 910,
     /* 356563 */   GIR_Done,
     /* 356564 */ // Label 7142: @356564
     /* 356564 */ GIM_Reject,
     /* 356565 */ // Label 7134: @356565
     /* 356565 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(356595), // Rule ID 902 //
     /* 356570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356584 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 356589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356593 */   GIR_RootConstrainSelectedInstOperands,
     /* 356594 */   // GIR_Coverage, 902,
     /* 356594 */   GIR_Done,
     /* 356595 */ // Label 7143: @356595
     /* 356595 */ GIM_Reject,
     /* 356596 */ // Label 7135: @356596
     /* 356596 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356626), // Rule ID 908 //
     /* 356601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356615 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356624 */   GIR_RootConstrainSelectedInstOperands,
     /* 356625 */   // GIR_Coverage, 908,
     /* 356625 */   GIR_Done,
     /* 356626 */ // Label 7144: @356626
     /* 356626 */ GIM_Reject,
     /* 356627 */ // Label 7136: @356627
     /* 356627 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356848),
     /* 356632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356643 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356662), // Rule ID 904 //
     /* 356648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356651 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 356656 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356660 */     GIR_RootConstrainSelectedInstOperands,
     /* 356661 */     // GIR_Coverage, 904,
     /* 356661 */     GIR_Done,
     /* 356662 */   // Label 7146: @356662
     /* 356662 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356847), // Rule ID 6900 //
     /* 356667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 356670 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 356670 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 356673 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 356677 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356682 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 356688 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 356691 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356695 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356700 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 356703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 356705 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 356708 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356712 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356717 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 356723 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356728 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356733 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356736 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 356740 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356745 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 356748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356750 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356753 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356757 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356762 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 356770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 356774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356779 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 356782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 356819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 356837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 356845 */     GIR_RootConstrainSelectedInstOperands,
     /* 356846 */     // GIR_Coverage, 6900,
     /* 356846 */     GIR_EraseRootFromParent_Done,
     /* 356847 */   // Label 7147: @356847
     /* 356847 */   GIM_Reject,
     /* 356848 */ // Label 7145: @356848
     /* 356848 */ GIM_Reject,
     /* 356849 */ // Label 7137: @356849
     /* 356849 */ GIM_Reject,
     /* 356850 */ // Label 94: @356850
     /* 356850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7156*/ GIMT_Encode4(357149),
     /* 356861 */ /*GILLT_s16*//*Label 7148*/ GIMT_Encode4(356901),
     /* 356865 */ /*GILLT_s32*//*Label 7149*/ GIMT_Encode4(356932),
     /* 356869 */ /*GILLT_s64*//*Label 7150*/ GIMT_Encode4(356963), GIMT_Encode4(0),
     /* 356877 */ /*GILLT_v2s32*//*Label 7151*/ GIMT_Encode4(356994),
     /* 356881 */ /*GILLT_v2s64*//*Label 7152*/ GIMT_Encode4(357025),
     /* 356885 */ /*GILLT_v4s16*//*Label 7153*/ GIMT_Encode4(357056),
     /* 356889 */ /*GILLT_v4s32*//*Label 7154*/ GIMT_Encode4(357087), GIMT_Encode4(0),
     /* 356897 */ /*GILLT_v8s16*//*Label 7155*/ GIMT_Encode4(357118),
     /* 356901 */ // Label 7148: @356901
     /* 356901 */ GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(356931), // Rule ID 570 //
     /* 356906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356920 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 356925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356929 */   GIR_RootConstrainSelectedInstOperands,
     /* 356930 */   // GIR_Coverage, 570,
     /* 356930 */   GIR_Done,
     /* 356931 */ // Label 7157: @356931
     /* 356931 */ GIM_Reject,
     /* 356932 */ // Label 7149: @356932
     /* 356932 */ GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356962), // Rule ID 572 //
     /* 356937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356951 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 356956 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356960 */   GIR_RootConstrainSelectedInstOperands,
     /* 356961 */   // GIR_Coverage, 572,
     /* 356961 */   GIR_Done,
     /* 356962 */ // Label 7158: @356962
     /* 356962 */ GIM_Reject,
     /* 356963 */ // Label 7150: @356963
     /* 356963 */ GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356993), // Rule ID 574 //
     /* 356968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356982 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 356987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356991 */   GIR_RootConstrainSelectedInstOperands,
     /* 356992 */   // GIR_Coverage, 574,
     /* 356992 */   GIR_Done,
     /* 356993 */ // Label 7159: @356993
     /* 356993 */ GIM_Reject,
     /* 356994 */ // Label 7151: @356994
     /* 356994 */ GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(357024), // Rule ID 953 //
     /* 356999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357013 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 357018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357022 */   GIR_RootConstrainSelectedInstOperands,
     /* 357023 */   // GIR_Coverage, 953,
     /* 357023 */   GIR_Done,
     /* 357024 */ // Label 7160: @357024
     /* 357024 */ GIM_Reject,
     /* 357025 */ // Label 7152: @357025
     /* 357025 */ GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357055), // Rule ID 957 //
     /* 357030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357044 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 357049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357053 */   GIR_RootConstrainSelectedInstOperands,
     /* 357054 */   // GIR_Coverage, 957,
     /* 357054 */   GIR_Done,
     /* 357055 */ // Label 7161: @357055
     /* 357055 */ GIM_Reject,
     /* 357056 */ // Label 7153: @357056
     /* 357056 */ GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(357086), // Rule ID 949 //
     /* 357061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357075 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 357080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357084 */   GIR_RootConstrainSelectedInstOperands,
     /* 357085 */   // GIR_Coverage, 949,
     /* 357085 */   GIR_Done,
     /* 357086 */ // Label 7162: @357086
     /* 357086 */ GIM_Reject,
     /* 357087 */ // Label 7154: @357087
     /* 357087 */ GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(357117), // Rule ID 955 //
     /* 357092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357106 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 357111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357115 */   GIR_RootConstrainSelectedInstOperands,
     /* 357116 */   // GIR_Coverage, 955,
     /* 357116 */   GIR_Done,
     /* 357117 */ // Label 7163: @357117
     /* 357117 */ GIM_Reject,
     /* 357118 */ // Label 7155: @357118
     /* 357118 */ GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(357148), // Rule ID 951 //
     /* 357123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357137 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 357142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357146 */   GIR_RootConstrainSelectedInstOperands,
     /* 357147 */   // GIR_Coverage, 951,
     /* 357147 */   GIR_Done,
     /* 357148 */ // Label 7164: @357148
     /* 357148 */ GIM_Reject,
     /* 357149 */ // Label 7156: @357149
     /* 357149 */ GIM_Reject,
     /* 357150 */ // Label 95: @357150
     /* 357150 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7173*/ GIMT_Encode4(357640),
     /* 357161 */ /*GILLT_s16*//*Label 7165*/ GIMT_Encode4(357201),
     /* 357165 */ /*GILLT_s32*//*Label 7166*/ GIMT_Encode4(357232),
     /* 357169 */ /*GILLT_s64*//*Label 7167*/ GIMT_Encode4(357263), GIMT_Encode4(0),
     /* 357177 */ /*GILLT_v2s32*//*Label 7168*/ GIMT_Encode4(357294),
     /* 357181 */ /*GILLT_v2s64*//*Label 7169*/ GIMT_Encode4(357325),
     /* 357185 */ /*GILLT_v4s16*//*Label 7170*/ GIMT_Encode4(357356),
     /* 357189 */ /*GILLT_v4s32*//*Label 7171*/ GIMT_Encode4(357387), GIMT_Encode4(0),
     /* 357197 */ /*GILLT_v8s16*//*Label 7172*/ GIMT_Encode4(357418),
     /* 357201 */ // Label 7165: @357201
     /* 357201 */ GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(357231), // Rule ID 540 //
     /* 357206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357220 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 357225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357229 */   GIR_RootConstrainSelectedInstOperands,
     /* 357230 */   // GIR_Coverage, 540,
     /* 357230 */   GIR_Done,
     /* 357231 */ // Label 7174: @357231
     /* 357231 */ GIM_Reject,
     /* 357232 */ // Label 7166: @357232
     /* 357232 */ GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357262), // Rule ID 542 //
     /* 357237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357251 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 357256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357260 */   GIR_RootConstrainSelectedInstOperands,
     /* 357261 */   // GIR_Coverage, 542,
     /* 357261 */   GIR_Done,
     /* 357262 */ // Label 7175: @357262
     /* 357262 */ GIM_Reject,
     /* 357263 */ // Label 7167: @357263
     /* 357263 */ GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(357293), // Rule ID 544 //
     /* 357268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357282 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 357287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357291 */   GIR_RootConstrainSelectedInstOperands,
     /* 357292 */   // GIR_Coverage, 544,
     /* 357292 */   GIR_Done,
     /* 357293 */ // Label 7176: @357293
     /* 357293 */ GIM_Reject,
     /* 357294 */ // Label 7168: @357294
     /* 357294 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(357324), // Rule ID 886 //
     /* 357299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357313 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 357318 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357322 */   GIR_RootConstrainSelectedInstOperands,
     /* 357323 */   // GIR_Coverage, 886,
     /* 357323 */   GIR_Done,
     /* 357324 */ // Label 7177: @357324
     /* 357324 */ GIM_Reject,
     /* 357325 */ // Label 7169: @357325
     /* 357325 */ GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(357355), // Rule ID 890 //
     /* 357330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357344 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 357349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357353 */   GIR_RootConstrainSelectedInstOperands,
     /* 357354 */   // GIR_Coverage, 890,
     /* 357354 */   GIR_Done,
     /* 357355 */ // Label 7178: @357355
     /* 357355 */ GIM_Reject,
     /* 357356 */ // Label 7170: @357356
     /* 357356 */ GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(357386), // Rule ID 882 //
     /* 357361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357375 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 357380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357384 */   GIR_RootConstrainSelectedInstOperands,
     /* 357385 */   // GIR_Coverage, 882,
     /* 357385 */   GIR_Done,
     /* 357386 */ // Label 7179: @357386
     /* 357386 */ GIM_Reject,
     /* 357387 */ // Label 7171: @357387
     /* 357387 */ GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(357417), // Rule ID 888 //
     /* 357392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357406 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357415 */   GIR_RootConstrainSelectedInstOperands,
     /* 357416 */   // GIR_Coverage, 888,
     /* 357416 */   GIR_Done,
     /* 357417 */ // Label 7180: @357417
     /* 357417 */ GIM_Reject,
     /* 357418 */ // Label 7172: @357418
     /* 357418 */ GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(357639),
     /* 357423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357434 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(357453), // Rule ID 884 //
     /* 357439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357442 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 357447 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357451 */     GIR_RootConstrainSelectedInstOperands,
     /* 357452 */     // GIR_Coverage, 884,
     /* 357452 */     GIR_Done,
     /* 357453 */   // Label 7182: @357453
     /* 357453 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(357638), // Rule ID 6902 //
     /* 357458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357461 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357461 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357464 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357468 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357473 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357479 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357482 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357486 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357491 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357496 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357499 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357503 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357508 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 357514 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357519 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357524 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357527 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 357531 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357536 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 357539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357541 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357544 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357548 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357553 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 357561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 357565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357570 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 357573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 357628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 357636 */     GIR_RootConstrainSelectedInstOperands,
     /* 357637 */     // GIR_Coverage, 6902,
     /* 357637 */     GIR_EraseRootFromParent_Done,
     /* 357638 */   // Label 7183: @357638
     /* 357638 */   GIM_Reject,
     /* 357639 */ // Label 7181: @357639
     /* 357639 */ GIM_Reject,
     /* 357640 */ // Label 7173: @357640
     /* 357640 */ GIM_Reject,
     /* 357641 */ // Label 96: @357641
     /* 357641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7192*/ GIMT_Encode4(358131),
     /* 357652 */ /*GILLT_s16*//*Label 7184*/ GIMT_Encode4(357692),
     /* 357656 */ /*GILLT_s32*//*Label 7185*/ GIMT_Encode4(357723),
     /* 357660 */ /*GILLT_s64*//*Label 7186*/ GIMT_Encode4(357754), GIMT_Encode4(0),
     /* 357668 */ /*GILLT_v2s32*//*Label 7187*/ GIMT_Encode4(357785),
     /* 357672 */ /*GILLT_v2s64*//*Label 7188*/ GIMT_Encode4(357816),
     /* 357676 */ /*GILLT_v4s16*//*Label 7189*/ GIMT_Encode4(357847),
     /* 357680 */ /*GILLT_v4s32*//*Label 7190*/ GIMT_Encode4(357878), GIMT_Encode4(0),
     /* 357688 */ /*GILLT_v8s16*//*Label 7191*/ GIMT_Encode4(357909),
     /* 357692 */ // Label 7184: @357692
     /* 357692 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(357722), // Rule ID 558 //
     /* 357697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357711 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 357716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357720 */   GIR_RootConstrainSelectedInstOperands,
     /* 357721 */   // GIR_Coverage, 558,
     /* 357721 */   GIR_Done,
     /* 357722 */ // Label 7193: @357722
     /* 357722 */ GIM_Reject,
     /* 357723 */ // Label 7185: @357723
     /* 357723 */ GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(357753), // Rule ID 560 //
     /* 357728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357742 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 357747 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357751 */   GIR_RootConstrainSelectedInstOperands,
     /* 357752 */   // GIR_Coverage, 560,
     /* 357752 */   GIR_Done,
     /* 357753 */ // Label 7194: @357753
     /* 357753 */ GIM_Reject,
     /* 357754 */ // Label 7186: @357754
     /* 357754 */ GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(357784), // Rule ID 562 //
     /* 357759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357773 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 357778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357782 */   GIR_RootConstrainSelectedInstOperands,
     /* 357783 */   // GIR_Coverage, 562,
     /* 357783 */   GIR_Done,
     /* 357784 */ // Label 7195: @357784
     /* 357784 */ GIM_Reject,
     /* 357785 */ // Label 7187: @357785
     /* 357785 */ GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(357815), // Rule ID 916 //
     /* 357790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357804 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 357809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357813 */   GIR_RootConstrainSelectedInstOperands,
     /* 357814 */   // GIR_Coverage, 916,
     /* 357814 */   GIR_Done,
     /* 357815 */ // Label 7196: @357815
     /* 357815 */ GIM_Reject,
     /* 357816 */ // Label 7188: @357816
     /* 357816 */ GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(357846), // Rule ID 920 //
     /* 357821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357835 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 357840 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357844 */   GIR_RootConstrainSelectedInstOperands,
     /* 357845 */   // GIR_Coverage, 920,
     /* 357845 */   GIR_Done,
     /* 357846 */ // Label 7197: @357846
     /* 357846 */ GIM_Reject,
     /* 357847 */ // Label 7189: @357847
     /* 357847 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(357877), // Rule ID 912 //
     /* 357852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357866 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 357871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357875 */   GIR_RootConstrainSelectedInstOperands,
     /* 357876 */   // GIR_Coverage, 912,
     /* 357876 */   GIR_Done,
     /* 357877 */ // Label 7198: @357877
     /* 357877 */ GIM_Reject,
     /* 357878 */ // Label 7190: @357878
     /* 357878 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(357908), // Rule ID 918 //
     /* 357883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357897 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357906 */   GIR_RootConstrainSelectedInstOperands,
     /* 357907 */   // GIR_Coverage, 918,
     /* 357907 */   GIR_Done,
     /* 357908 */ // Label 7199: @357908
     /* 357908 */ GIM_Reject,
     /* 357909 */ // Label 7191: @357909
     /* 357909 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(358130),
     /* 357914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357925 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(357944), // Rule ID 914 //
     /* 357930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357933 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 357938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357942 */     GIR_RootConstrainSelectedInstOperands,
     /* 357943 */     // GIR_Coverage, 914,
     /* 357943 */     GIR_Done,
     /* 357944 */   // Label 7201: @357944
     /* 357944 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(358129), // Rule ID 6910 //
     /* 357949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357952 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357952 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357955 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357959 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357964 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357970 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357973 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357977 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357982 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357987 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357990 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357994 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357999 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358005 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358010 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358015 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 358018 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 358022 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358027 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 358030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358032 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 358035 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 358039 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358044 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 358052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 358056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358061 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 358064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 358119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 358127 */     GIR_RootConstrainSelectedInstOperands,
     /* 358128 */     // GIR_Coverage, 6910,
     /* 358128 */     GIR_EraseRootFromParent_Done,
     /* 358129 */   // Label 7202: @358129
     /* 358129 */   GIM_Reject,
     /* 358130 */ // Label 7200: @358130
     /* 358130 */ GIM_Reject,
     /* 358131 */ // Label 7192: @358131
     /* 358131 */ GIM_Reject,
     /* 358132 */ // Label 97: @358132
     /* 358132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7211*/ GIMT_Encode4(358622),
     /* 358143 */ /*GILLT_s16*//*Label 7203*/ GIMT_Encode4(358183),
     /* 358147 */ /*GILLT_s32*//*Label 7204*/ GIMT_Encode4(358214),
     /* 358151 */ /*GILLT_s64*//*Label 7205*/ GIMT_Encode4(358245), GIMT_Encode4(0),
     /* 358159 */ /*GILLT_v2s32*//*Label 7206*/ GIMT_Encode4(358276),
     /* 358163 */ /*GILLT_v2s64*//*Label 7207*/ GIMT_Encode4(358307),
     /* 358167 */ /*GILLT_v4s16*//*Label 7208*/ GIMT_Encode4(358338),
     /* 358171 */ /*GILLT_v4s32*//*Label 7209*/ GIMT_Encode4(358369), GIMT_Encode4(0),
     /* 358179 */ /*GILLT_v8s16*//*Label 7210*/ GIMT_Encode4(358400),
     /* 358183 */ // Label 7203: @358183
     /* 358183 */ GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(358213), // Rule ID 534 //
     /* 358188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 358191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 358194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358202 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 358202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 358207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358211 */   GIR_RootConstrainSelectedInstOperands,
     /* 358212 */   // GIR_Coverage, 534,
     /* 358212 */   GIR_Done,
     /* 358213 */ // Label 7212: @358213
     /* 358213 */ GIM_Reject,
     /* 358214 */ // Label 7204: @358214
     /* 358214 */ GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(358244), // Rule ID 536 //
     /* 358219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358233 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 358233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 358238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358242 */   GIR_RootConstrainSelectedInstOperands,
     /* 358243 */   // GIR_Coverage, 536,
     /* 358243 */   GIR_Done,
     /* 358244 */ // Label 7213: @358244
     /* 358244 */ GIM_Reject,
     /* 358245 */ // Label 7205: @358245
     /* 358245 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(358275), // Rule ID 538 //
     /* 358250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358264 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 358264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 358269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358273 */   GIR_RootConstrainSelectedInstOperands,
     /* 358274 */   // GIR_Coverage, 538,
     /* 358274 */   GIR_Done,
     /* 358275 */ // Label 7214: @358275
     /* 358275 */ GIM_Reject,
     /* 358276 */ // Label 7206: @358276
     /* 358276 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(358306), // Rule ID 876 //
     /* 358281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358295 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 358295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 358300 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358304 */   GIR_RootConstrainSelectedInstOperands,
     /* 358305 */   // GIR_Coverage, 876,
     /* 358305 */   GIR_Done,
     /* 358306 */ // Label 7215: @358306
     /* 358306 */ GIM_Reject,
     /* 358307 */ // Label 7207: @358307
     /* 358307 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(358337), // Rule ID 880 //
     /* 358312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358326 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 358326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 358331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358335 */   GIR_RootConstrainSelectedInstOperands,
     /* 358336 */   // GIR_Coverage, 880,
     /* 358336 */   GIR_Done,
     /* 358337 */ // Label 7216: @358337
     /* 358337 */ GIM_Reject,
     /* 358338 */ // Label 7208: @358338
     /* 358338 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(358368), // Rule ID 872 //
     /* 358343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 358346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 358349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358357 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 358357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 358362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358366 */   GIR_RootConstrainSelectedInstOperands,
     /* 358367 */   // GIR_Coverage, 872,
     /* 358367 */   GIR_Done,
     /* 358368 */ // Label 7217: @358368
     /* 358368 */ GIM_Reject,
     /* 358369 */ // Label 7209: @358369
     /* 358369 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(358399), // Rule ID 878 //
     /* 358374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358388 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 358388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358397 */   GIR_RootConstrainSelectedInstOperands,
     /* 358398 */   // GIR_Coverage, 878,
     /* 358398 */   GIR_Done,
     /* 358399 */ // Label 7218: @358399
     /* 358399 */ GIM_Reject,
     /* 358400 */ // Label 7210: @358400
     /* 358400 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(358621),
     /* 358405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358416 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(358435), // Rule ID 874 //
     /* 358421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 358424 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 358424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 358429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358433 */     GIR_RootConstrainSelectedInstOperands,
     /* 358434 */     // GIR_Coverage, 874,
     /* 358434 */     GIR_Done,
     /* 358435 */   // Label 7220: @358435
     /* 358435 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(358620), // Rule ID 6904 //
     /* 358440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 358443 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 358443 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 358446 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 358450 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358455 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 358461 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 358464 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358468 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358473 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 358476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 358478 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 358481 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358485 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358490 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358496 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358501 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358506 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 358509 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 358513 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358518 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 358521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358523 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 358526 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358530 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358535 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 358543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 358547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358552 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 358555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 358610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 358618 */     GIR_RootConstrainSelectedInstOperands,
     /* 358619 */     // GIR_Coverage, 6904,
     /* 358619 */     GIR_EraseRootFromParent_Done,
     /* 358620 */   // Label 7221: @358620
     /* 358620 */   GIM_Reject,
     /* 358621 */ // Label 7219: @358621
     /* 358621 */ GIM_Reject,
     /* 358622 */ // Label 7211: @358622
     /* 358622 */ GIM_Reject,
     /* 358623 */ // Label 98: @358623
     /* 358623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7230*/ GIMT_Encode4(359748),
     /* 358634 */ /*GILLT_s16*//*Label 7222*/ GIMT_Encode4(358674),
     /* 358638 */ /*GILLT_s32*//*Label 7223*/ GIMT_Encode4(358900),
     /* 358642 */ /*GILLT_s64*//*Label 7224*/ GIMT_Encode4(359126), GIMT_Encode4(0),
     /* 358650 */ /*GILLT_v2s32*//*Label 7225*/ GIMT_Encode4(359298),
     /* 358654 */ /*GILLT_v2s64*//*Label 7226*/ GIMT_Encode4(359336),
     /* 358658 */ /*GILLT_v4s16*//*Label 7227*/ GIMT_Encode4(359374),
     /* 358662 */ /*GILLT_v4s32*//*Label 7228*/ GIMT_Encode4(359412), GIMT_Encode4(0),
     /* 358670 */ /*GILLT_v8s16*//*Label 7229*/ GIMT_Encode4(359450),
     /* 358674 */ // Label 7222: @358674
     /* 358674 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(358899),
     /* 358679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 358682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358689 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(358780), // Rule ID 6824 //
     /* 358694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358731 */     // MIs[2] Rn
     /* 358731 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358736 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358742 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358754 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358778 */     GIR_RootConstrainSelectedInstOperands,
     /* 358779 */     // GIR_Coverage, 6824,
     /* 358779 */     GIR_EraseRootFromParent_Done,
     /* 358780 */   // Label 7232: @358780
     /* 358780 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(358871), // Rule ID 13681 //
     /* 358785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358806 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358822 */     // MIs[2] Rn
     /* 358822 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358827 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358833 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358845 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358869 */     GIR_RootConstrainSelectedInstOperands,
     /* 358870 */     // GIR_Coverage, 13681,
     /* 358870 */     GIR_EraseRootFromParent_Done,
     /* 358871 */   // Label 7233: @358871
     /* 358871 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(358898), // Rule ID 583 //
     /* 358876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 358879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358887 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 358887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 358892 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358896 */     GIR_RootConstrainSelectedInstOperands,
     /* 358897 */     // GIR_Coverage, 583,
     /* 358897 */     GIR_Done,
     /* 358898 */   // Label 7234: @358898
     /* 358898 */   GIM_Reject,
     /* 358899 */ // Label 7231: @358899
     /* 358899 */ GIM_Reject,
     /* 358900 */ // Label 7223: @358900
     /* 358900 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(359125),
     /* 358905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358915 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(359006), // Rule ID 6822 //
     /* 358920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358957 */     // MIs[2] Rn
     /* 358957 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358968 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 358968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 358999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359004 */     GIR_RootConstrainSelectedInstOperands,
     /* 359005 */     // GIR_Coverage, 6822,
     /* 359005 */     GIR_EraseRootFromParent_Done,
     /* 359006 */   // Label 7236: @359006
     /* 359006 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(359097), // Rule ID 13679 //
     /* 359011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 359036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359048 */     // MIs[2] Rn
     /* 359048 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 359053 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 359057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359059 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 359059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 359090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359095 */     GIR_RootConstrainSelectedInstOperands,
     /* 359096 */     // GIR_Coverage, 13679,
     /* 359096 */     GIR_EraseRootFromParent_Done,
     /* 359097 */   // Label 7237: @359097
     /* 359097 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(359124), // Rule ID 585 //
     /* 359102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359113 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 359113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 359118 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359122 */     GIR_RootConstrainSelectedInstOperands,
     /* 359123 */     // GIR_Coverage, 585,
     /* 359123 */     GIR_Done,
     /* 359124 */   // Label 7238: @359124
     /* 359124 */   GIM_Reject,
     /* 359125 */ // Label 7235: @359125
     /* 359125 */ GIM_Reject,
     /* 359126 */ // Label 7224: @359126
     /* 359126 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(359297),
     /* 359131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359141 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(359205), // Rule ID 6820 //
     /* 359146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359167 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 359171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359183 */     // MIs[2] Rn
     /* 359183 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 359188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 359192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359194 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 359194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 359197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359203 */     GIR_RootConstrainSelectedInstOperands,
     /* 359204 */     // GIR_Coverage, 6820,
     /* 359204 */     GIR_EraseRootFromParent_Done,
     /* 359205 */   // Label 7240: @359205
     /* 359205 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(359269), // Rule ID 13677 //
     /* 359210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 359235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359247 */     // MIs[2] Rn
     /* 359247 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 359252 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 359256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359258 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 359258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 359261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359267 */     GIR_RootConstrainSelectedInstOperands,
     /* 359268 */     // GIR_Coverage, 13677,
     /* 359268 */     GIR_EraseRootFromParent_Done,
     /* 359269 */   // Label 7241: @359269
     /* 359269 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(359296), // Rule ID 587 //
     /* 359274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359285 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 359285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 359290 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359294 */     GIR_RootConstrainSelectedInstOperands,
     /* 359295 */     // GIR_Coverage, 587,
     /* 359295 */     GIR_Done,
     /* 359296 */   // Label 7242: @359296
     /* 359296 */   GIM_Reject,
     /* 359297 */ // Label 7239: @359297
     /* 359297 */ GIM_Reject,
     /* 359298 */ // Label 7225: @359298
     /* 359298 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(359335), // Rule ID 1195 //
     /* 359303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 359312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359324 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 359324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 359329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359333 */   GIR_RootConstrainSelectedInstOperands,
     /* 359334 */   // GIR_Coverage, 1195,
     /* 359334 */   GIR_Done,
     /* 359335 */ // Label 7243: @359335
     /* 359335 */ GIM_Reject,
     /* 359336 */ // Label 7226: @359336
     /* 359336 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(359373), // Rule ID 1199 //
     /* 359341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 359350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359362 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 359362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 359367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359371 */   GIR_RootConstrainSelectedInstOperands,
     /* 359372 */   // GIR_Coverage, 1199,
     /* 359372 */   GIR_Done,
     /* 359373 */ // Label 7244: @359373
     /* 359373 */ GIM_Reject,
     /* 359374 */ // Label 7227: @359374
     /* 359374 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(359411), // Rule ID 1191 //
     /* 359379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 359388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359400 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 359400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 359405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359409 */   GIR_RootConstrainSelectedInstOperands,
     /* 359410 */   // GIR_Coverage, 1191,
     /* 359410 */   GIR_Done,
     /* 359411 */ // Label 7245: @359411
     /* 359411 */ GIM_Reject,
     /* 359412 */ // Label 7228: @359412
     /* 359412 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(359449), // Rule ID 1197 //
     /* 359417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 359426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359438 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 359438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359447 */   GIR_RootConstrainSelectedInstOperands,
     /* 359448 */   // GIR_Coverage, 1197,
     /* 359448 */   GIR_Done,
     /* 359449 */ // Label 7246: @359449
     /* 359449 */ GIM_Reject,
     /* 359450 */ // Label 7229: @359450
     /* 359450 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(359747),
     /* 359455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 359461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359473 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(359492), // Rule ID 1193 //
     /* 359478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359481 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 359481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 359486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359490 */     GIR_RootConstrainSelectedInstOperands,
     /* 359491 */     // GIR_Coverage, 1193,
     /* 359491 */     GIR_Done,
     /* 359492 */   // Label 7248: @359492
     /* 359492 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(359746), // Rule ID 6913 //
     /* 359497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359500 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 359500 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 359503 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359507 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359512 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 359518 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 359521 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359525 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359530 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 359536 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 359539 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359543 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359548 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 359551 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 359554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 359556 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 359559 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359563 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359568 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 359574 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359579 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359584 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359587 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359591 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359596 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359601 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359604 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359608 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359613 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359619 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359624 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359629 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359632 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359636 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359641 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359646 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359649 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359653 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359658 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359661 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 359664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359666 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359669 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359673 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359678 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 359744 */     GIR_RootConstrainSelectedInstOperands,
     /* 359745 */     // GIR_Coverage, 6913,
     /* 359745 */     GIR_EraseRootFromParent_Done,
     /* 359746 */   // Label 7249: @359746
     /* 359746 */   GIM_Reject,
     /* 359747 */ // Label 7247: @359747
     /* 359747 */ GIM_Reject,
     /* 359748 */ // Label 7230: @359748
     /* 359748 */ GIM_Reject,
     /* 359749 */ // Label 99: @359749
     /* 359749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7258*/ GIMT_Encode4(360364),
     /* 359760 */ /*GILLT_s16*//*Label 7250*/ GIMT_Encode4(359800),
     /* 359764 */ /*GILLT_s32*//*Label 7251*/ GIMT_Encode4(359838),
     /* 359768 */ /*GILLT_s64*//*Label 7252*/ GIMT_Encode4(359876), GIMT_Encode4(0),
     /* 359776 */ /*GILLT_v2s32*//*Label 7253*/ GIMT_Encode4(359914),
     /* 359780 */ /*GILLT_v2s64*//*Label 7254*/ GIMT_Encode4(359952),
     /* 359784 */ /*GILLT_v4s16*//*Label 7255*/ GIMT_Encode4(359990),
     /* 359788 */ /*GILLT_v4s32*//*Label 7256*/ GIMT_Encode4(360028), GIMT_Encode4(0),
     /* 359796 */ /*GILLT_v8s16*//*Label 7257*/ GIMT_Encode4(360066),
     /* 359800 */ // Label 7250: @359800
     /* 359800 */ GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(359837), // Rule ID 631 //
     /* 359805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 359808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359826 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 359826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 359831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359835 */   GIR_RootConstrainSelectedInstOperands,
     /* 359836 */   // GIR_Coverage, 631,
     /* 359836 */   GIR_Done,
     /* 359837 */ // Label 7259: @359837
     /* 359837 */ GIM_Reject,
     /* 359838 */ // Label 7251: @359838
     /* 359838 */ GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(359875), // Rule ID 633 //
     /* 359843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 359849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359864 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 359864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 359869 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359873 */   GIR_RootConstrainSelectedInstOperands,
     /* 359874 */   // GIR_Coverage, 633,
     /* 359874 */   GIR_Done,
     /* 359875 */ // Label 7260: @359875
     /* 359875 */ GIM_Reject,
     /* 359876 */ // Label 7252: @359876
     /* 359876 */ GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(359913), // Rule ID 635 //
     /* 359881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359902 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 359902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 359907 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359911 */   GIR_RootConstrainSelectedInstOperands,
     /* 359912 */   // GIR_Coverage, 635,
     /* 359912 */   GIR_Done,
     /* 359913 */ // Label 7261: @359913
     /* 359913 */ GIM_Reject,
     /* 359914 */ // Label 7253: @359914
     /* 359914 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(359951), // Rule ID 1335 //
     /* 359919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 359928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359940 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 359940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 359945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359949 */   GIR_RootConstrainSelectedInstOperands,
     /* 359950 */   // GIR_Coverage, 1335,
     /* 359950 */   GIR_Done,
     /* 359951 */ // Label 7262: @359951
     /* 359951 */ GIM_Reject,
     /* 359952 */ // Label 7254: @359952
     /* 359952 */ GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(359989), // Rule ID 1339 //
     /* 359957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 359966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359978 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 359978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 359983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359987 */   GIR_RootConstrainSelectedInstOperands,
     /* 359988 */   // GIR_Coverage, 1339,
     /* 359988 */   GIR_Done,
     /* 359989 */ // Label 7263: @359989
     /* 359989 */ GIM_Reject,
     /* 359990 */ // Label 7255: @359990
     /* 359990 */ GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(360027), // Rule ID 1331 //
     /* 359995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 360001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 360004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360016 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 360016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 360021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360025 */   GIR_RootConstrainSelectedInstOperands,
     /* 360026 */   // GIR_Coverage, 1331,
     /* 360026 */   GIR_Done,
     /* 360027 */ // Label 7264: @360027
     /* 360027 */ GIM_Reject,
     /* 360028 */ // Label 7256: @360028
     /* 360028 */ GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(360065), // Rule ID 1337 //
     /* 360033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 360042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360054 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 360054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 360059 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360063 */   GIR_RootConstrainSelectedInstOperands,
     /* 360064 */   // GIR_Coverage, 1337,
     /* 360064 */   GIR_Done,
     /* 360065 */ // Label 7265: @360065
     /* 360065 */ GIM_Reject,
     /* 360066 */ // Label 7257: @360066
     /* 360066 */ GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(360363),
     /* 360071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 360077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360089 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(360108), // Rule ID 1333 //
     /* 360094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360097 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 360097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 360102 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360106 */     GIR_RootConstrainSelectedInstOperands,
     /* 360107 */     // GIR_Coverage, 1333,
     /* 360107 */     GIR_Done,
     /* 360108 */   // Label 7267: @360108
     /* 360108 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(360362), // Rule ID 6919 //
     /* 360113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 360116 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 360116 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 360119 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 360123 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360128 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 360132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 360134 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 360137 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 360141 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360146 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 360150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 360152 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 360155 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 360159 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360164 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 360167 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 360170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 360172 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 360175 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360179 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360184 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 360190 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360195 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360200 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 360203 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 360207 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360212 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 360215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 360217 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 360220 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360224 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360229 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 360235 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360240 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360245 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 360248 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 360252 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360257 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 360260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 360262 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 360265 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 360269 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360274 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360277 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 360280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 360285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 360289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360294 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 360297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 360302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 360316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 360352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 360360 */     GIR_RootConstrainSelectedInstOperands,
     /* 360361 */     // GIR_Coverage, 6919,
     /* 360361 */     GIR_EraseRootFromParent_Done,
     /* 360362 */   // Label 7268: @360362
     /* 360362 */   GIM_Reject,
     /* 360363 */ // Label 7266: @360363
     /* 360363 */ GIM_Reject,
     /* 360364 */ // Label 7258: @360364
     /* 360364 */ GIM_Reject,
     /* 360365 */ // Label 100: @360365
     /* 360365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7277*/ GIMT_Encode4(364086),
     /* 360376 */ /*GILLT_s16*//*Label 7269*/ GIMT_Encode4(360416),
     /* 360380 */ /*GILLT_s32*//*Label 7270*/ GIMT_Encode4(360970),
     /* 360384 */ /*GILLT_s64*//*Label 7271*/ GIMT_Encode4(361518), GIMT_Encode4(0),
     /* 360392 */ /*GILLT_v2s32*//*Label 7272*/ GIMT_Encode4(362066),
     /* 360396 */ /*GILLT_v2s64*//*Label 7273*/ GIMT_Encode4(362596),
     /* 360400 */ /*GILLT_v4s16*//*Label 7274*/ GIMT_Encode4(362954),
     /* 360404 */ /*GILLT_v4s32*//*Label 7275*/ GIMT_Encode4(363296), GIMT_Encode4(0),
     /* 360412 */ /*GILLT_v8s16*//*Label 7276*/ GIMT_Encode4(363654),
     /* 360416 */ // Label 7269: @360416
     /* 360416 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(360969),
     /* 360421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 360424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360431 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(360544), // Rule ID 6146 //
     /* 360436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360493 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360497 */     // MIs[3] Operand 1
     /* 360497 */     // No operand predicates
     /* 360497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360499 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 360539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360542 */     GIR_RootConstrainSelectedInstOperands,
     /* 360543 */     // GIR_Coverage, 6146,
     /* 360543 */     GIR_EraseRootFromParent_Done,
     /* 360544 */   // Label 7279: @360544
     /* 360544 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(360657), // Rule ID 13652 //
     /* 360549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360585 */     // MIs[2] Operand 1
     /* 360585 */     // No operand predicates
     /* 360585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360597 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 360601 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360606 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 360610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360612 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360624 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360655 */     GIR_RootConstrainSelectedInstOperands,
     /* 360656 */     // GIR_Coverage, 13652,
     /* 360656 */     GIR_EraseRootFromParent_Done,
     /* 360657 */   // Label 7280: @360657
     /* 360657 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(360736), // Rule ID 13589 //
     /* 360662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360696 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360708 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360734 */     GIR_RootConstrainSelectedInstOperands,
     /* 360735 */     // GIR_Coverage, 13589,
     /* 360735 */     GIR_EraseRootFromParent_Done,
     /* 360736 */   // Label 7281: @360736
     /* 360736 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(360815), // Rule ID 4742 //
     /* 360741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360769 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360775 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360813 */     GIR_RootConstrainSelectedInstOperands,
     /* 360814 */     // GIR_Coverage, 4742,
     /* 360814 */     GIR_EraseRootFromParent_Done,
     /* 360815 */   // Label 7282: @360815
     /* 360815 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(360878), // Rule ID 13204 //
     /* 360820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360856 */     // MIs[2] Operand 1
     /* 360856 */     // No operand predicates
     /* 360856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360862 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360876 */     GIR_RootConstrainSelectedInstOperands,
     /* 360877 */     // GIR_Coverage, 13204,
     /* 360877 */     GIR_EraseRootFromParent_Done,
     /* 360878 */   // Label 7283: @360878
     /* 360878 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(360941), // Rule ID 2004 //
     /* 360883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360923 */     // MIs[2] Operand 1
     /* 360923 */     // No operand predicates
     /* 360923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360925 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360939 */     GIR_RootConstrainSelectedInstOperands,
     /* 360940 */     // GIR_Coverage, 2004,
     /* 360940 */     GIR_EraseRootFromParent_Done,
     /* 360941 */   // Label 7284: @360941
     /* 360941 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(360968), // Rule ID 619 //
     /* 360946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360957 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 360957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360966 */     GIR_RootConstrainSelectedInstOperands,
     /* 360967 */     // GIR_Coverage, 619,
     /* 360967 */     GIR_Done,
     /* 360968 */   // Label 7285: @360968
     /* 360968 */   GIM_Reject,
     /* 360969 */ // Label 7278: @360969
     /* 360969 */ GIM_Reject,
     /* 360970 */ // Label 7270: @360970
     /* 360970 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(361517),
     /* 360975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360985 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(361098), // Rule ID 6148 //
     /* 360990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361047 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361051 */     // MIs[3] Operand 1
     /* 361051 */     // No operand predicates
     /* 361051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361053 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 361053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 361071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361096 */     GIR_RootConstrainSelectedInstOperands,
     /* 361097 */     // GIR_Coverage, 6148,
     /* 361097 */     GIR_EraseRootFromParent_Done,
     /* 361098 */   // Label 7287: @361098
     /* 361098 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(361211), // Rule ID 13654 //
     /* 361103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361139 */     // MIs[2] Operand 1
     /* 361139 */     // No operand predicates
     /* 361139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 361155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361160 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 361164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361166 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 361166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 361184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361209 */     GIR_RootConstrainSelectedInstOperands,
     /* 361210 */     // GIR_Coverage, 13654,
     /* 361210 */     GIR_EraseRootFromParent_Done,
     /* 361211 */   // Label 7288: @361211
     /* 361211 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(361287), // Rule ID 13591 //
     /* 361216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361237 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361247 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 361247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361259 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 361265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 361278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361285 */     GIR_RootConstrainSelectedInstOperands,
     /* 361286 */     // GIR_Coverage, 13591,
     /* 361286 */     GIR_EraseRootFromParent_Done,
     /* 361287 */   // Label 7289: @361287
     /* 361287 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(361363), // Rule ID 4744 //
     /* 361292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361323 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 361323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 361341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 361354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361361 */     GIR_RootConstrainSelectedInstOperands,
     /* 361362 */     // GIR_Coverage, 4744,
     /* 361362 */     GIR_EraseRootFromParent_Done,
     /* 361363 */   // Label 7290: @361363
     /* 361363 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(361426), // Rule ID 13206 //
     /* 361368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361404 */     // MIs[2] Operand 1
     /* 361404 */     // No operand predicates
     /* 361404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361410 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361424 */     GIR_RootConstrainSelectedInstOperands,
     /* 361425 */     // GIR_Coverage, 13206,
     /* 361425 */     GIR_EraseRootFromParent_Done,
     /* 361426 */   // Label 7291: @361426
     /* 361426 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(361489), // Rule ID 2006 //
     /* 361431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361471 */     // MIs[2] Operand 1
     /* 361471 */     // No operand predicates
     /* 361471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361473 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361487 */     GIR_RootConstrainSelectedInstOperands,
     /* 361488 */     // GIR_Coverage, 2006,
     /* 361488 */     GIR_EraseRootFromParent_Done,
     /* 361489 */   // Label 7292: @361489
     /* 361489 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(361516), // Rule ID 621 //
     /* 361494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361505 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 361505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 361510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361514 */     GIR_RootConstrainSelectedInstOperands,
     /* 361515 */     // GIR_Coverage, 621,
     /* 361515 */     GIR_Done,
     /* 361516 */   // Label 7293: @361516
     /* 361516 */   GIM_Reject,
     /* 361517 */ // Label 7286: @361517
     /* 361517 */ GIM_Reject,
     /* 361518 */ // Label 7271: @361518
     /* 361518 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(362065),
     /* 361523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 361526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361533 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(361646), // Rule ID 6150 //
     /* 361538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361562 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361599 */     // MIs[3] Operand 1
     /* 361599 */     // No operand predicates
     /* 361599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361601 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361644 */     GIR_RootConstrainSelectedInstOperands,
     /* 361645 */     // GIR_Coverage, 6150,
     /* 361645 */     GIR_EraseRootFromParent_Done,
     /* 361646 */   // Label 7295: @361646
     /* 361646 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(361759), // Rule ID 13656 //
     /* 361651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361687 */     // MIs[2] Operand 1
     /* 361687 */     // No operand predicates
     /* 361687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 361703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361708 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 361712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361714 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361757 */     GIR_RootConstrainSelectedInstOperands,
     /* 361758 */     // GIR_Coverage, 13656,
     /* 361758 */     GIR_EraseRootFromParent_Done,
     /* 361759 */   // Label 7296: @361759
     /* 361759 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(361835), // Rule ID 13593 //
     /* 361764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361795 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361833 */     GIR_RootConstrainSelectedInstOperands,
     /* 361834 */     // GIR_Coverage, 13593,
     /* 361834 */     GIR_EraseRootFromParent_Done,
     /* 361835 */   // Label 7297: @361835
     /* 361835 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(361911), // Rule ID 4746 //
     /* 361840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361871 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361909 */     GIR_RootConstrainSelectedInstOperands,
     /* 361910 */     // GIR_Coverage, 4746,
     /* 361910 */     GIR_EraseRootFromParent_Done,
     /* 361911 */   // Label 7298: @361911
     /* 361911 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(361974), // Rule ID 13208 //
     /* 361916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361948 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361952 */     // MIs[2] Operand 1
     /* 361952 */     // No operand predicates
     /* 361952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361958 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361972 */     GIR_RootConstrainSelectedInstOperands,
     /* 361973 */     // GIR_Coverage, 13208,
     /* 361973 */     GIR_EraseRootFromParent_Done,
     /* 361974 */   // Label 7299: @361974
     /* 361974 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(362037), // Rule ID 2008 //
     /* 361979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362019 */     // MIs[2] Operand 1
     /* 362019 */     // No operand predicates
     /* 362019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362021 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 362024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362035 */     GIR_RootConstrainSelectedInstOperands,
     /* 362036 */     // GIR_Coverage, 2008,
     /* 362036 */     GIR_EraseRootFromParent_Done,
     /* 362037 */   // Label 7300: @362037
     /* 362037 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(362064), // Rule ID 623 //
     /* 362042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 362045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362053 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 362053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 362058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362062 */     GIR_RootConstrainSelectedInstOperands,
     /* 362063 */     // GIR_Coverage, 623,
     /* 362063 */     GIR_Done,
     /* 362064 */   // Label 7301: @362064
     /* 362064 */   GIM_Reject,
     /* 362065 */ // Label 7294: @362065
     /* 362065 */ GIM_Reject,
     /* 362066 */ // Label 7272: @362066
     /* 362066 */ GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(362595),
     /* 362071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 362077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362081 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(362167), // Rule ID 13196 //
     /* 362086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362130 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362134 */     // MIs[3] Operand 1
     /* 362134 */     // No operand predicates
     /* 362134 */     // MIs[1] Operand 2
     /* 362134 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362151 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362165 */     GIR_RootConstrainSelectedInstOperands,
     /* 362166 */     // GIR_Coverage, 13196,
     /* 362166 */     GIR_EraseRootFromParent_Done,
     /* 362167 */   // Label 7303: @362167
     /* 362167 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(362253), // Rule ID 1996 //
     /* 362172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362220 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362224 */     // MIs[3] Operand 1
     /* 362224 */     // No operand predicates
     /* 362224 */     // MIs[1] Operand 2
     /* 362224 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362237 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362251 */     GIR_RootConstrainSelectedInstOperands,
     /* 362252 */     // GIR_Coverage, 1996,
     /* 362252 */     GIR_EraseRootFromParent_Done,
     /* 362253 */   // Label 7304: @362253
     /* 362253 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(362316), // Rule ID 13197 //
     /* 362258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362294 */     // MIs[2] Operand 1
     /* 362294 */     // No operand predicates
     /* 362294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362300 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362314 */     GIR_RootConstrainSelectedInstOperands,
     /* 362315 */     // GIR_Coverage, 13197,
     /* 362315 */     GIR_EraseRootFromParent_Done,
     /* 362316 */   // Label 7305: @362316
     /* 362316 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(362379), // Rule ID 1997 //
     /* 362321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362361 */     // MIs[2] Operand 1
     /* 362361 */     // No operand predicates
     /* 362361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362363 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362377 */     GIR_RootConstrainSelectedInstOperands,
     /* 362378 */     // GIR_Coverage, 1997,
     /* 362378 */     GIR_EraseRootFromParent_Done,
     /* 362379 */   // Label 7306: @362379
     /* 362379 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(362473), // Rule ID 13658 //
     /* 362384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362407 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 362443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362471 */     GIR_RootConstrainSelectedInstOperands,
     /* 362472 */     // GIR_Coverage, 13658,
     /* 362472 */     GIR_EraseRootFromParent_Done,
     /* 362473 */   // Label 7307: @362473
     /* 362473 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(362567), // Rule ID 6152 //
     /* 362478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362501 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362534 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 362537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362565 */     GIR_RootConstrainSelectedInstOperands,
     /* 362566 */     // GIR_Coverage, 6152,
     /* 362566 */     GIR_EraseRootFromParent_Done,
     /* 362567 */   // Label 7308: @362567
     /* 362567 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(362594), // Rule ID 1315 //
     /* 362572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362583 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 362583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 362588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362592 */     GIR_RootConstrainSelectedInstOperands,
     /* 362593 */     // GIR_Coverage, 1315,
     /* 362593 */     GIR_Done,
     /* 362594 */   // Label 7309: @362594
     /* 362594 */   GIM_Reject,
     /* 362595 */ // Label 7302: @362595
     /* 362595 */ GIM_Reject,
     /* 362596 */ // Label 7273: @362596
     /* 362596 */ GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(362953),
     /* 362601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 362607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362611 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(362674), // Rule ID 13202 //
     /* 362616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362648 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362652 */     // MIs[2] Operand 1
     /* 362652 */     // No operand predicates
     /* 362652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362658 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362672 */     GIR_RootConstrainSelectedInstOperands,
     /* 362673 */     // GIR_Coverage, 13202,
     /* 362673 */     GIR_EraseRootFromParent_Done,
     /* 362674 */   // Label 7311: @362674
     /* 362674 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(362737), // Rule ID 2002 //
     /* 362679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362719 */     // MIs[2] Operand 1
     /* 362719 */     // No operand predicates
     /* 362719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362721 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362735 */     GIR_RootConstrainSelectedInstOperands,
     /* 362736 */     // GIR_Coverage, 2002,
     /* 362736 */     GIR_EraseRootFromParent_Done,
     /* 362737 */   // Label 7312: @362737
     /* 362737 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(362831), // Rule ID 13662 //
     /* 362742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362765 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362829 */     GIR_RootConstrainSelectedInstOperands,
     /* 362830 */     // GIR_Coverage, 13662,
     /* 362830 */     GIR_EraseRootFromParent_Done,
     /* 362831 */   // Label 7313: @362831
     /* 362831 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(362925), // Rule ID 6156 //
     /* 362836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362859 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362923 */     GIR_RootConstrainSelectedInstOperands,
     /* 362924 */     // GIR_Coverage, 6156,
     /* 362924 */     GIR_EraseRootFromParent_Done,
     /* 362925 */   // Label 7314: @362925
     /* 362925 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(362952), // Rule ID 1319 //
     /* 362930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362941 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 362941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 362946 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362950 */     GIR_RootConstrainSelectedInstOperands,
     /* 362951 */     // GIR_Coverage, 1319,
     /* 362951 */     GIR_Done,
     /* 362952 */   // Label 7315: @362952
     /* 362952 */   GIM_Reject,
     /* 362953 */ // Label 7310: @362953
     /* 362953 */ GIM_Reject,
     /* 362954 */ // Label 7274: @362954
     /* 362954 */ GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(363295),
     /* 362959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 362965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362969 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(363055), // Rule ID 13190 //
     /* 362974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 363005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363018 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363022 */     // MIs[3] Operand 1
     /* 363022 */     // No operand predicates
     /* 363022 */     // MIs[1] Operand 2
     /* 363022 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 363033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363039 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 363042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 363050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 363053 */     GIR_RootConstrainSelectedInstOperands,
     /* 363054 */     // GIR_Coverage, 13190,
     /* 363054 */     GIR_EraseRootFromParent_Done,
     /* 363055 */   // Label 7317: @363055
     /* 363055 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(363141), // Rule ID 1990 //
     /* 363060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 363075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 363095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363108 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363112 */     // MIs[3] Operand 1
     /* 363112 */     // No operand predicates
     /* 363112 */     // MIs[1] Operand 2
     /* 363112 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 363123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363125 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 363128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 363136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 363139 */     GIR_RootConstrainSelectedInstOperands,
     /* 363140 */     // GIR_Coverage, 1990,
     /* 363140 */     GIR_EraseRootFromParent_Done,
     /* 363141 */   // Label 7318: @363141
     /* 363141 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(363204), // Rule ID 13191 //
     /* 363146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363178 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363182 */     // MIs[2] Operand 1
     /* 363182 */     // No operand predicates
     /* 363182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363188 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 363191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363202 */     GIR_RootConstrainSelectedInstOperands,
     /* 363203 */     // GIR_Coverage, 13191,
     /* 363203 */     GIR_EraseRootFromParent_Done,
     /* 363204 */   // Label 7319: @363204
     /* 363204 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(363267), // Rule ID 1991 //
     /* 363209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363249 */     // MIs[2] Operand 1
     /* 363249 */     // No operand predicates
     /* 363249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363251 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 363254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363265 */     GIR_RootConstrainSelectedInstOperands,
     /* 363266 */     // GIR_Coverage, 1991,
     /* 363266 */     GIR_EraseRootFromParent_Done,
     /* 363267 */   // Label 7320: @363267
     /* 363267 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(363294), // Rule ID 1311 //
     /* 363272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363283 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 363283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 363288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363292 */     GIR_RootConstrainSelectedInstOperands,
     /* 363293 */     // GIR_Coverage, 1311,
     /* 363293 */     GIR_Done,
     /* 363294 */   // Label 7321: @363294
     /* 363294 */   GIM_Reject,
     /* 363295 */ // Label 7316: @363295
     /* 363295 */ GIM_Reject,
     /* 363296 */ // Label 7275: @363296
     /* 363296 */ GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(363653),
     /* 363301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 363307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363311 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(363374), // Rule ID 13200 //
     /* 363316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 363327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363348 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363352 */     // MIs[2] Operand 1
     /* 363352 */     // No operand predicates
     /* 363352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363358 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363372 */     GIR_RootConstrainSelectedInstOperands,
     /* 363373 */     // GIR_Coverage, 13200,
     /* 363373 */     GIR_EraseRootFromParent_Done,
     /* 363374 */   // Label 7323: @363374
     /* 363374 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(363437), // Rule ID 2000 //
     /* 363379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 363394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363419 */     // MIs[2] Operand 1
     /* 363419 */     // No operand predicates
     /* 363419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363421 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363435 */     GIR_RootConstrainSelectedInstOperands,
     /* 363436 */     // GIR_Coverage, 2000,
     /* 363436 */     GIR_EraseRootFromParent_Done,
     /* 363437 */   // Label 7324: @363437
     /* 363437 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(363531), // Rule ID 13660 //
     /* 363442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363465 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363529 */     GIR_RootConstrainSelectedInstOperands,
     /* 363530 */     // GIR_Coverage, 13660,
     /* 363530 */     GIR_EraseRootFromParent_Done,
     /* 363531 */   // Label 7325: @363531
     /* 363531 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(363625), // Rule ID 6154 //
     /* 363536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363559 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363592 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363623 */     GIR_RootConstrainSelectedInstOperands,
     /* 363624 */     // GIR_Coverage, 6154,
     /* 363624 */     GIR_EraseRootFromParent_Done,
     /* 363625 */   // Label 7326: @363625
     /* 363625 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(363652), // Rule ID 1317 //
     /* 363630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363641 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 363641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363646 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363650 */     GIR_RootConstrainSelectedInstOperands,
     /* 363651 */     // GIR_Coverage, 1317,
     /* 363651 */     GIR_Done,
     /* 363652 */   // Label 7327: @363652
     /* 363652 */   GIM_Reject,
     /* 363653 */ // Label 7322: @363653
     /* 363653 */ GIM_Reject,
     /* 363654 */ // Label 7276: @363654
     /* 363654 */ GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(364085),
     /* 363659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 363665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363669 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(363732), // Rule ID 13194 //
     /* 363674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363710 */     // MIs[2] Operand 1
     /* 363710 */     // No operand predicates
     /* 363710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363716 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363730 */     GIR_RootConstrainSelectedInstOperands,
     /* 363731 */     // GIR_Coverage, 13194,
     /* 363731 */     GIR_EraseRootFromParent_Done,
     /* 363732 */   // Label 7329: @363732
     /* 363732 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(363795), // Rule ID 1994 //
     /* 363737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363773 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363777 */     // MIs[2] Operand 1
     /* 363777 */     // No operand predicates
     /* 363777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363779 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363793 */     GIR_RootConstrainSelectedInstOperands,
     /* 363794 */     // GIR_Coverage, 1994,
     /* 363794 */     GIR_EraseRootFromParent_Done,
     /* 363795 */   // Label 7330: @363795
     /* 363795 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(363822), // Rule ID 1313 //
     /* 363800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363811 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 363811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 363816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363820 */     GIR_RootConstrainSelectedInstOperands,
     /* 363821 */     // GIR_Coverage, 1313,
     /* 363821 */     GIR_Done,
     /* 363822 */   // Label 7331: @363822
     /* 363822 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(364084), // Rule ID 6917 //
     /* 363827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 363830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363838 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 363838 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 363841 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363845 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363850 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 363856 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 363859 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363863 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363868 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 363874 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 363877 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363881 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363886 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 363889 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 363892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 363894 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 363897 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363901 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363906 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 363912 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363917 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363922 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 363925 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363929 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363934 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 363937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 363939 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 363942 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363946 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363951 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363957 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363962 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363967 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 363970 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363974 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363979 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 363982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363984 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 363987 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363991 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363996 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363999 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 364002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364004 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364007 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364011 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364016 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 364082 */     GIR_RootConstrainSelectedInstOperands,
     /* 364083 */     // GIR_Coverage, 6917,
     /* 364083 */     GIR_EraseRootFromParent_Done,
     /* 364084 */   // Label 7332: @364084
     /* 364084 */   GIM_Reject,
     /* 364085 */ // Label 7328: @364085
     /* 364085 */ GIM_Reject,
     /* 364086 */ // Label 7277: @364086
     /* 364086 */ GIM_Reject,
     /* 364087 */ // Label 101: @364087
     /* 364087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7341*/ GIMT_Encode4(364702),
     /* 364098 */ /*GILLT_s16*//*Label 7333*/ GIMT_Encode4(364138),
     /* 364102 */ /*GILLT_s32*//*Label 7334*/ GIMT_Encode4(364176),
     /* 364106 */ /*GILLT_s64*//*Label 7335*/ GIMT_Encode4(364214), GIMT_Encode4(0),
     /* 364114 */ /*GILLT_v2s32*//*Label 7336*/ GIMT_Encode4(364252),
     /* 364118 */ /*GILLT_v2s64*//*Label 7337*/ GIMT_Encode4(364290),
     /* 364122 */ /*GILLT_v4s16*//*Label 7338*/ GIMT_Encode4(364328),
     /* 364126 */ /*GILLT_v4s32*//*Label 7339*/ GIMT_Encode4(364366), GIMT_Encode4(0),
     /* 364134 */ /*GILLT_v8s16*//*Label 7340*/ GIMT_Encode4(364404),
     /* 364138 */ // Label 7333: @364138
     /* 364138 */ GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(364175), // Rule ID 589 //
     /* 364143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364164 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 364164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 364169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364173 */   GIR_RootConstrainSelectedInstOperands,
     /* 364174 */   // GIR_Coverage, 589,
     /* 364174 */   GIR_Done,
     /* 364175 */ // Label 7342: @364175
     /* 364175 */ GIM_Reject,
     /* 364176 */ // Label 7334: @364176
     /* 364176 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(364213), // Rule ID 591 //
     /* 364181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364202 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 364202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 364207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364211 */   GIR_RootConstrainSelectedInstOperands,
     /* 364212 */   // GIR_Coverage, 591,
     /* 364212 */   GIR_Done,
     /* 364213 */ // Label 7343: @364213
     /* 364213 */ GIM_Reject,
     /* 364214 */ // Label 7335: @364214
     /* 364214 */ GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(364251), // Rule ID 593 //
     /* 364219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 364225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364240 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 364240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 364245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364249 */   GIR_RootConstrainSelectedInstOperands,
     /* 364250 */   // GIR_Coverage, 593,
     /* 364250 */   GIR_Done,
     /* 364251 */ // Label 7344: @364251
     /* 364251 */ GIM_Reject,
     /* 364252 */ // Label 7336: @364252
     /* 364252 */ GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(364289), // Rule ID 1220 //
     /* 364257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 364266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364278 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 364278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 364283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364287 */   GIR_RootConstrainSelectedInstOperands,
     /* 364288 */   // GIR_Coverage, 1220,
     /* 364288 */   GIR_Done,
     /* 364289 */ // Label 7345: @364289
     /* 364289 */ GIM_Reject,
     /* 364290 */ // Label 7337: @364290
     /* 364290 */ GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(364327), // Rule ID 1224 //
     /* 364295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 364304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364316 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 364316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 364321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364325 */   GIR_RootConstrainSelectedInstOperands,
     /* 364326 */   // GIR_Coverage, 1224,
     /* 364326 */   GIR_Done,
     /* 364327 */ // Label 7346: @364327
     /* 364327 */ GIM_Reject,
     /* 364328 */ // Label 7338: @364328
     /* 364328 */ GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(364365), // Rule ID 1216 //
     /* 364333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 364339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 364342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364354 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 364354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 364359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364363 */   GIR_RootConstrainSelectedInstOperands,
     /* 364364 */   // GIR_Coverage, 1216,
     /* 364364 */   GIR_Done,
     /* 364365 */ // Label 7347: @364365
     /* 364365 */ GIM_Reject,
     /* 364366 */ // Label 7339: @364366
     /* 364366 */ GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(364403), // Rule ID 1222 //
     /* 364371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 364380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364392 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 364392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364401 */   GIR_RootConstrainSelectedInstOperands,
     /* 364402 */   // GIR_Coverage, 1222,
     /* 364402 */   GIR_Done,
     /* 364403 */ // Label 7348: @364403
     /* 364403 */ GIM_Reject,
     /* 364404 */ // Label 7340: @364404
     /* 364404 */ GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(364701),
     /* 364409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 364415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364427 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(364446), // Rule ID 1218 //
     /* 364432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364435 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 364435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 364440 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364444 */     GIR_RootConstrainSelectedInstOperands,
     /* 364445 */     // GIR_Coverage, 1218,
     /* 364445 */     GIR_Done,
     /* 364446 */   // Label 7350: @364446
     /* 364446 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(364700), // Rule ID 6915 //
     /* 364451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 364454 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 364454 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 364457 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364461 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364466 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 364472 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 364475 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364479 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364484 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 364490 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 364493 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364497 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364502 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 364505 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 364508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 364510 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 364513 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364517 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364522 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 364528 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364533 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364538 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 364541 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364545 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364550 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 364553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 364555 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 364558 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364562 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364567 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364573 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364578 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364583 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 364586 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364590 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364595 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 364598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364600 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 364603 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364607 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364612 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364615 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 364618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364632 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364669 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 364698 */     GIR_RootConstrainSelectedInstOperands,
     /* 364699 */     // GIR_Coverage, 6915,
     /* 364699 */     GIR_EraseRootFromParent_Done,
     /* 364700 */   // Label 7351: @364700
     /* 364700 */   GIM_Reject,
     /* 364701 */ // Label 7349: @364701
     /* 364701 */ GIM_Reject,
     /* 364702 */ // Label 7341: @364702
     /* 364702 */ GIM_Reject,
     /* 364703 */ // Label 102: @364703
     /* 364703 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7360*/ GIMT_Encode4(380309),
     /* 364714 */ /*GILLT_s16*//*Label 7352*/ GIMT_Encode4(364754),
     /* 364718 */ /*GILLT_s32*//*Label 7353*/ GIMT_Encode4(367528),
     /* 364722 */ /*GILLT_s64*//*Label 7354*/ GIMT_Encode4(370458), GIMT_Encode4(0),
     /* 364730 */ /*GILLT_v2s32*//*Label 7355*/ GIMT_Encode4(373388),
     /* 364734 */ /*GILLT_v2s64*//*Label 7356*/ GIMT_Encode4(374909),
     /* 364738 */ /*GILLT_v4s16*//*Label 7357*/ GIMT_Encode4(376430),
     /* 364742 */ /*GILLT_v4s32*//*Label 7358*/ GIMT_Encode4(377609), GIMT_Encode4(0),
     /* 364750 */ /*GILLT_v8s16*//*Label 7359*/ GIMT_Encode4(379130),
     /* 364754 */ // Label 7352: @364754
     /* 364754 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(367527),
     /* 364759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 364768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364772 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(364922), // Rule ID 4804 //
     /* 364777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 364830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 364842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364849 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364861 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 364908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 364920 */     GIR_RootConstrainSelectedInstOperands,
     /* 364921 */     // GIR_Coverage, 4804,
     /* 364921 */     GIR_EraseRootFromParent_Done,
     /* 364922 */   // Label 7362: @364922
     /* 364922 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(365069), // Rule ID 4768 //
     /* 364927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364988 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364998 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 365001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365010 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365038 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365067 */     GIR_RootConstrainSelectedInstOperands,
     /* 365068 */     // GIR_Coverage, 4768,
     /* 365068 */     GIR_EraseRootFromParent_Done,
     /* 365069 */   // Label 7363: @365069
     /* 365069 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(365216), // Rule ID 13602 //
     /* 365074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365110 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365126 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365130 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365135 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 365139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365145 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365145 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 365148 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365152 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365157 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365214 */     GIR_RootConstrainSelectedInstOperands,
     /* 365215 */     // GIR_Coverage, 13602,
     /* 365215 */     GIR_EraseRootFromParent_Done,
     /* 365216 */   // Label 7364: @365216
     /* 365216 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(365347), // Rule ID 5984 //
     /* 365221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365245 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365269 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365273 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365277 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 365286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365290 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365294 */     // MIs[4] Operand 1
     /* 365294 */     // No operand predicates
     /* 365294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365300 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365312 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 365342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 365345 */     GIR_RootConstrainSelectedInstOperands,
     /* 365346 */     // GIR_Coverage, 5984,
     /* 365346 */     GIR_EraseRootFromParent_Done,
     /* 365347 */   // Label 7365: @365347
     /* 365347 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(365478), // Rule ID 6016 //
     /* 365352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365388 */     // MIs[2] Operand 1
     /* 365388 */     // No operand predicates
     /* 365388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 365400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 365404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365412 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 365416 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365421 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 365425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365429 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365431 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365476 */     GIR_RootConstrainSelectedInstOperands,
     /* 365477 */     // GIR_Coverage, 6016,
     /* 365477 */     GIR_EraseRootFromParent_Done,
     /* 365478 */   // Label 7366: @365478
     /* 365478 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(365609), // Rule ID 6080 //
     /* 365483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365519 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 365548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365552 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365556 */     // MIs[4] Operand 1
     /* 365556 */     // No operand predicates
     /* 365556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365562 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365574 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 365604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 365607 */     GIR_RootConstrainSelectedInstOperands,
     /* 365608 */     // GIR_Coverage, 6080,
     /* 365608 */     GIR_EraseRootFromParent_Done,
     /* 365609 */   // Label 7367: @365609
     /* 365609 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(365740), // Rule ID 6048 //
     /* 365614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365658 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365662 */     // MIs[3] Operand 1
     /* 365662 */     // No operand predicates
     /* 365662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 365666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365670 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365674 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 365678 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365683 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 365687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365691 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365693 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365738 */     GIR_RootConstrainSelectedInstOperands,
     /* 365739 */     // GIR_Coverage, 6048,
     /* 365739 */     GIR_EraseRootFromParent_Done,
     /* 365740 */   // Label 7368: @365740
     /* 365740 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(365875), // Rule ID 2446 //
     /* 365745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365769 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365804 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 365807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365816 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365844 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 365863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365873 */     GIR_RootConstrainSelectedInstOperands,
     /* 365874 */     // GIR_Coverage, 2446,
     /* 365874 */     GIR_EraseRootFromParent_Done,
     /* 365875 */   // Label 7369: @365875
     /* 365875 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(365994), // Rule ID 5952 //
     /* 365880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365937 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365941 */     // MIs[3] Operand 1
     /* 365941 */     // No operand predicates
     /* 365941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365947 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 365978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365992 */     GIR_RootConstrainSelectedInstOperands,
     /* 365993 */     // GIR_Coverage, 5952,
     /* 365993 */     GIR_EraseRootFromParent_Done,
     /* 365994 */   // Label 7370: @365994
     /* 365994 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(366113), // Rule ID 2528 //
     /* 365999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366035 */     // MIs[2] Operand 1
     /* 366035 */     // No operand predicates
     /* 366035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366043 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366047 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 366051 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366056 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 366060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366066 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 366097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366111 */     GIR_RootConstrainSelectedInstOperands,
     /* 366112 */     // GIR_Coverage, 2528,
     /* 366112 */     GIR_EraseRootFromParent_Done,
     /* 366113 */   // Label 7371: @366113
     /* 366113 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(366213), // Rule ID 4766 //
     /* 366118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 366158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366169 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366181 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366211 */     GIR_RootConstrainSelectedInstOperands,
     /* 366212 */     // GIR_Coverage, 4766,
     /* 366212 */     GIR_EraseRootFromParent_Done,
     /* 366213 */   // Label 7372: @366213
     /* 366213 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(366313), // Rule ID 4802 //
     /* 366218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 366262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366269 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366281 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 366300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 366307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 366311 */     GIR_RootConstrainSelectedInstOperands,
     /* 366312 */     // GIR_Coverage, 4802,
     /* 366312 */     GIR_EraseRootFromParent_Done,
     /* 366313 */   // Label 7373: @366313
     /* 366313 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(366410), // Rule ID 13598 //
     /* 366318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366354 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366368 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366380 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366408 */     GIR_RootConstrainSelectedInstOperands,
     /* 366409 */     // GIR_Coverage, 13598,
     /* 366409 */     GIR_EraseRootFromParent_Done,
     /* 366410 */   // Label 7374: @366410
     /* 366410 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(366510), // Rule ID 13600 //
     /* 366415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366466 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366478 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366508 */     GIR_RootConstrainSelectedInstOperands,
     /* 366509 */     // GIR_Coverage, 13600,
     /* 366509 */     GIR_EraseRootFromParent_Done,
     /* 366510 */   // Label 7375: @366510
     /* 366510 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(366610), // Rule ID 4800 //
     /* 366515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366543 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 366559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366566 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366578 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 366597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 366608 */     GIR_RootConstrainSelectedInstOperands,
     /* 366609 */     // GIR_Coverage, 4800,
     /* 366609 */     GIR_EraseRootFromParent_Done,
     /* 366610 */   // Label 7376: @366610
     /* 366610 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(366707), // Rule ID 4764 //
     /* 366615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366655 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366665 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366705 */     GIR_RootConstrainSelectedInstOperands,
     /* 366706 */     // GIR_Coverage, 4764,
     /* 366706 */     GIR_EraseRootFromParent_Done,
     /* 366707 */   // Label 7377: @366707
     /* 366707 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(366791), // Rule ID 6014 //
     /* 366712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366748 */     // MIs[2] Operand 1
     /* 366748 */     // No operand predicates
     /* 366748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 366760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366771 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366789 */     GIR_RootConstrainSelectedInstOperands,
     /* 366790 */     // GIR_Coverage, 6014,
     /* 366790 */     GIR_EraseRootFromParent_Done,
     /* 366791 */   // Label 7378: @366791
     /* 366791 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(366872), // Rule ID 6046 //
     /* 366796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366844 */     // MIs[3] Operand 1
     /* 366844 */     // No operand predicates
     /* 366844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366854 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366870 */     GIR_RootConstrainSelectedInstOperands,
     /* 366871 */     // GIR_Coverage, 6046,
     /* 366871 */     GIR_EraseRootFromParent_Done,
     /* 366872 */   // Label 7379: @366872
     /* 366872 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(366956), // Rule ID 6078 //
     /* 366877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366930 */     // MIs[3] Operand 1
     /* 366930 */     // No operand predicates
     /* 366930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366936 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366954 */     GIR_RootConstrainSelectedInstOperands,
     /* 366955 */     // GIR_Coverage, 6078,
     /* 366955 */     GIR_EraseRootFromParent_Done,
     /* 366956 */   // Label 7380: @366956
     /* 366956 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(367037), // Rule ID 5982 //
     /* 366961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367013 */     // MIs[3] Operand 1
     /* 367013 */     // No operand predicates
     /* 367013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367019 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 367022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 367032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 367035 */     GIR_RootConstrainSelectedInstOperands,
     /* 367036 */     // GIR_Coverage, 5982,
     /* 367036 */     GIR_EraseRootFromParent_Done,
     /* 367037 */   // Label 7381: @367037
     /* 367037 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(367122), // Rule ID 2444 //
     /* 367042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367080 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367092 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 367111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 367118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367120 */     GIR_RootConstrainSelectedInstOperands,
     /* 367121 */     // GIR_Coverage, 2444,
     /* 367121 */     GIR_EraseRootFromParent_Done,
     /* 367122 */   // Label 7382: @367122
     /* 367122 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(367207), // Rule ID 2442 //
     /* 367127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367155 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367165 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 367165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367177 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 367196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367205 */     GIR_RootConstrainSelectedInstOperands,
     /* 367206 */     // GIR_Coverage, 2442,
     /* 367206 */     GIR_EraseRootFromParent_Done,
     /* 367207 */   // Label 7383: @367207
     /* 367207 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(367276), // Rule ID 2526 //
     /* 367212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367244 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367248 */     // MIs[2] Operand 1
     /* 367248 */     // No operand predicates
     /* 367248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367258 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 367261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367274 */     GIR_RootConstrainSelectedInstOperands,
     /* 367275 */     // GIR_Coverage, 2526,
     /* 367275 */     GIR_EraseRootFromParent_Done,
     /* 367276 */   // Label 7384: @367276
     /* 367276 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(367345), // Rule ID 5950 //
     /* 367281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367321 */     // MIs[2] Operand 1
     /* 367321 */     // No operand predicates
     /* 367321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367327 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 367330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367343 */     GIR_RootConstrainSelectedInstOperands,
     /* 367344 */     // GIR_Coverage, 5950,
     /* 367344 */     GIR_EraseRootFromParent_Done,
     /* 367345 */   // Label 7385: @367345
     /* 367345 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(367395), // Rule ID 13044 //
     /* 367350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367380 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 367383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367393 */     GIR_RootConstrainSelectedInstOperands,
     /* 367394 */     // GIR_Coverage, 13044,
     /* 367394 */     GIR_EraseRootFromParent_Done,
     /* 367395 */   // Label 7386: @367395
     /* 367395 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(367445), // Rule ID 643 //
     /* 367400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367430 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 367433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367443 */     GIR_RootConstrainSelectedInstOperands,
     /* 367444 */     // GIR_Coverage, 643,
     /* 367444 */     GIR_EraseRootFromParent_Done,
     /* 367445 */   // Label 7387: @367445
     /* 367445 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(367495), // Rule ID 655 //
     /* 367450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367480 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 367483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 367489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 367493 */     GIR_RootConstrainSelectedInstOperands,
     /* 367494 */     // GIR_Coverage, 655,
     /* 367494 */     GIR_EraseRootFromParent_Done,
     /* 367495 */   // Label 7388: @367495
     /* 367495 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(367526), // Rule ID 637 //
     /* 367500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367515 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 367520 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367524 */     GIR_RootConstrainSelectedInstOperands,
     /* 367525 */     // GIR_Coverage, 637,
     /* 367525 */     GIR_Done,
     /* 367526 */   // Label 7389: @367526
     /* 367526 */   GIM_Reject,
     /* 367527 */ // Label 7361: @367527
     /* 367527 */ GIM_Reject,
     /* 367528 */ // Label 7353: @367528
     /* 367528 */ GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(370457),
     /* 367533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 367542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367546 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(367696), // Rule ID 4810 //
     /* 367551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367616 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367623 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367623 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367635 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367641 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367646 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 367682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 367694 */     GIR_RootConstrainSelectedInstOperands,
     /* 367695 */     // GIR_Coverage, 4810,
     /* 367695 */     GIR_EraseRootFromParent_Done,
     /* 367696 */   // Label 7391: @367696
     /* 367696 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(367843), // Rule ID 4774 //
     /* 367701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367762 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367772 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367784 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367841 */     GIR_RootConstrainSelectedInstOperands,
     /* 367842 */     // GIR_Coverage, 4774,
     /* 367842 */     GIR_EraseRootFromParent_Done,
     /* 367843 */   // Label 7392: @367843
     /* 367843 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(367990), // Rule ID 13608 //
     /* 367848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367909 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367919 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367931 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367988 */     GIR_RootConstrainSelectedInstOperands,
     /* 367989 */     // GIR_Coverage, 13608,
     /* 367989 */     GIR_EraseRootFromParent_Done,
     /* 367990 */   // Label 7393: @367990
     /* 367990 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(368121), // Rule ID 6000 //
     /* 367995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368019 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368043 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368047 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368051 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 368060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368064 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368068 */     // MIs[4] Operand 1
     /* 368068 */     // No operand predicates
     /* 368068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368074 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 368116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 368119 */     GIR_RootConstrainSelectedInstOperands,
     /* 368120 */     // GIR_Coverage, 6000,
     /* 368120 */     GIR_EraseRootFromParent_Done,
     /* 368121 */   // Label 7394: @368121
     /* 368121 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(368252), // Rule ID 6032 //
     /* 368126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368162 */     // MIs[2] Operand 1
     /* 368162 */     // No operand predicates
     /* 368162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 368174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 368178 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368182 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368186 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 368190 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368195 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 368199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368203 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368205 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368250 */     GIR_RootConstrainSelectedInstOperands,
     /* 368251 */     // GIR_Coverage, 6032,
     /* 368251 */     GIR_EraseRootFromParent_Done,
     /* 368252 */   // Label 7395: @368252
     /* 368252 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(368383), // Rule ID 6096 //
     /* 368257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368293 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 368322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368326 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368330 */     // MIs[4] Operand 1
     /* 368330 */     // No operand predicates
     /* 368330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368336 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368348 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 368378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 368381 */     GIR_RootConstrainSelectedInstOperands,
     /* 368382 */     // GIR_Coverage, 6096,
     /* 368382 */     GIR_EraseRootFromParent_Done,
     /* 368383 */   // Label 7396: @368383
     /* 368383 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(368514), // Rule ID 6064 //
     /* 368388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368432 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368436 */     // MIs[3] Operand 1
     /* 368436 */     // No operand predicates
     /* 368436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 368440 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368444 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 368452 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368457 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 368461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368465 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368467 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368479 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368512 */     GIR_RootConstrainSelectedInstOperands,
     /* 368513 */     // GIR_Coverage, 6064,
     /* 368513 */     GIR_EraseRootFromParent_Done,
     /* 368514 */   // Label 7397: @368514
     /* 368514 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(368649), // Rule ID 2452 //
     /* 368519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368543 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368578 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 368581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368590 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 368637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368647 */     GIR_RootConstrainSelectedInstOperands,
     /* 368648 */     // GIR_Coverage, 2452,
     /* 368648 */     GIR_EraseRootFromParent_Done,
     /* 368649 */   // Label 7398: @368649
     /* 368649 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(368768), // Rule ID 5968 //
     /* 368654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368678 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368715 */     // MIs[3] Operand 1
     /* 368715 */     // No operand predicates
     /* 368715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368721 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368766 */     GIR_RootConstrainSelectedInstOperands,
     /* 368767 */     // GIR_Coverage, 5968,
     /* 368767 */     GIR_EraseRootFromParent_Done,
     /* 368768 */   // Label 7399: @368768
     /* 368768 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(368887), // Rule ID 2544 //
     /* 368773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368809 */     // MIs[2] Operand 1
     /* 368809 */     // No operand predicates
     /* 368809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368830 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 368834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368840 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368852 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368885 */     GIR_RootConstrainSelectedInstOperands,
     /* 368886 */     // GIR_Coverage, 2544,
     /* 368886 */     GIR_EraseRootFromParent_Done,
     /* 368887 */   // Label 7400: @368887
     /* 368887 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(368987), // Rule ID 4772 //
     /* 368892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368916 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368943 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368985 */     GIR_RootConstrainSelectedInstOperands,
     /* 368986 */     // GIR_Coverage, 4772,
     /* 368986 */     GIR_EraseRootFromParent_Done,
     /* 368987 */   // Label 7401: @368987
     /* 368987 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(369087), // Rule ID 4808 //
     /* 368992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369016 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369043 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 369061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 369074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 369085 */     GIR_RootConstrainSelectedInstOperands,
     /* 369086 */     // GIR_Coverage, 4808,
     /* 369086 */     GIR_EraseRootFromParent_Done,
     /* 369087 */   // Label 7402: @369087
     /* 369087 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(369184), // Rule ID 13604 //
     /* 369092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369128 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369142 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369182 */     GIR_RootConstrainSelectedInstOperands,
     /* 369183 */     // GIR_Coverage, 13604,
     /* 369183 */     GIR_EraseRootFromParent_Done,
     /* 369184 */   // Label 7403: @369184
     /* 369184 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(369284), // Rule ID 13606 //
     /* 369189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369230 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369240 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369252 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 369258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369282 */     GIR_RootConstrainSelectedInstOperands,
     /* 369283 */     // GIR_Coverage, 13606,
     /* 369283 */     GIR_EraseRootFromParent_Done,
     /* 369284 */   // Label 7404: @369284
     /* 369284 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(369384), // Rule ID 4806 //
     /* 369289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369340 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 369371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 369382 */     GIR_RootConstrainSelectedInstOperands,
     /* 369383 */     // GIR_Coverage, 4806,
     /* 369383 */     GIR_EraseRootFromParent_Done,
     /* 369384 */   // Label 7405: @369384
     /* 369384 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(369481), // Rule ID 4770 //
     /* 369389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369429 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369439 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369479 */     GIR_RootConstrainSelectedInstOperands,
     /* 369480 */     // GIR_Coverage, 4770,
     /* 369480 */     GIR_EraseRootFromParent_Done,
     /* 369481 */   // Label 7406: @369481
     /* 369481 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(369559), // Rule ID 6118 //
     /* 369486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369527 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369531 */     // MIs[3] Operand 1
     /* 369531 */     // No operand predicates
     /* 369531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369541 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369557 */     GIR_RootConstrainSelectedInstOperands,
     /* 369558 */     // GIR_Coverage, 6118,
     /* 369558 */     GIR_EraseRootFromParent_Done,
     /* 369559 */   // Label 7407: @369559
     /* 369559 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(369643), // Rule ID 6030 //
     /* 369564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369596 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369600 */     // MIs[2] Operand 1
     /* 369600 */     // No operand predicates
     /* 369600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 369612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369623 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 369634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369641 */     GIR_RootConstrainSelectedInstOperands,
     /* 369642 */     // GIR_Coverage, 6030,
     /* 369642 */     GIR_EraseRootFromParent_Done,
     /* 369643 */   // Label 7408: @369643
     /* 369643 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(369724), // Rule ID 6062 //
     /* 369648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369696 */     // MIs[3] Operand 1
     /* 369696 */     // No operand predicates
     /* 369696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369706 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369722 */     GIR_RootConstrainSelectedInstOperands,
     /* 369723 */     // GIR_Coverage, 6062,
     /* 369723 */     GIR_EraseRootFromParent_Done,
     /* 369724 */   // Label 7409: @369724
     /* 369724 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(369808), // Rule ID 6094 //
     /* 369729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369778 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369782 */     // MIs[3] Operand 1
     /* 369782 */     // No operand predicates
     /* 369782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369788 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369806 */     GIR_RootConstrainSelectedInstOperands,
     /* 369807 */     // GIR_Coverage, 6094,
     /* 369807 */     GIR_EraseRootFromParent_Done,
     /* 369808 */   // Label 7410: @369808
     /* 369808 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(369886), // Rule ID 6140 //
     /* 369813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369858 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369862 */     // MIs[3] Operand 1
     /* 369862 */     // No operand predicates
     /* 369862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369868 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369884 */     GIR_RootConstrainSelectedInstOperands,
     /* 369885 */     // GIR_Coverage, 6140,
     /* 369885 */     GIR_EraseRootFromParent_Done,
     /* 369886 */   // Label 7411: @369886
     /* 369886 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(369967), // Rule ID 5998 //
     /* 369891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369943 */     // MIs[3] Operand 1
     /* 369943 */     // No operand predicates
     /* 369943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369949 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369965 */     GIR_RootConstrainSelectedInstOperands,
     /* 369966 */     // GIR_Coverage, 5998,
     /* 369966 */     GIR_EraseRootFromParent_Done,
     /* 369967 */   // Label 7412: @369967
     /* 369967 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(370052), // Rule ID 2450 //
     /* 369972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369996 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370010 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 370028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 370041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 370048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370050 */     GIR_RootConstrainSelectedInstOperands,
     /* 370051 */     // GIR_Coverage, 2450,
     /* 370051 */     GIR_EraseRootFromParent_Done,
     /* 370052 */   // Label 7413: @370052
     /* 370052 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(370137), // Rule ID 2448 //
     /* 370057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370095 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 370095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370107 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 370113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 370126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370135 */     GIR_RootConstrainSelectedInstOperands,
     /* 370136 */     // GIR_Coverage, 2448,
     /* 370136 */     GIR_EraseRootFromParent_Done,
     /* 370137 */   // Label 7414: @370137
     /* 370137 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(370206), // Rule ID 2542 //
     /* 370142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370178 */     // MIs[2] Operand 1
     /* 370178 */     // No operand predicates
     /* 370178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370188 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 370191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 370197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370204 */     GIR_RootConstrainSelectedInstOperands,
     /* 370205 */     // GIR_Coverage, 2542,
     /* 370205 */     GIR_EraseRootFromParent_Done,
     /* 370206 */   // Label 7415: @370206
     /* 370206 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(370275), // Rule ID 5966 //
     /* 370211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370247 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370251 */     // MIs[2] Operand 1
     /* 370251 */     // No operand predicates
     /* 370251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370257 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 370257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 370260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370273 */     GIR_RootConstrainSelectedInstOperands,
     /* 370274 */     // GIR_Coverage, 5966,
     /* 370274 */     GIR_EraseRootFromParent_Done,
     /* 370275 */   // Label 7416: @370275
     /* 370275 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(370325), // Rule ID 13046 //
     /* 370280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370310 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 370313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 370317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370323 */     GIR_RootConstrainSelectedInstOperands,
     /* 370324 */     // GIR_Coverage, 13046,
     /* 370324 */     GIR_EraseRootFromParent_Done,
     /* 370325 */   // Label 7417: @370325
     /* 370325 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(370375), // Rule ID 645 //
     /* 370330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370360 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 370363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370373 */     GIR_RootConstrainSelectedInstOperands,
     /* 370374 */     // GIR_Coverage, 645,
     /* 370374 */     GIR_EraseRootFromParent_Done,
     /* 370375 */   // Label 7418: @370375
     /* 370375 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(370425), // Rule ID 657 //
     /* 370380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370410 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 370413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 370419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 370423 */     GIR_RootConstrainSelectedInstOperands,
     /* 370424 */     // GIR_Coverage, 657,
     /* 370424 */     GIR_EraseRootFromParent_Done,
     /* 370425 */   // Label 7419: @370425
     /* 370425 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(370456), // Rule ID 639 //
     /* 370430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370445 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 370450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370454 */     GIR_RootConstrainSelectedInstOperands,
     /* 370455 */     // GIR_Coverage, 639,
     /* 370455 */     GIR_Done,
     /* 370456 */   // Label 7420: @370456
     /* 370456 */   GIM_Reject,
     /* 370457 */ // Label 7390: @370457
     /* 370457 */ GIM_Reject,
     /* 370458 */ // Label 7354: @370458
     /* 370458 */ GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(373387),
     /* 370463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370476 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(370626), // Rule ID 4816 //
     /* 370481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370530 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370546 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370553 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370565 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370593 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 370612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 370624 */     GIR_RootConstrainSelectedInstOperands,
     /* 370625 */     // GIR_Coverage, 4816,
     /* 370625 */     GIR_EraseRootFromParent_Done,
     /* 370626 */   // Label 7422: @370626
     /* 370626 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(370773), // Rule ID 4780 //
     /* 370631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370687 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370692 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370702 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370714 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370725 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370742 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370771 */     GIR_RootConstrainSelectedInstOperands,
     /* 370772 */     // GIR_Coverage, 4780,
     /* 370772 */     GIR_EraseRootFromParent_Done,
     /* 370773 */   // Label 7423: @370773
     /* 370773 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(370920), // Rule ID 13614 //
     /* 370778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370814 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370834 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370839 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370849 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370861 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370918 */     GIR_RootConstrainSelectedInstOperands,
     /* 370919 */     // GIR_Coverage, 13614,
     /* 370919 */     GIR_EraseRootFromParent_Done,
     /* 370920 */   // Label 7424: @370920
     /* 370920 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(371051), // Rule ID 6004 //
     /* 370925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370977 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370994 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370998 */     // MIs[4] Operand 1
     /* 370998 */     // No operand predicates
     /* 370998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371002 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371004 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371016 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 371035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 371046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 371049 */     GIR_RootConstrainSelectedInstOperands,
     /* 371050 */     // GIR_Coverage, 6004,
     /* 371050 */     GIR_EraseRootFromParent_Done,
     /* 371051 */   // Label 7425: @371051
     /* 371051 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(371182), // Rule ID 6036 //
     /* 371056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371092 */     // MIs[2] Operand 1
     /* 371092 */     // No operand predicates
     /* 371092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 371104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 371108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371116 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371120 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371125 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 371129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371133 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371135 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 371166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371180 */     GIR_RootConstrainSelectedInstOperands,
     /* 371181 */     // GIR_Coverage, 6036,
     /* 371181 */     GIR_EraseRootFromParent_Done,
     /* 371182 */   // Label 7426: @371182
     /* 371182 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(371313), // Rule ID 6100 //
     /* 371187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371223 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371256 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371260 */     // MIs[4] Operand 1
     /* 371260 */     // No operand predicates
     /* 371260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371266 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371278 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 371297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 371308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 371311 */     GIR_RootConstrainSelectedInstOperands,
     /* 371312 */     // GIR_Coverage, 6100,
     /* 371312 */     GIR_EraseRootFromParent_Done,
     /* 371313 */   // Label 7427: @371313
     /* 371313 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(371444), // Rule ID 6068 //
     /* 371318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371362 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371366 */     // MIs[3] Operand 1
     /* 371366 */     // No operand predicates
     /* 371366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 371370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371374 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371378 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 371382 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371387 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 371391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371395 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 371397 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 371428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371442 */     GIR_RootConstrainSelectedInstOperands,
     /* 371443 */     // GIR_Coverage, 6068,
     /* 371443 */     GIR_EraseRootFromParent_Done,
     /* 371444 */   // Label 7428: @371444
     /* 371444 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(371579), // Rule ID 2458 //
     /* 371449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371498 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371508 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371508 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 371511 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371515 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371520 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371548 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 371567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371577 */     GIR_RootConstrainSelectedInstOperands,
     /* 371578 */     // GIR_Coverage, 2458,
     /* 371578 */     GIR_EraseRootFromParent_Done,
     /* 371579 */   // Label 7429: @371579
     /* 371579 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(371698), // Rule ID 5972 //
     /* 371584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371641 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371645 */     // MIs[3] Operand 1
     /* 371645 */     // No operand predicates
     /* 371645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371651 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371696 */     GIR_RootConstrainSelectedInstOperands,
     /* 371697 */     // GIR_Coverage, 5972,
     /* 371697 */     GIR_EraseRootFromParent_Done,
     /* 371698 */   // Label 7430: @371698
     /* 371698 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(371817), // Rule ID 2548 //
     /* 371703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371739 */     // MIs[2] Operand 1
     /* 371739 */     // No operand predicates
     /* 371739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371747 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371751 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371755 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371760 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371770 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371782 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371815 */     GIR_RootConstrainSelectedInstOperands,
     /* 371816 */     // GIR_Coverage, 2548,
     /* 371816 */     GIR_EraseRootFromParent_Done,
     /* 371817 */   // Label 7431: @371817
     /* 371817 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(371917), // Rule ID 4778 //
     /* 371822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371846 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371873 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371915 */     GIR_RootConstrainSelectedInstOperands,
     /* 371916 */     // GIR_Coverage, 4778,
     /* 371916 */     GIR_EraseRootFromParent_Done,
     /* 371917 */   // Label 7432: @371917
     /* 371917 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(372017), // Rule ID 4814 //
     /* 371922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371973 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371985 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 372004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 372015 */     GIR_RootConstrainSelectedInstOperands,
     /* 372016 */     // GIR_Coverage, 4814,
     /* 372016 */     GIR_EraseRootFromParent_Done,
     /* 372017 */   // Label 7433: @372017
     /* 372017 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(372114), // Rule ID 13610 //
     /* 372022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372072 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 372072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372112 */     GIR_RootConstrainSelectedInstOperands,
     /* 372113 */     // GIR_Coverage, 13610,
     /* 372113 */     GIR_EraseRootFromParent_Done,
     /* 372114 */   // Label 7434: @372114
     /* 372114 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(372214), // Rule ID 13612 //
     /* 372119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372160 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372170 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372212 */     GIR_RootConstrainSelectedInstOperands,
     /* 372213 */     // GIR_Coverage, 13612,
     /* 372213 */     GIR_EraseRootFromParent_Done,
     /* 372214 */   // Label 7435: @372214
     /* 372214 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(372314), // Rule ID 4812 //
     /* 372219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372247 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 372263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372270 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 372270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372282 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 372301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 372312 */     GIR_RootConstrainSelectedInstOperands,
     /* 372313 */     // GIR_Coverage, 4812,
     /* 372313 */     GIR_EraseRootFromParent_Done,
     /* 372314 */   // Label 7436: @372314
     /* 372314 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(372411), // Rule ID 4776 //
     /* 372319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372369 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 372369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372381 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372409 */     GIR_RootConstrainSelectedInstOperands,
     /* 372410 */     // GIR_Coverage, 4776,
     /* 372410 */     GIR_EraseRootFromParent_Done,
     /* 372411 */   // Label 7437: @372411
     /* 372411 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(372489), // Rule ID 6122 //
     /* 372416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372461 */     // MIs[3] Operand 1
     /* 372461 */     // No operand predicates
     /* 372461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372471 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372487 */     GIR_RootConstrainSelectedInstOperands,
     /* 372488 */     // GIR_Coverage, 6122,
     /* 372488 */     GIR_EraseRootFromParent_Done,
     /* 372489 */   // Label 7438: @372489
     /* 372489 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(372573), // Rule ID 6034 //
     /* 372494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372526 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372530 */     // MIs[2] Operand 1
     /* 372530 */     // No operand predicates
     /* 372530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 372542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372553 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 372564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372571 */     GIR_RootConstrainSelectedInstOperands,
     /* 372572 */     // GIR_Coverage, 6034,
     /* 372572 */     GIR_EraseRootFromParent_Done,
     /* 372573 */   // Label 7439: @372573
     /* 372573 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(372654), // Rule ID 6066 //
     /* 372578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372622 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372626 */     // MIs[3] Operand 1
     /* 372626 */     // No operand predicates
     /* 372626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372636 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372652 */     GIR_RootConstrainSelectedInstOperands,
     /* 372653 */     // GIR_Coverage, 6066,
     /* 372653 */     GIR_EraseRootFromParent_Done,
     /* 372654 */   // Label 7440: @372654
     /* 372654 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(372738), // Rule ID 6098 //
     /* 372659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372708 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372712 */     // MIs[3] Operand 1
     /* 372712 */     // No operand predicates
     /* 372712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372718 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372736 */     GIR_RootConstrainSelectedInstOperands,
     /* 372737 */     // GIR_Coverage, 6098,
     /* 372737 */     GIR_EraseRootFromParent_Done,
     /* 372738 */   // Label 7441: @372738
     /* 372738 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(372816), // Rule ID 6144 //
     /* 372743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372792 */     // MIs[3] Operand 1
     /* 372792 */     // No operand predicates
     /* 372792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372798 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372814 */     GIR_RootConstrainSelectedInstOperands,
     /* 372815 */     // GIR_Coverage, 6144,
     /* 372815 */     GIR_EraseRootFromParent_Done,
     /* 372816 */   // Label 7442: @372816
     /* 372816 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(372897), // Rule ID 6002 //
     /* 372821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372869 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372873 */     // MIs[3] Operand 1
     /* 372873 */     // No operand predicates
     /* 372873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372879 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372895 */     GIR_RootConstrainSelectedInstOperands,
     /* 372896 */     // GIR_Coverage, 6002,
     /* 372896 */     GIR_EraseRootFromParent_Done,
     /* 372897 */   // Label 7443: @372897
     /* 372897 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(372982), // Rule ID 2456 //
     /* 372902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372940 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372980 */     GIR_RootConstrainSelectedInstOperands,
     /* 372981 */     // GIR_Coverage, 2456,
     /* 372981 */     GIR_EraseRootFromParent_Done,
     /* 372982 */   // Label 7444: @372982
     /* 372982 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(373067), // Rule ID 2454 //
     /* 372987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373025 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 373025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 373056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373065 */     GIR_RootConstrainSelectedInstOperands,
     /* 373066 */     // GIR_Coverage, 2454,
     /* 373066 */     GIR_EraseRootFromParent_Done,
     /* 373067 */   // Label 7445: @373067
     /* 373067 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(373136), // Rule ID 2546 //
     /* 373072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373108 */     // MIs[2] Operand 1
     /* 373108 */     // No operand predicates
     /* 373108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373118 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 373121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373134 */     GIR_RootConstrainSelectedInstOperands,
     /* 373135 */     // GIR_Coverage, 2546,
     /* 373135 */     GIR_EraseRootFromParent_Done,
     /* 373136 */   // Label 7446: @373136
     /* 373136 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(373205), // Rule ID 5970 //
     /* 373141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373181 */     // MIs[2] Operand 1
     /* 373181 */     // No operand predicates
     /* 373181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373187 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 373190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373203 */     GIR_RootConstrainSelectedInstOperands,
     /* 373204 */     // GIR_Coverage, 5970,
     /* 373204 */     GIR_EraseRootFromParent_Done,
     /* 373205 */   // Label 7447: @373205
     /* 373205 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(373255), // Rule ID 13048 //
     /* 373210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373240 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 373240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 373243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373253 */     GIR_RootConstrainSelectedInstOperands,
     /* 373254 */     // GIR_Coverage, 13048,
     /* 373254 */     GIR_EraseRootFromParent_Done,
     /* 373255 */   // Label 7448: @373255
     /* 373255 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(373305), // Rule ID 647 //
     /* 373260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373290 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 373290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 373293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373303 */     GIR_RootConstrainSelectedInstOperands,
     /* 373304 */     // GIR_Coverage, 647,
     /* 373304 */     GIR_EraseRootFromParent_Done,
     /* 373305 */   // Label 7449: @373305
     /* 373305 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(373355), // Rule ID 659 //
     /* 373310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 373325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373340 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 373340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 373343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 373349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 373353 */     GIR_RootConstrainSelectedInstOperands,
     /* 373354 */     // GIR_Coverage, 659,
     /* 373354 */     GIR_EraseRootFromParent_Done,
     /* 373355 */   // Label 7450: @373355
     /* 373355 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(373386), // Rule ID 641 //
     /* 373360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373375 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 373375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 373380 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373384 */     GIR_RootConstrainSelectedInstOperands,
     /* 373385 */     // GIR_Coverage, 641,
     /* 373385 */     GIR_Done,
     /* 373386 */   // Label 7451: @373386
     /* 373386 */   GIM_Reject,
     /* 373387 */ // Label 7421: @373387
     /* 373387 */ GIM_Reject,
     /* 373388 */ // Label 7355: @373388
     /* 373388 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(374908),
     /* 373393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 373399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 373402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373406 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(373484), // Rule ID 6102 //
     /* 373411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373452 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373456 */     // MIs[3] Operand 1
     /* 373456 */     // No operand predicates
     /* 373456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373466 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373482 */     GIR_RootConstrainSelectedInstOperands,
     /* 373483 */     // GIR_Coverage, 6102,
     /* 373483 */     GIR_EraseRootFromParent_Done,
     /* 373484 */   // Label 7453: @373484
     /* 373484 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(373568), // Rule ID 6018 //
     /* 373489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373525 */     // MIs[2] Operand 1
     /* 373525 */     // No operand predicates
     /* 373525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373548 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 373559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373566 */     GIR_RootConstrainSelectedInstOperands,
     /* 373567 */     // GIR_Coverage, 6018,
     /* 373567 */     GIR_EraseRootFromParent_Done,
     /* 373568 */   // Label 7454: @373568
     /* 373568 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(373649), // Rule ID 6050 //
     /* 373573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373621 */     // MIs[3] Operand 1
     /* 373621 */     // No operand predicates
     /* 373621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373631 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373647 */     GIR_RootConstrainSelectedInstOperands,
     /* 373648 */     // GIR_Coverage, 6050,
     /* 373648 */     GIR_EraseRootFromParent_Done,
     /* 373649 */   // Label 7455: @373649
     /* 373649 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(373733), // Rule ID 6082 //
     /* 373654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373703 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373707 */     // MIs[3] Operand 1
     /* 373707 */     // No operand predicates
     /* 373707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373713 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373731 */     GIR_RootConstrainSelectedInstOperands,
     /* 373732 */     // GIR_Coverage, 6082,
     /* 373732 */     GIR_EraseRootFromParent_Done,
     /* 373733 */   // Label 7456: @373733
     /* 373733 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(373811), // Rule ID 6124 //
     /* 373738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373783 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373787 */     // MIs[3] Operand 1
     /* 373787 */     // No operand predicates
     /* 373787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373793 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373809 */     GIR_RootConstrainSelectedInstOperands,
     /* 373810 */     // GIR_Coverage, 6124,
     /* 373810 */     GIR_EraseRootFromParent_Done,
     /* 373811 */   // Label 7457: @373811
     /* 373811 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(373892), // Rule ID 5986 //
     /* 373816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373864 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373868 */     // MIs[3] Operand 1
     /* 373868 */     // No operand predicates
     /* 373868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373874 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373890 */     GIR_RootConstrainSelectedInstOperands,
     /* 373891 */     // GIR_Coverage, 5986,
     /* 373891 */     GIR_EraseRootFromParent_Done,
     /* 373892 */   // Label 7458: @373892
     /* 373892 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(373961), // Rule ID 2530 //
     /* 373897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373933 */     // MIs[2] Operand 1
     /* 373933 */     // No operand predicates
     /* 373933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373943 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 373946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373959 */     GIR_RootConstrainSelectedInstOperands,
     /* 373960 */     // GIR_Coverage, 2530,
     /* 373960 */     GIR_EraseRootFromParent_Done,
     /* 373961 */   // Label 7459: @373961
     /* 373961 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(374030), // Rule ID 5954 //
     /* 373966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374006 */     // MIs[2] Operand 1
     /* 374006 */     // No operand predicates
     /* 374006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374012 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374028 */     GIR_RootConstrainSelectedInstOperands,
     /* 374029 */     // GIR_Coverage, 5954,
     /* 374029 */     GIR_EraseRootFromParent_Done,
     /* 374030 */   // Label 7460: @374030
     /* 374030 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(374123), // Rule ID 6106 //
     /* 374035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374074 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374086 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374121 */     GIR_RootConstrainSelectedInstOperands,
     /* 374122 */     // GIR_Coverage, 6106,
     /* 374122 */     GIR_EraseRootFromParent_Done,
     /* 374123 */   // Label 7461: @374123
     /* 374123 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(374222), // Rule ID 6020 //
     /* 374128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374171 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374220 */     GIR_RootConstrainSelectedInstOperands,
     /* 374221 */     // GIR_Coverage, 6020,
     /* 374221 */     GIR_EraseRootFromParent_Done,
     /* 374222 */   // Label 7462: @374222
     /* 374222 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(374318), // Rule ID 6052 //
     /* 374227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 374250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374269 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374316 */     GIR_RootConstrainSelectedInstOperands,
     /* 374317 */     // GIR_Coverage, 6052,
     /* 374317 */     GIR_EraseRootFromParent_Done,
     /* 374318 */   // Label 7463: @374318
     /* 374318 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(374417), // Rule ID 6084 //
     /* 374323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 374351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374366 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374415 */     GIR_RootConstrainSelectedInstOperands,
     /* 374416 */     // GIR_Coverage, 6084,
     /* 374416 */     GIR_EraseRootFromParent_Done,
     /* 374417 */   // Label 7464: @374417
     /* 374417 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(374510), // Rule ID 6128 //
     /* 374422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374461 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374480 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374508 */     GIR_RootConstrainSelectedInstOperands,
     /* 374509 */     // GIR_Coverage, 6128,
     /* 374509 */     GIR_EraseRootFromParent_Done,
     /* 374510 */   // Label 7465: @374510
     /* 374510 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(374606), // Rule ID 5988 //
     /* 374515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 374542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374557 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374569 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374604 */     GIR_RootConstrainSelectedInstOperands,
     /* 374605 */     // GIR_Coverage, 5988,
     /* 374605 */     GIR_EraseRootFromParent_Done,
     /* 374606 */   // Label 7466: @374606
     /* 374606 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(374690), // Rule ID 2532 //
     /* 374611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374641 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374688 */     GIR_RootConstrainSelectedInstOperands,
     /* 374689 */     // GIR_Coverage, 2532,
     /* 374689 */     GIR_EraseRootFromParent_Done,
     /* 374690 */   // Label 7467: @374690
     /* 374690 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(374740), // Rule ID 13078 //
     /* 374695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374725 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374738 */     GIR_RootConstrainSelectedInstOperands,
     /* 374739 */     // GIR_Coverage, 13078,
     /* 374739 */     GIR_EraseRootFromParent_Done,
     /* 374740 */   // Label 7468: @374740
     /* 374740 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(374824), // Rule ID 5956 //
     /* 374745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374775 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374822 */     GIR_RootConstrainSelectedInstOperands,
     /* 374823 */     // GIR_Coverage, 5956,
     /* 374823 */     GIR_EraseRootFromParent_Done,
     /* 374824 */   // Label 7469: @374824
     /* 374824 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(374874), // Rule ID 1300 //
     /* 374829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374859 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374872 */     GIR_RootConstrainSelectedInstOperands,
     /* 374873 */     // GIR_Coverage, 1300,
     /* 374873 */     GIR_EraseRootFromParent_Done,
     /* 374874 */   // Label 7470: @374874
     /* 374874 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(374907), // Rule ID 1290 //
     /* 374879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374894 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 374897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 374905 */     GIR_RootConstrainSelectedInstOperands,
     /* 374906 */     // GIR_Coverage, 1290,
     /* 374906 */     GIR_EraseRootFromParent_Done,
     /* 374907 */   // Label 7471: @374907
     /* 374907 */   GIM_Reject,
     /* 374908 */ // Label 7452: @374908
     /* 374908 */ GIM_Reject,
     /* 374909 */ // Label 7356: @374909
     /* 374909 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(376429),
     /* 374914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 374923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374927 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(375005), // Rule ID 6114 //
     /* 374932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374977 */     // MIs[3] Operand 1
     /* 374977 */     // No operand predicates
     /* 374977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374987 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375003 */     GIR_RootConstrainSelectedInstOperands,
     /* 375004 */     // GIR_Coverage, 6114,
     /* 375004 */     GIR_EraseRootFromParent_Done,
     /* 375005 */   // Label 7473: @375005
     /* 375005 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(375089), // Rule ID 6026 //
     /* 375010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375046 */     // MIs[2] Operand 1
     /* 375046 */     // No operand predicates
     /* 375046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375069 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 375080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375087 */     GIR_RootConstrainSelectedInstOperands,
     /* 375088 */     // GIR_Coverage, 6026,
     /* 375088 */     GIR_EraseRootFromParent_Done,
     /* 375089 */   // Label 7474: @375089
     /* 375089 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(375170), // Rule ID 6058 //
     /* 375094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375138 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375142 */     // MIs[3] Operand 1
     /* 375142 */     // No operand predicates
     /* 375142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375152 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375168 */     GIR_RootConstrainSelectedInstOperands,
     /* 375169 */     // GIR_Coverage, 6058,
     /* 375169 */     GIR_EraseRootFromParent_Done,
     /* 375170 */   // Label 7475: @375170
     /* 375170 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(375254), // Rule ID 6090 //
     /* 375175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375224 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375228 */     // MIs[3] Operand 1
     /* 375228 */     // No operand predicates
     /* 375228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375234 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375252 */     GIR_RootConstrainSelectedInstOperands,
     /* 375253 */     // GIR_Coverage, 6090,
     /* 375253 */     GIR_EraseRootFromParent_Done,
     /* 375254 */   // Label 7476: @375254
     /* 375254 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(375332), // Rule ID 6136 //
     /* 375259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 375300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375308 */     // MIs[3] Operand 1
     /* 375308 */     // No operand predicates
     /* 375308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375314 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375330 */     GIR_RootConstrainSelectedInstOperands,
     /* 375331 */     // GIR_Coverage, 6136,
     /* 375331 */     GIR_EraseRootFromParent_Done,
     /* 375332 */   // Label 7477: @375332
     /* 375332 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(375413), // Rule ID 5994 //
     /* 375337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375389 */     // MIs[3] Operand 1
     /* 375389 */     // No operand predicates
     /* 375389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375395 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375411 */     GIR_RootConstrainSelectedInstOperands,
     /* 375412 */     // GIR_Coverage, 5994,
     /* 375412 */     GIR_EraseRootFromParent_Done,
     /* 375413 */   // Label 7478: @375413
     /* 375413 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(375482), // Rule ID 2538 //
     /* 375418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375450 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375454 */     // MIs[2] Operand 1
     /* 375454 */     // No operand predicates
     /* 375454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375464 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375480 */     GIR_RootConstrainSelectedInstOperands,
     /* 375481 */     // GIR_Coverage, 2538,
     /* 375481 */     GIR_EraseRootFromParent_Done,
     /* 375482 */   // Label 7479: @375482
     /* 375482 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(375551), // Rule ID 5962 //
     /* 375487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375527 */     // MIs[2] Operand 1
     /* 375527 */     // No operand predicates
     /* 375527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375533 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375549 */     GIR_RootConstrainSelectedInstOperands,
     /* 375550 */     // GIR_Coverage, 5962,
     /* 375550 */     GIR_EraseRootFromParent_Done,
     /* 375551 */   // Label 7480: @375551
     /* 375551 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(375644), // Rule ID 6116 //
     /* 375556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375595 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375642 */     GIR_RootConstrainSelectedInstOperands,
     /* 375643 */     // GIR_Coverage, 6116,
     /* 375643 */     GIR_EraseRootFromParent_Done,
     /* 375644 */   // Label 7481: @375644
     /* 375644 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(375743), // Rule ID 6028 //
     /* 375649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375692 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375741 */     GIR_RootConstrainSelectedInstOperands,
     /* 375742 */     // GIR_Coverage, 6028,
     /* 375742 */     GIR_EraseRootFromParent_Done,
     /* 375743 */   // Label 7482: @375743
     /* 375743 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(375839), // Rule ID 6060 //
     /* 375748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375790 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375837 */     GIR_RootConstrainSelectedInstOperands,
     /* 375838 */     // GIR_Coverage, 6060,
     /* 375838 */     GIR_EraseRootFromParent_Done,
     /* 375839 */   // Label 7483: @375839
     /* 375839 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(375938), // Rule ID 6092 //
     /* 375844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375887 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375936 */     GIR_RootConstrainSelectedInstOperands,
     /* 375937 */     // GIR_Coverage, 6092,
     /* 375937 */     GIR_EraseRootFromParent_Done,
     /* 375938 */   // Label 7484: @375938
     /* 375938 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(376031), // Rule ID 6138 //
     /* 375943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375982 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 376017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376029 */     GIR_RootConstrainSelectedInstOperands,
     /* 376030 */     // GIR_Coverage, 6138,
     /* 376030 */     GIR_EraseRootFromParent_Done,
     /* 376031 */   // Label 7485: @376031
     /* 376031 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(376127), // Rule ID 5996 //
     /* 376036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 376067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376078 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 376113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376125 */     GIR_RootConstrainSelectedInstOperands,
     /* 376126 */     // GIR_Coverage, 5996,
     /* 376126 */     GIR_EraseRootFromParent_Done,
     /* 376127 */   // Label 7486: @376127
     /* 376127 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(376211), // Rule ID 2540 //
     /* 376132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 376147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376162 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 376197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376209 */     GIR_RootConstrainSelectedInstOperands,
     /* 376210 */     // GIR_Coverage, 2540,
     /* 376210 */     GIR_EraseRootFromParent_Done,
     /* 376211 */   // Label 7487: @376211
     /* 376211 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(376261), // Rule ID 13082 //
     /* 376216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376246 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 376249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376259 */     GIR_RootConstrainSelectedInstOperands,
     /* 376260 */     // GIR_Coverage, 13082,
     /* 376260 */     GIR_EraseRootFromParent_Done,
     /* 376261 */   // Label 7488: @376261
     /* 376261 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(376345), // Rule ID 5964 //
     /* 376266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 376285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376296 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 376331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376343 */     GIR_RootConstrainSelectedInstOperands,
     /* 376344 */     // GIR_Coverage, 5964,
     /* 376344 */     GIR_EraseRootFromParent_Done,
     /* 376345 */   // Label 7489: @376345
     /* 376345 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(376395), // Rule ID 1304 //
     /* 376350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376380 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 376383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376393 */     GIR_RootConstrainSelectedInstOperands,
     /* 376394 */     // GIR_Coverage, 1304,
     /* 376394 */     GIR_EraseRootFromParent_Done,
     /* 376395 */   // Label 7490: @376395
     /* 376395 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(376428), // Rule ID 1294 //
     /* 376400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376415 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 376418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 376426 */     GIR_RootConstrainSelectedInstOperands,
     /* 376427 */     // GIR_Coverage, 1294,
     /* 376427 */     GIR_EraseRootFromParent_Done,
     /* 376428 */   // Label 7491: @376428
     /* 376428 */   GIM_Reject,
     /* 376429 */ // Label 7472: @376429
     /* 376429 */ GIM_Reject,
     /* 376430 */ // Label 7357: @376430
     /* 376430 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(377608),
     /* 376435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 376444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376448 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(376532), // Rule ID 6010 //
     /* 376453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376489 */     // MIs[2] Operand 1
     /* 376489 */     // No operand predicates
     /* 376489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376501 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376512 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 376523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376530 */     GIR_RootConstrainSelectedInstOperands,
     /* 376531 */     // GIR_Coverage, 6010,
     /* 376531 */     GIR_EraseRootFromParent_Done,
     /* 376532 */   // Label 7493: @376532
     /* 376532 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(376613), // Rule ID 6042 //
     /* 376537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376581 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376585 */     // MIs[3] Operand 1
     /* 376585 */     // No operand predicates
     /* 376585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376595 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376611 */     GIR_RootConstrainSelectedInstOperands,
     /* 376612 */     // GIR_Coverage, 6042,
     /* 376612 */     GIR_EraseRootFromParent_Done,
     /* 376613 */   // Label 7494: @376613
     /* 376613 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(376697), // Rule ID 6074 //
     /* 376618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376667 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376671 */     // MIs[3] Operand 1
     /* 376671 */     // No operand predicates
     /* 376671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376677 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376695 */     GIR_RootConstrainSelectedInstOperands,
     /* 376696 */     // GIR_Coverage, 6074,
     /* 376696 */     GIR_EraseRootFromParent_Done,
     /* 376697 */   // Label 7495: @376697
     /* 376697 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(376778), // Rule ID 5978 //
     /* 376702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376750 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376754 */     // MIs[3] Operand 1
     /* 376754 */     // No operand predicates
     /* 376754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376760 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376776 */     GIR_RootConstrainSelectedInstOperands,
     /* 376777 */     // GIR_Coverage, 5978,
     /* 376777 */     GIR_EraseRootFromParent_Done,
     /* 376778 */   // Label 7496: @376778
     /* 376778 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(376847), // Rule ID 2522 //
     /* 376783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376815 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376819 */     // MIs[2] Operand 1
     /* 376819 */     // No operand predicates
     /* 376819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376829 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376845 */     GIR_RootConstrainSelectedInstOperands,
     /* 376846 */     // GIR_Coverage, 2522,
     /* 376846 */     GIR_EraseRootFromParent_Done,
     /* 376847 */   // Label 7497: @376847
     /* 376847 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(376916), // Rule ID 5946 //
     /* 376852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376892 */     // MIs[2] Operand 1
     /* 376892 */     // No operand predicates
     /* 376892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376898 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376914 */     GIR_RootConstrainSelectedInstOperands,
     /* 376915 */     // GIR_Coverage, 5946,
     /* 376915 */     GIR_EraseRootFromParent_Done,
     /* 376916 */   // Label 7498: @376916
     /* 376916 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(377015), // Rule ID 6012 //
     /* 376921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376964 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 377007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377013 */     GIR_RootConstrainSelectedInstOperands,
     /* 377014 */     // GIR_Coverage, 6012,
     /* 377014 */     GIR_EraseRootFromParent_Done,
     /* 377015 */   // Label 7499: @377015
     /* 377015 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(377111), // Rule ID 6044 //
     /* 377020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 377043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377062 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377074 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 377097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377109 */     GIR_RootConstrainSelectedInstOperands,
     /* 377110 */     // GIR_Coverage, 6044,
     /* 377110 */     GIR_EraseRootFromParent_Done,
     /* 377111 */   // Label 7500: @377111
     /* 377111 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(377210), // Rule ID 6076 //
     /* 377116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 377144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377159 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377178 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 377194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377208 */     GIR_RootConstrainSelectedInstOperands,
     /* 377209 */     // GIR_Coverage, 6076,
     /* 377209 */     GIR_EraseRootFromParent_Done,
     /* 377210 */   // Label 7501: @377210
     /* 377210 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(377306), // Rule ID 5980 //
     /* 377215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 377242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377257 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377269 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 377292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377304 */     GIR_RootConstrainSelectedInstOperands,
     /* 377305 */     // GIR_Coverage, 5980,
     /* 377305 */     GIR_EraseRootFromParent_Done,
     /* 377306 */   // Label 7502: @377306
     /* 377306 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(377390), // Rule ID 2524 //
     /* 377311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377341 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 377376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377388 */     GIR_RootConstrainSelectedInstOperands,
     /* 377389 */     // GIR_Coverage, 2524,
     /* 377389 */     GIR_EraseRootFromParent_Done,
     /* 377390 */   // Label 7503: @377390
     /* 377390 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(377440), // Rule ID 13074 //
     /* 377395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377425 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 377428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377438 */     GIR_RootConstrainSelectedInstOperands,
     /* 377439 */     // GIR_Coverage, 13074,
     /* 377439 */     GIR_EraseRootFromParent_Done,
     /* 377440 */   // Label 7504: @377440
     /* 377440 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(377524), // Rule ID 5948 //
     /* 377445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377475 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 377510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377522 */     GIR_RootConstrainSelectedInstOperands,
     /* 377523 */     // GIR_Coverage, 5948,
     /* 377523 */     GIR_EraseRootFromParent_Done,
     /* 377524 */   // Label 7505: @377524
     /* 377524 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(377574), // Rule ID 1296 //
     /* 377529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377559 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 377562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377572 */     GIR_RootConstrainSelectedInstOperands,
     /* 377573 */     // GIR_Coverage, 1296,
     /* 377573 */     GIR_EraseRootFromParent_Done,
     /* 377574 */   // Label 7506: @377574
     /* 377574 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(377607), // Rule ID 1286 //
     /* 377579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377594 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 377597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 377605 */     GIR_RootConstrainSelectedInstOperands,
     /* 377606 */     // GIR_Coverage, 1286,
     /* 377606 */     GIR_EraseRootFromParent_Done,
     /* 377607 */   // Label 7507: @377607
     /* 377607 */   GIM_Reject,
     /* 377608 */ // Label 7492: @377608
     /* 377608 */ GIM_Reject,
     /* 377609 */ // Label 7358: @377609
     /* 377609 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(379129),
     /* 377614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 377620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 377623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377627 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(377705), // Rule ID 6108 //
     /* 377632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377677 */     // MIs[3] Operand 1
     /* 377677 */     // No operand predicates
     /* 377677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377687 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377703 */     GIR_RootConstrainSelectedInstOperands,
     /* 377704 */     // GIR_Coverage, 6108,
     /* 377704 */     GIR_EraseRootFromParent_Done,
     /* 377705 */   // Label 7509: @377705
     /* 377705 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(377789), // Rule ID 6022 //
     /* 377710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377742 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377746 */     // MIs[2] Operand 1
     /* 377746 */     // No operand predicates
     /* 377746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377758 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377769 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 377780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377787 */     GIR_RootConstrainSelectedInstOperands,
     /* 377788 */     // GIR_Coverage, 6022,
     /* 377788 */     GIR_EraseRootFromParent_Done,
     /* 377789 */   // Label 7510: @377789
     /* 377789 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(377870), // Rule ID 6054 //
     /* 377794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377838 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377842 */     // MIs[3] Operand 1
     /* 377842 */     // No operand predicates
     /* 377842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377852 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377868 */     GIR_RootConstrainSelectedInstOperands,
     /* 377869 */     // GIR_Coverage, 6054,
     /* 377869 */     GIR_EraseRootFromParent_Done,
     /* 377870 */   // Label 7511: @377870
     /* 377870 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(377954), // Rule ID 6086 //
     /* 377875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377924 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377928 */     // MIs[3] Operand 1
     /* 377928 */     // No operand predicates
     /* 377928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377934 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377952 */     GIR_RootConstrainSelectedInstOperands,
     /* 377953 */     // GIR_Coverage, 6086,
     /* 377953 */     GIR_EraseRootFromParent_Done,
     /* 377954 */   // Label 7512: @377954
     /* 377954 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(378032), // Rule ID 6130 //
     /* 377959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 378000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378008 */     // MIs[3] Operand 1
     /* 378008 */     // No operand predicates
     /* 378008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378014 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 378014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378030 */     GIR_RootConstrainSelectedInstOperands,
     /* 378031 */     // GIR_Coverage, 6130,
     /* 378031 */     GIR_EraseRootFromParent_Done,
     /* 378032 */   // Label 7513: @378032
     /* 378032 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(378113), // Rule ID 5990 //
     /* 378037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378085 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378089 */     // MIs[3] Operand 1
     /* 378089 */     // No operand predicates
     /* 378089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378095 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 378095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378111 */     GIR_RootConstrainSelectedInstOperands,
     /* 378112 */     // GIR_Coverage, 5990,
     /* 378112 */     GIR_EraseRootFromParent_Done,
     /* 378113 */   // Label 7514: @378113
     /* 378113 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(378182), // Rule ID 2534 //
     /* 378118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378154 */     // MIs[2] Operand 1
     /* 378154 */     // No operand predicates
     /* 378154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378164 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 378164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378180 */     GIR_RootConstrainSelectedInstOperands,
     /* 378181 */     // GIR_Coverage, 2534,
     /* 378181 */     GIR_EraseRootFromParent_Done,
     /* 378182 */   // Label 7515: @378182
     /* 378182 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(378251), // Rule ID 5958 //
     /* 378187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 378202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 378227 */     // MIs[2] Operand 1
     /* 378227 */     // No operand predicates
     /* 378227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378233 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 378233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378249 */     GIR_RootConstrainSelectedInstOperands,
     /* 378250 */     // GIR_Coverage, 5958,
     /* 378250 */     GIR_EraseRootFromParent_Done,
     /* 378251 */   // Label 7516: @378251
     /* 378251 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(378344), // Rule ID 6112 //
     /* 378256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378295 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378342 */     GIR_RootConstrainSelectedInstOperands,
     /* 378343 */     // GIR_Coverage, 6112,
     /* 378343 */     GIR_EraseRootFromParent_Done,
     /* 378344 */   // Label 7517: @378344
     /* 378344 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(378443), // Rule ID 6024 //
     /* 378349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378392 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378404 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 378435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378441 */     GIR_RootConstrainSelectedInstOperands,
     /* 378442 */     // GIR_Coverage, 6024,
     /* 378442 */     GIR_EraseRootFromParent_Done,
     /* 378443 */   // Label 7518: @378443
     /* 378443 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(378539), // Rule ID 6056 //
     /* 378448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378490 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378509 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378537 */     GIR_RootConstrainSelectedInstOperands,
     /* 378538 */     // GIR_Coverage, 6056,
     /* 378538 */     GIR_EraseRootFromParent_Done,
     /* 378539 */   // Label 7519: @378539
     /* 378539 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(378638), // Rule ID 6088 //
     /* 378544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378587 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378636 */     GIR_RootConstrainSelectedInstOperands,
     /* 378637 */     // GIR_Coverage, 6088,
     /* 378637 */     GIR_EraseRootFromParent_Done,
     /* 378638 */   // Label 7520: @378638
     /* 378638 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(378731), // Rule ID 6134 //
     /* 378643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378682 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378729 */     GIR_RootConstrainSelectedInstOperands,
     /* 378730 */     // GIR_Coverage, 6134,
     /* 378730 */     GIR_EraseRootFromParent_Done,
     /* 378731 */   // Label 7521: @378731
     /* 378731 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(378827), // Rule ID 5992 //
     /* 378736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378778 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378793 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378825 */     GIR_RootConstrainSelectedInstOperands,
     /* 378826 */     // GIR_Coverage, 5992,
     /* 378826 */     GIR_EraseRootFromParent_Done,
     /* 378827 */   // Label 7522: @378827
     /* 378827 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(378911), // Rule ID 2536 //
     /* 378832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378862 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378909 */     GIR_RootConstrainSelectedInstOperands,
     /* 378910 */     // GIR_Coverage, 2536,
     /* 378910 */     GIR_EraseRootFromParent_Done,
     /* 378911 */   // Label 7523: @378911
     /* 378911 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(378961), // Rule ID 13080 //
     /* 378916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378946 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 378949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378959 */     GIR_RootConstrainSelectedInstOperands,
     /* 378960 */     // GIR_Coverage, 13080,
     /* 378960 */     GIR_EraseRootFromParent_Done,
     /* 378961 */   // Label 7524: @378961
     /* 378961 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(379045), // Rule ID 5960 //
     /* 378966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378996 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 379018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 379031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379043 */     GIR_RootConstrainSelectedInstOperands,
     /* 379044 */     // GIR_Coverage, 5960,
     /* 379044 */     GIR_EraseRootFromParent_Done,
     /* 379045 */   // Label 7525: @379045
     /* 379045 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(379095), // Rule ID 1302 //
     /* 379050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379080 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 379080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 379083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379093 */     GIR_RootConstrainSelectedInstOperands,
     /* 379094 */     // GIR_Coverage, 1302,
     /* 379094 */     GIR_EraseRootFromParent_Done,
     /* 379095 */   // Label 7526: @379095
     /* 379095 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(379128), // Rule ID 1292 //
     /* 379100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379115 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 379115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 379118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 379126 */     GIR_RootConstrainSelectedInstOperands,
     /* 379127 */     // GIR_Coverage, 1292,
     /* 379127 */     GIR_EraseRootFromParent_Done,
     /* 379128 */   // Label 7527: @379128
     /* 379128 */   GIM_Reject,
     /* 379129 */ // Label 7508: @379129
     /* 379129 */ GIM_Reject,
     /* 379130 */ // Label 7359: @379130
     /* 379130 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(380308),
     /* 379135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 379141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 379144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379148 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(379232), // Rule ID 6006 //
     /* 379153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379185 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379189 */     // MIs[2] Operand 1
     /* 379189 */     // No operand predicates
     /* 379189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379197 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379212 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 379223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379230 */     GIR_RootConstrainSelectedInstOperands,
     /* 379231 */     // GIR_Coverage, 6006,
     /* 379231 */     GIR_EraseRootFromParent_Done,
     /* 379232 */   // Label 7529: @379232
     /* 379232 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(379313), // Rule ID 6038 //
     /* 379237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379285 */     // MIs[3] Operand 1
     /* 379285 */     // No operand predicates
     /* 379285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379295 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379311 */     GIR_RootConstrainSelectedInstOperands,
     /* 379312 */     // GIR_Coverage, 6038,
     /* 379312 */     GIR_EraseRootFromParent_Done,
     /* 379313 */   // Label 7530: @379313
     /* 379313 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(379397), // Rule ID 6070 //
     /* 379318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379367 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379371 */     // MIs[3] Operand 1
     /* 379371 */     // No operand predicates
     /* 379371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379377 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379395 */     GIR_RootConstrainSelectedInstOperands,
     /* 379396 */     // GIR_Coverage, 6070,
     /* 379396 */     GIR_EraseRootFromParent_Done,
     /* 379397 */   // Label 7531: @379397
     /* 379397 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(379478), // Rule ID 5974 //
     /* 379402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379454 */     // MIs[3] Operand 1
     /* 379454 */     // No operand predicates
     /* 379454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379460 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379476 */     GIR_RootConstrainSelectedInstOperands,
     /* 379477 */     // GIR_Coverage, 5974,
     /* 379477 */     GIR_EraseRootFromParent_Done,
     /* 379478 */   // Label 7532: @379478
     /* 379478 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(379547), // Rule ID 2518 //
     /* 379483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379519 */     // MIs[2] Operand 1
     /* 379519 */     // No operand predicates
     /* 379519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379529 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379545 */     GIR_RootConstrainSelectedInstOperands,
     /* 379546 */     // GIR_Coverage, 2518,
     /* 379546 */     GIR_EraseRootFromParent_Done,
     /* 379547 */   // Label 7533: @379547
     /* 379547 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(379616), // Rule ID 5942 //
     /* 379552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379588 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379592 */     // MIs[2] Operand 1
     /* 379592 */     // No operand predicates
     /* 379592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379598 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379614 */     GIR_RootConstrainSelectedInstOperands,
     /* 379615 */     // GIR_Coverage, 5942,
     /* 379615 */     GIR_EraseRootFromParent_Done,
     /* 379616 */   // Label 7534: @379616
     /* 379616 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(379715), // Rule ID 6008 //
     /* 379621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379664 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379683 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 379707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379713 */     GIR_RootConstrainSelectedInstOperands,
     /* 379714 */     // GIR_Coverage, 6008,
     /* 379714 */     GIR_EraseRootFromParent_Done,
     /* 379715 */   // Label 7535: @379715
     /* 379715 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(379811), // Rule ID 6040 //
     /* 379720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379762 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379809 */     GIR_RootConstrainSelectedInstOperands,
     /* 379810 */     // GIR_Coverage, 6040,
     /* 379810 */     GIR_EraseRootFromParent_Done,
     /* 379811 */   // Label 7536: @379811
     /* 379811 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(379910), // Rule ID 6072 //
     /* 379816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379859 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379908 */     GIR_RootConstrainSelectedInstOperands,
     /* 379909 */     // GIR_Coverage, 6072,
     /* 379909 */     GIR_EraseRootFromParent_Done,
     /* 379910 */   // Label 7537: @379910
     /* 379910 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(380006), // Rule ID 5976 //
     /* 379915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379957 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380004 */     GIR_RootConstrainSelectedInstOperands,
     /* 380005 */     // GIR_Coverage, 5976,
     /* 380005 */     GIR_EraseRootFromParent_Done,
     /* 380006 */   // Label 7538: @380006
     /* 380006 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(380090), // Rule ID 2520 //
     /* 380011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 380031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380041 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 380044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 380063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 380073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 380076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380088 */     GIR_RootConstrainSelectedInstOperands,
     /* 380089 */     // GIR_Coverage, 2520,
     /* 380089 */     GIR_EraseRootFromParent_Done,
     /* 380090 */   // Label 7539: @380090
     /* 380090 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(380140), // Rule ID 13076 //
     /* 380095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380125 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 380125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 380128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380138 */     GIR_RootConstrainSelectedInstOperands,
     /* 380139 */     // GIR_Coverage, 13076,
     /* 380139 */     GIR_EraseRootFromParent_Done,
     /* 380140 */   // Label 7540: @380140
     /* 380140 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(380224), // Rule ID 5944 //
     /* 380145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 380169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380175 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 380178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 380197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 380207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 380210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380222 */     GIR_RootConstrainSelectedInstOperands,
     /* 380223 */     // GIR_Coverage, 5944,
     /* 380223 */     GIR_EraseRootFromParent_Done,
     /* 380224 */   // Label 7541: @380224
     /* 380224 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(380274), // Rule ID 1298 //
     /* 380229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380259 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 380259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 380262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380272 */     GIR_RootConstrainSelectedInstOperands,
     /* 380273 */     // GIR_Coverage, 1298,
     /* 380273 */     GIR_EraseRootFromParent_Done,
     /* 380274 */   // Label 7542: @380274
     /* 380274 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(380307), // Rule ID 1288 //
     /* 380279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380294 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 380294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 380297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 380305 */     GIR_RootConstrainSelectedInstOperands,
     /* 380306 */     // GIR_Coverage, 1288,
     /* 380306 */     GIR_EraseRootFromParent_Done,
     /* 380307 */   // Label 7543: @380307
     /* 380307 */   GIM_Reject,
     /* 380308 */ // Label 7528: @380308
     /* 380308 */ GIM_Reject,
     /* 380309 */ // Label 7360: @380309
     /* 380309 */ GIM_Reject,
     /* 380310 */ // Label 103: @380310
     /* 380310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7552*/ GIMT_Encode4(380609),
     /* 380321 */ /*GILLT_s16*//*Label 7544*/ GIMT_Encode4(380361),
     /* 380325 */ /*GILLT_s32*//*Label 7545*/ GIMT_Encode4(380392),
     /* 380329 */ /*GILLT_s64*//*Label 7546*/ GIMT_Encode4(380423), GIMT_Encode4(0),
     /* 380337 */ /*GILLT_v2s32*//*Label 7547*/ GIMT_Encode4(380454),
     /* 380341 */ /*GILLT_v2s64*//*Label 7548*/ GIMT_Encode4(380485),
     /* 380345 */ /*GILLT_v4s16*//*Label 7549*/ GIMT_Encode4(380516),
     /* 380349 */ /*GILLT_v4s32*//*Label 7550*/ GIMT_Encode4(380547), GIMT_Encode4(0),
     /* 380357 */ /*GILLT_v8s16*//*Label 7551*/ GIMT_Encode4(380578),
     /* 380361 */ // Label 7544: @380361
     /* 380361 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(380391), // Rule ID 569 //
     /* 380366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380380 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 380380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 380385 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380389 */   GIR_RootConstrainSelectedInstOperands,
     /* 380390 */   // GIR_Coverage, 569,
     /* 380390 */   GIR_Done,
     /* 380391 */ // Label 7553: @380391
     /* 380391 */ GIM_Reject,
     /* 380392 */ // Label 7545: @380392
     /* 380392 */ GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(380422), // Rule ID 571 //
     /* 380397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 380403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380411 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 380411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 380416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380420 */   GIR_RootConstrainSelectedInstOperands,
     /* 380421 */   // GIR_Coverage, 571,
     /* 380421 */   GIR_Done,
     /* 380422 */ // Label 7554: @380422
     /* 380422 */ GIM_Reject,
     /* 380423 */ // Label 7546: @380423
     /* 380423 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(380453), // Rule ID 573 //
     /* 380428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 380434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380442 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 380442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 380447 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380451 */   GIR_RootConstrainSelectedInstOperands,
     /* 380452 */   // GIR_Coverage, 573,
     /* 380452 */   GIR_Done,
     /* 380453 */ // Label 7555: @380453
     /* 380453 */ GIM_Reject,
     /* 380454 */ // Label 7547: @380454
     /* 380454 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(380484), // Rule ID 952 //
     /* 380459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380473 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 380478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380482 */   GIR_RootConstrainSelectedInstOperands,
     /* 380483 */   // GIR_Coverage, 952,
     /* 380483 */   GIR_Done,
     /* 380484 */ // Label 7556: @380484
     /* 380484 */ GIM_Reject,
     /* 380485 */ // Label 7548: @380485
     /* 380485 */ GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(380515), // Rule ID 956 //
     /* 380490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380504 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 380509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380513 */   GIR_RootConstrainSelectedInstOperands,
     /* 380514 */   // GIR_Coverage, 956,
     /* 380514 */   GIR_Done,
     /* 380515 */ // Label 7557: @380515
     /* 380515 */ GIM_Reject,
     /* 380516 */ // Label 7549: @380516
     /* 380516 */ GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(380546), // Rule ID 948 //
     /* 380521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380535 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 380540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380544 */   GIR_RootConstrainSelectedInstOperands,
     /* 380545 */   // GIR_Coverage, 948,
     /* 380545 */   GIR_Done,
     /* 380546 */ // Label 7558: @380546
     /* 380546 */ GIM_Reject,
     /* 380547 */ // Label 7550: @380547
     /* 380547 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(380577), // Rule ID 954 //
     /* 380552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380566 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 380571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380575 */   GIR_RootConstrainSelectedInstOperands,
     /* 380576 */   // GIR_Coverage, 954,
     /* 380576 */   GIR_Done,
     /* 380577 */ // Label 7559: @380577
     /* 380577 */ GIM_Reject,
     /* 380578 */ // Label 7551: @380578
     /* 380578 */ GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(380608), // Rule ID 950 //
     /* 380583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380597 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 380602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380606 */   GIR_RootConstrainSelectedInstOperands,
     /* 380607 */   // GIR_Coverage, 950,
     /* 380607 */   GIR_Done,
     /* 380608 */ // Label 7560: @380608
     /* 380608 */ GIM_Reject,
     /* 380609 */ // Label 7552: @380609
     /* 380609 */ GIM_Reject,
     /* 380610 */ // Label 104: @380610
     /* 380610 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(380623), // Rule ID 6429 //
     /* 380615 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 380615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 380621 */   GIR_RootConstrainSelectedInstOperands,
     /* 380622 */   // GIR_Coverage, 6429,
     /* 380622 */   GIR_EraseRootFromParent_Done,
     /* 380623 */ // Label 7561: @380623
     /* 380623 */ GIM_Reject,
     /* 380624 */ // Label 105: @380624
     /* 380624 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(380644), // Rule ID 6430 //
     /* 380629 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 380629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380632 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 380642 */   GIR_RootConstrainSelectedInstOperands,
     /* 380643 */   // GIR_Coverage, 6430,
     /* 380643 */   GIR_EraseRootFromParent_Done,
     /* 380644 */ // Label 7562: @380644
     /* 380644 */ GIM_Reject,
     /* 380645 */ // Label 106: @380645
     /* 380645 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(380669), // Rule ID 6431 //
     /* 380650 */   // MIs[0] kind
     /* 380650 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 380653 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 380658 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 380658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380661 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 380667 */   GIR_RootConstrainSelectedInstOperands,
     /* 380668 */   // GIR_Coverage, 6431,
     /* 380668 */   GIR_EraseRootFromParent_Done,
     /* 380669 */ // Label 7563: @380669
     /* 380669 */ GIM_Reject,
     /* 380670 */ // Label 107: @380670
     /* 380670 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7567*/ GIMT_Encode4(380979),
     /* 380681 */ /*GILLT_s16*//*Label 7564*/ GIMT_Encode4(380693),
     /* 380685 */ /*GILLT_s32*//*Label 7565*/ GIMT_Encode4(380846),
     /* 380689 */ /*GILLT_s64*//*Label 7566*/ GIMT_Encode4(380951),
     /* 380693 */ // Label 7564: @380693
     /* 380693 */ GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(380794), // Rule ID 5536 //
     /* 380698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380712 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 380712 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 380715 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380719 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380724 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380728 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380746 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 380749 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380767 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380792 */   GIR_RootConstrainSelectedInstOperands,
     /* 380793 */   // GIR_Coverage, 5536,
     /* 380793 */   GIR_EraseRootFromParent_Done,
     /* 380794 */ // Label 7568: @380794
     /* 380794 */ GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(380845), // Rule ID 5537 //
     /* 380799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380813 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 380813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 380820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380829 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380843 */   GIR_RootConstrainSelectedInstOperands,
     /* 380844 */   // GIR_Coverage, 5537,
     /* 380844 */   GIR_EraseRootFromParent_Done,
     /* 380845 */ // Label 7569: @380845
     /* 380845 */ GIM_Reject,
     /* 380846 */ // Label 7565: @380846
     /* 380846 */ GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(380923), // Rule ID 5538 //
     /* 380851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380862 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 380862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 380869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380874 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380878 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380896 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380921 */   GIR_RootConstrainSelectedInstOperands,
     /* 380922 */   // GIR_Coverage, 5538,
     /* 380922 */   GIR_EraseRootFromParent_Done,
     /* 380923 */ // Label 7570: @380923
     /* 380923 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(380950), // Rule ID 5539 //
     /* 380928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380939 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380948 */   GIR_RootConstrainSelectedInstOperands,
     /* 380949 */   // GIR_Coverage, 5539,
     /* 380949 */   GIR_Done,
     /* 380950 */ // Label 7571: @380950
     /* 380950 */ GIM_Reject,
     /* 380951 */ // Label 7566: @380951
     /* 380951 */ GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(380978), // Rule ID 5540 //
     /* 380956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380967 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 380972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380976 */   GIR_RootConstrainSelectedInstOperands,
     /* 380977 */   // GIR_Coverage, 5540,
     /* 380977 */   GIR_Done,
     /* 380978 */ // Label 7572: @380978
     /* 380978 */ GIM_Reject,
     /* 380979 */ // Label 7567: @380979
     /* 380979 */ GIM_Reject,
     /* 380980 */ // Label 108: @380980
     /* 380980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7576*/ GIMT_Encode4(381150),
     /* 380991 */ /*GILLT_s16*//*Label 7573*/ GIMT_Encode4(381003),
     /* 380995 */ /*GILLT_s32*//*Label 7574*/ GIMT_Encode4(381064),
     /* 380999 */ /*GILLT_s64*//*Label 7575*/ GIMT_Encode4(381122),
     /* 381003 */ // Label 7573: @381003
     /* 381003 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(381033), // Rule ID 1935 //
     /* 381008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381022 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 381027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381031 */   GIR_RootConstrainSelectedInstOperands,
     /* 381032 */   // GIR_Coverage, 1935,
     /* 381032 */   GIR_Done,
     /* 381033 */ // Label 7577: @381033
     /* 381033 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(381063), // Rule ID 1937 //
     /* 381038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381052 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 381057 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381061 */   GIR_RootConstrainSelectedInstOperands,
     /* 381062 */   // GIR_Coverage, 1937,
     /* 381062 */   GIR_Done,
     /* 381063 */ // Label 7578: @381063
     /* 381063 */ GIM_Reject,
     /* 381064 */ // Label 7574: @381064
     /* 381064 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(381094), // Rule ID 1939 //
     /* 381069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381083 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 381088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381092 */   GIR_RootConstrainSelectedInstOperands,
     /* 381093 */   // GIR_Coverage, 1939,
     /* 381093 */   GIR_Done,
     /* 381094 */ // Label 7579: @381094
     /* 381094 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(381121), // Rule ID 5546 //
     /* 381099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381110 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 381115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381119 */   GIR_RootConstrainSelectedInstOperands,
     /* 381120 */   // GIR_Coverage, 5546,
     /* 381120 */   GIR_Done,
     /* 381121 */ // Label 7580: @381121
     /* 381121 */ GIM_Reject,
     /* 381122 */ // Label 7575: @381122
     /* 381122 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(381149), // Rule ID 5548 //
     /* 381127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381138 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 381143 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381147 */   GIR_RootConstrainSelectedInstOperands,
     /* 381148 */   // GIR_Coverage, 5548,
     /* 381148 */   GIR_Done,
     /* 381149 */ // Label 7581: @381149
     /* 381149 */ GIM_Reject,
     /* 381150 */ // Label 7576: @381150
     /* 381150 */ GIM_Reject,
     /* 381151 */ // Label 109: @381151
     /* 381151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7585*/ GIMT_Encode4(381321),
     /* 381162 */ /*GILLT_s16*//*Label 7582*/ GIMT_Encode4(381174),
     /* 381166 */ /*GILLT_s32*//*Label 7583*/ GIMT_Encode4(381235),
     /* 381170 */ /*GILLT_s64*//*Label 7584*/ GIMT_Encode4(381293),
     /* 381174 */ // Label 7582: @381174
     /* 381174 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(381204), // Rule ID 1947 //
     /* 381179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381193 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 381198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381202 */   GIR_RootConstrainSelectedInstOperands,
     /* 381203 */   // GIR_Coverage, 1947,
     /* 381203 */   GIR_Done,
     /* 381204 */ // Label 7586: @381204
     /* 381204 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(381234), // Rule ID 1949 //
     /* 381209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381223 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 381228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381232 */   GIR_RootConstrainSelectedInstOperands,
     /* 381233 */   // GIR_Coverage, 1949,
     /* 381233 */   GIR_Done,
     /* 381234 */ // Label 7587: @381234
     /* 381234 */ GIM_Reject,
     /* 381235 */ // Label 7583: @381235
     /* 381235 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(381265), // Rule ID 1951 //
     /* 381240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381254 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 381259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381263 */   GIR_RootConstrainSelectedInstOperands,
     /* 381264 */   // GIR_Coverage, 1951,
     /* 381264 */   GIR_Done,
     /* 381265 */ // Label 7588: @381265
     /* 381265 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(381292), // Rule ID 5554 //
     /* 381270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381281 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 381286 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381290 */   GIR_RootConstrainSelectedInstOperands,
     /* 381291 */   // GIR_Coverage, 5554,
     /* 381291 */   GIR_Done,
     /* 381292 */ // Label 7589: @381292
     /* 381292 */ GIM_Reject,
     /* 381293 */ // Label 7584: @381293
     /* 381293 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(381320), // Rule ID 5556 //
     /* 381298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381309 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 381314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381318 */   GIR_RootConstrainSelectedInstOperands,
     /* 381319 */   // GIR_Coverage, 5556,
     /* 381319 */   GIR_Done,
     /* 381320 */ // Label 7590: @381320
     /* 381320 */ GIM_Reject,
     /* 381321 */ // Label 7585: @381321
     /* 381321 */ GIM_Reject,
     /* 381322 */ // Label 110: @381322
     /* 381322 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7594*/ GIMT_Encode4(381492),
     /* 381333 */ /*GILLT_s16*//*Label 7591*/ GIMT_Encode4(381345),
     /* 381337 */ /*GILLT_s32*//*Label 7592*/ GIMT_Encode4(381406),
     /* 381341 */ /*GILLT_s64*//*Label 7593*/ GIMT_Encode4(381464),
     /* 381345 */ // Label 7591: @381345
     /* 381345 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(381375), // Rule ID 1941 //
     /* 381350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381364 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 381369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381373 */   GIR_RootConstrainSelectedInstOperands,
     /* 381374 */   // GIR_Coverage, 1941,
     /* 381374 */   GIR_Done,
     /* 381375 */ // Label 7595: @381375
     /* 381375 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(381405), // Rule ID 1943 //
     /* 381380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381394 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 381399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381403 */   GIR_RootConstrainSelectedInstOperands,
     /* 381404 */   // GIR_Coverage, 1943,
     /* 381404 */   GIR_Done,
     /* 381405 */ // Label 7596: @381405
     /* 381405 */ GIM_Reject,
     /* 381406 */ // Label 7592: @381406
     /* 381406 */ GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(381436), // Rule ID 1945 //
     /* 381411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381425 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 381430 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381434 */   GIR_RootConstrainSelectedInstOperands,
     /* 381435 */   // GIR_Coverage, 1945,
     /* 381435 */   GIR_Done,
     /* 381436 */ // Label 7597: @381436
     /* 381436 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(381463), // Rule ID 5550 //
     /* 381441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381452 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 381457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381461 */   GIR_RootConstrainSelectedInstOperands,
     /* 381462 */   // GIR_Coverage, 5550,
     /* 381462 */   GIR_Done,
     /* 381463 */ // Label 7598: @381463
     /* 381463 */ GIM_Reject,
     /* 381464 */ // Label 7593: @381464
     /* 381464 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(381491), // Rule ID 5552 //
     /* 381469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381480 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 381485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381489 */   GIR_RootConstrainSelectedInstOperands,
     /* 381490 */   // GIR_Coverage, 5552,
     /* 381490 */   GIR_Done,
     /* 381491 */ // Label 7599: @381491
     /* 381491 */ GIM_Reject,
     /* 381492 */ // Label 7594: @381492
     /* 381492 */ GIM_Reject,
     /* 381493 */ // Label 111: @381493
     /* 381493 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7603*/ GIMT_Encode4(381663),
     /* 381504 */ /*GILLT_s16*//*Label 7600*/ GIMT_Encode4(381516),
     /* 381508 */ /*GILLT_s32*//*Label 7601*/ GIMT_Encode4(381577),
     /* 381512 */ /*GILLT_s64*//*Label 7602*/ GIMT_Encode4(381635),
     /* 381516 */ // Label 7600: @381516
     /* 381516 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(381546), // Rule ID 1953 //
     /* 381521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381535 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 381540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381544 */   GIR_RootConstrainSelectedInstOperands,
     /* 381545 */   // GIR_Coverage, 1953,
     /* 381545 */   GIR_Done,
     /* 381546 */ // Label 7604: @381546
     /* 381546 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(381576), // Rule ID 1955 //
     /* 381551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381565 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 381570 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381574 */   GIR_RootConstrainSelectedInstOperands,
     /* 381575 */   // GIR_Coverage, 1955,
     /* 381575 */   GIR_Done,
     /* 381576 */ // Label 7605: @381576
     /* 381576 */ GIM_Reject,
     /* 381577 */ // Label 7601: @381577
     /* 381577 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(381607), // Rule ID 1957 //
     /* 381582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381596 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 381601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381605 */   GIR_RootConstrainSelectedInstOperands,
     /* 381606 */   // GIR_Coverage, 1957,
     /* 381606 */   GIR_Done,
     /* 381607 */ // Label 7606: @381607
     /* 381607 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(381634), // Rule ID 5558 //
     /* 381612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381623 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 381628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381632 */   GIR_RootConstrainSelectedInstOperands,
     /* 381633 */   // GIR_Coverage, 5558,
     /* 381633 */   GIR_Done,
     /* 381634 */ // Label 7607: @381634
     /* 381634 */ GIM_Reject,
     /* 381635 */ // Label 7602: @381635
     /* 381635 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(381662), // Rule ID 5560 //
     /* 381640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381651 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 381656 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381660 */   GIR_RootConstrainSelectedInstOperands,
     /* 381661 */   // GIR_Coverage, 5560,
     /* 381661 */   GIR_Done,
     /* 381662 */ // Label 7608: @381662
     /* 381662 */ GIM_Reject,
     /* 381663 */ // Label 7603: @381663
     /* 381663 */ GIM_Reject,
     /* 381664 */ // Label 112: @381664
     /* 381664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7613*/ GIMT_Encode4(382792),
     /* 381675 */ /*GILLT_s8*//*Label 7609*/ GIMT_Encode4(381691),
     /* 381679 */ /*GILLT_s16*//*Label 7610*/ GIMT_Encode4(381738),
     /* 381683 */ /*GILLT_s32*//*Label 7611*/ GIMT_Encode4(382153),
     /* 381687 */ /*GILLT_s64*//*Label 7612*/ GIMT_Encode4(382606),
     /* 381691 */ // Label 7609: @381691
     /* 381691 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(381714), // Rule ID 5805 //
     /* 381696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381707 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 381707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 381712 */   GIR_RootConstrainSelectedInstOperands,
     /* 381713 */   // GIR_Coverage, 5805,
     /* 381713 */   GIR_Done,
     /* 381714 */ // Label 7614: @381714
     /* 381714 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(381737), // Rule ID 5806 //
     /* 381719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381730 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 381730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 381735 */   GIR_RootConstrainSelectedInstOperands,
     /* 381736 */   // GIR_Coverage, 5806,
     /* 381736 */   GIR_Done,
     /* 381737 */ // Label 7615: @381737
     /* 381737 */ GIM_Reject,
     /* 381738 */ // Label 7610: @381738
     /* 381738 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(381788), // Rule ID 5752 //
     /* 381743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381758 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381761 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381770 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381777 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 381780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381786 */   GIR_RootConstrainSelectedInstOperands,
     /* 381787 */   // GIR_Coverage, 5752,
     /* 381787 */   GIR_EraseRootFromParent_Done,
     /* 381788 */ // Label 7616: @381788
     /* 381788 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(381838), // Rule ID 5754 //
     /* 381793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381808 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381811 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381816 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381820 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381827 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 381830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381832 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381836 */   GIR_RootConstrainSelectedInstOperands,
     /* 381837 */   // GIR_Coverage, 5754,
     /* 381837 */   GIR_EraseRootFromParent_Done,
     /* 381838 */ // Label 7617: @381838
     /* 381838 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(381888), // Rule ID 5762 //
     /* 381843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381858 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381861 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381870 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381877 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381886 */   GIR_RootConstrainSelectedInstOperands,
     /* 381887 */   // GIR_Coverage, 5762,
     /* 381887 */   GIR_EraseRootFromParent_Done,
     /* 381888 */ // Label 7618: @381888
     /* 381888 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(381938), // Rule ID 5764 //
     /* 381893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381908 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381911 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381916 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381920 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381927 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 381930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381932 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381936 */   GIR_RootConstrainSelectedInstOperands,
     /* 381937 */   // GIR_Coverage, 5764,
     /* 381937 */   GIR_EraseRootFromParent_Done,
     /* 381938 */ // Label 7619: @381938
     /* 381938 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(381980), // Rule ID 5761 //
     /* 381943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381958 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381962 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381969 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381974 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381978 */   GIR_RootConstrainSelectedInstOperands,
     /* 381979 */   // GIR_Coverage, 5761,
     /* 381979 */   GIR_EraseRootFromParent_Done,
     /* 381980 */ // Label 7620: @381980
     /* 381980 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(382022), // Rule ID 5763 //
     /* 381985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382000 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382004 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382011 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 382011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 382014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382016 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382020 */   GIR_RootConstrainSelectedInstOperands,
     /* 382021 */   // GIR_Coverage, 5763,
     /* 382021 */   GIR_EraseRootFromParent_Done,
     /* 382022 */ // Label 7621: @382022
     /* 382022 */ GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(382064), // Rule ID 5751 //
     /* 382027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382042 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382053 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 382053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 382056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382062 */   GIR_RootConstrainSelectedInstOperands,
     /* 382063 */   // GIR_Coverage, 5751,
     /* 382063 */   GIR_EraseRootFromParent_Done,
     /* 382064 */ // Label 7622: @382064
     /* 382064 */ GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(382106), // Rule ID 5753 //
     /* 382069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382095 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 382095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 382098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382100 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382104 */   GIR_RootConstrainSelectedInstOperands,
     /* 382105 */   // GIR_Coverage, 5753,
     /* 382105 */   GIR_EraseRootFromParent_Done,
     /* 382106 */ // Label 7623: @382106
     /* 382106 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(382129), // Rule ID 5807 //
     /* 382111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382122 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 382122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 382127 */   GIR_RootConstrainSelectedInstOperands,
     /* 382128 */   // GIR_Coverage, 5807,
     /* 382128 */   GIR_Done,
     /* 382129 */ // Label 7624: @382129
     /* 382129 */ GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(382152), // Rule ID 5808 //
     /* 382134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382145 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 382145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 382150 */   GIR_RootConstrainSelectedInstOperands,
     /* 382151 */   // GIR_Coverage, 5808,
     /* 382151 */   GIR_Done,
     /* 382152 */ // Label 7625: @382152
     /* 382152 */ GIM_Reject,
     /* 382153 */ // Label 7611: @382153
     /* 382153 */ GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(382203), // Rule ID 5756 //
     /* 382158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382173 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382176 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 382181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 382185 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382192 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 382195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382197 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382201 */   GIR_RootConstrainSelectedInstOperands,
     /* 382202 */   // GIR_Coverage, 5756,
     /* 382202 */   GIR_EraseRootFromParent_Done,
     /* 382203 */ // Label 7626: @382203
     /* 382203 */ GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(382253), // Rule ID 5758 //
     /* 382208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382215 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382219 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382223 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382226 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 382231 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 382235 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382242 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 382245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382247 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382251 */   GIR_RootConstrainSelectedInstOperands,
     /* 382252 */   // GIR_Coverage, 5758,
     /* 382252 */   GIR_EraseRootFromParent_Done,
     /* 382253 */ // Label 7627: @382253
     /* 382253 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(382303), // Rule ID 5766 //
     /* 382258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382273 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382276 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 382281 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 382285 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382290 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382292 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 382295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382297 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382301 */   GIR_RootConstrainSelectedInstOperands,
     /* 382302 */   // GIR_Coverage, 5766,
     /* 382302 */   GIR_EraseRootFromParent_Done,
     /* 382303 */ // Label 7628: @382303
     /* 382303 */ GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(382353), // Rule ID 5768 //
     /* 382308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382323 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382326 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 382331 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 382335 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382340 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382342 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 382345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382347 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382351 */   GIR_RootConstrainSelectedInstOperands,
     /* 382352 */   // GIR_Coverage, 5768,
     /* 382352 */   GIR_EraseRootFromParent_Done,
     /* 382353 */ // Label 7629: @382353
     /* 382353 */ GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(382395), // Rule ID 5765 //
     /* 382358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382373 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382377 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382384 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 382387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382389 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382393 */   GIR_RootConstrainSelectedInstOperands,
     /* 382394 */   // GIR_Coverage, 5765,
     /* 382394 */   GIR_EraseRootFromParent_Done,
     /* 382395 */ // Label 7630: @382395
     /* 382395 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(382437), // Rule ID 5767 //
     /* 382400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382415 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382419 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382426 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 382429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382431 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382435 */   GIR_RootConstrainSelectedInstOperands,
     /* 382436 */   // GIR_Coverage, 5767,
     /* 382436 */   GIR_EraseRootFromParent_Done,
     /* 382437 */ // Label 7631: @382437
     /* 382437 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(382479), // Rule ID 5755 //
     /* 382442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382457 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382461 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382466 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382468 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 382471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382473 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382477 */   GIR_RootConstrainSelectedInstOperands,
     /* 382478 */   // GIR_Coverage, 5755,
     /* 382478 */   GIR_EraseRootFromParent_Done,
     /* 382479 */ // Label 7632: @382479
     /* 382479 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(382521), // Rule ID 5757 //
     /* 382484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382510 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 382513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382515 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382519 */   GIR_RootConstrainSelectedInstOperands,
     /* 382520 */   // GIR_Coverage, 5757,
     /* 382520 */   GIR_EraseRootFromParent_Done,
     /* 382521 */ // Label 7633: @382521
     /* 382521 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(382582), // Rule ID 5809 //
     /* 382526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382537 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 382544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382553 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382564 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382581 */   // GIR_Coverage, 5809,
     /* 382581 */   GIR_EraseRootFromParent_Done,
     /* 382582 */ // Label 7634: @382582
     /* 382582 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(382605), // Rule ID 5810 //
     /* 382587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382598 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 382603 */   GIR_RootConstrainSelectedInstOperands,
     /* 382604 */   // GIR_Coverage, 5810,
     /* 382604 */   GIR_Done,
     /* 382605 */ // Label 7635: @382605
     /* 382605 */ GIM_Reject,
     /* 382606 */ // Label 7612: @382606
     /* 382606 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(382791),
     /* 382611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382618 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(382661), // Rule ID 5760 //
     /* 382623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382631 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382634 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 382639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382650 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382659 */     GIR_RootConstrainSelectedInstOperands,
     /* 382660 */     // GIR_Coverage, 5760,
     /* 382660 */     GIR_EraseRootFromParent_Done,
     /* 382661 */   // Label 7637: @382661
     /* 382661 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(382704), // Rule ID 5770 //
     /* 382666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382674 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382677 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 382682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382693 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382702 */     GIR_RootConstrainSelectedInstOperands,
     /* 382703 */     // GIR_Coverage, 5770,
     /* 382703 */     GIR_EraseRootFromParent_Done,
     /* 382704 */   // Label 7638: @382704
     /* 382704 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(382739), // Rule ID 5769 //
     /* 382709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382728 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382737 */     GIR_RootConstrainSelectedInstOperands,
     /* 382738 */     // GIR_Coverage, 5769,
     /* 382738 */     GIR_EraseRootFromParent_Done,
     /* 382739 */   // Label 7639: @382739
     /* 382739 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(382774), // Rule ID 5759 //
     /* 382744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382763 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382772 */     GIR_RootConstrainSelectedInstOperands,
     /* 382773 */     // GIR_Coverage, 5759,
     /* 382773 */     GIR_EraseRootFromParent_Done,
     /* 382774 */   // Label 7640: @382774
     /* 382774 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(382790), // Rule ID 5811 //
     /* 382779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382783 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 382783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 382788 */     GIR_RootConstrainSelectedInstOperands,
     /* 382789 */     // GIR_Coverage, 5811,
     /* 382789 */     GIR_Done,
     /* 382790 */   // Label 7641: @382790
     /* 382790 */   GIM_Reject,
     /* 382791 */ // Label 7636: @382791
     /* 382791 */ GIM_Reject,
     /* 382792 */ // Label 7613: @382792
     /* 382792 */ GIM_Reject,
     /* 382793 */ // Label 113: @382793
     /* 382793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7645*/ GIMT_Encode4(382995),
     /* 382804 */ /*GILLT_s8*//*Label 7642*/ GIMT_Encode4(382816),
     /* 382808 */ /*GILLT_s16*//*Label 7643*/ GIMT_Encode4(382863),
     /* 382812 */ /*GILLT_s32*//*Label 7644*/ GIMT_Encode4(382910),
     /* 382816 */ // Label 7642: @382816
     /* 382816 */ GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(382839), // Rule ID 5902 //
     /* 382821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382832 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 382837 */   GIR_RootConstrainSelectedInstOperands,
     /* 382838 */   // GIR_Coverage, 5902,
     /* 382838 */   GIR_Done,
     /* 382839 */ // Label 7646: @382839
     /* 382839 */ GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(382862), // Rule ID 5903 //
     /* 382844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382855 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 382860 */   GIR_RootConstrainSelectedInstOperands,
     /* 382861 */   // GIR_Coverage, 5903,
     /* 382861 */   GIR_Done,
     /* 382862 */ // Label 7647: @382862
     /* 382862 */ GIM_Reject,
     /* 382863 */ // Label 7643: @382863
     /* 382863 */ GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(382886), // Rule ID 5904 //
     /* 382868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382879 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 382884 */   GIR_RootConstrainSelectedInstOperands,
     /* 382885 */   // GIR_Coverage, 5904,
     /* 382885 */   GIR_Done,
     /* 382886 */ // Label 7648: @382886
     /* 382886 */ GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(382909), // Rule ID 5905 //
     /* 382891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382902 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 382907 */   GIR_RootConstrainSelectedInstOperands,
     /* 382908 */   // GIR_Coverage, 5905,
     /* 382908 */   GIR_Done,
     /* 382909 */ // Label 7649: @382909
     /* 382909 */ GIM_Reject,
     /* 382910 */ // Label 7644: @382910
     /* 382910 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(382933), // Rule ID 5906 //
     /* 382915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382926 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 382931 */   GIR_RootConstrainSelectedInstOperands,
     /* 382932 */   // GIR_Coverage, 5906,
     /* 382932 */   GIR_Done,
     /* 382933 */ // Label 7650: @382933
     /* 382933 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(382994), // Rule ID 5907 //
     /* 382938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382949 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 382956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382961 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382965 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382976 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382993 */   // GIR_Coverage, 5907,
     /* 382993 */   GIR_EraseRootFromParent_Done,
     /* 382994 */ // Label 7651: @382994
     /* 382994 */ GIM_Reject,
     /* 382995 */ // Label 7645: @382995
     /* 382995 */ GIM_Reject,
     /* 382996 */ // Label 114: @382996
     /* 382996 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7655*/ GIMT_Encode4(383198),
     /* 383007 */ /*GILLT_s8*//*Label 7652*/ GIMT_Encode4(383019),
     /* 383011 */ /*GILLT_s16*//*Label 7653*/ GIMT_Encode4(383066),
     /* 383015 */ /*GILLT_s32*//*Label 7654*/ GIMT_Encode4(383113),
     /* 383019 */ // Label 7652: @383019
     /* 383019 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(383042), // Rule ID 5896 //
     /* 383024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383035 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 383035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 383040 */   GIR_RootConstrainSelectedInstOperands,
     /* 383041 */   // GIR_Coverage, 5896,
     /* 383041 */   GIR_Done,
     /* 383042 */ // Label 7656: @383042
     /* 383042 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(383065), // Rule ID 5897 //
     /* 383047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383058 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 383058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 383063 */   GIR_RootConstrainSelectedInstOperands,
     /* 383064 */   // GIR_Coverage, 5897,
     /* 383064 */   GIR_Done,
     /* 383065 */ // Label 7657: @383065
     /* 383065 */ GIM_Reject,
     /* 383066 */ // Label 7653: @383066
     /* 383066 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(383089), // Rule ID 5898 //
     /* 383071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383082 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 383082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 383087 */   GIR_RootConstrainSelectedInstOperands,
     /* 383088 */   // GIR_Coverage, 5898,
     /* 383088 */   GIR_Done,
     /* 383089 */ // Label 7658: @383089
     /* 383089 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(383112), // Rule ID 5899 //
     /* 383094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383105 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 383105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 383110 */   GIR_RootConstrainSelectedInstOperands,
     /* 383111 */   // GIR_Coverage, 5899,
     /* 383111 */   GIR_Done,
     /* 383112 */ // Label 7659: @383112
     /* 383112 */ GIM_Reject,
     /* 383113 */ // Label 7654: @383113
     /* 383113 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(383136), // Rule ID 5900 //
     /* 383118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383129 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 383129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 383134 */   GIR_RootConstrainSelectedInstOperands,
     /* 383135 */   // GIR_Coverage, 5900,
     /* 383135 */   GIR_Done,
     /* 383136 */ // Label 7660: @383136
     /* 383136 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(383197), // Rule ID 5901 //
     /* 383141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383152 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 383152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 383159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383168 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383179 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 383186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383196 */   // GIR_Coverage, 5901,
     /* 383196 */   GIR_EraseRootFromParent_Done,
     /* 383197 */ // Label 7661: @383197
     /* 383197 */ GIM_Reject,
     /* 383198 */ // Label 7655: @383198
     /* 383198 */ GIM_Reject,
     /* 383199 */ // Label 115: @383199
     /* 383199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7665*/ GIMT_Encode4(383401),
     /* 383210 */ /*GILLT_s8*//*Label 7662*/ GIMT_Encode4(383222),
     /* 383214 */ /*GILLT_s16*//*Label 7663*/ GIMT_Encode4(383269),
     /* 383218 */ /*GILLT_s32*//*Label 7664*/ GIMT_Encode4(383316),
     /* 383222 */ // Label 7662: @383222
     /* 383222 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(383245), // Rule ID 5890 //
     /* 383227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383238 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 383238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 383243 */   GIR_RootConstrainSelectedInstOperands,
     /* 383244 */   // GIR_Coverage, 5890,
     /* 383244 */   GIR_Done,
     /* 383245 */ // Label 7666: @383245
     /* 383245 */ GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383268), // Rule ID 5891 //
     /* 383250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383261 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 383261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 383266 */   GIR_RootConstrainSelectedInstOperands,
     /* 383267 */   // GIR_Coverage, 5891,
     /* 383267 */   GIR_Done,
     /* 383268 */ // Label 7667: @383268
     /* 383268 */ GIM_Reject,
     /* 383269 */ // Label 7663: @383269
     /* 383269 */ GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383292), // Rule ID 5892 //
     /* 383274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383285 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 383285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 383290 */   GIR_RootConstrainSelectedInstOperands,
     /* 383291 */   // GIR_Coverage, 5892,
     /* 383291 */   GIR_Done,
     /* 383292 */ // Label 7668: @383292
     /* 383292 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383315), // Rule ID 5893 //
     /* 383297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383308 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 383308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 383313 */   GIR_RootConstrainSelectedInstOperands,
     /* 383314 */   // GIR_Coverage, 5893,
     /* 383314 */   GIR_Done,
     /* 383315 */ // Label 7669: @383315
     /* 383315 */ GIM_Reject,
     /* 383316 */ // Label 7664: @383316
     /* 383316 */ GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383339), // Rule ID 5894 //
     /* 383321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383332 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 383332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 383337 */   GIR_RootConstrainSelectedInstOperands,
     /* 383338 */   // GIR_Coverage, 5894,
     /* 383338 */   GIR_Done,
     /* 383339 */ // Label 7670: @383339
     /* 383339 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(383400), // Rule ID 5895 //
     /* 383344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383355 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 383355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 383362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383371 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383382 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 383389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383399 */   // GIR_Coverage, 5895,
     /* 383399 */   GIR_EraseRootFromParent_Done,
     /* 383400 */ // Label 7671: @383400
     /* 383400 */ GIM_Reject,
     /* 383401 */ // Label 7665: @383401
     /* 383401 */ GIM_Reject,
     /* 383402 */ // Label 116: @383402
     /* 383402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7675*/ GIMT_Encode4(383604),
     /* 383413 */ /*GILLT_s8*//*Label 7672*/ GIMT_Encode4(383425),
     /* 383417 */ /*GILLT_s16*//*Label 7673*/ GIMT_Encode4(383472),
     /* 383421 */ /*GILLT_s32*//*Label 7674*/ GIMT_Encode4(383519),
     /* 383425 */ // Label 7672: @383425
     /* 383425 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(383448), // Rule ID 5884 //
     /* 383430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383441 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 383441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 383446 */   GIR_RootConstrainSelectedInstOperands,
     /* 383447 */   // GIR_Coverage, 5884,
     /* 383447 */   GIR_Done,
     /* 383448 */ // Label 7676: @383448
     /* 383448 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383471), // Rule ID 5885 //
     /* 383453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383464 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 383464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 383469 */   GIR_RootConstrainSelectedInstOperands,
     /* 383470 */   // GIR_Coverage, 5885,
     /* 383470 */   GIR_Done,
     /* 383471 */ // Label 7677: @383471
     /* 383471 */ GIM_Reject,
     /* 383472 */ // Label 7673: @383472
     /* 383472 */ GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(383495), // Rule ID 5886 //
     /* 383477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383488 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 383488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 383493 */   GIR_RootConstrainSelectedInstOperands,
     /* 383494 */   // GIR_Coverage, 5886,
     /* 383494 */   GIR_Done,
     /* 383495 */ // Label 7678: @383495
     /* 383495 */ GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(383518), // Rule ID 5887 //
     /* 383500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383511 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 383511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 383516 */   GIR_RootConstrainSelectedInstOperands,
     /* 383517 */   // GIR_Coverage, 5887,
     /* 383517 */   GIR_Done,
     /* 383518 */ // Label 7679: @383518
     /* 383518 */ GIM_Reject,
     /* 383519 */ // Label 7674: @383519
     /* 383519 */ GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(383542), // Rule ID 5888 //
     /* 383524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383535 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 383535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 383540 */   GIR_RootConstrainSelectedInstOperands,
     /* 383541 */   // GIR_Coverage, 5888,
     /* 383541 */   GIR_Done,
     /* 383542 */ // Label 7680: @383542
     /* 383542 */ GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(383603), // Rule ID 5889 //
     /* 383547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383558 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 383558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 383565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383574 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383585 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 383592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383602 */   // GIR_Coverage, 5889,
     /* 383602 */   GIR_EraseRootFromParent_Done,
     /* 383603 */ // Label 7681: @383603
     /* 383603 */ GIM_Reject,
     /* 383604 */ // Label 7675: @383604
     /* 383604 */ GIM_Reject,
     /* 383605 */ // Label 117: @383605
     /* 383605 */ GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(383744),
     /* 383610 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 383613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 383617 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(383651), // Rule ID 257 //
     /* 383622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 383629 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 383629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 383632 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383649 */     GIR_RootConstrainSelectedInstOperands,
     /* 383650 */     // GIR_Coverage, 257,
     /* 383650 */     GIR_EraseRootFromParent_Done,
     /* 383651 */   // Label 7683: @383651
     /* 383651 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(383685), // Rule ID 258 //
     /* 383656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 383663 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 383663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 383666 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383683 */     GIR_RootConstrainSelectedInstOperands,
     /* 383684 */     // GIR_Coverage, 258,
     /* 383684 */     GIR_EraseRootFromParent_Done,
     /* 383685 */   // Label 7684: @383685
     /* 383685 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(383714), // Rule ID 273 //
     /* 383690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 383697 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 383697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 383700 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383712 */     GIR_RootConstrainSelectedInstOperands,
     /* 383713 */     // GIR_Coverage, 273,
     /* 383713 */     GIR_EraseRootFromParent_Done,
     /* 383714 */   // Label 7685: @383714
     /* 383714 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(383743), // Rule ID 294 //
     /* 383719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 383726 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 383726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 383729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383741 */     GIR_RootConstrainSelectedInstOperands,
     /* 383742 */     // GIR_Coverage, 294,
     /* 383742 */     GIR_EraseRootFromParent_Done,
     /* 383743 */   // Label 7686: @383743
     /* 383743 */   GIM_Reject,
     /* 383744 */ // Label 7682: @383744
     /* 383744 */ GIM_Reject,
     /* 383745 */ // Label 118: @383745
     /* 383745 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7699*/ GIMT_Encode4(384284),
     /* 383756 */ /*GILLT_s64*//*Label 7687*/ GIMT_Encode4(383840), GIMT_Encode4(0),
     /* 383764 */ /*GILLT_v2s32*//*Label 7688*/ GIMT_Encode4(383878),
     /* 383768 */ /*GILLT_v2s64*//*Label 7689*/ GIMT_Encode4(383916),
     /* 383772 */ /*GILLT_v4s16*//*Label 7690*/ GIMT_Encode4(383954),
     /* 383776 */ /*GILLT_v4s32*//*Label 7691*/ GIMT_Encode4(383992),
     /* 383780 */ /*GILLT_v8s8*//*Label 7692*/ GIMT_Encode4(384030),
     /* 383784 */ /*GILLT_v8s16*//*Label 7693*/ GIMT_Encode4(384068),
     /* 383788 */ /*GILLT_v16s8*//*Label 7694*/ GIMT_Encode4(384106), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383808 */ /*GILLT_nxv2s64*//*Label 7695*/ GIMT_Encode4(384144), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383820 */ /*GILLT_nxv4s32*//*Label 7696*/ GIMT_Encode4(384179), GIMT_Encode4(0),
     /* 383828 */ /*GILLT_nxv8s16*//*Label 7697*/ GIMT_Encode4(384214), GIMT_Encode4(0),
     /* 383836 */ /*GILLT_nxv16s8*//*Label 7698*/ GIMT_Encode4(384249),
     /* 383840 */ // Label 7687: @383840
     /* 383840 */ GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(383877), // Rule ID 5006 //
     /* 383845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 383848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 383851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383870 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 383870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383875 */   GIR_RootConstrainSelectedInstOperands,
     /* 383876 */   // GIR_Coverage, 5006,
     /* 383876 */   GIR_Done,
     /* 383877 */ // Label 7700: @383877
     /* 383877 */ GIM_Reject,
     /* 383878 */ // Label 7688: @383878
     /* 383878 */ GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(383915), // Rule ID 5005 //
     /* 383883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 383889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 383892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383908 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 383908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383913 */   GIR_RootConstrainSelectedInstOperands,
     /* 383914 */   // GIR_Coverage, 5005,
     /* 383914 */   GIR_Done,
     /* 383915 */ // Label 7701: @383915
     /* 383915 */ GIM_Reject,
     /* 383916 */ // Label 7689: @383916
     /* 383916 */ GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(383953), // Rule ID 5010 //
     /* 383921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 383927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 383930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383946 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 383946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383951 */   GIR_RootConstrainSelectedInstOperands,
     /* 383952 */   // GIR_Coverage, 5010,
     /* 383952 */   GIR_Done,
     /* 383953 */ // Label 7702: @383953
     /* 383953 */ GIM_Reject,
     /* 383954 */ // Label 7690: @383954
     /* 383954 */ GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(383991), // Rule ID 5004 //
     /* 383959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 383965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 383968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383984 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 383984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383989 */   GIR_RootConstrainSelectedInstOperands,
     /* 383990 */   // GIR_Coverage, 5004,
     /* 383990 */   GIR_Done,
     /* 383991 */ // Label 7703: @383991
     /* 383991 */ GIM_Reject,
     /* 383992 */ // Label 7691: @383992
     /* 383992 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(384029), // Rule ID 5009 //
     /* 383997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 384003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 384006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384022 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 384022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 384027 */   GIR_RootConstrainSelectedInstOperands,
     /* 384028 */   // GIR_Coverage, 5009,
     /* 384028 */   GIR_Done,
     /* 384029 */ // Label 7704: @384029
     /* 384029 */ GIM_Reject,
     /* 384030 */ // Label 7692: @384030
     /* 384030 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(384067), // Rule ID 5003 //
     /* 384035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 384038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 384041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 384044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384060 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 384060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 384065 */   GIR_RootConstrainSelectedInstOperands,
     /* 384066 */   // GIR_Coverage, 5003,
     /* 384066 */   GIR_Done,
     /* 384067 */ // Label 7705: @384067
     /* 384067 */ GIM_Reject,
     /* 384068 */ // Label 7693: @384068
     /* 384068 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(384105), // Rule ID 5008 //
     /* 384073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 384076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 384079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 384082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384094 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384098 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 384098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 384103 */   GIR_RootConstrainSelectedInstOperands,
     /* 384104 */   // GIR_Coverage, 5008,
     /* 384104 */   GIR_Done,
     /* 384105 */ // Label 7706: @384105
     /* 384105 */ GIM_Reject,
     /* 384106 */ // Label 7694: @384106
     /* 384106 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(384143), // Rule ID 5007 //
     /* 384111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 384114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 384117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 384120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384136 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 384136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 384141 */   GIR_RootConstrainSelectedInstOperands,
     /* 384142 */   // GIR_Coverage, 5007,
     /* 384142 */   GIR_Done,
     /* 384143 */ // Label 7707: @384143
     /* 384143 */ GIM_Reject,
     /* 384144 */ // Label 7695: @384144
     /* 384144 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(384178), // Rule ID 11708 //
     /* 384149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 384152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 384155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 384158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 384161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384165 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 384165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 384168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 384170 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 384172 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 384174 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 384176 */   GIR_RootConstrainSelectedInstOperands,
     /* 384177 */   // GIR_Coverage, 11708,
     /* 384177 */   GIR_EraseRootFromParent_Done,
     /* 384178 */ // Label 7708: @384178
     /* 384178 */ GIM_Reject,
     /* 384179 */ // Label 7696: @384179
     /* 384179 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384213), // Rule ID 11706 //
     /* 384184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 384187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 384190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 384193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 384196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384200 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 384200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 384203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 384205 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 384207 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 384209 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 384211 */   GIR_RootConstrainSelectedInstOperands,
     /* 384212 */   // GIR_Coverage, 11706,
     /* 384212 */   GIR_EraseRootFromParent_Done,
     /* 384213 */ // Label 7709: @384213
     /* 384213 */ GIM_Reject,
     /* 384214 */ // Label 7697: @384214
     /* 384214 */ GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384248), // Rule ID 11704 //
     /* 384219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 384222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 384225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 384228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 384231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384235 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 384235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 384238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 384240 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 384242 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 384244 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 384246 */   GIR_RootConstrainSelectedInstOperands,
     /* 384247 */   // GIR_Coverage, 11704,
     /* 384247 */   GIR_EraseRootFromParent_Done,
     /* 384248 */ // Label 7710: @384248
     /* 384248 */ GIM_Reject,
     /* 384249 */ // Label 7698: @384249
     /* 384249 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384283), // Rule ID 11702 //
     /* 384254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 384257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 384260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 384263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 384266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384270 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 384270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 384273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 384275 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 384277 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 384279 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 384281 */   GIR_RootConstrainSelectedInstOperands,
     /* 384282 */   // GIR_Coverage, 11702,
     /* 384282 */   GIR_EraseRootFromParent_Done,
     /* 384283 */ // Label 7711: @384283
     /* 384283 */ GIM_Reject,
     /* 384284 */ // Label 7699: @384284
     /* 384284 */ GIM_Reject,
     /* 384285 */ // Label 119: @384285
     /* 384285 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7720*/ GIMT_Encode4(386107),
     /* 384296 */ /*GILLT_s64*//*Label 7712*/ GIMT_Encode4(384332), GIMT_Encode4(0),
     /* 384304 */ /*GILLT_v2s32*//*Label 7713*/ GIMT_Encode4(384527),
     /* 384308 */ /*GILLT_v2s64*//*Label 7714*/ GIMT_Encode4(384774),
     /* 384312 */ /*GILLT_v4s16*//*Label 7715*/ GIMT_Encode4(385021),
     /* 384316 */ /*GILLT_v4s32*//*Label 7716*/ GIMT_Encode4(385297),
     /* 384320 */ /*GILLT_v8s8*//*Label 7717*/ GIMT_Encode4(385544),
     /* 384324 */ /*GILLT_v8s16*//*Label 7718*/ GIMT_Encode4(385689),
     /* 384328 */ /*GILLT_v16s8*//*Label 7719*/ GIMT_Encode4(385965),
     /* 384332 */ // Label 7712: @384332
     /* 384332 */ GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(384526),
     /* 384337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 384340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384344 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(384391), // Rule ID 6327 //
     /* 384349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384364 */     // MIs[1] Rn
     /* 384364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384375 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 384378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384389 */     GIR_RootConstrainSelectedInstOperands,
     /* 384390 */     // GIR_Coverage, 6327,
     /* 384390 */     GIR_EraseRootFromParent_Done,
     /* 384391 */   // Label 7722: @384391
     /* 384391 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(384438), // Rule ID 6338 //
     /* 384396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384411 */     // MIs[1] Rn
     /* 384411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384422 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 384425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384436 */     GIR_RootConstrainSelectedInstOperands,
     /* 384437 */     // GIR_Coverage, 6338,
     /* 384437 */     GIR_EraseRootFromParent_Done,
     /* 384438 */   // Label 7723: @384438
     /* 384438 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(384485), // Rule ID 12947 //
     /* 384443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384458 */     // MIs[1] Rn
     /* 384458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384469 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 384472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384483 */     GIR_RootConstrainSelectedInstOperands,
     /* 384484 */     // GIR_Coverage, 12947,
     /* 384484 */     GIR_EraseRootFromParent_Done,
     /* 384485 */   // Label 7724: @384485
     /* 384485 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(384505), // Rule ID 5562 //
     /* 384490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384494 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 384494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384504 */     // GIR_Coverage, 5562,
     /* 384504 */     GIR_Done,
     /* 384505 */   // Label 7725: @384505
     /* 384505 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(384525), // Rule ID 5563 //
     /* 384510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384514 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 384514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384524 */     // GIR_Coverage, 5563,
     /* 384524 */     GIR_Done,
     /* 384525 */   // Label 7726: @384525
     /* 384525 */   GIM_Reject,
     /* 384526 */ // Label 7721: @384526
     /* 384526 */ GIM_Reject,
     /* 384527 */ // Label 7713: @384527
     /* 384527 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(384773),
     /* 384532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384539 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(384586), // Rule ID 6324 //
     /* 384544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384559 */     // MIs[1] Rn
     /* 384559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384570 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384584 */     GIR_RootConstrainSelectedInstOperands,
     /* 384585 */     // GIR_Coverage, 6324,
     /* 384585 */     GIR_EraseRootFromParent_Done,
     /* 384586 */   // Label 7728: @384586
     /* 384586 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(384633), // Rule ID 6335 //
     /* 384591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384606 */     // MIs[1] Rn
     /* 384606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384617 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384631 */     GIR_RootConstrainSelectedInstOperands,
     /* 384632 */     // GIR_Coverage, 6335,
     /* 384632 */     GIR_EraseRootFromParent_Done,
     /* 384633 */   // Label 7729: @384633
     /* 384633 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(384680), // Rule ID 12944 //
     /* 384638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384653 */     // MIs[1] Rn
     /* 384653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384664 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384678 */     GIR_RootConstrainSelectedInstOperands,
     /* 384679 */     // GIR_Coverage, 12944,
     /* 384679 */     GIR_EraseRootFromParent_Done,
     /* 384680 */   // Label 7730: @384680
     /* 384680 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(384699), // Rule ID 1909 //
     /* 384685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384692 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 384692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 384697 */     GIR_RootConstrainSelectedInstOperands,
     /* 384698 */     // GIR_Coverage, 1909,
     /* 384698 */     GIR_Done,
     /* 384699 */   // Label 7731: @384699
     /* 384699 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(384772), // Rule ID 5564 //
     /* 384704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384708 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 384744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 384762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384770 */     GIR_RootConstrainSelectedInstOperands,
     /* 384771 */     // GIR_Coverage, 5564,
     /* 384771 */     GIR_EraseRootFromParent_Done,
     /* 384772 */   // Label 7732: @384772
     /* 384772 */   GIM_Reject,
     /* 384773 */ // Label 7727: @384773
     /* 384773 */ GIM_Reject,
     /* 384774 */ // Label 7714: @384774
     /* 384774 */ GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(385020),
     /* 384779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 384782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384786 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(384833), // Rule ID 6326 //
     /* 384791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384806 */     // MIs[1] Rn
     /* 384806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384817 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384831 */     GIR_RootConstrainSelectedInstOperands,
     /* 384832 */     // GIR_Coverage, 6326,
     /* 384832 */     GIR_EraseRootFromParent_Done,
     /* 384833 */   // Label 7734: @384833
     /* 384833 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(384880), // Rule ID 6337 //
     /* 384838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384853 */     // MIs[1] Rn
     /* 384853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384864 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384878 */     GIR_RootConstrainSelectedInstOperands,
     /* 384879 */     // GIR_Coverage, 6337,
     /* 384879 */     GIR_EraseRootFromParent_Done,
     /* 384880 */   // Label 7735: @384880
     /* 384880 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(384927), // Rule ID 12946 //
     /* 384885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384900 */     // MIs[1] Rn
     /* 384900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384911 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384925 */     GIR_RootConstrainSelectedInstOperands,
     /* 384926 */     // GIR_Coverage, 12946,
     /* 384926 */     GIR_EraseRootFromParent_Done,
     /* 384927 */   // Label 7736: @384927
     /* 384927 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(384946), // Rule ID 1911 //
     /* 384932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384939 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 384939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 384944 */     GIR_RootConstrainSelectedInstOperands,
     /* 384945 */     // GIR_Coverage, 1911,
     /* 384945 */     GIR_Done,
     /* 384946 */   // Label 7737: @384946
     /* 384946 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(385019), // Rule ID 5566 //
     /* 384951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384955 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384988 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 384991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 385009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385017 */     GIR_RootConstrainSelectedInstOperands,
     /* 385018 */     // GIR_Coverage, 5566,
     /* 385018 */     GIR_EraseRootFromParent_Done,
     /* 385019 */   // Label 7738: @385019
     /* 385019 */   GIM_Reject,
     /* 385020 */ // Label 7733: @385020
     /* 385020 */ GIM_Reject,
     /* 385021 */ // Label 7715: @385021
     /* 385021 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(385082), // Rule ID 6322 //
     /* 385026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385041 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385044 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385048 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385055 */   // MIs[1] Rn
     /* 385055 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385066 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 385069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385071 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385080 */   GIR_RootConstrainSelectedInstOperands,
     /* 385081 */   // GIR_Coverage, 6322,
     /* 385081 */   GIR_EraseRootFromParent_Done,
     /* 385082 */ // Label 7739: @385082
     /* 385082 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(385136), // Rule ID 6339 //
     /* 385087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385102 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385105 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385109 */   // MIs[1] Rn
     /* 385109 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385113 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385118 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385120 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 385123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385125 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385134 */   GIR_RootConstrainSelectedInstOperands,
     /* 385135 */   // GIR_Coverage, 6339,
     /* 385135 */   GIR_EraseRootFromParent_Done,
     /* 385136 */ // Label 7740: @385136
     /* 385136 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(385190), // Rule ID 12942 //
     /* 385141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385163 */   // MIs[1] Rn
     /* 385163 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385172 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385174 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 385177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385179 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385188 */   GIR_RootConstrainSelectedInstOperands,
     /* 385189 */   // GIR_Coverage, 12942,
     /* 385189 */   GIR_EraseRootFromParent_Done,
     /* 385190 */ // Label 7741: @385190
     /* 385190 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(385216), // Rule ID 1907 //
     /* 385195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385209 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 385209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 385214 */   GIR_RootConstrainSelectedInstOperands,
     /* 385215 */   // GIR_Coverage, 1907,
     /* 385215 */   GIR_Done,
     /* 385216 */ // Label 7742: @385216
     /* 385216 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(385296), // Rule ID 5567 //
     /* 385221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385232 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385232 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 385235 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385239 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 385249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385258 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385265 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 385268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 385286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385294 */   GIR_RootConstrainSelectedInstOperands,
     /* 385295 */   // GIR_Coverage, 5567,
     /* 385295 */   GIR_EraseRootFromParent_Done,
     /* 385296 */ // Label 7743: @385296
     /* 385296 */ GIM_Reject,
     /* 385297 */ // Label 7716: @385297
     /* 385297 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(385543),
     /* 385302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385309 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(385356), // Rule ID 6325 //
     /* 385314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385329 */     // MIs[1] Rn
     /* 385329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385340 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 385343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385354 */     GIR_RootConstrainSelectedInstOperands,
     /* 385355 */     // GIR_Coverage, 6325,
     /* 385355 */     GIR_EraseRootFromParent_Done,
     /* 385356 */   // Label 7745: @385356
     /* 385356 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(385403), // Rule ID 6336 //
     /* 385361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385376 */     // MIs[1] Rn
     /* 385376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385387 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 385390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385401 */     GIR_RootConstrainSelectedInstOperands,
     /* 385402 */     // GIR_Coverage, 6336,
     /* 385402 */     GIR_EraseRootFromParent_Done,
     /* 385403 */   // Label 7746: @385403
     /* 385403 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(385450), // Rule ID 12945 //
     /* 385408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385423 */     // MIs[1] Rn
     /* 385423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385434 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 385437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385448 */     GIR_RootConstrainSelectedInstOperands,
     /* 385449 */     // GIR_Coverage, 12945,
     /* 385449 */     GIR_EraseRootFromParent_Done,
     /* 385450 */   // Label 7747: @385450
     /* 385450 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(385469), // Rule ID 1910 //
     /* 385455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385462 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 385462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 385467 */     GIR_RootConstrainSelectedInstOperands,
     /* 385468 */     // GIR_Coverage, 1910,
     /* 385468 */     GIR_Done,
     /* 385469 */   // Label 7748: @385469
     /* 385469 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(385542), // Rule ID 5565 //
     /* 385474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385478 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 385481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 385495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 385532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385540 */     GIR_RootConstrainSelectedInstOperands,
     /* 385541 */     // GIR_Coverage, 5565,
     /* 385541 */     GIR_EraseRootFromParent_Done,
     /* 385542 */   // Label 7749: @385542
     /* 385542 */   GIM_Reject,
     /* 385543 */ // Label 7744: @385543
     /* 385543 */ GIM_Reject,
     /* 385544 */ // Label 7717: @385544
     /* 385544 */ GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(385601), // Rule ID 12940 //
     /* 385549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 385552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385564 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385571 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 385575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385577 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385584 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385599 */   GIR_RootConstrainSelectedInstOperands,
     /* 385600 */   // GIR_Coverage, 12940,
     /* 385600 */   GIR_EraseRootFromParent_Done,
     /* 385601 */ // Label 7750: @385601
     /* 385601 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(385662), // Rule ID 6320 //
     /* 385606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385621 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385624 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385628 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385635 */   // MIs[1] Rn
     /* 385635 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385646 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385651 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385660 */   GIR_RootConstrainSelectedInstOperands,
     /* 385661 */   // GIR_Coverage, 6320,
     /* 385661 */   GIR_EraseRootFromParent_Done,
     /* 385662 */ // Label 7751: @385662
     /* 385662 */ GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(385688), // Rule ID 1905 //
     /* 385667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385681 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 385681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 385686 */   GIR_RootConstrainSelectedInstOperands,
     /* 385687 */   // GIR_Coverage, 1905,
     /* 385687 */   GIR_Done,
     /* 385688 */ // Label 7752: @385688
     /* 385688 */ GIM_Reject,
     /* 385689 */ // Label 7718: @385689
     /* 385689 */ GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(385750), // Rule ID 6323 //
     /* 385694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385709 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385712 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385716 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385723 */   // MIs[1] Rn
     /* 385723 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385727 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385734 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385748 */   GIR_RootConstrainSelectedInstOperands,
     /* 385749 */   // GIR_Coverage, 6323,
     /* 385749 */   GIR_EraseRootFromParent_Done,
     /* 385750 */ // Label 7753: @385750
     /* 385750 */ GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(385804), // Rule ID 6340 //
     /* 385755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385770 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385777 */   // MIs[1] Rn
     /* 385777 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385781 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385788 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385793 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385802 */   GIR_RootConstrainSelectedInstOperands,
     /* 385803 */   // GIR_Coverage, 6340,
     /* 385803 */   GIR_EraseRootFromParent_Done,
     /* 385804 */ // Label 7754: @385804
     /* 385804 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(385858), // Rule ID 12943 //
     /* 385809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385824 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385831 */   // MIs[1] Rn
     /* 385831 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385842 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385847 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385856 */   GIR_RootConstrainSelectedInstOperands,
     /* 385857 */   // GIR_Coverage, 12943,
     /* 385857 */   GIR_EraseRootFromParent_Done,
     /* 385858 */ // Label 7755: @385858
     /* 385858 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(385884), // Rule ID 1908 //
     /* 385863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385877 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 385877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 385882 */   GIR_RootConstrainSelectedInstOperands,
     /* 385883 */   // GIR_Coverage, 1908,
     /* 385883 */   GIR_Done,
     /* 385884 */ // Label 7756: @385884
     /* 385884 */ GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(385964), // Rule ID 5568 //
     /* 385889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385900 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 385903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 385917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385926 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385933 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 385936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385941 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385962 */   GIR_RootConstrainSelectedInstOperands,
     /* 385963 */   // GIR_Coverage, 5568,
     /* 385963 */   GIR_EraseRootFromParent_Done,
     /* 385964 */ // Label 7757: @385964
     /* 385964 */ GIM_Reject,
     /* 385965 */ // Label 7719: @385965
     /* 385965 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(386026), // Rule ID 6321 //
     /* 385970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385985 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385988 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385992 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385999 */   // MIs[1] Rn
     /* 385999 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386003 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386010 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 386013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386024 */   GIR_RootConstrainSelectedInstOperands,
     /* 386025 */   // GIR_Coverage, 6321,
     /* 386025 */   GIR_EraseRootFromParent_Done,
     /* 386026 */ // Label 7758: @386026
     /* 386026 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(386080), // Rule ID 12941 //
     /* 386031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 386034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386046 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386049 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386053 */   // MIs[1] Rn
     /* 386053 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386057 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386062 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386064 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 386067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386069 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386078 */   GIR_RootConstrainSelectedInstOperands,
     /* 386079 */   // GIR_Coverage, 12941,
     /* 386079 */   GIR_EraseRootFromParent_Done,
     /* 386080 */ // Label 7759: @386080
     /* 386080 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(386106), // Rule ID 1906 //
     /* 386085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 386091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386099 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 386099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 386104 */   GIR_RootConstrainSelectedInstOperands,
     /* 386105 */   // GIR_Coverage, 1906,
     /* 386105 */   GIR_Done,
     /* 386106 */ // Label 7760: @386106
     /* 386106 */ GIM_Reject,
     /* 386107 */ // Label 7720: @386107
     /* 386107 */ GIM_Reject,
     /* 386108 */ // Label 120: @386108
     /* 386108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7763*/ GIMT_Encode4(386362),
     /* 386119 */ /*GILLT_v4s16*//*Label 7761*/ GIMT_Encode4(386135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386131 */ /*GILLT_v8s16*//*Label 7762*/ GIMT_Encode4(386221),
     /* 386135 */ // Label 7761: @386135
     /* 386135 */ GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(386220),
     /* 386140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386154 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(386188), // Rule ID 1915 //
     /* 386159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386174 */     // MIs[1] Operand 1
     /* 386174 */     // No operand predicates
     /* 386174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386176 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 386179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386186 */     GIR_RootConstrainSelectedInstOperands,
     /* 386187 */     // GIR_Coverage, 1915,
     /* 386187 */     GIR_EraseRootFromParent_Done,
     /* 386188 */   // Label 7765: @386188
     /* 386188 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(386219), // Rule ID 5569 //
     /* 386193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386205 */     // MIs[1] Operand 1
     /* 386205 */     // No operand predicates
     /* 386205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386207 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 386207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 386210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386217 */     GIR_RootConstrainSelectedInstOperands,
     /* 386218 */     // GIR_Coverage, 5569,
     /* 386218 */     GIR_EraseRootFromParent_Done,
     /* 386219 */   // Label 7766: @386219
     /* 386219 */   GIM_Reject,
     /* 386220 */ // Label 7764: @386220
     /* 386220 */ GIM_Reject,
     /* 386221 */ // Label 7762: @386221
     /* 386221 */ GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(386361),
     /* 386226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386236 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(386287), // Rule ID 6331 //
     /* 386241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386256 */     // MIs[1] Rn
     /* 386256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386271 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 386274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386285 */     GIR_RootConstrainSelectedInstOperands,
     /* 386286 */     // GIR_Coverage, 6331,
     /* 386286 */     GIR_EraseRootFromParent_Done,
     /* 386287 */   // Label 7768: @386287
     /* 386287 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(386325), // Rule ID 1916 //
     /* 386292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386311 */     // MIs[1] Operand 1
     /* 386311 */     // No operand predicates
     /* 386311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386313 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 386316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386323 */     GIR_RootConstrainSelectedInstOperands,
     /* 386324 */     // GIR_Coverage, 1916,
     /* 386324 */     GIR_EraseRootFromParent_Done,
     /* 386325 */   // Label 7769: @386325
     /* 386325 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(386360), // Rule ID 5570 //
     /* 386330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386346 */     // MIs[1] Operand 1
     /* 386346 */     // No operand predicates
     /* 386346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386348 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 386348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 386351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386358 */     GIR_RootConstrainSelectedInstOperands,
     /* 386359 */     // GIR_Coverage, 5570,
     /* 386359 */     GIR_EraseRootFromParent_Done,
     /* 386360 */   // Label 7770: @386360
     /* 386360 */   GIM_Reject,
     /* 386361 */ // Label 7767: @386361
     /* 386361 */ GIM_Reject,
     /* 386362 */ // Label 7763: @386362
     /* 386362 */ GIM_Reject,
     /* 386363 */ // Label 121: @386363
     /* 386363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7773*/ GIMT_Encode4(386617),
     /* 386374 */ /*GILLT_v2s32*//*Label 7771*/ GIMT_Encode4(386390), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386386 */ /*GILLT_v4s32*//*Label 7772*/ GIMT_Encode4(386476),
     /* 386390 */ // Label 7771: @386390
     /* 386390 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(386475),
     /* 386395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386409 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(386443), // Rule ID 1913 //
     /* 386414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386429 */     // MIs[1] Operand 1
     /* 386429 */     // No operand predicates
     /* 386429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386431 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 386434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386441 */     GIR_RootConstrainSelectedInstOperands,
     /* 386442 */     // GIR_Coverage, 1913,
     /* 386442 */     GIR_EraseRootFromParent_Done,
     /* 386443 */   // Label 7775: @386443
     /* 386443 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(386474), // Rule ID 5571 //
     /* 386448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386460 */     // MIs[1] Operand 1
     /* 386460 */     // No operand predicates
     /* 386460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386462 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 386465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386472 */     GIR_RootConstrainSelectedInstOperands,
     /* 386473 */     // GIR_Coverage, 5571,
     /* 386473 */     GIR_EraseRootFromParent_Done,
     /* 386474 */   // Label 7776: @386474
     /* 386474 */   GIM_Reject,
     /* 386475 */ // Label 7774: @386475
     /* 386475 */ GIM_Reject,
     /* 386476 */ // Label 7772: @386476
     /* 386476 */ GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(386616),
     /* 386481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386491 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(386542), // Rule ID 6333 //
     /* 386496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386511 */     // MIs[1] Rn
     /* 386511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386526 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 386529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386540 */     GIR_RootConstrainSelectedInstOperands,
     /* 386541 */     // GIR_Coverage, 6333,
     /* 386541 */     GIR_EraseRootFromParent_Done,
     /* 386542 */   // Label 7778: @386542
     /* 386542 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(386580), // Rule ID 1914 //
     /* 386547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386566 */     // MIs[1] Operand 1
     /* 386566 */     // No operand predicates
     /* 386566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386568 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386578 */     GIR_RootConstrainSelectedInstOperands,
     /* 386579 */     // GIR_Coverage, 1914,
     /* 386579 */     GIR_EraseRootFromParent_Done,
     /* 386580 */   // Label 7779: @386580
     /* 386580 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(386615), // Rule ID 5572 //
     /* 386585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386601 */     // MIs[1] Operand 1
     /* 386601 */     // No operand predicates
     /* 386601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386603 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386613 */     GIR_RootConstrainSelectedInstOperands,
     /* 386614 */     // GIR_Coverage, 5572,
     /* 386614 */     GIR_EraseRootFromParent_Done,
     /* 386615 */   // Label 7780: @386615
     /* 386615 */   GIM_Reject,
     /* 386616 */ // Label 7777: @386616
     /* 386616 */ GIM_Reject,
     /* 386617 */ // Label 7773: @386617
     /* 386617 */ GIM_Reject,
     /* 386618 */ // Label 122: @386618
     /* 386618 */ GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(386763),
     /* 386623 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 386626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386636 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(386687), // Rule ID 6334 //
     /* 386641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386656 */     // MIs[1] Rn
     /* 386656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386671 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 386674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386685 */     GIR_RootConstrainSelectedInstOperands,
     /* 386686 */     // GIR_Coverage, 6334,
     /* 386686 */     GIR_EraseRootFromParent_Done,
     /* 386687 */   // Label 7782: @386687
     /* 386687 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(386762),
     /* 386692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386696 */     GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(386730), // Rule ID 1912 //
     /* 386701 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386704 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386708 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386712 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386716 */       // MIs[1] Operand 1
     /* 386716 */       // No operand predicates
     /* 386716 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386718 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386718 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386721 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386723 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386725 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386728 */       GIR_RootConstrainSelectedInstOperands,
     /* 386729 */       // GIR_Coverage, 1912,
     /* 386729 */       GIR_EraseRootFromParent_Done,
     /* 386730 */     // Label 7784: @386730
     /* 386730 */     GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(386761), // Rule ID 5573 //
     /* 386735 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386739 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386743 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386747 */       // MIs[1] Operand 1
     /* 386747 */       // No operand predicates
     /* 386747 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386749 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 386749 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386752 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386754 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386756 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386759 */       GIR_RootConstrainSelectedInstOperands,
     /* 386760 */       // GIR_Coverage, 5573,
     /* 386760 */       GIR_EraseRootFromParent_Done,
     /* 386761 */     // Label 7785: @386761
     /* 386761 */     GIM_Reject,
     /* 386762 */   // Label 7783: @386762
     /* 386762 */   GIM_Reject,
     /* 386763 */ // Label 7781: @386763
     /* 386763 */ GIM_Reject,
     /* 386764 */ // Label 123: @386764
     /* 386764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7788*/ GIMT_Encode4(386942),
     /* 386775 */ /*GILLT_v8s8*//*Label 7786*/ GIMT_Encode4(386787), GIMT_Encode4(0),
     /* 386783 */ /*GILLT_v16s8*//*Label 7787*/ GIMT_Encode4(386836),
     /* 386787 */ // Label 7786: @386787
     /* 386787 */ GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(386835), // Rule ID 1917 //
     /* 386792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386817 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386821 */   // MIs[1] Operand 1
     /* 386821 */   // No operand predicates
     /* 386821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386823 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 386826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386828 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386830 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386833 */   GIR_RootConstrainSelectedInstOperands,
     /* 386834 */   // GIR_Coverage, 1917,
     /* 386834 */   GIR_EraseRootFromParent_Done,
     /* 386835 */ // Label 7789: @386835
     /* 386835 */ GIM_Reject,
     /* 386836 */ // Label 7787: @386836
     /* 386836 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(386941),
     /* 386841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386851 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(386902), // Rule ID 6329 //
     /* 386856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386871 */     // MIs[1] Rn
     /* 386871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386886 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 386889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386900 */     GIR_RootConstrainSelectedInstOperands,
     /* 386901 */     // GIR_Coverage, 6329,
     /* 386901 */     GIR_EraseRootFromParent_Done,
     /* 386902 */   // Label 7791: @386902
     /* 386902 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(386940), // Rule ID 1918 //
     /* 386907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386926 */     // MIs[1] Operand 1
     /* 386926 */     // No operand predicates
     /* 386926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386928 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 386931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386938 */     GIR_RootConstrainSelectedInstOperands,
     /* 386939 */     // GIR_Coverage, 1918,
     /* 386939 */     GIR_EraseRootFromParent_Done,
     /* 386940 */   // Label 7792: @386940
     /* 386940 */   GIM_Reject,
     /* 386941 */ // Label 7790: @386941
     /* 386941 */ GIM_Reject,
     /* 386942 */ // Label 7788: @386942
     /* 386942 */ GIM_Reject,
     /* 386943 */ // Label 124: @386943
     /* 386943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7802*/ GIMT_Encode4(388592),
     /* 386954 */ /*GILLT_s64*//*Label 7793*/ GIMT_Encode4(387038), GIMT_Encode4(0),
     /* 386962 */ /*GILLT_v2s32*//*Label 7794*/ GIMT_Encode4(387359),
     /* 386966 */ /*GILLT_v2s64*//*Label 7795*/ GIMT_Encode4(387680),
     /* 386970 */ /*GILLT_v4s16*//*Label 7796*/ GIMT_Encode4(387763),
     /* 386974 */ /*GILLT_v4s32*//*Label 7797*/ GIMT_Encode4(388084),
     /* 386978 */ /*GILLT_v8s8*//*Label 7798*/ GIMT_Encode4(388167),
     /* 386982 */ /*GILLT_v8s16*//*Label 7799*/ GIMT_Encode4(388376),
     /* 386986 */ /*GILLT_v16s8*//*Label 7800*/ GIMT_Encode4(388459), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 387034 */ /*GILLT_nxv16s8*//*Label 7801*/ GIMT_Encode4(388545),
     /* 387038 */ // Label 7793: @387038
     /* 387038 */ GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(387358),
     /* 387043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 387046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387053 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(387168), // Rule ID 5396 //
     /* 387058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387075 */     // MIs[1] Operand 2
     /* 387075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387094 */     // MIs[2] Rn
     /* 387094 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387099 */     // MIs[2] Operand 2
     /* 387099 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 387110 */     // MIs[0] imm
     /* 387110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387118 */     // MIs[3] Operand 1
     /* 387118 */     // No operand predicates
     /* 387118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387120 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387150 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387167 */     // GIR_Coverage, 5396,
     /* 387167 */     GIR_EraseRootFromParent_Done,
     /* 387168 */   // Label 7804: @387168
     /* 387168 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(387283), // Rule ID 5401 //
     /* 387173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387190 */     // MIs[1] Operand 2
     /* 387190 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387209 */     // MIs[2] Rn
     /* 387209 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387214 */     // MIs[2] Operand 2
     /* 387214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 387225 */     // MIs[0] imm
     /* 387225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387233 */     // MIs[3] Operand 1
     /* 387233 */     // No operand predicates
     /* 387233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387235 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387265 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387282 */     // GIR_Coverage, 5401,
     /* 387282 */     GIR_EraseRootFromParent_Done,
     /* 387283 */   // Label 7805: @387283
     /* 387283 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(387320), // Rule ID 5393 //
     /* 387288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387296 */     // MIs[0] imm
     /* 387296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387304 */     // MIs[1] Operand 1
     /* 387304 */     // No operand predicates
     /* 387304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387306 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387318 */     GIR_RootConstrainSelectedInstOperands,
     /* 387319 */     // GIR_Coverage, 5393,
     /* 387319 */     GIR_EraseRootFromParent_Done,
     /* 387320 */   // Label 7806: @387320
     /* 387320 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(387357), // Rule ID 5398 //
     /* 387325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387333 */     // MIs[0] imm
     /* 387333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387341 */     // MIs[1] Operand 1
     /* 387341 */     // No operand predicates
     /* 387341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387343 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387355 */     GIR_RootConstrainSelectedInstOperands,
     /* 387356 */     // GIR_Coverage, 5398,
     /* 387356 */     GIR_EraseRootFromParent_Done,
     /* 387357 */   // Label 7807: @387357
     /* 387357 */   GIM_Reject,
     /* 387358 */ // Label 7803: @387358
     /* 387358 */ GIM_Reject,
     /* 387359 */ // Label 7794: @387359
     /* 387359 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(387679),
     /* 387364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 387370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387374 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(387489), // Rule ID 5386 //
     /* 387379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387396 */     // MIs[1] Operand 2
     /* 387396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387415 */     // MIs[2] Rn
     /* 387415 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387420 */     // MIs[2] Operand 2
     /* 387420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 387431 */     // MIs[0] imm
     /* 387431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387439 */     // MIs[3] Operand 1
     /* 387439 */     // No operand predicates
     /* 387439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387441 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387471 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387488 */     // GIR_Coverage, 5386,
     /* 387488 */     GIR_EraseRootFromParent_Done,
     /* 387489 */   // Label 7809: @387489
     /* 387489 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(387604), // Rule ID 5391 //
     /* 387494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387511 */     // MIs[1] Operand 2
     /* 387511 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387530 */     // MIs[2] Rn
     /* 387530 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387535 */     // MIs[2] Operand 2
     /* 387535 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 387546 */     // MIs[0] imm
     /* 387546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387554 */     // MIs[3] Operand 1
     /* 387554 */     // No operand predicates
     /* 387554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387556 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387586 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387603 */     // GIR_Coverage, 5391,
     /* 387603 */     GIR_EraseRootFromParent_Done,
     /* 387604 */   // Label 7810: @387604
     /* 387604 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(387641), // Rule ID 5383 //
     /* 387609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387617 */     // MIs[0] imm
     /* 387617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387625 */     // MIs[1] Operand 1
     /* 387625 */     // No operand predicates
     /* 387625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387627 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387639 */     GIR_RootConstrainSelectedInstOperands,
     /* 387640 */     // GIR_Coverage, 5383,
     /* 387640 */     GIR_EraseRootFromParent_Done,
     /* 387641 */   // Label 7811: @387641
     /* 387641 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(387678), // Rule ID 5388 //
     /* 387646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387654 */     // MIs[0] imm
     /* 387654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387662 */     // MIs[1] Operand 1
     /* 387662 */     // No operand predicates
     /* 387662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387664 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387676 */     GIR_RootConstrainSelectedInstOperands,
     /* 387677 */     // GIR_Coverage, 5388,
     /* 387677 */     GIR_EraseRootFromParent_Done,
     /* 387678 */   // Label 7812: @387678
     /* 387678 */   GIM_Reject,
     /* 387679 */ // Label 7808: @387679
     /* 387679 */ GIM_Reject,
     /* 387680 */ // Label 7795: @387680
     /* 387680 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(387762),
     /* 387685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 387691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387703 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(387732), // Rule ID 5394 //
     /* 387708 */     // MIs[0] imm
     /* 387708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387716 */     // MIs[1] Operand 1
     /* 387716 */     // No operand predicates
     /* 387716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387718 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387730 */     GIR_RootConstrainSelectedInstOperands,
     /* 387731 */     // GIR_Coverage, 5394,
     /* 387731 */     GIR_EraseRootFromParent_Done,
     /* 387732 */   // Label 7814: @387732
     /* 387732 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(387761), // Rule ID 5399 //
     /* 387737 */     // MIs[0] imm
     /* 387737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387745 */     // MIs[1] Operand 1
     /* 387745 */     // No operand predicates
     /* 387745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387747 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387759 */     GIR_RootConstrainSelectedInstOperands,
     /* 387760 */     // GIR_Coverage, 5399,
     /* 387760 */     GIR_EraseRootFromParent_Done,
     /* 387761 */   // Label 7815: @387761
     /* 387761 */   GIM_Reject,
     /* 387762 */ // Label 7813: @387762
     /* 387762 */ GIM_Reject,
     /* 387763 */ // Label 7796: @387763
     /* 387763 */ GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(388083),
     /* 387768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 387774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387778 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(387893), // Rule ID 5376 //
     /* 387783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387800 */     // MIs[1] Operand 2
     /* 387800 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387819 */     // MIs[2] Rn
     /* 387819 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387824 */     // MIs[2] Operand 2
     /* 387824 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387835 */     // MIs[0] imm
     /* 387835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387843 */     // MIs[3] Operand 1
     /* 387843 */     // No operand predicates
     /* 387843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387845 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387875 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387892 */     // GIR_Coverage, 5376,
     /* 387892 */     GIR_EraseRootFromParent_Done,
     /* 387893 */   // Label 7817: @387893
     /* 387893 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(388008), // Rule ID 5381 //
     /* 387898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387915 */     // MIs[1] Operand 2
     /* 387915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387934 */     // MIs[2] Rn
     /* 387934 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387939 */     // MIs[2] Operand 2
     /* 387939 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387950 */     // MIs[0] imm
     /* 387950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387958 */     // MIs[3] Operand 1
     /* 387958 */     // No operand predicates
     /* 387958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387960 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387990 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388007 */     // GIR_Coverage, 5381,
     /* 388007 */     GIR_EraseRootFromParent_Done,
     /* 388008 */   // Label 7818: @388008
     /* 388008 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(388045), // Rule ID 5373 //
     /* 388013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388021 */     // MIs[0] imm
     /* 388021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388029 */     // MIs[1] Operand 1
     /* 388029 */     // No operand predicates
     /* 388029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388031 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 388034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388043 */     GIR_RootConstrainSelectedInstOperands,
     /* 388044 */     // GIR_Coverage, 5373,
     /* 388044 */     GIR_EraseRootFromParent_Done,
     /* 388045 */   // Label 7819: @388045
     /* 388045 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(388082), // Rule ID 5378 //
     /* 388050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388058 */     // MIs[0] imm
     /* 388058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388066 */     // MIs[1] Operand 1
     /* 388066 */     // No operand predicates
     /* 388066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388068 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 388071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388080 */     GIR_RootConstrainSelectedInstOperands,
     /* 388081 */     // GIR_Coverage, 5378,
     /* 388081 */     GIR_EraseRootFromParent_Done,
     /* 388082 */   // Label 7820: @388082
     /* 388082 */   GIM_Reject,
     /* 388083 */ // Label 7816: @388083
     /* 388083 */ GIM_Reject,
     /* 388084 */ // Label 7797: @388084
     /* 388084 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(388166),
     /* 388089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388107 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(388136), // Rule ID 5384 //
     /* 388112 */     // MIs[0] imm
     /* 388112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388120 */     // MIs[1] Operand 1
     /* 388120 */     // No operand predicates
     /* 388120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388122 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388134 */     GIR_RootConstrainSelectedInstOperands,
     /* 388135 */     // GIR_Coverage, 5384,
     /* 388135 */     GIR_EraseRootFromParent_Done,
     /* 388136 */   // Label 7822: @388136
     /* 388136 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(388165), // Rule ID 5389 //
     /* 388141 */     // MIs[0] imm
     /* 388141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388149 */     // MIs[1] Operand 1
     /* 388149 */     // No operand predicates
     /* 388149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388151 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388163 */     GIR_RootConstrainSelectedInstOperands,
     /* 388164 */     // GIR_Coverage, 5389,
     /* 388164 */     GIR_EraseRootFromParent_Done,
     /* 388165 */   // Label 7823: @388165
     /* 388165 */   GIM_Reject,
     /* 388166 */ // Label 7821: @388166
     /* 388166 */ GIM_Reject,
     /* 388167 */ // Label 7798: @388167
     /* 388167 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(388375),
     /* 388172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 388175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 388178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388182 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(388297), // Rule ID 5371 //
     /* 388187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 388195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388204 */     // MIs[1] Operand 2
     /* 388204 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 388215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 388223 */     // MIs[2] Rn
     /* 388223 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388228 */     // MIs[2] Operand 2
     /* 388228 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 388239 */     // MIs[0] imm
     /* 388239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 388243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388247 */     // MIs[3] Operand 1
     /* 388247 */     // No operand predicates
     /* 388247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388249 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 388249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 388272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388279 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 388286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388296 */     // GIR_Coverage, 5371,
     /* 388296 */     GIR_EraseRootFromParent_Done,
     /* 388297 */   // Label 7825: @388297
     /* 388297 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(388337), // Rule ID 1861 //
     /* 388302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388313 */     // MIs[0] imm
     /* 388313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388321 */     // MIs[1] Operand 1
     /* 388321 */     // No operand predicates
     /* 388321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388323 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 388326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388335 */     GIR_RootConstrainSelectedInstOperands,
     /* 388336 */     // GIR_Coverage, 1861,
     /* 388336 */     GIR_EraseRootFromParent_Done,
     /* 388337 */   // Label 7826: @388337
     /* 388337 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(388374), // Rule ID 5368 //
     /* 388342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388350 */     // MIs[0] imm
     /* 388350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388358 */     // MIs[1] Operand 1
     /* 388358 */     // No operand predicates
     /* 388358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388360 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 388363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388372 */     GIR_RootConstrainSelectedInstOperands,
     /* 388373 */     // GIR_Coverage, 5368,
     /* 388373 */     GIR_EraseRootFromParent_Done,
     /* 388374 */   // Label 7827: @388374
     /* 388374 */   GIM_Reject,
     /* 388375 */ // Label 7824: @388375
     /* 388375 */ GIM_Reject,
     /* 388376 */ // Label 7799: @388376
     /* 388376 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(388458),
     /* 388381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388399 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(388428), // Rule ID 5374 //
     /* 388404 */     // MIs[0] imm
     /* 388404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388412 */     // MIs[1] Operand 1
     /* 388412 */     // No operand predicates
     /* 388412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388414 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388426 */     GIR_RootConstrainSelectedInstOperands,
     /* 388427 */     // GIR_Coverage, 5374,
     /* 388427 */     GIR_EraseRootFromParent_Done,
     /* 388428 */   // Label 7829: @388428
     /* 388428 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(388457), // Rule ID 5379 //
     /* 388433 */     // MIs[0] imm
     /* 388433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388441 */     // MIs[1] Operand 1
     /* 388441 */     // No operand predicates
     /* 388441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388443 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388455 */     GIR_RootConstrainSelectedInstOperands,
     /* 388456 */     // GIR_Coverage, 5379,
     /* 388456 */     GIR_EraseRootFromParent_Done,
     /* 388457 */   // Label 7830: @388457
     /* 388457 */   GIM_Reject,
     /* 388458 */ // Label 7828: @388458
     /* 388458 */ GIM_Reject,
     /* 388459 */ // Label 7800: @388459
     /* 388459 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(388544),
     /* 388464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 388470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388482 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(388514), // Rule ID 1862 //
     /* 388487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388490 */     // MIs[0] imm
     /* 388490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388498 */     // MIs[1] Operand 1
     /* 388498 */     // No operand predicates
     /* 388498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388500 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388512 */     GIR_RootConstrainSelectedInstOperands,
     /* 388513 */     // GIR_Coverage, 1862,
     /* 388513 */     GIR_EraseRootFromParent_Done,
     /* 388514 */   // Label 7832: @388514
     /* 388514 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(388543), // Rule ID 5369 //
     /* 388519 */     // MIs[0] imm
     /* 388519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388527 */     // MIs[1] Operand 1
     /* 388527 */     // No operand predicates
     /* 388527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388529 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388541 */     GIR_RootConstrainSelectedInstOperands,
     /* 388542 */     // GIR_Coverage, 5369,
     /* 388542 */     GIR_EraseRootFromParent_Done,
     /* 388543 */   // Label 7833: @388543
     /* 388543 */   GIM_Reject,
     /* 388544 */ // Label 7831: @388544
     /* 388544 */ GIM_Reject,
     /* 388545 */ // Label 7801: @388545
     /* 388545 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(388591), // Rule ID 2719 //
     /* 388550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 388559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388563 */   // MIs[0] Op3
     /* 388563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388571 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 388575 */   // MIs[1] Operand 1
     /* 388575 */   // No operand predicates
     /* 388575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388577 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 388577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 388580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 388582 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 388584 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 388586 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 388589 */   GIR_RootConstrainSelectedInstOperands,
     /* 388590 */   // GIR_Coverage, 2719,
     /* 388590 */   GIR_EraseRootFromParent_Done,
     /* 388591 */ // Label 7834: @388591
     /* 388591 */ GIM_Reject,
     /* 388592 */ // Label 7802: @388592
     /* 388592 */ GIM_Reject,
     /* 388593 */ // Label 125: @388593
     /* 388593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7842*/ GIMT_Encode4(388931),
     /* 388604 */ /*GILLT_s32*//*Label 7835*/ GIMT_Encode4(388640),
     /* 388608 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(388678), GIMT_Encode4(0),
     /* 388616 */ /*GILLT_v2s32*//*Label 7837*/ GIMT_Encode4(388741),
     /* 388620 */ /*GILLT_v2s64*//*Label 7838*/ GIMT_Encode4(388779),
     /* 388624 */ /*GILLT_v4s16*//*Label 7839*/ GIMT_Encode4(388817),
     /* 388628 */ /*GILLT_v4s32*//*Label 7840*/ GIMT_Encode4(388855), GIMT_Encode4(0),
     /* 388636 */ /*GILLT_v8s16*//*Label 7841*/ GIMT_Encode4(388893),
     /* 388640 */ // Label 7835: @388640
     /* 388640 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(388677), // Rule ID 1615 //
     /* 388645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388666 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 388666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 388671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388675 */   GIR_RootConstrainSelectedInstOperands,
     /* 388676 */   // GIR_Coverage, 1615,
     /* 388676 */   GIR_Done,
     /* 388677 */ // Label 7843: @388677
     /* 388677 */ GIM_Reject,
     /* 388678 */ // Label 7836: @388678
     /* 388678 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(388740),
     /* 388683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388701 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(388720), // Rule ID 1614 //
     /* 388706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388709 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 388709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388718 */     GIR_RootConstrainSelectedInstOperands,
     /* 388719 */     // GIR_Coverage, 1614,
     /* 388719 */     GIR_Done,
     /* 388720 */   // Label 7845: @388720
     /* 388720 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(388739), // Rule ID 5149 //
     /* 388725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388728 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 388728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388733 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388737 */     GIR_RootConstrainSelectedInstOperands,
     /* 388738 */     // GIR_Coverage, 5149,
     /* 388738 */     GIR_Done,
     /* 388739 */   // Label 7846: @388739
     /* 388739 */   GIM_Reject,
     /* 388740 */ // Label 7844: @388740
     /* 388740 */ GIM_Reject,
     /* 388741 */ // Label 7837: @388741
     /* 388741 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(388778), // Rule ID 1203 //
     /* 388746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 388755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388767 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 388772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388776 */   GIR_RootConstrainSelectedInstOperands,
     /* 388777 */   // GIR_Coverage, 1203,
     /* 388777 */   GIR_Done,
     /* 388778 */ // Label 7847: @388778
     /* 388778 */ GIM_Reject,
     /* 388779 */ // Label 7838: @388779
     /* 388779 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(388816), // Rule ID 1205 //
     /* 388784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 388793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388805 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 388810 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388814 */   GIR_RootConstrainSelectedInstOperands,
     /* 388815 */   // GIR_Coverage, 1205,
     /* 388815 */   GIR_Done,
     /* 388816 */ // Label 7848: @388816
     /* 388816 */ GIM_Reject,
     /* 388817 */ // Label 7839: @388817
     /* 388817 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(388854), // Rule ID 1201 //
     /* 388822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388843 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 388848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388852 */   GIR_RootConstrainSelectedInstOperands,
     /* 388853 */   // GIR_Coverage, 1201,
     /* 388853 */   GIR_Done,
     /* 388854 */ // Label 7849: @388854
     /* 388854 */ GIM_Reject,
     /* 388855 */ // Label 7840: @388855
     /* 388855 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(388892), // Rule ID 1204 //
     /* 388860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388881 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 388881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 388886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388890 */   GIR_RootConstrainSelectedInstOperands,
     /* 388891 */   // GIR_Coverage, 1204,
     /* 388891 */   GIR_Done,
     /* 388892 */ // Label 7850: @388892
     /* 388892 */ GIM_Reject,
     /* 388893 */ // Label 7841: @388893
     /* 388893 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(388930), // Rule ID 1202 //
     /* 388898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388919 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 388919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 388924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388928 */   GIR_RootConstrainSelectedInstOperands,
     /* 388929 */   // GIR_Coverage, 1202,
     /* 388929 */   GIR_Done,
     /* 388930 */ // Label 7851: @388930
     /* 388930 */ GIM_Reject,
     /* 388931 */ // Label 7842: @388931
     /* 388931 */ GIM_Reject,
     /* 388932 */ // Label 126: @388932
     /* 388932 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7858*/ GIMT_Encode4(389161),
     /* 388943 */ /*GILLT_s64*//*Label 7852*/ GIMT_Encode4(388975), GIMT_Encode4(0),
     /* 388951 */ /*GILLT_v2s32*//*Label 7853*/ GIMT_Encode4(389006),
     /* 388955 */ /*GILLT_v2s64*//*Label 7854*/ GIMT_Encode4(389037),
     /* 388959 */ /*GILLT_v4s16*//*Label 7855*/ GIMT_Encode4(389068),
     /* 388963 */ /*GILLT_v4s32*//*Label 7856*/ GIMT_Encode4(389099), GIMT_Encode4(0),
     /* 388971 */ /*GILLT_v8s16*//*Label 7857*/ GIMT_Encode4(389130),
     /* 388975 */ // Label 7852: @388975
     /* 388975 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(389005), // Rule ID 2504 //
     /* 388980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388994 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 388994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 388999 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389003 */   GIR_RootConstrainSelectedInstOperands,
     /* 389004 */   // GIR_Coverage, 2504,
     /* 389004 */   GIR_Done,
     /* 389005 */ // Label 7859: @389005
     /* 389005 */ GIM_Reject,
     /* 389006 */ // Label 7853: @389006
     /* 389006 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(389036), // Rule ID 766 //
     /* 389011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389025 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 389025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 389030 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389034 */   GIR_RootConstrainSelectedInstOperands,
     /* 389035 */   // GIR_Coverage, 766,
     /* 389035 */   GIR_Done,
     /* 389036 */ // Label 7860: @389036
     /* 389036 */ GIM_Reject,
     /* 389037 */ // Label 7854: @389037
     /* 389037 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(389067), // Rule ID 768 //
     /* 389042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389056 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 389056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 389061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389065 */   GIR_RootConstrainSelectedInstOperands,
     /* 389066 */   // GIR_Coverage, 768,
     /* 389066 */   GIR_Done,
     /* 389067 */ // Label 7861: @389067
     /* 389067 */ GIM_Reject,
     /* 389068 */ // Label 7855: @389068
     /* 389068 */ GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(389098), // Rule ID 764 //
     /* 389073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389087 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 389087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 389092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389096 */   GIR_RootConstrainSelectedInstOperands,
     /* 389097 */   // GIR_Coverage, 764,
     /* 389097 */   GIR_Done,
     /* 389098 */ // Label 7862: @389098
     /* 389098 */ GIM_Reject,
     /* 389099 */ // Label 7856: @389099
     /* 389099 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(389129), // Rule ID 767 //
     /* 389104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389118 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 389118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 389123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389127 */   GIR_RootConstrainSelectedInstOperands,
     /* 389128 */   // GIR_Coverage, 767,
     /* 389128 */   GIR_Done,
     /* 389129 */ // Label 7863: @389129
     /* 389129 */ GIM_Reject,
     /* 389130 */ // Label 7857: @389130
     /* 389130 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(389160), // Rule ID 765 //
     /* 389135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389149 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 389149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 389154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389158 */   GIR_RootConstrainSelectedInstOperands,
     /* 389159 */   // GIR_Coverage, 765,
     /* 389159 */   GIR_Done,
     /* 389160 */ // Label 7864: @389160
     /* 389160 */ GIM_Reject,
     /* 389161 */ // Label 7858: @389161
     /* 389161 */ GIM_Reject,
     /* 389162 */ // Label 127: @389162
     /* 389162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7872*/ GIMT_Encode4(389825),
     /* 389173 */ /*GILLT_s32*//*Label 7865*/ GIMT_Encode4(389209),
     /* 389177 */ /*GILLT_s64*//*Label 7866*/ GIMT_Encode4(389247), GIMT_Encode4(0),
     /* 389185 */ /*GILLT_v2s32*//*Label 7867*/ GIMT_Encode4(389310),
     /* 389189 */ /*GILLT_v2s64*//*Label 7868*/ GIMT_Encode4(389413),
     /* 389193 */ /*GILLT_v4s16*//*Label 7869*/ GIMT_Encode4(389516),
     /* 389197 */ /*GILLT_v4s32*//*Label 7870*/ GIMT_Encode4(389619), GIMT_Encode4(0),
     /* 389205 */ /*GILLT_v8s16*//*Label 7871*/ GIMT_Encode4(389722),
     /* 389209 */ // Label 7865: @389209
     /* 389209 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(389246), // Rule ID 1617 //
     /* 389214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 389223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389235 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 389235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 389240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389244 */   GIR_RootConstrainSelectedInstOperands,
     /* 389245 */   // GIR_Coverage, 1617,
     /* 389245 */   GIR_Done,
     /* 389246 */ // Label 7873: @389246
     /* 389246 */ GIM_Reject,
     /* 389247 */ // Label 7866: @389247
     /* 389247 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(389309),
     /* 389252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389270 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(389289), // Rule ID 1616 //
     /* 389275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389278 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 389278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 389283 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389287 */     GIR_RootConstrainSelectedInstOperands,
     /* 389288 */     // GIR_Coverage, 1616,
     /* 389288 */     GIR_Done,
     /* 389289 */   // Label 7875: @389289
     /* 389289 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(389308), // Rule ID 5150 //
     /* 389294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389297 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 389297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 389302 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389306 */     GIR_RootConstrainSelectedInstOperands,
     /* 389307 */     // GIR_Coverage, 5150,
     /* 389307 */     GIR_Done,
     /* 389308 */   // Label 7876: @389308
     /* 389308 */   GIM_Reject,
     /* 389309 */ // Label 7874: @389309
     /* 389309 */ GIM_Reject,
     /* 389310 */ // Label 7867: @389310
     /* 389310 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(389412),
     /* 389315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389325 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(389384), // Rule ID 1165 //
     /* 389330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389369 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 389372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389382 */     GIR_RootConstrainSelectedInstOperands,
     /* 389383 */     // GIR_Coverage, 1165,
     /* 389383 */     GIR_EraseRootFromParent_Done,
     /* 389384 */   // Label 7878: @389384
     /* 389384 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(389411), // Rule ID 1208 //
     /* 389389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389400 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 389405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389409 */     GIR_RootConstrainSelectedInstOperands,
     /* 389410 */     // GIR_Coverage, 1208,
     /* 389410 */     GIR_Done,
     /* 389411 */   // Label 7879: @389411
     /* 389411 */   GIM_Reject,
     /* 389412 */ // Label 7877: @389412
     /* 389412 */ GIM_Reject,
     /* 389413 */ // Label 7868: @389413
     /* 389413 */ GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(389515),
     /* 389418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 389424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389428 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(389487), // Rule ID 1169 //
     /* 389433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389472 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 389475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389485 */     GIR_RootConstrainSelectedInstOperands,
     /* 389486 */     // GIR_Coverage, 1169,
     /* 389486 */     GIR_EraseRootFromParent_Done,
     /* 389487 */   // Label 7881: @389487
     /* 389487 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(389514), // Rule ID 1210 //
     /* 389492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389503 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 389508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389512 */     GIR_RootConstrainSelectedInstOperands,
     /* 389513 */     // GIR_Coverage, 1210,
     /* 389513 */     GIR_Done,
     /* 389514 */   // Label 7882: @389514
     /* 389514 */   GIM_Reject,
     /* 389515 */ // Label 7880: @389515
     /* 389515 */ GIM_Reject,
     /* 389516 */ // Label 7869: @389516
     /* 389516 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(389618),
     /* 389521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389531 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(389590), // Rule ID 1161 //
     /* 389536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389575 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 389578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389588 */     GIR_RootConstrainSelectedInstOperands,
     /* 389589 */     // GIR_Coverage, 1161,
     /* 389589 */     GIR_EraseRootFromParent_Done,
     /* 389590 */   // Label 7884: @389590
     /* 389590 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(389617), // Rule ID 1206 //
     /* 389595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389606 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 389611 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389615 */     GIR_RootConstrainSelectedInstOperands,
     /* 389616 */     // GIR_Coverage, 1206,
     /* 389616 */     GIR_Done,
     /* 389617 */   // Label 7885: @389617
     /* 389617 */   GIM_Reject,
     /* 389618 */ // Label 7883: @389618
     /* 389618 */ GIM_Reject,
     /* 389619 */ // Label 7870: @389619
     /* 389619 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(389721),
     /* 389624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389634 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(389693), // Rule ID 1167 //
     /* 389639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389678 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 389681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389691 */     GIR_RootConstrainSelectedInstOperands,
     /* 389692 */     // GIR_Coverage, 1167,
     /* 389692 */     GIR_EraseRootFromParent_Done,
     /* 389693 */   // Label 7887: @389693
     /* 389693 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(389720), // Rule ID 1209 //
     /* 389698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389709 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 389714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389718 */     GIR_RootConstrainSelectedInstOperands,
     /* 389719 */     // GIR_Coverage, 1209,
     /* 389719 */     GIR_Done,
     /* 389720 */   // Label 7888: @389720
     /* 389720 */   GIM_Reject,
     /* 389721 */ // Label 7886: @389721
     /* 389721 */ GIM_Reject,
     /* 389722 */ // Label 7871: @389722
     /* 389722 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(389824),
     /* 389727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 389733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389737 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(389796), // Rule ID 1163 //
     /* 389742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389781 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 389784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389794 */     GIR_RootConstrainSelectedInstOperands,
     /* 389795 */     // GIR_Coverage, 1163,
     /* 389795 */     GIR_EraseRootFromParent_Done,
     /* 389796 */   // Label 7890: @389796
     /* 389796 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(389823), // Rule ID 1207 //
     /* 389801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389812 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 389817 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389821 */     GIR_RootConstrainSelectedInstOperands,
     /* 389822 */     // GIR_Coverage, 1207,
     /* 389822 */     GIR_Done,
     /* 389823 */   // Label 7891: @389823
     /* 389823 */   GIM_Reject,
     /* 389824 */ // Label 7889: @389824
     /* 389824 */ GIM_Reject,
     /* 389825 */ // Label 7872: @389825
     /* 389825 */ GIM_Reject,
     /* 389826 */ // Label 128: @389826
     /* 389826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7898*/ GIMT_Encode4(390055),
     /* 389837 */ /*GILLT_s64*//*Label 7892*/ GIMT_Encode4(389869), GIMT_Encode4(0),
     /* 389845 */ /*GILLT_v2s32*//*Label 7893*/ GIMT_Encode4(389900),
     /* 389849 */ /*GILLT_v2s64*//*Label 7894*/ GIMT_Encode4(389931),
     /* 389853 */ /*GILLT_v4s16*//*Label 7895*/ GIMT_Encode4(389962),
     /* 389857 */ /*GILLT_v4s32*//*Label 7896*/ GIMT_Encode4(389993), GIMT_Encode4(0),
     /* 389865 */ /*GILLT_v8s16*//*Label 7897*/ GIMT_Encode4(390024),
     /* 389869 */ // Label 7892: @389869
     /* 389869 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(389899), // Rule ID 5180 //
     /* 389874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389888 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 389888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 389893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389897 */   GIR_RootConstrainSelectedInstOperands,
     /* 389898 */   // GIR_Coverage, 5180,
     /* 389898 */   GIR_Done,
     /* 389899 */ // Label 7899: @389899
     /* 389899 */ GIM_Reject,
     /* 389900 */ // Label 7893: @389900
     /* 389900 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(389930), // Rule ID 771 //
     /* 389905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389919 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 389919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 389924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389928 */   GIR_RootConstrainSelectedInstOperands,
     /* 389929 */   // GIR_Coverage, 771,
     /* 389929 */   GIR_Done,
     /* 389930 */ // Label 7900: @389930
     /* 389930 */ GIM_Reject,
     /* 389931 */ // Label 7894: @389931
     /* 389931 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(389961), // Rule ID 773 //
     /* 389936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389950 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 389950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 389955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389959 */   GIR_RootConstrainSelectedInstOperands,
     /* 389960 */   // GIR_Coverage, 773,
     /* 389960 */   GIR_Done,
     /* 389961 */ // Label 7901: @389961
     /* 389961 */ GIM_Reject,
     /* 389962 */ // Label 7895: @389962
     /* 389962 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(389992), // Rule ID 769 //
     /* 389967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389981 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 389981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 389986 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389990 */   GIR_RootConstrainSelectedInstOperands,
     /* 389991 */   // GIR_Coverage, 769,
     /* 389991 */   GIR_Done,
     /* 389992 */ // Label 7902: @389992
     /* 389992 */ GIM_Reject,
     /* 389993 */ // Label 7896: @389993
     /* 389993 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(390023), // Rule ID 772 //
     /* 389998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390012 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 390017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390021 */   GIR_RootConstrainSelectedInstOperands,
     /* 390022 */   // GIR_Coverage, 772,
     /* 390022 */   GIR_Done,
     /* 390023 */ // Label 7903: @390023
     /* 390023 */ GIM_Reject,
     /* 390024 */ // Label 7897: @390024
     /* 390024 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(390054), // Rule ID 770 //
     /* 390029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390043 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 390048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390052 */   GIR_RootConstrainSelectedInstOperands,
     /* 390053 */   // GIR_Coverage, 770,
     /* 390053 */   GIR_Done,
     /* 390054 */ // Label 7904: @390054
     /* 390054 */ GIM_Reject,
     /* 390055 */ // Label 7898: @390055
     /* 390055 */ GIM_Reject,
     /* 390056 */ // Label 129: @390056
     /* 390056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7912*/ GIMT_Encode4(390719),
     /* 390067 */ /*GILLT_s32*//*Label 7905*/ GIMT_Encode4(390103),
     /* 390071 */ /*GILLT_s64*//*Label 7906*/ GIMT_Encode4(390141), GIMT_Encode4(0),
     /* 390079 */ /*GILLT_v2s32*//*Label 7907*/ GIMT_Encode4(390204),
     /* 390083 */ /*GILLT_v2s64*//*Label 7908*/ GIMT_Encode4(390307),
     /* 390087 */ /*GILLT_v4s16*//*Label 7909*/ GIMT_Encode4(390410),
     /* 390091 */ /*GILLT_v4s32*//*Label 7910*/ GIMT_Encode4(390513), GIMT_Encode4(0),
     /* 390099 */ /*GILLT_v8s16*//*Label 7911*/ GIMT_Encode4(390616),
     /* 390103 */ // Label 7905: @390103
     /* 390103 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(390140), // Rule ID 1619 //
     /* 390108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 390117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390129 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 390129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 390134 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390138 */   GIR_RootConstrainSelectedInstOperands,
     /* 390139 */   // GIR_Coverage, 1619,
     /* 390139 */   GIR_Done,
     /* 390140 */ // Label 7913: @390140
     /* 390140 */ GIM_Reject,
     /* 390141 */ // Label 7906: @390141
     /* 390141 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(390203),
     /* 390146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390164 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(390183), // Rule ID 1618 //
     /* 390169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390172 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 390172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 390177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390181 */     GIR_RootConstrainSelectedInstOperands,
     /* 390182 */     // GIR_Coverage, 1618,
     /* 390182 */     GIR_Done,
     /* 390183 */   // Label 7915: @390183
     /* 390183 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(390202), // Rule ID 5151 //
     /* 390188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390191 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 390191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 390196 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390200 */     GIR_RootConstrainSelectedInstOperands,
     /* 390201 */     // GIR_Coverage, 5151,
     /* 390201 */     GIR_Done,
     /* 390202 */   // Label 7916: @390202
     /* 390202 */   GIM_Reject,
     /* 390203 */ // Label 7914: @390203
     /* 390203 */ GIM_Reject,
     /* 390204 */ // Label 7907: @390204
     /* 390204 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(390306),
     /* 390209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 390215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390219 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(390278), // Rule ID 1175 //
     /* 390224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390263 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 390266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390276 */     GIR_RootConstrainSelectedInstOperands,
     /* 390277 */     // GIR_Coverage, 1175,
     /* 390277 */     GIR_EraseRootFromParent_Done,
     /* 390278 */   // Label 7918: @390278
     /* 390278 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(390305), // Rule ID 1213 //
     /* 390283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390294 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 390294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 390299 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390303 */     GIR_RootConstrainSelectedInstOperands,
     /* 390304 */     // GIR_Coverage, 1213,
     /* 390304 */     GIR_Done,
     /* 390305 */   // Label 7919: @390305
     /* 390305 */   GIM_Reject,
     /* 390306 */ // Label 7917: @390306
     /* 390306 */ GIM_Reject,
     /* 390307 */ // Label 7908: @390307
     /* 390307 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(390409),
     /* 390312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 390318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390322 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(390381), // Rule ID 1179 //
     /* 390327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390366 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 390366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 390369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390379 */     GIR_RootConstrainSelectedInstOperands,
     /* 390380 */     // GIR_Coverage, 1179,
     /* 390380 */     GIR_EraseRootFromParent_Done,
     /* 390381 */   // Label 7921: @390381
     /* 390381 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(390408), // Rule ID 1215 //
     /* 390386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390397 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 390397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 390402 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390406 */     GIR_RootConstrainSelectedInstOperands,
     /* 390407 */     // GIR_Coverage, 1215,
     /* 390407 */     GIR_Done,
     /* 390408 */   // Label 7922: @390408
     /* 390408 */   GIM_Reject,
     /* 390409 */ // Label 7920: @390409
     /* 390409 */ GIM_Reject,
     /* 390410 */ // Label 7909: @390410
     /* 390410 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(390512),
     /* 390415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 390421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390425 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(390484), // Rule ID 1171 //
     /* 390430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390469 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 390472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390482 */     GIR_RootConstrainSelectedInstOperands,
     /* 390483 */     // GIR_Coverage, 1171,
     /* 390483 */     GIR_EraseRootFromParent_Done,
     /* 390484 */   // Label 7924: @390484
     /* 390484 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(390511), // Rule ID 1211 //
     /* 390489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390500 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 390505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390509 */     GIR_RootConstrainSelectedInstOperands,
     /* 390510 */     // GIR_Coverage, 1211,
     /* 390510 */     GIR_Done,
     /* 390511 */   // Label 7925: @390511
     /* 390511 */   GIM_Reject,
     /* 390512 */ // Label 7923: @390512
     /* 390512 */ GIM_Reject,
     /* 390513 */ // Label 7910: @390513
     /* 390513 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(390615),
     /* 390518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 390524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390528 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(390587), // Rule ID 1177 //
     /* 390533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390572 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 390575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390585 */     GIR_RootConstrainSelectedInstOperands,
     /* 390586 */     // GIR_Coverage, 1177,
     /* 390586 */     GIR_EraseRootFromParent_Done,
     /* 390587 */   // Label 7927: @390587
     /* 390587 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(390614), // Rule ID 1214 //
     /* 390592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390603 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 390608 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390612 */     GIR_RootConstrainSelectedInstOperands,
     /* 390613 */     // GIR_Coverage, 1214,
     /* 390613 */     GIR_Done,
     /* 390614 */   // Label 7928: @390614
     /* 390614 */   GIM_Reject,
     /* 390615 */ // Label 7926: @390615
     /* 390615 */ GIM_Reject,
     /* 390616 */ // Label 7911: @390616
     /* 390616 */ GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(390718),
     /* 390621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390631 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(390690), // Rule ID 1173 //
     /* 390636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390675 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 390678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390688 */     GIR_RootConstrainSelectedInstOperands,
     /* 390689 */     // GIR_Coverage, 1173,
     /* 390689 */     GIR_EraseRootFromParent_Done,
     /* 390690 */   // Label 7930: @390690
     /* 390690 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(390717), // Rule ID 1212 //
     /* 390695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390706 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 390711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390715 */     GIR_RootConstrainSelectedInstOperands,
     /* 390716 */     // GIR_Coverage, 1212,
     /* 390716 */     GIR_Done,
     /* 390717 */   // Label 7931: @390717
     /* 390717 */   GIM_Reject,
     /* 390718 */ // Label 7929: @390718
     /* 390718 */ GIM_Reject,
     /* 390719 */ // Label 7912: @390719
     /* 390719 */ GIM_Reject,
     /* 390720 */ // Label 130: @390720
     /* 390720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7938*/ GIMT_Encode4(390949),
     /* 390731 */ /*GILLT_s64*//*Label 7932*/ GIMT_Encode4(390763), GIMT_Encode4(0),
     /* 390739 */ /*GILLT_v2s32*//*Label 7933*/ GIMT_Encode4(390794),
     /* 390743 */ /*GILLT_v2s64*//*Label 7934*/ GIMT_Encode4(390825),
     /* 390747 */ /*GILLT_v4s16*//*Label 7935*/ GIMT_Encode4(390856),
     /* 390751 */ /*GILLT_v4s32*//*Label 7936*/ GIMT_Encode4(390887), GIMT_Encode4(0),
     /* 390759 */ /*GILLT_v8s16*//*Label 7937*/ GIMT_Encode4(390918),
     /* 390763 */ // Label 7932: @390763
     /* 390763 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(390793), // Rule ID 5181 //
     /* 390768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390782 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 390787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390791 */   GIR_RootConstrainSelectedInstOperands,
     /* 390792 */   // GIR_Coverage, 5181,
     /* 390792 */   GIR_Done,
     /* 390793 */ // Label 7939: @390793
     /* 390793 */ GIM_Reject,
     /* 390794 */ // Label 7933: @390794
     /* 390794 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(390824), // Rule ID 776 //
     /* 390799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390813 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 390818 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390822 */   GIR_RootConstrainSelectedInstOperands,
     /* 390823 */   // GIR_Coverage, 776,
     /* 390823 */   GIR_Done,
     /* 390824 */ // Label 7940: @390824
     /* 390824 */ GIM_Reject,
     /* 390825 */ // Label 7934: @390825
     /* 390825 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(390855), // Rule ID 778 //
     /* 390830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390844 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 390849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390853 */   GIR_RootConstrainSelectedInstOperands,
     /* 390854 */   // GIR_Coverage, 778,
     /* 390854 */   GIR_Done,
     /* 390855 */ // Label 7941: @390855
     /* 390855 */ GIM_Reject,
     /* 390856 */ // Label 7935: @390856
     /* 390856 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(390886), // Rule ID 774 //
     /* 390861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390875 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 390880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390884 */   GIR_RootConstrainSelectedInstOperands,
     /* 390885 */   // GIR_Coverage, 774,
     /* 390885 */   GIR_Done,
     /* 390886 */ // Label 7942: @390886
     /* 390886 */ GIM_Reject,
     /* 390887 */ // Label 7936: @390887
     /* 390887 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(390917), // Rule ID 777 //
     /* 390892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390906 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 390911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390915 */   GIR_RootConstrainSelectedInstOperands,
     /* 390916 */   // GIR_Coverage, 777,
     /* 390916 */   GIR_Done,
     /* 390917 */ // Label 7943: @390917
     /* 390917 */ GIM_Reject,
     /* 390918 */ // Label 7937: @390918
     /* 390918 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(390948), // Rule ID 775 //
     /* 390923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390937 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 390942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390946 */   GIR_RootConstrainSelectedInstOperands,
     /* 390947 */   // GIR_Coverage, 775,
     /* 390947 */   GIR_Done,
     /* 390948 */ // Label 7944: @390948
     /* 390948 */ GIM_Reject,
     /* 390949 */ // Label 7938: @390949
     /* 390949 */ GIM_Reject,
     /* 390950 */ // Label 131: @390950
     /* 390950 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7951*/ GIMT_Encode4(391179),
     /* 390961 */ /*GILLT_s64*//*Label 7945*/ GIMT_Encode4(390993), GIMT_Encode4(0),
     /* 390969 */ /*GILLT_v2s32*//*Label 7946*/ GIMT_Encode4(391024),
     /* 390973 */ /*GILLT_v2s64*//*Label 7947*/ GIMT_Encode4(391055),
     /* 390977 */ /*GILLT_v4s16*//*Label 7948*/ GIMT_Encode4(391086),
     /* 390981 */ /*GILLT_v4s32*//*Label 7949*/ GIMT_Encode4(391117), GIMT_Encode4(0),
     /* 390989 */ /*GILLT_v8s16*//*Label 7950*/ GIMT_Encode4(391148),
     /* 390993 */ // Label 7945: @390993
     /* 390993 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(391023), // Rule ID 5182 //
     /* 390998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391012 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 391012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 391017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391021 */   GIR_RootConstrainSelectedInstOperands,
     /* 391022 */   // GIR_Coverage, 5182,
     /* 391022 */   GIR_Done,
     /* 391023 */ // Label 7952: @391023
     /* 391023 */ GIM_Reject,
     /* 391024 */ // Label 7946: @391024
     /* 391024 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(391054), // Rule ID 781 //
     /* 391029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391043 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 391043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 391048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391052 */   GIR_RootConstrainSelectedInstOperands,
     /* 391053 */   // GIR_Coverage, 781,
     /* 391053 */   GIR_Done,
     /* 391054 */ // Label 7953: @391054
     /* 391054 */ GIM_Reject,
     /* 391055 */ // Label 7947: @391055
     /* 391055 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(391085), // Rule ID 783 //
     /* 391060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391074 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 391074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 391079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391083 */   GIR_RootConstrainSelectedInstOperands,
     /* 391084 */   // GIR_Coverage, 783,
     /* 391084 */   GIR_Done,
     /* 391085 */ // Label 7954: @391085
     /* 391085 */ GIM_Reject,
     /* 391086 */ // Label 7948: @391086
     /* 391086 */ GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(391116), // Rule ID 779 //
     /* 391091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391105 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 391105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 391110 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391114 */   GIR_RootConstrainSelectedInstOperands,
     /* 391115 */   // GIR_Coverage, 779,
     /* 391115 */   GIR_Done,
     /* 391116 */ // Label 7955: @391116
     /* 391116 */ GIM_Reject,
     /* 391117 */ // Label 7949: @391117
     /* 391117 */ GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(391147), // Rule ID 782 //
     /* 391122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391136 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 391136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 391141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391145 */   GIR_RootConstrainSelectedInstOperands,
     /* 391146 */   // GIR_Coverage, 782,
     /* 391146 */   GIR_Done,
     /* 391147 */ // Label 7956: @391147
     /* 391147 */ GIM_Reject,
     /* 391148 */ // Label 7950: @391148
     /* 391148 */ GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(391178), // Rule ID 780 //
     /* 391153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391167 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 391167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 391172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391176 */   GIR_RootConstrainSelectedInstOperands,
     /* 391177 */   // GIR_Coverage, 780,
     /* 391177 */   GIR_Done,
     /* 391178 */ // Label 7957: @391178
     /* 391178 */ GIM_Reject,
     /* 391179 */ // Label 7951: @391179
     /* 391179 */ GIM_Reject,
     /* 391180 */ // Label 132: @391180
     /* 391180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7964*/ GIMT_Encode4(391409),
     /* 391191 */ /*GILLT_s64*//*Label 7958*/ GIMT_Encode4(391223), GIMT_Encode4(0),
     /* 391199 */ /*GILLT_v2s32*//*Label 7959*/ GIMT_Encode4(391254),
     /* 391203 */ /*GILLT_v2s64*//*Label 7960*/ GIMT_Encode4(391285),
     /* 391207 */ /*GILLT_v4s16*//*Label 7961*/ GIMT_Encode4(391316),
     /* 391211 */ /*GILLT_v4s32*//*Label 7962*/ GIMT_Encode4(391347), GIMT_Encode4(0),
     /* 391219 */ /*GILLT_v8s16*//*Label 7963*/ GIMT_Encode4(391378),
     /* 391223 */ // Label 7958: @391223
     /* 391223 */ GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(391253), // Rule ID 5183 //
     /* 391228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391242 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 391242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 391247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391251 */   GIR_RootConstrainSelectedInstOperands,
     /* 391252 */   // GIR_Coverage, 5183,
     /* 391252 */   GIR_Done,
     /* 391253 */ // Label 7965: @391253
     /* 391253 */ GIM_Reject,
     /* 391254 */ // Label 7959: @391254
     /* 391254 */ GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(391284), // Rule ID 786 //
     /* 391259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391273 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 391273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 391278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391282 */   GIR_RootConstrainSelectedInstOperands,
     /* 391283 */   // GIR_Coverage, 786,
     /* 391283 */   GIR_Done,
     /* 391284 */ // Label 7966: @391284
     /* 391284 */ GIM_Reject,
     /* 391285 */ // Label 7960: @391285
     /* 391285 */ GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(391315), // Rule ID 788 //
     /* 391290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391304 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 391304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 391309 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391313 */   GIR_RootConstrainSelectedInstOperands,
     /* 391314 */   // GIR_Coverage, 788,
     /* 391314 */   GIR_Done,
     /* 391315 */ // Label 7967: @391315
     /* 391315 */ GIM_Reject,
     /* 391316 */ // Label 7961: @391316
     /* 391316 */ GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(391346), // Rule ID 784 //
     /* 391321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391335 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 391335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 391340 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391344 */   GIR_RootConstrainSelectedInstOperands,
     /* 391345 */   // GIR_Coverage, 784,
     /* 391345 */   GIR_Done,
     /* 391346 */ // Label 7968: @391346
     /* 391346 */ GIM_Reject,
     /* 391347 */ // Label 7962: @391347
     /* 391347 */ GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(391377), // Rule ID 787 //
     /* 391352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391366 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 391366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 391371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391375 */   GIR_RootConstrainSelectedInstOperands,
     /* 391376 */   // GIR_Coverage, 787,
     /* 391376 */   GIR_Done,
     /* 391377 */ // Label 7969: @391377
     /* 391377 */ GIM_Reject,
     /* 391378 */ // Label 7963: @391378
     /* 391378 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(391408), // Rule ID 785 //
     /* 391383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391397 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 391397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 391402 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391406 */   GIR_RootConstrainSelectedInstOperands,
     /* 391407 */   // GIR_Coverage, 785,
     /* 391407 */   GIR_Done,
     /* 391408 */ // Label 7970: @391408
     /* 391408 */ GIM_Reject,
     /* 391409 */ // Label 7964: @391409
     /* 391409 */ GIM_Reject,
     /* 391410 */ // Label 133: @391410
     /* 391410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7975*/ GIMT_Encode4(391563),
     /* 391421 */ /*GILLT_s32*//*Label 7971*/ GIMT_Encode4(391461),
     /* 391425 */ /*GILLT_s64*//*Label 7972*/ GIMT_Encode4(391485), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391449 */ /*GILLT_v8s8*//*Label 7973*/ GIMT_Encode4(391509), GIMT_Encode4(0),
     /* 391457 */ /*GILLT_v16s8*//*Label 7974*/ GIMT_Encode4(391536),
     /* 391461 */ // Label 7971: @391461
     /* 391461 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(391484), // Rule ID 3957 //
     /* 391466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391477 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 391482 */   GIR_RootConstrainSelectedInstOperands,
     /* 391483 */   // GIR_Coverage, 3957,
     /* 391483 */   GIR_Done,
     /* 391484 */ // Label 7976: @391484
     /* 391484 */ GIM_Reject,
     /* 391485 */ // Label 7972: @391485
     /* 391485 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(391508), // Rule ID 3958 //
     /* 391490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391501 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 391506 */   GIR_RootConstrainSelectedInstOperands,
     /* 391507 */   // GIR_Coverage, 3958,
     /* 391507 */   GIR_Done,
     /* 391508 */ // Label 7977: @391508
     /* 391508 */ GIM_Reject,
     /* 391509 */ // Label 7973: @391509
     /* 391509 */ GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(391535), // Rule ID 969 //
     /* 391514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391528 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 391533 */   GIR_RootConstrainSelectedInstOperands,
     /* 391534 */   // GIR_Coverage, 969,
     /* 391534 */   GIR_Done,
     /* 391535 */ // Label 7978: @391535
     /* 391535 */ GIM_Reject,
     /* 391536 */ // Label 7974: @391536
     /* 391536 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(391562), // Rule ID 970 //
     /* 391541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391555 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 391560 */   GIR_RootConstrainSelectedInstOperands,
     /* 391561 */   // GIR_Coverage, 970,
     /* 391561 */   GIR_Done,
     /* 391562 */ // Label 7979: @391562
     /* 391562 */ GIM_Reject,
     /* 391563 */ // Label 7975: @391563
     /* 391563 */ GIM_Reject,
     /* 391564 */ // Label 134: @391564
     /* 391564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 7984*/ GIMT_Encode4(391739),
     /* 391575 */ /*GILLT_v4s16*//*Label 7980*/ GIMT_Encode4(391595), GIMT_Encode4(0),
     /* 391583 */ /*GILLT_v8s8*//*Label 7981*/ GIMT_Encode4(391640),
     /* 391587 */ /*GILLT_v8s16*//*Label 7982*/ GIMT_Encode4(391667),
     /* 391591 */ /*GILLT_v16s8*//*Label 7983*/ GIMT_Encode4(391712),
     /* 391595 */ // Label 7980: @391595
     /* 391595 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(391639),
     /* 391600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391611 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(391626), // Rule ID 973 //
     /* 391616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391619 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391624 */     GIR_RootConstrainSelectedInstOperands,
     /* 391625 */     // GIR_Coverage, 973,
     /* 391625 */     GIR_Done,
     /* 391626 */   // Label 7986: @391626
     /* 391626 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(391638), // Rule ID 4902 //
     /* 391631 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391636 */     GIR_RootConstrainSelectedInstOperands,
     /* 391637 */     // GIR_Coverage, 4902,
     /* 391637 */     GIR_Done,
     /* 391638 */   // Label 7987: @391638
     /* 391638 */   GIM_Reject,
     /* 391639 */ // Label 7985: @391639
     /* 391639 */ GIM_Reject,
     /* 391640 */ // Label 7981: @391640
     /* 391640 */ GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(391666), // Rule ID 971 //
     /* 391645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391659 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 391664 */   GIR_RootConstrainSelectedInstOperands,
     /* 391665 */   // GIR_Coverage, 971,
     /* 391665 */   GIR_Done,
     /* 391666 */ // Label 7988: @391666
     /* 391666 */ GIM_Reject,
     /* 391667 */ // Label 7982: @391667
     /* 391667 */ GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(391711),
     /* 391672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391683 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(391698), // Rule ID 974 //
     /* 391688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391691 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391696 */     GIR_RootConstrainSelectedInstOperands,
     /* 391697 */     // GIR_Coverage, 974,
     /* 391697 */     GIR_Done,
     /* 391698 */   // Label 7990: @391698
     /* 391698 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(391710), // Rule ID 4904 //
     /* 391703 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391708 */     GIR_RootConstrainSelectedInstOperands,
     /* 391709 */     // GIR_Coverage, 4904,
     /* 391709 */     GIR_Done,
     /* 391710 */   // Label 7991: @391710
     /* 391710 */   GIM_Reject,
     /* 391711 */ // Label 7989: @391711
     /* 391711 */ GIM_Reject,
     /* 391712 */ // Label 7983: @391712
     /* 391712 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(391738), // Rule ID 972 //
     /* 391717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391731 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 391736 */   GIR_RootConstrainSelectedInstOperands,
     /* 391737 */   // GIR_Coverage, 972,
     /* 391737 */   GIR_Done,
     /* 391738 */ // Label 7992: @391738
     /* 391738 */ GIM_Reject,
     /* 391739 */ // Label 7984: @391739
     /* 391739 */ GIM_Reject,
     /* 391740 */ // Label 135: @391740
     /* 391740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 7999*/ GIMT_Encode4(392013),
     /* 391751 */ /*GILLT_v2s32*//*Label 7993*/ GIMT_Encode4(391779), GIMT_Encode4(0),
     /* 391759 */ /*GILLT_v4s16*//*Label 7994*/ GIMT_Encode4(391824),
     /* 391763 */ /*GILLT_v4s32*//*Label 7995*/ GIMT_Encode4(391869),
     /* 391767 */ /*GILLT_v8s8*//*Label 7996*/ GIMT_Encode4(391914),
     /* 391771 */ /*GILLT_v8s16*//*Label 7997*/ GIMT_Encode4(391941),
     /* 391775 */ /*GILLT_v16s8*//*Label 7998*/ GIMT_Encode4(391986),
     /* 391779 */ // Label 7993: @391779
     /* 391779 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(391823),
     /* 391784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391795 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(391810), // Rule ID 979 //
     /* 391800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391803 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391808 */     GIR_RootConstrainSelectedInstOperands,
     /* 391809 */     // GIR_Coverage, 979,
     /* 391809 */     GIR_Done,
     /* 391810 */   // Label 8001: @391810
     /* 391810 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(391822), // Rule ID 4906 //
     /* 391815 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391820 */     GIR_RootConstrainSelectedInstOperands,
     /* 391821 */     // GIR_Coverage, 4906,
     /* 391821 */     GIR_Done,
     /* 391822 */   // Label 8002: @391822
     /* 391822 */   GIM_Reject,
     /* 391823 */ // Label 8000: @391823
     /* 391823 */ GIM_Reject,
     /* 391824 */ // Label 7994: @391824
     /* 391824 */ GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(391868),
     /* 391829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391840 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(391855), // Rule ID 977 //
     /* 391845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391848 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391853 */     GIR_RootConstrainSelectedInstOperands,
     /* 391854 */     // GIR_Coverage, 977,
     /* 391854 */     GIR_Done,
     /* 391855 */   // Label 8004: @391855
     /* 391855 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(391867), // Rule ID 4903 //
     /* 391860 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391865 */     GIR_RootConstrainSelectedInstOperands,
     /* 391866 */     // GIR_Coverage, 4903,
     /* 391866 */     GIR_Done,
     /* 391867 */   // Label 8005: @391867
     /* 391867 */   GIM_Reject,
     /* 391868 */ // Label 8003: @391868
     /* 391868 */ GIM_Reject,
     /* 391869 */ // Label 7995: @391869
     /* 391869 */ GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(391913),
     /* 391874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391885 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(391900), // Rule ID 980 //
     /* 391890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391893 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391898 */     GIR_RootConstrainSelectedInstOperands,
     /* 391899 */     // GIR_Coverage, 980,
     /* 391899 */     GIR_Done,
     /* 391900 */   // Label 8007: @391900
     /* 391900 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(391912), // Rule ID 4907 //
     /* 391905 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391910 */     GIR_RootConstrainSelectedInstOperands,
     /* 391911 */     // GIR_Coverage, 4907,
     /* 391911 */     GIR_Done,
     /* 391912 */   // Label 8008: @391912
     /* 391912 */   GIM_Reject,
     /* 391913 */ // Label 8006: @391913
     /* 391913 */ GIM_Reject,
     /* 391914 */ // Label 7996: @391914
     /* 391914 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(391940), // Rule ID 975 //
     /* 391919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391933 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 391938 */   GIR_RootConstrainSelectedInstOperands,
     /* 391939 */   // GIR_Coverage, 975,
     /* 391939 */   GIR_Done,
     /* 391940 */ // Label 8009: @391940
     /* 391940 */ GIM_Reject,
     /* 391941 */ // Label 7997: @391941
     /* 391941 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(391985),
     /* 391946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391957 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(391972), // Rule ID 978 //
     /* 391962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391965 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391970 */     GIR_RootConstrainSelectedInstOperands,
     /* 391971 */     // GIR_Coverage, 978,
     /* 391971 */     GIR_Done,
     /* 391972 */   // Label 8011: @391972
     /* 391972 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(391984), // Rule ID 4905 //
     /* 391977 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391982 */     GIR_RootConstrainSelectedInstOperands,
     /* 391983 */     // GIR_Coverage, 4905,
     /* 391983 */     GIR_Done,
     /* 391984 */   // Label 8012: @391984
     /* 391984 */   GIM_Reject,
     /* 391985 */ // Label 8010: @391985
     /* 391985 */ GIM_Reject,
     /* 391986 */ // Label 7998: @391986
     /* 391986 */ GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(392012), // Rule ID 976 //
     /* 391991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392005 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 392010 */   GIR_RootConstrainSelectedInstOperands,
     /* 392011 */   // GIR_Coverage, 976,
     /* 392011 */   GIR_Done,
     /* 392012 */ // Label 8013: @392012
     /* 392012 */ GIM_Reject,
     /* 392013 */ // Label 7999: @392013
     /* 392013 */ GIM_Reject,
     /* 392014 */ // Label 136: @392014
     /* 392014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8020*/ GIMT_Encode4(392219),
     /* 392025 */ /*GILLT_s64*//*Label 8014*/ GIMT_Encode4(392057), GIMT_Encode4(0),
     /* 392033 */ /*GILLT_v2s32*//*Label 8015*/ GIMT_Encode4(392084),
     /* 392037 */ /*GILLT_v2s64*//*Label 8016*/ GIMT_Encode4(392111),
     /* 392041 */ /*GILLT_v4s16*//*Label 8017*/ GIMT_Encode4(392138),
     /* 392045 */ /*GILLT_v4s32*//*Label 8018*/ GIMT_Encode4(392165), GIMT_Encode4(0),
     /* 392053 */ /*GILLT_v8s16*//*Label 8019*/ GIMT_Encode4(392192),
     /* 392057 */ // Label 8014: @392057
     /* 392057 */ GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(392083), // Rule ID 1001 //
     /* 392062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392076 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 392076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 392081 */   GIR_RootConstrainSelectedInstOperands,
     /* 392082 */   // GIR_Coverage, 1001,
     /* 392082 */   GIR_Done,
     /* 392083 */ // Label 8021: @392083
     /* 392083 */ GIM_Reject,
     /* 392084 */ // Label 8015: @392084
     /* 392084 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(392110), // Rule ID 997 //
     /* 392089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392103 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 392103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 392108 */   GIR_RootConstrainSelectedInstOperands,
     /* 392109 */   // GIR_Coverage, 997,
     /* 392109 */   GIR_Done,
     /* 392110 */ // Label 8022: @392110
     /* 392110 */ GIM_Reject,
     /* 392111 */ // Label 8016: @392111
     /* 392111 */ GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(392137), // Rule ID 1003 //
     /* 392116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392130 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 392130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 392135 */   GIR_RootConstrainSelectedInstOperands,
     /* 392136 */   // GIR_Coverage, 1003,
     /* 392136 */   GIR_Done,
     /* 392137 */ // Label 8023: @392137
     /* 392137 */ GIM_Reject,
     /* 392138 */ // Label 8017: @392138
     /* 392138 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(392164), // Rule ID 993 //
     /* 392143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392157 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 392157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 392162 */   GIR_RootConstrainSelectedInstOperands,
     /* 392163 */   // GIR_Coverage, 993,
     /* 392163 */   GIR_Done,
     /* 392164 */ // Label 8024: @392164
     /* 392164 */ GIM_Reject,
     /* 392165 */ // Label 8018: @392165
     /* 392165 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(392191), // Rule ID 999 //
     /* 392170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392184 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 392184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 392189 */   GIR_RootConstrainSelectedInstOperands,
     /* 392190 */   // GIR_Coverage, 999,
     /* 392190 */   GIR_Done,
     /* 392191 */ // Label 8025: @392191
     /* 392191 */ GIM_Reject,
     /* 392192 */ // Label 8019: @392192
     /* 392192 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(392218), // Rule ID 995 //
     /* 392197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392211 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 392211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 392216 */   GIR_RootConstrainSelectedInstOperands,
     /* 392217 */   // GIR_Coverage, 995,
     /* 392217 */   GIR_Done,
     /* 392218 */ // Label 8026: @392218
     /* 392218 */ GIM_Reject,
     /* 392219 */ // Label 8020: @392219
     /* 392219 */ GIM_Reject,
     /* 392220 */ // Label 137: @392220
     /* 392220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8029*/ GIMT_Encode4(392618),
     /* 392231 */ /*GILLT_v2s64*//*Label 8027*/ GIMT_Encode4(392243), GIMT_Encode4(0),
     /* 392239 */ /*GILLT_v4s32*//*Label 8028*/ GIMT_Encode4(392381),
     /* 392243 */ // Label 8027: @392243
     /* 392243 */ GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(392302), // Rule ID 5786 //
     /* 392248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392259 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 392259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 392266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392271 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 392291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392301 */   // GIR_Coverage, 5786,
     /* 392301 */   GIR_EraseRootFromParent_Done,
     /* 392302 */ // Label 8030: @392302
     /* 392302 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(392380), // Rule ID 5908 //
     /* 392307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392318 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 392318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 392321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 392325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392330 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 392339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 392361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 392364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392379 */   // GIR_Coverage, 5908,
     /* 392379 */   GIR_EraseRootFromParent_Done,
     /* 392380 */ // Label 8031: @392380
     /* 392380 */ GIM_Reject,
     /* 392381 */ // Label 8028: @392381
     /* 392381 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(392440), // Rule ID 5782 //
     /* 392386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392397 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 392397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 392400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 392404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392409 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 392429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392439 */   // GIR_Coverage, 5782,
     /* 392439 */   GIR_EraseRootFromParent_Done,
     /* 392440 */ // Label 8032: @392440
     /* 392440 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(392499), // Rule ID 5783 //
     /* 392445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392456 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 392456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 392463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392498 */   // GIR_Coverage, 5783,
     /* 392498 */   GIR_EraseRootFromParent_Done,
     /* 392499 */ // Label 8033: @392499
     /* 392499 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(392558), // Rule ID 5784 //
     /* 392504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392515 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 392515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 392518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 392522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392527 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 392547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392557 */   // GIR_Coverage, 5784,
     /* 392557 */   GIR_EraseRootFromParent_Done,
     /* 392558 */ // Label 8034: @392558
     /* 392558 */ GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(392617), // Rule ID 5785 //
     /* 392563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392574 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 392574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 392581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392586 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392616 */   // GIR_Coverage, 5785,
     /* 392616 */   GIR_EraseRootFromParent_Done,
     /* 392617 */ // Label 8035: @392617
     /* 392617 */ GIM_Reject,
     /* 392618 */ // Label 8029: @392618
     /* 392618 */ GIM_Reject,
     /* 392619 */ // Label 138: @392619
     /* 392619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8040*/ GIMT_Encode4(392988),
     /* 392630 */ /*GILLT_v2s32*//*Label 8036*/ GIMT_Encode4(392690), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392642 */ /*GILLT_v4s32*//*Label 8037*/ GIMT_Encode4(392810), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392674 */ /*GILLT_nxv2s64*//*Label 8038*/ GIMT_Encode4(392930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392686 */ /*GILLT_nxv4s32*//*Label 8039*/ GIMT_Encode4(392959),
     /* 392690 */ // Label 8036: @392690
     /* 392690 */ GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(392809),
     /* 392695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 392701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 392704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392716 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(392789), // Rule ID 26 //
     /* 392721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392769 */     // MIs[3] Operand 1
     /* 392769 */     // No operand predicates
     /* 392769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392771 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 392774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392787 */     GIR_RootConstrainSelectedInstOperands,
     /* 392788 */     // GIR_Coverage, 26,
     /* 392788 */     GIR_EraseRootFromParent_Done,
     /* 392789 */   // Label 8042: @392789
     /* 392789 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(392808), // Rule ID 22 //
     /* 392794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392801 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 392801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 392806 */     GIR_RootConstrainSelectedInstOperands,
     /* 392807 */     // GIR_Coverage, 22,
     /* 392807 */     GIR_Done,
     /* 392808 */   // Label 8043: @392808
     /* 392808 */   GIM_Reject,
     /* 392809 */ // Label 8041: @392809
     /* 392809 */ GIM_Reject,
     /* 392810 */ // Label 8037: @392810
     /* 392810 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(392929),
     /* 392815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 392821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 392824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392836 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(392909), // Rule ID 27 //
     /* 392841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392889 */     // MIs[3] Operand 1
     /* 392889 */     // No operand predicates
     /* 392889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392891 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 392894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392907 */     GIR_RootConstrainSelectedInstOperands,
     /* 392908 */     // GIR_Coverage, 27,
     /* 392908 */     GIR_EraseRootFromParent_Done,
     /* 392909 */   // Label 8045: @392909
     /* 392909 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(392928), // Rule ID 23 //
     /* 392914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392921 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 392921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 392926 */     GIR_RootConstrainSelectedInstOperands,
     /* 392927 */     // GIR_Coverage, 23,
     /* 392927 */     GIR_Done,
     /* 392928 */   // Label 8046: @392928
     /* 392928 */   GIM_Reject,
     /* 392929 */ // Label 8044: @392929
     /* 392929 */ GIM_Reject,
     /* 392930 */ // Label 8038: @392930
     /* 392930 */ GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(392958), // Rule ID 2972 //
     /* 392935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 392941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 392944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 392947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392951 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 392951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 392956 */   GIR_RootConstrainSelectedInstOperands,
     /* 392957 */   // GIR_Coverage, 2972,
     /* 392957 */   GIR_Done,
     /* 392958 */ // Label 8047: @392958
     /* 392958 */ GIM_Reject,
     /* 392959 */ // Label 8039: @392959
     /* 392959 */ GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(392987), // Rule ID 2971 //
     /* 392964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 392973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 392976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392980 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 392980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 392985 */   GIR_RootConstrainSelectedInstOperands,
     /* 392986 */   // GIR_Coverage, 2971,
     /* 392986 */   GIR_Done,
     /* 392987 */ // Label 8048: @392987
     /* 392987 */ GIM_Reject,
     /* 392988 */ // Label 8040: @392988
     /* 392988 */ GIM_Reject,
     /* 392989 */ // Label 139: @392989
     /* 392989 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8052*/ GIMT_Encode4(393105),
     /* 393000 */ /*GILLT_s16*//*Label 8049*/ GIMT_Encode4(393012),
     /* 393004 */ /*GILLT_s32*//*Label 8050*/ GIMT_Encode4(393043),
     /* 393008 */ /*GILLT_s64*//*Label 8051*/ GIMT_Encode4(393074),
     /* 393012 */ // Label 8049: @393012
     /* 393012 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(393042), // Rule ID 1651 //
     /* 393017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 393020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393031 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 393036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393040 */   GIR_RootConstrainSelectedInstOperands,
     /* 393041 */   // GIR_Coverage, 1651,
     /* 393041 */   GIR_Done,
     /* 393042 */ // Label 8053: @393042
     /* 393042 */ GIM_Reject,
     /* 393043 */ // Label 8050: @393043
     /* 393043 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(393073), // Rule ID 1650 //
     /* 393048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 393051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393062 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 393067 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393071 */   GIR_RootConstrainSelectedInstOperands,
     /* 393072 */   // GIR_Coverage, 1650,
     /* 393072 */   GIR_Done,
     /* 393073 */ // Label 8054: @393073
     /* 393073 */ GIM_Reject,
     /* 393074 */ // Label 8051: @393074
     /* 393074 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(393104), // Rule ID 1649 //
     /* 393079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 393082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393093 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 393098 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393102 */   GIR_RootConstrainSelectedInstOperands,
     /* 393103 */   // GIR_Coverage, 1649,
     /* 393103 */   GIR_Done,
     /* 393104 */ // Label 8055: @393104
     /* 393104 */ GIM_Reject,
     /* 393105 */ // Label 8052: @393105
     /* 393105 */ GIM_Reject,
     /* 393106 */ // Label 140: @393106
     /* 393106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8059*/ GIMT_Encode4(394338),
     /* 393117 */ /*GILLT_v2s64*//*Label 8056*/ GIMT_Encode4(393137), GIMT_Encode4(0),
     /* 393125 */ /*GILLT_v4s32*//*Label 8057*/ GIMT_Encode4(393698), GIMT_Encode4(0),
     /* 393133 */ /*GILLT_v8s16*//*Label 8058*/ GIMT_Encode4(394259),
     /* 393137 */ // Label 8056: @393137
     /* 393137 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(393697),
     /* 393142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 393148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393152 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(393244), // Rule ID 2047 //
     /* 393157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393205 */     // MIs[3] Operand 1
     /* 393205 */     // No operand predicates
     /* 393205 */     // MIs[1] Operand 2
     /* 393205 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 393216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393225 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 393228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393242 */     GIR_RootConstrainSelectedInstOperands,
     /* 393243 */     // GIR_Coverage, 2047,
     /* 393243 */     GIR_EraseRootFromParent_Done,
     /* 393244 */   // Label 8061: @393244
     /* 393244 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(393336), // Rule ID 13245 //
     /* 393249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393297 */     // MIs[3] Operand 1
     /* 393297 */     // No operand predicates
     /* 393297 */     // MIs[1] Operand 2
     /* 393297 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 393308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393317 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 393320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393334 */     GIR_RootConstrainSelectedInstOperands,
     /* 393335 */     // GIR_Coverage, 13245,
     /* 393335 */     GIR_EraseRootFromParent_Done,
     /* 393336 */   // Label 8062: @393336
     /* 393336 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(393422), // Rule ID 13243 //
     /* 393341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393389 */     // MIs[3] Operand 1
     /* 393389 */     // No operand predicates
     /* 393389 */     // MIs[1] Operand 2
     /* 393389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393406 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393420 */     GIR_RootConstrainSelectedInstOperands,
     /* 393421 */     // GIR_Coverage, 13243,
     /* 393421 */     GIR_EraseRootFromParent_Done,
     /* 393422 */   // Label 8063: @393422
     /* 393422 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(393508), // Rule ID 2045 //
     /* 393427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393475 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393479 */     // MIs[3] Operand 1
     /* 393479 */     // No operand predicates
     /* 393479 */     // MIs[1] Operand 2
     /* 393479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393492 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393506 */     GIR_RootConstrainSelectedInstOperands,
     /* 393507 */     // GIR_Coverage, 2045,
     /* 393507 */     GIR_EraseRootFromParent_Done,
     /* 393508 */   // Label 8064: @393508
     /* 393508 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(393547), // Rule ID 1734 //
     /* 393513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393530 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 393530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 393533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393545 */     GIR_RootConstrainSelectedInstOperands,
     /* 393546 */     // GIR_Coverage, 1734,
     /* 393546 */     GIR_EraseRootFromParent_Done,
     /* 393547 */   // Label 8065: @393547
     /* 393547 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(393610), // Rule ID 13244 //
     /* 393552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393588 */     // MIs[2] Operand 1
     /* 393588 */     // No operand predicates
     /* 393588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393594 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393608 */     GIR_RootConstrainSelectedInstOperands,
     /* 393609 */     // GIR_Coverage, 13244,
     /* 393609 */     GIR_EraseRootFromParent_Done,
     /* 393610 */   // Label 8066: @393610
     /* 393610 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(393673), // Rule ID 2046 //
     /* 393615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393651 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393655 */     // MIs[2] Operand 1
     /* 393655 */     // No operand predicates
     /* 393655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393657 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393671 */     GIR_RootConstrainSelectedInstOperands,
     /* 393672 */     // GIR_Coverage, 2046,
     /* 393672 */     GIR_EraseRootFromParent_Done,
     /* 393673 */   // Label 8067: @393673
     /* 393673 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(393696), // Rule ID 1733 //
     /* 393678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393689 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 393689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 393694 */     GIR_RootConstrainSelectedInstOperands,
     /* 393695 */     // GIR_Coverage, 1733,
     /* 393695 */     GIR_Done,
     /* 393696 */   // Label 8068: @393696
     /* 393696 */   GIM_Reject,
     /* 393697 */ // Label 8060: @393697
     /* 393697 */ GIM_Reject,
     /* 393698 */ // Label 8057: @393698
     /* 393698 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(394258),
     /* 393703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393713 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(393805), // Rule ID 2044 //
     /* 393718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393762 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393766 */     // MIs[3] Operand 1
     /* 393766 */     // No operand predicates
     /* 393766 */     // MIs[1] Operand 2
     /* 393766 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393786 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393803 */     GIR_RootConstrainSelectedInstOperands,
     /* 393804 */     // GIR_Coverage, 2044,
     /* 393804 */     GIR_EraseRootFromParent_Done,
     /* 393805 */   // Label 8070: @393805
     /* 393805 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(393897), // Rule ID 13242 //
     /* 393810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393854 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393858 */     // MIs[3] Operand 1
     /* 393858 */     // No operand predicates
     /* 393858 */     // MIs[1] Operand 2
     /* 393858 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393878 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393895 */     GIR_RootConstrainSelectedInstOperands,
     /* 393896 */     // GIR_Coverage, 13242,
     /* 393896 */     GIR_EraseRootFromParent_Done,
     /* 393897 */   // Label 8071: @393897
     /* 393897 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(393983), // Rule ID 13240 //
     /* 393902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393946 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393950 */     // MIs[3] Operand 1
     /* 393950 */     // No operand predicates
     /* 393950 */     // MIs[1] Operand 2
     /* 393950 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393967 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393981 */     GIR_RootConstrainSelectedInstOperands,
     /* 393982 */     // GIR_Coverage, 13240,
     /* 393982 */     GIR_EraseRootFromParent_Done,
     /* 393983 */   // Label 8072: @393983
     /* 393983 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(394069), // Rule ID 2042 //
     /* 393988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 394015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 394023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 394028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 394040 */     // MIs[3] Operand 1
     /* 394040 */     // No operand predicates
     /* 394040 */     // MIs[1] Operand 2
     /* 394040 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394053 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 394053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 394056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394067 */     GIR_RootConstrainSelectedInstOperands,
     /* 394068 */     // GIR_Coverage, 2042,
     /* 394068 */     GIR_EraseRootFromParent_Done,
     /* 394069 */   // Label 8073: @394069
     /* 394069 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(394108), // Rule ID 1732 //
     /* 394074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 394084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 394091 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 394091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 394094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 394106 */     GIR_RootConstrainSelectedInstOperands,
     /* 394107 */     // GIR_Coverage, 1732,
     /* 394107 */     GIR_EraseRootFromParent_Done,
     /* 394108 */   // Label 8074: @394108
     /* 394108 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(394171), // Rule ID 13241 //
     /* 394113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 394124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 394137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 394149 */     // MIs[2] Operand 1
     /* 394149 */     // No operand predicates
     /* 394149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394155 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 394155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 394158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394169 */     GIR_RootConstrainSelectedInstOperands,
     /* 394170 */     // GIR_Coverage, 13241,
     /* 394170 */     GIR_EraseRootFromParent_Done,
     /* 394171 */   // Label 8075: @394171
     /* 394171 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(394234), // Rule ID 2043 //
     /* 394176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 394191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 394204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 394216 */     // MIs[2] Operand 1
     /* 394216 */     // No operand predicates
     /* 394216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394218 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 394218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 394221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394232 */     GIR_RootConstrainSelectedInstOperands,
     /* 394233 */     // GIR_Coverage, 2043,
     /* 394233 */     GIR_EraseRootFromParent_Done,
     /* 394234 */   // Label 8076: @394234
     /* 394234 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(394257), // Rule ID 1731 //
     /* 394239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394250 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 394255 */     GIR_RootConstrainSelectedInstOperands,
     /* 394256 */     // GIR_Coverage, 1731,
     /* 394256 */     GIR_Done,
     /* 394257 */   // Label 8077: @394257
     /* 394257 */   GIM_Reject,
     /* 394258 */ // Label 8069: @394258
     /* 394258 */ GIM_Reject,
     /* 394259 */ // Label 8058: @394259
     /* 394259 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(394337),
     /* 394264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394274 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(394313), // Rule ID 1730 //
     /* 394279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 394289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 394296 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 394296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 394299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 394311 */     GIR_RootConstrainSelectedInstOperands,
     /* 394312 */     // GIR_Coverage, 1730,
     /* 394312 */     GIR_EraseRootFromParent_Done,
     /* 394313 */   // Label 8079: @394313
     /* 394313 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(394336), // Rule ID 1729 //
     /* 394318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394329 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 394329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 394334 */     GIR_RootConstrainSelectedInstOperands,
     /* 394335 */     // GIR_Coverage, 1729,
     /* 394335 */     GIR_Done,
     /* 394336 */   // Label 8080: @394336
     /* 394336 */   GIM_Reject,
     /* 394337 */ // Label 8078: @394337
     /* 394337 */ GIM_Reject,
     /* 394338 */ // Label 8059: @394338
     /* 394338 */ GIM_Reject,
     /* 394339 */ // Label 141: @394339
     /* 394339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8099*/ GIMT_Encode4(395118),
     /* 394350 */ /*GILLT_v2s32*//*Label 8081*/ GIMT_Encode4(394426),
     /* 394354 */ /*GILLT_v2s64*//*Label 8082*/ GIMT_Encode4(394481),
     /* 394358 */ /*GILLT_v4s16*//*Label 8083*/ GIMT_Encode4(394536),
     /* 394362 */ /*GILLT_v4s32*//*Label 8084*/ GIMT_Encode4(394591),
     /* 394366 */ /*GILLT_v8s8*//*Label 8085*/ GIMT_Encode4(394646),
     /* 394370 */ /*GILLT_v8s16*//*Label 8086*/ GIMT_Encode4(394680),
     /* 394374 */ /*GILLT_v16s8*//*Label 8087*/ GIMT_Encode4(394735), GIMT_Encode4(0),
     /* 394382 */ /*GILLT_nxv2s1*//*Label 8088*/ GIMT_Encode4(394769),
     /* 394386 */ /*GILLT_nxv2s16*//*Label 8089*/ GIMT_Encode4(394795),
     /* 394390 */ /*GILLT_nxv2s32*//*Label 8090*/ GIMT_Encode4(394821),
     /* 394394 */ /*GILLT_nxv2s64*//*Label 8091*/ GIMT_Encode4(394847),
     /* 394398 */ /*GILLT_nxv4s1*//*Label 8092*/ GIMT_Encode4(394894),
     /* 394402 */ /*GILLT_nxv4s16*//*Label 8093*/ GIMT_Encode4(394920),
     /* 394406 */ /*GILLT_nxv4s32*//*Label 8094*/ GIMT_Encode4(394946),
     /* 394410 */ /*GILLT_nxv8s1*//*Label 8095*/ GIMT_Encode4(394993),
     /* 394414 */ /*GILLT_nxv8s16*//*Label 8096*/ GIMT_Encode4(395019),
     /* 394418 */ /*GILLT_nxv16s1*//*Label 8097*/ GIMT_Encode4(395066),
     /* 394422 */ /*GILLT_nxv16s8*//*Label 8098*/ GIMT_Encode4(395092),
     /* 394426 */ // Label 8081: @394426
     /* 394426 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(394480),
     /* 394431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394449 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(394464), // Rule ID 1867 //
     /* 394454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394457 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394462 */     GIR_RootConstrainSelectedInstOperands,
     /* 394463 */     // GIR_Coverage, 1867,
     /* 394463 */     GIR_Done,
     /* 394464 */   // Label 8101: @394464
     /* 394464 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(394479), // Rule ID 2496 //
     /* 394469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394472 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394477 */     GIR_RootConstrainSelectedInstOperands,
     /* 394478 */     // GIR_Coverage, 2496,
     /* 394478 */     GIR_Done,
     /* 394479 */   // Label 8102: @394479
     /* 394479 */   GIM_Reject,
     /* 394480 */ // Label 8100: @394480
     /* 394480 */ GIM_Reject,
     /* 394481 */ // Label 8082: @394481
     /* 394481 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(394535),
     /* 394486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394504 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(394519), // Rule ID 1869 //
     /* 394509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394512 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394517 */     GIR_RootConstrainSelectedInstOperands,
     /* 394518 */     // GIR_Coverage, 1869,
     /* 394518 */     GIR_Done,
     /* 394519 */   // Label 8104: @394519
     /* 394519 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(394534), // Rule ID 2498 //
     /* 394524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394527 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394532 */     GIR_RootConstrainSelectedInstOperands,
     /* 394533 */     // GIR_Coverage, 2498,
     /* 394533 */     GIR_Done,
     /* 394534 */   // Label 8105: @394534
     /* 394534 */   GIM_Reject,
     /* 394535 */ // Label 8103: @394535
     /* 394535 */ GIM_Reject,
     /* 394536 */ // Label 8083: @394536
     /* 394536 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(394590),
     /* 394541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394559 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(394574), // Rule ID 1865 //
     /* 394564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394567 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394572 */     GIR_RootConstrainSelectedInstOperands,
     /* 394573 */     // GIR_Coverage, 1865,
     /* 394573 */     GIR_Done,
     /* 394574 */   // Label 8107: @394574
     /* 394574 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(394589), // Rule ID 2494 //
     /* 394579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394582 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394587 */     GIR_RootConstrainSelectedInstOperands,
     /* 394588 */     // GIR_Coverage, 2494,
     /* 394588 */     GIR_Done,
     /* 394589 */   // Label 8108: @394589
     /* 394589 */   GIM_Reject,
     /* 394590 */ // Label 8106: @394590
     /* 394590 */ GIM_Reject,
     /* 394591 */ // Label 8084: @394591
     /* 394591 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(394645),
     /* 394596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394614 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(394629), // Rule ID 1868 //
     /* 394619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394622 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394627 */     GIR_RootConstrainSelectedInstOperands,
     /* 394628 */     // GIR_Coverage, 1868,
     /* 394628 */     GIR_Done,
     /* 394629 */   // Label 8110: @394629
     /* 394629 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(394644), // Rule ID 2497 //
     /* 394634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394637 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394642 */     GIR_RootConstrainSelectedInstOperands,
     /* 394643 */     // GIR_Coverage, 2497,
     /* 394643 */     GIR_Done,
     /* 394644 */   // Label 8111: @394644
     /* 394644 */   GIM_Reject,
     /* 394645 */ // Label 8109: @394645
     /* 394645 */ GIM_Reject,
     /* 394646 */ // Label 8085: @394646
     /* 394646 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(394679), // Rule ID 1863 //
     /* 394651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394672 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 394672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 394677 */   GIR_RootConstrainSelectedInstOperands,
     /* 394678 */   // GIR_Coverage, 1863,
     /* 394678 */   GIR_Done,
     /* 394679 */ // Label 8112: @394679
     /* 394679 */ GIM_Reject,
     /* 394680 */ // Label 8086: @394680
     /* 394680 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(394734),
     /* 394685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394703 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(394718), // Rule ID 1866 //
     /* 394708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394711 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 394711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394716 */     GIR_RootConstrainSelectedInstOperands,
     /* 394717 */     // GIR_Coverage, 1866,
     /* 394717 */     GIR_Done,
     /* 394718 */   // Label 8114: @394718
     /* 394718 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(394733), // Rule ID 2495 //
     /* 394723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394726 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394731 */     GIR_RootConstrainSelectedInstOperands,
     /* 394732 */     // GIR_Coverage, 2495,
     /* 394732 */     GIR_Done,
     /* 394733 */   // Label 8115: @394733
     /* 394733 */   GIM_Reject,
     /* 394734 */ // Label 8113: @394734
     /* 394734 */ GIM_Reject,
     /* 394735 */ // Label 8087: @394735
     /* 394735 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(394768), // Rule ID 1864 //
     /* 394740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 394749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394761 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 394761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 394766 */   GIR_RootConstrainSelectedInstOperands,
     /* 394767 */   // GIR_Coverage, 1864,
     /* 394767 */   GIR_Done,
     /* 394768 */ // Label 8116: @394768
     /* 394768 */ GIM_Reject,
     /* 394769 */ // Label 8088: @394769
     /* 394769 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(394794), // Rule ID 8813 //
     /* 394774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 394780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 394783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394787 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 394787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 394792 */   GIR_RootConstrainSelectedInstOperands,
     /* 394793 */   // GIR_Coverage, 8813,
     /* 394793 */   GIR_Done,
     /* 394794 */ // Label 8117: @394794
     /* 394794 */ GIM_Reject,
     /* 394795 */ // Label 8089: @394795
     /* 394795 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(394820), // Rule ID 8789 //
     /* 394800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 394806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 394809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394813 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 394813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394818 */   GIR_RootConstrainSelectedInstOperands,
     /* 394819 */   // GIR_Coverage, 8789,
     /* 394819 */   GIR_Done,
     /* 394820 */ // Label 8118: @394820
     /* 394820 */ GIM_Reject,
     /* 394821 */ // Label 8090: @394821
     /* 394821 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(394846), // Rule ID 8790 //
     /* 394826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 394832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 394835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394839 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 394839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394844 */   GIR_RootConstrainSelectedInstOperands,
     /* 394845 */   // GIR_Coverage, 8790,
     /* 394845 */   GIR_Done,
     /* 394846 */ // Label 8119: @394846
     /* 394846 */ GIM_Reject,
     /* 394847 */ // Label 8091: @394847
     /* 394847 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(394893),
     /* 394852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 394855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 394858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394862 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(394877), // Rule ID 8785 //
     /* 394867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394870 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 394870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394875 */     GIR_RootConstrainSelectedInstOperands,
     /* 394876 */     // GIR_Coverage, 8785,
     /* 394876 */     GIR_Done,
     /* 394877 */   // Label 8121: @394877
     /* 394877 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(394892), // Rule ID 8791 //
     /* 394882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394885 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 394885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394890 */     GIR_RootConstrainSelectedInstOperands,
     /* 394891 */     // GIR_Coverage, 8791,
     /* 394891 */     GIR_Done,
     /* 394892 */   // Label 8122: @394892
     /* 394892 */   GIM_Reject,
     /* 394893 */ // Label 8120: @394893
     /* 394893 */ GIM_Reject,
     /* 394894 */ // Label 8092: @394894
     /* 394894 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(394919), // Rule ID 8812 //
     /* 394899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 394905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 394908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394912 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 394912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 394917 */   GIR_RootConstrainSelectedInstOperands,
     /* 394918 */   // GIR_Coverage, 8812,
     /* 394918 */   GIR_Done,
     /* 394919 */ // Label 8123: @394919
     /* 394919 */ GIM_Reject,
     /* 394920 */ // Label 8093: @394920
     /* 394920 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(394945), // Rule ID 8787 //
     /* 394925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 394931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 394934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394938 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 394938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394943 */   GIR_RootConstrainSelectedInstOperands,
     /* 394944 */   // GIR_Coverage, 8787,
     /* 394944 */   GIR_Done,
     /* 394945 */ // Label 8124: @394945
     /* 394945 */ GIM_Reject,
     /* 394946 */ // Label 8094: @394946
     /* 394946 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(394992),
     /* 394951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 394954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 394957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394961 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(394976), // Rule ID 8784 //
     /* 394966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394969 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 394969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394974 */     GIR_RootConstrainSelectedInstOperands,
     /* 394975 */     // GIR_Coverage, 8784,
     /* 394975 */     GIR_Done,
     /* 394976 */   // Label 8126: @394976
     /* 394976 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(394991), // Rule ID 8788 //
     /* 394981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394984 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 394984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394989 */     GIR_RootConstrainSelectedInstOperands,
     /* 394990 */     // GIR_Coverage, 8788,
     /* 394990 */     GIR_Done,
     /* 394991 */   // Label 8127: @394991
     /* 394991 */   GIM_Reject,
     /* 394992 */ // Label 8125: @394992
     /* 394992 */ GIM_Reject,
     /* 394993 */ // Label 8095: @394993
     /* 394993 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(395018), // Rule ID 8811 //
     /* 394998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 395004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 395007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395011 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 395011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 395016 */   GIR_RootConstrainSelectedInstOperands,
     /* 395017 */   // GIR_Coverage, 8811,
     /* 395017 */   GIR_Done,
     /* 395018 */ // Label 8128: @395018
     /* 395018 */ GIM_Reject,
     /* 395019 */ // Label 8096: @395019
     /* 395019 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(395065),
     /* 395024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395034 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(395049), // Rule ID 8783 //
     /* 395039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395042 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 395042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 395047 */     GIR_RootConstrainSelectedInstOperands,
     /* 395048 */     // GIR_Coverage, 8783,
     /* 395048 */     GIR_Done,
     /* 395049 */   // Label 8130: @395049
     /* 395049 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(395064), // Rule ID 8786 //
     /* 395054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395057 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 395057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 395062 */     GIR_RootConstrainSelectedInstOperands,
     /* 395063 */     // GIR_Coverage, 8786,
     /* 395063 */     GIR_Done,
     /* 395064 */   // Label 8131: @395064
     /* 395064 */   GIM_Reject,
     /* 395065 */ // Label 8129: @395065
     /* 395065 */ GIM_Reject,
     /* 395066 */ // Label 8097: @395066
     /* 395066 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(395091), // Rule ID 2405 //
     /* 395071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 395077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 395080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395084 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 395084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 395089 */   GIR_RootConstrainSelectedInstOperands,
     /* 395090 */   // GIR_Coverage, 2405,
     /* 395090 */   GIR_Done,
     /* 395091 */ // Label 8132: @395091
     /* 395091 */ GIM_Reject,
     /* 395092 */ // Label 8098: @395092
     /* 395092 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(395117), // Rule ID 8782 //
     /* 395097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395110 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 395110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 395115 */   GIR_RootConstrainSelectedInstOperands,
     /* 395116 */   // GIR_Coverage, 8782,
     /* 395116 */   GIR_Done,
     /* 395117 */ // Label 8133: @395117
     /* 395117 */ GIM_Reject,
     /* 395118 */ // Label 8099: @395118
     /* 395118 */ GIM_Reject,
     /* 395119 */ // Label 142: @395119
     /* 395119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8152*/ GIMT_Encode4(395898),
     /* 395130 */ /*GILLT_v2s32*//*Label 8134*/ GIMT_Encode4(395206),
     /* 395134 */ /*GILLT_v2s64*//*Label 8135*/ GIMT_Encode4(395261),
     /* 395138 */ /*GILLT_v4s16*//*Label 8136*/ GIMT_Encode4(395316),
     /* 395142 */ /*GILLT_v4s32*//*Label 8137*/ GIMT_Encode4(395371),
     /* 395146 */ /*GILLT_v8s8*//*Label 8138*/ GIMT_Encode4(395426),
     /* 395150 */ /*GILLT_v8s16*//*Label 8139*/ GIMT_Encode4(395460),
     /* 395154 */ /*GILLT_v16s8*//*Label 8140*/ GIMT_Encode4(395515), GIMT_Encode4(0),
     /* 395162 */ /*GILLT_nxv2s1*//*Label 8141*/ GIMT_Encode4(395549),
     /* 395166 */ /*GILLT_nxv2s16*//*Label 8142*/ GIMT_Encode4(395575),
     /* 395170 */ /*GILLT_nxv2s32*//*Label 8143*/ GIMT_Encode4(395601),
     /* 395174 */ /*GILLT_nxv2s64*//*Label 8144*/ GIMT_Encode4(395627),
     /* 395178 */ /*GILLT_nxv4s1*//*Label 8145*/ GIMT_Encode4(395674),
     /* 395182 */ /*GILLT_nxv4s16*//*Label 8146*/ GIMT_Encode4(395700),
     /* 395186 */ /*GILLT_nxv4s32*//*Label 8147*/ GIMT_Encode4(395726),
     /* 395190 */ /*GILLT_nxv8s1*//*Label 8148*/ GIMT_Encode4(395773),
     /* 395194 */ /*GILLT_nxv8s16*//*Label 8149*/ GIMT_Encode4(395799),
     /* 395198 */ /*GILLT_nxv16s1*//*Label 8150*/ GIMT_Encode4(395846),
     /* 395202 */ /*GILLT_nxv16s8*//*Label 8151*/ GIMT_Encode4(395872),
     /* 395206 */ // Label 8134: @395206
     /* 395206 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(395260),
     /* 395211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395229 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(395244), // Rule ID 1874 //
     /* 395234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395237 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 395237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 395242 */     GIR_RootConstrainSelectedInstOperands,
     /* 395243 */     // GIR_Coverage, 1874,
     /* 395243 */     GIR_Done,
     /* 395244 */   // Label 8154: @395244
     /* 395244 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(395259), // Rule ID 5405 //
     /* 395249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395252 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 395257 */     GIR_RootConstrainSelectedInstOperands,
     /* 395258 */     // GIR_Coverage, 5405,
     /* 395258 */     GIR_Done,
     /* 395259 */   // Label 8155: @395259
     /* 395259 */   GIM_Reject,
     /* 395260 */ // Label 8153: @395260
     /* 395260 */ GIM_Reject,
     /* 395261 */ // Label 8135: @395261
     /* 395261 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(395315),
     /* 395266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395284 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(395299), // Rule ID 1876 //
     /* 395289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395292 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 395292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 395297 */     GIR_RootConstrainSelectedInstOperands,
     /* 395298 */     // GIR_Coverage, 1876,
     /* 395298 */     GIR_Done,
     /* 395299 */   // Label 8157: @395299
     /* 395299 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(395314), // Rule ID 5407 //
     /* 395304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395307 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 395312 */     GIR_RootConstrainSelectedInstOperands,
     /* 395313 */     // GIR_Coverage, 5407,
     /* 395313 */     GIR_Done,
     /* 395314 */   // Label 8158: @395314
     /* 395314 */   GIM_Reject,
     /* 395315 */ // Label 8156: @395315
     /* 395315 */ GIM_Reject,
     /* 395316 */ // Label 8136: @395316
     /* 395316 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(395370),
     /* 395321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395339 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(395354), // Rule ID 1872 //
     /* 395344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395347 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 395347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 395352 */     GIR_RootConstrainSelectedInstOperands,
     /* 395353 */     // GIR_Coverage, 1872,
     /* 395353 */     GIR_Done,
     /* 395354 */   // Label 8160: @395354
     /* 395354 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(395369), // Rule ID 5403 //
     /* 395359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395362 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 395367 */     GIR_RootConstrainSelectedInstOperands,
     /* 395368 */     // GIR_Coverage, 5403,
     /* 395368 */     GIR_Done,
     /* 395369 */   // Label 8161: @395369
     /* 395369 */   GIM_Reject,
     /* 395370 */ // Label 8159: @395370
     /* 395370 */ GIM_Reject,
     /* 395371 */ // Label 8137: @395371
     /* 395371 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(395425),
     /* 395376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395394 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(395409), // Rule ID 1875 //
     /* 395399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395402 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 395402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 395407 */     GIR_RootConstrainSelectedInstOperands,
     /* 395408 */     // GIR_Coverage, 1875,
     /* 395408 */     GIR_Done,
     /* 395409 */   // Label 8163: @395409
     /* 395409 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(395424), // Rule ID 5406 //
     /* 395414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395417 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 395422 */     GIR_RootConstrainSelectedInstOperands,
     /* 395423 */     // GIR_Coverage, 5406,
     /* 395423 */     GIR_Done,
     /* 395424 */   // Label 8164: @395424
     /* 395424 */   GIM_Reject,
     /* 395425 */ // Label 8162: @395425
     /* 395425 */ GIM_Reject,
     /* 395426 */ // Label 8138: @395426
     /* 395426 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(395459), // Rule ID 1870 //
     /* 395431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 395440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395452 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 395457 */   GIR_RootConstrainSelectedInstOperands,
     /* 395458 */   // GIR_Coverage, 1870,
     /* 395458 */   GIR_Done,
     /* 395459 */ // Label 8165: @395459
     /* 395459 */ GIM_Reject,
     /* 395460 */ // Label 8139: @395460
     /* 395460 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(395514),
     /* 395465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395483 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(395498), // Rule ID 1873 //
     /* 395488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395491 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395496 */     GIR_RootConstrainSelectedInstOperands,
     /* 395497 */     // GIR_Coverage, 1873,
     /* 395497 */     GIR_Done,
     /* 395498 */   // Label 8167: @395498
     /* 395498 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(395513), // Rule ID 5404 //
     /* 395503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395506 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395511 */     GIR_RootConstrainSelectedInstOperands,
     /* 395512 */     // GIR_Coverage, 5404,
     /* 395512 */     GIR_Done,
     /* 395513 */   // Label 8168: @395513
     /* 395513 */   GIM_Reject,
     /* 395514 */ // Label 8166: @395514
     /* 395514 */ GIM_Reject,
     /* 395515 */ // Label 8140: @395515
     /* 395515 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(395548), // Rule ID 1871 //
     /* 395520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395541 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 395546 */   GIR_RootConstrainSelectedInstOperands,
     /* 395547 */   // GIR_Coverage, 1871,
     /* 395547 */   GIR_Done,
     /* 395548 */ // Label 8169: @395548
     /* 395548 */ GIM_Reject,
     /* 395549 */ // Label 8141: @395549
     /* 395549 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(395574), // Rule ID 8816 //
     /* 395554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 395560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 395563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395567 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 395567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 395572 */   GIR_RootConstrainSelectedInstOperands,
     /* 395573 */   // GIR_Coverage, 8816,
     /* 395573 */   GIR_Done,
     /* 395574 */ // Label 8170: @395574
     /* 395574 */ GIM_Reject,
     /* 395575 */ // Label 8142: @395575
     /* 395575 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(395600), // Rule ID 8799 //
     /* 395580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 395586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 395589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395593 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 395593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395598 */   GIR_RootConstrainSelectedInstOperands,
     /* 395599 */   // GIR_Coverage, 8799,
     /* 395599 */   GIR_Done,
     /* 395600 */ // Label 8171: @395600
     /* 395600 */ GIM_Reject,
     /* 395601 */ // Label 8143: @395601
     /* 395601 */ GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(395626), // Rule ID 8800 //
     /* 395606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 395612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 395615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395619 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 395619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395624 */   GIR_RootConstrainSelectedInstOperands,
     /* 395625 */   // GIR_Coverage, 8800,
     /* 395625 */   GIR_Done,
     /* 395626 */ // Label 8172: @395626
     /* 395626 */ GIM_Reject,
     /* 395627 */ // Label 8144: @395627
     /* 395627 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(395673),
     /* 395632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395642 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(395657), // Rule ID 8795 //
     /* 395647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395650 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 395650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395655 */     GIR_RootConstrainSelectedInstOperands,
     /* 395656 */     // GIR_Coverage, 8795,
     /* 395656 */     GIR_Done,
     /* 395657 */   // Label 8174: @395657
     /* 395657 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(395672), // Rule ID 8801 //
     /* 395662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395665 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 395665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395670 */     GIR_RootConstrainSelectedInstOperands,
     /* 395671 */     // GIR_Coverage, 8801,
     /* 395671 */     GIR_Done,
     /* 395672 */   // Label 8175: @395672
     /* 395672 */   GIM_Reject,
     /* 395673 */ // Label 8173: @395673
     /* 395673 */ GIM_Reject,
     /* 395674 */ // Label 8145: @395674
     /* 395674 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(395699), // Rule ID 8815 //
     /* 395679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 395685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 395688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395692 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 395692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 395697 */   GIR_RootConstrainSelectedInstOperands,
     /* 395698 */   // GIR_Coverage, 8815,
     /* 395698 */   GIR_Done,
     /* 395699 */ // Label 8176: @395699
     /* 395699 */ GIM_Reject,
     /* 395700 */ // Label 8146: @395700
     /* 395700 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(395725), // Rule ID 8797 //
     /* 395705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 395711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 395714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395718 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 395718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395723 */   GIR_RootConstrainSelectedInstOperands,
     /* 395724 */   // GIR_Coverage, 8797,
     /* 395724 */   GIR_Done,
     /* 395725 */ // Label 8177: @395725
     /* 395725 */ GIM_Reject,
     /* 395726 */ // Label 8147: @395726
     /* 395726 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(395772),
     /* 395731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395741 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(395756), // Rule ID 8794 //
     /* 395746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395749 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 395749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395754 */     GIR_RootConstrainSelectedInstOperands,
     /* 395755 */     // GIR_Coverage, 8794,
     /* 395755 */     GIR_Done,
     /* 395756 */   // Label 8179: @395756
     /* 395756 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(395771), // Rule ID 8798 //
     /* 395761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395764 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 395764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395769 */     GIR_RootConstrainSelectedInstOperands,
     /* 395770 */     // GIR_Coverage, 8798,
     /* 395770 */     GIR_Done,
     /* 395771 */   // Label 8180: @395771
     /* 395771 */   GIM_Reject,
     /* 395772 */ // Label 8178: @395772
     /* 395772 */ GIM_Reject,
     /* 395773 */ // Label 8148: @395773
     /* 395773 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(395798), // Rule ID 8814 //
     /* 395778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 395784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 395787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395791 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 395791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 395796 */   GIR_RootConstrainSelectedInstOperands,
     /* 395797 */   // GIR_Coverage, 8814,
     /* 395797 */   GIR_Done,
     /* 395798 */ // Label 8181: @395798
     /* 395798 */ GIM_Reject,
     /* 395799 */ // Label 8149: @395799
     /* 395799 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(395845),
     /* 395804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395814 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(395829), // Rule ID 8793 //
     /* 395819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395822 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 395822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395827 */     GIR_RootConstrainSelectedInstOperands,
     /* 395828 */     // GIR_Coverage, 8793,
     /* 395828 */     GIR_Done,
     /* 395829 */   // Label 8183: @395829
     /* 395829 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(395844), // Rule ID 8796 //
     /* 395834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395837 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 395837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395842 */     GIR_RootConstrainSelectedInstOperands,
     /* 395843 */     // GIR_Coverage, 8796,
     /* 395843 */     GIR_Done,
     /* 395844 */   // Label 8184: @395844
     /* 395844 */   GIM_Reject,
     /* 395845 */ // Label 8182: @395845
     /* 395845 */ GIM_Reject,
     /* 395846 */ // Label 8150: @395846
     /* 395846 */ GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(395871), // Rule ID 2409 //
     /* 395851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 395857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 395860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395864 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 395864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 395869 */   GIR_RootConstrainSelectedInstOperands,
     /* 395870 */   // GIR_Coverage, 2409,
     /* 395870 */   GIR_Done,
     /* 395871 */ // Label 8185: @395871
     /* 395871 */ GIM_Reject,
     /* 395872 */ // Label 8151: @395872
     /* 395872 */ GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(395897), // Rule ID 8792 //
     /* 395877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395890 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 395890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 395895 */   GIR_RootConstrainSelectedInstOperands,
     /* 395896 */   // GIR_Coverage, 8792,
     /* 395896 */   GIR_Done,
     /* 395897 */ // Label 8186: @395897
     /* 395897 */ GIM_Reject,
     /* 395898 */ // Label 8152: @395898
     /* 395898 */ GIM_Reject,
     /* 395899 */ // Label 143: @395899
     /* 395899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8193*/ GIMT_Encode4(396104),
     /* 395910 */ /*GILLT_s64*//*Label 8187*/ GIMT_Encode4(395942), GIMT_Encode4(0),
     /* 395918 */ /*GILLT_v2s32*//*Label 8188*/ GIMT_Encode4(395969),
     /* 395922 */ /*GILLT_v2s64*//*Label 8189*/ GIMT_Encode4(395996),
     /* 395926 */ /*GILLT_v4s16*//*Label 8190*/ GIMT_Encode4(396023),
     /* 395930 */ /*GILLT_v4s32*//*Label 8191*/ GIMT_Encode4(396050), GIMT_Encode4(0),
     /* 395938 */ /*GILLT_v8s16*//*Label 8192*/ GIMT_Encode4(396077),
     /* 395942 */ // Label 8187: @395942
     /* 395942 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(395968), // Rule ID 1062 //
     /* 395947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395961 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 395961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 395966 */   GIR_RootConstrainSelectedInstOperands,
     /* 395967 */   // GIR_Coverage, 1062,
     /* 395967 */   GIR_Done,
     /* 395968 */ // Label 8194: @395968
     /* 395968 */ GIM_Reject,
     /* 395969 */ // Label 8188: @395969
     /* 395969 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(395995), // Rule ID 1058 //
     /* 395974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395988 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 395988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 395993 */   GIR_RootConstrainSelectedInstOperands,
     /* 395994 */   // GIR_Coverage, 1058,
     /* 395994 */   GIR_Done,
     /* 395995 */ // Label 8195: @395995
     /* 395995 */ GIM_Reject,
     /* 395996 */ // Label 8189: @395996
     /* 395996 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(396022), // Rule ID 1064 //
     /* 396001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396015 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 396015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 396020 */   GIR_RootConstrainSelectedInstOperands,
     /* 396021 */   // GIR_Coverage, 1064,
     /* 396021 */   GIR_Done,
     /* 396022 */ // Label 8196: @396022
     /* 396022 */ GIM_Reject,
     /* 396023 */ // Label 8190: @396023
     /* 396023 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(396049), // Rule ID 1054 //
     /* 396028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396042 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 396042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 396047 */   GIR_RootConstrainSelectedInstOperands,
     /* 396048 */   // GIR_Coverage, 1054,
     /* 396048 */   GIR_Done,
     /* 396049 */ // Label 8197: @396049
     /* 396049 */ GIM_Reject,
     /* 396050 */ // Label 8191: @396050
     /* 396050 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(396076), // Rule ID 1060 //
     /* 396055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396069 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 396069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 396074 */   GIR_RootConstrainSelectedInstOperands,
     /* 396075 */   // GIR_Coverage, 1060,
     /* 396075 */   GIR_Done,
     /* 396076 */ // Label 8198: @396076
     /* 396076 */ GIM_Reject,
     /* 396077 */ // Label 8192: @396077
     /* 396077 */ GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(396103), // Rule ID 1056 //
     /* 396082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396096 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 396096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 396101 */   GIR_RootConstrainSelectedInstOperands,
     /* 396102 */   // GIR_Coverage, 1056,
     /* 396102 */   GIR_Done,
     /* 396103 */ // Label 8199: @396103
     /* 396103 */ GIM_Reject,
     /* 396104 */ // Label 8193: @396104
     /* 396104 */ GIM_Reject,
     /* 396105 */ // Label 144: @396105
     /* 396105 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8202*/ GIMT_Encode4(396971),
     /* 396116 */ /*GILLT_v2s64*//*Label 8200*/ GIMT_Encode4(396128), GIMT_Encode4(0),
     /* 396124 */ /*GILLT_v4s32*//*Label 8201*/ GIMT_Encode4(396422),
     /* 396128 */ // Label 8200: @396128
     /* 396128 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(396210), // Rule ID 5772 //
     /* 396133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396148 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396151 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396156 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396167 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 396167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396179 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396209 */   // GIR_Coverage, 5772,
     /* 396209 */   GIR_EraseRootFromParent_Done,
     /* 396210 */ // Label 8203: @396210
     /* 396210 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(396284), // Rule ID 5771 //
     /* 396215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396222 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396226 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396230 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396234 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396241 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 396241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396253 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396283 */   // GIR_Coverage, 5771,
     /* 396283 */   GIR_EraseRootFromParent_Done,
     /* 396284 */ // Label 8204: @396284
     /* 396284 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(396343), // Rule ID 5781 //
     /* 396289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396300 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 396300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 396307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396312 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 396332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396342 */   // GIR_Coverage, 5781,
     /* 396342 */   GIR_EraseRootFromParent_Done,
     /* 396343 */ // Label 8205: @396343
     /* 396343 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(396421), // Rule ID 5909 //
     /* 396348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396359 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 396359 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 396362 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 396366 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396371 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 396380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 396402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 396405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396420 */   // GIR_Coverage, 5909,
     /* 396420 */   GIR_EraseRootFromParent_Done,
     /* 396421 */ // Label 8206: @396421
     /* 396421 */ GIM_Reject,
     /* 396422 */ // Label 8201: @396422
     /* 396422 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(396504), // Rule ID 5774 //
     /* 396427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396442 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396445 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396461 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396473 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396503 */   // GIR_Coverage, 5774,
     /* 396503 */   GIR_EraseRootFromParent_Done,
     /* 396504 */ // Label 8207: @396504
     /* 396504 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(396586), // Rule ID 5776 //
     /* 396509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396520 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396524 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396527 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396543 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396585 */   // GIR_Coverage, 5776,
     /* 396585 */   GIR_EraseRootFromParent_Done,
     /* 396586 */ // Label 8208: @396586
     /* 396586 */ GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(396660), // Rule ID 5773 //
     /* 396591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396606 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396610 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396617 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396629 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396659 */   // GIR_Coverage, 5773,
     /* 396659 */   GIR_EraseRootFromParent_Done,
     /* 396660 */ // Label 8209: @396660
     /* 396660 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(396734), // Rule ID 5775 //
     /* 396665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396680 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396684 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396689 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396691 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396703 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396733 */   // GIR_Coverage, 5775,
     /* 396733 */   GIR_EraseRootFromParent_Done,
     /* 396734 */ // Label 8210: @396734
     /* 396734 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(396793), // Rule ID 5777 //
     /* 396739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396750 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 396750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396762 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396792 */   // GIR_Coverage, 5777,
     /* 396792 */   GIR_EraseRootFromParent_Done,
     /* 396793 */ // Label 8211: @396793
     /* 396793 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(396852), // Rule ID 5778 //
     /* 396798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396809 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 396809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 396816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396851 */   // GIR_Coverage, 5778,
     /* 396851 */   GIR_EraseRootFromParent_Done,
     /* 396852 */ // Label 8212: @396852
     /* 396852 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(396911), // Rule ID 5779 //
     /* 396857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396868 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 396868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396880 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396900 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396910 */   // GIR_Coverage, 5779,
     /* 396910 */   GIR_EraseRootFromParent_Done,
     /* 396911 */ // Label 8213: @396911
     /* 396911 */ GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(396970), // Rule ID 5780 //
     /* 396916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396927 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 396927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396939 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396969 */   // GIR_Coverage, 5780,
     /* 396969 */   GIR_EraseRootFromParent_Done,
     /* 396970 */ // Label 8214: @396970
     /* 396970 */ GIM_Reject,
     /* 396971 */ // Label 8202: @396971
     /* 396971 */ GIM_Reject,
     /* 396972 */ // Label 145: @396972
     /* 396972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8219*/ GIMT_Encode4(397341),
     /* 396983 */ /*GILLT_v2s32*//*Label 8215*/ GIMT_Encode4(397043), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396995 */ /*GILLT_v4s32*//*Label 8216*/ GIMT_Encode4(397163), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397027 */ /*GILLT_nxv2s64*//*Label 8217*/ GIMT_Encode4(397283), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397039 */ /*GILLT_nxv4s32*//*Label 8218*/ GIMT_Encode4(397312),
     /* 397043 */ // Label 8215: @397043
     /* 397043 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(397162),
     /* 397048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 397054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 397057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397069 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(397142), // Rule ID 28 //
     /* 397074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 397077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 397081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 397085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397118 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397122 */     // MIs[3] Operand 1
     /* 397122 */     // No operand predicates
     /* 397122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397124 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 397127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 397131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397140 */     GIR_RootConstrainSelectedInstOperands,
     /* 397141 */     // GIR_Coverage, 28,
     /* 397141 */     GIR_EraseRootFromParent_Done,
     /* 397142 */   // Label 8221: @397142
     /* 397142 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(397161), // Rule ID 24 //
     /* 397147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 397150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397154 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 397154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 397159 */     GIR_RootConstrainSelectedInstOperands,
     /* 397160 */     // GIR_Coverage, 24,
     /* 397160 */     GIR_Done,
     /* 397161 */   // Label 8222: @397161
     /* 397161 */   GIM_Reject,
     /* 397162 */ // Label 8220: @397162
     /* 397162 */ GIM_Reject,
     /* 397163 */ // Label 8216: @397163
     /* 397163 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(397282),
     /* 397168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 397174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 397177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397189 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(397262), // Rule ID 29 //
     /* 397194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 397197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 397201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 397205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397238 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397242 */     // MIs[3] Operand 1
     /* 397242 */     // No operand predicates
     /* 397242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397244 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 397247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 397251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397260 */     GIR_RootConstrainSelectedInstOperands,
     /* 397261 */     // GIR_Coverage, 29,
     /* 397261 */     GIR_EraseRootFromParent_Done,
     /* 397262 */   // Label 8224: @397262
     /* 397262 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(397281), // Rule ID 25 //
     /* 397267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 397270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397274 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 397274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 397279 */     GIR_RootConstrainSelectedInstOperands,
     /* 397280 */     // GIR_Coverage, 25,
     /* 397280 */     GIR_Done,
     /* 397281 */   // Label 8225: @397281
     /* 397281 */   GIM_Reject,
     /* 397282 */ // Label 8223: @397282
     /* 397282 */ GIM_Reject,
     /* 397283 */ // Label 8217: @397283
     /* 397283 */ GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(397311), // Rule ID 7503 //
     /* 397288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 397294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 397297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 397300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397304 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 397304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 397309 */   GIR_RootConstrainSelectedInstOperands,
     /* 397310 */   // GIR_Coverage, 7503,
     /* 397310 */   GIR_Done,
     /* 397311 */ // Label 8226: @397311
     /* 397311 */ GIM_Reject,
     /* 397312 */ // Label 8218: @397312
     /* 397312 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(397340), // Rule ID 7502 //
     /* 397317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 397320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 397323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 397326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 397329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 397333 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 397333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 397338 */   GIR_RootConstrainSelectedInstOperands,
     /* 397339 */   // GIR_Coverage, 7502,
     /* 397339 */   GIR_Done,
     /* 397340 */ // Label 8227: @397340
     /* 397340 */ GIM_Reject,
     /* 397341 */ // Label 8219: @397341
     /* 397341 */ GIM_Reject,
     /* 397342 */ // Label 146: @397342
     /* 397342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8231*/ GIMT_Encode4(397458),
     /* 397353 */ /*GILLT_s16*//*Label 8228*/ GIMT_Encode4(397365),
     /* 397357 */ /*GILLT_s32*//*Label 8229*/ GIMT_Encode4(397396),
     /* 397361 */ /*GILLT_s64*//*Label 8230*/ GIMT_Encode4(397427),
     /* 397365 */ // Label 8228: @397365
     /* 397365 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(397395), // Rule ID 1662 //
     /* 397370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 397373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397384 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 397384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 397389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397393 */   GIR_RootConstrainSelectedInstOperands,
     /* 397394 */   // GIR_Coverage, 1662,
     /* 397394 */   GIR_Done,
     /* 397395 */ // Label 8232: @397395
     /* 397395 */ GIM_Reject,
     /* 397396 */ // Label 8229: @397396
     /* 397396 */ GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(397426), // Rule ID 1661 //
     /* 397401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 397404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397415 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 397415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 397420 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397424 */   GIR_RootConstrainSelectedInstOperands,
     /* 397425 */   // GIR_Coverage, 1661,
     /* 397425 */   GIR_Done,
     /* 397426 */ // Label 8233: @397426
     /* 397426 */ GIM_Reject,
     /* 397427 */ // Label 8230: @397427
     /* 397427 */ GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(397457), // Rule ID 1660 //
     /* 397432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 397435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397446 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 397446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 397451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397455 */   GIR_RootConstrainSelectedInstOperands,
     /* 397456 */   // GIR_Coverage, 1660,
     /* 397456 */   GIR_Done,
     /* 397457 */ // Label 8234: @397457
     /* 397457 */ GIM_Reject,
     /* 397458 */ // Label 8231: @397458
     /* 397458 */ GIM_Reject,
     /* 397459 */ // Label 147: @397459
     /* 397459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8238*/ GIMT_Encode4(398691),
     /* 397470 */ /*GILLT_v2s64*//*Label 8235*/ GIMT_Encode4(397490), GIMT_Encode4(0),
     /* 397478 */ /*GILLT_v4s32*//*Label 8236*/ GIMT_Encode4(398051), GIMT_Encode4(0),
     /* 397486 */ /*GILLT_v8s16*//*Label 8237*/ GIMT_Encode4(398612),
     /* 397490 */ // Label 8235: @397490
     /* 397490 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(398050),
     /* 397495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397505 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(397597), // Rule ID 2099 //
     /* 397510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397554 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397558 */     // MIs[3] Operand 1
     /* 397558 */     // No operand predicates
     /* 397558 */     // MIs[1] Operand 2
     /* 397558 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397578 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397595 */     GIR_RootConstrainSelectedInstOperands,
     /* 397596 */     // GIR_Coverage, 2099,
     /* 397596 */     GIR_EraseRootFromParent_Done,
     /* 397597 */   // Label 8240: @397597
     /* 397597 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(397689), // Rule ID 13275 //
     /* 397602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397646 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397650 */     // MIs[3] Operand 1
     /* 397650 */     // No operand predicates
     /* 397650 */     // MIs[1] Operand 2
     /* 397650 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397670 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397687 */     GIR_RootConstrainSelectedInstOperands,
     /* 397688 */     // GIR_Coverage, 13275,
     /* 397688 */     GIR_EraseRootFromParent_Done,
     /* 397689 */   // Label 8241: @397689
     /* 397689 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(397775), // Rule ID 13273 //
     /* 397694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397742 */     // MIs[3] Operand 1
     /* 397742 */     // No operand predicates
     /* 397742 */     // MIs[1] Operand 2
     /* 397742 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397759 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397773 */     GIR_RootConstrainSelectedInstOperands,
     /* 397774 */     // GIR_Coverage, 13273,
     /* 397774 */     GIR_EraseRootFromParent_Done,
     /* 397775 */   // Label 8242: @397775
     /* 397775 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(397861), // Rule ID 2097 //
     /* 397780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397832 */     // MIs[3] Operand 1
     /* 397832 */     // No operand predicates
     /* 397832 */     // MIs[1] Operand 2
     /* 397832 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397845 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397859 */     GIR_RootConstrainSelectedInstOperands,
     /* 397860 */     // GIR_Coverage, 2097,
     /* 397860 */     GIR_EraseRootFromParent_Done,
     /* 397861 */   // Label 8243: @397861
     /* 397861 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(397900), // Rule ID 1824 //
     /* 397866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397883 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 397883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 397886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 397898 */     GIR_RootConstrainSelectedInstOperands,
     /* 397899 */     // GIR_Coverage, 1824,
     /* 397899 */     GIR_EraseRootFromParent_Done,
     /* 397900 */   // Label 8244: @397900
     /* 397900 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(397963), // Rule ID 13274 //
     /* 397905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397941 */     // MIs[2] Operand 1
     /* 397941 */     // No operand predicates
     /* 397941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397947 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397961 */     GIR_RootConstrainSelectedInstOperands,
     /* 397962 */     // GIR_Coverage, 13274,
     /* 397962 */     GIR_EraseRootFromParent_Done,
     /* 397963 */   // Label 8245: @397963
     /* 397963 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(398026), // Rule ID 2098 //
     /* 397968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398008 */     // MIs[2] Operand 1
     /* 398008 */     // No operand predicates
     /* 398008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398010 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 398013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398024 */     GIR_RootConstrainSelectedInstOperands,
     /* 398025 */     // GIR_Coverage, 2098,
     /* 398025 */     GIR_EraseRootFromParent_Done,
     /* 398026 */   // Label 8246: @398026
     /* 398026 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(398049), // Rule ID 1823 //
     /* 398031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398042 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 398042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 398047 */     GIR_RootConstrainSelectedInstOperands,
     /* 398048 */     // GIR_Coverage, 1823,
     /* 398048 */     GIR_Done,
     /* 398049 */   // Label 8247: @398049
     /* 398049 */   GIM_Reject,
     /* 398050 */ // Label 8239: @398050
     /* 398050 */ GIM_Reject,
     /* 398051 */ // Label 8236: @398051
     /* 398051 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(398611),
     /* 398056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398066 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(398158), // Rule ID 2096 //
     /* 398071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398115 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398119 */     // MIs[3] Operand 1
     /* 398119 */     // No operand predicates
     /* 398119 */     // MIs[1] Operand 2
     /* 398119 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 398130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398139 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 398142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398156 */     GIR_RootConstrainSelectedInstOperands,
     /* 398157 */     // GIR_Coverage, 2096,
     /* 398157 */     GIR_EraseRootFromParent_Done,
     /* 398158 */   // Label 8249: @398158
     /* 398158 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(398250), // Rule ID 13272 //
     /* 398163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398211 */     // MIs[3] Operand 1
     /* 398211 */     // No operand predicates
     /* 398211 */     // MIs[1] Operand 2
     /* 398211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 398222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398231 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 398234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398248 */     GIR_RootConstrainSelectedInstOperands,
     /* 398249 */     // GIR_Coverage, 13272,
     /* 398249 */     GIR_EraseRootFromParent_Done,
     /* 398250 */   // Label 8250: @398250
     /* 398250 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(398336), // Rule ID 13270 //
     /* 398255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398299 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398303 */     // MIs[3] Operand 1
     /* 398303 */     // No operand predicates
     /* 398303 */     // MIs[1] Operand 2
     /* 398303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398320 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398334 */     GIR_RootConstrainSelectedInstOperands,
     /* 398335 */     // GIR_Coverage, 13270,
     /* 398335 */     GIR_EraseRootFromParent_Done,
     /* 398336 */   // Label 8251: @398336
     /* 398336 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(398422), // Rule ID 2094 //
     /* 398341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398389 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398393 */     // MIs[3] Operand 1
     /* 398393 */     // No operand predicates
     /* 398393 */     // MIs[1] Operand 2
     /* 398393 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398406 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398420 */     GIR_RootConstrainSelectedInstOperands,
     /* 398421 */     // GIR_Coverage, 2094,
     /* 398421 */     GIR_EraseRootFromParent_Done,
     /* 398422 */   // Label 8252: @398422
     /* 398422 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(398461), // Rule ID 1822 //
     /* 398427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398444 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 398447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398459 */     GIR_RootConstrainSelectedInstOperands,
     /* 398460 */     // GIR_Coverage, 1822,
     /* 398460 */     GIR_EraseRootFromParent_Done,
     /* 398461 */   // Label 8253: @398461
     /* 398461 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(398524), // Rule ID 13271 //
     /* 398466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398498 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398502 */     // MIs[2] Operand 1
     /* 398502 */     // No operand predicates
     /* 398502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398508 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398522 */     GIR_RootConstrainSelectedInstOperands,
     /* 398523 */     // GIR_Coverage, 13271,
     /* 398523 */     GIR_EraseRootFromParent_Done,
     /* 398524 */   // Label 8254: @398524
     /* 398524 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(398587), // Rule ID 2095 //
     /* 398529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398569 */     // MIs[2] Operand 1
     /* 398569 */     // No operand predicates
     /* 398569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398571 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398585 */     GIR_RootConstrainSelectedInstOperands,
     /* 398586 */     // GIR_Coverage, 2095,
     /* 398586 */     GIR_EraseRootFromParent_Done,
     /* 398587 */   // Label 8255: @398587
     /* 398587 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(398610), // Rule ID 1821 //
     /* 398592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398603 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 398608 */     GIR_RootConstrainSelectedInstOperands,
     /* 398609 */     // GIR_Coverage, 1821,
     /* 398609 */     GIR_Done,
     /* 398610 */   // Label 8256: @398610
     /* 398610 */   GIM_Reject,
     /* 398611 */ // Label 8248: @398611
     /* 398611 */ GIM_Reject,
     /* 398612 */ // Label 8237: @398612
     /* 398612 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(398690),
     /* 398617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398627 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(398666), // Rule ID 1820 //
     /* 398632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398649 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 398652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398664 */     GIR_RootConstrainSelectedInstOperands,
     /* 398665 */     // GIR_Coverage, 1820,
     /* 398665 */     GIR_EraseRootFromParent_Done,
     /* 398666 */   // Label 8258: @398666
     /* 398666 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(398689), // Rule ID 1819 //
     /* 398671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398682 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 398687 */     GIR_RootConstrainSelectedInstOperands,
     /* 398688 */     // GIR_Coverage, 1819,
     /* 398688 */     GIR_Done,
     /* 398689 */   // Label 8259: @398689
     /* 398689 */   GIM_Reject,
     /* 398690 */ // Label 8257: @398690
     /* 398690 */ GIM_Reject,
     /* 398691 */ // Label 8238: @398691
     /* 398691 */ GIM_Reject,
     /* 398692 */ // Label 148: @398692
     /* 398692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8278*/ GIMT_Encode4(399471),
     /* 398703 */ /*GILLT_v2s32*//*Label 8260*/ GIMT_Encode4(398779),
     /* 398707 */ /*GILLT_v2s64*//*Label 8261*/ GIMT_Encode4(398834),
     /* 398711 */ /*GILLT_v4s16*//*Label 8262*/ GIMT_Encode4(398889),
     /* 398715 */ /*GILLT_v4s32*//*Label 8263*/ GIMT_Encode4(398944),
     /* 398719 */ /*GILLT_v8s8*//*Label 8264*/ GIMT_Encode4(398999),
     /* 398723 */ /*GILLT_v8s16*//*Label 8265*/ GIMT_Encode4(399033),
     /* 398727 */ /*GILLT_v16s8*//*Label 8266*/ GIMT_Encode4(399088), GIMT_Encode4(0),
     /* 398735 */ /*GILLT_nxv2s1*//*Label 8267*/ GIMT_Encode4(399122),
     /* 398739 */ /*GILLT_nxv2s16*//*Label 8268*/ GIMT_Encode4(399148),
     /* 398743 */ /*GILLT_nxv2s32*//*Label 8269*/ GIMT_Encode4(399174),
     /* 398747 */ /*GILLT_nxv2s64*//*Label 8270*/ GIMT_Encode4(399200),
     /* 398751 */ /*GILLT_nxv4s1*//*Label 8271*/ GIMT_Encode4(399247),
     /* 398755 */ /*GILLT_nxv4s16*//*Label 8272*/ GIMT_Encode4(399273),
     /* 398759 */ /*GILLT_nxv4s32*//*Label 8273*/ GIMT_Encode4(399299),
     /* 398763 */ /*GILLT_nxv8s1*//*Label 8274*/ GIMT_Encode4(399346),
     /* 398767 */ /*GILLT_nxv8s16*//*Label 8275*/ GIMT_Encode4(399372),
     /* 398771 */ /*GILLT_nxv16s1*//*Label 8276*/ GIMT_Encode4(399419),
     /* 398775 */ /*GILLT_nxv16s8*//*Label 8277*/ GIMT_Encode4(399445),
     /* 398779 */ // Label 8260: @398779
     /* 398779 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(398833),
     /* 398784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398802 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(398817), // Rule ID 1881 //
     /* 398807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398810 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 398810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398815 */     GIR_RootConstrainSelectedInstOperands,
     /* 398816 */     // GIR_Coverage, 1881,
     /* 398816 */     GIR_Done,
     /* 398817 */   // Label 8280: @398817
     /* 398817 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(398832), // Rule ID 5410 //
     /* 398822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398825 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398830 */     GIR_RootConstrainSelectedInstOperands,
     /* 398831 */     // GIR_Coverage, 5410,
     /* 398831 */     GIR_Done,
     /* 398832 */   // Label 8281: @398832
     /* 398832 */   GIM_Reject,
     /* 398833 */ // Label 8279: @398833
     /* 398833 */ GIM_Reject,
     /* 398834 */ // Label 8261: @398834
     /* 398834 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(398888),
     /* 398839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398857 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(398872), // Rule ID 1883 //
     /* 398862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398865 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 398865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398870 */     GIR_RootConstrainSelectedInstOperands,
     /* 398871 */     // GIR_Coverage, 1883,
     /* 398871 */     GIR_Done,
     /* 398872 */   // Label 8283: @398872
     /* 398872 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(398887), // Rule ID 5412 //
     /* 398877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398880 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398885 */     GIR_RootConstrainSelectedInstOperands,
     /* 398886 */     // GIR_Coverage, 5412,
     /* 398886 */     GIR_Done,
     /* 398887 */   // Label 8284: @398887
     /* 398887 */   GIM_Reject,
     /* 398888 */ // Label 8282: @398888
     /* 398888 */ GIM_Reject,
     /* 398889 */ // Label 8262: @398889
     /* 398889 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(398943),
     /* 398894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398912 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(398927), // Rule ID 1879 //
     /* 398917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398920 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398925 */     GIR_RootConstrainSelectedInstOperands,
     /* 398926 */     // GIR_Coverage, 1879,
     /* 398926 */     GIR_Done,
     /* 398927 */   // Label 8286: @398927
     /* 398927 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(398942), // Rule ID 5408 //
     /* 398932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398935 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398940 */     GIR_RootConstrainSelectedInstOperands,
     /* 398941 */     // GIR_Coverage, 5408,
     /* 398941 */     GIR_Done,
     /* 398942 */   // Label 8287: @398942
     /* 398942 */   GIM_Reject,
     /* 398943 */ // Label 8285: @398943
     /* 398943 */ GIM_Reject,
     /* 398944 */ // Label 8263: @398944
     /* 398944 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(398998),
     /* 398949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398967 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(398982), // Rule ID 1882 //
     /* 398972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398975 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 398975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398980 */     GIR_RootConstrainSelectedInstOperands,
     /* 398981 */     // GIR_Coverage, 1882,
     /* 398981 */     GIR_Done,
     /* 398982 */   // Label 8289: @398982
     /* 398982 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(398997), // Rule ID 5411 //
     /* 398987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398990 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 398990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398995 */     GIR_RootConstrainSelectedInstOperands,
     /* 398996 */     // GIR_Coverage, 5411,
     /* 398996 */     GIR_Done,
     /* 398997 */   // Label 8290: @398997
     /* 398997 */   GIM_Reject,
     /* 398998 */ // Label 8288: @398998
     /* 398998 */ GIM_Reject,
     /* 398999 */ // Label 8264: @398999
     /* 398999 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(399032), // Rule ID 1877 //
     /* 399004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399025 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 399030 */   GIR_RootConstrainSelectedInstOperands,
     /* 399031 */   // GIR_Coverage, 1877,
     /* 399031 */   GIR_Done,
     /* 399032 */ // Label 8291: @399032
     /* 399032 */ GIM_Reject,
     /* 399033 */ // Label 8265: @399033
     /* 399033 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(399087),
     /* 399038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399056 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(399071), // Rule ID 1880 //
     /* 399061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399064 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 399064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 399069 */     GIR_RootConstrainSelectedInstOperands,
     /* 399070 */     // GIR_Coverage, 1880,
     /* 399070 */     GIR_Done,
     /* 399071 */   // Label 8293: @399071
     /* 399071 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(399086), // Rule ID 5409 //
     /* 399076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399079 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 399084 */     GIR_RootConstrainSelectedInstOperands,
     /* 399085 */     // GIR_Coverage, 5409,
     /* 399085 */     GIR_Done,
     /* 399086 */   // Label 8294: @399086
     /* 399086 */   GIM_Reject,
     /* 399087 */ // Label 8292: @399087
     /* 399087 */ GIM_Reject,
     /* 399088 */ // Label 8266: @399088
     /* 399088 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(399121), // Rule ID 1878 //
     /* 399093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399114 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 399119 */   GIR_RootConstrainSelectedInstOperands,
     /* 399120 */   // GIR_Coverage, 1878,
     /* 399120 */   GIR_Done,
     /* 399121 */ // Label 8295: @399121
     /* 399121 */ GIM_Reject,
     /* 399122 */ // Label 8267: @399122
     /* 399122 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(399147), // Rule ID 8807 //
     /* 399127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 399133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 399136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399140 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 399140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 399145 */   GIR_RootConstrainSelectedInstOperands,
     /* 399146 */   // GIR_Coverage, 8807,
     /* 399146 */   GIR_Done,
     /* 399147 */ // Label 8296: @399147
     /* 399147 */ GIM_Reject,
     /* 399148 */ // Label 8268: @399148
     /* 399148 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(399173), // Rule ID 8769 //
     /* 399153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 399159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 399162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399166 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 399166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 399171 */   GIR_RootConstrainSelectedInstOperands,
     /* 399172 */   // GIR_Coverage, 8769,
     /* 399172 */   GIR_Done,
     /* 399173 */ // Label 8297: @399173
     /* 399173 */ GIM_Reject,
     /* 399174 */ // Label 8269: @399174
     /* 399174 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(399199), // Rule ID 8770 //
     /* 399179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 399185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 399188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399192 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 399192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 399197 */   GIR_RootConstrainSelectedInstOperands,
     /* 399198 */   // GIR_Coverage, 8770,
     /* 399198 */   GIR_Done,
     /* 399199 */ // Label 8298: @399199
     /* 399199 */ GIM_Reject,
     /* 399200 */ // Label 8270: @399200
     /* 399200 */ GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(399246),
     /* 399205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 399211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399215 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(399230), // Rule ID 8765 //
     /* 399220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399223 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 399223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 399228 */     GIR_RootConstrainSelectedInstOperands,
     /* 399229 */     // GIR_Coverage, 8765,
     /* 399229 */     GIR_Done,
     /* 399230 */   // Label 8300: @399230
     /* 399230 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(399245), // Rule ID 8771 //
     /* 399235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399238 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 399238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 399243 */     GIR_RootConstrainSelectedInstOperands,
     /* 399244 */     // GIR_Coverage, 8771,
     /* 399244 */     GIR_Done,
     /* 399245 */   // Label 8301: @399245
     /* 399245 */   GIM_Reject,
     /* 399246 */ // Label 8299: @399246
     /* 399246 */ GIM_Reject,
     /* 399247 */ // Label 8271: @399247
     /* 399247 */ GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(399272), // Rule ID 8806 //
     /* 399252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 399258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 399261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399265 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 399265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 399270 */   GIR_RootConstrainSelectedInstOperands,
     /* 399271 */   // GIR_Coverage, 8806,
     /* 399271 */   GIR_Done,
     /* 399272 */ // Label 8302: @399272
     /* 399272 */ GIM_Reject,
     /* 399273 */ // Label 8272: @399273
     /* 399273 */ GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(399298), // Rule ID 8767 //
     /* 399278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 399284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 399287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399291 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 399291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 399296 */   GIR_RootConstrainSelectedInstOperands,
     /* 399297 */   // GIR_Coverage, 8767,
     /* 399297 */   GIR_Done,
     /* 399298 */ // Label 8303: @399298
     /* 399298 */ GIM_Reject,
     /* 399299 */ // Label 8273: @399299
     /* 399299 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(399345),
     /* 399304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 399307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 399310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399314 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(399329), // Rule ID 8764 //
     /* 399319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399322 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 399322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 399327 */     GIR_RootConstrainSelectedInstOperands,
     /* 399328 */     // GIR_Coverage, 8764,
     /* 399328 */     GIR_Done,
     /* 399329 */   // Label 8305: @399329
     /* 399329 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(399344), // Rule ID 8768 //
     /* 399334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399337 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 399337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 399342 */     GIR_RootConstrainSelectedInstOperands,
     /* 399343 */     // GIR_Coverage, 8768,
     /* 399343 */     GIR_Done,
     /* 399344 */   // Label 8306: @399344
     /* 399344 */   GIM_Reject,
     /* 399345 */ // Label 8304: @399345
     /* 399345 */ GIM_Reject,
     /* 399346 */ // Label 8274: @399346
     /* 399346 */ GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(399371), // Rule ID 8805 //
     /* 399351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 399357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 399360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399364 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 399364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 399369 */   GIR_RootConstrainSelectedInstOperands,
     /* 399370 */   // GIR_Coverage, 8805,
     /* 399370 */   GIR_Done,
     /* 399371 */ // Label 8307: @399371
     /* 399371 */ GIM_Reject,
     /* 399372 */ // Label 8275: @399372
     /* 399372 */ GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(399418),
     /* 399377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 399380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 399383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399387 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(399402), // Rule ID 8763 //
     /* 399392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399395 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 399395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 399400 */     GIR_RootConstrainSelectedInstOperands,
     /* 399401 */     // GIR_Coverage, 8763,
     /* 399401 */     GIR_Done,
     /* 399402 */   // Label 8309: @399402
     /* 399402 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(399417), // Rule ID 8766 //
     /* 399407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399410 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 399410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 399415 */     GIR_RootConstrainSelectedInstOperands,
     /* 399416 */     // GIR_Coverage, 8766,
     /* 399416 */     GIR_Done,
     /* 399417 */   // Label 8310: @399417
     /* 399417 */   GIM_Reject,
     /* 399418 */ // Label 8308: @399418
     /* 399418 */ GIM_Reject,
     /* 399419 */ // Label 8276: @399419
     /* 399419 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(399444), // Rule ID 2397 //
     /* 399424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 399430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 399433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399437 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 399437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 399442 */   GIR_RootConstrainSelectedInstOperands,
     /* 399443 */   // GIR_Coverage, 2397,
     /* 399443 */   GIR_Done,
     /* 399444 */ // Label 8311: @399444
     /* 399444 */ GIM_Reject,
     /* 399445 */ // Label 8277: @399445
     /* 399445 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(399470), // Rule ID 8762 //
     /* 399450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399463 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 399463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 399468 */   GIR_RootConstrainSelectedInstOperands,
     /* 399469 */   // GIR_Coverage, 8762,
     /* 399469 */   GIR_Done,
     /* 399470 */ // Label 8312: @399470
     /* 399470 */ GIM_Reject,
     /* 399471 */ // Label 8278: @399471
     /* 399471 */ GIM_Reject,
     /* 399472 */ // Label 149: @399472
     /* 399472 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8331*/ GIMT_Encode4(400251),
     /* 399483 */ /*GILLT_v2s32*//*Label 8313*/ GIMT_Encode4(399559),
     /* 399487 */ /*GILLT_v2s64*//*Label 8314*/ GIMT_Encode4(399614),
     /* 399491 */ /*GILLT_v4s16*//*Label 8315*/ GIMT_Encode4(399669),
     /* 399495 */ /*GILLT_v4s32*//*Label 8316*/ GIMT_Encode4(399724),
     /* 399499 */ /*GILLT_v8s8*//*Label 8317*/ GIMT_Encode4(399779),
     /* 399503 */ /*GILLT_v8s16*//*Label 8318*/ GIMT_Encode4(399813),
     /* 399507 */ /*GILLT_v16s8*//*Label 8319*/ GIMT_Encode4(399868), GIMT_Encode4(0),
     /* 399515 */ /*GILLT_nxv2s1*//*Label 8320*/ GIMT_Encode4(399902),
     /* 399519 */ /*GILLT_nxv2s16*//*Label 8321*/ GIMT_Encode4(399928),
     /* 399523 */ /*GILLT_nxv2s32*//*Label 8322*/ GIMT_Encode4(399954),
     /* 399527 */ /*GILLT_nxv2s64*//*Label 8323*/ GIMT_Encode4(399980),
     /* 399531 */ /*GILLT_nxv4s1*//*Label 8324*/ GIMT_Encode4(400027),
     /* 399535 */ /*GILLT_nxv4s16*//*Label 8325*/ GIMT_Encode4(400053),
     /* 399539 */ /*GILLT_nxv4s32*//*Label 8326*/ GIMT_Encode4(400079),
     /* 399543 */ /*GILLT_nxv8s1*//*Label 8327*/ GIMT_Encode4(400126),
     /* 399547 */ /*GILLT_nxv8s16*//*Label 8328*/ GIMT_Encode4(400152),
     /* 399551 */ /*GILLT_nxv16s1*//*Label 8329*/ GIMT_Encode4(400199),
     /* 399555 */ /*GILLT_nxv16s8*//*Label 8330*/ GIMT_Encode4(400225),
     /* 399559 */ // Label 8313: @399559
     /* 399559 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(399613),
     /* 399564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399582 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(399597), // Rule ID 1888 //
     /* 399587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399590 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 399590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399595 */     GIR_RootConstrainSelectedInstOperands,
     /* 399596 */     // GIR_Coverage, 1888,
     /* 399596 */     GIR_Done,
     /* 399597 */   // Label 8333: @399597
     /* 399597 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(399612), // Rule ID 5415 //
     /* 399602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399605 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399610 */     GIR_RootConstrainSelectedInstOperands,
     /* 399611 */     // GIR_Coverage, 5415,
     /* 399611 */     GIR_Done,
     /* 399612 */   // Label 8334: @399612
     /* 399612 */   GIM_Reject,
     /* 399613 */ // Label 8332: @399613
     /* 399613 */ GIM_Reject,
     /* 399614 */ // Label 8314: @399614
     /* 399614 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(399668),
     /* 399619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399637 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(399652), // Rule ID 1890 //
     /* 399642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399645 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 399645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399650 */     GIR_RootConstrainSelectedInstOperands,
     /* 399651 */     // GIR_Coverage, 1890,
     /* 399651 */     GIR_Done,
     /* 399652 */   // Label 8336: @399652
     /* 399652 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(399667), // Rule ID 5417 //
     /* 399657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399660 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399665 */     GIR_RootConstrainSelectedInstOperands,
     /* 399666 */     // GIR_Coverage, 5417,
     /* 399666 */     GIR_Done,
     /* 399667 */   // Label 8337: @399667
     /* 399667 */   GIM_Reject,
     /* 399668 */ // Label 8335: @399668
     /* 399668 */ GIM_Reject,
     /* 399669 */ // Label 8315: @399669
     /* 399669 */ GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(399723),
     /* 399674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399692 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(399707), // Rule ID 1886 //
     /* 399697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399700 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 399700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399705 */     GIR_RootConstrainSelectedInstOperands,
     /* 399706 */     // GIR_Coverage, 1886,
     /* 399706 */     GIR_Done,
     /* 399707 */   // Label 8339: @399707
     /* 399707 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(399722), // Rule ID 5413 //
     /* 399712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399715 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399720 */     GIR_RootConstrainSelectedInstOperands,
     /* 399721 */     // GIR_Coverage, 5413,
     /* 399721 */     GIR_Done,
     /* 399722 */   // Label 8340: @399722
     /* 399722 */   GIM_Reject,
     /* 399723 */ // Label 8338: @399723
     /* 399723 */ GIM_Reject,
     /* 399724 */ // Label 8316: @399724
     /* 399724 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(399778),
     /* 399729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399747 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(399762), // Rule ID 1889 //
     /* 399752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399755 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 399755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399760 */     GIR_RootConstrainSelectedInstOperands,
     /* 399761 */     // GIR_Coverage, 1889,
     /* 399761 */     GIR_Done,
     /* 399762 */   // Label 8342: @399762
     /* 399762 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(399777), // Rule ID 5416 //
     /* 399767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399770 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399775 */     GIR_RootConstrainSelectedInstOperands,
     /* 399776 */     // GIR_Coverage, 5416,
     /* 399776 */     GIR_Done,
     /* 399777 */   // Label 8343: @399777
     /* 399777 */   GIM_Reject,
     /* 399778 */ // Label 8341: @399778
     /* 399778 */ GIM_Reject,
     /* 399779 */ // Label 8317: @399779
     /* 399779 */ GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(399812), // Rule ID 1884 //
     /* 399784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399805 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 399810 */   GIR_RootConstrainSelectedInstOperands,
     /* 399811 */   // GIR_Coverage, 1884,
     /* 399811 */   GIR_Done,
     /* 399812 */ // Label 8344: @399812
     /* 399812 */ GIM_Reject,
     /* 399813 */ // Label 8318: @399813
     /* 399813 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(399867),
     /* 399818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399836 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(399851), // Rule ID 1887 //
     /* 399841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399844 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 399844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399849 */     GIR_RootConstrainSelectedInstOperands,
     /* 399850 */     // GIR_Coverage, 1887,
     /* 399850 */     GIR_Done,
     /* 399851 */   // Label 8346: @399851
     /* 399851 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(399866), // Rule ID 5414 //
     /* 399856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399859 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399864 */     GIR_RootConstrainSelectedInstOperands,
     /* 399865 */     // GIR_Coverage, 5414,
     /* 399865 */     GIR_Done,
     /* 399866 */   // Label 8347: @399866
     /* 399866 */   GIM_Reject,
     /* 399867 */ // Label 8345: @399867
     /* 399867 */ GIM_Reject,
     /* 399868 */ // Label 8319: @399868
     /* 399868 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(399901), // Rule ID 1885 //
     /* 399873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399894 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 399899 */   GIR_RootConstrainSelectedInstOperands,
     /* 399900 */   // GIR_Coverage, 1885,
     /* 399900 */   GIR_Done,
     /* 399901 */ // Label 8348: @399901
     /* 399901 */ GIM_Reject,
     /* 399902 */ // Label 8320: @399902
     /* 399902 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(399927), // Rule ID 8810 //
     /* 399907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 399913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 399916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399920 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 399920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 399925 */   GIR_RootConstrainSelectedInstOperands,
     /* 399926 */   // GIR_Coverage, 8810,
     /* 399926 */   GIR_Done,
     /* 399927 */ // Label 8349: @399927
     /* 399927 */ GIM_Reject,
     /* 399928 */ // Label 8321: @399928
     /* 399928 */ GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(399953), // Rule ID 8779 //
     /* 399933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 399939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 399942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399946 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 399946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399951 */   GIR_RootConstrainSelectedInstOperands,
     /* 399952 */   // GIR_Coverage, 8779,
     /* 399952 */   GIR_Done,
     /* 399953 */ // Label 8350: @399953
     /* 399953 */ GIM_Reject,
     /* 399954 */ // Label 8322: @399954
     /* 399954 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(399979), // Rule ID 8780 //
     /* 399959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 399965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 399968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399972 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 399972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399977 */   GIR_RootConstrainSelectedInstOperands,
     /* 399978 */   // GIR_Coverage, 8780,
     /* 399978 */   GIR_Done,
     /* 399979 */ // Label 8351: @399979
     /* 399979 */ GIM_Reject,
     /* 399980 */ // Label 8323: @399980
     /* 399980 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(400026),
     /* 399985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 399991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399995 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(400010), // Rule ID 8775 //
     /* 400000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400003 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 400003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 400008 */     GIR_RootConstrainSelectedInstOperands,
     /* 400009 */     // GIR_Coverage, 8775,
     /* 400009 */     GIR_Done,
     /* 400010 */   // Label 8353: @400010
     /* 400010 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(400025), // Rule ID 8781 //
     /* 400015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400018 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 400018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 400023 */     GIR_RootConstrainSelectedInstOperands,
     /* 400024 */     // GIR_Coverage, 8781,
     /* 400024 */     GIR_Done,
     /* 400025 */   // Label 8354: @400025
     /* 400025 */   GIM_Reject,
     /* 400026 */ // Label 8352: @400026
     /* 400026 */ GIM_Reject,
     /* 400027 */ // Label 8324: @400027
     /* 400027 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(400052), // Rule ID 8809 //
     /* 400032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 400038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 400041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 400045 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 400045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 400050 */   GIR_RootConstrainSelectedInstOperands,
     /* 400051 */   // GIR_Coverage, 8809,
     /* 400051 */   GIR_Done,
     /* 400052 */ // Label 8355: @400052
     /* 400052 */ GIM_Reject,
     /* 400053 */ // Label 8325: @400053
     /* 400053 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(400078), // Rule ID 8777 //
     /* 400058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 400064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 400067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400071 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 400071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 400076 */   GIR_RootConstrainSelectedInstOperands,
     /* 400077 */   // GIR_Coverage, 8777,
     /* 400077 */   GIR_Done,
     /* 400078 */ // Label 8356: @400078
     /* 400078 */ GIM_Reject,
     /* 400079 */ // Label 8326: @400079
     /* 400079 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(400125),
     /* 400084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 400087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 400090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400094 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(400109), // Rule ID 8774 //
     /* 400099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400102 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 400102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 400107 */     GIR_RootConstrainSelectedInstOperands,
     /* 400108 */     // GIR_Coverage, 8774,
     /* 400108 */     GIR_Done,
     /* 400109 */   // Label 8358: @400109
     /* 400109 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(400124), // Rule ID 8778 //
     /* 400114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400117 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 400117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 400122 */     GIR_RootConstrainSelectedInstOperands,
     /* 400123 */     // GIR_Coverage, 8778,
     /* 400123 */     GIR_Done,
     /* 400124 */   // Label 8359: @400124
     /* 400124 */   GIM_Reject,
     /* 400125 */ // Label 8357: @400125
     /* 400125 */ GIM_Reject,
     /* 400126 */ // Label 8327: @400126
     /* 400126 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(400151), // Rule ID 8808 //
     /* 400131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 400137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 400140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 400144 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 400144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 400149 */   GIR_RootConstrainSelectedInstOperands,
     /* 400150 */   // GIR_Coverage, 8808,
     /* 400150 */   GIR_Done,
     /* 400151 */ // Label 8360: @400151
     /* 400151 */ GIM_Reject,
     /* 400152 */ // Label 8328: @400152
     /* 400152 */ GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(400198),
     /* 400157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 400160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 400163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400167 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(400182), // Rule ID 8773 //
     /* 400172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400175 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 400175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 400180 */     GIR_RootConstrainSelectedInstOperands,
     /* 400181 */     // GIR_Coverage, 8773,
     /* 400181 */     GIR_Done,
     /* 400182 */   // Label 8362: @400182
     /* 400182 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(400197), // Rule ID 8776 //
     /* 400187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400190 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 400190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 400195 */     GIR_RootConstrainSelectedInstOperands,
     /* 400196 */     // GIR_Coverage, 8776,
     /* 400196 */     GIR_Done,
     /* 400197 */   // Label 8363: @400197
     /* 400197 */   GIM_Reject,
     /* 400198 */ // Label 8361: @400198
     /* 400198 */ GIM_Reject,
     /* 400199 */ // Label 8329: @400199
     /* 400199 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(400224), // Rule ID 2401 //
     /* 400204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 400210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 400213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 400217 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 400217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 400222 */   GIR_RootConstrainSelectedInstOperands,
     /* 400223 */   // GIR_Coverage, 2401,
     /* 400223 */   GIR_Done,
     /* 400224 */ // Label 8364: @400224
     /* 400224 */ GIM_Reject,
     /* 400225 */ // Label 8330: @400225
     /* 400225 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(400250), // Rule ID 8772 //
     /* 400230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 400236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 400239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400243 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 400243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 400248 */   GIR_RootConstrainSelectedInstOperands,
     /* 400249 */   // GIR_Coverage, 8772,
     /* 400249 */   GIR_Done,
     /* 400250 */ // Label 8365: @400250
     /* 400250 */ GIM_Reject,
     /* 400251 */ // Label 8331: @400251
     /* 400251 */ GIM_Reject,
     /* 400252 */ // Label 150: @400252
     /* 400252 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8374*/ GIMT_Encode4(400949),
     /* 400263 */ /*GILLT_s64*//*Label 8366*/ GIMT_Encode4(400299), GIMT_Encode4(0),
     /* 400271 */ /*GILLT_v2s32*//*Label 8367*/ GIMT_Encode4(400410),
     /* 400275 */ /*GILLT_v2s64*//*Label 8368*/ GIMT_Encode4(400487),
     /* 400279 */ /*GILLT_v4s16*//*Label 8369*/ GIMT_Encode4(400564),
     /* 400283 */ /*GILLT_v4s32*//*Label 8370*/ GIMT_Encode4(400641),
     /* 400287 */ /*GILLT_v8s8*//*Label 8371*/ GIMT_Encode4(400718),
     /* 400291 */ /*GILLT_v8s16*//*Label 8372*/ GIMT_Encode4(400795),
     /* 400295 */ /*GILLT_v16s8*//*Label 8373*/ GIMT_Encode4(400872),
     /* 400299 */ // Label 8366: @400299
     /* 400299 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(400409),
     /* 400304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400315 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(400340), // Rule ID 5187 //
     /* 400320 */     // MIs[0] Operand 2
     /* 400320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 400331 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 400331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 400334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400338 */     GIR_RootConstrainSelectedInstOperands,
     /* 400339 */     // GIR_Coverage, 5187,
     /* 400339 */     GIR_EraseRootFromParent_Done,
     /* 400340 */   // Label 8376: @400340
     /* 400340 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(400374), // Rule ID 2111 //
     /* 400345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400348 */     // MIs[0] imm
     /* 400348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400360 */     // MIs[1] Operand 1
     /* 400360 */     // No operand predicates
     /* 400360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400362 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 400365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400372 */     GIR_RootConstrainSelectedInstOperands,
     /* 400373 */     // GIR_Coverage, 2111,
     /* 400373 */     GIR_EraseRootFromParent_Done,
     /* 400374 */   // Label 8377: @400374
     /* 400374 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(400408), // Rule ID 6196 //
     /* 400379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400382 */     // MIs[0] imm
     /* 400382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400394 */     // MIs[1] Operand 1
     /* 400394 */     // No operand predicates
     /* 400394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400396 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 400396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 400399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400406 */     GIR_RootConstrainSelectedInstOperands,
     /* 400407 */     // GIR_Coverage, 6196,
     /* 400407 */     GIR_EraseRootFromParent_Done,
     /* 400408 */   // Label 8378: @400408
     /* 400408 */   GIM_Reject,
     /* 400409 */ // Label 8375: @400409
     /* 400409 */ GIM_Reject,
     /* 400410 */ // Label 8367: @400410
     /* 400410 */ GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(400486),
     /* 400415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400426 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(400451), // Rule ID 4832 //
     /* 400431 */     // MIs[0] Operand 2
     /* 400431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 400442 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 400442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 400445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400449 */     GIR_RootConstrainSelectedInstOperands,
     /* 400450 */     // GIR_Coverage, 4832,
     /* 400450 */     GIR_EraseRootFromParent_Done,
     /* 400451 */   // Label 8380: @400451
     /* 400451 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(400485), // Rule ID 2218 //
     /* 400456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400459 */     // MIs[0] imm
     /* 400459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400471 */     // MIs[1] Operand 1
     /* 400471 */     // No operand predicates
     /* 400471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400473 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 400476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400483 */     GIR_RootConstrainSelectedInstOperands,
     /* 400484 */     // GIR_Coverage, 2218,
     /* 400484 */     GIR_EraseRootFromParent_Done,
     /* 400485 */   // Label 8381: @400485
     /* 400485 */   GIM_Reject,
     /* 400486 */ // Label 8379: @400486
     /* 400486 */ GIM_Reject,
     /* 400487 */ // Label 8368: @400487
     /* 400487 */ GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(400563),
     /* 400492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400503 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(400528), // Rule ID 4836 //
     /* 400508 */     // MIs[0] Operand 2
     /* 400508 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 400519 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 400519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 400522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400526 */     GIR_RootConstrainSelectedInstOperands,
     /* 400527 */     // GIR_Coverage, 4836,
     /* 400527 */     GIR_EraseRootFromParent_Done,
     /* 400528 */   // Label 8383: @400528
     /* 400528 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(400562), // Rule ID 2220 //
     /* 400533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400536 */     // MIs[0] imm
     /* 400536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400548 */     // MIs[1] Operand 1
     /* 400548 */     // No operand predicates
     /* 400548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400550 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 400553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400560 */     GIR_RootConstrainSelectedInstOperands,
     /* 400561 */     // GIR_Coverage, 2220,
     /* 400561 */     GIR_EraseRootFromParent_Done,
     /* 400562 */   // Label 8384: @400562
     /* 400562 */   GIM_Reject,
     /* 400563 */ // Label 8382: @400563
     /* 400563 */ GIM_Reject,
     /* 400564 */ // Label 8369: @400564
     /* 400564 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(400640),
     /* 400569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400580 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(400605), // Rule ID 4831 //
     /* 400585 */     // MIs[0] Operand 2
     /* 400585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400596 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 400596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 400599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400603 */     GIR_RootConstrainSelectedInstOperands,
     /* 400604 */     // GIR_Coverage, 4831,
     /* 400604 */     GIR_EraseRootFromParent_Done,
     /* 400605 */   // Label 8386: @400605
     /* 400605 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(400639), // Rule ID 2216 //
     /* 400610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400613 */     // MIs[0] imm
     /* 400613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400625 */     // MIs[1] Operand 1
     /* 400625 */     // No operand predicates
     /* 400625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400627 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 400630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400637 */     GIR_RootConstrainSelectedInstOperands,
     /* 400638 */     // GIR_Coverage, 2216,
     /* 400638 */     GIR_EraseRootFromParent_Done,
     /* 400639 */   // Label 8387: @400639
     /* 400639 */   GIM_Reject,
     /* 400640 */ // Label 8385: @400640
     /* 400640 */ GIM_Reject,
     /* 400641 */ // Label 8370: @400641
     /* 400641 */ GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(400717),
     /* 400646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400657 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(400682), // Rule ID 4835 //
     /* 400662 */     // MIs[0] Operand 2
     /* 400662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 400673 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 400673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 400676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400680 */     GIR_RootConstrainSelectedInstOperands,
     /* 400681 */     // GIR_Coverage, 4835,
     /* 400681 */     GIR_EraseRootFromParent_Done,
     /* 400682 */   // Label 8389: @400682
     /* 400682 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(400716), // Rule ID 2219 //
     /* 400687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400690 */     // MIs[0] imm
     /* 400690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400702 */     // MIs[1] Operand 1
     /* 400702 */     // No operand predicates
     /* 400702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400704 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 400707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400714 */     GIR_RootConstrainSelectedInstOperands,
     /* 400715 */     // GIR_Coverage, 2219,
     /* 400715 */     GIR_EraseRootFromParent_Done,
     /* 400716 */   // Label 8390: @400716
     /* 400716 */   GIM_Reject,
     /* 400717 */ // Label 8388: @400717
     /* 400717 */ GIM_Reject,
     /* 400718 */ // Label 8371: @400718
     /* 400718 */ GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(400794),
     /* 400723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400734 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(400759), // Rule ID 4830 //
     /* 400739 */     // MIs[0] Operand 2
     /* 400739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400750 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 400750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 400753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400757 */     GIR_RootConstrainSelectedInstOperands,
     /* 400758 */     // GIR_Coverage, 4830,
     /* 400758 */     GIR_EraseRootFromParent_Done,
     /* 400759 */   // Label 8392: @400759
     /* 400759 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(400793), // Rule ID 2214 //
     /* 400764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400767 */     // MIs[0] imm
     /* 400767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400779 */     // MIs[1] Operand 1
     /* 400779 */     // No operand predicates
     /* 400779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400781 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 400784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400791 */     GIR_RootConstrainSelectedInstOperands,
     /* 400792 */     // GIR_Coverage, 2214,
     /* 400792 */     GIR_EraseRootFromParent_Done,
     /* 400793 */   // Label 8393: @400793
     /* 400793 */   GIM_Reject,
     /* 400794 */ // Label 8391: @400794
     /* 400794 */ GIM_Reject,
     /* 400795 */ // Label 8372: @400795
     /* 400795 */ GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(400871),
     /* 400800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400811 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(400836), // Rule ID 4834 //
     /* 400816 */     // MIs[0] Operand 2
     /* 400816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400827 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 400827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 400830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400834 */     GIR_RootConstrainSelectedInstOperands,
     /* 400835 */     // GIR_Coverage, 4834,
     /* 400835 */     GIR_EraseRootFromParent_Done,
     /* 400836 */   // Label 8395: @400836
     /* 400836 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(400870), // Rule ID 2217 //
     /* 400841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400844 */     // MIs[0] imm
     /* 400844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400856 */     // MIs[1] Operand 1
     /* 400856 */     // No operand predicates
     /* 400856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400858 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 400861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400868 */     GIR_RootConstrainSelectedInstOperands,
     /* 400869 */     // GIR_Coverage, 2217,
     /* 400869 */     GIR_EraseRootFromParent_Done,
     /* 400870 */   // Label 8396: @400870
     /* 400870 */   GIM_Reject,
     /* 400871 */ // Label 8394: @400871
     /* 400871 */ GIM_Reject,
     /* 400872 */ // Label 8373: @400872
     /* 400872 */ GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(400948),
     /* 400877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400888 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(400913), // Rule ID 4833 //
     /* 400893 */     // MIs[0] Operand 2
     /* 400893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400904 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 400904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 400907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400911 */     GIR_RootConstrainSelectedInstOperands,
     /* 400912 */     // GIR_Coverage, 4833,
     /* 400912 */     GIR_EraseRootFromParent_Done,
     /* 400913 */   // Label 8398: @400913
     /* 400913 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(400947), // Rule ID 2215 //
     /* 400918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400921 */     // MIs[0] imm
     /* 400921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400933 */     // MIs[1] Operand 1
     /* 400933 */     // No operand predicates
     /* 400933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400935 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 400938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400945 */     GIR_RootConstrainSelectedInstOperands,
     /* 400946 */     // GIR_Coverage, 2215,
     /* 400946 */     GIR_EraseRootFromParent_Done,
     /* 400947 */   // Label 8399: @400947
     /* 400947 */   GIM_Reject,
     /* 400948 */ // Label 8397: @400948
     /* 400948 */ GIM_Reject,
     /* 400949 */ // Label 8374: @400949
     /* 400949 */ GIM_Reject,
     /* 400950 */ // Label 151: @400950
     /* 400950 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8408*/ GIMT_Encode4(401405),
     /* 400961 */ /*GILLT_s64*//*Label 8400*/ GIMT_Encode4(400997), GIMT_Encode4(0),
     /* 400969 */ /*GILLT_v2s32*//*Label 8401*/ GIMT_Encode4(401083),
     /* 400973 */ /*GILLT_v2s64*//*Label 8402*/ GIMT_Encode4(401129),
     /* 400977 */ /*GILLT_v4s16*//*Label 8403*/ GIMT_Encode4(401175),
     /* 400981 */ /*GILLT_v4s32*//*Label 8404*/ GIMT_Encode4(401221),
     /* 400985 */ /*GILLT_v8s8*//*Label 8405*/ GIMT_Encode4(401267),
     /* 400989 */ /*GILLT_v8s16*//*Label 8406*/ GIMT_Encode4(401313),
     /* 400993 */ /*GILLT_v16s8*//*Label 8407*/ GIMT_Encode4(401359),
     /* 400997 */ // Label 8400: @400997
     /* 400997 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(401082),
     /* 401002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401013 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(401047), // Rule ID 2120 //
     /* 401018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401021 */     // MIs[0] imm
     /* 401021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 401033 */     // MIs[1] Operand 1
     /* 401033 */     // No operand predicates
     /* 401033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401035 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 401038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401045 */     GIR_RootConstrainSelectedInstOperands,
     /* 401046 */     // GIR_Coverage, 2120,
     /* 401046 */     GIR_EraseRootFromParent_Done,
     /* 401047 */   // Label 8410: @401047
     /* 401047 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(401081), // Rule ID 6202 //
     /* 401052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401055 */     // MIs[0] imm
     /* 401055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 401067 */     // MIs[1] Operand 1
     /* 401067 */     // No operand predicates
     /* 401067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401069 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 401069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 401072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401079 */     GIR_RootConstrainSelectedInstOperands,
     /* 401080 */     // GIR_Coverage, 6202,
     /* 401080 */     GIR_EraseRootFromParent_Done,
     /* 401081 */   // Label 8411: @401081
     /* 401081 */   GIM_Reject,
     /* 401082 */ // Label 8409: @401082
     /* 401082 */ GIM_Reject,
     /* 401083 */ // Label 8401: @401083
     /* 401083 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(401128), // Rule ID 2277 //
     /* 401088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401102 */   // MIs[0] imm
     /* 401102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401110 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 401114 */   // MIs[1] Operand 1
     /* 401114 */   // No operand predicates
     /* 401114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401116 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 401119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401121 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401123 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401126 */   GIR_RootConstrainSelectedInstOperands,
     /* 401127 */   // GIR_Coverage, 2277,
     /* 401127 */   GIR_EraseRootFromParent_Done,
     /* 401128 */ // Label 8412: @401128
     /* 401128 */ GIM_Reject,
     /* 401129 */ // Label 8402: @401129
     /* 401129 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(401174), // Rule ID 2279 //
     /* 401134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401148 */   // MIs[0] imm
     /* 401148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401156 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 401160 */   // MIs[1] Operand 1
     /* 401160 */   // No operand predicates
     /* 401160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401162 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 401165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401167 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401169 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401172 */   GIR_RootConstrainSelectedInstOperands,
     /* 401173 */   // GIR_Coverage, 2279,
     /* 401173 */   GIR_EraseRootFromParent_Done,
     /* 401174 */ // Label 8413: @401174
     /* 401174 */ GIM_Reject,
     /* 401175 */ // Label 8403: @401175
     /* 401175 */ GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(401220), // Rule ID 2275 //
     /* 401180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401194 */   // MIs[0] imm
     /* 401194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401202 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 401206 */   // MIs[1] Operand 1
     /* 401206 */   // No operand predicates
     /* 401206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401208 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 401211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401213 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401215 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401218 */   GIR_RootConstrainSelectedInstOperands,
     /* 401219 */   // GIR_Coverage, 2275,
     /* 401219 */   GIR_EraseRootFromParent_Done,
     /* 401220 */ // Label 8414: @401220
     /* 401220 */ GIM_Reject,
     /* 401221 */ // Label 8404: @401221
     /* 401221 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(401266), // Rule ID 2278 //
     /* 401226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401240 */   // MIs[0] imm
     /* 401240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401248 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 401252 */   // MIs[1] Operand 1
     /* 401252 */   // No operand predicates
     /* 401252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401254 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 401257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401259 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401261 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401264 */   GIR_RootConstrainSelectedInstOperands,
     /* 401265 */   // GIR_Coverage, 2278,
     /* 401265 */   GIR_EraseRootFromParent_Done,
     /* 401266 */ // Label 8415: @401266
     /* 401266 */ GIM_Reject,
     /* 401267 */ // Label 8405: @401267
     /* 401267 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(401312), // Rule ID 2273 //
     /* 401272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401286 */   // MIs[0] imm
     /* 401286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401294 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 401298 */   // MIs[1] Operand 1
     /* 401298 */   // No operand predicates
     /* 401298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401300 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 401303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401307 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401310 */   GIR_RootConstrainSelectedInstOperands,
     /* 401311 */   // GIR_Coverage, 2273,
     /* 401311 */   GIR_EraseRootFromParent_Done,
     /* 401312 */ // Label 8416: @401312
     /* 401312 */ GIM_Reject,
     /* 401313 */ // Label 8406: @401313
     /* 401313 */ GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(401358), // Rule ID 2276 //
     /* 401318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401332 */   // MIs[0] imm
     /* 401332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401340 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 401344 */   // MIs[1] Operand 1
     /* 401344 */   // No operand predicates
     /* 401344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401346 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 401349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401351 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401353 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401356 */   GIR_RootConstrainSelectedInstOperands,
     /* 401357 */   // GIR_Coverage, 2276,
     /* 401357 */   GIR_EraseRootFromParent_Done,
     /* 401358 */ // Label 8417: @401358
     /* 401358 */ GIM_Reject,
     /* 401359 */ // Label 8407: @401359
     /* 401359 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(401404), // Rule ID 2274 //
     /* 401364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401378 */   // MIs[0] imm
     /* 401378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401386 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 401390 */   // MIs[1] Operand 1
     /* 401390 */   // No operand predicates
     /* 401390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401392 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 401392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 401395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401397 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401402 */   GIR_RootConstrainSelectedInstOperands,
     /* 401403 */   // GIR_Coverage, 2274,
     /* 401403 */   GIR_EraseRootFromParent_Done,
     /* 401404 */ // Label 8418: @401404
     /* 401404 */ GIM_Reject,
     /* 401405 */ // Label 8408: @401405
     /* 401405 */ GIM_Reject,
     /* 401406 */ // Label 152: @401406
     /* 401406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8437*/ GIMT_Encode4(402185),
     /* 401417 */ /*GILLT_v2s32*//*Label 8419*/ GIMT_Encode4(401493),
     /* 401421 */ /*GILLT_v2s64*//*Label 8420*/ GIMT_Encode4(401548),
     /* 401425 */ /*GILLT_v4s16*//*Label 8421*/ GIMT_Encode4(401603),
     /* 401429 */ /*GILLT_v4s32*//*Label 8422*/ GIMT_Encode4(401658),
     /* 401433 */ /*GILLT_v8s8*//*Label 8423*/ GIMT_Encode4(401713),
     /* 401437 */ /*GILLT_v8s16*//*Label 8424*/ GIMT_Encode4(401747),
     /* 401441 */ /*GILLT_v16s8*//*Label 8425*/ GIMT_Encode4(401802), GIMT_Encode4(0),
     /* 401449 */ /*GILLT_nxv2s1*//*Label 8426*/ GIMT_Encode4(401836),
     /* 401453 */ /*GILLT_nxv2s16*//*Label 8427*/ GIMT_Encode4(401862),
     /* 401457 */ /*GILLT_nxv2s32*//*Label 8428*/ GIMT_Encode4(401888),
     /* 401461 */ /*GILLT_nxv2s64*//*Label 8429*/ GIMT_Encode4(401914),
     /* 401465 */ /*GILLT_nxv4s1*//*Label 8430*/ GIMT_Encode4(401961),
     /* 401469 */ /*GILLT_nxv4s16*//*Label 8431*/ GIMT_Encode4(401987),
     /* 401473 */ /*GILLT_nxv4s32*//*Label 8432*/ GIMT_Encode4(402013),
     /* 401477 */ /*GILLT_nxv8s1*//*Label 8433*/ GIMT_Encode4(402060),
     /* 401481 */ /*GILLT_nxv8s16*//*Label 8434*/ GIMT_Encode4(402086),
     /* 401485 */ /*GILLT_nxv16s1*//*Label 8435*/ GIMT_Encode4(402133),
     /* 401489 */ /*GILLT_nxv16s8*//*Label 8436*/ GIMT_Encode4(402159),
     /* 401493 */ // Label 8419: @401493
     /* 401493 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(401547),
     /* 401498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401516 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(401531), // Rule ID 1895 //
     /* 401521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401524 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401529 */     GIR_RootConstrainSelectedInstOperands,
     /* 401530 */     // GIR_Coverage, 1895,
     /* 401530 */     GIR_Done,
     /* 401531 */   // Label 8439: @401531
     /* 401531 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(401546), // Rule ID 5420 //
     /* 401536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401539 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401544 */     GIR_RootConstrainSelectedInstOperands,
     /* 401545 */     // GIR_Coverage, 5420,
     /* 401545 */     GIR_Done,
     /* 401546 */   // Label 8440: @401546
     /* 401546 */   GIM_Reject,
     /* 401547 */ // Label 8438: @401547
     /* 401547 */ GIM_Reject,
     /* 401548 */ // Label 8420: @401548
     /* 401548 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(401602),
     /* 401553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401571 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(401586), // Rule ID 1897 //
     /* 401576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401579 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401584 */     GIR_RootConstrainSelectedInstOperands,
     /* 401585 */     // GIR_Coverage, 1897,
     /* 401585 */     GIR_Done,
     /* 401586 */   // Label 8442: @401586
     /* 401586 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(401601), // Rule ID 5422 //
     /* 401591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401594 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401599 */     GIR_RootConstrainSelectedInstOperands,
     /* 401600 */     // GIR_Coverage, 5422,
     /* 401600 */     GIR_Done,
     /* 401601 */   // Label 8443: @401601
     /* 401601 */   GIM_Reject,
     /* 401602 */ // Label 8441: @401602
     /* 401602 */ GIM_Reject,
     /* 401603 */ // Label 8421: @401603
     /* 401603 */ GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(401657),
     /* 401608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401626 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(401641), // Rule ID 1893 //
     /* 401631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401634 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401639 */     GIR_RootConstrainSelectedInstOperands,
     /* 401640 */     // GIR_Coverage, 1893,
     /* 401640 */     GIR_Done,
     /* 401641 */   // Label 8445: @401641
     /* 401641 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(401656), // Rule ID 5418 //
     /* 401646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401649 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401654 */     GIR_RootConstrainSelectedInstOperands,
     /* 401655 */     // GIR_Coverage, 5418,
     /* 401655 */     GIR_Done,
     /* 401656 */   // Label 8446: @401656
     /* 401656 */   GIM_Reject,
     /* 401657 */ // Label 8444: @401657
     /* 401657 */ GIM_Reject,
     /* 401658 */ // Label 8422: @401658
     /* 401658 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(401712),
     /* 401663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401681 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(401696), // Rule ID 1896 //
     /* 401686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401689 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 401689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401694 */     GIR_RootConstrainSelectedInstOperands,
     /* 401695 */     // GIR_Coverage, 1896,
     /* 401695 */     GIR_Done,
     /* 401696 */   // Label 8448: @401696
     /* 401696 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(401711), // Rule ID 5421 //
     /* 401701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401704 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401709 */     GIR_RootConstrainSelectedInstOperands,
     /* 401710 */     // GIR_Coverage, 5421,
     /* 401710 */     GIR_Done,
     /* 401711 */   // Label 8449: @401711
     /* 401711 */   GIM_Reject,
     /* 401712 */ // Label 8447: @401712
     /* 401712 */ GIM_Reject,
     /* 401713 */ // Label 8423: @401713
     /* 401713 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(401746), // Rule ID 1891 //
     /* 401718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401739 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 401744 */   GIR_RootConstrainSelectedInstOperands,
     /* 401745 */   // GIR_Coverage, 1891,
     /* 401745 */   GIR_Done,
     /* 401746 */ // Label 8450: @401746
     /* 401746 */ GIM_Reject,
     /* 401747 */ // Label 8424: @401747
     /* 401747 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(401801),
     /* 401752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401770 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(401785), // Rule ID 1894 //
     /* 401775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401778 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 401778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401783 */     GIR_RootConstrainSelectedInstOperands,
     /* 401784 */     // GIR_Coverage, 1894,
     /* 401784 */     GIR_Done,
     /* 401785 */   // Label 8452: @401785
     /* 401785 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(401800), // Rule ID 5419 //
     /* 401790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401793 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401798 */     GIR_RootConstrainSelectedInstOperands,
     /* 401799 */     // GIR_Coverage, 5419,
     /* 401799 */     GIR_Done,
     /* 401800 */   // Label 8453: @401800
     /* 401800 */   GIM_Reject,
     /* 401801 */ // Label 8451: @401801
     /* 401801 */ GIM_Reject,
     /* 401802 */ // Label 8425: @401802
     /* 401802 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(401835), // Rule ID 1892 //
     /* 401807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 401816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401828 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 401833 */   GIR_RootConstrainSelectedInstOperands,
     /* 401834 */   // GIR_Coverage, 1892,
     /* 401834 */   GIR_Done,
     /* 401835 */ // Label 8454: @401835
     /* 401835 */ GIM_Reject,
     /* 401836 */ // Label 8426: @401836
     /* 401836 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(401861), // Rule ID 3328 //
     /* 401841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 401847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 401850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401854 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 401854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 401859 */   GIR_RootConstrainSelectedInstOperands,
     /* 401860 */   // GIR_Coverage, 3328,
     /* 401860 */   GIR_Done,
     /* 401861 */ // Label 8455: @401861
     /* 401861 */ GIM_Reject,
     /* 401862 */ // Label 8427: @401862
     /* 401862 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(401887), // Rule ID 2865 //
     /* 401867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 401873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 401876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401880 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 401880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401885 */   GIR_RootConstrainSelectedInstOperands,
     /* 401886 */   // GIR_Coverage, 2865,
     /* 401886 */   GIR_Done,
     /* 401887 */ // Label 8456: @401887
     /* 401887 */ GIM_Reject,
     /* 401888 */ // Label 8428: @401888
     /* 401888 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(401913), // Rule ID 2866 //
     /* 401893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 401899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 401902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401906 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 401906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401911 */   GIR_RootConstrainSelectedInstOperands,
     /* 401912 */   // GIR_Coverage, 2866,
     /* 401912 */   GIR_Done,
     /* 401913 */ // Label 8457: @401913
     /* 401913 */ GIM_Reject,
     /* 401914 */ // Label 8429: @401914
     /* 401914 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(401960),
     /* 401919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 401922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 401925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401929 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(401944), // Rule ID 2861 //
     /* 401934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401937 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 401937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401942 */     GIR_RootConstrainSelectedInstOperands,
     /* 401943 */     // GIR_Coverage, 2861,
     /* 401943 */     GIR_Done,
     /* 401944 */   // Label 8459: @401944
     /* 401944 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(401959), // Rule ID 2867 //
     /* 401949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401952 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 401952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401957 */     GIR_RootConstrainSelectedInstOperands,
     /* 401958 */     // GIR_Coverage, 2867,
     /* 401958 */     GIR_Done,
     /* 401959 */   // Label 8460: @401959
     /* 401959 */   GIM_Reject,
     /* 401960 */ // Label 8458: @401960
     /* 401960 */ GIM_Reject,
     /* 401961 */ // Label 8430: @401961
     /* 401961 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(401986), // Rule ID 3327 //
     /* 401966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 401972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 401975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401979 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 401979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 401984 */   GIR_RootConstrainSelectedInstOperands,
     /* 401985 */   // GIR_Coverage, 3327,
     /* 401985 */   GIR_Done,
     /* 401986 */ // Label 8461: @401986
     /* 401986 */ GIM_Reject,
     /* 401987 */ // Label 8431: @401987
     /* 401987 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(402012), // Rule ID 2863 //
     /* 401992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 401998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402005 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 402010 */   GIR_RootConstrainSelectedInstOperands,
     /* 402011 */   // GIR_Coverage, 2863,
     /* 402011 */   GIR_Done,
     /* 402012 */ // Label 8462: @402012
     /* 402012 */ GIM_Reject,
     /* 402013 */ // Label 8432: @402013
     /* 402013 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(402059),
     /* 402018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402028 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(402043), // Rule ID 2860 //
     /* 402033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402036 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 402041 */     GIR_RootConstrainSelectedInstOperands,
     /* 402042 */     // GIR_Coverage, 2860,
     /* 402042 */     GIR_Done,
     /* 402043 */   // Label 8464: @402043
     /* 402043 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(402058), // Rule ID 2864 //
     /* 402048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402051 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 402056 */     GIR_RootConstrainSelectedInstOperands,
     /* 402057 */     // GIR_Coverage, 2864,
     /* 402057 */     GIR_Done,
     /* 402058 */   // Label 8465: @402058
     /* 402058 */   GIM_Reject,
     /* 402059 */ // Label 8463: @402059
     /* 402059 */ GIM_Reject,
     /* 402060 */ // Label 8433: @402060
     /* 402060 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(402085), // Rule ID 3326 //
     /* 402065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402078 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 402083 */   GIR_RootConstrainSelectedInstOperands,
     /* 402084 */   // GIR_Coverage, 3326,
     /* 402084 */   GIR_Done,
     /* 402085 */ // Label 8466: @402085
     /* 402085 */ GIM_Reject,
     /* 402086 */ // Label 8434: @402086
     /* 402086 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(402132),
     /* 402091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402101 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(402116), // Rule ID 2859 //
     /* 402106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402109 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 402114 */     GIR_RootConstrainSelectedInstOperands,
     /* 402115 */     // GIR_Coverage, 2859,
     /* 402115 */     GIR_Done,
     /* 402116 */   // Label 8468: @402116
     /* 402116 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(402131), // Rule ID 2862 //
     /* 402121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402124 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 402129 */     GIR_RootConstrainSelectedInstOperands,
     /* 402130 */     // GIR_Coverage, 2862,
     /* 402130 */     GIR_Done,
     /* 402131 */   // Label 8469: @402131
     /* 402131 */   GIM_Reject,
     /* 402132 */ // Label 8467: @402132
     /* 402132 */ GIM_Reject,
     /* 402133 */ // Label 8435: @402133
     /* 402133 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(402158), // Rule ID 2389 //
     /* 402138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402151 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 402156 */   GIR_RootConstrainSelectedInstOperands,
     /* 402157 */   // GIR_Coverage, 2389,
     /* 402157 */   GIR_Done,
     /* 402158 */ // Label 8470: @402158
     /* 402158 */ GIM_Reject,
     /* 402159 */ // Label 8436: @402159
     /* 402159 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(402184), // Rule ID 2858 //
     /* 402164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402177 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 402182 */   GIR_RootConstrainSelectedInstOperands,
     /* 402183 */   // GIR_Coverage, 2858,
     /* 402183 */   GIR_Done,
     /* 402184 */ // Label 8471: @402184
     /* 402184 */ GIM_Reject,
     /* 402185 */ // Label 8437: @402185
     /* 402185 */ GIM_Reject,
     /* 402186 */ // Label 153: @402186
     /* 402186 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8490*/ GIMT_Encode4(402965),
     /* 402197 */ /*GILLT_v2s32*//*Label 8472*/ GIMT_Encode4(402273),
     /* 402201 */ /*GILLT_v2s64*//*Label 8473*/ GIMT_Encode4(402328),
     /* 402205 */ /*GILLT_v4s16*//*Label 8474*/ GIMT_Encode4(402383),
     /* 402209 */ /*GILLT_v4s32*//*Label 8475*/ GIMT_Encode4(402438),
     /* 402213 */ /*GILLT_v8s8*//*Label 8476*/ GIMT_Encode4(402493),
     /* 402217 */ /*GILLT_v8s16*//*Label 8477*/ GIMT_Encode4(402527),
     /* 402221 */ /*GILLT_v16s8*//*Label 8478*/ GIMT_Encode4(402582), GIMT_Encode4(0),
     /* 402229 */ /*GILLT_nxv2s1*//*Label 8479*/ GIMT_Encode4(402616),
     /* 402233 */ /*GILLT_nxv2s16*//*Label 8480*/ GIMT_Encode4(402642),
     /* 402237 */ /*GILLT_nxv2s32*//*Label 8481*/ GIMT_Encode4(402668),
     /* 402241 */ /*GILLT_nxv2s64*//*Label 8482*/ GIMT_Encode4(402694),
     /* 402245 */ /*GILLT_nxv4s1*//*Label 8483*/ GIMT_Encode4(402741),
     /* 402249 */ /*GILLT_nxv4s16*//*Label 8484*/ GIMT_Encode4(402767),
     /* 402253 */ /*GILLT_nxv4s32*//*Label 8485*/ GIMT_Encode4(402793),
     /* 402257 */ /*GILLT_nxv8s1*//*Label 8486*/ GIMT_Encode4(402840),
     /* 402261 */ /*GILLT_nxv8s16*//*Label 8487*/ GIMT_Encode4(402866),
     /* 402265 */ /*GILLT_nxv16s1*//*Label 8488*/ GIMT_Encode4(402913),
     /* 402269 */ /*GILLT_nxv16s8*//*Label 8489*/ GIMT_Encode4(402939),
     /* 402273 */ // Label 8472: @402273
     /* 402273 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(402327),
     /* 402278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 402284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402296 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(402311), // Rule ID 1902 //
     /* 402301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402304 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 402304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 402309 */     GIR_RootConstrainSelectedInstOperands,
     /* 402310 */     // GIR_Coverage, 1902,
     /* 402310 */     GIR_Done,
     /* 402311 */   // Label 8492: @402311
     /* 402311 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(402326), // Rule ID 5425 //
     /* 402316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402319 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 402324 */     GIR_RootConstrainSelectedInstOperands,
     /* 402325 */     // GIR_Coverage, 5425,
     /* 402325 */     GIR_Done,
     /* 402326 */   // Label 8493: @402326
     /* 402326 */   GIM_Reject,
     /* 402327 */ // Label 8491: @402327
     /* 402327 */ GIM_Reject,
     /* 402328 */ // Label 8473: @402328
     /* 402328 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(402382),
     /* 402333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402351 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(402366), // Rule ID 1904 //
     /* 402356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402359 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 402359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 402364 */     GIR_RootConstrainSelectedInstOperands,
     /* 402365 */     // GIR_Coverage, 1904,
     /* 402365 */     GIR_Done,
     /* 402366 */   // Label 8495: @402366
     /* 402366 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(402381), // Rule ID 5427 //
     /* 402371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402374 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 402379 */     GIR_RootConstrainSelectedInstOperands,
     /* 402380 */     // GIR_Coverage, 5427,
     /* 402380 */     GIR_Done,
     /* 402381 */   // Label 8496: @402381
     /* 402381 */   GIM_Reject,
     /* 402382 */ // Label 8494: @402382
     /* 402382 */ GIM_Reject,
     /* 402383 */ // Label 8474: @402383
     /* 402383 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(402437),
     /* 402388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402406 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(402421), // Rule ID 1900 //
     /* 402411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402414 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 402414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 402419 */     GIR_RootConstrainSelectedInstOperands,
     /* 402420 */     // GIR_Coverage, 1900,
     /* 402420 */     GIR_Done,
     /* 402421 */   // Label 8498: @402421
     /* 402421 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(402436), // Rule ID 5423 //
     /* 402426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402429 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 402434 */     GIR_RootConstrainSelectedInstOperands,
     /* 402435 */     // GIR_Coverage, 5423,
     /* 402435 */     GIR_Done,
     /* 402436 */   // Label 8499: @402436
     /* 402436 */   GIM_Reject,
     /* 402437 */ // Label 8497: @402437
     /* 402437 */ GIM_Reject,
     /* 402438 */ // Label 8475: @402438
     /* 402438 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(402492),
     /* 402443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402461 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(402476), // Rule ID 1903 //
     /* 402466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402469 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 402469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402474 */     GIR_RootConstrainSelectedInstOperands,
     /* 402475 */     // GIR_Coverage, 1903,
     /* 402475 */     GIR_Done,
     /* 402476 */   // Label 8501: @402476
     /* 402476 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(402491), // Rule ID 5426 //
     /* 402481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402484 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402489 */     GIR_RootConstrainSelectedInstOperands,
     /* 402490 */     // GIR_Coverage, 5426,
     /* 402490 */     GIR_Done,
     /* 402491 */   // Label 8502: @402491
     /* 402491 */   GIM_Reject,
     /* 402492 */ // Label 8500: @402492
     /* 402492 */ GIM_Reject,
     /* 402493 */ // Label 8476: @402493
     /* 402493 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(402526), // Rule ID 1898 //
     /* 402498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402519 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 402519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 402524 */   GIR_RootConstrainSelectedInstOperands,
     /* 402525 */   // GIR_Coverage, 1898,
     /* 402525 */   GIR_Done,
     /* 402526 */ // Label 8503: @402526
     /* 402526 */ GIM_Reject,
     /* 402527 */ // Label 8477: @402527
     /* 402527 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(402581),
     /* 402532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402550 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(402565), // Rule ID 1901 //
     /* 402555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402558 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 402558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402563 */     GIR_RootConstrainSelectedInstOperands,
     /* 402564 */     // GIR_Coverage, 1901,
     /* 402564 */     GIR_Done,
     /* 402565 */   // Label 8505: @402565
     /* 402565 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(402580), // Rule ID 5424 //
     /* 402570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402573 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402578 */     GIR_RootConstrainSelectedInstOperands,
     /* 402579 */     // GIR_Coverage, 5424,
     /* 402579 */     GIR_Done,
     /* 402580 */   // Label 8506: @402580
     /* 402580 */   GIM_Reject,
     /* 402581 */ // Label 8504: @402581
     /* 402581 */ GIM_Reject,
     /* 402582 */ // Label 8478: @402582
     /* 402582 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(402615), // Rule ID 1899 //
     /* 402587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 402596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402608 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 402608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 402613 */   GIR_RootConstrainSelectedInstOperands,
     /* 402614 */   // GIR_Coverage, 1899,
     /* 402614 */   GIR_Done,
     /* 402615 */ // Label 8507: @402615
     /* 402615 */ GIM_Reject,
     /* 402616 */ // Label 8479: @402616
     /* 402616 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(402641), // Rule ID 8804 //
     /* 402621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 402627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 402630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402634 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 402634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 402639 */   GIR_RootConstrainSelectedInstOperands,
     /* 402640 */   // GIR_Coverage, 8804,
     /* 402640 */   GIR_Done,
     /* 402641 */ // Label 8508: @402641
     /* 402641 */ GIM_Reject,
     /* 402642 */ // Label 8480: @402642
     /* 402642 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(402667), // Rule ID 8759 //
     /* 402647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 402653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 402656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402660 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 402660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402665 */   GIR_RootConstrainSelectedInstOperands,
     /* 402666 */   // GIR_Coverage, 8759,
     /* 402666 */   GIR_Done,
     /* 402667 */ // Label 8509: @402667
     /* 402667 */ GIM_Reject,
     /* 402668 */ // Label 8481: @402668
     /* 402668 */ GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(402693), // Rule ID 8760 //
     /* 402673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 402679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 402682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402686 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 402686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402691 */   GIR_RootConstrainSelectedInstOperands,
     /* 402692 */   // GIR_Coverage, 8760,
     /* 402692 */   GIR_Done,
     /* 402693 */ // Label 8510: @402693
     /* 402693 */ GIM_Reject,
     /* 402694 */ // Label 8482: @402694
     /* 402694 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(402740),
     /* 402699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 402702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 402705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402709 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(402724), // Rule ID 8755 //
     /* 402714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402717 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 402717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402722 */     GIR_RootConstrainSelectedInstOperands,
     /* 402723 */     // GIR_Coverage, 8755,
     /* 402723 */     GIR_Done,
     /* 402724 */   // Label 8512: @402724
     /* 402724 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(402739), // Rule ID 8761 //
     /* 402729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402732 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 402732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402737 */     GIR_RootConstrainSelectedInstOperands,
     /* 402738 */     // GIR_Coverage, 8761,
     /* 402738 */     GIR_Done,
     /* 402739 */   // Label 8513: @402739
     /* 402739 */   GIM_Reject,
     /* 402740 */ // Label 8511: @402740
     /* 402740 */ GIM_Reject,
     /* 402741 */ // Label 8483: @402741
     /* 402741 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(402766), // Rule ID 8803 //
     /* 402746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 402752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 402755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402759 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 402759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 402764 */   GIR_RootConstrainSelectedInstOperands,
     /* 402765 */   // GIR_Coverage, 8803,
     /* 402765 */   GIR_Done,
     /* 402766 */ // Label 8514: @402766
     /* 402766 */ GIM_Reject,
     /* 402767 */ // Label 8484: @402767
     /* 402767 */ GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(402792), // Rule ID 8757 //
     /* 402772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 402778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402785 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402790 */   GIR_RootConstrainSelectedInstOperands,
     /* 402791 */   // GIR_Coverage, 8757,
     /* 402791 */   GIR_Done,
     /* 402792 */ // Label 8515: @402792
     /* 402792 */ GIM_Reject,
     /* 402793 */ // Label 8485: @402793
     /* 402793 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(402839),
     /* 402798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402808 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(402823), // Rule ID 8754 //
     /* 402813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402816 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402821 */     GIR_RootConstrainSelectedInstOperands,
     /* 402822 */     // GIR_Coverage, 8754,
     /* 402822 */     GIR_Done,
     /* 402823 */   // Label 8517: @402823
     /* 402823 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(402838), // Rule ID 8758 //
     /* 402828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402831 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402836 */     GIR_RootConstrainSelectedInstOperands,
     /* 402837 */     // GIR_Coverage, 8758,
     /* 402837 */     GIR_Done,
     /* 402838 */   // Label 8518: @402838
     /* 402838 */   GIM_Reject,
     /* 402839 */ // Label 8516: @402839
     /* 402839 */ GIM_Reject,
     /* 402840 */ // Label 8486: @402840
     /* 402840 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(402865), // Rule ID 8802 //
     /* 402845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402858 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 402863 */   GIR_RootConstrainSelectedInstOperands,
     /* 402864 */   // GIR_Coverage, 8802,
     /* 402864 */   GIR_Done,
     /* 402865 */ // Label 8519: @402865
     /* 402865 */ GIM_Reject,
     /* 402866 */ // Label 8487: @402866
     /* 402866 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(402912),
     /* 402871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402881 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(402896), // Rule ID 8753 //
     /* 402886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402889 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402894 */     GIR_RootConstrainSelectedInstOperands,
     /* 402895 */     // GIR_Coverage, 8753,
     /* 402895 */     GIR_Done,
     /* 402896 */   // Label 8521: @402896
     /* 402896 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(402911), // Rule ID 8756 //
     /* 402901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402904 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402909 */     GIR_RootConstrainSelectedInstOperands,
     /* 402910 */     // GIR_Coverage, 8756,
     /* 402910 */     GIR_Done,
     /* 402911 */   // Label 8522: @402911
     /* 402911 */   GIM_Reject,
     /* 402912 */ // Label 8520: @402912
     /* 402912 */ GIM_Reject,
     /* 402913 */ // Label 8488: @402913
     /* 402913 */ GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(402938), // Rule ID 2393 //
     /* 402918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402931 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 402936 */   GIR_RootConstrainSelectedInstOperands,
     /* 402937 */   // GIR_Coverage, 2393,
     /* 402937 */   GIR_Done,
     /* 402938 */ // Label 8523: @402938
     /* 402938 */ GIM_Reject,
     /* 402939 */ // Label 8489: @402939
     /* 402939 */ GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(402964), // Rule ID 8752 //
     /* 402944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402957 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 402962 */   GIR_RootConstrainSelectedInstOperands,
     /* 402963 */   // GIR_Coverage, 8752,
     /* 402963 */   GIR_Done,
     /* 402964 */ // Label 8524: @402964
     /* 402964 */ GIM_Reject,
     /* 402965 */ // Label 8490: @402965
     /* 402965 */ GIM_Reject,
     /* 402966 */ // Label 154: @402966
     /* 402966 */ GIM_Reject,
     /* 402967 */ }; // Size: 402967 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
